//
// DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/security/manager/ssl/nsIDataStorage.idl
//


/// `interface nsIDataStorageManager : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIDataStorageManager {
    vtable: &'static nsIDataStorageManagerVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIDataStorageManager.
unsafe impl XpCom for nsIDataStorageManager {
    const IID: nsIID = nsID(0x71b49926, 0xfd4e, 0x43e2,
        [0xab, 0x8d, 0xd9, 0xb0, 0x49, 0x41, 0x3c, 0x0b]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIDataStorageManager {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIDataStorageManager.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIDataStorageManagerCoerce {
    /// Cheaply cast a value of this type from a `nsIDataStorageManager`.
    fn coerce_from(v: &nsIDataStorageManager) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIDataStorageManagerCoerce for nsIDataStorageManager {
    #[inline]
    fn coerce_from(v: &nsIDataStorageManager) -> &Self {
        v
    }
}

impl nsIDataStorageManager {
    /// Cast this `nsIDataStorageManager` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIDataStorageManagerCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIDataStorageManager {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIDataStorageManagerCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIDataStorageManager) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIDataStorageManager
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIDataStorageManagerVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* nsIDataStorage get (in nsIDataStorageManager_DataStorage dataStorage); */
    pub Get: unsafe extern "system" fn (this: *const nsIDataStorageManager, dataStorage:  u8, _retval: *mut*const nsIDataStorage) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIDataStorageManager {

    pub const AlternateServices:  u8 = 0;


    pub const ClientAuthRememberList:  u8 = 1;


    pub const SiteSecurityServiceState:  u8 = 2;


    /// `nsIDataStorage get (in nsIDataStorageManager_DataStorage dataStorage);`
    #[inline]
    pub unsafe fn Get(&self, dataStorage:  u8, _retval: *mut*const nsIDataStorage) -> ::nserror::nsresult {
        ((*self.vtable).Get)(self, dataStorage, _retval)
    }


}


/// `interface nsIDataStorage : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIDataStorage {
    vtable: &'static nsIDataStorageVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIDataStorage.
unsafe impl XpCom for nsIDataStorage {
    const IID: nsIID = nsID(0xfcbb5ec4, 0x7134, 0x4069,
        [0x91, 0xc6, 0x93, 0x78, 0xef, 0xf5, 0x1e, 0x03]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIDataStorage {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIDataStorage.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIDataStorageCoerce {
    /// Cheaply cast a value of this type from a `nsIDataStorage`.
    fn coerce_from(v: &nsIDataStorage) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIDataStorageCoerce for nsIDataStorage {
    #[inline]
    fn coerce_from(v: &nsIDataStorage) -> &Self {
        v
    }
}

impl nsIDataStorage {
    /// Cast this `nsIDataStorage` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIDataStorageCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIDataStorage {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIDataStorageCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIDataStorage) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIDataStorage
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIDataStorageVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* ACString get (in ACString key, in nsIDataStorage_DataType type); */
    pub Get: unsafe extern "system" fn (this: *const nsIDataStorage, key: *const ::nsstring::nsACString, type_:  u8, _retval: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* void put (in ACString key, in ACString value, in nsIDataStorage_DataType type); */
    pub Put: unsafe extern "system" fn (this: *const nsIDataStorage, key: *const ::nsstring::nsACString, value: *const ::nsstring::nsACString, type_:  u8) -> ::nserror::nsresult,

    /* void remove (in ACString key, in nsIDataStorage_DataType type); */
    pub Remove: unsafe extern "system" fn (this: *const nsIDataStorage, key: *const ::nsstring::nsACString, type_:  u8) -> ::nserror::nsresult,

    /* void clear (); */
    pub Clear: unsafe extern "system" fn (this: *const nsIDataStorage) -> ::nserror::nsresult,

    /* boolean isReady (); */
    pub IsReady: unsafe extern "system" fn (this: *const nsIDataStorage, _retval: *mut bool) -> ::nserror::nsresult,

    /* Array<nsIDataStorageItem> getAll (); */
    pub GetAll: unsafe extern "system" fn (this: *const nsIDataStorage, _retval: *mut thin_vec::ThinVec<Option<RefPtr<nsIDataStorageItem>>>) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIDataStorage {

    pub const Persistent:  u8 = 0;


    pub const Private:  u8 = 1;


    pub const Temporary:  u8 = 2;


    /// `ACString get (in ACString key, in nsIDataStorage_DataType type);`
    #[inline]
    pub unsafe fn Get(&self, key: *const ::nsstring::nsACString, type_:  u8, _retval: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).Get)(self, key, type_, _retval)
    }



    /// `void put (in ACString key, in ACString value, in nsIDataStorage_DataType type);`
    #[inline]
    pub unsafe fn Put(&self, key: *const ::nsstring::nsACString, value: *const ::nsstring::nsACString, type_:  u8) -> ::nserror::nsresult {
        ((*self.vtable).Put)(self, key, value, type_)
    }



    /// `void remove (in ACString key, in nsIDataStorage_DataType type);`
    #[inline]
    pub unsafe fn Remove(&self, key: *const ::nsstring::nsACString, type_:  u8) -> ::nserror::nsresult {
        ((*self.vtable).Remove)(self, key, type_)
    }



    /// `void clear ();`
    #[inline]
    pub unsafe fn Clear(&self, ) -> ::nserror::nsresult {
        ((*self.vtable).Clear)(self, )
    }



    /// `boolean isReady ();`
    #[inline]
    pub unsafe fn IsReady(&self, _retval: *mut bool) -> ::nserror::nsresult {
        ((*self.vtable).IsReady)(self, _retval)
    }



    /// `Array<nsIDataStorageItem> getAll ();`
    #[inline]
    pub unsafe fn GetAll(&self, _retval: *mut thin_vec::ThinVec<Option<RefPtr<nsIDataStorageItem>>>) -> ::nserror::nsresult {
        ((*self.vtable).GetAll)(self, _retval)
    }


}


/// `interface nsIDataStorageItem : nsISupports`
///


// The actual type definition for the interface. This struct has methods
// declared on it which will call through its vtable. You never want to pass
// this type around by value, always pass it behind a reference.

#[repr(C)]
pub struct nsIDataStorageItem {
    vtable: &'static nsIDataStorageItemVTable,

    /// This field is a phantomdata to ensure that the VTable type and any
    /// struct containing it is not safe to send across threads by default, as
    /// XPCOM is generally not threadsafe.
    ///
    /// If this type is marked as [rust_sync], there will be explicit `Send` and
    /// `Sync` implementations on this type, which will override the inherited
    /// negative impls from `Rc`.
    __nosync: ::std::marker::PhantomData<::std::rc::Rc<u8>>,

    // Make the rust compiler aware that there might be interior mutability
    // in what actually implements the interface. This works around UB
    // introduced by https://github.com/llvm/llvm-project/commit/01859da84bad95fd51d6a03b08b60c660e642a4f
    // that a rust lint would make blatantly obvious, but doesn't exist.
    // (See https://github.com/rust-lang/rust/issues/111229).
    // This prevents optimizations, but those optimizations weren't available
    // before rustc switched to LLVM 16, and they now cause problems because
    // of the UB.
    // Until there's a lint available to find all our UB, it's simpler to
    // avoid the UB in the first place, at the cost of preventing optimizations
    // in places that don't cause UB. But again, those optimizations weren't
    // available before.
    __maybe_interior_mutability: ::std::cell::UnsafeCell<[u8; 0]>,
}

// Implementing XpCom for an interface exposes its IID, which allows for easy
// use of the `.query_interface<T>` helper method. This also defines that
// method for nsIDataStorageItem.
unsafe impl XpCom for nsIDataStorageItem {
    const IID: nsIID = nsID(0x4501f984, 0x0e3a, 0x4199,
        [0xa6, 0x7e, 0x77, 0x53, 0x64, 0x9e, 0x93, 0xf1]);
}

// We need to implement the RefCounted trait so we can be used with `RefPtr`.
// This trait teaches `RefPtr` how to manage our memory.
unsafe impl RefCounted for nsIDataStorageItem {
    #[inline]
    unsafe fn addref(&self) {
        self.AddRef();
    }
    #[inline]
    unsafe fn release(&self) {
        self.Release();
    }
}

// This trait is implemented on all types which can be coerced to from nsIDataStorageItem.
// It is used in the implementation of `fn coerce<T>`. We hide it from the
// documentation, because it clutters it up a lot.
#[doc(hidden)]
pub trait nsIDataStorageItemCoerce {
    /// Cheaply cast a value of this type from a `nsIDataStorageItem`.
    fn coerce_from(v: &nsIDataStorageItem) -> &Self;
}

// The trivial implementation: We can obviously coerce ourselves to ourselves.
impl nsIDataStorageItemCoerce for nsIDataStorageItem {
    #[inline]
    fn coerce_from(v: &nsIDataStorageItem) -> &Self {
        v
    }
}

impl nsIDataStorageItem {
    /// Cast this `nsIDataStorageItem` to one of its base interfaces.
    #[inline]
    pub fn coerce<T: nsIDataStorageItemCoerce>(&self) -> &T {
        T::coerce_from(self)
    }
}

// Every interface struct type implements `Deref` to its base interface. This
// causes methods on the base interfaces to be directly avaliable on the
// object. For example, you can call `.AddRef` or `.QueryInterface` directly
// on any interface which inherits from `nsISupports`.
impl ::std::ops::Deref for nsIDataStorageItem {
    type Target = nsISupports;
    #[inline]
    fn deref(&self) -> &nsISupports {
        unsafe {
            ::std::mem::transmute(self)
        }
    }
}

// Ensure we can use .coerce() to cast to our base types as well. Any type which
// our base interface can coerce from should be coercable from us as well.
impl<T: nsISupportsCoerce> nsIDataStorageItemCoerce for T {
    #[inline]
    fn coerce_from(v: &nsIDataStorageItem) -> &Self {
        T::coerce_from(v)
    }
}

// This struct represents the interface's VTable. A pointer to a statically
// allocated version of this struct is at the beginning of every nsIDataStorageItem
// object. It contains one pointer field for each method in the interface. In
// the case where we can't generate a binding for a method, we include a void
// pointer.
#[doc(hidden)]
#[repr(C)]
pub struct nsIDataStorageItemVTable {
    /// We need to include the members from the base interface's vtable at the start
    /// of the VTable definition.
    pub __base: nsISupportsVTable,

    /* readonly attribute ACString key; */
    pub GetKey: unsafe extern "system" fn (this: *const nsIDataStorageItem, aKey: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute ACString value; */
    pub GetValue: unsafe extern "system" fn (this: *const nsIDataStorageItem, aValue: *mut ::nsstring::nsACString) -> ::nserror::nsresult,

    /* readonly attribute nsIDataStorage_DataType type; */
    pub GetType: unsafe extern "system" fn (this: *const nsIDataStorageItem, aType: *mut u8) -> ::nserror::nsresult,
}


// The implementations of the function wrappers which are exposed to rust code.
// Call these methods rather than manually calling through the VTable struct.
impl nsIDataStorageItem {


    /// `readonly attribute ACString key;`
    #[inline]
    pub unsafe fn GetKey(&self, aKey: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetKey)(self, aKey)
    }



    /// `readonly attribute ACString value;`
    #[inline]
    pub unsafe fn GetValue(&self, aValue: *mut ::nsstring::nsACString) -> ::nserror::nsresult {
        ((*self.vtable).GetValue)(self, aValue)
    }



    /// `readonly attribute nsIDataStorage_DataType type;`
    #[inline]
    pub unsafe fn GetType(&self, aType: *mut u8) -> ::nserror::nsresult {
        ((*self.vtable).GetType)(self, aType)
    }


}


