// -*- mode: Rust -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */


pub enum DynamicLabel { }

pub mod a11y {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from a11y.always_underline_links
    ///
    /// Bool tracking if the user has always underline links enabled in firefox. This metric was generated to correspond to the Legacy Telemetry scalar a11y.always_underline_links.
    pub static always_underline_links: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_underline_links".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.backplate
    ///
    /// Boolean tracking if the user has the backplate preference enabled or disabled. This metric was generated to correspond to the Legacy Telemetry scalar a11y.backplate.
    pub static backplate: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backplate".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(2), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.consumers
    ///
    /// A list of known accessibility clients that inject into Firefox process space (see https://searchfox.org/mozilla-central/source/accessible/windows/msaa/Compatibility.h).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram A11Y_CONSUMERS.
    pub static consumers: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "consumers".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3), meta, 0, 11, 12, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.hcm_background
    ///
    /// Unsigned int tracking the user's prefered background color \ (logged when HCM is enabled). This metric was generated to correspond to the Legacy Telemetry scalar a11y.HCM_background.
    pub static hcm_background: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hcm_background".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.hcm_foreground
    ///
    /// Unsigned int tracking the user's prefered foreground color \ (logged when HCM is enabled). This metric was generated to correspond to the Legacy Telemetry scalar a11y.HCM_foreground.
    pub static hcm_foreground: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hcm_foreground".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.instantiators
    ///
    /// The leaf name and version number of the binary for the process responsible for remotely instantiating a11y. This metric was generated to correspond to the Legacy Telemetry scalar a11y.instantiators.
    pub static instantiators: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "instantiators".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(6), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.invert_colors
    ///
    /// Boolean tracking if the user has an invert colors OS setting enabled. This metric was generated to correspond to the Legacy Telemetry scalar a11y.invert_colors.
    pub static invert_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invert_colors".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(7), meta)
    });

    #[repr(u16)]
    pub enum ThemeLabel {
        EDefault = 0,
        EAlways = 1,
        ENever = 2,
        __Other__,
    }
    impl From<u16> for ThemeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDefault,
                1 => Self::EAlways,
                2 => Self::ENever,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ThemeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDefault => "default",
                Self::EAlways => "always",
                Self::ENever => "never",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from a11y.theme
    ///
    /// OS high contrast or other accessibility theme is enabled. The result is split into keys which represent the values of browser.display.document_color_use: "default", "always", or "never". This metric was generated to correspond to the Legacy Telemetry scalar a11y.theme.
    pub static theme: Lazy<LabeledMetric<LabeledBooleanMetric, ThemeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "theme".into(),
                    category: "a11y".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(8), meta, Some(vec![::std::borrow::Cow::from("always"), ::std::borrow::Cow::from("default"), ::std::borrow::Cow::from("never")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.tree_update_timing
    ///
    /// The amount of time taken to update the accessibility tree (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram A11Y_TREE_UPDATE_TIMING_MS.
    pub static tree_update_timing: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tree_update_timing".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(9), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from a11y.use_system_colors
    ///
    /// Bool tracking if the user has system colors enabled in firefox. This metric was generated to correspond to the Legacy Telemetry scalar a11y.use_system_colors.
    pub static use_system_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_system_colors".into(),
                category: "a11y".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(10), meta)
    });

}
pub mod fullscreen {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fullscreen.change
    ///
    /// The time content uses to enter/exit fullscreen regardless of fullscreen transition timeout
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FULLSCREEN_CHANGE_MS.
    pub static change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change".into(),
                category: "fullscreen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(11), meta, TimeUnit::Millisecond)
    });

}
pub mod browser_engagement {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.bookmarks_toolbar_bookmark_added
    ///
    /// The count of bookmarks added to the bookmarks toolbar. This counts bookmarks created on the bookmarks toolbar and bookmarks moved to the bookmarks toolbar. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.bookmarks_toolbar_bookmark_added.
    pub static bookmarks_toolbar_bookmark_added: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            12,
            "browser.engagement",
            "bookmarks_toolbar_bookmark_added",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.bookmarks_toolbar_bookmark_opened
    ///
    /// The count of bookmarks opened from the Bookmarks Toolbar. This counts bookmarks opened on the toolbar and bookmarks opened from the 'symlinked' Other Bookmarks folder on the Bookmarks Toolbar. It does not count Bookmarks Toolbar bookmarks opened via the Library, Bookmarks Menu, or other UI since the goal is to measure interactions that pass through the toolbar. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.bookmarks_toolbar_bookmark_opened.
    pub static bookmarks_toolbar_bookmark_opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            13,
            "browser.engagement",
            "bookmarks_toolbar_bookmark_opened",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum TotalTopVisitsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TotalTopVisitsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TotalTopVisitsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.total_top_visits
    ///
    /// Count the number of times a new top page was starting to load
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram FX_TOTAL_TOP_VISITS.
    pub static total_top_visits: Lazy<LabeledMetric<LabeledCounterMetric, TotalTopVisitsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "total_top_visits".into(),
                    category: "browser.engagement".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(14), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.sessionrestore_interstitial
    ///
    /// Whether we show about:sessionrestore or not. Split by key, which indicates why we showed the item or not. Specifically, 'deferred_restore' means we didn't autorestore and thus didn't show the interstitial; 'autorestore' indicates we autorestored without showing the interstitial. 'shown_old_session', 'shown_only_about_welcomeback', 'shown_many_crashes', 'shown_many_crashes_old_session' all indicate we did show the interstitial because of a crash, and the text after 'shown' indicates what secondary reason there was to show this page (as we don't show it for 'just' one crash). This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.sessionrestore_interstitial.
    pub static sessionrestore_interstitial: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sessionrestore_interstitial".into(),
                    category: "browser.engagement".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(15), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TabExplicitUnloadExtra {
        pub r#all_tabs_unloaded: Option<bool>,
        pub r#memory_after: Option<u32>,
        pub r#memory_before: Option<u32>,
        pub r#tabs_unloaded: Option<u32>,
        pub r#time_to_unload_in_ms: Option<u32>,
        pub r#unload_selected_tab: Option<bool>,
    }

    impl ExtraKeys for TabExplicitUnloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["all_tabs_unloaded", "memory_after", "memory_before", "tabs_unloaded", "time_to_unload_in_ms", "unload_selected_tab"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#all_tabs_unloaded.and_then(|val| map.insert("all_tabs_unloaded".into(), val.to_string()));
          self.r#memory_after.and_then(|val| map.insert("memory_after".into(), val.to_string()));
          self.r#memory_before.and_then(|val| map.insert("memory_before".into(), val.to_string()));
          self.r#tabs_unloaded.and_then(|val| map.insert("tabs_unloaded".into(), val.to_string()));
          self.r#time_to_unload_in_ms.and_then(|val| map.insert("time_to_unload_in_ms".into(), val.to_string()));
          self.r#unload_selected_tab.and_then(|val| map.insert("unload_selected_tab".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_explicit_unload
    ///
    /// Recorded when the user explicitly unloads tab(s) from memory via the tab context menu.
    pub static tab_explicit_unload: Lazy<EventMetric<TabExplicitUnloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_explicit_unload".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(16), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_reload_count
    ///
    /// The count of tab reload events by the user after unloaded. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.tab_reload_count.
    pub static tab_reload_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            17,
            "browser.engagement",
            "tab_reload_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_unload_count
    ///
    /// The count of tab unload events by TabUnloader due to a low-memory situation. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.tab_unload_count.
    pub static tab_unload_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            18,
            "browser.engagement",
            "tab_unload_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_unload_to_reload
    ///
    /// How long (sec) a tab had been unloaded until it was reloaded.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TAB_UNLOAD_TO_RELOAD.
    pub static tab_unload_to_reload: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_unload_to_reload".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(19), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.active_ticks
    ///
    /// The number of five-second intervals ('ticks') the user was considered
    /// 'active'.
    /// 
    /// 'active' means keyboard or mouse interaction with the application.
    /// It doesn't take into account whether or not the window has focus or is in
    /// the foreground, only if it is receiving these interaction events.
    /// 
    /// Migrated from Telemetry's `browser.engagement.active_ticks`.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_ticks".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["baseline".into(), "metrics".into(), "usage-reporting".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(BaseMetricId(20), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.loaded_tab_count
    ///
    /// Number of fully loaded (i.e., not pending from session restore) tabs opened across all windows, collected at most every 5 minutes whenever the user interacts with the browser in the following ways: open tab/window, page load, restoring a pending tab.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram LOADED_TAB_COUNT.
    pub static loaded_tab_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "loaded_tab_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(21), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.max_concurrent_tab_count
    ///
    /// The count of maximum number of tabs open during a subsession, across all windows, including tabs in private windows and restored at startup. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.max_concurrent_tab_count.
    pub static max_concurrent_tab_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_concurrent_tab_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(22), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.max_concurrent_tab_pinned_count
    ///
    /// The count of maximum number of pinned tabs open during a subsession. This includes private windows and the ones opened when starting the browser. Starting Firefox 85 this includes number of restored pinned tabs at startup. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.max_concurrent_tab_pinned_count.
    pub static max_concurrent_tab_pinned_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_concurrent_tab_pinned_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(23), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.max_concurrent_vertical_tab_count
    ///
    /// The count of maximum number of tabs with vertical tabs enabled. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.max_concurrent_vertical_tab_count.
    pub static max_concurrent_vertical_tab_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_concurrent_vertical_tab_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(24), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.max_concurrent_vertical_tab_pinned_count
    ///
    /// The count of maximum number of pinned tabs with vertical tabs enabled. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.max_concurrent_vertical_tab_pinned_count.
    pub static max_concurrent_vertical_tab_pinned_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_concurrent_vertical_tab_pinned_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(25), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.max_concurrent_window_count
    ///
    /// The count of maximum number of browser windows open during a subsession. This includes private windows and the ones opened when starting the browser. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.max_concurrent_window_count.
    pub static max_concurrent_window_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_concurrent_window_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(26), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.profile_count
    ///
    /// Windows only count of the browser profiles on the current system. This
    /// counts profiles that have been used across all Windows user accounts on
    /// machine since this probe was added. The value persists across installs.
    /// A value of 0 is reported if there is an error determining the correct
    /// count. Unset on other platforms.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(27), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_count
    ///
    /// Number of tabs opened across all windows, collected at most every 5 minutes whenever the user interacts with the browser in the following ways: open tab/window, page load.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TAB_COUNT.
    pub static tab_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(28), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_open_event_count
    ///
    /// The count of tab open events per subsession, across all windows, after the session has been restored. This includes tab open events from private windows and from manual session restorations (i.e. after crashes and from about:home), but excludes tabs opened vertically. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.tab_open_event_count.
    pub static tab_open_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            29,
            "browser.engagement",
            "tab_open_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.tab_pinned_event_count
    ///
    /// The count of tab pinned events per subsession, across all windows, after the session has been restored. This includes tab pinned events from private windows. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.tab_pinned_event_count.
    pub static tab_pinned_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            30,
            "browser.engagement",
            "tab_pinned_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.unfiltered_uri_count
    ///
    /// The count of the total non-unique URIs visited in a subsession, not restricted to a specific protocol, including page reloads and about:* pages (other than initial pages such as about:blank, ...), after the session has been restored. This does not include background page requests and URIs from embedded pages or private browsing. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.unfiltered_uri_count.
    pub static unfiltered_uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            31,
            "browser.engagement",
            "unfiltered_uri_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.unique_domains_count
    ///
    /// The count of the unique domains visited in a subsession, after the session has been restored. Subdomains under eTLD are aggregated after the first level (i.e. test.example.com and other.example.com are only counted once). This does not include background page requests and domains from embedded pages or private browsing. The count is limited to 100 unique domains. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.unique_domains_count.
    pub static unique_domains_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unique_domains_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(32), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count
    ///
    /// The number of total non-unique http(s) URIs visited, including page
    /// reloads, after the session has been restored. URIs on minimized or
    /// background tabs may also be counted. Private browsing uris are included.
    /// 
    /// Migrated from Telemetry's
    /// `browser.engagement.total_uri_count_normal_and_private_mode`.
    pub static uri_count: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uri_count".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["baseline".into(), "metrics".into(), "usage-reporting".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(BaseMetricId(33), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.uri_count_normal_mode
    ///
    /// The count of the total non-unique http(s) URIs visited in a subsession, including page reloads, after the session has been restored. URIs on minimized or background tabs may also be counted towards this. Private browsing is not included in this count. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.total_uri_count.
    pub static uri_count_normal_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            34,
            "browser.engagement",
            "uri_count_normal_mode",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.vertical_tab_open_event_count
    ///
    /// The count of tab open events with vertical tabs enabled. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.vertical_tab_open_event_count.
    pub static vertical_tab_open_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            35,
            "browser.engagement",
            "vertical_tab_open_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.vertical_tab_pinned_event_count
    ///
    /// The count of tab pinned events with vertical tabs enabled. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.vertical_tab_pinned_event_count.
    pub static vertical_tab_pinned_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            36,
            "browser.engagement",
            "vertical_tab_pinned_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.window_open_event_count
    ///
    /// The count of browser window open events per subsession, after the session has been restored. The count includes private windows and the ones from manual session restorations (i.e. after crashes and from about:home). This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.window_open_event_count.
    pub static window_open_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            37,
            "browser.engagement",
            "window_open_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.session_time_excluding_suspend
    ///
    /// The duration of the session in milliseconds, excluding the time the device was suspended. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.session_time_excluding_suspend.
    pub static session_time_excluding_suspend: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_time_excluding_suspend".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(38), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.session_time_including_suspend
    ///
    /// The duration of the session in milliseconds, including the time the device was suspended. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.session_time_including_suspend.
    pub static session_time_including_suspend: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_time_including_suspend".into(),
                category: "browser.engagement".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(39), meta)
    });

}
pub mod browser_timings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.new_window
    ///
    /// Firefox: Time taken to open a new browser window (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_NEW_WINDOW_MS.
    pub static new_window: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_window".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(40), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.page_load
    ///
    /// Firefox: Time taken to load a page (ms). This includes all static contents, no dynamic content. Page reloads and loading of about: pages are not included.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram FX_PAGE_LOAD_MS_2.
    pub static page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(41), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.page_reload_normal
    ///
    /// Firefox: Time taken to reload a page (ms) when using the LOAD_RELOAD_NORMAL flag
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram FX_PAGE_RELOAD_NORMAL_MS.
    pub static page_reload_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_reload_normal".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(42), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.page_reload_skip_cache
    ///
    /// Firefox: Time taken to reload a page (ms) when caches are skipped
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram FX_PAGE_RELOAD_SKIP_CACHE_MS.
    pub static page_reload_skip_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_reload_skip_cache".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(43), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.tab_click
    ///
    /// Firefox: Time in ms spent on switching tabs in response to a tab click
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_CLICK_MS.
    pub static tab_click: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_click".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(44), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.timings.last_shutdown
    ///
    /// The time, in milliseconds, it took to complete the last shutdown. On successful shutdown, Telemetry saves this to disk into Telemetry.ShutdownTime.txt. On the next startup this is loaded and recorded. This metric was generated to correspond to the Legacy Telemetry scalar browser.timings.last_shutdown.
    pub static last_shutdown: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_shutdown".into(),
                category: "browser.timings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(45), meta)
    });

}
pub mod networking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CaptivePortalBannerDisplayTimeLabel {
        ESuccess = 0,
        EAbort = 1,
        EDismiss = 2,
        __Other__,
    }
    impl From<u16> for CaptivePortalBannerDisplayTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EAbort,
                2 => Self::EDismiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CaptivePortalBannerDisplayTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EAbort => "abort",
                Self::EDismiss => "dismiss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.captive_portal_banner_display_time
    ///
    /// Number of seconds the captive portal banner was displayed for, keyed by close reason:
    ///   "success" - the portal login was completed
    ///   "abort"   - the portal login was aborted (e.g. loss of network)
    ///   "dismiss" - the user dismissed the banner
    /// This metric was generated to correspond to the Legacy Telemetry scalar networking.captive_portal_banner_display_time.
    pub static captive_portal_banner_display_time: Lazy<LabeledMetric<LabeledCounterMetric, CaptivePortalBannerDisplayTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "captive_portal_banner_display_time".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(46), meta, Some(vec![::std::borrow::Cow::from("abort"), ::std::borrow::Cow::from("dismiss"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.captive_portal_banner_displayed
    ///
    /// Number of times the captive portal banner was displayed in this session. This metric was generated to correspond to the Legacy Telemetry scalar networking.captive_portal_banner_displayed.
    pub static captive_portal_banner_displayed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            47,
            "networking",
            "captive_portal_banner_displayed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_first_read_time
    ///
    /// Time spent to read the first part of the metadata from the cache entry file.
    pub static cache_metadata_first_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_first_read_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(48), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_second_read_time
    ///
    /// Time spent to read the missing part of the metadata from the cache entry file.
    pub static cache_metadata_second_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_second_read_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(49), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_metadata_size
    ///
    /// Size of the metadata in bytes parsed from the disk.
    pub static cache_metadata_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_metadata_size".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(50), meta, MemoryUnit::Byte)
    });

    #[repr(u16)]
    pub enum CachePurgeDueToMemoryLimitLabel {
        EMetaDataFileSizeLimit = 0,
        ECacheMemoryLimit = 1,
        __Other__,
    }
    impl From<u16> for CachePurgeDueToMemoryLimitLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMetaDataFileSizeLimit,
                1 => Self::ECacheMemoryLimit,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CachePurgeDueToMemoryLimitLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMetaDataFileSizeLimit => "meta_data_file_size_limit",
                Self::ECacheMemoryLimit => "cache_memory_limit",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.cache_purge_due_to_memory_limit
    ///
    /// Counts how often we purge cache entries from memory due to memory limits.
    pub static cache_purge_due_to_memory_limit: Lazy<LabeledMetric<LabeledCounterMetric, CachePurgeDueToMemoryLimitLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cache_purge_due_to_memory_limit".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(51), meta, Some(vec![::std::borrow::Cow::from("cache_memory_limit"), ::std::borrow::Cow::from("meta_data_file_size_limit")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_access_fixup_diff
    ///
    /// If we fix up a cookie lastAccessed timestamp that is in the future this metric records the number of seconds that timestamp was off from NOW.
    pub static cookie_access_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_access_fixup_diff".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(52), meta, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_chips_partition_limit_overflow
    ///
    /// The number of cookie bytes exceeding chips partition limit capacity for a single partition
    pub static cookie_chips_partition_limit_overflow: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_chips_partition_limit_overflow".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(53), meta, 0, 16000000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_invalid_first_party_partitioned_in_db
    ///
    /// This counts the number of invalid first-party partitioned cookies that don't have the partitioned cookie attribution(CHIPS).
    pub static cookie_count_invalid_first_party_partitioned_in_db: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            54,
            "networking",
            "cookie_count_invalid_first_party_partitioned_in_db",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_part_by_key
    ///
    /// A distribution of the partitioned cookies in storage belonging to a particular cookie key (host + origin attributes)
    pub static cookie_count_part_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_part_by_key".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(55), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_partitioned
    ///
    /// Reports the number of partitioned cookies in storage
    pub static cookie_count_partitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(56), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_total
    ///
    /// Reports the total number of cookies in storage
    pub static cookie_count_total: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_total".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(57), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpart_by_key
    ///
    /// A distribution of the unpartitioned cookies in storage belonging to a particular cookie key (host + origin attributes)
    pub static cookie_count_unpart_by_key: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_unpart_by_key".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(58), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_count_unpartitioned
    ///
    /// Reports the number of unpartitioned cookies in storage
    pub static cookie_count_unpartitioned: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_count_unpartitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(59), meta, 0, 4000, 22, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_creation_fixup_diff
    ///
    /// If we fix up a cookie creation timestamp that is in the future this metric records the number of seconds that timestamp was off from NOW.
    pub static cookie_creation_fixup_diff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_creation_fixup_diff".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(60), meta, 0, 315360000000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_entry_max
    ///
    /// A distribution of the number of cookies purged for a single host + OA entry as a result of exceeding the maximum threshold for the given host + OA (single purge)
    pub static cookie_purge_entry_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_purge_entry_max".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(61), meta, 1, 220, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_purge_max
    ///
    /// A distribution of the number of cookies purged across all host + OAs as a result of exceeding the cookie maximum threshold (single purge)
    pub static cookie_purge_max: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_purge_max".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(62), meta, 1, 4000, 22, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum CookieTimestampFixedCountLabel {
        ECreationtime = 0,
        ELastaccessed = 1,
        __Other__,
    }
    impl From<u16> for CookieTimestampFixedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECreationtime,
                1 => Self::ELastaccessed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CookieTimestampFixedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECreationtime => "creationTime",
                Self::ELastaccessed => "lastAccessed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.cookie_timestamp_fixed_count
    ///
    /// Counts the number of times a cookie's invalid timestamp was fixed when reading it from the DB.
    pub static cookie_timestamp_fixed_count: Lazy<LabeledMetric<LabeledCounterMetric, CookieTimestampFixedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cookie_timestamp_fixed_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(63), meta, Some(vec![::std::borrow::Cow::from("creationTime"), ::std::borrow::Cow::from("lastAccessed")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_failed_lookup_time
    ///
    /// Time for an unsuccessful DNS OS resolution (msec) | Migrated from Firefox Telemetry's `DNS_FAILED_LOOKUP_TIME`.
    pub static dns_failed_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_failed_lookup_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(64), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_lookup_time
    ///
    /// Time for a successful DNS resolution (msec) | Migrated from Firefox Telemetry's `DNS_LOOKUP_TIME`.
    pub static dns_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_lookup_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(65), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum DnsNativeCountLabel {
        ERegular = 0,
        EPrivate = 1,
        EHttpsRegular = 2,
        EHttpsPrivate = 3,
        __Other__,
    }
    impl From<u16> for DnsNativeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                2 => Self::EHttpsRegular,
                3 => Self::EHttpsPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DnsNativeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::EHttpsRegular => "https_regular",
                Self::EHttpsPrivate => "https_private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_count
    ///
    /// The count of calls to the native DNS APIs
    pub static dns_native_count: Lazy<LabeledMetric<LabeledCounterMetric, DnsNativeCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "dns_native_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(66), meta, Some(vec![::std::borrow::Cow::from("https_private"), ::std::borrow::Cow::from("https_regular"), ::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_native_https_call_time
    ///
    /// Time spent in the call to the native OS DNS resolution.
    pub static dns_native_https_call_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_native_https_call_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(67), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time
    ///
    /// Time for a renewed DNS OS resolution (msec) | Migrated from Firefox Telemetry's `DNS_RENEWAL_TIME`.
    pub static dns_renewal_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_renewal_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(68), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.dns_renewal_time_for_ttl
    ///
    /// Time for a DNS OS resolution (msec) used to get TTL | Migrated from Firefox Telemetry's `DNS_RENEWAL_TIME_FOR_TTL`.
    pub static dns_renewal_time_for_ttl: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_renewal_time_for_ttl".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(69), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum FetchKeepaliveDiscardCountLabel {
        ETotalKeepaliveLimit = 0,
        EPerOriginLimit = 1,
        __Other__,
    }
    impl From<u16> for FetchKeepaliveDiscardCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETotalKeepaliveLimit,
                1 => Self::EPerOriginLimit,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FetchKeepaliveDiscardCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETotalKeepaliveLimit => "total_keepalive_limit",
                Self::EPerOriginLimit => "per_origin_limit",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.fetch_keepalive_discard_count
    ///
    /// Counts how many fetch keepalive requests are dropped due to configured resource limits.
    pub static fetch_keepalive_discard_count: Lazy<LabeledMetric<LabeledCounterMetric, FetchKeepaliveDiscardCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fetch_keepalive_discard_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(70), meta, Some(vec![::std::borrow::Cow::from("per_origin_limit"), ::std::borrow::Cow::from("total_keepalive_limit")]))
    });

    #[repr(u16)]
    pub enum FetchKeepaliveRequestCountLabel {
        EWorker = 0,
        EMain = 1,
        __Other__,
    }
    impl From<u16> for FetchKeepaliveRequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWorker,
                1 => Self::EMain,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FetchKeepaliveRequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWorker => "worker",
                Self::EMain => "main",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.fetch_keepalive_request_count
    ///
    /// Counts how many fetch keepalive requests are made. This counter helps us to understand the adoption of fetch keepalive for firefox.
    pub static fetch_keepalive_request_count: Lazy<LabeledMetric<LabeledCounterMetric, FetchKeepaliveRequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fetch_keepalive_request_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(71), meta, Some(vec![::std::borrow::Cow::from("main"), ::std::borrow::Cow::from("worker")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput
    ///
    /// The download throughput for  http/1.0, http/1.1 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_1_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(72), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput_100
    ///
    /// The download throughput for http/1.0 and http/1.1 requests size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_1_download_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_download_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(73), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput_10_50
    ///
    /// The download throughput for http/1.0 and http/1.1 requests between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_1_download_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_download_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(74), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_download_throughput_50_100
    ///
    /// The download throughput for http/1.0 and http/1.1 requests between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_1_download_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_download_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(75), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput
    ///
    /// The upload throughput for http/1.0, http/1.1 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(76), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(77), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_10_50
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(78), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_1_upload_throughput_50_100
    ///
    /// The upload throughput for http/1.0, http/1.1 request size between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_1_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_1_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(79), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput
    ///
    /// The download throughput for http/2 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_2_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(80), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput_100
    ///
    /// The download throughput for http/2 requests size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_2_download_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_download_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(81), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput_10_50
    ///
    /// The download throughput for http/2 requests between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_2_download_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_download_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(82), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_download_throughput_50_100
    ///
    /// The download throughput for http/2 requests between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_2_download_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_download_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(83), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput
    ///
    /// The upload throughput for http/2 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_2_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(84), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_100
    ///
    /// The upload throughput for http/2 request size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_2_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(85), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_10_50
    ///
    /// The upload throughput for http/2 request size between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_2_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(86), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_2_upload_throughput_50_100
    ///
    /// The upload throughput for http/2 request size between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_2_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_2_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(87), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum Http3ConnectionCloseReasonLabel {
        EApplication = 0,
        ENoerror = 1,
        EInternalerror = 2,
        EConnectionrefused = 3,
        EFlowcontrolerror = 4,
        EStreamlimiterror = 5,
        EStreamstateerror = 6,
        EFinalsizeerror = 7,
        EFrameencodingerror = 8,
        ETransportparametererror = 9,
        EProtocolviolation = 10,
        EInvalidtoken = 11,
        EApplicationerror = 12,
        ECryptobufferexceeded = 13,
        ECryptoerror = 14,
        EQlogerror = 15,
        ECryptoalert = 16,
        EEchretry = 17,
        EAckedunsentpacket = 18,
        EConnectionidlimitexceeded = 19,
        EConnectionidsexhausted = 20,
        EConnectionstate = 21,
        EDecodingframe = 22,
        EDecrypterror = 23,
        EDisabledversion = 24,
        EIdletimeout = 25,
        EIntegeroverflow = 26,
        EInvalidinput = 27,
        EInvalidmigration = 28,
        EInvalidpacket = 29,
        EInvalidresumptiontoken = 30,
        EInvalidretry = 31,
        EInvalidstreamid = 32,
        EKeysdiscarded = 33,
        EKeysexhausted = 34,
        EKeyspending = 35,
        EKeyupdateblocked = 36,
        ENoavailablepath = 37,
        ENomoredata = 38,
        ENotavailable = 39,
        ENotconnected = 40,
        EPacketnumberoverlap = 41,
        EPeerapplicationerror = 42,
        EPeererror = 43,
        EStatelessreset = 44,
        EToomuchdata = 45,
        EUnexpectedmessage = 46,
        EUnknownconnectionid = 47,
        EUnknownframetype = 48,
        EVersionnegotiation = 49,
        EWrongrole = 50,
        __Other__,
    }
    impl From<u16> for Http3ConnectionCloseReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EApplication,
                1 => Self::ENoerror,
                2 => Self::EInternalerror,
                3 => Self::EConnectionrefused,
                4 => Self::EFlowcontrolerror,
                5 => Self::EStreamlimiterror,
                6 => Self::EStreamstateerror,
                7 => Self::EFinalsizeerror,
                8 => Self::EFrameencodingerror,
                9 => Self::ETransportparametererror,
                10 => Self::EProtocolviolation,
                11 => Self::EInvalidtoken,
                12 => Self::EApplicationerror,
                13 => Self::ECryptobufferexceeded,
                14 => Self::ECryptoerror,
                15 => Self::EQlogerror,
                16 => Self::ECryptoalert,
                17 => Self::EEchretry,
                18 => Self::EAckedunsentpacket,
                19 => Self::EConnectionidlimitexceeded,
                20 => Self::EConnectionidsexhausted,
                21 => Self::EConnectionstate,
                22 => Self::EDecodingframe,
                23 => Self::EDecrypterror,
                24 => Self::EDisabledversion,
                25 => Self::EIdletimeout,
                26 => Self::EIntegeroverflow,
                27 => Self::EInvalidinput,
                28 => Self::EInvalidmigration,
                29 => Self::EInvalidpacket,
                30 => Self::EInvalidresumptiontoken,
                31 => Self::EInvalidretry,
                32 => Self::EInvalidstreamid,
                33 => Self::EKeysdiscarded,
                34 => Self::EKeysexhausted,
                35 => Self::EKeyspending,
                36 => Self::EKeyupdateblocked,
                37 => Self::ENoavailablepath,
                38 => Self::ENomoredata,
                39 => Self::ENotavailable,
                40 => Self::ENotconnected,
                41 => Self::EPacketnumberoverlap,
                42 => Self::EPeerapplicationerror,
                43 => Self::EPeererror,
                44 => Self::EStatelessreset,
                45 => Self::EToomuchdata,
                46 => Self::EUnexpectedmessage,
                47 => Self::EUnknownconnectionid,
                48 => Self::EUnknownframetype,
                49 => Self::EVersionnegotiation,
                50 => Self::EWrongrole,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3ConnectionCloseReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EApplication => "Application",
                Self::ENoerror => "NoError",
                Self::EInternalerror => "InternalError",
                Self::EConnectionrefused => "ConnectionRefused",
                Self::EFlowcontrolerror => "FlowControlError",
                Self::EStreamlimiterror => "StreamLimitError",
                Self::EStreamstateerror => "StreamStateError",
                Self::EFinalsizeerror => "FinalSizeError",
                Self::EFrameencodingerror => "FrameEncodingError",
                Self::ETransportparametererror => "TransportParameterError",
                Self::EProtocolviolation => "ProtocolViolation",
                Self::EInvalidtoken => "InvalidToken",
                Self::EApplicationerror => "ApplicationError",
                Self::ECryptobufferexceeded => "CryptoBufferExceeded",
                Self::ECryptoerror => "CryptoError",
                Self::EQlogerror => "QlogError",
                Self::ECryptoalert => "CryptoAlert",
                Self::EEchretry => "EchRetry",
                Self::EAckedunsentpacket => "AckedUnsentPacket",
                Self::EConnectionidlimitexceeded => "ConnectionIdLimitExceeded",
                Self::EConnectionidsexhausted => "ConnectionIdsExhausted",
                Self::EConnectionstate => "ConnectionState",
                Self::EDecodingframe => "DecodingFrame",
                Self::EDecrypterror => "DecryptError",
                Self::EDisabledversion => "DisabledVersion",
                Self::EIdletimeout => "IdleTimeout",
                Self::EIntegeroverflow => "IntegerOverflow",
                Self::EInvalidinput => "InvalidInput",
                Self::EInvalidmigration => "InvalidMigration",
                Self::EInvalidpacket => "InvalidPacket",
                Self::EInvalidresumptiontoken => "InvalidResumptionToken",
                Self::EInvalidretry => "InvalidRetry",
                Self::EInvalidstreamid => "InvalidStreamId",
                Self::EKeysdiscarded => "KeysDiscarded",
                Self::EKeysexhausted => "KeysExhausted",
                Self::EKeyspending => "KeysPending",
                Self::EKeyupdateblocked => "KeyUpdateBlocked",
                Self::ENoavailablepath => "NoAvailablePath",
                Self::ENomoredata => "NoMoreData",
                Self::ENotavailable => "NotAvailable",
                Self::ENotconnected => "NotConnected",
                Self::EPacketnumberoverlap => "PacketNumberOverlap",
                Self::EPeerapplicationerror => "PeerApplicationError",
                Self::EPeererror => "PeerError",
                Self::EStatelessreset => "StatelessReset",
                Self::EToomuchdata => "TooMuchData",
                Self::EUnexpectedmessage => "UnexpectedMessage",
                Self::EUnknownconnectionid => "UnknownConnectionId",
                Self::EUnknownframetype => "UnknownFrameType",
                Self::EVersionnegotiation => "VersionNegotiation",
                Self::EWrongrole => "WrongRole",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_connection_close_reason
    ///
    /// Number of HTTP3 connections closed, labeled by reason.
    pub static http_3_connection_close_reason: Lazy<LabeledMetric<LabeledCounterMetric, Http3ConnectionCloseReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_3_connection_close_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(88), meta, Some(vec![::std::borrow::Cow::from("AckedUnsentPacket"), ::std::borrow::Cow::from("Application"), ::std::borrow::Cow::from("ApplicationError"), ::std::borrow::Cow::from("ConnectionIdLimitExceeded"), ::std::borrow::Cow::from("ConnectionIdsExhausted"), ::std::borrow::Cow::from("ConnectionRefused"), ::std::borrow::Cow::from("ConnectionState"), ::std::borrow::Cow::from("CryptoAlert"), ::std::borrow::Cow::from("CryptoBufferExceeded"), ::std::borrow::Cow::from("CryptoError"), ::std::borrow::Cow::from("DecodingFrame"), ::std::borrow::Cow::from("DecryptError"), ::std::borrow::Cow::from("DisabledVersion"), ::std::borrow::Cow::from("EchRetry"), ::std::borrow::Cow::from("FinalSizeError"), ::std::borrow::Cow::from("FlowControlError"), ::std::borrow::Cow::from("FrameEncodingError"), ::std::borrow::Cow::from("IdleTimeout"), ::std::borrow::Cow::from("IntegerOverflow"), ::std::borrow::Cow::from("InternalError"), ::std::borrow::Cow::from("InvalidInput"), ::std::borrow::Cow::from("InvalidMigration"), ::std::borrow::Cow::from("InvalidPacket"), ::std::borrow::Cow::from("InvalidResumptionToken"), ::std::borrow::Cow::from("InvalidRetry"), ::std::borrow::Cow::from("InvalidStreamId"), ::std::borrow::Cow::from("InvalidToken"), ::std::borrow::Cow::from("KeyUpdateBlocked"), ::std::borrow::Cow::from("KeysDiscarded"), ::std::borrow::Cow::from("KeysExhausted"), ::std::borrow::Cow::from("KeysPending"), ::std::borrow::Cow::from("NoAvailablePath"), ::std::borrow::Cow::from("NoError"), ::std::borrow::Cow::from("NoMoreData"), ::std::borrow::Cow::from("NotAvailable"), ::std::borrow::Cow::from("NotConnected"), ::std::borrow::Cow::from("PacketNumberOverlap"), ::std::borrow::Cow::from("PeerApplicationError"), ::std::borrow::Cow::from("PeerError"), ::std::borrow::Cow::from("ProtocolViolation"), ::std::borrow::Cow::from("QlogError"), ::std::borrow::Cow::from("StatelessReset"), ::std::borrow::Cow::from("StreamLimitError"), ::std::borrow::Cow::from("StreamStateError"), ::std::borrow::Cow::from("TooMuchData"), ::std::borrow::Cow::from("TransportParameterError"), ::std::borrow::Cow::from("UnexpectedMessage"), ::std::borrow::Cow::from("UnknownConnectionId"), ::std::borrow::Cow::from("UnknownFrameType"), ::std::borrow::Cow::from("VersionNegotiation"), ::std::borrow::Cow::from("WrongRole")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput
    ///
    /// The download throughput for http/3 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_3_download_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(89), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_100
    ///
    /// The download throughput for http/3 requests size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_3_download_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(90), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_10_50
    ///
    /// The download throughput for http/3 requests between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_3_download_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(91), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_download_throughput_50_100
    ///
    /// The download throughput for http/3 requests between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_3_download_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_download_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(92), meta, 0, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_ce_ect0_ratio_received
    ///
    /// HTTP3: ECN CE to ECT0 ratio (multiply by 10000) received.
    pub static http_3_ecn_ce_ect0_ratio_received: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_ecn_ce_ect0_ratio_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(93), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_ce_ect0_ratio_sent
    ///
    /// HTTP3: ECN CE to ECT0 ratio (multiply by 10000) sent.
    pub static http_3_ecn_ce_ect0_ratio_sent: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_ecn_ce_ect0_ratio_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(94), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum Http3EcnPathCapabilityLabel {
        ECapable = 0,
        EBlackHole = 1,
        EBleaching = 2,
        EReceivedUnsentEct1 = 3,
        __Other__,
    }
    impl From<u16> for Http3EcnPathCapabilityLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECapable,
                1 => Self::EBlackHole,
                2 => Self::EBleaching,
                3 => Self::EReceivedUnsentEct1,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3EcnPathCapabilityLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECapable => "capable",
                Self::EBlackHole => "black-hole",
                Self::EBleaching => "bleaching",
                Self::EReceivedUnsentEct1 => "received-unsent-ect-1",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_ecn_path_capability
    ///
    /// Number of paths known to be ECN capable or not-capable.
    pub static http_3_ecn_path_capability: Lazy<LabeledMetric<LabeledCounterMetric, Http3EcnPathCapabilityLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_3_ecn_path_capability".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(95), meta, Some(vec![::std::borrow::Cow::from("black-hole"), ::std::borrow::Cow::from("bleaching"), ::std::borrow::Cow::from("capable"), ::std::borrow::Cow::from("received-unsent-ect-1")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_loss_ratio
    ///
    /// HTTP3: packet loss ratio (multiply by 10000).
    pub static http_3_loss_ratio: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_loss_ratio".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(96), meta, 0, 2000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum Http3QuicFrameCountLabel {
        EAckTx = 0,
        EAckRx = 1,
        ECryptoTx = 2,
        ECryptoRx = 3,
        EStreamTx = 4,
        EStreamRx = 5,
        EResetStreamTx = 6,
        EResetStreamRx = 7,
        EStopSendingTx = 8,
        EStopSendingRx = 9,
        EPingTx = 10,
        EPingRx = 11,
        EPaddingTx = 12,
        EPaddingRx = 13,
        EMaxStreamsTx = 14,
        EMaxStreamsRx = 15,
        EStreamsBlockedTx = 16,
        EStreamsBlockedRx = 17,
        EMaxDataTx = 18,
        EMaxDataRx = 19,
        EDataBlockedTx = 20,
        EDataBlockedRx = 21,
        EMaxStreamDataTx = 22,
        EMaxStreamDataRx = 23,
        EStreamDataBlockedTx = 24,
        EStreamDataBlockedRx = 25,
        ENewConnectionIdTx = 26,
        ENewConnectionIdRx = 27,
        ERetireConnectionIdTx = 28,
        ERetireConnectionIdRx = 29,
        EPathChallengeTx = 30,
        EPathChallengeRx = 31,
        EPathResponseTx = 32,
        EPathResponseRx = 33,
        EConnectionCloseTx = 34,
        EConnectionCloseRx = 35,
        EHandshakeDoneTx = 36,
        EHandshakeDoneRx = 37,
        ENewTokenTx = 38,
        ENewTokenRx = 39,
        EAckFrequencyTx = 40,
        EAckFrequencyRx = 41,
        EDatagramTx = 42,
        EDatagramRx = 43,
        __Other__,
    }
    impl From<u16> for Http3QuicFrameCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAckTx,
                1 => Self::EAckRx,
                2 => Self::ECryptoTx,
                3 => Self::ECryptoRx,
                4 => Self::EStreamTx,
                5 => Self::EStreamRx,
                6 => Self::EResetStreamTx,
                7 => Self::EResetStreamRx,
                8 => Self::EStopSendingTx,
                9 => Self::EStopSendingRx,
                10 => Self::EPingTx,
                11 => Self::EPingRx,
                12 => Self::EPaddingTx,
                13 => Self::EPaddingRx,
                14 => Self::EMaxStreamsTx,
                15 => Self::EMaxStreamsRx,
                16 => Self::EStreamsBlockedTx,
                17 => Self::EStreamsBlockedRx,
                18 => Self::EMaxDataTx,
                19 => Self::EMaxDataRx,
                20 => Self::EDataBlockedTx,
                21 => Self::EDataBlockedRx,
                22 => Self::EMaxStreamDataTx,
                23 => Self::EMaxStreamDataRx,
                24 => Self::EStreamDataBlockedTx,
                25 => Self::EStreamDataBlockedRx,
                26 => Self::ENewConnectionIdTx,
                27 => Self::ENewConnectionIdRx,
                28 => Self::ERetireConnectionIdTx,
                29 => Self::ERetireConnectionIdRx,
                30 => Self::EPathChallengeTx,
                31 => Self::EPathChallengeRx,
                32 => Self::EPathResponseTx,
                33 => Self::EPathResponseRx,
                34 => Self::EConnectionCloseTx,
                35 => Self::EConnectionCloseRx,
                36 => Self::EHandshakeDoneTx,
                37 => Self::EHandshakeDoneRx,
                38 => Self::ENewTokenTx,
                39 => Self::ENewTokenRx,
                40 => Self::EAckFrequencyTx,
                41 => Self::EAckFrequencyRx,
                42 => Self::EDatagramTx,
                43 => Self::EDatagramRx,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3QuicFrameCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAckTx => "ack_tx",
                Self::EAckRx => "ack_rx",
                Self::ECryptoTx => "crypto_tx",
                Self::ECryptoRx => "crypto_rx",
                Self::EStreamTx => "stream_tx",
                Self::EStreamRx => "stream_rx",
                Self::EResetStreamTx => "reset_stream_tx",
                Self::EResetStreamRx => "reset_stream_rx",
                Self::EStopSendingTx => "stop_sending_tx",
                Self::EStopSendingRx => "stop_sending_rx",
                Self::EPingTx => "ping_tx",
                Self::EPingRx => "ping_rx",
                Self::EPaddingTx => "padding_tx",
                Self::EPaddingRx => "padding_rx",
                Self::EMaxStreamsTx => "max_streams_tx",
                Self::EMaxStreamsRx => "max_streams_rx",
                Self::EStreamsBlockedTx => "streams_blocked_tx",
                Self::EStreamsBlockedRx => "streams_blocked_rx",
                Self::EMaxDataTx => "max_data_tx",
                Self::EMaxDataRx => "max_data_rx",
                Self::EDataBlockedTx => "data_blocked_tx",
                Self::EDataBlockedRx => "data_blocked_rx",
                Self::EMaxStreamDataTx => "max_stream_data_tx",
                Self::EMaxStreamDataRx => "max_stream_data_rx",
                Self::EStreamDataBlockedTx => "stream_data_blocked_tx",
                Self::EStreamDataBlockedRx => "stream_data_blocked_rx",
                Self::ENewConnectionIdTx => "new_connection_id_tx",
                Self::ENewConnectionIdRx => "new_connection_id_rx",
                Self::ERetireConnectionIdTx => "retire_connection_id_tx",
                Self::ERetireConnectionIdRx => "retire_connection_id_rx",
                Self::EPathChallengeTx => "path_challenge_tx",
                Self::EPathChallengeRx => "path_challenge_rx",
                Self::EPathResponseTx => "path_response_tx",
                Self::EPathResponseRx => "path_response_rx",
                Self::EConnectionCloseTx => "connection_close_tx",
                Self::EConnectionCloseRx => "connection_close_rx",
                Self::EHandshakeDoneTx => "handshake_done_tx",
                Self::EHandshakeDoneRx => "handshake_done_rx",
                Self::ENewTokenTx => "new_token_tx",
                Self::ENewTokenRx => "new_token_rx",
                Self::EAckFrequencyTx => "ack_frequency_tx",
                Self::EAckFrequencyRx => "ack_frequency_rx",
                Self::EDatagramTx => "datagram_tx",
                Self::EDatagramRx => "datagram_rx",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_quic_frame_count
    ///
    /// Number of QUIC frames send and received by type.
    pub static http_3_quic_frame_count: Lazy<LabeledMetric<LabeledCounterMetric, Http3QuicFrameCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_3_quic_frame_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(97), meta, Some(vec![::std::borrow::Cow::from("ack_frequency_rx"), ::std::borrow::Cow::from("ack_frequency_tx"), ::std::borrow::Cow::from("ack_rx"), ::std::borrow::Cow::from("ack_tx"), ::std::borrow::Cow::from("connection_close_rx"), ::std::borrow::Cow::from("connection_close_tx"), ::std::borrow::Cow::from("crypto_rx"), ::std::borrow::Cow::from("crypto_tx"), ::std::borrow::Cow::from("data_blocked_rx"), ::std::borrow::Cow::from("data_blocked_tx"), ::std::borrow::Cow::from("datagram_rx"), ::std::borrow::Cow::from("datagram_tx"), ::std::borrow::Cow::from("handshake_done_rx"), ::std::borrow::Cow::from("handshake_done_tx"), ::std::borrow::Cow::from("max_data_rx"), ::std::borrow::Cow::from("max_data_tx"), ::std::borrow::Cow::from("max_stream_data_rx"), ::std::borrow::Cow::from("max_stream_data_tx"), ::std::borrow::Cow::from("max_streams_rx"), ::std::borrow::Cow::from("max_streams_tx"), ::std::borrow::Cow::from("new_connection_id_rx"), ::std::borrow::Cow::from("new_connection_id_tx"), ::std::borrow::Cow::from("new_token_rx"), ::std::borrow::Cow::from("new_token_tx"), ::std::borrow::Cow::from("padding_rx"), ::std::borrow::Cow::from("padding_tx"), ::std::borrow::Cow::from("path_challenge_rx"), ::std::borrow::Cow::from("path_challenge_tx"), ::std::borrow::Cow::from("path_response_rx"), ::std::borrow::Cow::from("path_response_tx"), ::std::borrow::Cow::from("ping_rx"), ::std::borrow::Cow::from("ping_tx"), ::std::borrow::Cow::from("reset_stream_rx"), ::std::borrow::Cow::from("reset_stream_tx"), ::std::borrow::Cow::from("retire_connection_id_rx"), ::std::borrow::Cow::from("retire_connection_id_tx"), ::std::borrow::Cow::from("stop_sending_rx"), ::std::borrow::Cow::from("stop_sending_tx"), ::std::borrow::Cow::from("stream_data_blocked_rx"), ::std::borrow::Cow::from("stream_data_blocked_tx"), ::std::borrow::Cow::from("stream_rx"), ::std::borrow::Cow::from("stream_tx"), ::std::borrow::Cow::from("streams_blocked_rx"), ::std::borrow::Cow::from("streams_blocked_tx")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segment_size_received
    ///
    /// HTTP3 UDP datagram size received.
    pub static http_3_udp_datagram_segment_size_received: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segment_size_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(98), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segment_size_sent
    ///
    /// HTTP3 UDP datagram segment size sent.
    pub static http_3_udp_datagram_segment_size_sent: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segment_size_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(99), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_segments_received
    ///
    /// HTTP3 UDP number of segments per datagram received.
    pub static http_3_udp_datagram_segments_received: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_segments_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(100), meta, 0, 128, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_udp_datagram_size_received
    ///
    /// HTTP3 UDP datagram size received.
    pub static http_3_udp_datagram_size_received: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_udp_datagram_size_received".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(101), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput
    ///
    /// The upload throughput for http/3 requests larger than 10MB. Measured in megabits per second, Mbps.
    pub static http_3_upload_throughput: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(102), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_100
    ///
    /// The upload throughput for http/3 request size larger than 100MB. Measured in megabits per second, Mbps.
    pub static http_3_upload_throughput_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(103), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_10_50
    ///
    /// The upload throughput for http/3 request size between 10MB and 50MB. Measured in megabits per second, Mbps.
    pub static http_3_upload_throughput_10_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_10_50".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(104), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_3_upload_throughput_50_100
    ///
    /// The upload throughput for http/3 request size between 50MB and 100MB. Measured in megabits per second, Mbps.
    pub static http_3_upload_throughput_50_100: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_3_upload_throughput_50_100".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(105), meta, 0, 5000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionLabel {
        EHttpCancelled = 0,
        EHttpDisk = 1,
        EHttpNetOk = 2,
        EHttpNetEarlyFail = 3,
        EHttpNetLateFail = 4,
        EHttpsCancelled = 5,
        EHttpsDisk = 6,
        EHttpsNetOk = 7,
        EHttpsNetEarlyFail = 8,
        EHttpsNetLateFail = 9,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttpCancelled,
                1 => Self::EHttpDisk,
                2 => Self::EHttpNetOk,
                3 => Self::EHttpNetEarlyFail,
                4 => Self::EHttpNetLateFail,
                5 => Self::EHttpsCancelled,
                6 => Self::EHttpsDisk,
                7 => Self::EHttpsNetOk,
                8 => Self::EHttpsNetEarlyFail,
                9 => Self::EHttpsNetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttpCancelled => "http_cancelled",
                Self::EHttpDisk => "http_disk",
                Self::EHttpNetOk => "http_net_ok",
                Self::EHttpNetEarlyFail => "http_net_early_fail",
                Self::EHttpNetLateFail => "http_net_late_fail",
                Self::EHttpsCancelled => "https_cancelled",
                Self::EHttpsDisk => "https_disk",
                Self::EHttpsNetOk => "https_net_ok",
                Self::EHttpsNetEarlyFail => "https_net_early_fail",
                Self::EHttpsNetLateFail => "https_net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition
    ///
    /// Channel Disposition for HTTP and HTTPS: cancel, disk, net_ok, net_early_fail, and net_late_fail
    pub static http_channel_disposition: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(106), meta, Some(vec![::std::borrow::Cow::from("http_cancelled"), ::std::borrow::Cow::from("http_disk"), ::std::borrow::Cow::from("http_net_early_fail"), ::std::borrow::Cow::from("http_net_late_fail"), ::std::borrow::Cow::from("http_net_ok"), ::std::borrow::Cow::from("https_cancelled"), ::std::borrow::Cow::from("https_disk"), ::std::borrow::Cow::from("https_net_early_fail"), ::std::borrow::Cow::from("https_net_late_fail"), ::std::borrow::Cow::from("https_net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledNoReasonLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledNoReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledNoReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_no_reason
    ///
    /// Upgrading display content Channel Disposition (key: disabled_no_reason)
    pub static http_channel_disposition_disabled_no_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledNoReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_no_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(107), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledUpgradeLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledUpgradeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledUpgradeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_upgrade
    ///
    /// Upgrading display content Channel Disposition (key: disable_upgrade)
    pub static http_channel_disposition_disabled_upgrade: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledUpgradeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_upgrade".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(108), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionDisabledWontLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionDisabledWontLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionDisabledWontLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_disabled_wont
    ///
    /// Upgrading display content Channel Disposition (key: disabled_wont)
    pub static http_channel_disposition_disabled_wont: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionDisabledWontLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_disabled_wont".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(109), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledNoReasonLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledNoReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledNoReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_no_reason
    ///
    /// Upgrading display content Channel Disposition (key: enabled_no_reason)
    pub static http_channel_disposition_enabled_no_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledNoReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_no_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(110), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledUpgradeLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledUpgradeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledUpgradeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_upgrade
    ///
    /// Upgrading display content Channel Disposition (key: enable_upgrade)
    pub static http_channel_disposition_enabled_upgrade: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledUpgradeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_upgrade".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(111), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelDispositionEnabledWontLabel {
        ECancel = 0,
        EDisk = 1,
        ENetOk = 2,
        ENetEarlyFail = 3,
        ENetLateFail = 4,
        __Other__,
    }
    impl From<u16> for HttpChannelDispositionEnabledWontLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECancel,
                1 => Self::EDisk,
                2 => Self::ENetOk,
                3 => Self::ENetEarlyFail,
                4 => Self::ENetLateFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelDispositionEnabledWontLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECancel => "cancel",
                Self::EDisk => "disk",
                Self::ENetOk => "net_ok",
                Self::ENetEarlyFail => "net_early_fail",
                Self::ENetLateFail => "net_late_fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_disposition_enabled_wont
    ///
    /// Upgrading display content Channel Disposition (key: enabled_wont)
    pub static http_channel_disposition_enabled_wont: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelDispositionEnabledWontLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_disposition_enabled_wont".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(112), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("disk"), ::std::borrow::Cow::from("net_early_fail"), ::std::borrow::Cow::from("net_late_fail"), ::std::borrow::Cow::from("net_ok")]))
    });

    #[repr(u16)]
    pub enum HttpChannelOnstartStatusLabel {
        ESuccessful = 0,
        EFail = 1,
        __Other__,
    }
    impl From<u16> for HttpChannelOnstartStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccessful,
                1 => Self::EFail,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelOnstartStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccessful => "successful",
                Self::EFail => "fail",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_onstart_status
    ///
    /// Whether successfully started HTTP channels
    pub static http_channel_onstart_status: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelOnstartStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_onstart_status".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(113), meta, Some(vec![::std::borrow::Cow::from("fail"), ::std::borrow::Cow::from("successful")]))
    });

    #[repr(u16)]
    pub enum HttpChannelOnstartSuccessHttpsRrLabel {
        ESuccess = 0,
        EFailure = 1,
        ESuccessEchUsed = 2,
        EFailureEchUsed = 3,
        __Other__,
    }
    impl From<u16> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::ESuccessEchUsed,
                3 => Self::EFailureEchUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpChannelOnstartSuccessHttpsRrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::ESuccessEchUsed => "success_ech_used",
                Self::EFailureEchUsed => "failure_ech_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_onstart_success_https_rr
    ///
    /// Successfully started HTTP channels when HTTPS RR is used
    pub static http_channel_onstart_success_https_rr: Lazy<LabeledMetric<LabeledCounterMetric, HttpChannelOnstartSuccessHttpsRrLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_channel_onstart_success_https_rr".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(114), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("failure_ech_used"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("success_ech_used")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable for page loads without HTTPS RR
    pub static http_channel_page_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_page_open_to_first_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(115), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_page_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable for page loads with HTTPS RR
    pub static http_channel_page_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_page_open_to_first_sent_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(116), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable for sub-resource loads without HTTPS RR
    pub static http_channel_sub_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_sub_open_to_first_sent".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(117), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_channel_sub_open_to_first_sent_https_rr
    ///
    /// Time in milliseconds from AsyncOpen to first byte of request sent, applicable for sub-resource loads with HTTPS RR
    pub static http_channel_sub_open_to_first_sent_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_channel_sub_open_to_first_sent_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(118), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_cssloader_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest for CSSLoader in the content process
    pub static http_content_cssloader_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_cssloader_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(119), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_html5parser_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if OnDataFinished comes first)
    pub static http_content_html5parser_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_html5parser_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(120), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_delay
    ///
    /// The time between dispatching OnDataFinished from the socket thread and processing it on main/background thread.
    pub static http_content_ondatafinished_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(121), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_delay_2
    ///
    /// The time between dispatching OnDataFinished from the socket thread and processing it on the background thread.
    pub static http_content_ondatafinished_delay_2: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_delay_2".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(122), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_ondatafinished_to_onstop_delay
    ///
    /// The time between processing OnDataFinished and processing OnStopRequest (if OnDataFinished comes first)
    pub static http_content_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_ondatafinished_to_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(123), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstart_delay
    ///
    /// The time between dispatching OnStartRequest from the socket thread and processing it on the main thread (content process).
    pub static http_content_onstart_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_onstart_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(124), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_content_onstop_delay
    ///
    /// The time between dispatching OnStopRequest from the socket thread and processing it on the main thread (content process).
    pub static http_content_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_onstop_delay".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(125), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum HttpIpAddrAnyCountLabel {
        ENotBlockedRequests = 0,
        EBlockedRequests = 1,
        __Other__,
    }
    impl From<u16> for HttpIpAddrAnyCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotBlockedRequests,
                1 => Self::EBlockedRequests,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpIpAddrAnyCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotBlockedRequests => "not_blocked_requests",
                Self::EBlockedRequests => "blocked_requests",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_ip_addr_any_count
    ///
    /// The number of times we see the IP address 0.0.0.0 or its IPv6 equivalent.
    pub static http_ip_addr_any_count: Lazy<LabeledMetric<LabeledCounterMetric, HttpIpAddrAnyCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_ip_addr_any_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(126), meta, Some(vec![::std::borrow::Cow::from("blocked_requests"), ::std::borrow::Cow::from("not_blocked_requests")]))
    });

    #[repr(u16)]
    pub enum HttpIpAddrAnyHostnamesLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for HttpIpAddrAnyHostnamesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpIpAddrAnyHostnamesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_ip_addr_any_hostnames
    ///
    /// The number of times we see the IP address 0.0.0.0 or its IPv6 equivalent used as hostnames
    pub static http_ip_addr_any_hostnames: Lazy<LabeledMetric<LabeledCounterMetric, HttpIpAddrAnyHostnamesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_ip_addr_any_hostnames".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(127), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_onstart_suspend_total_time
    ///
    /// Time in milliseconds that http channel spent suspended between AsyncOpen and OnStartRequest.
    pub static http_onstart_suspend_total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_onstart_suspend_total_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(128), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_redirect_to_scheme_subresource
    ///
    /// Count of the HTTP redirection that triggered by subresource, keyed by the URL scheme redirected to
    pub static http_redirect_to_scheme_subresource: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_redirect_to_scheme_subresource".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(129), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http_redirect_to_scheme_top_level
    ///
    /// Count of the HTTP redirection that triggered by top-level document, keyed by the URL scheme redirected to
    pub static http_redirect_to_scheme_top_level: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_redirect_to_scheme_top_level".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(130), meta, None)
    });

    #[repr(u16)]
    pub enum HttpResponseStatusCodeLabel {
        E200Ok = 0,
        E301MovedPermanently = 1,
        E302Found = 2,
        E304NotModified = 3,
        E307TemporaryRedirect = 4,
        E308PermanentRedirect = 5,
        E400BadRequest = 6,
        E401Unauthorized = 7,
        E403Forbidden = 8,
        E404NotFound = 9,
        E421MisdirectedRequest = 10,
        E425TooEarly = 11,
        E429TooManyRequests = 12,
        EOther4xx = 13,
        EOther5xx = 14,
        EOther = 15,
        __Other__,
    }
    impl From<u16> for HttpResponseStatusCodeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::E200Ok,
                1 => Self::E301MovedPermanently,
                2 => Self::E302Found,
                3 => Self::E304NotModified,
                4 => Self::E307TemporaryRedirect,
                5 => Self::E308PermanentRedirect,
                6 => Self::E400BadRequest,
                7 => Self::E401Unauthorized,
                8 => Self::E403Forbidden,
                9 => Self::E404NotFound,
                10 => Self::E421MisdirectedRequest,
                11 => Self::E425TooEarly,
                12 => Self::E429TooManyRequests,
                13 => Self::EOther4xx,
                14 => Self::EOther5xx,
                15 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpResponseStatusCodeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::E200Ok => "200_ok",
                Self::E301MovedPermanently => "301_moved_permanently",
                Self::E302Found => "302_found",
                Self::E304NotModified => "304_not_modified",
                Self::E307TemporaryRedirect => "307_temporary_redirect",
                Self::E308PermanentRedirect => "308_permanent_redirect",
                Self::E400BadRequest => "400_bad_request",
                Self::E401Unauthorized => "401_unauthorized",
                Self::E403Forbidden => "403_forbidden",
                Self::E404NotFound => "404_not_found",
                Self::E421MisdirectedRequest => "421_misdirected_request",
                Self::E425TooEarly => "425_too_early",
                Self::E429TooManyRequests => "429_too_many_requests",
                Self::EOther4xx => "other_4xx",
                Self::EOther5xx => "other_5xx",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_response_status_code
    ///
    /// HTTP Response Status Code (200, 301, 302, 304, 307, 308, 400, 401, 403, 404, 421, 425, 429, other 400 and 500)
    pub static http_response_status_code: Lazy<LabeledMetric<LabeledCounterMetric, HttpResponseStatusCodeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_response_status_code".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(131), meta, Some(vec![::std::borrow::Cow::from("200_ok"), ::std::borrow::Cow::from("301_moved_permanently"), ::std::borrow::Cow::from("302_found"), ::std::borrow::Cow::from("304_not_modified"), ::std::borrow::Cow::from("307_temporary_redirect"), ::std::borrow::Cow::from("308_permanent_redirect"), ::std::borrow::Cow::from("400_bad_request"), ::std::borrow::Cow::from("401_unauthorized"), ::std::borrow::Cow::from("403_forbidden"), ::std::borrow::Cow::from("404_not_found"), ::std::borrow::Cow::from("421_misdirected_request"), ::std::borrow::Cow::from("425_too_early"), ::std::borrow::Cow::from("429_too_many_requests"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("other_4xx"), ::std::borrow::Cow::from("other_5xx")]))
    });

    #[repr(u16)]
    pub enum HttpResponseVersionLabel {
        EUnknown = 0,
        EHttp1 = 1,
        EHttp2 = 2,
        EHttp3 = 3,
        __Other__,
    }
    impl From<u16> for HttpResponseVersionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EHttp1,
                2 => Self::EHttp2,
                3 => Self::EHttp3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpResponseVersionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EHttp1 => "http_1",
                Self::EHttp2 => "http_2",
                Self::EHttp3 => "http_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_response_version
    ///
    /// HTTP protocol version used on response from nsHttp.h
    pub static http_response_version: Lazy<LabeledMetric<LabeledCounterMetric, HttpResponseVersionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_response_version".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(132), meta, Some(vec![::std::borrow::Cow::from("http_1"), ::std::borrow::Cow::from("http_2"), ::std::borrow::Cow::from("http_3"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum HttpToHttpsUpgradeReasonLabel {
        ENotInitialized = 0,
        ENotInitializedHttps = 1,
        ENoUpgrade = 2,
        ENoUpgradeHttps = 3,
        EAlreadyHttps = 4,
        EHsts = 5,
        EHttpsOnlyUpgrade = 6,
        EHttpsOnlyUpgradeDowngrade = 7,
        EHttpsFirstUpgrade = 8,
        EHttpsFirstUpgradeDowngrade = 9,
        EHttpsFirstSchemelessUpgrade = 10,
        EHttpsFirstSchemelessUpgradeDowngrade = 11,
        ECspUir = 12,
        EHttpsRr = 13,
        EWebExtensionUpgrade = 14,
        EUpgradeException = 15,
        ESkipUpgrade = 16,
        __Other__,
    }
    impl From<u16> for HttpToHttpsUpgradeReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotInitialized,
                1 => Self::ENotInitializedHttps,
                2 => Self::ENoUpgrade,
                3 => Self::ENoUpgradeHttps,
                4 => Self::EAlreadyHttps,
                5 => Self::EHsts,
                6 => Self::EHttpsOnlyUpgrade,
                7 => Self::EHttpsOnlyUpgradeDowngrade,
                8 => Self::EHttpsFirstUpgrade,
                9 => Self::EHttpsFirstUpgradeDowngrade,
                10 => Self::EHttpsFirstSchemelessUpgrade,
                11 => Self::EHttpsFirstSchemelessUpgradeDowngrade,
                12 => Self::ECspUir,
                13 => Self::EHttpsRr,
                14 => Self::EWebExtensionUpgrade,
                15 => Self::EUpgradeException,
                16 => Self::ESkipUpgrade,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpToHttpsUpgradeReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotInitialized => "not_initialized",
                Self::ENotInitializedHttps => "not_initialized_https",
                Self::ENoUpgrade => "no_upgrade",
                Self::ENoUpgradeHttps => "no_upgrade_https",
                Self::EAlreadyHttps => "already_https",
                Self::EHsts => "hsts",
                Self::EHttpsOnlyUpgrade => "https_only_upgrade",
                Self::EHttpsOnlyUpgradeDowngrade => "https_only_upgrade_downgrade",
                Self::EHttpsFirstUpgrade => "https_first_upgrade",
                Self::EHttpsFirstUpgradeDowngrade => "https_first_upgrade_downgrade",
                Self::EHttpsFirstSchemelessUpgrade => "https_first_schemeless_upgrade",
                Self::EHttpsFirstSchemelessUpgradeDowngrade => "https_first_schemeless_upgrade_downgrade",
                Self::ECspUir => "csp_uir",
                Self::EHttpsRr => "https_rr",
                Self::EWebExtensionUpgrade => "web_extension_upgrade",
                Self::EUpgradeException => "upgrade_exception",
                Self::ESkipUpgrade => "skip_upgrade",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.http_to_https_upgrade_reason
    ///
    /// Whether a top-level HTTP request gets upgraded to HTTPS and the reason for it
    pub static http_to_https_upgrade_reason: Lazy<LabeledMetric<LabeledCounterMetric, HttpToHttpsUpgradeReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http_to_https_upgrade_reason".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(133), meta, Some(vec![::std::borrow::Cow::from("already_https"), ::std::borrow::Cow::from("csp_uir"), ::std::borrow::Cow::from("hsts"), ::std::borrow::Cow::from("https_first_schemeless_upgrade"), ::std::borrow::Cow::from("https_first_schemeless_upgrade_downgrade"), ::std::borrow::Cow::from("https_first_upgrade"), ::std::borrow::Cow::from("https_first_upgrade_downgrade"), ::std::borrow::Cow::from("https_only_upgrade"), ::std::borrow::Cow::from("https_only_upgrade_downgrade"), ::std::borrow::Cow::from("https_rr"), ::std::borrow::Cow::from("no_upgrade"), ::std::borrow::Cow::from("no_upgrade_https"), ::std::borrow::Cow::from("not_initialized"), ::std::borrow::Cow::from("not_initialized_https"), ::std::borrow::Cow::from("skip_upgrade"), ::std::borrow::Cow::from("upgrade_exception"), ::std::borrow::Cow::from("web_extension_upgrade")]))
    });

    #[repr(u16)]
    pub enum HttpsHttpOrLocalLabel {
        ELoadIsHttps = 0,
        ELoadIsHttp = 1,
        ELoadIsHttpForLocalDomain = 2,
        __Other__,
    }
    impl From<u16> for HttpsHttpOrLocalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ELoadIsHttps,
                1 => Self::ELoadIsHttp,
                2 => Self::ELoadIsHttpForLocalDomain,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsHttpOrLocalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ELoadIsHttps => "load_is_https",
                Self::ELoadIsHttp => "load_is_http",
                Self::ELoadIsHttpForLocalDomain => "load_is_http_for_local_domain",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_http_or_local
    ///
    /// Whether a top-level request is HTTPS, HTTP, or HTTP for local domain
    pub static https_http_or_local: Lazy<LabeledMetric<LabeledCounterMetric, HttpsHttpOrLocalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "https_http_or_local".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(134), meta, Some(vec![::std::borrow::Cow::from("load_is_http"), ::std::borrow::Cow::from("load_is_http_for_local_domain"), ::std::borrow::Cow::from("load_is_https")]))
    });

    #[repr(u16)]
    pub enum HttpsRrPresentedLabel {
        EPresented = 0,
        EPresentedWithHttp3 = 1,
        ENone = 2,
        __Other__,
    }
    impl From<u16> for HttpsRrPresentedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresented,
                1 => Self::EPresentedWithHttp3,
                2 => Self::ENone,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsRrPresentedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresented => "presented",
                Self::EPresentedWithHttp3 => "presented_with_http3",
                Self::ENone => "none",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_rr_presented
    ///
    /// HTTPS RR is presented or not
    pub static https_rr_presented: Lazy<LabeledMetric<LabeledCounterMetric, HttpsRrPresentedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "https_rr_presented".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(135), meta, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("presented"), ::std::borrow::Cow::from("presented_with_http3")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.os_socket_limit_reached
    ///
    /// Counts the number of times the os socket limit was reached. i.e. CanAttachSocket() returned false.
    pub static os_socket_limit_reached: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            136,
            "networking",
            "os_socket_limit_reached",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_tcp_blocking_time_connectivity_change
    ///
    /// Time spent blocked in PR_Close when there has been the connectivity change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_TCP_BLOCKING_TIME_CONNECTIVITY_CHANGE.
    pub static prclose_tcp_blocking_time_connectivity_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_tcp_blocking_time_connectivity_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(137), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_tcp_blocking_time_link_change
    ///
    /// Time spent blocked in PR_Close when there has been a link change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_TCP_BLOCKING_TIME_LINK_CHANGE.
    pub static prclose_tcp_blocking_time_link_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_tcp_blocking_time_link_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(138), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_tcp_blocking_time_normal
    ///
    /// Time spent blocked in PR_Close when we are not shutting down and there has been niether a network nor an offline state change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_TCP_BLOCKING_TIME_NORMAL.
    pub static prclose_tcp_blocking_time_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_tcp_blocking_time_normal".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(139), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_tcp_blocking_time_offline
    ///
    /// Time spent blocked in PR_Close when the offline state has changed in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_TCP_BLOCKING_TIME_OFFLINE.
    pub static prclose_tcp_blocking_time_offline: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_tcp_blocking_time_offline".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(140), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_tcp_blocking_time_shutdown
    ///
    /// Time spent blocked in PR_Close during a shutdown (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_TCP_BLOCKING_TIME_SHUTDOWN.
    pub static prclose_tcp_blocking_time_shutdown: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_tcp_blocking_time_shutdown".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(141), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_udp_blocking_time_connectivity_change
    ///
    /// Time spent blocked in PR_Close when there has been the connectivity change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_UDP_BLOCKING_TIME_CONNECTIVITY_CHANGE.
    pub static prclose_udp_blocking_time_connectivity_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_udp_blocking_time_connectivity_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(142), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_udp_blocking_time_link_change
    ///
    /// Time spent blocked in PR_Close when there has been a link change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_UDP_BLOCKING_TIME_LINK_CHANGE.
    pub static prclose_udp_blocking_time_link_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_udp_blocking_time_link_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(143), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_udp_blocking_time_normal
    ///
    /// Time spent blocked in PR_Close when we are not shutting down and there has been niether a network nor an offline state change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_UDP_BLOCKING_TIME_NORMAL.
    pub static prclose_udp_blocking_time_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_udp_blocking_time_normal".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(144), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_udp_blocking_time_offline
    ///
    /// Time spent blocked in PR_Close when the offline state has changed in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_UDP_BLOCKING_TIME_OFFLINE.
    pub static prclose_udp_blocking_time_offline: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_udp_blocking_time_offline".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(145), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prclose_udp_blocking_time_shutdown
    ///
    /// Time spent blocked in PR_Close during a shutdown (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCLOSE_UDP_BLOCKING_TIME_SHUTDOWN.
    pub static prclose_udp_blocking_time_shutdown: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prclose_udp_blocking_time_shutdown".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(146), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_blocking_time_connectivity_change
    ///
    /// Time spent blocked in PR_Connect when there has been the connectiviy change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_BLOCKING_TIME_CONNECTIVITY_CHANGE.
    pub static prconnect_blocking_time_connectivity_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_blocking_time_connectivity_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(147), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_blocking_time_link_change
    ///
    /// Time spent blocked in PR_Connect when there has been a link change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_BLOCKING_TIME_LINK_CHANGE.
    pub static prconnect_blocking_time_link_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_blocking_time_link_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(148), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_blocking_time_normal
    ///
    /// Time spent blocked in PR_Connect when we are not shutting down and there has been niether a network nor an offline state change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_BLOCKING_TIME_NORMAL.
    pub static prconnect_blocking_time_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_blocking_time_normal".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(149), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_blocking_time_offline
    ///
    /// Time spent blocked in PR_Connect when the offline state has changed in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_BLOCKING_TIME_OFFLINE.
    pub static prconnect_blocking_time_offline: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_blocking_time_offline".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(150), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_blocking_time_shutdown
    ///
    /// Time spent blocked in PR_Connect during a shutdown (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_BLOCKING_TIME_SHUTDOWN.
    pub static prconnect_blocking_time_shutdown: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_blocking_time_shutdown".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(151), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_fail_blocking_time_connectivity_change
    ///
    /// Time spent blocked in a failed PR_Connect when there has been the connectiviy change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_FAIL_BLOCKING_TIME_CONNECTIVITY_CHANGE.
    pub static prconnect_fail_blocking_time_connectivity_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_fail_blocking_time_connectivity_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(152), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_fail_blocking_time_link_change
    ///
    /// Time spent blocked in a failed PR_Connect when there has been a link change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_FAIL_BLOCKING_TIME_LINK_CHANGE.
    pub static prconnect_fail_blocking_time_link_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_fail_blocking_time_link_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(153), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_fail_blocking_time_normal
    ///
    /// Time spent blocked in a failed PR_Connect when we are not shutting down and there has been niether a network nor an offline state change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_FAIL_BLOCKING_TIME_NORMAL.
    pub static prconnect_fail_blocking_time_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_fail_blocking_time_normal".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(154), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_fail_blocking_time_offline
    ///
    /// Time spent blocked in a failed PR_Connect when the offline state has changed in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_FAIL_BLOCKING_TIME_OFFLINE.
    pub static prconnect_fail_blocking_time_offline: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_fail_blocking_time_offline".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(155), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnect_fail_blocking_time_shutdown
    ///
    /// Time spent blocked in a failed PR_Connect during a shutdown (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECT_FAIL_BLOCKING_TIME_SHUTDOWN.
    pub static prconnect_fail_blocking_time_shutdown: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnect_fail_blocking_time_shutdown".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(156), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnectcontinue_blocking_time_connectivity_change
    ///
    /// Time spent blocked in PR_ConnectContinue when there has been the connectivity change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECTCONTINUE_BLOCKING_TIME_CONNECTIVITY_CHANGE.
    pub static prconnectcontinue_blocking_time_connectivity_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnectcontinue_blocking_time_connectivity_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(157), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnectcontinue_blocking_time_link_change
    ///
    /// Time spent blocked in PR_ConnectContinue when there has been a link change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECTCONTINUE_BLOCKING_TIME_LINK_CHANGE.
    pub static prconnectcontinue_blocking_time_link_change: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnectcontinue_blocking_time_link_change".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(158), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnectcontinue_blocking_time_normal
    ///
    /// Time spent blocked in PR_ConnectContinue when we are not shutting down and there has been niether a network nor an offline state change in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECTCONTINUE_BLOCKING_TIME_NORMAL.
    pub static prconnectcontinue_blocking_time_normal: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnectcontinue_blocking_time_normal".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(159), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnectcontinue_blocking_time_offline
    ///
    /// Time spent blocked in PR_ConnectContinue when the offline state has changed in the last 60s (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECTCONTINUE_BLOCKING_TIME_OFFLINE.
    pub static prconnectcontinue_blocking_time_offline: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnectcontinue_blocking_time_offline".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(160), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.prconnectcontinue_blocking_time_shutdown
    ///
    /// Time spent blocked in PR_ConnectContinue during a shutdown (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PRCONNECTCONTINUE_BLOCKING_TIME_SHUTDOWN.
    pub static prconnectcontinue_blocking_time_shutdown: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prconnectcontinue_blocking_time_shutdown".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(161), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum ProxyInfoTypeLabel {
        EHttp = 0,
        EHttps = 1,
        ESocks4 = 2,
        ESocks4a = 3,
        ESocks5 = 4,
        ESocks5h = 5,
        EDirect = 6,
        EUnknown = 7,
        __Other__,
    }
    impl From<u16> for ProxyInfoTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHttp,
                1 => Self::EHttps,
                2 => Self::ESocks4,
                3 => Self::ESocks4a,
                4 => Self::ESocks5,
                5 => Self::ESocks5h,
                6 => Self::EDirect,
                7 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProxyInfoTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHttp => "http",
                Self::EHttps => "https",
                Self::ESocks4 => "socks4",
                Self::ESocks4a => "socks4a",
                Self::ESocks5 => "socks5",
                Self::ESocks5h => "socks5h",
                Self::EDirect => "direct",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.proxy_info_type
    ///
    /// The proxies configurations created in the browser session (SOCKSv4, SOCKSv5, HTTP, HTTPS)
    pub static proxy_info_type: Lazy<LabeledMetric<LabeledCounterMetric, ProxyInfoTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "proxy_info_type".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(162), meta, Some(vec![::std::borrow::Cow::from("direct"), ::std::borrow::Cow::from("http"), ::std::borrow::Cow::from("https"), ::std::borrow::Cow::from("socks4"), ::std::borrow::Cow::from("socks4a"), ::std::borrow::Cow::from("socks5"), ::std::borrow::Cow::from("socks5h"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_count
    ///
    /// Counts how often we find a cache folder that wasn't purged at shutdown by a background task process.
    pub static residual_cache_folder_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            163,
            "networking",
            "residual_cache_folder_count",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ResidualCacheFolderRemovalLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for ResidualCacheFolderRemovalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResidualCacheFolderRemovalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.residual_cache_folder_removal
    ///
    /// Counts how often succeed/fail in removing cache folder that wasn't purged at shutdown
    pub static residual_cache_folder_removal: Lazy<LabeledMetric<LabeledCounterMetric, ResidualCacheFolderRemovalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "residual_cache_folder_removal".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(164), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie
    ///
    /// This counts the number of times we set a cookie. Introduced as a denomenator for measuring CHIPS adoption.
    pub static set_cookie: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(165), meta, vec![CommonMetricData {name: "set_cookie_foreign".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_foreign_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "set_cookie_partitioned".into(), category: "networking".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign
    ///
    /// This counts the number of times we set a cookie from a foreign (not same-site) context. Introduced as a denomenator for measuring CHIPS adoption.
    pub static set_cookie_foreign: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_foreign".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(166), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_foreign_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned attribute in a foreign (not same-site) context. This tracks the adoption of CHIPS.
    pub static set_cookie_foreign_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_foreign_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(167), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_cookie_partitioned
    ///
    /// This counts the number of times we set a cookie that has the Partitioned attribute. This tracks the adoption of CHIPS.
    pub static set_cookie_partitioned: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_cookie_partitioned".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(168), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.set_invalid_first_party_partitioned_cookie
    ///
    /// This counts the number of times we set an invalid first-party partitioned cookie.
    pub static set_invalid_first_party_partitioned_cookie: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            169,
            "networking",
            "set_invalid_first_party_partitioned_cookie",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum SpeculativeConnectOutcomeLabel {
        ESuccessful = 0,
        EAbortedSocketLimit = 1,
        EAbortedSocketFail = 2,
        EAbortedHttpsNotEnabled = 3,
        __Other__,
    }
    impl From<u16> for SpeculativeConnectOutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccessful,
                1 => Self::EAbortedSocketLimit,
                2 => Self::EAbortedSocketFail,
                3 => Self::EAbortedHttpsNotEnabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SpeculativeConnectOutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccessful => "successful",
                Self::EAbortedSocketLimit => "aborted_socket_limit",
                Self::EAbortedSocketFail => "aborted_socket_fail",
                Self::EAbortedHttpsNotEnabled => "aborted_https_not_enabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.speculative_connect_outcome
    ///
    /// Counts the occurrence of each outcome of a speculative connection
    pub static speculative_connect_outcome: Lazy<LabeledMetric<LabeledCounterMetric, SpeculativeConnectOutcomeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "speculative_connect_outcome".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(170), meta, Some(vec![::std::borrow::Cow::from("aborted_https_not_enabled"), ::std::borrow::Cow::from("aborted_socket_fail"), ::std::borrow::Cow::from("aborted_socket_limit"), ::std::borrow::Cow::from("successful")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.sqlite_cookies_block_main_thread
    ///
    /// Time spent on blocking main thread by startup cookie database read (in milliseconds), only for blocking case
    pub static sqlite_cookies_block_main_thread: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sqlite_cookies_block_main_thread".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(171), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.sqlite_cookies_time_to_block_main_thread
    ///
    /// How long (in milliseconds) after we finished reading the cookie db until the first cookie request came in (0 implies we blocked the main thread)
    pub static sqlite_cookies_time_to_block_main_thread: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sqlite_cookies_time_to_block_main_thread".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(172), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time
    ///
    /// Time from submission to dispatch of transaction without HTTPS RR (ms)
    pub static transaction_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(173), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.transaction_wait_time_https_rr
    ///
    /// Time from submission to dispatch of transaction when HTTPS RR is used (ms)
    pub static transaction_wait_time_https_rr: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_https_rr".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(174), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TrrCompleteLoadLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrCompleteLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrCompleteLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_complete_load
    ///
    /// In TRR channel, overall load time.
    pub static trr_complete_load: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrCompleteLoadLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_complete_load".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(175), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrDnsEndLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrDnsEndLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrDnsEndLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_dns_end
    ///
    /// In TRR channel, time from the DNS request being issued to the response.
    pub static trr_dns_end: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrDnsEndLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_dns_end".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(176), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrDnsStartLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrDnsStartLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrDnsStartLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_dns_start
    ///
    /// In TRR channel, time from connection open to the DNS request being issued.
    pub static trr_dns_start: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrDnsStartLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_dns_start".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(177), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrFetchDurationLabel {
        EH1 = 0,
        EH1NetworkOnly = 1,
        EH2 = 2,
        EH2NetworkOnly = 3,
        EH3 = 4,
        EH3NetworkOnly = 5,
        __Other__,
    }
    impl From<u16> for TrrFetchDurationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH1,
                1 => Self::EH1NetworkOnly,
                2 => Self::EH2,
                3 => Self::EH2NetworkOnly,
                4 => Self::EH3,
                5 => Self::EH3NetworkOnly,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrFetchDurationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH1 => "h1",
                Self::EH1NetworkOnly => "h1_network_only",
                Self::EH2 => "h2",
                Self::EH2NetworkOnly => "h2_network_only",
                Self::EH3 => "h3",
                Self::EH3NetworkOnly => "h3_network_only",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_fetch_duration
    ///
    /// Time for a successful DoH request, from AsyncOpen to ReturnData
    pub static trr_fetch_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrFetchDurationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_fetch_duration".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(178), meta, Some(vec![::std::borrow::Cow::from("h1"), ::std::borrow::Cow::from("h1_network_only"), ::std::borrow::Cow::from("h2"), ::std::borrow::Cow::from("h2_network_only"), ::std::borrow::Cow::from("h3"), ::std::borrow::Cow::from("h3_network_only")]))
    });

    #[repr(u16)]
    pub enum TrrFirstSentToLastReceivedLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrFirstSentToLastReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrFirstSentToLastReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_first_sent_to_last_received
    ///
    /// In TRR channel, time from first byte of request sent to last byte of response received.
    pub static trr_first_sent_to_last_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrFirstSentToLastReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_first_sent_to_last_received".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(179), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrOpenToFirstReceivedLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrOpenToFirstReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrOpenToFirstReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_open_to_first_received
    ///
    /// In TRR channel, time from open to first byte of reply received.
    pub static trr_open_to_first_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrOpenToFirstReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_open_to_first_received".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(180), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrOpenToFirstSentLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrOpenToFirstSentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrOpenToFirstSentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_open_to_first_sent
    ///
    /// In TRR channel, time from open to first byte of request.
    pub static trr_open_to_first_sent: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrOpenToFirstSentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_open_to_first_sent".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(181), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrRequestCountLabel {
        ERegular = 0,
        EPrivate = 1,
        __Other__,
    }
    impl From<u16> for TrrRequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERegular,
                1 => Self::EPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERegular => "regular",
                Self::EPrivate => "private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_count
    ///
    /// The count of successful TRR requests keyed by regular/private browsing
    pub static trr_request_count: Lazy<LabeledMetric<LabeledCounterMetric, TrrRequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_request_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(182), meta, Some(vec![::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("regular")]))
    });

    #[repr(u16)]
    pub enum TrrRequestCountPerConnLabel {
        EH1 = 0,
        EH2 = 1,
        EH3 = 2,
        __Other__,
    }
    impl From<u16> for TrrRequestCountPerConnLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH1,
                1 => Self::EH2,
                2 => Self::EH3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestCountPerConnLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH1 => "h1",
                Self::EH2 => "h2",
                Self::EH3 => "h3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_count_per_conn
    ///
    /// Number of DOH requests per connection keyed by HTTP version
    pub static trr_request_count_per_conn: Lazy<LabeledMetric<LabeledCounterMetric, TrrRequestCountPerConnLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_request_count_per_conn".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(183), meta, Some(vec![::std::borrow::Cow::from("h1"), ::std::borrow::Cow::from("h2"), ::std::borrow::Cow::from("h3")]))
    });

    #[repr(u16)]
    pub enum TrrRequestSizeLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrRequestSizeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrRequestSizeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_request_size
    ///
    /// In TRR channel, the size of the HTTP request.
    pub static trr_request_size: Lazy<LabeledMetric<LabeledMemoryDistributionMetric, TrrRequestSizeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::MemoryDistribution {
                cmd: CommonMetricData {
                    name: "trr_request_size".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: MemoryUnit::Byte};
        LabeledMetric::new(BaseMetricId(184), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrResponseSizeLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrResponseSizeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrResponseSizeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_response_size
    ///
    /// In TRR channel, the size of the HTTP response.
    pub static trr_response_size: Lazy<LabeledMetric<LabeledMemoryDistributionMetric, TrrResponseSizeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::MemoryDistribution {
                cmd: CommonMetricData {
                    name: "trr_response_size".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: MemoryUnit::Byte};
        LabeledMetric::new(BaseMetricId(185), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrTcpConnectionLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrTcpConnectionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrTcpConnectionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_tcp_connection
    ///
    /// In TRR channel, time from the TCP SYN packet is received to the connection is established and ready for HTTP.
    pub static trr_tcp_connection: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrTcpConnectionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_tcp_connection".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(186), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrTlsHandshakeLabel {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrTlsHandshakeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrTlsHandshakeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_tls_handshake
    ///
    /// In TRR channel, time from after the TCP SYN packet is received to the secure connection is established and ready for HTTP.
    pub static trr_tls_handshake: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrTlsHandshakeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_tls_handshake".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(187), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.data_transferred_v3_kb
    ///
    /// How many KB of HTTP data transferred by type, there are some categories separated by keys based on 5 parameters:
    ///   1. normal browsing or private browsing
    ///   2. system principal or not
    ///   3. first party or third party
    ///   4. class of service (Leader/Background/Others)
    ///   5. tracking classification (Basic/Content/FingerprintingContent)
    /// 
    /// Available keys are:
    ///   "Y0_N1Sys",
    ///   "Y1_N1",
    ///   "Y2_N3Oth",
    ///   "Y3_N3BasicLead",
    ///   "Y4_N3BasicBg",
    ///   "Y5_N3BasicOth",
    ///   "Y6_N3ContentLead",
    ///   "Y7_N3ContentBg",
    ///   "Y8_N3ContentOth",
    ///   "Y9_N3FpLead",
    ///   "Y10_N3FpBg",
    ///   "Y11_N3FpOth",
    ///   "Y12_P1Sys",
    ///   "Y13_P1",
    ///   "Y14_P3Oth",
    ///   "Y15_P3BasicLead",
    ///   "Y16_P3BasicBg",
    ///   "Y17_P3BasicOth",
    ///   "Y18_P3ContentLead",
    ///   "Y19_P3ContentBg",
    ///   "Y20_P3ContentOth",
    ///   "Y21_P3FpLead",
    ///   "Y22_P3FpBg",
    ///   "Y23_P3FpOth"
    /// 
    /// This metric was generated to correspond to the Legacy Telemetry scalar networking.data_transferred_v3_kb.
    pub static data_transferred_v3_kb: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "data_transferred_v3_kb".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(188), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.http3_enabled
    ///
    /// True if HTTP3 is enabled at the start of a session. This metric was generated to correspond to the Legacy Telemetry scalar networking.http3_enabled.
    pub static http3_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_enabled".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(189), meta)
    });

    #[repr(u16)]
    pub enum HttpsRecordStateLabel {
        EInvalid = 0,
        ESucceeded = 1,
        EUnmatchedCname = 2,
        EAllExcluded = 3,
        ENoDefaultAlpn = 4,
        EOthers = 5,
        __Other__,
    }
    impl From<u16> for HttpsRecordStateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInvalid,
                1 => Self::ESucceeded,
                2 => Self::EUnmatchedCname,
                3 => Self::EAllExcluded,
                4 => Self::ENoDefaultAlpn,
                5 => Self::EOthers,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsRecordStateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInvalid => "invalid",
                Self::ESucceeded => "succeeded",
                Self::EUnmatchedCname => "unmatched_cname",
                Self::EAllExcluded => "all_excluded",
                Self::ENoDefaultAlpn => "no_default_alpn",
                Self::EOthers => "others",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from networking.https_record_state
    ///
    /// Gather the outcome of checking if a HTTPS record can be used: - "invalid" - "succeeded" - "unmatched_cname" - "all_excluded" - "no_default_alpn" - "others"
    pub static https_record_state: Lazy<LabeledMetric<LabeledCounterMetric, HttpsRecordStateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "https_record_state".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(190), meta, Some(vec![::std::borrow::Cow::from("all_excluded"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("no_default_alpn"), ::std::borrow::Cow::from("others"), ::std::borrow::Cow::from("succeeded"), ::std::borrow::Cow::from("unmatched_cname")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.https_rr_prefs_usage
    ///
    /// A bitfield representation for the usage of HTTPS RR prefs. bit 0: network.dns.upgrade_with_https_rr is enabled or not. bit 1: network.dns.use_https_rr_as_altsvc is enabled or not. bit 2: network.dns.echconfig.enabled is enabled or not. This metric was generated to correspond to the Legacy Telemetry scalar networking.https_rr_prefs_usage.
    pub static https_rr_prefs_usage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_rr_prefs_usage".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(191), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.trr_connection_cycle_count
    ///
    /// Number of times we cycled the TRR connection during a subsession. Keyed by TRR provider URL. This metric was generated to correspond to the Legacy Telemetry scalar networking.trr_connection_cycle_count.
    pub static trr_connection_cycle_count: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "trr_connection_cycle_count".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(192), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.loading_certs_task
    ///
    /// The time in milliseconds to load any external certificates. This occurs off of the main-thread, but can block main-thread operations. This metric was generated to correspond to the Legacy Telemetry scalar networking.loading_certs_task.
    pub static loading_certs_task: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "loading_certs_task".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(193), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.nss_initialization
    ///
    /// The time in milliseconds to initialize the NSS component in the parent process. This metric was generated to correspond to the Legacy Telemetry scalar networking.nss_initialization.
    pub static nss_initialization: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nss_initialization".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(194), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristic_ever_tripped
    ///
    /// True if this heuristic (key) was ever tripped during the session. This metric was generated to correspond to the Legacy Telemetry scalar networking.doh_heuristic_ever_tripped.
    pub static doh_heuristic_ever_tripped: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "doh_heuristic_ever_tripped".into(),
                    category: "networking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(195), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_attempts
    ///
    /// The number of times we ran DoH heuristics. This metric was generated to correspond to the Legacy Telemetry scalar networking.doh_heuristics_attempts.
    pub static doh_heuristics_attempts: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            196,
            "networking",
            "doh_heuristics_attempts",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_pass_count
    ///
    /// The number of times we passed DoH heuristics. This metric was generated to correspond to the Legacy Telemetry scalar networking.doh_heuristics_pass_count.
    pub static doh_heuristics_pass_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            197,
            "networking",
            "doh_heuristics_pass_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from networking.doh_heuristics_result
    ///
    /// The value of this scalar indicates the result of the last heuristic run. 0: "incomplete" 1: "pass" 2: "opt-out" 3: "manually-disabled" 4: "manually-enabled" 5: "enterprise-disabled" 6: "enterprise- present" 7: "enterprise-enabled" 8: "vpn" 9: "proxy" 10: "nrpt" 11: "parental" 12: "modifiedRoots" 13: "thirdPartyRoots" 14: "google" 15: "youtube" 16: "zscaler" 17: "canary" 18: "ignored" This metric was generated to correspond to the Legacy Telemetry scalar networking.doh_heuristics_result.
    pub static doh_heuristics_result: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doh_heuristics_result".into(),
                category: "networking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(198), meta)
    });

}
pub mod security_ui_protectionspopup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookieb_toggle_off
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#cookieb_toggle_off.
    pub static click_cookieb_toggle_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookieb_toggle_off".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(199), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookieb_toggle_on
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#cookieb_toggle_on.
    pub static click_cookieb_toggle_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookieb_toggle_on".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(200), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cookies
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#cookies.
    pub static click_cookies: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cookies".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(201), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_cryptominers
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#cryptominers.
    pub static click_cryptominers: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cryptominers".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(202), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_etp_toggle_off
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#etp_toggle_off.
    pub static click_etp_toggle_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_etp_toggle_off".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(203), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_etp_toggle_on
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#etp_toggle_on.
    pub static click_etp_toggle_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_etp_toggle_on".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(204), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_fingerprinters
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#fingerprinters.
    pub static click_fingerprinters: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fingerprinters".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(205), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_full_report
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#full_report.
    pub static click_full_report: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_full_report".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(206), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_milestone_message
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#milestone_message.
    pub static click_milestone_message: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_milestone_message".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(207), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickProtectionspopupCfrExtra {
        pub r#message: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickProtectionspopupCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["message", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#message.and_then(|val| map.insert("message".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_protectionspopup_cfr
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#protectionspopup_cfr.
    pub static click_protectionspopup_cfr: Lazy<EventMetric<ClickProtectionspopupCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_protectionspopup_cfr".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(208), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_settings
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#settings.
    pub static click_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(209), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSmartblockembedsToggleExtra {
        pub r#isBlock: Option<bool>,
        pub r#openingReason: Option<String>,
    }

    impl ExtraKeys for ClickSmartblockembedsToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["isBlock", "openingReason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#isBlock.and_then(|val| map.insert("isBlock".into(), val.to_string()));
          self.r#openingReason.and_then(|val| map.insert("openingReason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_smartblockembeds_toggle
    ///
    /// Triggered when SmartBlock embed toggles are clicked by the user
    pub static click_smartblockembeds_toggle: Lazy<EventMetric<ClickSmartblockembedsToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_smartblockembeds_toggle".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(210), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_social
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#social.
    pub static click_social: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_social".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(211), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSubviewSettingsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSubviewSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_subview_settings
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#subview_settings.
    pub static click_subview_settings: Lazy<EventMetric<ClickSubviewSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_subview_settings".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(212), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.click_trackers
    ///
    /// User interaction by click events in the protections panel. This event was generated to correspond to the Legacy Telemetry event security.ui.protectionspopup.click#trackers.
    pub static click_trackers: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_trackers".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(213), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseProtectionsPopupExtra {
        pub r#openingReason: Option<String>,
        pub r#smartblockToggleClicked: Option<bool>,
    }

    impl ExtraKeys for CloseProtectionsPopupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["openingReason", "smartblockToggleClicked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#openingReason.and_then(|val| map.insert("openingReason".into(), val.to_string()));
          self.r#smartblockToggleClicked.and_then(|val| map.insert("smartblockToggleClicked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.close_protections_popup
    ///
    /// Triggered when the protections panel is closed. Records how the panel was opened and if the SmartBlock section had any interactions
    pub static close_protections_popup: Lazy<EventMetric<CloseProtectionsPopupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_protections_popup".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(214), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenProtectionsPopupExtra {
        pub r#openingReason: Option<String>,
        pub r#smartblockEmbedTogglesShown: Option<bool>,
    }

    impl ExtraKeys for OpenProtectionsPopupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["openingReason", "smartblockEmbedTogglesShown"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#openingReason.and_then(|val| map.insert("openingReason".into(), val.to_string()));
          self.r#smartblockEmbedTogglesShown.and_then(|val| map.insert("smartblockEmbedTogglesShown".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.open_protections_popup
    ///
    /// How many times the protections panel was opened.
    pub static open_protections_popup: Lazy<EventMetric<OpenProtectionsPopupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_protections_popup".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(215), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenProtectionspopupCfrExtra {
        pub r#message: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for OpenProtectionspopupCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["message", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#message.and_then(|val| map.insert("message".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.open_protectionspopup_cfr
    ///
    /// How many times the protections panel was opened.
    pub static open_protectionspopup_cfr: Lazy<EventMetric<OpenProtectionspopupCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_protectionspopup_cfr".into(),
                category: "security.ui.protectionspopup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(216), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protectionspopup.smartblockembeds_shown
    ///
    /// How many times the SmartBlock placeholders are shown on the page
    pub static smartblockembeds_shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            217,
            "security.ui.protectionspopup",
            "smartblockembeds_shown",
            "metrics"
        )
    });

}
pub mod messaging_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.addon_version
    ///
    /// Used to hold the system addon's version, now is almost certainly an echo of the app's build id.
    pub static addon_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_version".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(218), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.browser_session_id
    ///
    /// The Legacy Telemetry browser "session id". Identifies a specific period from application start to shutdown. See [the "main" ping docs](https://firefox-source-docs.mozilla.org/toolkit/components/telemetry/data/main-ping.html) for details.
    pub static browser_session_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_session_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(219), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.bucket_id
    ///
    /// A name shared between multiple messages that may individually be too targetted. e.g. a message that gets shown on specific websites or a message asking about personal information.
    pub static bucket_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bucket_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(220), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to policy around specific types of
    /// ping being sent. Value may be the canary client id
    /// `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Present only in some circumstances (see
    /// [bug 1484035]https://bugzilla.mozilla.org/show_bug.cgi?id=1484035)).
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(221), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event
    ///
    /// The type of event. Any user defined string (e.g. “IMPRESSION”, “CLICK_BUTTON”, "INDEXEDDB_OPEN_FAILED", “SESSION_END”)
    pub static event: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(222), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context
    ///
    /// The stringified JSON of `event_context`.
    pub static event_context: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_context".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(223), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_context_parse_error
    ///
    /// How often we failed to parse event_context as JSON.
    pub static event_context_parse_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            224,
            "messaging_system",
            "event_context_parse_error",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_page
    ///
    /// The event_context's `page`. Almost always "about:welcome".
    pub static event_page: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_page".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(225), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_reason
    ///
    /// The event_context's `reason`. Likely something like
    /// "welcome-window-closed" or "app-shut-down",.
    pub static event_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_reason".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(226), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_family
    ///
    /// A string identifier of the message family derived from the message id
    /// (e.g. MR_WELCOME_DEFAULT).
    pub static event_screen_family: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_family".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(227), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_id
    ///
    /// A string identifier of the message screen id
    /// (e.g. AW_MOBILE_DOWNLOAD).
    pub static event_screen_id: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(228), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_index
    ///
    /// A number identifier of the screen index in a sequence of screens
    /// (e.g. 0 for first message).
    pub static event_screen_index: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_index".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(229), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_screen_initials
    ///
    /// A string identifier of the message screen initials
    /// (e.g. 'EMAG' for EASY_SETUP, MOBILE_DOWNLOADS, AMO, GRATITUDE).
    pub static event_screen_initials: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_screen_initials".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(230), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.event_source
    ///
    /// The event_context's `source`. Likely something like "primary_button".
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_source".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(231), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.glean_ping_for_ping_failures
    ///
    /// How often something went awry within
    /// `AboutWelcome.submitGleanPingForPing`, preventing ping submission.
    pub static glean_ping_for_ping_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            232,
            "messaging_system",
            "glean_ping_for_ping_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.impression_id
    ///
    /// The unique impression identifier for a specific client.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(233), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.invalid_nested_data
    ///
    /// We received a ping with non-scalar data on a field of this name.
    /// If this is existing pre-PingCentre-replacement data, you may need to
    /// augment the logic in
    /// `AboutWelcome.submitGleanPingForPing` like the other `handledKeys`.
    /// If this is for new, post-PingCentre-replacement data, you should
    /// probably prefer a flat structure.
    /// If you're unsure, please ask in
    /// [the #glean channel](https://chat.mozilla.org/#/room/#glean:mozilla.org).
    pub static invalid_nested_data: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "invalid_nested_data".into(),
                    category: "messaging_system".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(234), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.locale
    ///
    /// The locale as supplied to the messaging system by `Services.locale.appLocaleAsBCP47`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "locale".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(235), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.message_id
    ///
    /// A string identifier of the message in Activity Stream Router.
    pub static message_id: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "message_id".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(236), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.message_request_time
    ///
    /// Firefox: Time in ms spent selecting and matching messages to user profile.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MS_MESSAGE_REQUEST_TIME_MS.
    pub static message_request_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "message_request_time".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(237), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.ping_type
    ///
    /// Type of event the ping is capturing. e.g. "cfr", "onboarding"
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(238), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.source
    ///
    /// The source of the interaction described by the other metrics. e.g. "frecent_links", "newtab", "CFR"
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "messaging_system".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(239), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_key_count
    ///
    /// The sum of all unknown keys counted.
    /// Useful for testing.
    /// Can be removed after bug 1600008 is resolved.
    pub static unknown_key_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            240,
            "messaging_system",
            "unknown_key_count",
            "messaging-system"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.unknown_keys
    ///
    /// Ping keys supplied to the messaging system for which
    /// we did not have a corresponding metric mapped to how often they attempted
    /// to be recorded.
    /// You may have forgotten to define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml`.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown_keys".into(),
                    category: "messaging_system".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(241), meta, None)
    });

}
pub mod messaging_system_attribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.campaign
    ///
    /// Attribution's campaign, possibly derived from the utm parameter of the
    /// same name.
    pub static campaign: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "campaign".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(242), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.content
    ///
    /// Attribution's content, possibly derived from the utm parameter of the
    /// same name.
    pub static content: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(243), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dlsource
    ///
    /// Mozilla-specific download "source" name. Could be something like
    /// "mozillaci" to identify that the installer came from
    /// `{archive|ftp}.mozilla.org`.
    pub static dlsource: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dlsource".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(244), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.dltoken
    ///
    /// String representation of the dltoken identifying the particular
    /// installer used to install this Firefox.
    /// Likely a UUID, if present.
    pub static dltoken: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dltoken".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(245), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.experiment
    ///
    /// Attribution's experiment key.
    pub static experiment: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(246), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.medium
    ///
    /// Attribution's medium, possibly derived from the utm parameter of the same
    /// name.
    pub static medium: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "medium".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(247), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.msstoresignedin
    ///
    /// Either the string "true" or the string "false" to indicate whether the
    /// attributed install came from the Microsoft store and, if so, whether the
    /// user was signed in at the time.
    pub static msstoresignedin: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "msstoresignedin".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(248), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.source
    ///
    /// Attribution's source, possibly derived from the utm parameter of the same
    /// name.
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(249), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.ua
    ///
    /// Attribution's ua key.
    pub static ua: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ua".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(250), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.unknown_keys
    ///
    /// Attribution keys supplied to the messaging system for which
    /// we did not have a corresponding metric, and the count of how
    /// often that happened.
    /// Either add this key to a list of known attribution keys in
    /// `AboutWelcomeTelemetry` to suppress or define an appropriate metric in
    /// `browser/components/newtab/metrics.yaml` to collect.
    pub static unknown_keys: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown_keys".into(),
                    category: "messaging_system.attribution".into(),
                    send_in_pings: vec!["messaging-system".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(251), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from messaging_system.attribution.variation
    ///
    /// Attribution's variation key.
    pub static variation: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "variation".into(),
                category: "messaging_system.attribution".into(),
                send_in_pings: vec!["messaging-system".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(252), meta)
    });

}
pub mod glean_attribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ExtObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub experiment: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub variation: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ua: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub dltoken: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub msstoresignedin: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub dlsource: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from glean.attribution.ext
    ///
    /// Extended attribution information.
    /// Mapped to client_info.attribution.ext in datasets.
    /// * `experiment`: name/id of the enrolled funnel experiment
    /// * `variation`: name/id of the variation cohort used in the enrolled funnel experiment
    /// * `ua`: identifier derived from the user agent downloading the installer
    ///         e.g. chrome, Google Chrome 123
    /// * `dltoken`: Unique token created at Firefox download time.
    ///              e.g. c18f86a3-f228-4d98-91bb-f90135c0aa9c
    /// * `msstoresignedin`: only present if the installation was done through the Microsoft Store,
    ///                      and was able to retrieve the "campaign ID" it was first installed with.
    ///                      This value is "true" if the user was signed into the Microsoft Store
    ///                      when they first installed, and false otherwise.
    /// * `dlsource`: identifier that indicate where installations of Firefox originate
    pub static ext: Lazy<ObjectMetric<ExtObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ext".into(),
                category: "glean.attribution".into(),
                send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(253), meta)
    });

}
pub mod glean_distribution {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ExtObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub distributionVersion: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub partnerId: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub distributor: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub distributorChannel: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub partnerNames: ExtObjectItemPartnernames,
    }

            pub type ExtObjectItemPartnernames = Vec<ExtObjectItemPartnernamesItem>;

    pub type ExtObjectItemPartnernamesItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from glean.distribution.ext
    ///
    /// Extended distribution information.
    /// Mapped to client_info.distribution.ext in datasets.
    /// * `distributionVersion`: pref `distribution.version`, `null` on failure
    /// * `partnerId`: pref `mozilla.partner.id`, `null` on failure
    /// * `distributor`:  pref `app.distributor`, `null` on failure
    /// * `distributorChannel`: pref `app.distributor.channel`, `null` on failure
    /// * `partnerNames`: list from prefs `app.partner.<name>=<name>`
    pub static ext: Lazy<ObjectMetric<ExtObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ext".into(),
                category: "glean.distribution".into(),
                send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(254), meta)
    });

}
pub mod browser_backup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.browser_extension_data_size
    ///
    /// The total size of the current profiles storage.local legacy JSON backend in the browser-extension-data directory, rounded to the nearest 10 kilobytes.
    pub static browser_extension_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_extension_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(255), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.change_location
    ///
    /// Dispatched when the backup destination location is changed.
    pub static change_location: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_location".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(256), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.compressed_archive_size
    ///
    /// The total compressed size of a single-file profile data backup archive. To reduce fingerprintability, we round to the nearest 1 mebibyte.
    pub static compressed_archive_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compressed_archive_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(257), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.cookies_size
    ///
    /// The total file size of the cookies.sqlite db located in the current profile directory, in kilobytes.
    pub static cookies_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookies_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(258), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.created
    ///
    /// Dispatched when a backup is successfully created.
    pub static created: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "created".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(259), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.credentials_data_size
    ///
    /// The total size of logins, payment method, and form autofill related files in the current profile directory, in kilobytes.
    pub static credentials_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "credentials_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(260), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.enabled
    ///
    /// True if the BackupService is enabled by default.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(261), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#backup_step: Option<String>,
        pub r#error_code: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["backup_step", "error_code"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#backup_step.and_then(|val| map.insert("backup_step".into(), val.to_string()));
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.error
    ///
    /// Dispatched when a backup fails to be created. We encode the error code as well as the stage the backup failed in in the extra data.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(262), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extension_store_permissions_data_size
    ///
    /// The file size of the current profiles extension-store-permissions/data.safe.bin file, rounded to the nearest 10 kilobytes.
    pub static extension_store_permissions_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extension_store_permissions_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(263), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_json_size
    ///
    /// The total file size of the current profiles extensions metadata files, rounded to the nearest 10 kilobytes. Files included are:
    ///   - extensions.json
    ///   - extension-settings.json
    ///   - extension-preferences.json
    ///   - addonStartup.json.lz4
    pub static extensions_json_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_json_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(264), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_storage_size
    ///
    /// The total size of all extensions storage directories, rounded to the nearest 10 kilobytes.
    pub static extensions_storage_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_storage_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(265), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.extensions_xpi_directory_size
    ///
    /// The total size of the current profiles extensions directory, rounded to the nearest 10 kilobytes.
    pub static extensions_xpi_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_xpi_directory_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(266), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.favicons_size
    ///
    /// The total file size of the favicons.sqlite db located in the current profile directory, in kilobytes.
    pub static favicons_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "favicons_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(267), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.favicons_time
    ///
    /// Total time, in milliseconds, required to back up a profile's favicons database.
    pub static favicons_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "favicons_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(268), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.form_history_size
    ///
    /// The file size of the formhistory.sqlite db located in the current profile directory, in kilobytes.
    pub static form_history_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "form_history_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(269), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.location_on_device
    ///
    /// 1 = the default location, 2 = a non-default location
    pub static location_on_device: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "location_on_device".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(270), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.misc_data_size
    ///
    /// The total size of files for telemetry, site storage, media device origin mapping, chrome privileged IndexedDB databases, and Mozilla Accounts in the current profile directory, rounded to the nearest tenth kilobyte.
    pub static misc_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "misc_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(271), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.password_added
    ///
    /// Dispatched when the backup encryption is enabled.
    pub static password_added: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "password_added".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(272), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.password_changed
    ///
    /// Dispatched when the backup encryption password is changed.
    pub static password_changed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "password_changed".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(273), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.password_removed
    ///
    /// Dispatched when the backup encryption is removed.
    pub static password_removed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "password_removed".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(274), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.places_size
    ///
    /// The total file size of the places.sqlite db located in the current profile directory, in kilobytes.
    pub static places_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "places_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(275), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.places_time
    ///
    /// Total time, in milliseconds, required to back up a profile's places database.
    pub static places_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "places_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(276), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.preferences_size
    ///
    /// The total size of files relating to user preferences and permissions in the current profile directory, in kilobytes.
    pub static preferences_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preferences_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(277), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.prof_d_disk_space
    ///
    /// The total disk space available on the storage device that the profile directory is stored on. To reduce fingerprintability, we round to the nearest 10 megabytes and return the result in kilobytes.
    pub static prof_d_disk_space: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prof_d_disk_space".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(278), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.pswd_encrypted
    ///
    /// True if the BackupService is configured to encrypt backups.
    pub static pswd_encrypted: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pswd_encrypted".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(279), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.scheduler_enabled
    ///
    /// True if the BackupService is configured to automatically create backups in the background.
    pub static scheduler_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scheduler_enabled".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(280), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.security_data_size
    ///
    /// The total size of files needed for NSS initialization parameters and security certificate settings in the current profile directory, in kilobytes.
    pub static security_data_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "security_data_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(281), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_backups_directory_size
    ///
    /// The total size of the session store backups directory, in kilobytes.
    pub static session_store_backups_directory_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_store_backups_directory_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(282), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.session_store_size
    ///
    /// The size of uncompressed session store json, in kilobytes.
    pub static session_store_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_store_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(283), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.storage_sync_size
    ///
    /// The file size of the current profiles storage-sync-v2.sqlite db, rounded to the nearest 10 kilobytes.
    pub static storage_sync_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_sync_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(284), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.toggle_off
    ///
    /// Dispatched when scheduled backups are disabled.
    pub static toggle_off: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toggle_off".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(285), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.toggle_on
    ///
    /// Dispatched when scheduled backups are enabled.
    pub static toggle_on: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toggle_on".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(286), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.total_backup_size
    ///
    /// The total uncompressed size of all profile data included in a completed backup. To reduce fingerprintability, we round to the nearest 1 mebibyte.
    pub static total_backup_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_backup_size".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(287), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.backup.total_backup_time
    ///
    /// Total time elapsed, in milliseconds, between the start and end of the profile backup creation process
    pub static total_backup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_backup_time".into(),
                category: "browser.backup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(288), meta, TimeUnit::Millisecond)
    });

}
pub mod downloads {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from downloads.panel_shown
    ///
    /// The count of how many times the downloads panel was shown per session. This metric was generated to correspond to the Legacy Telemetry scalar downloads.panel_shown.
    pub static panel_shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            289,
            "downloads",
            "panel_shown",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddedFileExtensionExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddedFileExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from downloads.added_file_extension
    ///
    /// Sent when downloading a new file. This event was generated to correspond to the Legacy Telemetry event downloads.added#fileExtension.
    pub static added_file_extension: Lazy<EventMetric<AddedFileExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "added_file_extension".into(),
                category: "downloads".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(290), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from downloads.file_opened
    ///
    /// The count of how many times files were opened from the download panel. This metric was generated to correspond to the Legacy Telemetry scalar downloads.file_opened.
    pub static file_opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            291,
            "downloads",
            "file_opened",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from downloads.user_action_on_blocked_download
    ///
    /// Users action on blocked download, keyed by verdict type (0=Number of blocked downloads, 1=Confirm block, 2=Confirm unblock)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DOWNLOADS_USER_ACTION_ON_BLOCKED_DOWNLOAD.
    pub static user_action_on_blocked_download: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "user_action_on_blocked_download".into(),
                    category: "downloads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 3, bucket_count: 4, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(292), meta, None)
    });

}
pub mod glam_experiment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.panel_shown
    ///
    /// Duplicate of: `downloads.panel_shown`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static panel_shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            293,
            "glam_experiment",
            "panel_shown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.active_ticks
    ///
    /// Duplicate of:
    /// `browser.engagement.active_ticks`
    /// 
    /// Intended for the purpose of testing client side sampling of data. This
    /// metric is disabled by default and will be enabled only for the purpose
    /// of the experiment. See Bug 1947604 for more information.
    pub static active_ticks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            294,
            "glam_experiment",
            "active_ticks",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.largest_contentful_paint
    ///
    /// Duplicate of: `perf.largest_contentful_paint`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static largest_contentful_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "largest_contentful_paint".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(295), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.protect_time
    ///
    /// Duplicate of: `javascript_pageload.protect_time`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static protect_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "protect_time".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(296), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.time
    ///
    /// Duplicate of: `performance.clone.deserialize.time`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(297), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.async_sheet_load
    ///
    /// Duplicate of: `performance.pageload.async_sheet_load`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static async_sheet_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_sheet_load".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(298), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.http_content_html5parser_ondatafinished_to_onstop_delay
    ///
    /// Duplicate of: `networking.http_content_html5parser_ondatafinished_to_onstop_delay`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static http_content_html5parser_ondatafinished_to_onstop_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_content_html5parser_ondatafinished_to_onstop_delay".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(299), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.os_socket_limit_reached
    ///
    /// Duplicate of: `networking.os_socket_limit_reached`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static os_socket_limit_reached: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            300,
            "glam_experiment",
            "os_socket_limit_reached",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.sub_complete_load_net
    ///
    /// Duplicate of: `network.sub_complete_load_net`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static sub_complete_load_net: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load_net".into(),
                category: "glam_experiment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(301), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.used
    ///
    /// Duplicate of: `pdfjs.used`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            302,
            "glam_experiment",
            "used",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.cpu_time_bogus_values
    ///
    /// Duplicate of: `power.cpu_time_bogus_values`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            303,
            "glam_experiment",
            "cpu_time_bogus_values",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from glam_experiment.total_cpu_time_ms
    ///
    /// Duplicate of: `power.total_cpu_time_ms`
    /// Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_disabled_new(
            304,
            "glam_experiment",
            "total_cpu_time_ms",
            "metrics"
        )
    });

}
pub mod firefoxview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CumulativeSearchesLabel {
        ERecentbrowsing = 0,
        EOpentabs = 1,
        ERecentlyclosed = 2,
        EHistory = 3,
        ESyncedtabs = 4,
        __Other__,
    }
    impl From<u16> for CumulativeSearchesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERecentbrowsing,
                1 => Self::EOpentabs,
                2 => Self::ERecentlyclosed,
                3 => Self::EHistory,
                4 => Self::ESyncedtabs,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CumulativeSearchesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERecentbrowsing => "recentbrowsing",
                Self::EOpentabs => "opentabs",
                Self::ERecentlyclosed => "recentlyclosed",
                Self::EHistory => "history",
                Self::ESyncedtabs => "syncedtabs",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview.cumulative_searches
    ///
    /// Cumulative no. of searches performed before selecting a resulting tab.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FIREFOX_VIEW_CUMULATIVE_SEARCHES.
    pub static cumulative_searches: Lazy<LabeledMetric<LabeledCustomDistributionMetric, CumulativeSearchesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cumulative_searches".into(),
                    category: "firefoxview".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 100, bucket_count: 101, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(305), meta, Some(vec![::std::borrow::Cow::from("history"), ::std::borrow::Cow::from("opentabs"), ::std::borrow::Cow::from("recentbrowsing"), ::std::borrow::Cow::from("recentlyclosed"), ::std::borrow::Cow::from("syncedtabs")]))
    });

}
pub mod firefoxview_next {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BrowserContextMenuTabsExtra {
        pub r#menu_action: Option<String>,
        pub r#page: Option<String>,
    }

    impl ExtraKeys for BrowserContextMenuTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["menu_action", "page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#menu_action.and_then(|val| map.insert("menu_action".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.browser_context_menu_tabs
    ///
    /// Recorded when a browser context menu selection is made in Firefox View This event was generated to correspond to the Legacy Telemetry event firefoxview_next.browser_context_menu#tabs.
    pub static browser_context_menu_tabs: Lazy<EventMetric<BrowserContextMenuTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_context_menu_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(306), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardCollapsedCardContainerExtra {
        pub r#data_type: Option<String>,
    }

    impl ExtraKeys for CardCollapsedCardContainerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.card_collapsed_card_container
    ///
    /// Recorded when a card-container is collapsed on the 'Recent browsing' page This event was generated to correspond to the Legacy Telemetry event firefoxview_next.card_collapsed#card_container.
    pub static card_collapsed_card_container: Lazy<EventMetric<CardCollapsedCardContainerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_collapsed_card_container".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(307), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardExpandedCardContainerExtra {
        pub r#data_type: Option<String>,
    }

    impl ExtraKeys for CardExpandedCardContainerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.card_expanded_card_container
    ///
    /// Recorded when a card-container is expanded on the 'Recent browsing' page This event was generated to correspond to the Legacy Telemetry event firefoxview_next.card_expanded#card_container.
    pub static card_expanded_card_container: Lazy<EventMetric<CardExpandedCardContainerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_expanded_card_container".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(308), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangePageNavigationExtra {
        pub r#page: Option<String>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for ChangePageNavigationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.change_page_navigation
    ///
    /// Recorded when the page/view is changed in Firefox View This event was generated to correspond to the Legacy Telemetry event firefoxview_next.change_page#navigation.
    pub static change_page_navigation: Lazy<EventMetric<ChangePageNavigationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_page_navigation".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(309), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.close_open_tab_tabs
    ///
    /// Recorded when a tab is closed via the close button on an open tab row. This event was generated to correspond to the Legacy Telemetry event firefoxview_next.close_open_tab#tabs.
    pub static close_open_tab_tabs: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_open_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(310), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContextMenuTabsExtra {
        pub r#data_type: Option<String>,
        pub r#menu_action: Option<String>,
    }

    impl ExtraKeys for ContextMenuTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["data_type", "menu_action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#data_type.and_then(|val| map.insert("data_type".into(), val.to_string()));
          self.r#menu_action.and_then(|val| map.insert("menu_action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.context_menu_tabs
    ///
    /// Recorded when a context menu selection is made in Firefox View This event was generated to correspond to the Legacy Telemetry event firefoxview_next.context_menu#tabs.
    pub static context_menu_tabs: Lazy<EventMetric<ContextMenuTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_menu_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(311), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissClosedTabTabsExtra {
        pub r#delta: Option<String>,
        pub r#page: Option<String>,
        pub r#position: Option<u32>,
    }

    impl ExtraKeys for DismissClosedTabTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delta", "page", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delta.and_then(|val| map.insert("delta".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.dismiss_closed_tab_tabs
    ///
    /// Recorded when a recently closed tab is dismissed This event was generated to correspond to the Legacy Telemetry event firefoxview_next.dismiss_closed_tab#tabs.
    pub static dismiss_closed_tab_tabs: Lazy<EventMetric<DismissClosedTabTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss_closed_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(312), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnteredFirefoxviewExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for EnteredFirefoxviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.entered_firefoxview
    ///
    /// Recorded when the Firefox View tab is selected This event was generated to correspond to the Legacy Telemetry event firefoxview_next.entered#firefoxview.
    pub static entered_firefoxview: Lazy<EventMetric<EnteredFirefoxviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "entered_firefoxview".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(313), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.fxa_continue_sync
    ///
    /// Recorded when button to sign in or sign up is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.fxa_continue#sync.
    pub static fxa_continue_sync: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fxa_continue_sync".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(314), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FxaMobileSyncExtra {
        pub r#has_devices: Option<bool>,
    }

    impl ExtraKeys for FxaMobileSyncExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_devices"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_devices.and_then(|val| map.insert("has_devices".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.fxa_mobile_sync
    ///
    /// Recorded when the 'Try Firefox for mobile' button is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.fxa_mobile#sync.
    pub static fxa_mobile_sync: Lazy<EventMetric<FxaMobileSyncExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fxa_mobile_sync".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(315), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.history_visits
    ///
    /// Recorded when a history tab is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.history#visits.
    pub static history_visits: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_visits".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(316), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenTabTabsExtra {
        pub r#page: Option<String>,
        pub r#window: Option<String>,
    }

    impl ExtraKeys for OpenTabTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page", "window"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#window.and_then(|val| map.insert("window".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.open_tab_tabs
    ///
    /// Recorded when an open tab is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.open_tab#tabs.
    pub static open_tab_tabs: Lazy<EventMetric<OpenTabTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_tab_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(317), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RecentlyClosedTabsExtra {
        pub r#delta: Option<String>,
        pub r#page: Option<String>,
        pub r#position: Option<u32>,
    }

    impl ExtraKeys for RecentlyClosedTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delta", "page", "position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delta.and_then(|val| map.insert("delta".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.recently_closed_tabs
    ///
    /// Recorded when a recently closed tab is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.recently_closed#tabs.
    pub static recently_closed_tabs: Lazy<EventMetric<RecentlyClosedTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "recently_closed_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(318), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchInitiatedSearchExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for SearchInitiatedSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.search_initiated_search
    ///
    /// Recorded when search is initiated and from what page. This event was generated to correspond to the Legacy Telemetry event firefoxview_next.search_initiated#search.
    pub static search_initiated_search: Lazy<EventMetric<SearchInitiatedSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_initiated_search".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(319), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchShowAllShowallbuttonExtra {
        pub r#section: Option<String>,
    }

    impl ExtraKeys for SearchShowAllShowallbuttonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["section"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.search_show_all_showallbutton
    ///
    /// Recorded when the show all button is clicked to show more search results. This event was generated to correspond to the Legacy Telemetry event firefoxview_next.search_show_all#showallbutton.
    pub static search_show_all_showallbutton: Lazy<EventMetric<SearchShowAllShowallbuttonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_show_all_showallbutton".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(320), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.show_all_history_tabs
    ///
    /// Recorded when the 'Show all history' button is clicked on the History page in Firefox View This event was generated to correspond to the Legacy Telemetry event firefoxview_next.show_all_history#tabs.
    pub static show_all_history_tabs: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_all_history_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(321), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SortHistoryTabsExtra {
        pub r#search_start: Option<String>,
        pub r#sort_type: Option<String>,
    }

    impl ExtraKeys for SortHistoryTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["search_start", "sort_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#search_start.and_then(|val| map.insert("search_start".into(), val.to_string()));
          self.r#sort_type.and_then(|val| map.insert("sort_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.sort_history_tabs
    ///
    /// Recorded when the sort option is changed for History in Firefox View This event was generated to correspond to the Legacy Telemetry event firefoxview_next.sort_history#tabs.
    pub static sort_history_tabs: Lazy<EventMetric<SortHistoryTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sort_history_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(322), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsTabsExtra {
        pub r#page: Option<String>,
    }

    impl ExtraKeys for SyncedTabsTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.synced_tabs_tabs
    ///
    /// Recorded when a synced tab is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.synced_tabs#tabs.
    pub static synced_tabs_tabs: Lazy<EventMetric<SyncedTabsTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_tabs".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(323), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from firefoxview_next.tab_selected_toolbarbutton
    ///
    /// Recorded when the Firefox View tab is clicked This event was generated to correspond to the Legacy Telemetry event firefoxview_next.tab_selected#toolbarbutton.
    pub static tab_selected_toolbarbutton: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_selected_toolbarbutton".into(),
                category: "firefoxview_next".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(324), meta)
    });

}
pub mod genai_chatbot {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContextmenuPromptClickExtra {
        pub r#prompt: Option<String>,
        pub r#provider: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ContextmenuPromptClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt", "provider", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt.and_then(|val| map.insert("prompt".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.contextmenu_prompt_click
    ///
    /// Chatbot prompt was clicked from the context menu.
    pub static contextmenu_prompt_click: Lazy<EventMetric<ContextmenuPromptClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "contextmenu_prompt_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(325), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContextmenuRemoveExtra {
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for ContextmenuRemoveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.contextmenu_remove
    ///
    /// Chatbot provider was removed from the context menu.
    pub static contextmenu_remove: Lazy<EventMetric<ContextmenuRemoveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "contextmenu_remove".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(326), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.enabled
    ///
    /// Indicates if the chatbot feature is enabled.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(327), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExperimentCheckboxClickExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for ExperimentCheckboxClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.experiment_checkbox_click
    ///
    /// Chatbot experiment checkbox was clicked to enable/disable.
    pub static experiment_checkbox_click: Lazy<EventMetric<ExperimentCheckboxClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment_checkbox_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(328), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct KeyboardShortcutExtra {
        pub r#enabled: Option<bool>,
        pub r#sidebar: Option<String>,
    }

    impl ExtraKeys for KeyboardShortcutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled", "sidebar"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          self.r#sidebar.and_then(|val| map.insert("sidebar".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.keyboard_shortcut
    ///
    /// Chatbot sidebar toggled with keyboard shortcut.
    pub static keyboard_shortcut: Lazy<EventMetric<KeyboardShortcutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyboard_shortcut".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(329), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingCloseExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_close
    ///
    /// Chatbot onboarding closed from provider choice.
    pub static onboarding_close: Lazy<EventMetric<OnboardingCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_close".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(330), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingContinueExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingContinueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_continue
    ///
    /// Chatbot onboarding continued from provider choice.
    pub static onboarding_continue: Lazy<EventMetric<OnboardingContinueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_continue".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(331), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingFinishExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingFinishExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_finish
    ///
    /// Chatbot onboarding finished with start chatting button.
    pub static onboarding_finish: Lazy<EventMetric<OnboardingFinishExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_finish".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(332), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingLearnMoreExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingLearnMoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_learn_more
    ///
    /// Chatbot onboarding opened feature learn more link.
    pub static onboarding_learn_more: Lazy<EventMetric<OnboardingLearnMoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_learn_more".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(333), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderChoiceDisplayedExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderChoiceDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_choice_displayed
    ///
    /// Chatbot onboarding impression for provider choice screen.
    pub static onboarding_provider_choice_displayed: Lazy<EventMetric<OnboardingProviderChoiceDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_choice_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(334), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderLearnExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderLearnExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_learn
    ///
    /// Chatbot onboarding opened provider learn more link.
    pub static onboarding_provider_learn: Lazy<EventMetric<OnboardingProviderLearnExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_learn".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(335), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderSelectionExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingProviderSelectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_selection
    ///
    /// Chatbot onboarding selected a provider.
    pub static onboarding_provider_selection: Lazy<EventMetric<OnboardingProviderSelectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_selection".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(336), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingProviderTermsExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
        pub r#text: Option<String>,
    }

    impl ExtraKeys for OnboardingProviderTermsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step", "text"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#text.and_then(|val| map.insert("text".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_provider_terms
    ///
    /// Chatbot onboarding opened provider terms link.
    pub static onboarding_provider_terms: Lazy<EventMetric<OnboardingProviderTermsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_provider_terms".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(337), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnboardingTextHighlightDisplayedExtra {
        pub r#provider: Option<String>,
        pub r#step: Option<u32>,
    }

    impl ExtraKeys for OnboardingTextHighlightDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.onboarding_text_highlight_displayed
    ///
    /// Chatbot onboarding impression for text highlight screen.
    pub static onboarding_text_highlight_displayed: Lazy<EventMetric<OnboardingTextHighlightDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "onboarding_text_highlight_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(338), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.provider
    ///
    /// Indicates id of activated chatbot provider or "custom" or "none"
    pub static provider: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(339), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProviderChangeExtra {
        pub r#current: Option<String>,
        pub r#previous: Option<String>,
        pub r#surface: Option<String>,
    }

    impl ExtraKeys for ProviderChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["current", "previous", "surface"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#current.and_then(|val| map.insert("current".into(), val.to_string()));
          self.r#previous.and_then(|val| map.insert("previous".into(), val.to_string()));
          self.r#surface.and_then(|val| map.insert("surface".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.provider_change
    ///
    /// Chatbot provider UI changed providers.
    pub static provider_change: Lazy<EventMetric<ProviderChangeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_change".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(340), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts
    ///
    /// Indicates if the chatbot feature would show shortcuts on selection.
    pub static shortcuts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(341), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsCheckboxClickExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for ShortcutsCheckboxClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_checkbox_click
    ///
    /// Chatbot shortcuts checkbox was clicked to enable/disable.
    pub static shortcuts_checkbox_click: Lazy<EventMetric<ShortcutsCheckboxClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_checkbox_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(342), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_custom
    ///
    /// Indicates if the chatbot feature would show shortcuts custom input.
    pub static shortcuts_custom: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_custom".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(343), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsDisplayedExtra {
        pub r#delay: Option<u32>,
        pub r#inputType: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delay", "inputType", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delay.and_then(|val| map.insert("delay".into(), val.to_string()));
          self.r#inputType.and_then(|val| map.insert("inputType".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_displayed
    ///
    /// Shortcuts displayed on text selection.
    pub static shortcuts_displayed: Lazy<EventMetric<ShortcutsDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_displayed".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(344), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsExpandedExtra {
        pub r#provider: Option<String>,
        pub r#selection: Option<u32>,
        pub r#warning: Option<bool>,
    }

    impl ExtraKeys for ShortcutsExpandedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider", "selection", "warning"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          self.r#warning.and_then(|val| map.insert("warning".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_expanded
    ///
    /// Shortcuts expanded to show prompts.
    pub static shortcuts_expanded: Lazy<EventMetric<ShortcutsExpandedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_expanded".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(345), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsHideClickExtra {
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsHideClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_hide_click
    ///
    /// Chatbot hide shortcuts was clicked from the shortcuts.
    pub static shortcuts_hide_click: Lazy<EventMetric<ShortcutsHideClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_hide_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(346), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShortcutsPromptClickExtra {
        pub r#prompt: Option<String>,
        pub r#provider: Option<String>,
        pub r#selection: Option<u32>,
    }

    impl ExtraKeys for ShortcutsPromptClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt", "provider", "selection"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt.and_then(|val| map.insert("prompt".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#selection.and_then(|val| map.insert("selection".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.shortcuts_prompt_click
    ///
    /// Chatbot prompt was clicked from the shortcuts.
    pub static shortcuts_prompt_click: Lazy<EventMetric<ShortcutsPromptClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shortcuts_prompt_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(347), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar
    ///
    /// Indicates if the chatbot feature would open in sidebar.
    pub static sidebar: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(348), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarCloseClickExtra {
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarCloseClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_close_click
    ///
    /// Chatbot close X clicked.
    pub static sidebar_close_click: Lazy<EventMetric<SidebarCloseClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_close_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(349), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarMoreMenuClickExtra {
        pub r#action: Option<String>,
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarMoreMenuClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_more_menu_click
    ///
    /// Chatbot more menu clicked an action.
    pub static sidebar_more_menu_click: Lazy<EventMetric<SidebarMoreMenuClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_more_menu_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(350), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarMoreMenuDisplayExtra {
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarMoreMenuDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_more_menu_display
    ///
    /// Chatbot more menu opened.
    pub static sidebar_more_menu_display: Lazy<EventMetric<SidebarMoreMenuDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_more_menu_display".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(351), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarProviderMenuClickExtra {
        pub r#action: Option<String>,
        pub r#provider: Option<String>,
    }

    impl ExtraKeys for SidebarProviderMenuClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "provider"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_provider_menu_click
    ///
    /// Chatbot provider menu clicked an action.
    pub static sidebar_provider_menu_click: Lazy<EventMetric<SidebarProviderMenuClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_provider_menu_click".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(352), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#provider: Option<String>,
        pub r#reason: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "provider", "reason", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.chatbot.sidebar_toggle
    ///
    /// Chatbot sidebar panel was toggled open/close.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "genai.chatbot".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(353), meta)
    });

}
pub mod genai_linkpreview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardCloseExtra {
        pub r#duration: Option<u32>,
    }

    impl ExtraKeys for CardCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["duration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#duration.and_then(|val| map.insert("duration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.card_close
    ///
    /// Recorded when the user closes the card
    pub static card_close: Lazy<EventMetric<CardCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_close".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(354), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CardLinkExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for CardLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.card_link
    ///
    /// Recorded when the user clicks on a link from the card
    pub static card_link: Lazy<EventMetric<CardLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "card_link".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(355), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.enabled
    ///
    /// Records if the user has link previews enabled
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(356), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FetchExtra {
        pub r#description: Option<bool>,
        pub r#image: Option<bool>,
        pub r#length: Option<u32>,
        pub r#outcome: Option<String>,
        pub r#sitename: Option<bool>,
        pub r#skipped: Option<bool>,
        pub r#time: Option<u32>,
        pub r#title: Option<bool>,
    }

    impl ExtraKeys for FetchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["description", "image", "length", "outcome", "sitename", "skipped", "time", "title"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#description.and_then(|val| map.insert("description".into(), val.to_string()));
          self.r#image.and_then(|val| map.insert("image".into(), val.to_string()));
          self.r#length.and_then(|val| map.insert("length".into(), val.to_string()));
          self.r#outcome.and_then(|val| map.insert("outcome".into(), val.to_string()));
          self.r#sitename.and_then(|val| map.insert("sitename".into(), val.to_string()));
          self.r#skipped.and_then(|val| map.insert("skipped".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          self.r#title.and_then(|val| map.insert("title".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.fetch
    ///
    /// Recorded when the browser fetches the page to be previewed
    pub static fetch: Lazy<EventMetric<FetchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fetch".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(357), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GenerateExtra {
        pub r#delay: Option<u32>,
        pub r#download: Option<u32>,
        pub r#latency: Option<u32>,
        pub r#outcome: Option<String>,
        pub r#sentences: Option<u32>,
        pub r#time: Option<u32>,
    }

    impl ExtraKeys for GenerateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["delay", "download", "latency", "outcome", "sentences", "time"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#delay.and_then(|val| map.insert("delay".into(), val.to_string()));
          self.r#download.and_then(|val| map.insert("download".into(), val.to_string()));
          self.r#latency.and_then(|val| map.insert("latency".into(), val.to_string()));
          self.r#outcome.and_then(|val| map.insert("outcome".into(), val.to_string()));
          self.r#sentences.and_then(|val| map.insert("sentences".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.generate
    ///
    /// Recorded when the model finishes generating the preview
    pub static generate: Lazy<EventMetric<GenerateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "generate".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(358), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LabsCheckboxExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for LabsCheckboxExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.labs_checkbox
    ///
    /// Recorded when the user clicks on the Labs checkbox
    pub static labs_checkbox: Lazy<EventMetric<LabsCheckboxExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "labs_checkbox".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(359), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StartExtra {
        pub r#cached: Option<bool>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for StartExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cached", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cached.and_then(|val| map.insert("cached".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from genai.linkpreview.start
    ///
    /// Recorded when the user initiates a link preview
    pub static start: Lazy<EventMetric<StartExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "start".into(),
                category: "genai.linkpreview".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(360), meta)
    });

}
pub mod background_update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons_to_not_update
    ///
    /// Records which error was causing the background updater to fail. This list supercedes the `background-update.reason` in `mozapps/update/metrics.yaml`
    pub static reasons_to_not_update: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reasons_to_not_update".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(361), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.time_last_update_scheduled
    ///
    /// Last time the background update was triggered.
    pub static time_last_update_scheduled: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_last_update_scheduled".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(362), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_attempted
    ///
    /// True if the background update task successfully attempted an automatic restart.
    pub static automatic_restart_attempted: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "automatic_restart_attempted".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(363), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.automatic_restart_success
    ///
    /// True if the background update task successfully restarted after an automatic restart.
    pub static automatic_restart_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "automatic_restart_success".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(364), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.client_id
    ///
    /// The legacy Telemetry client ID of this installation's default profile.
    /// The default profile is as determined by the Profile Service, namely `nsIToolkitProfileService.defaultProfile`.  The majority of users have only one Firefox installation and only one profile, so the default profile is their regular browsing profile.
    /// It is possible for a Firefox installation to not have a default profile, but in such cases the background update task will abort before sending any telemetry; therefore, the legacy Telemetry client ID should always be present.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into(), "baseline".into(), "events".into(), "metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(365), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_exception
    ///
    /// True if the exit code/status of the background update task is 3, which means an exception was thrown.
    pub static exit_code_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_code_exception".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(366), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.exit_code_success
    ///
    /// True if the exit code/status of the background update task is 0, which means success.
    pub static exit_code_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_code_success".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(367), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.final_state
    ///
    /// String description of the final state the update state machine reached.
    pub static final_state: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "final_state".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(368), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.reasons
    ///
    /// List of reasons that the background update task did not run.
    pub static reasons: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reasons".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(369), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.states
    ///
    /// Ordered list of string descriptions of the states that the update state machine reached.
    pub static states: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "states".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(370), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_current_date
    ///
    /// The `environment.currentDate` of the default profile's serialized targeting snapshot.
    pub static targeting_env_current_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_current_date".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(371), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_firefox_version
    ///
    /// The `environment.firefoxVersion` of the default profile's serialized targeting snapshot.  At the time of writing, this version is an integer representing the Firefox major version, e.g., `109`.
    pub static targeting_env_firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_firefox_version".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(372), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_env_profile_age
    ///
    /// The `environment.profileAgeCreated` of the default profile's serialized targeting snapshot.
    pub static targeting_env_profile_age: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_env_profile_age".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(373), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exception
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, but an exception was thrown reading it.
    pub static targeting_exception: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_exception".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(374), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_exists
    ///
    /// True if the default profile had a targeting snapshot serialized to disk, and there was no exception thrown reading it.
    pub static targeting_exists: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_exists".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(375), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_update.targeting_version
    ///
    /// If the default profile had a targeting snapshot serialized to disk, the `version` of the snapshot.
    /// This version number does not have a physical unit: it's only useful to compare between versions.
    pub static targeting_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_version".into(),
                category: "background_update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(376), meta)
    });

}
pub mod browser {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AttributionErrorsLabel {
        EReadError = 0,
        EDecodeError = 1,
        EWriteError = 2,
        EQuarantineError = 3,
        EEmptyError = 4,
        ENullError = 5,
        __Other__,
    }
    impl From<u16> for AttributionErrorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReadError,
                1 => Self::EDecodeError,
                2 => Self::EWriteError,
                3 => Self::EQuarantineError,
                4 => Self::EEmptyError,
                5 => Self::ENullError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AttributionErrorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReadError => "read_error",
                Self::EDecodeError => "decode_error",
                Self::EWriteError => "write_error",
                Self::EQuarantineError => "quarantine_error",
                Self::EEmptyError => "empty_error",
                Self::ENullError => "null_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.attribution_errors
    ///
    /// Count for the number of errors encountered trying to determine attribution data: on Windows, from the installers (stub and full); on macOS, from an extended attributed on the .app bundle.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram BROWSER_ATTRIBUTION_ERRORS.
    pub static attribution_errors: Lazy<LabeledMetric<LabeledCounterMetric, AttributionErrorsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "attribution_errors".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(377), meta, Some(vec![::std::borrow::Cow::from("decode_error"), ::std::borrow::Cow::from("empty_error"), ::std::borrow::Cow::from("null_error"), ::std::borrow::Cow::from("quarantine_error"), ::std::borrow::Cow::from("read_error"), ::std::borrow::Cow::from("write_error")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.default_at_launch
    ///
    /// Whether the shell service identified this app as the default browser.
    /// Checked once near startup.
    /// On Windows, this is operationalized as whether Firefox is the default
    /// HTTP protocol handler and the default HTML file handler.
    pub static default_at_launch: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_at_launch".into(),
                category: "browser".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(378), meta)
    });

    #[repr(u16)]
    pub enum IsUserDefaultLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for IsUserDefaultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IsUserDefaultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.is_user_default
    ///
    /// Whether Firefox is the system default browser on startup. A true value is also recorded here, and a false value is recorded to set_default_error, if a user clicked 'Use Firefox as my default browser' on an in-product prompt. (Note that on Windows 8+ the latter action opens the right settings dialog but does not actually change the default browser without further user action.) On Windows, 'system default browser' is operationalized as whether Firefox is the default HTTP protocol handler.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BROWSER_IS_USER_DEFAULT.
    pub static is_user_default: Lazy<LabeledMetric<LabeledCounterMetric, IsUserDefaultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_user_default".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(379), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum IsUserDefaultErrorLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for IsUserDefaultErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IsUserDefaultErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.is_user_default_error
    ///
    /// True if the browser was unable to determine if the browser was set as default.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BROWSER_IS_USER_DEFAULT_ERROR.
    pub static is_user_default_error: Lazy<LabeledMetric<LabeledCounterMetric, IsUserDefaultErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_user_default_error".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(380), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum SetDefaultAlwaysCheckLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SetDefaultAlwaysCheckLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SetDefaultAlwaysCheckLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_always_check
    ///
    /// True if the profile has `browser.shell.checkDefaultBrowser` set to true.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BROWSER_SET_DEFAULT_ALWAYS_CHECK.
    pub static set_default_always_check: Lazy<LabeledMetric<LabeledCounterMetric, SetDefaultAlwaysCheckLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "set_default_always_check".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(381), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_dialog_prompt_rawcount
    ///
    /// The number of times that a profile has seen the 'Set Default Browser' dialog.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram BROWSER_SET_DEFAULT_DIALOG_PROMPT_RAWCOUNT.
    pub static set_default_dialog_prompt_rawcount: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_default_dialog_prompt_rawcount".into(),
                category: "browser".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(382), meta, 1, 250, 15, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum SetDefaultErrorLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SetDefaultErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SetDefaultErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_error
    ///
    /// True if the browser was unable to set Firefox as the default browser
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BROWSER_SET_DEFAULT_ERROR.
    pub static set_default_error: Lazy<LabeledMetric<LabeledCounterMetric, SetDefaultErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "set_default_error".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(383), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum SetDefaultPdfHandlerUserChoiceResultLabel {
        ESuccess = 0,
        EErrprogid = 1,
        EErrhash = 2,
        EErrlaunchexe = 3,
        EErrexetimeout = 4,
        EErrexeprogid = 5,
        EErrexehash = 6,
        EErrexerejected = 7,
        EErrexeother = 8,
        EErrother = 9,
        EErrbuild = 10,
        __Other__,
    }
    impl From<u16> for SetDefaultPdfHandlerUserChoiceResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EErrprogid,
                2 => Self::EErrhash,
                3 => Self::EErrlaunchexe,
                4 => Self::EErrexetimeout,
                5 => Self::EErrexeprogid,
                6 => Self::EErrexehash,
                7 => Self::EErrexerejected,
                8 => Self::EErrexeother,
                9 => Self::EErrother,
                10 => Self::EErrbuild,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SetDefaultPdfHandlerUserChoiceResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "Success",
                Self::EErrprogid => "ErrProgID",
                Self::EErrhash => "ErrHash",
                Self::EErrlaunchexe => "ErrLaunchExe",
                Self::EErrexetimeout => "ErrExeTimeout",
                Self::EErrexeprogid => "ErrExeProgID",
                Self::EErrexehash => "ErrExeHash",
                Self::EErrexerejected => "ErrExeRejected",
                Self::EErrexeother => "ErrExeOther",
                Self::EErrother => "ErrOther",
                Self::EErrbuild => "ErrBuild",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_pdf_handler_user_choice_result
    ///
    /// Result of each attempt to set the default browser with SetDefaultExtensionHandlersUserChoice() for pdf extension
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram BROWSER_SET_DEFAULT_PDF_HANDLER_USER_CHOICE_RESULT.
    pub static set_default_pdf_handler_user_choice_result: Lazy<LabeledMetric<LabeledCounterMetric, SetDefaultPdfHandlerUserChoiceResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "set_default_pdf_handler_user_choice_result".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(384), meta, Some(vec![::std::borrow::Cow::from("ErrBuild"), ::std::borrow::Cow::from("ErrExeHash"), ::std::borrow::Cow::from("ErrExeOther"), ::std::borrow::Cow::from("ErrExeProgID"), ::std::borrow::Cow::from("ErrExeRejected"), ::std::borrow::Cow::from("ErrExeTimeout"), ::std::borrow::Cow::from("ErrHash"), ::std::borrow::Cow::from("ErrLaunchExe"), ::std::borrow::Cow::from("ErrOther"), ::std::borrow::Cow::from("ErrProgID"), ::std::borrow::Cow::from("Success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_result
    ///
    /// Result of the Set Default Browser dialog. After Firefox 89 the these values are: (0=Use Firefox + 'Don't ask again' checked, 1=Use Firefox + 'Don't ask again' unchecked, 2=Not Now + 'Don't ask again' checked, 3=Not Now + 'Don't ask again' unchecked). Before Firefox 89 these values were: (0=Use Firefox + 'Always perform check' unchecked, 1=Use Firefox + 'Always perform check' checked, 2=Not Now + 'Always perform check' unchecked, 3=Not Now + 'Always perform check' checked).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram BROWSER_SET_DEFAULT_RESULT.
    pub static set_default_result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_default_result".into(),
                category: "browser".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(385), meta, 0, 4, 5, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum SetDefaultUserChoiceResultLabel {
        ESuccess = 0,
        EErrprogid = 1,
        EErrhash = 2,
        EErrlaunchexe = 3,
        EErrexetimeout = 4,
        EErrexeprogid = 5,
        EErrexehash = 6,
        EErrexerejected = 7,
        EErrexeother = 8,
        EErrother = 9,
        EErrbuild = 10,
        __Other__,
    }
    impl From<u16> for SetDefaultUserChoiceResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EErrprogid,
                2 => Self::EErrhash,
                3 => Self::EErrlaunchexe,
                4 => Self::EErrexetimeout,
                5 => Self::EErrexeprogid,
                6 => Self::EErrexehash,
                7 => Self::EErrexerejected,
                8 => Self::EErrexeother,
                9 => Self::EErrother,
                10 => Self::EErrbuild,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SetDefaultUserChoiceResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "Success",
                Self::EErrprogid => "ErrProgID",
                Self::EErrhash => "ErrHash",
                Self::EErrlaunchexe => "ErrLaunchExe",
                Self::EErrexetimeout => "ErrExeTimeout",
                Self::EErrexeprogid => "ErrExeProgID",
                Self::EErrexehash => "ErrExeHash",
                Self::EErrexerejected => "ErrExeRejected",
                Self::EErrexeother => "ErrExeOther",
                Self::EErrother => "ErrOther",
                Self::EErrbuild => "ErrBuild",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.set_default_user_choice_result
    ///
    /// Result of each attempt to set the default browser with SetDefaultBrowserUserChoice()
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram BROWSER_SET_DEFAULT_USER_CHOICE_RESULT.
    pub static set_default_user_choice_result: Lazy<LabeledMetric<LabeledCounterMetric, SetDefaultUserChoiceResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "set_default_user_choice_result".into(),
                    category: "browser".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(386), meta, Some(vec![::std::borrow::Cow::from("ErrBuild"), ::std::borrow::Cow::from("ErrExeHash"), ::std::borrow::Cow::from("ErrExeOther"), ::std::borrow::Cow::from("ErrExeProgID"), ::std::borrow::Cow::from("ErrExeRejected"), ::std::borrow::Cow::from("ErrExeTimeout"), ::std::borrow::Cow::from("ErrHash"), ::std::borrow::Cow::from("ErrLaunchExe"), ::std::borrow::Cow::from("ErrOther"), ::std::borrow::Cow::from("ErrProgID"), ::std::borrow::Cow::from("Success")]))
    });

}
pub mod browser_launched_to_handle {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SystemNotificationExtra {
        pub r#action: Option<String>,
        pub r#name: Option<String>,
    }

    impl ExtraKeys for SystemNotificationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.launched_to_handle.system_notification
    ///
    /// Recorded when Firefox launches to complete a native notification popped by a system (chrome privileged) alert.  Windows-only at the time of writing.
    pub static system_notification: Lazy<EventMetric<SystemNotificationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_notification".into(),
                category: "browser.launched_to_handle".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(387), meta)
    });

}
pub mod browser_startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.startup.abouthome_cache_result
    ///
    /// How the about:home startup cache functioned on startup.
    /// 0: Result value was never set (error case) 1: Cache did not exist 2: Cache page stream was corrupt / inaccessible 3: Cache script stream was corrupt / inaccessible 4: Cache was invalidated by a version bump 5: Cache was valid, but read too late to be useful. 6: Cache was valid and used. 7: Cache is disabled. 8: User did not load about:home on its own by default. 9: Cache is disabled because about:newtab preloading is disabled.
    /// This metric was generated to correspond to the Legacy Telemetry scalar browser.startup.abouthome_cache_result.
    pub static abouthome_cache_result: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abouthome_cache_result".into(),
                category: "browser.startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(388), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.startup.abouthome_cache_shutdownwrite
    ///
    /// True if the about:home startup cache was written via the AsyncShutdown blocker. This metric was generated to correspond to the Legacy Telemetry scalar browser.startup.abouthome_cache_shutdownwrite.
    pub static abouthome_cache_shutdownwrite: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abouthome_cache_shutdownwrite".into(),
                category: "browser.startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(389), meta)
    });

}
pub mod datasanitization {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_cache
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.cache pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_cache.
    pub static privacy_clear_on_shutdown_cache: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_cache".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(390), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_cookies
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.cookies pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_cookies.
    pub static privacy_clear_on_shutdown_cookies: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_cookies".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(391), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_downloads
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.downloads pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_downloads.
    pub static privacy_clear_on_shutdown_downloads: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_downloads".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(392), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_formdata
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.formdata pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_formdata.
    pub static privacy_clear_on_shutdown_formdata: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_formdata".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(393), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_history
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.history pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_history.
    pub static privacy_clear_on_shutdown_history: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_history".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(394), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_offline_apps
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.offlineApps pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_offlineApps.
    pub static privacy_clear_on_shutdown_offline_apps: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_offline_apps".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(395), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_open_windows
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.openWindows pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_openWindows.
    pub static privacy_clear_on_shutdown_open_windows: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_open_windows".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(396), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_sessions
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.sessions pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_sessions.
    pub static privacy_clear_on_shutdown_sessions: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_sessions".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(397), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_clear_on_shutdown_site_settings
    ///
    /// A boolean reporting the value of the privacy.clearOnShutdown.siteSettings pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_clearOnShutdown_siteSettings.
    pub static privacy_clear_on_shutdown_site_settings: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_clear_on_shutdown_site_settings".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(398), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.privacy_sanitize_sanitize_on_shutdown
    ///
    /// A boolean reporting the value of the privacy.sanitize.sanitizeOnShutdown pref. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.privacy_sanitize_sanitizeOnShutdown.
    pub static privacy_sanitize_sanitize_on_shutdown: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_sanitize_sanitize_on_shutdown".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(399), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from datasanitization.session_permission_exceptions
    ///
    /// A count of how many "session" cookie exceptions a user has set. This metric was generated to correspond to the Legacy Telemetry scalar datasanitization.session_permission_exceptions.
    pub static session_permission_exceptions: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "session_permission_exceptions".into(),
                category: "datasanitization".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(400), meta)
    });

}
pub mod launch_on_login {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from launch_on_login.last_profile_disable_startup
    ///
    /// Recorded when Launch on login is disabled because the start with last profile setting has been disabled. This event was generated to correspond to the Legacy Telemetry event launch_on_login.last_profile_disable#startup.
    pub static last_profile_disable_startup: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_profile_disable_startup".into(),
                category: "launch_on_login".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(401), meta)
    });

}
pub mod os_environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.invoked_to_handle
    ///
    /// Records counts for when Firefox was invoked (i.e., was already running and was not launched) to handle a file type or protocol with `-osint -url ...`.  The result is split into keys which represent the file extension: currently, the set of file types Firefox registers to handle, namely ".avif", ".htm", ".html", ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol schemes that Firefox registers to handle, namely "about", "http", "https", "mailto".  If Firefox was invoked to handle a file type or protocol it does not register to handle by default, the count is recorded as ".<other extension>" or "<other protocol>", respectively (neither of which are valid extension or protocol identifiers). This metric was generated to correspond to the Legacy Telemetry scalar os.environment.invoked_to_handle.
    pub static invoked_to_handle: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "invoked_to_handle".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(402), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_default_handler
    ///
    /// Records whether Firefox was the default handler for particular file types or protocols.  The result is split into keys which represent the file extension or scheme: currently, a subset of the file types Firefox registers to handle, namely ".pdf" and "mailto" as protocol. In the future, more file types may be recorded. This metric was generated to correspond to the Legacy Telemetry scalar os.environment.is_default_handler.
    pub static is_default_handler: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_default_handler".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(403), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_kept_in_dock
    ///
    /// Whether this app was kept in macOS Dock on startup This metric was generated to correspond to the Legacy Telemetry scalar os.environment.is_kept_in_dock.
    pub static is_kept_in_dock: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_kept_in_dock".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(404), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_taskbar_pinned
    ///
    /// Whether the non-Private Browsing version of this app was pinned to taskbar on startup This metric was generated to correspond to the Legacy Telemetry scalar os.environment.is_taskbar_pinned.
    pub static is_taskbar_pinned: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_taskbar_pinned".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(405), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_taskbar_pinned_private
    ///
    /// Whether the Private Browsing version of this app was pinned to taskbar on startup This metric was generated to correspond to the Legacy Telemetry scalar os.environment.is_taskbar_pinned_private.
    pub static is_taskbar_pinned_private: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_taskbar_pinned_private".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(406), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.launch_method
    ///
    /// Records how Firefox was started on Windows. Currently will be one of "Desktop", "DesktopPrivate", "StartMenu" (including pins), "StartMenuPrivate", "Taskbar", "TaskbarPrivate", "OtherShortcut", or "Other" This metric was generated to correspond to the Legacy Telemetry scalar os.environment.launch_method.
    pub static launch_method: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_method".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(407), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.launched_to_handle
    ///
    /// Records counts for when Firefox was launched afresh (i.e., was not already running) to handle a file type or protocol with `-osint -url ...`.  The result is split into keys which represent the file extension: currently, the set of file types Firefox registers to handle, namely ".avif", ".htm", ".html", ".pdf", ".shtml", ".xht", ".xhtml", ".svg", ".webp", and the set of protocol schemes that Firefox registers to handle, namely "about", "http", "https", "mailto".  If Firefox was launched to handle a file type or protocol it does not register to handle by default, the count is recorded as ".<other extension>" or "<other protocol>", respectively (neither of which are valid extension or protocol identifiers). This metric was generated to correspond to the Legacy Telemetry scalar os.environment.launched_to_handle.
    pub static launched_to_handle: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "launched_to_handle".into(),
                    category: "os.environment".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(408), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.allowed_app_sources
    ///
    /// Indicates what sources the OS is currently configured to allow apps to be installed from. Possible values are "Anywhere", "Recommendations", "PreferStore", "StoreOnly", "NoSuchFeature", or "Error". "Recommendations" allows installs from anywhere, but recommends a comparable app from the store, if available. "NoSuchFeature" will be reported on versions of Windows that do not have an app source setting. This metric was generated to correspond to the Legacy Telemetry scalar os.environment.allowed_app_sources.
    pub static allowed_app_sources: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "allowed_app_sources".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(409), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from os.environment.is_admin_without_uac
    ///
    /// Indicates that the process is lauched with Admin privileges but without UAC. This metric was generated to correspond to the Legacy Telemetry scalar os.environment.is_admin_without_uac.
    pub static is_admin_without_uac: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_admin_without_uac".into(),
                category: "os.environment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(410), meta)
    });

}
pub mod primary_password {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from primary.password.enabled
    ///
    /// If a primary-password is enabled for this profile. Set soon after browser startup. Does not update if a primary password is added or removed after startup.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "primary.password".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(411), meta)
    });

}
pub mod security {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from security.global_privacy_control_enabled
    ///
    /// Measures user retention of the Global Privacy Control. 0 = never enabled, 1 = enabled, 2 = disabled (but was enabled) This metric was generated to correspond to the Legacy Telemetry scalar security.global_privacy_control_enabled.
    pub static global_privacy_control_enabled: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "global_privacy_control_enabled".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(412), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.https_only_mode_enabled
    ///
    /// Measures user retention of the HTTPS-Only Mode. 0 = never enabled, 1 = enabled, 2 = disabled (but was enabled) This metric was generated to correspond to the Legacy Telemetry scalar security.https_only_mode_enabled.
    pub static https_only_mode_enabled: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_only_mode_enabled".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(413), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.https_only_mode_enabled_pbm
    ///
    /// Measures user retention of the HTTPS-Only Mode in Private Browsing. 0 = https-only never enabled in PBM, 1 = https-only enabled in PBM, 2 = https-only disabled in PBM (but was enabled) This metric was generated to correspond to the Legacy Telemetry scalar security.https_only_mode_enabled_pbm.
    pub static https_only_mode_enabled_pbm: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "https_only_mode_enabled_pbm".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(414), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FissionPrincipalsExtra {
        pub r#principalType: Option<String>,
        pub r#scheme: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FissionPrincipalsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["principalType", "scheme", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#principalType.and_then(|val| map.insert("principalType".into(), val.to_string()));
          self.r#scheme.and_then(|val| map.insert("scheme".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.fission_principals
    ///
    /// When running with Fission, we received an unexpected principal from the content process. Expected values for this telemetry event are the method names in ContentParent that received the unexpected principal. This event was generated to correspond to the Legacy Telemetry event security.fissionPrincipals#contentParent.
    pub static fission_principals: Lazy<EventMetric<FissionPrincipalsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fission_principals".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(415), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CspViolationInternalPageExtra {
        pub r#blockeduridetails: Option<String>,
        pub r#blockeduritype: Option<String>,
        pub r#columnnumber: Option<u32>,
        pub r#directive: Option<String>,
        pub r#linenumber: Option<u32>,
        pub r#sample: Option<String>,
        pub r#selfdetails: Option<String>,
        pub r#selftype: Option<String>,
        pub r#sourcedetails: Option<String>,
        pub r#sourcetype: Option<String>,
    }

    impl ExtraKeys for CspViolationInternalPageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blockeduridetails", "blockeduritype", "columnnumber", "directive", "linenumber", "sample", "selfdetails", "selftype", "sourcedetails", "sourcetype"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blockeduridetails.and_then(|val| map.insert("blockeduridetails".into(), val.to_string()));
          self.r#blockeduritype.and_then(|val| map.insert("blockeduritype".into(), val.to_string()));
          self.r#columnnumber.and_then(|val| map.insert("columnnumber".into(), val.to_string()));
          self.r#directive.and_then(|val| map.insert("directive".into(), val.to_string()));
          self.r#linenumber.and_then(|val| map.insert("linenumber".into(), val.to_string()));
          self.r#sample.and_then(|val| map.insert("sample".into(), val.to_string()));
          self.r#selfdetails.and_then(|val| map.insert("selfdetails".into(), val.to_string()));
          self.r#selftype.and_then(|val| map.insert("selftype".into(), val.to_string()));
          self.r#sourcedetails.and_then(|val| map.insert("sourcedetails".into(), val.to_string()));
          self.r#sourcetype.and_then(|val| map.insert("sourcetype".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.csp_violation_internal_page
    ///
    /// Information about Content-Security-Policy violations that happen in internal pages like chrome://
    pub static csp_violation_internal_page: Lazy<EventMetric<CspViolationInternalPageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "csp_violation_internal_page".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(416), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvalUsageParentProcessExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvalUsageParentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.eval_usage_parent_process
    ///
    /// eval() (or an eval()-like method) was called while running in the System Principal context or the Parent Process. Expected values are: chromeuri - chrome:// file   resourceuri - resource:// file datauri - a data URI   bloburi - a blob URI   abouturi - an about URI   singlestring - A single file or string with no slashes mozillaextension - An extension claiming to be from *mozilla.org (Deprecated)   otherextension - Another extension not from Mozilla (Deprecated)   mozillaextension_file - An extension claiming to be from *mozilla.org, loaded from a file://   otherextension_file - Another extension not from Mozilla, loaded from a file:// extension_uri - A URI with the moz-extension:// scheme suspectedUserChromeJS - A filepath ending in .uc.js sanitizedWindowsPath - A filepath, on Windows, sanitized by WinUtils::PreparePathForTelemetry                          which is a bare filename or a subpath of %ProgramFiles%, %SystemRoot%, or %TEMP%   sanitizedWindowsURL - A partial URL, on Windows, consisting of either file://../ followed by the value prepared as for sanitizedWindowsPath, or the bare scheme of                         the original url   other - Unknown other-on-worker - We cannot do a regex; it is not a chrome, resource, data, or blob uri, but                     could be any other.   regexfailure - Our Regex Matching code threw an error The fileinfo key may contain additional information about the file that caused the eval() depending on the above value. Resource, Chrome, About, and SingleString will contain the full value. (About URIs will remove any querystring values.) Extensions-from-file will contain the full value; however .xpi! will be shortened to !, shield.mozilla.org! to s! and mozilla.org! to m!.  Data, Blob, UserChromeJS, Other, and Regexfailure should have no value. This event was generated to correspond to the Legacy Telemetry event security.evalUsage#parentProcess.
    pub static eval_usage_parent_process: Lazy<EventMetric<EvalUsageParentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eval_usage_parent_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(417), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvalUsageSystemContextExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvalUsageSystemContextExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.eval_usage_system_context
    ///
    /// eval() (or an eval()-like method) was called while running in the System Principal context or the Parent Process. Expected values are:
    ///   - chromeuri - chrome:// file
    ///   - resourceuri - resource:// file
    ///   - datauri - a data URI
    ///   - bloburi - a blob URI
    ///   - abouturi - an about URI
    ///   - singlestring - A single file or string with no slashes
    ///   - mozillaextension - An extension claiming to be from *mozilla.org (Deprecated)
    ///   - otherextension - Another extension not from Mozilla (Deprecated)
    ///   - mozillaextension_file - An extension claiming to be from *mozilla.org, loaded from a file://
    ///   - otherextension_file - Another extension not from Mozilla, loaded from a file://
    ///   - extension_uri - A URI with the moz-extension:// scheme
    ///   - suspectedUserChromeJS - A filepath ending in .uc.js
    ///   - sanitizedWindowsPath - A filepath, on Windows, sanitized by WinUtils::PreparePathForTelemetry which is a bare filename or a subpath of %ProgramFiles%, %SystemRoot%, or %TEMP%
    ///   - sanitizedWindowsURL - A partial URL, on Windows, consisting of either file://../ followed by the value prepared as for sanitizedWindowsPath, or the bare scheme of the original url
    ///   - other - Unknown
    ///   - other-on-worker - We cannot do a regex; it is not a chrome, resource, data, or blob uri, but could be any other.
    ///   - regexfailure - Our Regex Matching code threw an error
    /// 
    /// The fileinfo key may contain additional information about the file that caused the eval() depending on the above value. Resource, Chrome, About, and SingleString will contain the full value. (About URIs will remove any querystring values.)
    /// Extensions-from-file will contain the full value; however .xpi! will be shortened to !, shield.mozilla.org! to s! and mozilla.org! to m!.  Data, Blob, UserChromeJS, Other, and Regexfailure should have no value.
    /// This event was generated to correspond to the Legacy Telemetry event security.evalUsage#systemContext.
    pub static eval_usage_system_context: Lazy<EventMetric<EvalUsageSystemContextExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eval_usage_system_context".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(418), meta)
    });

    #[repr(u16)]
    pub enum HttpsOnlyModeUpgradeTimeLabel {
        ETopSuccessful = 0,
        ESubSuccessful = 1,
        ETopFRedirectloop = 2,
        ESubFRedirectloop = 3,
        ETopFTimeout = 4,
        ESubFTimeout = 5,
        ETopFAborted = 6,
        ESubFAborted = 7,
        ETopFCxnrefused = 8,
        ESubFCxnrefused = 9,
        ETopFSslSelfsignd = 10,
        ESubFSslSelfsignd = 11,
        ETopFSslBadcertdm = 12,
        ESubFSslBadcertdm = 13,
        ETopFSslUnkwnissr = 14,
        ESubFSslUnkwnissr = 15,
        ETopFSslOther = 16,
        ESubFSslOther = 17,
        ETopFOther = 18,
        ESubFOther = 19,
        __Other__,
    }
    impl From<u16> for HttpsOnlyModeUpgradeTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETopSuccessful,
                1 => Self::ESubSuccessful,
                2 => Self::ETopFRedirectloop,
                3 => Self::ESubFRedirectloop,
                4 => Self::ETopFTimeout,
                5 => Self::ESubFTimeout,
                6 => Self::ETopFAborted,
                7 => Self::ESubFAborted,
                8 => Self::ETopFCxnrefused,
                9 => Self::ESubFCxnrefused,
                10 => Self::ETopFSslSelfsignd,
                11 => Self::ESubFSslSelfsignd,
                12 => Self::ETopFSslBadcertdm,
                13 => Self::ESubFSslBadcertdm,
                14 => Self::ETopFSslUnkwnissr,
                15 => Self::ESubFSslUnkwnissr,
                16 => Self::ETopFSslOther,
                17 => Self::ESubFSslOther,
                18 => Self::ETopFOther,
                19 => Self::ESubFOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpsOnlyModeUpgradeTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETopSuccessful => "top_successful",
                Self::ESubSuccessful => "sub_successful",
                Self::ETopFRedirectloop => "top_f_redirectloop",
                Self::ESubFRedirectloop => "sub_f_redirectloop",
                Self::ETopFTimeout => "top_f_timeout",
                Self::ESubFTimeout => "sub_f_timeout",
                Self::ETopFAborted => "top_f_aborted",
                Self::ESubFAborted => "sub_f_aborted",
                Self::ETopFCxnrefused => "top_f_cxnrefused",
                Self::ESubFCxnrefused => "sub_f_cxnrefused",
                Self::ETopFSslSelfsignd => "top_f_ssl_selfsignd",
                Self::ESubFSslSelfsignd => "sub_f_ssl_selfsignd",
                Self::ETopFSslBadcertdm => "top_f_ssl_badcertdm",
                Self::ESubFSslBadcertdm => "sub_f_ssl_badcertdm",
                Self::ETopFSslUnkwnissr => "top_f_ssl_unkwnissr",
                Self::ESubFSslUnkwnissr => "sub_f_ssl_unkwnissr",
                Self::ETopFSslOther => "top_f_ssl_other",
                Self::ESubFSslOther => "sub_f_ssl_other",
                Self::ETopFOther => "top_f_other",
                Self::ESubFOther => "sub_f_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.https_only_mode_upgrade_time
    ///
    /// Time it takes for a request that has been upgraded with HTTPS-Only Mode to complete, broken down by top-level (top) / sub-resource (sub) and status
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTPS_ONLY_MODE_UPGRADE_TIME_MS.
    pub static https_only_mode_upgrade_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, HttpsOnlyModeUpgradeTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "https_only_mode_upgrade_time".into(),
                    category: "security".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(419), meta, Some(vec![::std::borrow::Cow::from("sub_f_aborted"), ::std::borrow::Cow::from("sub_f_cxnrefused"), ::std::borrow::Cow::from("sub_f_other"), ::std::borrow::Cow::from("sub_f_redirectloop"), ::std::borrow::Cow::from("sub_f_ssl_badcertdm"), ::std::borrow::Cow::from("sub_f_ssl_other"), ::std::borrow::Cow::from("sub_f_ssl_selfsignd"), ::std::borrow::Cow::from("sub_f_ssl_unkwnissr"), ::std::borrow::Cow::from("sub_f_timeout"), ::std::borrow::Cow::from("sub_successful"), ::std::borrow::Cow::from("top_f_aborted"), ::std::borrow::Cow::from("top_f_cxnrefused"), ::std::borrow::Cow::from("top_f_other"), ::std::borrow::Cow::from("top_f_redirectloop"), ::std::borrow::Cow::from("top_f_ssl_badcertdm"), ::std::borrow::Cow::from("top_f_ssl_other"), ::std::borrow::Cow::from("top_f_ssl_selfsignd"), ::std::borrow::Cow::from("top_f_ssl_unkwnissr"), ::std::borrow::Cow::from("top_f_timeout"), ::std::borrow::Cow::from("top_successful")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JavascriptLoadParentProcessExtra {
        pub r#fileinfo: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JavascriptLoadParentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fileinfo", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fileinfo.and_then(|val| map.insert("fileinfo".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.javascript_load_parent_process
    ///
    /// The javascript engine requested to load a filename that was not allowed. Expected values, and fileinfo key, are the same possible values as above in 'evalUsage' This event was generated to correspond to the Legacy Telemetry event security.javascriptLoad#parentProcess.
    pub static javascript_load_parent_process: Lazy<EventMetric<JavascriptLoadParentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "javascript_load_parent_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(420), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.referrer_policy_count
    ///
    /// The counter of each referrer policy which has been computed for a referrer. The buckets (0-8) are for same-site requests and buckets (9-17) are for cross-site requests. Note that the index matches to the order in ReferrerPolicy.webidl
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram REFERRER_POLICY_COUNT.
    pub static referrer_policy_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "referrer_policy_count".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(421), meta, 0, 18, 19, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnexpectedLoadExtra {
        pub r#contenttype: Option<String>,
        pub r#filedetails: Option<String>,
        pub r#redirects: Option<String>,
        pub r#remotetype: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnexpectedLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["contenttype", "filedetails", "redirects", "remotetype", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#contenttype.and_then(|val| map.insert("contenttype".into(), val.to_string()));
          self.r#filedetails.and_then(|val| map.insert("filedetails".into(), val.to_string()));
          self.r#redirects.and_then(|val| map.insert("redirects".into(), val.to_string()));
          self.r#remotetype.and_then(|val| map.insert("remotetype".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.unexpected_load
    ///
    /// Long term want to block all loads from the system principal that cause us to parse non-trivial data. We don't look to break existing functionality and will allow exceptions, for this we are collecting information about unexpected requests triggered by the system principal Our measurement *excludes* acceptable requests. Those are: - annotated using the 'AllowedDeprecatedSystemRequests' loadinfo flag - using a nsContentPolicyType of FETCH, XMLHTTPREQUEST, WEBSOCKET, SAVEAS_DOWNLOAD or IMAGE - with a requested URI object has the flag URI_IS_UI_RESOURCE - if the URL scheme is 'view-source' - if the URL scheme is 'file' and the Content-Type is STYLESHEET or OTHER - if the scheme is 'jar', 'about' or 'moz-extension' This event was generated to correspond to the Legacy Telemetry event security.unexpectedload#systemprincipal.
    pub static unexpected_load: Lazy<EventMetric<UnexpectedLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unexpected_load".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(422), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefUsageContentProcessExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefUsageContentProcessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.pref_usage_content_process
    ///
    /// We block certain preferences from being sent to the content process because they contain sensitive user data. Some preferences are blocked by name, others by heuristic. If one of the preferences so blocked is accidently accessed we want to know about it so we can allowlist it or refactor the access. This event was generated to correspond to the Legacy Telemetry event security.prefUsage#contentProcess.
    pub static pref_usage_content_process: Lazy<EventMetric<PrefUsageContentProcessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_usage_content_process".into(),
                category: "security".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(423), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.addon_signature_verification_status
    ///
    /// Records the result of App Signature Verification. See the comments in OpenSignedAppFile.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram ADDON_SIGNATURE_VERIFICATION_STATUS.
    pub static addon_signature_verification_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_signature_verification_status".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(424), meta, 0, 32, 33, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.client_auth_cert_usage
    ///
    /// Measures how many servers have requested a client authentication certificate (key: "requested") and how many times the user has opted to send one in response (key: "sent"). This metric was generated to correspond to the Legacy Telemetry scalar security.client_auth_cert_usage.
    pub static client_auth_cert_usage: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "client_auth_cert_usage".into(),
                    category: "security".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(425), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.content_signature_verification_status
    ///
    /// What was the result of the content signature verification? 0=valid, 1=invalid, 2=noCertChain, 3=createContextFailedWithOtherError, 4=expiredCert, 5=certNotValidYet, 6=buildCertChainFailed, 7=eeCertForWrongHost, 8=extractKeyError, 9=vfyContextError
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CONTENT_SIGNATURE_VERIFICATION_STATUS.
    pub static content_signature_verification_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_signature_verification_status".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(426), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from security.ntlm_module_used
    ///
    /// The module used for the NTLM protocol (Windows_API, Kerberos, Samba_auth or Generic) and whether or not the authentication was used to connect to a proxy server. This data is collected only once per session (at first NTLM authentification) ; fixed version.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NTLM_MODULE_USED_2.
    pub static ntlm_module_used: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ntlm_module_used".into(),
                category: "security".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(427), meta, 0, 8, 9, HistogramType::Linear)
    });

}
pub mod sslkeylogging {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sslkeylogging.enabled
    ///
    /// Records whether TLS key logging has been enabled via the environment variable SSLKEYLOGFILE.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "sslkeylogging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(428), meta)
    });

}
pub mod start_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from start_menu.manually_unpinned_since_last_launch
    ///
    /// Records whether Firefox has been unpinned from the Windows start menu since last launch. This will only be recorded on MSIX due to the underlying API only being available for packaged applications.
    pub static manually_unpinned_since_last_launch: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manually_unpinned_since_last_launch".into(),
                category: "start_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(429), meta)
    });

}
pub mod startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from startup.is_cold
    ///
    /// Whether or not this startup is the first startup since OS reboot (according to our best guess.) This metric was generated to correspond to the Legacy Telemetry scalar startup.is_cold.
    pub static is_cold: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_cold".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(430), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.seconds_since_last_os_restart
    ///
    /// The time in seconds between the first browser window loading, and the time the OS started. This can give us an indication of whether starting the browser may have been the first thing the user did after starting their computer. This metric was generated to correspond to the Legacy Telemetry scalar startup.seconds_since_last_os_restart.
    pub static seconds_since_last_os_restart: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "seconds_since_last_os_restart".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(431), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_count
    ///
    /// This records the number of known profiles after startup completes. This includes any profiles that were created during startup. This metric was generated to correspond to the Legacy Telemetry scalar startup.profile_count.
    pub static profile_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_count".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(432), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_database_version
    ///
    /// The version of the profiles.ini database loaded during startup. A value of "0" is used to indicate that no file was present during startup. This metric was generated to correspond to the Legacy Telemetry scalar startup.profile_database_version.
    pub static profile_database_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_database_version".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(433), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from startup.profile_selection_reason
    ///
    /// How the profile was selected during startup. One of the following reasons:
    ///   unknown:
    ///     Generally should not happen, set as a default in case no other reason
    ///     occured.
    ///   profile-manager:
    ///     The profile was selected by the profile manager.
    ///   profile-selector:
    ///     The profile was selected by the profile selector window.
    ///   profile-reset:
    ///     The profile was selected for reset, normally this would mean a restart.
    ///   restart:
    ///     The user restarted the application, the same profile as previous will
    ///     be used.
    ///   argument-profile:
    ///     The profile was selected by the --profile command line argument.
    ///   argument-p:
    ///     The profile was selected by the -p command line argument.
    ///   firstrun-claimed-default:
    ///     A first run of a dedicated profiles build chose the old default
    ///     profile to be the default for this install.
    ///   firstrun-skipped-default:
    ///     A first run of a dedicated profiles build skipped over the old default
    ///     profile and created a new profile.
    ///   restart-claimed-default:
    ///     A first run of a dedicated profiles build after a restart chose the
    ///     old default profile to be the default for this install.
    ///   restart-skipped-default:
    ///     A first run of a dedicated profiles build after a restart skipped over
    ///     the old default profile and created a new profile.
    ///   firstrun-created-default:
    ///     A first run of the application created a new profile to use.
    ///   default:
    ///     The default profile was selected as normal.
    /// This metric was generated to correspond to the Legacy Telemetry scalar startup.profile_selection_reason.
    pub static profile_selection_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_selection_reason".into(),
                category: "startup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(434), meta)
    });

}
pub mod upgrade_dialog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TriggerReasonExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TriggerReasonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from upgrade_dialog.trigger_reason
    ///
    /// Triggering behaviors of the upgrade dialog. Value indicates which condition failed or all satisfied. This event was generated to correspond to the Legacy Telemetry event upgrade_dialog.trigger#reason.
    pub static trigger_reason: Lazy<EventMetric<TriggerReasonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trigger_reason".into(),
                category: "upgrade_dialog".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(435), meta)
    });

}
pub mod browser_migration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.bookmarks_quantity
    ///
    /// How many bookmarks we imported from another browser, keyed by the name of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_MIGRATION_BOOKMARKS_QUANTITY.
    pub static bookmarks_quantity: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "bookmarks_quantity".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 1000, bucket_count: 20, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(436), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BrowserSelectedWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for BrowserSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.browser_selected_wizard
    ///
    /// Recorded when the user selects a browser to migrate from. This event was generated to correspond to the Legacy Telemetry event browser.migration.browser_selected#wizard.
    pub static browser_selected_wizard: Lazy<EventMetric<BrowserSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(437), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.cards_quantity
    ///
    /// How many credit card entries we imported from another browser, keyed by the name of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_MIGRATION_CARDS_QUANTITY.
    pub static cards_quantity: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cards_quantity".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 1000, bucket_count: 20, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(438), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.chrome_password_file_wizard
    ///
    /// Recorded if the user is importing from Chrome, and was presented with the page of the wizard requesting to import passwords from a file. This currently only gets shown on Windows.
    pub static chrome_password_file_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chrome_password_file_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(439), meta)
    });

    #[repr(u16)]
    pub enum EntryPointCategoricalLabel {
        EUnknown = 0,
        EFirstrun = 1,
        EFxrefresh = 2,
        EPlaces = 3,
        EPasswords = 4,
        ENewtab = 5,
        EFileMenu = 6,
        EHelpMenu = 7,
        EBookmarksToolbar = 8,
        EPreferences = 9,
        __Other__,
    }
    impl From<u16> for EntryPointCategoricalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EFirstrun,
                2 => Self::EFxrefresh,
                3 => Self::EPlaces,
                4 => Self::EPasswords,
                5 => Self::ENewtab,
                6 => Self::EFileMenu,
                7 => Self::EHelpMenu,
                8 => Self::EBookmarksToolbar,
                9 => Self::EPreferences,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EntryPointCategoricalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EFirstrun => "firstrun",
                Self::EFxrefresh => "fxrefresh",
                Self::EPlaces => "places",
                Self::EPasswords => "passwords",
                Self::ENewtab => "newtab",
                Self::EFileMenu => "file_menu",
                Self::EHelpMenu => "help_menu",
                Self::EBookmarksToolbar => "bookmarks_toolbar",
                Self::EPreferences => "preferences",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.entry_point_categorical
    ///
    /// Where the migration wizard was entered from.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram FX_MIGRATION_ENTRY_POINT_CATEGORICAL.
    pub static entry_point_categorical: Lazy<LabeledMetric<LabeledCounterMetric, EntryPointCategoricalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "entry_point_categorical".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(440), meta, Some(vec![::std::borrow::Cow::from("bookmarks_toolbar"), ::std::borrow::Cow::from("file_menu"), ::std::borrow::Cow::from("firstrun"), ::std::borrow::Cow::from("fxrefresh"), ::std::borrow::Cow::from("help_menu"), ::std::borrow::Cow::from("newtab"), ::std::borrow::Cow::from("passwords"), ::std::borrow::Cow::from("places"), ::std::borrow::Cow::from("preferences"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.errors
    ///
    /// Errors encountered during migration in buckets defined by the datatype, keyed by the string description of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_MIGRATION_ERRORS.
    pub static errors: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "errors".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 12, bucket_count: 13, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(441), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.extensions_quantity
    ///
    /// How many extensions were matched to be imported from another browser, keyed by the name of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_MIGRATION_EXTENSIONS_QUANTITY.
    pub static extensions_quantity: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "extensions_quantity".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 1000, bucket_count: 20, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(442), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.history_quantity
    ///
    /// How many history visits we imported from another browser, keyed by the name of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_MIGRATION_HISTORY_QUANTITY.
    pub static history_quantity: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "history_quantity".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 10000, bucket_count: 40, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(443), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LinuxPermsWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for LinuxPermsWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.linux_perms_wizard
    ///
    /// Recorded if the user is on Linux and the browser is installed in a sandboxed environment that prevents it from reading other browser's data, and the user is presented with instructions and an option to grant the browser permission to read that other data. This event was generated to correspond to the Legacy Telemetry event browser.migration.linux_perms#wizard.
    pub static linux_perms_wizard: Lazy<EventMetric<LinuxPermsWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "linux_perms_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(444), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.logins_quantity
    ///
    /// How many logins (passwords) we imported from another browser, keyed by the name of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_MIGRATION_LOGINS_QUANTITY.
    pub static logins_quantity: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "logins_quantity".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 1000, bucket_count: 20, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(445), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.matched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were successfully matched to Firefox equivalents from the list downloaded from AMO.
    pub static matched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "matched_extensions".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(446), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrationFinishedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for MigrationFinishedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.migration_finished_wizard
    ///
    /// Recorded when the user finishes a migration. This event was generated to correspond to the Legacy Telemetry event browser.migration.migration_finished#wizard.
    pub static migration_finished_wizard: Lazy<EventMetric<MigrationFinishedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migration_finished_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(447), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrationStartedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for MigrationStartedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.migration_started_wizard
    ///
    /// Recorded when the user begins a migration. This event was generated to correspond to the Legacy Telemetry event browser.migration.migration_started#wizard.
    pub static migration_started_wizard: Lazy<EventMetric<MigrationStartedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migration_started_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(448), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.no_browsers_found_wizard
    ///
    /// Recorded when the migration wizard reports that there are no browsers to migrate from. This event was generated to correspond to the Legacy Telemetry event browser.migration.no_browsers_found#wizard.
    pub static no_browsers_found_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "no_browsers_found_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(449), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.opened_wizard
    ///
    /// Recorded when the migration wizard opens. This event was generated to correspond to the Legacy Telemetry event browser.migration.opened#wizard.
    pub static opened_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(450), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProfileSelectedWizardExtra {
        pub r#migrator_key: Option<String>,
    }

    impl ExtraKeys for ProfileSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["migrator_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.profile_selected_wizard
    ///
    /// Recorded when the user selects a profile to migrate from. If the browser doesn't support multiple profiles, this will not be recorded. This event was generated to correspond to the Legacy Telemetry event browser.migration.profile_selected#wizard.
    pub static profile_selected_wizard: Lazy<EventMetric<ProfileSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(451), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResourcesSelectedWizardExtra {
        pub r#bookmarks: Option<String>,
        pub r#configured: Option<String>,
        pub r#extensions: Option<String>,
        pub r#formdata: Option<String>,
        pub r#history: Option<String>,
        pub r#migrator_key: Option<String>,
        pub r#other: Option<u32>,
        pub r#passwords: Option<String>,
        pub r#payment_methods: Option<String>,
    }

    impl ExtraKeys for ResourcesSelectedWizardExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bookmarks", "configured", "extensions", "formdata", "history", "migrator_key", "other", "passwords", "payment_methods"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bookmarks.and_then(|val| map.insert("bookmarks".into(), val.to_string()));
          self.r#configured.and_then(|val| map.insert("configured".into(), val.to_string()));
          self.r#extensions.and_then(|val| map.insert("extensions".into(), val.to_string()));
          self.r#formdata.and_then(|val| map.insert("formdata".into(), val.to_string()));
          self.r#history.and_then(|val| map.insert("history".into(), val.to_string()));
          self.r#migrator_key.and_then(|val| map.insert("migrator_key".into(), val.to_string()));
          self.r#other.and_then(|val| map.insert("other".into(), val.to_string()));
          self.r#passwords.and_then(|val| map.insert("passwords".into(), val.to_string()));
          self.r#payment_methods.and_then(|val| map.insert("payment_methods".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.resources_selected_wizard
    ///
    /// Recorded when the user selects resources from the browser / profile to import. This event was generated to correspond to the Legacy Telemetry event browser.migration.resources_selected#wizard.
    pub static resources_selected_wizard: Lazy<EventMetric<ResourcesSelectedWizardExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resources_selected_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(452), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.safari_password_file_wizard
    ///
    /// Recorded if the user is on macOS, chose to migrate from Safari, and was presented with the page of the wizard requesting to import passwords from a file. This only gets recorded in the new migration wizard. This event was generated to correspond to the Legacy Telemetry event browser.migration.safari_password_file#wizard.
    pub static safari_password_file_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "safari_password_file_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(453), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.safari_perms_wizard
    ///
    /// Recorded if the user is on macOS, chose to migrate from Safari, and was presented with the page of the wizard requesting permission to read from the Safari profile folder. This event was generated to correspond to the Legacy Telemetry event browser.migration.safari_perms#wizard.
    pub static safari_perms_wizard: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "safari_perms_wizard".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(454), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.source_browser
    ///
    /// The browser that data is pulled from. The values correspond to the internal browser ID (see MigrationUtils.sys.mjs)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_MIGRATION_SOURCE_BROWSER.
    pub static source_browser: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source_browser".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(455), meta, 0, 15, 16, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.unmatched_extensions
    ///
    /// Records a list of the Chrome extension IDs that were unsuccessfully matched to Firefox equivalents from the list downloaded from AMO.
    pub static unmatched_extensions: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unmatched_extensions".into(),
                category: "browser.migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(456), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.migration.usage
    ///
    /// Usage of migration for each datatype when migration is run through the post-firstrun flow which allows individual datatypes, keyed by the string description of the browser.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_MIGRATION_USAGE.
    pub static usage: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "usage".into(),
                    category: "browser.migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 12, bucket_count: 13, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(457), meta, None)
    });

}
pub mod migration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from migration.discovered_migrators
    ///
    /// A keyed uint recording how many times the migration wizard detected a browser / profile pair for a particular browser. This is incremented every time the discovery occurs, so multiple openings of the wizard will increase the counts each time. This metric was generated to correspond to the Legacy Telemetry scalar migration.discovered_migrators.
    pub static discovered_migrators: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "discovered_migrators".into(),
                    category: "migration".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(458), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from migration.time_to_produce_migrator_list
    ///
    /// The amount of time it took in milliseconds to produce the list of migrators and profiles for the first time the migration wizard opened during the process lifetime. This metric was generated to correspond to the Legacy Telemetry scalar migration.time_to_produce_migrator_list.
    pub static time_to_produce_migrator_list: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_produce_migrator_list".into(),
                category: "migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(459), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from migration.uninstaller_profile_refresh
    ///
    /// Set when a profile refresh is initiated from the uninstaller. This metric was generated to correspond to the Legacy Telemetry scalar migration.uninstaller_profile_refresh.
    pub static uninstaller_profile_refresh: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstaller_profile_refresh".into(),
                category: "migration".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(460), meta)
    });

}
pub mod activity_stream {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EndSessionExtra {
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for EndSessionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.end_session
    ///
    /// This is recorded with every session ended in Activity Stream. This event was generated to correspond to the Legacy Telemetry event activity_stream.end#session.
    pub static end_session: Lazy<EventMetric<EndSessionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "end_session".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(461), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventArchiveFromPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventArchiveFromPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_archive_from_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#ARCHIVE_FROM_POCKET.
    pub static event_archive_from_pocket: Lazy<EventMetric<EventArchiveFromPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_archive_from_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(462), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBlockExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBlockExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_block
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#BLOCK.
    pub static event_block: Lazy<EventMetric<EventBlockExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_block".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(463), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBookmarkAddExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBookmarkAddExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_bookmark_add
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#BOOKMARK_ADD.
    pub static event_bookmark_add: Lazy<EventMetric<EventBookmarkAddExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_bookmark_add".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(464), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventBookmarkDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventBookmarkDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_bookmark_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#BOOKMARK_DELETE.
    pub static event_bookmark_delete: Lazy<EventMetric<EventBookmarkDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_bookmark_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(465), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventClickExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_click
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#CLICK.
    pub static event_click: Lazy<EventMetric<EventClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_click".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(466), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventClickPrivacyInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventClickPrivacyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_click_privacy_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#CLICK_PRIVACY_INFO.
    pub static event_click_privacy_info: Lazy<EventMetric<EventClickPrivacyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_click_privacy_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(467), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventCloseNewtabPrefsExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventCloseNewtabPrefsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_close_newtab_prefs
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#CLOSE_NEWTAB_PREFS.
    pub static event_close_newtab_prefs: Lazy<EventMetric<EventCloseNewtabPrefsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_close_newtab_prefs".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(468), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DELETE.
    pub static event_delete: Lazy<EventMetric<EventDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(469), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteConfirmExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteConfirmExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete_confirm
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DELETE_CONFIRM.
    pub static event_delete_confirm: Lazy<EventMetric<EventDeleteConfirmExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete_confirm".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(470), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDeleteFromPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDeleteFromPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_delete_from_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DELETE_FROM_POCKET.
    pub static event_delete_from_pocket: Lazy<EventMetric<EventDeleteFromPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_delete_from_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(471), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDialogCancelExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDialogCancelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_dialog_cancel
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DIALOG_CANCEL.
    pub static event_dialog_cancel: Lazy<EventMetric<EventDialogCancelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_dialog_cancel".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(472), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDialogOpenExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDialogOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_dialog_open
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DIALOG_OPEN.
    pub static event_dialog_open: Lazy<EventMetric<EventDialogOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_dialog_open".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(473), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDisclaimerAckedExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDisclaimerAckedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_disclaimer_acked
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DISCLAIMER_ACKED.
    pub static event_disclaimer_acked: Lazy<EventMetric<EventDisclaimerAckedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_disclaimer_acked".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(474), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDragExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDragExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_drag
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DRAG.
    pub static event_drag: Lazy<EventMetric<EventDragExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_drag".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(475), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventDropExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventDropExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_drop
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#DROP.
    pub static event_drop: Lazy<EventMetric<EventDropExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_drop".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(476), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventFakespotCategoryExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventFakespotCategoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_fakespot_category
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#FAKESPOT_CATEGORY.
    pub static event_fakespot_category: Lazy<EventMetric<EventFakespotCategoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_fakespot_category".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(477), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventFakespotClickExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventFakespotClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_fakespot_click
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#FAKESPOT_CLICK.
    pub static event_fakespot_click: Lazy<EventMetric<EventFakespotClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_fakespot_click".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(478), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventHidePersonalizeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventHidePersonalizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_hide_personalize
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#HIDE_PERSONALIZE.
    pub static event_hide_personalize: Lazy<EventMetric<EventHidePersonalizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_hide_personalize".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(479), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventImpressionExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_impression
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#IMPRESSION.
    pub static event_impression: Lazy<EventMetric<EventImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_impression".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(480), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuAddSearchExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuAddSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_add_search
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_ADD_SEARCH.
    pub static event_menu_add_search: Lazy<EventMetric<EventMenuAddSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_add_search".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(481), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuAddTopsiteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuAddTopsiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_add_topsite
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_ADD_TOPSITE.
    pub static event_menu_add_topsite: Lazy<EventMetric<EventMenuAddTopsiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_add_topsite".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(482), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuCollapseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuCollapseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_collapse
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_COLLAPSE.
    pub static event_menu_collapse: Lazy<EventMetric<EventMenuCollapseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_collapse".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(483), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuExpandExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuExpandExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_expand
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_EXPAND.
    pub static event_menu_expand: Lazy<EventMetric<EventMenuExpandExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_expand".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(484), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuManageExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_manage
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_MANAGE.
    pub static event_menu_manage: Lazy<EventMetric<EventMenuManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_manage".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(485), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuMoveDownExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuMoveDownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_move_down
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_MOVE_DOWN.
    pub static event_menu_move_down: Lazy<EventMetric<EventMenuMoveDownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_move_down".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(486), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuMoveUpExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuMoveUpExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_move_up
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_MOVE_UP.
    pub static event_menu_move_up: Lazy<EventMetric<EventMenuMoveUpExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_move_up".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(487), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuPrivacyNoticeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuPrivacyNoticeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_privacy_notice
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_PRIVACY_NOTICE.
    pub static event_menu_privacy_notice: Lazy<EventMetric<EventMenuPrivacyNoticeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_privacy_notice".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(488), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMenuRemoveExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMenuRemoveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_menu_remove
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MENU_REMOVE.
    pub static event_menu_remove: Lazy<EventMetric<EventMenuRemoveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_menu_remove".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(489), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMigrationCancelExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMigrationCancelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_migration_cancel
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MIGRATION_CANCEL.
    pub static event_migration_cancel: Lazy<EventMetric<EventMigrationCancelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_migration_cancel".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(490), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventMigrationStartExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventMigrationStartExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_migration_start
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#MIGRATION_START.
    pub static event_migration_start: Lazy<EventMetric<EventMigrationStartExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_migration_start".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(491), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenNewWindowExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenNewWindowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_new_window
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#OPEN_NEW_WINDOW.
    pub static event_open_new_window: Lazy<EventMetric<EventOpenNewWindowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_new_window".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(492), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenNewtabPrefsExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenNewtabPrefsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_newtab_prefs
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#OPEN_NEWTAB_PREFS.
    pub static event_open_newtab_prefs: Lazy<EventMetric<EventOpenNewtabPrefsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_newtab_prefs".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(493), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventOpenPrivateWindowExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventOpenPrivateWindowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_open_private_window
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#OPEN_PRIVATE_WINDOW.
    pub static event_open_private_window: Lazy<EventMetric<EventOpenPrivateWindowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_open_private_window".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(494), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPinExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPinExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#PIN.
    pub static event_pin: Lazy<EventMetric<EventPinExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(495), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPocketThumbsDownExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPocketThumbsDownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pocket_thumbs_down
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#POCKET_THUMBS_DOWN.
    pub static event_pocket_thumbs_down: Lazy<EventMetric<EventPocketThumbsDownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pocket_thumbs_down".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(496), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPocketThumbsUpExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPocketThumbsUpExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pocket_thumbs_up
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#POCKET_THUMBS_UP.
    pub static event_pocket_thumbs_up: Lazy<EventMetric<EventPocketThumbsUpExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pocket_thumbs_up".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(497), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPrefChangedExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPrefChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_pref_changed
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#PREF_CHANGED.
    pub static event_pref_changed: Lazy<EventMetric<EventPrefChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_pref_changed".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(498), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventPreviewRequestExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventPreviewRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_preview_request
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#PREVIEW_REQUEST.
    pub static event_preview_request: Lazy<EventMetric<EventPreviewRequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_preview_request".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(499), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSaveToPocketExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSaveToPocketExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_save_to_pocket
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SAVE_TO_POCKET.
    pub static event_save_to_pocket: Lazy<EventMetric<EventSaveToPocketExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_save_to_pocket".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(500), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SEARCH.
    pub static event_search: Lazy<EventMetric<EventSearchExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(501), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditAddExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditAddExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_add
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SEARCH_EDIT_ADD.
    pub static event_search_edit_add: Lazy<EventMetric<EventSearchEditAddExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_add".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(502), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditCloseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_close
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SEARCH_EDIT_CLOSE.
    pub static event_search_edit_close: Lazy<EventMetric<EventSearchEditCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_close".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(503), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchEditDeleteExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchEditDeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_edit_delete
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SEARCH_EDIT_DELETE.
    pub static event_search_edit_delete: Lazy<EventMetric<EventSearchEditDeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_edit_delete".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(504), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSearchHandoffExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSearchHandoffExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_search_handoff
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SEARCH_HANDOFF.
    pub static event_search_handoff: Lazy<EventMetric<EventSearchHandoffExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_search_handoff".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(505), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventShowPersonalizeExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventShowPersonalizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_show_personalize
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SHOW_PERSONALIZE.
    pub static event_show_personalize: Lazy<EventMetric<EventShowPersonalizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_show_personalize".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(506), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventShowPrivacyInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventShowPrivacyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_show_privacy_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SHOW_PRIVACY_INFO.
    pub static event_show_privacy_info: Lazy<EventMetric<EventShowPrivacyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_show_privacy_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(507), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSkippedSigninExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSkippedSigninExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_skipped_signin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SKIPPED_SIGNIN.
    pub static event_skipped_signin: Lazy<EventMetric<EventSkippedSigninExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_skipped_signin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(508), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventSubmitEmailExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventSubmitEmailExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_submit_email
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#SUBMIT_EMAIL.
    pub static event_submit_email: Lazy<EventMetric<EventSubmitEmailExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_submit_email".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(509), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopSitesEditExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopSitesEditExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_top_sites_edit
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#TOP_SITES_EDIT.
    pub static event_top_sites_edit: Lazy<EventMetric<EventTopSitesEditExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_top_sites_edit".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(510), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopSitesEditCloseExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopSitesEditCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_top_sites_edit_close
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#TOP_SITES_EDIT_CLOSE.
    pub static event_top_sites_edit_close: Lazy<EventMetric<EventTopSitesEditCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_top_sites_edit_close".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(511), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventTopsiteSponsorInfoExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventTopsiteSponsorInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_topsite_sponsor_info
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#TOPSITE_SPONSOR_INFO.
    pub static event_topsite_sponsor_info: Lazy<EventMetric<EventTopsiteSponsorInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_topsite_sponsor_info".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(512), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventUnpinExtra {
        pub r#action_position: Option<u32>,
        pub r#addon_version: Option<String>,
        pub r#page: Option<String>,
        pub r#session_id: Option<String>,
        pub r#user_prefs: Option<u32>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EventUnpinExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_position", "addon_version", "page", "session_id", "user_prefs", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_position.and_then(|val| map.insert("action_position".into(), val.to_string()));
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#page.and_then(|val| map.insert("page".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#user_prefs.and_then(|val| map.insert("user_prefs".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from activity_stream.event_unpin
    ///
    /// This is recorded with every user interaction on Activity Stream elements. This event was generated to correspond to the Legacy Telemetry event activity_stream.event#UNPIN.
    pub static event_unpin: Lazy<EventMetric<EventUnpinExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_unpin".into(),
                category: "activity_stream".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(513), meta)
    });

}
pub mod contextual_services_topsites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from contextual.services.topsites.click
    ///
    /// A keyed uint recording how many times the user has clicked on the sponsored TopSites on the newtab page. The key is a combination of the source and the placement of the TopSites tile (1-based). such as 'urlbar_1', 'newtab_2'. This metric was generated to correspond to the Legacy Telemetry scalar contextual.services.topsites.click.
    pub static click: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "click".into(),
                    category: "contextual.services.topsites".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(514), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contextual.services.topsites.impression
    ///
    /// A keyed uint recording how many times the user has viewed the sponsored TopSites on the newtab page. The key is a combination of the source and the placement of the TopSites tile (1-based). such as 'urlbar_1', 'newtab_2'. This metric was generated to correspond to the Legacy Telemetry scalar contextual.services.topsites.impression.
    pub static impression: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "impression".into(),
                    category: "contextual.services.topsites".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(515), meta, None)
    });

}
pub mod deletion_request {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from deletion.request.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings. This metric was generated to correspond to the Legacy Telemetry scalar deletion.request.context_id.
    pub static context_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "deletion.request".into(),
                send_in_pings: vec!["deletion-request".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(516), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from deletion.request.impression_id
    ///
    /// An identifier used by user interaction pings in Pocket/newtab and Messaging System. This metric was generated to correspond to the Legacy Telemetry scalar deletion.request.impression_id.
    pub static impression_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id".into(),
                category: "deletion.request".into(),
                send_in_pings: vec!["deletion-request".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(517), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from deletion.request.sync_device_id
    ///
    /// An identifier used by sync ping, to identify the current Firefox profile for a specific Account. This metric was generated to correspond to the Legacy Telemetry scalar deletion.request.sync_device_id.
    pub static sync_device_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sync_device_id".into(),
                category: "deletion.request".into(),
                send_in_pings: vec!["deletion-request".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(518), meta)
    });

}
pub mod newtab {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.abouthome_cache_construction
    ///
    /// The length of time (in milliseconds) that it takes for the cache worker to generate the cache and return it to the main thread
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_ABOUTHOME_CACHE_CONSTRUCTION.
    pub static abouthome_cache_construction: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abouthome_cache_construction".into(),
                category: "newtab".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(519), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.blocked_sponsors
    ///
    /// The advertiser names that have been dismissed by the user.
    pub static blocked_sponsors: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blocked_sponsors".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(520), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClosedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.closed
    ///
    /// Recorded when newtab UI is closed by * navigation * closing the tab
    /// Doesn't mean that the newtab was ever visible to a user.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(521), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotAboutClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotAboutClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_about_click
    ///
    /// Recorded when a user the 'About Fakespot' link in TBR fakespot feed context menu
    pub static fakespot_about_click: Lazy<EventMetric<FakespotAboutClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_about_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(522), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotCategoryExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotCategoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_category
    ///
    /// Recorded when a user changes the category in TBR fakespot feed
    pub static fakespot_category: Lazy<EventMetric<FakespotCategoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(523), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotClickExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#product_id: Option<String>,
    }

    impl ExtraKeys for FakespotClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id", "product_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#product_id.and_then(|val| map.insert("product_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_click
    ///
    /// Recorded when a user clicks on a card in TBR fakespot feed
    pub static fakespot_click: Lazy<EventMetric<FakespotClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(524), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotCtaClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_cta_click
    ///
    /// Recorded when a user clicks on the CTA in TBR fakespot feed
    pub static fakespot_cta_click: Lazy<EventMetric<FakespotCtaClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_cta_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(525), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotDismissExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for FakespotDismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_dismiss
    ///
    /// Recorded when a user dissmisses TBR fakespot feed
    pub static fakespot_dismiss: Lazy<EventMetric<FakespotDismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_dismiss".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(526), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotProductImpressionExtra {
        pub r#category: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#product_id: Option<String>,
        pub r#product_title: Option<String>,
    }

    impl ExtraKeys for FakespotProductImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "newtab_visit_id", "product_id", "product_title"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#product_id.and_then(|val| map.insert("product_id".into(), val.to_string()));
          self.r#product_title.and_then(|val| map.insert("product_title".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.fakespot_product_impression
    ///
    /// Recorded when a user triggers an impression on a card in TBR fakespot feed
    pub static fakespot_product_impression: Lazy<EventMetric<FakespotProductImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_product_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(527), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.homepage_category
    ///
    /// The current setting of the home page. One of ["enabled", "disabled", "extension"] or any value from SiteClassifier like "known-hijacker" or "social-media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's `home_url_category`. Sampled once after newtab init.
    pub static homepage_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "homepage_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(528), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InlineSelectionClickExtra {
        pub r#is_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section_position: Option<String>,
        pub r#topic: Option<String>,
        pub r#topic_position: Option<String>,
    }

    impl ExtraKeys for InlineSelectionClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_followed", "newtab_visit_id", "section_position", "topic", "topic_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_followed.and_then(|val| map.insert("is_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          self.r#topic_position.and_then(|val| map.insert("topic_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.inline_selection_click
    ///
    /// Recorded when there is a click on the inline selection component
    pub static inline_selection_click: Lazy<EventMetric<InlineSelectionClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inline_selection_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(529), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InlineSelectionImpressionExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for InlineSelectionImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.inline_selection_impression
    ///
    /// Recorded when there is an impression on the inline selection component
    pub static inline_selection_impression: Lazy<EventMetric<InlineSelectionImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inline_selection_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(530), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.locale
    ///
    /// The application's locale as of when newtab's TelemetryFeed was init. Comes from `Services.local.appLocaleAsBCP47`. Looks like `en-US`.
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "locale".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(531), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.metric_registered
    ///
    /// Records technical data about whether the metric registration at runtime succeeded
    pub static metric_registered: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "metric_registered".into(),
                    category: "newtab".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(532), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.newtab_category
    ///
    /// The current setting of the newtab page. One of ["enabled", "disabled", "extension"] or any value from SiteClassifier like "known-hijacker" or "social-media". Similar to Activity Stream's PAGE_TAKEOVER_DATA event's `newtab_url_category`. Sampled once after newtab init.
    pub static newtab_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "newtab_category".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(533), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#source: Option<String>,
        pub r#window_inner_height: Option<String>,
        pub r#window_inner_width: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "source", "window_inner_height", "window_inner_width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#window_inner_height.and_then(|val| map.insert("window_inner_height".into(), val.to_string()));
          self.r#window_inner_width.and_then(|val| map.insert("window_inner_width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.opened
    ///
    /// Recorded when newtab UI is opened via `about:newtab` or `about:home` or `about:welcome` and has been made visible (see `visibility_event_rcvd_ts` in [detect-user-session-start.js](https://searchfox.org/mozilla-central/source/browser/components/newtab/content-src/lib/detect-user-session-start.js)).
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(534), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.ping_registered
    ///
    /// Records technical data about whether the ping registration at runtime succeeded
    pub static ping_registered: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ping_registered".into(),
                    category: "newtab".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(535), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReportContentOpenExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for ReportContentOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.report_content_open
    ///
    /// Recorded when content reporting is opened from context menu
    pub static report_content_open: Lazy<EventMetric<ReportContentOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "report_content_open".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(536), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReportContentSubmitExtra {
        pub r#card_type: Option<String>,
        pub r#corpus_item_id: Option<String>,
        pub r#is_section_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#received_rank: Option<u32>,
        pub r#recommended_at: Option<u32>,
        pub r#report_reason: Option<String>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#title: Option<String>,
        pub r#topic: Option<String>,
        pub r#url: Option<String>,
    }

    impl ExtraKeys for ReportContentSubmitExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["card_type", "corpus_item_id", "is_section_followed", "newtab_visit_id", "received_rank", "recommended_at", "report_reason", "scheduled_corpus_item_id", "section", "section_position", "title", "topic", "url"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#card_type.and_then(|val| map.insert("card_type".into(), val.to_string()));
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#report_reason.and_then(|val| map.insert("report_reason".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#title.and_then(|val| map.insert("title".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          self.r#url.and_then(|val| map.insert("url".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.report_content_submit
    ///
    /// Recorded when content reporting has been submitted
    pub static report_content_submit: Lazy<EventMetric<ReportContentSubmitExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "report_content_submit".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(537), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsBlockSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsBlockSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.sections_block_section
    ///
    /// Recorded when a section is blocked
    pub static sections_block_section: Lazy<EventMetric<SectionsBlockSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_block_section".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(538), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsFollowSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsFollowSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.sections_follow_section
    ///
    /// Recorded when a section is followed
    pub static sections_follow_section: Lazy<EventMetric<SectionsFollowSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_follow_section".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(539), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsImpressionExtra {
        pub r#is_section_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_section_followed", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.sections_impression
    ///
    /// Recorded when a section is viewport and triggers an impression event
    pub static sections_impression: Lazy<EventMetric<SectionsImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(540), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsUnblockSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsUnblockSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.sections_unblock_section
    ///
    /// Recorded when a section is unblocked
    pub static sections_unblock_section: Lazy<EventMetric<SectionsUnblockSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_unblock_section".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(541), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsUnfollowSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsUnfollowSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.sections_unfollow_section
    ///
    /// Recorded when a section is unfollowed
    pub static sections_unfollow_section: Lazy<EventMetric<SectionsUnfollowSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_unfollow_section".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(542), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.selected_topics
    ///
    /// The list of topics the user selected
    pub static selected_topics: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_topics".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(543), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.sov_allocation
    ///
    /// The partner group assignment for sov
    pub static sov_allocation: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sov_allocation".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(544), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TooltipClickExtra {
        pub r#feature: Option<String>,
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TooltipClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["feature", "newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#feature.and_then(|val| map.insert("feature".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.tooltip_click
    ///
    /// Recorded when a feature highlight tooltip is opened.
    pub static tooltip_click: Lazy<EventMetric<TooltipClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tooltip_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(545), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionDismissExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TopicSelectionDismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_dismiss
    ///
    /// Recorded when the topic selection modal is dismissed (topics are not saved)
    pub static topic_selection_dismiss: Lazy<EventMetric<TopicSelectionDismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_dismiss".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(546), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionOpenExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for TopicSelectionOpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_open
    ///
    /// Recorded when the topic selection modal is opened
    pub static topic_selection_open: Lazy<EventMetric<TopicSelectionOpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_open".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(547), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicSelectionTopicsSavedExtra {
        pub r#first_save: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#previous_topics: Option<String>,
        pub r#topics: Option<String>,
    }

    impl ExtraKeys for TopicSelectionTopicsSavedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["first_save", "newtab_visit_id", "previous_topics", "topics"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#first_save.and_then(|val| map.insert("first_save".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#previous_topics.and_then(|val| map.insert("previous_topics".into(), val.to_string()));
          self.r#topics.and_then(|val| map.insert("topics".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.topic_selection_topics_saved
    ///
    /// Recorded when topics are saved from the topics selection modal
    pub static topic_selection_topics_saved: Lazy<EventMetric<TopicSelectionTopicsSavedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_selection_topics_saved".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(548), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperCategoryClickExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#selected_category: Option<String>,
    }

    impl ExtraKeys for WallpaperCategoryClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "selected_category"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#selected_category.and_then(|val| map.insert("selected_category".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_category_click
    ///
    /// Recorded when a user clicks a wallpaper category option
    pub static wallpaper_category_click: Lazy<EventMetric<WallpaperCategoryClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_category_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(549), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperClickExtra {
        pub r#had_previous_wallpaper: Option<bool>,
        pub r#had_uploaded_previously: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#selected_wallpaper: Option<String>,
    }

    impl ExtraKeys for WallpaperClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["had_previous_wallpaper", "had_uploaded_previously", "newtab_visit_id", "selected_wallpaper"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#had_previous_wallpaper.and_then(|val| map.insert("had_previous_wallpaper".into(), val.to_string()));
          self.r#had_uploaded_previously.and_then(|val| map.insert("had_uploaded_previously".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#selected_wallpaper.and_then(|val| map.insert("selected_wallpaper".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_click
    ///
    /// Recorded when a user clicks on a wallpaper option
    pub static wallpaper_click: Lazy<EventMetric<WallpaperClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(550), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperHighlightCtaClickExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightCtaClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_cta_click
    ///
    /// Recorded when a user clicks the CTA on the wallpaper feature highlight
    pub static wallpaper_highlight_cta_click: Lazy<EventMetric<WallpaperHighlightCtaClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_highlight_cta_click".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(551), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WallpaperHighlightDismissedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WallpaperHighlightDismissedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.wallpaper_highlight_dismissed
    ///
    /// Recorded when a user dismisses the wallpaper feature highlight
    pub static wallpaper_highlight_dismissed: Lazy<EventMetric<WallpaperHighlightDismissedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wallpaper_highlight_dismissed".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(552), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherChangeDisplayExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#weather_display_mode: Option<String>,
    }

    impl ExtraKeys for WeatherChangeDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "weather_display_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#weather_display_mode.and_then(|val| map.insert("weather_display_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_change_display
    ///
    /// Recorded when a user changes the weather display.
    pub static weather_change_display: Lazy<EventMetric<WeatherChangeDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_change_display".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(553), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_enabled
    ///
    /// Whether the weather widget is enabled on the newtab. Corresponds to the value of the `browser.newtabpage.activity-stream.showWeather` pref.
    pub static weather_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_enabled".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(554), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherImpressionExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_impression
    ///
    /// Recorded when the weather widget is viewed
    pub static weather_impression: Lazy<EventMetric<WeatherImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_impression".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(555), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherLoadErrorExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLoadErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_load_error
    ///
    /// Recorded when the weather widget is not available
    pub static weather_load_error: Lazy<EventMetric<WeatherLoadErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_load_error".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(556), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherLocationSelectedExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherLocationSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_location_selected
    ///
    /// Recorded when a user selects a location for weather widget
    pub static weather_location_selected: Lazy<EventMetric<WeatherLocationSelectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_location_selected".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(557), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct WeatherOpenProviderUrlExtra {
        pub r#newtab_visit_id: Option<String>,
    }

    impl ExtraKeys for WeatherOpenProviderUrlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.weather_open_provider_url
    ///
    /// Recorded when a user opens a link to the Weather provider website.
    pub static weather_open_provider_url: Lazy<EventMetric<WeatherOpenProviderUrlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "weather_open_provider_url".into(),
                category: "newtab".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(558), meta)
    });

}
pub mod newtab_handoff_preference {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.handoff_preference.enabled
    ///
    /// Records whether the browser.newtabpage.activity-stream.improvesearch.handoffToAwesomebar preference is enabled or disabled
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "newtab.handoff_preference".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(559), meta)
    });

}
pub mod newtab_search {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.enabled
    ///
    /// Whether the search input is enabled on the newtab. Corresponds to the value of the `browser.newtabpage.activity-stream.showSearch` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "newtab.search".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(560), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct IssuedExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for IssuedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.issued
    ///
    /// When Firefox was asked to issue a search from a Search Access Point (SAP) on a newtab page. Doesn't record searches in Private Browsing Mode unless `browser.engagement.search_counts.pbm` is set to `true`.
    pub static issued: Lazy<EventMetric<IssuedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "issued".into(),
                category: "newtab.search".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(561), meta)
    });

}
pub mod newtab_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type ActiveExperimentsObject = Vec<ActiveExperimentsObjectItem>;

    pub type ActiveExperimentsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.active_experiments
    ///
    /// slugs of actively enrolled experiments
    pub static active_experiments: Lazy<ObjectMetric<ActiveExperimentsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_experiments".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(562), meta)
    });

        pub type ActiveRolloutsObject = Vec<ActiveRolloutsObjectItem>;

    pub type ActiveRolloutsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.active_rollouts
    ///
    /// slugs of actively enrolled rollouts
    pub static active_rollouts: Lazy<ObjectMetric<ActiveRolloutsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_rollouts".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(563), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#matches_selected_topic: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "matches_selected_topic", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#matches_selected_topic.and_then(|val| map.insert("matches_selected_topic".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(564), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.coarse_os
    ///
    /// The name of the operating system. Possible values: Android, iOS, Linux, Windows, or macOS
    pub static coarse_os: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "coarse_os".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(565), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.coarse_os_version
    ///
    /// The user-visible version of the operating system (e.g. "1.2.3").
    /// If the version detection fails, this metric gets set to 0.
    pub static coarse_os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "coarse_os_version".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(566), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_section_followed", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.dismiss
    ///
    /// Recorded when a pocket tile is dismissed.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(567), meta)
    });

        pub type EnrollmentsMapObject = Vec<EnrollmentsMapObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct EnrollmentsMapObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub experimentSlug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branchSlug: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.enrollments_map
    ///
    /// Information about historic enrollments, including the branches enrolled.
    pub static enrollments_map: Lazy<ObjectMetric<EnrollmentsMapObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollments_map".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(568), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.followed_sections
    ///
    /// Optional metric: section ids followed by user in alphabetical order, if possible, ordered by most recently followed. Max 2 sections
    pub static followed_sections: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "followed_sections".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(569), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(570), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsBlockSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsBlockSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.sections_block_section
    ///
    /// Recorded when a section is blocked
    pub static sections_block_section: Lazy<EventMetric<SectionsBlockSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_block_section".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(571), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsFollowSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsFollowSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.sections_follow_section
    ///
    /// Recorded when a section is followed
    pub static sections_follow_section: Lazy<EventMetric<SectionsFollowSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_follow_section".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(572), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsImpressionExtra {
        pub r#is_section_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_section_followed", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.sections_impression
    ///
    /// Recorded when a section is viewport and triggers an impression event
    pub static sections_impression: Lazy<EventMetric<SectionsImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_impression".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(573), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsUnblockSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsUnblockSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.sections_unblock_section
    ///
    /// Recorded when a section is unblocked
    pub static sections_unblock_section: Lazy<EventMetric<SectionsUnblockSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_unblock_section".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(574), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SectionsUnfollowSectionExtra {
        pub r#event_source: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
    }

    impl ExtraKeys for SectionsUnfollowSectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["event_source", "newtab_visit_id", "section", "section_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#event_source.and_then(|val| map.insert("event_source".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.sections_unfollow_section
    ///
    /// Recorded when a section is unfollowed
    pub static sections_unfollow_section: Lazy<EventMetric<SectionsUnfollowSectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sections_unfollow_section".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(575), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.surface_id
    ///
    /// Surface id sent to the client from merino api
    pub static surface_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_id".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab".into(), "newtab-content".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(576), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThumbVotingInteractionExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#thumbs_down: Option<bool>,
        pub r#thumbs_up: Option<bool>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ThumbVotingInteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "is_list_card", "is_section_followed", "newtab_visit_id", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "thumbs_down", "thumbs_up", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#thumbs_down.and_then(|val| map.insert("thumbs_down".into(), val.to_string()));
          self.r#thumbs_up.and_then(|val| map.insert("thumbs_up".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.thumb_voting_interaction
    ///
    /// Recorded when a thumbs up/down on a tile is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static thumb_voting_interaction: Lazy<EventMetric<ThumbVotingInteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "thumb_voting_interaction".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(577), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_content.utc_offset
    ///
    /// <0-24> positive UTC offset, rounded to the nearest integer number greater than 0. (If less than 0, then add 24.)
    pub static utc_offset: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "utc_offset".into(),
                category: "newtab_content".into(),
                send_in_pings: vec!["newtab-content".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(578), meta)
    });

}
pub mod pocket {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#matches_selected_topic: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "matches_selected_topic", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#matches_selected_topic.and_then(|val| map.insert("matches_selected_topic".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.click
    ///
    /// Recorded when a pocket tile is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(579), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.dismiss
    ///
    /// Recorded when a pocket tile is dismissed.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(580), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.enabled
    ///
    /// Whether Pocket is enabled on the newtab. AKA the "Recommended by Pocket" section. Corresponds to the value of the `browser.newtabpage.activity-stream.feeds.section.topstories` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(581), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.fetch_timestamp
    ///
    /// Timestamp of when the spoc was fetched by the client
    pub static fetch_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fetch_timestamp".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(582), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.impression
    ///
    /// Recorded when a pocket tile is visible to the user.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(583), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.is_signed_in
    ///
    /// Whether the Firefox user is signed in to Pocket. Does not correspond to a pref, so its value is resampled at newtab's component init and whenever there is a Discovery Stream user event.
    pub static is_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_signed_in".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(584), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.newtab_creation_timestamp
    ///
    /// Timestamp of when this instance of the newtab was first visible to the user.
    pub static newtab_creation_timestamp: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "newtab_creation_timestamp".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(585), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#is_sponsored: Option<bool>,
        pub r#matches_selected_topic: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#selected_topics: Option<String>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "is_sponsored", "matches_selected_topic", "newtab_visit_id", "position", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "selected_topics", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#matches_selected_topic.and_then(|val| map.insert("matches_selected_topic".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#selected_topics.and_then(|val| map.insert("selected_topics".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.save
    ///
    /// Recorded when a user decides to save a pocket tile. Does not mean it ends up successfully saved. Just that the user clicked on "Save to Pocket" in the little pocket tile menu.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(586), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.shim
    ///
    /// Opaque partner identifier for a given ad impression or engagement action,
    /// unique per market and region.
    /// Pocket
    /// [proxies requests to ad partners](https://github.com/Pocket/proxy-server/)
    /// and provides them solely with market, region, and action to generate these
    /// shims. Thus, though the contents of this field are obscure, they cannot
    /// identify clients.
    /// At time of writing this information is a comma-separated trio.
    /// The first item is an index into the proxy server's list of acceptable http
    /// endpoints for contacting the ad service. The second item is a
    /// several-hundred-byte base64-encoded JSON-encoded struct with fields for,
    /// amongst other things, market and region. The third is unknown, but appears
    /// to be a signature or checksum.
    /// This shim should not be sent with the client_id.
    pub static shim: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shim".into(),
                category: "pocket".into(),
                send_in_pings: vec!["spoc".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(587), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.sponsored_stories_enabled
    ///
    /// Whether Pocket sponsored stories are enabled on the newtab. Corresponds to the value of the `browser.newtabpage.activity-stream.showSponsored` pref. Can be `true` even if pocket.enabled is `false`.
    pub static sponsored_stories_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_stories_enabled".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(588), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThumbVotingInteractionExtra {
        pub r#corpus_item_id: Option<String>,
        pub r#format: Option<String>,
        pub r#is_list_card: Option<bool>,
        pub r#is_section_followed: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#received_rank: Option<u32>,
        pub r#recommendation_id: Option<String>,
        pub r#recommended_at: Option<u32>,
        pub r#scheduled_corpus_item_id: Option<String>,
        pub r#section: Option<String>,
        pub r#section_position: Option<String>,
        pub r#thumbs_down: Option<bool>,
        pub r#thumbs_up: Option<bool>,
        pub r#tile_id: Option<u32>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for ThumbVotingInteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["corpus_item_id", "format", "is_list_card", "is_section_followed", "newtab_visit_id", "received_rank", "recommendation_id", "recommended_at", "scheduled_corpus_item_id", "section", "section_position", "thumbs_down", "thumbs_up", "tile_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#corpus_item_id.and_then(|val| map.insert("corpus_item_id".into(), val.to_string()));
          self.r#format.and_then(|val| map.insert("format".into(), val.to_string()));
          self.r#is_list_card.and_then(|val| map.insert("is_list_card".into(), val.to_string()));
          self.r#is_section_followed.and_then(|val| map.insert("is_section_followed".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#received_rank.and_then(|val| map.insert("received_rank".into(), val.to_string()));
          self.r#recommendation_id.and_then(|val| map.insert("recommendation_id".into(), val.to_string()));
          self.r#recommended_at.and_then(|val| map.insert("recommended_at".into(), val.to_string()));
          self.r#scheduled_corpus_item_id.and_then(|val| map.insert("scheduled_corpus_item_id".into(), val.to_string()));
          self.r#section.and_then(|val| map.insert("section".into(), val.to_string()));
          self.r#section_position.and_then(|val| map.insert("section_position".into(), val.to_string()));
          self.r#thumbs_down.and_then(|val| map.insert("thumbs_down".into(), val.to_string()));
          self.r#thumbs_up.and_then(|val| map.insert("thumbs_up".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.thumb_voting_interaction
    ///
    /// Recorded when a thumbs up/down on a tile is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static thumb_voting_interaction: Lazy<EventMetric<ThumbVotingInteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "thumb_voting_interaction".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(589), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TopicClickExtra {
        pub r#newtab_visit_id: Option<String>,
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for TopicClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newtab_visit_id", "topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pocket.topic_click
    ///
    /// Recorded when a pocket "Popular Topic" is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static topic_click: Lazy<EventMetric<TopicClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "topic_click".into(),
                category: "pocket".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(590), meta)
    });

}
pub mod top_sites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "advertiser".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(591), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(592), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or an interaction field. E.g. "topsites-impression", "topsites-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(593), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.position
    ///
    /// The position (1-based) of the topsites item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(594), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(595), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.source
    ///
    /// The source of the interaction. Always set to "newtab".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(596), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from top_sites.tile_id
    ///
    /// String-encoded number for the tile's sponsored tile id.
    pub static tile_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tile_id".into(),
                category: "top_sites".into(),
                send_in_pings: vec!["top-sites".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(597), meta)
    });

}
pub mod topsites {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.click
    ///
    /// Recorded when a topsite tile is clicked. Only happens on click. Not on middle-click. Not on "Open in new Tab"-like options in the context menu.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(598), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.dismiss
    ///
    /// Recorded when the "Dismiss" menu item in the three-dots menu of a topsite is clicked. Corresponds to the receipt of a dispatched `BLOCK_URL` action by `TelemetryFeed`. Applies to both sponsored and non-sponsored topsites. `advertiser_name` is only provided for sponsored topsites.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(599), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.enabled
    ///
    /// Whether "topsites" is enabled on the newtab. AKA the "Shortcuts" section. Corresponds to the value of the `browser.newtabpage.activity-stream.feeds.topsites` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(600), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#advertiser_name: Option<String>,
        pub r#is_sponsored: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "is_sponsored", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#is_sponsored.and_then(|val| map.insert("is_sponsored".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.impression
    ///
    /// Recorded when topsite tiles are loaded.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(601), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefChangedExtra {
        pub r#new_value: Option<bool>,
        pub r#pref_name: Option<String>,
    }

    impl ExtraKeys for PrefChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["new_value", "pref_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#new_value.and_then(|val| map.insert("new_value".into(), val.to_string()));
          self.r#pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.pref_changed
    ///
    /// Recorded when specific topsites prefs have changed.
    /// The list of possible prefs is presently:
    ///  * browser.newtabpage.activity-stream.feeds.topsites
    ///  * browser.newtabpage.activity-stream.showSponsoredTopSites
    pub static pref_changed: Lazy<EventMetric<PrefChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_changed".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(602), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.rows
    ///
    /// The number of topsite tile rows configured to be shown on the newtab page. Corresponds to the value of the `browser.newtabpage.activity-stream.topSitesRows` pref. This is not the number of rows actually seen by the user: if the browser window is partially off-screen, or isn't wide enough to accommodate eight tiles per row, the actual number of rows may be different.
    pub static rows: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rows".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(603), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowPrivacyClickExtra {
        pub r#advertiser_name: Option<String>,
        pub r#newtab_visit_id: Option<String>,
        pub r#position: Option<u32>,
        pub r#tile_id: Option<u32>,
    }

    impl ExtraKeys for ShowPrivacyClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["advertiser_name", "newtab_visit_id", "position", "tile_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#advertiser_name.and_then(|val| map.insert("advertiser_name".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          self.r#tile_id.and_then(|val| map.insert("tile_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from topsites.show_privacy_click
    ///
    /// Recorded when the "Our Sponsors and Your Privacy" menu item in the three- dots menu of a sponsored topsite is clicked. Corresponds to the receipt of a dispatched `ABOUT_SPONSORED_TOP_SITES` action by `TelemetryFeed`.
    pub static show_privacy_click: Lazy<EventMetric<ShowPrivacyClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_privacy_click".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(604), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_enabled
    ///
    /// Whether sponsored topsites are enabled on the newtab. AKA the "Sponsored Shortcuts" section. Corresponds to the value of the `browser.newtabpage.activity-stream.showSponsoredTopSites` pref. Can be `true` even if topsites.enabled is `false`.
    pub static sponsored_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_enabled".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(605), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_configured
    ///
    /// The number of topsite tiles configured to be shown on newtab.
    pub static sponsored_tiles_configured: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_tiles_configured".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(606), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from topsites.sponsored_tiles_received
    ///
    /// The stringified JSON of tiles processed for display (array of objects). Includes tiles not displayed and reason for not displaying. Fields included: advertiser, provider, display_position, display_fail_reason.
    pub static sponsored_tiles_received: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sponsored_tiles_received".into(),
                category: "topsites".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(607), meta)
    });

}
pub mod bookmarks_sidebar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from bookmarks_sidebar.cumulative_searches
    ///
    /// Cumulative no. bookmark of searches performed before selecting a link.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_BOOKMARKS_SEARCHBAR_CUMULATIVE_SEARCHES.
    pub static cumulative_searches: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cumulative_searches".into(),
                category: "bookmarks_sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(608), meta, 0, 20, 21, HistogramType::Linear)
    });

}
pub mod bookmarks_toolbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from bookmarks_toolbar.init
    ///
    /// Firefox: Time to initialize the bookmarks toolbar view (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_BOOKMARKS_TOOLBAR_INIT_MS.
    pub static init: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "init".into(),
                category: "bookmarks_toolbar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(609), meta, TimeUnit::Millisecond)
    });

}
pub mod history_sidebar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from history_sidebar.cumulative_filter_count
    ///
    /// Cumulative no. of search filters applied performed before selecting a link.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_SEARCHBAR_CUMULATIVE_FILTER_COUNT.
    pub static cumulative_filter_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cumulative_filter_count".into(),
                category: "history_sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(610), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from history_sidebar.cumulative_searches
    ///
    /// Cumulative no. of searches performed before selecting a link.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_SEARCHBAR_CUMULATIVE_SEARCHES.
    pub static cumulative_searches: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cumulative_searches".into(),
                category: "history_sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(611), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum FilterTypeLabel {
        EVisited = 0,
        ELastvisited = 1,
        EDayandsite = 2,
        ESite = 3,
        EDay = 4,
        __Other__,
    }
    impl From<u16> for FilterTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EVisited,
                1 => Self::ELastvisited,
                2 => Self::EDayandsite,
                3 => Self::ESite,
                4 => Self::EDay,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FilterTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EVisited => "visited",
                Self::ELastvisited => "lastvisited",
                Self::EDayandsite => "dayandsite",
                Self::ESite => "site",
                Self::EDay => "day",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from history_sidebar.filter_type
    ///
    /// The type of search filters used for the sidebar search.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram PLACES_SEARCHBAR_FILTER_TYPE.
    pub static filter_type: Lazy<LabeledMetric<LabeledCounterMetric, FilterTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "filter_type".into(),
                    category: "history_sidebar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(612), meta, Some(vec![::std::borrow::Cow::from("day"), ::std::borrow::Cow::from("dayandsite"), ::std::borrow::Cow::from("lastvisited"), ::std::borrow::Cow::from("site"), ::std::borrow::Cow::from("visited")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from history_sidebar.lastvisited_tree_query_time
    ///
    /// PLACES: Time to load the sidebar history tree sorted by last visit (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HISTORY_LASTVISITED_TREE_QUERY_TIME_MS.
    pub static lastvisited_tree_query_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "lastvisited_tree_query_time".into(),
                category: "history_sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(613), meta, TimeUnit::Millisecond)
    });

}
pub mod library {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from library.cumulative_bookmark_searches
    ///
    /// Cumulative no. of Bookmark-specific searches performed before selecting a bookmark link in Library.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_LIBRARY_CUMULATIVE_BOOKMARK_SEARCHES.
    pub static cumulative_bookmark_searches: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cumulative_bookmark_searches".into(),
                category: "library".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(614), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.cumulative_history_searches
    ///
    /// Cumulative no. of History-specific searches performed before selecting a History link in Library.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_LIBRARY_CUMULATIVE_HISTORY_SEARCHES.
    pub static cumulative_history_searches: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cumulative_history_searches".into(),
                category: "library".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(615), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.history_search_time
    ///
    /// PLACES: Time to search the history library (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_HISTORY_LIBRARY_SEARCH_TIME_MS.
    pub static history_search_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_search_time".into(),
                category: "library".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(616), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.link
    ///
    /// The number of history or bookmark items opened from the Library window This metric was generated to correspond to the Legacy Telemetry scalar library.link.
    pub static link: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "link".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(617), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.opened
    ///
    /// The number of times the Library window was opened, keyed by 'history' or 'bookmarks' This metric was generated to correspond to the Legacy Telemetry scalar library.opened.
    pub static opened: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "opened".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(618), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from library.search
    ///
    /// The number of history-specific or bookmark-specific searches made from the Library window This metric was generated to correspond to the Legacy Telemetry scalar library.search.
    pub static search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "search".into(),
                    category: "library".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(619), meta, None)
    });

}
pub mod pocket_button {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_action
    ///
    /// The action that was taken, like "click" or... actually, it might only ever be "click".
    pub static event_action: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_action".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(620), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_position
    ///
    /// 0-based index of the item on which the action was performed. Not always provided.
    pub static event_position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_position".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(621), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.event_source
    ///
    /// The source of the taken action, like "save_button", "home_button", "on_save_recs", or the like.
    pub static event_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_source".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(622), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.impression_id
    ///
    /// A UUID representing this profile. This isn't client_id, nor can it be used to link to a client_id. This also means it should never be sent in a ping with a client_id.
    pub static impression_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(623), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.model
    ///
    /// A string that identifies the ML model (if any) used to generate on-save recommendations. Like "doc2vec-incremental-best-article-pubspread".
    pub static model: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(624), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.pocket_logged_in_status
    ///
    /// Whether there was a logged-in Pocket account in the Pocket-Firefox integration at the point in time this action occurred.
    pub static pocket_logged_in_status: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pocket_logged_in_status".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(625), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pocket.button.profile_creation_date
    ///
    /// The days since Jan 1, 1970 that the oldest file in the profile dir was modified. Or created. Or just the day and time of the first thing to ask for the profile age called in. Or something earlier or later than that.
    /// You may not want to use this.
    pub static profile_creation_date: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_creation_date".into(),
                category: "pocket.button".into(),
                send_in_pings: vec!["pocket-button".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(626), meta)
    });

}
pub mod aboutpreferences {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowClickExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_click
    ///
    /// This is recorded when a pane is shown when user clicks category name inside about:preferences. This event was generated to correspond to the Legacy Telemetry event aboutpreferences.show#click.
    pub static show_click: Lazy<EventMetric<ShowClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_click".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(627), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowHashExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowHashExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_hash
    ///
    /// This is recorded when a pane is shown via a hash change in url. This event was generated to correspond to the Legacy Telemetry event aboutpreferences.show#hash.
    pub static show_hash: Lazy<EventMetric<ShowHashExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_hash".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(628), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowInitialExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowInitialExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from aboutpreferences.show_initial
    ///
    /// This is recorded when a pane is shown direclty. This happens with or without a hash in the URL. The "general" pane loads without such a hash, when the pane is loaded via the "main" entrypoints in the menu system or with shortcuts. This event was generated to correspond to the Legacy Telemetry event aboutpreferences.show#initial.
    pub static show_initial: Lazy<EventMetric<ShowInitialExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_initial".into(),
                category: "aboutpreferences".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(629), meta)
    });

}
pub mod intl_ui_browser_language {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AcceptDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AcceptDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.accept_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.accept#dialog.
    pub static accept_dialog: Lazy<EventMetric<AcceptDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accept_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(630), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddDialogExtra {
        pub r#installId: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["installId", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#installId.and_then(|val| map.insert("installId".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.add_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.add#dialog.
    pub static add_dialog: Lazy<EventMetric<AddDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(631), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.apply_main
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.apply#main.
    pub static apply_main: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "apply_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(632), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.cancel_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.cancel#dialog.
    pub static cancel_dialog: Lazy<EventMetric<CancelDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(633), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageMainExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ManageMainExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.manage_main
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.manage#main.
    pub static manage_main: Lazy<EventMetric<ManageMainExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(634), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RemoveDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RemoveDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.remove_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.remove#dialog.
    pub static remove_dialog: Lazy<EventMetric<RemoveDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remove_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(635), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReorderDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReorderDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.reorder_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.reorder#dialog.
    pub static reorder_dialog: Lazy<EventMetric<ReorderDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reorder_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(636), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.reorder_main
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.reorder#main.
    pub static reorder_main: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reorder_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(637), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SearchDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.search_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.search#dialog.
    pub static search_dialog: Lazy<EventMetric<SearchDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(638), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchMainExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SearchMainExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.search_main
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.search#main.
    pub static search_main: Lazy<EventMetric<SearchMainExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_main".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(639), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SetFallbackDialogExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SetFallbackDialogExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from intl.ui.browser_language.set_fallback_dialog
    ///
    /// User interactions for the browser language within about-preferences in the main pane and in the browser language dialog. Each dialog event (on the dialog object, and the manage and search methods of the main object) has a value which is a monotonically increasing number that links it with other events related to the same dialog instance. This event was generated to correspond to the Legacy Telemetry event intl.ui.browserLanguage.set_fallback#dialog.
    pub static set_fallback_dialog: Lazy<EventMetric<SetFallbackDialogExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "set_fallback_dialog".into(),
                category: "intl.ui.browser_language".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(640), meta)
    });

}
pub mod network_proxy_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProxyTypePreferenceExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ProxyTypePreferenceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.proxy.settings.proxy_type_preference
    ///
    /// This metric tracks what proxy types users are choosing in the Network Settings dialog at the bottom of about:preferences#general. It gets recorded when pressing OK in the dialog box.
    pub static proxy_type_preference: Lazy<EventMetric<ProxyTypePreferenceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "proxy_type_preference".into(),
                category: "network.proxy.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(641), meta)
    });

}
pub mod privacy_ui_fpp_click {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CheckboxExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for CheckboxExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.checkbox
    ///
    /// User interaction by click events on fingerprinting protection checkbox in the ETP Custom subpanel.
    pub static checkbox: Lazy<EventMetric<CheckboxExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "checkbox".into(),
                category: "privacy.ui.fpp.click".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(642), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MenuExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for MenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from privacy.ui.fpp.click.menu
    ///
    /// User interaction by click events on fingerprinting protection menulist in the ETP Custom subpanel.
    pub static menu: Lazy<EventMetric<MenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "menu".into(),
                category: "privacy.ui.fpp.click".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(643), meta)
    });

}
pub mod security_doh_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModeChangedButtonExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ModeChangedButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.settings.mode_changed_button
    ///
    /// User changed the TRR mode in about:preferences#privacy settings Value is id of the clicked button. This event was generated to correspond to the Legacy Telemetry event security.doh.settings.mode_changed#button.
    pub static mode_changed_button: Lazy<EventMetric<ModeChangedButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mode_changed_button".into(),
                category: "security.doh.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(644), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ProviderChoiceValueExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ProviderChoiceValueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.settings.provider_choice_value
    ///
    /// User changed their DoH provider. Recorded value is URL of one of the existing providers or "custom". This event was generated to correspond to the Legacy Telemetry event security.doh.settings.provider_choice#value.
    pub static provider_choice_value: Lazy<EventMetric<ProviderChoiceValueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_choice_value".into(),
                category: "security.doh.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(645), meta)
    });

}
pub mod aboutprivatebrowsing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_dismiss_button
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This event was generated to correspond to the Legacy Telemetry event aboutprivatebrowsing.click#dismiss_button.
    pub static click_dismiss_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_dismiss_button".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(646), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_info_link
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This event was generated to correspond to the Legacy Telemetry event aboutprivatebrowsing.click#info_link.
    pub static click_info_link: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_info_link".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(647), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from aboutprivatebrowsing.click_promo_link
    ///
    /// This is recorded when a user clicks a link on the private browsing newtab. This event was generated to correspond to the Legacy Telemetry event aboutprivatebrowsing.click#promo_link.
    pub static click_promo_link: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_promo_link".into(),
                category: "aboutprivatebrowsing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(648), meta)
    });

}
pub mod private_browsing_reset_pbm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConfirmPanelExtra {
        pub r#action: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ConfirmPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.confirm_panel
    ///
    /// Confirm panel show / hide event.
    pub static confirm_panel: Lazy<EventMetric<ConfirmPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "confirm_panel".into(),
                category: "private_browsing.reset_pbm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(649), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResetActionExtra {
        pub r#did_confirm: Option<bool>,
    }

    impl ExtraKeys for ResetActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_confirm"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_confirm.and_then(|val| map.insert("did_confirm".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from private_browsing.reset_pbm.reset_action
    ///
    /// Dispatched whenever PBM is restarted / reset via the resetPBM feature.
    pub static reset_action: Lazy<EventMetric<ResetActionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reset_action".into(),
                category: "private_browsing.reset_pbm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(650), meta)
    });

}
pub mod profiles_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from profiles.default.updated
    ///
    /// Recorded when a new profile from a profile group becomes the default startup profile for the group. This may happen when a profile other than the current default is launched from the profile selector window, or when the user has multiple profiles running at the same time and switches app focus to a profile other than the current default. An event is not recorded if the current default profile is launched or gains app focus.
    pub static updated: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "updated".into(),
                category: "profiles.default".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(651), meta)
    });

}
pub mod profiles_delete {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from profiles.delete.cancel
    ///
    /// Recorded when the user clicks the "Cancel" button on the about:deleteprofile page, canceling deletion of the current profile and closing the page.
    pub static cancel: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel".into(),
                category: "profiles.delete".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(652), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.delete.confirm
    ///
    /// Recorded when the user clicks the "Delete" button on the about:deleteprofile page, triggering deletion of the current profile.
    pub static confirm: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "confirm".into(),
                category: "profiles.delete".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(653), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.delete.displayed
    ///
    /// Recorded when the about:deleteprofile page is loaded.
    pub static displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "displayed".into(),
                category: "profiles.delete".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(654), meta)
    });

}
pub mod profiles_existing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlertExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AlertExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.alert
    ///
    /// Recorded when the user tries to close the about:editprofile page without setting a name. A beforeunload alert is then displayed. We record the user's decision to stay on the page or leave in the `extra` value.
    pub static alert: Lazy<EventMetric<AlertExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "alert".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(655), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AvatarExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AvatarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.avatar
    ///
    /// Recorded when the user selects a different avatar.
    pub static avatar: Lazy<EventMetric<AvatarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avatar".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(656), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClosedExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.closed
    ///
    /// Recorded when the page is closed.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(657), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.deleted
    ///
    /// Recorded when the user clicks the delete button.
    pub static deleted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deleted".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(658), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.displayed
    ///
    /// Recorded when the page is loaded.
    pub static displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "displayed".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(659), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.learn_more
    ///
    /// Recorded when the "explore more addons" link is clicked.
    pub static learn_more: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(660), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.name
    ///
    /// Recorded when the name is changed. This event is fired either after the user has stopped typing in the name input field for 2 seconds, or if they have edited the name, then quickly closed the tab.
    pub static name: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "name".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(661), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThemeExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.existing.theme
    ///
    /// Recorded when the user selects a different theme.
    pub static theme: Lazy<EventMetric<ThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "theme".into(),
                category: "profiles.existing".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(662), meta)
    });

}
pub mod profiles_new {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlertExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AlertExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.alert
    ///
    /// Recorded when the user tries to close the about:newprofile page without setting a name. A beforeunload alert is then displayed. We record the user's decision to stay on the page or leave in the `extra` value.
    pub static alert: Lazy<EventMetric<AlertExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "alert".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(663), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AvatarExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AvatarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.avatar
    ///
    /// Recorded when the user selects a different avatar.
    pub static avatar: Lazy<EventMetric<AvatarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avatar".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(664), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClosedExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.closed
    ///
    /// Recorded when the page is closed.
    pub static closed: Lazy<EventMetric<ClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(665), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.deleted
    ///
    /// Recorded when the user clicks the delete button.
    pub static deleted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deleted".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(666), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.displayed
    ///
    /// Recorded when the page is loaded.
    pub static displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "displayed".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(667), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.learn_more
    ///
    /// Recorded when the "explore more addons" link is clicked.
    pub static learn_more: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(668), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.name
    ///
    /// Recorded when the name is changed. This event is fired either after the user has stopped typing in the name input field for 2 seconds, or if they have edited the name, then quickly closed the tab.
    pub static name: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "name".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(669), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThemeExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.new.theme
    ///
    /// Recorded when the user selects a different theme.
    pub static theme: Lazy<EventMetric<ThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "theme".into(),
                category: "profiles.new".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(670), meta)
    });

}
pub mod profiles_selector_window {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from profiles.selector_window.launch
    ///
    /// Recorded when the user clicks a profile card in the profile selector window, launching the profile in a new Firefox instance.
    pub static launch: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch".into(),
                category: "profiles.selector_window".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(671), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowAtStartupExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowAtStartupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from profiles.selector_window.show_at_startup
    ///
    /// Recorded when the user toggles the checkbox that determines if the profile selector window is shown at startup.
    pub static show_at_startup: Lazy<EventMetric<ShowAtStartupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_at_startup".into(),
                category: "profiles.selector_window".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(672), meta)
    });

}
pub mod security_ui_protections {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_about_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#lw_about_link.
    pub static click_lw_about_link: Lazy<EventMetric<ClickLwAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(673), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwOpenButtonExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwOpenButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_open_button
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#lw_open_button.
    pub static click_lw_open_button: Lazy<EventMetric<ClickLwOpenButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_open_button".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(674), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLwSyncLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLwSyncLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_lw_sync_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#lw_sync_link.
    pub static click_lw_sync_link: Lazy<EventMetric<ClickLwSyncLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_lw_sync_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(675), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMobileAppLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMobileAppLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mobile_app_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#mobile_app_link.
    pub static click_mobile_app_link: Lazy<EventMetric<ClickMobileAppLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mobile_app_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(676), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_about_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#mtr_about_link.
    pub static click_mtr_about_link: Lazy<EventMetric<ClickMtrAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(677), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrReportLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrReportLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_report_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#mtr_report_link.
    pub static click_mtr_report_link: Lazy<EventMetric<ClickMtrReportLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_report_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(678), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMtrSignupButtonExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickMtrSignupButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_mtr_signup_button
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#mtr_signup_button.
    pub static click_mtr_signup_button: Lazy<EventMetric<ClickMtrSignupButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_mtr_signup_button".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(679), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSettingsLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSettingsLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_settings_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#settings_link.
    pub static click_settings_link: Lazy<EventMetric<ClickSettingsLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(680), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickTrackersAboutLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickTrackersAboutLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_trackers_about_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#trackers_about_link.
    pub static click_trackers_about_link: Lazy<EventMetric<ClickTrackersAboutLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_trackers_about_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(681), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnAppLinkAndroidExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnAppLinkAndroidExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_app_link_android
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#vpn_app_link_android.
    pub static click_vpn_app_link_android: Lazy<EventMetric<ClickVpnAppLinkAndroidExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_app_link_android".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(682), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnAppLinkIosExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnAppLinkIosExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_app_link_ios
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#vpn_app_link_ios.
    pub static click_vpn_app_link_ios: Lazy<EventMetric<ClickVpnAppLinkIosExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_app_link_ios".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(683), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnBannerCloseExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnBannerCloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_banner_close
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#vpn_banner_close.
    pub static click_vpn_banner_close: Lazy<EventMetric<ClickVpnBannerCloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_banner_close".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(684), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnBannerLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnBannerLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_banner_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#vpn_banner_link.
    pub static click_vpn_banner_link: Lazy<EventMetric<ClickVpnBannerLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_banner_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(685), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCardLinkExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickVpnCardLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.click_vpn_card_link
    ///
    /// User interaction by click events on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.click#vpn_card_link.
    pub static click_vpn_card_link: Lazy<EventMetric<ClickVpnCardLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_card_link".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(686), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseProtectionReportExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CloseProtectionReportExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.close_protection_report
    ///
    /// User closed on the protection report. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.close#protection_report.
    pub static close_protection_report: Lazy<EventMetric<CloseProtectionReportExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_protection_report".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(687), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowProtectionReportExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowProtectionReportExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.show_protection_report
    ///
    /// User arrived on the protection report. This also includes a 'value' attribute which defaults to 'direct' or will be the value that a referring website addds to the url. This also indicates if the vpn banner has been seen. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.show#protection_report.
    pub static show_protection_report: Lazy<EventMetric<ShowProtectionReportExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_protection_report".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(688), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowVpnBannerExtra {
        pub r#category: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowVpnBannerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.protections.show_vpn_banner
    ///
    /// User arrived on the protection report. This also includes a 'value' attribute which defaults to 'direct' or will be the value that a referring website addds to the url. This also indicates if the vpn banner has been seen. This event was generated to correspond to the Legacy Telemetry event security.ui.protections.show#vpn_banner.
    pub static show_vpn_banner: Lazy<EventMetric<ShowVpnBannerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_vpn_banner".into(),
                category: "security.ui.protections".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(689), meta)
    });

}
pub mod protocolhandler_mailto {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum HandlerPromptShownLabel {
        EOsDefault = 0,
        EFxDefault = 1,
        __Other__,
    }
    impl From<u16> for HandlerPromptShownLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOsDefault,
                1 => Self::EFxDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HandlerPromptShownLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOsDefault => "os_default",
                Self::EFxDefault => "fx_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.handler_prompt_shown
    ///
    /// A website was visited, which called registerProtocolHandler for mailto://
    pub static handler_prompt_shown: Lazy<LabeledMetric<LabeledCounterMetric, HandlerPromptShownLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "handler_prompt_shown".into(),
                    category: "protocolhandler.mailto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(690), meta, Some(vec![::std::borrow::Cow::from("fx_default"), ::std::borrow::Cow::from("os_default")]))
    });

    #[repr(u16)]
    pub enum PromptClickedLabel {
        ESetOsDefault = 0,
        ESetOsDefaultError = 1,
        ESetOsDefaultImpossible = 2,
        EDismissOsDefault = 3,
        ESetLocalDefault = 4,
        EDismissLocalDefault = 5,
        __Other__,
    }
    impl From<u16> for PromptClickedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESetOsDefault,
                1 => Self::ESetOsDefaultError,
                2 => Self::ESetOsDefaultImpossible,
                3 => Self::EDismissOsDefault,
                4 => Self::ESetLocalDefault,
                5 => Self::EDismissLocalDefault,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PromptClickedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESetOsDefault => "set_os_default",
                Self::ESetOsDefaultError => "set_os_default_error",
                Self::ESetOsDefaultImpossible => "set_os_default_impossible",
                Self::EDismissOsDefault => "dismiss_os_default",
                Self::ESetLocalDefault => "set_local_default",
                Self::EDismissLocalDefault => "dismiss_local_default",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.prompt_clicked
    ///
    /// User clicked on a button to approve setting the current site as default web mail site. The sum of all counters is the total amount of user interactions and dismissing the same dialog often could be a sign of a bug.
    pub static prompt_clicked: Lazy<LabeledMetric<LabeledCounterMetric, PromptClickedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "prompt_clicked".into(),
                    category: "protocolhandler.mailto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(691), meta, Some(vec![::std::borrow::Cow::from("dismiss_local_default"), ::std::borrow::Cow::from("dismiss_os_default"), ::std::borrow::Cow::from("set_local_default"), ::std::borrow::Cow::from("set_os_default"), ::std::borrow::Cow::from("set_os_default_error"), ::std::borrow::Cow::from("set_os_default_impossible")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct VisitExtra {
        pub r#triggered_externally: Option<bool>,
    }

    impl ExtraKeys for VisitExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["triggered_externally"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#triggered_externally.and_then(|val| map.insert("triggered_externally".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from protocolhandler.mailto.visit
    ///
    /// a URI of type mailto was visited. Furthermore we want to know if from within the browser.
    pub static visit: Lazy<EventMetric<VisitExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "visit".into(),
                category: "protocolhandler.mailto".into(),
                send_in_pings: vec!["events".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(692), meta)
    });

}
pub mod screenshots {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_context_menu
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#context_menu.
    pub static canceled_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_context_menu".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(693), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_escape
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#escape.
    pub static canceled_escape: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_escape".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(694), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_navigation
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#navigation.
    pub static canceled_navigation: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_navigation".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(695), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_overlay_cancel
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#overlay_cancel.
    pub static canceled_overlay_cancel: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_overlay_cancel".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(696), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_preview_cancel
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#preview_cancel.
    pub static canceled_preview_cancel: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_preview_cancel".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(697), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_quick_actions
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#quick_actions.
    pub static canceled_quick_actions: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_quick_actions".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(698), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_shortcut
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#shortcut.
    pub static canceled_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_shortcut".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(699), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.canceled_toolbar_button
    ///
    /// Recorded when a user closes the screenshots ui. The screenshots ui is closed after copying/downloading but we do not record that as canceling the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.canceled#toolbar_button.
    pub static canceled_toolbar_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canceled_toolbar_button".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(700), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyOverlayCopyExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for CopyOverlayCopyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.copy_overlay_copy
    ///
    /// Recorded when a user copies a screenshot from the overlay or the preview. This event was generated to correspond to the Legacy Telemetry event screenshots.copy#overlay_copy.
    pub static copy_overlay_copy: Lazy<EventMetric<CopyOverlayCopyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_overlay_copy".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(701), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyPreviewCopyExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for CopyPreviewCopyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.copy_preview_copy
    ///
    /// Recorded when a user copies a screenshot from the overlay or the preview. This event was generated to correspond to the Legacy Telemetry event screenshots.copy#preview_copy.
    pub static copy_preview_copy: Lazy<EventMetric<CopyPreviewCopyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_preview_copy".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(702), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DownloadOverlayDownloadExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for DownloadOverlayDownloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.download_overlay_download
    ///
    /// Recorded when a user downloads a screenshot from the overlay or the preview. This event was generated to correspond to the Legacy Telemetry event screenshots.download#overlay_download.
    pub static download_overlay_download: Lazy<EventMetric<DownloadOverlayDownloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_overlay_download".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(703), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DownloadPreviewDownloadExtra {
        pub r#element: Option<String>,
        pub r#fullpage: Option<String>,
        pub r#move: Option<String>,
        pub r#region: Option<String>,
        pub r#resize: Option<String>,
        pub r#visible: Option<String>,
    }

    impl ExtraKeys for DownloadPreviewDownloadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["element", "fullpage", "move", "region", "resize", "visible"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#element.and_then(|val| map.insert("element".into(), val.to_string()));
          self.r#fullpage.and_then(|val| map.insert("fullpage".into(), val.to_string()));
          self.r#move.and_then(|val| map.insert("move".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#resize.and_then(|val| map.insert("resize".into(), val.to_string()));
          self.r#visible.and_then(|val| map.insert("visible".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from screenshots.download_preview_download
    ///
    /// Recorded when a user downloads a screenshot from the overlay or the preview. This event was generated to correspond to the Legacy Telemetry event screenshots.download#preview_download.
    pub static download_preview_download: Lazy<EventMetric<DownloadPreviewDownloadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_preview_download".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(704), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.failed_screenshot_too_large
    ///
    /// Recorded when a screenshot is too big to capture and we have to crop the screenshot. This event was generated to correspond to the Legacy Telemetry event screenshots.failed#screenshot_too_large.
    pub static failed_screenshot_too_large: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failed_screenshot_too_large".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(705), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_element
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the save visible, or selects save full page. Note that this is recorded independent of whether or not the screenshot is saved. This event was generated to correspond to the Legacy Telemetry event screenshots.selected#element.
    pub static selected_element: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_element".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(706), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_full_page
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the save visible, or selects save full page. Note that this is recorded independent of whether or not the screenshot is saved. This event was generated to correspond to the Legacy Telemetry event screenshots.selected#full_page.
    pub static selected_full_page: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_full_page".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(707), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_region_selection
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the save visible, or selects save full page. Note that this is recorded independent of whether or not the screenshot is saved. This event was generated to correspond to the Legacy Telemetry event screenshots.selected#region_selection.
    pub static selected_region_selection: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_region_selection".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(708), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.selected_visible
    ///
    /// Recorded when a user selects a region by hand, selects an element, selects the save visible, or selects save full page. Note that this is recorded independent of whether or not the screenshot is saved. This event was generated to correspond to the Legacy Telemetry event screenshots.selected#visible.
    pub static selected_visible: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "selected_visible".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(709), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_context_menu
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#context_menu.
    pub static started_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_context_menu".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(710), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_overlay_retry
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#overlay_retry.
    pub static started_overlay_retry: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_overlay_retry".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(711), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_preview_retry
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#preview_retry.
    pub static started_preview_retry: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_preview_retry".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(712), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_quick_actions
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#quick_actions.
    pub static started_quick_actions: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_quick_actions".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(713), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_shortcut
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#shortcut.
    pub static started_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_shortcut".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(714), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenshots.started_toolbar_button
    ///
    /// Recorded when a user opens the screenshots ui. This event was generated to correspond to the Legacy Telemetry event screenshots.started#toolbar_button.
    pub static started_toolbar_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "started_toolbar_button".into(),
                category: "screenshots".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(715), meta)
    });

}
pub mod browser_engagement_navigation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.about_home
    ///
    /// The count URI loads triggered in a subsession from about:home, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(716), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.about_newtab
    ///
    /// The count URI loads triggered in a subsession from about:newtab, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(717), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.contextmenu
    ///
    /// The count URI loads triggered in a subsession from the contextmenu, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(718), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.searchbar
    ///
    /// The count URI loads triggered in a subsession from the searchbar, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(719), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar
    ///
    /// The count URI loads triggered in a subsession from the urlbar, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(720), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(721), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_persisted
    ///
    /// The count of URI loads triggered in a subsession from the urlbar after the search term was shown in the urlbar, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(722), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.urlbar_searchmode
    ///
    /// The count URI loads triggered in a subsession from the urlbar's search mode, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(723), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.engagement.navigation.webextension
    ///
    /// The count URI loads triggered in a subsession from a webextension. This metric was generated to correspond to the Legacy Telemetry scalar browser.engagement.navigation.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.engagement.navigation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(724), meta, None)
    });

}
pub mod browser_search_adclicks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.about_home
    ///
    /// Records clicks of adverts on SERP pages where the search was started from about:home. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source- docs.mozilla.org/browser/search/telemetry.html#browser-search- content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(725), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.about_newtab
    ///
    /// Records clicks of adverts on SERP pages where the search was started from about:newtab. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(726), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.contextmenu
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the context menu. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(727), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.reload
    ///
    /// Records clicks of adverts on SERP pages where the search was loaded by reloading the page. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(728), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.searchbar
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the search bar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(729), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.system
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the system, e.g. command line. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(730), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.tabhistory
    ///
    /// Records clicks of adverts on SERP pages where the search was loaded from the tab history. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(731), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.unknown
    ///
    /// Records clicks of adverts on SERP pages where the search was started from a place not categorized by the other scalars. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(732), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source- docs.mozilla.org/browser/search/telemetry.html#browser-search- content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(733), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(734), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_persisted
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the urlbar after the search term was shown in the urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(735), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.urlbar_searchmode
    ///
    /// Records clicks of adverts on SERP pages where the search was started from the urlbar in search mode. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(736), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.adclicks.webextension
    ///
    /// Records clicks of adverts on SERP pages where the search was started from a webextension. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.adclicks.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.adclicks".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(737), meta, None)
    });

}
pub mod browser_search_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.about_home
    ///
    /// Records counts for in-content searches where the search was most likely started from the about:home. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(738), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.about_newtab
    ///
    /// Records counts for in-content searches where the search was most likely started from the about:newtab. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(739), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.contextmenu
    ///
    /// Records counts for in-content searches where the search was most likely started from the context menu. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(740), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.reload
    ///
    /// Records counts for in-content searches where the search was loaded by reloading the page. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(741), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.searchbar
    ///
    /// Records counts for in-content searches where the search was most likely started from the search bar. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(742), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.system
    ///
    /// Records counts for in-content searches where the search was most likely started from the system, e.g. command line. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(743), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.tabhistory
    ///
    /// Records counts for in-content searches where the search was loaded from the tab history. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(744), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.unknown
    ///
    /// Records counts for in-content searches where the search was started from a place that could not be determined or not categorized by the other scalars. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(745), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar
    ///
    /// Records counts for in-content searches where the search was most likely started from the urlbar. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(746), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(747), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_persisted
    ///
    /// Records counts for in-content searches where the search was most likely started from the urlbar after the search term was shown in the urlbar. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(748), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.urlbar_searchmode
    ///
    /// Records counts for in-content searches where the search was most likely started from the urlbar in search mode. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(749), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.content.webextension
    ///
    /// Records counts for in-content searches where the search was most likely started from a webextension. The key format is <provider>:[tagged|tagged-follow-on|organic]:[code|other|none] See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.content.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(750), meta, None)
    });

}
pub mod browser_search_withads {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.about_home
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from about:home. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.about_home.
    pub static about_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_home".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(751), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.about_newtab
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from about:newtab. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.about_newtab.
    pub static about_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "about_newtab".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(752), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.contextmenu
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the context menu. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.contextmenu.
    pub static contextmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "contextmenu".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(753), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.reload
    ///
    /// Records counts of SERP pages with adverts displayed where the search was loaded by reloading the page. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.reload.
    pub static reload: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reload".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(754), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.searchbar
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the search bar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.searchbar.
    pub static searchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbar".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(755), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.system
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the system, e.g. command line. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.system.
    pub static system: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(756), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.tabhistory
    ///
    /// Records counts of SERP pages with adverts displayed where the search was loaded from the tab history. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.tabhistory.
    pub static tabhistory: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabhistory".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(757), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.unknown
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from a place not categorized by the other scalars. The key format is ‘<provider>:<tagged|organic>’ See https://firefox- source-docs.mozilla.org/browser/search/telemetry.html#browser- search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.unknown.
    pub static unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unknown".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(758), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.urlbar.
    pub static urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(759), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_handoff
    ///
    /// The count URI loads triggered in a subsession from the urlbar via handoff, broken down by the originating action. This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.urlbar_handoff.
    pub static urlbar_handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_handoff".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(760), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_persisted
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the urlbar after the search term was shown in the urlbar. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.urlbar_persisted.
    pub static urlbar_persisted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_persisted".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(761), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.urlbar_searchmode
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from the urlbar in search mode. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source-docs.mozilla.org/browser/search/telemetry.html#browser-search-content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.urlbar_searchmode.
    pub static urlbar_searchmode: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "urlbar_searchmode".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(762), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.search.withads.webextension
    ///
    /// Records counts of SERP pages with adverts displayed where the search was started from a webextension. The key format is ‘<provider>:<tagged|organic>’ See https://firefox-source- docs.mozilla.org/browser/search/telemetry.html#browser-search- content This metric was generated to correspond to the Legacy Telemetry scalar browser.search.withads.webextension.
    pub static webextension: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webextension".into(),
                    category: "browser.search.withads".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(763), meta, None)
    });

}
pub mod newtab_search_ad {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExtra {
        pub r#is_follow_on: Option<bool>,
        pub r#is_tagged: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for ClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.r#is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.click
    ///
    /// Recorded when an ad link is clicked on a Search Engine Result Page (SERP) which was loaded by a seach that began on a newtab page.
    pub static click: Lazy<EventMetric<ClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click".into(),
                category: "newtab.search.ad".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(764), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#is_follow_on: Option<bool>,
        pub r#is_tagged: Option<bool>,
        pub r#newtab_visit_id: Option<String>,
        pub r#search_access_point: Option<String>,
        pub r#telemetry_id: Option<String>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["is_follow_on", "is_tagged", "newtab_visit_id", "search_access_point", "telemetry_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#is_follow_on.and_then(|val| map.insert("is_follow_on".into(), val.to_string()));
          self.r#is_tagged.and_then(|val| map.insert("is_tagged".into(), val.to_string()));
          self.r#newtab_visit_id.and_then(|val| map.insert("newtab_visit_id".into(), val.to_string()));
          self.r#search_access_point.and_then(|val| map.insert("search_access_point".into(), val.to_string()));
          self.r#telemetry_id.and_then(|val| map.insert("telemetry_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from newtab.search.ad.impression
    ///
    /// Recorded when a newtab visit resulted in a search that loaded a Search Engine Result Page (SERP) that contains an ad link. And the SERP is visible.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "newtab.search.ad".into(),
                send_in_pings: vec!["newtab".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(765), meta)
    });

}
pub mod sap {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CountsExtra {
        pub r#overridden_by_third_party: Option<bool>,
        pub r#partner_code: Option<String>,
        pub r#provider_id: Option<String>,
        pub r#provider_name: Option<String>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for CountsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["overridden_by_third_party", "partner_code", "provider_id", "provider_name", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#overridden_by_third_party.and_then(|val| map.insert("overridden_by_third_party".into(), val.to_string()));
          self.r#partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.r#provider_id.and_then(|val| map.insert("provider_id".into(), val.to_string()));
          self.r#provider_name.and_then(|val| map.insert("provider_name".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sap.counts
    ///
    /// Recorded search counts when a user initiates a search from a search access point (SAP). It does not guarantee that the search engine result page was loaded successfully (use SERP telemetry).
    pub static counts: Lazy<EventMetric<CountsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "counts".into(),
                category: "sap".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(766), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sap.deprecated_counts
    ///
    /// This is deprecated metric that should not be incoporated into dashboards. Use the `sap.counts` event instead.
    /// This metric has been added to Glean to aid transition of histograms and allow the legacy telemetry SEARCH_COUNTS to continue to be recorded.
    /// Records search counts for search access points. The format is: <engine-name>.<search-access-point>. For the urlbar when in search mode, the format is <engine name>.urlbar-searchmode. For the urlbar when an internal @engine shortcut is used, the format is: <engine-name>.alias.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SEARCH_COUNTS.
    pub static deprecated_counts: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "deprecated_counts".into(),
                    category: "sap".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(767), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SearchFormCountsExtra {
        pub r#provider_id: Option<String>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for SearchFormCountsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["provider_id", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#provider_id.and_then(|val| map.insert("provider_id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sap.search_form_counts
    ///
    /// Records how often users visit the homepages of search engines (also known as SearchForm) using a SAP. It only counts how many visits were initiated, not how many homepages were loaded successfully.
    pub static search_form_counts: Lazy<EventMetric<SearchFormCountsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "search_form_counts".into(),
                category: "sap".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(768), meta)
    });

}
pub mod search_with {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from search_with.context_id
    ///
    /// An identifier for Contextual Services user interaction pings. This is used internally for counting unique users as well as for anti-fraud. It is shared with other Contextual Services. It is not shared externally.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "search_with".into(),
                send_in_pings: vec!["search-with".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(769), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search_with.reporting_url
    ///
    /// The external url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "search_with".into(),
                send_in_pings: vec!["search-with".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(770), meta)
    });

}
pub mod searchbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum SelectedResultMethodLabel {
        EEnter = 0,
        EEnterselection = 1,
        EClick = 2,
        __Other__,
    }
    impl From<u16> for SelectedResultMethodLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EEnter,
                1 => Self::EEnterselection,
                2 => Self::EClick,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SelectedResultMethodLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EEnter => "enter",
                Self::EEnterselection => "enterSelection",
                Self::EClick => "click",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from searchbar.selected_result_method
    ///
    /// The input method the user used to select a result in the searchbar. 'enter' => The user hit the Enter key without choosing a result in the popup. 'enterSelection' => The user chose a result and then hit the Enter key. 'click' => The user clicked a result with the mouse.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram FX_SEARCHBAR_SELECTED_RESULT_METHOD.
    pub static selected_result_method: Lazy<LabeledMetric<LabeledCounterMetric, SelectedResultMethodLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "selected_result_method".into(),
                    category: "searchbar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(771), meta, Some(vec![::std::borrow::Cow::from("click"), ::std::borrow::Cow::from("enter"), ::std::borrow::Cow::from("enterSelection")]))
    });

}
pub mod serp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AbandonmentExtra {
        pub r#impression_id: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.abandonment
    ///
    /// Recorded when there is no engagement with the SERP before the tab is closed, the window is closed, the app is closed, or the tab is navigated away from.
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abandonment".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(772), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AdImpressionExtra {
        pub r#ads_hidden: Option<u32>,
        pub r#ads_loaded: Option<u32>,
        pub r#ads_visible: Option<u32>,
        pub r#component: Option<String>,
        pub r#impression_id: Option<String>,
    }

    impl ExtraKeys for AdImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ads_hidden", "ads_loaded", "ads_visible", "component", "impression_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#ads_hidden.and_then(|val| map.insert("ads_hidden".into(), val.to_string()));
          self.r#ads_loaded.and_then(|val| map.insert("ads_loaded".into(), val.to_string()));
          self.r#ads_visible.and_then(|val| map.insert("ads_visible".into(), val.to_string()));
          self.r#component.and_then(|val| map.insert("component".into(), val.to_string()));
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ad_impression
    ///
    /// Recorded when a user loads a SERP and ads are detected.
    pub static ad_impression: Lazy<EventMetric<AdImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ad_impression".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(773), meta)
    });

    #[repr(u16)]
    pub enum AdsBlockedCountLabel {
        EBeyondViewport = 0,
        EHiddenParent = 1,
        EHiddenChild = 2,
        __Other__,
    }
    impl From<u16> for AdsBlockedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBeyondViewport,
                1 => Self::EHiddenParent,
                2 => Self::EHiddenChild,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AdsBlockedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBeyondViewport => "beyond_viewport",
                Self::EHiddenParent => "hidden_parent",
                Self::EHiddenChild => "hidden_child",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.ads_blocked_count
    ///
    /// Counts the specific type of block.
    pub static ads_blocked_count: Lazy<LabeledMetric<LabeledCounterMetric, AdsBlockedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ads_blocked_count".into(),
                    category: "serp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(774), meta, Some(vec![::std::borrow::Cow::from("beyond_viewport"), ::std::borrow::Cow::from("hidden_child"), ::std::borrow::Cow::from("hidden_parent")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CategorizationExtra {
        pub r#app_version: Option<u32>,
        pub r#channel: Option<String>,
        pub r#is_shopping_page: Option<bool>,
        pub r#mappings_version: Option<u32>,
        pub r#num_ads_clicked: Option<u32>,
        pub r#num_ads_hidden: Option<u32>,
        pub r#num_ads_loaded: Option<u32>,
        pub r#num_ads_visible: Option<u32>,
        pub r#organic_category: Option<u32>,
        pub r#organic_num_domains: Option<u32>,
        pub r#organic_num_inconclusive: Option<u32>,
        pub r#organic_num_unknown: Option<u32>,
        pub r#partner_code: Option<String>,
        pub r#provider: Option<String>,
        pub r#region: Option<String>,
        pub r#sponsored_category: Option<u32>,
        pub r#sponsored_num_domains: Option<u32>,
        pub r#sponsored_num_inconclusive: Option<u32>,
        pub r#sponsored_num_unknown: Option<u32>,
        pub r#tagged: Option<bool>,
    }

    impl ExtraKeys for CategorizationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["app_version", "channel", "is_shopping_page", "mappings_version", "num_ads_clicked", "num_ads_hidden", "num_ads_loaded", "num_ads_visible", "organic_category", "organic_num_domains", "organic_num_inconclusive", "organic_num_unknown", "partner_code", "provider", "region", "sponsored_category", "sponsored_num_domains", "sponsored_num_inconclusive", "sponsored_num_unknown", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#app_version.and_then(|val| map.insert("app_version".into(), val.to_string()));
          self.r#channel.and_then(|val| map.insert("channel".into(), val.to_string()));
          self.r#is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.r#mappings_version.and_then(|val| map.insert("mappings_version".into(), val.to_string()));
          self.r#num_ads_clicked.and_then(|val| map.insert("num_ads_clicked".into(), val.to_string()));
          self.r#num_ads_hidden.and_then(|val| map.insert("num_ads_hidden".into(), val.to_string()));
          self.r#num_ads_loaded.and_then(|val| map.insert("num_ads_loaded".into(), val.to_string()));
          self.r#num_ads_visible.and_then(|val| map.insert("num_ads_visible".into(), val.to_string()));
          self.r#organic_category.and_then(|val| map.insert("organic_category".into(), val.to_string()));
          self.r#organic_num_domains.and_then(|val| map.insert("organic_num_domains".into(), val.to_string()));
          self.r#organic_num_inconclusive.and_then(|val| map.insert("organic_num_inconclusive".into(), val.to_string()));
          self.r#organic_num_unknown.and_then(|val| map.insert("organic_num_unknown".into(), val.to_string()));
          self.r#partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#sponsored_category.and_then(|val| map.insert("sponsored_category".into(), val.to_string()));
          self.r#sponsored_num_domains.and_then(|val| map.insert("sponsored_num_domains".into(), val.to_string()));
          self.r#sponsored_num_inconclusive.and_then(|val| map.insert("sponsored_num_inconclusive".into(), val.to_string()));
          self.r#sponsored_num_unknown.and_then(|val| map.insert("sponsored_num_unknown".into(), val.to_string()));
          self.r#tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization
    ///
    /// A high-level categorization of a SERP (a best guess as to its topic), using buckets such as "sports" or "travel".
    pub static categorization: Lazy<EventMetric<CategorizationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "categorization".into(),
                category: "serp".into(),
                send_in_pings: vec!["serp-categorization".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(775), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_duration
    ///
    /// The time it takes to categorize elements on a SERP.
    pub static categorization_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "categorization_duration".into(),
                category: "serp".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(776), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from serp.categorization_no_map_found
    ///
    /// A count incremented upon a SERP categorization event being recorded without a corresponding impression event being recorded. This metric effectively counts missing impressions due to issues with the domain-to-categories map.
    pub static categorization_no_map_found: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            777,
            "serp",
            "categorization_no_map_found",
            "serp-categorization"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EngagementExtra {
        pub r#action: Option<String>,
        pub r#impression_id: Option<String>,
        pub r#target: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "impression_id", "target"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#target.and_then(|val| map.insert("target".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.engagement
    ///
    /// Recorded user actions on a SERP.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engagement".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(778), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ExperimentInfoObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub slug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branch: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from serp.experiment_info
    ///
    /// Whether the client is enrolled in a specified experiment and if so, which branch the client is assigned to. The target experiment is specified in the Nimbus config by creating a "targetExperiment" key and setting its value to the experiment's slug (and ensuring the featureId is "search").
    pub static experiment_info: Lazy<ObjectMetric<ExperimentInfoObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiment_info".into(),
                category: "serp".into(),
                send_in_pings: vec!["serp-categorization".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(779), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImpressionExtra {
        pub r#impression_id: Option<String>,
        pub r#is_private: Option<bool>,
        pub r#is_shopping_page: Option<bool>,
        pub r#is_signed_in: Option<bool>,
        pub r#partner_code: Option<String>,
        pub r#provider: Option<String>,
        pub r#shopping_tab_displayed: Option<bool>,
        pub r#source: Option<String>,
        pub r#tagged: Option<bool>,
    }

    impl ExtraKeys for ImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["impression_id", "is_private", "is_shopping_page", "is_signed_in", "partner_code", "provider", "shopping_tab_displayed", "source", "tagged"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#impression_id.and_then(|val| map.insert("impression_id".into(), val.to_string()));
          self.r#is_private.and_then(|val| map.insert("is_private".into(), val.to_string()));
          self.r#is_shopping_page.and_then(|val| map.insert("is_shopping_page".into(), val.to_string()));
          self.r#is_signed_in.and_then(|val| map.insert("is_signed_in".into(), val.to_string()));
          self.r#partner_code.and_then(|val| map.insert("partner_code".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#shopping_tab_displayed.and_then(|val| map.insert("shopping_tab_displayed".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#tagged.and_then(|val| map.insert("tagged".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from serp.impression
    ///
    /// Recorded when a search engine results page (SERP) is shown to a user. The feature began rolling out to all users with Firefox 115, and was permanently enabled in Firefox 119.
    pub static impression: Lazy<EventMetric<ImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression".into(),
                category: "serp".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(780), meta)
    });

}
pub mod urlbar_searchmode {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.bookmarkmenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecing the Search Bookmarks menu item in the Library menu. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.bookmarkmenu.
    pub static bookmarkmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bookmarkmenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(781), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.handoff
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after being handed off from the search bar on the new tab page. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.handoff.
    pub static handoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "handoff".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(782), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.historymenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecing the Search History menu item in a History menu. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.historymenu.
    pub static historymenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "historymenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(783), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.keywordoffer
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a keyword offer result. The scalar key for local search modes entered using a restrict keyword will be suffixed with "keyword". For example: tabs_keyword, bookmarks_keyword, history_keyword, and actions_keyword. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.keywordoffer.
    pub static keywordoffer: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keywordoffer".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(784), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.oneoff
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a one-off. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.oneoff.
    pub static oneoff: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "oneoff".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(785), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.other
    ///
    /// A keyed uint recording how many times the user entered a particular search mode from an unknown entry point. If values appear for this probe in Telemetry, we should review the entry points to search mode. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.other.
    pub static other: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "other".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(786), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.searchbutton
    ///
    /// A keyed uint recording how many times the user entered a particular search mode by unified search button. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.searchbutton.
    pub static searchbutton: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "searchbutton".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(787), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.shortcut
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after pressing a keyboard shortcut. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.shortcut.
    pub static shortcut: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "shortcut".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(788), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabmenu
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting the Search Tabs menu item in the Tab Overflow menu. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.tabmenu.
    pub static tabmenu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabmenu".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(789), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabtosearch
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a tab-to-search result. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.tabtosearch.
    pub static tabtosearch: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabtosearch".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(790), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.tabtosearch_onboard
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a tab-to-search onboarding result. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.tabtosearch_onboard.
    pub static tabtosearch_onboard: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabtosearch_onboard".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(791), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.topsites_newtab
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a search shortcut Top Site on the New Tab Page. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.topsites_newtab.
    pub static topsites_newtab: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "topsites_newtab".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(792), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.topsites_urlbar
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a search shortcut Top Site in the Urlbar. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.topsites_urlbar.
    pub static topsites_urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "topsites_urlbar".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(793), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.touchbar
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after selecting a search shortcut on the macOS Touch Bar. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.touchbar.
    pub static touchbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "touchbar".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(794), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.searchmode.typed
    ///
    /// A keyed uint recording how many times the user entered a particular search mode after typing an alias. The scalar keys for local search modes entered by typing a restrict keyword will be suffixed with "keyword". For example: tabs_keyword, bookmarks_keyword, history_keyword, and actions_keyword. If instead search mode was entered by typing a restrict symbol the key will be suffixed with "symbol" (e.g. typing "%" will generate "tabs_symbol"). This metric was generated to correspond to the Legacy Telemetry scalar urlbar.searchmode.typed.
    pub static typed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "typed".into(),
                    category: "urlbar.searchmode".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(795), meta, None)
    });

}
pub mod session_restore {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AllFilesCorruptLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for AllFilesCorruptLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AllFilesCorruptLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.all_files_corrupt
    ///
    /// Session restore: Whether none of the backup files contained parse-able JSON
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram FX_SESSION_RESTORE_ALL_FILES_CORRUPT.
    pub static all_files_corrupt: Lazy<LabeledMetric<LabeledCounterMetric, AllFilesCorruptLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "all_files_corrupt".into(),
                    category: "session_restore".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(796), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.auto_restore_duration_until_eager_tabs_restored
    ///
    /// Session restore: If the browser is setup to auto-restore tabs, this probe measures the time elapsed between the instant we start Session Restore and the instant we have finished restoring tabs eagerly. At this stage, the tabs that are restored on demand are not restored yet.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_AUTO_RESTORE_DURATION_UNTIL_EAGER_TABS_RESTORED_MS.
    pub static auto_restore_duration_until_eager_tabs_restored: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auto_restore_duration_until_eager_tabs_restored".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(797), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BackupCanBeLoadedSessionFileExtra {
        pub r#can_load: Option<String>,
        pub r#loadfail_reason: Option<String>,
        pub r#path_key: Option<String>,
    }

    impl ExtraKeys for BackupCanBeLoadedSessionFileExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["can_load", "loadfail_reason", "path_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#can_load.and_then(|val| map.insert("can_load".into(), val.to_string()));
          self.r#loadfail_reason.and_then(|val| map.insert("loadfail_reason".into(), val.to_string()));
          self.r#path_key.and_then(|val| map.insert("path_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.backup_can_be_loaded_session_file
    ///
    /// Recorded when a file is able to be successfully read on startup This event was generated to correspond to the Legacy Telemetry event session_restore.backup_can_be_loaded#session_file.
    pub static backup_can_be_loaded_session_file: Lazy<EventMetric<BackupCanBeLoadedSessionFileExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backup_can_be_loaded_session_file".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(798), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.collect_all_windows_data
    ///
    /// Session restore: Time to collect all window data (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_COLLECT_ALL_WINDOWS_DATA_MS.
    pub static collect_all_windows_data: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "collect_all_windows_data".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(799), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.collect_data
    ///
    /// Session restore: Time to collect all window and tab data (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_COLLECT_DATA_MS.
    pub static collect_data: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "collect_data".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(800), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.collect_session_history
    ///
    /// Session restore: Duration of session history collection in the parent process (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_COLLECT_SESSION_HISTORY_MS.
    pub static collect_session_history: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "collect_session_history".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(801), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum CorruptFileLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for CorruptFileLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CorruptFileLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.corrupt_file
    ///
    /// Session restore: Whether the file read on startup contained parse-able JSON
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram FX_SESSION_RESTORE_CORRUPT_FILE.
    pub static corrupt_file: Lazy<LabeledMetric<LabeledCounterMetric, CorruptFileLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "corrupt_file".into(),
                    category: "session_restore".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(802), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.file_size_bytes
    ///
    /// Session restore: The size of file sessionstore.js (bytes)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_FILE_SIZE_BYTES.
    pub static file_size_bytes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "file_size_bytes".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(803), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.manual_restore_duration_until_eager_tabs_restored
    ///
    /// Session restore: If a session is restored by the user clicking on 'Restore Session', this probe measures the time elapsed between the instant the user has clicked and the instant we have finished restoring tabs eagerly. At this stage, the tabs that are restored on demand are not restored yet.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_MANUAL_RESTORE_DURATION_UNTIL_EAGER_TABS_RESTORED_MS.
    pub static manual_restore_duration_until_eager_tabs_restored: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manual_restore_duration_until_eager_tabs_restored".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(804), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.number_of_eager_tabs_restored
    ///
    /// Session restore: Number of tabs restored eagerly in the session that has just been restored.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_SESSION_RESTORE_NUMBER_OF_EAGER_TABS_RESTORED.
    pub static number_of_eager_tabs_restored: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "number_of_eager_tabs_restored".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(805), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.number_of_tabs_restored
    ///
    /// Session restore: Number of tabs in the session that has just been restored.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_NUMBER_OF_TABS_RESTORED.
    pub static number_of_tabs_restored: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "number_of_tabs_restored".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(806), meta, 1, 500, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.number_of_windows_restored
    ///
    /// Session restore: Number of windows in the session that has just been restored.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_SESSION_RESTORE_NUMBER_OF_WINDOWS_RESTORED.
    pub static number_of_windows_restored: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "number_of_windows_restored".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(807), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.read_file
    ///
    /// Session restore: Time to read the session data from the file on disk (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_READ_FILE_MS.
    pub static read_file: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "read_file".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(808), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.restore_window
    ///
    /// Session restore: Time spent blocking the main thread while restoring a window state (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_RESTORE_WINDOW_MS.
    pub static restore_window: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "restore_window".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(809), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum ShutdownOkLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ShutdownOkLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ShutdownOkLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.shutdown_ok
    ///
    /// Did the browser start after a successful shutdown
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram SHUTDOWN_OK.
    pub static shutdown_ok: Lazy<LabeledMetric<LabeledCounterMetric, ShutdownOkLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "shutdown_ok".into(),
                    category: "session_restore".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(810), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShutdownSuccessSessionStartupExtra {
        pub r#shutdown_ok: Option<String>,
        pub r#shutdown_reason: Option<String>,
    }

    impl ExtraKeys for ShutdownSuccessSessionStartupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["shutdown_ok", "shutdown_reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#shutdown_ok.and_then(|val| map.insert("shutdown_ok".into(), val.to_string()));
          self.r#shutdown_reason.and_then(|val| map.insert("shutdown_reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from session_restore.shutdown_success_session_startup
    ///
    /// Report shutdown success This event was generated to correspond to the Legacy Telemetry event session_restore.shutdown_success#session_startup.
    pub static shutdown_success_session_startup: Lazy<EventMetric<ShutdownSuccessSessionStartupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_success_session_startup".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(811), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.startup_init_session
    ///
    /// Session restore: Time it takes to prepare the data structures for restoring a session (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_STARTUP_INIT_SESSION_MS.
    pub static startup_init_session: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_init_session".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(812), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.startup_onload_initial_window
    ///
    /// Session restore: Time it takes to finish restoration once we have first opened a window (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_STARTUP_ONLOAD_INITIAL_WINDOW_MS.
    pub static startup_onload_initial_window: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_onload_initial_window".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(813), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from session_restore.write_file
    ///
    /// Session restore: Time to write the session data to the file on disk (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SESSION_RESTORE_WRITE_FILE_MS.
    pub static write_file: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "write_file".into(),
                category: "session_restore".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(814), meta, TimeUnit::Millisecond)
    });

}
pub mod shopping {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddressBarFeatureCalloutDisplayedExtra {
        pub r#configuration: Option<String>,
    }

    impl ExtraKeys for AddressBarFeatureCalloutDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_feature_callout_displayed
    ///
    /// The user was shown the feature callout for the Shopping component.
    pub static address_bar_feature_callout_displayed: Lazy<EventMetric<AddressBarFeatureCalloutDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_feature_callout_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(815), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddressBarIconClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for AddressBarIconClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_clicked
    ///
    /// The Shopping product Address Bar Icon was clicked by the user.
    pub static address_bar_icon_clicked: Lazy<EventMetric<AddressBarIconClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_icon_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(816), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.address_bar_icon_displayed
    ///
    /// The Shopping product Address Bar Icon was displayed to the user.
    pub static address_bar_icon_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "address_bar_icon_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(817), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.product_page_visits
    ///
    /// Counts number of visits to a supported retailer product page
    /// while enrolled in either the control or treatment branches
    /// of the shopping experiment.
    pub static product_page_visits: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            818,
            "shopping",
            "product_page_visits",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsClickedExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_clicked
    ///
    /// An ad shown in the sidebar was clicked.
    pub static surface_ads_clicked: Lazy<EventMetric<SurfaceAdsClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(819), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsImpressionExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsImpressionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_impression
    ///
    /// An ad was shown and visible in the sidebar for 1.5 seconds.
    pub static surface_ads_impression: Lazy<EventMetric<SurfaceAdsImpressionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_impression".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(820), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsPlacementExtra {
        pub r#sponsored: Option<bool>,
    }

    impl ExtraKeys for SurfaceAdsPlacementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sponsored"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sponsored.and_then(|val| map.insert("sponsored".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_placement
    ///
    /// An ad unit was fetched successfully.
    pub static surface_ads_placement: Lazy<EventMetric<SurfaceAdsPlacementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_placement".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(821), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAdsSettingToggledExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceAdsSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_ads_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable ads in the
    /// sidebar settings component.
    pub static surface_ads_setting_toggled: Lazy<EventMetric<SurfaceAdsSettingToggledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_ads_setting_toggled".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(822), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_analyze_reviews_none_available_clicked
    ///
    /// The user clicked to analyze reviews in the case the reliability rating
    /// was not available for display in the shopping side bar. This metric
    /// does not contain any information about the product the user is viewing.
    pub static surface_analyze_reviews_none_available_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_analyze_reviews_none_available_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(823), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceAutoOpenSettingToggledExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceAutoOpenSettingToggledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_auto_open_setting_toggled
    ///
    /// The user clicked the settings toggle to enable or disable auto-open in the
    /// sidebar settings component.
    pub static surface_auto_open_setting_toggled: Lazy<EventMetric<SurfaceAutoOpenSettingToggledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_auto_open_setting_toggled".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(824), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceClosedExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for SurfaceClosedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_closed
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_closed: Lazy<EventMetric<SurfaceClosedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_closed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(825), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceDisplayedExtra {
        pub r#isIntegratedSidebar: Option<bool>,
        pub r#isProductPage: Option<bool>,
        pub r#isSupportedSite: Option<bool>,
    }

    impl ExtraKeys for SurfaceDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["isIntegratedSidebar", "isProductPage", "isSupportedSite"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#isIntegratedSidebar.and_then(|val| map.insert("isIntegratedSidebar".into(), val.to_string()));
          self.r#isProductPage.and_then(|val| map.insert("isProductPage".into(), val.to_string()));
          self.r#isSupportedSite.and_then(|val| map.insert("isSupportedSite".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_displayed
    ///
    /// The Shopping product Sidebar was displayed.
    pub static surface_displayed: Lazy<EventMetric<SurfaceDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(826), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_learn_more_clicked
    ///
    /// The user clicked the 'Learn More' link in the Shopping onboarding
    /// experience.
    pub static surface_learn_more_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_learn_more_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(827), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_ads_available
    ///
    /// On a supported product page, the review checker showed analysis, and
    /// review checker ads were enabled, but when we tried to fetch an ad from
    /// the ad server, no ad was available.
    pub static surface_no_ads_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_ads_available".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(828), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_review_reliability_available
    ///
    /// Review reliability was not available for display in the shopping side
    /// bar. This metric does not contain any information about the product
    /// the user is viewing.
    pub static surface_no_review_reliability_available: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_review_reliability_available".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(829), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_no_thanks_button_clicked
    ///
    /// The user clicks the 'No thanks' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_no_thanks_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_no_thanks_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(830), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_not_now_clicked
    ///
    /// The user clicked 'Not Now' to dismiss the dialog.
    pub static surface_not_now_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_not_now_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(831), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_notification_card_dismiss_clicked
    ///
    /// The user clicked the dismiss button to close the notification card.
    pub static surface_notification_card_dismiss_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_notification_card_dismiss_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(832), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_notification_card_impression
    ///
    /// The notification card for changing left or right sidebar position was
    /// visible in the Review Checker sidebar panel.
    pub static surface_notification_card_impression: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_notification_card_impression".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(833), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_notification_card_move_left_clicked
    ///
    /// The user clicked the 'Move left' button to move the sidebar to the left side.
    pub static surface_notification_card_move_left_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_notification_card_move_left_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(834), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_notification_card_move_right_clicked
    ///
    /// The user clicked the 'Move right' button to move the sidebar to the right side.
    pub static surface_notification_card_move_right_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_notification_card_move_right_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(835), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_notification_card_sidebar_settings_clicked
    ///
    /// The user clicked the sidebar settings link in the notification card to view
    /// the sidebar settings panel.
    pub static surface_notification_card_sidebar_settings_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_notification_card_sidebar_settings_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(836), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceOnboardingDisplayedExtra {
        pub r#configuration: Option<String>,
    }

    impl ExtraKeys for SurfaceOnboardingDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["configuration"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#configuration.and_then(|val| map.insert("configuration".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_onboarding_displayed
    ///
    /// The Shopping Side bar displayed the onboarding experience.
    pub static surface_onboarding_displayed: Lazy<EventMetric<SurfaceOnboardingDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_onboarding_displayed".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(837), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_in_clicked
    ///
    /// The user clicked the "Yes, try it" element to use the Shopping product's
    /// functionality.
    pub static surface_opt_in_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_opt_in_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(838), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_opt_out_button_clicked
    ///
    /// The user clicked the button in the settings panel to turn off the shopping experience.
    pub static surface_opt_out_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_opt_out_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(839), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_powered_by_fakespot_link_clicked
    ///
    /// The user clicked the "Fakespot by Mozilla" link in the shopping side
    /// bar.
    pub static surface_powered_by_fakespot_link_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_powered_by_fakespot_link_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(840), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reactivated_button_clicked
    ///
    /// The user clicked the reactivated product button.
    pub static surface_reactivated_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_reactivated_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(841), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_reanalyze_clicked
    ///
    /// The user clicked to REanalyze reviews in the shopping side bar. This
    /// metric does not contain any information about the product the user is
    /// viewing or any displayed trusted deals.
    pub static surface_reanalyze_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_reanalyze_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(842), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceSettingsExpandClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceSettingsExpandClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_settings_expand_clicked
    ///
    /// The user opened the settings menu of the shopping component.
    pub static surface_settings_expand_clicked: Lazy<EventMetric<SurfaceSettingsExpandClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_settings_expand_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(843), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceShowMoreReviewsButtonClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowMoreReviewsButtonClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_more_reviews_button_clicked
    ///
    /// The user clicked to expand the recent reviews to see more.
    pub static surface_show_more_reviews_button_clicked: Lazy<EventMetric<SurfaceShowMoreReviewsButtonClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_more_reviews_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(844), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_privacy_policy_clicked
    ///
    /// The user clicked to view the Privacy Policy.
    pub static surface_show_privacy_policy_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_privacy_policy_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(845), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SurfaceShowQualityExplainerClickedExtra {
        pub r#action: Option<String>,
    }

    impl ExtraKeys for SurfaceShowQualityExplainerClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_clicked: Lazy<EventMetric<SurfaceShowQualityExplainerClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_quality_explainer_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(846), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_quality_explainer_url_clicked
    ///
    /// The user clicked to see the explanation of Review Quality in the
    /// shopping component.
    pub static surface_show_quality_explainer_url_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_quality_explainer_url_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(847), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_show_terms_clicked
    ///
    /// The user clicked to view the Terms of Service.
    pub static surface_show_terms_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_show_terms_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(848), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_stale_analysis_shown
    ///
    /// The user was shown the dialogue box indicating that analysis of a product
    /// was stale. No information about the product is included.
    pub static surface_stale_analysis_shown: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_stale_analysis_shown".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(849), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.surface_yes_keep_closed_button_clicked
    ///
    /// The user clicks the 'Yes, keep closed' button when asked if they want to
    /// disable auto-open behavior.
    pub static surface_yes_keep_closed_button_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "surface_yes_keep_closed_button_clicked".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(850), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from shopping.sidebar_toggle
    ///
    /// The Review Checker sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "shopping".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(851), meta)
    });

}
pub mod shopping_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.auto_open_user_disabled
    ///
    /// Indicates if the user has manually disabled the auto open sidebar feature.
    /// Set during shopping component init and updated when changed in browser.
    pub static auto_open_user_disabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auto_open_user_disabled".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(852), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.component_opted_out
    ///
    /// Indicates if the user has opted out of using the shopping component.
    /// Set during shopping component init and updated when changed in browser.
    pub static component_opted_out: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "component_opted_out".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(853), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.disabled_ads
    ///
    /// Indicates if the user has manually disabled ads. Set during shopping
    /// component init and updated when changed in browser.
    pub static disabled_ads: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_ads".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(854), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.has_onboarded
    ///
    /// Indicates if the user has completed the Shopping product Onboarding
    /// experience. Set during shopping component init and updated when changed
    /// in browser.
    pub static has_onboarded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_onboarded".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(855), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping.settings.nimbus_disabled_shopping
    ///
    /// Indicates if Nimbus has disabled the use the shopping component.
    pub static nimbus_disabled_shopping: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nimbus_disabled_shopping".into(),
                category: "shopping.settings".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(856), meta)
    });

}
pub mod bookmarks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bookmarks.sidebar_toggle
    ///
    /// The Bookmarks sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "bookmarks".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(857), meta)
    });

}
pub mod contextual_manager {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PasswordsEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for PasswordsEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.passwords_enabled
    ///
    /// User clicked on the checkbox corresponding to the "Passwords" entry on sidebar customization settings.
    pub static passwords_enabled: Lazy<EventMetric<PasswordsEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "passwords_enabled".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(858), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.sidebar_toggle
    ///
    /// Client opens Contextual Manager.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(859), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NotificationInteractionExtra {
        pub r#action_type: Option<String>,
        pub r#notification_detail: Option<String>,
    }

    impl ExtraKeys for NotificationInteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action_type", "notification_detail"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action_type.and_then(|val| map.insert("action_type".into(), val.to_string()));
          self.r#notification_detail.and_then(|val| map.insert("notification_detail".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.notification_interaction
    ///
    /// Client interacts with displayed notification Possible notification details include:
    ///   "import_success": Logins were successfully imported
    ///   "import_error": There was an error importing logins
    ///   "export_passwords_success": Logins were successfully exported
    ///   "add_login_success": A login was successfully added manually
    ///   "update_login_success": A login was succesfully updated manually
    ///   "delete_login_success": Logins were successfully deleted
    ///   "discard_changes": Exited the login form while updating
    ///   "login_already_exists_warning": A login was not created because it already exists
    ///   "breached_origin_warning": A login has a breached origin alert
    ///   "vulnerable_password_warning": A login has a vulnerable password alert
    ///   "no_username_warning": A login has a no username alert
    /// Possible action types include:
    ///   "change_record": Change a record field
    ///   "open_link": Open a link
    ///   "import": Import records after a failed attempt
    ///   "confirm_discard_changes": Continue exiting the login form while updating
    ///   "nav_record": Navigate to a newly created or existing record
    ///   "dismiss": Close a notification
    pub static notification_interaction: Lazy<EventMetric<NotificationInteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "notification_interaction".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(860), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NotificationShownExtra {
        pub r#notification_detail: Option<String>,
    }

    impl ExtraKeys for NotificationShownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["notification_detail"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#notification_detail.and_then(|val| map.insert("notification_detail".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.notification_shown
    ///
    /// Notification is dislayed to client. Possible notification details include:
    ///   "import_success": Logins were successfully imported
    ///   "import_error": There was an error importing logins
    ///   "export_passwords_success": Logins were successfully exported
    ///   "add_login_success": A login was successfully added manually
    ///   "update_login_success": A login was succesfully updated manually
    ///   "delete_login_success": Logins were successfully deleted
    ///   "discard_changes": Exited the login form while updating
    ///   "login_already_exists_warning": A login was not created because it already exists
    ///   "breached_origin_warning": A login has a breached origin alert
    ///   "vulnerable_password_warning": A login has a vulnerable password alert
    ///   "no_username_warning": A login has a no username alert
    pub static notification_shown: Lazy<EventMetric<NotificationShownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "notification_shown".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(861), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RecordsInteractionExtra {
        pub r#interaction_type: Option<String>,
    }

    impl ExtraKeys for RecordsInteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["interaction_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#interaction_type.and_then(|val| map.insert("interaction_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.records_interaction
    ///
    /// Client interacts with existing CM tile Possible interaction types include:
    ///   "url_navigate": When the origin field is clicked
    ///   "copy_username": When the username field is clicked
    ///   "copy_password": When the password field is clicked
    ///   "view_password": When the reveal password button is clicked
    ///   "hide_password": When the hide password button is clicked
    ///   "edit": When the edit button is clicked
    ///   "view_alert": When the "View alert" button is clicked
    pub static records_interaction: Lazy<EventMetric<RecordsInteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "records_interaction".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(862), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RecordsUpdateExtra {
        pub r#change_type: Option<String>,
    }

    impl ExtraKeys for RecordsUpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#change_type.and_then(|val| map.insert("change_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.records_update
    ///
    /// Client modifies, adds, or removes CM record. Captures changes committed to a client's password management records. Possible change types:
    ///   "add": Single record is created
    ///   "edit": Single record is edited
    ///   "remove": Single record is removed
    ///   "remove_all": All records are removed
    ///   "import": Records were changed by importing from another dataset
    ///             (such as a file, browser)
    pub static records_update: Lazy<EventMetric<RecordsUpdateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "records_update".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(863), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolbarActionExtra {
        pub r#option_name: Option<String>,
        pub r#trigger: Option<String>,
    }

    impl ExtraKeys for ToolbarActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["option_name", "trigger"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#option_name.and_then(|val| map.insert("option_name".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contextual_manager.toolbar_action
    ///
    /// Client interacts with any object within CM toolbar, or any action associated with the toolbar is initiated from an "empty state". Possible triggers include:
    ///   "empty_state_card": When there are no records stored and user is presented
    ///                       options for a user to take
    ///   "toolbar": When the user selects an option from the CPM toolbar
    /// Possible option names include:
    ///   "add_new": Add a new record
    ///   "import_browser": Import records from another browser
    ///   "import_file": Import records from a file
    ///   "export": Export records to a file
    ///   "remove_all": Remove all records
    ///   "preferences": Takes user to about:preferences
    ///   "help": Takes user to a SUMO page
    ///   "list_state_all": Display all records
    ///   "list_state_alerts": Display only alerts
    pub static toolbar_action: Lazy<EventMetric<ToolbarActionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toolbar_action".into(),
                category: "contextual_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(864), meta)
    });

}
pub mod extension {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_name: Option<String>,
        pub r#opened: Option<bool>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_name", "opened", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_name.and_then(|val| map.insert("addon_name".into(), val.to_string()));
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extension.sidebar_toggle
    ///
    /// A sidebar extension panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "extension".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(865), meta)
    });

}
pub mod history {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from history.sidebar_toggle
    ///
    /// The History sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "history".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(866), meta)
    });

}
pub mod sidebar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddonIconClickExtra {
        pub r#addon_id: Option<String>,
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for AddonIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.addon_icon_click
    ///
    /// An extension icon was clicked.
    pub static addon_icon_click: Lazy<EventMetric<AddonIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(867), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BookmarksIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for BookmarksIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.bookmarks_icon_click
    ///
    /// The bookmarks icon was clicked.
    pub static bookmarks_icon_click: Lazy<EventMetric<BookmarksIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bookmarks_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(868), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChatbotIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for ChatbotIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.chatbot_icon_click
    ///
    /// The chatbot icon was clicked.
    pub static chatbot_icon_click: Lazy<EventMetric<ChatbotIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chatbot_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(869), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.display_settings
    ///
    /// Setting for sidebar display (either "always", "expand-on-hover", or "hide").
    pub static display_settings: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_settings".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(870), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.expand
    ///
    /// The sidebar was expanded.
    pub static expand: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expand".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(871), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HistoryIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for HistoryIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.history_icon_click
    ///
    /// The history icon was clicked.
    pub static history_icon_click: Lazy<EventMetric<HistoryIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(872), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct KeyboardShortcutExtra {
        pub r#opened: Option<bool>,
        pub r#panel: Option<String>,
    }

    impl ExtraKeys for KeyboardShortcutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "panel"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#panel.and_then(|val| map.insert("panel".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.keyboard_shortcut
    ///
    /// Revamped sidebar toggled with keyboard shortcut.
    pub static keyboard_shortcut: Lazy<EventMetric<KeyboardShortcutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyboard_shortcut".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(873), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.link
    ///
    /// The number of history items opened from the History sidebar. This metric was generated to correspond to the Legacy Telemetry scalar sidebar.link.
    pub static link: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "link".into(),
                    category: "sidebar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(874), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.position_settings
    ///
    /// Setting for sidebar position (either "left" or "right").
    pub static position_settings: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position_settings".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(875), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResizeExtra {
        pub r#current: Option<u32>,
        pub r#percentage: Option<u32>,
        pub r#previous: Option<u32>,
    }

    impl ExtraKeys for ResizeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["current", "percentage", "previous"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#current.and_then(|val| map.insert("current".into(), val.to_string()));
          self.r#percentage.and_then(|val| map.insert("percentage".into(), val.to_string()));
          self.r#previous.and_then(|val| map.insert("previous".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.resize
    ///
    /// User resized the sidebar.
    pub static resize: Lazy<EventMetric<ResizeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resize".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(876), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.search
    ///
    /// The number of searches from the sidebar, per view (e.g.: bookmarks, history). This metric was generated to correspond to the Legacy Telemetry scalar sidebar.search.
    pub static search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "search".into(),
                    category: "sidebar".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(877), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShoppingReviewCheckerIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for ShoppingReviewCheckerIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.shopping_review_checker_icon_click
    ///
    /// The Review Checker icon was clicked.
    pub static shopping_review_checker_icon_click: Lazy<EventMetric<ShoppingReviewCheckerIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shopping_review_checker_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(878), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsIconClickExtra {
        pub r#sidebar_open: Option<bool>,
    }

    impl ExtraKeys for SyncedTabsIconClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sidebar_open"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sidebar_open.and_then(|val| map.insert("sidebar_open".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.synced_tabs_icon_click
    ///
    /// The synced tabs icon was clicked.
    pub static synced_tabs_icon_click: Lazy<EventMetric<SyncedTabsIconClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_icon_click".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(879), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.tabs_layout
    ///
    /// Setting for tabs orientation (either "horizontal" or "vertical").
    pub static tabs_layout: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_layout".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(880), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.width
    ///
    /// Width of the sidebar, in pixels.
    pub static width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "width".into(),
                category: "sidebar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(881), meta)
    });

}
pub mod sidebar_customize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BookmarksEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for BookmarksEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.bookmarks_enabled
    ///
    /// User clicked on the checkbox corresponding to bookmarks on sidebar customization settings.
    pub static bookmarks_enabled: Lazy<EventMetric<BookmarksEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bookmarks_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(882), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChatbotEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for ChatbotEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.chatbot_enabled
    ///
    /// User clicked on the checkbox corresponding to chatbot on sidebar customization settings.
    pub static chatbot_enabled: Lazy<EventMetric<ChatbotEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chatbot_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(883), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExpandOnHoverEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for ExpandOnHoverEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.expand_on_hover_enabled
    ///
    /// User clicked on the checkbox corresponding to expand on hover on sidebar customization settings.
    pub static expand_on_hover_enabled: Lazy<EventMetric<ExpandOnHoverEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expand_on_hover_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(884), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.extensions_clicked
    ///
    /// User clicked on the link to go to Browser Extensions on sidebar customization settings.
    pub static extensions_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extensions_clicked".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(885), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.firefox_settings_clicked
    ///
    /// User clicked on the link to Manage Firefox Settings on sidebar customization settings.
    pub static firefox_settings_clicked: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "firefox_settings_clicked".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(886), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HistoryEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for HistoryEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.history_enabled
    ///
    /// User clicked on the checkbox corresponding to history on sidebar customization settings.
    pub static history_enabled: Lazy<EventMetric<HistoryEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(887), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.icon_click
    ///
    /// User clicked on the gear icon to customize the sidebar.
    pub static icon_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "icon_click".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(888), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PanelToggleExtra {
        pub r#opened: Option<bool>,
    }

    impl ExtraKeys for PanelToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.panel_toggle
    ///
    /// The Customize sidebar panel was loaded or unloaded.
    pub static panel_toggle: Lazy<EventMetric<PanelToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "panel_toggle".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(889), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShoppingReviewCheckerEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for ShoppingReviewCheckerEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.shopping_review_checker_enabled
    ///
    /// User clicked on the checkbox corresponding to Review Checker on sidebar customization settings.
    pub static shopping_review_checker_enabled: Lazy<EventMetric<ShoppingReviewCheckerEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shopping_review_checker_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(890), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarDisplayExtra {
        pub r#preference: Option<String>,
    }

    impl ExtraKeys for SidebarDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["preference"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.sidebar_display
    ///
    /// User selected an option of when the sidebar is shown on sidebar customization settings.
    pub static sidebar_display: Lazy<EventMetric<SidebarDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_display".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(891), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarPositionExtra {
        pub r#position: Option<String>,
    }

    impl ExtraKeys for SidebarPositionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#position.and_then(|val| map.insert("position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.sidebar_position
    ///
    /// User selected an option of in which side the sidebar is displayed from the sidebar customization settings.
    pub static sidebar_position: Lazy<EventMetric<SidebarPositionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_position".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(892), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncedTabsEnabledExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for SyncedTabsEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.synced_tabs_enabled
    ///
    /// User clicked on the checkbox corresponding to synced tabs on sidebar customization settings.
    pub static synced_tabs_enabled: Lazy<EventMetric<SyncedTabsEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "synced_tabs_enabled".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(893), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TabsDisplayExtra {
        pub r#checked: Option<bool>,
    }

    impl ExtraKeys for TabsDisplayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["checked"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#checked.and_then(|val| map.insert("checked".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.tabs_display
    ///
    /// User clicked on the checkbox corresponding to hiding horizontal tabs on sidebar customization settings.
    pub static tabs_display: Lazy<EventMetric<TabsDisplayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_display".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(894), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TabsLayoutExtra {
        pub r#orientation: Option<String>,
    }

    impl ExtraKeys for TabsLayoutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["orientation"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#orientation.and_then(|val| map.insert("orientation".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sidebar.customize.tabs_layout
    ///
    /// User selected between horizontal or vertical tabs on sidebar customization settings.
    pub static tabs_layout: Lazy<EventMetric<TabsLayoutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tabs_layout".into(),
                category: "sidebar.customize".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(895), meta)
    });

}
pub mod synced_tabs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidebarToggleExtra {
        pub r#opened: Option<bool>,
        pub r#synced_tabs_loaded: Option<bool>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for SidebarToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["opened", "synced_tabs_loaded", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#opened.and_then(|val| map.insert("opened".into(), val.to_string()));
          self.r#synced_tabs_loaded.and_then(|val| map.insert("synced_tabs_loaded".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.sidebar_toggle
    ///
    /// The Synced Tabs sidebar panel was loaded or unloaded.
    pub static sidebar_toggle: Lazy<EventMetric<SidebarToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidebar_toggle".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(896), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickFxaAppMenuExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickFxaAppMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_fxa_app_menu
    ///
    /// Record how users access and use synced tabs component This event was generated to correspond to the Legacy Telemetry event synced_tabs.click#fxa_app_menu.
    pub static click_fxa_app_menu: Lazy<EventMetric<ClickFxaAppMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fxa_app_menu".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(897), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickFxaAvatarMenuExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickFxaAvatarMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_fxa_avatar_menu
    ///
    /// Record how users access and use synced tabs component This event was generated to correspond to the Legacy Telemetry event synced_tabs.click#fxa_avatar_menu.
    pub static click_fxa_avatar_menu: Lazy<EventMetric<ClickFxaAvatarMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_fxa_avatar_menu".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(898), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncedTabsSidebarExtra {
        pub r#filter: Option<String>,
        pub r#tab_pos: Option<String>,
    }

    impl ExtraKeys for ClickSyncedTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filter", "tab_pos"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filter.and_then(|val| map.insert("filter".into(), val.to_string()));
          self.r#tab_pos.and_then(|val| map.insert("tab_pos".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from synced_tabs.click_synced_tabs_sidebar
    ///
    /// Record how users access and use synced tabs component This event was generated to correspond to the Legacy Telemetry event synced_tabs.click#synced_tabs_sidebar.
    pub static click_synced_tabs_sidebar: Lazy<EventMetric<ClickSyncedTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_synced_tabs_sidebar".into(),
                category: "synced_tabs".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(899), meta)
    });

}
pub mod browser_tabclose {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabclose.permit_unload_time
    ///
    /// Firefox: Time taken to run permitUnload on a browser during tab close to see whether or not we're allowed to close the tab (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_CLOSE_PERMIT_UNLOAD_TIME_MS.
    pub static permit_unload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "permit_unload_time".into(),
                category: "browser.tabclose".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(900), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabclose.time_anim
    ///
    /// Firefox: Time taken from the point of closing a tab (with animation), to the browser element being removed from the DOM. (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_CLOSE_TIME_ANIM_MS.
    pub static time_anim: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_anim".into(),
                category: "browser.tabclose".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(901), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabclose.time_no_anim
    ///
    /// Firefox: Time taken from the point of closing a tab (without animation) to the browser element being removed from the DOM. (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_CLOSE_TIME_NO_ANIM_MS.
    pub static time_no_anim: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_no_anim".into(),
                category: "browser.tabclose".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(902), meta, TimeUnit::Millisecond)
    });

}
pub mod browser_tabswitch {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabswitch.spinner_visible
    ///
    /// Firefox: If the spinner interstitial displays during tab switching, records the time in ms the graphic is visible
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_SWITCH_SPINNER_VISIBLE_MS.
    pub static spinner_visible: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "spinner_visible".into(),
                category: "browser.tabswitch".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(903), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SpinnerVisibleTriggerLabel {
        ENone = 0,
        EPreactions = 1,
        EPostactions = 2,
        EOnloadtimeout = 3,
        EOnlayersready = 4,
        EOnsizemodeorocc = 5,
        EOnendswapdocshells = 6,
        __Other__,
    }
    impl From<u16> for SpinnerVisibleTriggerLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EPreactions,
                2 => Self::EPostactions,
                3 => Self::EOnloadtimeout,
                4 => Self::EOnlayersready,
                5 => Self::EOnsizemodeorocc,
                6 => Self::EOnendswapdocshells,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SpinnerVisibleTriggerLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EPreactions => "preActions",
                Self::EPostactions => "postActions",
                Self::EOnloadtimeout => "onLoadTimeout",
                Self::EOnlayersready => "onLayersReady",
                Self::EOnsizemodeorocc => "onSizeModeOrOcc",
                Self::EOnendswapdocshells => "onEndSwapDocShells",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.tabswitch.spinner_visible_trigger
    ///
    /// Diagnostic probe to aid in categorizing tab switch spinners. Records what most recently set the loadTimer to null if a spinner was displayed.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram FX_TAB_SWITCH_SPINNER_VISIBLE_TRIGGER.
    pub static spinner_visible_trigger: Lazy<LabeledMetric<LabeledCounterMetric, SpinnerVisibleTriggerLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "spinner_visible_trigger".into(),
                    category: "browser.tabswitch".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(904), meta, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("onEndSwapDocShells"), ::std::borrow::Cow::from("onLayersReady"), ::std::borrow::Cow::from("onLoadTimeout"), ::std::borrow::Cow::from("onSizeModeOrOcc"), ::std::borrow::Cow::from("postActions"), ::std::borrow::Cow::from("preActions")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabswitch.total
    ///
    /// Firefox: Time in ms between tab selection and tab content paint in e10s windows
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_SWITCH_TOTAL_E10S_MS.
    pub static total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "browser.tabswitch".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(905), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.tabswitch.update
    ///
    /// Firefox: Time in ms spent updating UI in response to a tab switch
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_TAB_SWITCH_UPDATE_MS.
    pub static update: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update".into(),
                category: "browser.tabswitch".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(906), meta, TimeUnit::Millisecond)
    });

}
pub mod browser_ui_interaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count
    ///
    /// Records a count of how many times a drag event started for a tab within the All Tabs panel. This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.all_tabs_panel_dragstart_tab_event_count.
    pub static all_tabs_panel_dragstart_tab_event_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            907,
            "browser.ui.interaction",
            "all_tabs_panel_dragstart_tab_event_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.all_tabs_panel_entrypoint
    ///
    /// Records a count of how many times the All Tabs Panel was opened, keyed on a string describing the entrypoint. This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.all_tabs_panel_entrypoint.
    pub static all_tabs_panel_entrypoint: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "all_tabs_panel_entrypoint".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(908), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.textrecognition_error
    ///
    /// Recorded when text recognition in images fails for some unknown reason. This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.textrecognition_error.
    pub static textrecognition_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            909,
            "browser.ui.interaction",
            "textrecognition_error",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.app_menu
    ///
    /// Records a count of interactions with items in the app menu. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.app_menu.
    pub static app_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "app_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(910), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.bookmarks_bar
    ///
    /// Records a count of interactions with items in the bookmarks bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.bookmarks_bar.
    pub static bookmarks_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bookmarks_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(911), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.content_context
    ///
    /// Records a count of interactions with items in the content context menu. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.content_context.
    pub static content_context: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_context".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(912), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.menu_bar
    ///
    /// Records a count of interactions with items in the menu bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.menu_bar.
    pub static menu_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "menu_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(913), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.nav_bar
    ///
    /// Records a count of interactions with items in the nav bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.nav_bar.
    pub static nav_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "nav_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(914), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.overflow_menu
    ///
    /// Records a count of interactions with items in the overflow menu. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.overflow_menu.
    pub static overflow_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "overflow_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(915), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pageaction_panel
    ///
    /// Records a count of interactions with page action items in the panel. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.pageaction_panel.
    pub static pageaction_panel: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pageaction_panel".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(916), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pageaction_urlbar
    ///
    /// Records a count of interactions with page action items in the url bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.pageaction_urlbar.
    pub static pageaction_urlbar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pageaction_urlbar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(917), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.pinned_overflow_menu
    ///
    /// Records a count of interactions with items in the pinned area of the overflow menu. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.pinned_overflow_menu.
    pub static pinned_overflow_menu: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pinned_overflow_menu".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(918), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_containers
    ///
    /// Records the items interacted with in the Containers section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneContainers.
    pub static preferences_pane_containers: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_containers".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(919), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_experimental
    ///
    /// Records the items interacted with in the Experimental section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneExperimental.
    pub static preferences_pane_experimental: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_experimental".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(920), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_general
    ///
    /// Records the items interacted with in the General section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneGeneral.
    pub static preferences_pane_general: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_general".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(921), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_home
    ///
    /// Records the items interacted with in the Home section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneHome.
    pub static preferences_pane_home: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_home".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(922), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_more_from_mozilla
    ///
    /// Records the items interacted with in the More From Mozilla section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneMoreFromMozilla.
    pub static preferences_pane_more_from_mozilla: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_more_from_mozilla".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(923), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_privacy
    ///
    /// Records the items interacted with in the Privacy section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_panePrivacy.
    pub static preferences_pane_privacy: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_privacy".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(924), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_search
    ///
    /// Records the items interacted with in the Search section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneSearch.
    pub static preferences_pane_search: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_search".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(925), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_search_results
    ///
    /// Records the items interacted with in the Search results section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneSearchResults.
    pub static preferences_pane_search_results: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_search_results".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(926), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_sync
    ///
    /// Records the items interacted with in the Sync section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneSync.
    pub static preferences_pane_sync: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_sync".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(927), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.preferences_pane_unknown
    ///
    /// Records the items interacted with in any other section of preferences. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.preferences_paneUnknown.
    pub static preferences_pane_unknown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preferences_pane_unknown".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(928), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_bar
    ///
    /// Records a count of interactions with items in the tab bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.tabs_bar.
    pub static tabs_bar: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_bar".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(929), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_context
    ///
    /// Records a count of interactions with items in the tab context menu. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.tabs_context.
    pub static tabs_context: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_context".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(930), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.tabs_context_entrypoint
    ///
    /// Records a count for each entrypoint (the container of the trigger node) when an item from the tabs context menu is selected. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.tabs_context_entrypoint.
    pub static tabs_context_entrypoint: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_context_entrypoint".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(931), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.unified_extensions_area
    ///
    /// Records a count of interactions with items in the Unified Extensions area. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.unified_extensions_area.
    pub static unified_extensions_area: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "unified_extensions_area".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(932), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.vertical_tabs_container
    ///
    /// Records a count of interactions with items in the vertical tab bar. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.vertical_tabs_container.
    pub static vertical_tabs_container: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "vertical_tabs_container".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(933), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.interaction.keyboard
    ///
    /// Records a count of interactions with keyboard shortcuts. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.interaction.keyboard.
    pub static keyboard: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyboard".into(),
                    category: "browser.ui.interaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(934), meta, None)
    });

}
pub mod tabgroup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ActiveGroupsLabel {
        EExpanded = 0,
        ECollapsed = 1,
        __Other__,
    }
    impl From<u16> for ActiveGroupsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EExpanded,
                1 => Self::ECollapsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ActiveGroupsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EExpanded => "expanded",
                Self::ECollapsed => "collapsed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.active_groups
    ///
    /// Records the number of groups present in the tab bar, split by expanded or collapsed.
    pub static active_groups: Lazy<LabeledMetric<LabeledQuantityMetric, ActiveGroupsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "active_groups".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(935), meta, Some(vec![::std::borrow::Cow::from("collapsed"), ::std::borrow::Cow::from("expanded")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddTabExtra {
        pub r#layout: Option<String>,
        pub r#source: Option<String>,
        pub r#tabs: Option<u32>,
    }

    impl ExtraKeys for AddTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["layout", "source", "tabs"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#layout.and_then(|val| map.insert("layout".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#tabs.and_then(|val| map.insert("tabs".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.add_tab
    ///
    /// Recorded when the user adds one or more ungrouped tabs to an existing tab group
    pub static add_tab: Lazy<EventMetric<AddTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_tab".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(936), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CreateGroupExtra {
        pub r#id: Option<String>,
        pub r#layout: Option<String>,
        pub r#source: Option<String>,
        pub r#tabs: Option<u32>,
    }

    impl ExtraKeys for CreateGroupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["id", "layout", "source", "tabs"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#layout.and_then(|val| map.insert("layout".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#tabs.and_then(|val| map.insert("tabs".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.create_group
    ///
    /// Recorded when the user creates a new tab group via the tab context menu or through drag and drop.
    pub static create_group: Lazy<EventMetric<CreateGroupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "create_group".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(937), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteExtra {
        pub r#id: Option<String>,
        pub r#source: Option<String>,
    }

    impl ExtraKeys for DeleteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["id", "source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.delete
    ///
    /// Recorded when the user deletes a tab group
    pub static delete: Lazy<EventMetric<DeleteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(938), meta)
    });

    #[repr(u16)]
    pub enum GroupInteractionsLabel {
        EExpand = 0,
        ECollapse = 1,
        ERename = 2,
        EChangeColor = 3,
        ESave = 4,
        EReopen = 5,
        EOpenTabmenu = 6,
        EOpenRecent = 7,
        EOpenSuggest = 8,
        EDelete = 9,
        EUngroup = 10,
        EMoveWindow = 11,
        __Other__,
    }
    impl From<u16> for GroupInteractionsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EExpand,
                1 => Self::ECollapse,
                2 => Self::ERename,
                3 => Self::EChangeColor,
                4 => Self::ESave,
                5 => Self::EReopen,
                6 => Self::EOpenTabmenu,
                7 => Self::EOpenRecent,
                8 => Self::EOpenSuggest,
                9 => Self::EDelete,
                10 => Self::EUngroup,
                11 => Self::EMoveWindow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GroupInteractionsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EExpand => "expand",
                Self::ECollapse => "collapse",
                Self::ERename => "rename",
                Self::EChangeColor => "change_color",
                Self::ESave => "save",
                Self::EReopen => "reopen",
                Self::EOpenTabmenu => "open_tabmenu",
                Self::EOpenRecent => "open_recent",
                Self::EOpenSuggest => "open_suggest",
                Self::EDelete => "delete",
                Self::EUngroup => "ungroup",
                Self::EMoveWindow => "move_window",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.group_interactions
    ///
    /// Records interactions with tab groups: expand/collapse; rename, change color; save/reopen/delete; ungroup tabs; open from tab menu/recent/ Awesomebar; move to another window
    pub static group_interactions: Lazy<LabeledMetric<LabeledCounterMetric, GroupInteractionsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "group_interactions".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(939), meta, Some(vec![::std::borrow::Cow::from("change_color"), ::std::borrow::Cow::from("collapse"), ::std::borrow::Cow::from("delete"), ::std::borrow::Cow::from("expand"), ::std::borrow::Cow::from("move_window"), ::std::borrow::Cow::from("open_recent"), ::std::borrow::Cow::from("open_suggest"), ::std::borrow::Cow::from("open_tabmenu"), ::std::borrow::Cow::from("rename"), ::std::borrow::Cow::from("reopen"), ::std::borrow::Cow::from("save"), ::std::borrow::Cow::from("ungroup")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReopenExtra {
        pub r#id: Option<String>,
        pub r#layout: Option<String>,
        pub r#source: Option<String>,
        pub r#type: Option<String>,
    }

    impl ExtraKeys for ReopenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["id", "layout", "source", "type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#layout.and_then(|val| map.insert("layout".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.reopen
    ///
    /// Recorded when a user reopens a saved tab group
    pub static reopen: Lazy<EventMetric<ReopenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reopen".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(940), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExtra {
        pub r#id: Option<String>,
        pub r#user_triggered: Option<bool>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["id", "user_triggered"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#user_triggered.and_then(|val| map.insert("user_triggered".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.save
    ///
    /// Recorded when the user saves a tab group
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(941), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.saved_groups
    ///
    /// Records the number of saved tab groups present in the user's session
    pub static saved_groups: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_groups".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(942), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SmartTabExtra {
        pub r#enabled: Option<bool>,
    }

    impl ExtraKeys for SmartTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enabled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enabled.and_then(|val| map.insert("enabled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.smart_tab
    ///
    /// Recorded when any pref cause smart tabs to be enabled / disabled
    pub static smart_tab: Lazy<EventMetric<SmartTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "smart_tab".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(943), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.smart_tab_enabled
    ///
    /// Records if the user has smart tab groups enabled
    pub static smart_tab_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "smart_tab_enabled".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(944), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SmartTabOptinExtra {
        pub r#step: Option<String>,
    }

    impl ExtraKeys for SmartTabOptinExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["step"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.smart_tab_optin
    ///
    /// Recorded when onboards to smart tab grouping through opt-in UI
    pub static smart_tab_optin: Lazy<EventMetric<SmartTabOptinExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "smart_tab_optin".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(945), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SmartTabSuggestExtra {
        pub r#action: Option<String>,
        pub r#id: Option<String>,
        pub r#model_revision: Option<String>,
        pub r#tabs_approved: Option<u32>,
        pub r#tabs_in_group: Option<u32>,
        pub r#tabs_in_window: Option<u32>,
        pub r#tabs_removed: Option<u32>,
        pub r#tabs_suggested: Option<u32>,
    }

    impl ExtraKeys for SmartTabSuggestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "id", "model_revision", "tabs_approved", "tabs_in_group", "tabs_in_window", "tabs_removed", "tabs_suggested"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#model_revision.and_then(|val| map.insert("model_revision".into(), val.to_string()));
          self.r#tabs_approved.and_then(|val| map.insert("tabs_approved".into(), val.to_string()));
          self.r#tabs_in_group.and_then(|val| map.insert("tabs_in_group".into(), val.to_string()));
          self.r#tabs_in_window.and_then(|val| map.insert("tabs_in_window".into(), val.to_string()));
          self.r#tabs_removed.and_then(|val| map.insert("tabs_removed".into(), val.to_string()));
          self.r#tabs_suggested.and_then(|val| map.insert("tabs_suggested".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.smart_tab_suggest
    ///
    /// Recorded when the user saves suggested tabs using the ml embedding model
    pub static smart_tab_suggest: Lazy<EventMetric<SmartTabSuggestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "smart_tab_suggest".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(946), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SmartTabTopicExtra {
        pub r#action: Option<String>,
        pub r#id: Option<String>,
        pub r#label_reason: Option<String>,
        pub r#levenshtein_distance: Option<u32>,
        pub r#ml_label_length: Option<u32>,
        pub r#model_revision: Option<String>,
        pub r#tabs_in_group: Option<u32>,
        pub r#user_label_length: Option<u32>,
    }

    impl ExtraKeys for SmartTabTopicExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["action", "id", "label_reason", "levenshtein_distance", "ml_label_length", "model_revision", "tabs_in_group", "user_label_length"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#action.and_then(|val| map.insert("action".into(), val.to_string()));
          self.r#id.and_then(|val| map.insert("id".into(), val.to_string()));
          self.r#label_reason.and_then(|val| map.insert("label_reason".into(), val.to_string()));
          self.r#levenshtein_distance.and_then(|val| map.insert("levenshtein_distance".into(), val.to_string()));
          self.r#ml_label_length.and_then(|val| map.insert("ml_label_length".into(), val.to_string()));
          self.r#model_revision.and_then(|val| map.insert("model_revision".into(), val.to_string()));
          self.r#tabs_in_group.and_then(|val| map.insert("tabs_in_group".into(), val.to_string()));
          self.r#user_label_length.and_then(|val| map.insert("user_label_length".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.smart_tab_topic
    ///
    /// Recorded when the user saves a tab group label with the ml topic model
    pub static smart_tab_topic: Lazy<EventMetric<SmartTabTopicExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "smart_tab_topic".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(947), meta)
    });

    #[repr(u16)]
    pub enum TabCountInGroupsLabel {
        EInside = 0,
        EOutside = 1,
        __Other__,
    }
    impl From<u16> for TabCountInGroupsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInside,
                1 => Self::EOutside,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TabCountInGroupsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInside => "inside",
                Self::EOutside => "outside",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.tab_count_in_groups
    ///
    /// Records the latest number of tabs in the tab bar, split by being inside a group or outside.
    pub static tab_count_in_groups: Lazy<LabeledMetric<LabeledQuantityMetric, TabCountInGroupsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tab_count_in_groups".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(948), meta, Some(vec![::std::borrow::Cow::from("inside"), ::std::borrow::Cow::from("outside")]))
    });

    #[repr(u16)]
    pub enum TabInteractionsLabel {
        EActivate = 0,
        EAdd = 1,
        EDuplicate = 2,
        ENew = 3,
        ECloseTabstrip = 4,
        ECloseTabmenu = 5,
        EReorder = 6,
        ERemoveSameWindow = 7,
        ERemoveOtherWindow = 8,
        ERemoveNewWindow = 9,
        __Other__,
    }
    impl From<u16> for TabInteractionsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EActivate,
                1 => Self::EAdd,
                2 => Self::EDuplicate,
                3 => Self::ENew,
                4 => Self::ECloseTabstrip,
                5 => Self::ECloseTabmenu,
                6 => Self::EReorder,
                7 => Self::ERemoveSameWindow,
                8 => Self::ERemoveOtherWindow,
                9 => Self::ERemoveNewWindow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TabInteractionsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EActivate => "activate",
                Self::EAdd => "add",
                Self::EDuplicate => "duplicate",
                Self::ENew => "new",
                Self::ECloseTabstrip => "close_tabstrip",
                Self::ECloseTabmenu => "close_tabmenu",
                Self::EReorder => "reorder",
                Self::ERemoveSameWindow => "remove_same_window",
                Self::ERemoveOtherWindow => "remove_other_window",
                Self::ERemoveNewWindow => "remove_new_window",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.tab_interactions
    ///
    /// Records interactions with tabs related to a group: open, add tab to group, duplicate, create a new tab, close a tab, reorder, and remove from group
    pub static tab_interactions: Lazy<LabeledMetric<LabeledCounterMetric, TabInteractionsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tab_interactions".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(949), meta, Some(vec![::std::borrow::Cow::from("activate"), ::std::borrow::Cow::from("add"), ::std::borrow::Cow::from("close_tabmenu"), ::std::borrow::Cow::from("close_tabstrip"), ::std::borrow::Cow::from("duplicate"), ::std::borrow::Cow::from("new"), ::std::borrow::Cow::from("remove_new_window"), ::std::borrow::Cow::from("remove_other_window"), ::std::borrow::Cow::from("remove_same_window"), ::std::borrow::Cow::from("reorder")]))
    });

    #[repr(u16)]
    pub enum TabsPerActiveGroupLabel {
        EMax = 0,
        EMedian = 1,
        EAverage = 2,
        EMin = 3,
        __Other__,
    }
    impl From<u16> for TabsPerActiveGroupLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMax,
                1 => Self::EMedian,
                2 => Self::EAverage,
                3 => Self::EMin,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TabsPerActiveGroupLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMax => "max",
                Self::EMedian => "median",
                Self::EAverage => "average",
                Self::EMin => "min",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.tabs_per_active_group
    ///
    /// Records statistics about the number of tabs per active group: max, median, average and min.
    pub static tabs_per_active_group: Lazy<LabeledMetric<LabeledQuantityMetric, TabsPerActiveGroupLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_per_active_group".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(950), meta, Some(vec![::std::borrow::Cow::from("average"), ::std::borrow::Cow::from("max"), ::std::borrow::Cow::from("median"), ::std::borrow::Cow::from("min")]))
    });

    #[repr(u16)]
    pub enum TabsPerSavedGroupLabel {
        EMax = 0,
        EMedian = 1,
        EAverage = 2,
        EMin = 3,
        __Other__,
    }
    impl From<u16> for TabsPerSavedGroupLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMax,
                1 => Self::EMedian,
                2 => Self::EAverage,
                3 => Self::EMin,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TabsPerSavedGroupLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMax => "max",
                Self::EMedian => "median",
                Self::EAverage => "average",
                Self::EMin => "min",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.tabs_per_saved_group
    ///
    /// Records statistics about the number of tabs per saved tab group: max, median, average and min.
    pub static tabs_per_saved_group: Lazy<LabeledMetric<LabeledQuantityMetric, TabsPerSavedGroupLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_per_saved_group".into(),
                    category: "tabgroup".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(951), meta, Some(vec![::std::borrow::Cow::from("average"), ::std::borrow::Cow::from("max"), ::std::borrow::Cow::from("median"), ::std::borrow::Cow::from("min")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UngroupExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for UngroupExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tabgroup.ungroup
    ///
    /// Recorded when the user ungroups all tabs of a tab group
    pub static ungroup: Lazy<EventMetric<UngroupExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ungroup".into(),
                category: "tabgroup".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(952), meta)
    });

}
pub mod text_recognition {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from text_recognition.api_performance
    ///
    /// The milliseconds of time the text recognition results took to display, including the UI time and OS response time.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TEXT_RECOGNITION_API_PERFORMANCE.
    pub static api_performance: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "api_performance".into(),
                category: "text_recognition".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(953), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from text_recognition.interaction_timing
    ///
    /// The milliseconds of time that a user viewed the text results.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TEXT_RECOGNITION_INTERACTION_TIMING.
    pub static interaction_timing: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "interaction_timing".into(),
                category: "text_recognition".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(954), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from text_recognition.text_length
    ///
    /// Measures the length of the text that was recognized, in code units.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TEXT_RECOGNITION_TEXT_LENGTH.
    pub static text_length: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "text_length".into(),
                category: "text_recognition".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(955), meta, 1, 50000, 20, HistogramType::Exponential)
    });

}
pub mod quick_suggest {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.advertiser
    ///
    /// The name of the advertiser providing the sponsored TopSite.
    pub static advertiser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "advertiser".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(956), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.block_id
    ///
    /// A unique identifier for the suggestion (a.k.a. a keywords block).
    pub static block_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "block_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(957), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.context_id
    ///
    /// An identifier to identify users for Contextual Services user interaction pings.
    pub static context_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "context_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into(), "quick-suggest-deletion-request".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(958), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.iab_category
    ///
    /// The suggestion's category. Either "22 - Shopping" or "5 - Educational".
    pub static iab_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "iab_category".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(959), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.improve_suggest_experience
    ///
    /// Whether the "Improve Suggest Experience" checkbox is checked.
    pub static improve_suggest_experience: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "improve_suggest_experience".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(960), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.is_clicked
    ///
    /// Whether this quicksuggest-impression ping was for an item that was clicked.
    pub static is_clicked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_clicked".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(961), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.match_type
    ///
    /// Whether this was a best/top match or not. Either "best-match" or "firefox-suggest".
    pub static match_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "match_type".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(962), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.ping_type
    ///
    /// The ping's type. In other situations might be designated by an event's name or an interaction field. E.g. "quicksuggest-impression", "quicksuggest-block", "quicksuggest-click".
    pub static ping_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ping_type".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(963), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.position
    ///
    /// The position (1-based) of the QuickSuggest item being interatcted with.
    pub static position: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "position".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(964), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.reporting_url
    ///
    /// The url to report this interaction to.
    pub static reporting_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reporting_url".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(965), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.request_id
    ///
    /// A request identifier for each API request to [Merino](https://mozilla-services.github.io/merino/). Only present for suggestions provided by Merino.
    pub static request_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_id".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(966), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.source
    ///
    /// The source of the interaction. E.g. "urlbar".
    pub static source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "source".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(967), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index
    ///
    /// A stringified integer value that is the intended index of the suggestion being interacted with. If `suggested_index_relative_to_group` is true, the index is relative to the "Firefox Suggest" group; otherwise the index is relative to the entire list of suggestions. Non-negative values (starting at 0) are relative to the start/top of the group/list; negative values are relative to the end/bottom of the group/list.
    pub static suggested_index: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suggested_index".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(968), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from quick_suggest.suggested_index_relative_to_group
    ///
    /// Whether `suggested_index` is relative to the "Firefox Suggest" group. If false, it is relative to the entire list of suggestions.
    pub static suggested_index_relative_to_group: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suggested_index_relative_to_group".into(),
                category: "quick_suggest".into(),
                send_in_pings: vec!["quick-suggest".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(969), meta)
    });

}
pub mod suggest {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum IngestDownloadTimeLabel {
        EIcon = 0,
        EAmp = 1,
        EWikipedia = 2,
        EAmoSuggestions = 3,
        EPocketSuggestions = 4,
        EYelpSuggestions = 5,
        EMdnSuggestions = 6,
        EWeather = 7,
        EConfiguration = 8,
        EFakespotSuggestions = 9,
        __Other__,
    }
    impl From<u16> for IngestDownloadTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIcon,
                1 => Self::EAmp,
                2 => Self::EWikipedia,
                3 => Self::EAmoSuggestions,
                4 => Self::EPocketSuggestions,
                5 => Self::EYelpSuggestions,
                6 => Self::EMdnSuggestions,
                7 => Self::EWeather,
                8 => Self::EConfiguration,
                9 => Self::EFakespotSuggestions,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IngestDownloadTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIcon => "icon",
                Self::EAmp => "amp",
                Self::EWikipedia => "wikipedia",
                Self::EAmoSuggestions => "amo-suggestions",
                Self::EPocketSuggestions => "pocket-suggestions",
                Self::EYelpSuggestions => "yelp-suggestions",
                Self::EMdnSuggestions => "mdn-suggestions",
                Self::EWeather => "weather",
                Self::EConfiguration => "configuration",
                Self::EFakespotSuggestions => "fakespot-suggestions",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.ingest_download_time
    ///
    /// Download time for ingestion, labelled by record type
    pub static ingest_download_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, IngestDownloadTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "ingest_download_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(BaseMetricId(970), meta, Some(vec![::std::borrow::Cow::from("amo-suggestions"), ::std::borrow::Cow::from("amp"), ::std::borrow::Cow::from("configuration"), ::std::borrow::Cow::from("fakespot-suggestions"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("mdn-suggestions"), ::std::borrow::Cow::from("pocket-suggestions"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("wikipedia"), ::std::borrow::Cow::from("yelp-suggestions")]))
    });

    #[repr(u16)]
    pub enum IngestTimeLabel {
        EIcon = 0,
        EAmp = 1,
        EWikipedia = 2,
        EAmoSuggestions = 3,
        EPocketSuggestions = 4,
        EYelpSuggestions = 5,
        EMdnSuggestions = 6,
        EWeather = 7,
        EConfiguration = 8,
        EFakespotSuggestions = 9,
        __Other__,
    }
    impl From<u16> for IngestTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIcon,
                1 => Self::EAmp,
                2 => Self::EWikipedia,
                3 => Self::EAmoSuggestions,
                4 => Self::EPocketSuggestions,
                5 => Self::EYelpSuggestions,
                6 => Self::EMdnSuggestions,
                7 => Self::EWeather,
                8 => Self::EConfiguration,
                9 => Self::EFakespotSuggestions,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IngestTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIcon => "icon",
                Self::EAmp => "amp",
                Self::EWikipedia => "wikipedia",
                Self::EAmoSuggestions => "amo-suggestions",
                Self::EPocketSuggestions => "pocket-suggestions",
                Self::EYelpSuggestions => "yelp-suggestions",
                Self::EMdnSuggestions => "mdn-suggestions",
                Self::EWeather => "weather",
                Self::EConfiguration => "configuration",
                Self::EFakespotSuggestions => "fakespot-suggestions",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.ingest_time
    ///
    /// Time for ingestion (excluding download time), labelled by record type
    pub static ingest_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, IngestTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "ingest_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(BaseMetricId(971), meta, Some(vec![::std::borrow::Cow::from("amo-suggestions"), ::std::borrow::Cow::from("amp"), ::std::borrow::Cow::from("configuration"), ::std::borrow::Cow::from("fakespot-suggestions"), ::std::borrow::Cow::from("icon"), ::std::borrow::Cow::from("mdn-suggestions"), ::std::borrow::Cow::from("pocket-suggestions"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("wikipedia"), ::std::borrow::Cow::from("yelp-suggestions")]))
    });

    #[repr(u16)]
    pub enum QueryTimeLabel {
        EAmp = 0,
        EWikipedia = 1,
        EAmo = 2,
        EPocket = 3,
        EYelp = 4,
        EMdn = 5,
        EWeather = 6,
        EFakespot = 7,
        __Other__,
    }
    impl From<u16> for QueryTimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAmp,
                1 => Self::EWikipedia,
                2 => Self::EAmo,
                3 => Self::EPocket,
                4 => Self::EYelp,
                5 => Self::EMdn,
                6 => Self::EWeather,
                7 => Self::EFakespot,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for QueryTimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAmp => "amp",
                Self::EWikipedia => "wikipedia",
                Self::EAmo => "amo",
                Self::EPocket => "pocket",
                Self::EYelp => "yelp",
                Self::EMdn => "mdn",
                Self::EWeather => "weather",
                Self::EFakespot => "fakespot",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest.query_time
    ///
    /// Time executing queries, labelled by provider type
    pub static query_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, QueryTimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "query_time".into(),
                    category: "suggest".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(BaseMetricId(972), meta, Some(vec![::std::borrow::Cow::from("amo"), ::std::borrow::Cow::from("amp"), ::std::borrow::Cow::from("fakespot"), ::std::borrow::Cow::from("mdn"), ::std::borrow::Cow::from("pocket"), ::std::borrow::Cow::from("weather"), ::std::borrow::Cow::from("wikipedia"), ::std::borrow::Cow::from("yelp")]))
    });

}
pub mod suggest_relevance {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum OutcomeLabel {
        EBoosted = 0,
        EDecreased = 1,
        __Other__,
    }
    impl From<u16> for OutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBoosted,
                1 => Self::EDecreased,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for OutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBoosted => "boosted",
                Self::EDecreased => "decreased",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest_relevance.outcome
    ///
    /// For each successful scoring, count whether the relevance score gets boosted or decreased over the original score. Note that given how the score is calculated, it's practically impossible to have the two scores tied. If that's the case anyhow, it will increment the "boosted" counter.
    pub static outcome: Lazy<LabeledMetric<LabeledCounterMetric, OutcomeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "outcome".into(),
                    category: "suggest_relevance".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(973), meta, Some(vec![::std::borrow::Cow::from("boosted"), ::std::borrow::Cow::from("decreased")]))
    });

    #[repr(u16)]
    pub enum StatusLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for StatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from suggest_relevance.status
    ///
    /// Count the successful / failed attempts of relevance scoring in Firefox Suggest.
    pub static status: Lazy<LabeledMetric<LabeledCounterMetric, StatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "status".into(),
                    category: "suggest_relevance".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(974), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

}
pub mod urlbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AbandonmentExtra {
        pub r#abandonment_type: Option<String>,
        pub r#actions: Option<String>,
        pub r#groups: Option<String>,
        pub r#interaction: Option<String>,
        pub r#n_chars: Option<u32>,
        pub r#n_results: Option<u32>,
        pub r#n_words: Option<u32>,
        pub r#results: Option<String>,
        pub r#sap: Option<String>,
        pub r#search_engine_default_id: Option<String>,
        pub r#search_mode: Option<String>,
    }

    impl ExtraKeys for AbandonmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["abandonment_type", "actions", "groups", "interaction", "n_chars", "n_results", "n_words", "results", "sap", "search_engine_default_id", "search_mode"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#abandonment_type.and_then(|val| map.insert("abandonment_type".into(), val.to_string()));
          self.r#actions.and_then(|val| map.insert("actions".into(), val.to_string()));
          self.r#groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.r#n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.r#n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.r#search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.r#search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.abandonment
    ///
    /// Recorded when the user abandons a search (blurring the urlbar).
    pub static abandonment: Lazy<EventMetric<AbandonmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abandonment".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(975), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.autocomplete_first_result_time
    ///
    /// PLACES: Time for first autocomplete result if > 50ms (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_AUTOCOMPLETE_1ST_RESULT_TIME_MS.
    pub static autocomplete_first_result_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_first_result_time".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(976), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.autocomplete_sixth_result_time
    ///
    /// PLACES: Time for the 6 first autocomplete results (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_AUTOCOMPLETE_6_FIRST_RESULTS_TIME_MS.
    pub static autocomplete_sixth_result_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_sixth_result_time".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(977), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.autofill_deletion
    ///
    /// A uint recording the deletion count for autofilled string in the urlbar. This occurs when the user deletes whole autofilled string by BACKSPACE or DELETE key while the autofilled string is selected. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.autofill_deletion.
    pub static autofill_deletion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            978,
            "urlbar",
            "autofill_deletion",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EngagementExtra {
        pub r#actions: Option<String>,
        pub r#engagement_type: Option<String>,
        pub r#groups: Option<String>,
        pub r#interaction: Option<String>,
        pub r#n_chars: Option<u32>,
        pub r#n_results: Option<u32>,
        pub r#n_words: Option<u32>,
        pub r#provider: Option<String>,
        pub r#results: Option<String>,
        pub r#sap: Option<String>,
        pub r#search_engine_default_id: Option<String>,
        pub r#search_mode: Option<String>,
        pub r#selected_position: Option<u32>,
        pub r#selected_result: Option<String>,
    }

    impl ExtraKeys for EngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["actions", "engagement_type", "groups", "interaction", "n_chars", "n_results", "n_words", "provider", "results", "sap", "search_engine_default_id", "search_mode", "selected_position", "selected_result"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#actions.and_then(|val| map.insert("actions".into(), val.to_string()));
          self.r#engagement_type.and_then(|val| map.insert("engagement_type".into(), val.to_string()));
          self.r#groups.and_then(|val| map.insert("groups".into(), val.to_string()));
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#n_chars.and_then(|val| map.insert("n_chars".into(), val.to_string()));
          self.r#n_results.and_then(|val| map.insert("n_results".into(), val.to_string()));
          self.r#n_words.and_then(|val| map.insert("n_words".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#sap.and_then(|val| map.insert("sap".into(), val.to_string()));
          self.r#search_engine_default_id.and_then(|val| map.insert("search_engine_default_id".into(), val.to_string()));
          self.r#search_mode.and_then(|val| map.insert("search_mode".into(), val.to_string()));
          self.r#selected_position.and_then(|val| map.insert("selected_position".into(), val.to_string()));
          self.r#selected_result.and_then(|val| map.insert("selected_result".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.engagement
    ///
    /// Recorded when the user executes an action on a result.
    pub static engagement: Lazy<EventMetric<EngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engagement".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(979), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposureExtra {
        pub r#results: Option<String>,
        pub r#terminal: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["results", "terminal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#terminal.and_then(|val| map.insert("terminal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.exposure
    ///
    /// Recorded when client is exposed to urlbar experiment results.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exposure".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(980), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FakespotEngagementExtra {
        pub r#grade: Option<String>,
        pub r#provider: Option<String>,
        pub r#rating: Option<String>,
    }

    impl ExtraKeys for FakespotEngagementExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["grade", "provider", "rating"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#grade.and_then(|val| map.insert("grade".into(), val.to_string()));
          self.r#provider.and_then(|val| map.insert("provider".into(), val.to_string()));
          self.r#rating.and_then(|val| map.insert("rating".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.fakespot_engagement
    ///
    /// Recorded when the user engages with a Fakespot suggestion.
    pub static fakespot_engagement: Lazy<EventMetric<FakespotEngagementExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fakespot_engagement".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(981), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct KeywordExposureExtra {
        pub r#keyword: Option<String>,
        pub r#result: Option<String>,
        pub r#terminal: Option<bool>,
    }

    impl ExtraKeys for KeywordExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["keyword", "result", "terminal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#keyword.and_then(|val| map.insert("keyword".into(), val.to_string()));
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#terminal.and_then(|val| map.insert("terminal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.keyword_exposure
    ///
    /// When keyword exposures are enabled, this event is recorded in the `urlbar-keyword-exposure` ping, which is submitted at the end of urlbar sessions during which one or more exposure results are matched. The ping will contain one `keyword_exposure` event for each instance where a result is matched during the session. See the `urlbar-keyword-exposure` ping for details.
    pub static keyword_exposure: Lazy<EventMetric<KeywordExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyword_exposure".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["urlbar-keyword-exposure".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(982), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_max_results
    ///
    /// Maximum results to show in the Address Bar. Corresponds to the value of the `browser.urlbar.maxRichResults` pref.
    pub static pref_max_results: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_max_results".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(983), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_data_collection
    ///
    /// Whether the user has opted in to data collection for Firefox Suggest, i.e., online suggestions served from Merino. Corresponds to the value of the `browser.urlbar.quicksuggest.dataCollection.enabled` pref.
    pub static pref_suggest_data_collection: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_data_collection".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(984), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_nonsponsored
    ///
    /// Whether non-sponsored quick suggest results are shown in the urlbar. Corresponds to the value of the `browser.urlbar.suggest.quicksuggest.nonsponsored` pref.
    pub static pref_suggest_nonsponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_nonsponsored".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(985), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_sponsored
    ///
    /// Whether sponsored quick suggest results are shown in the urlbar. Corresponds to the value of the `browser.urlbar.suggest.quicksuggest.sponsored` pref.
    pub static pref_suggest_sponsored: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_sponsored".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(986), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.pref_suggest_topsites
    ///
    /// Whether topsite results are enabled in the urlbar. Corresponds to the value of the `browser.urlbar.suggest.topsites` pref.
    pub static pref_suggest_topsites: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_suggest_topsites".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(987), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct QuickSuggestContextualOptInExtra {
        pub r#interaction: Option<String>,
        pub r#say_hello: Option<bool>,
        pub r#top_position: Option<bool>,
    }

    impl ExtraKeys for QuickSuggestContextualOptInExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["interaction", "say_hello", "top_position"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#interaction.and_then(|val| map.insert("interaction".into(), val.to_string()));
          self.r#say_hello.and_then(|val| map.insert("say_hello".into(), val.to_string()));
          self.r#top_position.and_then(|val| map.insert("top_position".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlbar.quick_suggest_contextual_opt_in
    ///
    /// Recorded when the contextual opt-in UI is shown or interacted with.
    pub static quick_suggest_contextual_opt_in: Lazy<EventMetric<QuickSuggestContextualOptInExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "quick_suggest_contextual_opt_in".into(),
                category: "urlbar".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(988), meta)
    });

}
pub mod urlbar_persistedsearchterms {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.persistedsearchterms.revert_by_popup_count
    ///
    /// The count of the number of times search terms were removed from the urlbar due to a shown PopupNotification. This event can happen when a user loads a SERP and a PopupNotification is shown, as well as when a user switches away from a tab on a SERP showing a PopupNotification and switches back to it. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.persistedsearchterms.revert_by_popup_count.
    pub static revert_by_popup_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            989,
            "urlbar.persistedsearchterms",
            "revert_by_popup_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.persistedsearchterms.view_count
    ///
    /// The count of the number of times search terms persisted in the Urlbar. This gets recorded after a user loads a SERP that persists search terms, or switches back to an existing tab that should be showing the persisted search terms in the Urlbar, regardless of whether PopupNotification cleared the search terms from the Urlbar. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.persistedsearchterms.view_count.
    pub static view_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            990,
            "urlbar.persistedsearchterms",
            "view_count",
            "metrics"
        )
    });

}
pub mod urlbar_quickaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.quickaction.picked
    ///
    /// Counts how many times quickaction results were selected. The key is the in the form "actionkey-N" where N is the number of characters the user typed to be shown the action. This metric was generated to correspond to the Legacy Telemetry scalar quickaction.picked.
    pub static picked: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "picked".into(),
                    category: "urlbar.quickaction".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(991), meta, None)
    });

}
pub mod urlbar_trending {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.trending.block
    ///
    /// User has blocked seeing trending results. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.trending.block.
    pub static block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            992,
            "urlbar.trending",
            "block",
            "metrics"
        )
    });

}
pub mod urlbar_unifiedsearchbutton {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.unifiedsearchbutton.opened
    ///
    /// Counts how many times Unified Search Button popup is opened. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.unifiedsearchbutton.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            993,
            "urlbar.unifiedsearchbutton",
            "opened",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.unifiedsearchbutton.picked
    ///
    /// Counts how many times Unified Search Button items were selected. The key is followings. * builtin_search: Builtin search engine. * addon_search: Addon search engine. * local_search: Local search engine such as Bookmarks. * settings: Settings menu. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.unifiedsearchbutton.picked.
    pub static picked: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "picked".into(),
                    category: "urlbar.unifiedsearchbutton".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(994), meta, None)
    });

}
pub mod urlbar_zeroprefix {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.zeroprefix.abandonment
    ///
    /// Counts how many times the zero-prefix urlbar results panel was abandoned. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.zeroprefix.abandonment.
    pub static abandonment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            995,
            "urlbar.zeroprefix",
            "abandonment",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.zeroprefix.engagement
    ///
    /// Counts how many times a result was picked in the zero-prefix urlbar results panel. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.zeroprefix.engagement.
    pub static engagement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            996,
            "urlbar.zeroprefix",
            "engagement",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlbar.zeroprefix.exposure
    ///
    /// Counts how many times the zero-prefix urlbar results panel was shown to the user. This metric was generated to correspond to the Legacy Telemetry scalar urlbar.zeroprefix.exposure.
    pub static exposure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            997,
            "urlbar.zeroprefix",
            "exposure",
            "metrics"
        )
    });

}
pub mod addons_search_detection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EtldChangeOtherExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#from: Option<String>,
        pub r#to: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EtldChangeOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "from", "to", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#from.and_then(|val| map.insert("from".into(), val.to_string()));
          self.r#to.and_then(|val| map.insert("to".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons.search_detection.etld_change_other
    ///
    /// Recorded when a request for a search query is redirected to another
    /// domain via something other than the `webRequest` API.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// addonsSearchDetection.etld_change#other.
    pub static etld_change_other: Lazy<EventMetric<EtldChangeOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "etld_change_other".into(),
                category: "addons.search_detection".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(998), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EtldChangeWebrequestExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#from: Option<String>,
        pub r#to: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EtldChangeWebrequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "from", "to", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#from.and_then(|val| map.insert("from".into(), val.to_string()));
          self.r#to.and_then(|val| map.insert("to".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons.search_detection.etld_change_webrequest
    ///
    /// Recorded when a request for a search query is redirected to another
    /// domain via the `webRequest` API.
    /// This event was generated to correspond to the Legacy Telemetry event
    /// addonsSearchDetection.etld_change#webrequest.
    pub static etld_change_webrequest: Lazy<EventMetric<EtldChangeWebrequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "etld_change_webrequest".into(),
                category: "addons.search_detection".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(999), meta)
    });

}
pub mod browser_content_crash {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.content_crash.dump_unavailable
    ///
    /// Counts the number of times that about:tabcrashed was unable to find a crash dump.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram FX_CONTENT_CRASH_DUMP_UNAVAILABLE.
    pub static dump_unavailable: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1000,
            "browser.content_crash",
            "dump_unavailable",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.content_crash.not_submitted
    ///
    /// Counts the number of times that about:tabcrashed was unloaded without submitting.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram FX_CONTENT_CRASH_NOT_SUBMITTED.
    pub static not_submitted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1001,
            "browser.content_crash",
            "not_submitted",
            "metrics"
        )
    });

}
pub mod browser_sanitizer {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.cache
    ///
    /// Sanitize: Time it takes to sanitize the cache (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_CACHE.
    pub static cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1002), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.cookies
    ///
    /// Sanitize: Time it takes to sanitize firefox cookies (ms). A subset of FX_SANITIZE_COOKIES.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_COOKIES_2.
    pub static cookies: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookies".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1003), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.downloads
    ///
    /// Sanitize: Time it takes to sanitize recent downloads (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_DOWNLOADS.
    pub static downloads: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downloads".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1004), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.formdata
    ///
    /// Sanitize: Time it takes to sanitize stored form data (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_FORMDATA.
    pub static formdata: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "formdata".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1005), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.history
    ///
    /// Sanitize: Time it takes to sanitize history (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_HISTORY.
    pub static history: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "history".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1006), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.openwindows
    ///
    /// Sanitize: Time it takes to sanitize the open windows list (ms). On Android, this is the time it takes to close all open tabs (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_OPENWINDOWS.
    pub static openwindows: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "openwindows".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1007), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.sessions
    ///
    /// Sanitize: Time it takes to sanitize saved sessions (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_SESSIONS.
    pub static sessions: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sessions".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1008), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.sitesettings
    ///
    /// Sanitize: Time it takes to sanitize site-specific settings (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_SITESETTINGS.
    pub static sitesettings: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sitesettings".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1009), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.sanitizer.total
    ///
    /// Sanitize: Total time it takes to sanitize (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_SANITIZE_TOTAL.
    pub static total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "browser.sanitizer".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1010), meta, TimeUnit::Millisecond)
    });

}
pub mod browser_ui {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.customized_widgets
    ///
    /// Records when widgets are added, removed or moved in the UI. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.customized_widgets.
    pub static customized_widgets: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "customized_widgets".into(),
                    category: "browser.ui".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1011), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.mirror_for_toolbar_widgets
    ///
    /// The widgets in the toolbars. See https://firefox-source- docs.mozilla.org/browser/BrowserUsageTelemetry.html This metric was generated to correspond to the Legacy Telemetry scalar browser.ui.toolbar_widgets.
    pub static mirror_for_toolbar_widgets: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mirror_for_toolbar_widgets".into(),
                    category: "browser.ui".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1012), meta, None)
    });

        pub type ToolbarWidgetsObject = Vec<ToolbarWidgetsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ToolbarWidgetsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub position: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub widgetId: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from browser.ui.toolbar_widgets
    ///
    /// What widgets are in which toolbars. Not dissimilar from Telemetry's `browser.ui.toolbar_widgets`, but in a friendlier format. See https://firefox-source-docs.mozilla.org/browser/BrowserUsageTelemetry.html for how widget ids and positions are determined.
    pub static toolbar_widgets: Lazy<ObjectMetric<ToolbarWidgetsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toolbar_widgets".into(),
                category: "browser.ui".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(1013), meta)
    });

}
pub mod browser_usage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InteractionExtra {
        pub r#flow_id: Option<String>,
        pub r#source: Option<String>,
        pub r#widget_id: Option<String>,
    }

    impl ExtraKeys for InteractionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "source", "widget_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#widget_id.and_then(|val| map.insert("widget_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from browser.usage.interaction
    ///
    /// The user interacted with something in the Firefox Desktop frontend. Could be via mouse or keyboard, could be a command or a UI element.
    pub static interaction: Lazy<EventMetric<InteractionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "interaction".into(),
                category: "browser.usage".into(),
                send_in_pings: vec!["prototype-no-code-events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1014), meta)
    });

}
pub mod homepage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PreferenceIgnoreExtra {
        pub r#value: Option<String>,
        pub r#webExtensionId: Option<String>,
    }

    impl ExtraKeys for PreferenceIgnoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value", "webExtensionId"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#webExtensionId.and_then(|val| map.insert("webExtensionId".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from homepage.preference_ignore
    ///
    /// This is recorded whenever the homepage preference is either reset due to being on the ignore list, or setting is blocked due to being on the same list. The value field records the reason for the ignore. "saved_reset" for when a saved preference value is reset. "set_blocked" for when the setting was blocked and "set_blocked_extension" for when we know a WebExtension attempting to set it was blocked. This event was generated to correspond to the Legacy Telemetry event homepage.preference#ignore.
    pub static preference_ignore: Lazy<EventMetric<PreferenceIgnoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preference_ignore".into(),
                category: "homepage".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1015), meta)
    });

}
pub mod installation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenFullExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenFullExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_full
    ///
    /// Recorded after the application has been installed or reinstalled, the first time that a profile sees that there was a new installation. This includes information about how the installer was run. This event was generated to correspond to the Legacy Telemetry event installation.first_seen#full.
    pub static first_seen_full: Lazy<EventMetric<FirstSeenFullExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_full".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1016), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenMsixExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenMsixExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_msix
    ///
    /// Recorded after the application has been installed or reinstalled, the first time that a profile sees that there was a new installation. This includes information about how the installer was run. This event was generated to correspond to the Legacy Telemetry event installation.first_seen#msix.
    pub static first_seen_msix: Lazy<EventMetric<FirstSeenMsixExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_msix".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1017), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstSeenStubExtra {
        pub r#admin_user: Option<String>,
        pub r#build_id: Option<String>,
        pub r#default_path: Option<String>,
        pub r#from_msi: Option<String>,
        pub r#install_existed: Option<String>,
        pub r#other_inst: Option<String>,
        pub r#other_msix_inst: Option<String>,
        pub r#profdir_existed: Option<String>,
        pub r#silent: Option<String>,
        pub r#version: Option<String>,
    }

    impl ExtraKeys for FirstSeenStubExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["admin_user", "build_id", "default_path", "from_msi", "install_existed", "other_inst", "other_msix_inst", "profdir_existed", "silent", "version"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#admin_user.and_then(|val| map.insert("admin_user".into(), val.to_string()));
          self.r#build_id.and_then(|val| map.insert("build_id".into(), val.to_string()));
          self.r#default_path.and_then(|val| map.insert("default_path".into(), val.to_string()));
          self.r#from_msi.and_then(|val| map.insert("from_msi".into(), val.to_string()));
          self.r#install_existed.and_then(|val| map.insert("install_existed".into(), val.to_string()));
          self.r#other_inst.and_then(|val| map.insert("other_inst".into(), val.to_string()));
          self.r#other_msix_inst.and_then(|val| map.insert("other_msix_inst".into(), val.to_string()));
          self.r#profdir_existed.and_then(|val| map.insert("profdir_existed".into(), val.to_string()));
          self.r#silent.and_then(|val| map.insert("silent".into(), val.to_string()));
          self.r#version.and_then(|val| map.insert("version".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen_stub
    ///
    /// Recorded after the application has been installed or reinstalled, the first time that a profile sees that there was a new installation. This includes information about how the installer was run. This event was generated to correspond to the Legacy Telemetry event installation.first_seen#stub.
    pub static first_seen_stub: Lazy<EventMetric<FirstSeenStubExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_seen_stub".into(),
                category: "installation".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1018), meta)
    });

}
pub mod installation_first_seen {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.admin_user
    ///
    /// Whether the installer is running from an elevated admin user
    pub static admin_user: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "admin_user".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1019), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.default_path
    ///
    /// (optional, present if installer_type is "full") Whether the default path was used
    pub static default_path: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_path".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1020), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.failure_reason
    ///
    /// Only sent if unable to collect firstSeen data. Can have value "NotFoundError" if file not found or other values depending on the failure reason.
    pub static failure_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure_reason".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(1021), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.from_msi
    ///
    /// (optional, present if installer_type is "full") Whether this was an MSI install
    pub static from_msi: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_msi".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1022), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.install_existed
    ///
    /// Whether there was already an install in this location
    pub static install_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_existed".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1023), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.installer_type
    ///
    /// The type of installer used to install Firefox. The value is one of "stub", "full", or "msix"
    pub static installer_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "installer_type".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(1024), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_inst
    ///
    /// Whether there was already any non-MSIX install on this system
    pub static other_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "other_inst".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1025), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.other_msix_inst
    ///
    /// Whether there was already any MSIX install on this system
    pub static other_msix_inst: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "other_msix_inst".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1026), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.profdir_existed
    ///
    /// Whether the top-level profile directory existed
    pub static profdir_existed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profdir_existed".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1027), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.silent
    ///
    /// (optional, present if installer_type is "full") Whether this was a silent install
    pub static silent: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "silent".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1028), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from installation.first_seen.version
    ///
    /// The application version installed by the installer (not necessarily the current version)
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "installation.first_seen".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(1029), meta)
    });

}
pub mod link_icon_sizes_attr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from link_icon_sizes_attr.dimension
    ///
    /// The width dimension of the 'sizes' attribute for <link rel=icon>.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram LINK_ICON_SIZES_ATTR_DIMENSION.
    pub static dimension: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dimension".into(),
                category: "link_icon_sizes_attr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1030), meta, 1, 513, 64, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from link_icon_sizes_attr.usage
    ///
    /// The possible types of the 'sizes' attribute for <link rel=icon>. 0: Attribute not specified, 1: 'any', 2: Integer dimensions, 3: Invalid value.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram LINK_ICON_SIZES_ATTR_USAGE.
    pub static usage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "usage".into(),
                category: "link_icon_sizes_attr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1031), meta, 0, 4, 5, HistogramType::Linear)
    });

}
pub mod partner_link {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionAbortExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionAbortExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_abort
    ///
    /// This is recorded when sending an attribution request for a partner link. The value is the partner. This event was generated to correspond to the Legacy Telemetry event partner_link.attribution#abort.
    pub static attribution_abort: Lazy<EventMetric<AttributionAbortExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_abort".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1032), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionFailureExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionFailureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_failure
    ///
    /// This is recorded when sending an attribution request for a partner link. The value is the partner. This event was generated to correspond to the Legacy Telemetry event partner_link.attribution#failure.
    pub static attribution_failure: Lazy<EventMetric<AttributionFailureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_failure".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1033), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AttributionSuccessExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AttributionSuccessExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.attribution_success
    ///
    /// This is recorded when sending an attribution request for a partner link. The value is the partner. This event was generated to correspond to the Legacy Telemetry event partner_link.attribution#success.
    pub static attribution_success: Lazy<EventMetric<AttributionSuccessExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_success".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1034), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickNewtabExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickNewtabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.click_newtab
    ///
    /// This is recorded when clicking a partner link. The value is the partner. This event was generated to correspond to the Legacy Telemetry event partner_link.click#newtab.
    pub static click_newtab: Lazy<EventMetric<ClickNewtabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_newtab".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1035), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUrlbarExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickUrlbarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from partner_link.click_urlbar
    ///
    /// This is recorded when clicking a partner link. The value is the partner. This event was generated to correspond to the Legacy Telemetry event partner_link.click#urlbar.
    pub static click_urlbar: Lazy<EventMetric<ClickUrlbarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_urlbar".into(),
                category: "partner_link".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1036), meta)
    });

}
pub mod performance_interaction {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.tab_switch_composite
    ///
    /// Time between tab selection and first composite of the tab content onto the screen. (Migrated from the geckoview metric of the same name.)
    pub static tab_switch_composite: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tab_switch_composite".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1037), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.keypress_present_latency
    ///
    /// Time between receiving a keypress event in the event loop and compositing its result onto the screen. (Migrated from the geckoview metric of the same name).
    pub static keypress_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keypress_present_latency".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1038), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.interaction.mouseup_click_present_latency
    ///
    /// Time between receiving a mouseup which follow by a mouseclick on the event loop and compositing its result onto the screen. (Migrated from the geckoview metric of the same name).
    pub static mouseup_click_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mouseup_click_present_latency".into(),
                category: "performance.interaction".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1039), meta, TimeUnit::Millisecond)
    });

}
pub mod timestamps {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from timestamps.about_home_topsites_first_paint
    ///
    /// Record the timestamp of when the first about:home's Topsites are painted. Only records if about:home is set as the default homepage, and if sessions are not being restored by default. This metric was generated to correspond to the Legacy Telemetry scalar timestamps.about_home_topsites_first_paint.
    pub static about_home_topsites_first_paint: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "about_home_topsites_first_paint".into(),
                category: "timestamps".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(1040), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from timestamps.first_paint
    ///
    /// Record the timestamp of the first content window paint, in milliseconds since process start. This metric was generated to correspond to the Legacy Telemetry scalar timestamps.first_paint.
    pub static first_paint: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_paint".into(),
                category: "timestamps".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(1041), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from timestamps.first_paint_two
    ///
    /// Record the timestamp of the first main window paint, in milliseconds since process start. Intended to replace first_paint since first_paint is broken. This metric was generated to correspond to the Legacy Telemetry scalar timestamps.first_paint_two.
    pub static first_paint_two: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_paint_two".into(),
                category: "timestamps".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(1042), meta)
    });

}
pub mod devtools_accessibility {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.accessible_context_menu_item_activated
    ///
    /// Number of times a context menu item for an accessible object was activated (with mouse or keyboard) from the context menu opened in the accessibility tree. Keyed by the id of the context menu item. This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.accessible_context_menu_item_activated.
    pub static accessible_context_menu_item_activated: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "accessible_context_menu_item_activated".into(),
                    category: "devtools.accessibility".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1043), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.accessible_context_menu_opened
    ///
    /// Number of times a context menu was opened for an accessible object in the accessibility tree. This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.accessible_context_menu_opened.
    pub static accessible_context_menu_opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1044,
            "devtools.accessibility",
            "accessible_context_menu_opened",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.audit_activated
    ///
    /// Number of times accessibility audit was activated (with mouse or keyboard) from the accessibility panel's toolbar. Keyed by the audit filter type (e.g. "CONTRAST"). This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.audit_activated.
    pub static audit_activated: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "audit_activated".into(),
                    category: "devtools.accessibility".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1045), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.node_inspected_count
    ///
    /// Number of times a DOM node was inspected from within the Accessibility tool. This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.node_inspected_count.
    pub static node_inspected_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1046,
            "devtools.accessibility",
            "node_inspected_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.select_accessible_for_node
    ///
    /// Number of times an accessible object was inspected from outside the Accessibility tool (navigation to Accessibility panel). Keyed by the source of user action (inspector context menu, browser context menu, etc). This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.select_accessible_for_node.
    pub static select_accessible_for_node: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "select_accessible_for_node".into(),
                    category: "devtools.accessibility".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1047), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.simulation_activated
    ///
    /// Number of times accessibility simulation was activated (with mouse or keyboard) from the accessibility panel's toolbar. Keyed by the simulation type (e.g. "DEUTERANOPIA"). This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.simulation_activated.
    pub static simulation_activated: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "simulation_activated".into(),
                    category: "devtools.accessibility".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1048), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.opened_count
    ///
    /// Number of times the DevTools Accessibility tool has been opened. This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.opened_count.
    pub static opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1049,
            "devtools.accessibility",
            "opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility.picker_used_count
    ///
    /// Number of times the picker tool has been used in DevTools Accessibility panel. This metric was generated to correspond to the Legacy Telemetry scalar devtools.accessibility.picker_used_count.
    pub static picker_used_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1050,
            "devtools.accessibility",
            "picker_used_count",
            "metrics"
        )
    });

}
pub mod devtools {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.cold_toolbox_open_delay
    ///
    /// Time taken (in ms) to open the first DevTools toolbox. This is keyed by tool ID being opened [inspector, webconsole, jsdebugger, styleeditor, performance, memory, netmonitor, storage, dom].
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_COLD_TOOLBOX_OPEN_DELAY_MS.
    pub static cold_toolbox_open_delay: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "cold_toolbox_open_delay".into(),
                    category: "devtools".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(1051), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.current_theme
    ///
    /// Number of times DevTools was opened, keyed by theme. This metric was generated to correspond to the Legacy Telemetry scalar devtools.current_theme.
    pub static current_theme: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "current_theme".into(),
                    category: "devtools".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1052), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.toolbox_host
    ///
    /// Records DevTools toolbox host each time the toolbox is opened and when the host is changed (0:Bottom, 1:RIGHT, 2:WINDOW, 3:CUSTOM, 4:LEFT, 5:PAGE, 9:Unknown).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DEVTOOLS_TOOLBOX_HOST.
    pub static toolbox_host: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toolbox_host".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1053), meta, 0, 9, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.toolbox_page_reload_delay
    ///
    /// Time taken (in ms) to update DevTools panel when reloading a page. This is keyed by tool ID being currently opened [inspector, webconsole, jsdebugger, styleeditor, performance, memory, netmonitor, storage, dom].
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_TOOLBOX_PAGE_RELOAD_DELAY_MS.
    pub static toolbox_page_reload_delay: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "toolbox_page_reload_delay".into(),
                    category: "devtools".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(1054), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.warm_toolbox_open_delay
    ///
    /// Time taken (in ms) to open all but first DevTools toolbox. This is keyed by tool ID being opened [inspector, webconsole, jsdebugger, styleeditor, performance, memory, netmonitor, storage, dom].
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_WARM_TOOLBOX_OPEN_DELAY_MS.
    pub static warm_toolbox_open_delay: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "warm_toolbox_open_delay".into(),
                    category: "devtools".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(1055), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.aboutdebugging_opened_count
    ///
    /// Number of times about:debugging has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_ABOUTDEBUGGING_OPENED_COUNT.
    pub static aboutdebugging_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1056,
            "devtools",
            "aboutdebugging_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.aboutdebugging_time_active
    ///
    /// How long has about:debugging been active? (seconds) (bug 1204601)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_ABOUTDEBUGGING_TIME_ACTIVE_SECONDS.
    pub static aboutdebugging_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "aboutdebugging_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1057), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility_picker_time_active
    ///
    /// How long has the picker tool in accessibility panel been active (seconds).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_ACCESSIBILITY_PICKER_TIME_ACTIVE_SECONDS.
    pub static accessibility_picker_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accessibility_picker_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1058), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility_service_time_active
    ///
    /// How long has the platform accessibility been active (seconds) in accessibility panel.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_ACCESSIBILITY_SERVICE_TIME_ACTIVE_SECONDS.
    pub static accessibility_service_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accessibility_service_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1059), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.accessibility_time_active
    ///
    /// How long has the accessibility panel been active (seconds).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_ACCESSIBILITY_TIME_ACTIVE_SECONDS.
    pub static accessibility_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accessibility_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1060), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.animationinspector_opened_count
    ///
    /// Number of times the DevTools Animation Inspector has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_ANIMATIONINSPECTOR_OPENED_COUNT.
    pub static animationinspector_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1061,
            "devtools",
            "animationinspector_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.animationinspector_time_active
    ///
    /// How long has the animation inspector been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_ANIMATIONINSPECTOR_TIME_ACTIVE_SECONDS.
    pub static animationinspector_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "animationinspector_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1062), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.browserconsole_opened_count
    ///
    /// Number of times the DevTools Browser Console has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_BROWSERCONSOLE_OPENED_COUNT.
    pub static browserconsole_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1063,
            "devtools",
            "browserconsole_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.browserconsole_time_active
    ///
    /// How long has the browser console been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_BROWSERCONSOLE_TIME_ACTIVE_SECONDS.
    pub static browserconsole_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browserconsole_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1064), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.changesview_time_active
    ///
    /// How long has the Changes panel been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_CHANGESVIEW_TIME_ACTIVE_SECONDS.
    pub static changesview_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changesview_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1065), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.compatibilityview_opened_count
    ///
    /// Number of times about:debugging has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_COMPATIBILITYVIEW_OPENED_COUNT.
    pub static compatibilityview_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1066,
            "devtools",
            "compatibilityview_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.compatibilityview_time_active
    ///
    /// How long has the compatibility view been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_COMPATIBILITYVIEW_TIME_ACTIVE_SECONDS.
    pub static compatibilityview_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compatibilityview_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1067), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.computedview_opened_count
    ///
    /// Number of times the DevTools Computed View has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_COMPUTEDVIEW_OPENED_COUNT.
    pub static computedview_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1068,
            "devtools",
            "computedview_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.computedview_time_active
    ///
    /// How long has the computed view been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_COMPUTEDVIEW_TIME_ACTIVE_SECONDS.
    pub static computedview_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "computedview_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1069), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.custom_opened_count
    ///
    /// Number of times a custom developer tool has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_CUSTOM_OPENED_COUNT.
    pub static custom_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1070,
            "devtools",
            "custom_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.custom_time_active
    ///
    /// How long has a custom developer tool been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_CUSTOM_TIME_ACTIVE_SECONDS.
    pub static custom_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "custom_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1071), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.dom_opened_count
    ///
    /// Number of times the DevTools DOM Inspector has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_DOM_OPENED_COUNT.
    pub static dom_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1072,
            "devtools",
            "dom_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.dom_time_active
    ///
    /// How long has the DOM inspector been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_DOM_TIME_ACTIVE_SECONDS.
    pub static dom_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1073), meta, TimeUnit::Second)
    });

    #[repr(u16)]
    pub enum EntryPointLabel {
        EKeyshortcut = 0,
        ESystemmenu = 1,
        EHamburgermenu = 2,
        EContextmenu = 3,
        ECommandline = 4,
        ESessionrestore = 5,
        ESlowscript = 6,
        __Other__,
    }
    impl From<u16> for EntryPointLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EKeyshortcut,
                1 => Self::ESystemmenu,
                2 => Self::EHamburgermenu,
                3 => Self::EContextmenu,
                4 => Self::ECommandline,
                5 => Self::ESessionrestore,
                6 => Self::ESlowscript,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EntryPointLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EKeyshortcut => "KeyShortcut",
                Self::ESystemmenu => "SystemMenu",
                Self::EHamburgermenu => "HamburgerMenu",
                Self::EContextmenu => "ContextMenu",
                Self::ECommandline => "CommandLine",
                Self::ESessionrestore => "SessionRestore",
                Self::ESlowscript => "SlowScript",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.entry_point
    ///
    /// Records how the user is triggering Developer Tools startup.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram DEVTOOLS_ENTRY_POINT.
    pub static entry_point: Lazy<LabeledMetric<LabeledCounterMetric, EntryPointLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "entry_point".into(),
                    category: "devtools".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1074), meta, Some(vec![::std::borrow::Cow::from("CommandLine"), ::std::borrow::Cow::from("ContextMenu"), ::std::borrow::Cow::from("HamburgerMenu"), ::std::borrow::Cow::from("KeyShortcut"), ::std::borrow::Cow::from("SessionRestore"), ::std::borrow::Cow::from("SlowScript"), ::std::borrow::Cow::from("SystemMenu")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.eyedropper_opened_count
    ///
    /// Number of times the DevTools Eyedropper tool has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_EYEDROPPER_OPENED_COUNT.
    pub static eyedropper_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1075,
            "devtools",
            "eyedropper_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.flexbox_highlighter_time_active
    ///
    /// How long has the flexbox highlighter been active (seconds).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_FLEXBOX_HIGHLIGHTER_TIME_ACTIVE_SECONDS.
    pub static flexbox_highlighter_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "flexbox_highlighter_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1076), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.fontinspector_opened_count
    ///
    /// Number of times the DevTools Font Inspector has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_FONTINSPECTOR_OPENED_COUNT.
    pub static fontinspector_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1077,
            "devtools",
            "fontinspector_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.fontinspector_time_active
    ///
    /// How long has the font inspector been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_FONTINSPECTOR_TIME_ACTIVE_SECONDS.
    pub static fontinspector_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fontinspector_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1078), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.grid_highlighter_time_active
    ///
    /// How long has the grid highlighter been active (seconds).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_GRID_HIGHLIGHTER_TIME_ACTIVE_SECONDS.
    pub static grid_highlighter_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "grid_highlighter_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1079), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector_opened_count
    ///
    /// Number of times the DevTools Inspector has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_INSPECTOR_OPENED_COUNT.
    pub static inspector_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1080,
            "devtools",
            "inspector_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector_time_active
    ///
    /// How long has the inspector been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_INSPECTOR_TIME_ACTIVE_SECONDS.
    pub static inspector_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inspector_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1081), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsbrowserdebugger_opened_count
    ///
    /// Number of times the DevTools Browser Debugger has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_JSBROWSERDEBUGGER_OPENED_COUNT.
    pub static jsbrowserdebugger_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1082,
            "devtools",
            "jsbrowserdebugger_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsbrowserdebugger_time_active
    ///
    /// How long has the JS browser debugger been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_JSBROWSERDEBUGGER_TIME_ACTIVE_SECONDS.
    pub static jsbrowserdebugger_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jsbrowserdebugger_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1083), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsdebugger_opened_count
    ///
    /// Number of times the DevTools Debugger has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_JSDEBUGGER_OPENED_COUNT.
    pub static jsdebugger_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1084,
            "devtools",
            "jsdebugger_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsdebugger_time_active
    ///
    /// How long has the JS debugger been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_JSDEBUGGER_TIME_ACTIVE_SECONDS.
    pub static jsdebugger_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jsdebugger_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1085), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsprofiler_opened_count
    ///
    /// Number of times the DevTools JS Profiler has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_JSPROFILER_OPENED_COUNT.
    pub static jsprofiler_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1086,
            "devtools",
            "jsprofiler_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.jsprofiler_time_active
    ///
    /// How long has the JS profiler been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_JSPROFILER_TIME_ACTIVE_SECONDS.
    pub static jsprofiler_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jsprofiler_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1087), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.layoutview_opened_count
    ///
    /// Number of times the DevTools Layout View has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_LAYOUTVIEW_OPENED_COUNT.
    pub static layoutview_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1088,
            "devtools",
            "layoutview_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.layoutview_time_active
    ///
    /// How long has the layout view been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_LAYOUTVIEW_TIME_ACTIVE_SECONDS.
    pub static layoutview_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "layoutview_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1089), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.memory_opened_count
    ///
    /// Number of times the DevTools Memory Tool has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_MEMORY_OPENED_COUNT.
    pub static memory_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1090,
            "devtools",
            "memory_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.memory_time_active
    ///
    /// How long has the Memory Tool been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_MEMORY_TIME_ACTIVE_SECONDS.
    pub static memory_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1091), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.menu_eyedropper_opened_count
    ///
    /// Number of times the DevTools Eyedropper has been opened via the DevTools menu.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_MENU_EYEDROPPER_OPENED_COUNT.
    pub static menu_eyedropper_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1092,
            "devtools",
            "menu_eyedropper_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.netmonitor_opened_count
    ///
    /// Number of times the DevTools Network Monitor has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_NETMONITOR_OPENED_COUNT.
    pub static netmonitor_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1093,
            "devtools",
            "netmonitor_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.netmonitor_time_active
    ///
    /// How long has the network monitor been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_NETMONITOR_TIME_ACTIVE_SECONDS.
    pub static netmonitor_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "netmonitor_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1094), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.options_opened_count
    ///
    /// Number of times the DevTools options panel has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_OPTIONS_OPENED_COUNT.
    pub static options_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1095,
            "devtools",
            "options_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.options_time_active
    ///
    /// How long has the options panel been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_OPTIONS_TIME_ACTIVE_SECONDS.
    pub static options_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "options_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1096), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.picker_eyedropper_opened_count
    ///
    /// Number of times the DevTools Eyedropper has been opened via the color picker.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_PICKER_EYEDROPPER_OPENED_COUNT.
    pub static picker_eyedropper_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1097,
            "devtools",
            "picker_eyedropper_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.responsive_opened_count
    ///
    /// Number of times the DevTools Responsive Design Mode tool has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_RESPONSIVE_OPENED_COUNT.
    pub static responsive_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1098,
            "devtools",
            "responsive_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.responsive_time_active
    ///
    /// How long has the responsive view been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_RESPONSIVE_TIME_ACTIVE_SECONDS.
    pub static responsive_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "responsive_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1099), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.ruleview_opened_count
    ///
    /// Number of times the DevTools Rule View has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_RULEVIEW_OPENED_COUNT.
    pub static ruleview_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1100,
            "devtools",
            "ruleview_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.ruleview_time_active
    ///
    /// How long has the rule view been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_RULEVIEW_TIME_ACTIVE_SECONDS.
    pub static ruleview_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ruleview_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1101), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.storage_opened_count
    ///
    /// Number of times the DevTools Storage Inspector has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_STORAGE_OPENED_COUNT.
    pub static storage_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1102,
            "devtools",
            "storage_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.storage_time_active
    ///
    /// How long has the storage inspector been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_STORAGE_TIME_ACTIVE_SECONDS.
    pub static storage_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1103), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.styleeditor_opened_count
    ///
    /// Number of times the DevTools Style Editor has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_STYLEEDITOR_OPENED_COUNT.
    pub static styleeditor_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1104,
            "devtools",
            "styleeditor_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.styleeditor_time_active
    ///
    /// How long has the style editor been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_STYLEEDITOR_TIME_ACTIVE_SECONDS.
    pub static styleeditor_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "styleeditor_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1105), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.toolbox_opened_count
    ///
    /// Number of times the DevTools toolbox has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_TOOLBOX_OPENED_COUNT.
    pub static toolbox_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1106,
            "devtools",
            "toolbox_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.toolbox_time_active
    ///
    /// How long has the toolbox been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_TOOLBOX_TIME_ACTIVE_SECONDS.
    pub static toolbox_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toolbox_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1107), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.webconsole_opened_count
    ///
    /// Number of times the DevTools Web Console has been opened.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEVTOOLS_WEBCONSOLE_OPENED_COUNT.
    pub static webconsole_opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1108,
            "devtools",
            "webconsole_opened_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.webconsole_time_active
    ///
    /// How long has the web console been active (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_WEBCONSOLE_TIME_ACTIVE_SECONDS.
    pub static webconsole_time_active: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "webconsole_time_active".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1109), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.heap_snapshot_edge_count
    ///
    /// The number of edges serialized into a heap snapshot.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram DEVTOOLS_HEAP_SNAPSHOT_EDGE_COUNT.
    pub static heap_snapshot_edge_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "heap_snapshot_edge_count".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1110), meta, 1, 10000000, 10000, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.heap_snapshot_node_count
    ///
    /// The number of nodes serialized into a heap snapshot.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram DEVTOOLS_HEAP_SNAPSHOT_NODE_COUNT.
    pub static heap_snapshot_node_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "heap_snapshot_node_count".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1111), meta, 1, 10000000, 10000, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.read_heap_snapshot
    ///
    /// The time (in milliseconds) that it took to read a heap snapshot in mozilla::devtools::ChromeUtils::ReadHeapSnapshot.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_READ_HEAP_SNAPSHOT_MS.
    pub static read_heap_snapshot: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "read_heap_snapshot".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1112), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.save_heap_snapshot
    ///
    /// The time (in milliseconds) that it took to save a heap snapshot in mozilla::devtools::ChromeUtils::SaveHeapSnapshot.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_SAVE_HEAP_SNAPSHOT_MS.
    pub static save_heap_snapshot: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_heap_snapshot".into(),
                category: "devtools".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1113), meta, TimeUnit::Millisecond)
    });

}
pub mod devtools_tool {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.tool.registered
    ///
    /// Recorded on enable tool checkbox check/uncheck in Developer Tools options panel. Boolean stating if the tool was enabled or disabled by the user. Keyed by tool id. Current default tools with their id's are defined in https://searchfox.org/mozilla- central/source/devtools/client/definitions.js This metric was generated to correspond to the Legacy Telemetry scalar devtools.tool.registered.
    pub static registered: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "registered".into(),
                    category: "devtools.tool".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1114), meta, None)
    });

}
pub mod devtools_toolbox {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.toolbox.tabs_reordered
    ///
    /// Number of times the DevTools tab was reordered. Keyed by tab's id. This metric was generated to correspond to the Legacy Telemetry scalar devtools.toolbox.tabs_reordered.
    pub static tabs_reordered: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tabs_reordered".into(),
                    category: "devtools.toolbox".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1115), meta, None)
    });

}
pub mod devtools_grid_gridinspector {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.grid.gridinspector.opened
    ///
    /// Number of times the DevTools grid inspector was opened from the grid view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.grid.gridinspector.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1116,
            "devtools.grid.gridinspector",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_inspector {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum FonteditorFontTypeDisplayedLabel {
        EVariable = 0,
        ENonvariable = 1,
        __Other__,
    }
    impl From<u16> for FonteditorFontTypeDisplayedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EVariable,
                1 => Self::ENonvariable,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FonteditorFontTypeDisplayedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EVariable => "variable",
                Self::ENonvariable => "nonvariable",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector.fonteditor_font_type_displayed
    ///
    /// Indicates if the font editor displayed its UI for a non-variable font or a variable font
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram DEVTOOLS_FONTEDITOR_FONT_TYPE_DISPLAYED.
    pub static fonteditor_font_type_displayed: Lazy<LabeledMetric<LabeledCounterMetric, FonteditorFontTypeDisplayedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fonteditor_font_type_displayed".into(),
                    category: "devtools.inspector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1117), meta, Some(vec![::std::borrow::Cow::from("nonvariable"), ::std::borrow::Cow::from("variable")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector.new_root_to_reload_delay
    ///
    /// Time taken (in ms) to update the inspector during a page reload, starting from new-root event.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEVTOOLS_INSPECTOR_NEW_ROOT_TO_RELOAD_DELAY_MS.
    pub static new_root_to_reload_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_root_to_reload_delay".into(),
                category: "devtools.inspector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1118), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector.node_selection_count
    ///
    /// Number of times a different node is marked as selected in the Inspector regardless of the cause: context menu, manual selection in markup view, etc. This metric was generated to correspond to the Legacy Telemetry scalar devtools.inspector.node_selection_count.
    pub static node_selection_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1119,
            "devtools.inspector",
            "node_selection_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector.number_of_css_grids_in_a_page
    ///
    /// On page load, record the number of CSS Grid elements present on a page when the DevTools is open
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram DEVTOOLS_NUMBER_OF_CSS_GRIDS_IN_A_PAGE.
    pub static number_of_css_grids_in_a_page: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "number_of_css_grids_in_a_page".into(),
                category: "devtools.inspector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(1120), meta, 1, 30, 29, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.inspector.three_pane_enabled
    ///
    /// Number of times the DevTools inspector was opened with the 3 pane inspector enabled, keyed by true/false. This metric was generated to correspond to the Legacy Telemetry scalar devtools.inspector.three_pane_enabled.
    pub static three_pane_enabled: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "three_pane_enabled".into(),
                    category: "devtools.inspector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1121), meta, None)
    });

}
pub mod devtools_layout_flexboxhighlighter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.layout.flexboxhighlighter.opened
    ///
    /// Number of times the DevTools flexbox highlighter was activated from the layout view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.layout.flexboxhighlighter.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1122,
            "devtools.layout.flexboxhighlighter",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_markup_flexboxhighlighter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.markup.flexboxhighlighter.opened
    ///
    /// Number of times the DevTools flexbox highlighter was activated from the markup view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.markup.flexboxhighlighter.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1123,
            "devtools.markup.flexboxhighlighter",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_markup_gridinspector {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.markup.gridinspector.opened
    ///
    /// Number of times the DevTools grid inspector was opened from the markup view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.markup.gridinspector.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1124,
            "devtools.markup.gridinspector",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_markup_scrollable_badge {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.markup.scrollable.badge.clicked
    ///
    /// Number of times the scrollable inspector badge has been clicked. This metric was generated to correspond to the Legacy Telemetry scalar devtools.markup.scrollable.badge.clicked.
    pub static clicked: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1125,
            "devtools.markup.scrollable.badge",
            "clicked",
            "metrics"
        )
    });

}
pub mod devtools_rules_flexboxhighlighter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.rules.flexboxhighlighter.opened
    ///
    /// Number of times the DevTools flexbox highlighter was activated from the rules view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.rules.flexboxhighlighter.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1126,
            "devtools.rules.flexboxhighlighter",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_rules_gridinspector {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.rules.gridinspector.opened
    ///
    /// Number of times the DevTools grid inspector was opened from the rules view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.rules.gridinspector.opened.
    pub static opened: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1127,
            "devtools.rules.gridinspector",
            "opened",
            "metrics"
        )
    });

}
pub mod devtools_shadowdom {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.shadowdom.reveal_link_clicked
    ///
    /// Whether the user clicked on any "reveal" link. "reveal" links are displayed in shadow dom trees in the markup view. This metric was generated to correspond to the Legacy Telemetry scalar devtools.shadowdom.reveal_link_clicked.
    pub static reveal_link_clicked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reveal_link_clicked".into(),
                category: "devtools.shadowdom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1128), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.shadowdom.shadow_root_displayed
    ///
    /// Whether the markup view displayed any #shadow-root element in the UI. This metric was generated to correspond to the Legacy Telemetry scalar devtools.shadowdom.shadow_root_displayed.
    pub static shadow_root_displayed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shadow_root_displayed".into(),
                category: "devtools.shadowdom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1129), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.shadowdom.shadow_root_expanded
    ///
    /// Whether the user expanded any #shadow-root element. This metric was generated to correspond to the Legacy Telemetry scalar devtools.shadowdom.shadow_root_expanded.
    pub static shadow_root_expanded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shadow_root_expanded".into(),
                category: "devtools.shadowdom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(1130), meta)
    });

}
pub mod devtools_tooltip {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.tooltip.shown
    ///
    /// Number of times a tooltip was shown, keyed by tooltip type. Currently supported types are "image", "font-family", "inactive- css", "css-compatibility", "css-query-container" and "variable." This metric was generated to correspond to the Legacy Telemetry scalar devtools.tooltip.shown.
    pub static shown: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "shown".into(),
                    category: "devtools.tooltip".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1131), meta, None)
    });

}
pub mod devtools_responsive {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.responsive.open_trigger
    ///
    /// Number of Responsive Design Mode opens keyed by the UI entry point used. This metric was generated to correspond to the Legacy Telemetry scalar devtools.responsive.open_trigger.
    pub static open_trigger: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "open_trigger".into(),
                    category: "devtools.responsive".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1132), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from devtools.responsive.toolbox_opened_first
    ///
    /// Number of Responsive Design Mode opens with a toolbox already open. This metric was generated to correspond to the Legacy Telemetry scalar devtools.responsive.toolbox_opened_first.
    pub static toolbox_opened_first: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1133,
            "devtools.responsive",
            "toolbox_opened_first",
            "metrics"
        )
    });

}
pub mod devtools_changesview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from devtools.changesview.opened_count
    ///
    /// Number of times the Changes panel has been opened. This metric was generated to correspond to the Legacy Telemetry scalar devtools.changesview.opened_count.
    pub static opened_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1134,
            "devtools.changesview",
            "opened_count",
            "metrics"
        )
    });

}
pub mod devtools_main {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ActivateResponsiveDesignExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ActivateResponsiveDesignExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.activate_responsive_design
    ///
    /// User activates the responsive_design or split_console in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.activate#responsive_design.
    pub static activate_responsive_design: Lazy<EventMetric<ActivateResponsiveDesignExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "activate_responsive_design".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1135), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ActivateSplitConsoleExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ActivateSplitConsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.activate_split_console
    ///
    /// User activates the responsive_design or split_console in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.activate#split_console.
    pub static activate_split_console: Lazy<EventMetric<ActivateSplitConsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "activate_split_console".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1136), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddBreakpointDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddBreakpointDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.add_breakpoint_debugger
    ///
    /// User has added a breakpoint to a script. This event was generated to correspond to the Legacy Telemetry event devtools.main.add_breakpoint#debugger.
    pub static add_breakpoint_debugger: Lazy<EventMetric<AddBreakpointDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_breakpoint_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1137), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BlackboxDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for BlackboxDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.blackbox_debugger
    ///
    /// User clicked the blackbox button to blackbox a script. This event was generated to correspond to the Legacy Telemetry event devtools.main.blackbox#debugger.
    pub static blackbox_debugger: Lazy<EventMetric<BlackboxDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blackbox_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1138), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseAdbgAboutdebuggingExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for CloseAdbgAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.close_adbg_aboutdebugging
    ///
    /// User closes about:debugging. This event was generated to correspond to the Legacy Telemetry event devtools.main.close_adbg#aboutdebugging.
    pub static close_adbg_aboutdebugging: Lazy<EventMetric<CloseAdbgAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_adbg_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1139), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseToolsExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for CloseToolsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.close_tools
    ///
    /// User closes devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.close#tools.
    pub static close_tools: Lazy<EventMetric<CloseToolsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_tools".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1140), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConnectionAttemptAboutdebuggingExtra {
        pub r#connection_id: Option<String>,
        pub r#connection_type: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#status: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ConnectionAttemptAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_id", "connection_type", "runtime_id", "session_id", "status", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_id.and_then(|val| map.insert("connection_id".into(), val.to_string()));
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.connection_attempt_aboutdebugging
    ///
    /// User is trying to connect to a remote runtime. This event was generated to correspond to the Legacy Telemetry event devtools.main.connection_attempt#aboutdebugging.
    pub static connection_attempt_aboutdebugging: Lazy<EventMetric<ConnectionAttemptAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "connection_attempt_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1141), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ContinueDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ContinueDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.continue_debugger
    ///
    /// User has pressed the continue button on a paused script. This event was generated to correspond to the Legacy Telemetry event devtools.main.continue#debugger.
    pub static continue_debugger: Lazy<EventMetric<ContinueDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "continue_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1142), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeactivateResponsiveDesignExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for DeactivateResponsiveDesignExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.deactivate_responsive_design
    ///
    /// User deactivates the responsive_design or split_console in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.deactivate#responsive_design.
    pub static deactivate_responsive_design: Lazy<EventMetric<DeactivateResponsiveDesignExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deactivate_responsive_design".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1143), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeactivateSplitConsoleExtra {
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for DeactivateSplitConsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.deactivate_split_console
    ///
    /// User deactivates the responsive_design or split_console in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.deactivate#split_console.
    pub static deactivate_split_console: Lazy<EventMetric<DeactivateSplitConsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deactivate_split_console".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1144), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeviceAddedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeviceAddedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.device_added_aboutdebugging
    ///
    /// A new device was detected in about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.device_added#aboutdebugging.
    pub static device_added_aboutdebugging: Lazy<EventMetric<DeviceAddedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_added_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1145), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeviceRemovedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeviceRemovedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.device_removed_aboutdebugging
    ///
    /// A previously listed device was removed in about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.device_removed#aboutdebugging.
    pub static device_removed_aboutdebugging: Lazy<EventMetric<DeviceRemovedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_removed_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1146), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditHtmlInspectorExtra {
        pub r#made_changes: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditHtmlInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["made_changes", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#made_changes.and_then(|val| map.insert("made_changes".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_html_inspector
    ///
    /// User is editing HTML via the context menu item in the markup view. This event was generated to correspond to the Legacy Telemetry event devtools.main.edit_html#inspector.
    pub static edit_html_inspector: Lazy<EventMetric<EditHtmlInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_html_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1147), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditResendNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditResendNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_resend_netmonitor
    ///
    /// User has executed edit / resend in the netmonitor. This event was generated to correspond to the Legacy Telemetry event devtools.main.edit_resend#netmonitor.
    pub static edit_resend_netmonitor: Lazy<EventMetric<EditResendNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_resend_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1148), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditRuleRuleviewExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditRuleRuleviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.edit_rule_ruleview
    ///
    /// User is editing a CSS rule by clicking on or next to a CSS property, enabling / disabling a rule or creating a new property. This event was generated to correspond to the Legacy Telemetry event devtools.main.edit_rule#ruleview.
    pub static edit_rule_ruleview: Lazy<EventMetric<EditRuleRuleviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_rule_ruleview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1149), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterAccessibilityExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterAccessibilityExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_accessibility
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#accessibility.
    pub static enter_accessibility: Lazy<EventMetric<EnterAccessibilityExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_accessibility".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1150), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterApplicationExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_application
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#application.
    pub static enter_application: Lazy<EventMetric<EnterApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1151), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterDomExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterDomExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_dom
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#dom.
    pub static enter_dom: Lazy<EventMetric<EnterDomExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_dom".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1152), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterFakeTool4242Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterFakeTool4242Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_fake_tool4242
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#fakeTool4242.
    pub static enter_fake_tool4242: Lazy<EventMetric<EnterFakeTool4242Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_fake_tool4242".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1153), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterInspectorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_inspector
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#inspector.
    pub static enter_inspector: Lazy<EventMetric<EnterInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1154), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterJsdebuggerExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterJsdebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_jsdebugger
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#jsdebugger.
    pub static enter_jsdebugger: Lazy<EventMetric<EnterJsdebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_jsdebugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1155), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterMemoryExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterMemoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_memory
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#memory.
    pub static enter_memory: Lazy<EventMetric<EnterMemoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_memory".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1156), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterNetmonitorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_netmonitor
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#netmonitor.
    pub static enter_netmonitor: Lazy<EventMetric<EnterNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1157), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterOptionsExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterOptionsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_options
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#options.
    pub static enter_options: Lazy<EventMetric<EnterOptionsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_options".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1158), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterOtherExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_other
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#other.
    pub static enter_other: Lazy<EventMetric<EnterOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_other".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1159), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterPerformanceExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterPerformanceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_performance
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#performance.
    pub static enter_performance: Lazy<EventMetric<EnterPerformanceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_performance".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1160), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterStorageExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterStorageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_storage
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#storage.
    pub static enter_storage: Lazy<EventMetric<EnterStorageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_storage".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1161), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterStyleeditorExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterStyleeditorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_styleeditor
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#styleeditor.
    pub static enter_styleeditor: Lazy<EventMetric<EnterStyleeditorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_styleeditor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1162), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestBlankPanelExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestBlankPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_blank_panel
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#testBlankPanel.
    pub static enter_test_blank_panel: Lazy<EventMetric<EnterTestBlankPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_blank_panel".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1163), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestToolExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestToolExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_tool
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#testTool.
    pub static enter_test_tool: Lazy<EventMetric<EnterTestToolExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_tool".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1164), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTestTool1072208Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTestTool1072208Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_test_tool1072208
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#testTool1072208.
    pub static enter_test_tool1072208: Lazy<EventMetric<EnterTestTool1072208Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_test_tool1072208".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1165), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTesttool1Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTesttool1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_testtool1
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#testtool1.
    pub static enter_testtool1: Lazy<EventMetric<EnterTesttool1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_testtool1".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1166), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterTesttool2Extra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterTesttool2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_testtool2
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#testtool2.
    pub static enter_testtool2: Lazy<EventMetric<EnterTesttool2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_testtool2".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1167), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterWebconsoleExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_webconsole
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#webconsole.
    pub static enter_webconsole: Lazy<EventMetric<EnterWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1168), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnterWhatsnewExtra {
        pub r#cold: Option<String>,
        pub r#host: Option<String>,
        pub r#message_count: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#start_state: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for EnterWhatsnewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cold", "host", "message_count", "panel_name", "session_id", "start_state", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cold.and_then(|val| map.insert("cold".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#message_count.and_then(|val| map.insert("message_count".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#start_state.and_then(|val| map.insert("start_state".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.enter_whatsnew
    ///
    /// User opens a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.enter#whatsnew.
    pub static enter_whatsnew: Lazy<EventMetric<EnterWhatsnewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enter_whatsnew".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1169), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExecuteJsWebconsoleExtra {
        pub r#input: Option<String>,
        pub r#lines: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExecuteJsWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["input", "lines", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#input.and_then(|val| map.insert("input".into(), val.to_string()));
          self.r#lines.and_then(|val| map.insert("lines".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.execute_js_webconsole
    ///
    /// User has executed some JS in the Web Console. This event was generated to correspond to the Legacy Telemetry event devtools.main.execute_js#webconsole.
    pub static execute_js_webconsole: Lazy<EventMetric<ExecuteJsWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "execute_js_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1170), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitAccessibilityExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitAccessibilityExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_accessibility
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#accessibility.
    pub static exit_accessibility: Lazy<EventMetric<ExitAccessibilityExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_accessibility".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1171), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitApplicationExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_application
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#application.
    pub static exit_application: Lazy<EventMetric<ExitApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1172), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitDomExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitDomExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_dom
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#dom.
    pub static exit_dom: Lazy<EventMetric<ExitDomExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_dom".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1173), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitFakeTool4242Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitFakeTool4242Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_fake_tool4242
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#fakeTool4242.
    pub static exit_fake_tool4242: Lazy<EventMetric<ExitFakeTool4242Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_fake_tool4242".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1174), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitInspectorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_inspector
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#inspector.
    pub static exit_inspector: Lazy<EventMetric<ExitInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1175), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitJsdebuggerExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitJsdebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_jsdebugger
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#jsdebugger.
    pub static exit_jsdebugger: Lazy<EventMetric<ExitJsdebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_jsdebugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1176), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitMemoryExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitMemoryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_memory
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#memory.
    pub static exit_memory: Lazy<EventMetric<ExitMemoryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_memory".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1177), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitNetmonitorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_netmonitor
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#netmonitor.
    pub static exit_netmonitor: Lazy<EventMetric<ExitNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1178), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitOptionsExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitOptionsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_options
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#options.
    pub static exit_options: Lazy<EventMetric<ExitOptionsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_options".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1179), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitOtherExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_other
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#other.
    pub static exit_other: Lazy<EventMetric<ExitOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_other".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1180), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitPerformanceExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitPerformanceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_performance
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#performance.
    pub static exit_performance: Lazy<EventMetric<ExitPerformanceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_performance".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1181), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitStorageExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitStorageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_storage
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#storage.
    pub static exit_storage: Lazy<EventMetric<ExitStorageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_storage".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1182), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitStyleeditorExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitStyleeditorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_styleeditor
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#styleeditor.
    pub static exit_styleeditor: Lazy<EventMetric<ExitStyleeditorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_styleeditor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1183), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestBlankPanelExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestBlankPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_blank_panel
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#testBlankPanel.
    pub static exit_test_blank_panel: Lazy<EventMetric<ExitTestBlankPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_blank_panel".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1184), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestToolExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestToolExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_tool
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#testTool.
    pub static exit_test_tool: Lazy<EventMetric<ExitTestToolExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_tool".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1185), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTestTool1072208Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTestTool1072208Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_test_tool1072208
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#testTool1072208.
    pub static exit_test_tool1072208: Lazy<EventMetric<ExitTestTool1072208Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_test_tool1072208".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1186), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTesttool1Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTesttool1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_testtool1
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#testtool1.
    pub static exit_testtool1: Lazy<EventMetric<ExitTesttool1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_testtool1".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1187), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitTesttool2Extra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitTesttool2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_testtool2
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#testtool2.
    pub static exit_testtool2: Lazy<EventMetric<ExitTesttool2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_testtool2".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1188), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitWebconsoleExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_webconsole
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#webconsole.
    pub static exit_webconsole: Lazy<EventMetric<ExitWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1189), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExitWhatsnewExtra {
        pub r#host: Option<String>,
        pub r#next_panel: Option<String>,
        pub r#panel_name: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for ExitWhatsnewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["host", "next_panel", "panel_name", "reason", "session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#next_panel.and_then(|val| map.insert("next_panel".into(), val.to_string()));
          self.r#panel_name.and_then(|val| map.insert("panel_name".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.exit_whatsnew
    ///
    /// User closes a tool in the devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.exit#whatsnew.
    pub static exit_whatsnew: Lazy<EventMetric<ExitWhatsnewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exit_whatsnew".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1190), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FiltersChangedNetmonitorExtra {
        pub r#active: Option<String>,
        pub r#inactive: Option<String>,
        pub r#session_id: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FiltersChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["active", "inactive", "session_id", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#active.and_then(|val| map.insert("active".into(), val.to_string()));
          self.r#inactive.and_then(|val| map.insert("inactive".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.filters_changed_netmonitor
    ///
    /// User has changed filters in the web console. This event was generated to correspond to the Legacy Telemetry event devtools.main.filters_changed#netmonitor.
    pub static filters_changed_netmonitor: Lazy<EventMetric<FiltersChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filters_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1191), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FiltersChangedWebconsoleExtra {
        pub r#active: Option<String>,
        pub r#inactive: Option<String>,
        pub r#session_id: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FiltersChangedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["active", "inactive", "session_id", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#active.and_then(|val| map.insert("active".into(), val.to_string()));
          self.r#inactive.and_then(|val| map.insert("inactive".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.filters_changed_webconsole
    ///
    /// User has changed filters in the web console. This event was generated to correspond to the Legacy Telemetry event devtools.main.filters_changed#webconsole.
    pub static filters_changed_webconsole: Lazy<EventMetric<FiltersChangedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filters_changed_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1192), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InspectAboutdebuggingExtra {
        pub r#runtime_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#target_type: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InspectAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["runtime_type", "session_id", "target_type", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#runtime_type.and_then(|val| map.insert("runtime_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#target_type.and_then(|val| map.insert("target_type".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.inspect_aboutdebugging
    ///
    /// User has clicked on the inspect button of one of the debug targets of aboutdebugging. This event was generated to correspond to the Legacy Telemetry event devtools.main.inspect#aboutdebugging.
    pub static inspect_aboutdebugging: Lazy<EventMetric<InspectAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inspect_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1193), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JumpToDefinitionWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JumpToDefinitionWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.jump_to_definition_webconsole
    ///
    /// User has clicked "Jump to definition" icon (next to logged functions) in the web console. This event was generated to correspond to the Legacy Telemetry event devtools.main.jump_to_definition#webconsole.
    pub static jump_to_definition_webconsole: Lazy<EventMetric<JumpToDefinitionWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jump_to_definition_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1194), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct JumpToSourceWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for JumpToSourceWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.jump_to_source_webconsole
    ///
    /// User has clicked a link to a source file in the web console. This event was generated to correspond to the Legacy Telemetry event devtools.main.jump_to_source#webconsole.
    pub static jump_to_source_webconsole: Lazy<EventMetric<JumpToSourceWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "jump_to_source_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1195), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ObjectExpandedWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ObjectExpandedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.object_expanded_webconsole
    ///
    /// User has expanded an object in the web console. This event was generated to correspond to the Legacy Telemetry event devtools.main.object_expanded#webconsole.
    pub static object_expanded_webconsole: Lazy<EventMetric<ObjectExpandedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "object_expanded_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1196), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenAdbgAboutdebuggingExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for OpenAdbgAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.open_adbg_aboutdebugging
    ///
    /// User opens about:debugging. This event was generated to correspond to the Legacy Telemetry event devtools.main.open_adbg#aboutdebugging.
    pub static open_adbg_aboutdebugging: Lazy<EventMetric<OpenAdbgAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_adbg_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1197), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenToolsExtra {
        pub r#entrypoint: Option<String>,
        pub r#first_panel: Option<String>,
        pub r#host: Option<String>,
        pub r#session_id: Option<String>,
        pub r#shortcut: Option<String>,
        pub r#splitconsole: Option<String>,
        pub r#value: Option<String>,
        pub r#width: Option<String>,
    }

    impl ExtraKeys for OpenToolsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["entrypoint", "first_panel", "host", "session_id", "shortcut", "splitconsole", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#entrypoint.and_then(|val| map.insert("entrypoint".into(), val.to_string()));
          self.r#first_panel.and_then(|val| map.insert("first_panel".into(), val.to_string()));
          self.r#host.and_then(|val| map.insert("host".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#shortcut.and_then(|val| map.insert("shortcut".into(), val.to_string()));
          self.r#splitconsole.and_then(|val| map.insert("splitconsole".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.open_tools
    ///
    /// User opens devtools toolbox. This event was generated to correspond to the Legacy Telemetry event devtools.main.open#tools.
    pub static open_tools: Lazy<EventMetric<OpenToolsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_tools".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1198), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PauseDebuggerExtra {
        pub r#lib_stacks: Option<String>,
        pub r#reason: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PauseDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["lib_stacks", "reason", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#lib_stacks.and_then(|val| map.insert("lib_stacks".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pause_debugger
    ///
    /// Debugger has paused in a script due to a breakpoint or exception. This event was generated to correspond to the Legacy Telemetry event devtools.main.pause#debugger.
    pub static pause_debugger: Lazy<EventMetric<PauseDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pause_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1199), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PauseOnExceptionsDebuggerExtra {
        pub r#caught_exceptio: Option<String>,
        pub r#exceptions: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PauseOnExceptionsDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caught_exceptio", "exceptions", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caught_exceptio.and_then(|val| map.insert("caught_exceptio".into(), val.to_string()));
          self.r#exceptions.and_then(|val| map.insert("exceptions".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pause_on_exceptions_debugger
    ///
    /// User has changed pausing behaviour in the debugger. This event was generated to correspond to the Legacy Telemetry event devtools.main.pause_on_exceptions#debugger.
    pub static pause_on_exceptions_debugger: Lazy<EventMetric<PauseOnExceptionsDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pause_on_exceptions_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1200), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PersistChangedNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PersistChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.persist_changed_netmonitor
    ///
    /// User has changed log persist status. This event was generated to correspond to the Legacy Telemetry event devtools.main.persist_changed#netmonitor.
    pub static persist_changed_netmonitor: Lazy<EventMetric<PersistChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "persist_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1201), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PersistChangedWebconsoleExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PersistChangedWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.persist_changed_webconsole
    ///
    /// User has changed log persist status. This event was generated to correspond to the Legacy Telemetry event devtools.main.persist_changed#webconsole.
    pub static persist_changed_webconsole: Lazy<EventMetric<PersistChangedWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "persist_changed_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1202), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrettyPrintDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrettyPrintDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.pretty_print_debugger
    ///
    /// User clicked the pretty print button to pretty print a script. This event was generated to correspond to the Legacy Telemetry event devtools.main.pretty_print#debugger.
    pub static pretty_print_debugger: Lazy<EventMetric<PrettyPrintDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pretty_print_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1203), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RemoveBreakpointDebuggerExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RemoveBreakpointDebuggerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.remove_breakpoint_debugger
    ///
    /// User has removed a breakpoint from a script. This event was generated to correspond to the Legacy Telemetry event devtools.main.remove_breakpoint#debugger.
    pub static remove_breakpoint_debugger: Lazy<EventMetric<RemoveBreakpointDebuggerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remove_breakpoint_debugger".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1204), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReverseSearchWebconsoleExtra {
        pub r#functionality: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReverseSearchWebconsoleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["functionality", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#functionality.and_then(|val| map.insert("functionality".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.reverse_search_webconsole
    ///
    /// User has toggled, navigated or evaluated expressions from reverse search . This event was generated to correspond to the Legacy Telemetry event devtools.main.reverse_search#webconsole.
    pub static reverse_search_webconsole: Lazy<EventMetric<ReverseSearchWebconsoleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reverse_search_webconsole".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1205), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeAddedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeAddedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_added_aboutdebugging
    ///
    /// A new remote runtime has been detected in about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.runtime_added#aboutdebugging.
    pub static runtime_added_aboutdebugging: Lazy<EventMetric<RuntimeAddedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_added_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1206), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeConnectedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#runtime_os: Option<String>,
        pub r#runtime_version: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeConnectedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "runtime_os", "runtime_version", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#runtime_os.and_then(|val| map.insert("runtime_os".into(), val.to_string()));
          self.r#runtime_version.and_then(|val| map.insert("runtime_version".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_connected_aboutdebugging
    ///
    /// Connection was established with a remote runtime in about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.runtime_connected#aboutdebugging.
    pub static runtime_connected_aboutdebugging: Lazy<EventMetric<RuntimeConnectedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_connected_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1207), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeDisconnectedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeDisconnectedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_disconnected_aboutdebugging
    ///
    /// Connection was lost with a remote runtime in about debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.runtime_disconnected#aboutdebugging.
    pub static runtime_disconnected_aboutdebugging: Lazy<EventMetric<RuntimeDisconnectedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_disconnected_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1208), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RuntimeRemovedAboutdebuggingExtra {
        pub r#connection_type: Option<String>,
        pub r#device_name: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#runtime_name: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for RuntimeRemovedAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["connection_type", "device_name", "runtime_id", "runtime_name", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#connection_type.and_then(|val| map.insert("connection_type".into(), val.to_string()));
          self.r#device_name.and_then(|val| map.insert("device_name".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#runtime_name.and_then(|val| map.insert("runtime_name".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.runtime_removed_aboutdebugging
    ///
    /// A previously listed runtime was removed in about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.runtime_removed#aboutdebugging.
    pub static runtime_removed_aboutdebugging: Lazy<EventMetric<RuntimeRemovedAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "runtime_removed_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1209), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectPageAboutdebuggingExtra {
        pub r#page_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectPageAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page_type", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page_type.and_then(|val| map.insert("page_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_page_aboutdebugging
    ///
    /// User navigates to a new page of an application such as about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.select_page#aboutdebugging.
    pub static select_page_aboutdebugging: Lazy<EventMetric<SelectPageAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_page_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1210), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectPageApplicationExtra {
        pub r#page_type: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectPageApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["page_type", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#page_type.and_then(|val| map.insert("page_type".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_page_application
    ///
    /// User navigates to a new page of an application such as about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.select_page#application.
    pub static select_page_application: Lazy<EventMetric<SelectPageApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_page_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1211), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectWsFrameNetmonitorExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SelectWsFrameNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.select_ws_frame_netmonitor
    ///
    /// User has selected a WebSocket frame. This event was generated to correspond to the Legacy Telemetry event devtools.main.select_ws_frame#netmonitor.
    pub static select_ws_frame_netmonitor: Lazy<EventMetric<SelectWsFrameNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_ws_frame_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1212), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowProfilerAboutdebuggingExtra {
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowProfilerAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["runtime_id", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.show_profiler_aboutdebugging
    ///
    /// User has clicked on the "Open Profiler" button in a runtime page of about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.show_profiler#aboutdebugging.
    pub static show_profiler_aboutdebugging: Lazy<EventMetric<ShowProfilerAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_profiler_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1213), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidepanelChangedInspectorExtra {
        pub r#newpanel: Option<String>,
        pub r#oldpanel: Option<String>,
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SidepanelChangedInspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newpanel", "oldpanel", "os", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newpanel.and_then(|val| map.insert("newpanel".into(), val.to_string()));
          self.r#oldpanel.and_then(|val| map.insert("oldpanel".into(), val.to_string()));
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.sidepanel_changed_inspector
    ///
    /// User has switched sidepanel tabs. This event was generated to correspond to the Legacy Telemetry event devtools.main.sidepanel_changed#inspector.
    pub static sidepanel_changed_inspector: Lazy<EventMetric<SidepanelChangedInspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidepanel_changed_inspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1214), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SidepanelChangedNetmonitorExtra {
        pub r#newpanel: Option<String>,
        pub r#oldpanel: Option<String>,
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SidepanelChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["newpanel", "oldpanel", "os", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#newpanel.and_then(|val| map.insert("newpanel".into(), val.to_string()));
          self.r#oldpanel.and_then(|val| map.insert("oldpanel".into(), val.to_string()));
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.sidepanel_changed_netmonitor
    ///
    /// User has switched sidepanel tabs. This event was generated to correspond to the Legacy Telemetry event devtools.main.sidepanel_changed#netmonitor.
    pub static sidepanel_changed_netmonitor: Lazy<EventMetric<SidepanelChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sidepanel_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1215), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StartWorkerApplicationExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StartWorkerApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.start_worker_application
    ///
    /// User manually starts a service worker This event was generated to correspond to the Legacy Telemetry event devtools.main.start_worker#application.
    pub static start_worker_application: Lazy<EventMetric<StartWorkerApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "start_worker_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1216), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ThrottleChangedNetmonitorExtra {
        pub r#mode: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ThrottleChangedNetmonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.throttle_changed_netmonitor
    ///
    /// User has changed the throttle setting in the netmonitor. This event was generated to correspond to the Legacy Telemetry event devtools.main.throttle_changed#netmonitor.
    pub static throttle_changed_netmonitor: Lazy<EventMetric<ThrottleChangedNetmonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "throttle_changed_netmonitor".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1217), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerAnimationinspectorExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerAnimationinspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_animationinspector
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#animationinspector.
    pub static tool_timer_animationinspector: Lazy<EventMetric<ToolTimerAnimationinspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_animationinspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1218), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerChangesviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerChangesviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_changesview
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#changesview.
    pub static tool_timer_changesview: Lazy<EventMetric<ToolTimerChangesviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_changesview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1219), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerCompatibilityviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerCompatibilityviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_compatibilityview
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#compatibilityview.
    pub static tool_timer_compatibilityview: Lazy<EventMetric<ToolTimerCompatibilityviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_compatibilityview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1220), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerComputedviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerComputedviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_computedview
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#computedview.
    pub static tool_timer_computedview: Lazy<EventMetric<ToolTimerComputedviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_computedview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1221), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerFontinspectorExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerFontinspectorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_fontinspector
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#fontinspector.
    pub static tool_timer_fontinspector: Lazy<EventMetric<ToolTimerFontinspectorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_fontinspector".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1222), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerLayoutviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerLayoutviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_layoutview
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#layoutview.
    pub static tool_timer_layoutview: Lazy<EventMetric<ToolTimerLayoutviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_layoutview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1223), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ToolTimerRuleviewExtra {
        pub r#os: Option<String>,
        pub r#session_id: Option<String>,
        pub r#time_open: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ToolTimerRuleviewExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["os", "session_id", "time_open", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#os.and_then(|val| map.insert("os".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#time_open.and_then(|val| map.insert("time_open".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.tool_timer_ruleview
    ///
    /// The amount of time a tool was opened for. This event was generated to correspond to the Legacy Telemetry event devtools.main.tool_timer#ruleview.
    pub static tool_timer_ruleview: Lazy<EventMetric<ToolTimerRuleviewExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tool_timer_ruleview".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1224), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnregisterWorkerApplicationExtra {
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnregisterWorkerApplicationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.unregister_worker_application
    ///
    /// User manually unregisters a service worker registration This event was generated to correspond to the Legacy Telemetry event devtools.main.unregister_worker#application.
    pub static unregister_worker_application: Lazy<EventMetric<UnregisterWorkerApplicationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unregister_worker_application".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1225), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateConnPromptAboutdebuggingExtra {
        pub r#prompt_enabled: Option<String>,
        pub r#runtime_id: Option<String>,
        pub r#session_id: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateConnPromptAboutdebuggingExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["prompt_enabled", "runtime_id", "session_id", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#prompt_enabled.and_then(|val| map.insert("prompt_enabled".into(), val.to_string()));
          self.r#runtime_id.and_then(|val| map.insert("runtime_id".into(), val.to_string()));
          self.r#session_id.and_then(|val| map.insert("session_id".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from devtools.main.update_conn_prompt_aboutdebugging
    ///
    /// User has clicked on the "Enable/Disable connection prompt" button in a runtime page of about:debugging This event was generated to correspond to the Legacy Telemetry event devtools.main.update_conn_prompt#aboutdebugging.
    pub static update_conn_prompt_aboutdebugging: Lazy<EventMetric<UpdateConnPromptAboutdebuggingExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_conn_prompt_aboutdebugging".into(),
                category: "devtools.main".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(1226), meta)
    });

}
pub mod bfcache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ComboLabel {
        EBfcacheSuccess = 0,
        ESuccessNotToplevel = 1,
        EUnload = 2,
        EUnloadReq = 3,
        EReq = 4,
        EUnloadReqPeer = 5,
        EUnloadReqPeerMse = 6,
        EUnloadReqMse = 7,
        ESpdUnloadReqPeer = 8,
        ERemoteSubframes = 9,
        EBeforeunload = 10,
        EOther = 11,
        __Other__,
    }
    impl From<u16> for ComboLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBfcacheSuccess,
                1 => Self::ESuccessNotToplevel,
                2 => Self::EUnload,
                3 => Self::EUnloadReq,
                4 => Self::EReq,
                5 => Self::EUnloadReqPeer,
                6 => Self::EUnloadReqPeerMse,
                7 => Self::EUnloadReqMse,
                8 => Self::ESpdUnloadReqPeer,
                9 => Self::ERemoteSubframes,
                10 => Self::EBeforeunload,
                11 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ComboLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBfcacheSuccess => "BFCache_Success",
                Self::ESuccessNotToplevel => "Success_Not_Toplevel",
                Self::EUnload => "Unload",
                Self::EUnloadReq => "Unload_Req",
                Self::EReq => "Req",
                Self::EUnloadReqPeer => "Unload_Req_Peer",
                Self::EUnloadReqPeerMse => "Unload_Req_Peer_MSE",
                Self::EUnloadReqMse => "Unload_Req_MSE",
                Self::ESpdUnloadReqPeer => "SPD_Unload_Req_Peer",
                Self::ERemoteSubframes => "Remote_Subframes",
                Self::EBeforeunload => "Beforeunload",
                Self::EOther => "Other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bfcache.combo
    ///
    /// The common combinations of BFCacheStatus when we determine whether the page can be BFCached or not; If it's BFCached, we record BFCache_Success; Success_Not_Toplevel represents the number of not the only top level document in BrowsingContextGroup's documents that are BFCached, and BFCache_Success includes Success_Not_Toplevel; If it's not and it falls under common failure reasons combinations, we record the corresponding combination; Otherwise, we record Other to indicate this is not a common failure
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram BFCACHE_COMBO.
    pub static combo: Lazy<LabeledMetric<LabeledCounterMetric, ComboLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "combo".into(),
                    category: "bfcache".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1227), meta, Some(vec![::std::borrow::Cow::from("BFCache_Success"), ::std::borrow::Cow::from("Beforeunload"), ::std::borrow::Cow::from("Other"), ::std::borrow::Cow::from("Remote_Subframes"), ::std::borrow::Cow::from("Req"), ::std::borrow::Cow::from("SPD_Unload_Req_Peer"), ::std::borrow::Cow::from("Success_Not_Toplevel"), ::std::borrow::Cow::from("Unload"), ::std::borrow::Cow::from("Unload_Req"), ::std::borrow::Cow::from("Unload_Req_MSE"), ::std::borrow::Cow::from("Unload_Req_Peer"), ::std::borrow::Cow::from("Unload_Req_Peer_MSE")]))
    });

    #[repr(u16)]
    pub enum PageRestoredLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for PageRestoredLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PageRestoredLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bfcache.page_restored
    ///
    /// Whether bfcache is used when loading a page from session history
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BFCACHE_PAGE_RESTORED.
    pub static page_restored: Lazy<LabeledMetric<LabeledCounterMetric, PageRestoredLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "page_restored".into(),
                    category: "bfcache".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(1228), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod performance_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.total_content_page_load
    ///
    /// Time to load all of a page's resources and render. (Migrated from the geckoview metric of the same name.)
    pub static total_content_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_content_page_load".into(),
                category: "performance.page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1229), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.page.non_blank_paint
    ///
    /// The time between navigationStart and the first non-blank paint of a foreground root content document, in milliseconds. This only records documents that were in an active docshell throughout the whole time between navigation start and non-blank paint. The non-blank paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name.)
    pub static non_blank_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "non_blank_paint".into(),
                category: "performance.page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(1230), meta, TimeUnit::Millisecond)
    });

}
pub mod use_counter {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.content_documents_destroyed
    ///
    /// A count of how many content documents were destroyed. Used to turn document use counters' counts into rates. Excludes documents for which we do not count use counters (See `Document::ShouldIncludeInTelemetry`).
    pub static content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1231,
            "use.counter",
            "content_documents_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.dedicated_workers_destroyed
    ///
    /// A count of how many `Dedicated`-kind workers were destroyed. Used to turn dedicated worker use counters' counts into rates. Excludes chrome workers.
    pub static dedicated_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1232,
            "use.counter",
            "dedicated_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.service_workers_destroyed
    ///
    /// A count of how many `Service`-kind workers were destroyed. Used to turn service worker use counters' counts into rates. Excludes chrome workers.
    pub static service_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1233,
            "use.counter",
            "service_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.shared_workers_destroyed
    ///
    /// A count of how many `Shared`-kind workers were destroyed. Used to turn shared worker use counters' counts into rates. Excludes chrome workers.
    pub static shared_workers_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1234,
            "use.counter",
            "shared_workers_destroyed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.top_level_content_documents_destroyed
    ///
    /// A count of how many "pages" were destroyed. Used to turn page use counters' counts into rates. Excludes pages that contain only documents for which we do not count use counters (See `Document::ShouldIncludeInTelemetry`).
    pub static top_level_content_documents_destroyed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1235,
            "use.counter",
            "top_level_content_documents_destroyed",
            "use-counters"
        )
    });

}
pub mod use_counter_css_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.alignment_baseline
    ///
    /// Whether a document used the (unknown, counted) CSS property alignment-baseline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1236,
            "use.counter.css.doc",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property background-repeat-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1237,
            "use.counter.css.doc",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.background_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property background-repeat-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1238,
            "use.counter.css.doc",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.baseline_shift
    ///
    /// Whether a document used the (unknown, counted) CSS property baseline-shift. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1239,
            "use.counter.css.doc",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.buffered_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property buffered-rendering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1240,
            "use.counter.css.doc",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.color_rendering
    ///
    /// Whether a document used the (unknown, counted) CSS property color-rendering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1241,
            "use.counter.css.doc",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_accent_color
    ///
    /// Whether a document used the CSS property accent-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1242,
            "use.counter.css.doc",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_content
    ///
    /// Whether a document used the CSS property align-content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1243,
            "use.counter.css.doc",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_items
    ///
    /// Whether a document used the CSS property align-items. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1244,
            "use.counter.css.doc",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_align_self
    ///
    /// Whether a document used the CSS property align-self. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1245,
            "use.counter.css.doc",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_all
    ///
    /// Whether a document used the CSS property all. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1246,
            "use.counter.css.doc",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_name
    ///
    /// Whether a document used the CSS property anchor-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1247,
            "use.counter.css.doc",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_anchor_scope
    ///
    /// Whether a document used the CSS property anchor-scope. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1248,
            "use.counter.css.doc",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation
    ///
    /// Whether a document used the CSS property animation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1249,
            "use.counter.css.doc",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_composition
    ///
    /// Whether a document used the CSS property animation-composition. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1250,
            "use.counter.css.doc",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_delay
    ///
    /// Whether a document used the CSS property animation-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1251,
            "use.counter.css.doc",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_direction
    ///
    /// Whether a document used the CSS property animation-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1252,
            "use.counter.css.doc",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_duration
    ///
    /// Whether a document used the CSS property animation-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1253,
            "use.counter.css.doc",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_fill_mode
    ///
    /// Whether a document used the CSS property animation-fill-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1254,
            "use.counter.css.doc",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_iteration_count
    ///
    /// Whether a document used the CSS property animation-iteration-count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1255,
            "use.counter.css.doc",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_name
    ///
    /// Whether a document used the CSS property animation-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1256,
            "use.counter.css.doc",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_play_state
    ///
    /// Whether a document used the CSS property animation-play-state. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1257,
            "use.counter.css.doc",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timeline
    ///
    /// Whether a document used the CSS property animation-timeline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1258,
            "use.counter.css.doc",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_animation_timing_function
    ///
    /// Whether a document used the CSS property animation-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1259,
            "use.counter.css.doc",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_appearance
    ///
    /// Whether a document used the CSS property appearance. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1260,
            "use.counter.css.doc",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_aspect_ratio
    ///
    /// Whether a document used the CSS property aspect-ratio. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1261,
            "use.counter.css.doc",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backdrop_filter
    ///
    /// Whether a document used the CSS property backdrop-filter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1262,
            "use.counter.css.doc",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_backface_visibility
    ///
    /// Whether a document used the CSS property backface-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1263,
            "use.counter.css.doc",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background
    ///
    /// Whether a document used the CSS property background. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1264,
            "use.counter.css.doc",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_attachment
    ///
    /// Whether a document used the CSS property background-attachment. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1265,
            "use.counter.css.doc",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_blend_mode
    ///
    /// Whether a document used the CSS property background-blend-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1266,
            "use.counter.css.doc",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_clip
    ///
    /// Whether a document used the CSS property background-clip. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1267,
            "use.counter.css.doc",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_color
    ///
    /// Whether a document used the CSS property background-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1268,
            "use.counter.css.doc",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_image
    ///
    /// Whether a document used the CSS property background-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1269,
            "use.counter.css.doc",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_origin
    ///
    /// Whether a document used the CSS property background-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1270,
            "use.counter.css.doc",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position
    ///
    /// Whether a document used the CSS property background-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1271,
            "use.counter.css.doc",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_x
    ///
    /// Whether a document used the CSS property background-position-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1272,
            "use.counter.css.doc",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_position_y
    ///
    /// Whether a document used the CSS property background-position-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1273,
            "use.counter.css.doc",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_repeat
    ///
    /// Whether a document used the CSS property background-repeat. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1274,
            "use.counter.css.doc",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_background_size
    ///
    /// Whether a document used the CSS property background-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1275,
            "use.counter.css.doc",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_baseline_source
    ///
    /// Whether a document used the CSS property baseline-source. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1276,
            "use.counter.css.doc",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_block_size
    ///
    /// Whether a document used the CSS property block-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1277,
            "use.counter.css.doc",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border
    ///
    /// Whether a document used the CSS property border. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1278,
            "use.counter.css.doc",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block
    ///
    /// Whether a document used the CSS property border-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1279,
            "use.counter.css.doc",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_color
    ///
    /// Whether a document used the CSS property border-block-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1280,
            "use.counter.css.doc",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end
    ///
    /// Whether a document used the CSS property border-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1281,
            "use.counter.css.doc",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_color
    ///
    /// Whether a document used the CSS property border-block-end-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1282,
            "use.counter.css.doc",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_style
    ///
    /// Whether a document used the CSS property border-block-end-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1283,
            "use.counter.css.doc",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_end_width
    ///
    /// Whether a document used the CSS property border-block-end-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1284,
            "use.counter.css.doc",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start
    ///
    /// Whether a document used the CSS property border-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1285,
            "use.counter.css.doc",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_color
    ///
    /// Whether a document used the CSS property border-block-start-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1286,
            "use.counter.css.doc",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_style
    ///
    /// Whether a document used the CSS property border-block-start-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1287,
            "use.counter.css.doc",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_start_width
    ///
    /// Whether a document used the CSS property border-block-start-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1288,
            "use.counter.css.doc",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_style
    ///
    /// Whether a document used the CSS property border-block-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1289,
            "use.counter.css.doc",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_block_width
    ///
    /// Whether a document used the CSS property border-block-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1290,
            "use.counter.css.doc",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom
    ///
    /// Whether a document used the CSS property border-bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1291,
            "use.counter.css.doc",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_color
    ///
    /// Whether a document used the CSS property border-bottom-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1292,
            "use.counter.css.doc",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property border-bottom-left-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1293,
            "use.counter.css.doc",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property border-bottom-right-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1294,
            "use.counter.css.doc",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_style
    ///
    /// Whether a document used the CSS property border-bottom-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1295,
            "use.counter.css.doc",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_bottom_width
    ///
    /// Whether a document used the CSS property border-bottom-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1296,
            "use.counter.css.doc",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_collapse
    ///
    /// Whether a document used the CSS property border-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1297,
            "use.counter.css.doc",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_color
    ///
    /// Whether a document used the CSS property border-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1298,
            "use.counter.css.doc",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_end_radius
    ///
    /// Whether a document used the CSS property border-end-end-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1299,
            "use.counter.css.doc",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_end_start_radius
    ///
    /// Whether a document used the CSS property border-end-start-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1300,
            "use.counter.css.doc",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image
    ///
    /// Whether a document used the CSS property border-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1301,
            "use.counter.css.doc",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_outset
    ///
    /// Whether a document used the CSS property border-image-outset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1302,
            "use.counter.css.doc",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_repeat
    ///
    /// Whether a document used the CSS property border-image-repeat. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1303,
            "use.counter.css.doc",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_slice
    ///
    /// Whether a document used the CSS property border-image-slice. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1304,
            "use.counter.css.doc",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_source
    ///
    /// Whether a document used the CSS property border-image-source. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1305,
            "use.counter.css.doc",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_image_width
    ///
    /// Whether a document used the CSS property border-image-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1306,
            "use.counter.css.doc",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline
    ///
    /// Whether a document used the CSS property border-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1307,
            "use.counter.css.doc",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_color
    ///
    /// Whether a document used the CSS property border-inline-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1308,
            "use.counter.css.doc",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end
    ///
    /// Whether a document used the CSS property border-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1309,
            "use.counter.css.doc",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_color
    ///
    /// Whether a document used the CSS property border-inline-end-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1310,
            "use.counter.css.doc",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_style
    ///
    /// Whether a document used the CSS property border-inline-end-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1311,
            "use.counter.css.doc",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_end_width
    ///
    /// Whether a document used the CSS property border-inline-end-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1312,
            "use.counter.css.doc",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start
    ///
    /// Whether a document used the CSS property border-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1313,
            "use.counter.css.doc",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_color
    ///
    /// Whether a document used the CSS property border-inline-start-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1314,
            "use.counter.css.doc",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_style
    ///
    /// Whether a document used the CSS property border-inline-start-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1315,
            "use.counter.css.doc",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_start_width
    ///
    /// Whether a document used the CSS property border-inline-start-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1316,
            "use.counter.css.doc",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_style
    ///
    /// Whether a document used the CSS property border-inline-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1317,
            "use.counter.css.doc",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_inline_width
    ///
    /// Whether a document used the CSS property border-inline-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1318,
            "use.counter.css.doc",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left
    ///
    /// Whether a document used the CSS property border-left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1319,
            "use.counter.css.doc",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_color
    ///
    /// Whether a document used the CSS property border-left-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1320,
            "use.counter.css.doc",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_style
    ///
    /// Whether a document used the CSS property border-left-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1321,
            "use.counter.css.doc",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_left_width
    ///
    /// Whether a document used the CSS property border-left-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1322,
            "use.counter.css.doc",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_radius
    ///
    /// Whether a document used the CSS property border-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1323,
            "use.counter.css.doc",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right
    ///
    /// Whether a document used the CSS property border-right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1324,
            "use.counter.css.doc",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_color
    ///
    /// Whether a document used the CSS property border-right-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1325,
            "use.counter.css.doc",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_style
    ///
    /// Whether a document used the CSS property border-right-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1326,
            "use.counter.css.doc",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_right_width
    ///
    /// Whether a document used the CSS property border-right-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1327,
            "use.counter.css.doc",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_spacing
    ///
    /// Whether a document used the CSS property border-spacing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1328,
            "use.counter.css.doc",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_end_radius
    ///
    /// Whether a document used the CSS property border-start-end-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1329,
            "use.counter.css.doc",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_start_start_radius
    ///
    /// Whether a document used the CSS property border-start-start-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1330,
            "use.counter.css.doc",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_style
    ///
    /// Whether a document used the CSS property border-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1331,
            "use.counter.css.doc",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top
    ///
    /// Whether a document used the CSS property border-top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1332,
            "use.counter.css.doc",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_color
    ///
    /// Whether a document used the CSS property border-top-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1333,
            "use.counter.css.doc",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_left_radius
    ///
    /// Whether a document used the CSS property border-top-left-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1334,
            "use.counter.css.doc",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_right_radius
    ///
    /// Whether a document used the CSS property border-top-right-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1335,
            "use.counter.css.doc",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_style
    ///
    /// Whether a document used the CSS property border-top-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1336,
            "use.counter.css.doc",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_top_width
    ///
    /// Whether a document used the CSS property border-top-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1337,
            "use.counter.css.doc",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_border_width
    ///
    /// Whether a document used the CSS property border-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1338,
            "use.counter.css.doc",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_bottom
    ///
    /// Whether a document used the CSS property bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1339,
            "use.counter.css.doc",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_decoration_break
    ///
    /// Whether a document used the CSS property box-decoration-break. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1340,
            "use.counter.css.doc",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_shadow
    ///
    /// Whether a document used the CSS property box-shadow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1341,
            "use.counter.css.doc",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_box_sizing
    ///
    /// Whether a document used the CSS property box-sizing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1342,
            "use.counter.css.doc",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_after
    ///
    /// Whether a document used the CSS property break-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1343,
            "use.counter.css.doc",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_before
    ///
    /// Whether a document used the CSS property break-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1344,
            "use.counter.css.doc",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_break_inside
    ///
    /// Whether a document used the CSS property break-inside. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1345,
            "use.counter.css.doc",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caption_side
    ///
    /// Whether a document used the CSS property caption-side. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1346,
            "use.counter.css.doc",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_caret_color
    ///
    /// Whether a document used the CSS property caret-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1347,
            "use.counter.css.doc",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clear
    ///
    /// Whether a document used the CSS property clear. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1348,
            "use.counter.css.doc",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip
    ///
    /// Whether a document used the CSS property clip. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1349,
            "use.counter.css.doc",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_path
    ///
    /// Whether a document used the CSS property clip-path. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1350,
            "use.counter.css.doc",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_clip_rule
    ///
    /// Whether a document used the CSS property clip-rule. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1351,
            "use.counter.css.doc",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color
    ///
    /// Whether a document used the CSS property color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1352,
            "use.counter.css.doc",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_adjust
    ///
    /// Whether a document used the CSS property color-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1353,
            "use.counter.css.doc",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation
    ///
    /// Whether a document used the CSS property color-interpolation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1354,
            "use.counter.css.doc",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_interpolation_filters
    ///
    /// Whether a document used the CSS property color-interpolation-filters. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1355,
            "use.counter.css.doc",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_color_scheme
    ///
    /// Whether a document used the CSS property color-scheme. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1356,
            "use.counter.css.doc",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_count
    ///
    /// Whether a document used the CSS property column-count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1357,
            "use.counter.css.doc",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_fill
    ///
    /// Whether a document used the CSS property column-fill. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1358,
            "use.counter.css.doc",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_gap
    ///
    /// Whether a document used the CSS property column-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1359,
            "use.counter.css.doc",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule
    ///
    /// Whether a document used the CSS property column-rule. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1360,
            "use.counter.css.doc",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_color
    ///
    /// Whether a document used the CSS property column-rule-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1361,
            "use.counter.css.doc",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_style
    ///
    /// Whether a document used the CSS property column-rule-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1362,
            "use.counter.css.doc",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_rule_width
    ///
    /// Whether a document used the CSS property column-rule-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1363,
            "use.counter.css.doc",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_span
    ///
    /// Whether a document used the CSS property column-span. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1364,
            "use.counter.css.doc",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_column_width
    ///
    /// Whether a document used the CSS property column-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1365,
            "use.counter.css.doc",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_columns
    ///
    /// Whether a document used the CSS property columns. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1366,
            "use.counter.css.doc",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain
    ///
    /// Whether a document used the CSS property contain. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1367,
            "use.counter.css.doc",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_block_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-block-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1368,
            "use.counter.css.doc",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_height
    ///
    /// Whether a document used the CSS property contain-intrinsic-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1369,
            "use.counter.css.doc",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_inline_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-inline-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1370,
            "use.counter.css.doc",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_size
    ///
    /// Whether a document used the CSS property contain-intrinsic-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1371,
            "use.counter.css.doc",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_contain_intrinsic_width
    ///
    /// Whether a document used the CSS property contain-intrinsic-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1372,
            "use.counter.css.doc",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container
    ///
    /// Whether a document used the CSS property container. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1373,
            "use.counter.css.doc",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_name
    ///
    /// Whether a document used the CSS property container-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1374,
            "use.counter.css.doc",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_container_type
    ///
    /// Whether a document used the CSS property container-type. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1375,
            "use.counter.css.doc",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content
    ///
    /// Whether a document used the CSS property content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1376,
            "use.counter.css.doc",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_content_visibility
    ///
    /// Whether a document used the CSS property content-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1377,
            "use.counter.css.doc",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_increment
    ///
    /// Whether a document used the CSS property counter-increment. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1378,
            "use.counter.css.doc",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_reset
    ///
    /// Whether a document used the CSS property counter-reset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1379,
            "use.counter.css.doc",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_counter_set
    ///
    /// Whether a document used the CSS property counter-set. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1380,
            "use.counter.css.doc",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cursor
    ///
    /// Whether a document used the CSS property cursor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1381,
            "use.counter.css.doc",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cx
    ///
    /// Whether a document used the CSS property cx. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1382,
            "use.counter.css.doc",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_cy
    ///
    /// Whether a document used the CSS property cy. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1383,
            "use.counter.css.doc",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_d
    ///
    /// Whether a document used the CSS property d. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1384,
            "use.counter.css.doc",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_direction
    ///
    /// Whether a document used the CSS property direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1385,
            "use.counter.css.doc",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_display
    ///
    /// Whether a document used the CSS property display. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1386,
            "use.counter.css.doc",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_dominant_baseline
    ///
    /// Whether a document used the CSS property dominant-baseline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1387,
            "use.counter.css.doc",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_empty_cells
    ///
    /// Whether a document used the CSS property empty-cells. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1388,
            "use.counter.css.doc",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_field_sizing
    ///
    /// Whether a document used the CSS property field-sizing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_field_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1389,
            "use.counter.css.doc",
            "css_field_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill
    ///
    /// Whether a document used the CSS property fill. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1390,
            "use.counter.css.doc",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_opacity
    ///
    /// Whether a document used the CSS property fill-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1391,
            "use.counter.css.doc",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_fill_rule
    ///
    /// Whether a document used the CSS property fill-rule. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1392,
            "use.counter.css.doc",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_filter
    ///
    /// Whether a document used the CSS property filter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1393,
            "use.counter.css.doc",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex
    ///
    /// Whether a document used the CSS property flex. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1394,
            "use.counter.css.doc",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_basis
    ///
    /// Whether a document used the CSS property flex-basis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1395,
            "use.counter.css.doc",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_direction
    ///
    /// Whether a document used the CSS property flex-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1396,
            "use.counter.css.doc",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_flow
    ///
    /// Whether a document used the CSS property flex-flow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1397,
            "use.counter.css.doc",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_grow
    ///
    /// Whether a document used the CSS property flex-grow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1398,
            "use.counter.css.doc",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_shrink
    ///
    /// Whether a document used the CSS property flex-shrink. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1399,
            "use.counter.css.doc",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flex_wrap
    ///
    /// Whether a document used the CSS property flex-wrap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1400,
            "use.counter.css.doc",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_float
    ///
    /// Whether a document used the CSS property float. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1401,
            "use.counter.css.doc",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_color
    ///
    /// Whether a document used the CSS property flood-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1402,
            "use.counter.css.doc",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_flood_opacity
    ///
    /// Whether a document used the CSS property flood-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1403,
            "use.counter.css.doc",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font
    ///
    /// Whether a document used the CSS property font. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1404,
            "use.counter.css.doc",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_family
    ///
    /// Whether a document used the CSS property font-family. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1405,
            "use.counter.css.doc",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_feature_settings
    ///
    /// Whether a document used the CSS property font-feature-settings. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1406,
            "use.counter.css.doc",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_kerning
    ///
    /// Whether a document used the CSS property font-kerning. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1407,
            "use.counter.css.doc",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_language_override
    ///
    /// Whether a document used the CSS property font-language-override. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1408,
            "use.counter.css.doc",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_optical_sizing
    ///
    /// Whether a document used the CSS property font-optical-sizing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1409,
            "use.counter.css.doc",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_palette
    ///
    /// Whether a document used the CSS property font-palette. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1410,
            "use.counter.css.doc",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size
    ///
    /// Whether a document used the CSS property font-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1411,
            "use.counter.css.doc",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_size_adjust
    ///
    /// Whether a document used the CSS property font-size-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1412,
            "use.counter.css.doc",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_stretch
    ///
    /// Whether a document used the CSS property font-stretch. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1413,
            "use.counter.css.doc",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_style
    ///
    /// Whether a document used the CSS property font-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1414,
            "use.counter.css.doc",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis
    ///
    /// Whether a document used the CSS property font-synthesis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1415,
            "use.counter.css.doc",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_position
    ///
    /// Whether a document used the CSS property font-synthesis-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1416,
            "use.counter.css.doc",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_small_caps
    ///
    /// Whether a document used the CSS property font-synthesis-small-caps. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1417,
            "use.counter.css.doc",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_style
    ///
    /// Whether a document used the CSS property font-synthesis-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1418,
            "use.counter.css.doc",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_synthesis_weight
    ///
    /// Whether a document used the CSS property font-synthesis-weight. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1419,
            "use.counter.css.doc",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant
    ///
    /// Whether a document used the CSS property font-variant. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1420,
            "use.counter.css.doc",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_alternates
    ///
    /// Whether a document used the CSS property font-variant-alternates. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1421,
            "use.counter.css.doc",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_caps
    ///
    /// Whether a document used the CSS property font-variant-caps. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1422,
            "use.counter.css.doc",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_east_asian
    ///
    /// Whether a document used the CSS property font-variant-east-asian. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1423,
            "use.counter.css.doc",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_emoji
    ///
    /// Whether a document used the CSS property font-variant-emoji. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1424,
            "use.counter.css.doc",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_ligatures
    ///
    /// Whether a document used the CSS property font-variant-ligatures. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1425,
            "use.counter.css.doc",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_numeric
    ///
    /// Whether a document used the CSS property font-variant-numeric. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1426,
            "use.counter.css.doc",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variant_position
    ///
    /// Whether a document used the CSS property font-variant-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1427,
            "use.counter.css.doc",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_variation_settings
    ///
    /// Whether a document used the CSS property font-variation-settings. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1428,
            "use.counter.css.doc",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_font_weight
    ///
    /// Whether a document used the CSS property font-weight. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1429,
            "use.counter.css.doc",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_forced_color_adjust
    ///
    /// Whether a document used the CSS property forced-color-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1430,
            "use.counter.css.doc",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_gap
    ///
    /// Whether a document used the CSS property gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1431,
            "use.counter.css.doc",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid
    ///
    /// Whether a document used the CSS property grid. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1432,
            "use.counter.css.doc",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_area
    ///
    /// Whether a document used the CSS property grid-area. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1433,
            "use.counter.css.doc",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_columns
    ///
    /// Whether a document used the CSS property grid-auto-columns. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1434,
            "use.counter.css.doc",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_flow
    ///
    /// Whether a document used the CSS property grid-auto-flow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1435,
            "use.counter.css.doc",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_auto_rows
    ///
    /// Whether a document used the CSS property grid-auto-rows. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1436,
            "use.counter.css.doc",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column
    ///
    /// Whether a document used the CSS property grid-column. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1437,
            "use.counter.css.doc",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_end
    ///
    /// Whether a document used the CSS property grid-column-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1438,
            "use.counter.css.doc",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_gap
    ///
    /// Whether a document used the CSS property grid-column-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1439,
            "use.counter.css.doc",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_column_start
    ///
    /// Whether a document used the CSS property grid-column-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1440,
            "use.counter.css.doc",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_gap
    ///
    /// Whether a document used the CSS property grid-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1441,
            "use.counter.css.doc",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row
    ///
    /// Whether a document used the CSS property grid-row. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1442,
            "use.counter.css.doc",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_end
    ///
    /// Whether a document used the CSS property grid-row-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1443,
            "use.counter.css.doc",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_gap
    ///
    /// Whether a document used the CSS property grid-row-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1444,
            "use.counter.css.doc",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_row_start
    ///
    /// Whether a document used the CSS property grid-row-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1445,
            "use.counter.css.doc",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template
    ///
    /// Whether a document used the CSS property grid-template. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1446,
            "use.counter.css.doc",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_areas
    ///
    /// Whether a document used the CSS property grid-template-areas. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1447,
            "use.counter.css.doc",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_columns
    ///
    /// Whether a document used the CSS property grid-template-columns. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1448,
            "use.counter.css.doc",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_grid_template_rows
    ///
    /// Whether a document used the CSS property grid-template-rows. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1449,
            "use.counter.css.doc",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_height
    ///
    /// Whether a document used the CSS property height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1450,
            "use.counter.css.doc",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphenate_character
    ///
    /// Whether a document used the CSS property hyphenate-character. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1451,
            "use.counter.css.doc",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphenate_limit_chars
    ///
    /// Whether a document used the CSS property hyphenate-limit-chars. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_limit_chars: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1452,
            "use.counter.css.doc",
            "css_hyphenate_limit_chars",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_hyphens
    ///
    /// Whether a document used the CSS property hyphens. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1453,
            "use.counter.css.doc",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_orientation
    ///
    /// Whether a document used the CSS property image-orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1454,
            "use.counter.css.doc",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_image_rendering
    ///
    /// Whether a document used the CSS property image-rendering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1455,
            "use.counter.css.doc",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ime_mode
    ///
    /// Whether a document used the CSS property ime-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1456,
            "use.counter.css.doc",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_initial_letter
    ///
    /// Whether a document used the CSS property initial-letter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1457,
            "use.counter.css.doc",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inline_size
    ///
    /// Whether a document used the CSS property inline-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1458,
            "use.counter.css.doc",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset
    ///
    /// Whether a document used the CSS property inset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1459,
            "use.counter.css.doc",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block
    ///
    /// Whether a document used the CSS property inset-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1460,
            "use.counter.css.doc",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_end
    ///
    /// Whether a document used the CSS property inset-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1461,
            "use.counter.css.doc",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_block_start
    ///
    /// Whether a document used the CSS property inset-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1462,
            "use.counter.css.doc",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline
    ///
    /// Whether a document used the CSS property inset-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1463,
            "use.counter.css.doc",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_end
    ///
    /// Whether a document used the CSS property inset-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1464,
            "use.counter.css.doc",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_inset_inline_start
    ///
    /// Whether a document used the CSS property inset-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1465,
            "use.counter.css.doc",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_isolation
    ///
    /// Whether a document used the CSS property isolation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1466,
            "use.counter.css.doc",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_content
    ///
    /// Whether a document used the CSS property justify-content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1467,
            "use.counter.css.doc",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_items
    ///
    /// Whether a document used the CSS property justify-items. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1468,
            "use.counter.css.doc",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_justify_self
    ///
    /// Whether a document used the CSS property justify-self. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1469,
            "use.counter.css.doc",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_left
    ///
    /// Whether a document used the CSS property left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1470,
            "use.counter.css.doc",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_letter_spacing
    ///
    /// Whether a document used the CSS property letter-spacing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1471,
            "use.counter.css.doc",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_lighting_color
    ///
    /// Whether a document used the CSS property lighting-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1472,
            "use.counter.css.doc",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_break
    ///
    /// Whether a document used the CSS property line-break. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1473,
            "use.counter.css.doc",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_line_height
    ///
    /// Whether a document used the CSS property line-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1474,
            "use.counter.css.doc",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style
    ///
    /// Whether a document used the CSS property list-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1475,
            "use.counter.css.doc",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_image
    ///
    /// Whether a document used the CSS property list-style-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1476,
            "use.counter.css.doc",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_position
    ///
    /// Whether a document used the CSS property list-style-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1477,
            "use.counter.css.doc",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_list_style_type
    ///
    /// Whether a document used the CSS property list-style-type. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1478,
            "use.counter.css.doc",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin
    ///
    /// Whether a document used the CSS property margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1479,
            "use.counter.css.doc",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block
    ///
    /// Whether a document used the CSS property margin-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1480,
            "use.counter.css.doc",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_end
    ///
    /// Whether a document used the CSS property margin-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1481,
            "use.counter.css.doc",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_block_start
    ///
    /// Whether a document used the CSS property margin-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1482,
            "use.counter.css.doc",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_bottom
    ///
    /// Whether a document used the CSS property margin-bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1483,
            "use.counter.css.doc",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline
    ///
    /// Whether a document used the CSS property margin-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1484,
            "use.counter.css.doc",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_end
    ///
    /// Whether a document used the CSS property margin-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1485,
            "use.counter.css.doc",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_inline_start
    ///
    /// Whether a document used the CSS property margin-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1486,
            "use.counter.css.doc",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_left
    ///
    /// Whether a document used the CSS property margin-left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1487,
            "use.counter.css.doc",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_right
    ///
    /// Whether a document used the CSS property margin-right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1488,
            "use.counter.css.doc",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_margin_top
    ///
    /// Whether a document used the CSS property margin-top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1489,
            "use.counter.css.doc",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker
    ///
    /// Whether a document used the CSS property marker. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1490,
            "use.counter.css.doc",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_end
    ///
    /// Whether a document used the CSS property marker-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1491,
            "use.counter.css.doc",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_mid
    ///
    /// Whether a document used the CSS property marker-mid. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1492,
            "use.counter.css.doc",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_marker_start
    ///
    /// Whether a document used the CSS property marker-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1493,
            "use.counter.css.doc",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask
    ///
    /// Whether a document used the CSS property mask. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1494,
            "use.counter.css.doc",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_clip
    ///
    /// Whether a document used the CSS property mask-clip. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1495,
            "use.counter.css.doc",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_composite
    ///
    /// Whether a document used the CSS property mask-composite. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1496,
            "use.counter.css.doc",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_image
    ///
    /// Whether a document used the CSS property mask-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1497,
            "use.counter.css.doc",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_mode
    ///
    /// Whether a document used the CSS property mask-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1498,
            "use.counter.css.doc",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_origin
    ///
    /// Whether a document used the CSS property mask-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1499,
            "use.counter.css.doc",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position
    ///
    /// Whether a document used the CSS property mask-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1500,
            "use.counter.css.doc",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_x
    ///
    /// Whether a document used the CSS property mask-position-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1501,
            "use.counter.css.doc",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_position_y
    ///
    /// Whether a document used the CSS property mask-position-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1502,
            "use.counter.css.doc",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_repeat
    ///
    /// Whether a document used the CSS property mask-repeat. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1503,
            "use.counter.css.doc",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_size
    ///
    /// Whether a document used the CSS property mask-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1504,
            "use.counter.css.doc",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mask_type
    ///
    /// Whether a document used the CSS property mask-type. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1505,
            "use.counter.css.doc",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_masonry_auto_flow
    ///
    /// Whether a document used the CSS property masonry-auto-flow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1506,
            "use.counter.css.doc",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_depth
    ///
    /// Whether a document used the CSS property math-depth. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1507,
            "use.counter.css.doc",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_math_style
    ///
    /// Whether a document used the CSS property math-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1508,
            "use.counter.css.doc",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_block_size
    ///
    /// Whether a document used the CSS property max-block-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1509,
            "use.counter.css.doc",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_height
    ///
    /// Whether a document used the CSS property max-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1510,
            "use.counter.css.doc",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_inline_size
    ///
    /// Whether a document used the CSS property max-inline-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1511,
            "use.counter.css.doc",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_max_width
    ///
    /// Whether a document used the CSS property max-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1512,
            "use.counter.css.doc",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_block_size
    ///
    /// Whether a document used the CSS property min-block-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1513,
            "use.counter.css.doc",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_height
    ///
    /// Whether a document used the CSS property min-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1514,
            "use.counter.css.doc",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_inline_size
    ///
    /// Whether a document used the CSS property min-inline-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1515,
            "use.counter.css.doc",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_min_width
    ///
    /// Whether a document used the CSS property min-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1516,
            "use.counter.css.doc",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_mix_blend_mode
    ///
    /// Whether a document used the CSS property mix-blend-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1517,
            "use.counter.css.doc",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation
    ///
    /// Whether a document used the CSS property -moz-animation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1518,
            "use.counter.css.doc",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_delay
    ///
    /// Whether a document used the CSS property -moz-animation-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1519,
            "use.counter.css.doc",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_direction
    ///
    /// Whether a document used the CSS property -moz-animation-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1520,
            "use.counter.css.doc",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_duration
    ///
    /// Whether a document used the CSS property -moz-animation-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1521,
            "use.counter.css.doc",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_fill_mode
    ///
    /// Whether a document used the CSS property -moz-animation-fill-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1522,
            "use.counter.css.doc",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_iteration_count
    ///
    /// Whether a document used the CSS property -moz-animation-iteration-count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1523,
            "use.counter.css.doc",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_name
    ///
    /// Whether a document used the CSS property -moz-animation-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1524,
            "use.counter.css.doc",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_play_state
    ///
    /// Whether a document used the CSS property -moz-animation-play-state. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1525,
            "use.counter.css.doc",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_animation_timing_function
    ///
    /// Whether a document used the CSS property -moz-animation-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1526,
            "use.counter.css.doc",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_appearance
    ///
    /// Whether a document used the CSS property -moz-appearance. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1527,
            "use.counter.css.doc",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_backface_visibility
    ///
    /// Whether a document used the CSS property -moz-backface-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1528,
            "use.counter.css.doc",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end
    ///
    /// Whether a document used the CSS property -moz-border-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1529,
            "use.counter.css.doc",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_color
    ///
    /// Whether a document used the CSS property -moz-border-end-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1530,
            "use.counter.css.doc",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_style
    ///
    /// Whether a document used the CSS property -moz-border-end-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1531,
            "use.counter.css.doc",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_end_width
    ///
    /// Whether a document used the CSS property -moz-border-end-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1532,
            "use.counter.css.doc",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_image
    ///
    /// Whether a document used the CSS property -moz-border-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1533,
            "use.counter.css.doc",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start
    ///
    /// Whether a document used the CSS property -moz-border-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1534,
            "use.counter.css.doc",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_color
    ///
    /// Whether a document used the CSS property -moz-border-start-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1535,
            "use.counter.css.doc",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_style
    ///
    /// Whether a document used the CSS property -moz-border-start-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1536,
            "use.counter.css.doc",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_border_start_width
    ///
    /// Whether a document used the CSS property -moz-border-start-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1537,
            "use.counter.css.doc",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_align
    ///
    /// Whether a document used the CSS property -moz-box-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1538,
            "use.counter.css.doc",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_collapse
    ///
    /// Whether a document used the CSS property -moz-box-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1539,
            "use.counter.css.doc",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_direction
    ///
    /// Whether a document used the CSS property -moz-box-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1540,
            "use.counter.css.doc",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_flex
    ///
    /// Whether a document used the CSS property -moz-box-flex. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1541,
            "use.counter.css.doc",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_ordinal_group
    ///
    /// Whether a document used the CSS property -moz-box-ordinal-group. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1542,
            "use.counter.css.doc",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_orient
    ///
    /// Whether a document used the CSS property -moz-box-orient. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1543,
            "use.counter.css.doc",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_pack
    ///
    /// Whether a document used the CSS property -moz-box-pack. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1544,
            "use.counter.css.doc",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_box_sizing
    ///
    /// Whether a document used the CSS property -moz-box-sizing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1545,
            "use.counter.css.doc",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_context_properties
    ///
    /// Whether a document used the CSS property -moz-context-properties. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1546,
            "use.counter.css.doc",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_control_character_visibility
    ///
    /// Whether a document used the CSS property -moz-control-character-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1547,
            "use.counter.css.doc",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_default_appearance
    ///
    /// Whether a document used the CSS property -moz-default-appearance. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1548,
            "use.counter.css.doc",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_float_edge
    ///
    /// Whether a document used the CSS property -moz-float-edge. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1549,
            "use.counter.css.doc",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_feature_settings
    ///
    /// Whether a document used the CSS property -moz-font-feature-settings. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1550,
            "use.counter.css.doc",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_font_language_override
    ///
    /// Whether a document used the CSS property -moz-font-language-override. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1551,
            "use.counter.css.doc",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_force_broken_image_icon
    ///
    /// Whether a document used the CSS property -moz-force-broken-image-icon. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1552,
            "use.counter.css.doc",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_hyphens
    ///
    /// Whether a document used the CSS property -moz-hyphens. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1553,
            "use.counter.css.doc",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_inert
    ///
    /// Whether a document used the CSS property -moz-inert. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1554,
            "use.counter.css.doc",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_end
    ///
    /// Whether a document used the CSS property -moz-margin-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1555,
            "use.counter.css.doc",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_margin_start
    ///
    /// Whether a document used the CSS property -moz-margin-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1556,
            "use.counter.css.doc",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_math_variant
    ///
    /// Whether a document used the CSS property -moz-math-variant. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1557,
            "use.counter.css.doc",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_min_font_size_ratio
    ///
    /// Whether a document used the CSS property -moz-min-font-size-ratio. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1558,
            "use.counter.css.doc",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_orient
    ///
    /// Whether a document used the CSS property -moz-orient. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1559,
            "use.counter.css.doc",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_osx_font_smoothing
    ///
    /// Whether a document used the CSS property -moz-osx-font-smoothing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1560,
            "use.counter.css.doc",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_end
    ///
    /// Whether a document used the CSS property -moz-padding-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1561,
            "use.counter.css.doc",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_padding_start
    ///
    /// Whether a document used the CSS property -moz-padding-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1562,
            "use.counter.css.doc",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective
    ///
    /// Whether a document used the CSS property -moz-perspective. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1563,
            "use.counter.css.doc",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_perspective_origin
    ///
    /// Whether a document used the CSS property -moz-perspective-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1564,
            "use.counter.css.doc",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a document used the CSS property -moz-subtree-hidden-only-visually. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1565,
            "use.counter.css.doc",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_tab_size
    ///
    /// Whether a document used the CSS property -moz-tab-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1566,
            "use.counter.css.doc",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_text_size_adjust
    ///
    /// Whether a document used the CSS property -moz-text-size-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1567,
            "use.counter.css.doc",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_theme
    ///
    /// Whether a document used the CSS property -moz-theme. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1568,
            "use.counter.css.doc",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_top_layer
    ///
    /// Whether a document used the CSS property -moz-top-layer. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1569,
            "use.counter.css.doc",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform
    ///
    /// Whether a document used the CSS property -moz-transform. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1570,
            "use.counter.css.doc",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_origin
    ///
    /// Whether a document used the CSS property -moz-transform-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1571,
            "use.counter.css.doc",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transform_style
    ///
    /// Whether a document used the CSS property -moz-transform-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1572,
            "use.counter.css.doc",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition
    ///
    /// Whether a document used the CSS property -moz-transition. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1573,
            "use.counter.css.doc",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_delay
    ///
    /// Whether a document used the CSS property -moz-transition-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1574,
            "use.counter.css.doc",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_duration
    ///
    /// Whether a document used the CSS property -moz-transition-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1575,
            "use.counter.css.doc",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_property
    ///
    /// Whether a document used the CSS property -moz-transition-property. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1576,
            "use.counter.css.doc",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_transition_timing_function
    ///
    /// Whether a document used the CSS property -moz-transition-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1577,
            "use.counter.css.doc",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_focus
    ///
    /// Whether a document used the CSS property -moz-user-focus. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1578,
            "use.counter.css.doc",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_input
    ///
    /// Whether a document used the CSS property -moz-user-input. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1579,
            "use.counter.css.doc",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_user_select
    ///
    /// Whether a document used the CSS property -moz-user-select. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1580,
            "use.counter.css.doc",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_dragging
    ///
    /// Whether a document used the CSS property -moz-window-dragging. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1581,
            "use.counter.css.doc",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_input_region_margin
    ///
    /// Whether a document used the CSS property -moz-window-input-region-margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1582,
            "use.counter.css.doc",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_opacity
    ///
    /// Whether a document used the CSS property -moz-window-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1583,
            "use.counter.css.doc",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_shadow
    ///
    /// Whether a document used the CSS property -moz-window-shadow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1584,
            "use.counter.css.doc",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_moz_window_transform
    ///
    /// Whether a document used the CSS property -moz-window-transform. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1585,
            "use.counter.css.doc",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_fit
    ///
    /// Whether a document used the CSS property object-fit. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1586,
            "use.counter.css.doc",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_object_position
    ///
    /// Whether a document used the CSS property object-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1587,
            "use.counter.css.doc",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset
    ///
    /// Whether a document used the CSS property offset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1588,
            "use.counter.css.doc",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_anchor
    ///
    /// Whether a document used the CSS property offset-anchor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1589,
            "use.counter.css.doc",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_distance
    ///
    /// Whether a document used the CSS property offset-distance. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1590,
            "use.counter.css.doc",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_path
    ///
    /// Whether a document used the CSS property offset-path. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1591,
            "use.counter.css.doc",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_position
    ///
    /// Whether a document used the CSS property offset-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1592,
            "use.counter.css.doc",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_offset_rotate
    ///
    /// Whether a document used the CSS property offset-rotate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1593,
            "use.counter.css.doc",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_opacity
    ///
    /// Whether a document used the CSS property opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1594,
            "use.counter.css.doc",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_order
    ///
    /// Whether a document used the CSS property order. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1595,
            "use.counter.css.doc",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline
    ///
    /// Whether a document used the CSS property outline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1596,
            "use.counter.css.doc",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_color
    ///
    /// Whether a document used the CSS property outline-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1597,
            "use.counter.css.doc",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_offset
    ///
    /// Whether a document used the CSS property outline-offset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1598,
            "use.counter.css.doc",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_style
    ///
    /// Whether a document used the CSS property outline-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1599,
            "use.counter.css.doc",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_outline_width
    ///
    /// Whether a document used the CSS property outline-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1600,
            "use.counter.css.doc",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow
    ///
    /// Whether a document used the CSS property overflow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1601,
            "use.counter.css.doc",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_anchor
    ///
    /// Whether a document used the CSS property overflow-anchor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1602,
            "use.counter.css.doc",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_block
    ///
    /// Whether a document used the CSS property overflow-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1603,
            "use.counter.css.doc",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box
    ///
    /// Whether a document used the CSS property overflow-clip-box. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1604,
            "use.counter.css.doc",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_block
    ///
    /// Whether a document used the CSS property overflow-clip-box-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1605,
            "use.counter.css.doc",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_box_inline
    ///
    /// Whether a document used the CSS property overflow-clip-box-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1606,
            "use.counter.css.doc",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_clip_margin
    ///
    /// Whether a document used the CSS property overflow-clip-margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1607,
            "use.counter.css.doc",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_inline
    ///
    /// Whether a document used the CSS property overflow-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1608,
            "use.counter.css.doc",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_wrap
    ///
    /// Whether a document used the CSS property overflow-wrap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1609,
            "use.counter.css.doc",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_x
    ///
    /// Whether a document used the CSS property overflow-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1610,
            "use.counter.css.doc",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overflow_y
    ///
    /// Whether a document used the CSS property overflow-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1611,
            "use.counter.css.doc",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior
    ///
    /// Whether a document used the CSS property overscroll-behavior. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1612,
            "use.counter.css.doc",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_block
    ///
    /// Whether a document used the CSS property overscroll-behavior-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1613,
            "use.counter.css.doc",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_inline
    ///
    /// Whether a document used the CSS property overscroll-behavior-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1614,
            "use.counter.css.doc",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_x
    ///
    /// Whether a document used the CSS property overscroll-behavior-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1615,
            "use.counter.css.doc",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_overscroll_behavior_y
    ///
    /// Whether a document used the CSS property overscroll-behavior-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1616,
            "use.counter.css.doc",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding
    ///
    /// Whether a document used the CSS property padding. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1617,
            "use.counter.css.doc",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block
    ///
    /// Whether a document used the CSS property padding-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1618,
            "use.counter.css.doc",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_end
    ///
    /// Whether a document used the CSS property padding-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1619,
            "use.counter.css.doc",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_block_start
    ///
    /// Whether a document used the CSS property padding-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1620,
            "use.counter.css.doc",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_bottom
    ///
    /// Whether a document used the CSS property padding-bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1621,
            "use.counter.css.doc",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline
    ///
    /// Whether a document used the CSS property padding-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1622,
            "use.counter.css.doc",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_end
    ///
    /// Whether a document used the CSS property padding-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1623,
            "use.counter.css.doc",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_inline_start
    ///
    /// Whether a document used the CSS property padding-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1624,
            "use.counter.css.doc",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_left
    ///
    /// Whether a document used the CSS property padding-left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1625,
            "use.counter.css.doc",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_right
    ///
    /// Whether a document used the CSS property padding-right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1626,
            "use.counter.css.doc",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_padding_top
    ///
    /// Whether a document used the CSS property padding-top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1627,
            "use.counter.css.doc",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page
    ///
    /// Whether a document used the CSS property page. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1628,
            "use.counter.css.doc",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_after
    ///
    /// Whether a document used the CSS property page-break-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1629,
            "use.counter.css.doc",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_before
    ///
    /// Whether a document used the CSS property page-break-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1630,
            "use.counter.css.doc",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_break_inside
    ///
    /// Whether a document used the CSS property page-break-inside. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1631,
            "use.counter.css.doc",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_page_orientation
    ///
    /// Whether a document used the CSS property page-orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1632,
            "use.counter.css.doc",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_paint_order
    ///
    /// Whether a document used the CSS property paint-order. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1633,
            "use.counter.css.doc",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective
    ///
    /// Whether a document used the CSS property perspective. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1634,
            "use.counter.css.doc",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_perspective_origin
    ///
    /// Whether a document used the CSS property perspective-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1635,
            "use.counter.css.doc",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_content
    ///
    /// Whether a document used the CSS property place-content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1636,
            "use.counter.css.doc",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_items
    ///
    /// Whether a document used the CSS property place-items. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1637,
            "use.counter.css.doc",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_place_self
    ///
    /// Whether a document used the CSS property place-self. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1638,
            "use.counter.css.doc",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_pointer_events
    ///
    /// Whether a document used the CSS property pointer-events. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1639,
            "use.counter.css.doc",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position
    ///
    /// Whether a document used the CSS property position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1640,
            "use.counter.css.doc",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_anchor
    ///
    /// Whether a document used the CSS property position-anchor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1641,
            "use.counter.css.doc",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_area
    ///
    /// Whether a document used the CSS property position-area. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1642,
            "use.counter.css.doc",
            "css_position_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try
    ///
    /// Whether a document used the CSS property position-try. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1643,
            "use.counter.css.doc",
            "css_position_try",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_fallbacks
    ///
    /// Whether a document used the CSS property position-try-fallbacks. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_fallbacks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1644,
            "use.counter.css.doc",
            "css_position_try_fallbacks",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_try_order
    ///
    /// Whether a document used the CSS property position-try-order. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1645,
            "use.counter.css.doc",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_position_visibility
    ///
    /// Whether a document used the CSS property position-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1646,
            "use.counter.css.doc",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_print_color_adjust
    ///
    /// Whether a document used the CSS property print-color-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1647,
            "use.counter.css.doc",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_quotes
    ///
    /// Whether a document used the CSS property quotes. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1648,
            "use.counter.css.doc",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_r
    ///
    /// Whether a document used the CSS property r. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1649,
            "use.counter.css.doc",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_resize
    ///
    /// Whether a document used the CSS property resize. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1650,
            "use.counter.css.doc",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_right
    ///
    /// Whether a document used the CSS property right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1651,
            "use.counter.css.doc",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rotate
    ///
    /// Whether a document used the CSS property rotate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1652,
            "use.counter.css.doc",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_row_gap
    ///
    /// Whether a document used the CSS property row-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1653,
            "use.counter.css.doc",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_align
    ///
    /// Whether a document used the CSS property ruby-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1654,
            "use.counter.css.doc",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ruby_position
    ///
    /// Whether a document used the CSS property ruby-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1655,
            "use.counter.css.doc",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_rx
    ///
    /// Whether a document used the CSS property rx. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1656,
            "use.counter.css.doc",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_ry
    ///
    /// Whether a document used the CSS property ry. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1657,
            "use.counter.css.doc",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scale
    ///
    /// Whether a document used the CSS property scale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1658,
            "use.counter.css.doc",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_behavior
    ///
    /// Whether a document used the CSS property scroll-behavior. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1659,
            "use.counter.css.doc",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin
    ///
    /// Whether a document used the CSS property scroll-margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1660,
            "use.counter.css.doc",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block
    ///
    /// Whether a document used the CSS property scroll-margin-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1661,
            "use.counter.css.doc",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_end
    ///
    /// Whether a document used the CSS property scroll-margin-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1662,
            "use.counter.css.doc",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_block_start
    ///
    /// Whether a document used the CSS property scroll-margin-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1663,
            "use.counter.css.doc",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_bottom
    ///
    /// Whether a document used the CSS property scroll-margin-bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1664,
            "use.counter.css.doc",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline
    ///
    /// Whether a document used the CSS property scroll-margin-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1665,
            "use.counter.css.doc",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_end
    ///
    /// Whether a document used the CSS property scroll-margin-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1666,
            "use.counter.css.doc",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_inline_start
    ///
    /// Whether a document used the CSS property scroll-margin-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1667,
            "use.counter.css.doc",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_left
    ///
    /// Whether a document used the CSS property scroll-margin-left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1668,
            "use.counter.css.doc",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_right
    ///
    /// Whether a document used the CSS property scroll-margin-right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1669,
            "use.counter.css.doc",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_margin_top
    ///
    /// Whether a document used the CSS property scroll-margin-top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1670,
            "use.counter.css.doc",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding
    ///
    /// Whether a document used the CSS property scroll-padding. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1671,
            "use.counter.css.doc",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block
    ///
    /// Whether a document used the CSS property scroll-padding-block. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1672,
            "use.counter.css.doc",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_end
    ///
    /// Whether a document used the CSS property scroll-padding-block-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1673,
            "use.counter.css.doc",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_block_start
    ///
    /// Whether a document used the CSS property scroll-padding-block-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1674,
            "use.counter.css.doc",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_bottom
    ///
    /// Whether a document used the CSS property scroll-padding-bottom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1675,
            "use.counter.css.doc",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline
    ///
    /// Whether a document used the CSS property scroll-padding-inline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1676,
            "use.counter.css.doc",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_end
    ///
    /// Whether a document used the CSS property scroll-padding-inline-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1677,
            "use.counter.css.doc",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_inline_start
    ///
    /// Whether a document used the CSS property scroll-padding-inline-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1678,
            "use.counter.css.doc",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_left
    ///
    /// Whether a document used the CSS property scroll-padding-left. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1679,
            "use.counter.css.doc",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_right
    ///
    /// Whether a document used the CSS property scroll-padding-right. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1680,
            "use.counter.css.doc",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_padding_top
    ///
    /// Whether a document used the CSS property scroll-padding-top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1681,
            "use.counter.css.doc",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_align
    ///
    /// Whether a document used the CSS property scroll-snap-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1682,
            "use.counter.css.doc",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_stop
    ///
    /// Whether a document used the CSS property scroll-snap-stop. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1683,
            "use.counter.css.doc",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_snap_type
    ///
    /// Whether a document used the CSS property scroll-snap-type. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1684,
            "use.counter.css.doc",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline
    ///
    /// Whether a document used the CSS property scroll-timeline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1685,
            "use.counter.css.doc",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_axis
    ///
    /// Whether a document used the CSS property scroll-timeline-axis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1686,
            "use.counter.css.doc",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scroll_timeline_name
    ///
    /// Whether a document used the CSS property scroll-timeline-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1687,
            "use.counter.css.doc",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_color
    ///
    /// Whether a document used the CSS property scrollbar-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1688,
            "use.counter.css.doc",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_gutter
    ///
    /// Whether a document used the CSS property scrollbar-gutter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1689,
            "use.counter.css.doc",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_scrollbar_width
    ///
    /// Whether a document used the CSS property scrollbar-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1690,
            "use.counter.css.doc",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_image_threshold
    ///
    /// Whether a document used the CSS property shape-image-threshold. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1691,
            "use.counter.css.doc",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_margin
    ///
    /// Whether a document used the CSS property shape-margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1692,
            "use.counter.css.doc",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_outside
    ///
    /// Whether a document used the CSS property shape-outside. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1693,
            "use.counter.css.doc",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_shape_rendering
    ///
    /// Whether a document used the CSS property shape-rendering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1694,
            "use.counter.css.doc",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_size
    ///
    /// Whether a document used the CSS property size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1695,
            "use.counter.css.doc",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_color
    ///
    /// Whether a document used the CSS property stop-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1696,
            "use.counter.css.doc",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stop_opacity
    ///
    /// Whether a document used the CSS property stop-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1697,
            "use.counter.css.doc",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke
    ///
    /// Whether a document used the CSS property stroke. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1698,
            "use.counter.css.doc",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dasharray
    ///
    /// Whether a document used the CSS property stroke-dasharray. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1699,
            "use.counter.css.doc",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_dashoffset
    ///
    /// Whether a document used the CSS property stroke-dashoffset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1700,
            "use.counter.css.doc",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linecap
    ///
    /// Whether a document used the CSS property stroke-linecap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1701,
            "use.counter.css.doc",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_linejoin
    ///
    /// Whether a document used the CSS property stroke-linejoin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1702,
            "use.counter.css.doc",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_miterlimit
    ///
    /// Whether a document used the CSS property stroke-miterlimit. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1703,
            "use.counter.css.doc",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_opacity
    ///
    /// Whether a document used the CSS property stroke-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1704,
            "use.counter.css.doc",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_stroke_width
    ///
    /// Whether a document used the CSS property stroke-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1705,
            "use.counter.css.doc",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_tab_size
    ///
    /// Whether a document used the CSS property tab-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1706,
            "use.counter.css.doc",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_table_layout
    ///
    /// Whether a document used the CSS property table-layout. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1707,
            "use.counter.css.doc",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align
    ///
    /// Whether a document used the CSS property text-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1708,
            "use.counter.css.doc",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_align_last
    ///
    /// Whether a document used the CSS property text-align-last. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1709,
            "use.counter.css.doc",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_anchor
    ///
    /// Whether a document used the CSS property text-anchor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1710,
            "use.counter.css.doc",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_combine_upright
    ///
    /// Whether a document used the CSS property text-combine-upright. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1711,
            "use.counter.css.doc",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration
    ///
    /// Whether a document used the CSS property text-decoration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1712,
            "use.counter.css.doc",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_color
    ///
    /// Whether a document used the CSS property text-decoration-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1713,
            "use.counter.css.doc",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_line
    ///
    /// Whether a document used the CSS property text-decoration-line. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1714,
            "use.counter.css.doc",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_skip_ink
    ///
    /// Whether a document used the CSS property text-decoration-skip-ink. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1715,
            "use.counter.css.doc",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_style
    ///
    /// Whether a document used the CSS property text-decoration-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1716,
            "use.counter.css.doc",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_decoration_thickness
    ///
    /// Whether a document used the CSS property text-decoration-thickness. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1717,
            "use.counter.css.doc",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis
    ///
    /// Whether a document used the CSS property text-emphasis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1718,
            "use.counter.css.doc",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_color
    ///
    /// Whether a document used the CSS property text-emphasis-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1719,
            "use.counter.css.doc",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_position
    ///
    /// Whether a document used the CSS property text-emphasis-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1720,
            "use.counter.css.doc",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_emphasis_style
    ///
    /// Whether a document used the CSS property text-emphasis-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1721,
            "use.counter.css.doc",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_indent
    ///
    /// Whether a document used the CSS property text-indent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1722,
            "use.counter.css.doc",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_justify
    ///
    /// Whether a document used the CSS property text-justify. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1723,
            "use.counter.css.doc",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_orientation
    ///
    /// Whether a document used the CSS property text-orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1724,
            "use.counter.css.doc",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_overflow
    ///
    /// Whether a document used the CSS property text-overflow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1725,
            "use.counter.css.doc",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_rendering
    ///
    /// Whether a document used the CSS property text-rendering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1726,
            "use.counter.css.doc",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_shadow
    ///
    /// Whether a document used the CSS property text-shadow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1727,
            "use.counter.css.doc",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_transform
    ///
    /// Whether a document used the CSS property text-transform. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1728,
            "use.counter.css.doc",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_offset
    ///
    /// Whether a document used the CSS property text-underline-offset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1729,
            "use.counter.css.doc",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_underline_position
    ///
    /// Whether a document used the CSS property text-underline-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1730,
            "use.counter.css.doc",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap
    ///
    /// Whether a document used the CSS property text-wrap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1731,
            "use.counter.css.doc",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_mode
    ///
    /// Whether a document used the CSS property text-wrap-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1732,
            "use.counter.css.doc",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_text_wrap_style
    ///
    /// Whether a document used the CSS property text-wrap-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1733,
            "use.counter.css.doc",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_top
    ///
    /// Whether a document used the CSS property top. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1734,
            "use.counter.css.doc",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_touch_action
    ///
    /// Whether a document used the CSS property touch-action. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1735,
            "use.counter.css.doc",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform
    ///
    /// Whether a document used the CSS property transform. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1736,
            "use.counter.css.doc",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_box
    ///
    /// Whether a document used the CSS property transform-box. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1737,
            "use.counter.css.doc",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_origin
    ///
    /// Whether a document used the CSS property transform-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1738,
            "use.counter.css.doc",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transform_style
    ///
    /// Whether a document used the CSS property transform-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1739,
            "use.counter.css.doc",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition
    ///
    /// Whether a document used the CSS property transition. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1740,
            "use.counter.css.doc",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_behavior
    ///
    /// Whether a document used the CSS property transition-behavior. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1741,
            "use.counter.css.doc",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_delay
    ///
    /// Whether a document used the CSS property transition-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1742,
            "use.counter.css.doc",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_duration
    ///
    /// Whether a document used the CSS property transition-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1743,
            "use.counter.css.doc",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_property
    ///
    /// Whether a document used the CSS property transition-property. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1744,
            "use.counter.css.doc",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_transition_timing_function
    ///
    /// Whether a document used the CSS property transition-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1745,
            "use.counter.css.doc",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_translate
    ///
    /// Whether a document used the CSS property translate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1746,
            "use.counter.css.doc",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_unicode_bidi
    ///
    /// Whether a document used the CSS property unicode-bidi. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1747,
            "use.counter.css.doc",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_user_select
    ///
    /// Whether a document used the CSS property user-select. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1748,
            "use.counter.css.doc",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vector_effect
    ///
    /// Whether a document used the CSS property vector-effect. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1749,
            "use.counter.css.doc",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_vertical_align
    ///
    /// Whether a document used the CSS property vertical-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1750,
            "use.counter.css.doc",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline
    ///
    /// Whether a document used the CSS property view-timeline. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1751,
            "use.counter.css.doc",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_axis
    ///
    /// Whether a document used the CSS property view-timeline-axis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1752,
            "use.counter.css.doc",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_inset
    ///
    /// Whether a document used the CSS property view-timeline-inset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1753,
            "use.counter.css.doc",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_timeline_name
    ///
    /// Whether a document used the CSS property view-timeline-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1754,
            "use.counter.css.doc",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_view_transition_name
    ///
    /// Whether a document used the CSS property view-transition-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_view_transition_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1755,
            "use.counter.css.doc",
            "css_view_transition_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_visibility
    ///
    /// Whether a document used the CSS property visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1756,
            "use.counter.css.doc",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_content
    ///
    /// Whether a document used the CSS property -webkit-align-content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1757,
            "use.counter.css.doc",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_items
    ///
    /// Whether a document used the CSS property -webkit-align-items. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1758,
            "use.counter.css.doc",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_align_self
    ///
    /// Whether a document used the CSS property -webkit-align-self. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1759,
            "use.counter.css.doc",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation
    ///
    /// Whether a document used the CSS property -webkit-animation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1760,
            "use.counter.css.doc",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_delay
    ///
    /// Whether a document used the CSS property -webkit-animation-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1761,
            "use.counter.css.doc",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_direction
    ///
    /// Whether a document used the CSS property -webkit-animation-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1762,
            "use.counter.css.doc",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_duration
    ///
    /// Whether a document used the CSS property -webkit-animation-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1763,
            "use.counter.css.doc",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_fill_mode
    ///
    /// Whether a document used the CSS property -webkit-animation-fill-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1764,
            "use.counter.css.doc",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_iteration_count
    ///
    /// Whether a document used the CSS property -webkit-animation-iteration-count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1765,
            "use.counter.css.doc",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_name
    ///
    /// Whether a document used the CSS property -webkit-animation-name. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1766,
            "use.counter.css.doc",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_play_state
    ///
    /// Whether a document used the CSS property -webkit-animation-play-state. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1767,
            "use.counter.css.doc",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_animation_timing_function
    ///
    /// Whether a document used the CSS property -webkit-animation-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1768,
            "use.counter.css.doc",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_appearance
    ///
    /// Whether a document used the CSS property -webkit-appearance. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1769,
            "use.counter.css.doc",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_backface_visibility
    ///
    /// Whether a document used the CSS property -webkit-backface-visibility. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1770,
            "use.counter.css.doc",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_clip
    ///
    /// Whether a document used the CSS property -webkit-background-clip. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1771,
            "use.counter.css.doc",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_origin
    ///
    /// Whether a document used the CSS property -webkit-background-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1772,
            "use.counter.css.doc",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_background_size
    ///
    /// Whether a document used the CSS property -webkit-background-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1773,
            "use.counter.css.doc",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-left-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1774,
            "use.counter.css.doc",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_bottom_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-bottom-right-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1775,
            "use.counter.css.doc",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_image
    ///
    /// Whether a document used the CSS property -webkit-border-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1776,
            "use.counter.css.doc",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_radius
    ///
    /// Whether a document used the CSS property -webkit-border-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1777,
            "use.counter.css.doc",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_left_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-left-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1778,
            "use.counter.css.doc",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_border_top_right_radius
    ///
    /// Whether a document used the CSS property -webkit-border-top-right-radius. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1779,
            "use.counter.css.doc",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_align
    ///
    /// Whether a document used the CSS property -webkit-box-align. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1780,
            "use.counter.css.doc",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_direction
    ///
    /// Whether a document used the CSS property -webkit-box-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1781,
            "use.counter.css.doc",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_flex
    ///
    /// Whether a document used the CSS property -webkit-box-flex. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1782,
            "use.counter.css.doc",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_ordinal_group
    ///
    /// Whether a document used the CSS property -webkit-box-ordinal-group. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1783,
            "use.counter.css.doc",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_orient
    ///
    /// Whether a document used the CSS property -webkit-box-orient. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1784,
            "use.counter.css.doc",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_pack
    ///
    /// Whether a document used the CSS property -webkit-box-pack. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1785,
            "use.counter.css.doc",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_shadow
    ///
    /// Whether a document used the CSS property -webkit-box-shadow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1786,
            "use.counter.css.doc",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_box_sizing
    ///
    /// Whether a document used the CSS property -webkit-box-sizing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1787,
            "use.counter.css.doc",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_clip_path
    ///
    /// Whether a document used the CSS property -webkit-clip-path. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1788,
            "use.counter.css.doc",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_filter
    ///
    /// Whether a document used the CSS property -webkit-filter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1789,
            "use.counter.css.doc",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex
    ///
    /// Whether a document used the CSS property -webkit-flex. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1790,
            "use.counter.css.doc",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_basis
    ///
    /// Whether a document used the CSS property -webkit-flex-basis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1791,
            "use.counter.css.doc",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_direction
    ///
    /// Whether a document used the CSS property -webkit-flex-direction. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1792,
            "use.counter.css.doc",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_flow
    ///
    /// Whether a document used the CSS property -webkit-flex-flow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1793,
            "use.counter.css.doc",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_grow
    ///
    /// Whether a document used the CSS property -webkit-flex-grow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1794,
            "use.counter.css.doc",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_shrink
    ///
    /// Whether a document used the CSS property -webkit-flex-shrink. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1795,
            "use.counter.css.doc",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_flex_wrap
    ///
    /// Whether a document used the CSS property -webkit-flex-wrap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1796,
            "use.counter.css.doc",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_font_feature_settings
    ///
    /// Whether a document used the CSS property -webkit-font-feature-settings. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1797,
            "use.counter.css.doc",
            "css_webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_font_smoothing
    ///
    /// Whether a document used the CSS property -webkit-font-smoothing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1798,
            "use.counter.css.doc",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_justify_content
    ///
    /// Whether a document used the CSS property -webkit-justify-content. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1799,
            "use.counter.css.doc",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_line_clamp
    ///
    /// Whether a document used the CSS property -webkit-line-clamp. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1800,
            "use.counter.css.doc",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask
    ///
    /// Whether a document used the CSS property -webkit-mask. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1801,
            "use.counter.css.doc",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_clip
    ///
    /// Whether a document used the CSS property -webkit-mask-clip. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1802,
            "use.counter.css.doc",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_composite
    ///
    /// Whether a document used the CSS property -webkit-mask-composite. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1803,
            "use.counter.css.doc",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_image
    ///
    /// Whether a document used the CSS property -webkit-mask-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1804,
            "use.counter.css.doc",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_origin
    ///
    /// Whether a document used the CSS property -webkit-mask-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1805,
            "use.counter.css.doc",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position
    ///
    /// Whether a document used the CSS property -webkit-mask-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1806,
            "use.counter.css.doc",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_x
    ///
    /// Whether a document used the CSS property -webkit-mask-position-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1807,
            "use.counter.css.doc",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_position_y
    ///
    /// Whether a document used the CSS property -webkit-mask-position-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1808,
            "use.counter.css.doc",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_repeat
    ///
    /// Whether a document used the CSS property -webkit-mask-repeat. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1809,
            "use.counter.css.doc",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_mask_size
    ///
    /// Whether a document used the CSS property -webkit-mask-size. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1810,
            "use.counter.css.doc",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_order
    ///
    /// Whether a document used the CSS property -webkit-order. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1811,
            "use.counter.css.doc",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective
    ///
    /// Whether a document used the CSS property -webkit-perspective. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1812,
            "use.counter.css.doc",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_perspective_origin
    ///
    /// Whether a document used the CSS property -webkit-perspective-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1813,
            "use.counter.css.doc",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_fill_color
    ///
    /// Whether a document used the CSS property -webkit-text-fill-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1814,
            "use.counter.css.doc",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_security
    ///
    /// Whether a document used the CSS property -webkit-text-security. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1815,
            "use.counter.css.doc",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_size_adjust
    ///
    /// Whether a document used the CSS property -webkit-text-size-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1816,
            "use.counter.css.doc",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke
    ///
    /// Whether a document used the CSS property -webkit-text-stroke. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1817,
            "use.counter.css.doc",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_color
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1818,
            "use.counter.css.doc",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_text_stroke_width
    ///
    /// Whether a document used the CSS property -webkit-text-stroke-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1819,
            "use.counter.css.doc",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform
    ///
    /// Whether a document used the CSS property -webkit-transform. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1820,
            "use.counter.css.doc",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_origin
    ///
    /// Whether a document used the CSS property -webkit-transform-origin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1821,
            "use.counter.css.doc",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transform_style
    ///
    /// Whether a document used the CSS property -webkit-transform-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1822,
            "use.counter.css.doc",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition
    ///
    /// Whether a document used the CSS property -webkit-transition. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1823,
            "use.counter.css.doc",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_delay
    ///
    /// Whether a document used the CSS property -webkit-transition-delay. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1824,
            "use.counter.css.doc",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_duration
    ///
    /// Whether a document used the CSS property -webkit-transition-duration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1825,
            "use.counter.css.doc",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_property
    ///
    /// Whether a document used the CSS property -webkit-transition-property. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1826,
            "use.counter.css.doc",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_transition_timing_function
    ///
    /// Whether a document used the CSS property -webkit-transition-timing-function. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1827,
            "use.counter.css.doc",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_webkit_user_select
    ///
    /// Whether a document used the CSS property -webkit-user-select. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1828,
            "use.counter.css.doc",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space
    ///
    /// Whether a document used the CSS property white-space. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1829,
            "use.counter.css.doc",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_white_space_collapse
    ///
    /// Whether a document used the CSS property white-space-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1830,
            "use.counter.css.doc",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_width
    ///
    /// Whether a document used the CSS property width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1831,
            "use.counter.css.doc",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_will_change
    ///
    /// Whether a document used the CSS property will-change. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1832,
            "use.counter.css.doc",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_break
    ///
    /// Whether a document used the CSS property word-break. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1833,
            "use.counter.css.doc",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_spacing
    ///
    /// Whether a document used the CSS property word-spacing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1834,
            "use.counter.css.doc",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_word_wrap
    ///
    /// Whether a document used the CSS property word-wrap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1835,
            "use.counter.css.doc",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_writing_mode
    ///
    /// Whether a document used the CSS property writing-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1836,
            "use.counter.css.doc",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x
    ///
    /// Whether a document used the CSS property x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1837,
            "use.counter.css.doc",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_lang
    ///
    /// Whether a document used the CSS property -x-lang. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1838,
            "use.counter.css.doc",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_span
    ///
    /// Whether a document used the CSS property -x-span. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1839,
            "use.counter.css.doc",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_x_text_scale
    ///
    /// Whether a document used the CSS property -x-text-scale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1840,
            "use.counter.css.doc",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_y
    ///
    /// Whether a document used the CSS property y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1841,
            "use.counter.css.doc",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_z_index
    ///
    /// Whether a document used the CSS property z-index. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1842,
            "use.counter.css.doc",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.css_zoom
    ///
    /// Whether a document used the CSS property zoom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1843,
            "use.counter.css.doc",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.max_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property max-zoom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1844,
            "use.counter.css.doc",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.min_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property min-zoom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1845,
            "use.counter.css.doc",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1846,
            "use.counter.css.doc",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.orphans
    ///
    /// Whether a document used the (unknown, counted) CSS property orphans. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1847,
            "use.counter.css.doc",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.speak
    ///
    /// Whether a document used the (unknown, counted) CSS property speak. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1848,
            "use.counter.css.doc",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.text_size_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property text-size-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1849,
            "use.counter.css.doc",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.user_zoom
    ///
    /// Whether a document used the (unknown, counted) CSS property user-zoom. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1850,
            "use.counter.css.doc",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_app_region
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-app-region. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1851,
            "use.counter.css.doc",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1852,
            "use.counter.css.doc",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-after-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1853,
            "use.counter.css.doc",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-after-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1854,
            "use.counter.css.doc",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_after_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-after-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1855,
            "use.counter.css.doc",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1856,
            "use.counter.css.doc",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-before-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1857,
            "use.counter.css.doc",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-before-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1858,
            "use.counter.css.doc",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_before_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-before-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1859,
            "use.counter.css.doc",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1860,
            "use.counter.css.doc",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1861,
            "use.counter.css.doc",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1862,
            "use.counter.css.doc",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_end_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-end-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1863,
            "use.counter.css.doc",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_horizontal_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-horizontal-spacing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1864,
            "use.counter.css.doc",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1865,
            "use.counter.css.doc",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-start-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1866,
            "use.counter.css.doc",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-start-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1867,
            "use.counter.css.doc",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_start_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-start-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1868,
            "use.counter.css.doc",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_border_vertical_spacing
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-border-vertical-spacing. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1869,
            "use.counter.css.doc",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_decoration_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-decoration-break. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1870,
            "use.counter.css.doc",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_box_reflect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-box-reflect. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1871,
            "use.counter.css.doc",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-break-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1872,
            "use.counter.css.doc",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-break-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1873,
            "use.counter.css.doc",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_break_inside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-break-inside. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1874,
            "use.counter.css.doc",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_count
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1875,
            "use.counter.css.doc",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_gap
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-gap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1876,
            "use.counter.css.doc",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-rule. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1877,
            "use.counter.css.doc",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-rule-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1878,
            "use.counter.css.doc",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-rule-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1879,
            "use.counter.css.doc",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_rule_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-rule-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1880,
            "use.counter.css.doc",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_span
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-span. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1881,
            "use.counter.css.doc",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_column_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-column-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1882,
            "use.counter.css.doc",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_columns
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-columns. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1883,
            "use.counter.css.doc",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_font_size_delta
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-font-size-delta. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1884,
            "use.counter.css.doc",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_highlight
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-highlight. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1885,
            "use.counter.css.doc",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_hyphenate_character
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-hyphenate-character. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1886,
            "use.counter.css.doc",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_line_break
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-line-break. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1887,
            "use.counter.css.doc",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_locale
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-locale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1888,
            "use.counter.css.doc",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1889,
            "use.counter.css.doc",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-logical-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1890,
            "use.counter.css.doc",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1891,
            "use.counter.css.doc",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_after_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-after-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1892,
            "use.counter.css.doc",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1893,
            "use.counter.css.doc",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_before_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-before-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1894,
            "use.counter.css.doc",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_bottom_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-bottom-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1895,
            "use.counter.css.doc",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1896,
            "use.counter.css.doc",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1897,
            "use.counter.css.doc",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1898,
            "use.counter.css.doc",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_margin_top_collapse
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-margin-top-collapse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1899,
            "use.counter.css.doc",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1900,
            "use.counter.css.doc",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_outset
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image-outset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1901,
            "use.counter.css.doc",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_repeat
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image-repeat. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1902,
            "use.counter.css.doc",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_slice
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image-slice. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1903,
            "use.counter.css.doc",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_source
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image-source. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1904,
            "use.counter.css.doc",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_box_image_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-box-image-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1905,
            "use.counter.css.doc",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-repeat-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1906,
            "use.counter.css.doc",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_mask_repeat_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-mask-repeat-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1907,
            "use.counter.css.doc",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-logical-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1908,
            "use.counter.css.doc",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_max_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-max-logical-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1909,
            "use.counter.css.doc",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_height
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-logical-height. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1910,
            "use.counter.css.doc",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_min_logical_width
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-min-logical-width. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1911,
            "use.counter.css.doc",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_opacity
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-opacity. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1912,
            "use.counter.css.doc",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_after
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-after. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1913,
            "use.counter.css.doc",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_before
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-before. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1914,
            "use.counter.css.doc",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_end
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-end. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1915,
            "use.counter.css.doc",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_padding_start
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-padding-start. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1916,
            "use.counter.css.doc",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-perspective-origin-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1917,
            "use.counter.css.doc",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_perspective_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-perspective-origin-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1918,
            "use.counter.css.doc",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_print_color_adjust
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-print-color-adjust. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1919,
            "use.counter.css.doc",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_rtl_ordering
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-rtl-ordering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1920,
            "use.counter.css.doc",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_ruby_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-ruby-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1921,
            "use.counter.css.doc",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_image_threshold
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-image-threshold. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1922,
            "use.counter.css.doc",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_margin
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-margin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1923,
            "use.counter.css.doc",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_shape_outside
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-shape-outside. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1924,
            "use.counter.css.doc",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_tap_highlight_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-tap-highlight-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1925,
            "use.counter.css.doc",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_combine
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-combine. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1926,
            "use.counter.css.doc",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_decorations_in_effect
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-decorations-in-effect. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1927,
            "use.counter.css.doc",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-emphasis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1928,
            "use.counter.css.doc",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_color
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-emphasis-color. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1929,
            "use.counter.css.doc",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_position
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-emphasis-position. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1930,
            "use.counter.css.doc",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_emphasis_style
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-emphasis-style. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1931,
            "use.counter.css.doc",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_text_orientation
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-text-orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1932,
            "use.counter.css.doc",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_x
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-origin-x. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1933,
            "use.counter.css.doc",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_y
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-origin-y. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1934,
            "use.counter.css.doc",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_transform_origin_z
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-transform-origin-z. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1935,
            "use.counter.css.doc",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_drag
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-drag. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1936,
            "use.counter.css.doc",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_user_modify
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-user-modify. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1937,
            "use.counter.css.doc",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.webkit_writing_mode
    ///
    /// Whether a document used the (unknown, counted) CSS property -webkit-writing-mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1938,
            "use.counter.css.doc",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.doc.widows
    ///
    /// Whether a document used the (unknown, counted) CSS property widows. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1939,
            "use.counter.css.doc",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_css_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.alignment_baseline
    ///
    /// Whether a page used the (unknown, counted) CSS property alignment-baseline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static alignment_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1940,
            "use.counter.css.page",
            "alignment_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static background_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1941,
            "use.counter.css.page",
            "background_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.background_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property background-repeat-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static background_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1942,
            "use.counter.css.page",
            "background_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.baseline_shift
    ///
    /// Whether a page used the (unknown, counted) CSS property baseline-shift. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static baseline_shift: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1943,
            "use.counter.css.page",
            "baseline_shift",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.buffered_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property buffered-rendering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static buffered_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1944,
            "use.counter.css.page",
            "buffered_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.color_rendering
    ///
    /// Whether a page used the (unknown, counted) CSS property color-rendering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static color_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1945,
            "use.counter.css.page",
            "color_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_accent_color
    ///
    /// Whether a page used the CSS property accent-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_accent_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1946,
            "use.counter.css.page",
            "css_accent_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_content
    ///
    /// Whether a page used the CSS property align-content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1947,
            "use.counter.css.page",
            "css_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_items
    ///
    /// Whether a page used the CSS property align-items. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1948,
            "use.counter.css.page",
            "css_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_align_self
    ///
    /// Whether a page used the CSS property align-self. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1949,
            "use.counter.css.page",
            "css_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_all
    ///
    /// Whether a page used the CSS property all. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1950,
            "use.counter.css.page",
            "css_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_name
    ///
    /// Whether a page used the CSS property anchor-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1951,
            "use.counter.css.page",
            "css_anchor_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_anchor_scope
    ///
    /// Whether a page used the CSS property anchor-scope. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_anchor_scope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1952,
            "use.counter.css.page",
            "css_anchor_scope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation
    ///
    /// Whether a page used the CSS property animation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1953,
            "use.counter.css.page",
            "css_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_composition
    ///
    /// Whether a page used the CSS property animation-composition. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_composition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1954,
            "use.counter.css.page",
            "css_animation_composition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_delay
    ///
    /// Whether a page used the CSS property animation-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1955,
            "use.counter.css.page",
            "css_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_direction
    ///
    /// Whether a page used the CSS property animation-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1956,
            "use.counter.css.page",
            "css_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_duration
    ///
    /// Whether a page used the CSS property animation-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1957,
            "use.counter.css.page",
            "css_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_fill_mode
    ///
    /// Whether a page used the CSS property animation-fill-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1958,
            "use.counter.css.page",
            "css_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_iteration_count
    ///
    /// Whether a page used the CSS property animation-iteration-count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1959,
            "use.counter.css.page",
            "css_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_name
    ///
    /// Whether a page used the CSS property animation-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1960,
            "use.counter.css.page",
            "css_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_play_state
    ///
    /// Whether a page used the CSS property animation-play-state. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1961,
            "use.counter.css.page",
            "css_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timeline
    ///
    /// Whether a page used the CSS property animation-timeline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1962,
            "use.counter.css.page",
            "css_animation_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_animation_timing_function
    ///
    /// Whether a page used the CSS property animation-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1963,
            "use.counter.css.page",
            "css_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_appearance
    ///
    /// Whether a page used the CSS property appearance. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1964,
            "use.counter.css.page",
            "css_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_aspect_ratio
    ///
    /// Whether a page used the CSS property aspect-ratio. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_aspect_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1965,
            "use.counter.css.page",
            "css_aspect_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backdrop_filter
    ///
    /// Whether a page used the CSS property backdrop-filter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backdrop_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1966,
            "use.counter.css.page",
            "css_backdrop_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_backface_visibility
    ///
    /// Whether a page used the CSS property backface-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1967,
            "use.counter.css.page",
            "css_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background
    ///
    /// Whether a page used the CSS property background. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1968,
            "use.counter.css.page",
            "css_background",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_attachment
    ///
    /// Whether a page used the CSS property background-attachment. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_attachment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1969,
            "use.counter.css.page",
            "css_background_attachment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_blend_mode
    ///
    /// Whether a page used the CSS property background-blend-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1970,
            "use.counter.css.page",
            "css_background_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_clip
    ///
    /// Whether a page used the CSS property background-clip. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1971,
            "use.counter.css.page",
            "css_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_color
    ///
    /// Whether a page used the CSS property background-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1972,
            "use.counter.css.page",
            "css_background_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_image
    ///
    /// Whether a page used the CSS property background-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1973,
            "use.counter.css.page",
            "css_background_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_origin
    ///
    /// Whether a page used the CSS property background-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1974,
            "use.counter.css.page",
            "css_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position
    ///
    /// Whether a page used the CSS property background-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1975,
            "use.counter.css.page",
            "css_background_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_x
    ///
    /// Whether a page used the CSS property background-position-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1976,
            "use.counter.css.page",
            "css_background_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_position_y
    ///
    /// Whether a page used the CSS property background-position-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1977,
            "use.counter.css.page",
            "css_background_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_repeat
    ///
    /// Whether a page used the CSS property background-repeat. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1978,
            "use.counter.css.page",
            "css_background_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_background_size
    ///
    /// Whether a page used the CSS property background-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1979,
            "use.counter.css.page",
            "css_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_baseline_source
    ///
    /// Whether a page used the CSS property baseline-source. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_baseline_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1980,
            "use.counter.css.page",
            "css_baseline_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_block_size
    ///
    /// Whether a page used the CSS property block-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1981,
            "use.counter.css.page",
            "css_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border
    ///
    /// Whether a page used the CSS property border. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1982,
            "use.counter.css.page",
            "css_border",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block
    ///
    /// Whether a page used the CSS property border-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1983,
            "use.counter.css.page",
            "css_border_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_color
    ///
    /// Whether a page used the CSS property border-block-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1984,
            "use.counter.css.page",
            "css_border_block_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end
    ///
    /// Whether a page used the CSS property border-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1985,
            "use.counter.css.page",
            "css_border_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_color
    ///
    /// Whether a page used the CSS property border-block-end-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1986,
            "use.counter.css.page",
            "css_border_block_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_style
    ///
    /// Whether a page used the CSS property border-block-end-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1987,
            "use.counter.css.page",
            "css_border_block_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_end_width
    ///
    /// Whether a page used the CSS property border-block-end-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1988,
            "use.counter.css.page",
            "css_border_block_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start
    ///
    /// Whether a page used the CSS property border-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1989,
            "use.counter.css.page",
            "css_border_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_color
    ///
    /// Whether a page used the CSS property border-block-start-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1990,
            "use.counter.css.page",
            "css_border_block_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_style
    ///
    /// Whether a page used the CSS property border-block-start-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1991,
            "use.counter.css.page",
            "css_border_block_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_start_width
    ///
    /// Whether a page used the CSS property border-block-start-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1992,
            "use.counter.css.page",
            "css_border_block_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_style
    ///
    /// Whether a page used the CSS property border-block-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1993,
            "use.counter.css.page",
            "css_border_block_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_block_width
    ///
    /// Whether a page used the CSS property border-block-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_block_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1994,
            "use.counter.css.page",
            "css_border_block_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom
    ///
    /// Whether a page used the CSS property border-bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1995,
            "use.counter.css.page",
            "css_border_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_color
    ///
    /// Whether a page used the CSS property border-bottom-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1996,
            "use.counter.css.page",
            "css_border_bottom_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property border-bottom-left-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1997,
            "use.counter.css.page",
            "css_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property border-bottom-right-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1998,
            "use.counter.css.page",
            "css_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_style
    ///
    /// Whether a page used the CSS property border-bottom-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            1999,
            "use.counter.css.page",
            "css_border_bottom_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_bottom_width
    ///
    /// Whether a page used the CSS property border-bottom-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_bottom_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2000,
            "use.counter.css.page",
            "css_border_bottom_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_collapse
    ///
    /// Whether a page used the CSS property border-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2001,
            "use.counter.css.page",
            "css_border_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_color
    ///
    /// Whether a page used the CSS property border-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2002,
            "use.counter.css.page",
            "css_border_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_end_radius
    ///
    /// Whether a page used the CSS property border-end-end-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2003,
            "use.counter.css.page",
            "css_border_end_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_end_start_radius
    ///
    /// Whether a page used the CSS property border-end-start-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_end_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2004,
            "use.counter.css.page",
            "css_border_end_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image
    ///
    /// Whether a page used the CSS property border-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2005,
            "use.counter.css.page",
            "css_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_outset
    ///
    /// Whether a page used the CSS property border-image-outset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2006,
            "use.counter.css.page",
            "css_border_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_repeat
    ///
    /// Whether a page used the CSS property border-image-repeat. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2007,
            "use.counter.css.page",
            "css_border_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_slice
    ///
    /// Whether a page used the CSS property border-image-slice. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2008,
            "use.counter.css.page",
            "css_border_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_source
    ///
    /// Whether a page used the CSS property border-image-source. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2009,
            "use.counter.css.page",
            "css_border_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_image_width
    ///
    /// Whether a page used the CSS property border-image-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2010,
            "use.counter.css.page",
            "css_border_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline
    ///
    /// Whether a page used the CSS property border-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2011,
            "use.counter.css.page",
            "css_border_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_color
    ///
    /// Whether a page used the CSS property border-inline-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2012,
            "use.counter.css.page",
            "css_border_inline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end
    ///
    /// Whether a page used the CSS property border-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2013,
            "use.counter.css.page",
            "css_border_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_color
    ///
    /// Whether a page used the CSS property border-inline-end-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2014,
            "use.counter.css.page",
            "css_border_inline_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_style
    ///
    /// Whether a page used the CSS property border-inline-end-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2015,
            "use.counter.css.page",
            "css_border_inline_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_end_width
    ///
    /// Whether a page used the CSS property border-inline-end-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2016,
            "use.counter.css.page",
            "css_border_inline_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start
    ///
    /// Whether a page used the CSS property border-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2017,
            "use.counter.css.page",
            "css_border_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_color
    ///
    /// Whether a page used the CSS property border-inline-start-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2018,
            "use.counter.css.page",
            "css_border_inline_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_style
    ///
    /// Whether a page used the CSS property border-inline-start-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2019,
            "use.counter.css.page",
            "css_border_inline_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_start_width
    ///
    /// Whether a page used the CSS property border-inline-start-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2020,
            "use.counter.css.page",
            "css_border_inline_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_style
    ///
    /// Whether a page used the CSS property border-inline-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2021,
            "use.counter.css.page",
            "css_border_inline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_inline_width
    ///
    /// Whether a page used the CSS property border-inline-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_inline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2022,
            "use.counter.css.page",
            "css_border_inline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left
    ///
    /// Whether a page used the CSS property border-left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2023,
            "use.counter.css.page",
            "css_border_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_color
    ///
    /// Whether a page used the CSS property border-left-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2024,
            "use.counter.css.page",
            "css_border_left_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_style
    ///
    /// Whether a page used the CSS property border-left-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2025,
            "use.counter.css.page",
            "css_border_left_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_left_width
    ///
    /// Whether a page used the CSS property border-left-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_left_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2026,
            "use.counter.css.page",
            "css_border_left_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_radius
    ///
    /// Whether a page used the CSS property border-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2027,
            "use.counter.css.page",
            "css_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right
    ///
    /// Whether a page used the CSS property border-right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2028,
            "use.counter.css.page",
            "css_border_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_color
    ///
    /// Whether a page used the CSS property border-right-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2029,
            "use.counter.css.page",
            "css_border_right_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_style
    ///
    /// Whether a page used the CSS property border-right-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2030,
            "use.counter.css.page",
            "css_border_right_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_right_width
    ///
    /// Whether a page used the CSS property border-right-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_right_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2031,
            "use.counter.css.page",
            "css_border_right_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_spacing
    ///
    /// Whether a page used the CSS property border-spacing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2032,
            "use.counter.css.page",
            "css_border_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_end_radius
    ///
    /// Whether a page used the CSS property border-start-end-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_end_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2033,
            "use.counter.css.page",
            "css_border_start_end_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_start_start_radius
    ///
    /// Whether a page used the CSS property border-start-start-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_start_start_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2034,
            "use.counter.css.page",
            "css_border_start_start_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_style
    ///
    /// Whether a page used the CSS property border-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2035,
            "use.counter.css.page",
            "css_border_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top
    ///
    /// Whether a page used the CSS property border-top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2036,
            "use.counter.css.page",
            "css_border_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_color
    ///
    /// Whether a page used the CSS property border-top-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2037,
            "use.counter.css.page",
            "css_border_top_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_left_radius
    ///
    /// Whether a page used the CSS property border-top-left-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2038,
            "use.counter.css.page",
            "css_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_right_radius
    ///
    /// Whether a page used the CSS property border-top-right-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2039,
            "use.counter.css.page",
            "css_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_style
    ///
    /// Whether a page used the CSS property border-top-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2040,
            "use.counter.css.page",
            "css_border_top_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_top_width
    ///
    /// Whether a page used the CSS property border-top-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_top_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2041,
            "use.counter.css.page",
            "css_border_top_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_border_width
    ///
    /// Whether a page used the CSS property border-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_border_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2042,
            "use.counter.css.page",
            "css_border_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_bottom
    ///
    /// Whether a page used the CSS property bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2043,
            "use.counter.css.page",
            "css_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_decoration_break
    ///
    /// Whether a page used the CSS property box-decoration-break. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2044,
            "use.counter.css.page",
            "css_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_shadow
    ///
    /// Whether a page used the CSS property box-shadow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2045,
            "use.counter.css.page",
            "css_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_box_sizing
    ///
    /// Whether a page used the CSS property box-sizing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2046,
            "use.counter.css.page",
            "css_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_after
    ///
    /// Whether a page used the CSS property break-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2047,
            "use.counter.css.page",
            "css_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_before
    ///
    /// Whether a page used the CSS property break-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2048,
            "use.counter.css.page",
            "css_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_break_inside
    ///
    /// Whether a page used the CSS property break-inside. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2049,
            "use.counter.css.page",
            "css_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caption_side
    ///
    /// Whether a page used the CSS property caption-side. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caption_side: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2050,
            "use.counter.css.page",
            "css_caption_side",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_caret_color
    ///
    /// Whether a page used the CSS property caret-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_caret_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2051,
            "use.counter.css.page",
            "css_caret_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clear
    ///
    /// Whether a page used the CSS property clear. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2052,
            "use.counter.css.page",
            "css_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip
    ///
    /// Whether a page used the CSS property clip. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2053,
            "use.counter.css.page",
            "css_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_path
    ///
    /// Whether a page used the CSS property clip-path. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2054,
            "use.counter.css.page",
            "css_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_clip_rule
    ///
    /// Whether a page used the CSS property clip-rule. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_clip_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2055,
            "use.counter.css.page",
            "css_clip_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color
    ///
    /// Whether a page used the CSS property color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2056,
            "use.counter.css.page",
            "css_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_adjust
    ///
    /// Whether a page used the CSS property color-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2057,
            "use.counter.css.page",
            "css_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation
    ///
    /// Whether a page used the CSS property color-interpolation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2058,
            "use.counter.css.page",
            "css_color_interpolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_interpolation_filters
    ///
    /// Whether a page used the CSS property color-interpolation-filters. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_interpolation_filters: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2059,
            "use.counter.css.page",
            "css_color_interpolation_filters",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_color_scheme
    ///
    /// Whether a page used the CSS property color-scheme. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_color_scheme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2060,
            "use.counter.css.page",
            "css_color_scheme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_count
    ///
    /// Whether a page used the CSS property column-count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2061,
            "use.counter.css.page",
            "css_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_fill
    ///
    /// Whether a page used the CSS property column-fill. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2062,
            "use.counter.css.page",
            "css_column_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_gap
    ///
    /// Whether a page used the CSS property column-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2063,
            "use.counter.css.page",
            "css_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule
    ///
    /// Whether a page used the CSS property column-rule. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2064,
            "use.counter.css.page",
            "css_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_color
    ///
    /// Whether a page used the CSS property column-rule-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2065,
            "use.counter.css.page",
            "css_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_style
    ///
    /// Whether a page used the CSS property column-rule-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2066,
            "use.counter.css.page",
            "css_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_rule_width
    ///
    /// Whether a page used the CSS property column-rule-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2067,
            "use.counter.css.page",
            "css_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_span
    ///
    /// Whether a page used the CSS property column-span. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2068,
            "use.counter.css.page",
            "css_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_column_width
    ///
    /// Whether a page used the CSS property column-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2069,
            "use.counter.css.page",
            "css_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_columns
    ///
    /// Whether a page used the CSS property columns. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2070,
            "use.counter.css.page",
            "css_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain
    ///
    /// Whether a page used the CSS property contain. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2071,
            "use.counter.css.page",
            "css_contain",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_block_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-block-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2072,
            "use.counter.css.page",
            "css_contain_intrinsic_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_height
    ///
    /// Whether a page used the CSS property contain-intrinsic-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2073,
            "use.counter.css.page",
            "css_contain_intrinsic_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_inline_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-inline-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2074,
            "use.counter.css.page",
            "css_contain_intrinsic_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_size
    ///
    /// Whether a page used the CSS property contain-intrinsic-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2075,
            "use.counter.css.page",
            "css_contain_intrinsic_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_contain_intrinsic_width
    ///
    /// Whether a page used the CSS property contain-intrinsic-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_contain_intrinsic_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2076,
            "use.counter.css.page",
            "css_contain_intrinsic_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container
    ///
    /// Whether a page used the CSS property container. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2077,
            "use.counter.css.page",
            "css_container",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_name
    ///
    /// Whether a page used the CSS property container-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2078,
            "use.counter.css.page",
            "css_container_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_container_type
    ///
    /// Whether a page used the CSS property container-type. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_container_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2079,
            "use.counter.css.page",
            "css_container_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content
    ///
    /// Whether a page used the CSS property content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2080,
            "use.counter.css.page",
            "css_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_content_visibility
    ///
    /// Whether a page used the CSS property content-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_content_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2081,
            "use.counter.css.page",
            "css_content_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_increment
    ///
    /// Whether a page used the CSS property counter-increment. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_increment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2082,
            "use.counter.css.page",
            "css_counter_increment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_reset
    ///
    /// Whether a page used the CSS property counter-reset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_reset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2083,
            "use.counter.css.page",
            "css_counter_reset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_counter_set
    ///
    /// Whether a page used the CSS property counter-set. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_counter_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2084,
            "use.counter.css.page",
            "css_counter_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cursor
    ///
    /// Whether a page used the CSS property cursor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cursor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2085,
            "use.counter.css.page",
            "css_cursor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cx
    ///
    /// Whether a page used the CSS property cx. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2086,
            "use.counter.css.page",
            "css_cx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_cy
    ///
    /// Whether a page used the CSS property cy. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_cy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2087,
            "use.counter.css.page",
            "css_cy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_d
    ///
    /// Whether a page used the CSS property d. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2088,
            "use.counter.css.page",
            "css_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_direction
    ///
    /// Whether a page used the CSS property direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2089,
            "use.counter.css.page",
            "css_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_display
    ///
    /// Whether a page used the CSS property display. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_display: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2090,
            "use.counter.css.page",
            "css_display",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_dominant_baseline
    ///
    /// Whether a page used the CSS property dominant-baseline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_dominant_baseline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2091,
            "use.counter.css.page",
            "css_dominant_baseline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_empty_cells
    ///
    /// Whether a page used the CSS property empty-cells. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_empty_cells: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2092,
            "use.counter.css.page",
            "css_empty_cells",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_field_sizing
    ///
    /// Whether a page used the CSS property field-sizing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_field_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2093,
            "use.counter.css.page",
            "css_field_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill
    ///
    /// Whether a page used the CSS property fill. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2094,
            "use.counter.css.page",
            "css_fill",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_opacity
    ///
    /// Whether a page used the CSS property fill-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2095,
            "use.counter.css.page",
            "css_fill_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_fill_rule
    ///
    /// Whether a page used the CSS property fill-rule. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_fill_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2096,
            "use.counter.css.page",
            "css_fill_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_filter
    ///
    /// Whether a page used the CSS property filter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2097,
            "use.counter.css.page",
            "css_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex
    ///
    /// Whether a page used the CSS property flex. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2098,
            "use.counter.css.page",
            "css_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_basis
    ///
    /// Whether a page used the CSS property flex-basis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2099,
            "use.counter.css.page",
            "css_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_direction
    ///
    /// Whether a page used the CSS property flex-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2100,
            "use.counter.css.page",
            "css_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_flow
    ///
    /// Whether a page used the CSS property flex-flow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2101,
            "use.counter.css.page",
            "css_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_grow
    ///
    /// Whether a page used the CSS property flex-grow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2102,
            "use.counter.css.page",
            "css_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_shrink
    ///
    /// Whether a page used the CSS property flex-shrink. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2103,
            "use.counter.css.page",
            "css_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flex_wrap
    ///
    /// Whether a page used the CSS property flex-wrap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2104,
            "use.counter.css.page",
            "css_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_float
    ///
    /// Whether a page used the CSS property float. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_float: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2105,
            "use.counter.css.page",
            "css_float",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_color
    ///
    /// Whether a page used the CSS property flood-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2106,
            "use.counter.css.page",
            "css_flood_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_flood_opacity
    ///
    /// Whether a page used the CSS property flood-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_flood_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2107,
            "use.counter.css.page",
            "css_flood_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font
    ///
    /// Whether a page used the CSS property font. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2108,
            "use.counter.css.page",
            "css_font",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_family
    ///
    /// Whether a page used the CSS property font-family. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_family: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2109,
            "use.counter.css.page",
            "css_font_family",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_feature_settings
    ///
    /// Whether a page used the CSS property font-feature-settings. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2110,
            "use.counter.css.page",
            "css_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_kerning
    ///
    /// Whether a page used the CSS property font-kerning. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_kerning: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2111,
            "use.counter.css.page",
            "css_font_kerning",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_language_override
    ///
    /// Whether a page used the CSS property font-language-override. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2112,
            "use.counter.css.page",
            "css_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_optical_sizing
    ///
    /// Whether a page used the CSS property font-optical-sizing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_optical_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2113,
            "use.counter.css.page",
            "css_font_optical_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_palette
    ///
    /// Whether a page used the CSS property font-palette. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_palette: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2114,
            "use.counter.css.page",
            "css_font_palette",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size
    ///
    /// Whether a page used the CSS property font-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2115,
            "use.counter.css.page",
            "css_font_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_size_adjust
    ///
    /// Whether a page used the CSS property font-size-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2116,
            "use.counter.css.page",
            "css_font_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_stretch
    ///
    /// Whether a page used the CSS property font-stretch. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_stretch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2117,
            "use.counter.css.page",
            "css_font_stretch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_style
    ///
    /// Whether a page used the CSS property font-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2118,
            "use.counter.css.page",
            "css_font_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis
    ///
    /// Whether a page used the CSS property font-synthesis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2119,
            "use.counter.css.page",
            "css_font_synthesis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_position
    ///
    /// Whether a page used the CSS property font-synthesis-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2120,
            "use.counter.css.page",
            "css_font_synthesis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_small_caps
    ///
    /// Whether a page used the CSS property font-synthesis-small-caps. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_small_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2121,
            "use.counter.css.page",
            "css_font_synthesis_small_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_style
    ///
    /// Whether a page used the CSS property font-synthesis-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2122,
            "use.counter.css.page",
            "css_font_synthesis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_synthesis_weight
    ///
    /// Whether a page used the CSS property font-synthesis-weight. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_synthesis_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2123,
            "use.counter.css.page",
            "css_font_synthesis_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant
    ///
    /// Whether a page used the CSS property font-variant. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2124,
            "use.counter.css.page",
            "css_font_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_alternates
    ///
    /// Whether a page used the CSS property font-variant-alternates. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_alternates: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2125,
            "use.counter.css.page",
            "css_font_variant_alternates",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_caps
    ///
    /// Whether a page used the CSS property font-variant-caps. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_caps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2126,
            "use.counter.css.page",
            "css_font_variant_caps",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_east_asian
    ///
    /// Whether a page used the CSS property font-variant-east-asian. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_east_asian: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2127,
            "use.counter.css.page",
            "css_font_variant_east_asian",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_emoji
    ///
    /// Whether a page used the CSS property font-variant-emoji. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_emoji: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2128,
            "use.counter.css.page",
            "css_font_variant_emoji",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_ligatures
    ///
    /// Whether a page used the CSS property font-variant-ligatures. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_ligatures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2129,
            "use.counter.css.page",
            "css_font_variant_ligatures",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_numeric
    ///
    /// Whether a page used the CSS property font-variant-numeric. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_numeric: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2130,
            "use.counter.css.page",
            "css_font_variant_numeric",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variant_position
    ///
    /// Whether a page used the CSS property font-variant-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variant_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2131,
            "use.counter.css.page",
            "css_font_variant_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_variation_settings
    ///
    /// Whether a page used the CSS property font-variation-settings. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_variation_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2132,
            "use.counter.css.page",
            "css_font_variation_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_font_weight
    ///
    /// Whether a page used the CSS property font-weight. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_font_weight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2133,
            "use.counter.css.page",
            "css_font_weight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_forced_color_adjust
    ///
    /// Whether a page used the CSS property forced-color-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_forced_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2134,
            "use.counter.css.page",
            "css_forced_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_gap
    ///
    /// Whether a page used the CSS property gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2135,
            "use.counter.css.page",
            "css_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid
    ///
    /// Whether a page used the CSS property grid. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2136,
            "use.counter.css.page",
            "css_grid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_area
    ///
    /// Whether a page used the CSS property grid-area. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2137,
            "use.counter.css.page",
            "css_grid_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_columns
    ///
    /// Whether a page used the CSS property grid-auto-columns. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2138,
            "use.counter.css.page",
            "css_grid_auto_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_flow
    ///
    /// Whether a page used the CSS property grid-auto-flow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2139,
            "use.counter.css.page",
            "css_grid_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_auto_rows
    ///
    /// Whether a page used the CSS property grid-auto-rows. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_auto_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2140,
            "use.counter.css.page",
            "css_grid_auto_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column
    ///
    /// Whether a page used the CSS property grid-column. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2141,
            "use.counter.css.page",
            "css_grid_column",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_end
    ///
    /// Whether a page used the CSS property grid-column-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2142,
            "use.counter.css.page",
            "css_grid_column_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_gap
    ///
    /// Whether a page used the CSS property grid-column-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2143,
            "use.counter.css.page",
            "css_grid_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_column_start
    ///
    /// Whether a page used the CSS property grid-column-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_column_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2144,
            "use.counter.css.page",
            "css_grid_column_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_gap
    ///
    /// Whether a page used the CSS property grid-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2145,
            "use.counter.css.page",
            "css_grid_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row
    ///
    /// Whether a page used the CSS property grid-row. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2146,
            "use.counter.css.page",
            "css_grid_row",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_end
    ///
    /// Whether a page used the CSS property grid-row-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2147,
            "use.counter.css.page",
            "css_grid_row_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_gap
    ///
    /// Whether a page used the CSS property grid-row-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2148,
            "use.counter.css.page",
            "css_grid_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_row_start
    ///
    /// Whether a page used the CSS property grid-row-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_row_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2149,
            "use.counter.css.page",
            "css_grid_row_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template
    ///
    /// Whether a page used the CSS property grid-template. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2150,
            "use.counter.css.page",
            "css_grid_template",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_areas
    ///
    /// Whether a page used the CSS property grid-template-areas. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_areas: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2151,
            "use.counter.css.page",
            "css_grid_template_areas",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_columns
    ///
    /// Whether a page used the CSS property grid-template-columns. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2152,
            "use.counter.css.page",
            "css_grid_template_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_grid_template_rows
    ///
    /// Whether a page used the CSS property grid-template-rows. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_grid_template_rows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2153,
            "use.counter.css.page",
            "css_grid_template_rows",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_height
    ///
    /// Whether a page used the CSS property height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2154,
            "use.counter.css.page",
            "css_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphenate_character
    ///
    /// Whether a page used the CSS property hyphenate-character. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2155,
            "use.counter.css.page",
            "css_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphenate_limit_chars
    ///
    /// Whether a page used the CSS property hyphenate-limit-chars. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphenate_limit_chars: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2156,
            "use.counter.css.page",
            "css_hyphenate_limit_chars",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_hyphens
    ///
    /// Whether a page used the CSS property hyphens. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2157,
            "use.counter.css.page",
            "css_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_orientation
    ///
    /// Whether a page used the CSS property image-orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2158,
            "use.counter.css.page",
            "css_image_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_image_rendering
    ///
    /// Whether a page used the CSS property image-rendering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_image_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2159,
            "use.counter.css.page",
            "css_image_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ime_mode
    ///
    /// Whether a page used the CSS property ime-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ime_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2160,
            "use.counter.css.page",
            "css_ime_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_initial_letter
    ///
    /// Whether a page used the CSS property initial-letter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_initial_letter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2161,
            "use.counter.css.page",
            "css_initial_letter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inline_size
    ///
    /// Whether a page used the CSS property inline-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2162,
            "use.counter.css.page",
            "css_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset
    ///
    /// Whether a page used the CSS property inset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2163,
            "use.counter.css.page",
            "css_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block
    ///
    /// Whether a page used the CSS property inset-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2164,
            "use.counter.css.page",
            "css_inset_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_end
    ///
    /// Whether a page used the CSS property inset-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2165,
            "use.counter.css.page",
            "css_inset_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_block_start
    ///
    /// Whether a page used the CSS property inset-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2166,
            "use.counter.css.page",
            "css_inset_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline
    ///
    /// Whether a page used the CSS property inset-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2167,
            "use.counter.css.page",
            "css_inset_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_end
    ///
    /// Whether a page used the CSS property inset-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2168,
            "use.counter.css.page",
            "css_inset_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_inset_inline_start
    ///
    /// Whether a page used the CSS property inset-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_inset_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2169,
            "use.counter.css.page",
            "css_inset_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_isolation
    ///
    /// Whether a page used the CSS property isolation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_isolation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2170,
            "use.counter.css.page",
            "css_isolation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_content
    ///
    /// Whether a page used the CSS property justify-content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2171,
            "use.counter.css.page",
            "css_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_items
    ///
    /// Whether a page used the CSS property justify-items. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2172,
            "use.counter.css.page",
            "css_justify_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_justify_self
    ///
    /// Whether a page used the CSS property justify-self. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_justify_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2173,
            "use.counter.css.page",
            "css_justify_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_left
    ///
    /// Whether a page used the CSS property left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2174,
            "use.counter.css.page",
            "css_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_letter_spacing
    ///
    /// Whether a page used the CSS property letter-spacing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_letter_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2175,
            "use.counter.css.page",
            "css_letter_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_lighting_color
    ///
    /// Whether a page used the CSS property lighting-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_lighting_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2176,
            "use.counter.css.page",
            "css_lighting_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_break
    ///
    /// Whether a page used the CSS property line-break. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2177,
            "use.counter.css.page",
            "css_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_line_height
    ///
    /// Whether a page used the CSS property line-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_line_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2178,
            "use.counter.css.page",
            "css_line_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style
    ///
    /// Whether a page used the CSS property list-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2179,
            "use.counter.css.page",
            "css_list_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_image
    ///
    /// Whether a page used the CSS property list-style-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2180,
            "use.counter.css.page",
            "css_list_style_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_position
    ///
    /// Whether a page used the CSS property list-style-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2181,
            "use.counter.css.page",
            "css_list_style_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_list_style_type
    ///
    /// Whether a page used the CSS property list-style-type. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_list_style_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2182,
            "use.counter.css.page",
            "css_list_style_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin
    ///
    /// Whether a page used the CSS property margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2183,
            "use.counter.css.page",
            "css_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block
    ///
    /// Whether a page used the CSS property margin-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2184,
            "use.counter.css.page",
            "css_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_end
    ///
    /// Whether a page used the CSS property margin-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2185,
            "use.counter.css.page",
            "css_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_block_start
    ///
    /// Whether a page used the CSS property margin-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2186,
            "use.counter.css.page",
            "css_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_bottom
    ///
    /// Whether a page used the CSS property margin-bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2187,
            "use.counter.css.page",
            "css_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline
    ///
    /// Whether a page used the CSS property margin-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2188,
            "use.counter.css.page",
            "css_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_end
    ///
    /// Whether a page used the CSS property margin-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2189,
            "use.counter.css.page",
            "css_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_inline_start
    ///
    /// Whether a page used the CSS property margin-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2190,
            "use.counter.css.page",
            "css_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_left
    ///
    /// Whether a page used the CSS property margin-left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2191,
            "use.counter.css.page",
            "css_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_right
    ///
    /// Whether a page used the CSS property margin-right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2192,
            "use.counter.css.page",
            "css_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_margin_top
    ///
    /// Whether a page used the CSS property margin-top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2193,
            "use.counter.css.page",
            "css_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker
    ///
    /// Whether a page used the CSS property marker. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2194,
            "use.counter.css.page",
            "css_marker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_end
    ///
    /// Whether a page used the CSS property marker-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2195,
            "use.counter.css.page",
            "css_marker_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_mid
    ///
    /// Whether a page used the CSS property marker-mid. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_mid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2196,
            "use.counter.css.page",
            "css_marker_mid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_marker_start
    ///
    /// Whether a page used the CSS property marker-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_marker_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2197,
            "use.counter.css.page",
            "css_marker_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask
    ///
    /// Whether a page used the CSS property mask. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2198,
            "use.counter.css.page",
            "css_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_clip
    ///
    /// Whether a page used the CSS property mask-clip. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2199,
            "use.counter.css.page",
            "css_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_composite
    ///
    /// Whether a page used the CSS property mask-composite. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2200,
            "use.counter.css.page",
            "css_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_image
    ///
    /// Whether a page used the CSS property mask-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2201,
            "use.counter.css.page",
            "css_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_mode
    ///
    /// Whether a page used the CSS property mask-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2202,
            "use.counter.css.page",
            "css_mask_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_origin
    ///
    /// Whether a page used the CSS property mask-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2203,
            "use.counter.css.page",
            "css_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position
    ///
    /// Whether a page used the CSS property mask-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2204,
            "use.counter.css.page",
            "css_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_x
    ///
    /// Whether a page used the CSS property mask-position-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2205,
            "use.counter.css.page",
            "css_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_position_y
    ///
    /// Whether a page used the CSS property mask-position-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2206,
            "use.counter.css.page",
            "css_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_repeat
    ///
    /// Whether a page used the CSS property mask-repeat. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2207,
            "use.counter.css.page",
            "css_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_size
    ///
    /// Whether a page used the CSS property mask-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2208,
            "use.counter.css.page",
            "css_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mask_type
    ///
    /// Whether a page used the CSS property mask-type. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mask_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2209,
            "use.counter.css.page",
            "css_mask_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_masonry_auto_flow
    ///
    /// Whether a page used the CSS property masonry-auto-flow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_masonry_auto_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2210,
            "use.counter.css.page",
            "css_masonry_auto_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_depth
    ///
    /// Whether a page used the CSS property math-depth. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_depth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2211,
            "use.counter.css.page",
            "css_math_depth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_math_style
    ///
    /// Whether a page used the CSS property math-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_math_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2212,
            "use.counter.css.page",
            "css_math_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_block_size
    ///
    /// Whether a page used the CSS property max-block-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2213,
            "use.counter.css.page",
            "css_max_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_height
    ///
    /// Whether a page used the CSS property max-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2214,
            "use.counter.css.page",
            "css_max_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_inline_size
    ///
    /// Whether a page used the CSS property max-inline-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2215,
            "use.counter.css.page",
            "css_max_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_max_width
    ///
    /// Whether a page used the CSS property max-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_max_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2216,
            "use.counter.css.page",
            "css_max_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_block_size
    ///
    /// Whether a page used the CSS property min-block-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_block_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2217,
            "use.counter.css.page",
            "css_min_block_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_height
    ///
    /// Whether a page used the CSS property min-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2218,
            "use.counter.css.page",
            "css_min_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_inline_size
    ///
    /// Whether a page used the CSS property min-inline-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_inline_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2219,
            "use.counter.css.page",
            "css_min_inline_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_min_width
    ///
    /// Whether a page used the CSS property min-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_min_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2220,
            "use.counter.css.page",
            "css_min_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_mix_blend_mode
    ///
    /// Whether a page used the CSS property mix-blend-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_mix_blend_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2221,
            "use.counter.css.page",
            "css_mix_blend_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation
    ///
    /// Whether a page used the CSS property -moz-animation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2222,
            "use.counter.css.page",
            "css_moz_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_delay
    ///
    /// Whether a page used the CSS property -moz-animation-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2223,
            "use.counter.css.page",
            "css_moz_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_direction
    ///
    /// Whether a page used the CSS property -moz-animation-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2224,
            "use.counter.css.page",
            "css_moz_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_duration
    ///
    /// Whether a page used the CSS property -moz-animation-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2225,
            "use.counter.css.page",
            "css_moz_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_fill_mode
    ///
    /// Whether a page used the CSS property -moz-animation-fill-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2226,
            "use.counter.css.page",
            "css_moz_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_iteration_count
    ///
    /// Whether a page used the CSS property -moz-animation-iteration-count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2227,
            "use.counter.css.page",
            "css_moz_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_name
    ///
    /// Whether a page used the CSS property -moz-animation-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2228,
            "use.counter.css.page",
            "css_moz_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_play_state
    ///
    /// Whether a page used the CSS property -moz-animation-play-state. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2229,
            "use.counter.css.page",
            "css_moz_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_animation_timing_function
    ///
    /// Whether a page used the CSS property -moz-animation-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2230,
            "use.counter.css.page",
            "css_moz_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_appearance
    ///
    /// Whether a page used the CSS property -moz-appearance. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2231,
            "use.counter.css.page",
            "css_moz_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_backface_visibility
    ///
    /// Whether a page used the CSS property -moz-backface-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2232,
            "use.counter.css.page",
            "css_moz_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end
    ///
    /// Whether a page used the CSS property -moz-border-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2233,
            "use.counter.css.page",
            "css_moz_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_color
    ///
    /// Whether a page used the CSS property -moz-border-end-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2234,
            "use.counter.css.page",
            "css_moz_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_style
    ///
    /// Whether a page used the CSS property -moz-border-end-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2235,
            "use.counter.css.page",
            "css_moz_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_end_width
    ///
    /// Whether a page used the CSS property -moz-border-end-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2236,
            "use.counter.css.page",
            "css_moz_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_image
    ///
    /// Whether a page used the CSS property -moz-border-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2237,
            "use.counter.css.page",
            "css_moz_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start
    ///
    /// Whether a page used the CSS property -moz-border-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2238,
            "use.counter.css.page",
            "css_moz_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_color
    ///
    /// Whether a page used the CSS property -moz-border-start-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2239,
            "use.counter.css.page",
            "css_moz_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_style
    ///
    /// Whether a page used the CSS property -moz-border-start-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2240,
            "use.counter.css.page",
            "css_moz_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_border_start_width
    ///
    /// Whether a page used the CSS property -moz-border-start-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2241,
            "use.counter.css.page",
            "css_moz_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_align
    ///
    /// Whether a page used the CSS property -moz-box-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2242,
            "use.counter.css.page",
            "css_moz_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_collapse
    ///
    /// Whether a page used the CSS property -moz-box-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2243,
            "use.counter.css.page",
            "css_moz_box_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_direction
    ///
    /// Whether a page used the CSS property -moz-box-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2244,
            "use.counter.css.page",
            "css_moz_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_flex
    ///
    /// Whether a page used the CSS property -moz-box-flex. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2245,
            "use.counter.css.page",
            "css_moz_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_ordinal_group
    ///
    /// Whether a page used the CSS property -moz-box-ordinal-group. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2246,
            "use.counter.css.page",
            "css_moz_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_orient
    ///
    /// Whether a page used the CSS property -moz-box-orient. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2247,
            "use.counter.css.page",
            "css_moz_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_pack
    ///
    /// Whether a page used the CSS property -moz-box-pack. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2248,
            "use.counter.css.page",
            "css_moz_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_box_sizing
    ///
    /// Whether a page used the CSS property -moz-box-sizing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2249,
            "use.counter.css.page",
            "css_moz_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_context_properties
    ///
    /// Whether a page used the CSS property -moz-context-properties. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_context_properties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2250,
            "use.counter.css.page",
            "css_moz_context_properties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_control_character_visibility
    ///
    /// Whether a page used the CSS property -moz-control-character-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_control_character_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2251,
            "use.counter.css.page",
            "css_moz_control_character_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_default_appearance
    ///
    /// Whether a page used the CSS property -moz-default-appearance. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_default_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2252,
            "use.counter.css.page",
            "css_moz_default_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_float_edge
    ///
    /// Whether a page used the CSS property -moz-float-edge. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_float_edge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2253,
            "use.counter.css.page",
            "css_moz_float_edge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_feature_settings
    ///
    /// Whether a page used the CSS property -moz-font-feature-settings. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2254,
            "use.counter.css.page",
            "css_moz_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_font_language_override
    ///
    /// Whether a page used the CSS property -moz-font-language-override. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_font_language_override: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2255,
            "use.counter.css.page",
            "css_moz_font_language_override",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_force_broken_image_icon
    ///
    /// Whether a page used the CSS property -moz-force-broken-image-icon. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_force_broken_image_icon: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2256,
            "use.counter.css.page",
            "css_moz_force_broken_image_icon",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_hyphens
    ///
    /// Whether a page used the CSS property -moz-hyphens. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_hyphens: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2257,
            "use.counter.css.page",
            "css_moz_hyphens",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_inert
    ///
    /// Whether a page used the CSS property -moz-inert. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_inert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2258,
            "use.counter.css.page",
            "css_moz_inert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_end
    ///
    /// Whether a page used the CSS property -moz-margin-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2259,
            "use.counter.css.page",
            "css_moz_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_margin_start
    ///
    /// Whether a page used the CSS property -moz-margin-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2260,
            "use.counter.css.page",
            "css_moz_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_math_variant
    ///
    /// Whether a page used the CSS property -moz-math-variant. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2261,
            "use.counter.css.page",
            "css_moz_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_min_font_size_ratio
    ///
    /// Whether a page used the CSS property -moz-min-font-size-ratio. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_min_font_size_ratio: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2262,
            "use.counter.css.page",
            "css_moz_min_font_size_ratio",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_orient
    ///
    /// Whether a page used the CSS property -moz-orient. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2263,
            "use.counter.css.page",
            "css_moz_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_osx_font_smoothing
    ///
    /// Whether a page used the CSS property -moz-osx-font-smoothing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_osx_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2264,
            "use.counter.css.page",
            "css_moz_osx_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_end
    ///
    /// Whether a page used the CSS property -moz-padding-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2265,
            "use.counter.css.page",
            "css_moz_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_padding_start
    ///
    /// Whether a page used the CSS property -moz-padding-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2266,
            "use.counter.css.page",
            "css_moz_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective
    ///
    /// Whether a page used the CSS property -moz-perspective. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2267,
            "use.counter.css.page",
            "css_moz_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_perspective_origin
    ///
    /// Whether a page used the CSS property -moz-perspective-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2268,
            "use.counter.css.page",
            "css_moz_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_subtree_hidden_only_visually
    ///
    /// Whether a page used the CSS property -moz-subtree-hidden-only-visually. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_subtree_hidden_only_visually: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2269,
            "use.counter.css.page",
            "css_moz_subtree_hidden_only_visually",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_tab_size
    ///
    /// Whether a page used the CSS property -moz-tab-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2270,
            "use.counter.css.page",
            "css_moz_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_text_size_adjust
    ///
    /// Whether a page used the CSS property -moz-text-size-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2271,
            "use.counter.css.page",
            "css_moz_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_theme
    ///
    /// Whether a page used the CSS property -moz-theme. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_theme: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2272,
            "use.counter.css.page",
            "css_moz_theme",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_top_layer
    ///
    /// Whether a page used the CSS property -moz-top-layer. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_top_layer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2273,
            "use.counter.css.page",
            "css_moz_top_layer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform
    ///
    /// Whether a page used the CSS property -moz-transform. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2274,
            "use.counter.css.page",
            "css_moz_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_origin
    ///
    /// Whether a page used the CSS property -moz-transform-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2275,
            "use.counter.css.page",
            "css_moz_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transform_style
    ///
    /// Whether a page used the CSS property -moz-transform-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2276,
            "use.counter.css.page",
            "css_moz_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition
    ///
    /// Whether a page used the CSS property -moz-transition. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2277,
            "use.counter.css.page",
            "css_moz_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_delay
    ///
    /// Whether a page used the CSS property -moz-transition-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2278,
            "use.counter.css.page",
            "css_moz_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_duration
    ///
    /// Whether a page used the CSS property -moz-transition-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2279,
            "use.counter.css.page",
            "css_moz_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_property
    ///
    /// Whether a page used the CSS property -moz-transition-property. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2280,
            "use.counter.css.page",
            "css_moz_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_transition_timing_function
    ///
    /// Whether a page used the CSS property -moz-transition-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2281,
            "use.counter.css.page",
            "css_moz_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_focus
    ///
    /// Whether a page used the CSS property -moz-user-focus. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_focus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2282,
            "use.counter.css.page",
            "css_moz_user_focus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_input
    ///
    /// Whether a page used the CSS property -moz-user-input. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_input: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2283,
            "use.counter.css.page",
            "css_moz_user_input",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_user_select
    ///
    /// Whether a page used the CSS property -moz-user-select. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2284,
            "use.counter.css.page",
            "css_moz_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_dragging
    ///
    /// Whether a page used the CSS property -moz-window-dragging. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_dragging: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2285,
            "use.counter.css.page",
            "css_moz_window_dragging",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_input_region_margin
    ///
    /// Whether a page used the CSS property -moz-window-input-region-margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_input_region_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2286,
            "use.counter.css.page",
            "css_moz_window_input_region_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_opacity
    ///
    /// Whether a page used the CSS property -moz-window-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2287,
            "use.counter.css.page",
            "css_moz_window_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_shadow
    ///
    /// Whether a page used the CSS property -moz-window-shadow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2288,
            "use.counter.css.page",
            "css_moz_window_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_moz_window_transform
    ///
    /// Whether a page used the CSS property -moz-window-transform. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_moz_window_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2289,
            "use.counter.css.page",
            "css_moz_window_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_fit
    ///
    /// Whether a page used the CSS property object-fit. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_fit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2290,
            "use.counter.css.page",
            "css_object_fit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_object_position
    ///
    /// Whether a page used the CSS property object-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_object_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2291,
            "use.counter.css.page",
            "css_object_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset
    ///
    /// Whether a page used the CSS property offset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2292,
            "use.counter.css.page",
            "css_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_anchor
    ///
    /// Whether a page used the CSS property offset-anchor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2293,
            "use.counter.css.page",
            "css_offset_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_distance
    ///
    /// Whether a page used the CSS property offset-distance. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_distance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2294,
            "use.counter.css.page",
            "css_offset_distance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_path
    ///
    /// Whether a page used the CSS property offset-path. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2295,
            "use.counter.css.page",
            "css_offset_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_position
    ///
    /// Whether a page used the CSS property offset-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2296,
            "use.counter.css.page",
            "css_offset_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_offset_rotate
    ///
    /// Whether a page used the CSS property offset-rotate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_offset_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2297,
            "use.counter.css.page",
            "css_offset_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_opacity
    ///
    /// Whether a page used the CSS property opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2298,
            "use.counter.css.page",
            "css_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_order
    ///
    /// Whether a page used the CSS property order. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2299,
            "use.counter.css.page",
            "css_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline
    ///
    /// Whether a page used the CSS property outline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2300,
            "use.counter.css.page",
            "css_outline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_color
    ///
    /// Whether a page used the CSS property outline-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2301,
            "use.counter.css.page",
            "css_outline_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_offset
    ///
    /// Whether a page used the CSS property outline-offset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2302,
            "use.counter.css.page",
            "css_outline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_style
    ///
    /// Whether a page used the CSS property outline-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2303,
            "use.counter.css.page",
            "css_outline_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_outline_width
    ///
    /// Whether a page used the CSS property outline-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_outline_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2304,
            "use.counter.css.page",
            "css_outline_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow
    ///
    /// Whether a page used the CSS property overflow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2305,
            "use.counter.css.page",
            "css_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_anchor
    ///
    /// Whether a page used the CSS property overflow-anchor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2306,
            "use.counter.css.page",
            "css_overflow_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_block
    ///
    /// Whether a page used the CSS property overflow-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2307,
            "use.counter.css.page",
            "css_overflow_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box
    ///
    /// Whether a page used the CSS property overflow-clip-box. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2308,
            "use.counter.css.page",
            "css_overflow_clip_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_block
    ///
    /// Whether a page used the CSS property overflow-clip-box-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2309,
            "use.counter.css.page",
            "css_overflow_clip_box_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_box_inline
    ///
    /// Whether a page used the CSS property overflow-clip-box-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_box_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2310,
            "use.counter.css.page",
            "css_overflow_clip_box_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_clip_margin
    ///
    /// Whether a page used the CSS property overflow-clip-margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_clip_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2311,
            "use.counter.css.page",
            "css_overflow_clip_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_inline
    ///
    /// Whether a page used the CSS property overflow-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2312,
            "use.counter.css.page",
            "css_overflow_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_wrap
    ///
    /// Whether a page used the CSS property overflow-wrap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2313,
            "use.counter.css.page",
            "css_overflow_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_x
    ///
    /// Whether a page used the CSS property overflow-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2314,
            "use.counter.css.page",
            "css_overflow_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overflow_y
    ///
    /// Whether a page used the CSS property overflow-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overflow_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2315,
            "use.counter.css.page",
            "css_overflow_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior
    ///
    /// Whether a page used the CSS property overscroll-behavior. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2316,
            "use.counter.css.page",
            "css_overscroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_block
    ///
    /// Whether a page used the CSS property overscroll-behavior-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2317,
            "use.counter.css.page",
            "css_overscroll_behavior_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_inline
    ///
    /// Whether a page used the CSS property overscroll-behavior-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2318,
            "use.counter.css.page",
            "css_overscroll_behavior_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_x
    ///
    /// Whether a page used the CSS property overscroll-behavior-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2319,
            "use.counter.css.page",
            "css_overscroll_behavior_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_overscroll_behavior_y
    ///
    /// Whether a page used the CSS property overscroll-behavior-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_overscroll_behavior_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2320,
            "use.counter.css.page",
            "css_overscroll_behavior_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding
    ///
    /// Whether a page used the CSS property padding. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2321,
            "use.counter.css.page",
            "css_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block
    ///
    /// Whether a page used the CSS property padding-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2322,
            "use.counter.css.page",
            "css_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_end
    ///
    /// Whether a page used the CSS property padding-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2323,
            "use.counter.css.page",
            "css_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_block_start
    ///
    /// Whether a page used the CSS property padding-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2324,
            "use.counter.css.page",
            "css_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_bottom
    ///
    /// Whether a page used the CSS property padding-bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2325,
            "use.counter.css.page",
            "css_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline
    ///
    /// Whether a page used the CSS property padding-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2326,
            "use.counter.css.page",
            "css_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_end
    ///
    /// Whether a page used the CSS property padding-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2327,
            "use.counter.css.page",
            "css_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_inline_start
    ///
    /// Whether a page used the CSS property padding-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2328,
            "use.counter.css.page",
            "css_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_left
    ///
    /// Whether a page used the CSS property padding-left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2329,
            "use.counter.css.page",
            "css_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_right
    ///
    /// Whether a page used the CSS property padding-right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2330,
            "use.counter.css.page",
            "css_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_padding_top
    ///
    /// Whether a page used the CSS property padding-top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2331,
            "use.counter.css.page",
            "css_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page
    ///
    /// Whether a page used the CSS property page. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2332,
            "use.counter.css.page",
            "css_page",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_after
    ///
    /// Whether a page used the CSS property page-break-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2333,
            "use.counter.css.page",
            "css_page_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_before
    ///
    /// Whether a page used the CSS property page-break-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2334,
            "use.counter.css.page",
            "css_page_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_break_inside
    ///
    /// Whether a page used the CSS property page-break-inside. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2335,
            "use.counter.css.page",
            "css_page_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_page_orientation
    ///
    /// Whether a page used the CSS property page-orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_page_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2336,
            "use.counter.css.page",
            "css_page_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_paint_order
    ///
    /// Whether a page used the CSS property paint-order. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_paint_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2337,
            "use.counter.css.page",
            "css_paint_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective
    ///
    /// Whether a page used the CSS property perspective. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2338,
            "use.counter.css.page",
            "css_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_perspective_origin
    ///
    /// Whether a page used the CSS property perspective-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2339,
            "use.counter.css.page",
            "css_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_content
    ///
    /// Whether a page used the CSS property place-content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2340,
            "use.counter.css.page",
            "css_place_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_items
    ///
    /// Whether a page used the CSS property place-items. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2341,
            "use.counter.css.page",
            "css_place_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_place_self
    ///
    /// Whether a page used the CSS property place-self. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_place_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2342,
            "use.counter.css.page",
            "css_place_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_pointer_events
    ///
    /// Whether a page used the CSS property pointer-events. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_pointer_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2343,
            "use.counter.css.page",
            "css_pointer_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position
    ///
    /// Whether a page used the CSS property position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2344,
            "use.counter.css.page",
            "css_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_anchor
    ///
    /// Whether a page used the CSS property position-anchor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2345,
            "use.counter.css.page",
            "css_position_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_area
    ///
    /// Whether a page used the CSS property position-area. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_area: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2346,
            "use.counter.css.page",
            "css_position_area",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try
    ///
    /// Whether a page used the CSS property position-try. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2347,
            "use.counter.css.page",
            "css_position_try",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_fallbacks
    ///
    /// Whether a page used the CSS property position-try-fallbacks. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_fallbacks: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2348,
            "use.counter.css.page",
            "css_position_try_fallbacks",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_try_order
    ///
    /// Whether a page used the CSS property position-try-order. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_try_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2349,
            "use.counter.css.page",
            "css_position_try_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_position_visibility
    ///
    /// Whether a page used the CSS property position-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_position_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2350,
            "use.counter.css.page",
            "css_position_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_print_color_adjust
    ///
    /// Whether a page used the CSS property print-color-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2351,
            "use.counter.css.page",
            "css_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_quotes
    ///
    /// Whether a page used the CSS property quotes. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_quotes: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2352,
            "use.counter.css.page",
            "css_quotes",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_r
    ///
    /// Whether a page used the CSS property r. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_r: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2353,
            "use.counter.css.page",
            "css_r",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_resize
    ///
    /// Whether a page used the CSS property resize. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_resize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2354,
            "use.counter.css.page",
            "css_resize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_right
    ///
    /// Whether a page used the CSS property right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2355,
            "use.counter.css.page",
            "css_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rotate
    ///
    /// Whether a page used the CSS property rotate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2356,
            "use.counter.css.page",
            "css_rotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_row_gap
    ///
    /// Whether a page used the CSS property row-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_row_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2357,
            "use.counter.css.page",
            "css_row_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_align
    ///
    /// Whether a page used the CSS property ruby-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2358,
            "use.counter.css.page",
            "css_ruby_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ruby_position
    ///
    /// Whether a page used the CSS property ruby-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2359,
            "use.counter.css.page",
            "css_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_rx
    ///
    /// Whether a page used the CSS property rx. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_rx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2360,
            "use.counter.css.page",
            "css_rx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_ry
    ///
    /// Whether a page used the CSS property ry. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_ry: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2361,
            "use.counter.css.page",
            "css_ry",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scale
    ///
    /// Whether a page used the CSS property scale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2362,
            "use.counter.css.page",
            "css_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_behavior
    ///
    /// Whether a page used the CSS property scroll-behavior. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2363,
            "use.counter.css.page",
            "css_scroll_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin
    ///
    /// Whether a page used the CSS property scroll-margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2364,
            "use.counter.css.page",
            "css_scroll_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block
    ///
    /// Whether a page used the CSS property scroll-margin-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2365,
            "use.counter.css.page",
            "css_scroll_margin_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_end
    ///
    /// Whether a page used the CSS property scroll-margin-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2366,
            "use.counter.css.page",
            "css_scroll_margin_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_block_start
    ///
    /// Whether a page used the CSS property scroll-margin-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2367,
            "use.counter.css.page",
            "css_scroll_margin_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_bottom
    ///
    /// Whether a page used the CSS property scroll-margin-bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2368,
            "use.counter.css.page",
            "css_scroll_margin_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline
    ///
    /// Whether a page used the CSS property scroll-margin-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2369,
            "use.counter.css.page",
            "css_scroll_margin_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_end
    ///
    /// Whether a page used the CSS property scroll-margin-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2370,
            "use.counter.css.page",
            "css_scroll_margin_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_inline_start
    ///
    /// Whether a page used the CSS property scroll-margin-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2371,
            "use.counter.css.page",
            "css_scroll_margin_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_left
    ///
    /// Whether a page used the CSS property scroll-margin-left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2372,
            "use.counter.css.page",
            "css_scroll_margin_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_right
    ///
    /// Whether a page used the CSS property scroll-margin-right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2373,
            "use.counter.css.page",
            "css_scroll_margin_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_margin_top
    ///
    /// Whether a page used the CSS property scroll-margin-top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_margin_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2374,
            "use.counter.css.page",
            "css_scroll_margin_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding
    ///
    /// Whether a page used the CSS property scroll-padding. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2375,
            "use.counter.css.page",
            "css_scroll_padding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block
    ///
    /// Whether a page used the CSS property scroll-padding-block. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2376,
            "use.counter.css.page",
            "css_scroll_padding_block",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_end
    ///
    /// Whether a page used the CSS property scroll-padding-block-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2377,
            "use.counter.css.page",
            "css_scroll_padding_block_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_block_start
    ///
    /// Whether a page used the CSS property scroll-padding-block-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_block_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2378,
            "use.counter.css.page",
            "css_scroll_padding_block_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_bottom
    ///
    /// Whether a page used the CSS property scroll-padding-bottom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_bottom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2379,
            "use.counter.css.page",
            "css_scroll_padding_bottom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline
    ///
    /// Whether a page used the CSS property scroll-padding-inline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2380,
            "use.counter.css.page",
            "css_scroll_padding_inline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_end
    ///
    /// Whether a page used the CSS property scroll-padding-inline-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2381,
            "use.counter.css.page",
            "css_scroll_padding_inline_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_inline_start
    ///
    /// Whether a page used the CSS property scroll-padding-inline-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_inline_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2382,
            "use.counter.css.page",
            "css_scroll_padding_inline_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_left
    ///
    /// Whether a page used the CSS property scroll-padding-left. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_left: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2383,
            "use.counter.css.page",
            "css_scroll_padding_left",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_right
    ///
    /// Whether a page used the CSS property scroll-padding-right. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_right: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2384,
            "use.counter.css.page",
            "css_scroll_padding_right",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_padding_top
    ///
    /// Whether a page used the CSS property scroll-padding-top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_padding_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2385,
            "use.counter.css.page",
            "css_scroll_padding_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_align
    ///
    /// Whether a page used the CSS property scroll-snap-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2386,
            "use.counter.css.page",
            "css_scroll_snap_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_stop
    ///
    /// Whether a page used the CSS property scroll-snap-stop. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_stop: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2387,
            "use.counter.css.page",
            "css_scroll_snap_stop",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_snap_type
    ///
    /// Whether a page used the CSS property scroll-snap-type. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_snap_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2388,
            "use.counter.css.page",
            "css_scroll_snap_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline
    ///
    /// Whether a page used the CSS property scroll-timeline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2389,
            "use.counter.css.page",
            "css_scroll_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_axis
    ///
    /// Whether a page used the CSS property scroll-timeline-axis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2390,
            "use.counter.css.page",
            "css_scroll_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scroll_timeline_name
    ///
    /// Whether a page used the CSS property scroll-timeline-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scroll_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2391,
            "use.counter.css.page",
            "css_scroll_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_color
    ///
    /// Whether a page used the CSS property scrollbar-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2392,
            "use.counter.css.page",
            "css_scrollbar_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_gutter
    ///
    /// Whether a page used the CSS property scrollbar-gutter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_gutter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2393,
            "use.counter.css.page",
            "css_scrollbar_gutter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_scrollbar_width
    ///
    /// Whether a page used the CSS property scrollbar-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_scrollbar_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2394,
            "use.counter.css.page",
            "css_scrollbar_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_image_threshold
    ///
    /// Whether a page used the CSS property shape-image-threshold. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2395,
            "use.counter.css.page",
            "css_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_margin
    ///
    /// Whether a page used the CSS property shape-margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2396,
            "use.counter.css.page",
            "css_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_outside
    ///
    /// Whether a page used the CSS property shape-outside. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2397,
            "use.counter.css.page",
            "css_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_shape_rendering
    ///
    /// Whether a page used the CSS property shape-rendering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_shape_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2398,
            "use.counter.css.page",
            "css_shape_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_size
    ///
    /// Whether a page used the CSS property size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2399,
            "use.counter.css.page",
            "css_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_color
    ///
    /// Whether a page used the CSS property stop-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2400,
            "use.counter.css.page",
            "css_stop_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stop_opacity
    ///
    /// Whether a page used the CSS property stop-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stop_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2401,
            "use.counter.css.page",
            "css_stop_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke
    ///
    /// Whether a page used the CSS property stroke. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2402,
            "use.counter.css.page",
            "css_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dasharray
    ///
    /// Whether a page used the CSS property stroke-dasharray. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dasharray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2403,
            "use.counter.css.page",
            "css_stroke_dasharray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_dashoffset
    ///
    /// Whether a page used the CSS property stroke-dashoffset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_dashoffset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2404,
            "use.counter.css.page",
            "css_stroke_dashoffset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linecap
    ///
    /// Whether a page used the CSS property stroke-linecap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linecap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2405,
            "use.counter.css.page",
            "css_stroke_linecap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_linejoin
    ///
    /// Whether a page used the CSS property stroke-linejoin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_linejoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2406,
            "use.counter.css.page",
            "css_stroke_linejoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_miterlimit
    ///
    /// Whether a page used the CSS property stroke-miterlimit. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_miterlimit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2407,
            "use.counter.css.page",
            "css_stroke_miterlimit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_opacity
    ///
    /// Whether a page used the CSS property stroke-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2408,
            "use.counter.css.page",
            "css_stroke_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_stroke_width
    ///
    /// Whether a page used the CSS property stroke-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2409,
            "use.counter.css.page",
            "css_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_tab_size
    ///
    /// Whether a page used the CSS property tab-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_tab_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2410,
            "use.counter.css.page",
            "css_tab_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_table_layout
    ///
    /// Whether a page used the CSS property table-layout. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_table_layout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2411,
            "use.counter.css.page",
            "css_table_layout",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align
    ///
    /// Whether a page used the CSS property text-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2412,
            "use.counter.css.page",
            "css_text_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_align_last
    ///
    /// Whether a page used the CSS property text-align-last. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_align_last: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2413,
            "use.counter.css.page",
            "css_text_align_last",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_anchor
    ///
    /// Whether a page used the CSS property text-anchor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_anchor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2414,
            "use.counter.css.page",
            "css_text_anchor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_combine_upright
    ///
    /// Whether a page used the CSS property text-combine-upright. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_combine_upright: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2415,
            "use.counter.css.page",
            "css_text_combine_upright",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration
    ///
    /// Whether a page used the CSS property text-decoration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2416,
            "use.counter.css.page",
            "css_text_decoration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_color
    ///
    /// Whether a page used the CSS property text-decoration-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2417,
            "use.counter.css.page",
            "css_text_decoration_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_line
    ///
    /// Whether a page used the CSS property text-decoration-line. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_line: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2418,
            "use.counter.css.page",
            "css_text_decoration_line",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_skip_ink
    ///
    /// Whether a page used the CSS property text-decoration-skip-ink. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_skip_ink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2419,
            "use.counter.css.page",
            "css_text_decoration_skip_ink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_style
    ///
    /// Whether a page used the CSS property text-decoration-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2420,
            "use.counter.css.page",
            "css_text_decoration_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_decoration_thickness
    ///
    /// Whether a page used the CSS property text-decoration-thickness. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_decoration_thickness: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2421,
            "use.counter.css.page",
            "css_text_decoration_thickness",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis
    ///
    /// Whether a page used the CSS property text-emphasis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2422,
            "use.counter.css.page",
            "css_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_color
    ///
    /// Whether a page used the CSS property text-emphasis-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2423,
            "use.counter.css.page",
            "css_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_position
    ///
    /// Whether a page used the CSS property text-emphasis-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2424,
            "use.counter.css.page",
            "css_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_emphasis_style
    ///
    /// Whether a page used the CSS property text-emphasis-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2425,
            "use.counter.css.page",
            "css_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_indent
    ///
    /// Whether a page used the CSS property text-indent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_indent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2426,
            "use.counter.css.page",
            "css_text_indent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_justify
    ///
    /// Whether a page used the CSS property text-justify. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_justify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2427,
            "use.counter.css.page",
            "css_text_justify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_orientation
    ///
    /// Whether a page used the CSS property text-orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2428,
            "use.counter.css.page",
            "css_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_overflow
    ///
    /// Whether a page used the CSS property text-overflow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_overflow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2429,
            "use.counter.css.page",
            "css_text_overflow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_rendering
    ///
    /// Whether a page used the CSS property text-rendering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_rendering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2430,
            "use.counter.css.page",
            "css_text_rendering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_shadow
    ///
    /// Whether a page used the CSS property text-shadow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2431,
            "use.counter.css.page",
            "css_text_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_transform
    ///
    /// Whether a page used the CSS property text-transform. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2432,
            "use.counter.css.page",
            "css_text_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_offset
    ///
    /// Whether a page used the CSS property text-underline-offset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2433,
            "use.counter.css.page",
            "css_text_underline_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_underline_position
    ///
    /// Whether a page used the CSS property text-underline-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_underline_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2434,
            "use.counter.css.page",
            "css_text_underline_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap
    ///
    /// Whether a page used the CSS property text-wrap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2435,
            "use.counter.css.page",
            "css_text_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_mode
    ///
    /// Whether a page used the CSS property text-wrap-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2436,
            "use.counter.css.page",
            "css_text_wrap_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_text_wrap_style
    ///
    /// Whether a page used the CSS property text-wrap-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_text_wrap_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2437,
            "use.counter.css.page",
            "css_text_wrap_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_top
    ///
    /// Whether a page used the CSS property top. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_top: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2438,
            "use.counter.css.page",
            "css_top",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_touch_action
    ///
    /// Whether a page used the CSS property touch-action. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_touch_action: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2439,
            "use.counter.css.page",
            "css_touch_action",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform
    ///
    /// Whether a page used the CSS property transform. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2440,
            "use.counter.css.page",
            "css_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_box
    ///
    /// Whether a page used the CSS property transform-box. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_box: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2441,
            "use.counter.css.page",
            "css_transform_box",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_origin
    ///
    /// Whether a page used the CSS property transform-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2442,
            "use.counter.css.page",
            "css_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transform_style
    ///
    /// Whether a page used the CSS property transform-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2443,
            "use.counter.css.page",
            "css_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition
    ///
    /// Whether a page used the CSS property transition. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2444,
            "use.counter.css.page",
            "css_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_behavior
    ///
    /// Whether a page used the CSS property transition-behavior. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_behavior: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2445,
            "use.counter.css.page",
            "css_transition_behavior",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_delay
    ///
    /// Whether a page used the CSS property transition-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2446,
            "use.counter.css.page",
            "css_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_duration
    ///
    /// Whether a page used the CSS property transition-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2447,
            "use.counter.css.page",
            "css_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_property
    ///
    /// Whether a page used the CSS property transition-property. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2448,
            "use.counter.css.page",
            "css_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_transition_timing_function
    ///
    /// Whether a page used the CSS property transition-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2449,
            "use.counter.css.page",
            "css_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_translate
    ///
    /// Whether a page used the CSS property translate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_translate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2450,
            "use.counter.css.page",
            "css_translate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_unicode_bidi
    ///
    /// Whether a page used the CSS property unicode-bidi. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_unicode_bidi: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2451,
            "use.counter.css.page",
            "css_unicode_bidi",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_user_select
    ///
    /// Whether a page used the CSS property user-select. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2452,
            "use.counter.css.page",
            "css_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vector_effect
    ///
    /// Whether a page used the CSS property vector-effect. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vector_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2453,
            "use.counter.css.page",
            "css_vector_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_vertical_align
    ///
    /// Whether a page used the CSS property vertical-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_vertical_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2454,
            "use.counter.css.page",
            "css_vertical_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline
    ///
    /// Whether a page used the CSS property view-timeline. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2455,
            "use.counter.css.page",
            "css_view_timeline",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_axis
    ///
    /// Whether a page used the CSS property view-timeline-axis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_axis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2456,
            "use.counter.css.page",
            "css_view_timeline_axis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_inset
    ///
    /// Whether a page used the CSS property view-timeline-inset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_inset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2457,
            "use.counter.css.page",
            "css_view_timeline_inset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_timeline_name
    ///
    /// Whether a page used the CSS property view-timeline-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_timeline_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2458,
            "use.counter.css.page",
            "css_view_timeline_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_view_transition_name
    ///
    /// Whether a page used the CSS property view-transition-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_view_transition_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2459,
            "use.counter.css.page",
            "css_view_transition_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_visibility
    ///
    /// Whether a page used the CSS property visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2460,
            "use.counter.css.page",
            "css_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_content
    ///
    /// Whether a page used the CSS property -webkit-align-content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2461,
            "use.counter.css.page",
            "css_webkit_align_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_items
    ///
    /// Whether a page used the CSS property -webkit-align-items. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_items: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2462,
            "use.counter.css.page",
            "css_webkit_align_items",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_align_self
    ///
    /// Whether a page used the CSS property -webkit-align-self. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_align_self: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2463,
            "use.counter.css.page",
            "css_webkit_align_self",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation
    ///
    /// Whether a page used the CSS property -webkit-animation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2464,
            "use.counter.css.page",
            "css_webkit_animation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_delay
    ///
    /// Whether a page used the CSS property -webkit-animation-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2465,
            "use.counter.css.page",
            "css_webkit_animation_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_direction
    ///
    /// Whether a page used the CSS property -webkit-animation-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2466,
            "use.counter.css.page",
            "css_webkit_animation_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_duration
    ///
    /// Whether a page used the CSS property -webkit-animation-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2467,
            "use.counter.css.page",
            "css_webkit_animation_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_fill_mode
    ///
    /// Whether a page used the CSS property -webkit-animation-fill-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_fill_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2468,
            "use.counter.css.page",
            "css_webkit_animation_fill_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_iteration_count
    ///
    /// Whether a page used the CSS property -webkit-animation-iteration-count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_iteration_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2469,
            "use.counter.css.page",
            "css_webkit_animation_iteration_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_name
    ///
    /// Whether a page used the CSS property -webkit-animation-name. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_name: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2470,
            "use.counter.css.page",
            "css_webkit_animation_name",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_play_state
    ///
    /// Whether a page used the CSS property -webkit-animation-play-state. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_play_state: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2471,
            "use.counter.css.page",
            "css_webkit_animation_play_state",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_animation_timing_function
    ///
    /// Whether a page used the CSS property -webkit-animation-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_animation_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2472,
            "use.counter.css.page",
            "css_webkit_animation_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_appearance
    ///
    /// Whether a page used the CSS property -webkit-appearance. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_appearance: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2473,
            "use.counter.css.page",
            "css_webkit_appearance",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_backface_visibility
    ///
    /// Whether a page used the CSS property -webkit-backface-visibility. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_backface_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2474,
            "use.counter.css.page",
            "css_webkit_backface_visibility",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_clip
    ///
    /// Whether a page used the CSS property -webkit-background-clip. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2475,
            "use.counter.css.page",
            "css_webkit_background_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_origin
    ///
    /// Whether a page used the CSS property -webkit-background-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2476,
            "use.counter.css.page",
            "css_webkit_background_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_background_size
    ///
    /// Whether a page used the CSS property -webkit-background-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_background_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2477,
            "use.counter.css.page",
            "css_webkit_background_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-left-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_bottom_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2478,
            "use.counter.css.page",
            "css_webkit_border_bottom_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_bottom_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-bottom-right-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_bottom_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2479,
            "use.counter.css.page",
            "css_webkit_border_bottom_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_image
    ///
    /// Whether a page used the CSS property -webkit-border-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2480,
            "use.counter.css.page",
            "css_webkit_border_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_radius
    ///
    /// Whether a page used the CSS property -webkit-border-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2481,
            "use.counter.css.page",
            "css_webkit_border_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_left_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-left-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_top_left_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2482,
            "use.counter.css.page",
            "css_webkit_border_top_left_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_border_top_right_radius
    ///
    /// Whether a page used the CSS property -webkit-border-top-right-radius. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_border_top_right_radius: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2483,
            "use.counter.css.page",
            "css_webkit_border_top_right_radius",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_align
    ///
    /// Whether a page used the CSS property -webkit-box-align. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_align: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2484,
            "use.counter.css.page",
            "css_webkit_box_align",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_direction
    ///
    /// Whether a page used the CSS property -webkit-box-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2485,
            "use.counter.css.page",
            "css_webkit_box_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_flex
    ///
    /// Whether a page used the CSS property -webkit-box-flex. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2486,
            "use.counter.css.page",
            "css_webkit_box_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_ordinal_group
    ///
    /// Whether a page used the CSS property -webkit-box-ordinal-group. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_ordinal_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2487,
            "use.counter.css.page",
            "css_webkit_box_ordinal_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_orient
    ///
    /// Whether a page used the CSS property -webkit-box-orient. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_orient: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2488,
            "use.counter.css.page",
            "css_webkit_box_orient",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_pack
    ///
    /// Whether a page used the CSS property -webkit-box-pack. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_pack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2489,
            "use.counter.css.page",
            "css_webkit_box_pack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_shadow
    ///
    /// Whether a page used the CSS property -webkit-box-shadow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_shadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2490,
            "use.counter.css.page",
            "css_webkit_box_shadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_box_sizing
    ///
    /// Whether a page used the CSS property -webkit-box-sizing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_box_sizing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2491,
            "use.counter.css.page",
            "css_webkit_box_sizing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_clip_path
    ///
    /// Whether a page used the CSS property -webkit-clip-path. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_clip_path: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2492,
            "use.counter.css.page",
            "css_webkit_clip_path",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_filter
    ///
    /// Whether a page used the CSS property -webkit-filter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_filter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2493,
            "use.counter.css.page",
            "css_webkit_filter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex
    ///
    /// Whether a page used the CSS property -webkit-flex. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2494,
            "use.counter.css.page",
            "css_webkit_flex",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_basis
    ///
    /// Whether a page used the CSS property -webkit-flex-basis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_basis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2495,
            "use.counter.css.page",
            "css_webkit_flex_basis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_direction
    ///
    /// Whether a page used the CSS property -webkit-flex-direction. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_direction: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2496,
            "use.counter.css.page",
            "css_webkit_flex_direction",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_flow
    ///
    /// Whether a page used the CSS property -webkit-flex-flow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_flow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2497,
            "use.counter.css.page",
            "css_webkit_flex_flow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_grow
    ///
    /// Whether a page used the CSS property -webkit-flex-grow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_grow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2498,
            "use.counter.css.page",
            "css_webkit_flex_grow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_shrink
    ///
    /// Whether a page used the CSS property -webkit-flex-shrink. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_shrink: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2499,
            "use.counter.css.page",
            "css_webkit_flex_shrink",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_flex_wrap
    ///
    /// Whether a page used the CSS property -webkit-flex-wrap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_flex_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2500,
            "use.counter.css.page",
            "css_webkit_flex_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_font_feature_settings
    ///
    /// Whether a page used the CSS property -webkit-font-feature-settings. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_feature_settings: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2501,
            "use.counter.css.page",
            "css_webkit_font_feature_settings",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_font_smoothing
    ///
    /// Whether a page used the CSS property -webkit-font-smoothing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_font_smoothing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2502,
            "use.counter.css.page",
            "css_webkit_font_smoothing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_justify_content
    ///
    /// Whether a page used the CSS property -webkit-justify-content. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_justify_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2503,
            "use.counter.css.page",
            "css_webkit_justify_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_line_clamp
    ///
    /// Whether a page used the CSS property -webkit-line-clamp. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_line_clamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2504,
            "use.counter.css.page",
            "css_webkit_line_clamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask
    ///
    /// Whether a page used the CSS property -webkit-mask. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2505,
            "use.counter.css.page",
            "css_webkit_mask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_clip
    ///
    /// Whether a page used the CSS property -webkit-mask-clip. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_clip: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2506,
            "use.counter.css.page",
            "css_webkit_mask_clip",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_composite
    ///
    /// Whether a page used the CSS property -webkit-mask-composite. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2507,
            "use.counter.css.page",
            "css_webkit_mask_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_image
    ///
    /// Whether a page used the CSS property -webkit-mask-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2508,
            "use.counter.css.page",
            "css_webkit_mask_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_origin
    ///
    /// Whether a page used the CSS property -webkit-mask-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2509,
            "use.counter.css.page",
            "css_webkit_mask_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position
    ///
    /// Whether a page used the CSS property -webkit-mask-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2510,
            "use.counter.css.page",
            "css_webkit_mask_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_x
    ///
    /// Whether a page used the CSS property -webkit-mask-position-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2511,
            "use.counter.css.page",
            "css_webkit_mask_position_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_position_y
    ///
    /// Whether a page used the CSS property -webkit-mask-position-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_position_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2512,
            "use.counter.css.page",
            "css_webkit_mask_position_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_repeat
    ///
    /// Whether a page used the CSS property -webkit-mask-repeat. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2513,
            "use.counter.css.page",
            "css_webkit_mask_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_mask_size
    ///
    /// Whether a page used the CSS property -webkit-mask-size. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_mask_size: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2514,
            "use.counter.css.page",
            "css_webkit_mask_size",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_order
    ///
    /// Whether a page used the CSS property -webkit-order. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_order: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2515,
            "use.counter.css.page",
            "css_webkit_order",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective
    ///
    /// Whether a page used the CSS property -webkit-perspective. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2516,
            "use.counter.css.page",
            "css_webkit_perspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_perspective_origin
    ///
    /// Whether a page used the CSS property -webkit-perspective-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_perspective_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2517,
            "use.counter.css.page",
            "css_webkit_perspective_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_fill_color
    ///
    /// Whether a page used the CSS property -webkit-text-fill-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_fill_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2518,
            "use.counter.css.page",
            "css_webkit_text_fill_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_security
    ///
    /// Whether a page used the CSS property -webkit-text-security. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_security: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2519,
            "use.counter.css.page",
            "css_webkit_text_security",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_size_adjust
    ///
    /// Whether a page used the CSS property -webkit-text-size-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2520,
            "use.counter.css.page",
            "css_webkit_text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke
    ///
    /// Whether a page used the CSS property -webkit-text-stroke. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2521,
            "use.counter.css.page",
            "css_webkit_text_stroke",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_color
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2522,
            "use.counter.css.page",
            "css_webkit_text_stroke_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_text_stroke_width
    ///
    /// Whether a page used the CSS property -webkit-text-stroke-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_text_stroke_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2523,
            "use.counter.css.page",
            "css_webkit_text_stroke_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform
    ///
    /// Whether a page used the CSS property -webkit-transform. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2524,
            "use.counter.css.page",
            "css_webkit_transform",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_origin
    ///
    /// Whether a page used the CSS property -webkit-transform-origin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_origin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2525,
            "use.counter.css.page",
            "css_webkit_transform_origin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transform_style
    ///
    /// Whether a page used the CSS property -webkit-transform-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transform_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2526,
            "use.counter.css.page",
            "css_webkit_transform_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition
    ///
    /// Whether a page used the CSS property -webkit-transition. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2527,
            "use.counter.css.page",
            "css_webkit_transition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_delay
    ///
    /// Whether a page used the CSS property -webkit-transition-delay. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_delay: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2528,
            "use.counter.css.page",
            "css_webkit_transition_delay",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_duration
    ///
    /// Whether a page used the CSS property -webkit-transition-duration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_duration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2529,
            "use.counter.css.page",
            "css_webkit_transition_duration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_property
    ///
    /// Whether a page used the CSS property -webkit-transition-property. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_property: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2530,
            "use.counter.css.page",
            "css_webkit_transition_property",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_transition_timing_function
    ///
    /// Whether a page used the CSS property -webkit-transition-timing-function. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_transition_timing_function: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2531,
            "use.counter.css.page",
            "css_webkit_transition_timing_function",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_webkit_user_select
    ///
    /// Whether a page used the CSS property -webkit-user-select. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_webkit_user_select: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2532,
            "use.counter.css.page",
            "css_webkit_user_select",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space
    ///
    /// Whether a page used the CSS property white-space. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2533,
            "use.counter.css.page",
            "css_white_space",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_white_space_collapse
    ///
    /// Whether a page used the CSS property white-space-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_white_space_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2534,
            "use.counter.css.page",
            "css_white_space_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_width
    ///
    /// Whether a page used the CSS property width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2535,
            "use.counter.css.page",
            "css_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_will_change
    ///
    /// Whether a page used the CSS property will-change. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_will_change: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2536,
            "use.counter.css.page",
            "css_will_change",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_break
    ///
    /// Whether a page used the CSS property word-break. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2537,
            "use.counter.css.page",
            "css_word_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_spacing
    ///
    /// Whether a page used the CSS property word-spacing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2538,
            "use.counter.css.page",
            "css_word_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_word_wrap
    ///
    /// Whether a page used the CSS property word-wrap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_word_wrap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2539,
            "use.counter.css.page",
            "css_word_wrap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_writing_mode
    ///
    /// Whether a page used the CSS property writing-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2540,
            "use.counter.css.page",
            "css_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x
    ///
    /// Whether a page used the CSS property x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2541,
            "use.counter.css.page",
            "css_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_lang
    ///
    /// Whether a page used the CSS property -x-lang. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_lang: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2542,
            "use.counter.css.page",
            "css_x_lang",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_span
    ///
    /// Whether a page used the CSS property -x-span. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2543,
            "use.counter.css.page",
            "css_x_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_x_text_scale
    ///
    /// Whether a page used the CSS property -x-text-scale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_x_text_scale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2544,
            "use.counter.css.page",
            "css_x_text_scale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_y
    ///
    /// Whether a page used the CSS property y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2545,
            "use.counter.css.page",
            "css_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_z_index
    ///
    /// Whether a page used the CSS property z-index. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_z_index: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2546,
            "use.counter.css.page",
            "css_z_index",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.css_zoom
    ///
    /// Whether a page used the CSS property zoom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static css_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2547,
            "use.counter.css.page",
            "css_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.max_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property max-zoom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static max_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2548,
            "use.counter.css.page",
            "max_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.min_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property min-zoom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static min_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2549,
            "use.counter.css.page",
            "min_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2550,
            "use.counter.css.page",
            "orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.orphans
    ///
    /// Whether a page used the (unknown, counted) CSS property orphans. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static orphans: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2551,
            "use.counter.css.page",
            "orphans",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.speak
    ///
    /// Whether a page used the (unknown, counted) CSS property speak. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static speak: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2552,
            "use.counter.css.page",
            "speak",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.text_size_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property text-size-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static text_size_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2553,
            "use.counter.css.page",
            "text_size_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.user_zoom
    ///
    /// Whether a page used the (unknown, counted) CSS property user-zoom. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static user_zoom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2554,
            "use.counter.css.page",
            "user_zoom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_app_region
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-app-region. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_app_region: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2555,
            "use.counter.css.page",
            "webkit_app_region",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2556,
            "use.counter.css.page",
            "webkit_border_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2557,
            "use.counter.css.page",
            "webkit_border_after_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2558,
            "use.counter.css.page",
            "webkit_border_after_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_after_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-after-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_after_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2559,
            "use.counter.css.page",
            "webkit_border_after_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2560,
            "use.counter.css.page",
            "webkit_border_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2561,
            "use.counter.css.page",
            "webkit_border_before_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2562,
            "use.counter.css.page",
            "webkit_border_before_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_before_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-before-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_before_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2563,
            "use.counter.css.page",
            "webkit_border_before_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2564,
            "use.counter.css.page",
            "webkit_border_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2565,
            "use.counter.css.page",
            "webkit_border_end_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2566,
            "use.counter.css.page",
            "webkit_border_end_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_end_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-end-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_end_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2567,
            "use.counter.css.page",
            "webkit_border_end_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_horizontal_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-horizontal-spacing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_horizontal_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2568,
            "use.counter.css.page",
            "webkit_border_horizontal_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2569,
            "use.counter.css.page",
            "webkit_border_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2570,
            "use.counter.css.page",
            "webkit_border_start_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2571,
            "use.counter.css.page",
            "webkit_border_start_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_start_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-start-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_start_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2572,
            "use.counter.css.page",
            "webkit_border_start_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_border_vertical_spacing
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-border-vertical-spacing. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_border_vertical_spacing: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2573,
            "use.counter.css.page",
            "webkit_border_vertical_spacing",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_decoration_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-decoration-break. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_box_decoration_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2574,
            "use.counter.css.page",
            "webkit_box_decoration_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_box_reflect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-box-reflect. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_box_reflect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2575,
            "use.counter.css.page",
            "webkit_box_reflect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2576,
            "use.counter.css.page",
            "webkit_column_break_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2577,
            "use.counter.css.page",
            "webkit_column_break_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_break_inside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-break-inside. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_break_inside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2578,
            "use.counter.css.page",
            "webkit_column_break_inside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_count
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2579,
            "use.counter.css.page",
            "webkit_column_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_gap
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-gap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_gap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2580,
            "use.counter.css.page",
            "webkit_column_gap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2581,
            "use.counter.css.page",
            "webkit_column_rule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2582,
            "use.counter.css.page",
            "webkit_column_rule_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2583,
            "use.counter.css.page",
            "webkit_column_rule_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_rule_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-rule-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_rule_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2584,
            "use.counter.css.page",
            "webkit_column_rule_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_span
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-span. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_span: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2585,
            "use.counter.css.page",
            "webkit_column_span",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_column_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-column-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_column_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2586,
            "use.counter.css.page",
            "webkit_column_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_columns
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-columns. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_columns: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2587,
            "use.counter.css.page",
            "webkit_columns",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_font_size_delta
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-font-size-delta. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_font_size_delta: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2588,
            "use.counter.css.page",
            "webkit_font_size_delta",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_highlight
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-highlight. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_highlight: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2589,
            "use.counter.css.page",
            "webkit_highlight",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_hyphenate_character
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-hyphenate-character. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_hyphenate_character: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2590,
            "use.counter.css.page",
            "webkit_hyphenate_character",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_line_break
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-line-break. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_line_break: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2591,
            "use.counter.css.page",
            "webkit_line_break",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_locale
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-locale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2592,
            "use.counter.css.page",
            "webkit_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2593,
            "use.counter.css.page",
            "webkit_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-logical-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2594,
            "use.counter.css.page",
            "webkit_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2595,
            "use.counter.css.page",
            "webkit_margin_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_after_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-after-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_after_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2596,
            "use.counter.css.page",
            "webkit_margin_after_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2597,
            "use.counter.css.page",
            "webkit_margin_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_before_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-before-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_before_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2598,
            "use.counter.css.page",
            "webkit_margin_before_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_bottom_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-bottom-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_bottom_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2599,
            "use.counter.css.page",
            "webkit_margin_bottom_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2600,
            "use.counter.css.page",
            "webkit_margin_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2601,
            "use.counter.css.page",
            "webkit_margin_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2602,
            "use.counter.css.page",
            "webkit_margin_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_margin_top_collapse
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-margin-top-collapse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_margin_top_collapse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2603,
            "use.counter.css.page",
            "webkit_margin_top_collapse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2604,
            "use.counter.css.page",
            "webkit_mask_box_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_outset
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-outset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_outset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2605,
            "use.counter.css.page",
            "webkit_mask_box_image_outset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_repeat
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-repeat. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_repeat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2606,
            "use.counter.css.page",
            "webkit_mask_box_image_repeat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_slice
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-slice. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_slice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2607,
            "use.counter.css.page",
            "webkit_mask_box_image_slice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_source
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-source. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2608,
            "use.counter.css.page",
            "webkit_mask_box_image_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_box_image_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-box-image-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_box_image_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2609,
            "use.counter.css.page",
            "webkit_mask_box_image_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_repeat_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2610,
            "use.counter.css.page",
            "webkit_mask_repeat_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_mask_repeat_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-mask-repeat-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_mask_repeat_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2611,
            "use.counter.css.page",
            "webkit_mask_repeat_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_max_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2612,
            "use.counter.css.page",
            "webkit_max_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_max_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-max-logical-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_max_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2613,
            "use.counter.css.page",
            "webkit_max_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_height
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-height. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_min_logical_height: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2614,
            "use.counter.css.page",
            "webkit_min_logical_height",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_min_logical_width
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-min-logical-width. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_min_logical_width: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2615,
            "use.counter.css.page",
            "webkit_min_logical_width",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_opacity
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-opacity. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_opacity: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2616,
            "use.counter.css.page",
            "webkit_opacity",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_after
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-after. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_after: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2617,
            "use.counter.css.page",
            "webkit_padding_after",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_before
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-before. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_before: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2618,
            "use.counter.css.page",
            "webkit_padding_before",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_end
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-end. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_end: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2619,
            "use.counter.css.page",
            "webkit_padding_end",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_padding_start
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-padding-start. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_padding_start: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2620,
            "use.counter.css.page",
            "webkit_padding_start",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-origin-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_perspective_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2621,
            "use.counter.css.page",
            "webkit_perspective_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_perspective_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-perspective-origin-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_perspective_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2622,
            "use.counter.css.page",
            "webkit_perspective_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_print_color_adjust
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-print-color-adjust. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_print_color_adjust: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2623,
            "use.counter.css.page",
            "webkit_print_color_adjust",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_rtl_ordering
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-rtl-ordering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_rtl_ordering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2624,
            "use.counter.css.page",
            "webkit_rtl_ordering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_ruby_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-ruby-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_ruby_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2625,
            "use.counter.css.page",
            "webkit_ruby_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_image_threshold
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-image-threshold. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_image_threshold: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2626,
            "use.counter.css.page",
            "webkit_shape_image_threshold",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_margin
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-margin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_margin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2627,
            "use.counter.css.page",
            "webkit_shape_margin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_shape_outside
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-shape-outside. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_shape_outside: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2628,
            "use.counter.css.page",
            "webkit_shape_outside",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_tap_highlight_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-tap-highlight-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_tap_highlight_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2629,
            "use.counter.css.page",
            "webkit_tap_highlight_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_combine
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-combine. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_combine: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2630,
            "use.counter.css.page",
            "webkit_text_combine",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_decorations_in_effect
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-decorations-in-effect. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_decorations_in_effect: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2631,
            "use.counter.css.page",
            "webkit_text_decorations_in_effect",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2632,
            "use.counter.css.page",
            "webkit_text_emphasis",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_color
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-color. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_color: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2633,
            "use.counter.css.page",
            "webkit_text_emphasis_color",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_position
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-position. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_position: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2634,
            "use.counter.css.page",
            "webkit_text_emphasis_position",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_emphasis_style
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-emphasis-style. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_emphasis_style: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2635,
            "use.counter.css.page",
            "webkit_text_emphasis_style",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_text_orientation
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-text-orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_text_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2636,
            "use.counter.css.page",
            "webkit_text_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_x
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-origin-x. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_x: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2637,
            "use.counter.css.page",
            "webkit_transform_origin_x",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_y
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-origin-y. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_y: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2638,
            "use.counter.css.page",
            "webkit_transform_origin_y",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_transform_origin_z
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-transform-origin-z. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_transform_origin_z: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2639,
            "use.counter.css.page",
            "webkit_transform_origin_z",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_drag
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-drag. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_user_drag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2640,
            "use.counter.css.page",
            "webkit_user_drag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_user_modify
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-user-modify. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_user_modify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2641,
            "use.counter.css.page",
            "webkit_user_modify",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.webkit_writing_mode
    ///
    /// Whether a page used the (unknown, counted) CSS property -webkit-writing-mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webkit_writing_mode: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2642,
            "use.counter.css.page",
            "webkit_writing_mode",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.css.page.widows
    ///
    /// Whether a page used the (unknown, counted) CSS property widows. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static widows: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2643,
            "use.counter.css.page",
            "widows",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.after_script_execute_event
    ///
    /// Whether a document used AfterScriptExecuteEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static after_script_execute_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2644,
            "use.counter.deprecated_ops.doc",
            "after_script_execute_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.ambient_light_event
    ///
    /// Whether a document used AmbientLightEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2645,
            "use.counter.deprecated_ops.doc",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.app_cache
    ///
    /// Whether a document used AppCache. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2646,
            "use.counter.deprecated_ops.doc",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.before_script_execute_event
    ///
    /// Whether a document used BeforeScriptExecuteEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static before_script_execute_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2647,
            "use.counter.deprecated_ops.doc",
            "before_script_execute_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.components
    ///
    /// Whether a document used Components. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2648,
            "use.counter.deprecated_ops.doc",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a document used CreateImageBitmapCanvasRenderingContext2D. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2649,
            "use.counter.deprecated_ops.doc",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_attribute
    ///
    /// Whether a document used DeprecatedTestingAttribute. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2650,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_interface
    ///
    /// Whether a document used DeprecatedTestingInterface. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2651,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.deprecated_testing_method
    ///
    /// Whether a document used DeprecatedTestingMethod. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2652,
            "use.counter.deprecated_ops.doc",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.document_release_capture
    ///
    /// Whether a document used DocumentReleaseCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2653,
            "use.counter.deprecated_ops.doc",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domattr_modified
    ///
    /// Whether a document used DOMAttrModified. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2654,
            "use.counter.deprecated_ops.doc",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domcharacter_data_modified
    ///
    /// Whether a document used DOMCharacterDataModified. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2655,
            "use.counter.deprecated_ops.doc",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted
    ///
    /// Whether a document used DOMNodeInserted. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2656,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_inserted_into_document
    ///
    /// Whether a document used DOMNodeInsertedIntoDocument. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2657,
            "use.counter.deprecated_ops.doc",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed
    ///
    /// Whether a document used DOMNodeRemoved. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2658,
            "use.counter.deprecated_ops.doc",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domnode_removed_from_document
    ///
    /// Whether a document used DOMNodeRemovedFromDocument. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2659,
            "use.counter.deprecated_ops.doc",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domquad_bounds_attr
    ///
    /// Whether a document used DOMQuadBoundsAttr. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2660,
            "use.counter.deprecated_ops.doc",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.domsubtree_modified
    ///
    /// Whether a document used DOMSubtreeModified. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2661,
            "use.counter.deprecated_ops.doc",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a document used DrawWindowCanvasRenderingContext2D. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2662,
            "use.counter.deprecated_ops.doc",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_release_capture
    ///
    /// Whether a document used ElementReleaseCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2663,
            "use.counter.deprecated_ops.doc",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.element_set_capture
    ///
    /// Whether a document used ElementSetCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2664,
            "use.counter.deprecated_ops.doc",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.external__add_search_provider
    ///
    /// Whether a document used External_AddSearchProvider. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2665,
            "use.counter.deprecated_ops.doc",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.form_submission_untrusted_event
    ///
    /// Whether a document used FormSubmissionUntrustedEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2666,
            "use.counter.deprecated_ops.doc",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbobject_store_create_index_locale
    ///
    /// Whether a document used IDBObjectStoreCreateIndexLocale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2667,
            "use.counter.deprecated_ops.doc",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.idbopen_dboptions__storage_type
    ///
    /// Whether a document used IDBOpenDBOptions_StorageType. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2668,
            "use.counter.deprecated_ops.doc",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a document used ImageBitmapRenderingContext_TransferImageBitmap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2669,
            "use.counter.deprecated_ops.doc",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.import_xulinto_content
    ///
    /// Whether a document used ImportXULIntoContent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2670,
            "use.counter.deprecated_ops.doc",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_mouse_event
    ///
    /// Whether a document used InitMouseEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2671,
            "use.counter.deprecated_ops.doc",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.init_nsmouse_event
    ///
    /// Whether a document used InitNSMouseEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2672,
            "use.counter.deprecated_ops.doc",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_deprecated
    ///
    /// Whether a document used InstallTriggerDeprecated. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2673,
            "use.counter.deprecated_ops.doc",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.install_trigger_install_deprecated
    ///
    /// Whether a document used InstallTriggerInstallDeprecated. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2674,
            "use.counter.deprecated_ops.doc",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_setter
    ///
    /// Whether a document used LenientSetter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2675,
            "use.counter.deprecated_ops.doc",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.lenient_this
    ///
    /// Whether a document used LenientThis. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2676,
            "use.counter.deprecated_ops.doc",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_space_value2
    ///
    /// Whether a document used MathML_DeprecatedMathSpaceValue2. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2677,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_math_variant
    ///
    /// Whether a document used MathML_DeprecatedMathVariant. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2678,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a document used MathML_DeprecatedStixgeneralOperatorStretching. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2679,
            "use.counter.deprecated_ops.doc",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.motion_event
    ///
    /// Whether a document used MotionEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2680,
            "use.counter.deprecated_ops.doc",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mouse_event__moz_pressure
    ///
    /// Whether a document used MouseEvent_MozPressure. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2681,
            "use.counter.deprecated_ops.doc",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_input_source
    ///
    /// Whether a document used MozInputSource. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2682,
            "use.counter.deprecated_ops.doc",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a document used MozRequestFullScreenDeprecatedPrefix. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2683,
            "use.counter.deprecated_ops.doc",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenchangeDeprecatedPrefix. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2684,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a document used MozfullscreenerrorDeprecatedPrefix. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2685,
            "use.counter.deprecated_ops.doc",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.navigator_get_user_media
    ///
    /// Whether a document used NavigatorGetUserMedia. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2686,
            "use.counter.deprecated_ops.doc",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.node_iterator_detach
    ///
    /// Whether a document used NodeIteratorDetach. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2687,
            "use.counter.deprecated_ops.doc",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.offscreen_canvas_to_blob
    ///
    /// Whether a document used OffscreenCanvasToBlob. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2688,
            "use.counter.deprecated_ops.doc",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.orientation_event
    ///
    /// Whether a document used OrientationEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2689,
            "use.counter.deprecated_ops.doc",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.proximity_event
    ///
    /// Whether a document used ProximityEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2690,
            "use.counter.deprecated_ops.doc",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.rtcpeer_connection_get_streams
    ///
    /// Whether a document used RTCPeerConnectionGetStreams. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2691,
            "use.counter.deprecated_ops.doc",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgdeselect_all
    ///
    /// Whether a document used SVGDeselectAll. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2692,
            "use.counter.deprecated_ops.doc",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgfarthest_viewport_element
    ///
    /// Whether a document used SVGFarthestViewportElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2693,
            "use.counter.deprecated_ops.doc",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.svgnearest_viewport_element
    ///
    /// Whether a document used SVGNearestViewportElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2694,
            "use.counter.deprecated_ops.doc",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.sync_xmlhttp_request_deprecated
    ///
    /// Whether a document used SyncXMLHttpRequestDeprecated. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2695,
            "use.counter.deprecated_ops.doc",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_capture_events
    ///
    /// Whether a document used UseOfCaptureEvents. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2696,
            "use.counter.deprecated_ops.doc",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.use_of_release_events
    ///
    /// Whether a document used UseOfReleaseEvents. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2697,
            "use.counter.deprecated_ops.doc",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.webrtc_deprecated_prefix
    ///
    /// Whether a document used WebrtcDeprecatedPrefix. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2698,
            "use.counter.deprecated_ops.doc",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window__cc_ontrollers
    ///
    /// Whether a document used Window_Cc_ontrollers. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2699,
            "use.counter.deprecated_ops.doc",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.doc.window_content_untrusted
    ///
    /// Whether a document used WindowContentUntrusted. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2700,
            "use.counter.deprecated_ops.doc",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_deprecated_ops_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.after_script_execute_event
    ///
    /// Whether a page used AfterScriptExecuteEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static after_script_execute_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2701,
            "use.counter.deprecated_ops.page",
            "after_script_execute_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.ambient_light_event
    ///
    /// Whether a page used AmbientLightEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ambient_light_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2702,
            "use.counter.deprecated_ops.page",
            "ambient_light_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.app_cache
    ///
    /// Whether a page used AppCache. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static app_cache: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2703,
            "use.counter.deprecated_ops.page",
            "app_cache",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.before_script_execute_event
    ///
    /// Whether a page used BeforeScriptExecuteEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static before_script_execute_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2704,
            "use.counter.deprecated_ops.page",
            "before_script_execute_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.components
    ///
    /// Whether a page used Components. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static components: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2705,
            "use.counter.deprecated_ops.page",
            "components",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.create_image_bitmap_canvas_rendering_context2_d
    ///
    /// Whether a page used CreateImageBitmapCanvasRenderingContext2D. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static create_image_bitmap_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2706,
            "use.counter.deprecated_ops.page",
            "create_image_bitmap_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_attribute
    ///
    /// Whether a page used DeprecatedTestingAttribute. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_attribute: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2707,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_attribute",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_interface
    ///
    /// Whether a page used DeprecatedTestingInterface. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_interface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2708,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_interface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.deprecated_testing_method
    ///
    /// Whether a page used DeprecatedTestingMethod. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static deprecated_testing_method: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2709,
            "use.counter.deprecated_ops.page",
            "deprecated_testing_method",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.document_release_capture
    ///
    /// Whether a page used DocumentReleaseCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2710,
            "use.counter.deprecated_ops.page",
            "document_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domattr_modified
    ///
    /// Whether a page used DOMAttrModified. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domattr_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2711,
            "use.counter.deprecated_ops.page",
            "domattr_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domcharacter_data_modified
    ///
    /// Whether a page used DOMCharacterDataModified. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domcharacter_data_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2712,
            "use.counter.deprecated_ops.page",
            "domcharacter_data_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted
    ///
    /// Whether a page used DOMNodeInserted. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2713,
            "use.counter.deprecated_ops.page",
            "domnode_inserted",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_inserted_into_document
    ///
    /// Whether a page used DOMNodeInsertedIntoDocument. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_inserted_into_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2714,
            "use.counter.deprecated_ops.page",
            "domnode_inserted_into_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed
    ///
    /// Whether a page used DOMNodeRemoved. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2715,
            "use.counter.deprecated_ops.page",
            "domnode_removed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domnode_removed_from_document
    ///
    /// Whether a page used DOMNodeRemovedFromDocument. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domnode_removed_from_document: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2716,
            "use.counter.deprecated_ops.page",
            "domnode_removed_from_document",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domquad_bounds_attr
    ///
    /// Whether a page used DOMQuadBoundsAttr. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domquad_bounds_attr: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2717,
            "use.counter.deprecated_ops.page",
            "domquad_bounds_attr",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.domsubtree_modified
    ///
    /// Whether a page used DOMSubtreeModified. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domsubtree_modified: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2718,
            "use.counter.deprecated_ops.page",
            "domsubtree_modified",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.draw_window_canvas_rendering_context2_d
    ///
    /// Whether a page used DrawWindowCanvasRenderingContext2D. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static draw_window_canvas_rendering_context2_d: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2719,
            "use.counter.deprecated_ops.page",
            "draw_window_canvas_rendering_context2_d",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_release_capture
    ///
    /// Whether a page used ElementReleaseCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_release_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2720,
            "use.counter.deprecated_ops.page",
            "element_release_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.element_set_capture
    ///
    /// Whether a page used ElementSetCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_set_capture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2721,
            "use.counter.deprecated_ops.page",
            "element_set_capture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.external__add_search_provider
    ///
    /// Whether a page used External_AddSearchProvider. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static external__add_search_provider: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2722,
            "use.counter.deprecated_ops.page",
            "external__add_search_provider",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.form_submission_untrusted_event
    ///
    /// Whether a page used FormSubmissionUntrustedEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static form_submission_untrusted_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2723,
            "use.counter.deprecated_ops.page",
            "form_submission_untrusted_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbobject_store_create_index_locale
    ///
    /// Whether a page used IDBObjectStoreCreateIndexLocale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbobject_store_create_index_locale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2724,
            "use.counter.deprecated_ops.page",
            "idbobject_store_create_index_locale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.idbopen_dboptions__storage_type
    ///
    /// Whether a page used IDBOpenDBOptions_StorageType. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static idbopen_dboptions__storage_type: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2725,
            "use.counter.deprecated_ops.page",
            "idbopen_dboptions__storage_type",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.image_bitmap_rendering_context__transfer_image_bitmap
    ///
    /// Whether a page used ImageBitmapRenderingContext_TransferImageBitmap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static image_bitmap_rendering_context__transfer_image_bitmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2726,
            "use.counter.deprecated_ops.page",
            "image_bitmap_rendering_context__transfer_image_bitmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.import_xulinto_content
    ///
    /// Whether a page used ImportXULIntoContent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static import_xulinto_content: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2727,
            "use.counter.deprecated_ops.page",
            "import_xulinto_content",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_mouse_event
    ///
    /// Whether a page used InitMouseEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_mouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2728,
            "use.counter.deprecated_ops.page",
            "init_mouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.init_nsmouse_event
    ///
    /// Whether a page used InitNSMouseEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static init_nsmouse_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2729,
            "use.counter.deprecated_ops.page",
            "init_nsmouse_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_deprecated
    ///
    /// Whether a page used InstallTriggerDeprecated. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2730,
            "use.counter.deprecated_ops.page",
            "install_trigger_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.install_trigger_install_deprecated
    ///
    /// Whether a page used InstallTriggerInstallDeprecated. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static install_trigger_install_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2731,
            "use.counter.deprecated_ops.page",
            "install_trigger_install_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_setter
    ///
    /// Whether a page used LenientSetter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2732,
            "use.counter.deprecated_ops.page",
            "lenient_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.lenient_this
    ///
    /// Whether a page used LenientThis. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static lenient_this: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2733,
            "use.counter.deprecated_ops.page",
            "lenient_this",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_space_value2
    ///
    /// Whether a page used MathML_DeprecatedMathSpaceValue2. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_space_value2: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2734,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_space_value2",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_math_variant
    ///
    /// Whether a page used MathML_DeprecatedMathVariant. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_math_variant: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2735,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_math_variant",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.math_ml__deprecated_stixgeneral_operator_stretching
    ///
    /// Whether a page used MathML_DeprecatedStixgeneralOperatorStretching. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_ml__deprecated_stixgeneral_operator_stretching: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2736,
            "use.counter.deprecated_ops.page",
            "math_ml__deprecated_stixgeneral_operator_stretching",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.motion_event
    ///
    /// Whether a page used MotionEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static motion_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2737,
            "use.counter.deprecated_ops.page",
            "motion_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mouse_event__moz_pressure
    ///
    /// Whether a page used MouseEvent_MozPressure. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mouse_event__moz_pressure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2738,
            "use.counter.deprecated_ops.page",
            "mouse_event__moz_pressure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_input_source
    ///
    /// Whether a page used MozInputSource. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_input_source: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2739,
            "use.counter.deprecated_ops.page",
            "moz_input_source",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.moz_request_full_screen_deprecated_prefix
    ///
    /// Whether a page used MozRequestFullScreenDeprecatedPrefix. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static moz_request_full_screen_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2740,
            "use.counter.deprecated_ops.page",
            "moz_request_full_screen_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenchange_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenchangeDeprecatedPrefix. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenchange_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2741,
            "use.counter.deprecated_ops.page",
            "mozfullscreenchange_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.mozfullscreenerror_deprecated_prefix
    ///
    /// Whether a page used MozfullscreenerrorDeprecatedPrefix. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mozfullscreenerror_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2742,
            "use.counter.deprecated_ops.page",
            "mozfullscreenerror_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.navigator_get_user_media
    ///
    /// Whether a page used NavigatorGetUserMedia. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_get_user_media: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2743,
            "use.counter.deprecated_ops.page",
            "navigator_get_user_media",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.node_iterator_detach
    ///
    /// Whether a page used NodeIteratorDetach. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static node_iterator_detach: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2744,
            "use.counter.deprecated_ops.page",
            "node_iterator_detach",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.offscreen_canvas_to_blob
    ///
    /// Whether a page used OffscreenCanvasToBlob. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static offscreen_canvas_to_blob: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2745,
            "use.counter.deprecated_ops.page",
            "offscreen_canvas_to_blob",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.orientation_event
    ///
    /// Whether a page used OrientationEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static orientation_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2746,
            "use.counter.deprecated_ops.page",
            "orientation_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.proximity_event
    ///
    /// Whether a page used ProximityEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static proximity_event: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2747,
            "use.counter.deprecated_ops.page",
            "proximity_event",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.rtcpeer_connection_get_streams
    ///
    /// Whether a page used RTCPeerConnectionGetStreams. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static rtcpeer_connection_get_streams: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2748,
            "use.counter.deprecated_ops.page",
            "rtcpeer_connection_get_streams",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgdeselect_all
    ///
    /// Whether a page used SVGDeselectAll. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgdeselect_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2749,
            "use.counter.deprecated_ops.page",
            "svgdeselect_all",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgfarthest_viewport_element
    ///
    /// Whether a page used SVGFarthestViewportElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgfarthest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2750,
            "use.counter.deprecated_ops.page",
            "svgfarthest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.svgnearest_viewport_element
    ///
    /// Whether a page used SVGNearestViewportElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgnearest_viewport_element: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2751,
            "use.counter.deprecated_ops.page",
            "svgnearest_viewport_element",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.sync_xmlhttp_request_deprecated
    ///
    /// Whether a page used SyncXMLHttpRequestDeprecated. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sync_xmlhttp_request_deprecated: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2752,
            "use.counter.deprecated_ops.page",
            "sync_xmlhttp_request_deprecated",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_capture_events
    ///
    /// Whether a page used UseOfCaptureEvents. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_capture_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2753,
            "use.counter.deprecated_ops.page",
            "use_of_capture_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.use_of_release_events
    ///
    /// Whether a page used UseOfReleaseEvents. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static use_of_release_events: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2754,
            "use.counter.deprecated_ops.page",
            "use_of_release_events",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.webrtc_deprecated_prefix
    ///
    /// Whether a page used WebrtcDeprecatedPrefix. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static webrtc_deprecated_prefix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2755,
            "use.counter.deprecated_ops.page",
            "webrtc_deprecated_prefix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window__cc_ontrollers
    ///
    /// Whether a page used Window_Cc_ontrollers. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window__cc_ontrollers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2756,
            "use.counter.deprecated_ops.page",
            "window__cc_ontrollers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.deprecated_ops.page.window_content_untrusted
    ///
    /// Whether a page used WindowContentUntrusted. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_content_untrusted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2757,
            "use.counter.deprecated_ops.page",
            "window_content_untrusted",
            "use-counters"
        )
    });

}
pub mod use_counter_doc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.animation_commitstyles
    ///
    /// Whether a document called called Animation.commitStyles. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static animation_commitstyles: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2758,
            "use.counter.doc",
            "animation_commitstyles",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.commit_styles_non_filling_final_value
    ///
    /// Whether a document calls commitStyles and its result differs depending on whether the endpoint-inclusive pref is enabled or not. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static commit_styles_non_filling_final_value: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2759,
            "use.counter.doc",
            "commit_styles_non_filling_final_value",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.components_shim_resolved
    ///
    /// Whether a document resolves the components shim.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static components_shim_resolved: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2760,
            "use.counter.doc",
            "components_shim_resolved",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_assert
    ///
    /// Whether a document called called console.assert. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2761,
            "use.counter.doc",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_clear
    ///
    /// Whether a document called called console.clear. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2762,
            "use.counter.doc",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_count
    ///
    /// Whether a document called called console.count. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2763,
            "use.counter.doc",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_countreset
    ///
    /// Whether a document called called console.countReset. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2764,
            "use.counter.doc",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_debug
    ///
    /// Whether a document called called console.debug. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2765,
            "use.counter.doc",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dir
    ///
    /// Whether a document called called console.dir. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2766,
            "use.counter.doc",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_dirxml
    ///
    /// Whether a document called called console.dirxml. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2767,
            "use.counter.doc",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_error
    ///
    /// Whether a document called called console.error. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2768,
            "use.counter.doc",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_exception
    ///
    /// Whether a document called called console.exception. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2769,
            "use.counter.doc",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_group
    ///
    /// Whether a document called called console.group. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2770,
            "use.counter.doc",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupcollapsed
    ///
    /// Whether a document called called console.groupCollapsed. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2771,
            "use.counter.doc",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_groupend
    ///
    /// Whether a document called called console.groupEnd. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2772,
            "use.counter.doc",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_info
    ///
    /// Whether a document called called console.info. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2773,
            "use.counter.doc",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_log
    ///
    /// Whether a document called called console.log. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2774,
            "use.counter.doc",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profile
    ///
    /// Whether a document called called console.profile. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2775,
            "use.counter.doc",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_profileend
    ///
    /// Whether a document called called console.profileEnd. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2776,
            "use.counter.doc",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_table
    ///
    /// Whether a document called called console.table. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2777,
            "use.counter.doc",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_time
    ///
    /// Whether a document called called console.time. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2778,
            "use.counter.doc",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timeend
    ///
    /// Whether a document called called console.timeEnd. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2779,
            "use.counter.doc",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timelog
    ///
    /// Whether a document called called console.timeLog. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2780,
            "use.counter.doc",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_timestamp
    ///
    /// Whether a document called called console.timeStamp. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2781,
            "use.counter.doc",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_trace
    ///
    /// Whether a document called called console.trace. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2782,
            "use.counter.doc",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.console_warn
    ///
    /// Whether a document called called console.warn. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2783,
            "use.counter.doc",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.cookiestore_delete
    ///
    /// Whether a document called called CookieStore.delete. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static cookiestore_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2784,
            "use.counter.doc",
            "cookiestore_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.cookiestore_get
    ///
    /// Whether a document called called CookieStore.get. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static cookiestore_get: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2785,
            "use.counter.doc",
            "cookiestore_get",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.cookiestore_getall
    ///
    /// Whether a document called called CookieStore.getAll. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static cookiestore_getall: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2786,
            "use.counter.doc",
            "cookiestore_getall",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.cookiestore_set
    ///
    /// Whether a document called called CookieStore.set. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static cookiestore_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2787,
            "use.counter.doc",
            "cookiestore_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customelementregistry_define
    ///
    /// Whether a document called called CustomElementRegistry.define. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2788,
            "use.counter.doc",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.customized_builtin
    ///
    /// Whether a document registers a customized built-in element. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2789,
            "use.counter.doc",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_addelement
    ///
    /// Whether a document called called DataTransfer.addElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2790,
            "use.counter.doc",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcleardataat
    ///
    /// Whether a document called called DataTransfer.mozClearDataAt. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2791,
            "use.counter.doc",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_getter
    ///
    /// Whether a document got DataTransfer.mozCursor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2792,
            "use.counter.doc",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozcursor_setter
    ///
    /// Whether a document set DataTransfer.mozCursor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2793,
            "use.counter.doc",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozgetdataat
    ///
    /// Whether a document called called DataTransfer.mozGetDataAt. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2794,
            "use.counter.doc",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_getter
    ///
    /// Whether a document got DataTransfer.mozItemCount. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2795,
            "use.counter.doc",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozitemcount_setter
    ///
    /// Whether a document set DataTransfer.mozItemCount. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2796,
            "use.counter.doc",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsetdataat
    ///
    /// Whether a document called called DataTransfer.mozSetDataAt. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2797,
            "use.counter.doc",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_getter
    ///
    /// Whether a document got DataTransfer.mozSourceNode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2798,
            "use.counter.doc",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozsourcenode_setter
    ///
    /// Whether a document set DataTransfer.mozSourceNode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2799,
            "use.counter.doc",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_moztypesat
    ///
    /// Whether a document called called DataTransfer.mozTypesAt. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2800,
            "use.counter.doc",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_getter
    ///
    /// Whether a document got DataTransfer.mozUserCancelled. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2801,
            "use.counter.doc",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.datatransfer_mozusercancelled_setter
    ///
    /// Whether a document set DataTransfer.mozUserCancelled. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2802,
            "use.counter.doc",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_exec_command_content_read_only
    ///
    /// Whether a document calls execCommand with contentReadOnly. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2803,
            "use.counter.doc",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_mozsetimageelement
    ///
    /// Whether a document called called Document.mozSetImageElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2804,
            "use.counter.doc",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_open
    ///
    /// Whether a document calls document.open in a way that creates a new Window object. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2805,
            "use.counter.doc",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with contentReadOnly. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2806,
            "use.counter.doc",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a document calls queryCommandState or queryCommandValue with insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2807,
            "use.counter.doc",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with contentReadOnly. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2808,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a document calls queryCommandSupported or queryCommandEnabled with insertBrOnReturn. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2809,
            "use.counter.doc",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.domparser_parsefromstring
    ///
    /// Whether a document called called DOMParser.parseFromString. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2810,
            "use.counter.doc",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_attachshadow
    ///
    /// Whether a document called called Element.attachShadow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2811,
            "use.counter.doc",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasecapture
    ///
    /// Whether a document called called Element.releaseCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2812,
            "use.counter.doc",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_releasepointercapture
    ///
    /// Whether a document called called Element.releasePointerCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2813,
            "use.counter.doc",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setcapture
    ///
    /// Whether a document called called Element.setCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2814,
            "use.counter.doc",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_sethtml
    ///
    /// Whether a document called called Element.setHTML. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2815,
            "use.counter.doc",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.element_setpointercapture
    ///
    /// Whether a document called called Element.setPointerCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2816,
            "use.counter.doc",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_insec
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from an insecure context. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2817,
            "use.counter.doc",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.enumerate_devices_unfocused
    ///
    /// Whether a document calls MediaDevices.enumerateDevices from a unfocused document. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2818,
            "use.counter.doc",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_blend
    ///
    /// Whether a document uses the feBlend SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2819,
            "use.counter.doc",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_color_matrix
    ///
    /// Whether a document uses the feColorMatrix SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2820,
            "use.counter.doc",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_component_transfer
    ///
    /// Whether a document uses the feComponentTransfer SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2821,
            "use.counter.doc",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_composite
    ///
    /// Whether a document uses the feComposite SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2822,
            "use.counter.doc",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_convolve_matrix
    ///
    /// Whether a document uses the feConvolveMatrix SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2823,
            "use.counter.doc",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_diffuse_lighting
    ///
    /// Whether a document uses the feDiffuseLighting SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2824,
            "use.counter.doc",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_displacement_map
    ///
    /// Whether a document uses the feDisplacementMap SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2825,
            "use.counter.doc",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_flood
    ///
    /// Whether a document uses the feFlood SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2826,
            "use.counter.doc",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_gaussian_blur
    ///
    /// Whether a document uses the feGaussianBlur SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2827,
            "use.counter.doc",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_image
    ///
    /// Whether a document uses the feImage SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2828,
            "use.counter.doc",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_merge
    ///
    /// Whether a document uses the feMerge SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2829,
            "use.counter.doc",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_morphology
    ///
    /// Whether a document uses the feMorphology SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2830,
            "use.counter.doc",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_offset
    ///
    /// Whether a document uses the feOffset SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2831,
            "use.counter.doc",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_specular_lighting
    ///
    /// Whether a document uses the feSpecularLighting SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2832,
            "use.counter.doc",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_tile
    ///
    /// Whether a document uses the feTile SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2833,
            "use.counter.doc",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.fe_turbulence
    ///
    /// Whether a document uses the feTurbulence SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2834,
            "use.counter.doc",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.filtered_cross_origin_iframe
    ///
    /// Whether a document cross-origin <iframe> within a CSS/SVG filter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2835,
            "use.counter.doc",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_insec
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an insecure context. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2836,
            "use.counter.doc",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.get_user_media_unfocused
    ///
    /// Whether a document calls MediaDevices.getUserMedia from an unfocused document. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2837,
            "use.counter.doc",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldialogelement_show
    ///
    /// Whether a document called called HTMLDialogElement.show. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2838,
            "use.counter.doc",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_caretrangefrompoint
    ///
    /// Whether a document called called HTMLDocument.caretRangeFromPoint. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2839,
            "use.counter.doc",
            "htmldocument_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_exitpictureinpicture
    ///
    /// Whether a document called called HTMLDocument.exitPictureInPicture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2840,
            "use.counter.doc",
            "htmldocument_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_featurepolicy
    ///
    /// Whether a document called called HTMLDocument.featurePolicy. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2841,
            "use.counter.doc",
            "htmldocument_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_named_getter_hit
    ///
    /// Whether a document calls to the named getter on HTMLDocument that find something via the name lookup. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2842,
            "use.counter.doc",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onbeforecopy
    ///
    /// Whether a document called called HTMLDocument.onbeforecopy. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2843,
            "use.counter.doc",
            "htmldocument_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onbeforecut
    ///
    /// Whether a document called called HTMLDocument.onbeforecut. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2844,
            "use.counter.doc",
            "htmldocument_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onbeforepaste
    ///
    /// Whether a document called called HTMLDocument.onbeforepaste. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2845,
            "use.counter.doc",
            "htmldocument_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_oncancel
    ///
    /// Whether a document called called HTMLDocument.oncancel. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2846,
            "use.counter.doc",
            "htmldocument_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onfreeze
    ///
    /// Whether a document called called HTMLDocument.onfreeze. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2847,
            "use.counter.doc",
            "htmldocument_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onmousewheel
    ///
    /// Whether a document called called HTMLDocument.onmousewheel. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2848,
            "use.counter.doc",
            "htmldocument_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onresume
    ///
    /// Whether a document called called HTMLDocument.onresume. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2849,
            "use.counter.doc",
            "htmldocument_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onsearch
    ///
    /// Whether a document called called HTMLDocument.onsearch. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2850,
            "use.counter.doc",
            "htmldocument_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onwebkitfullscreenchange
    ///
    /// Whether a document called called HTMLDocument.onwebkitfullscreenchange. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2851,
            "use.counter.doc",
            "htmldocument_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_onwebkitfullscreenerror
    ///
    /// Whether a document called called HTMLDocument.onwebkitfullscreenerror. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2852,
            "use.counter.doc",
            "htmldocument_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_pictureinpictureelement
    ///
    /// Whether a document called called HTMLDocument.pictureInPictureElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2853,
            "use.counter.doc",
            "htmldocument_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_pictureinpictureenabled
    ///
    /// Whether a document called called HTMLDocument.pictureInPictureEnabled. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2854,
            "use.counter.doc",
            "htmldocument_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_registerelement
    ///
    /// Whether a document called called HTMLDocument.registerElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2855,
            "use.counter.doc",
            "htmldocument_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_wasdiscarded
    ///
    /// Whether a document called called HTMLDocument.wasDiscarded. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2856,
            "use.counter.doc",
            "htmldocument_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitcancelfullscreen
    ///
    /// Whether a document called called HTMLDocument.webkitCancelFullScreen. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2857,
            "use.counter.doc",
            "htmldocument_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitcurrentfullscreenelement
    ///
    /// Whether a document called called HTMLDocument.webkitCurrentFullScreenElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2858,
            "use.counter.doc",
            "htmldocument_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitexitfullscreen
    ///
    /// Whether a document called called HTMLDocument.webkitExitFullscreen. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2859,
            "use.counter.doc",
            "htmldocument_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitfullscreenelement
    ///
    /// Whether a document called called HTMLDocument.webkitFullscreenElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2860,
            "use.counter.doc",
            "htmldocument_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitfullscreenenabled
    ///
    /// Whether a document called called HTMLDocument.webkitFullscreenEnabled. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2861,
            "use.counter.doc",
            "htmldocument_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkithidden
    ///
    /// Whether a document called called HTMLDocument.webkitHidden. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2862,
            "use.counter.doc",
            "htmldocument_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitisfullscreen
    ///
    /// Whether a document called called HTMLDocument.webkitIsFullScreen. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2863,
            "use.counter.doc",
            "htmldocument_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_webkitvisibilitystate
    ///
    /// Whether a document called called HTMLDocument.webkitVisibilityState. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2864,
            "use.counter.doc",
            "htmldocument_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_xmlencoding
    ///
    /// Whether a document called called HTMLDocument.xmlEncoding. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2865,
            "use.counter.doc",
            "htmldocument_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_xmlstandalone
    ///
    /// Whether a document called called HTMLDocument.xmlStandalone. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2866,
            "use.counter.doc",
            "htmldocument_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.htmldocument_xmlversion
    ///
    /// Whether a document called called HTMLDocument.xmlVersion. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2867,
            "use.counter.doc",
            "htmldocument_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.invalid_text_directives
    ///
    /// Whether a document had a text fragment that could not be found after loading has finished. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static invalid_text_directives: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2868,
            "use.counter.doc",
            "invalid_text_directives",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_asmjs
    ///
    /// Whether a document uses asm.js. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2869,
            "use.counter.doc",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_dateparse
    ///
    /// Whether a document called Date.parse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_dateparse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2870,
            "use.counter.doc",
            "js_dateparse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_dateparse_impl_def
    ///
    /// Whether a document call to Date.parse used implementation defined behaviour. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_dateparse_impl_def: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2871,
            "use.counter.doc",
            "js_dateparse_impl_def",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_errorstack_getter
    ///
    /// Whether a document called error.stack getter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2872,
            "use.counter.doc",
            "js_errorstack_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_errorstack_getter_no_errordata
    ///
    /// Whether a document called error.stack getter on object without ErrorData internal slot. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_getter_no_errordata: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2873,
            "use.counter.doc",
            "js_errorstack_getter_no_errordata",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_errorstack_setter
    ///
    /// Whether a document called error.stack setter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2874,
            "use.counter.doc",
            "js_errorstack_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_errorstack_setter_no_errordata
    ///
    /// Whether a document called error.stack setter on object without ErrorData internal slot. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter_no_errordata: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2875,
            "use.counter.doc",
            "js_errorstack_setter_no_errordata",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_errorstack_setter_nonstring
    ///
    /// Whether a document called error.stack setter with non-string input. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter_nonstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2876,
            "use.counter.doc",
            "js_errorstack_setter_nonstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_ic_stub_oom
    ///
    /// Whether a document OOMed while creating IC stub. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_ic_stub_oom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2877,
            "use.counter.doc",
            "js_ic_stub_oom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_ic_stub_too_large
    ///
    /// Whether a document tried to create an IC stub that was too large. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_ic_stub_too_large: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2878,
            "use.counter.doc",
            "js_ic_stub_too_large",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_is_htmldda_fuse
    ///
    /// Whether a document has used the document.all getter (popping the EmulatesUndefined Fuse). Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_is_htmldda_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2879,
            "use.counter.doc",
            "js_is_htmldda_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_legacy_lang_subtag
    ///
    /// Whether a document uses a 5-to-8-character language subtag in Intl.Locale constructor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_legacy_lang_subtag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2880,
            "use.counter.doc",
            "js_legacy_lang_subtag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_optimize_array_species_fuse
    ///
    /// Whether a document has modified builtin Array objects such that the ArraySpecies fuse is popped. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_optimize_array_species_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2881,
            "use.counter.doc",
            "js_optimize_array_species_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_optimize_get_iterator_fuse
    ///
    /// Whether a document has modified any builtins such that the GetIterator fuse is popped. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_optimize_get_iterator_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2882,
            "use.counter.doc",
            "js_optimize_get_iterator_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_optimize_promise_lookup_fuse
    ///
    /// Whether a document has modified builtin Promise objects such that the PromiseLookup fuse is popped. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_optimize_promise_lookup_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2883,
            "use.counter.doc",
            "js_optimize_promise_lookup_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_regexp_symbol_protocol_on_primitive
    ///
    /// Whether a document passed a primitive with a custom implementation of the regexp protocol symbols to one of the String methods that accept a regexp. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_regexp_symbol_protocol_on_primitive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2884,
            "use.counter.doc",
            "js_regexp_symbol_protocol_on_primitive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_thenable
    ///
    /// Whether a document resolved a promise using thenable support rather than builtin methods. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_thenable: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2885,
            "use.counter.doc",
            "js_thenable",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_thenable_object_proto
    ///
    /// Whether a document resolved a promise using thenable on a realms Object.prototype. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_thenable_object_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2886,
            "use.counter.doc",
            "js_thenable_object_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_thenable_proto
    ///
    /// Whether a document resolved a promise using thenable on prototype. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_thenable_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2887,
            "use.counter.doc",
            "js_thenable_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_thenable_standard_proto
    ///
    /// Whether a document resolved a promise using thenable on a standard prototype. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_thenable_standard_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2888,
            "use.counter.doc",
            "js_thenable_standard_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm
    ///
    /// Whether a document uses WebAssembly. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2889,
            "use.counter.doc",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.js_wasm_legacy_exceptions
    ///
    /// Whether a document uses WebAssembly legacy exception-handling. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2890,
            "use.counter.doc",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.location_ancestororigins
    ///
    /// Whether a document called called Location.ancestorOrigins. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2891,
            "use.counter.doc",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.math_mlused
    ///
    /// Whether a document has used MathML. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static math_mlused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2892,
            "use.counter.doc",
            "math_mlused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_enumeratedevices
    ///
    /// Whether a document called called MediaDevices.enumerateDevices. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2893,
            "use.counter.doc",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getdisplaymedia
    ///
    /// Whether a document called called MediaDevices.getDisplayMedia. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2894,
            "use.counter.doc",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mediadevices_getusermedia
    ///
    /// Whether a document called called MediaDevices.getUserMedia. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2895,
            "use.counter.doc",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2896,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2897,
            "use.counter.doc",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2898,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2899,
            "use.counter.doc",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2900,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_not_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2901,
            "use.counter.doc",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_failure
    ///
    /// Whether a document includes a mixed content audio element that does not load.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2902,
            "use.counter.doc",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_audio_success
    ///
    /// Whether a document includes a mixed content audio element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2903,
            "use.counter.doc",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_failure
    ///
    /// Whether a document includes a mixed content img element that does not load.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2904,
            "use.counter.doc",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_image_success
    ///
    /// Whether a document includes a mixed content img element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2905,
            "use.counter.doc",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_failure
    ///
    /// Whether a document includes a mixed content video element that does not laod.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2906,
            "use.counter.doc",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mixed_content_upgraded_video_success
    ///
    /// Whether a document includes a mixed content video element that loads.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2907,
            "use.counter.doc",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_deriveexporter
    ///
    /// Whether a document called called MLS.deriveExporter. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_deriveexporter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2908,
            "use.counter.doc",
            "mls_deriveexporter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_generatecredentialbasic
    ///
    /// Whether a document called called MLS.generateCredentialBasic. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_generatecredentialbasic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2909,
            "use.counter.doc",
            "mls_generatecredentialbasic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_generatekeypackage
    ///
    /// Whether a document called called MLS.generateKeyPackage. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_generatekeypackage: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2910,
            "use.counter.doc",
            "mls_generatekeypackage",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_generatesignaturekeypair
    ///
    /// Whether a document called called MLS.generateSignatureKeypair. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_generatesignaturekeypair: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2911,
            "use.counter.doc",
            "mls_generatesignaturekeypair",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupadd
    ///
    /// Whether a document called called MLS.groupAdd. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2912,
            "use.counter.doc",
            "mls_groupadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupclose
    ///
    /// Whether a document called called MLS.groupClose. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupclose: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2913,
            "use.counter.doc",
            "mls_groupclose",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupcreate
    ///
    /// Whether a document called called MLS.groupCreate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupcreate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2914,
            "use.counter.doc",
            "mls_groupcreate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupjoin
    ///
    /// Whether a document called called MLS.groupJoin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupjoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2915,
            "use.counter.doc",
            "mls_groupjoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupmembers
    ///
    /// Whether a document called called MLS.groupMembers. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupmembers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2916,
            "use.counter.doc",
            "mls_groupmembers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupproposeadd
    ///
    /// Whether a document called called MLS.groupProposeAdd. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupproposeadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2917,
            "use.counter.doc",
            "mls_groupproposeadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupproposeremove
    ///
    /// Whether a document called called MLS.groupProposeRemove. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupproposeremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2918,
            "use.counter.doc",
            "mls_groupproposeremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_groupremove
    ///
    /// Whether a document called called MLS.groupRemove. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_groupremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2919,
            "use.counter.doc",
            "mls_groupremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_receive
    ///
    /// Whether a document called called MLS.receive. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_receive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2920,
            "use.counter.doc",
            "mls_receive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_send
    ///
    /// Whether a document called called MLS.send. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2921,
            "use.counter.doc",
            "mls_send",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_statedelete
    ///
    /// Whether a document called called MLS.stateDelete. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_statedelete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2922,
            "use.counter.doc",
            "mls_statedelete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.mls_statedeletegroup
    ///
    /// Whether a document called called MLS.stateDeleteGroup. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static mls_statedeletegroup: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2923,
            "use.counter.doc",
            "mls_statedeletegroup",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.navigator_mozgetusermedia
    ///
    /// Whether a document called called Navigator.mozGetUserMedia. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2924,
            "use.counter.doc",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.ondommousescroll
    ///
    /// Whether a document sets DOMMouseScroll event listener. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2925,
            "use.counter.doc",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.onmozmousepixelscroll
    ///
    /// Whether a document sets MozMousePixelScroll event listener. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2926,
            "use.counter.doc",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svg
    ///
    /// Whether a document whether percentage stroke-width is used in SVG elements (excluding <text>). Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2927,
            "use.counter.doc",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.percentage_stroke_width_in_svgtext
    ///
    /// Whether a document whether percentage stroke-width is used in SVG <text>. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2928,
            "use.counter.doc",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_delete
    ///
    /// Whether a document calls caches.delete in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2929,
            "use.counter.doc",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_has
    ///
    /// Whether a document calls caches.has in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2930,
            "use.counter.doc",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_keys
    ///
    /// Whether a document calls caches.keys in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2931,
            "use.counter.doc",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_match
    ///
    /// Whether a document calls caches.match in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2932,
            "use.counter.doc",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_caches_open
    ///
    /// Whether a document calls caches.open in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2933,
            "use.counter.doc",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_delete_database
    ///
    /// Whether a document calls indexedDB.deleteDatabase in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2934,
            "use.counter.doc",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_idbfactory_open
    ///
    /// Whether a document calls indexedDB.open in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2935,
            "use.counter.doc",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.private_browsing_navigator_service_worker
    ///
    /// Whether a document accesses navigator.serviceWorker in Private Browsing Mode. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2936,
            "use.counter.doc",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushmanager_subscribe
    ///
    /// Whether a document called called PushManager.subscribe. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2937,
            "use.counter.doc",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.pushsubscription_unsubscribe
    ///
    /// Whether a document called called PushSubscription.unsubscribe. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2938,
            "use.counter.doc",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.range_createcontextualfragment
    ///
    /// Whether a document called called Range.createContextualFragment. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2939,
            "use.counter.doc",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_constructor
    ///
    /// Whether a document called called Sanitizer.constructor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2940,
            "use.counter.doc",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sanitizer_sanitize
    ///
    /// Whether a document called called Sanitizer.sanitize. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2941,
            "use.counter.doc",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.scheduler_posttask
    ///
    /// Whether a document called called Scheduler.postTask. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2942,
            "use.counter.doc",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.sectioning_h1_with_no_font_size_or_margins
    ///
    /// Whether a document found sectioned h1 element with no font-size or no margins. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static sectioning_h1_with_no_font_size_or_margins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2943,
            "use.counter.doc",
            "sectioning_h1_with_no_font_size_or_margins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_getter
    ///
    /// Whether a document got SVGSVGElement.currentScale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2944,
            "use.counter.doc",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_currentscale_setter
    ///
    /// Whether a document set SVGSVGElement.currentScale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2945,
            "use.counter.doc",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.svgsvgelement_getelementbyid
    ///
    /// Whether a document called called SVGSVGElement.getElementById. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2946,
            "use.counter.doc",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.text_directive_not_created
    ///
    /// Whether a document has not succeeded in creating a text fragment. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static text_directive_not_created: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2947,
            "use.counter.doc",
            "text_directive_not_created",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.text_directive_pages
    ///
    /// Whether a document used text fragments. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static text_directive_pages: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2948,
            "use.counter.doc",
            "text_directive_pages",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_absoluteorientationsensor
    ///
    /// Whether a document called called Window.AbsoluteOrientationSensor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2949,
            "use.counter.doc",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_accelerometer
    ///
    /// Whether a document called called Window.Accelerometer. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2950,
            "use.counter.doc",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchmanager
    ///
    /// Whether a document called called Window.BackgroundFetchManager. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2951,
            "use.counter.doc",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchrecord
    ///
    /// Whether a document called called Window.BackgroundFetchRecord. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2952,
            "use.counter.doc",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_backgroundfetchregistration
    ///
    /// Whether a document called called Window.BackgroundFetchRegistration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2953,
            "use.counter.doc",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_beforeinstallpromptevent
    ///
    /// Whether a document called called Window.BeforeInstallPromptEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2954,
            "use.counter.doc",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetooth
    ///
    /// Whether a document called called Window.Bluetooth. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2955,
            "use.counter.doc",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothcharacteristicproperties
    ///
    /// Whether a document called called Window.BluetoothCharacteristicProperties. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2956,
            "use.counter.doc",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothdevice
    ///
    /// Whether a document called called Window.BluetoothDevice. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2957,
            "use.counter.doc",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTCharacteristic. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2958,
            "use.counter.doc",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattdescriptor
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTDescriptor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2959,
            "use.counter.doc",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattserver
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTServer. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2960,
            "use.counter.doc",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothremotegattservice
    ///
    /// Whether a document called called Window.BluetoothRemoteGATTService. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2961,
            "use.counter.doc",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_bluetoothuuid
    ///
    /// Whether a document called called Window.BluetoothUUID. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2962,
            "use.counter.doc",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_canvascapturemediastreamtrack
    ///
    /// Whether a document called called Window.CanvasCaptureMediaStreamTrack. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2963,
            "use.counter.doc",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_chrome
    ///
    /// Whether a document called called Window.chrome. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2964,
            "use.counter.doc",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_clipboarditem
    ///
    /// Whether a document called called Window.ClipboardItem. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2965,
            "use.counter.doc",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssimagevalue
    ///
    /// Whether a document called called Window.CSSImageValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2966,
            "use.counter.doc",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csskeywordvalue
    ///
    /// Whether a document called called Window.CSSKeywordValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2967,
            "use.counter.doc",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathclamp
    ///
    /// Whether a document called called Window.CSSMathClamp. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2968,
            "use.counter.doc",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathinvert
    ///
    /// Whether a document called called Window.CSSMathInvert. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2969,
            "use.counter.doc",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmax
    ///
    /// Whether a document called called Window.CSSMathMax. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2970,
            "use.counter.doc",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathmin
    ///
    /// Whether a document called called Window.CSSMathMin. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2971,
            "use.counter.doc",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathnegate
    ///
    /// Whether a document called called Window.CSSMathNegate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2972,
            "use.counter.doc",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathproduct
    ///
    /// Whether a document called called Window.CSSMathProduct. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2973,
            "use.counter.doc",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathsum
    ///
    /// Whether a document called called Window.CSSMathSum. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2974,
            "use.counter.doc",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmathvalue
    ///
    /// Whether a document called called Window.CSSMathValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2975,
            "use.counter.doc",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssmatrixcomponent
    ///
    /// Whether a document called called Window.CSSMatrixComponent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2976,
            "use.counter.doc",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericarray
    ///
    /// Whether a document called called Window.CSSNumericArray. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2977,
            "use.counter.doc",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssnumericvalue
    ///
    /// Whether a document called called Window.CSSNumericValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2978,
            "use.counter.doc",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssperspective
    ///
    /// Whether a document called called Window.CSSPerspective. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2979,
            "use.counter.doc",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspositionvalue
    ///
    /// Whether a document called called Window.CSSPositionValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2980,
            "use.counter.doc",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csspropertyrule
    ///
    /// Whether a document called called Window.CSSPropertyRule. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2981,
            "use.counter.doc",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssrotate
    ///
    /// Whether a document called called Window.CSSRotate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2982,
            "use.counter.doc",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssscale
    ///
    /// Whether a document called called Window.CSSScale. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2983,
            "use.counter.doc",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskew
    ///
    /// Whether a document called called Window.CSSSkew. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2984,
            "use.counter.doc",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewx
    ///
    /// Whether a document called called Window.CSSSkewX. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2985,
            "use.counter.doc",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssskewy
    ///
    /// Whether a document called called Window.CSSSkewY. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2986,
            "use.counter.doc",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssstylevalue
    ///
    /// Whether a document called called Window.CSSStyleValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2987,
            "use.counter.doc",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformcomponent
    ///
    /// Whether a document called called Window.CSSTransformComponent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2988,
            "use.counter.doc",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstransformvalue
    ///
    /// Whether a document called called Window.CSSTransformValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2989,
            "use.counter.doc",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_csstranslate
    ///
    /// Whether a document called called Window.CSSTranslate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2990,
            "use.counter.doc",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunitvalue
    ///
    /// Whether a document called called Window.CSSUnitValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2991,
            "use.counter.doc",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssunparsedvalue
    ///
    /// Whether a document called called Window.CSSUnparsedValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2992,
            "use.counter.doc",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_cssvariablereferencevalue
    ///
    /// Whether a document called called Window.CSSVariableReferenceValue. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2993,
            "use.counter.doc",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_defaultstatus
    ///
    /// Whether a document called called Window.defaultStatus. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2994,
            "use.counter.doc",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventacceleration
    ///
    /// Whether a document called called Window.DeviceMotionEventAcceleration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2995,
            "use.counter.doc",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_devicemotioneventrotationrate
    ///
    /// Whether a document called called Window.DeviceMotionEventRotationRate. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2996,
            "use.counter.doc",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_domerror
    ///
    /// Whether a document called called Window.DOMError. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2997,
            "use.counter.doc",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_encodedvideochunk
    ///
    /// Whether a document called called Window.EncodedVideoChunk. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2998,
            "use.counter.doc",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_enterpictureinpictureevent
    ///
    /// Whether a document called called Window.EnterPictureInPictureEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            2999,
            "use.counter.doc",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_external
    ///
    /// Whether a document called called Window.External. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3000,
            "use.counter.doc",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_federatedcredential
    ///
    /// Whether a document called called Window.FederatedCredential. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3001,
            "use.counter.doc",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_gyroscope
    ///
    /// Whether a document called called Window.Gyroscope. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3002,
            "use.counter.doc",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlcontentelement
    ///
    /// Whether a document called called Window.HTMLContentElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3003,
            "use.counter.doc",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_htmlshadowelement
    ///
    /// Whether a document called called Window.HTMLShadowElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3004,
            "use.counter.doc",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_imagecapture
    ///
    /// Whether a document called called Window.ImageCapture. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3005,
            "use.counter.doc",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdevicecapabilities
    ///
    /// Whether a document called called Window.InputDeviceCapabilities. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3006,
            "use.counter.doc",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_inputdeviceinfo
    ///
    /// Whether a document called called Window.InputDeviceInfo. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3007,
            "use.counter.doc",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboard
    ///
    /// Whether a document called called Window.Keyboard. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3008,
            "use.counter.doc",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_keyboardlayoutmap
    ///
    /// Whether a document called called Window.KeyboardLayoutMap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3009,
            "use.counter.doc",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_linearaccelerationsensor
    ///
    /// Whether a document called called Window.LinearAccelerationSensor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3010,
            "use.counter.doc",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_mediasettingsrange
    ///
    /// Whether a document called called Window.MediaSettingsRange. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3011,
            "use.counter.doc",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiaccess
    ///
    /// Whether a document called called Window.MIDIAccess. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3012,
            "use.counter.doc",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiconnectionevent
    ///
    /// Whether a document called called Window.MIDIConnectionEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3013,
            "use.counter.doc",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinput
    ///
    /// Whether a document called called Window.MIDIInput. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3014,
            "use.counter.doc",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiinputmap
    ///
    /// Whether a document called called Window.MIDIInputMap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3015,
            "use.counter.doc",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midimessageevent
    ///
    /// Whether a document called called Window.MIDIMessageEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3016,
            "use.counter.doc",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutput
    ///
    /// Whether a document called called Window.MIDIOutput. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3017,
            "use.counter.doc",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midioutputmap
    ///
    /// Whether a document called called Window.MIDIOutputMap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3018,
            "use.counter.doc",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_midiport
    ///
    /// Whether a document called called Window.MIDIPort. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3019,
            "use.counter.doc",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_networkinformation
    ///
    /// Whether a document called called Window.NetworkInformation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3020,
            "use.counter.doc",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_offscreenbuffering
    ///
    /// Whether a document called called Window.offscreenBuffering. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3021,
            "use.counter.doc",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onbeforeinstallprompt
    ///
    /// Whether a document called called Window.onbeforeinstallprompt. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3022,
            "use.counter.doc",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_oncancel
    ///
    /// Whether a document called called Window.oncancel. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3023,
            "use.counter.doc",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onmousewheel
    ///
    /// Whether a document called called Window.onmousewheel. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3024,
            "use.counter.doc",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onorientationchange
    ///
    /// Whether a document called called Window.onorientationchange. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3025,
            "use.counter.doc",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onsearch
    ///
    /// Whether a document called called Window.onsearch. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3026,
            "use.counter.doc",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_onselectionchange
    ///
    /// Whether a document called called Window.onselectionchange. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3027,
            "use.counter.doc",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_open_empty_url
    ///
    /// Whether a document calls window.open with an empty url argument. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3028,
            "use.counter.doc",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_opendatabase
    ///
    /// Whether a document called called Window.openDatabase. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3029,
            "use.counter.doc",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientation
    ///
    /// Whether a document called called Window.orientation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3030,
            "use.counter.doc",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_orientationsensor
    ///
    /// Whether a document called called Window.OrientationSensor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3031,
            "use.counter.doc",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_overconstrainederror
    ///
    /// Whether a document called called Window.OverconstrainedError. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3032,
            "use.counter.doc",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_passwordcredential
    ///
    /// Whether a document called called Window.PasswordCredential. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3033,
            "use.counter.doc",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentaddress
    ///
    /// Whether a document called called Window.PaymentAddress. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3034,
            "use.counter.doc",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentinstruments
    ///
    /// Whether a document called called Window.PaymentInstruments. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3035,
            "use.counter.doc",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmanager
    ///
    /// Whether a document called called Window.PaymentManager. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3036,
            "use.counter.doc",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentmethodchangeevent
    ///
    /// Whether a document called called Window.PaymentMethodChangeEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3037,
            "use.counter.doc",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequest
    ///
    /// Whether a document called called Window.PaymentRequest. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3038,
            "use.counter.doc",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentrequestupdateevent
    ///
    /// Whether a document called called Window.PaymentRequestUpdateEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3039,
            "use.counter.doc",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_paymentresponse
    ///
    /// Whether a document called called Window.PaymentResponse. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3040,
            "use.counter.doc",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_performancelongtasktiming
    ///
    /// Whether a document called called Window.PerformanceLongTaskTiming. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3041,
            "use.counter.doc",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_photocapabilities
    ///
    /// Whether a document called called Window.PhotoCapabilities. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3042,
            "use.counter.doc",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpictureevent
    ///
    /// Whether a document called called Window.PictureInPictureEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3043,
            "use.counter.doc",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_pictureinpicturewindow
    ///
    /// Whether a document called called Window.PictureInPictureWindow. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3044,
            "use.counter.doc",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentation
    ///
    /// Whether a document called called Window.Presentation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3045,
            "use.counter.doc",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationavailability
    ///
    /// Whether a document called called Window.PresentationAvailability. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3046,
            "use.counter.doc",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnection
    ///
    /// Whether a document called called Window.PresentationConnection. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3047,
            "use.counter.doc",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionavailableevent
    ///
    /// Whether a document called called Window.PresentationConnectionAvailableEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3048,
            "use.counter.doc",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectioncloseevent
    ///
    /// Whether a document called called Window.PresentationConnectionCloseEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3049,
            "use.counter.doc",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationconnectionlist
    ///
    /// Whether a document called called Window.PresentationConnectionList. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3050,
            "use.counter.doc",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationreceiver
    ///
    /// Whether a document called called Window.PresentationReceiver. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3051,
            "use.counter.doc",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_presentationrequest
    ///
    /// Whether a document called called Window.PresentationRequest. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3052,
            "use.counter.doc",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_relativeorientationsensor
    ///
    /// Whether a document called called Window.RelativeOrientationSensor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3053,
            "use.counter.doc",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_remoteplayback
    ///
    /// Whether a document called called Window.RemotePlayback. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3054,
            "use.counter.doc",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_report
    ///
    /// Whether a document called called Window.Report. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3055,
            "use.counter.doc",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportbody
    ///
    /// Whether a document called called Window.ReportBody. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3056,
            "use.counter.doc",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_reportingobserver
    ///
    /// Whether a document called called Window.ReportingObserver. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3057,
            "use.counter.doc",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerror
    ///
    /// Whether a document called called Window.RTCError. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3058,
            "use.counter.doc",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcerrorevent
    ///
    /// Whether a document called called Window.RTCErrorEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3059,
            "use.counter.doc",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcicetransport
    ///
    /// Whether a document called called Window.RTCIceTransport. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3060,
            "use.counter.doc",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a document called called Window.RTCPeerConnectionIceErrorEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3061,
            "use.counter.doc",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensor
    ///
    /// Whether a document called called Window.Sensor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3062,
            "use.counter.doc",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sensorerrorevent
    ///
    /// Whether a document called called Window.SensorErrorEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3063,
            "use.counter.doc",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_getter
    ///
    /// Whether a document got Window.sidebar. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3064,
            "use.counter.doc",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_sidebar_setter
    ///
    /// Whether a document set Window.sidebar. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3065,
            "use.counter.doc",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionalternative
    ///
    /// Whether a document called called Window.SpeechRecognitionAlternative. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3066,
            "use.counter.doc",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresult
    ///
    /// Whether a document called called Window.SpeechRecognitionResult. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3067,
            "use.counter.doc",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_speechrecognitionresultlist
    ///
    /// Whether a document called called Window.SpeechRecognitionResultList. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3068,
            "use.counter.doc",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylemedia
    ///
    /// Whether a document called called Window.styleMedia. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3069,
            "use.counter.doc",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymap
    ///
    /// Whether a document called called Window.StylePropertyMap. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3070,
            "use.counter.doc",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_stylepropertymapreadonly
    ///
    /// Whether a document called called Window.StylePropertyMapReadOnly. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3071,
            "use.counter.doc",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_svgdiscardelement
    ///
    /// Whether a document called called Window.SVGDiscardElement. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3072,
            "use.counter.doc",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_syncmanager
    ///
    /// Whether a document called called Window.SyncManager. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3073,
            "use.counter.doc",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_taskattributiontiming
    ///
    /// Whether a document called called Window.TaskAttributionTiming. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3074,
            "use.counter.doc",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_textevent
    ///
    /// Whether a document called called Window.TextEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3075,
            "use.counter.doc",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touch
    ///
    /// Whether a document called called Window.Touch. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3076,
            "use.counter.doc",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchevent
    ///
    /// Whether a document called called Window.TouchEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3077,
            "use.counter.doc",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_touchlist
    ///
    /// Whether a document called called Window.TouchList. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3078,
            "use.counter.doc",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usb
    ///
    /// Whether a document called called Window.USB. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3079,
            "use.counter.doc",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbalternateinterface
    ///
    /// Whether a document called called Window.USBAlternateInterface. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3080,
            "use.counter.doc",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconfiguration
    ///
    /// Whether a document called called Window.USBConfiguration. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3081,
            "use.counter.doc",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbconnectionevent
    ///
    /// Whether a document called called Window.USBConnectionEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3082,
            "use.counter.doc",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbdevice
    ///
    /// Whether a document called called Window.USBDevice. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3083,
            "use.counter.doc",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbendpoint
    ///
    /// Whether a document called called Window.USBEndpoint. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3084,
            "use.counter.doc",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbinterface
    ///
    /// Whether a document called called Window.USBInterface. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3085,
            "use.counter.doc",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbintransferresult
    ///
    /// Whether a document called called Window.USBInTransferResult. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3086,
            "use.counter.doc",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousInTransferPacket. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3087,
            "use.counter.doc",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousintransferresult
    ///
    /// Whether a document called called Window.USBIsochronousInTransferResult. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3088,
            "use.counter.doc",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferpacket
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferPacket. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3089,
            "use.counter.doc",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbisochronousouttransferresult
    ///
    /// Whether a document called called Window.USBIsochronousOutTransferResult. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3090,
            "use.counter.doc",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_usbouttransferresult
    ///
    /// Whether a document called called Window.USBOutTransferResult. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3091,
            "use.counter.doc",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_useractivation
    ///
    /// Whether a document called called Window.UserActivation. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3092,
            "use.counter.doc",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videocolorspace
    ///
    /// Whether a document called called Window.VideoColorSpace. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3093,
            "use.counter.doc",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videodecoder
    ///
    /// Whether a document called called Window.VideoDecoder. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3094,
            "use.counter.doc",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoencoder
    ///
    /// Whether a document called called Window.VideoEncoder. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3095,
            "use.counter.doc",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_videoframe
    ///
    /// Whether a document called called Window.VideoFrame. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3096,
            "use.counter.doc",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelock
    ///
    /// Whether a document called called Window.WakeLock. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3097,
            "use.counter.doc",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_wakelocksentinel
    ///
    /// Whether a document called called Window.WakeLockSentinel. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3098,
            "use.counter.doc",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitcancelanimationframe
    ///
    /// Whether a document called called Window.webkitCancelAnimationFrame. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3099,
            "use.counter.doc",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmediastream
    ///
    /// Whether a document called called Window.webkitMediaStream. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3100,
            "use.counter.doc",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitmutationobserver
    ///
    /// Whether a document called called Window.WebKitMutationObserver. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3101,
            "use.counter.doc",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestanimationframe
    ///
    /// Whether a document called called Window.webkitRequestAnimationFrame. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3102,
            "use.counter.doc",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrequestfilesystem
    ///
    /// Whether a document called called Window.webkitRequestFileSystem. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3103,
            "use.counter.doc",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a document called called Window.webkitResolveLocalFileSystemURL. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3104,
            "use.counter.doc",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitrtcpeerconnection
    ///
    /// Whether a document called called Window.webkitRTCPeerConnection. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3105,
            "use.counter.doc",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammar
    ///
    /// Whether a document called called Window.webkitSpeechGrammar. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3106,
            "use.counter.doc",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechgrammarlist
    ///
    /// Whether a document called called Window.webkitSpeechGrammarList. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3107,
            "use.counter.doc",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognition
    ///
    /// Whether a document called called Window.webkitSpeechRecognition. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3108,
            "use.counter.doc",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionerror
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionError. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3109,
            "use.counter.doc",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitspeechrecognitionevent
    ///
    /// Whether a document called called Window.webkitSpeechRecognitionEvent. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3110,
            "use.counter.doc",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.window_webkitstorageinfo
    ///
    /// Whether a document called called Window.webkitStorageInfo. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3111,
            "use.counter.doc",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.wr_filter_fallback
    ///
    /// Whether a document triggers the blob fallback for an SVG filter.. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3112,
            "use.counter.doc",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xslstylesheet
    ///
    /// Whether a document uses an XSL Stylesheet. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3113,
            "use.counter.doc",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.xsltprocessor_constructor
    ///
    /// Whether a document called called XSLTProcessor.constructor. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3114,
            "use.counter.doc",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.doc.you_tube_flash_embed
    ///
    /// Whether a document in <object> or <embed>. Compare against `use.counter.content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3115,
            "use.counter.doc",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.animation_commitstyles
    ///
    /// Whether a page called called Animation.commitStyles. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static animation_commitstyles: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3116,
            "use.counter.page",
            "animation_commitstyles",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.commit_styles_non_filling_final_value
    ///
    /// Whether a page calls commitStyles and its result differs depending on whether the endpoint-inclusive pref is enabled or not. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static commit_styles_non_filling_final_value: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3117,
            "use.counter.page",
            "commit_styles_non_filling_final_value",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.components_shim_resolved
    ///
    /// Whether a page resolves the components shim.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static components_shim_resolved: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3118,
            "use.counter.page",
            "components_shim_resolved",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_assert
    ///
    /// Whether a page called called console.assert. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3119,
            "use.counter.page",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_clear
    ///
    /// Whether a page called called console.clear. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3120,
            "use.counter.page",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_count
    ///
    /// Whether a page called called console.count. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3121,
            "use.counter.page",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_countreset
    ///
    /// Whether a page called called console.countReset. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3122,
            "use.counter.page",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_debug
    ///
    /// Whether a page called called console.debug. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3123,
            "use.counter.page",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dir
    ///
    /// Whether a page called called console.dir. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3124,
            "use.counter.page",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_dirxml
    ///
    /// Whether a page called called console.dirxml. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3125,
            "use.counter.page",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_error
    ///
    /// Whether a page called called console.error. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3126,
            "use.counter.page",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_exception
    ///
    /// Whether a page called called console.exception. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3127,
            "use.counter.page",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_group
    ///
    /// Whether a page called called console.group. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3128,
            "use.counter.page",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupcollapsed
    ///
    /// Whether a page called called console.groupCollapsed. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3129,
            "use.counter.page",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_groupend
    ///
    /// Whether a page called called console.groupEnd. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3130,
            "use.counter.page",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_info
    ///
    /// Whether a page called called console.info. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3131,
            "use.counter.page",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_log
    ///
    /// Whether a page called called console.log. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3132,
            "use.counter.page",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profile
    ///
    /// Whether a page called called console.profile. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3133,
            "use.counter.page",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_profileend
    ///
    /// Whether a page called called console.profileEnd. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3134,
            "use.counter.page",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_table
    ///
    /// Whether a page called called console.table. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3135,
            "use.counter.page",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_time
    ///
    /// Whether a page called called console.time. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3136,
            "use.counter.page",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timeend
    ///
    /// Whether a page called called console.timeEnd. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3137,
            "use.counter.page",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timelog
    ///
    /// Whether a page called called console.timeLog. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3138,
            "use.counter.page",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_timestamp
    ///
    /// Whether a page called called console.timeStamp. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3139,
            "use.counter.page",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_trace
    ///
    /// Whether a page called called console.trace. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3140,
            "use.counter.page",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.console_warn
    ///
    /// Whether a page called called console.warn. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3141,
            "use.counter.page",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.cookiestore_delete
    ///
    /// Whether a page called called CookieStore.delete. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static cookiestore_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3142,
            "use.counter.page",
            "cookiestore_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.cookiestore_get
    ///
    /// Whether a page called called CookieStore.get. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static cookiestore_get: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3143,
            "use.counter.page",
            "cookiestore_get",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.cookiestore_getall
    ///
    /// Whether a page called called CookieStore.getAll. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static cookiestore_getall: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3144,
            "use.counter.page",
            "cookiestore_getall",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.cookiestore_set
    ///
    /// Whether a page called called CookieStore.set. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static cookiestore_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3145,
            "use.counter.page",
            "cookiestore_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customelementregistry_define
    ///
    /// Whether a page called called CustomElementRegistry.define. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customelementregistry_define: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3146,
            "use.counter.page",
            "customelementregistry_define",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.customized_builtin
    ///
    /// Whether a page registers a customized built-in element. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static customized_builtin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3147,
            "use.counter.page",
            "customized_builtin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_addelement
    ///
    /// Whether a page called called DataTransfer.addElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_addelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3148,
            "use.counter.page",
            "datatransfer_addelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcleardataat
    ///
    /// Whether a page called called DataTransfer.mozClearDataAt. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcleardataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3149,
            "use.counter.page",
            "datatransfer_mozcleardataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_getter
    ///
    /// Whether a page got DataTransfer.mozCursor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3150,
            "use.counter.page",
            "datatransfer_mozcursor_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozcursor_setter
    ///
    /// Whether a page set DataTransfer.mozCursor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozcursor_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3151,
            "use.counter.page",
            "datatransfer_mozcursor_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozgetdataat
    ///
    /// Whether a page called called DataTransfer.mozGetDataAt. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozgetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3152,
            "use.counter.page",
            "datatransfer_mozgetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_getter
    ///
    /// Whether a page got DataTransfer.mozItemCount. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3153,
            "use.counter.page",
            "datatransfer_mozitemcount_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozitemcount_setter
    ///
    /// Whether a page set DataTransfer.mozItemCount. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozitemcount_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3154,
            "use.counter.page",
            "datatransfer_mozitemcount_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsetdataat
    ///
    /// Whether a page called called DataTransfer.mozSetDataAt. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsetdataat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3155,
            "use.counter.page",
            "datatransfer_mozsetdataat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_getter
    ///
    /// Whether a page got DataTransfer.mozSourceNode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3156,
            "use.counter.page",
            "datatransfer_mozsourcenode_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozsourcenode_setter
    ///
    /// Whether a page set DataTransfer.mozSourceNode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozsourcenode_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3157,
            "use.counter.page",
            "datatransfer_mozsourcenode_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_moztypesat
    ///
    /// Whether a page called called DataTransfer.mozTypesAt. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_moztypesat: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3158,
            "use.counter.page",
            "datatransfer_moztypesat",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_getter
    ///
    /// Whether a page got DataTransfer.mozUserCancelled. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3159,
            "use.counter.page",
            "datatransfer_mozusercancelled_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.datatransfer_mozusercancelled_setter
    ///
    /// Whether a page set DataTransfer.mozUserCancelled. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static datatransfer_mozusercancelled_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3160,
            "use.counter.page",
            "datatransfer_mozusercancelled_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_exec_command_content_read_only
    ///
    /// Whether a page calls execCommand with contentReadOnly. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_exec_command_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3161,
            "use.counter.page",
            "document_exec_command_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_mozsetimageelement
    ///
    /// Whether a page called called Document.mozSetImageElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_mozsetimageelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3162,
            "use.counter.page",
            "document_mozsetimageelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_open
    ///
    /// Whether a page calls document.open in a way that creates a new Window object. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3163,
            "use.counter.page",
            "document_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_content_read_only
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with contentReadOnly. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3164,
            "use.counter.page",
            "document_query_command_state_or_value_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_state_or_value_insert_br_on_return
    ///
    /// Whether a page calls queryCommandState or queryCommandValue with insertBrOnReturn. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_state_or_value_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3165,
            "use.counter.page",
            "document_query_command_state_or_value_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_content_read_only
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with contentReadOnly. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_content_read_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3166,
            "use.counter.page",
            "document_query_command_supported_or_enabled_content_read_only",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.document_query_command_supported_or_enabled_insert_br_on_return
    ///
    /// Whether a page calls queryCommandSupported or queryCommandEnabled with insertBrOnReturn. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static document_query_command_supported_or_enabled_insert_br_on_return: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3167,
            "use.counter.page",
            "document_query_command_supported_or_enabled_insert_br_on_return",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.domparser_parsefromstring
    ///
    /// Whether a page called called DOMParser.parseFromString. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static domparser_parsefromstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3168,
            "use.counter.page",
            "domparser_parsefromstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_attachshadow
    ///
    /// Whether a page called called Element.attachShadow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_attachshadow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3169,
            "use.counter.page",
            "element_attachshadow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasecapture
    ///
    /// Whether a page called called Element.releaseCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3170,
            "use.counter.page",
            "element_releasecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_releasepointercapture
    ///
    /// Whether a page called called Element.releasePointerCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_releasepointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3171,
            "use.counter.page",
            "element_releasepointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setcapture
    ///
    /// Whether a page called called Element.setCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setcapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3172,
            "use.counter.page",
            "element_setcapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_sethtml
    ///
    /// Whether a page called called Element.setHTML. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_sethtml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3173,
            "use.counter.page",
            "element_sethtml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.element_setpointercapture
    ///
    /// Whether a page called called Element.setPointerCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static element_setpointercapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3174,
            "use.counter.page",
            "element_setpointercapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_insec
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from an insecure context. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static enumerate_devices_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3175,
            "use.counter.page",
            "enumerate_devices_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.enumerate_devices_unfocused
    ///
    /// Whether a page calls MediaDevices.enumerateDevices from a unfocused document. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static enumerate_devices_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3176,
            "use.counter.page",
            "enumerate_devices_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_blend
    ///
    /// Whether a page uses the feBlend SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_blend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3177,
            "use.counter.page",
            "fe_blend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_color_matrix
    ///
    /// Whether a page uses the feColorMatrix SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_color_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3178,
            "use.counter.page",
            "fe_color_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_component_transfer
    ///
    /// Whether a page uses the feComponentTransfer SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_component_transfer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3179,
            "use.counter.page",
            "fe_component_transfer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_composite
    ///
    /// Whether a page uses the feComposite SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_composite: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3180,
            "use.counter.page",
            "fe_composite",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_convolve_matrix
    ///
    /// Whether a page uses the feConvolveMatrix SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_convolve_matrix: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3181,
            "use.counter.page",
            "fe_convolve_matrix",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_diffuse_lighting
    ///
    /// Whether a page uses the feDiffuseLighting SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_diffuse_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3182,
            "use.counter.page",
            "fe_diffuse_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_displacement_map
    ///
    /// Whether a page uses the feDisplacementMap SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_displacement_map: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3183,
            "use.counter.page",
            "fe_displacement_map",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_flood
    ///
    /// Whether a page uses the feFlood SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_flood: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3184,
            "use.counter.page",
            "fe_flood",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_gaussian_blur
    ///
    /// Whether a page uses the feGaussianBlur SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_gaussian_blur: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3185,
            "use.counter.page",
            "fe_gaussian_blur",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_image
    ///
    /// Whether a page uses the feImage SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_image: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3186,
            "use.counter.page",
            "fe_image",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_merge
    ///
    /// Whether a page uses the feMerge SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_merge: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3187,
            "use.counter.page",
            "fe_merge",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_morphology
    ///
    /// Whether a page uses the feMorphology SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_morphology: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3188,
            "use.counter.page",
            "fe_morphology",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_offset
    ///
    /// Whether a page uses the feOffset SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_offset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3189,
            "use.counter.page",
            "fe_offset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_specular_lighting
    ///
    /// Whether a page uses the feSpecularLighting SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_specular_lighting: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3190,
            "use.counter.page",
            "fe_specular_lighting",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_tile
    ///
    /// Whether a page uses the feTile SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_tile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3191,
            "use.counter.page",
            "fe_tile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.fe_turbulence
    ///
    /// Whether a page uses the feTurbulence SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static fe_turbulence: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3192,
            "use.counter.page",
            "fe_turbulence",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.filtered_cross_origin_iframe
    ///
    /// Whether a page cross-origin <iframe> within a CSS/SVG filter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static filtered_cross_origin_iframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3193,
            "use.counter.page",
            "filtered_cross_origin_iframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_insec
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an insecure context. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static get_user_media_insec: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3194,
            "use.counter.page",
            "get_user_media_insec",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.get_user_media_unfocused
    ///
    /// Whether a page calls MediaDevices.getUserMedia from an unfocused document. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static get_user_media_unfocused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3195,
            "use.counter.page",
            "get_user_media_unfocused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldialogelement_show
    ///
    /// Whether a page called called HTMLDialogElement.show. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldialogelement_show: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3196,
            "use.counter.page",
            "htmldialogelement_show",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_caretrangefrompoint
    ///
    /// Whether a page called called HTMLDocument.caretRangeFromPoint. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_caretrangefrompoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3197,
            "use.counter.page",
            "htmldocument_caretrangefrompoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_exitpictureinpicture
    ///
    /// Whether a page called called HTMLDocument.exitPictureInPicture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_exitpictureinpicture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3198,
            "use.counter.page",
            "htmldocument_exitpictureinpicture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_featurepolicy
    ///
    /// Whether a page called called HTMLDocument.featurePolicy. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_featurepolicy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3199,
            "use.counter.page",
            "htmldocument_featurepolicy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_named_getter_hit
    ///
    /// Whether a page calls to the named getter on HTMLDocument that find something via the name lookup. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_named_getter_hit: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3200,
            "use.counter.page",
            "htmldocument_named_getter_hit",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onbeforecopy
    ///
    /// Whether a page called called HTMLDocument.onbeforecopy. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforecopy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3201,
            "use.counter.page",
            "htmldocument_onbeforecopy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onbeforecut
    ///
    /// Whether a page called called HTMLDocument.onbeforecut. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforecut: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3202,
            "use.counter.page",
            "htmldocument_onbeforecut",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onbeforepaste
    ///
    /// Whether a page called called HTMLDocument.onbeforepaste. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onbeforepaste: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3203,
            "use.counter.page",
            "htmldocument_onbeforepaste",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_oncancel
    ///
    /// Whether a page called called HTMLDocument.oncancel. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3204,
            "use.counter.page",
            "htmldocument_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onfreeze
    ///
    /// Whether a page called called HTMLDocument.onfreeze. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onfreeze: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3205,
            "use.counter.page",
            "htmldocument_onfreeze",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onmousewheel
    ///
    /// Whether a page called called HTMLDocument.onmousewheel. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3206,
            "use.counter.page",
            "htmldocument_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onresume
    ///
    /// Whether a page called called HTMLDocument.onresume. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onresume: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3207,
            "use.counter.page",
            "htmldocument_onresume",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onsearch
    ///
    /// Whether a page called called HTMLDocument.onsearch. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3208,
            "use.counter.page",
            "htmldocument_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onwebkitfullscreenchange
    ///
    /// Whether a page called called HTMLDocument.onwebkitfullscreenchange. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onwebkitfullscreenchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3209,
            "use.counter.page",
            "htmldocument_onwebkitfullscreenchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_onwebkitfullscreenerror
    ///
    /// Whether a page called called HTMLDocument.onwebkitfullscreenerror. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_onwebkitfullscreenerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3210,
            "use.counter.page",
            "htmldocument_onwebkitfullscreenerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_pictureinpictureelement
    ///
    /// Whether a page called called HTMLDocument.pictureInPictureElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_pictureinpictureelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3211,
            "use.counter.page",
            "htmldocument_pictureinpictureelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_pictureinpictureenabled
    ///
    /// Whether a page called called HTMLDocument.pictureInPictureEnabled. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_pictureinpictureenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3212,
            "use.counter.page",
            "htmldocument_pictureinpictureenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_registerelement
    ///
    /// Whether a page called called HTMLDocument.registerElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_registerelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3213,
            "use.counter.page",
            "htmldocument_registerelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_wasdiscarded
    ///
    /// Whether a page called called HTMLDocument.wasDiscarded. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_wasdiscarded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3214,
            "use.counter.page",
            "htmldocument_wasdiscarded",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitcancelfullscreen
    ///
    /// Whether a page called called HTMLDocument.webkitCancelFullScreen. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitcancelfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3215,
            "use.counter.page",
            "htmldocument_webkitcancelfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitcurrentfullscreenelement
    ///
    /// Whether a page called called HTMLDocument.webkitCurrentFullScreenElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitcurrentfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3216,
            "use.counter.page",
            "htmldocument_webkitcurrentfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitexitfullscreen
    ///
    /// Whether a page called called HTMLDocument.webkitExitFullscreen. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitexitfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3217,
            "use.counter.page",
            "htmldocument_webkitexitfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitfullscreenelement
    ///
    /// Whether a page called called HTMLDocument.webkitFullscreenElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitfullscreenelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3218,
            "use.counter.page",
            "htmldocument_webkitfullscreenelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitfullscreenenabled
    ///
    /// Whether a page called called HTMLDocument.webkitFullscreenEnabled. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitfullscreenenabled: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3219,
            "use.counter.page",
            "htmldocument_webkitfullscreenenabled",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkithidden
    ///
    /// Whether a page called called HTMLDocument.webkitHidden. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkithidden: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3220,
            "use.counter.page",
            "htmldocument_webkithidden",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitisfullscreen
    ///
    /// Whether a page called called HTMLDocument.webkitIsFullScreen. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitisfullscreen: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3221,
            "use.counter.page",
            "htmldocument_webkitisfullscreen",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_webkitvisibilitystate
    ///
    /// Whether a page called called HTMLDocument.webkitVisibilityState. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_webkitvisibilitystate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3222,
            "use.counter.page",
            "htmldocument_webkitvisibilitystate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_xmlencoding
    ///
    /// Whether a page called called HTMLDocument.xmlEncoding. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlencoding: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3223,
            "use.counter.page",
            "htmldocument_xmlencoding",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_xmlstandalone
    ///
    /// Whether a page called called HTMLDocument.xmlStandalone. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlstandalone: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3224,
            "use.counter.page",
            "htmldocument_xmlstandalone",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.htmldocument_xmlversion
    ///
    /// Whether a page called called HTMLDocument.xmlVersion. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static htmldocument_xmlversion: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3225,
            "use.counter.page",
            "htmldocument_xmlversion",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.invalid_text_directives
    ///
    /// Whether a page had a text fragment that could not be found after loading has finished. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static invalid_text_directives: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3226,
            "use.counter.page",
            "invalid_text_directives",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_asmjs
    ///
    /// Whether a page uses asm.js. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_asmjs: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3227,
            "use.counter.page",
            "js_asmjs",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_dateparse
    ///
    /// Whether a page called Date.parse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_dateparse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3228,
            "use.counter.page",
            "js_dateparse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_dateparse_impl_def
    ///
    /// Whether a page call to Date.parse used implementation defined behaviour. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_dateparse_impl_def: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3229,
            "use.counter.page",
            "js_dateparse_impl_def",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_errorstack_getter
    ///
    /// Whether a page called error.stack getter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3230,
            "use.counter.page",
            "js_errorstack_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_errorstack_getter_no_errordata
    ///
    /// Whether a page called error.stack getter on object without ErrorData internal slot. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_getter_no_errordata: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3231,
            "use.counter.page",
            "js_errorstack_getter_no_errordata",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_errorstack_setter
    ///
    /// Whether a page called error.stack setter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3232,
            "use.counter.page",
            "js_errorstack_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_errorstack_setter_no_errordata
    ///
    /// Whether a page called error.stack setter on object without ErrorData internal slot. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter_no_errordata: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3233,
            "use.counter.page",
            "js_errorstack_setter_no_errordata",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_errorstack_setter_nonstring
    ///
    /// Whether a page called error.stack setter with non-string input. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_errorstack_setter_nonstring: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3234,
            "use.counter.page",
            "js_errorstack_setter_nonstring",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_ic_stub_oom
    ///
    /// Whether a page OOMed while creating IC stub. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_ic_stub_oom: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3235,
            "use.counter.page",
            "js_ic_stub_oom",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_ic_stub_too_large
    ///
    /// Whether a page tried to create an IC stub that was too large. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_ic_stub_too_large: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3236,
            "use.counter.page",
            "js_ic_stub_too_large",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_is_htmldda_fuse
    ///
    /// Whether a page has used the document.all getter (popping the EmulatesUndefined Fuse). Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_is_htmldda_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3237,
            "use.counter.page",
            "js_is_htmldda_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_legacy_lang_subtag
    ///
    /// Whether a page uses a 5-to-8-character language subtag in Intl.Locale constructor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_legacy_lang_subtag: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3238,
            "use.counter.page",
            "js_legacy_lang_subtag",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_optimize_array_species_fuse
    ///
    /// Whether a page has modified builtin Array objects such that the ArraySpecies fuse is popped. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_optimize_array_species_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3239,
            "use.counter.page",
            "js_optimize_array_species_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_optimize_get_iterator_fuse
    ///
    /// Whether a page has modified any builtins such that the GetIterator fuse is popped. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_optimize_get_iterator_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3240,
            "use.counter.page",
            "js_optimize_get_iterator_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_optimize_promise_lookup_fuse
    ///
    /// Whether a page has modified builtin Promise objects such that the PromiseLookup fuse is popped. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_optimize_promise_lookup_fuse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3241,
            "use.counter.page",
            "js_optimize_promise_lookup_fuse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_regexp_symbol_protocol_on_primitive
    ///
    /// Whether a page passed a primitive with a custom implementation of the regexp protocol symbols to one of the String methods that accept a regexp. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_regexp_symbol_protocol_on_primitive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3242,
            "use.counter.page",
            "js_regexp_symbol_protocol_on_primitive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_thenable
    ///
    /// Whether a page resolved a promise using thenable support rather than builtin methods. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_thenable: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3243,
            "use.counter.page",
            "js_thenable",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_thenable_object_proto
    ///
    /// Whether a page resolved a promise using thenable on a realms Object.prototype. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_thenable_object_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3244,
            "use.counter.page",
            "js_thenable_object_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_thenable_proto
    ///
    /// Whether a page resolved a promise using thenable on prototype. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_thenable_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3245,
            "use.counter.page",
            "js_thenable_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_thenable_standard_proto
    ///
    /// Whether a page resolved a promise using thenable on a standard prototype. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_thenable_standard_proto: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3246,
            "use.counter.page",
            "js_thenable_standard_proto",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm
    ///
    /// Whether a page uses WebAssembly. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3247,
            "use.counter.page",
            "js_wasm",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.js_wasm_legacy_exceptions
    ///
    /// Whether a page uses WebAssembly legacy exception-handling. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static js_wasm_legacy_exceptions: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3248,
            "use.counter.page",
            "js_wasm_legacy_exceptions",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.location_ancestororigins
    ///
    /// Whether a page called called Location.ancestorOrigins. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static location_ancestororigins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3249,
            "use.counter.page",
            "location_ancestororigins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.math_mlused
    ///
    /// Whether a page has used MathML. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static math_mlused: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3250,
            "use.counter.page",
            "math_mlused",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_enumeratedevices
    ///
    /// Whether a page called called MediaDevices.enumerateDevices. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_enumeratedevices: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3251,
            "use.counter.page",
            "mediadevices_enumeratedevices",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getdisplaymedia
    ///
    /// Whether a page called called MediaDevices.getDisplayMedia. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getdisplaymedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3252,
            "use.counter.page",
            "mediadevices_getdisplaymedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mediadevices_getusermedia
    ///
    /// Whether a page called called MediaDevices.getUserMedia. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mediadevices_getusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3253,
            "use.counter.page",
            "mediadevices_getusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3254,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3255,
            "use.counter.page",
            "mixed_content_not_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3256,
            "use.counter.page",
            "mixed_content_not_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3257,
            "use.counter.page",
            "mixed_content_not_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3258,
            "use.counter.page",
            "mixed_content_not_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_not_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_not_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3259,
            "use.counter.page",
            "mixed_content_not_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_failure
    ///
    /// Whether a page includes a mixed content audio element that does not load.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3260,
            "use.counter.page",
            "mixed_content_upgraded_audio_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_audio_success
    ///
    /// Whether a page includes a mixed content audio element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_audio_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3261,
            "use.counter.page",
            "mixed_content_upgraded_audio_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_failure
    ///
    /// Whether a page includes a mixed content img element that does not load.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3262,
            "use.counter.page",
            "mixed_content_upgraded_image_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_image_success
    ///
    /// Whether a page includes a mixed content img element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_image_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3263,
            "use.counter.page",
            "mixed_content_upgraded_image_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_failure
    ///
    /// Whether a page includes a mixed content video element that does not laod.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3264,
            "use.counter.page",
            "mixed_content_upgraded_video_failure",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mixed_content_upgraded_video_success
    ///
    /// Whether a page includes a mixed content video element that loads.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mixed_content_upgraded_video_success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3265,
            "use.counter.page",
            "mixed_content_upgraded_video_success",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_deriveexporter
    ///
    /// Whether a page called called MLS.deriveExporter. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_deriveexporter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3266,
            "use.counter.page",
            "mls_deriveexporter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_generatecredentialbasic
    ///
    /// Whether a page called called MLS.generateCredentialBasic. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_generatecredentialbasic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3267,
            "use.counter.page",
            "mls_generatecredentialbasic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_generatekeypackage
    ///
    /// Whether a page called called MLS.generateKeyPackage. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_generatekeypackage: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3268,
            "use.counter.page",
            "mls_generatekeypackage",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_generatesignaturekeypair
    ///
    /// Whether a page called called MLS.generateSignatureKeypair. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_generatesignaturekeypair: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3269,
            "use.counter.page",
            "mls_generatesignaturekeypair",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupadd
    ///
    /// Whether a page called called MLS.groupAdd. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3270,
            "use.counter.page",
            "mls_groupadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupclose
    ///
    /// Whether a page called called MLS.groupClose. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupclose: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3271,
            "use.counter.page",
            "mls_groupclose",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupcreate
    ///
    /// Whether a page called called MLS.groupCreate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupcreate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3272,
            "use.counter.page",
            "mls_groupcreate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupjoin
    ///
    /// Whether a page called called MLS.groupJoin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupjoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3273,
            "use.counter.page",
            "mls_groupjoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupmembers
    ///
    /// Whether a page called called MLS.groupMembers. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupmembers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3274,
            "use.counter.page",
            "mls_groupmembers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupproposeadd
    ///
    /// Whether a page called called MLS.groupProposeAdd. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupproposeadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3275,
            "use.counter.page",
            "mls_groupproposeadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupproposeremove
    ///
    /// Whether a page called called MLS.groupProposeRemove. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupproposeremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3276,
            "use.counter.page",
            "mls_groupproposeremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_groupremove
    ///
    /// Whether a page called called MLS.groupRemove. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_groupremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3277,
            "use.counter.page",
            "mls_groupremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_receive
    ///
    /// Whether a page called called MLS.receive. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_receive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3278,
            "use.counter.page",
            "mls_receive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_send
    ///
    /// Whether a page called called MLS.send. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3279,
            "use.counter.page",
            "mls_send",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_statedelete
    ///
    /// Whether a page called called MLS.stateDelete. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_statedelete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3280,
            "use.counter.page",
            "mls_statedelete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.mls_statedeletegroup
    ///
    /// Whether a page called called MLS.stateDeleteGroup. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static mls_statedeletegroup: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3281,
            "use.counter.page",
            "mls_statedeletegroup",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.navigator_mozgetusermedia
    ///
    /// Whether a page called called Navigator.mozGetUserMedia. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static navigator_mozgetusermedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3282,
            "use.counter.page",
            "navigator_mozgetusermedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.ondommousescroll
    ///
    /// Whether a page sets DOMMouseScroll event listener. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static ondommousescroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3283,
            "use.counter.page",
            "ondommousescroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.onmozmousepixelscroll
    ///
    /// Whether a page sets MozMousePixelScroll event listener. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static onmozmousepixelscroll: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3284,
            "use.counter.page",
            "onmozmousepixelscroll",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svg
    ///
    /// Whether a page whether percentage stroke-width is used in SVG elements (excluding <text>). Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svg: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3285,
            "use.counter.page",
            "percentage_stroke_width_in_svg",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.percentage_stroke_width_in_svgtext
    ///
    /// Whether a page whether percentage stroke-width is used in SVG <text>. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static percentage_stroke_width_in_svgtext: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3286,
            "use.counter.page",
            "percentage_stroke_width_in_svgtext",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_delete
    ///
    /// Whether a page calls caches.delete in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3287,
            "use.counter.page",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_has
    ///
    /// Whether a page calls caches.has in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3288,
            "use.counter.page",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_keys
    ///
    /// Whether a page calls caches.keys in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3289,
            "use.counter.page",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_match
    ///
    /// Whether a page calls caches.match in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3290,
            "use.counter.page",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_caches_open
    ///
    /// Whether a page calls caches.open in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3291,
            "use.counter.page",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_delete_database
    ///
    /// Whether a page calls indexedDB.deleteDatabase in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3292,
            "use.counter.page",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_idbfactory_open
    ///
    /// Whether a page calls indexedDB.open in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3293,
            "use.counter.page",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.private_browsing_navigator_service_worker
    ///
    /// Whether a page accesses navigator.serviceWorker in Private Browsing Mode. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static private_browsing_navigator_service_worker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3294,
            "use.counter.page",
            "private_browsing_navigator_service_worker",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushmanager_subscribe
    ///
    /// Whether a page called called PushManager.subscribe. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3295,
            "use.counter.page",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.pushsubscription_unsubscribe
    ///
    /// Whether a page called called PushSubscription.unsubscribe. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3296,
            "use.counter.page",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.range_createcontextualfragment
    ///
    /// Whether a page called called Range.createContextualFragment. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static range_createcontextualfragment: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3297,
            "use.counter.page",
            "range_createcontextualfragment",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_constructor
    ///
    /// Whether a page called called Sanitizer.constructor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3298,
            "use.counter.page",
            "sanitizer_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sanitizer_sanitize
    ///
    /// Whether a page called called Sanitizer.sanitize. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sanitizer_sanitize: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3299,
            "use.counter.page",
            "sanitizer_sanitize",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.scheduler_posttask
    ///
    /// Whether a page called called Scheduler.postTask. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3300,
            "use.counter.page",
            "scheduler_posttask",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.sectioning_h1_with_no_font_size_or_margins
    ///
    /// Whether a page found sectioned h1 element with no font-size or no margins. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static sectioning_h1_with_no_font_size_or_margins: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3301,
            "use.counter.page",
            "sectioning_h1_with_no_font_size_or_margins",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_getter
    ///
    /// Whether a page got SVGSVGElement.currentScale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3302,
            "use.counter.page",
            "svgsvgelement_currentscale_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_currentscale_setter
    ///
    /// Whether a page set SVGSVGElement.currentScale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_currentscale_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3303,
            "use.counter.page",
            "svgsvgelement_currentscale_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.svgsvgelement_getelementbyid
    ///
    /// Whether a page called called SVGSVGElement.getElementById. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static svgsvgelement_getelementbyid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3304,
            "use.counter.page",
            "svgsvgelement_getelementbyid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.text_directive_not_created
    ///
    /// Whether a page has not succeeded in creating a text fragment. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static text_directive_not_created: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3305,
            "use.counter.page",
            "text_directive_not_created",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.text_directive_pages
    ///
    /// Whether a page used text fragments. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static text_directive_pages: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3306,
            "use.counter.page",
            "text_directive_pages",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_absoluteorientationsensor
    ///
    /// Whether a page called called Window.AbsoluteOrientationSensor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_absoluteorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3307,
            "use.counter.page",
            "window_absoluteorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_accelerometer
    ///
    /// Whether a page called called Window.Accelerometer. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_accelerometer: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3308,
            "use.counter.page",
            "window_accelerometer",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchmanager
    ///
    /// Whether a page called called Window.BackgroundFetchManager. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3309,
            "use.counter.page",
            "window_backgroundfetchmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchrecord
    ///
    /// Whether a page called called Window.BackgroundFetchRecord. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchrecord: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3310,
            "use.counter.page",
            "window_backgroundfetchrecord",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_backgroundfetchregistration
    ///
    /// Whether a page called called Window.BackgroundFetchRegistration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_backgroundfetchregistration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3311,
            "use.counter.page",
            "window_backgroundfetchregistration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_beforeinstallpromptevent
    ///
    /// Whether a page called called Window.BeforeInstallPromptEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_beforeinstallpromptevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3312,
            "use.counter.page",
            "window_beforeinstallpromptevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetooth
    ///
    /// Whether a page called called Window.Bluetooth. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetooth: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3313,
            "use.counter.page",
            "window_bluetooth",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothcharacteristicproperties
    ///
    /// Whether a page called called Window.BluetoothCharacteristicProperties. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothcharacteristicproperties: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3314,
            "use.counter.page",
            "window_bluetoothcharacteristicproperties",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothdevice
    ///
    /// Whether a page called called Window.BluetoothDevice. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3315,
            "use.counter.page",
            "window_bluetoothdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattcharacteristic
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTCharacteristic. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattcharacteristic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3316,
            "use.counter.page",
            "window_bluetoothremotegattcharacteristic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattdescriptor
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTDescriptor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattdescriptor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3317,
            "use.counter.page",
            "window_bluetoothremotegattdescriptor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattserver
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTServer. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3318,
            "use.counter.page",
            "window_bluetoothremotegattserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothremotegattservice
    ///
    /// Whether a page called called Window.BluetoothRemoteGATTService. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothremotegattservice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3319,
            "use.counter.page",
            "window_bluetoothremotegattservice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_bluetoothuuid
    ///
    /// Whether a page called called Window.BluetoothUUID. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_bluetoothuuid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3320,
            "use.counter.page",
            "window_bluetoothuuid",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_canvascapturemediastreamtrack
    ///
    /// Whether a page called called Window.CanvasCaptureMediaStreamTrack. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_canvascapturemediastreamtrack: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3321,
            "use.counter.page",
            "window_canvascapturemediastreamtrack",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_chrome
    ///
    /// Whether a page called called Window.chrome. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_chrome: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3322,
            "use.counter.page",
            "window_chrome",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_clipboarditem
    ///
    /// Whether a page called called Window.ClipboardItem. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_clipboarditem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3323,
            "use.counter.page",
            "window_clipboarditem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssimagevalue
    ///
    /// Whether a page called called Window.CSSImageValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssimagevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3324,
            "use.counter.page",
            "window_cssimagevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csskeywordvalue
    ///
    /// Whether a page called called Window.CSSKeywordValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csskeywordvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3325,
            "use.counter.page",
            "window_csskeywordvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathclamp
    ///
    /// Whether a page called called Window.CSSMathClamp. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathclamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3326,
            "use.counter.page",
            "window_cssmathclamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathinvert
    ///
    /// Whether a page called called Window.CSSMathInvert. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathinvert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3327,
            "use.counter.page",
            "window_cssmathinvert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmax
    ///
    /// Whether a page called called Window.CSSMathMax. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmax: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3328,
            "use.counter.page",
            "window_cssmathmax",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathmin
    ///
    /// Whether a page called called Window.CSSMathMin. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathmin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3329,
            "use.counter.page",
            "window_cssmathmin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathnegate
    ///
    /// Whether a page called called Window.CSSMathNegate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathnegate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3330,
            "use.counter.page",
            "window_cssmathnegate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathproduct
    ///
    /// Whether a page called called Window.CSSMathProduct. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3331,
            "use.counter.page",
            "window_cssmathproduct",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathsum
    ///
    /// Whether a page called called Window.CSSMathSum. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathsum: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3332,
            "use.counter.page",
            "window_cssmathsum",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmathvalue
    ///
    /// Whether a page called called Window.CSSMathValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmathvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3333,
            "use.counter.page",
            "window_cssmathvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssmatrixcomponent
    ///
    /// Whether a page called called Window.CSSMatrixComponent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssmatrixcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3334,
            "use.counter.page",
            "window_cssmatrixcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericarray
    ///
    /// Whether a page called called Window.CSSNumericArray. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericarray: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3335,
            "use.counter.page",
            "window_cssnumericarray",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssnumericvalue
    ///
    /// Whether a page called called Window.CSSNumericValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssnumericvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3336,
            "use.counter.page",
            "window_cssnumericvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssperspective
    ///
    /// Whether a page called called Window.CSSPerspective. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssperspective: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3337,
            "use.counter.page",
            "window_cssperspective",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspositionvalue
    ///
    /// Whether a page called called Window.CSSPositionValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspositionvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3338,
            "use.counter.page",
            "window_csspositionvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csspropertyrule
    ///
    /// Whether a page called called Window.CSSPropertyRule. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csspropertyrule: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3339,
            "use.counter.page",
            "window_csspropertyrule",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssrotate
    ///
    /// Whether a page called called Window.CSSRotate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssrotate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3340,
            "use.counter.page",
            "window_cssrotate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssscale
    ///
    /// Whether a page called called Window.CSSScale. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssscale: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3341,
            "use.counter.page",
            "window_cssscale",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskew
    ///
    /// Whether a page called called Window.CSSSkew. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskew: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3342,
            "use.counter.page",
            "window_cssskew",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewx
    ///
    /// Whether a page called called Window.CSSSkewX. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewx: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3343,
            "use.counter.page",
            "window_cssskewx",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssskewy
    ///
    /// Whether a page called called Window.CSSSkewY. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssskewy: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3344,
            "use.counter.page",
            "window_cssskewy",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssstylevalue
    ///
    /// Whether a page called called Window.CSSStyleValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssstylevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3345,
            "use.counter.page",
            "window_cssstylevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformcomponent
    ///
    /// Whether a page called called Window.CSSTransformComponent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformcomponent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3346,
            "use.counter.page",
            "window_csstransformcomponent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstransformvalue
    ///
    /// Whether a page called called Window.CSSTransformValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstransformvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3347,
            "use.counter.page",
            "window_csstransformvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_csstranslate
    ///
    /// Whether a page called called Window.CSSTranslate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_csstranslate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3348,
            "use.counter.page",
            "window_csstranslate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunitvalue
    ///
    /// Whether a page called called Window.CSSUnitValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunitvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3349,
            "use.counter.page",
            "window_cssunitvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssunparsedvalue
    ///
    /// Whether a page called called Window.CSSUnparsedValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssunparsedvalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3350,
            "use.counter.page",
            "window_cssunparsedvalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_cssvariablereferencevalue
    ///
    /// Whether a page called called Window.CSSVariableReferenceValue. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_cssvariablereferencevalue: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3351,
            "use.counter.page",
            "window_cssvariablereferencevalue",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_defaultstatus
    ///
    /// Whether a page called called Window.defaultStatus. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_defaultstatus: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3352,
            "use.counter.page",
            "window_defaultstatus",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventacceleration
    ///
    /// Whether a page called called Window.DeviceMotionEventAcceleration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventacceleration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3353,
            "use.counter.page",
            "window_devicemotioneventacceleration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_devicemotioneventrotationrate
    ///
    /// Whether a page called called Window.DeviceMotionEventRotationRate. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_devicemotioneventrotationrate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3354,
            "use.counter.page",
            "window_devicemotioneventrotationrate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_domerror
    ///
    /// Whether a page called called Window.DOMError. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_domerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3355,
            "use.counter.page",
            "window_domerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_encodedvideochunk
    ///
    /// Whether a page called called Window.EncodedVideoChunk. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_encodedvideochunk: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3356,
            "use.counter.page",
            "window_encodedvideochunk",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_enterpictureinpictureevent
    ///
    /// Whether a page called called Window.EnterPictureInPictureEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_enterpictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3357,
            "use.counter.page",
            "window_enterpictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_external
    ///
    /// Whether a page called called Window.External. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3358,
            "use.counter.page",
            "window_external",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_federatedcredential
    ///
    /// Whether a page called called Window.FederatedCredential. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_federatedcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3359,
            "use.counter.page",
            "window_federatedcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_gyroscope
    ///
    /// Whether a page called called Window.Gyroscope. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_gyroscope: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3360,
            "use.counter.page",
            "window_gyroscope",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlcontentelement
    ///
    /// Whether a page called called Window.HTMLContentElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlcontentelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3361,
            "use.counter.page",
            "window_htmlcontentelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_htmlshadowelement
    ///
    /// Whether a page called called Window.HTMLShadowElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_htmlshadowelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3362,
            "use.counter.page",
            "window_htmlshadowelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_imagecapture
    ///
    /// Whether a page called called Window.ImageCapture. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_imagecapture: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3363,
            "use.counter.page",
            "window_imagecapture",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdevicecapabilities
    ///
    /// Whether a page called called Window.InputDeviceCapabilities. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdevicecapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3364,
            "use.counter.page",
            "window_inputdevicecapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_inputdeviceinfo
    ///
    /// Whether a page called called Window.InputDeviceInfo. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_inputdeviceinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3365,
            "use.counter.page",
            "window_inputdeviceinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboard
    ///
    /// Whether a page called called Window.Keyboard. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboard: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3366,
            "use.counter.page",
            "window_keyboard",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_keyboardlayoutmap
    ///
    /// Whether a page called called Window.KeyboardLayoutMap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_keyboardlayoutmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3367,
            "use.counter.page",
            "window_keyboardlayoutmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_linearaccelerationsensor
    ///
    /// Whether a page called called Window.LinearAccelerationSensor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_linearaccelerationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3368,
            "use.counter.page",
            "window_linearaccelerationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_mediasettingsrange
    ///
    /// Whether a page called called Window.MediaSettingsRange. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_mediasettingsrange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3369,
            "use.counter.page",
            "window_mediasettingsrange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiaccess
    ///
    /// Whether a page called called Window.MIDIAccess. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiaccess: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3370,
            "use.counter.page",
            "window_midiaccess",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiconnectionevent
    ///
    /// Whether a page called called Window.MIDIConnectionEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3371,
            "use.counter.page",
            "window_midiconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinput
    ///
    /// Whether a page called called Window.MIDIInput. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3372,
            "use.counter.page",
            "window_midiinput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiinputmap
    ///
    /// Whether a page called called Window.MIDIInputMap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiinputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3373,
            "use.counter.page",
            "window_midiinputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midimessageevent
    ///
    /// Whether a page called called Window.MIDIMessageEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midimessageevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3374,
            "use.counter.page",
            "window_midimessageevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutput
    ///
    /// Whether a page called called Window.MIDIOutput. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutput: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3375,
            "use.counter.page",
            "window_midioutput",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midioutputmap
    ///
    /// Whether a page called called Window.MIDIOutputMap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midioutputmap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3376,
            "use.counter.page",
            "window_midioutputmap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_midiport
    ///
    /// Whether a page called called Window.MIDIPort. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_midiport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3377,
            "use.counter.page",
            "window_midiport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_networkinformation
    ///
    /// Whether a page called called Window.NetworkInformation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_networkinformation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3378,
            "use.counter.page",
            "window_networkinformation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_offscreenbuffering
    ///
    /// Whether a page called called Window.offscreenBuffering. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_offscreenbuffering: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3379,
            "use.counter.page",
            "window_offscreenbuffering",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onbeforeinstallprompt
    ///
    /// Whether a page called called Window.onbeforeinstallprompt. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onbeforeinstallprompt: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3380,
            "use.counter.page",
            "window_onbeforeinstallprompt",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_oncancel
    ///
    /// Whether a page called called Window.oncancel. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_oncancel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3381,
            "use.counter.page",
            "window_oncancel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onmousewheel
    ///
    /// Whether a page called called Window.onmousewheel. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onmousewheel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3382,
            "use.counter.page",
            "window_onmousewheel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onorientationchange
    ///
    /// Whether a page called called Window.onorientationchange. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onorientationchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3383,
            "use.counter.page",
            "window_onorientationchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onsearch
    ///
    /// Whether a page called called Window.onsearch. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onsearch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3384,
            "use.counter.page",
            "window_onsearch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_onselectionchange
    ///
    /// Whether a page called called Window.onselectionchange. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_onselectionchange: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3385,
            "use.counter.page",
            "window_onselectionchange",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_open_empty_url
    ///
    /// Whether a page calls window.open with an empty url argument. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_open_empty_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3386,
            "use.counter.page",
            "window_open_empty_url",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_opendatabase
    ///
    /// Whether a page called called Window.openDatabase. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_opendatabase: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3387,
            "use.counter.page",
            "window_opendatabase",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientation
    ///
    /// Whether a page called called Window.orientation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3388,
            "use.counter.page",
            "window_orientation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_orientationsensor
    ///
    /// Whether a page called called Window.OrientationSensor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_orientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3389,
            "use.counter.page",
            "window_orientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_overconstrainederror
    ///
    /// Whether a page called called Window.OverconstrainedError. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_overconstrainederror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3390,
            "use.counter.page",
            "window_overconstrainederror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_passwordcredential
    ///
    /// Whether a page called called Window.PasswordCredential. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_passwordcredential: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3391,
            "use.counter.page",
            "window_passwordcredential",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentaddress
    ///
    /// Whether a page called called Window.PaymentAddress. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentaddress: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3392,
            "use.counter.page",
            "window_paymentaddress",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentinstruments
    ///
    /// Whether a page called called Window.PaymentInstruments. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentinstruments: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3393,
            "use.counter.page",
            "window_paymentinstruments",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmanager
    ///
    /// Whether a page called called Window.PaymentManager. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3394,
            "use.counter.page",
            "window_paymentmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentmethodchangeevent
    ///
    /// Whether a page called called Window.PaymentMethodChangeEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentmethodchangeevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3395,
            "use.counter.page",
            "window_paymentmethodchangeevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequest
    ///
    /// Whether a page called called Window.PaymentRequest. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3396,
            "use.counter.page",
            "window_paymentrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentrequestupdateevent
    ///
    /// Whether a page called called Window.PaymentRequestUpdateEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentrequestupdateevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3397,
            "use.counter.page",
            "window_paymentrequestupdateevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_paymentresponse
    ///
    /// Whether a page called called Window.PaymentResponse. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_paymentresponse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3398,
            "use.counter.page",
            "window_paymentresponse",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_performancelongtasktiming
    ///
    /// Whether a page called called Window.PerformanceLongTaskTiming. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_performancelongtasktiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3399,
            "use.counter.page",
            "window_performancelongtasktiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_photocapabilities
    ///
    /// Whether a page called called Window.PhotoCapabilities. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_photocapabilities: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3400,
            "use.counter.page",
            "window_photocapabilities",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpictureevent
    ///
    /// Whether a page called called Window.PictureInPictureEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpictureevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3401,
            "use.counter.page",
            "window_pictureinpictureevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_pictureinpicturewindow
    ///
    /// Whether a page called called Window.PictureInPictureWindow. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_pictureinpicturewindow: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3402,
            "use.counter.page",
            "window_pictureinpicturewindow",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentation
    ///
    /// Whether a page called called Window.Presentation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3403,
            "use.counter.page",
            "window_presentation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationavailability
    ///
    /// Whether a page called called Window.PresentationAvailability. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationavailability: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3404,
            "use.counter.page",
            "window_presentationavailability",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnection
    ///
    /// Whether a page called called Window.PresentationConnection. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3405,
            "use.counter.page",
            "window_presentationconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionavailableevent
    ///
    /// Whether a page called called Window.PresentationConnectionAvailableEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionavailableevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3406,
            "use.counter.page",
            "window_presentationconnectionavailableevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectioncloseevent
    ///
    /// Whether a page called called Window.PresentationConnectionCloseEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectioncloseevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3407,
            "use.counter.page",
            "window_presentationconnectioncloseevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationconnectionlist
    ///
    /// Whether a page called called Window.PresentationConnectionList. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationconnectionlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3408,
            "use.counter.page",
            "window_presentationconnectionlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationreceiver
    ///
    /// Whether a page called called Window.PresentationReceiver. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationreceiver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3409,
            "use.counter.page",
            "window_presentationreceiver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_presentationrequest
    ///
    /// Whether a page called called Window.PresentationRequest. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_presentationrequest: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3410,
            "use.counter.page",
            "window_presentationrequest",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_relativeorientationsensor
    ///
    /// Whether a page called called Window.RelativeOrientationSensor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_relativeorientationsensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3411,
            "use.counter.page",
            "window_relativeorientationsensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_remoteplayback
    ///
    /// Whether a page called called Window.RemotePlayback. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_remoteplayback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3412,
            "use.counter.page",
            "window_remoteplayback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_report
    ///
    /// Whether a page called called Window.Report. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_report: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3413,
            "use.counter.page",
            "window_report",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportbody
    ///
    /// Whether a page called called Window.ReportBody. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportbody: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3414,
            "use.counter.page",
            "window_reportbody",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_reportingobserver
    ///
    /// Whether a page called called Window.ReportingObserver. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_reportingobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3415,
            "use.counter.page",
            "window_reportingobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerror
    ///
    /// Whether a page called called Window.RTCError. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3416,
            "use.counter.page",
            "window_rtcerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcerrorevent
    ///
    /// Whether a page called called Window.RTCErrorEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3417,
            "use.counter.page",
            "window_rtcerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcicetransport
    ///
    /// Whether a page called called Window.RTCIceTransport. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcicetransport: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3418,
            "use.counter.page",
            "window_rtcicetransport",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_rtcpeerconnectioniceerrorevent
    ///
    /// Whether a page called called Window.RTCPeerConnectionIceErrorEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_rtcpeerconnectioniceerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3419,
            "use.counter.page",
            "window_rtcpeerconnectioniceerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensor
    ///
    /// Whether a page called called Window.Sensor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3420,
            "use.counter.page",
            "window_sensor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sensorerrorevent
    ///
    /// Whether a page called called Window.SensorErrorEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sensorerrorevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3421,
            "use.counter.page",
            "window_sensorerrorevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_getter
    ///
    /// Whether a page got Window.sidebar. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_getter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3422,
            "use.counter.page",
            "window_sidebar_getter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_sidebar_setter
    ///
    /// Whether a page set Window.sidebar. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_sidebar_setter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3423,
            "use.counter.page",
            "window_sidebar_setter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionalternative
    ///
    /// Whether a page called called Window.SpeechRecognitionAlternative. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionalternative: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3424,
            "use.counter.page",
            "window_speechrecognitionalternative",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresult
    ///
    /// Whether a page called called Window.SpeechRecognitionResult. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3425,
            "use.counter.page",
            "window_speechrecognitionresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_speechrecognitionresultlist
    ///
    /// Whether a page called called Window.SpeechRecognitionResultList. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_speechrecognitionresultlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3426,
            "use.counter.page",
            "window_speechrecognitionresultlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylemedia
    ///
    /// Whether a page called called Window.styleMedia. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylemedia: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3427,
            "use.counter.page",
            "window_stylemedia",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymap
    ///
    /// Whether a page called called Window.StylePropertyMap. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymap: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3428,
            "use.counter.page",
            "window_stylepropertymap",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_stylepropertymapreadonly
    ///
    /// Whether a page called called Window.StylePropertyMapReadOnly. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_stylepropertymapreadonly: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3429,
            "use.counter.page",
            "window_stylepropertymapreadonly",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_svgdiscardelement
    ///
    /// Whether a page called called Window.SVGDiscardElement. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_svgdiscardelement: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3430,
            "use.counter.page",
            "window_svgdiscardelement",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_syncmanager
    ///
    /// Whether a page called called Window.SyncManager. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_syncmanager: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3431,
            "use.counter.page",
            "window_syncmanager",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_taskattributiontiming
    ///
    /// Whether a page called called Window.TaskAttributionTiming. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_taskattributiontiming: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3432,
            "use.counter.page",
            "window_taskattributiontiming",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_textevent
    ///
    /// Whether a page called called Window.TextEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_textevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3433,
            "use.counter.page",
            "window_textevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touch
    ///
    /// Whether a page called called Window.Touch. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3434,
            "use.counter.page",
            "window_touch",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchevent
    ///
    /// Whether a page called called Window.TouchEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3435,
            "use.counter.page",
            "window_touchevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_touchlist
    ///
    /// Whether a page called called Window.TouchList. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_touchlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3436,
            "use.counter.page",
            "window_touchlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usb
    ///
    /// Whether a page called called Window.USB. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usb: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3437,
            "use.counter.page",
            "window_usb",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbalternateinterface
    ///
    /// Whether a page called called Window.USBAlternateInterface. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbalternateinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3438,
            "use.counter.page",
            "window_usbalternateinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconfiguration
    ///
    /// Whether a page called called Window.USBConfiguration. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconfiguration: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3439,
            "use.counter.page",
            "window_usbconfiguration",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbconnectionevent
    ///
    /// Whether a page called called Window.USBConnectionEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbconnectionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3440,
            "use.counter.page",
            "window_usbconnectionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbdevice
    ///
    /// Whether a page called called Window.USBDevice. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbdevice: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3441,
            "use.counter.page",
            "window_usbdevice",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbendpoint
    ///
    /// Whether a page called called Window.USBEndpoint. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbendpoint: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3442,
            "use.counter.page",
            "window_usbendpoint",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbinterface
    ///
    /// Whether a page called called Window.USBInterface. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbinterface: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3443,
            "use.counter.page",
            "window_usbinterface",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbintransferresult
    ///
    /// Whether a page called called Window.USBInTransferResult. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3444,
            "use.counter.page",
            "window_usbintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousInTransferPacket. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3445,
            "use.counter.page",
            "window_usbisochronousintransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousintransferresult
    ///
    /// Whether a page called called Window.USBIsochronousInTransferResult. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousintransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3446,
            "use.counter.page",
            "window_usbisochronousintransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferpacket
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferPacket. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousouttransferpacket: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3447,
            "use.counter.page",
            "window_usbisochronousouttransferpacket",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbisochronousouttransferresult
    ///
    /// Whether a page called called Window.USBIsochronousOutTransferResult. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbisochronousouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3448,
            "use.counter.page",
            "window_usbisochronousouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_usbouttransferresult
    ///
    /// Whether a page called called Window.USBOutTransferResult. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_usbouttransferresult: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3449,
            "use.counter.page",
            "window_usbouttransferresult",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_useractivation
    ///
    /// Whether a page called called Window.UserActivation. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_useractivation: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3450,
            "use.counter.page",
            "window_useractivation",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videocolorspace
    ///
    /// Whether a page called called Window.VideoColorSpace. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videocolorspace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3451,
            "use.counter.page",
            "window_videocolorspace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videodecoder
    ///
    /// Whether a page called called Window.VideoDecoder. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videodecoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3452,
            "use.counter.page",
            "window_videodecoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoencoder
    ///
    /// Whether a page called called Window.VideoEncoder. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoencoder: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3453,
            "use.counter.page",
            "window_videoencoder",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_videoframe
    ///
    /// Whether a page called called Window.VideoFrame. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_videoframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3454,
            "use.counter.page",
            "window_videoframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelock
    ///
    /// Whether a page called called Window.WakeLock. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelock: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3455,
            "use.counter.page",
            "window_wakelock",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_wakelocksentinel
    ///
    /// Whether a page called called Window.WakeLockSentinel. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_wakelocksentinel: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3456,
            "use.counter.page",
            "window_wakelocksentinel",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitcancelanimationframe
    ///
    /// Whether a page called called Window.webkitCancelAnimationFrame. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitcancelanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3457,
            "use.counter.page",
            "window_webkitcancelanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmediastream
    ///
    /// Whether a page called called Window.webkitMediaStream. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmediastream: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3458,
            "use.counter.page",
            "window_webkitmediastream",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitmutationobserver
    ///
    /// Whether a page called called Window.WebKitMutationObserver. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitmutationobserver: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3459,
            "use.counter.page",
            "window_webkitmutationobserver",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestanimationframe
    ///
    /// Whether a page called called Window.webkitRequestAnimationFrame. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestanimationframe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3460,
            "use.counter.page",
            "window_webkitrequestanimationframe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrequestfilesystem
    ///
    /// Whether a page called called Window.webkitRequestFileSystem. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrequestfilesystem: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3461,
            "use.counter.page",
            "window_webkitrequestfilesystem",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitresolvelocalfilesystemurl
    ///
    /// Whether a page called called Window.webkitResolveLocalFileSystemURL. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitresolvelocalfilesystemurl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3462,
            "use.counter.page",
            "window_webkitresolvelocalfilesystemurl",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitrtcpeerconnection
    ///
    /// Whether a page called called Window.webkitRTCPeerConnection. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitrtcpeerconnection: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3463,
            "use.counter.page",
            "window_webkitrtcpeerconnection",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammar
    ///
    /// Whether a page called called Window.webkitSpeechGrammar. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammar: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3464,
            "use.counter.page",
            "window_webkitspeechgrammar",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechgrammarlist
    ///
    /// Whether a page called called Window.webkitSpeechGrammarList. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechgrammarlist: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3465,
            "use.counter.page",
            "window_webkitspeechgrammarlist",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognition
    ///
    /// Whether a page called called Window.webkitSpeechRecognition. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognition: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3466,
            "use.counter.page",
            "window_webkitspeechrecognition",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionerror
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionError. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionerror: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3467,
            "use.counter.page",
            "window_webkitspeechrecognitionerror",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitspeechrecognitionevent
    ///
    /// Whether a page called called Window.webkitSpeechRecognitionEvent. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitspeechrecognitionevent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3468,
            "use.counter.page",
            "window_webkitspeechrecognitionevent",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.window_webkitstorageinfo
    ///
    /// Whether a page called called Window.webkitStorageInfo. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static window_webkitstorageinfo: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3469,
            "use.counter.page",
            "window_webkitstorageinfo",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.wr_filter_fallback
    ///
    /// Whether a page triggers the blob fallback for an SVG filter.. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static wr_filter_fallback: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3470,
            "use.counter.page",
            "wr_filter_fallback",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xslstylesheet
    ///
    /// Whether a page uses an XSL Stylesheet. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xslstylesheet: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3471,
            "use.counter.page",
            "xslstylesheet",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.xsltprocessor_constructor
    ///
    /// Whether a page called called XSLTProcessor.constructor. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static xsltprocessor_constructor: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3472,
            "use.counter.page",
            "xsltprocessor_constructor",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.page.you_tube_flash_embed
    ///
    /// Whether a page in <object> or <embed>. Compare against `use.counter.top_level_content_documents_destroyed` to calculate the rate.
    pub static you_tube_flash_embed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3473,
            "use.counter.page",
            "you_tube_flash_embed",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_dedicated {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_assert
    ///
    /// Whether a dedicated worker called called console.assert. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3474,
            "use.counter.worker.dedicated",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_clear
    ///
    /// Whether a dedicated worker called called console.clear. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3475,
            "use.counter.worker.dedicated",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_count
    ///
    /// Whether a dedicated worker called called console.count. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3476,
            "use.counter.worker.dedicated",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_countreset
    ///
    /// Whether a dedicated worker called called console.countReset. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3477,
            "use.counter.worker.dedicated",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_debug
    ///
    /// Whether a dedicated worker called called console.debug. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3478,
            "use.counter.worker.dedicated",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dir
    ///
    /// Whether a dedicated worker called called console.dir. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3479,
            "use.counter.worker.dedicated",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_dirxml
    ///
    /// Whether a dedicated worker called called console.dirxml. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3480,
            "use.counter.worker.dedicated",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_error
    ///
    /// Whether a dedicated worker called called console.error. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3481,
            "use.counter.worker.dedicated",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_exception
    ///
    /// Whether a dedicated worker called called console.exception. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3482,
            "use.counter.worker.dedicated",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_group
    ///
    /// Whether a dedicated worker called called console.group. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3483,
            "use.counter.worker.dedicated",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupcollapsed
    ///
    /// Whether a dedicated worker called called console.groupCollapsed. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3484,
            "use.counter.worker.dedicated",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_groupend
    ///
    /// Whether a dedicated worker called called console.groupEnd. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3485,
            "use.counter.worker.dedicated",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_info
    ///
    /// Whether a dedicated worker called called console.info. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3486,
            "use.counter.worker.dedicated",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_log
    ///
    /// Whether a dedicated worker called called console.log. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3487,
            "use.counter.worker.dedicated",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profile
    ///
    /// Whether a dedicated worker called called console.profile. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3488,
            "use.counter.worker.dedicated",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_profileend
    ///
    /// Whether a dedicated worker called called console.profileEnd. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3489,
            "use.counter.worker.dedicated",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_table
    ///
    /// Whether a dedicated worker called called console.table. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3490,
            "use.counter.worker.dedicated",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_time
    ///
    /// Whether a dedicated worker called called console.time. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3491,
            "use.counter.worker.dedicated",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timeend
    ///
    /// Whether a dedicated worker called called console.timeEnd. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3492,
            "use.counter.worker.dedicated",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timelog
    ///
    /// Whether a dedicated worker called called console.timeLog. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3493,
            "use.counter.worker.dedicated",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_timestamp
    ///
    /// Whether a dedicated worker called called console.timeStamp. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3494,
            "use.counter.worker.dedicated",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_trace
    ///
    /// Whether a dedicated worker called called console.trace. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3495,
            "use.counter.worker.dedicated",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.console_warn
    ///
    /// Whether a dedicated worker called called console.warn. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3496,
            "use.counter.worker.dedicated",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.cookiestore_delete
    ///
    /// Whether a dedicated worker called called CookieStore.delete. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static cookiestore_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3497,
            "use.counter.worker.dedicated",
            "cookiestore_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.cookiestore_get
    ///
    /// Whether a dedicated worker called called CookieStore.get. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static cookiestore_get: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3498,
            "use.counter.worker.dedicated",
            "cookiestore_get",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.cookiestore_getall
    ///
    /// Whether a dedicated worker called called CookieStore.getAll. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static cookiestore_getall: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3499,
            "use.counter.worker.dedicated",
            "cookiestore_getall",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.cookiestore_set
    ///
    /// Whether a dedicated worker called called CookieStore.set. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static cookiestore_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3500,
            "use.counter.worker.dedicated",
            "cookiestore_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_deriveexporter
    ///
    /// Whether a dedicated worker called called MLS.deriveExporter. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_deriveexporter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3501,
            "use.counter.worker.dedicated",
            "mls_deriveexporter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_generatecredentialbasic
    ///
    /// Whether a dedicated worker called called MLS.generateCredentialBasic. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_generatecredentialbasic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3502,
            "use.counter.worker.dedicated",
            "mls_generatecredentialbasic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_generatekeypackage
    ///
    /// Whether a dedicated worker called called MLS.generateKeyPackage. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_generatekeypackage: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3503,
            "use.counter.worker.dedicated",
            "mls_generatekeypackage",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_generatesignaturekeypair
    ///
    /// Whether a dedicated worker called called MLS.generateSignatureKeypair. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_generatesignaturekeypair: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3504,
            "use.counter.worker.dedicated",
            "mls_generatesignaturekeypair",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupadd
    ///
    /// Whether a dedicated worker called called MLS.groupAdd. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3505,
            "use.counter.worker.dedicated",
            "mls_groupadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupclose
    ///
    /// Whether a dedicated worker called called MLS.groupClose. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupclose: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3506,
            "use.counter.worker.dedicated",
            "mls_groupclose",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupcreate
    ///
    /// Whether a dedicated worker called called MLS.groupCreate. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupcreate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3507,
            "use.counter.worker.dedicated",
            "mls_groupcreate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupjoin
    ///
    /// Whether a dedicated worker called called MLS.groupJoin. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupjoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3508,
            "use.counter.worker.dedicated",
            "mls_groupjoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupmembers
    ///
    /// Whether a dedicated worker called called MLS.groupMembers. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupmembers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3509,
            "use.counter.worker.dedicated",
            "mls_groupmembers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupproposeadd
    ///
    /// Whether a dedicated worker called called MLS.groupProposeAdd. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3510,
            "use.counter.worker.dedicated",
            "mls_groupproposeadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupproposeremove
    ///
    /// Whether a dedicated worker called called MLS.groupProposeRemove. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3511,
            "use.counter.worker.dedicated",
            "mls_groupproposeremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_groupremove
    ///
    /// Whether a dedicated worker called called MLS.groupRemove. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_groupremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3512,
            "use.counter.worker.dedicated",
            "mls_groupremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_receive
    ///
    /// Whether a dedicated worker called called MLS.receive. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_receive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3513,
            "use.counter.worker.dedicated",
            "mls_receive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_send
    ///
    /// Whether a dedicated worker called called MLS.send. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3514,
            "use.counter.worker.dedicated",
            "mls_send",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_statedelete
    ///
    /// Whether a dedicated worker called called MLS.stateDelete. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_statedelete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3515,
            "use.counter.worker.dedicated",
            "mls_statedelete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.mls_statedeletegroup
    ///
    /// Whether a dedicated worker called called MLS.stateDeleteGroup. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static mls_statedeletegroup: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3516,
            "use.counter.worker.dedicated",
            "mls_statedeletegroup",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_delete
    ///
    /// Whether a dedicated worker calls caches.delete in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3517,
            "use.counter.worker.dedicated",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_has
    ///
    /// Whether a dedicated worker calls caches.has in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3518,
            "use.counter.worker.dedicated",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_keys
    ///
    /// Whether a dedicated worker calls caches.keys in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3519,
            "use.counter.worker.dedicated",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_match
    ///
    /// Whether a dedicated worker calls caches.match in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3520,
            "use.counter.worker.dedicated",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_caches_open
    ///
    /// Whether a dedicated worker calls caches.open in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3521,
            "use.counter.worker.dedicated",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_delete_database
    ///
    /// Whether a dedicated worker calls indexedDB.deleteDatabase in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3522,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.private_browsing_idbfactory_open
    ///
    /// Whether a dedicated worker calls indexedDB.open in Private Browsing Mode. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3523,
            "use.counter.worker.dedicated",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushmanager_subscribe
    ///
    /// Whether a dedicated worker called called PushManager.subscribe. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3524,
            "use.counter.worker.dedicated",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.pushsubscription_unsubscribe
    ///
    /// Whether a dedicated worker called called PushSubscription.unsubscribe. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3525,
            "use.counter.worker.dedicated",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.dedicated.scheduler_posttask
    ///
    /// Whether a dedicated worker called called Scheduler.postTask. Compare against `use.counter.dedicated_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3526,
            "use.counter.worker.dedicated",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_assert
    ///
    /// Whether a service worker called called console.assert. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3527,
            "use.counter.worker.service",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_clear
    ///
    /// Whether a service worker called called console.clear. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3528,
            "use.counter.worker.service",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_count
    ///
    /// Whether a service worker called called console.count. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3529,
            "use.counter.worker.service",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_countreset
    ///
    /// Whether a service worker called called console.countReset. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3530,
            "use.counter.worker.service",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_debug
    ///
    /// Whether a service worker called called console.debug. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3531,
            "use.counter.worker.service",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dir
    ///
    /// Whether a service worker called called console.dir. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3532,
            "use.counter.worker.service",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_dirxml
    ///
    /// Whether a service worker called called console.dirxml. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3533,
            "use.counter.worker.service",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_error
    ///
    /// Whether a service worker called called console.error. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3534,
            "use.counter.worker.service",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_exception
    ///
    /// Whether a service worker called called console.exception. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3535,
            "use.counter.worker.service",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_group
    ///
    /// Whether a service worker called called console.group. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3536,
            "use.counter.worker.service",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupcollapsed
    ///
    /// Whether a service worker called called console.groupCollapsed. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3537,
            "use.counter.worker.service",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_groupend
    ///
    /// Whether a service worker called called console.groupEnd. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3538,
            "use.counter.worker.service",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_info
    ///
    /// Whether a service worker called called console.info. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3539,
            "use.counter.worker.service",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_log
    ///
    /// Whether a service worker called called console.log. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3540,
            "use.counter.worker.service",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profile
    ///
    /// Whether a service worker called called console.profile. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3541,
            "use.counter.worker.service",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_profileend
    ///
    /// Whether a service worker called called console.profileEnd. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3542,
            "use.counter.worker.service",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_table
    ///
    /// Whether a service worker called called console.table. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3543,
            "use.counter.worker.service",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_time
    ///
    /// Whether a service worker called called console.time. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3544,
            "use.counter.worker.service",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timeend
    ///
    /// Whether a service worker called called console.timeEnd. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3545,
            "use.counter.worker.service",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timelog
    ///
    /// Whether a service worker called called console.timeLog. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3546,
            "use.counter.worker.service",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_timestamp
    ///
    /// Whether a service worker called called console.timeStamp. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3547,
            "use.counter.worker.service",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_trace
    ///
    /// Whether a service worker called called console.trace. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3548,
            "use.counter.worker.service",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.console_warn
    ///
    /// Whether a service worker called called console.warn. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3549,
            "use.counter.worker.service",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.cookiestore_delete
    ///
    /// Whether a service worker called called CookieStore.delete. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static cookiestore_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3550,
            "use.counter.worker.service",
            "cookiestore_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.cookiestore_get
    ///
    /// Whether a service worker called called CookieStore.get. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static cookiestore_get: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3551,
            "use.counter.worker.service",
            "cookiestore_get",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.cookiestore_getall
    ///
    /// Whether a service worker called called CookieStore.getAll. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static cookiestore_getall: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3552,
            "use.counter.worker.service",
            "cookiestore_getall",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.cookiestore_set
    ///
    /// Whether a service worker called called CookieStore.set. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static cookiestore_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3553,
            "use.counter.worker.service",
            "cookiestore_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_deriveexporter
    ///
    /// Whether a service worker called called MLS.deriveExporter. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_deriveexporter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3554,
            "use.counter.worker.service",
            "mls_deriveexporter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_generatecredentialbasic
    ///
    /// Whether a service worker called called MLS.generateCredentialBasic. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_generatecredentialbasic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3555,
            "use.counter.worker.service",
            "mls_generatecredentialbasic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_generatekeypackage
    ///
    /// Whether a service worker called called MLS.generateKeyPackage. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_generatekeypackage: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3556,
            "use.counter.worker.service",
            "mls_generatekeypackage",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_generatesignaturekeypair
    ///
    /// Whether a service worker called called MLS.generateSignatureKeypair. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_generatesignaturekeypair: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3557,
            "use.counter.worker.service",
            "mls_generatesignaturekeypair",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupadd
    ///
    /// Whether a service worker called called MLS.groupAdd. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3558,
            "use.counter.worker.service",
            "mls_groupadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupclose
    ///
    /// Whether a service worker called called MLS.groupClose. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupclose: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3559,
            "use.counter.worker.service",
            "mls_groupclose",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupcreate
    ///
    /// Whether a service worker called called MLS.groupCreate. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupcreate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3560,
            "use.counter.worker.service",
            "mls_groupcreate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupjoin
    ///
    /// Whether a service worker called called MLS.groupJoin. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupjoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3561,
            "use.counter.worker.service",
            "mls_groupjoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupmembers
    ///
    /// Whether a service worker called called MLS.groupMembers. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupmembers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3562,
            "use.counter.worker.service",
            "mls_groupmembers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupproposeadd
    ///
    /// Whether a service worker called called MLS.groupProposeAdd. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3563,
            "use.counter.worker.service",
            "mls_groupproposeadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupproposeremove
    ///
    /// Whether a service worker called called MLS.groupProposeRemove. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3564,
            "use.counter.worker.service",
            "mls_groupproposeremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_groupremove
    ///
    /// Whether a service worker called called MLS.groupRemove. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_groupremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3565,
            "use.counter.worker.service",
            "mls_groupremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_receive
    ///
    /// Whether a service worker called called MLS.receive. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_receive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3566,
            "use.counter.worker.service",
            "mls_receive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_send
    ///
    /// Whether a service worker called called MLS.send. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3567,
            "use.counter.worker.service",
            "mls_send",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_statedelete
    ///
    /// Whether a service worker called called MLS.stateDelete. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_statedelete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3568,
            "use.counter.worker.service",
            "mls_statedelete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.mls_statedeletegroup
    ///
    /// Whether a service worker called called MLS.stateDeleteGroup. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static mls_statedeletegroup: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3569,
            "use.counter.worker.service",
            "mls_statedeletegroup",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_delete
    ///
    /// Whether a service worker calls caches.delete in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3570,
            "use.counter.worker.service",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_has
    ///
    /// Whether a service worker calls caches.has in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3571,
            "use.counter.worker.service",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_keys
    ///
    /// Whether a service worker calls caches.keys in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3572,
            "use.counter.worker.service",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_match
    ///
    /// Whether a service worker calls caches.match in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3573,
            "use.counter.worker.service",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_caches_open
    ///
    /// Whether a service worker calls caches.open in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3574,
            "use.counter.worker.service",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_delete_database
    ///
    /// Whether a service worker calls indexedDB.deleteDatabase in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3575,
            "use.counter.worker.service",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.private_browsing_idbfactory_open
    ///
    /// Whether a service worker calls indexedDB.open in Private Browsing Mode. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3576,
            "use.counter.worker.service",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushmanager_subscribe
    ///
    /// Whether a service worker called called PushManager.subscribe. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3577,
            "use.counter.worker.service",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.pushsubscription_unsubscribe
    ///
    /// Whether a service worker called called PushSubscription.unsubscribe. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3578,
            "use.counter.worker.service",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.service.scheduler_posttask
    ///
    /// Whether a service worker called called Scheduler.postTask. Compare against `use.counter.service_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3579,
            "use.counter.worker.service",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod use_counter_worker_shared {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_assert
    ///
    /// Whether a shared worker called called console.assert. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_assert: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3580,
            "use.counter.worker.shared",
            "console_assert",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_clear
    ///
    /// Whether a shared worker called called console.clear. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_clear: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3581,
            "use.counter.worker.shared",
            "console_clear",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_count
    ///
    /// Whether a shared worker called called console.count. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3582,
            "use.counter.worker.shared",
            "console_count",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_countreset
    ///
    /// Whether a shared worker called called console.countReset. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_countreset: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3583,
            "use.counter.worker.shared",
            "console_countreset",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_debug
    ///
    /// Whether a shared worker called called console.debug. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_debug: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3584,
            "use.counter.worker.shared",
            "console_debug",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dir
    ///
    /// Whether a shared worker called called console.dir. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dir: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3585,
            "use.counter.worker.shared",
            "console_dir",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_dirxml
    ///
    /// Whether a shared worker called called console.dirxml. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_dirxml: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3586,
            "use.counter.worker.shared",
            "console_dirxml",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_error
    ///
    /// Whether a shared worker called called console.error. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_error: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3587,
            "use.counter.worker.shared",
            "console_error",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_exception
    ///
    /// Whether a shared worker called called console.exception. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_exception: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3588,
            "use.counter.worker.shared",
            "console_exception",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_group
    ///
    /// Whether a shared worker called called console.group. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_group: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3589,
            "use.counter.worker.shared",
            "console_group",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupcollapsed
    ///
    /// Whether a shared worker called called console.groupCollapsed. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupcollapsed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3590,
            "use.counter.worker.shared",
            "console_groupcollapsed",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_groupend
    ///
    /// Whether a shared worker called called console.groupEnd. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_groupend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3591,
            "use.counter.worker.shared",
            "console_groupend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_info
    ///
    /// Whether a shared worker called called console.info. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_info: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3592,
            "use.counter.worker.shared",
            "console_info",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_log
    ///
    /// Whether a shared worker called called console.log. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_log: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3593,
            "use.counter.worker.shared",
            "console_log",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profile
    ///
    /// Whether a shared worker called called console.profile. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3594,
            "use.counter.worker.shared",
            "console_profile",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_profileend
    ///
    /// Whether a shared worker called called console.profileEnd. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_profileend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3595,
            "use.counter.worker.shared",
            "console_profileend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_table
    ///
    /// Whether a shared worker called called console.table. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_table: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3596,
            "use.counter.worker.shared",
            "console_table",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_time
    ///
    /// Whether a shared worker called called console.time. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_time: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3597,
            "use.counter.worker.shared",
            "console_time",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timeend
    ///
    /// Whether a shared worker called called console.timeEnd. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timeend: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3598,
            "use.counter.worker.shared",
            "console_timeend",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timelog
    ///
    /// Whether a shared worker called called console.timeLog. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timelog: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3599,
            "use.counter.worker.shared",
            "console_timelog",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_timestamp
    ///
    /// Whether a shared worker called called console.timeStamp. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_timestamp: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3600,
            "use.counter.worker.shared",
            "console_timestamp",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_trace
    ///
    /// Whether a shared worker called called console.trace. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_trace: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3601,
            "use.counter.worker.shared",
            "console_trace",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.console_warn
    ///
    /// Whether a shared worker called called console.warn. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static console_warn: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3602,
            "use.counter.worker.shared",
            "console_warn",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.cookiestore_delete
    ///
    /// Whether a shared worker called called CookieStore.delete. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static cookiestore_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3603,
            "use.counter.worker.shared",
            "cookiestore_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.cookiestore_get
    ///
    /// Whether a shared worker called called CookieStore.get. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static cookiestore_get: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3604,
            "use.counter.worker.shared",
            "cookiestore_get",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.cookiestore_getall
    ///
    /// Whether a shared worker called called CookieStore.getAll. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static cookiestore_getall: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3605,
            "use.counter.worker.shared",
            "cookiestore_getall",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.cookiestore_set
    ///
    /// Whether a shared worker called called CookieStore.set. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static cookiestore_set: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3606,
            "use.counter.worker.shared",
            "cookiestore_set",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_deriveexporter
    ///
    /// Whether a shared worker called called MLS.deriveExporter. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_deriveexporter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3607,
            "use.counter.worker.shared",
            "mls_deriveexporter",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_generatecredentialbasic
    ///
    /// Whether a shared worker called called MLS.generateCredentialBasic. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_generatecredentialbasic: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3608,
            "use.counter.worker.shared",
            "mls_generatecredentialbasic",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_generatekeypackage
    ///
    /// Whether a shared worker called called MLS.generateKeyPackage. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_generatekeypackage: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3609,
            "use.counter.worker.shared",
            "mls_generatekeypackage",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_generatesignaturekeypair
    ///
    /// Whether a shared worker called called MLS.generateSignatureKeypair. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_generatesignaturekeypair: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3610,
            "use.counter.worker.shared",
            "mls_generatesignaturekeypair",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupadd
    ///
    /// Whether a shared worker called called MLS.groupAdd. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3611,
            "use.counter.worker.shared",
            "mls_groupadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupclose
    ///
    /// Whether a shared worker called called MLS.groupClose. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupclose: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3612,
            "use.counter.worker.shared",
            "mls_groupclose",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupcreate
    ///
    /// Whether a shared worker called called MLS.groupCreate. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupcreate: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3613,
            "use.counter.worker.shared",
            "mls_groupcreate",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupjoin
    ///
    /// Whether a shared worker called called MLS.groupJoin. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupjoin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3614,
            "use.counter.worker.shared",
            "mls_groupjoin",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupmembers
    ///
    /// Whether a shared worker called called MLS.groupMembers. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupmembers: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3615,
            "use.counter.worker.shared",
            "mls_groupmembers",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupproposeadd
    ///
    /// Whether a shared worker called called MLS.groupProposeAdd. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeadd: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3616,
            "use.counter.worker.shared",
            "mls_groupproposeadd",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupproposeremove
    ///
    /// Whether a shared worker called called MLS.groupProposeRemove. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupproposeremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3617,
            "use.counter.worker.shared",
            "mls_groupproposeremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_groupremove
    ///
    /// Whether a shared worker called called MLS.groupRemove. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_groupremove: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3618,
            "use.counter.worker.shared",
            "mls_groupremove",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_receive
    ///
    /// Whether a shared worker called called MLS.receive. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_receive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3619,
            "use.counter.worker.shared",
            "mls_receive",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_send
    ///
    /// Whether a shared worker called called MLS.send. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3620,
            "use.counter.worker.shared",
            "mls_send",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_statedelete
    ///
    /// Whether a shared worker called called MLS.stateDelete. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_statedelete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3621,
            "use.counter.worker.shared",
            "mls_statedelete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.mls_statedeletegroup
    ///
    /// Whether a shared worker called called MLS.stateDeleteGroup. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static mls_statedeletegroup: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3622,
            "use.counter.worker.shared",
            "mls_statedeletegroup",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_delete
    ///
    /// Whether a shared worker calls caches.delete in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_delete: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3623,
            "use.counter.worker.shared",
            "private_browsing_caches_delete",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_has
    ///
    /// Whether a shared worker calls caches.has in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_has: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3624,
            "use.counter.worker.shared",
            "private_browsing_caches_has",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_keys
    ///
    /// Whether a shared worker calls caches.keys in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_keys: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3625,
            "use.counter.worker.shared",
            "private_browsing_caches_keys",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_match
    ///
    /// Whether a shared worker calls caches.match in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_match: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3626,
            "use.counter.worker.shared",
            "private_browsing_caches_match",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_caches_open
    ///
    /// Whether a shared worker calls caches.open in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_caches_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3627,
            "use.counter.worker.shared",
            "private_browsing_caches_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_delete_database
    ///
    /// Whether a shared worker calls indexedDB.deleteDatabase in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_delete_database: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3628,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_delete_database",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.private_browsing_idbfactory_open
    ///
    /// Whether a shared worker calls indexedDB.open in Private Browsing Mode. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static private_browsing_idbfactory_open: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3629,
            "use.counter.worker.shared",
            "private_browsing_idbfactory_open",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushmanager_subscribe
    ///
    /// Whether a shared worker called called PushManager.subscribe. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushmanager_subscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3630,
            "use.counter.worker.shared",
            "pushmanager_subscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.pushsubscription_unsubscribe
    ///
    /// Whether a shared worker called called PushSubscription.unsubscribe. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static pushsubscription_unsubscribe: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3631,
            "use.counter.worker.shared",
            "pushsubscription_unsubscribe",
            "use-counters"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from use.counter.worker.shared.scheduler_posttask
    ///
    /// Whether a shared worker called called Scheduler.postTask. Compare against `use.counter.shared_workers_destroyed` to calculate the rate.
    pub static scheduler_posttask: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3632,
            "use.counter.worker.shared",
            "scheduler_posttask",
            "use-counters"
        )
    });

}
pub mod canvas {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum Used2dLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for Used2dLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Used2dLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from canvas.used_2d
    ///
    /// 2D canvas used
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CANVAS_2D_USED.
    pub static used_2d: Lazy<LabeledMetric<LabeledCounterMetric, Used2dLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "used_2d".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3633), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum Webgl2SuccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for Webgl2SuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Webgl2SuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from canvas.webgl2_success
    ///
    /// WebGL2 creation success
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CANVAS_WEBGL2_SUCCESS.
    pub static webgl2_success: Lazy<LabeledMetric<LabeledCounterMetric, Webgl2SuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webgl2_success".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3634), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from canvas.webgl_accl_failure_id
    ///
    /// Track the failure IDs that lead us to reject attempting to create an accelerated context. CANVAS_WEBGL_FAILURE_ID reports the overall WebGL status with the attempt to fallback.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram CANVAS_WEBGL_ACCL_FAILURE_ID.
    pub static webgl_accl_failure_id: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webgl_accl_failure_id".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3635), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from canvas.webgl_failure_id
    ///
    /// WebGL runtime and dynamic failure IDs. This will record a count for each context creation success or failure. Each failure id is a unique identifier that can be traced back to a particular failure branch or blocklist rule.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram CANVAS_WEBGL_FAILURE_ID.
    pub static webgl_failure_id: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webgl_failure_id".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3636), meta, None)
    });

    #[repr(u16)]
    pub enum WebglSuccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WebglSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WebglSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from canvas.webgl_success
    ///
    /// WebGL1 creation success
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CANVAS_WEBGL_SUCCESS.
    pub static webgl_success: Lazy<LabeledMetric<LabeledCounterMetric, WebglSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webgl_success".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3637), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum WebglUsedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WebglUsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WebglUsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from canvas.webgl_used
    ///
    /// WebGL canvas used
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CANVAS_WEBGL_USED.
    pub static webgl_used: Lazy<LabeledMetric<LabeledCounterMetric, WebglUsedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webgl_used".into(),
                    category: "canvas".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3638), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod webcrypto {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.alg
    ///
    /// Algorithms used with WebCrypto (see table in WebCryptoTask.cpp)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBCRYPTO_ALG.
    pub static alg: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "alg".into(),
                category: "webcrypto".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3639), meta, 0, 30, 31, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ExtractableEncLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ExtractableEncLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ExtractableEncLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.extractable_enc
    ///
    /// Whether a key used in an encrypt/decrypt operation was marked as extractable
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBCRYPTO_EXTRACTABLE_ENC.
    pub static extractable_enc: Lazy<LabeledMetric<LabeledCounterMetric, ExtractableEncLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "extractable_enc".into(),
                    category: "webcrypto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3640), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ExtractableGenerateLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ExtractableGenerateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ExtractableGenerateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.extractable_generate
    ///
    /// Whether a generated key was marked as extractable
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBCRYPTO_EXTRACTABLE_GENERATE.
    pub static extractable_generate: Lazy<LabeledMetric<LabeledCounterMetric, ExtractableGenerateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "extractable_generate".into(),
                    category: "webcrypto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3641), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ExtractableImportLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ExtractableImportLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ExtractableImportLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.extractable_import
    ///
    /// Whether an imported key was marked as extractable
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBCRYPTO_EXTRACTABLE_IMPORT.
    pub static extractable_import: Lazy<LabeledMetric<LabeledCounterMetric, ExtractableImportLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "extractable_import".into(),
                    category: "webcrypto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3642), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ExtractableSigLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ExtractableSigLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ExtractableSigLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.extractable_sig
    ///
    /// Whether a key used in a sign/verify operation was marked as extractable
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBCRYPTO_EXTRACTABLE_SIG.
    pub static extractable_sig: Lazy<LabeledMetric<LabeledCounterMetric, ExtractableSigLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "extractable_sig".into(),
                    category: "webcrypto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3643), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.method
    ///
    /// Methods invoked under window.crypto.subtle (0=encrypt, 1=decrypt, 2=sign, 3=verify, 4=digest, 5=generateKey, 6=deriveKey, 7=deriveBits, 8=importKey, 9=exportKey, 10=wrapKey, 11=unwrapKey)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBCRYPTO_METHOD.
    pub static method: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "method".into(),
                category: "webcrypto".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3644), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ResolvedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ResolvedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResolvedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcrypto.resolved
    ///
    /// Whether a promise created by WebCrypto was resolved (vs rejected)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBCRYPTO_RESOLVED.
    pub static resolved: Lazy<LabeledMetric<LabeledCounterMetric, ResolvedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "resolved".into(),
                    category: "webcrypto".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3645), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod geolocation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geolocation.accuracy
    ///
    /// Accuracy returned by the Geolocation API
    pub static accuracy: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "accuracy".into(),
                category: "geolocation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3646), meta, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum FallbackLabel {
        ENone = 0,
        EOnError = 1,
        EOnTimeout = 2,
        __Other__,
    }
    impl From<u16> for FallbackLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EOnError,
                2 => Self::EOnTimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FallbackLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EOnError => "on_error",
                Self::EOnTimeout => "on_timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.fallback
    ///
    /// Whether the default provider falled back to NetworkGeolocationProvider.
    pub static fallback: Lazy<LabeledMetric<LabeledCounterMetric, FallbackLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fallback".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3647), meta, Some(vec![::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("on_error"), ::std::borrow::Cow::from("on_timeout")]))
    });

    #[repr(u16)]
    pub enum LinuxProviderLabel {
        ENone = 0,
        EPortal = 1,
        EGeoclue = 2,
        __Other__,
    }
    impl From<u16> for LinuxProviderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EPortal,
                2 => Self::EGeoclue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LinuxProviderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EPortal => "portal",
                Self::EGeoclue => "geoclue",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.linux_provider
    ///
    /// Which system provider are we using on Linux
    pub static linux_provider: Lazy<LabeledMetric<LabeledBooleanMetric, LinuxProviderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "linux_provider".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3648), meta, Some(vec![::std::borrow::Cow::from("geoclue"), ::std::borrow::Cow::from("none"), ::std::borrow::Cow::from("portal")]))
    });

    #[repr(u16)]
    pub enum RequestResultLabel {
        ESuccess = 0,
        EPermissionDenied = 1,
        EPositionUnavailable = 2,
        ETimeout = 3,
        __Other__,
    }
    impl From<u16> for RequestResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EPermissionDenied,
                2 => Self::EPositionUnavailable,
                3 => Self::ETimeout,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EPermissionDenied => "permission_denied",
                Self::EPositionUnavailable => "position_unavailable",
                Self::ETimeout => "timeout",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from geolocation.request_result
    ///
    /// The result for each geolocation request. Success label will only happen once for each request, even if it's a watch request.
    pub static request_result: Lazy<LabeledMetric<LabeledCounterMetric, RequestResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_result".into(),
                    category: "geolocation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3649), meta, Some(vec![::std::borrow::Cow::from("permission_denied"), ::std::borrow::Cow::from("position_unavailable"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("timeout")]))
    });

}
pub mod localstorage_database {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from localstorage.database.new_object_setup_time
    ///
    /// Measures the time taken for the content process to fully set up a new database, including any time required for datastore preparation in the parent process. This duration can be significantly affected by datastore preloading, which is triggered when a page begins loading. If an error occurs, the time is not recorded.
    pub static new_object_setup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_object_setup_time".into(),
                category: "localstorage.database".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3650), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from localstorage.database.request_allow_to_close_response_time
    ///
    /// Time it took between sending PBackgroundLSDatabase::RequestAllowToClose and receiving PBackgroundLSDatabase::AllowToClose message. These messages are issued when QuotaManager is shutting down or is aborting operations for a particular origin or process.
    pub static request_allow_to_close_response_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_allow_to_close_response_time".into(),
                category: "localstorage.database".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3651), meta, TimeUnit::Microsecond)
    });

}
pub mod localstorage_request {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from localstorage.request.prepare_datastore_processing_time
    ///
    /// Measures the time taken by the parent process to prepare a datastore. This duration can be significantly affected by datastore preloading, which is triggered when a page begins to load. When a datastore is already preloaded, preparation is usually fast since no additional I/O is required. If an error occurs, the time is not recorded. In the future, we may introduce separate metrics to distinguish between different types of datastore preparations (e.g., loading data from disk vs. using preloaded data).
    pub static prepare_datastore_processing_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prepare_datastore_processing_time".into(),
                category: "localstorage.request".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3652), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from localstorage.request.recv_cancel_counter
    ///
    /// Increments whenever a request cancellation message is successfully received. This includes cancellations for requests related to either databases or observers.
    pub static recv_cancel_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3653,
            "localstorage.request",
            "recv_cancel_counter",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from localstorage.request.send_cancel_counter
    ///
    /// Increments whenever a request cancellation message is successfully sent. This includes cancellations for requests related to either databases or observers.
    pub static send_cancel_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3654,
            "localstorage.request",
            "send_cancel_counter",
            "metrics"
        )
    });

}
pub mod mediadrm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum DecryptionLabel {
        EHasHardwareDecryption = 0,
        EHasHardwareClearlead = 1,
        EHasSoftwareClearlead = 2,
        EHasHdcp22Plus = 3,
        EHasWmf = 4,
        __Other__,
    }
    impl From<u16> for DecryptionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHasHardwareDecryption,
                1 => Self::EHasHardwareClearlead,
                2 => Self::EHasSoftwareClearlead,
                3 => Self::EHasHdcp22Plus,
                4 => Self::EHasWmf,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecryptionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHasHardwareDecryption => "has_hardware_decryption",
                Self::EHasHardwareClearlead => "has_hardware_clearlead",
                Self::EHasSoftwareClearlead => "has_software_clearlead",
                Self::EHasHdcp22Plus => "has_hdcp22_plus",
                Self::EHasWmf => "has_wmf",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mediadrm.decryption
    ///
    /// Record the statuses related with the media decryption.
    pub static decryption: Lazy<LabeledMetric<LabeledBooleanMetric, DecryptionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decryption".into(),
                    category: "mediadrm".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3655), meta, Some(vec![::std::borrow::Cow::from("has_hardware_clearlead"), ::std::borrow::Cow::from("has_hardware_decryption"), ::std::borrow::Cow::from("has_hdcp22_plus"), ::std::borrow::Cow::from("has_software_clearlead"), ::std::borrow::Cow::from("has_wmf")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EmePlaybackExtra {
        pub r#key_system: Option<String>,
        pub r#played_time: Option<u32>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key_system", "played_time", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mediadrm.eme_playback
    ///
    /// Record the EME play time with the video codec and resolutions.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eme_playback".into(),
                category: "mediadrm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3656), meta)
    });

}
pub mod hls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_requested
    ///
    /// Record when a page requests canPlayType for a HLS media type.
    pub static canplay_requested: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3657,
            "hls",
            "canplay_requested",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from hls.canplay_supported
    ///
    /// Record when a canPlayType request supports HLS.
    pub static canplay_supported: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3658,
            "hls",
            "canplay_supported",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MediaLoadExtra {
        pub r#media_extension: Option<String>,
    }

    impl ExtraKeys for MediaLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["media_extension"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#media_extension.and_then(|val| map.insert("media_extension".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from hls.media_load
    ///
    /// Record the information about the HLS playback on Android using ExoPlayer. The value of this event contains the media format.
    pub static media_load: Lazy<EventMetric<MediaLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_load".into(),
                category: "hls".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3659), meta)
    });

}
pub mod gmp {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum UpdateXmlFetchResultLabel {
        ECertPinSuccess = 0,
        ECertPinNetRequestError = 1,
        ECertPinNetTimeout = 2,
        ECertPinAbort = 3,
        ECertPinMissingData = 4,
        ECertPinFailed = 5,
        ECertPinInvalid = 6,
        ECertPinXmlParseError = 7,
        ECertPinUnknownError = 8,
        EContentSigSuccess = 9,
        EContentSigNetRequestError = 10,
        EContentSigNetTimeout = 11,
        EContentSigAbort = 12,
        EContentSigMissingData = 13,
        EContentSigFailed = 14,
        EContentSigInvalid = 15,
        EContentSigXmlParseError = 16,
        EContentSigUnknownError = 17,
        __Other__,
    }
    impl From<u16> for UpdateXmlFetchResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECertPinSuccess,
                1 => Self::ECertPinNetRequestError,
                2 => Self::ECertPinNetTimeout,
                3 => Self::ECertPinAbort,
                4 => Self::ECertPinMissingData,
                5 => Self::ECertPinFailed,
                6 => Self::ECertPinInvalid,
                7 => Self::ECertPinXmlParseError,
                8 => Self::ECertPinUnknownError,
                9 => Self::EContentSigSuccess,
                10 => Self::EContentSigNetRequestError,
                11 => Self::EContentSigNetTimeout,
                12 => Self::EContentSigAbort,
                13 => Self::EContentSigMissingData,
                14 => Self::EContentSigFailed,
                15 => Self::EContentSigInvalid,
                16 => Self::EContentSigXmlParseError,
                17 => Self::EContentSigUnknownError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UpdateXmlFetchResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECertPinSuccess => "cert_pin_success",
                Self::ECertPinNetRequestError => "cert_pin_net_request_error",
                Self::ECertPinNetTimeout => "cert_pin_net_timeout",
                Self::ECertPinAbort => "cert_pin_abort",
                Self::ECertPinMissingData => "cert_pin_missing_data",
                Self::ECertPinFailed => "cert_pin_failed",
                Self::ECertPinInvalid => "cert_pin_invalid",
                Self::ECertPinXmlParseError => "cert_pin_xml_parse_error",
                Self::ECertPinUnknownError => "cert_pin_unknown_error",
                Self::EContentSigSuccess => "content_sig_success",
                Self::EContentSigNetRequestError => "content_sig_net_request_error",
                Self::EContentSigNetTimeout => "content_sig_net_timeout",
                Self::EContentSigAbort => "content_sig_abort",
                Self::EContentSigMissingData => "content_sig_missing_data",
                Self::EContentSigFailed => "content_sig_failed",
                Self::EContentSigInvalid => "content_sig_invalid",
                Self::EContentSigXmlParseError => "content_sig_xml_parse_error",
                Self::EContentSigUnknownError => "content_sig_unknown_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gmp.update_xml_fetch_result
    ///
    /// The result of Gecko fetching an update.xml from Balrog. This captures 3 different data points: success or failure of the request, if cert pinning or content signatures were used to verify the result, and the reason for failure, if the request failed.
    pub static update_xml_fetch_result: Lazy<LabeledMetric<LabeledCounterMetric, UpdateXmlFetchResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "update_xml_fetch_result".into(),
                    category: "gmp".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3660), meta, Some(vec![::std::borrow::Cow::from("cert_pin_abort"), ::std::borrow::Cow::from("cert_pin_failed"), ::std::borrow::Cow::from("cert_pin_invalid"), ::std::borrow::Cow::from("cert_pin_missing_data"), ::std::borrow::Cow::from("cert_pin_net_request_error"), ::std::borrow::Cow::from("cert_pin_net_timeout"), ::std::borrow::Cow::from("cert_pin_success"), ::std::borrow::Cow::from("cert_pin_unknown_error"), ::std::borrow::Cow::from("cert_pin_xml_parse_error"), ::std::borrow::Cow::from("content_sig_abort"), ::std::borrow::Cow::from("content_sig_failed"), ::std::borrow::Cow::from("content_sig_invalid"), ::std::borrow::Cow::from("content_sig_missing_data"), ::std::borrow::Cow::from("content_sig_net_request_error"), ::std::borrow::Cow::from("content_sig_net_timeout"), ::std::borrow::Cow::from("content_sig_success"), ::std::borrow::Cow::from("content_sig_unknown_error"), ::std::borrow::Cow::from("content_sig_xml_parse_error")]))
    });

}
pub mod media {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from media.audible_play_time_percent
    ///
    /// Percentage of time spent playing media with an audible audio track, regardless of the volume. Keyed by audio-only or video presence.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram AUDIBLE_PLAY_TIME_PERCENT.
    pub static audible_play_time_percent: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "audible_play_time_percent".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 50, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3661), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.codec_used
    ///
    /// Count of use of audio/video codecs in HTMLMediaElements and WebAudio. Those with 'resource' prefix are approximate; report based on HTTP ContentType or sniffing. Those with 'webaudio' prefix are for WebAudio.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram MEDIA_CODEC_USED.
    pub static codec_used: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "codec_used".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3662), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.element_in_page_count
    ///
    /// The number of times a document hierarchy contained at least one HTMLMediaElement. In addition, the telemetry probe 'MIXED_CONTENT_UNBLOCK_COUNTER' records the total number of loaded top level content documents, which can help us calculate the result of the percentage of documents using media. This metric was generated to correspond to the Legacy Telemetry scalar media.element_in_page_count.
    pub static element_in_page_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3663,
            "media",
            "element_in_page_count",
            "metrics"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#error_name: Option<String>,
        pub r#error_type: Option<String>,
        pub r#key_system: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_name", "error_type", "key_system"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#error_type.and_then(|val| map.insert("error_type".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.error
    ///
    /// Record the error details happened on a media element.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "media".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3664), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.media_play_time
    ///
    /// Total time spent playing media in milliseconds, keyed by its content (Audio and video, audio only, video only, audio and video but audio inaudible, audio and video but audio muted).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEDIA_PLAY_TIME_MS.
    pub static media_play_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "media_play_time".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3665), meta, None)
    });

    #[repr(u16)]
    pub enum MseSourceBufferTypeLabel {
        EVideohevc = 0,
        EVideowebm = 1,
        EAudiowebm = 2,
        EVideomp4 = 3,
        EAudiomp4 = 4,
        EVideomp2t = 5,
        EAudiomp2t = 6,
        EAudiompeg = 7,
        EAudioaac = 8,
        __Other__,
    }
    impl From<u16> for MseSourceBufferTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EVideohevc,
                1 => Self::EVideowebm,
                2 => Self::EAudiowebm,
                3 => Self::EVideomp4,
                4 => Self::EAudiomp4,
                5 => Self::EVideomp2t,
                6 => Self::EAudiomp2t,
                7 => Self::EAudiompeg,
                8 => Self::EAudioaac,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MseSourceBufferTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EVideohevc => "VideoHevc",
                Self::EVideowebm => "VideoWebm",
                Self::EAudiowebm => "AudioWebm",
                Self::EVideomp4 => "VideoMp4",
                Self::EAudiomp4 => "AudioMp4",
                Self::EVideomp2t => "VideoMp2t",
                Self::EAudiomp2t => "AudioMp2t",
                Self::EAudiompeg => "AudioMpeg",
                Self::EAudioaac => "AudioAac",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.mse_source_buffer_type
    ///
    /// Count the actual or possible (because we don't support some of them for now) usage amount for each media mime type used in MSE. We collect this data in MediaSource's `AddSourceBuffer()` and `IsTypeSupported()`.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram MSE_SOURCE_BUFFER_TYPE.
    pub static mse_source_buffer_type: Lazy<LabeledMetric<LabeledCounterMetric, MseSourceBufferTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mse_source_buffer_type".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3666), meta, Some(vec![::std::borrow::Cow::from("AudioAac"), ::std::borrow::Cow::from("AudioMp2t"), ::std::borrow::Cow::from("AudioMp4"), ::std::borrow::Cow::from("AudioMpeg"), ::std::borrow::Cow::from("AudioWebm"), ::std::borrow::Cow::from("VideoHevc"), ::std::borrow::Cow::from("VideoMp2t"), ::std::borrow::Cow::from("VideoMp4"), ::std::borrow::Cow::from("VideoWebm")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.muted_play_time_percent
    ///
    /// Percentage of time spent playing media that has an audio track, with the audio muted. Keyed by audio-only or video presence.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram MUTED_PLAY_TIME_PERCENT.
    pub static muted_play_time_percent: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "muted_play_time_percent".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 50, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3667), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_clearkey_play_time
    ///
    /// Total time spent playing Clearkey encrypted video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_CLEARKEY_PLAY_TIME_MS.
    pub static video_clearkey_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_clearkey_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3668), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_dropped_compositor_frames_proportion_exponential
    ///
    /// Ratio of compositor dropped frames per total decoded frames scaled by 10,000 between starting and stopping a video
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_DROPPED_COMPOSITOR_FRAMES_PROPORTION_EXPONENTIAL.
    pub static video_dropped_compositor_frames_proportion_exponential: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dropped_compositor_frames_proportion_exponential".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3669), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_dropped_decoded_frames_proportion_exponential
    ///
    /// Ratio of decoder dropped frames per total decoded frames scaled by 10,000 between starting and stopping a video
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_DROPPED_DECODED_FRAMES_PROPORTION_EXPONENTIAL.
    pub static video_dropped_decoded_frames_proportion_exponential: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dropped_decoded_frames_proportion_exponential".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3670), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_dropped_frames_proportion
    ///
    /// Percentage of frames decoded frames dropped between starting and stopping a video
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram VIDEO_DROPPED_FRAMES_PROPORTION.
    pub static video_dropped_frames_proportion: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dropped_frames_proportion".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3671), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_dropped_frames_proportion_exponential
    ///
    /// Ratio of dropped frames per total decoded frames scaled by 10,000 between starting and stopping a video
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_DROPPED_FRAMES_PROPORTION_EXPONENTIAL.
    pub static video_dropped_frames_proportion_exponential: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dropped_frames_proportion_exponential".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3672), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_dropped_sink_frames_proportion_exponential
    ///
    /// Ratio of sink dropped frames per total decoded frames scaled by 10,000 between starting and stopping a video
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_DROPPED_SINK_FRAMES_PROPORTION_EXPONENTIAL.
    pub static video_dropped_sink_frames_proportion_exponential: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_dropped_sink_frames_proportion_exponential".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3673), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_encrypted_play_time
    ///
    /// Total time spent playing encrypted video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_ENCRYPTED_PLAY_TIME_MS.
    pub static video_encrypted_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_encrypted_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3674), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hardware_decoding_support
    ///
    /// Record whether hardware decoding is supported for the specific video codec. The key is the type of video codec, eg. video/vp9. This metric was generated to correspond to the Legacy Telemetry scalar media.video_hardware_decoding_support.
    pub static video_hardware_decoding_support: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_hardware_decoding_support".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(BaseMetricId(3675), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hd_hardware_decoding_support
    ///
    /// Record whether hardware decoding is supported for the specific video codec, this only records video in HD (1280*720) or higher resultion. The key is the type of video codec, eg. video/vp9. This metric was generated to correspond to the Legacy Telemetry scalar media.video_hd_hardware_decoding_support.
    pub static video_hd_hardware_decoding_support: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_hd_hardware_decoding_support".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(BaseMetricId(3676), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hdr_play_time
    ///
    /// Total time spent playing HDR video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_HDR_PLAY_TIME_MS.
    pub static video_hdr_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_hdr_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3677), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hidden_play_time
    ///
    /// Total time spent playing video while element is hidden, in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_HIDDEN_PLAY_TIME_MS.
    pub static video_hidden_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_hidden_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3678), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_hidden_play_time_percentage
    ///
    /// Percentage of total time spent playing video while element is hidden. Keyed by audio presence and by height ranges (boundaries: 240. 480, 576, 720, 1080, 2160), e.g.: 'V,0<h<=240', 'AV,h>2160'; and 'All' will accumulate all percentages. This is reported whenever the decoder stops. (eg. pausing media, encountering an error, changing to a new resource, page goes to the bf-cached or page gets discarded)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram VIDEO_HIDDEN_PLAY_TIME_PERCENTAGE.
    pub static video_hidden_play_time_percentage: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "video_hidden_play_time_percentage".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 50, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3679), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_play_time
    ///
    /// Total time spent playing video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_PLAY_TIME_MS.
    pub static video_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3680), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_visible_play_time
    ///
    /// Total time spent playing visible video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_VISIBLE_PLAY_TIME_MS.
    pub static video_visible_play_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "video_visible_play_time".into(),
                    category: "media".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3681), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.video_widevine_play_time
    ///
    /// Total time spent playing Widevine encrypted video in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram VIDEO_WIDEVINE_PLAY_TIME_MS.
    pub static video_widevine_play_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_widevine_play_time".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3682), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.decoder_backend_used
    ///
    /// Media decoder backend (0=WMF Software, 1=DXVA2D3D9, 2=DXVA2D3D11)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram MEDIA_DECODER_BACKEND_USED.
    pub static decoder_backend_used: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "decoder_backend_used".into(),
                category: "media".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3683), meta, 0, 10, 11, HistogramType::Linear)
    });

}
pub mod media_audio {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BackendLabel {
        EUnknown = 0,
        EAudiounit = 1,
        EAudiounitRust = 2,
        EAaudio = 3,
        EOpensl = 4,
        EWasapi = 5,
        EWinmm = 6,
        EAlsa = 7,
        EJack = 8,
        EOss = 9,
        EPulse = 10,
        EPulseRust = 11,
        ESndio = 12,
        ESunaudio = 13,
        __Other__,
    }
    impl From<u16> for BackendLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EAudiounit,
                2 => Self::EAudiounitRust,
                3 => Self::EAaudio,
                4 => Self::EOpensl,
                5 => Self::EWasapi,
                6 => Self::EWinmm,
                7 => Self::EAlsa,
                8 => Self::EJack,
                9 => Self::EOss,
                10 => Self::EPulse,
                11 => Self::EPulseRust,
                12 => Self::ESndio,
                13 => Self::ESunaudio,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BackendLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EAudiounit => "audiounit",
                Self::EAudiounitRust => "audiounit-rust",
                Self::EAaudio => "aaudio",
                Self::EOpensl => "opensl",
                Self::EWasapi => "wasapi",
                Self::EWinmm => "winmm",
                Self::EAlsa => "alsa",
                Self::EJack => "jack",
                Self::EOss => "oss",
                Self::EPulse => "pulse",
                Self::EPulseRust => "pulse-rust",
                Self::ESndio => "sndio",
                Self::ESunaudio => "sunaudio",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.backend
    ///
    /// The operating system audio backend (Migrated from the geckoview metric of the same name).
    pub static backend: Lazy<LabeledMetric<LabeledCounterMetric, BackendLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "backend".into(),
                    category: "media.audio".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3684), meta, Some(vec![::std::borrow::Cow::from("aaudio"), ::std::borrow::Cow::from("alsa"), ::std::borrow::Cow::from("audiounit"), ::std::borrow::Cow::from("audiounit-rust"), ::std::borrow::Cow::from("jack"), ::std::borrow::Cow::from("opensl"), ::std::borrow::Cow::from("oss"), ::std::borrow::Cow::from("pulse"), ::std::borrow::Cow::from("pulse-rust"), ::std::borrow::Cow::from("sndio"), ::std::borrow::Cow::from("sunaudio"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("wasapi"), ::std::borrow::Cow::from("winmm")]))
    });

    #[repr(u16)]
    pub enum InitFailureLabel {
        EFirst = 0,
        EOther = 1,
        __Other__,
    }
    impl From<u16> for InitFailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirst,
                1 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitFailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirst => "first",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.audio.init_failure
    ///
    /// Failure occurs when initializing the audio stream. (Migrated from the geckoview metric of the same name).
    pub static init_failure: Lazy<LabeledMetric<LabeledCounterMetric, InitFailureLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "init_failure".into(),
                    category: "media.audio".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3685), meta, Some(vec![::std::borrow::Cow::from("first"), ::std::borrow::Cow::from("other")]))
    });

}
pub mod media_playback {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DecodeErrorExtra {
        pub r#decoder_name: Option<String>,
        pub r#error_name: Option<String>,
        pub r#is_hardware_accelerated: Option<bool>,
        pub r#key_system: Option<String>,
        pub r#mime_type: Option<String>,
    }

    impl ExtraKeys for DecodeErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["decoder_name", "error_name", "is_hardware_accelerated", "key_system", "mime_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#decoder_name.and_then(|val| map.insert("decoder_name".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#is_hardware_accelerated.and_then(|val| map.insert("is_hardware_accelerated".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#mime_type.and_then(|val| map.insert("mime_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.decode_error
    ///
    /// Record the decode error details.
    pub static decode_error: Lazy<EventMetric<DecodeErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "decode_error".into(),
                category: "media.playback".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3686), meta)
    });

    #[repr(u16)]
    pub enum DeviceHardwareDecoderSupportLabel {
        EH264 = 0,
        EVp8 = 1,
        EVp9 = 2,
        EAv1 = 3,
        EHevc = 4,
        __Other__,
    }
    impl From<u16> for DeviceHardwareDecoderSupportLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH264,
                1 => Self::EVp8,
                2 => Self::EVp9,
                3 => Self::EAv1,
                4 => Self::EHevc,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DeviceHardwareDecoderSupportLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH264 => "h264",
                Self::EVp8 => "vp8",
                Self::EVp9 => "vp9",
                Self::EAv1 => "av1",
                Self::EHevc => "hevc",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.device_hardware_decoder_support
    ///
    /// The results of hardware decoder support for different video codecs. True means that codec can be decoded by hardware on user's device.
    pub static device_hardware_decoder_support: Lazy<LabeledMetric<LabeledBooleanMetric, DeviceHardwareDecoderSupportLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "device_hardware_decoder_support".into(),
                    category: "media.playback".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3687), meta, Some(vec![::std::borrow::Cow::from("av1"), ::std::borrow::Cow::from("h264"), ::std::borrow::Cow::from("hevc"), ::std::borrow::Cow::from("vp8"), ::std::borrow::Cow::from("vp9")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FirstFrameLoadedExtra {
        pub r#buffering_time: Option<u32>,
        pub r#decoder_name: Option<String>,
        pub r#first_frame_loaded_time: Option<u32>,
        pub r#hls_decoder: Option<bool>,
        pub r#is_hardware_decoding: Option<bool>,
        pub r#is_hdr: Option<bool>,
        pub r#key_system: Option<String>,
        pub r#metadata_loaded_time: Option<u32>,
        pub r#playback_type: Option<String>,
        pub r#resolution: Option<String>,
        pub r#total_waiting_data_time: Option<u32>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for FirstFrameLoadedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["buffering_time", "decoder_name", "first_frame_loaded_time", "hls_decoder", "is_hardware_decoding", "is_hdr", "key_system", "metadata_loaded_time", "playback_type", "resolution", "total_waiting_data_time", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#buffering_time.and_then(|val| map.insert("buffering_time".into(), val.to_string()));
          self.r#decoder_name.and_then(|val| map.insert("decoder_name".into(), val.to_string()));
          self.r#first_frame_loaded_time.and_then(|val| map.insert("first_frame_loaded_time".into(), val.to_string()));
          self.r#hls_decoder.and_then(|val| map.insert("hls_decoder".into(), val.to_string()));
          self.r#is_hardware_decoding.and_then(|val| map.insert("is_hardware_decoding".into(), val.to_string()));
          self.r#is_hdr.and_then(|val| map.insert("is_hdr".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#metadata_loaded_time.and_then(|val| map.insert("metadata_loaded_time".into(), val.to_string()));
          self.r#playback_type.and_then(|val| map.insert("playback_type".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#total_waiting_data_time.and_then(|val| map.insert("total_waiting_data_time".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.playback.first_frame_loaded
    ///
    /// The time that the media pipeline takes to load the first video frame.
    pub static first_frame_loaded: Lazy<EventMetric<FirstFrameLoadedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_frame_loaded".into(),
                category: "media.playback".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3688), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from media.playback.not_supported_video_per_mime_type
    ///
    /// Count the amount of times where video playback is failed to start due to the mime type is not supported by Firefox. The result is accumulated per mime type, eg. video/hevc.
    pub static not_supported_video_per_mime_type: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "not_supported_video_per_mime_type".into(),
                    category: "media.playback".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3689), meta, None)
    });

}
pub mod media_mp4_parse {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from media.mp4_parse.num_sample_description_entries
    ///
    /// Counts the number of entries in the sample description box (stsd) for a track in an mp4. Recorded each time we process a track's metadata while parsing mp4s.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram MEDIA_MP4_PARSE_NUM_SAMPLE_DESCRIPTION_ENTRIES.
    pub static num_sample_description_entries: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "num_sample_description_entries".into(),
                category: "media.mp4_parse".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3690), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum SampleDescriptionEntriesHaveMultipleCodecsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SampleDescriptionEntriesHaveMultipleCodecsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SampleDescriptionEntriesHaveMultipleCodecsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.mp4_parse.sample_description_entries_have_multiple_codecs
    ///
    /// Records if multiple codecs are present in a track's sample description entries. Recorded each time we process a track's metadata while parsing mp4s.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram MEDIA_MP4_PARSE_SAMPLE_DESCRIPTION_ENTRIES_HAVE_MULTIPLE_CODECS.
    pub static sample_description_entries_have_multiple_codecs: Lazy<LabeledMetric<LabeledCounterMetric, SampleDescriptionEntriesHaveMultipleCodecsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sample_description_entries_have_multiple_codecs".into(),
                    category: "media.mp4_parse".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3691), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum SampleDescriptionEntriesHaveMultipleCryptoLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SampleDescriptionEntriesHaveMultipleCryptoLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SampleDescriptionEntriesHaveMultipleCryptoLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media.mp4_parse.sample_description_entries_have_multiple_crypto
    ///
    /// Records if multiple sets of crypto info are present in a track's sample description entries. Recorded each time we process a track's metadata while parsing mp4s.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram MEDIA_MP4_PARSE_SAMPLE_DESCRIPTION_ENTRIES_HAVE_MULTIPLE_CRYPTO.
    pub static sample_description_entries_have_multiple_crypto: Lazy<LabeledMetric<LabeledCounterMetric, SampleDescriptionEntriesHaveMultipleCryptoLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sample_description_entries_have_multiple_crypto".into(),
                    category: "media.mp4_parse".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3692), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod mfcdm {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EmePlaybackExtra {
        pub r#dropped_frames: Option<u32>,
        pub r#key_system: Option<String>,
        pub r#played_time: Option<u32>,
        pub r#rendered_frames: Option<u32>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for EmePlaybackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dropped_frames", "key_system", "played_time", "rendered_frames", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#dropped_frames.and_then(|val| map.insert("dropped_frames".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#played_time.and_then(|val| map.insert("played_time".into(), val.to_string()));
          self.r#rendered_frames.and_then(|val| map.insert("rendered_frames".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.eme_playback
    ///
    /// Record the information about the EME playback when using the media engine. The value of this event is the key system name.
    pub static eme_playback: Lazy<EventMetric<EmePlaybackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "eme_playback".into(),
                category: "mfcdm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3693), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#audio_codec: Option<String>,
        pub r#current_state: Option<String>,
        pub r#error_name: Option<String>,
        pub r#key_system: Option<String>,
        pub r#platform_error: Option<u32>,
        pub r#resolution: Option<String>,
        pub r#video_codec: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["audio_codec", "current_state", "error_name", "key_system", "platform_error", "resolution", "video_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#audio_codec.and_then(|val| map.insert("audio_codec".into(), val.to_string()));
          self.r#current_state.and_then(|val| map.insert("current_state".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#key_system.and_then(|val| map.insert("key_system".into(), val.to_string()));
          self.r#platform_error.and_then(|val| map.insert("platform_error".into(), val.to_string()));
          self.r#resolution.and_then(|val| map.insert("resolution".into(), val.to_string()));
          self.r#video_codec.and_then(|val| map.insert("video_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mfcdm.error
    ///
    /// Record the error or crash happened while using the media engine playback. The value of this event is the name of error. This probe covers both EME and non-EME playback.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "mfcdm".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3694), meta)
    });

}
pub mod codec_stats {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.audio_preferred_codec
    ///
    /// Counts the preferred audio codec being signaled to us to identify preferred audio codec.
    pub static audio_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "audio_preferred_codec".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3695), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.other_fec_signaled
    ///
    /// Count how many other fec options are being offered.
    pub static other_fec_signaled: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "other_fec_signaled".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3696), meta, None)
    });

    #[repr(u16)]
    pub enum UlpfecNegotiatedLabel {
        ENegotiated = 0,
        ENotNegotiated = 1,
        __Other__,
    }
    impl From<u16> for UlpfecNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENegotiated,
                1 => Self::ENotNegotiated,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for UlpfecNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENegotiated => "negotiated",
                Self::ENotNegotiated => "not_negotiated",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.ulpfec_negotiated
    ///
    /// Counts the number of times that ulpfec is negotiated or not negotiated on the first negotiation for each video transceiver.
    pub static ulpfec_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, UlpfecNegotiatedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ulpfec_negotiated".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3697), meta, Some(vec![::std::borrow::Cow::from("negotiated"), ::std::borrow::Cow::from("not_negotiated")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from codec.stats.video_preferred_codec
    ///
    /// Counts the preferred video codec being signaled to us to identify preferred video codec.
    pub static video_preferred_codec: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video_preferred_codec".into(),
                    category: "codec.stats".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3698), meta, None)
    });

}
pub mod rtcrtpsender {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count
    ///
    /// The number of RTCRtpSenders created.
    pub static count: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(3699), meta, vec![CommonMetricData {name: "used_sendencodings".into(), category: "rtcrtpsender".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_other".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_rid_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "fail_stale_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.count_setparameters_compat
    ///
    /// The number of RTCRtpSenders created that use the compatibility mode for setParameters.
    pub static count_setparameters_compat: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count_setparameters_compat".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(3700), meta, vec![CommonMetricData {name: "fail_no_encodings".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_length_changed".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_getparameters".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "warn_no_transactionid".into(), category: "rtcrtpsender.setparameters".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.used_sendencodings
    ///
    /// The proportion of RTCRtpSenders that were created by an addTransceivers call that was passed a sendEncodings.
    pub static used_sendencodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "used_sendencodings".into(),
                category: "rtcrtpsender".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3701), meta)
    });

}
pub mod rtcrtpsender_setparameters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_length_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call that attempted to change the number of encodings.
    pub static fail_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_length_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3702), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_encodings
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode that have thrown an error at least once about a setParameters call that had no encodings (we do not measure this against the general population of RTCRtpSenders, since without the compat mode this failure is never observed, because it fails the length change check).
    pub static fail_no_encodings: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_encodings".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3703), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_getparameters
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call because [[LastReturnedParameters]] was not set. (ie; there was not a recent enough call to getParameters)
    pub static fail_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_getparameters".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3704), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_no_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call that did not set the transactionId field.
    pub static fail_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_no_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3705), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_other
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call that had no encodings.
    pub static fail_other: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_other".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3706), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_rid_changed
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call that attempted to change the rid on an encoding (note that we only check this if the encoding count did not change, see fail_length_changed).
    pub static fail_rid_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_rid_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3707), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.fail_stale_transactionid
    ///
    /// The proportion of RTCRtpSenders that have thrown an error at least once about a setParameters call that used a stale transaction id.
    pub static fail_stale_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail_stale_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3708), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_length_changed
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode that have warned at least once about a setParameters call that attempted to change the number of encodings.
    pub static warn_length_changed: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_length_changed".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3709), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_getparameters
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode that have warned at least once about a setParameters call because [[LastReturnedParameters]] was not set.  (ie; there was not a recent enough call to getParameters)
    pub static warn_no_getparameters: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_no_getparameters".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3710), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from rtcrtpsender.setparameters.warn_no_transactionid
    ///
    /// The proportion of RTCRtpSenders configured with the setParameters compat mode that have warned at least once about a setParameters call that did not set the transactionId field.
    pub static warn_no_transactionid: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "warn_no_transactionid".into(),
                category: "rtcrtpsender.setparameters".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3711), meta)
    });

}
pub mod webrtc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_inbound_bandwidth_kbits
    ///
    /// Locally measured data rate on inbound audio (kbit/s). Computed every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_INBOUND_BANDWIDTH_KBITS.
    pub static audio_quality_inbound_bandwidth_kbits: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_inbound_bandwidth_kbits".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3712), meta, 1, 1000000, 1000, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_inbound_jitter
    ///
    /// Locally measured jitter on inbound audio (ms). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_INBOUND_JITTER.
    pub static audio_quality_inbound_jitter: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_inbound_jitter".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3713), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_inbound_packetloss_rate
    ///
    /// Locally measured packet loss on inbound audio (permille). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_INBOUND_PACKETLOSS_RATE.
    pub static audio_quality_inbound_packetloss_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_inbound_packetloss_rate".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3714), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_outbound_jitter
    ///
    /// RTCP-reported jitter by remote recipient of outbound audio (ms). Sampled every second of a call (for easy comparison).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_OUTBOUND_JITTER.
    pub static audio_quality_outbound_jitter: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_outbound_jitter".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3715), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_outbound_packetloss_rate
    ///
    /// RTCP-reported packet loss by remote recipient of outbound audio (permille). Sampled every second of a call (for easy comparison).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_OUTBOUND_PACKETLOSS_RATE.
    pub static audio_quality_outbound_packetloss_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_outbound_packetloss_rate".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3716), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.audio_quality_outbound_rtt
    ///
    /// Roundtrip time of outbound audio (ms). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AUDIO_QUALITY_OUTBOUND_RTT.
    pub static audio_quality_outbound_rtt: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_quality_outbound_rtt".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3717), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.av_call_duration
    ///
    /// The length of time (in seconds) that a call with audio or video in it lasted.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_AV_CALL_DURATION.
    pub static av_call_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "av_call_duration".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3718), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.call_count_3
    ///
    /// The number of successfully connected calls made during a session (discounting re-negotiations).
    /// This metric was generated to correspond to the Legacy Telemetry count histogram WEBRTC_CALL_COUNT_3.
    pub static call_count_3: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3719,
            "webrtc",
            "call_count_3",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.call_duration
    ///
    /// The length of time (in seconds) that a call lasted.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_CALL_DURATION.
    pub static call_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "call_duration".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3720), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.call_type
    ///
    /// Type of call: (Bitmask) Audio = 1, Video = 2, DataChannels = 4
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBRTC_CALL_TYPE.
    pub static call_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "call_type".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3721), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum DatachannelNegotiatedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for DatachannelNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DatachannelNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.datachannel_negotiated
    ///
    /// Was DataChannels negotiated
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_DATACHANNEL_NEGOTIATED.
    pub static datachannel_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, DatachannelNegotiatedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "datachannel_negotiated".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3722), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.get_user_media_type
    ///
    /// Type for media in getUserMedia calls (0=Camera, 1=Screen, 2=Application, 3=Window, 4=Browser, 5=Microphone, 6=AudioCapture, 7=Other)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBRTC_GET_USER_MEDIA_TYPE.
    pub static get_user_media_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "get_user_media_type".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3723), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum GmpInitSuccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for GmpInitSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GmpInitSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.gmp_init_success
    ///
    /// Counts of GMP codec initialization success and failure
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_GMP_INIT_SUCCESS.
    pub static gmp_init_success: Lazy<LabeledMetric<LabeledCounterMetric, GmpInitSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gmp_init_success".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3724), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum H264EnabledLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for H264EnabledLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for H264EnabledLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.h264_enabled
    ///
    /// Whether any kind of H264 is enabled
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_H264_ENABLED.
    pub static h264_enabled: Lazy<LabeledMetric<LabeledCounterMetric, H264EnabledLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "h264_enabled".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3725), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum HardwareH264EnabledLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for HardwareH264EnabledLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HardwareH264EnabledLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.hardware_h264_enabled
    ///
    /// Whether software H264 is enabled
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_HARDWARE_H264_ENABLED.
    pub static hardware_h264_enabled: Lazy<LabeledMetric<LabeledCounterMetric, HardwareH264EnabledLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "hardware_h264_enabled".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3726), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum HasH264HardwareLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for HasH264HardwareLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HasH264HardwareLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.has_h264_hardware
    ///
    /// Whether the user has H264 hardware
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_HAS_H264_HARDWARE.
    pub static has_h264_hardware: Lazy<LabeledMetric<LabeledCounterMetric, HasH264HardwareLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "has_h264_hardware".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3727), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.max_audio_receive_track
    ///
    /// Number of Audio tracks received simultaneously
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram WEBRTC_MAX_AUDIO_RECEIVE_TRACK.
    pub static max_audio_receive_track: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_audio_receive_track".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3728), meta, 1, 30, 29, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.max_audio_send_track
    ///
    /// Number of Audio tracks sent simultaneously
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram WEBRTC_MAX_AUDIO_SEND_TRACK.
    pub static max_audio_send_track: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_audio_send_track".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3729), meta, 1, 20, 19, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.max_video_receive_track
    ///
    /// Number of Video tracks received simultaneously
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram WEBRTC_MAX_VIDEO_RECEIVE_TRACK.
    pub static max_video_receive_track: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_video_receive_track".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3730), meta, 1, 20, 19, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.max_video_send_track
    ///
    /// Number of Video tracks sent simultaneously
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram WEBRTC_MAX_VIDEO_SEND_TRACK.
    pub static max_video_send_track: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_video_send_track".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3731), meta, 1, 10, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.renegotiations
    ///
    /// Number of Renegotiations during each call
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram WEBRTC_RENEGOTIATIONS.
    pub static renegotiations: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "renegotiations".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3732), meta, 1, 21, 20, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum SoftwareH264EnabledLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SoftwareH264EnabledLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SoftwareH264EnabledLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.software_h264_enabled
    ///
    /// Whether hardware H264 is enabled
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBRTC_SOFTWARE_H264_ENABLED.
    pub static software_h264_enabled: Lazy<LabeledMetric<LabeledCounterMetric, SoftwareH264EnabledLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "software_h264_enabled".into(),
                    category: "webrtc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3733), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_decoder_bitrate_avg_per_call_kbps
    ///
    /// Video decoder's average bitrate (in kbits/s) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_DECODER_BITRATE_AVG_PER_CALL_KBPS.
    pub static video_decoder_bitrate_avg_per_call_kbps: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_decoder_bitrate_avg_per_call_kbps".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3734), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_decoder_bitrate_std_dev_per_call_kbps
    ///
    /// Standard deviation from video decoder's average bitrate (in kbits/s) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_DECODER_BITRATE_STD_DEV_PER_CALL_KBPS.
    pub static video_decoder_bitrate_std_dev_per_call_kbps: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_decoder_bitrate_std_dev_per_call_kbps".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3735), meta, 1, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_decoder_discarded_packets_per_call_ppm
    ///
    /// Video decoder's number of discarded packets (in packets/min) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_DECODER_DISCARDED_PACKETS_PER_CALL_PPM.
    pub static video_decoder_discarded_packets_per_call_ppm: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_decoder_discarded_packets_per_call_ppm".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3736), meta, 1, 50000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_decoder_framerate_10x_std_dev_per_call
    ///
    /// Standard deviation from video decoder's average framerate (in 1/10 fps) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_DECODER_FRAMERATE_10X_STD_DEV_PER_CALL.
    pub static video_decoder_framerate_10x_std_dev_per_call: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_decoder_framerate_10x_std_dev_per_call".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3737), meta, 1, 200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_decoder_framerate_avg_per_call
    ///
    /// Video decoder's average framerate (in fps) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_DECODER_FRAMERATE_AVG_PER_CALL.
    pub static video_decoder_framerate_avg_per_call: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_decoder_framerate_avg_per_call".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3738), meta, 1, 200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_encoder_bitrate_avg_per_call_kbps
    ///
    /// Video encoder's average bitrate (in kbits/s) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_ENCODER_BITRATE_AVG_PER_CALL_KBPS.
    pub static video_encoder_bitrate_avg_per_call_kbps: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_encoder_bitrate_avg_per_call_kbps".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3739), meta, 1, 10000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_encoder_bitrate_std_dev_per_call_kbps
    ///
    /// Standard deviation from video encoder's average bitrate (in kbits/s) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_ENCODER_BITRATE_STD_DEV_PER_CALL_KBPS.
    pub static video_encoder_bitrate_std_dev_per_call_kbps: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_encoder_bitrate_std_dev_per_call_kbps".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3740), meta, 1, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_encoder_framerate_10x_std_dev_per_call
    ///
    /// Standard deviation from video encoder's average framerate (in 1/10 fps) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_ENCODER_FRAMERATE_10X_STD_DEV_PER_CALL.
    pub static video_encoder_framerate_10x_std_dev_per_call: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_encoder_framerate_10x_std_dev_per_call".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3741), meta, 1, 200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_encoder_framerate_avg_per_call
    ///
    /// Video encoder's average framerate (in fps) over an entire call
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_ENCODER_FRAMERATE_AVG_PER_CALL.
    pub static video_encoder_framerate_avg_per_call: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_encoder_framerate_avg_per_call".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3742), meta, 1, 200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_inbound_bandwidth_kbits
    ///
    /// Locally measured data rate of inbound video (kbit/s). Computed every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_INBOUND_BANDWIDTH_KBITS.
    pub static video_quality_inbound_bandwidth_kbits: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_inbound_bandwidth_kbits".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3743), meta, 1, 1000000, 1000, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_inbound_jitter
    ///
    /// Locally measured jitter on inbound video (ms). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_INBOUND_JITTER.
    pub static video_quality_inbound_jitter: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_inbound_jitter".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3744), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_inbound_packetloss_rate
    ///
    /// Locally measured packet loss on inbound video (permille). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_INBOUND_PACKETLOSS_RATE.
    pub static video_quality_inbound_packetloss_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_inbound_packetloss_rate".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3745), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_outbound_jitter
    ///
    /// RTCP-reported jitter by remote recipient of outbound video (ms). Sampled every second of a call (for easy comparison).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_OUTBOUND_JITTER.
    pub static video_quality_outbound_jitter: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_outbound_jitter".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3746), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_outbound_packetloss_rate
    ///
    /// RTCP-reported packet loss by remote recipient of outbound video (permille). Sampled every second of a call (for easy comparison).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_OUTBOUND_PACKETLOSS_RATE.
    pub static video_quality_outbound_packetloss_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_outbound_packetloss_rate".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3747), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video_quality_outbound_rtt
    ///
    /// Roundtrip time of outbound video (ms). Sampled every second of a call.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBRTC_VIDEO_QUALITY_OUTBOUND_RTT.
    pub static video_quality_outbound_rtt: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_quality_outbound_rtt".into(),
                category: "webrtc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3748), meta, TimeUnit::Millisecond)
    });

}
pub mod webrtc_signaling {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AudioMsectionNegotiatedExtra {
        pub r#codecs: Option<String>,
        pub r#direction: Option<String>,
        pub r#has_rtcp_mux: Option<bool>,
        pub r#pc_id: Option<String>,
        pub r#pc_negotiation_count: Option<u32>,
        pub r#preferred_recv_codec: Option<String>,
        pub r#preferred_send_codec: Option<String>,
    }

    impl ExtraKeys for AudioMsectionNegotiatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["codecs", "direction", "has_rtcp_mux", "pc_id", "pc_negotiation_count", "preferred_recv_codec", "preferred_send_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#codecs.and_then(|val| map.insert("codecs".into(), val.to_string()));
          self.r#direction.and_then(|val| map.insert("direction".into(), val.to_string()));
          self.r#has_rtcp_mux.and_then(|val| map.insert("has_rtcp_mux".into(), val.to_string()));
          self.r#pc_id.and_then(|val| map.insert("pc_id".into(), val.to_string()));
          self.r#pc_negotiation_count.and_then(|val| map.insert("pc_negotiation_count".into(), val.to_string()));
          self.r#preferred_recv_codec.and_then(|val| map.insert("preferred_recv_codec".into(), val.to_string()));
          self.r#preferred_send_codec.and_then(|val| map.insert("preferred_send_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.signaling.audio_msection_negotiated
    ///
    /// Collects data relevant to an audio m-section as part of SDP Offer/Answer negotiation completing and the RTCPeerConnection's signaling state becoming stable.
    pub static audio_msection_negotiated: Lazy<EventMetric<AudioMsectionNegotiatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_msection_negotiated".into(),
                category: "webrtc.signaling".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3749), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SdpNegotiatedExtra {
        pub r#bundle_policy: Option<String>,
        pub r#ice_transport_policy: Option<String>,
        pub r#is_remote_ice_lite: Option<bool>,
        pub r#negotiation_count: Option<u32>,
        pub r#num_msections_audio_recvonly: Option<u32>,
        pub r#num_msections_audio_sendonly: Option<u32>,
        pub r#num_msections_audio_sendrecv: Option<u32>,
        pub r#num_msections_data: Option<u32>,
        pub r#num_msections_video_recvonly: Option<u32>,
        pub r#num_msections_video_sendonly: Option<u32>,
        pub r#num_msections_video_sendrecv: Option<u32>,
        pub r#num_transports: Option<u32>,
        pub r#pc_id: Option<String>,
    }

    impl ExtraKeys for SdpNegotiatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bundle_policy", "ice_transport_policy", "is_remote_ice_lite", "negotiation_count", "num_msections_audio_recvonly", "num_msections_audio_sendonly", "num_msections_audio_sendrecv", "num_msections_data", "num_msections_video_recvonly", "num_msections_video_sendonly", "num_msections_video_sendrecv", "num_transports", "pc_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bundle_policy.and_then(|val| map.insert("bundle_policy".into(), val.to_string()));
          self.r#ice_transport_policy.and_then(|val| map.insert("ice_transport_policy".into(), val.to_string()));
          self.r#is_remote_ice_lite.and_then(|val| map.insert("is_remote_ice_lite".into(), val.to_string()));
          self.r#negotiation_count.and_then(|val| map.insert("negotiation_count".into(), val.to_string()));
          self.r#num_msections_audio_recvonly.and_then(|val| map.insert("num_msections_audio_recvonly".into(), val.to_string()));
          self.r#num_msections_audio_sendonly.and_then(|val| map.insert("num_msections_audio_sendonly".into(), val.to_string()));
          self.r#num_msections_audio_sendrecv.and_then(|val| map.insert("num_msections_audio_sendrecv".into(), val.to_string()));
          self.r#num_msections_data.and_then(|val| map.insert("num_msections_data".into(), val.to_string()));
          self.r#num_msections_video_recvonly.and_then(|val| map.insert("num_msections_video_recvonly".into(), val.to_string()));
          self.r#num_msections_video_sendonly.and_then(|val| map.insert("num_msections_video_sendonly".into(), val.to_string()));
          self.r#num_msections_video_sendrecv.and_then(|val| map.insert("num_msections_video_sendrecv".into(), val.to_string()));
          self.r#num_transports.and_then(|val| map.insert("num_transports".into(), val.to_string()));
          self.r#pc_id.and_then(|val| map.insert("pc_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.signaling.sdp_negotiated
    ///
    /// Collects data relevant to a SDP Offer/Answer negotiation completing and the RTCPeerConnection's signaling state becoming stable. The pc_id and negotiation_count uniquely identifies these events.
    pub static sdp_negotiated: Lazy<EventMetric<SdpNegotiatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sdp_negotiated".into(),
                category: "webrtc.signaling".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3750), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct VideoMsectionNegotiatedExtra {
        pub r#codecs: Option<String>,
        pub r#direction: Option<String>,
        pub r#has_rtcp_mux: Option<bool>,
        pub r#num_send_simulcast_layers: Option<u32>,
        pub r#pc_id: Option<String>,
        pub r#pc_negotiation_count: Option<u32>,
        pub r#preferred_recv_codec: Option<String>,
        pub r#preferred_send_codec: Option<String>,
    }

    impl ExtraKeys for VideoMsectionNegotiatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["codecs", "direction", "has_rtcp_mux", "num_send_simulcast_layers", "pc_id", "pc_negotiation_count", "preferred_recv_codec", "preferred_send_codec"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#codecs.and_then(|val| map.insert("codecs".into(), val.to_string()));
          self.r#direction.and_then(|val| map.insert("direction".into(), val.to_string()));
          self.r#has_rtcp_mux.and_then(|val| map.insert("has_rtcp_mux".into(), val.to_string()));
          self.r#num_send_simulcast_layers.and_then(|val| map.insert("num_send_simulcast_layers".into(), val.to_string()));
          self.r#pc_id.and_then(|val| map.insert("pc_id".into(), val.to_string()));
          self.r#pc_negotiation_count.and_then(|val| map.insert("pc_negotiation_count".into(), val.to_string()));
          self.r#preferred_recv_codec.and_then(|val| map.insert("preferred_recv_codec".into(), val.to_string()));
          self.r#preferred_send_codec.and_then(|val| map.insert("preferred_send_codec".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webrtc.signaling.video_msection_negotiated
    ///
    /// Collects data relevant to a video m-section as part of SDP Offer/Answer negotiation completing and the RTCPeerConnection's signaling state becoming stable.
    pub static video_msection_negotiated: Lazy<EventMetric<VideoMsectionNegotiatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "video_msection_negotiated".into(),
                category: "webrtc.signaling".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3751), meta)
    });

}
pub mod webrtc_video {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video.recv_codec_used
    ///
    /// The video codec used for receiving video on a WebRTC call. This metric was generated to correspond to the Legacy Telemetry scalar webrtc.video.recv_codec_used.
    pub static recv_codec_used: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "recv_codec_used".into(),
                    category: "webrtc.video".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3752), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtc.video.send_codec_used
    ///
    /// The video codec used for sending video on a WebRTC call. This metric was generated to correspond to the Legacy Telemetry scalar webrtc.video.send_codec_used.
    pub static send_codec_used: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "send_codec_used".into(),
                    category: "webrtc.video".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3753), meta, None)
    });

}
pub mod webrtcdtls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.cipher
    ///
    /// The CipherSuite used for each webrtc DTLS connection, as a string representation of the CipherSuite's ID in 4 hex digits (eg; TLS_DHE_RSA_WITH_AES_128_CBC_SHA would be "0x0033")
    pub static cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cipher".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3754), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.client_handshake_result
    ///
    /// The result of each webrtc client DTLS handshake as a string containing either the name of the error code (eg; SSL_ERROR_BAD_CERTIFICATE), SUCCESS for successful handshakes, ALPN_FAILURE when ALPN negotiation fails, or CERT_FAILURE when cert validation fails.
    pub static client_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "client_handshake_result".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3755), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.client_handshake_started_counter
    ///
    /// The number of webrtc transports that have started a DTLS handshake as the client.
    pub static client_handshake_started_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3756,
            "webrtcdtls",
            "client_handshake_started_counter",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.protocol_version
    ///
    /// The version of DTLS used for each webrtc connection. Can be 1.0, 1.2, or 1.3 (there is no 1.1 version of DTLS)
    pub static protocol_version: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "protocol_version".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3757), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.server_handshake_result
    ///
    /// The result of each webrtc server DTLS handshake, as the name of the error code (eg; SSL_ERROR_BAD_CERTIFICATE), the empty string for successful handshakes, ALPN_FAILURE when ALPN negotiation fails, or CERT_FAILURE when cert validation fails.
    pub static server_handshake_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "server_handshake_result".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3758), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.server_handshake_started_counter
    ///
    /// The number of webrtc transports that have started a DTLS handshake as the server.
    pub static server_handshake_started_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3759,
            "webrtcdtls",
            "server_handshake_started_counter",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webrtcdtls.srtp_cipher
    ///
    /// The SRTPProtectionProfile (see RFC 5764) used for each webrtc SRTP connection, as a string representation of the SRTPProtectionProfile's ID in 4 hex digits (eg; SRTP_AES128_CM_HMAC_SHA1_80 would be "0x0001")
    pub static srtp_cipher: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "srtp_cipher".into(),
                    category: "webrtcdtls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3760), meta, None)
    });

}
pub mod dom {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BlinkFilesystemUsedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for BlinkFilesystemUsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BlinkFilesystemUsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.blink_filesystem_used
    ///
    /// Webkit/Blink filesystem used
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BLINK_FILESYSTEM_USED.
    pub static blink_filesystem_used: Lazy<LabeledMetric<LabeledCounterMetric, BlinkFilesystemUsedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "blink_filesystem_used".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3761), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.forget_skippable_during_idle
    ///
    /// Percent of the cycle collector's forget skippable done during idle time
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram FORGET_SKIPPABLE_DURING_IDLE.
    pub static forget_skippable_during_idle: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forget_skippable_during_idle".into(),
                category: "dom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3762), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.forget_skippable_frequency
    ///
    /// Number of forget skippables occurred during a minute
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram FORGET_SKIPPABLE_FREQUENCY.
    pub static forget_skippable_frequency: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forget_skippable_frequency".into(),
                category: "dom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3763), meta, 1, 500, 100, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.fullscreen_transition_black
    ///
    /// The time spent in the fully-black screen in fullscreen transition
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FULLSCREEN_TRANSITION_BLACK_MS.
    pub static fullscreen_transition_black: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fullscreen_transition_black".into(),
                category: "dom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3764), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.gc_in_progress
    ///
    /// Time from the beginning of the first slice to the end of the last slice (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram GC_IN_PROGRESS_MS.
    pub static gc_in_progress: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gc_in_progress".into(),
                category: "dom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3765), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.gc_slice_during_idle
    ///
    /// Percent of GC slice done during idle time
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram GC_SLICE_DURING_IDLE.
    pub static gc_slice_during_idle: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gc_slice_during_idle".into(),
                category: "dom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3766), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum InnerwindowsWithMutationListenersLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for InnerwindowsWithMutationListenersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InnerwindowsWithMutationListenersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.innerwindows_with_mutation_listeners
    ///
    /// Deleted or to-be-reused innerwindow which has had mutation event listeners.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram INNERWINDOWS_WITH_MUTATION_LISTENERS.
    pub static innerwindows_with_mutation_listeners: Lazy<LabeledMetric<LabeledCounterMetric, InnerwindowsWithMutationListenersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "innerwindows_with_mutation_listeners".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3767), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ScriptLoadingSourceLabel {
        EInline = 0,
        ESourcefallback = 1,
        ESource = 2,
        EAltdata = 3,
        __Other__,
    }
    impl From<u16> for ScriptLoadingSourceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInline,
                1 => Self::ESourcefallback,
                2 => Self::ESource,
                3 => Self::EAltdata,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ScriptLoadingSourceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInline => "Inline",
                Self::ESourcefallback => "SourceFallback",
                Self::ESource => "Source",
                Self::EAltdata => "AltData",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.script_loading_source
    ///
    /// Record the input from which the bytes are coming from, for each script in a document.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram DOM_SCRIPT_LOADING_SOURCE.
    pub static script_loading_source: Lazy<LabeledMetric<LabeledCounterMetric, ScriptLoadingSourceLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "script_loading_source".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3768), meta, Some(vec![::std::borrow::Cow::from("AltData"), ::std::borrow::Cow::from("Inline"), ::std::borrow::Cow::from("Source"), ::std::borrow::Cow::from("SourceFallback")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.slow_script_notice_count
    ///
    /// Count slow script notices
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SLOW_SCRIPT_NOTICE_COUNT.
    pub static slow_script_notice_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3769,
            "dom",
            "slow_script_notice_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.slow_script_page_count
    ///
    /// The number of pages that trigger slow script notices
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SLOW_SCRIPT_PAGE_COUNT.
    pub static slow_script_page_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3770,
            "dom",
            "slow_script_page_count",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum StorageAccessApiUiLabel {
        ERequest = 0,
        EAllowautomatically = 1,
        EDeny = 2,
        EAllow = 3,
        EAllowonanysite = 4,
        __Other__,
    }
    impl From<u16> for StorageAccessApiUiLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERequest,
                1 => Self::EAllowautomatically,
                2 => Self::EDeny,
                3 => Self::EAllow,
                4 => Self::EAllowonanysite,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StorageAccessApiUiLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERequest => "Request",
                Self::EAllowautomatically => "AllowAutomatically",
                Self::EDeny => "Deny",
                Self::EAllow => "Allow",
                Self::EAllowonanysite => "AllowOnAnySite",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.storage_access_api_ui
    ///
    /// Storage Access API UI events.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram STORAGE_ACCESS_API_UI.
    pub static storage_access_api_ui: Lazy<LabeledMetric<LabeledCounterMetric, StorageAccessApiUiLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "storage_access_api_ui".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3771), meta, Some(vec![::std::borrow::Cow::from("Allow"), ::std::borrow::Cow::from("AllowAutomatically"), ::std::borrow::Cow::from("AllowOnAnySite"), ::std::borrow::Cow::from("Deny"), ::std::borrow::Cow::from("Request")]))
    });

    #[repr(u16)]
    pub enum WebkitDirectoryUsedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WebkitDirectoryUsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WebkitDirectoryUsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.webkit_directory_used
    ///
    /// HTMLInputElement.webkitdirectory attribute used
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBKIT_DIRECTORY_USED.
    pub static webkit_directory_used: Lazy<LabeledMetric<LabeledCounterMetric, WebkitDirectoryUsedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "webkit_directory_used".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3772), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum XmlhttprequestAsyncOrSyncLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for XmlhttprequestAsyncOrSyncLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for XmlhttprequestAsyncOrSyncLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.xmlhttprequest_async_or_sync
    ///
    /// Type of XMLHttpRequest, async or sync
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram XMLHTTPREQUEST_ASYNC_OR_SYNC.
    pub static xmlhttprequest_async_or_sync: Lazy<LabeledMetric<LabeledCounterMetric, XmlhttprequestAsyncOrSyncLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "xmlhttprequest_async_or_sync".into(),
                    category: "dom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3773), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod dom_contentprocess {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.build_id_mismatch
    ///
    /// The number of times the about:restartrequired page appeared due to a buildID mismatch between the parent and the content processes. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.buildID_mismatch.
    pub static build_id_mismatch: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3774,
            "dom.contentprocess",
            "build_id_mismatch",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.build_id_mismatch_false_positive
    ///
    /// The number of times a process crashed early but we could verify it was not because of buildID mismatch between the parent and the content processes. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.buildID_mismatch_false_positive.
    pub static build_id_mismatch_false_positive: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3775,
            "dom.contentprocess",
            "build_id_mismatch_false_positive",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum LaunchIsSyncLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for LaunchIsSyncLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LaunchIsSyncLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.launch_is_sync
    ///
    /// Whether a content process was launched synchronously (unnecessarily delaying UI response).
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CONTENT_PROCESS_LAUNCH_IS_SYNC.
    pub static launch_is_sync: Lazy<LabeledMetric<LabeledCounterMetric, LaunchIsSyncLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "launch_is_sync".into(),
                    category: "dom.contentprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3776), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.launch_mainthread
    ///
    /// Time spent on the main thread during asynchronous content process launch.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_LAUNCH_MAINTHREAD_MS.
    pub static launch_mainthread: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_mainthread".into(),
                category: "dom.contentprocess".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3777), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.launch_total
    ///
    /// Total time elapsed during asynchronous content process launch, until the process is usable for loading content.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_LAUNCH_TOTAL_MS.
    pub static launch_total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_total".into(),
                category: "dom.contentprocess".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3778), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_change_considered
    ///
    /// The number of times we've had the opportunity to change content process priority due to a tab switch or a tab being opened. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_change_considered.
    pub static os_priority_change_considered: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3779,
            "dom.contentprocess",
            "os_priority_change_considered",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_lowered
    ///
    /// The number of times a content process has had its OS priority lowered due to only containing background tabs without audible media playing. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_lowered.
    pub static os_priority_lowered: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3780,
            "dom.contentprocess",
            "os_priority_lowered",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.os_priority_raised
    ///
    /// The number of times a content process has had its OS priority raised due to containing at least one foregrounded tab, or a tab with audible media has started playing in it. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_raised.
    pub static os_priority_raised: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3781,
            "dom.contentprocess",
            "os_priority_raised",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.contentprocess.sync_launch
    ///
    /// Time elapsed during synchronous content process launch until the process is usable for loading content.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_SYNC_LAUNCH_MS.
    pub static sync_launch: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sync_launch".into(),
                category: "dom.contentprocess".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3782), meta, TimeUnit::Millisecond)
    });

}
pub mod dom_parentprocess {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.parentprocess.private_window_used
    ///
    /// Whether a private browsing window has been used in the session. This metric was generated to correspond to the Legacy Telemetry scalar dom.parentprocess.private_window_used.
    pub static private_window_used: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "private_window_used".into(),
                category: "dom.parentprocess".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(3783), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.parentprocess.process_launch_errors
    ///
    /// Collect precise set of error code and calling site upon process creation failure path. This metric was generated to correspond to the Legacy Telemetry scalar dom.parentprocess.process_launch_errors.
    pub static process_launch_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "process_launch_errors".into(),
                    category: "dom.parentprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3784), meta, None)
    });

}
pub mod dom_textfragment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.textfragment.create_directive
    ///
    /// Time spent in FragmentDirective::CreateTextDirective()
    pub static create_directive: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "create_directive".into(),
                category: "dom.textfragment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3785), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.textfragment.find_directives
    ///
    /// Time spent in TextDirectiveFinder::FindTextDirectivesInDocument() per page load
    pub static find_directives: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "find_directives".into(),
                category: "dom.textfragment".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3786), meta, TimeUnit::Millisecond)
    });

}
pub mod javascript_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.baseline_compile_time
    ///
    /// Time spent during page load baseline compiling Javascript in ms. (Migrated from the geckoview metric of the same name.)
    pub static baseline_compile_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "baseline_compile_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3787), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.delazification_time
    ///
    /// Time spent during page load delazifying Javascript in ms. (Migrated from the geckoview metric of the same name.)
    pub static delazification_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delazification_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3788), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.execution_time
    ///
    /// Time spent during page load executing Javascript in ms. (Migrated from the geckoview metric of the same name.)
    pub static execution_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "execution_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3789), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.gc_time
    ///
    /// Time spent during page load in the GC in ms. (Migrated from the geckoview metric of the same name.)
    pub static gc_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gc_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3790), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.parse_time
    ///
    /// Time spent during page load syntax parsing JS scripts on the main thread in ms. (Migrated from the geckoview metric of the same name.)
    pub static parse_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parse_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3791), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.protect_time
    ///
    /// Time spent during page load protecting JIT executable memory. (Migrated from the geckoview metric of the same name.)
    pub static protect_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "protect_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3792), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.pageload.xdr_encode_time
    ///
    /// Time spent during page load XDR encoding Javascript in ms. (Migrated from the geckoview metric of the same name.)
    pub static xdr_encode_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "xdr_encode_time".into(),
                category: "javascript.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3793), meta, TimeUnit::Millisecond)
    });

}
pub mod perf {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from perf.dns_first_byte
    ///
    /// The time from a top-level document's HTTP channel open to the first byte of the reply is received (ms). Keyed by TRR domain for DoH or 'Native' otherwise
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_PERF_FIRST_BYTE_MS.
    pub static dns_first_byte: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "dns_first_byte".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3794), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.dns_first_contentful_paint
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. Keyed by TRR domain for DoH or 'Native' otherwise
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_PERF_FIRST_CONTENTFUL_PAINT_MS.
    pub static dns_first_contentful_paint: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "dns_first_contentful_paint".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3795), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.h3p_first_contentful_paint
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. It is keyed based on whether a "priority" header has been received.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram H3P_PERF_FIRST_CONTENTFUL_PAINT_MS.
    pub static h3p_first_contentful_paint: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "h3p_first_contentful_paint".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3796), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.h3p_page_load_time
    ///
    /// Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. This is collected only on page load where the main document uses HTTP3. It is keyed based on whether a "priority" header has been received.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram H3P_PERF_PAGE_LOAD_TIME_MS.
    pub static h3p_page_load_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "h3p_page_load_time".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3797), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.http3_first_contentful_paint
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses or suppports HTTP3
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_PERF_FIRST_CONTENTFUL_PAINT_MS.
    pub static http3_first_contentful_paint: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_first_contentful_paint".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3798), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.http3_page_load_time
    ///
    /// Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. This is collected only on page load where the main document uses or suppports HTTP3
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_PERF_PAGE_LOAD_TIME_MS.
    pub static http3_page_load_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_page_load_time".into(),
                    category: "perf".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3799), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint
    ///
    /// Time from navigation start to largest contentful paint.
    pub static largest_contentful_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "largest_contentful_paint".into(),
                category: "perf".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3800), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from perf.largest_contentful_paint_from_response_start
    ///
    /// Time from response start to largest contentful paint.
    pub static largest_contentful_paint_from_response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "largest_contentful_paint_from_response_start".into(),
                category: "perf".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3801), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PageLoadExtra {
        pub r#dns_lookup_time: Option<u32>,
        pub r#fcp_time: Option<u32>,
        pub r#features: Option<u32>,
        pub r#has_ssd: Option<bool>,
        pub r#http_ver: Option<u32>,
        pub r#js_exec_time: Option<u32>,
        pub r#lcp_time: Option<u32>,
        pub r#load_time: Option<u32>,
        pub r#load_type: Option<String>,
        pub r#redirect_count: Option<u32>,
        pub r#redirect_time: Option<u32>,
        pub r#response_time: Option<u32>,
        pub r#same_origin_nav: Option<bool>,
        pub r#time_to_request_start: Option<u32>,
        pub r#tls_handshake_time: Option<u32>,
        pub r#trr_domain: Option<String>,
        pub r#using_webdriver: Option<bool>,
    }

    impl ExtraKeys for PageLoadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["dns_lookup_time", "fcp_time", "features", "has_ssd", "http_ver", "js_exec_time", "lcp_time", "load_time", "load_type", "redirect_count", "redirect_time", "response_time", "same_origin_nav", "time_to_request_start", "tls_handshake_time", "trr_domain", "using_webdriver"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#dns_lookup_time.and_then(|val| map.insert("dns_lookup_time".into(), val.to_string()));
          self.r#fcp_time.and_then(|val| map.insert("fcp_time".into(), val.to_string()));
          self.r#features.and_then(|val| map.insert("features".into(), val.to_string()));
          self.r#has_ssd.and_then(|val| map.insert("has_ssd".into(), val.to_string()));
          self.r#http_ver.and_then(|val| map.insert("http_ver".into(), val.to_string()));
          self.r#js_exec_time.and_then(|val| map.insert("js_exec_time".into(), val.to_string()));
          self.r#lcp_time.and_then(|val| map.insert("lcp_time".into(), val.to_string()));
          self.r#load_time.and_then(|val| map.insert("load_time".into(), val.to_string()));
          self.r#load_type.and_then(|val| map.insert("load_type".into(), val.to_string()));
          self.r#redirect_count.and_then(|val| map.insert("redirect_count".into(), val.to_string()));
          self.r#redirect_time.and_then(|val| map.insert("redirect_time".into(), val.to_string()));
          self.r#response_time.and_then(|val| map.insert("response_time".into(), val.to_string()));
          self.r#same_origin_nav.and_then(|val| map.insert("same_origin_nav".into(), val.to_string()));
          self.r#time_to_request_start.and_then(|val| map.insert("time_to_request_start".into(), val.to_string()));
          self.r#tls_handshake_time.and_then(|val| map.insert("tls_handshake_time".into(), val.to_string()));
          self.r#trr_domain.and_then(|val| map.insert("trr_domain".into(), val.to_string()));
          self.r#using_webdriver.and_then(|val| map.insert("using_webdriver".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from perf.page_load
    ///
    /// Recorded when a top level content document has been loaded.
    pub static page_load: Lazy<EventMetric<PageLoadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load".into(),
                category: "perf".into(),
                send_in_pings: vec!["pageload".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3802), meta)
    });

}
pub mod performance_pageload {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name).
    pub static fcp: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fcp".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3803), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.fcp_responsestart
    ///
    /// The time between responseStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name).
    pub static fcp_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fcp_responsestart".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3804), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.h3p_fcp_with_priority
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. A "priority" header has been received.
    pub static h3p_fcp_with_priority: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "h3p_fcp_with_priority".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3805), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_http3
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses or suppports HTTP3.
    pub static http3_fcp_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_http3".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3806), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_supports_http3
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document supports but is not using HTTP3.
    pub static http3_fcp_supports_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_supports_http3".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3807), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.http3_fcp_without_priority
    ///
    /// The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. A "priority" header has not been received.
    pub static http3_fcp_without_priority: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http3_fcp_without_priority".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3808), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time
    ///
    /// Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. (Migrated from the geckoview metric of the same name).
    pub static load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_time".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3809), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.load_time_responsestart
    ///
    /// Time in milliseconds from responseStart to loadEventStart for the foreground http or https root content document. (Migrated from the geckoview metric of the same name).
    pub static load_time_responsestart: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_time_responsestart".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3810), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.pageload.async_sheet_load
    ///
    /// Time spent in milliseconds since a style sheet started loading async until it finished.
    pub static async_sheet_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_sheet_load".into(),
                category: "performance.pageload".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3811), meta, TimeUnit::Millisecond)
    });

}
pub mod performance_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_complete
    ///
    /// Time from navigationStart to domComplete as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_complete: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_complete".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3812), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_end
    ///
    /// Time from navigationStart to domContentLoadedEventEnd as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_content_loaded_end".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3813), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_content_loaded_start
    ///
    /// Time from navigationStart to domContentLoadedEventStart as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_content_loaded_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_content_loaded_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3814), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.dom_interactive
    ///
    /// Time from navigationStart to domInteractive as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static dom_interactive: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dom_interactive".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3815), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_end
    ///
    /// Time from navigationStart to loadEventEnd as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_event_end".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3816), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.load_event_start
    ///
    /// Time from navigationStart to loadEventStart as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static load_event_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_event_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3817), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.to_dom_loading
    ///
    /// Time in milliseconds from navigationStart to domLoading.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TIME_TO_DOM_LOADING_MS.
    pub static to_dom_loading: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "to_dom_loading".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3818), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.to_first_contentful_paint
    ///
    /// The time between navigation start and the first contentful paint of a foreground root content document, in milliseconds. This only records documents that were in an active docshell throughout the whole time between navigation start and contentful paint. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TIME_TO_FIRST_CONTENTFUL_PAINT_MS.
    pub static to_first_contentful_paint: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "to_first_contentful_paint".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3819), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.time.response_start
    ///
    /// Time from navigationStart to responseStart as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
    pub static response_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "response_start".into(),
                category: "performance.time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3820), meta, TimeUnit::Millisecond)
    });

}
pub mod web_notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum IconUrlEncodingLabel {
        EUtf8 = 0,
        EDocumentCharset = 1,
        EEitherWay = 2,
        ENeitherWay = 3,
        __Other__,
    }
    impl From<u16> for IconUrlEncodingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUtf8,
                1 => Self::EDocumentCharset,
                2 => Self::EEitherWay,
                3 => Self::ENeitherWay,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IconUrlEncodingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUtf8 => "utf8",
                Self::EDocumentCharset => "document_charset",
                Self::EEitherWay => "either_way",
                Self::ENeitherWay => "neither_way",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.icon_url_encoding
    ///
    /// The encoding of the notification icon URL
    pub static icon_url_encoding: Lazy<LabeledMetric<LabeledCounterMetric, IconUrlEncodingLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "icon_url_encoding".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3821), meta, Some(vec![::std::borrow::Cow::from("document_charset"), ::std::borrow::Cow::from("either_way"), ::std::borrow::Cow::from("neither_way"), ::std::borrow::Cow::from("utf8")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from web_notification.insecure_context_permission_request
    ///
    /// Whether we saw a permission request from an insecure context.
    pub static insecure_context_permission_request: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3822,
            "web_notification",
            "insecure_context_permission_request",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum PermissionOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for PermissionOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PermissionOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.permission_origin
    ///
    /// The category of the origin that retrieves Notification.permission.
    pub static permission_origin: Lazy<LabeledMetric<LabeledCounterMetric, PermissionOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "permission_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3823), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

    #[repr(u16)]
    pub enum RequestPermissionOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for RequestPermissionOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestPermissionOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.request_permission_origin
    ///
    /// The category of the origin that calls Notification.requestPermission().
    pub static request_permission_origin: Lazy<LabeledMetric<LabeledCounterMetric, RequestPermissionOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_permission_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3824), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

    #[repr(u16)]
    pub enum ShowOriginLabel {
        EFirstParty = 0,
        EThirdParty = 1,
        ENestedFirstParty = 2,
        __Other__,
    }
    impl From<u16> for ShowOriginLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFirstParty,
                1 => Self::EThirdParty,
                2 => Self::ENestedFirstParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ShowOriginLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFirstParty => "first_party",
                Self::EThirdParty => "third_party",
                Self::ENestedFirstParty => "nested_first_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_notification.show_origin
    ///
    /// The category of the origin that calls new Notification/showNotification().
    pub static show_origin: Lazy<LabeledMetric<LabeledCounterMetric, ShowOriginLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "show_origin".into(),
                    category: "web_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3825), meta, Some(vec![::std::borrow::Cow::from("first_party"), ::std::borrow::Cow::from("nested_first_party"), ::std::borrow::Cow::from("third_party")]))
    });

}
pub mod screenwakelock {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from screenwakelock.held_duration
    ///
    /// How long a screen wake lock was held in ms
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SCREENWAKELOCK_HELD_DURATION_MS.
    pub static held_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "held_duration".into(),
                category: "screenwakelock".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3826), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from screenwakelock.release_battery_level_discharging
    ///
    /// Battery level when discharging and the wake lock was released
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram SCREENWAKELOCK_RELEASE_BATTERY_LEVEL_DISCHARGING.
    pub static release_battery_level_discharging: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "release_battery_level_discharging".into(),
                category: "screenwakelock".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3827), meta, 1, 100, 50, HistogramType::Linear)
    });

}
pub mod web_push {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from web_push.api_notify
    ///
    /// Number of push messages that were successfully decrypted and delivered to a ServiceWorker.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram PUSH_API_NOTIFY.
    pub static api_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3828,
            "web_push",
            "api_notify",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ContentEncodingLabel {
        EAes128gcm = 0,
        EAesgcm = 1,
        __Other__,
    }
    impl From<u16> for ContentEncodingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAes128gcm,
                1 => Self::EAesgcm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentEncodingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAes128gcm => "aes128gcm",
                Self::EAesgcm => "aesgcm",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_push.content_encoding
    ///
    /// Which content encoding is being used for push.
    pub static content_encoding: Lazy<LabeledMetric<LabeledCounterMetric, ContentEncodingLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_encoding".into(),
                    category: "web_push".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3829), meta, Some(vec![::std::borrow::Cow::from("aes128gcm"), ::std::borrow::Cow::from("aesgcm")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from web_push.detected_duplicated_message_ids
    ///
    /// Counts the duplicated IDs from the server. The ability to detect depends on the pref `dom.push.maxRecentMessageIDsPerSubscription`.
    pub static detected_duplicated_message_ids: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3830,
            "web_push",
            "detected_duplicated_message_ids",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ErrorCodeLabel {
        EDecryptionError = 0,
        ENotDelivered = 1,
        EUncaughtException = 2,
        EUnhandledRejection = 3,
        EInternalError = 4,
        __Other__,
    }
    impl From<u16> for ErrorCodeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDecryptionError,
                1 => Self::ENotDelivered,
                2 => Self::EUncaughtException,
                3 => Self::EUnhandledRejection,
                4 => Self::EInternalError,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ErrorCodeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDecryptionError => "decryption_error",
                Self::ENotDelivered => "not_delivered",
                Self::EUncaughtException => "uncaught_exception",
                Self::EUnhandledRejection => "unhandled_rejection",
                Self::EInternalError => "internal_error",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from web_push.error_code
    ///
    /// The code indicating why the push message couldn't be processed.
    pub static error_code: Lazy<LabeledMetric<LabeledCounterMetric, ErrorCodeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "error_code".into(),
                    category: "web_push".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3831), meta, Some(vec![::std::borrow::Cow::from("decryption_error"), ::std::borrow::Cow::from("internal_error"), ::std::borrow::Cow::from("not_delivered"), ::std::borrow::Cow::from("uncaught_exception"), ::std::borrow::Cow::from("unhandled_rejection")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from web_push.unsubscribed_by_clearing_data
    ///
    /// Counts unsubscriptions triggered by ClearDataService.
    pub static unsubscribed_by_clearing_data: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3832,
            "web_push",
            "unsubscribed_by_clearing_data",
            "metrics"
        )
    });

}
pub mod dom_quota {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dom.quota.info_load_time
    ///
    /// Time (ms) for the QuotaManager to load quota information. Keyed by conditions during quota info loading, see RecordTimeDeltaHelper::Run in https://searchfox.org/mozilla-central/source/dom/quota/ActorsParent.cpp
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram QM_QUOTA_INFO_LOAD_TIME_V0.
    pub static info_load_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "info_load_time".into(),
                    category: "dom.quota".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3833), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dom.quota.shutdown_time
    ///
    /// Time (ms) for the QuotaManager to shutdown. Keyed by conditions during shutdown, see RecordTimeDeltaHelper::Run in https://searchfox.org/mozilla-central/source/dom/quota/ActorsParent.cpp
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram QM_SHUTDOWN_TIME_V0.
    pub static shutdown_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "shutdown_time".into(),
                    category: "dom.quota".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3834), meta, None)
    });

}
pub mod dom_quota_try {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorStepExtra {
        pub r#context: Option<String>,
        pub r#frame_id: Option<String>,
        pub r#process_id: Option<String>,
        pub r#result: Option<String>,
        pub r#seq: Option<u32>,
        pub r#severity: Option<String>,
        pub r#source_file: Option<String>,
        pub r#source_line: Option<u32>,
        pub r#stack_id: Option<String>,
    }

    impl ExtraKeys for ErrorStepExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["context", "frame_id", "process_id", "result", "seq", "severity", "source_file", "source_line", "stack_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#context.and_then(|val| map.insert("context".into(), val.to_string()));
          self.r#frame_id.and_then(|val| map.insert("frame_id".into(), val.to_string()));
          self.r#process_id.and_then(|val| map.insert("process_id".into(), val.to_string()));
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#seq.and_then(|val| map.insert("seq".into(), val.to_string()));
          self.r#severity.and_then(|val| map.insert("severity".into(), val.to_string()));
          self.r#source_file.and_then(|val| map.insert("source_file".into(), val.to_string()));
          self.r#source_line.and_then(|val| map.insert("source_line".into(), val.to_string()));
          self.r#stack_id.and_then(|val| map.insert("stack_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dom.quota.try.error_step
    ///
    /// An event recorded on an error of the quota manager or its clients. Since errors are usually propagated up the call chain, all such propagation steps are recorded for an error. This is only active during specific contexts, in particular during storage initialization. No dynamic data is included in the event beyond the error code which will be added through Bug 1670555. This event was generated to correspond to the Legacy Telemetry event dom.quota.try.error#step.
    pub static error_step: Lazy<EventMetric<ErrorStepExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error_step".into(),
                category: "dom.quota.try".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3835), meta)
    });

}
pub mod quotamanager {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quotamanager.restore_origin_directory_metadata_counter
    ///
    /// Increments each time QuotaManager::RestoreDirectoryMetadata2 is called to restore origin directory metadata. This typically occurs when expected directory metadata is missing or needs to be regenerated. The counter is incremented regardless of whether the restoration ultimately succeeds or fails. This can provide insight into the impacts of specific code changes, including potential optimizations or regressions.
    pub static restore_origin_directory_metadata_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3836,
            "quotamanager",
            "restore_origin_directory_metadata_counter",
            "metrics"
        )
    });

}
pub mod quotamanager_initialize_repository {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum NumberOfIterationsLabel {
        EPersistent = 0,
        ETemporary = 1,
        EDefault = 2,
        EPrivate = 3,
        __Other__,
    }
    impl From<u16> for NumberOfIterationsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPersistent,
                1 => Self::ETemporary,
                2 => Self::EDefault,
                3 => Self::EPrivate,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NumberOfIterationsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPersistent => "persistent",
                Self::ETemporary => "temporary",
                Self::EDefault => "default",
                Self::EPrivate => "private",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from quotamanager.initialize.repository.number_of_iterations
    ///
    /// This metric logs the count of directory entries iterated within the QuotaManager::InitializeRepository function for each repository type. Each instance of this metric is labeled with one of three repository types: "persistent", "temporary" or "default" (there's also "private" repository but that should never be iterated by the function). The main purpose is to track and analyze iteration counts during the initialization process of each repository type, helping to identify performance trends or potential inefficiencies across these repositories. This can provide insight into the impacts of specific code changes, including potential optimizations or regressions.
    pub static number_of_iterations: Lazy<LabeledMetric<LabeledCustomDistributionMetric, NumberOfIterationsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "number_of_iterations".into(),
                    category: "quotamanager.initialize.repository".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 65535, bucket_count: 50, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(3837), meta, Some(vec![::std::borrow::Cow::from("default"), ::std::borrow::Cow::from("persistent"), ::std::borrow::Cow::from("private"), ::std::borrow::Cow::from("temporary")]))
    });

}
pub mod quotamanager_initialize_temporarystorage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quotamanager.initialize.temporarystorage.total_time_excluding_suspend
    ///
    /// This metric logs the total time required to initialize temporary storage within the QuotaManager after startup on the I/O thread. The duration excludes any periods when the system was suspended (e.g. system sleep or hibernation), to better reflect actual time spent performing temporary storage initialization. The primary goal is to measure the actual runtime cost of temporary storage initialization under typical conditions, without distortion from system-level suspension delays. This data can help detect performance regressions or improvements during startup-related phases, particularly for users with significant amounts of temporary storage data on disk.
    pub static total_time_excluding_suspend: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_time_excluding_suspend".into(),
                category: "quotamanager.initialize.temporarystorage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3838), meta, TimeUnit::Millisecond)
    });

}
pub mod quotamanager_shutdown {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from quotamanager.shutdown.total_time_excluding_suspend
    ///
    /// This metric logs the total time required to shut down the QuotaManager instance on the PBackground thread. The duration excludes any periods when the system was suspended (system sleep or hibernation), to better reflect actual time spent performing shutdown. While the shutdown process is measured on the PBackground thread, it involves spinning the event loop and thus waiting for operations on other threads (especially I/O threads) to complete. The primary goal is to measure the actual runtime cost of shutdown under typical conditions, without distortion from system-level suspension delays. This data can help detect performance regressions or improvements related to QuotaManager shutdown behavior, especially in scenarios involving large amounts of user storage data.
    pub static total_time_excluding_suspend: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_time_excluding_suspend".into(),
                category: "quotamanager.shutdown".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3839), meta, TimeUnit::Millisecond)
    });

}
pub mod httpsfirst {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time
    ///
    /// If a HTTPS-First (`dom.security.https_first` enabled) upgrade isn't successful, measures the timespan between the navigation start and the downgrade.
    pub static downgrade_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgrade_time".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3840), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgrade_time_schemeless
    ///
    /// If a schemeless HTTPS-First (`dom.security.https_first` disabled, but load marked as schemeless) upgrade isn't successful, measures the timespan between the navigation start and the downgrade.
    pub static downgrade_time_schemeless: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgrade_time_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3841), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded
    ///
    /// How many regular HTTPS-First (`dom.security.https_first` enabled) upgrades fail and get downgraded again.
    pub static downgraded: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(3842), meta, vec![CommonMetricData {name: "downgraded_on_timer".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer
    ///
    /// How many HTTPS-First (`dom.security.https_first` enabled) upgrades get downgraded again because the HTTP request fired after 3s received a answer faster than the HTTPS request.
    pub static downgraded_on_timer: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_on_timer".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3843), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_on_timer_schemeless
    ///
    /// How many of schemeless HTTPS-First (`dom.security.https_first` disabled, but load marked as schemeless) upgrades get downgraded again because the HTTP request fired after 3s received a answer faster than the HTTPS request
    pub static downgraded_on_timer_schemeless: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_on_timer_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(3844), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.downgraded_schemeless
    ///
    /// How many schemeless HTTPS-First (`dom.security.https_first` disabled, but load marked as schemeless) upgrades fail and get downgraded again.
    pub static downgraded_schemeless: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "downgraded_schemeless".into(),
                category: "httpsfirst".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(3845), meta, vec![CommonMetricData {name: "downgraded_on_timer_schemeless".into(), category: "httpsfirst".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of HTTPS-First (`dom.security.https_first` enabled). This does not include loads that get downgraded again.
    pub static upgraded: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3846,
            "httpsfirst",
            "upgraded",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from httpsfirst.upgraded_schemeless
    ///
    /// Counts how often a load is successfully upgraded to HTTPS because of schemeless HTTPS-First (`dom.security.https_first` disabled, but load marked as schemeless). This does not include loads that get downgraded again.
    pub static upgraded_schemeless: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3847,
            "httpsfirst",
            "upgraded_schemeless",
            "metrics"
        )
    });

}
pub mod mixed_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AudioLabel {
        EAudioupsuccess = 0,
        EAudioupfailure = 1,
        EAudionoupsuccess = 2,
        EAudionoupfailure = 3,
        __Other__,
    }
    impl From<u16> for AudioLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAudioupsuccess,
                1 => Self::EAudioupfailure,
                2 => Self::EAudionoupsuccess,
                3 => Self::EAudionoupfailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AudioLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAudioupsuccess => "AudioUpSuccess",
                Self::EAudioupfailure => "AudioUpFailure",
                Self::EAudionoupsuccess => "AudioNoUpSuccess",
                Self::EAudionoupfailure => "AudioNoUpFailure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.audio
    ///
    /// How often audio loads fail in regular mode and in upgrading mode?
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram MIXED_CONTENT_AUDIO.
    pub static audio: Lazy<LabeledMetric<LabeledCounterMetric, AudioLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "audio".into(),
                    category: "mixed_content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3848), meta, Some(vec![::std::borrow::Cow::from("AudioNoUpFailure"), ::std::borrow::Cow::from("AudioNoUpSuccess"), ::std::borrow::Cow::from("AudioUpFailure"), ::std::borrow::Cow::from("AudioUpSuccess")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.hsts
    ///
    /// How often would blocked mixed content be allowed if HSTS upgrades were allowed? 0=display/no-HSTS, 1=display/HSTS, 2=active/no-HSTS, 3=active/HSTS
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram MIXED_CONTENT_HSTS.
    pub static hsts: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hsts".into(),
                category: "mixed_content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3849), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ImagesLabel {
        EImgupsuccess = 0,
        EImgupfailure = 1,
        EImgnoupsuccess = 2,
        EImgnoupfailure = 3,
        __Other__,
    }
    impl From<u16> for ImagesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EImgupsuccess,
                1 => Self::EImgupfailure,
                2 => Self::EImgnoupsuccess,
                3 => Self::EImgnoupfailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ImagesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EImgupsuccess => "ImgUpSuccess",
                Self::EImgupfailure => "ImgUpFailure",
                Self::EImgnoupsuccess => "ImgNoUpSuccess",
                Self::EImgnoupfailure => "ImgNoUpFailure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.images
    ///
    /// How often image loads fail in regular mode and in upgrading mode?
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram MIXED_CONTENT_IMAGES.
    pub static images: Lazy<LabeledMetric<LabeledCounterMetric, ImagesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "images".into(),
                    category: "mixed_content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3850), meta, Some(vec![::std::borrow::Cow::from("ImgNoUpFailure"), ::std::borrow::Cow::from("ImgNoUpSuccess"), ::std::borrow::Cow::from("ImgUpFailure"), ::std::borrow::Cow::from("ImgUpSuccess")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.page_load
    ///
    /// Accumulates type of content per page load (0=no mixed or non-secure page, 1=mixed passive, 2=mixed active, 3=mixed passive and mixed active)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram MIXED_CONTENT_PAGE_LOAD.
    pub static page_load: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load".into(),
                category: "mixed_content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3851), meta, 0, 4, 5, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.unblock_counter
    ///
    /// A simple counter of daily mixed-content unblock operations and top documents loaded
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram MIXED_CONTENT_UNBLOCK_COUNTER.
    pub static unblock_counter: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unblock_counter".into(),
                category: "mixed_content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3852), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum VideoLabel {
        EVideoupsuccess = 0,
        EVideoupfailure = 1,
        EVideonoupsuccess = 2,
        EVideonoupfailure = 3,
        __Other__,
    }
    impl From<u16> for VideoLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EVideoupsuccess,
                1 => Self::EVideoupfailure,
                2 => Self::EVideonoupsuccess,
                3 => Self::EVideonoupfailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for VideoLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EVideoupsuccess => "VideoUpSuccess",
                Self::EVideoupfailure => "VideoUpFailure",
                Self::EVideonoupsuccess => "VideoNoUpSuccess",
                Self::EVideonoupfailure => "VideoNoUpFailure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from mixed_content.video
    ///
    /// How often video loads fail in regular mode and in upgrading mode?
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram MIXED_CONTENT_VIDEO.
    pub static video: Lazy<LabeledMetric<LabeledCounterMetric, VideoLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "video".into(),
                    category: "mixed_content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3853), meta, Some(vec![::std::borrow::Cow::from("VideoNoUpFailure"), ::std::borrow::Cow::from("VideoNoUpSuccess"), ::std::borrow::Cow::from("VideoUpFailure"), ::std::borrow::Cow::from("VideoUpSuccess")]))
    });

}
pub mod security_ui {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from security.ui.events
    ///
    /// Security-related UI events (addons, form submission, TLS certs, Safe Browsing, updates and geolocation). See /security/manager/ssl/nsISecurityUITelemetry.idl for the specific values.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SECURITY_UI.
    pub static events: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "events".into(),
                category: "security.ui".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3854), meta, 0, 100, 101, HistogramType::Linear)
    });

}
pub mod service_worker {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.fetch_event_channel_reset
    ///
    /// Time (in ms) measured between when the fetch handler finished executing and when we reset the network channel.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_FETCH_EVENT_CHANNEL_RESET_MS_2.
    pub static fetch_event_channel_reset: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "fetch_event_channel_reset".into(),
                    category: "service_worker".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3855), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.fetch_event_dispatch
    ///
    /// Time (in ms) measured between when the fetch event is dispatched by the Service Worker and before we execute the event listeners.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_FETCH_EVENT_DISPATCH_MS_2.
    pub static fetch_event_dispatch: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "fetch_event_dispatch".into(),
                    category: "service_worker".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3856), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.fetch_event_finish_synthesized_response
    ///
    /// Time (in ms) measured between when the respondWith promise resolves and when we provide the response through the intercepted channel.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_FETCH_EVENT_FINISH_SYNTHESIZED_RESPONSE_MS_2.
    pub static fetch_event_finish_synthesized_response: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "fetch_event_finish_synthesized_response".into(),
                    category: "service_worker".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3857), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.fetch_interception_duration
    ///
    /// Time delta (ms) between when a network request is intercepted in the parent process and the service worker provides a response.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_FETCH_INTERCEPTION_DURATION_MS_2.
    pub static fetch_interception_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "fetch_interception_duration".into(),
                    category: "service_worker".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3858), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.isolated_launch_time
    ///
    /// Time (ms) for spawning a service worker in an isolated content process.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_ISOLATED_LAUNCH_TIME.
    pub static isolated_launch_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "isolated_launch_time".into(),
                category: "service_worker".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3859), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.launch_time
    ///
    /// Time (ms) for spawning a service worker in the remote content process.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_LAUNCH_TIME_2.
    pub static launch_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_time".into(),
                category: "service_worker".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3860), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from service_worker.registration_loading
    ///
    /// Tracking how ServiceWorkerRegistrar loads data before the first content is shown.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SERVICE_WORKER_REGISTRATION_LOADING.
    pub static registration_loading: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "registration_loading".into(),
                category: "service_worker".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3861), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum RunningLabel {
        EAll = 0,
        EFetch = 1,
        __Other__,
    }
    impl From<u16> for RunningLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAll,
                1 => Self::EFetch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RunningLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAll => "All",
                Self::EFetch => "Fetch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from service_worker.running
    ///
    /// The sampled number of simultaneous running ServiceWorkers in a session, sampled once each 10 seconds (lazily on state change)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram SERVICE_WORKER_RUNNING.
    pub static running: Lazy<LabeledMetric<LabeledCustomDistributionMetric, RunningLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "running".into(),
                    category: "service_worker".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 31, bucket_count: 30, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3862), meta, Some(vec![::std::borrow::Cow::from("All"), ::std::borrow::Cow::from("Fetch")]))
    });

}
pub mod localdomstorage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum PreloadPendingOnFirstAccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for PreloadPendingOnFirstAccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PreloadPendingOnFirstAccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from localdomstorage.preload_pending_on_first_access
    ///
    /// True when we had to wait for a pending preload on first access to localStorage data, false otherwise
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram LOCALDOMSTORAGE_PRELOAD_PENDING_ON_FIRST_ACCESS.
    pub static preload_pending_on_first_access: Lazy<LabeledMetric<LabeledCounterMetric, PreloadPendingOnFirstAccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "preload_pending_on_first_access".into(),
                    category: "localdomstorage".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3863), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from localdomstorage.shutdown_database
    ///
    /// Time to flush and close the localStorage database (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram LOCALDOMSTORAGE_SHUTDOWN_DATABASE_MS.
    pub static shutdown_database: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_database".into(),
                category: "localdomstorage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3864), meta, TimeUnit::Millisecond)
    });

}
pub mod webauthn_create {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.authenticator_attachment
    ///
    /// The number of successfully created credentials by authenticator attachment modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "authenticator_attachment".into(),
                    category: "webauthn_create".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3865), meta, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.failure
    ///
    /// The total number of failed calls to navigator.credentials.create.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3866,
            "webauthn_create",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.passkey
    ///
    /// The number of client-side discoverable credentials (passkeys) created.
    pub static passkey: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3867,
            "webauthn_create",
            "passkey",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_create.success
    ///
    /// The total number of successful calls to navigator.credentials.create.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3868,
            "webauthn_create",
            "success",
            "metrics"
        )
    });

}
pub mod webauthn_get {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AuthenticatorAttachmentLabel {
        ECrossPlatform = 0,
        EPlatform = 1,
        EUnknown = 2,
        __Other__,
    }
    impl From<u16> for AuthenticatorAttachmentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrossPlatform,
                1 => Self::EPlatform,
                2 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AuthenticatorAttachmentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrossPlatform => "cross-platform",
                Self::EPlatform => "platform",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.authenticator_attachment
    ///
    /// The number of successfully asserted credentials by authenticator attachment modality.
    pub static authenticator_attachment: Lazy<LabeledMetric<LabeledCounterMetric, AuthenticatorAttachmentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "authenticator_attachment".into(),
                    category: "webauthn_get".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3869), meta, Some(vec![::std::borrow::Cow::from("cross-platform"), ::std::borrow::Cow::from("platform"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.failure
    ///
    /// The total number of failed calls to navigator.credentials.get.
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3870,
            "webauthn_get",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webauthn_get.success
    ///
    /// The total number of successful calls to navigator.credentials.get.
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3871,
            "webauthn_get",
            "success",
            "metrics"
        )
    });

}
pub mod workers {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from workers.dedicated_worker_spawn_gets_queued
    ///
    /// Tracking whether a DedicatedWorker spawn gets queued due to hitting max workers per domain limit.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEDICATED_WORKER_SPAWN_GETS_QUEUED.
    pub static dedicated_worker_spawn_gets_queued: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3872,
            "workers",
            "dedicated_worker_spawn_gets_queued",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from workers.service_worker_spawn_gets_queued
    ///
    /// Tracking whether a ServiceWorker spawn gets queued due to hitting max workers per domain limit.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SERVICE_WORKER_SPAWN_GETS_QUEUED.
    pub static service_worker_spawn_gets_queued: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3873,
            "workers",
            "service_worker_spawn_gets_queued",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from workers.shared_worker_spawn_gets_queued
    ///
    /// Tracking whether a SharedWorker spawn gets queued due to hitting max workers per domain limit.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SHARED_WORKER_SPAWN_GETS_QUEUED.
    pub static shared_worker_spawn_gets_queued: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3874,
            "workers",
            "shared_worker_spawn_gets_queued",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from workers.sync_worker_operation
    ///
    /// Tracking how long a Worker thread is blocked when a sync operation is executed on the main-thread.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SYNC_WORKER_OPERATION.
    pub static sync_worker_operation: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "sync_worker_operation".into(),
                    category: "workers".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(3875), meta, None)
    });

}
pub mod htmleditors {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum OverriddenByBeforeinputListenersLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for OverriddenByBeforeinputListenersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for OverriddenByBeforeinputListenersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from htmleditors.overridden_by_beforeinput_listeners
    ///
    /// Number of HTML editors whose dispatching beforeinput events are canceled
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTMLEDITORS_OVERRIDDEN_BY_BEFOREINPUT_LISTENERS.
    pub static overridden_by_beforeinput_listeners: Lazy<LabeledMetric<LabeledCounterMetric, OverriddenByBeforeinputListenersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "overridden_by_beforeinput_listeners".into(),
                    category: "htmleditors".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3876), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum WithBeforeinputListenersLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WithBeforeinputListenersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WithBeforeinputListenersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from htmleditors.with_beforeinput_listeners
    ///
    /// Number of HTML editors whose window or a node in it has had beforeinput event listeners
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTMLEDITORS_WITH_BEFOREINPUT_LISTENERS.
    pub static with_beforeinput_listeners: Lazy<LabeledMetric<LabeledCounterMetric, WithBeforeinputListenersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "with_beforeinput_listeners".into(),
                    category: "htmleditors".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3877), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum WithMutationListenersWithoutBeforeinputListenersLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WithMutationListenersWithoutBeforeinputListenersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WithMutationListenersWithoutBeforeinputListenersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from htmleditors.with_mutation_listeners_without_beforeinput_listeners
    ///
    /// Number of HTML editors whose window or a node in it has had mutation event listeners, but has not had beforeinput event listeners
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTMLEDITORS_WITH_MUTATION_LISTENERS_WITHOUT_BEFOREINPUT_LISTENERS.
    pub static with_mutation_listeners_without_beforeinput_listeners: Lazy<LabeledMetric<LabeledCounterMetric, WithMutationListenersWithoutBeforeinputListenersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "with_mutation_listeners_without_beforeinput_listeners".into(),
                    category: "htmleditors".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3878), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum WithMutationObserversWithoutBeforeinputListenersLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WithMutationObserversWithoutBeforeinputListenersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WithMutationObserversWithoutBeforeinputListenersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from htmleditors.with_mutation_observers_without_beforeinput_listeners
    ///
    /// Number of HTML editors a node in the window has been observed by mutation observers, but has not had beforeinput event listeners
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTMLEDITORS_WITH_MUTATION_OBSERVERS_WITHOUT_BEFOREINPUT_LISTENERS.
    pub static with_mutation_observers_without_beforeinput_listeners: Lazy<LabeledMetric<LabeledCounterMetric, WithMutationObserversWithoutBeforeinputListenersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "with_mutation_observers_without_beforeinput_listeners".into(),
                    category: "htmleditors".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3879), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod permissions {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from permissions.defective_sql_removed
    ///
    /// Record the removal of defective permissions.sqlite
    /// This metric was generated to correspond to the Legacy Telemetry count histogram DEFECTIVE_PERMISSIONS_SQL_REMOVED.
    pub static defective_sql_removed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3880,
            "permissions",
            "defective_sql_removed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from permissions.sql_corrupted
    ///
    /// Record the permissions.sqlite init failure
    /// This metric was generated to correspond to the Legacy Telemetry count histogram PERMISSIONS_SQL_CORRUPTED.
    pub static sql_corrupted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3881,
            "permissions",
            "sql_corrupted",
            "metrics"
        )
    });

}
pub mod apz_zoom {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ActivityLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ActivityLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ActivityLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from apz_zoom.activity
    ///
    /// Whether non-RDM page had user-triggered zooming activity
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram APZ_ZOOM_ACTIVITY.
    pub static activity: Lazy<LabeledMetric<LabeledCounterMetric, ActivityLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "activity".into(),
                    category: "apz_zoom".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3882), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from apz_zoom.pinchsource
    ///
    /// Input device that triggered the zoom gesture (InputData::PinchGestureSource)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram APZ_ZOOM_PINCHSOURCE.
    pub static pinchsource: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pinchsource".into(),
                category: "apz_zoom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3883), meta, 0, 5, 6, HistogramType::Linear)
    });

}
pub mod fontlist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BadFallbackFontLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for BadFallbackFontLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BadFallbackFontLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fontlist.bad_fallback_font
    ///
    /// system fallback font can't be used
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram BAD_FALLBACK_FONT.
    pub static bad_fallback_font: Lazy<LabeledMetric<LabeledCounterMetric, BadFallbackFontLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bad_fallback_font".into(),
                    category: "fontlist".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3884), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.bundledfonts_activate
    ///
    /// Time(ms) spent activating additional fonts bundled with the product
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FONTLIST_BUNDLEDFONTS_ACTIVATE.
    pub static bundledfonts_activate: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bundledfonts_activate".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3885), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.dwritefont_delayedinit_collect
    ///
    /// gfxDWriteFontList::DelayedInitFontList GetSystemFontCollection (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DWRITEFONT_DELAYEDINITFONTLIST_COLLECT.
    pub static dwritefont_delayedinit_collect: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dwritefont_delayedinit_collect".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3886), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.dwritefont_delayedinit_count
    ///
    /// gfxDWriteFontList::DelayedInitFontList Font Family Count
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DWRITEFONT_DELAYEDINITFONTLIST_COUNT.
    pub static dwritefont_delayedinit_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dwritefont_delayedinit_count".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3887), meta, 1, 10000, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.dwritefont_delayedinit_total
    ///
    /// gfxDWriteFontList::DelayedInitFontList Total (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DWRITEFONT_DELAYEDINITFONTLIST_TOTAL.
    pub static dwritefont_delayedinit_total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dwritefont_delayedinit_total".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3888), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.dwritefont_init_problem
    ///
    /// DirectWrite system fontlist initialization problem (1=GDI interop, 2=system font collection, 3=no fonts)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DWRITEFONT_INIT_PROBLEM.
    pub static dwritefont_init_problem: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dwritefont_init_problem".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3889), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum FontCacheHitLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for FontCacheHitLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FontCacheHitLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fontlist.font_cache_hit
    ///
    /// font cache hit
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram FONT_CACHE_HIT.
    pub static font_cache_hit: Lazy<LabeledMetric<LabeledCounterMetric, FontCacheHitLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "font_cache_hit".into(),
                    category: "fontlist".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3890), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.gdi_init_total
    ///
    /// gfxGDIFontList::InitFontList Total (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram GDI_INITFONTLIST_TOTAL.
    pub static gdi_init_total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gdi_init_total".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3891), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.initfacenamelists
    ///
    /// Time(ms) spent on reading family names from all fonts
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FONTLIST_INITFACENAMELISTS.
    pub static initfacenamelists: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initfacenamelists".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3892), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.initotherfamilynames
    ///
    /// Time(ms) spent on reading other family names from all fonts
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FONTLIST_INITOTHERFAMILYNAMES.
    pub static initotherfamilynames: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initotherfamilynames".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3893), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.initotherfamilynames_no_deferring
    ///
    /// Time(ms) spent on reading other family names from all fonts for no timeout case
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FONTLIST_INITOTHERFAMILYNAMES_NO_DEFERRING.
    pub static initotherfamilynames_no_deferring: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initotherfamilynames_no_deferring".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3894), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.mac_init_total
    ///
    /// gfxMacPlatformFontList::InitFontList Total (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MAC_INITFONTLIST_TOTAL.
    pub static mac_init_total: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mac_init_total".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3895), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.system_font_fallback
    ///
    /// System font fallback (us)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SYSTEM_FONT_FALLBACK.
    pub static system_font_fallback: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_font_fallback".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3896), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fontlist.system_font_fallback_first
    ///
    /// System font fallback, first call (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SYSTEM_FONT_FALLBACK_FIRST.
    pub static system_font_fallback_first: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_font_fallback_first".into(),
                category: "fontlist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3897), meta, TimeUnit::Millisecond)
    });

}
pub mod gfx {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.composite_frame_roundtrip_time
    ///
    /// Time from vsync to finishing a composite in milliseconds.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram COMPOSITE_FRAME_ROUNDTRIP_TIME.
    pub static composite_frame_roundtrip_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "composite_frame_roundtrip_time".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3898), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.composite_swap_time
    ///
    /// Time to do swap/present/commit in 100 microseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram COMPOSITE_SWAP_TIME.
    pub static composite_swap_time: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "composite_swap_time".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3899), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.composite_time
    ///
    /// The time taken to composite a frame. On non-webrender this is the time taken in `CompositorBridgeParent::CompositeToTarget()`. On webrender, this is the time taken from the start of `WebRenderBridgeParent::CompositeToTarget()`, until the render thread has rendered the frame (in `RenderThread::HandleFrameOneDoc()`). (Migrated from the geckoview metric of the same name).
    pub static composite_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "composite_time".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3900), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content_failed_to_acquire_device
    ///
    /// Failed to create a gfx content device. 0=content d3d11, 1=image d3d11, 2=d2d1.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram GFX_CONTENT_FAILED_TO_ACQUIRE_DEVICE.
    pub static content_failed_to_acquire_device: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_failed_to_acquire_device".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3901), meta, 0, 6, 7, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.crash
    ///
    /// Graphics Crash Reason (...)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram GFX_CRASH.
    pub static crash: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "crash".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3902), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.device_reset_reason
    ///
    /// GPU Device Reset Reason (ok, hung, removed, reset, internal error, invalid call, out of memory)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DEVICE_RESET_REASON.
    pub static device_reset_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_reset_reason".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3903), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.forced_device_reset_reason
    ///
    /// GPU Forced Device Reset Reason (OpenSharedHandle)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FORCED_DEVICE_RESET_REASON.
    pub static forced_device_reset_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forced_device_reset_reason".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3904), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.graphics_driver_startup_test
    ///
    /// Reports whether or not graphics drivers crashed during startup.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram GRAPHICS_DRIVER_STARTUP_TEST.
    pub static graphics_driver_startup_test: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "graphics_driver_startup_test".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3905), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.linux_window_protocol
    ///
    /// Windowing protocol on Linux. Can be Wayland, WaylandDRM, XWayland, or X11 This metric was generated to correspond to the Legacy Telemetry scalar gfx.linux_window_protocol.
    pub static linux_window_protocol: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "linux_window_protocol".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3906), meta)
    });

    #[repr(u16)]
    pub enum MacosVideoLowPowerLabel {
        ENotvideo = 0,
        ELowpower = 1,
        EFailmultiplevideo = 2,
        EFailwindowed = 3,
        EFailoverlaid = 4,
        EFailbacking = 5,
        EFailmacosversion = 6,
        EFailpref = 7,
        EFailsurface = 8,
        EFailenqueue = 9,
        __Other__,
    }
    impl From<u16> for MacosVideoLowPowerLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotvideo,
                1 => Self::ELowpower,
                2 => Self::EFailmultiplevideo,
                3 => Self::EFailwindowed,
                4 => Self::EFailoverlaid,
                5 => Self::EFailbacking,
                6 => Self::EFailmacosversion,
                7 => Self::EFailpref,
                8 => Self::EFailsurface,
                9 => Self::EFailenqueue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MacosVideoLowPowerLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotvideo => "NotVideo",
                Self::ELowpower => "LowPower",
                Self::EFailmultiplevideo => "FailMultipleVideo",
                Self::EFailwindowed => "FailWindowed",
                Self::EFailoverlaid => "FailOverlaid",
                Self::EFailbacking => "FailBacking",
                Self::EFailmacosversion => "FailMacOSVersion",
                Self::EFailpref => "FailPref",
                Self::EFailsurface => "FailSurface",
                Self::EFailenqueue => "FailEnqueue",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.macos_video_low_power
    ///
    /// MacOS video low power state achieved when enqueueing a video frame.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram GFX_MACOS_VIDEO_LOW_POWER.
    pub static macos_video_low_power: Lazy<LabeledMetric<LabeledCounterMetric, MacosVideoLowPowerLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "macos_video_low_power".into(),
                    category: "gfx".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3907), meta, Some(vec![::std::borrow::Cow::from("FailBacking"), ::std::borrow::Cow::from("FailEnqueue"), ::std::borrow::Cow::from("FailMacOSVersion"), ::std::borrow::Cow::from("FailMultipleVideo"), ::std::borrow::Cow::from("FailOverlaid"), ::std::borrow::Cow::from("FailPref"), ::std::borrow::Cow::from("FailSurface"), ::std::borrow::Cow::from("FailWindowed"), ::std::borrow::Cow::from("LowPower"), ::std::borrow::Cow::from("NotVideo")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.os_compositor
    ///
    /// Boolean indicating whether the os compositor is being used by WebRender. Only collected in the first subsession. This metric was generated to correspond to the Legacy Telemetry scalar gfx.os_compositor.
    pub static os_compositor: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_compositor".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(3908), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.sanity_test
    ///
    /// Reports results from the graphics sanity test to track which drivers are having problems (0=TEST_PASSED, 1=TEST_FAILED_RENDER, 2=TEST_FAILED_VIDEO, 3=TEST_CRASHED)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram GRAPHICS_SANITY_TEST.
    pub static sanity_test: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sanity_test".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3909), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.scroll_present_latency
    ///
    /// Time between receiving a scroll event on the event loop and compositing its result onto the screen (ms). (Migrated from the geckoview metric of the same name).
    pub static scroll_present_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scroll_present_latency".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3910), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.skipped_composites
    ///
    /// Number of skipped composites, happening when rendering is too slow to keep up with content. This metric was generated to correspond to the Legacy Telemetry scalar gfx.skipped_composites.
    pub static skipped_composites: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3911,
            "gfx",
            "skipped_composites",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.supports_hdr
    ///
    /// Does the hardware support accurate display of HDR content This metric was generated to correspond to the Legacy Telemetry scalar gfx.supports_hdr.
    pub static supports_hdr: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "supports_hdr".into(),
                category: "gfx".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(3912), meta)
    });

}
pub mod gfx_adapter_primary {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.description
    ///
    /// Long form description of the Graphics adapter (Migrated from the geckoview metric of the same name).
    pub static description: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "description".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3913), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.device_id
    ///
    /// Graphics adapter device identification (Migrated from the geckoview metric of the same name).
    pub static device_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3914), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_date
    ///
    /// Graphics adapter driver date (Migrated from the geckoview metric of the same name).
    pub static driver_date: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_date".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3915), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_files
    ///
    /// List of graphics adapter driver files (Migrated from the geckoview metric of the same name).
    pub static driver_files: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_files".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3916), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_vendor
    ///
    /// Graphics adapter driver vendor identification (Migrated from the geckoview metric of the same name).
    pub static driver_vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_vendor".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3917), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.driver_version
    ///
    /// Graphics adapter driver version (Migrated from the geckoview metric of the same name).
    pub static driver_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "driver_version".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3918), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.ram
    ///
    /// Graphics adapter dedicated memory (Migrated from the geckoview metric of the same name).
    pub static ram: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ram".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3919), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.subsystem_id
    ///
    /// Graphics adapter subsystem identification (Migrated from the geckoview metric of the same name).
    pub static subsystem_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subsystem_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3920), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.adapter.primary.vendor_id
    ///
    /// Graphics adapter vendor identification (Migrated from the geckoview metric of the same name).
    pub static vendor_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vendor_id".into(),
                category: "gfx.adapter.primary".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3921), meta)
    });

}
pub mod gfx_checkerboard {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.duration
    ///
    /// The duration of a checkerboard event. Checkerboarding is when painting has not kept up with asynchronous panning and zooming so the compositor has to display a "checkerboard pattern" (or in practice, the background color) rather than the actual page content. (Migrated from the geckoview metric of the same name).
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "duration".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3922), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.peak_pixel_count
    ///
    /// The peak number of CSS pixels that checkerboarded during a checkerboard event. The minimum value of the largest histogram bucket is the size of a 4k display with maximum APZ zooming. (Migrated from the geckoview metric of the same name).
    pub static peak_pixel_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_pixel_count".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3923), meta, 1, 66355200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.potential_duration
    ///
    /// The total amount of time that we could reasonably be checkerboarding. This is the union of two possibly-intersecting sets of time periods: The first set is that in which checkerboarding was actually happening, since by definition it could potentially be happening. The second set is that in which the APZC is actively transforming content in the compositor, since it could potentially transform it so as to display checkerboarding to the user. Combined with other information, this allows us to meaningfully say how frequently users actually enncounters checkerboarding. (Migrated from the geckoview metric of the same name).
    pub static potential_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "potential_duration".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3924), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.checkerboard.severity
    ///
    /// An opaque measurement of the severity of a checkerboard event. This doesn't have units, it's just useful for comparing two checkerboard events to see which one is worse, for some implementation-specific definition of "worse". The larger the value, the worse the checkerboarding. (Migrated from the geckoview metric of the same name).
    pub static severity: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "severity".into(),
                category: "gfx.checkerboard".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3925), meta, 1, 1073741824, 50, HistogramType::Exponential)
    });

}
pub mod gfx_content {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.full_paint_time
    ///
    /// Time spent in the full paint pipeline for content until it's ready for composition. For non-webrender this includes `paint_time`, plus rasterization if OMTP is enabled. For webrender, this includes `paint_time`, plus scene building time. (Migrated from the geckoview metric of the same name).
    pub static full_paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "full_paint_time".into(),
                category: "gfx.content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3926), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum LargePaintPhaseWeightFullLabel {
        EDl = 0,
        EWrdl = 1,
        ESb = 2,
        EFb = 3,
        __Other__,
    }
    impl From<u16> for LargePaintPhaseWeightFullLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDl,
                1 => Self::EWrdl,
                2 => Self::ESb,
                3 => Self::EFb,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LargePaintPhaseWeightFullLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDl => "dl",
                Self::EWrdl => "wrdl",
                Self::ESb => "sb",
                Self::EFb => "fb",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.large_paint_phase_weight_full
    ///
    /// Percentages of times for phases in an expensive content paint relative to the time spent in the entire expensive paint. ("dl" = Display list, "wrdl" = WebRender display list, "sb" = Scene building, "fb" = Frame building)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram CONTENT_LARGE_PAINT_PHASE_WEIGHT_FULL.
    pub static large_paint_phase_weight_full: Lazy<LabeledMetric<LabeledCustomDistributionMetric, LargePaintPhaseWeightFullLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "large_paint_phase_weight_full".into(),
                    category: "gfx.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 12, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3927), meta, Some(vec![::std::borrow::Cow::from("dl"), ::std::borrow::Cow::from("fb"), ::std::borrow::Cow::from("sb"), ::std::borrow::Cow::from("wrdl")]))
    });

    #[repr(u16)]
    pub enum LargePaintPhaseWeightPartialLabel {
        EDl = 0,
        EWrdl = 1,
        ESb = 2,
        EFb = 3,
        __Other__,
    }
    impl From<u16> for LargePaintPhaseWeightPartialLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDl,
                1 => Self::EWrdl,
                2 => Self::ESb,
                3 => Self::EFb,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LargePaintPhaseWeightPartialLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDl => "dl",
                Self::EWrdl => "wrdl",
                Self::ESb => "sb",
                Self::EFb => "fb",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.large_paint_phase_weight_partial
    ///
    /// Percentages of times for phases in an expensive content paint relative to the time spent in the entire expensive paint. ("dl" = Display list, "wrdl" = WebRender display list, "sb" = Scene building, "fb" = Frame building)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram CONTENT_LARGE_PAINT_PHASE_WEIGHT_PARTIAL.
    pub static large_paint_phase_weight_partial: Lazy<LabeledMetric<LabeledCustomDistributionMetric, LargePaintPhaseWeightPartialLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "large_paint_phase_weight_partial".into(),
                    category: "gfx.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 12, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3928), meta, Some(vec![::std::borrow::Cow::from("dl"), ::std::borrow::Cow::from("fb"), ::std::borrow::Cow::from("sb"), ::std::borrow::Cow::from("wrdl")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.paint_time
    ///
    /// Time spent in the main-thread paint pipeline for content. For non-webrender, this includes display list building, layer building, and when OMTP is disabled, rasterization. For webrender, this includes display list building, and webrender display list building. (Migrated from the geckoview metric of the same name).
    pub static paint_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "paint_time".into(),
                category: "gfx.content".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3929), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SmallPaintPhaseWeightFullLabel {
        EDl = 0,
        EWrdl = 1,
        ESb = 2,
        EFb = 3,
        __Other__,
    }
    impl From<u16> for SmallPaintPhaseWeightFullLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDl,
                1 => Self::EWrdl,
                2 => Self::ESb,
                3 => Self::EFb,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SmallPaintPhaseWeightFullLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDl => "dl",
                Self::EWrdl => "wrdl",
                Self::ESb => "sb",
                Self::EFb => "fb",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.small_paint_phase_weight_full
    ///
    /// Percentages of times for phases in a normal content paint relative to the time spent in the entire normal paint. ("dl" = Display list, "wrdl" = WebRender display list, "sb" = Scene building, "fb" = Frame building)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram CONTENT_SMALL_PAINT_PHASE_WEIGHT_FULL.
    pub static small_paint_phase_weight_full: Lazy<LabeledMetric<LabeledCustomDistributionMetric, SmallPaintPhaseWeightFullLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "small_paint_phase_weight_full".into(),
                    category: "gfx.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 12, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3930), meta, Some(vec![::std::borrow::Cow::from("dl"), ::std::borrow::Cow::from("fb"), ::std::borrow::Cow::from("sb"), ::std::borrow::Cow::from("wrdl")]))
    });

    #[repr(u16)]
    pub enum SmallPaintPhaseWeightPartialLabel {
        EDl = 0,
        EWrdl = 1,
        ESb = 2,
        EFb = 3,
        __Other__,
    }
    impl From<u16> for SmallPaintPhaseWeightPartialLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDl,
                1 => Self::EWrdl,
                2 => Self::ESb,
                3 => Self::EFb,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SmallPaintPhaseWeightPartialLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDl => "dl",
                Self::EWrdl => "wrdl",
                Self::ESb => "sb",
                Self::EFb => "fb",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.small_paint_phase_weight_partial
    ///
    /// Percentages of times for phases in a normal content paint relative to the time spent in the entire normal paint. ("dl" = Display list, "wrdl" = WebRender display list, "sb" = Scene building, "fb" = Frame building)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram CONTENT_SMALL_PAINT_PHASE_WEIGHT_PARTIAL.
    pub static small_paint_phase_weight_partial: Lazy<LabeledMetric<LabeledCustomDistributionMetric, SmallPaintPhaseWeightPartialLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "small_paint_phase_weight_partial".into(),
                    category: "gfx.content".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100, bucket_count: 12, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(3931), meta, Some(vec![::std::borrow::Cow::from("dl"), ::std::borrow::Cow::from("fb"), ::std::borrow::Cow::from("sb"), ::std::borrow::Cow::from("wrdl")]))
    });

}
pub mod gfx_content_frame_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_paint
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in the content process until that frame is presented in the compositor. (Migrated from the geckoview metric of the same name).
    pub static from_paint: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_paint".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3932), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.from_vsync
    ///
    /// The time, in percentage of a vsync interval, spent from the vsync that started a paint in the content process until that frame is presented in the compositor. (Migrated from the geckoview metric of the same name).
    pub static from_vsync: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "from_vsync".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3933), meta, 8, 792, 100, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ReasonLabel {
        EOnTime = 0,
        ENoVsync = 1,
        EMissedComposite = 2,
        ESlowComposite = 3,
        EMissedCompositeMid = 4,
        EMissedCompositeLong = 5,
        EMissedCompositeLow = 6,
        ENoVsyncNoId = 7,
        __Other__,
    }
    impl From<u16> for ReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOnTime,
                1 => Self::ENoVsync,
                2 => Self::EMissedComposite,
                3 => Self::ESlowComposite,
                4 => Self::EMissedCompositeMid,
                5 => Self::EMissedCompositeLong,
                6 => Self::EMissedCompositeLow,
                7 => Self::ENoVsyncNoId,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOnTime => "on_time",
                Self::ENoVsync => "no_vsync",
                Self::EMissedComposite => "missed_composite",
                Self::ESlowComposite => "slow_composite",
                Self::EMissedCompositeMid => "missed_composite_mid",
                Self::EMissedCompositeLong => "missed_composite_long",
                Self::EMissedCompositeLow => "missed_composite_low",
                Self::ENoVsyncNoId => "no_vsync_no_id",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.reason
    ///
    /// The reason that `gfx.content.frame_time.from_paint` recorded a slow (>200ms) result, if any. (Migrated from the geckoview metric of the same name).
    pub static reason: Lazy<LabeledMetric<LabeledCounterMetric, ReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reason".into(),
                    category: "gfx.content.frame_time".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3934), meta, Some(vec![::std::borrow::Cow::from("missed_composite"), ::std::borrow::Cow::from("missed_composite_long"), ::std::borrow::Cow::from("missed_composite_low"), ::std::borrow::Cow::from("missed_composite_mid"), ::std::borrow::Cow::from("no_vsync"), ::std::borrow::Cow::from("no_vsync_no_id"), ::std::borrow::Cow::from("on_time"), ::std::borrow::Cow::from("slow_composite")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.with_svg
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in the content process until that frame is presented in the compositor, for frames that contained an SVG to be drawn by webrender. (Migrated from the geckoview metric of the same name).
    pub static with_svg: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "with_svg".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3935), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_resource_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in the content process until that frame is presented in the compositor by webrender, excluding time spent uploading resources. (Migrated from the geckoview metric of the same name).
    pub static without_resource_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "without_resource_upload".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3936), meta, 1, 5000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.content.frame_time.without_upload
    ///
    /// The time, in percentage of a vsync interval, spent from beginning a paint in the content process until that frame is presented in the compositor by webrender, excluding time spent uploading any content. (Migrated from the geckoview metric of the same name).
    pub static without_upload: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "without_upload".into(),
                category: "gfx.content.frame_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3937), meta, 1, 5000, 50, HistogramType::Exponential)
    });

}
pub mod gfx_display {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.count
    ///
    /// Amount of displays connected to the device (Migrated from the geckoview metric of the same name).
    pub static count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3938), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_height
    ///
    /// Height of the primary display, takes device rotation into account. (Migrated from the geckoview metric of the same name).
    pub static primary_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "primary_height".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3939), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.primary_width
    ///
    /// Width of the primary display, takes device rotation into account. (Migrated from the geckoview metric of the same name).
    pub static primary_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "primary_width".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3940), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.display.scaling
    ///
    /// Scaling percentage for the display where the first window is opened
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram DISPLAY_SCALING.
    pub static scaling: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scaling".into(),
                category: "gfx.display".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3941), meta, 1, 500, 100, HistogramType::Linear)
    });

}
pub mod gfx_feature {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.feature.webrender
    ///
    /// Whether webrender is enabled or disabled, and why. (Migrated from the geckoview metric of the same name).
    pub static webrender: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "webrender".into(),
                category: "gfx.feature".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3942), meta)
    });

}
pub mod gfx_hdr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.hdr.windows_display_colorspace_bitfield
    ///
    /// A bitfield representation of the available DXGI color spaces of the connected displays on Windows. See (https://docs.microsoft.com/en- us/windows/desktop/api/dxgicommon/ne-dxgicommon- dxgi_color_space_type) for definitions of color spaces. Each N'th bit of this scalar indicates whether the DXGI color space with index 'N' is available on at least one connected monitor. This metric was generated to correspond to the Legacy Telemetry scalar gfx.hdr.windows_display_colorspace_bitfield.
    pub static windows_display_colorspace_bitfield: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "windows_display_colorspace_bitfield".into(),
                category: "gfx.hdr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3943), meta)
    });

}
pub mod gfx_status {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.compositor
    ///
    /// Name of the graphics compositor in use. Possible values are "opengl, d3d11, client, webrender or basic" (Migrated from the geckoview metric of the same name).
    pub static compositor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compositor".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3944), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.headless
    ///
    /// Boolean indicated whether graphics is running in headless (no display) mode (Migrated from the geckoview metric of the same name).
    pub static headless: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "headless".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(3945), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gfx.status.last_compositor_gecko_version
    ///
    /// The gecko version at the last time a compositor was initialized, and therefore when gfx_status_compositor was last updated. Due to gfx_status_compositor's user lifetime we see lots of unexpected values for the current gecko version. We believe this is because the user has not opened a tab since they were updated to a version where webrender should be enabled on their device. This can be used to verify that theory. (Migrated from the geckoview metric of the same name).
    pub static last_compositor_gecko_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_compositor_gecko_version".into(),
                category: "gfx.status".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3946), meta)
    });

}
pub mod gpu_process {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CrashFallbacksLabel {
        ENone = 0,
        EDecodingDisabled = 1,
        EDisabled = 2,
        __Other__,
    }
    impl From<u16> for CrashFallbacksLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EDecodingDisabled,
                2 => Self::EDisabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrashFallbacksLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "none",
                Self::EDecodingDisabled => "decoding_disabled",
                Self::EDisabled => "disabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.crash_fallbacks
    ///
    /// How often we use different fallbacks when the GPU process crashes
    pub static crash_fallbacks: Lazy<LabeledMetric<LabeledCounterMetric, CrashFallbacksLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crash_fallbacks".into(),
                    category: "gpu_process".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3947), meta, Some(vec![::std::borrow::Cow::from("decoding_disabled"), ::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("none")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.feature_status
    ///
    /// Current status of the GPU process feature
    pub static feature_status: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "feature_status".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(3948), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.initialization_time
    ///
    /// GPU process initialization (excluding XPCOM and fork time) time in milliseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram GPU_PROCESS_INITIALIZATION_TIME_MS.
    pub static initialization_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initialization_time".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3949), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.launch_time
    ///
    /// GPU process launch time in milliseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram GPU_PROCESS_LAUNCH_TIME_MS_2.
    pub static launch_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "launch_time".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3950), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.total_launch_attempts
    ///
    /// The number of total GPU process launch attempts.
    pub static total_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_launch_attempts".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3951), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gpu_process.unstable_launch_attempts
    ///
    /// The number of consecutive unstable launch attempts.
    pub static unstable_launch_attempts: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unstable_launch_attempts".into(),
                category: "gpu_process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(3952), meta)
    });

}
pub mod paint {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from paint.build_displaylist_time
    ///
    /// The time to build a Gecko display list.
    pub static build_displaylist_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_displaylist_time".into(),
                category: "paint".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3953), meta, TimeUnit::Nanosecond)
    });

}
pub mod webfont {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from webfont.compression_woff
    ///
    /// Compression ratio of WOFF data (%)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBFONT_COMPRESSION_WOFF.
    pub static compression_woff: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compression_woff".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3954), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.compression_woff2
    ///
    /// Compression ratio of WOFF2 data (%)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBFONT_COMPRESSION_WOFF2.
    pub static compression_woff2: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compression_woff2".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3955), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.download_time
    ///
    /// Time to download a webfont (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBFONT_DOWNLOAD_TIME.
    pub static download_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_time".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3956), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.fonttype
    ///
    /// Font format type (woff/woff2/ttf/...)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBFONT_FONTTYPE.
    pub static fonttype: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonttype".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3957), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.per_page
    ///
    /// Number of fonts loaded at page load
    /// This metric was generated to correspond to the Legacy Telemetry count histogram WEBFONT_PER_PAGE.
    pub static per_page: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            3958,
            "webfont",
            "per_page",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.size
    ///
    /// Size of font loaded (kb)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBFONT_SIZE.
    pub static size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(3959), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.size_per_page
    ///
    /// Size of all fonts loaded at page load (kb)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBFONT_SIZE_PER_PAGE.
    pub static size_per_page: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size_per_page".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(3960), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webfont.srctype
    ///
    /// Font src type loaded (1 = local, 2 = url, 3 = data)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBFONT_SRCTYPE.
    pub static srctype: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "srctype".into(),
                category: "webfont".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3961), meta, 0, 5, 6, HistogramType::Linear)
    });

}
pub mod wr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from wr.framebuild_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static framebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "framebuild_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3962), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.gpu_wait_time
    ///
    /// The time spent waiting for the GPU to complete previously issued drawing commands.
    pub static gpu_wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gpu_wait_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3963), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_blobs_time
    ///
    /// The time to rasterize blobs for consumption by WebRender.
    pub static rasterize_blobs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rasterize_blobs_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3964), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.rasterize_glyphs_time
    ///
    /// The time to rasterize glyphs for consumption by WebRender.
    pub static rasterize_glyphs_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rasterize_glyphs_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3965), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time
    ///
    /// WebRender renderer time.
    pub static renderer_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "renderer_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3966), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.renderer_time_no_sc
    ///
    /// WebRender renderer time excluding frames in which shader compilation took place.
    pub static renderer_time_no_sc: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "renderer_time_no_sc".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3967), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.scenebuild_time
    ///
    /// WebRender scene build time.
    pub static scenebuild_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scenebuild_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3968), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.sceneswap_time
    ///
    /// WebRender scene swap time.
    pub static sceneswap_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sceneswap_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3969), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.shaderload_time
    ///
    /// Time spent blocking on the shader compilation for LazilyCompiled shaders created with ASYNC_COMPILE or FULL_COMPILE.
    pub static shaderload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shaderload_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3970), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.texture_cache_update_time
    ///
    /// Time taken by WebRender to update the texture cache.
    pub static texture_cache_update_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "texture_cache_update_time".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3971), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_frame_build
    ///
    /// Time elapsed between the construction of a transaction and the associated frame build beginning.
    pub static time_to_frame_build: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_frame_build".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3972), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from wr.time_to_render_start
    ///
    /// Time elapsed between the construction of a frame and the start of rendering.
    pub static time_to_render_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_render_start".into(),
                category: "wr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3973), meta, TimeUnit::Microsecond)
    });

}
pub mod avif {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum A1lxLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1lxLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1lxLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1lx
    ///
    /// AV1LayeredImageIndexingProperty (a1lx). (Migrated from the geckoview metric of the same name).
    pub static a1lx: Lazy<LabeledMetric<LabeledCounterMetric, A1lxLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a1lx".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3974), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum A1opLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for A1opLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for A1opLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.a1op
    ///
    /// AVIF OperatingPointSelectorProperty (a1op). (Migrated from the geckoview metric of the same name).
    pub static a1op: Lazy<LabeledMetric<LabeledCounterMetric, A1opLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a1op".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3975), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AlphaLabel {
        EAbsent = 0,
        EPresent = 1,
        __Other__,
    }
    impl From<u16> for AlphaLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::EPresent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AlphaLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::EPresent => "present",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.alpha
    ///
    /// AVIF alpha plane. (Migrated from the geckoview metric of the same name).
    pub static alpha: Lazy<LabeledMetric<LabeledCounterMetric, AlphaLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "alpha".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3976), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum AomDecodeErrorLabel {
        EError = 0,
        EMemError = 1,
        EAbiMismatch = 2,
        EIncapable = 3,
        EUnsupBitstream = 4,
        EUnsupFeature = 5,
        ECorruptFrame = 6,
        EInvalidParam = 7,
        __Other__,
    }
    impl From<u16> for AomDecodeErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EError,
                1 => Self::EMemError,
                2 => Self::EAbiMismatch,
                3 => Self::EIncapable,
                4 => Self::EUnsupBitstream,
                5 => Self::EUnsupFeature,
                6 => Self::ECorruptFrame,
                7 => Self::EInvalidParam,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AomDecodeErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EError => "error",
                Self::EMemError => "mem_error",
                Self::EAbiMismatch => "abi_mismatch",
                Self::EIncapable => "incapable",
                Self::EUnsupBitstream => "unsup_bitstream",
                Self::EUnsupFeature => "unsup_feature",
                Self::ECorruptFrame => "corrupt_frame",
                Self::EInvalidParam => "invalid_param",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.aom_decode_error
    ///
    /// Image-decode Error from AOM decoder (Migrated from the geckoview metric of the same name).
    pub static aom_decode_error: Lazy<LabeledMetric<LabeledCounterMetric, AomDecodeErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "aom_decode_error".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3977), meta, Some(vec![::std::borrow::Cow::from("abi_mismatch"), ::std::borrow::Cow::from("corrupt_frame"), ::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("incapable"), ::std::borrow::Cow::from("invalid_param"), ::std::borrow::Cow::from("mem_error"), ::std::borrow::Cow::from("unsup_bitstream"), ::std::borrow::Cow::from("unsup_feature")]))
    });

    #[repr(u16)]
    pub enum BitDepthLabel {
        EColor8 = 0,
        EColor10 = 1,
        EColor12 = 2,
        EColor16 = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for BitDepthLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EColor8,
                1 => Self::EColor10,
                2 => Self::EColor12,
                3 => Self::EColor16,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BitDepthLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EColor8 => "color_8",
                Self::EColor10 => "color_10",
                Self::EColor12 => "color_12",
                Self::EColor16 => "color_16",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.bit_depth
    ///
    /// Bits per pixel of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static bit_depth: Lazy<LabeledMetric<LabeledCounterMetric, BitDepthLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bit_depth".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3978), meta, Some(vec![::std::borrow::Cow::from("color_10"), ::std::borrow::Cow::from("color_12"), ::std::borrow::Cow::from("color_16"), ::std::borrow::Cow::from("color_8"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum CicpCpLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EGenericFilm = 8,
        EBt2020 = 9,
        EXyz = 10,
        ESmpte431 = 11,
        ESmpte432 = 12,
        EReserved13 = 13,
        EReserved14 = 14,
        EReserved15 = 15,
        EReserved16 = 16,
        EReserved17 = 17,
        EReserved18 = 18,
        EReserved19 = 19,
        EReserved20 = 20,
        EReserved21 = 21,
        EEbu3213 = 22,
        EReservedRest = 23,
        __Other__,
    }
    impl From<u16> for CicpCpLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EGenericFilm,
                9 => Self::EBt2020,
                10 => Self::EXyz,
                11 => Self::ESmpte431,
                12 => Self::ESmpte432,
                13 => Self::EReserved13,
                14 => Self::EReserved14,
                15 => Self::EReserved15,
                16 => Self::EReserved16,
                17 => Self::EReserved17,
                18 => Self::EReserved18,
                19 => Self::EReserved19,
                20 => Self::EReserved20,
                21 => Self::EReserved21,
                22 => Self::EEbu3213,
                23 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpCpLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EGenericFilm => "generic_film",
                Self::EBt2020 => "bt2020",
                Self::EXyz => "xyz",
                Self::ESmpte431 => "smpte431",
                Self::ESmpte432 => "smpte432",
                Self::EReserved13 => "reserved_13",
                Self::EReserved14 => "reserved_14",
                Self::EReserved15 => "reserved_15",
                Self::EReserved16 => "reserved_16",
                Self::EReserved17 => "reserved_17",
                Self::EReserved18 => "reserved_18",
                Self::EReserved19 => "reserved_19",
                Self::EReserved20 => "reserved_20",
                Self::EReserved21 => "reserved_21",
                Self::EEbu3213 => "ebu3213",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_cp
    ///
    /// AVIF CICP colour primaries. (Migrated from the geckoview metric of the same name).
    pub static cicp_cp: Lazy<LabeledMetric<LabeledCounterMetric, CicpCpLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_cp".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3979), meta, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("ebu3213"), ::std::borrow::Cow::from("generic_film"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_13"), ::std::borrow::Cow::from("reserved_14"), ::std::borrow::Cow::from("reserved_15"), ::std::borrow::Cow::from("reserved_16"), ::std::borrow::Cow::from("reserved_17"), ::std::borrow::Cow::from("reserved_18"), ::std::borrow::Cow::from("reserved_19"), ::std::borrow::Cow::from("reserved_20"), ::std::borrow::Cow::from("reserved_21"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte431"), ::std::borrow::Cow::from("smpte432"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("xyz")]))
    });

    #[repr(u16)]
    pub enum CicpMcLabel {
        EIdentity = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved = 3,
        EFcc = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        EYcgco = 8,
        EBt2020Ncl = 9,
        EBt2020Cl = 10,
        ESmpte2085 = 11,
        EChromatNcl = 12,
        EChromatCl = 13,
        EIctcp = 14,
        EReservedRest = 15,
        __Other__,
    }
    impl From<u16> for CicpMcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EIdentity,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved,
                4 => Self::EFcc,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::EYcgco,
                9 => Self::EBt2020Ncl,
                10 => Self::EBt2020Cl,
                11 => Self::ESmpte2085,
                12 => Self::EChromatNcl,
                13 => Self::EChromatCl,
                14 => Self::EIctcp,
                15 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpMcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EIdentity => "identity",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved => "reserved",
                Self::EFcc => "fcc",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::EYcgco => "ycgco",
                Self::EBt2020Ncl => "bt2020_ncl",
                Self::EBt2020Cl => "bt2020_cl",
                Self::ESmpte2085 => "smpte2085",
                Self::EChromatNcl => "chromat_ncl",
                Self::EChromatCl => "chromat_cl",
                Self::EIctcp => "ictcp",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_mc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the same name).
    pub static cicp_mc: Lazy<LabeledMetric<LabeledCounterMetric, CicpMcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_mc".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3980), meta, Some(vec![::std::borrow::Cow::from("bt2020_cl"), ::std::borrow::Cow::from("bt2020_ncl"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("chromat_cl"), ::std::borrow::Cow::from("chromat_ncl"), ::std::borrow::Cow::from("fcc"), ::std::borrow::Cow::from("ictcp"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2085"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("unspecified"), ::std::borrow::Cow::from("ycgco")]))
    });

    #[repr(u16)]
    pub enum CicpTcLabel {
        EReserved = 0,
        EBt709 = 1,
        EUnspecified = 2,
        EReserved3 = 3,
        EBt470m = 4,
        EBt470bg = 5,
        EBt601 = 6,
        ESmpte240 = 7,
        ELinear = 8,
        ELog100 = 9,
        ELog100Sqrt10 = 10,
        EIec61966 = 11,
        EBt1361 = 12,
        ESrgb = 13,
        EBt202010bit = 14,
        EBt202012bit = 15,
        ESmpte2084 = 16,
        ESmpte428 = 17,
        EHlg = 18,
        EReservedRest = 19,
        __Other__,
    }
    impl From<u16> for CicpTcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReserved,
                1 => Self::EBt709,
                2 => Self::EUnspecified,
                3 => Self::EReserved3,
                4 => Self::EBt470m,
                5 => Self::EBt470bg,
                6 => Self::EBt601,
                7 => Self::ESmpte240,
                8 => Self::ELinear,
                9 => Self::ELog100,
                10 => Self::ELog100Sqrt10,
                11 => Self::EIec61966,
                12 => Self::EBt1361,
                13 => Self::ESrgb,
                14 => Self::EBt202010bit,
                15 => Self::EBt202012bit,
                16 => Self::ESmpte2084,
                17 => Self::ESmpte428,
                18 => Self::EHlg,
                19 => Self::EReservedRest,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CicpTcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReserved => "reserved",
                Self::EBt709 => "bt709",
                Self::EUnspecified => "unspecified",
                Self::EReserved3 => "reserved_3",
                Self::EBt470m => "bt470m",
                Self::EBt470bg => "bt470bg",
                Self::EBt601 => "bt601",
                Self::ESmpte240 => "smpte240",
                Self::ELinear => "linear",
                Self::ELog100 => "log_100",
                Self::ELog100Sqrt10 => "log_100_sqrt10",
                Self::EIec61966 => "iec61966",
                Self::EBt1361 => "bt_1361",
                Self::ESrgb => "srgb",
                Self::EBt202010bit => "bt2020_10bit",
                Self::EBt202012bit => "bt2020_12bit",
                Self::ESmpte2084 => "smpte2084",
                Self::ESmpte428 => "smpte428",
                Self::EHlg => "hlg",
                Self::EReservedRest => "reserved_rest",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.cicp_tc
    ///
    /// AVIF CICP transfer characteristics. (Migrated from the geckoview metric of the same name).
    pub static cicp_tc: Lazy<LabeledMetric<LabeledCounterMetric, CicpTcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cicp_tc".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3981), meta, Some(vec![::std::borrow::Cow::from("bt2020_10bit"), ::std::borrow::Cow::from("bt2020_12bit"), ::std::borrow::Cow::from("bt470bg"), ::std::borrow::Cow::from("bt470m"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("bt_1361"), ::std::borrow::Cow::from("hlg"), ::std::borrow::Cow::from("iec61966"), ::std::borrow::Cow::from("linear"), ::std::borrow::Cow::from("log_100"), ::std::borrow::Cow::from("log_100_sqrt10"), ::std::borrow::Cow::from("reserved"), ::std::borrow::Cow::from("reserved_3"), ::std::borrow::Cow::from("reserved_rest"), ::std::borrow::Cow::from("smpte2084"), ::std::borrow::Cow::from("smpte240"), ::std::borrow::Cow::from("smpte428"), ::std::borrow::Cow::from("srgb"), ::std::borrow::Cow::from("unspecified")]))
    });

    #[repr(u16)]
    pub enum ClapLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for ClapLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ClapLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.clap
    ///
    /// AVIF CleanApertureBox (clap). (Migrated from the geckoview metric of the same name).
    pub static clap: Lazy<LabeledMetric<LabeledCounterMetric, ClapLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "clap".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3982), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum ColrLabel {
        ENclx = 0,
        EIcc = 1,
        EAbsent = 2,
        EBoth = 3,
        __Other__,
    }
    impl From<u16> for ColrLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENclx,
                1 => Self::EIcc,
                2 => Self::EAbsent,
                3 => Self::EBoth,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColrLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENclx => "nclx",
                Self::EIcc => "icc",
                Self::EAbsent => "absent",
                Self::EBoth => "both",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.colr
    ///
    /// AVIF colour information type. (Migrated from the geckoview metric of the same name).
    pub static colr: Lazy<LabeledMetric<LabeledCounterMetric, ColrLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "colr".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3983), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("both"), ::std::borrow::Cow::from("icc"), ::std::borrow::Cow::from("nclx")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Dav1dGetPictureReturnValueExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Dav1dGetPictureReturnValueExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.dav1d_get_picture_return_value
    ///
    /// Return value from dav1d_get_picture This event was generated to correspond to the Legacy Telemetry event avif.dav1d_get_picture#return_value.
    pub static dav1d_get_picture_return_value: Lazy<EventMetric<Dav1dGetPictureReturnValueExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dav1d_get_picture_return_value".into(),
                category: "avif".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(3984), meta)
    });

    #[repr(u16)]
    pub enum DecodeResultLabel {
        ESuccess = 0,
        EParseError = 1,
        ENoPrimaryItem = 2,
        EDecodeError = 3,
        ESizeOverflow = 4,
        EOutOfMemory = 5,
        EPipeInitError = 6,
        EWriteBufferError = 7,
        EAlphaYSzMismatch = 8,
        EAlphaYBpcMismatch = 9,
        EIspeMismatch = 10,
        ERenderSizeMismatch = 11,
        EFrameSizeChanged = 12,
        EInvalidCicp = 13,
        EInvalidParseStatus = 14,
        EMissingBrand = 15,
        EFtypNotFirst = 16,
        ENoImage = 17,
        EMultipleMoov = 18,
        ENoMoov = 19,
        ELselNoEssential = 20,
        EA1opNoEssential = 21,
        EA1lxEssential = 22,
        ETxformNoEssential = 23,
        EImageItemType = 24,
        EItemTypeMissing = 25,
        EConstructionMethod = 26,
        EItemLocNotFound = 27,
        ENoItemDataBox = 28,
        ENoSamples = 29,
        EConvertycbcrFailure = 30,
        EUncategorized = 31,
        __Other__,
    }
    impl From<u16> for DecodeResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EParseError,
                2 => Self::ENoPrimaryItem,
                3 => Self::EDecodeError,
                4 => Self::ESizeOverflow,
                5 => Self::EOutOfMemory,
                6 => Self::EPipeInitError,
                7 => Self::EWriteBufferError,
                8 => Self::EAlphaYSzMismatch,
                9 => Self::EAlphaYBpcMismatch,
                10 => Self::EIspeMismatch,
                11 => Self::ERenderSizeMismatch,
                12 => Self::EFrameSizeChanged,
                13 => Self::EInvalidCicp,
                14 => Self::EInvalidParseStatus,
                15 => Self::EMissingBrand,
                16 => Self::EFtypNotFirst,
                17 => Self::ENoImage,
                18 => Self::EMultipleMoov,
                19 => Self::ENoMoov,
                20 => Self::ELselNoEssential,
                21 => Self::EA1opNoEssential,
                22 => Self::EA1lxEssential,
                23 => Self::ETxformNoEssential,
                24 => Self::EImageItemType,
                25 => Self::EItemTypeMissing,
                26 => Self::EConstructionMethod,
                27 => Self::EItemLocNotFound,
                28 => Self::ENoItemDataBox,
                29 => Self::ENoSamples,
                30 => Self::EConvertycbcrFailure,
                31 => Self::EUncategorized,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecodeResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EParseError => "parse_error",
                Self::ENoPrimaryItem => "no_primary_item",
                Self::EDecodeError => "decode_error",
                Self::ESizeOverflow => "size_overflow",
                Self::EOutOfMemory => "out_of_memory",
                Self::EPipeInitError => "pipe_init_error",
                Self::EWriteBufferError => "write_buffer_error",
                Self::EAlphaYSzMismatch => "alpha_y_sz_mismatch",
                Self::EAlphaYBpcMismatch => "alpha_y_bpc_mismatch",
                Self::EIspeMismatch => "ispe_mismatch",
                Self::ERenderSizeMismatch => "render_size_mismatch",
                Self::EFrameSizeChanged => "frame_size_changed",
                Self::EInvalidCicp => "invalid_cicp",
                Self::EInvalidParseStatus => "invalid_parse_status",
                Self::EMissingBrand => "missing_brand",
                Self::EFtypNotFirst => "ftyp_not_first",
                Self::ENoImage => "no_image",
                Self::EMultipleMoov => "multiple_moov",
                Self::ENoMoov => "no_moov",
                Self::ELselNoEssential => "lsel_no_essential",
                Self::EA1opNoEssential => "a1op_no_essential",
                Self::EA1lxEssential => "a1lx_essential",
                Self::ETxformNoEssential => "txform_no_essential",
                Self::EImageItemType => "image_item_type",
                Self::EItemTypeMissing => "item_type_missing",
                Self::EConstructionMethod => "construction_method",
                Self::EItemLocNotFound => "item_loc_not_found",
                Self::ENoItemDataBox => "no_item_data_box",
                Self::ENoSamples => "no_samples",
                Self::EConvertycbcrFailure => "ConvertYCbCr_failure",
                Self::EUncategorized => "uncategorized",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decode_result
    ///
    /// Decode result of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static decode_result: Lazy<LabeledMetric<LabeledCounterMetric, DecodeResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decode_result".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3985), meta, Some(vec![::std::borrow::Cow::from("ConvertYCbCr_failure"), ::std::borrow::Cow::from("a1lx_essential"), ::std::borrow::Cow::from("a1op_no_essential"), ::std::borrow::Cow::from("alpha_y_bpc_mismatch"), ::std::borrow::Cow::from("alpha_y_sz_mismatch"), ::std::borrow::Cow::from("construction_method"), ::std::borrow::Cow::from("decode_error"), ::std::borrow::Cow::from("frame_size_changed"), ::std::borrow::Cow::from("ftyp_not_first"), ::std::borrow::Cow::from("image_item_type"), ::std::borrow::Cow::from("invalid_cicp"), ::std::borrow::Cow::from("invalid_parse_status"), ::std::borrow::Cow::from("ispe_mismatch"), ::std::borrow::Cow::from("item_loc_not_found"), ::std::borrow::Cow::from("item_type_missing"), ::std::borrow::Cow::from("lsel_no_essential"), ::std::borrow::Cow::from("missing_brand"), ::std::borrow::Cow::from("multiple_moov"), ::std::borrow::Cow::from("no_image"), ::std::borrow::Cow::from("no_item_data_box"), ::std::borrow::Cow::from("no_moov"), ::std::borrow::Cow::from("no_primary_item"), ::std::borrow::Cow::from("no_samples"), ::std::borrow::Cow::from("out_of_memory"), ::std::borrow::Cow::from("parse_error"), ::std::borrow::Cow::from("pipe_init_error"), ::std::borrow::Cow::from("render_size_mismatch"), ::std::borrow::Cow::from("size_overflow"), ::std::borrow::Cow::from("success"), ::std::borrow::Cow::from("txform_no_essential"), ::std::borrow::Cow::from("uncategorized"), ::std::borrow::Cow::from("write_buffer_error")]))
    });

    #[repr(u16)]
    pub enum DecoderLabel {
        EDav1d = 0,
        EAom = 1,
        __Other__,
    }
    impl From<u16> for DecoderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDav1d,
                1 => Self::EAom,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DecoderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDav1d => "dav1d",
                Self::EAom => "aom",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.decoder
    ///
    /// Decoder of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static decoder: Lazy<LabeledMetric<LabeledCounterMetric, DecoderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "decoder".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3986), meta, Some(vec![::std::borrow::Cow::from("aom"), ::std::borrow::Cow::from("dav1d")]))
    });

    #[repr(u16)]
    pub enum GridLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for GridLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GridLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.grid
    ///
    /// AVIF AVIF grid-based image. (Migrated from the geckoview metric of the same name).
    pub static grid: Lazy<LabeledMetric<LabeledCounterMetric, GridLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "grid".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3987), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IproLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for IproLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IproLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ipro
    ///
    /// AVIF ItemProtectionBox (ipro). (Migrated from the geckoview metric of the same name).
    pub static ipro: Lazy<LabeledMetric<LabeledCounterMetric, IproLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ipro".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3988), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum IspeLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for IspeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IspeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.ispe
    ///
    /// AVIF spatial extents (image size). (Migrated from the geckoview metric of the same name).
    pub static ispe: Lazy<LabeledMetric<LabeledCounterMetric, IspeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ispe".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3989), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum LselLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for LselLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LselLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.lsel
    ///
    /// AVIF LayerSelectorProperty (lsel). (Migrated from the geckoview metric of the same name).
    pub static lsel: Lazy<LabeledMetric<LabeledCounterMetric, LselLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "lsel".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3990), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum MajorBrandLabel {
        EAvif = 0,
        EAvis = 1,
        EOther = 2,
        __Other__,
    }
    impl From<u16> for MajorBrandLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAvif,
                1 => Self::EAvis,
                2 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MajorBrandLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAvif => "avif",
                Self::EAvis => "avis",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.major_brand
    ///
    /// AVIF major brand
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram AVIF_MAJOR_BRAND.
    pub static major_brand: Lazy<LabeledMetric<LabeledCounterMetric, MajorBrandLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "major_brand".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3991), meta, Some(vec![::std::borrow::Cow::from("avif"), ::std::borrow::Cow::from("avis"), ::std::borrow::Cow::from("other")]))
    });

    #[repr(u16)]
    pub enum PaspLabel {
        EAbsent = 0,
        ESquare = 1,
        ENonsquare = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PaspLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::ESquare,
                2 => Self::ENonsquare,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PaspLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::ESquare => "square",
                Self::ENonsquare => "nonsquare",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pasp
    ///
    /// AVIF pixel aspect ratio. (Migrated from the geckoview metric of the same name).
    pub static pasp: Lazy<LabeledMetric<LabeledCounterMetric, PaspLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pasp".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3992), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("nonsquare"), ::std::borrow::Cow::from("square")]))
    });

    #[repr(u16)]
    pub enum PixiLabel {
        EValid = 0,
        EAbsent = 1,
        EBitstreamMismatch = 2,
        __Other__,
    }
    impl From<u16> for PixiLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EValid,
                1 => Self::EAbsent,
                2 => Self::EBitstreamMismatch,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PixiLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EValid => "valid",
                Self::EAbsent => "absent",
                Self::EBitstreamMismatch => "bitstream_mismatch",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.pixi
    ///
    /// AVIF pixel information (bits per channel). (Migrated from the geckoview metric of the same name).
    pub static pixi: Lazy<LabeledMetric<LabeledCounterMetric, PixiLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pixi".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3993), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("bitstream_mismatch"), ::std::borrow::Cow::from("valid")]))
    });

    #[repr(u16)]
    pub enum SequenceLabel {
        EPresent = 0,
        EAbsent = 1,
        __Other__,
    }
    impl From<u16> for SequenceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresent,
                1 => Self::EAbsent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SequenceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresent => "present",
                Self::EAbsent => "absent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.sequence
    ///
    /// AVIF image sequence
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram AVIF_SEQUENCE.
    pub static sequence: Lazy<LabeledMetric<LabeledCounterMetric, SequenceLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sequence".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3994), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[repr(u16)]
    pub enum YuvColorSpaceLabel {
        EBt601 = 0,
        EBt709 = 1,
        EBt2020 = 2,
        EIdentity = 3,
        EUnknown = 4,
        __Other__,
    }
    impl From<u16> for YuvColorSpaceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBt601,
                1 => Self::EBt709,
                2 => Self::EBt2020,
                3 => Self::EIdentity,
                4 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for YuvColorSpaceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBt601 => "bt601",
                Self::EBt709 => "bt709",
                Self::EBt2020 => "bt2020",
                Self::EIdentity => "identity",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from avif.yuv_color_space
    ///
    /// YUV color space of AVIF image. (Migrated from the geckoview metric of the same name).
    pub static yuv_color_space: Lazy<LabeledMetric<LabeledCounterMetric, YuvColorSpaceLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "yuv_color_space".into(),
                    category: "avif".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(3995), meta, Some(vec![::std::borrow::Cow::from("bt2020"), ::std::borrow::Cow::from("bt601"), ::std::borrow::Cow::from("bt709"), ::std::borrow::Cow::from("identity"), ::std::borrow::Cow::from("unknown")]))
    });

}
pub mod image_decode {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.chunks
    ///
    /// Number of chunks per decode attempt
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_CHUNKS.
    pub static chunks: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chunks".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3996), meta, 1, 500, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.count
    ///
    /// Decode count
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_COUNT.
    pub static count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(3997), meta, 1, 500, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.on_draw_latency
    ///
    /// Time from starting a decode to it showing up on the screen (us)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_ON_DRAW_LATENCY.
    pub static on_draw_latency: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "on_draw_latency".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(3998), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.speed_avif
    ///
    /// AVIF image decode speed (Kbytes/sec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_SPEED_AVIF.
    pub static speed_avif: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed_avif".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(3999), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.speed_gif
    ///
    /// GIF image decode speed (Kbytes/sec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_SPEED_GIF.
    pub static speed_gif: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed_gif".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4000), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.speed_jpeg
    ///
    /// JPEG image decode speed (Kbytes/sec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_SPEED_JPEG.
    pub static speed_jpeg: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed_jpeg".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4001), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.speed_png
    ///
    /// PNG image decode speed (Kbytes/sec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_SPEED_PNG.
    pub static speed_png: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed_png".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4002), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.speed_webp
    ///
    /// WebP image decode speed (Kbytes/sec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_SPEED_WEBP.
    pub static speed_webp: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed_webp".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4003), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from image_decode.time
    ///
    /// Time spent decoding an image (us)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IMAGE_DECODE_TIME.
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "image_decode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4004), meta, TimeUnit::Microsecond)
    });

}
pub mod ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum TransactionCancelLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TransactionCancelLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TransactionCancelLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ipc.transaction_cancel
    ///
    /// True when an IPC transaction is canceled
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram IPC_TRANSACTION_CANCEL.
    pub static transaction_cancel: Lazy<LabeledMetric<LabeledCounterMetric, TransactionCancelLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "transaction_cancel".into(),
                    category: "ipc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4005), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod process {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from process.child_launch
    ///
    /// Time spent in the generic child process launching code, which is run off-main-thread and used by all child process types
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CHILD_PROCESS_LAUNCH_MS.
    pub static child_launch: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "child_launch".into(),
                category: "process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4006), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from process.lifetime
    ///
    /// Average lifetime of a content process in seconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PROCESS_LIFETIME.
    pub static lifetime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "lifetime".into(),
                category: "process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4007), meta, TimeUnit::Second)
    });

}
pub mod subprocess {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from subprocess.abnormal_abort
    ///
    /// Counts of plugin/content process abnormal shutdown, whether or not a crash report was available.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SUBPROCESS_ABNORMAL_ABORT.
    pub static abnormal_abort: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "abnormal_abort".into(),
                    category: "subprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4008), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from subprocess.crashes_with_dump
    ///
    /// Counts of plugin and content process crashes which are reported with a crash dump.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SUBPROCESS_CRASHES_WITH_DUMP.
    pub static crashes_with_dump: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crashes_with_dump".into(),
                    category: "subprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4009), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from subprocess.kill_hard
    ///
    /// Counts the number of times a subprocess was forcibly killed, and the reason.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SUBPROCESS_KILL_HARD.
    pub static kill_hard: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "kill_hard".into(),
                    category: "subprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4010), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from subprocess.launch_failure
    ///
    /// Counts the number of times launching a subprocess fails. Counts are by subprocess-type using the GeckoProcessType enum.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SUBPROCESS_LAUNCH_FAILURE.
    pub static launch_failure: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "launch_failure".into(),
                    category: "subprocess".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4011), meta, None)
    });

}
pub mod javascript_gc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.animation
    ///
    /// Time spent running JS GC when animating.
    pub static animation: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "animation".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4012), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.budget
    ///
    /// Requested GC slice budget.
    pub static budget: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "budget".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4013), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.budget_overrun
    ///
    /// How long a GC slice ran over its budget.
    pub static budget_overrun: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "budget_overrun".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4014), meta, TimeUnit::Microsecond)
    });

    #[repr(u16)]
    pub enum BudgetWasIncreasedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for BudgetWasIncreasedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BudgetWasIncreasedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.budget_was_increased
    ///
    /// Whether the budget was increased due to taking too long or approaching the incremental limit
    pub static budget_was_increased: Lazy<LabeledMetric<LabeledCounterMetric, BudgetWasIncreasedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "budget_was_increased".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4015), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.compact_time
    ///
    /// The time spent in the compact phase. (Migrated from the geckoview metric of the same name.)
    pub static compact_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compact_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4016), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.effectiveness
    ///
    /// GC effectiveness, the amount of memory freed divided by main-thread collection time (MB/s)
    pub static effectiveness: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "effectiveness".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4017), meta, 0, 50000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum IsZoneGcLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for IsZoneGcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IsZoneGcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.is_zone_gc
    ///
    /// Is it a zone GC?
    pub static is_zone_gc: Lazy<LabeledMetric<LabeledCounterMetric, IsZoneGcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_zone_gc".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4018), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_gray
    ///
    /// Time spent marking gray GC objects.
    pub static mark_gray: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_gray".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4019), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_rate
    ///
    /// The number of objects marked per ms during GC.
    pub static mark_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_rate".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4020), meta, 1000, 300000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_roots_time
    ///
    /// The time spent marking GC roots. (Migrated from the geckoview metric of the same name.)
    pub static mark_roots_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_roots_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4021), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_time
    ///
    /// The time spent in the mark phase. (Migrated from the geckoview metric of the same name.)
    pub static mark_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4022), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mark_weak
    ///
    /// Time spent marking GC objects held live through weakmaps.
    pub static mark_weak: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mark_weak".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4023), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.max_pause
    ///
    /// Longest GC slice in a GC.
    pub static max_pause: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_pause".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4024), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum MinorReasonLabel {
        EApi = 0,
        EEagerAllocTrigger = 1,
        EDestroyRuntime = 2,
        ERootsRemoved = 3,
        ELastDitch = 4,
        ETooMuchMalloc = 5,
        EAllocTrigger = 6,
        EDebugGc = 7,
        ECompartmentRevived = 8,
        EReset = 9,
        EOutOfNursery = 10,
        EEvictNursery = 11,
        ESharedMemoryLimit = 12,
        EEagerNurseryCollection = 13,
        EBgTaskFinished = 14,
        EAbortGc = 15,
        EFullWholeCellBuffer = 16,
        EFullGenericBuffer = 17,
        EFullValueBuffer = 18,
        EFullCellPtrObjBuffer = 19,
        EFullSlotBuffer = 20,
        EFullShapeBuffer = 21,
        ETooMuchWasmMemory = 22,
        EDisableGenerationalGc = 23,
        EFinishGc = 24,
        EPrepareForTracing = 25,
        EFullWasmAnyrefBuffer = 26,
        EFullCellPtrStrBuffer = 27,
        ETooMuchJitCode = 28,
        EFullCellPtrBigintBuffer = 29,
        ENurseryTrailers = 30,
        ENurseryMallocBuffers = 31,
        EDomWindowUtils = 32,
        EComponentUtils = 33,
        EMemPressure = 34,
        ECcFinished = 35,
        ECcForced = 36,
        ELoadEnd = 37,
        EUnused3 = 38,
        EPageHide = 39,
        ENsjscontextDestroy = 40,
        EWorkerShutdown = 41,
        ESetDocShell = 42,
        EDomUtils = 43,
        EDomIpc = 44,
        EDomWorker = 45,
        EInterSliceGc = 46,
        EUnused1 = 47,
        EFullGcTimer = 48,
        EShutdownCc = 49,
        EUnused2 = 50,
        EUserInactive = 51,
        EXpconnectShutdown = 52,
        EDocshell = 53,
        EHtmlParser = 54,
        EDomTestutils = 55,
        EPrepareForPageload = 56,
        __Other__,
    }
    impl From<u16> for MinorReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EApi,
                1 => Self::EEagerAllocTrigger,
                2 => Self::EDestroyRuntime,
                3 => Self::ERootsRemoved,
                4 => Self::ELastDitch,
                5 => Self::ETooMuchMalloc,
                6 => Self::EAllocTrigger,
                7 => Self::EDebugGc,
                8 => Self::ECompartmentRevived,
                9 => Self::EReset,
                10 => Self::EOutOfNursery,
                11 => Self::EEvictNursery,
                12 => Self::ESharedMemoryLimit,
                13 => Self::EEagerNurseryCollection,
                14 => Self::EBgTaskFinished,
                15 => Self::EAbortGc,
                16 => Self::EFullWholeCellBuffer,
                17 => Self::EFullGenericBuffer,
                18 => Self::EFullValueBuffer,
                19 => Self::EFullCellPtrObjBuffer,
                20 => Self::EFullSlotBuffer,
                21 => Self::EFullShapeBuffer,
                22 => Self::ETooMuchWasmMemory,
                23 => Self::EDisableGenerationalGc,
                24 => Self::EFinishGc,
                25 => Self::EPrepareForTracing,
                26 => Self::EFullWasmAnyrefBuffer,
                27 => Self::EFullCellPtrStrBuffer,
                28 => Self::ETooMuchJitCode,
                29 => Self::EFullCellPtrBigintBuffer,
                30 => Self::ENurseryTrailers,
                31 => Self::ENurseryMallocBuffers,
                32 => Self::EDomWindowUtils,
                33 => Self::EComponentUtils,
                34 => Self::EMemPressure,
                35 => Self::ECcFinished,
                36 => Self::ECcForced,
                37 => Self::ELoadEnd,
                38 => Self::EUnused3,
                39 => Self::EPageHide,
                40 => Self::ENsjscontextDestroy,
                41 => Self::EWorkerShutdown,
                42 => Self::ESetDocShell,
                43 => Self::EDomUtils,
                44 => Self::EDomIpc,
                45 => Self::EDomWorker,
                46 => Self::EInterSliceGc,
                47 => Self::EUnused1,
                48 => Self::EFullGcTimer,
                49 => Self::EShutdownCc,
                50 => Self::EUnused2,
                51 => Self::EUserInactive,
                52 => Self::EXpconnectShutdown,
                53 => Self::EDocshell,
                54 => Self::EHtmlParser,
                55 => Self::EDomTestutils,
                56 => Self::EPrepareForPageload,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MinorReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EApi => "API",
                Self::EEagerAllocTrigger => "EAGER_ALLOC_TRIGGER",
                Self::EDestroyRuntime => "DESTROY_RUNTIME",
                Self::ERootsRemoved => "ROOTS_REMOVED",
                Self::ELastDitch => "LAST_DITCH",
                Self::ETooMuchMalloc => "TOO_MUCH_MALLOC",
                Self::EAllocTrigger => "ALLOC_TRIGGER",
                Self::EDebugGc => "DEBUG_GC",
                Self::ECompartmentRevived => "COMPARTMENT_REVIVED",
                Self::EReset => "RESET",
                Self::EOutOfNursery => "OUT_OF_NURSERY",
                Self::EEvictNursery => "EVICT_NURSERY",
                Self::ESharedMemoryLimit => "SHARED_MEMORY_LIMIT",
                Self::EEagerNurseryCollection => "EAGER_NURSERY_COLLECTION",
                Self::EBgTaskFinished => "BG_TASK_FINISHED",
                Self::EAbortGc => "ABORT_GC",
                Self::EFullWholeCellBuffer => "FULL_WHOLE_CELL_BUFFER",
                Self::EFullGenericBuffer => "FULL_GENERIC_BUFFER",
                Self::EFullValueBuffer => "FULL_VALUE_BUFFER",
                Self::EFullCellPtrObjBuffer => "FULL_CELL_PTR_OBJ_BUFFER",
                Self::EFullSlotBuffer => "FULL_SLOT_BUFFER",
                Self::EFullShapeBuffer => "FULL_SHAPE_BUFFER",
                Self::ETooMuchWasmMemory => "TOO_MUCH_WASM_MEMORY",
                Self::EDisableGenerationalGc => "DISABLE_GENERATIONAL_GC",
                Self::EFinishGc => "FINISH_GC",
                Self::EPrepareForTracing => "PREPARE_FOR_TRACING",
                Self::EFullWasmAnyrefBuffer => "FULL_WASM_ANYREF_BUFFER",
                Self::EFullCellPtrStrBuffer => "FULL_CELL_PTR_STR_BUFFER",
                Self::ETooMuchJitCode => "TOO_MUCH_JIT_CODE",
                Self::EFullCellPtrBigintBuffer => "FULL_CELL_PTR_BIGINT_BUFFER",
                Self::ENurseryTrailers => "NURSERY_TRAILERS",
                Self::ENurseryMallocBuffers => "NURSERY_MALLOC_BUFFERS",
                Self::EDomWindowUtils => "DOM_WINDOW_UTILS",
                Self::EComponentUtils => "COMPONENT_UTILS",
                Self::EMemPressure => "MEM_PRESSURE",
                Self::ECcFinished => "CC_FINISHED",
                Self::ECcForced => "CC_FORCED",
                Self::ELoadEnd => "LOAD_END",
                Self::EUnused3 => "UNUSED3",
                Self::EPageHide => "PAGE_HIDE",
                Self::ENsjscontextDestroy => "NSJSCONTEXT_DESTROY",
                Self::EWorkerShutdown => "WORKER_SHUTDOWN",
                Self::ESetDocShell => "SET_DOC_SHELL",
                Self::EDomUtils => "DOM_UTILS",
                Self::EDomIpc => "DOM_IPC",
                Self::EDomWorker => "DOM_WORKER",
                Self::EInterSliceGc => "INTER_SLICE_GC",
                Self::EUnused1 => "UNUSED1",
                Self::EFullGcTimer => "FULL_GC_TIMER",
                Self::EShutdownCc => "SHUTDOWN_CC",
                Self::EUnused2 => "UNUSED2",
                Self::EUserInactive => "USER_INACTIVE",
                Self::EXpconnectShutdown => "XPCONNECT_SHUTDOWN",
                Self::EDocshell => "DOCSHELL",
                Self::EHtmlParser => "HTML_PARSER",
                Self::EDomTestutils => "DOM_TESTUTILS",
                Self::EPrepareForPageload => "PREPARE_FOR_PAGELOAD",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.minor_reason
    ///
    /// Reason (enum value) for initiating a minor GC
    pub static minor_reason: Lazy<LabeledMetric<LabeledCounterMetric, MinorReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "minor_reason".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4025), meta, Some(vec![::std::borrow::Cow::from("ABORT_GC"), ::std::borrow::Cow::from("ALLOC_TRIGGER"), ::std::borrow::Cow::from("API"), ::std::borrow::Cow::from("BG_TASK_FINISHED"), ::std::borrow::Cow::from("CC_FINISHED"), ::std::borrow::Cow::from("CC_FORCED"), ::std::borrow::Cow::from("COMPARTMENT_REVIVED"), ::std::borrow::Cow::from("COMPONENT_UTILS"), ::std::borrow::Cow::from("DEBUG_GC"), ::std::borrow::Cow::from("DESTROY_RUNTIME"), ::std::borrow::Cow::from("DISABLE_GENERATIONAL_GC"), ::std::borrow::Cow::from("DOCSHELL"), ::std::borrow::Cow::from("DOM_IPC"), ::std::borrow::Cow::from("DOM_TESTUTILS"), ::std::borrow::Cow::from("DOM_UTILS"), ::std::borrow::Cow::from("DOM_WINDOW_UTILS"), ::std::borrow::Cow::from("DOM_WORKER"), ::std::borrow::Cow::from("EAGER_ALLOC_TRIGGER"), ::std::borrow::Cow::from("EAGER_NURSERY_COLLECTION"), ::std::borrow::Cow::from("EVICT_NURSERY"), ::std::borrow::Cow::from("FINISH_GC"), ::std::borrow::Cow::from("FULL_CELL_PTR_BIGINT_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_OBJ_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_STR_BUFFER"), ::std::borrow::Cow::from("FULL_GC_TIMER"), ::std::borrow::Cow::from("FULL_GENERIC_BUFFER"), ::std::borrow::Cow::from("FULL_SHAPE_BUFFER"), ::std::borrow::Cow::from("FULL_SLOT_BUFFER"), ::std::borrow::Cow::from("FULL_VALUE_BUFFER"), ::std::borrow::Cow::from("FULL_WASM_ANYREF_BUFFER"), ::std::borrow::Cow::from("FULL_WHOLE_CELL_BUFFER"), ::std::borrow::Cow::from("HTML_PARSER"), ::std::borrow::Cow::from("INTER_SLICE_GC"), ::std::borrow::Cow::from("LAST_DITCH"), ::std::borrow::Cow::from("LOAD_END"), ::std::borrow::Cow::from("MEM_PRESSURE"), ::std::borrow::Cow::from("NSJSCONTEXT_DESTROY"), ::std::borrow::Cow::from("NURSERY_MALLOC_BUFFERS"), ::std::borrow::Cow::from("NURSERY_TRAILERS"), ::std::borrow::Cow::from("OUT_OF_NURSERY"), ::std::borrow::Cow::from("PAGE_HIDE"), ::std::borrow::Cow::from("PREPARE_FOR_PAGELOAD"), ::std::borrow::Cow::from("PREPARE_FOR_TRACING"), ::std::borrow::Cow::from("RESET"), ::std::borrow::Cow::from("ROOTS_REMOVED"), ::std::borrow::Cow::from("SET_DOC_SHELL"), ::std::borrow::Cow::from("SHARED_MEMORY_LIMIT"), ::std::borrow::Cow::from("SHUTDOWN_CC"), ::std::borrow::Cow::from("TOO_MUCH_JIT_CODE"), ::std::borrow::Cow::from("TOO_MUCH_MALLOC"), ::std::borrow::Cow::from("TOO_MUCH_WASM_MEMORY"), ::std::borrow::Cow::from("UNUSED1"), ::std::borrow::Cow::from("UNUSED2"), ::std::borrow::Cow::from("UNUSED3"), ::std::borrow::Cow::from("USER_INACTIVE"), ::std::borrow::Cow::from("WORKER_SHUTDOWN"), ::std::borrow::Cow::from("XPCONNECT_SHUTDOWN")]))
    });

    #[repr(u16)]
    pub enum MinorReasonLongLabel {
        EApi = 0,
        EEagerAllocTrigger = 1,
        EDestroyRuntime = 2,
        ERootsRemoved = 3,
        ELastDitch = 4,
        ETooMuchMalloc = 5,
        EAllocTrigger = 6,
        EDebugGc = 7,
        ECompartmentRevived = 8,
        EReset = 9,
        EOutOfNursery = 10,
        EEvictNursery = 11,
        ESharedMemoryLimit = 12,
        EEagerNurseryCollection = 13,
        EBgTaskFinished = 14,
        EAbortGc = 15,
        EFullWholeCellBuffer = 16,
        EFullGenericBuffer = 17,
        EFullValueBuffer = 18,
        EFullCellPtrObjBuffer = 19,
        EFullSlotBuffer = 20,
        EFullShapeBuffer = 21,
        ETooMuchWasmMemory = 22,
        EDisableGenerationalGc = 23,
        EFinishGc = 24,
        EPrepareForTracing = 25,
        EFullWasmAnyrefBuffer = 26,
        EFullCellPtrStrBuffer = 27,
        ETooMuchJitCode = 28,
        EFullCellPtrBigintBuffer = 29,
        ENurseryTrailers = 30,
        ENurseryMallocBuffers = 31,
        EDomWindowUtils = 32,
        EComponentUtils = 33,
        EMemPressure = 34,
        ECcFinished = 35,
        ECcForced = 36,
        ELoadEnd = 37,
        EUnused3 = 38,
        EPageHide = 39,
        ENsjscontextDestroy = 40,
        EWorkerShutdown = 41,
        ESetDocShell = 42,
        EDomUtils = 43,
        EDomIpc = 44,
        EDomWorker = 45,
        EInterSliceGc = 46,
        EUnused1 = 47,
        EFullGcTimer = 48,
        EShutdownCc = 49,
        EUnused2 = 50,
        EUserInactive = 51,
        EXpconnectShutdown = 52,
        EDocshell = 53,
        EHtmlParser = 54,
        EDomTestutils = 55,
        EPrepareForPageload = 56,
        __Other__,
    }
    impl From<u16> for MinorReasonLongLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EApi,
                1 => Self::EEagerAllocTrigger,
                2 => Self::EDestroyRuntime,
                3 => Self::ERootsRemoved,
                4 => Self::ELastDitch,
                5 => Self::ETooMuchMalloc,
                6 => Self::EAllocTrigger,
                7 => Self::EDebugGc,
                8 => Self::ECompartmentRevived,
                9 => Self::EReset,
                10 => Self::EOutOfNursery,
                11 => Self::EEvictNursery,
                12 => Self::ESharedMemoryLimit,
                13 => Self::EEagerNurseryCollection,
                14 => Self::EBgTaskFinished,
                15 => Self::EAbortGc,
                16 => Self::EFullWholeCellBuffer,
                17 => Self::EFullGenericBuffer,
                18 => Self::EFullValueBuffer,
                19 => Self::EFullCellPtrObjBuffer,
                20 => Self::EFullSlotBuffer,
                21 => Self::EFullShapeBuffer,
                22 => Self::ETooMuchWasmMemory,
                23 => Self::EDisableGenerationalGc,
                24 => Self::EFinishGc,
                25 => Self::EPrepareForTracing,
                26 => Self::EFullWasmAnyrefBuffer,
                27 => Self::EFullCellPtrStrBuffer,
                28 => Self::ETooMuchJitCode,
                29 => Self::EFullCellPtrBigintBuffer,
                30 => Self::ENurseryTrailers,
                31 => Self::ENurseryMallocBuffers,
                32 => Self::EDomWindowUtils,
                33 => Self::EComponentUtils,
                34 => Self::EMemPressure,
                35 => Self::ECcFinished,
                36 => Self::ECcForced,
                37 => Self::ELoadEnd,
                38 => Self::EUnused3,
                39 => Self::EPageHide,
                40 => Self::ENsjscontextDestroy,
                41 => Self::EWorkerShutdown,
                42 => Self::ESetDocShell,
                43 => Self::EDomUtils,
                44 => Self::EDomIpc,
                45 => Self::EDomWorker,
                46 => Self::EInterSliceGc,
                47 => Self::EUnused1,
                48 => Self::EFullGcTimer,
                49 => Self::EShutdownCc,
                50 => Self::EUnused2,
                51 => Self::EUserInactive,
                52 => Self::EXpconnectShutdown,
                53 => Self::EDocshell,
                54 => Self::EHtmlParser,
                55 => Self::EDomTestutils,
                56 => Self::EPrepareForPageload,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MinorReasonLongLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EApi => "API",
                Self::EEagerAllocTrigger => "EAGER_ALLOC_TRIGGER",
                Self::EDestroyRuntime => "DESTROY_RUNTIME",
                Self::ERootsRemoved => "ROOTS_REMOVED",
                Self::ELastDitch => "LAST_DITCH",
                Self::ETooMuchMalloc => "TOO_MUCH_MALLOC",
                Self::EAllocTrigger => "ALLOC_TRIGGER",
                Self::EDebugGc => "DEBUG_GC",
                Self::ECompartmentRevived => "COMPARTMENT_REVIVED",
                Self::EReset => "RESET",
                Self::EOutOfNursery => "OUT_OF_NURSERY",
                Self::EEvictNursery => "EVICT_NURSERY",
                Self::ESharedMemoryLimit => "SHARED_MEMORY_LIMIT",
                Self::EEagerNurseryCollection => "EAGER_NURSERY_COLLECTION",
                Self::EBgTaskFinished => "BG_TASK_FINISHED",
                Self::EAbortGc => "ABORT_GC",
                Self::EFullWholeCellBuffer => "FULL_WHOLE_CELL_BUFFER",
                Self::EFullGenericBuffer => "FULL_GENERIC_BUFFER",
                Self::EFullValueBuffer => "FULL_VALUE_BUFFER",
                Self::EFullCellPtrObjBuffer => "FULL_CELL_PTR_OBJ_BUFFER",
                Self::EFullSlotBuffer => "FULL_SLOT_BUFFER",
                Self::EFullShapeBuffer => "FULL_SHAPE_BUFFER",
                Self::ETooMuchWasmMemory => "TOO_MUCH_WASM_MEMORY",
                Self::EDisableGenerationalGc => "DISABLE_GENERATIONAL_GC",
                Self::EFinishGc => "FINISH_GC",
                Self::EPrepareForTracing => "PREPARE_FOR_TRACING",
                Self::EFullWasmAnyrefBuffer => "FULL_WASM_ANYREF_BUFFER",
                Self::EFullCellPtrStrBuffer => "FULL_CELL_PTR_STR_BUFFER",
                Self::ETooMuchJitCode => "TOO_MUCH_JIT_CODE",
                Self::EFullCellPtrBigintBuffer => "FULL_CELL_PTR_BIGINT_BUFFER",
                Self::ENurseryTrailers => "NURSERY_TRAILERS",
                Self::ENurseryMallocBuffers => "NURSERY_MALLOC_BUFFERS",
                Self::EDomWindowUtils => "DOM_WINDOW_UTILS",
                Self::EComponentUtils => "COMPONENT_UTILS",
                Self::EMemPressure => "MEM_PRESSURE",
                Self::ECcFinished => "CC_FINISHED",
                Self::ECcForced => "CC_FORCED",
                Self::ELoadEnd => "LOAD_END",
                Self::EUnused3 => "UNUSED3",
                Self::EPageHide => "PAGE_HIDE",
                Self::ENsjscontextDestroy => "NSJSCONTEXT_DESTROY",
                Self::EWorkerShutdown => "WORKER_SHUTDOWN",
                Self::ESetDocShell => "SET_DOC_SHELL",
                Self::EDomUtils => "DOM_UTILS",
                Self::EDomIpc => "DOM_IPC",
                Self::EDomWorker => "DOM_WORKER",
                Self::EInterSliceGc => "INTER_SLICE_GC",
                Self::EUnused1 => "UNUSED1",
                Self::EFullGcTimer => "FULL_GC_TIMER",
                Self::EShutdownCc => "SHUTDOWN_CC",
                Self::EUnused2 => "UNUSED2",
                Self::EUserInactive => "USER_INACTIVE",
                Self::EXpconnectShutdown => "XPCONNECT_SHUTDOWN",
                Self::EDocshell => "DOCSHELL",
                Self::EHtmlParser => "HTML_PARSER",
                Self::EDomTestutils => "DOM_TESTUTILS",
                Self::EPrepareForPageload => "PREPARE_FOR_PAGELOAD",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.minor_reason_long
    ///
    /// Reason (enum value) that caused a long (>1ms) minor GC
    pub static minor_reason_long: Lazy<LabeledMetric<LabeledCounterMetric, MinorReasonLongLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "minor_reason_long".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4026), meta, Some(vec![::std::borrow::Cow::from("ABORT_GC"), ::std::borrow::Cow::from("ALLOC_TRIGGER"), ::std::borrow::Cow::from("API"), ::std::borrow::Cow::from("BG_TASK_FINISHED"), ::std::borrow::Cow::from("CC_FINISHED"), ::std::borrow::Cow::from("CC_FORCED"), ::std::borrow::Cow::from("COMPARTMENT_REVIVED"), ::std::borrow::Cow::from("COMPONENT_UTILS"), ::std::borrow::Cow::from("DEBUG_GC"), ::std::borrow::Cow::from("DESTROY_RUNTIME"), ::std::borrow::Cow::from("DISABLE_GENERATIONAL_GC"), ::std::borrow::Cow::from("DOCSHELL"), ::std::borrow::Cow::from("DOM_IPC"), ::std::borrow::Cow::from("DOM_TESTUTILS"), ::std::borrow::Cow::from("DOM_UTILS"), ::std::borrow::Cow::from("DOM_WINDOW_UTILS"), ::std::borrow::Cow::from("DOM_WORKER"), ::std::borrow::Cow::from("EAGER_ALLOC_TRIGGER"), ::std::borrow::Cow::from("EAGER_NURSERY_COLLECTION"), ::std::borrow::Cow::from("EVICT_NURSERY"), ::std::borrow::Cow::from("FINISH_GC"), ::std::borrow::Cow::from("FULL_CELL_PTR_BIGINT_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_OBJ_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_STR_BUFFER"), ::std::borrow::Cow::from("FULL_GC_TIMER"), ::std::borrow::Cow::from("FULL_GENERIC_BUFFER"), ::std::borrow::Cow::from("FULL_SHAPE_BUFFER"), ::std::borrow::Cow::from("FULL_SLOT_BUFFER"), ::std::borrow::Cow::from("FULL_VALUE_BUFFER"), ::std::borrow::Cow::from("FULL_WASM_ANYREF_BUFFER"), ::std::borrow::Cow::from("FULL_WHOLE_CELL_BUFFER"), ::std::borrow::Cow::from("HTML_PARSER"), ::std::borrow::Cow::from("INTER_SLICE_GC"), ::std::borrow::Cow::from("LAST_DITCH"), ::std::borrow::Cow::from("LOAD_END"), ::std::borrow::Cow::from("MEM_PRESSURE"), ::std::borrow::Cow::from("NSJSCONTEXT_DESTROY"), ::std::borrow::Cow::from("NURSERY_MALLOC_BUFFERS"), ::std::borrow::Cow::from("NURSERY_TRAILERS"), ::std::borrow::Cow::from("OUT_OF_NURSERY"), ::std::borrow::Cow::from("PAGE_HIDE"), ::std::borrow::Cow::from("PREPARE_FOR_PAGELOAD"), ::std::borrow::Cow::from("PREPARE_FOR_TRACING"), ::std::borrow::Cow::from("RESET"), ::std::borrow::Cow::from("ROOTS_REMOVED"), ::std::borrow::Cow::from("SET_DOC_SHELL"), ::std::borrow::Cow::from("SHARED_MEMORY_LIMIT"), ::std::borrow::Cow::from("SHUTDOWN_CC"), ::std::borrow::Cow::from("TOO_MUCH_JIT_CODE"), ::std::borrow::Cow::from("TOO_MUCH_MALLOC"), ::std::borrow::Cow::from("TOO_MUCH_WASM_MEMORY"), ::std::borrow::Cow::from("UNUSED1"), ::std::borrow::Cow::from("UNUSED2"), ::std::borrow::Cow::from("UNUSED3"), ::std::borrow::Cow::from("USER_INACTIVE"), ::std::borrow::Cow::from("WORKER_SHUTDOWN"), ::std::borrow::Cow::from("XPCONNECT_SHUTDOWN")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.minor_time
    ///
    /// The time taked by a minor (nursery) collection. (Migrated from the geckoview metric of the same name.)
    pub static minor_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "minor_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4027), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.mmu_50
    ///
    /// Minimum percentage of time spent outside GC over any 50ms window.
    pub static mmu_50: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mmu_50".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4028), meta, 0, 100, 20, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum NonIncrementalLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for NonIncrementalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NonIncrementalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.non_incremental
    ///
    /// Was the GC non-incremental?
    pub static non_incremental: Lazy<LabeledMetric<LabeledCounterMetric, NonIncrementalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "non_incremental".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4029), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum NonIncrementalReasonLabel {
        ENone = 0,
        ENonincrementalrequested = 1,
        EAbortrequested = 2,
        EUnused1 = 3,
        EIncrementaldisabled = 4,
        EModechange = 5,
        EMallocbytestrigger = 6,
        EGcbytestrigger = 7,
        EZonechange = 8,
        ECompartmentrevived = 9,
        EGrayrootbufferingfailed = 10,
        EJitcodebytestrigger = 11,
        __Other__,
    }
    impl From<u16> for NonIncrementalReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::ENonincrementalrequested,
                2 => Self::EAbortrequested,
                3 => Self::EUnused1,
                4 => Self::EIncrementaldisabled,
                5 => Self::EModechange,
                6 => Self::EMallocbytestrigger,
                7 => Self::EGcbytestrigger,
                8 => Self::EZonechange,
                9 => Self::ECompartmentrevived,
                10 => Self::EGrayrootbufferingfailed,
                11 => Self::EJitcodebytestrigger,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NonIncrementalReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "None",
                Self::ENonincrementalrequested => "NonIncrementalRequested",
                Self::EAbortrequested => "AbortRequested",
                Self::EUnused1 => "Unused1",
                Self::EIncrementaldisabled => "IncrementalDisabled",
                Self::EModechange => "ModeChange",
                Self::EMallocbytestrigger => "MallocBytesTrigger",
                Self::EGcbytestrigger => "GCBytesTrigger",
                Self::EZonechange => "ZoneChange",
                Self::ECompartmentrevived => "CompartmentRevived",
                Self::EGrayrootbufferingfailed => "GrayRootBufferingFailed",
                Self::EJitcodebytestrigger => "JitCodeBytesTrigger",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.non_incremental_reason
    ///
    /// Reason for performing a non-incremental GC (see js::GCAbortReason)
    pub static non_incremental_reason: Lazy<LabeledMetric<LabeledCounterMetric, NonIncrementalReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "non_incremental_reason".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4030), meta, Some(vec![::std::borrow::Cow::from("AbortRequested"), ::std::borrow::Cow::from("CompartmentRevived"), ::std::borrow::Cow::from("GCBytesTrigger"), ::std::borrow::Cow::from("GrayRootBufferingFailed"), ::std::borrow::Cow::from("IncrementalDisabled"), ::std::borrow::Cow::from("JitCodeBytesTrigger"), ::std::borrow::Cow::from("MallocBytesTrigger"), ::std::borrow::Cow::from("ModeChange"), ::std::borrow::Cow::from("NonIncrementalRequested"), ::std::borrow::Cow::from("None"), ::std::borrow::Cow::from("Unused1"), ::std::borrow::Cow::from("ZoneChange")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.nursery_bytes
    ///
    /// Size of the GC nursery in bytes.
    pub static nursery_bytes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nursery_bytes".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4031), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.nursery_promotion_rate
    ///
    /// The percentage of nursery objects that were promoted to the tenured heap.
    pub static nursery_promotion_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nursery_promotion_rate".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4032), meta, 0, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.parallel_mark_interruptions
    ///
    /// Number of interruptions/donations per slice during parallel marking.
    pub static parallel_mark_interruptions: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parallel_mark_interruptions".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4033), meta, 1, 500, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.parallel_mark_speedup
    ///
    /// Ratio of total helper thread time spent marking to main thread time for parallel marking, scaled by 100.
    pub static parallel_mark_speedup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parallel_mark_speedup".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4034), meta, 50, 800, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum ParallelMarkUsedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ParallelMarkUsedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParallelMarkUsedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.parallel_mark_used
    ///
    /// Whether parallel marking was used for this collection
    pub static parallel_mark_used: Lazy<LabeledMetric<LabeledCounterMetric, ParallelMarkUsedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parallel_mark_used".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4035), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.parallel_mark_utilization
    ///
    /// Ratio of helper thread time spent marking to total helper thread time for parallel marking.
    pub static parallel_mark_utilization: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parallel_mark_utilization".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4036), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.prepare_time
    ///
    /// The time spent in the preparation phase. (Migrated from the geckoview metric of the same name.)
    pub static prepare_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prepare_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4037), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.pretenure_count
    ///
    /// How many allocation sites were selected for pretenuring by a minor GC
    pub static pretenure_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pretenure_count".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4038), meta, 0, 100, 20, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum ReasonLabel {
        EApi = 0,
        EEagerAllocTrigger = 1,
        EDestroyRuntime = 2,
        ERootsRemoved = 3,
        ELastDitch = 4,
        ETooMuchMalloc = 5,
        EAllocTrigger = 6,
        EDebugGc = 7,
        ECompartmentRevived = 8,
        EReset = 9,
        EOutOfNursery = 10,
        EEvictNursery = 11,
        ESharedMemoryLimit = 12,
        EEagerNurseryCollection = 13,
        EBgTaskFinished = 14,
        EAbortGc = 15,
        EFullWholeCellBuffer = 16,
        EFullGenericBuffer = 17,
        EFullValueBuffer = 18,
        EFullCellPtrObjBuffer = 19,
        EFullSlotBuffer = 20,
        EFullShapeBuffer = 21,
        ETooMuchWasmMemory = 22,
        EDisableGenerationalGc = 23,
        EFinishGc = 24,
        EPrepareForTracing = 25,
        EFullWasmAnyrefBuffer = 26,
        EFullCellPtrStrBuffer = 27,
        ETooMuchJitCode = 28,
        EFullCellPtrBigintBuffer = 29,
        ENurseryTrailers = 30,
        ENurseryMallocBuffers = 31,
        EDomWindowUtils = 32,
        EComponentUtils = 33,
        EMemPressure = 34,
        ECcFinished = 35,
        ECcForced = 36,
        ELoadEnd = 37,
        EUnused3 = 38,
        EPageHide = 39,
        ENsjscontextDestroy = 40,
        EWorkerShutdown = 41,
        ESetDocShell = 42,
        EDomUtils = 43,
        EDomIpc = 44,
        EDomWorker = 45,
        EInterSliceGc = 46,
        EUnused1 = 47,
        EFullGcTimer = 48,
        EShutdownCc = 49,
        EUnused2 = 50,
        EUserInactive = 51,
        EXpconnectShutdown = 52,
        EDocshell = 53,
        EHtmlParser = 54,
        EDomTestutils = 55,
        EPrepareForPageload = 56,
        __Other__,
    }
    impl From<u16> for ReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EApi,
                1 => Self::EEagerAllocTrigger,
                2 => Self::EDestroyRuntime,
                3 => Self::ERootsRemoved,
                4 => Self::ELastDitch,
                5 => Self::ETooMuchMalloc,
                6 => Self::EAllocTrigger,
                7 => Self::EDebugGc,
                8 => Self::ECompartmentRevived,
                9 => Self::EReset,
                10 => Self::EOutOfNursery,
                11 => Self::EEvictNursery,
                12 => Self::ESharedMemoryLimit,
                13 => Self::EEagerNurseryCollection,
                14 => Self::EBgTaskFinished,
                15 => Self::EAbortGc,
                16 => Self::EFullWholeCellBuffer,
                17 => Self::EFullGenericBuffer,
                18 => Self::EFullValueBuffer,
                19 => Self::EFullCellPtrObjBuffer,
                20 => Self::EFullSlotBuffer,
                21 => Self::EFullShapeBuffer,
                22 => Self::ETooMuchWasmMemory,
                23 => Self::EDisableGenerationalGc,
                24 => Self::EFinishGc,
                25 => Self::EPrepareForTracing,
                26 => Self::EFullWasmAnyrefBuffer,
                27 => Self::EFullCellPtrStrBuffer,
                28 => Self::ETooMuchJitCode,
                29 => Self::EFullCellPtrBigintBuffer,
                30 => Self::ENurseryTrailers,
                31 => Self::ENurseryMallocBuffers,
                32 => Self::EDomWindowUtils,
                33 => Self::EComponentUtils,
                34 => Self::EMemPressure,
                35 => Self::ECcFinished,
                36 => Self::ECcForced,
                37 => Self::ELoadEnd,
                38 => Self::EUnused3,
                39 => Self::EPageHide,
                40 => Self::ENsjscontextDestroy,
                41 => Self::EWorkerShutdown,
                42 => Self::ESetDocShell,
                43 => Self::EDomUtils,
                44 => Self::EDomIpc,
                45 => Self::EDomWorker,
                46 => Self::EInterSliceGc,
                47 => Self::EUnused1,
                48 => Self::EFullGcTimer,
                49 => Self::EShutdownCc,
                50 => Self::EUnused2,
                51 => Self::EUserInactive,
                52 => Self::EXpconnectShutdown,
                53 => Self::EDocshell,
                54 => Self::EHtmlParser,
                55 => Self::EDomTestutils,
                56 => Self::EPrepareForPageload,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EApi => "API",
                Self::EEagerAllocTrigger => "EAGER_ALLOC_TRIGGER",
                Self::EDestroyRuntime => "DESTROY_RUNTIME",
                Self::ERootsRemoved => "ROOTS_REMOVED",
                Self::ELastDitch => "LAST_DITCH",
                Self::ETooMuchMalloc => "TOO_MUCH_MALLOC",
                Self::EAllocTrigger => "ALLOC_TRIGGER",
                Self::EDebugGc => "DEBUG_GC",
                Self::ECompartmentRevived => "COMPARTMENT_REVIVED",
                Self::EReset => "RESET",
                Self::EOutOfNursery => "OUT_OF_NURSERY",
                Self::EEvictNursery => "EVICT_NURSERY",
                Self::ESharedMemoryLimit => "SHARED_MEMORY_LIMIT",
                Self::EEagerNurseryCollection => "EAGER_NURSERY_COLLECTION",
                Self::EBgTaskFinished => "BG_TASK_FINISHED",
                Self::EAbortGc => "ABORT_GC",
                Self::EFullWholeCellBuffer => "FULL_WHOLE_CELL_BUFFER",
                Self::EFullGenericBuffer => "FULL_GENERIC_BUFFER",
                Self::EFullValueBuffer => "FULL_VALUE_BUFFER",
                Self::EFullCellPtrObjBuffer => "FULL_CELL_PTR_OBJ_BUFFER",
                Self::EFullSlotBuffer => "FULL_SLOT_BUFFER",
                Self::EFullShapeBuffer => "FULL_SHAPE_BUFFER",
                Self::ETooMuchWasmMemory => "TOO_MUCH_WASM_MEMORY",
                Self::EDisableGenerationalGc => "DISABLE_GENERATIONAL_GC",
                Self::EFinishGc => "FINISH_GC",
                Self::EPrepareForTracing => "PREPARE_FOR_TRACING",
                Self::EFullWasmAnyrefBuffer => "FULL_WASM_ANYREF_BUFFER",
                Self::EFullCellPtrStrBuffer => "FULL_CELL_PTR_STR_BUFFER",
                Self::ETooMuchJitCode => "TOO_MUCH_JIT_CODE",
                Self::EFullCellPtrBigintBuffer => "FULL_CELL_PTR_BIGINT_BUFFER",
                Self::ENurseryTrailers => "NURSERY_TRAILERS",
                Self::ENurseryMallocBuffers => "NURSERY_MALLOC_BUFFERS",
                Self::EDomWindowUtils => "DOM_WINDOW_UTILS",
                Self::EComponentUtils => "COMPONENT_UTILS",
                Self::EMemPressure => "MEM_PRESSURE",
                Self::ECcFinished => "CC_FINISHED",
                Self::ECcForced => "CC_FORCED",
                Self::ELoadEnd => "LOAD_END",
                Self::EUnused3 => "UNUSED3",
                Self::EPageHide => "PAGE_HIDE",
                Self::ENsjscontextDestroy => "NSJSCONTEXT_DESTROY",
                Self::EWorkerShutdown => "WORKER_SHUTDOWN",
                Self::ESetDocShell => "SET_DOC_SHELL",
                Self::EDomUtils => "DOM_UTILS",
                Self::EDomIpc => "DOM_IPC",
                Self::EDomWorker => "DOM_WORKER",
                Self::EInterSliceGc => "INTER_SLICE_GC",
                Self::EUnused1 => "UNUSED1",
                Self::EFullGcTimer => "FULL_GC_TIMER",
                Self::EShutdownCc => "SHUTDOWN_CC",
                Self::EUnused2 => "UNUSED2",
                Self::EUserInactive => "USER_INACTIVE",
                Self::EXpconnectShutdown => "XPCONNECT_SHUTDOWN",
                Self::EDocshell => "DOCSHELL",
                Self::EHtmlParser => "HTML_PARSER",
                Self::EDomTestutils => "DOM_TESTUTILS",
                Self::EPrepareForPageload => "PREPARE_FOR_PAGELOAD",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.reason
    ///
    /// Reason (enum value) for initiating a GC
    pub static reason: Lazy<LabeledMetric<LabeledCounterMetric, ReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reason".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4039), meta, Some(vec![::std::borrow::Cow::from("ABORT_GC"), ::std::borrow::Cow::from("ALLOC_TRIGGER"), ::std::borrow::Cow::from("API"), ::std::borrow::Cow::from("BG_TASK_FINISHED"), ::std::borrow::Cow::from("CC_FINISHED"), ::std::borrow::Cow::from("CC_FORCED"), ::std::borrow::Cow::from("COMPARTMENT_REVIVED"), ::std::borrow::Cow::from("COMPONENT_UTILS"), ::std::borrow::Cow::from("DEBUG_GC"), ::std::borrow::Cow::from("DESTROY_RUNTIME"), ::std::borrow::Cow::from("DISABLE_GENERATIONAL_GC"), ::std::borrow::Cow::from("DOCSHELL"), ::std::borrow::Cow::from("DOM_IPC"), ::std::borrow::Cow::from("DOM_TESTUTILS"), ::std::borrow::Cow::from("DOM_UTILS"), ::std::borrow::Cow::from("DOM_WINDOW_UTILS"), ::std::borrow::Cow::from("DOM_WORKER"), ::std::borrow::Cow::from("EAGER_ALLOC_TRIGGER"), ::std::borrow::Cow::from("EAGER_NURSERY_COLLECTION"), ::std::borrow::Cow::from("EVICT_NURSERY"), ::std::borrow::Cow::from("FINISH_GC"), ::std::borrow::Cow::from("FULL_CELL_PTR_BIGINT_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_OBJ_BUFFER"), ::std::borrow::Cow::from("FULL_CELL_PTR_STR_BUFFER"), ::std::borrow::Cow::from("FULL_GC_TIMER"), ::std::borrow::Cow::from("FULL_GENERIC_BUFFER"), ::std::borrow::Cow::from("FULL_SHAPE_BUFFER"), ::std::borrow::Cow::from("FULL_SLOT_BUFFER"), ::std::borrow::Cow::from("FULL_VALUE_BUFFER"), ::std::borrow::Cow::from("FULL_WASM_ANYREF_BUFFER"), ::std::borrow::Cow::from("FULL_WHOLE_CELL_BUFFER"), ::std::borrow::Cow::from("HTML_PARSER"), ::std::borrow::Cow::from("INTER_SLICE_GC"), ::std::borrow::Cow::from("LAST_DITCH"), ::std::borrow::Cow::from("LOAD_END"), ::std::borrow::Cow::from("MEM_PRESSURE"), ::std::borrow::Cow::from("NSJSCONTEXT_DESTROY"), ::std::borrow::Cow::from("NURSERY_MALLOC_BUFFERS"), ::std::borrow::Cow::from("NURSERY_TRAILERS"), ::std::borrow::Cow::from("OUT_OF_NURSERY"), ::std::borrow::Cow::from("PAGE_HIDE"), ::std::borrow::Cow::from("PREPARE_FOR_PAGELOAD"), ::std::borrow::Cow::from("PREPARE_FOR_TRACING"), ::std::borrow::Cow::from("RESET"), ::std::borrow::Cow::from("ROOTS_REMOVED"), ::std::borrow::Cow::from("SET_DOC_SHELL"), ::std::borrow::Cow::from("SHARED_MEMORY_LIMIT"), ::std::borrow::Cow::from("SHUTDOWN_CC"), ::std::borrow::Cow::from("TOO_MUCH_JIT_CODE"), ::std::borrow::Cow::from("TOO_MUCH_MALLOC"), ::std::borrow::Cow::from("TOO_MUCH_WASM_MEMORY"), ::std::borrow::Cow::from("UNUSED1"), ::std::borrow::Cow::from("UNUSED2"), ::std::borrow::Cow::from("UNUSED3"), ::std::borrow::Cow::from("USER_INACTIVE"), ::std::borrow::Cow::from("WORKER_SHUTDOWN"), ::std::borrow::Cow::from("XPCONNECT_SHUTDOWN")]))
    });

    #[repr(u16)]
    pub enum ResetLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ResetLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResetLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.reset
    ///
    /// Was an incremental GC canceled?
    pub static reset: Lazy<LabeledMetric<LabeledCounterMetric, ResetLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reset".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4040), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ResetReasonLabel {
        ENone = 0,
        ENonincrementalrequested = 1,
        EAbortrequested = 2,
        EUnused1 = 3,
        EIncrementaldisabled = 4,
        EModechange = 5,
        EMallocbytestrigger = 6,
        EGcbytestrigger = 7,
        EZonechange = 8,
        ECompartmentrevived = 9,
        EGrayrootbufferingfailed = 10,
        EJitcodebytestrigger = 11,
        __Other__,
    }
    impl From<u16> for ResetReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::ENonincrementalrequested,
                2 => Self::EAbortrequested,
                3 => Self::EUnused1,
                4 => Self::EIncrementaldisabled,
                5 => Self::EModechange,
                6 => Self::EMallocbytestrigger,
                7 => Self::EGcbytestrigger,
                8 => Self::EZonechange,
                9 => Self::ECompartmentrevived,
                10 => Self::EGrayrootbufferingfailed,
                11 => Self::EJitcodebytestrigger,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResetReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "None",
                Self::ENonincrementalrequested => "NonIncrementalRequested",
                Self::EAbortrequested => "AbortRequested",
                Self::EUnused1 => "Unused1",
                Self::EIncrementaldisabled => "IncrementalDisabled",
                Self::EModechange => "ModeChange",
                Self::EMallocbytestrigger => "MallocBytesTrigger",
                Self::EGcbytestrigger => "GCBytesTrigger",
                Self::EZonechange => "ZoneChange",
                Self::ECompartmentrevived => "CompartmentRevived",
                Self::EGrayrootbufferingfailed => "GrayRootBufferingFailed",
                Self::EJitcodebytestrigger => "JitCodeBytesTrigger",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.reset_reason
    ///
    /// Reason for cancelling an ongoing GC (see js::GCAbortReason)
    pub static reset_reason: Lazy<LabeledMetric<LabeledCounterMetric, ResetReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reset_reason".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4041), meta, Some(vec![::std::borrow::Cow::from("AbortRequested"), ::std::borrow::Cow::from("CompartmentRevived"), ::std::borrow::Cow::from("GCBytesTrigger"), ::std::borrow::Cow::from("GrayRootBufferingFailed"), ::std::borrow::Cow::from("IncrementalDisabled"), ::std::borrow::Cow::from("JitCodeBytesTrigger"), ::std::borrow::Cow::from("MallocBytesTrigger"), ::std::borrow::Cow::from("ModeChange"), ::std::borrow::Cow::from("NonIncrementalRequested"), ::std::borrow::Cow::from("None"), ::std::borrow::Cow::from("Unused1"), ::std::borrow::Cow::from("ZoneChange")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slice_count
    ///
    /// The number of slices in an incremental GC for the main runtime.
    pub static slice_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slice_count".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4042), meta, 0, 200, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slice_time
    ///
    /// The time spent running a GC slice. (Migrated from the geckoview metric of the same name.)
    pub static slice_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slice_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4043), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SliceWasLongLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SliceWasLongLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SliceWasLongLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slice_was_long
    ///
    /// Whether a GC slice took 1.5 times or 5ms more than its budget
    pub static slice_was_long: Lazy<LabeledMetric<LabeledCounterMetric, SliceWasLongLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "slice_was_long".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4044), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum SlowPhaseLabel {
        EMutator = 0,
        EGcBegin = 1,
        EMarkCcws = 2,
        EMarkStack = 3,
        EMarkRuntimeData = 4,
        EMarkEmbedding = 5,
        EMarkRoots = 6,
        EEvictNurseryForMajorGc = 7,
        EWaitBackgroundThread = 8,
        EUnmark = 9,
        EUnmarkWeakmaps = 10,
        EMarkDiscardCode = 11,
        ERelazifyFunctions = 12,
        EPurge = 13,
        EPurgePropMapTables = 14,
        EPurgeSourceUrls = 15,
        EJoinParallelTasks = 16,
        EPrepare = 17,
        EMarkDelayed = 18,
        EMarkGrayWeak = 19,
        EMarkWeak = 20,
        EMarkIncomingGray = 21,
        EMarkGray = 22,
        EParallelMarkMark = 23,
        EParallelMarkWait = 24,
        EParallelMarkOther = 25,
        EParallelMark = 26,
        EMark = 27,
        EWeakZonesCallback = 28,
        EWeakCompartmentCallback = 29,
        EFinalizeStart = 30,
        EUpdateAtomsBitmap = 31,
        ESweepAtomsTable = 32,
        ESweepJitScripts = 33,
        ESweepInnerViews = 34,
        ESweepCcWrapper = 35,
        ESweepBaseShape = 36,
        ESweepInitialShape = 37,
        ESweepRegexp = 38,
        ESweepCompression = 39,
        ESweepWeakmaps = 40,
        ESweepUniqueids = 41,
        ESweepWeakPointers = 42,
        ESweepFinalizationObservers = 43,
        ESweepJitData = 44,
        ESweepWeakCaches = 45,
        ESweepMisc = 46,
        ESweepCompartments = 47,
        ESweepPropMap = 48,
        EFinalizeEnd = 49,
        EDestroy = 50,
        EFindDeadCompartments = 51,
        ESweep = 52,
        ECompactMove = 53,
        ECompactUpdateCells = 54,
        ECompactUpdate = 55,
        ECompact = 56,
        EDecommit = 57,
        EGcEnd = 58,
        EMinorGc = 59,
        EEvictNursery = 60,
        ETraceHeap = 61,
        __Other__,
    }
    impl From<u16> for SlowPhaseLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMutator,
                1 => Self::EGcBegin,
                2 => Self::EMarkCcws,
                3 => Self::EMarkStack,
                4 => Self::EMarkRuntimeData,
                5 => Self::EMarkEmbedding,
                6 => Self::EMarkRoots,
                7 => Self::EEvictNurseryForMajorGc,
                8 => Self::EWaitBackgroundThread,
                9 => Self::EUnmark,
                10 => Self::EUnmarkWeakmaps,
                11 => Self::EMarkDiscardCode,
                12 => Self::ERelazifyFunctions,
                13 => Self::EPurge,
                14 => Self::EPurgePropMapTables,
                15 => Self::EPurgeSourceUrls,
                16 => Self::EJoinParallelTasks,
                17 => Self::EPrepare,
                18 => Self::EMarkDelayed,
                19 => Self::EMarkGrayWeak,
                20 => Self::EMarkWeak,
                21 => Self::EMarkIncomingGray,
                22 => Self::EMarkGray,
                23 => Self::EParallelMarkMark,
                24 => Self::EParallelMarkWait,
                25 => Self::EParallelMarkOther,
                26 => Self::EParallelMark,
                27 => Self::EMark,
                28 => Self::EWeakZonesCallback,
                29 => Self::EWeakCompartmentCallback,
                30 => Self::EFinalizeStart,
                31 => Self::EUpdateAtomsBitmap,
                32 => Self::ESweepAtomsTable,
                33 => Self::ESweepJitScripts,
                34 => Self::ESweepInnerViews,
                35 => Self::ESweepCcWrapper,
                36 => Self::ESweepBaseShape,
                37 => Self::ESweepInitialShape,
                38 => Self::ESweepRegexp,
                39 => Self::ESweepCompression,
                40 => Self::ESweepWeakmaps,
                41 => Self::ESweepUniqueids,
                42 => Self::ESweepWeakPointers,
                43 => Self::ESweepFinalizationObservers,
                44 => Self::ESweepJitData,
                45 => Self::ESweepWeakCaches,
                46 => Self::ESweepMisc,
                47 => Self::ESweepCompartments,
                48 => Self::ESweepPropMap,
                49 => Self::EFinalizeEnd,
                50 => Self::EDestroy,
                51 => Self::EFindDeadCompartments,
                52 => Self::ESweep,
                53 => Self::ECompactMove,
                54 => Self::ECompactUpdateCells,
                55 => Self::ECompactUpdate,
                56 => Self::ECompact,
                57 => Self::EDecommit,
                58 => Self::EGcEnd,
                59 => Self::EMinorGc,
                60 => Self::EEvictNursery,
                61 => Self::ETraceHeap,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SlowPhaseLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMutator => "MUTATOR",
                Self::EGcBegin => "GC_BEGIN",
                Self::EMarkCcws => "MARK_CCWS",
                Self::EMarkStack => "MARK_STACK",
                Self::EMarkRuntimeData => "MARK_RUNTIME_DATA",
                Self::EMarkEmbedding => "MARK_EMBEDDING",
                Self::EMarkRoots => "MARK_ROOTS",
                Self::EEvictNurseryForMajorGc => "EVICT_NURSERY_FOR_MAJOR_GC",
                Self::EWaitBackgroundThread => "WAIT_BACKGROUND_THREAD",
                Self::EUnmark => "UNMARK",
                Self::EUnmarkWeakmaps => "UNMARK_WEAKMAPS",
                Self::EMarkDiscardCode => "MARK_DISCARD_CODE",
                Self::ERelazifyFunctions => "RELAZIFY_FUNCTIONS",
                Self::EPurge => "PURGE",
                Self::EPurgePropMapTables => "PURGE_PROP_MAP_TABLES",
                Self::EPurgeSourceUrls => "PURGE_SOURCE_URLS",
                Self::EJoinParallelTasks => "JOIN_PARALLEL_TASKS",
                Self::EPrepare => "PREPARE",
                Self::EMarkDelayed => "MARK_DELAYED",
                Self::EMarkGrayWeak => "MARK_GRAY_WEAK",
                Self::EMarkWeak => "MARK_WEAK",
                Self::EMarkIncomingGray => "MARK_INCOMING_GRAY",
                Self::EMarkGray => "MARK_GRAY",
                Self::EParallelMarkMark => "PARALLEL_MARK_MARK",
                Self::EParallelMarkWait => "PARALLEL_MARK_WAIT",
                Self::EParallelMarkOther => "PARALLEL_MARK_OTHER",
                Self::EParallelMark => "PARALLEL_MARK",
                Self::EMark => "MARK",
                Self::EWeakZonesCallback => "WEAK_ZONES_CALLBACK",
                Self::EWeakCompartmentCallback => "WEAK_COMPARTMENT_CALLBACK",
                Self::EFinalizeStart => "FINALIZE_START",
                Self::EUpdateAtomsBitmap => "UPDATE_ATOMS_BITMAP",
                Self::ESweepAtomsTable => "SWEEP_ATOMS_TABLE",
                Self::ESweepJitScripts => "SWEEP_JIT_SCRIPTS",
                Self::ESweepInnerViews => "SWEEP_INNER_VIEWS",
                Self::ESweepCcWrapper => "SWEEP_CC_WRAPPER",
                Self::ESweepBaseShape => "SWEEP_BASE_SHAPE",
                Self::ESweepInitialShape => "SWEEP_INITIAL_SHAPE",
                Self::ESweepRegexp => "SWEEP_REGEXP",
                Self::ESweepCompression => "SWEEP_COMPRESSION",
                Self::ESweepWeakmaps => "SWEEP_WEAKMAPS",
                Self::ESweepUniqueids => "SWEEP_UNIQUEIDS",
                Self::ESweepWeakPointers => "SWEEP_WEAK_POINTERS",
                Self::ESweepFinalizationObservers => "SWEEP_FINALIZATION_OBSERVERS",
                Self::ESweepJitData => "SWEEP_JIT_DATA",
                Self::ESweepWeakCaches => "SWEEP_WEAK_CACHES",
                Self::ESweepMisc => "SWEEP_MISC",
                Self::ESweepCompartments => "SWEEP_COMPARTMENTS",
                Self::ESweepPropMap => "SWEEP_PROP_MAP",
                Self::EFinalizeEnd => "FINALIZE_END",
                Self::EDestroy => "DESTROY",
                Self::EFindDeadCompartments => "FIND_DEAD_COMPARTMENTS",
                Self::ESweep => "SWEEP",
                Self::ECompactMove => "COMPACT_MOVE",
                Self::ECompactUpdateCells => "COMPACT_UPDATE_CELLS",
                Self::ECompactUpdate => "COMPACT_UPDATE",
                Self::ECompact => "COMPACT",
                Self::EDecommit => "DECOMMIT",
                Self::EGcEnd => "GC_END",
                Self::EMinorGc => "MINOR_GC",
                Self::EEvictNursery => "EVICT_NURSERY",
                Self::ETraceHeap => "TRACE_HEAP",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slow_phase
    ///
    /// The longest phase in any slice that goes over 2x the budget. The phase values are defined in js/src/gc/GenerateStatsPhases.py.
    pub static slow_phase: Lazy<LabeledMetric<LabeledCounterMetric, SlowPhaseLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "slow_phase".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4045), meta, Some(vec![::std::borrow::Cow::from("COMPACT"), ::std::borrow::Cow::from("COMPACT_MOVE"), ::std::borrow::Cow::from("COMPACT_UPDATE"), ::std::borrow::Cow::from("COMPACT_UPDATE_CELLS"), ::std::borrow::Cow::from("DECOMMIT"), ::std::borrow::Cow::from("DESTROY"), ::std::borrow::Cow::from("EVICT_NURSERY"), ::std::borrow::Cow::from("EVICT_NURSERY_FOR_MAJOR_GC"), ::std::borrow::Cow::from("FINALIZE_END"), ::std::borrow::Cow::from("FINALIZE_START"), ::std::borrow::Cow::from("FIND_DEAD_COMPARTMENTS"), ::std::borrow::Cow::from("GC_BEGIN"), ::std::borrow::Cow::from("GC_END"), ::std::borrow::Cow::from("JOIN_PARALLEL_TASKS"), ::std::borrow::Cow::from("MARK"), ::std::borrow::Cow::from("MARK_CCWS"), ::std::borrow::Cow::from("MARK_DELAYED"), ::std::borrow::Cow::from("MARK_DISCARD_CODE"), ::std::borrow::Cow::from("MARK_EMBEDDING"), ::std::borrow::Cow::from("MARK_GRAY"), ::std::borrow::Cow::from("MARK_GRAY_WEAK"), ::std::borrow::Cow::from("MARK_INCOMING_GRAY"), ::std::borrow::Cow::from("MARK_ROOTS"), ::std::borrow::Cow::from("MARK_RUNTIME_DATA"), ::std::borrow::Cow::from("MARK_STACK"), ::std::borrow::Cow::from("MARK_WEAK"), ::std::borrow::Cow::from("MINOR_GC"), ::std::borrow::Cow::from("MUTATOR"), ::std::borrow::Cow::from("PARALLEL_MARK"), ::std::borrow::Cow::from("PARALLEL_MARK_MARK"), ::std::borrow::Cow::from("PARALLEL_MARK_OTHER"), ::std::borrow::Cow::from("PARALLEL_MARK_WAIT"), ::std::borrow::Cow::from("PREPARE"), ::std::borrow::Cow::from("PURGE"), ::std::borrow::Cow::from("PURGE_PROP_MAP_TABLES"), ::std::borrow::Cow::from("PURGE_SOURCE_URLS"), ::std::borrow::Cow::from("RELAZIFY_FUNCTIONS"), ::std::borrow::Cow::from("SWEEP"), ::std::borrow::Cow::from("SWEEP_ATOMS_TABLE"), ::std::borrow::Cow::from("SWEEP_BASE_SHAPE"), ::std::borrow::Cow::from("SWEEP_CC_WRAPPER"), ::std::borrow::Cow::from("SWEEP_COMPARTMENTS"), ::std::borrow::Cow::from("SWEEP_COMPRESSION"), ::std::borrow::Cow::from("SWEEP_FINALIZATION_OBSERVERS"), ::std::borrow::Cow::from("SWEEP_INITIAL_SHAPE"), ::std::borrow::Cow::from("SWEEP_INNER_VIEWS"), ::std::borrow::Cow::from("SWEEP_JIT_DATA"), ::std::borrow::Cow::from("SWEEP_JIT_SCRIPTS"), ::std::borrow::Cow::from("SWEEP_MISC"), ::std::borrow::Cow::from("SWEEP_PROP_MAP"), ::std::borrow::Cow::from("SWEEP_REGEXP"), ::std::borrow::Cow::from("SWEEP_UNIQUEIDS"), ::std::borrow::Cow::from("SWEEP_WEAKMAPS"), ::std::borrow::Cow::from("SWEEP_WEAK_CACHES"), ::std::borrow::Cow::from("SWEEP_WEAK_POINTERS"), ::std::borrow::Cow::from("TRACE_HEAP"), ::std::borrow::Cow::from("UNMARK"), ::std::borrow::Cow::from("UNMARK_WEAKMAPS"), ::std::borrow::Cow::from("UPDATE_ATOMS_BITMAP"), ::std::borrow::Cow::from("WAIT_BACKGROUND_THREAD"), ::std::borrow::Cow::from("WEAK_COMPARTMENT_CALLBACK"), ::std::borrow::Cow::from("WEAK_ZONES_CALLBACK")]))
    });

    #[repr(u16)]
    pub enum SlowTaskLabel {
        EMutator = 0,
        EGcBegin = 1,
        EMarkCcws = 2,
        EMarkStack = 3,
        EMarkRuntimeData = 4,
        EMarkEmbedding = 5,
        EMarkRoots = 6,
        EEvictNurseryForMajorGc = 7,
        EWaitBackgroundThread = 8,
        EUnmark = 9,
        EUnmarkWeakmaps = 10,
        EMarkDiscardCode = 11,
        ERelazifyFunctions = 12,
        EPurge = 13,
        EPurgePropMapTables = 14,
        EPurgeSourceUrls = 15,
        EJoinParallelTasks = 16,
        EPrepare = 17,
        EMarkDelayed = 18,
        EMarkGrayWeak = 19,
        EMarkWeak = 20,
        EMarkIncomingGray = 21,
        EMarkGray = 22,
        EParallelMarkMark = 23,
        EParallelMarkWait = 24,
        EParallelMarkOther = 25,
        EParallelMark = 26,
        EMark = 27,
        EWeakZonesCallback = 28,
        EWeakCompartmentCallback = 29,
        EFinalizeStart = 30,
        EUpdateAtomsBitmap = 31,
        ESweepAtomsTable = 32,
        ESweepJitScripts = 33,
        ESweepInnerViews = 34,
        ESweepCcWrapper = 35,
        ESweepBaseShape = 36,
        ESweepInitialShape = 37,
        ESweepRegexp = 38,
        ESweepCompression = 39,
        ESweepWeakmaps = 40,
        ESweepUniqueids = 41,
        ESweepWeakPointers = 42,
        ESweepFinalizationObservers = 43,
        ESweepJitData = 44,
        ESweepWeakCaches = 45,
        ESweepMisc = 46,
        ESweepCompartments = 47,
        ESweepPropMap = 48,
        EFinalizeEnd = 49,
        EDestroy = 50,
        EFindDeadCompartments = 51,
        ESweep = 52,
        ECompactMove = 53,
        ECompactUpdateCells = 54,
        ECompactUpdate = 55,
        ECompact = 56,
        EDecommit = 57,
        EGcEnd = 58,
        EMinorGc = 59,
        EEvictNursery = 60,
        ETraceHeap = 61,
        __Other__,
    }
    impl From<u16> for SlowTaskLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMutator,
                1 => Self::EGcBegin,
                2 => Self::EMarkCcws,
                3 => Self::EMarkStack,
                4 => Self::EMarkRuntimeData,
                5 => Self::EMarkEmbedding,
                6 => Self::EMarkRoots,
                7 => Self::EEvictNurseryForMajorGc,
                8 => Self::EWaitBackgroundThread,
                9 => Self::EUnmark,
                10 => Self::EUnmarkWeakmaps,
                11 => Self::EMarkDiscardCode,
                12 => Self::ERelazifyFunctions,
                13 => Self::EPurge,
                14 => Self::EPurgePropMapTables,
                15 => Self::EPurgeSourceUrls,
                16 => Self::EJoinParallelTasks,
                17 => Self::EPrepare,
                18 => Self::EMarkDelayed,
                19 => Self::EMarkGrayWeak,
                20 => Self::EMarkWeak,
                21 => Self::EMarkIncomingGray,
                22 => Self::EMarkGray,
                23 => Self::EParallelMarkMark,
                24 => Self::EParallelMarkWait,
                25 => Self::EParallelMarkOther,
                26 => Self::EParallelMark,
                27 => Self::EMark,
                28 => Self::EWeakZonesCallback,
                29 => Self::EWeakCompartmentCallback,
                30 => Self::EFinalizeStart,
                31 => Self::EUpdateAtomsBitmap,
                32 => Self::ESweepAtomsTable,
                33 => Self::ESweepJitScripts,
                34 => Self::ESweepInnerViews,
                35 => Self::ESweepCcWrapper,
                36 => Self::ESweepBaseShape,
                37 => Self::ESweepInitialShape,
                38 => Self::ESweepRegexp,
                39 => Self::ESweepCompression,
                40 => Self::ESweepWeakmaps,
                41 => Self::ESweepUniqueids,
                42 => Self::ESweepWeakPointers,
                43 => Self::ESweepFinalizationObservers,
                44 => Self::ESweepJitData,
                45 => Self::ESweepWeakCaches,
                46 => Self::ESweepMisc,
                47 => Self::ESweepCompartments,
                48 => Self::ESweepPropMap,
                49 => Self::EFinalizeEnd,
                50 => Self::EDestroy,
                51 => Self::EFindDeadCompartments,
                52 => Self::ESweep,
                53 => Self::ECompactMove,
                54 => Self::ECompactUpdateCells,
                55 => Self::ECompactUpdate,
                56 => Self::ECompact,
                57 => Self::EDecommit,
                58 => Self::EGcEnd,
                59 => Self::EMinorGc,
                60 => Self::EEvictNursery,
                61 => Self::ETraceHeap,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SlowTaskLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMutator => "MUTATOR",
                Self::EGcBegin => "GC_BEGIN",
                Self::EMarkCcws => "MARK_CCWS",
                Self::EMarkStack => "MARK_STACK",
                Self::EMarkRuntimeData => "MARK_RUNTIME_DATA",
                Self::EMarkEmbedding => "MARK_EMBEDDING",
                Self::EMarkRoots => "MARK_ROOTS",
                Self::EEvictNurseryForMajorGc => "EVICT_NURSERY_FOR_MAJOR_GC",
                Self::EWaitBackgroundThread => "WAIT_BACKGROUND_THREAD",
                Self::EUnmark => "UNMARK",
                Self::EUnmarkWeakmaps => "UNMARK_WEAKMAPS",
                Self::EMarkDiscardCode => "MARK_DISCARD_CODE",
                Self::ERelazifyFunctions => "RELAZIFY_FUNCTIONS",
                Self::EPurge => "PURGE",
                Self::EPurgePropMapTables => "PURGE_PROP_MAP_TABLES",
                Self::EPurgeSourceUrls => "PURGE_SOURCE_URLS",
                Self::EJoinParallelTasks => "JOIN_PARALLEL_TASKS",
                Self::EPrepare => "PREPARE",
                Self::EMarkDelayed => "MARK_DELAYED",
                Self::EMarkGrayWeak => "MARK_GRAY_WEAK",
                Self::EMarkWeak => "MARK_WEAK",
                Self::EMarkIncomingGray => "MARK_INCOMING_GRAY",
                Self::EMarkGray => "MARK_GRAY",
                Self::EParallelMarkMark => "PARALLEL_MARK_MARK",
                Self::EParallelMarkWait => "PARALLEL_MARK_WAIT",
                Self::EParallelMarkOther => "PARALLEL_MARK_OTHER",
                Self::EParallelMark => "PARALLEL_MARK",
                Self::EMark => "MARK",
                Self::EWeakZonesCallback => "WEAK_ZONES_CALLBACK",
                Self::EWeakCompartmentCallback => "WEAK_COMPARTMENT_CALLBACK",
                Self::EFinalizeStart => "FINALIZE_START",
                Self::EUpdateAtomsBitmap => "UPDATE_ATOMS_BITMAP",
                Self::ESweepAtomsTable => "SWEEP_ATOMS_TABLE",
                Self::ESweepJitScripts => "SWEEP_JIT_SCRIPTS",
                Self::ESweepInnerViews => "SWEEP_INNER_VIEWS",
                Self::ESweepCcWrapper => "SWEEP_CC_WRAPPER",
                Self::ESweepBaseShape => "SWEEP_BASE_SHAPE",
                Self::ESweepInitialShape => "SWEEP_INITIAL_SHAPE",
                Self::ESweepRegexp => "SWEEP_REGEXP",
                Self::ESweepCompression => "SWEEP_COMPRESSION",
                Self::ESweepWeakmaps => "SWEEP_WEAKMAPS",
                Self::ESweepUniqueids => "SWEEP_UNIQUEIDS",
                Self::ESweepWeakPointers => "SWEEP_WEAK_POINTERS",
                Self::ESweepFinalizationObservers => "SWEEP_FINALIZATION_OBSERVERS",
                Self::ESweepJitData => "SWEEP_JIT_DATA",
                Self::ESweepWeakCaches => "SWEEP_WEAK_CACHES",
                Self::ESweepMisc => "SWEEP_MISC",
                Self::ESweepCompartments => "SWEEP_COMPARTMENTS",
                Self::ESweepPropMap => "SWEEP_PROP_MAP",
                Self::EFinalizeEnd => "FINALIZE_END",
                Self::EDestroy => "DESTROY",
                Self::EFindDeadCompartments => "FIND_DEAD_COMPARTMENTS",
                Self::ESweep => "SWEEP",
                Self::ECompactMove => "COMPACT_MOVE",
                Self::ECompactUpdateCells => "COMPACT_UPDATE_CELLS",
                Self::ECompactUpdate => "COMPACT_UPDATE",
                Self::ECompact => "COMPACT",
                Self::EDecommit => "DECOMMIT",
                Self::EGcEnd => "GC_END",
                Self::EMinorGc => "MINOR_GC",
                Self::EEvictNursery => "EVICT_NURSERY",
                Self::ETraceHeap => "TRACE_HEAP",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.slow_task
    ///
    /// The longest parallel task in any slice that goes over 2x the budget. The phase values are defined in js/src/gc/GenerateStatsPhases.py.
    pub static slow_task: Lazy<LabeledMetric<LabeledCounterMetric, SlowTaskLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "slow_task".into(),
                    category: "javascript.gc".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4046), meta, Some(vec![::std::borrow::Cow::from("COMPACT"), ::std::borrow::Cow::from("COMPACT_MOVE"), ::std::borrow::Cow::from("COMPACT_UPDATE"), ::std::borrow::Cow::from("COMPACT_UPDATE_CELLS"), ::std::borrow::Cow::from("DECOMMIT"), ::std::borrow::Cow::from("DESTROY"), ::std::borrow::Cow::from("EVICT_NURSERY"), ::std::borrow::Cow::from("EVICT_NURSERY_FOR_MAJOR_GC"), ::std::borrow::Cow::from("FINALIZE_END"), ::std::borrow::Cow::from("FINALIZE_START"), ::std::borrow::Cow::from("FIND_DEAD_COMPARTMENTS"), ::std::borrow::Cow::from("GC_BEGIN"), ::std::borrow::Cow::from("GC_END"), ::std::borrow::Cow::from("JOIN_PARALLEL_TASKS"), ::std::borrow::Cow::from("MARK"), ::std::borrow::Cow::from("MARK_CCWS"), ::std::borrow::Cow::from("MARK_DELAYED"), ::std::borrow::Cow::from("MARK_DISCARD_CODE"), ::std::borrow::Cow::from("MARK_EMBEDDING"), ::std::borrow::Cow::from("MARK_GRAY"), ::std::borrow::Cow::from("MARK_GRAY_WEAK"), ::std::borrow::Cow::from("MARK_INCOMING_GRAY"), ::std::borrow::Cow::from("MARK_ROOTS"), ::std::borrow::Cow::from("MARK_RUNTIME_DATA"), ::std::borrow::Cow::from("MARK_STACK"), ::std::borrow::Cow::from("MARK_WEAK"), ::std::borrow::Cow::from("MINOR_GC"), ::std::borrow::Cow::from("MUTATOR"), ::std::borrow::Cow::from("PARALLEL_MARK"), ::std::borrow::Cow::from("PARALLEL_MARK_MARK"), ::std::borrow::Cow::from("PARALLEL_MARK_OTHER"), ::std::borrow::Cow::from("PARALLEL_MARK_WAIT"), ::std::borrow::Cow::from("PREPARE"), ::std::borrow::Cow::from("PURGE"), ::std::borrow::Cow::from("PURGE_PROP_MAP_TABLES"), ::std::borrow::Cow::from("PURGE_SOURCE_URLS"), ::std::borrow::Cow::from("RELAZIFY_FUNCTIONS"), ::std::borrow::Cow::from("SWEEP"), ::std::borrow::Cow::from("SWEEP_ATOMS_TABLE"), ::std::borrow::Cow::from("SWEEP_BASE_SHAPE"), ::std::borrow::Cow::from("SWEEP_CC_WRAPPER"), ::std::borrow::Cow::from("SWEEP_COMPARTMENTS"), ::std::borrow::Cow::from("SWEEP_COMPRESSION"), ::std::borrow::Cow::from("SWEEP_FINALIZATION_OBSERVERS"), ::std::borrow::Cow::from("SWEEP_INITIAL_SHAPE"), ::std::borrow::Cow::from("SWEEP_INNER_VIEWS"), ::std::borrow::Cow::from("SWEEP_JIT_DATA"), ::std::borrow::Cow::from("SWEEP_JIT_SCRIPTS"), ::std::borrow::Cow::from("SWEEP_MISC"), ::std::borrow::Cow::from("SWEEP_PROP_MAP"), ::std::borrow::Cow::from("SWEEP_REGEXP"), ::std::borrow::Cow::from("SWEEP_UNIQUEIDS"), ::std::borrow::Cow::from("SWEEP_WEAKMAPS"), ::std::borrow::Cow::from("SWEEP_WEAK_CACHES"), ::std::borrow::Cow::from("SWEEP_WEAK_POINTERS"), ::std::borrow::Cow::from("TRACE_HEAP"), ::std::borrow::Cow::from("UNMARK"), ::std::borrow::Cow::from("UNMARK_WEAKMAPS"), ::std::borrow::Cow::from("UPDATE_ATOMS_BITMAP"), ::std::borrow::Cow::from("WAIT_BACKGROUND_THREAD"), ::std::borrow::Cow::from("WEAK_COMPARTMENT_CALLBACK"), ::std::borrow::Cow::from("WEAK_ZONES_CALLBACK")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.sweep_time
    ///
    /// The time spent in the sweep phase. (Migrated from the geckoview metric of the same name.)
    pub static sweep_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sweep_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4047), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.task_start_delay
    ///
    /// Delay between queuing a GC task and the task starting.
    pub static task_start_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "task_start_delay".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4048), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.tenured_survival_rate
    ///
    /// The percentage of tenured GC things that survived a collection.
    pub static tenured_survival_rate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tenured_survival_rate".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4049), meta, 0, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.time_between
    ///
    /// Time spent in between garbage collections for the main runtime.
    pub static time_between: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_between".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4050), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.time_between_slices
    ///
    /// Time spent in between garbage collections for the main runtime.
    pub static time_between_slices: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_between_slices".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4051), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.total_time
    ///
    /// The total time taken by a major collection. (Migrated from the geckoview metric of the same name.)
    pub static total_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_time".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4052), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.zone_count
    ///
    /// Total number of GC zones
    pub static zone_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zone_count".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4053), meta, 0, 100, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from javascript.gc.zones_collected
    ///
    /// Number of zones collected in a zone GC.
    pub static zones_collected: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zones_collected".into(),
                category: "javascript.gc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4054), meta, 0, 100, 20, HistogramType::Exponential)
    });

}
pub mod javascript_ion {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from javascript.ion.compile_time
    ///
    /// Time in microseconds of an Ion compilation.
    pub static compile_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compile_time".into(),
                category: "javascript.ion".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4055), meta, TimeUnit::Microsecond)
    });

}
pub mod performance_clone_deserialize {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.items
    ///
    /// Size of deserialized data, in items
    pub static items: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "items".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4056), meta, 1, 2147483646, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.size
    ///
    /// Size of deserialized data, in bytes
    pub static size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4057), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from performance.clone.deserialize.time
    ///
    /// Time spent deserializing structured data
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "performance.clone.deserialize".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4058), meta, TimeUnit::Microsecond)
    });

}
pub mod script_preloader {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from script.preloader.mainthread_recompile
    ///
    /// How many times we ended up recompiling a script from the script preloader on the main thread. This metric was generated to correspond to the Legacy Telemetry scalar script.preloader.mainthread_recompile.
    pub static mainthread_recompile: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4059,
            "script.preloader",
            "mainthread_recompile",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum RequestsLabel {
        EHit = 0,
        EHitchild = 1,
        EMiss = 2,
        __Other__,
    }
    impl From<u16> for RequestsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHit,
                1 => Self::EHitchild,
                2 => Self::EMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHit => "Hit",
                Self::EHitchild => "HitChild",
                Self::EMiss => "Miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from script.preloader.requests
    ///
    /// Record hits and misses to the script preloader, with categories.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram SCRIPT_PRELOADER_REQUESTS.
    pub static requests: Lazy<LabeledMetric<LabeledCounterMetric, RequestsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "requests".into(),
                    category: "script.preloader".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4060), meta, Some(vec![::std::borrow::Cow::from("Hit"), ::std::borrow::Cow::from("HitChild"), ::std::borrow::Cow::from("Miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from script.preloader.wait_time
    ///
    /// Time spent waiting for off-thread compiles in the script preloader.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SCRIPT_PRELOADER_WAIT_TIME.
    pub static wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wait_time".into(),
                category: "script.preloader".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4061), meta, TimeUnit::Millisecond)
    });

}
pub mod slow_script_warning {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from slow_script_warning.notify_delay
    ///
    /// The difference between the js slow script timeout for content set in prefs and the actual time we waited before displaying the notification (msec).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SLOW_SCRIPT_NOTIFY_DELAY.
    pub static notify_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "notify_delay".into(),
                category: "slow_script_warning".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4062), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownBrowserExtra {
        pub r#hang_duration: Option<String>,
        pub r#uri_type: Option<String>,
    }

    impl ExtraKeys for ShownBrowserExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["hang_duration", "uri_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#hang_duration.and_then(|val| map.insert("hang_duration".into(), val.to_string()));
          self.r#uri_type.and_then(|val| map.insert("uri_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from slow_script_warning.shown_browser
    ///
    /// Recorded when a slow script hang is resolved. This event was generated to correspond to the Legacy Telemetry event slow_script_warning.shown#browser.
    pub static shown_browser: Lazy<EventMetric<ShownBrowserExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_browser".into(),
                category: "slow_script_warning".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4063), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownContentExtra {
        pub r#end_reason: Option<String>,
        pub r#hang_duration: Option<String>,
        pub r#n_tab_deselect: Option<u32>,
        pub r#uptime: Option<String>,
        pub r#uri_type: Option<String>,
        pub r#wait_count: Option<u32>,
    }

    impl ExtraKeys for ShownContentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["end_reason", "hang_duration", "n_tab_deselect", "uptime", "uri_type", "wait_count"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#end_reason.and_then(|val| map.insert("end_reason".into(), val.to_string()));
          self.r#hang_duration.and_then(|val| map.insert("hang_duration".into(), val.to_string()));
          self.r#n_tab_deselect.and_then(|val| map.insert("n_tab_deselect".into(), val.to_string()));
          self.r#uptime.and_then(|val| map.insert("uptime".into(), val.to_string()));
          self.r#uri_type.and_then(|val| map.insert("uri_type".into(), val.to_string()));
          self.r#wait_count.and_then(|val| map.insert("wait_count".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from slow_script_warning.shown_content
    ///
    /// Recorded when a slow script hang is resolved. This event was generated to correspond to the Legacy Telemetry event slow_script_warning.shown#content.
    pub static shown_content: Lazy<EventMetric<ShownContentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_content".into(),
                category: "slow_script_warning".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4064), meta)
    });

}
pub mod layout {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from layout.input_event_queued_click
    ///
    /// Time (ms) for the mouse up/down event to dispatch, but before handlers executing.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram INPUT_EVENT_QUEUED_CLICK_MS.
    pub static input_event_queued_click: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "input_event_queued_click".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4065), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.input_event_queued_keyboard
    ///
    /// Time (ms) for the keyboard event to dispatch, but before handlers executing.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram INPUT_EVENT_QUEUED_KEYBOARD_MS.
    pub static input_event_queued_keyboard: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "input_event_queued_keyboard".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4066), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.input_event_response
    ///
    /// Time (ms) from the Input event being created to the end of it being handled
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram INPUT_EVENT_RESPONSE_MS.
    pub static input_event_response: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "input_event_response".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4067), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.input_event_response_coalesced
    ///
    /// Time (ms) from the Input event being created to the end of it being handled, but with overlapping events coalesced.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram INPUT_EVENT_RESPONSE_COALESCED_MS.
    pub static input_event_response_coalesced: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "input_event_response_coalesced".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4068), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.load_input_event_response
    ///
    /// Time (ms) from the Input event being created to the end of it being handled for events handling during page load only
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram LOAD_INPUT_EVENT_RESPONSE_MS.
    pub static load_input_event_response: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_input_event_response".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4069), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum LongReflowInterruptibleLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for LongReflowInterruptibleLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LongReflowInterruptibleLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from layout.long_reflow_interruptible
    ///
    /// Long running reflow, interruptible or not
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram LONG_REFLOW_INTERRUPTIBLE.
    pub static long_reflow_interruptible: Lazy<LabeledMetric<LabeledCounterMetric, LongReflowInterruptibleLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "long_reflow_interruptible".into(),
                    category: "layout".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4070), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.paint_rasterize_time
    ///
    /// Time spent rasterizing each frame in milliseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PAINT_RASTERIZE_TIME.
    pub static paint_rasterize_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "paint_rasterize_time".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4071), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.refresh_driver_chrome_frame_delay
    ///
    /// Delay in ms between the target and the actual handling time of the frame at refresh driver in the chrome process.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_REFRESH_DRIVER_CHROME_FRAME_DELAY_MS.
    pub static refresh_driver_chrome_frame_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "refresh_driver_chrome_frame_delay".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4072), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.refresh_driver_content_frame_delay
    ///
    /// Delay in ms between the target and the actual handling time of the frame at refresh driver in the content process.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_REFRESH_DRIVER_CONTENT_FRAME_DELAY_MS.
    pub static refresh_driver_content_frame_delay: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "refresh_driver_content_frame_delay".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4073), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.refresh_driver_tick
    ///
    /// Total time spent ticking the refresh driver in milliseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram REFRESH_DRIVER_TICK.
    pub static refresh_driver_tick: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "refresh_driver_tick".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4074), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from layout.time_to_first_interaction
    ///
    /// Time in milliseconds from the first non-blank paint to the creation time of the next click, key, mouse or scroll event per top-level content browsing context.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TIME_TO_FIRST_INTERACTION_MS.
    pub static time_to_first_interaction: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_first_interaction".into(),
                category: "layout".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4075), meta, TimeUnit::Millisecond)
    });

}
pub mod geckoview {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.content_process_lifetime
    ///
    /// The uptime of content processes. (Migrated from the geckoview metric of the same name).
    pub static content_process_lifetime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_process_lifetime".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4076), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.document_site_origins
    ///
    /// When a document is loaded, report the number of [site origins](https://searchfox.org/ mozilla-central/rev/ 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) of the entire browser if it has been at least 5 minutes since last time we collect this data. (Migrated from the geckoview metric of the same name).
    pub static document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "document_site_origins".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4077), meta, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_progress_time
    ///
    /// Time between page load progress starts (0) and completion (100). (Migrated from the geckoview metric of the same name).
    pub static page_load_progress_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load_progress_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4078), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_load_time
    ///
    /// The time taken to load a page. This includes all static contents, no dynamic content. Loading of about: pages is not counted. Back back navigation (sometimes via BFCache) is included which is a source of bimodality due to the <50ms load times. (Migrated from the geckoview metric of the same name).
    pub static page_load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_load_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4079), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.page_reload_time
    ///
    /// Time taken to reload a page. This includes all static contents, no dynamic content. Loading of about: pages is not counted. (Migrated from the geckoview metric of the same name).
    pub static page_reload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_reload_time".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4080), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.per_document_site_origins
    ///
    /// When a document is unloaded, report the highest number of [site origins](https://searchfox.org/ mozilla-central/rev/ 3300072e993ae05d50d5c63d815260367eaf9179/ caps/nsIPrincipal.idl#264) loaded simultaneously in that document. (Migrated from the geckoview metric of the same name).
    pub static per_document_site_origins: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "per_document_site_origins".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4081), meta, 0, 100, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from geckoview.startup_runtime
    ///
    /// The time taken to initialize GeckoRuntime. (Migrated from the geckoview metric of the same name).
    pub static startup_runtime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_runtime".into(),
                category: "geckoview".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4082), meta, TimeUnit::Millisecond)
    });

}
pub mod zero_byte_load {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadCssExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadCssExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_css
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#css.
    pub static load_css: Lazy<EventMetric<LoadCssExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_css".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4083), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadDtdExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadDtdExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_dtd
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#dtd.
    pub static load_dtd: Lazy<EventMetric<LoadDtdExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_dtd".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4084), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadFtlExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadFtlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_ftl
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#ftl.
    pub static load_ftl: Lazy<EventMetric<LoadFtlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_ftl".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4085), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadHtmlExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadHtmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_html
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#html.
    pub static load_html: Lazy<EventMetric<LoadHtmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_html".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4086), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadJsExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadJsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_js
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#js.
    pub static load_js: Lazy<EventMetric<LoadJsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_js".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4087), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadJsonExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadJsonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_json
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#json.
    pub static load_json: Lazy<EventMetric<LoadJsonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_json".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4088), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadOthersExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadOthersExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_others
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#others.
    pub static load_others: Lazy<EventMetric<LoadOthersExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_others".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4089), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadPngExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadPngExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_png
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#png.
    pub static load_png: Lazy<EventMetric<LoadPngExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_png".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4090), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadPropertiesExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadPropertiesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_properties
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#properties.
    pub static load_properties: Lazy<EventMetric<LoadPropertiesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_properties".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4091), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadSvgExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadSvgExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_svg
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#svg.
    pub static load_svg: Lazy<EventMetric<LoadSvgExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_svg".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4092), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadXhtmlExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadXhtmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_xhtml
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#xhtml.
    pub static load_xhtml: Lazy<EventMetric<LoadXhtmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_xhtml".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4093), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadXmlExtra {
        pub r#cancel_reason: Option<String>,
        pub r#cancelled: Option<bool>,
        pub r#file_name: Option<String>,
        pub r#status: Option<String>,
        pub r#sync: Option<bool>,
    }

    impl ExtraKeys for LoadXmlExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cancel_reason", "cancelled", "file_name", "status", "sync"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cancel_reason.and_then(|val| map.insert("cancel_reason".into(), val.to_string()));
          self.r#cancelled.and_then(|val| map.insert("cancelled".into(), val.to_string()));
          self.r#file_name.and_then(|val| map.insert("file_name".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from zero_byte_load.load_xml
    ///
    /// Collection of zero_byte_load events as part of the Yellow Screen of Death analysis. When a file is loaded synchronously, this event gets recorded in nsJARChannel::Open if the content length is zero. For asynchronous loads, this event gets recorded in onStopRequest. Note that when the load has been cancelled, the consumer could already receive some data, so this event also captures non-zero-byte loads. This event was generated to correspond to the Legacy Telemetry event zero_byte_load.load#xml.
    pub static load_xml: Lazy<EventMetric<LoadXmlExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_xml".into(),
                category: "zero_byte_load".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4094), meta)
    });

}
pub mod preferences {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from preferences.prefs_file_was_invalid
    ///
    /// Set to true if a failure occurred reading profile/prefs.js. This metric was generated to correspond to the Legacy Telemetry scalar preferences.prefs_file_was_invalid.
    pub static prefs_file_was_invalid: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_file_was_invalid".into(),
                category: "preferences".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4095), meta)
    });

        pub type UserPrefsObject = Vec<UserPrefsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct UserPrefsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub name: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub value: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from preferences.user_prefs
    ///
    /// The fossilized remains of the Legacy Telemetry Environment's
    /// `settings.userPrefs` structure.
    /// A list of pref names and values.
    /// Some values will be the string "<user-set>" to obscure the value.
    /// Do not add more prefs to this list.
    /// Prefer instead to instrument your prefs directly with individual metrics.
    /// See Environment.sys.mjs' `DEFAULT_ENVIRONMENT_PREFS`.
    pub static user_prefs: Lazy<ObjectMetric<UserPrefsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_prefs".into(),
                category: "preferences".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4096), meta)
    });

}
pub mod network {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CacheEntryCountLabel {
        ESmartsize = 0,
        EUserdefinedsize = 1,
        __Other__,
    }
    impl From<u16> for CacheEntryCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESmartsize,
                1 => Self::EUserdefinedsize,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CacheEntryCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESmartsize => "SMARTSIZE",
                Self::EUserdefinedsize => "USERDEFINEDSIZE",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cache_entry_count
    ///
    /// Number of entries in the cache keyed by cache capacity calculation type. Numbers are sampled periodically, every time 2GB of data is written to the cache.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_CACHE_ENTRY_COUNT.
    pub static cache_entry_count: Lazy<LabeledMetric<LabeledCustomDistributionMetric, CacheEntryCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cache_entry_count".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4097), meta, Some(vec![::std::borrow::Cow::from("SMARTSIZE"), ::std::borrow::Cow::from("USERDEFINEDSIZE")]))
    });

    #[repr(u16)]
    pub enum CacheEntryCountShareLabel {
        EUnknown = 0,
        EOther = 1,
        EJavascript = 2,
        EImage = 3,
        EMedia = 4,
        EStylesheet = 5,
        EWasm = 6,
        __Other__,
    }
    impl From<u16> for CacheEntryCountShareLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EOther,
                2 => Self::EJavascript,
                3 => Self::EImage,
                4 => Self::EMedia,
                5 => Self::EStylesheet,
                6 => Self::EWasm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CacheEntryCountShareLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "UNKNOWN",
                Self::EOther => "OTHER",
                Self::EJavascript => "JAVASCRIPT",
                Self::EImage => "IMAGE",
                Self::EMedia => "MEDIA",
                Self::EStylesheet => "STYLESHEET",
                Self::EWasm => "WASM",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cache_entry_count_share
    ///
    /// Percentage of the entries with the given content type. Numbers are sampled periodically, every time 2GB of data is written to the cache.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_CACHE_ENTRY_COUNT_SHARE.
    pub static cache_entry_count_share: Lazy<LabeledMetric<LabeledCustomDistributionMetric, CacheEntryCountShareLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cache_entry_count_share".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 99, bucket_count: 100, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4098), meta, Some(vec![::std::borrow::Cow::from("IMAGE"), ::std::borrow::Cow::from("JAVASCRIPT"), ::std::borrow::Cow::from("MEDIA"), ::std::borrow::Cow::from("OTHER"), ::std::borrow::Cow::from("STYLESHEET"), ::std::borrow::Cow::from("UNKNOWN"), ::std::borrow::Cow::from("WASM")]))
    });

    #[repr(u16)]
    pub enum CacheSizeLabel {
        ESmartsize = 0,
        EUserdefinedsize = 1,
        __Other__,
    }
    impl From<u16> for CacheSizeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESmartsize,
                1 => Self::EUserdefinedsize,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CacheSizeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESmartsize => "SMARTSIZE",
                Self::EUserdefinedsize => "USERDEFINEDSIZE",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cache_size
    ///
    /// Cache size in megabytes keyed by cache capacity calculation type. Numbers are sampled periodically, every time 2GB of data is written to the cache.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram NETWORK_CACHE_SIZE.
    pub static cache_size: Lazy<LabeledMetric<LabeledMemoryDistributionMetric, CacheSizeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::MemoryDistribution {
                cmd: CommonMetricData {
                    name: "cache_size".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: MemoryUnit::Megabyte};
        LabeledMetric::new(BaseMetricId(4099), meta, Some(vec![::std::borrow::Cow::from("SMARTSIZE"), ::std::borrow::Cow::from("USERDEFINEDSIZE")]))
    });

    #[repr(u16)]
    pub enum CacheSizeShareLabel {
        EUnknown = 0,
        EOther = 1,
        EJavascript = 2,
        EImage = 3,
        EMedia = 4,
        EStylesheet = 5,
        EWasm = 6,
        __Other__,
    }
    impl From<u16> for CacheSizeShareLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EOther,
                2 => Self::EJavascript,
                3 => Self::EImage,
                4 => Self::EMedia,
                5 => Self::EStylesheet,
                6 => Self::EWasm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CacheSizeShareLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "UNKNOWN",
                Self::EOther => "OTHER",
                Self::EJavascript => "JAVASCRIPT",
                Self::EImage => "IMAGE",
                Self::EMedia => "MEDIA",
                Self::EStylesheet => "STYLESHEET",
                Self::EWasm => "WASM",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cache_size_share
    ///
    /// Percentage of the cache size occupied by given content type. Numbers are sampled periodically, every time 2GB of data is written to the cache.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_CACHE_SIZE_SHARE.
    pub static cache_size_share: Lazy<LabeledMetric<LabeledCustomDistributionMetric, CacheSizeShareLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cache_size_share".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 99, bucket_count: 100, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4100), meta, Some(vec![::std::borrow::Cow::from("IMAGE"), ::std::borrow::Cow::from("JAVASCRIPT"), ::std::borrow::Cow::from("MEDIA"), ::std::borrow::Cow::from("OTHER"), ::std::borrow::Cow::from("STYLESHEET"), ::std::borrow::Cow::from("UNKNOWN"), ::std::borrow::Cow::from("WASM")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_v2_input_stream_status
    ///
    /// Final status of the CacheFileInputStream (0=ok, 1=other error, 2=out of memory, 3=disk full, 4=file corrupted, 5=file not found, 6=binding aborted)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_CACHE_V2_INPUT_STREAM_STATUS.
    pub static cache_v2_input_stream_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_v2_input_stream_status".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4101), meta, 0, 7, 8, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_v2_output_stream_status
    ///
    /// Final status of the CacheFileOutputStream (0=ok, 1=other error, 2=out of memory, 3=disk full, 4=file corrupted, 5=file not found, 6=binding aborted)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_CACHE_V2_OUTPUT_STREAM_STATUS.
    pub static cache_v2_output_stream_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_v2_output_stream_status".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4102), meta, 0, 7, 8, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.disk_cache2_shutdown_clear_private
    ///
    /// Time spent (ms) during shutdown deleting disk cache v2 for 'clear private data' option
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_DISK_CACHE2_SHUTDOWN_CLEAR_PRIVATE.
    pub static disk_cache2_shutdown_clear_private: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disk_cache2_shutdown_clear_private".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4103), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.disk_cache_shutdown_v2
    ///
    /// Total Time spent (ms) during disk cache shutdown [cache2]
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_DISK_CACHE_SHUTDOWN_V2.
    pub static disk_cache_shutdown_v2: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disk_cache_shutdown_v2".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4104), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.http_cache_entry_alive_time
    ///
    /// Time for which an HTTP cache entry is kept warmed in memory
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_CACHE_ENTRY_ALIVE_TIME.
    pub static http_cache_entry_alive_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_cache_entry_alive_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4105), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.http_cache_entry_reload_time
    ///
    /// Time before we reload an HTTP cache entry again to memory
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_CACHE_ENTRY_RELOAD_TIME.
    pub static http_cache_entry_reload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_cache_entry_reload_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4106), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.http_cache_entry_reuse_count
    ///
    /// Reuse count of an HTTP cache entry warmed in memory
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram HTTP_CACHE_ENTRY_REUSE_COUNT.
    pub static http_cache_entry_reuse_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_cache_entry_reuse_count".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4107), meta, 1, 20, 19, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.backgroundfilesaver_thread_count
    ///
    /// Maximum number of concurrent threads reached during a given download session
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram BACKGROUNDFILESAVER_THREAD_COUNT.
    pub static backgroundfilesaver_thread_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backgroundfilesaver_thread_count".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4108), meta, 0, 21, 22, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.id
    ///
    /// Network identification (0=None, 1=New Ipv4, 2=Same, 3=New IPv6, 4=New dual)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_ID2.
    pub static id: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "id".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4109), meta, 0, 6, 7, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum IdOnlineLabel {
        EAbsent = 0,
        EPresent = 1,
        __Other__,
    }
    impl From<u16> for IdOnlineLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAbsent,
                1 => Self::EPresent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IdOnlineLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAbsent => "absent",
                Self::EPresent => "present",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.id_online
    ///
    /// Network ID presence when the network connectivity checker reports that we have connectivity
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram NETWORK_ID_ONLINE.
    pub static id_online: Lazy<LabeledMetric<LabeledCounterMetric, IdOnlineLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "id_online".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4110), meta, Some(vec![::std::borrow::Cow::from("absent"), ::std::borrow::Cow::from("present")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.ipv4_and_ipv6_address_connectivity
    ///
    /// Count the number of 0) successful connections to an ipv4 address, 1) failed connection an ipv4 address, 2) successful connection to an ipv6 address and 3) failed connections to an ipv6 address.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram IPV4_AND_IPV6_ADDRESS_CONNECTIVITY.
    pub static ipv4_and_ipv6_address_connectivity: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ipv4_and_ipv6_address_connectivity".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4111), meta, 0, 4, 5, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum RelPreloadMissRatioLabel {
        ETypeScriptUsed = 0,
        ETypeScriptUnused = 1,
        ETypeStyleUsed = 2,
        ETypeStyleUnused = 3,
        ETypeImageUsed = 4,
        ETypeImageUnused = 5,
        ETypeFontUsed = 6,
        ETypeFontUnused = 7,
        ETypeFetchUsed = 8,
        ETypeFetchUnused = 9,
        __Other__,
    }
    impl From<u16> for RelPreloadMissRatioLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ETypeScriptUsed,
                1 => Self::ETypeScriptUnused,
                2 => Self::ETypeStyleUsed,
                3 => Self::ETypeStyleUnused,
                4 => Self::ETypeImageUsed,
                5 => Self::ETypeImageUnused,
                6 => Self::ETypeFontUsed,
                7 => Self::ETypeFontUnused,
                8 => Self::ETypeFetchUsed,
                9 => Self::ETypeFetchUnused,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RelPreloadMissRatioLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ETypeScriptUsed => "TYPE_SCRIPT_USED",
                Self::ETypeScriptUnused => "TYPE_SCRIPT_UNUSED",
                Self::ETypeStyleUsed => "TYPE_STYLE_USED",
                Self::ETypeStyleUnused => "TYPE_STYLE_UNUSED",
                Self::ETypeImageUsed => "TYPE_IMAGE_USED",
                Self::ETypeImageUnused => "TYPE_IMAGE_UNUSED",
                Self::ETypeFontUsed => "TYPE_FONT_USED",
                Self::ETypeFontUnused => "TYPE_FONT_UNUSED",
                Self::ETypeFetchUsed => "TYPE_FETCH_USED",
                Self::ETypeFetchUnused => "TYPE_FETCH_UNUSED",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.rel_preload_miss_ratio
    ///
    /// Ratio of used and unused resources preloaded with link rel=preload tag or response header, broken down by supported resource type.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram REL_PRELOAD_MISS_RATIO.
    pub static rel_preload_miss_ratio: Lazy<LabeledMetric<LabeledCounterMetric, RelPreloadMissRatioLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "rel_preload_miss_ratio".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4112), meta, Some(vec![::std::borrow::Cow::from("TYPE_FETCH_UNUSED"), ::std::borrow::Cow::from("TYPE_FETCH_USED"), ::std::borrow::Cow::from("TYPE_FONT_UNUSED"), ::std::borrow::Cow::from("TYPE_FONT_USED"), ::std::borrow::Cow::from("TYPE_IMAGE_UNUSED"), ::std::borrow::Cow::from("TYPE_IMAGE_USED"), ::std::borrow::Cow::from("TYPE_SCRIPT_UNUSED"), ::std::borrow::Cow::from("TYPE_SCRIPT_USED"), ::std::borrow::Cow::from("TYPE_STYLE_UNUSED"), ::std::borrow::Cow::from("TYPE_STYLE_USED")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.alpn_mismatch_count
    ///
    /// Counts the number of times we encountered a mismatched ALPN token and needed to reset the connection. Keyed by the negotiated NPN.
    pub static alpn_mismatch_count: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "alpn_mismatch_count".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4113), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.async_open_child_to_transaction_pending_exp
    ///
    /// The time spent from HttpChannelChild::AsyncOpen to adding the transactionto the nsHttpConnectionMgr, in milliseconds, keyed by the classOfService flags
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_ASYNC_OPEN_CHILD_TO_TRANSACTION_PENDING_EXP_MS.
    pub static async_open_child_to_transaction_pending_exp: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "async_open_child_to_transaction_pending_exp".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4114), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.back_pressure_suspension_cp_type
    ///
    /// Collect the content policy when the resource is non-local and suspended by back pressure (0-44 from nsContentPolicyType in nsIContentPolicy.idl).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NETWORK_BACK_PRESSURE_SUSPENSION_CP_TYPE.
    pub static back_pressure_suspension_cp_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "back_pressure_suspension_cp_type".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4115), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.back_pressure_suspension_delay_time
    ///
    /// The delay caused by the e10s back pressure suspension(ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_BACK_PRESSURE_SUSPENSION_DELAY_TIME_MS.
    pub static back_pressure_suspension_delay_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "back_pressure_suspension_delay_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4116), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum BackPressureSuspensionRateLabel {
        ESuspended = 0,
        ENotsuspended = 1,
        ESuspendedlocal = 2,
        ENotsuspendedlocal = 3,
        __Other__,
    }
    impl From<u16> for BackPressureSuspensionRateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuspended,
                1 => Self::ENotsuspended,
                2 => Self::ESuspendedlocal,
                3 => Self::ENotsuspendedlocal,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BackPressureSuspensionRateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuspended => "Suspended",
                Self::ENotsuspended => "NotSuspended",
                Self::ESuspendedlocal => "SuspendedLocal",
                Self::ENotsuspendedlocal => "NotSuspendedLocal",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.back_pressure_suspension_rate
    ///
    /// Collect whether the resource is suspended by back pressure. And split by local-ness.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram NETWORK_BACK_PRESSURE_SUSPENSION_RATE_V2.
    pub static back_pressure_suspension_rate: Lazy<LabeledMetric<LabeledCounterMetric, BackPressureSuspensionRateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "back_pressure_suspension_rate".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4117), meta, Some(vec![::std::borrow::Cow::from("NotSuspended"), ::std::borrow::Cow::from("NotSuspendedLocal"), ::std::borrow::Cow::from("Suspended"), ::std::borrow::Cow::from("SuspendedLocal")]))
    });

    #[repr(u16)]
    pub enum ByteRangeRequestLabel {
        ECacheable = 0,
        ENotCacheable = 1,
        __Other__,
    }
    impl From<u16> for ByteRangeRequestLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECacheable,
                1 => Self::ENotCacheable,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ByteRangeRequestLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECacheable => "cacheable",
                Self::ENotCacheable => "not_cacheable",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.byte_range_request
    ///
    /// Counts of cacheable/non-cacheable byte-range requests
    pub static byte_range_request: Lazy<LabeledMetric<LabeledCounterMetric, ByteRangeRequestLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "byte_range_request".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4118), meta, Some(vec![::std::borrow::Cow::from("cacheable"), ::std::borrow::Cow::from("not_cacheable")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_hit_miss_stat_per_cache_size
    ///
    /// Hit/Miss count split by cache size in file count Hit 0-5000, Miss 0-5000, Hit 5001-10000, ...
    pub static cache_hit_miss_stat_per_cache_size: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cache_hit_miss_stat_per_cache_size".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4119), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_hit_rate_per_cache_size
    ///
    /// Hit rate for a specific cache size in file count. The hit rate is split into 20 buckets. The key is the cacheSize (20 buckets) and the value is between 0 and 100.
    pub static cache_hit_rate_per_cache_size: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "cache_hit_rate_per_cache_size".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 100, bucket_count: 20, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4120), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_hit_time
    ///
    /// Time to open existing cache entry file. (Migrated from the geckoview metric of the same name).
    pub static cache_hit_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_hit_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4121), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_miss_time
    ///
    /// Time spent to find out a cache entry file is missing. (Migrated from the geckoview metric of the same name).
    pub static cache_miss_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_miss_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4122), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.cache_read_time
    ///
    /// In the HTTP page channel, time from connection cache read start to cache read end. Corresponds to Legacy histogram HTTP_PAGE_CACHE_READ_TIME_V2 in Desktop.
    pub static cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cache_read_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4123), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load
    ///
    /// In the HTTP page channel, time from connection open to complete load (cache read end/until the last byte received) Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_V2 in Desktop.
    pub static complete_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4124), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load_cached
    ///
    /// In the HTTP page channel, time from connection open to cache read end. Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_CACHED_V2 in Desktop.
    pub static complete_load_cached: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load_cached".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4125), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.complete_load_net
    ///
    /// In the HTTP page channel, time from connection open to the last byte received. Corresponds to Legacy histogram HTTP_PAGE_COMPLETE_LOAD_NET_V2 in Desktop.
    pub static complete_load_net: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "complete_load_net".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4126), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum CorsAuthorizationHeaderLabel {
        EAllowed = 0,
        EDisallowed = 1,
        ECoveredByWildcard = 2,
        __Other__,
    }
    impl From<u16> for CorsAuthorizationHeaderLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAllowed,
                1 => Self::EDisallowed,
                2 => Self::ECoveredByWildcard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CorsAuthorizationHeaderLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAllowed => "allowed",
                Self::EDisallowed => "disallowed",
                Self::ECoveredByWildcard => "covered_by_wildcard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.cors_authorization_header
    ///
    /// Count how many times we see `Authorization` header in `Access-Control-Request-Headers` header and the possible outcomes.
    pub static cors_authorization_header: Lazy<LabeledMetric<LabeledCounterMetric, CorsAuthorizationHeaderLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cors_authorization_header".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4127), meta, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("covered_by_wildcard"), ::std::borrow::Cow::from("disallowed")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_end
    ///
    /// In the HTTP page channel, time from the DNS request being issued to the response. Corresponds to Legacy histogram HTTP_PAGE_DNS_LOOKUP_TIME in Desktop. (Migrated from the geckoview metric of the same name).
    pub static dns_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4128), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_end_to_connect_start_exp
    ///
    /// The time spent from dns resolution to connect start, in milliseconds, keyed by protocol version and the classOfService flags
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_DNS_END_TO_CONNECT_START_EXP_MS.
    pub static dns_end_to_connect_start_exp: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "dns_end_to_connect_start_exp".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4129), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.dns_start
    ///
    /// In the HTTP page channel, time from connection open to the DNS request being issued. Corresponds to Legacy histogram HTTP_PAGE_DNS_ISSUE_TIME in Desktop. (Migrated from the geckoview metric of the same name).
    pub static dns_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_start".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4130), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.first_from_cache
    ///
    /// In the HTTP page channel, time from connection open to cache read start. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_FROM_CACHE_V2 in Desktop.
    pub static first_from_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_from_cache".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4131), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.first_sent_to_last_received
    ///
    /// In the HTTP page channel, time from first byte of request sent to the last byte received. Corresponds to Legacy histogram HTTP_PAGE_FIRST_SENT_TO_LAST_RECEIVED in Desktop. (Migrated from the geckoview metric of the same name).
    pub static first_sent_to_last_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_sent_to_last_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4132), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.font_download_end
    ///
    /// Time after navigationStart that all webfont downloads are completed. (Migrated from the geckoview metric of the same name).
    pub static font_download_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_download_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4133), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum Http3CompleteLoadLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3CompleteLoadLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3CompleteLoadLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_complete_load
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub, supports_http3_page, supports_http3_sub), overall load time
    pub static http3_complete_load: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3CompleteLoadLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_complete_load".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4134), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3FirstSentToLastReceivedLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3FirstSentToLastReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3FirstSentToLastReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_first_sent_to_last_received
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub, supports_http3_page, supports_http3_sub), time from first byte of request sent to last byte of response received
    pub static http3_first_sent_to_last_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3FirstSentToLastReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_first_sent_to_last_received".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4135), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3OpenToFirstReceivedLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3OpenToFirstReceivedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3OpenToFirstReceivedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_open_to_first_received
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub, supports_http3_page, supports_http3_sub), time from open to first byte of reply received
    pub static http3_open_to_first_received: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3OpenToFirstReceivedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_open_to_first_received".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4136), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3OpenToFirstSentLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3OpenToFirstSentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3OpenToFirstSentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_open_to_first_sent
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub, supports_http3_page, supports_http3_sub), time from open to first byte of request
    pub static http3_open_to_first_sent: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3OpenToFirstSentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_open_to_first_sent".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4137), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum Http3TlsHandshakeLabel {
        EUsesHttp3Page = 0,
        EUsesHttp3Sub = 1,
        ESupportsHttp3Page = 2,
        ESupportsHttp3Sub = 3,
        __Other__,
    }
    impl From<u16> for Http3TlsHandshakeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsesHttp3Page,
                1 => Self::EUsesHttp3Sub,
                2 => Self::ESupportsHttp3Page,
                3 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3TlsHandshakeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsesHttp3Page => "uses_http3_page",
                Self::EUsesHttp3Sub => "uses_http3_sub",
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http3_tls_handshake
    ///
    /// In the HTTP channel (keys: uses_http3_page, uses_http3_sub, supports_http3_page, supports_http3_sub), time from secure connection start (after TCP SYN) to ready for HTTP
    pub static http3_tls_handshake: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3TlsHandshakeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_tls_handshake".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4138), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub"), ::std::borrow::Cow::from("uses_http3_page"), ::std::borrow::Cow::from("uses_http3_sub")]))
    });

    #[repr(u16)]
    pub enum HttpFetchDurationLabel {
        EH3Cloudflare = 0,
        EH3Others = 1,
        EH2Cloudflare = 2,
        EH2Others = 3,
        EH1Cloudflare = 4,
        EH1Others = 5,
        __Other__,
    }
    impl From<u16> for HttpFetchDurationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EH3Cloudflare,
                1 => Self::EH3Others,
                2 => Self::EH2Cloudflare,
                3 => Self::EH2Others,
                4 => Self::EH1Cloudflare,
                5 => Self::EH1Others,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HttpFetchDurationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EH3Cloudflare => "h3_cloudflare",
                Self::EH3Others => "h3_others",
                Self::EH2Cloudflare => "h2_cloudflare",
                Self::EH2Others => "h2_others",
                Self::EH1Cloudflare => "h1_cloudflare",
                Self::EH1Others => "h1_others",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.http_fetch_duration
    ///
    /// The time between requestStart and responseEnd, keyed by the server header
    pub static http_fetch_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, HttpFetchDurationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http_fetch_duration".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4139), meta, Some(vec![::std::borrow::Cow::from("h1_cloudflare"), ::std::borrow::Cow::from("h1_others"), ::std::borrow::Cow::from("h2_cloudflare"), ::std::borrow::Cow::from("h2_others"), ::std::borrow::Cow::from("h3_cloudflare"), ::std::borrow::Cow::from("h3_others")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.http_revalidation
    ///
    /// In the HTTP page channel, time for positive cache validation Corresponds to Legacy histogram HTTP_PAGE_REVALIDATION in Desktop.
    pub static http_revalidation: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "http_revalidation".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4140), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.open_to_first_received
    ///
    /// In the HTTP subitem channel,time from connection open to the first byte received. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_RECEIVED in Desktop. (Migrated from the geckoview metric of the same name).
    pub static open_to_first_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_first_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4141), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.open_to_first_sent
    ///
    /// In the HTTP page channel, time from connection open to the first byte of requst sent. Corresponds to Legacy histogram HTTP_PAGE_OPEN_TO_FIRST_SENT in Desktop. (Migrated from the geckoview metric of the same name).
    pub static open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_first_sent".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4142), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_bandwidth_not_race
    ///
    /// Amount of bytes received when we decide not to race cache with network.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RACE_CACHE_BANDWIDTH_NOT_RACE.
    pub static race_cache_bandwidth_not_race: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "race_cache_bandwidth_not_race".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4143), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_bandwidth_race_cache_win
    ///
    /// Amount of bytes received when we decide to race cache with network and cache wins.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RACE_CACHE_BANDWIDTH_RACE_CACHE_WIN.
    pub static race_cache_bandwidth_race_cache_win: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "race_cache_bandwidth_race_cache_win".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4144), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_bandwidth_race_network_win
    ///
    /// Amount of bytes received when we decide to race cache with network and network wins.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RACE_CACHE_BANDWIDTH_RACE_NETWORK_WIN.
    pub static race_cache_bandwidth_race_network_win: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "race_cache_bandwidth_race_network_win".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4145), meta, MemoryUnit::Byte)
    });

    #[repr(u16)]
    pub enum RaceCacheValidationLabel {
        ENotsent = 0,
        ECachedcontentused = 1,
        ECachedcontentnotused = 2,
        __Other__,
    }
    impl From<u16> for RaceCacheValidationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotsent,
                1 => Self::ECachedcontentused,
                2 => Self::ECachedcontentnotused,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RaceCacheValidationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotsent => "NotSent",
                Self::ECachedcontentused => "CachedContentUsed",
                Self::ECachedcontentnotused => "CachedContentNotUsed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_validation
    ///
    /// Stats for validation requests when cache won the race.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram NETWORK_RACE_CACHE_VALIDATION.
    pub static race_cache_validation: Lazy<LabeledMetric<LabeledCounterMetric, RaceCacheValidationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "race_cache_validation".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4146), meta, Some(vec![::std::borrow::Cow::from("CachedContentNotUsed"), ::std::borrow::Cow::from("CachedContentUsed"), ::std::borrow::Cow::from("NotSent")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_with_network_ocec_on_start_diff
    ///
    /// Time in milliseconds between onStartRequest from the cache and onCacheEntryCheck. Report only when net wins and OCEC is before onStartRequest from net.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram NETWORK_RACE_CACHE_WITH_NETWORK_OCEC_ON_START_DIFF.
    pub static race_cache_with_network_ocec_on_start_diff: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "race_cache_with_network_ocec_on_start_diff".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4147), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_with_network_saved_time
    ///
    /// Time in milliseconds that we saved when we race cache with network.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RACE_CACHE_WITH_NETWORK_SAVED_TIME.
    pub static race_cache_with_network_saved_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "race_cache_with_network_saved_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4148), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum RaceCacheWithNetworkUsageLabel {
        ENetworknorace = 0,
        ECachenorace = 1,
        ENetworkrace = 2,
        ECacherace = 3,
        ENetworkdelayedrace = 4,
        ECachedelayedrace = 5,
        __Other__,
    }
    impl From<u16> for RaceCacheWithNetworkUsageLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENetworknorace,
                1 => Self::ECachenorace,
                2 => Self::ENetworkrace,
                3 => Self::ECacherace,
                4 => Self::ENetworkdelayedrace,
                5 => Self::ECachedelayedrace,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RaceCacheWithNetworkUsageLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENetworknorace => "NetworkNoRace",
                Self::ECachenorace => "CacheNoRace",
                Self::ENetworkrace => "NetworkRace",
                Self::ECacherace => "CacheRace",
                Self::ENetworkdelayedrace => "NetworkDelayedRace",
                Self::ECachedelayedrace => "CacheDelayedRace",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.race_cache_with_network_usage
    ///
    /// Whether we raced network with the cache.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram NETWORK_RACE_CACHE_WITH_NETWORK_USAGE_2.
    pub static race_cache_with_network_usage: Lazy<LabeledMetric<LabeledCounterMetric, RaceCacheWithNetworkUsageLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "race_cache_with_network_usage".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4149), meta, Some(vec![::std::borrow::Cow::from("CacheDelayedRace"), ::std::borrow::Cow::from("CacheNoRace"), ::std::borrow::Cow::from("CacheRace"), ::std::borrow::Cow::from("NetworkDelayedRace"), ::std::borrow::Cow::from("NetworkNoRace"), ::std::borrow::Cow::from("NetworkRace")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.response_end_parent_to_content
    ///
    /// The time spent relaying response completion from the socket thread of the parent process to the content process, in milliseconds, keyed by the classOfService flags
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RESPONSE_END_PARENT_TO_CONTENT_MS.
    pub static response_end_parent_to_content: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "response_end_parent_to_content".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4150), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.response_start_parent_to_content_exp
    ///
    /// The time spent relaying response start from the socket thread of the parent process to the content process, in milliseconds, keyed by the classOfService flags
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NETWORK_RESPONSE_START_PARENT_TO_CONTENT_EXP_MS.
    pub static response_start_parent_to_content_exp: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "response_start_parent_to_content_exp".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4151), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_cache_read_time
    ///
    /// In the HTTP subitem channel, time from connection cache read start to cache read end. Corresponds to Legacy histogram HTTP_SUB_CACHE_READ_TIME_V2 in Desktop.
    pub static sub_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_cache_read_time".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4152), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load
    ///
    /// In the HTTP subitem channel, time from connection open to complete load (cache read end/until the last byte received) Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_V2 in Desktop.
    pub static sub_complete_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4153), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load_cached
    ///
    /// In the HTTP subitem channel, time from connection open to cache read end. Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_CACHED_V2 in Desktop.
    pub static sub_complete_load_cached: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load_cached".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4154), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_complete_load_net
    ///
    /// In the HTTP subitem channel, time from connection open to the last byte received. Corresponds to Legacy histogram HTTP_SUB_COMPLETE_LOAD_NET_V2 in Desktop.
    pub static sub_complete_load_net: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_complete_load_net".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4155), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_dns_end
    ///
    /// In the HTTP subitem channel, time from the DNS request being issued to the response. Corresponds to Legacy histogram HTTP_SUB_DNS_LOOKUP_TIME in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_dns_end: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_dns_end".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4156), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_dns_start
    ///
    /// In the HTTP subitem channel, time from connection open to the DNS request being issued. Corresponds to Legacy histogram HTTP_SUB_DNS_ISSUE_TIME in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_dns_start: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_dns_start".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4157), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_first_from_cache
    ///
    /// In the HTTP subitem channel, time from connection open to cache read start. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_FROM_CACHE_V2 in Desktop.
    pub static sub_first_from_cache: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_first_from_cache".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4158), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_first_sent_to_last_received
    ///
    /// In the HTTP subitem channel, time from first byte of request sent to the last byte received. Corresponds to Legacy histogram HTTP_SUB_FIRST_SENT_TO_LAST_RECEIVED in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_first_sent_to_last_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_first_sent_to_last_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4159), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_http_revalidation
    ///
    /// In the HTTP subitem channel, time for positive cache validation Corresponds to Legacy histogram HTTP_SUB_REVALIDATION in Desktop.
    pub static sub_http_revalidation: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_http_revalidation".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4160), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_open_to_first_received
    ///
    /// In the HTTP subitem channel, time from connection open to the first byte received. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_RECEIVED in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_open_to_first_received: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_open_to_first_received".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4161), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_open_to_first_sent
    ///
    /// In the HTTP subitem channel, time from connection open to the first byte of requst sent. Corresponds to Legacy histogram HTTP_SUB_OPEN_TO_FIRST_SENT in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_open_to_first_sent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_open_to_first_sent".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4162), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_tcp_connection
    ///
    /// In the HTTP subitem channel, time from the TCP SYN packet is received to the connection is established and ready for HTTP. Corresponds to Legacy histogram HTTP_SUB_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of the same name).
    pub static sub_tcp_connection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_tcp_connection".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4163), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sub_tls_handshake
    ///
    /// In the HTTP subitem channel, time from after the TCP SYN packet is received to the secure connection is established and ready for HTTP. Corresponds to Legacy histogram HTTP_SUB_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview metric of the same name).
    pub static sub_tls_handshake: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sub_tls_handshake".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4164), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SupHttp3TcpConnectionLabel {
        ESupportsHttp3Page = 0,
        ESupportsHttp3Sub = 1,
        __Other__,
    }
    impl From<u16> for SupHttp3TcpConnectionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESupportsHttp3Page,
                1 => Self::ESupportsHttp3Sub,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SupHttp3TcpConnectionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESupportsHttp3Page => "supports_http3_page",
                Self::ESupportsHttp3Sub => "supports_http3_sub",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.sup_http3_tcp_connection
    ///
    /// In the HTTP channel (keys: supports_http3_page, supports_http3_sub), time from TCP SYN to ready for HTTP
    pub static sup_http3_tcp_connection: Lazy<LabeledMetric<LabeledTimingDistributionMetric, SupHttp3TcpConnectionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "sup_http3_tcp_connection".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4165), meta, Some(vec![::std::borrow::Cow::from("supports_http3_page"), ::std::borrow::Cow::from("supports_http3_sub")]))
    });

    #[repr(u16)]
    pub enum SystemChannelAddonStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelAddonStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelAddonStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_addon_status
    ///
    /// Counts the status of succeeded and failed requests to addons.mozilla.org
    pub static system_channel_addon_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelAddonStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_addon_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4166), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelAddonversionStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelAddonversionStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelAddonversionStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_addonversion_status
    ///
    /// Counts the status of succeeded and failed requests to *.addons.mozilla.org
    pub static system_channel_addonversion_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelAddonversionStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_addonversion_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4167), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelOtherStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelOtherStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelOtherStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_other_status
    ///
    /// Counts the status of succeeded and failed requests to other mozilla.org domains
    pub static system_channel_other_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelOtherStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_other_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4168), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelRemoteSettingsStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelRemoteSettingsStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelRemoteSettingsStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_remote_settings_status
    ///
    /// Counts the status of succeeded and failed requests to firefox.settings.services.mozilla.com
    pub static system_channel_remote_settings_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelRemoteSettingsStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_remote_settings_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4169), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelSuccessOrFailureLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelSuccessOrFailureLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelSuccessOrFailureLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_success_or_failure
    ///
    /// Counts the number of succeeded and failed channels with a system principal to a mozilla domain. Label contains ok or failure reason.
    pub static system_channel_success_or_failure: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelSuccessOrFailureLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_success_or_failure".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4170), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelTelemetryStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelTelemetryStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelTelemetryStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_telemetry_status
    ///
    /// Counts the status of succeeded and failed requests to incoming.telemetry.mozilla.org
    pub static system_channel_telemetry_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelTelemetryStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_telemetry_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4171), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[repr(u16)]
    pub enum SystemChannelUpdateStatusLabel {
        EOk = 0,
        EOffline = 1,
        EConnectivity = 2,
        EDns = 3,
        EConnectFail = 4,
        ETlsFail = 5,
        EHttpStatus = 6,
        ECancel = 7,
        ETimeout = 8,
        EReset = 9,
        ERefused = 10,
        EPartial = 11,
        EOther = 12,
        __Other__,
    }
    impl From<u16> for SystemChannelUpdateStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOk,
                1 => Self::EOffline,
                2 => Self::EConnectivity,
                3 => Self::EDns,
                4 => Self::EConnectFail,
                5 => Self::ETlsFail,
                6 => Self::EHttpStatus,
                7 => Self::ECancel,
                8 => Self::ETimeout,
                9 => Self::EReset,
                10 => Self::ERefused,
                11 => Self::EPartial,
                12 => Self::EOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SystemChannelUpdateStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOk => "ok",
                Self::EOffline => "offline",
                Self::EConnectivity => "connectivity",
                Self::EDns => "dns",
                Self::EConnectFail => "connect_fail",
                Self::ETlsFail => "tls_fail",
                Self::EHttpStatus => "http_status",
                Self::ECancel => "cancel",
                Self::ETimeout => "timeout",
                Self::EReset => "reset",
                Self::ERefused => "refused",
                Self::EPartial => "partial",
                Self::EOther => "other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.system_channel_update_status
    ///
    /// Counts the status of succeeded and failed requests to aus5.mozilla.org
    pub static system_channel_update_status: Lazy<LabeledMetric<LabeledCounterMetric, SystemChannelUpdateStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "system_channel_update_status".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4172), meta, Some(vec![::std::borrow::Cow::from("cancel"), ::std::borrow::Cow::from("connect_fail"), ::std::borrow::Cow::from("connectivity"), ::std::borrow::Cow::from("dns"), ::std::borrow::Cow::from("http_status"), ::std::borrow::Cow::from("offline"), ::std::borrow::Cow::from("ok"), ::std::borrow::Cow::from("other"), ::std::borrow::Cow::from("partial"), ::std::borrow::Cow::from("refused"), ::std::borrow::Cow::from("reset"), ::std::borrow::Cow::from("timeout"), ::std::borrow::Cow::from("tls_fail")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tcp_connection
    ///
    /// In the HTTP page channel, time from the TCP SYN packet is received to the connection is established and ready for HTTP. Corresponds to Legacy histogram HTTP_PAGE_TCP_CONNECTION_2 in Desktop (Migrated from the geckoview metric of the same name).
    pub static tcp_connection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tcp_connection".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4173), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TlsEarlyDataAcceptedLabel {
        EAccepted = 0,
        ERejected = 1,
        __Other__,
    }
    impl From<u16> for TlsEarlyDataAcceptedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAccepted,
                1 => Self::ERejected,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TlsEarlyDataAcceptedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAccepted => "accepted",
                Self::ERejected => "rejected",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_accepted
    ///
    /// TLS early data was used and it was accepted or rejected by the remote host.
    pub static tls_early_data_accepted: Lazy<LabeledMetric<LabeledCounterMetric, TlsEarlyDataAcceptedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tls_early_data_accepted".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4174), meta, Some(vec![::std::borrow::Cow::from("accepted"), ::std::borrow::Cow::from("rejected")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_bytes_written
    ///
    /// Amount of bytes sent using TLS early data at the start of a TLS connection for a given channel.
    pub static tls_early_data_bytes_written: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_early_data_bytes_written".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4175), meta, 0, 60000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum TlsEarlyDataNegotiatedLabel {
        ENotAvailable = 0,
        EAvailableAndUsed = 1,
        EAvailableButNotUsed = 2,
        __Other__,
    }
    impl From<u16> for TlsEarlyDataNegotiatedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotAvailable,
                1 => Self::EAvailableAndUsed,
                2 => Self::EAvailableButNotUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TlsEarlyDataNegotiatedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotAvailable => "not_available",
                Self::EAvailableAndUsed => "available_and_used",
                Self::EAvailableButNotUsed => "available_but_not_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.tls_early_data_negotiated
    ///
    /// Sending TLS early data was not possible, possible and used, or possible but not used.
    pub static tls_early_data_negotiated: Lazy<LabeledMetric<LabeledCounterMetric, TlsEarlyDataNegotiatedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tls_early_data_negotiated".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4176), meta, Some(vec![::std::borrow::Cow::from("available_and_used"), ::std::borrow::Cow::from("available_but_not_used"), ::std::borrow::Cow::from("not_available")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.tls_handshake
    ///
    /// In the HTTP page channel, time from after the TCP SYN packet is received to the secure connection is established and ready for HTTP. Corresponds to Legacy histogram HTTP_PAGE_TLS_HANDSHAKE in Desktop. (Migrated from the geckoview metric of the same name).
    pub static tls_handshake: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_handshake".into(),
                category: "network".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4177), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TrrIdleCloseTimeH1Label {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrIdleCloseTimeH1Label {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrIdleCloseTimeH1Label {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.trr_idle_close_time_h1
    ///
    /// Time (in seconds) that it takes for an idle TRR connection to be closed by the server (HTTP/1.1)
    pub static trr_idle_close_time_h1: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrIdleCloseTimeH1Label>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_idle_close_time_h1".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Second};
        LabeledMetric::new(BaseMetricId(4178), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrIdleCloseTimeH2Label {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrIdleCloseTimeH2Label {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrIdleCloseTimeH2Label {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.trr_idle_close_time_h2
    ///
    /// Time (in seconds) that it takes for an idle TRR connection to be closed by the server (HTTP/2)
    pub static trr_idle_close_time_h2: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrIdleCloseTimeH2Label>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_idle_close_time_h2".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Second};
        LabeledMetric::new(BaseMetricId(4179), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

    #[repr(u16)]
    pub enum TrrIdleCloseTimeH3Label {
        EMozillaCloudflareDnsCom = 0,
        EFirefoxDnsNextdnsIo = 1,
        EPrivateCanadianshieldCiraCa = 2,
        EDohXfinityCom = 3,
        EDnsShawCa = 4,
        EDoohCloudflareDnsCom = 5,
        EMozillaCloudflareDnsCom2 = 6,
        EFirefoxDnsNextdnsIo2 = 7,
        EPrivateCanadianshieldCiraCa2 = 8,
        EDohXfinityCom2 = 9,
        EDnsShawCa2 = 10,
        EDoohCloudflareDnsCom2 = 11,
        EMozillaCloudflareDnsCom3 = 12,
        EFirefoxDnsNextdnsIo3 = 13,
        EPrivateCanadianshieldCiraCa3 = 14,
        EDohXfinityCom3 = 15,
        EDnsShawCa3 = 16,
        EDoohCloudflareDnsCom3 = 17,
        __Other__,
    }
    impl From<u16> for TrrIdleCloseTimeH3Label {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMozillaCloudflareDnsCom,
                1 => Self::EFirefoxDnsNextdnsIo,
                2 => Self::EPrivateCanadianshieldCiraCa,
                3 => Self::EDohXfinityCom,
                4 => Self::EDnsShawCa,
                5 => Self::EDoohCloudflareDnsCom,
                6 => Self::EMozillaCloudflareDnsCom2,
                7 => Self::EFirefoxDnsNextdnsIo2,
                8 => Self::EPrivateCanadianshieldCiraCa2,
                9 => Self::EDohXfinityCom2,
                10 => Self::EDnsShawCa2,
                11 => Self::EDoohCloudflareDnsCom2,
                12 => Self::EMozillaCloudflareDnsCom3,
                13 => Self::EFirefoxDnsNextdnsIo3,
                14 => Self::EPrivateCanadianshieldCiraCa3,
                15 => Self::EDohXfinityCom3,
                16 => Self::EDnsShawCa3,
                17 => Self::EDoohCloudflareDnsCom3,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrrIdleCloseTimeH3Label {
        fn into(self) -> &'static str {
            match self {
                Self::EMozillaCloudflareDnsCom => "mozilla.cloudflare-dns.com",
                Self::EFirefoxDnsNextdnsIo => "firefox.dns.nextdns.io",
                Self::EPrivateCanadianshieldCiraCa => "private.canadianshield.cira.ca",
                Self::EDohXfinityCom => "doh.xfinity.com",
                Self::EDnsShawCa => "dns.shaw.ca",
                Self::EDoohCloudflareDnsCom => "dooh.cloudflare-dns.com",
                Self::EMozillaCloudflareDnsCom2 => "mozilla.cloudflare-dns.com_2",
                Self::EFirefoxDnsNextdnsIo2 => "firefox.dns.nextdns.io_2",
                Self::EPrivateCanadianshieldCiraCa2 => "private.canadianshield.cira.ca_2",
                Self::EDohXfinityCom2 => "doh.xfinity.com_2",
                Self::EDnsShawCa2 => "dns.shaw.ca_2",
                Self::EDoohCloudflareDnsCom2 => "dooh.cloudflare-dns.com_2",
                Self::EMozillaCloudflareDnsCom3 => "mozilla.cloudflare-dns.com_3",
                Self::EFirefoxDnsNextdnsIo3 => "firefox.dns.nextdns.io_3",
                Self::EPrivateCanadianshieldCiraCa3 => "private.canadianshield.cira.ca_3",
                Self::EDohXfinityCom3 => "doh.xfinity.com_3",
                Self::EDnsShawCa3 => "dns.shaw.ca_3",
                Self::EDoohCloudflareDnsCom3 => "dooh.cloudflare-dns.com_3",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.trr_idle_close_time_h3
    ///
    /// Time (in seconds) that it takes for an idle TRR connection to be closed by the server (HTTP/3)
    pub static trr_idle_close_time_h3: Lazy<LabeledMetric<LabeledTimingDistributionMetric, TrrIdleCloseTimeH3Label>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_idle_close_time_h3".into(),
                    category: "network".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Second};
        LabeledMetric::new(BaseMetricId(4180), meta, Some(vec![::std::borrow::Cow::from("dns.shaw.ca"), ::std::borrow::Cow::from("dns.shaw.ca_2"), ::std::borrow::Cow::from("dns.shaw.ca_3"), ::std::borrow::Cow::from("doh.xfinity.com"), ::std::borrow::Cow::from("doh.xfinity.com_2"), ::std::borrow::Cow::from("doh.xfinity.com_3"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_2"), ::std::borrow::Cow::from("dooh.cloudflare-dns.com_3"), ::std::borrow::Cow::from("firefox.dns.nextdns.io"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_2"), ::std::borrow::Cow::from("firefox.dns.nextdns.io_3"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_2"), ::std::borrow::Cow::from("mozilla.cloudflare-dns.com_3"), ::std::borrow::Cow::from("private.canadianshield.cira.ca"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_2"), ::std::borrow::Cow::from("private.canadianshield.cira.ca_3")]))
    });

}
pub mod dns {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dns.blocklist_count
    ///
    /// The number of unusable addresses reported for each record
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram DNS_BLACKLIST_COUNT.
    pub static blocklist_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blocklist_count".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4181), meta, 1, 21, 20, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.by_type_cleanup_age
    ///
    /// DNS Cache Entry Age for by-type queries at Removal Time (minutes)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_BY_TYPE_CLEANUP_AGE.
    pub static by_type_cleanup_age: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "by_type_cleanup_age".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4182), meta, TimeUnit::Minute)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.by_type_failed_lookup_time
    ///
    /// Time for a completed by-type resolution that has a negative answer (msec).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_BY_TYPE_FAILED_LOOKUP_TIME.
    pub static by_type_failed_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "by_type_failed_lookup_time".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4183), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.by_type_premature_eviction
    ///
    /// DNS Cache Entry Age for by-type queries at Removal Time of non-expired entries (minutes)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_BY_TYPE_PREMATURE_EVICTION.
    pub static by_type_premature_eviction: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "by_type_premature_eviction".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4184), meta, TimeUnit::Minute)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.by_type_succeeded_lookup_time
    ///
    /// Time for a completed by-type resolution that succeeded (msec).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_BY_TYPE_SUCCEEDED_LOOKUP_TIME.
    pub static by_type_succeeded_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "by_type_succeeded_lookup_time".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4185), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.cleanup_age
    ///
    /// DNS Cache Entry Age at Removal Time (minutes)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_CLEANUP_AGE.
    pub static cleanup_age: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cleanup_age".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4186), meta, TimeUnit::Minute)
    });

    #[repr(u16)]
    pub enum GracePeriodRenewalLabel {
        EDifferentRecord = 0,
        ESameRecord = 1,
        __Other__,
    }
    impl From<u16> for GracePeriodRenewalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDifferentRecord,
                1 => Self::ESameRecord,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GracePeriodRenewalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDifferentRecord => "different_record",
                Self::ESameRecord => "same_record",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dns.grace_period_renewal
    ///
    /// Counts the amount of times that we get a record that is different (or identical) from the one that was used from the cache after a grace period induced renewal.
    /// This is to keep track of the amount of possible breakage that is occuring due to the grace period and useful for evaluating experiments increasing the grace period.
    pub static grace_period_renewal: Lazy<LabeledMetric<LabeledCounterMetric, GracePeriodRenewalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "grace_period_renewal".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4187), meta, Some(vec![::std::borrow::Cow::from("different_record"), ::std::borrow::Cow::from("same_record")]))
    });

    #[repr(u16)]
    pub enum LookupAlgorithmLabel {
        ENativeonly = 0,
        ETrrrace = 1,
        ETrrfirst = 2,
        ETrronly = 3,
        ETrrshadow = 4,
        __Other__,
    }
    impl From<u16> for LookupAlgorithmLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENativeonly,
                1 => Self::ETrrrace,
                2 => Self::ETrrfirst,
                3 => Self::ETrronly,
                4 => Self::ETrrshadow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LookupAlgorithmLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENativeonly => "nativeOnly",
                Self::ETrrrace => "trrRace",
                Self::ETrrfirst => "trrFirst",
                Self::ETrronly => "trrOnly",
                Self::ETrrshadow => "trrShadow",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from dns.lookup_algorithm
    ///
    /// DNS: lookup algorithm
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram DNS_LOOKUP_ALGORITHM.
    pub static lookup_algorithm: Lazy<LabeledMetric<LabeledCounterMetric, LookupAlgorithmLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "lookup_algorithm".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4188), meta, Some(vec![::std::borrow::Cow::from("nativeOnly"), ::std::borrow::Cow::from("trrFirst"), ::std::borrow::Cow::from("trrOnly"), ::std::borrow::Cow::from("trrRace"), ::std::borrow::Cow::from("trrShadow")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.lookup_method
    ///
    /// DNS Lookup Type (hit, renewal, negative-hit, literal, overflow, network-first, network-shared)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DNS_LOOKUP_METHOD2.
    pub static lookup_method: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "lookup_method".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4189), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.native_lookup_time
    ///
    /// Time for a completed native name resolution (msec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_NATIVE_LOOKUP_TIME.
    pub static native_lookup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "native_lookup_time".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4190), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.native_queuing
    ///
    /// Time in resolve queue waiting to getaddrinfo (msec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_NATIVE_QUEUING.
    pub static native_queuing: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "native_queuing".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4191), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.premature_eviction
    ///
    /// DNS Cache Entry Age at Removal Time of non-expired entries (minutes)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_PREMATURE_EVICTION.
    pub static premature_eviction: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "premature_eviction".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4192), meta, TimeUnit::Minute)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_attempt_count
    ///
    /// Number of times we attempted TRR for a successful lookup in TRR-first mode. Keyed by provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_ATTEMPT_COUNT.
    pub static trr_attempt_count: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_attempt_count".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 10, bucket_count: 11, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4193), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_lookup_time
    ///
    /// Time for a completed TRR resolution (msec); Keyed by TRR domain
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_TRR_LOOKUP_TIME3.
    pub static trr_lookup_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "trr_lookup_time".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4194), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_processing_time
    ///
    /// Time from the last received byte of the response until we have notified the consumer with a DNS record (msec)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_TRR_PROCESSING_TIME.
    pub static trr_processing_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trr_processing_time".into(),
                category: "dns".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4195), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_relevant_skip_reason_native_failed
    ///
    /// When in TRR-first mode, if TRR was skipped and native failed, it lists the reason we may have skipped TRR, keyed by the provider. Does not include requests that intentionally skip TRR.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_RELEVANT_SKIP_REASON_NATIVE_FAILED.
    pub static trr_relevant_skip_reason_native_failed: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_relevant_skip_reason_native_failed".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4196), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_relevant_skip_reason_native_success
    ///
    /// When in TRR-first mode, if TRR was skipped and native succeeded, it lists the reason we may have skipped TRR, keyed by the provider. Does not include requests that intentionally skip TRR.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_RELEVANT_SKIP_REASON_NATIVE_SUCCESS.
    pub static trr_relevant_skip_reason_native_success: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_relevant_skip_reason_native_success".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4197), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_relevant_skip_reason_trr_first
    ///
    /// When in TRR-first mode, it lists the reason we may have skipped TRR, keyed by the provider. Does not include requests that intentionally skip TRR.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_RELEVANT_SKIP_REASON_TRR_FIRST.
    pub static trr_relevant_skip_reason_trr_first: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_relevant_skip_reason_trr_first".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4198), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_relevant_skip_reason_trr_first_type_rec
    ///
    /// When in TRR-first mode, it lists the reason we may have skipped TRR for HTTPS RR, keyed by the provider. Does not include requests that intentionally skip TRR.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_RELEVANT_SKIP_REASON_TRR_FIRST_TYPE_REC.
    pub static trr_relevant_skip_reason_trr_first_type_rec: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_relevant_skip_reason_trr_first_type_rec".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4199), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_native_failed
    ///
    /// When in TRR-first mode, if TRR was skipped and native failed, it lists the reason we may have skipped TRR, keyed by the provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_NATIVE_FAILED.
    pub static trr_skip_reason_native_failed: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_native_failed".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4200), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_native_success
    ///
    /// When in TRR-first mode, if TRR was skipped and native succeeded, it lists the reason we may have skipped TRR, keyed by the provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_NATIVE_SUCCESS.
    pub static trr_skip_reason_native_success: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_native_success".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4201), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_retry_failed
    ///
    /// When in TRR-first mode, if TRR failed once and retried unsuccessfully, it lists the reason for the first failure, keyed by the provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_RETRY_FAILED.
    pub static trr_skip_reason_retry_failed: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_retry_failed".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4202), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_retry_success
    ///
    /// When in TRR-first mode, if TRR failed once and was successfully retried, it lists the reason for the first failure, keyed by the provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_RETRY_SUCCESS.
    pub static trr_skip_reason_retry_success: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_retry_success".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4203), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_strict_mode
    ///
    /// When in TRR-first mode, it lists the reason we may have skipped TRR. The key is like `<provider>|<skip reason of first attempt>` or just `<provider>` used when there was no second attempt.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_STRICT_MODE.
    pub static trr_skip_reason_strict_mode: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_strict_mode".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4204), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dns.trr_skip_reason_trr_first
    ///
    /// When in TRR-first mode, it lists the reason we may have skipped TRR, keyed by the provider.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRR_SKIP_REASON_TRR_FIRST2.
    pub static trr_skip_reason_trr_first: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "trr_skip_reason_trr_first".into(),
                    category: "dns".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4205), meta, None)
    });

}
pub mod network_cookies {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from network.cookies.sqlite_open_readahead
    ///
    /// Time spent on cookie DB open with readahead (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MOZ_SQLITE_COOKIES_OPEN_READAHEAD_MS.
    pub static sqlite_open_readahead: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sqlite_open_readahead".into(),
                category: "network.cookies".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4206), meta, TimeUnit::Millisecond)
    });

}
pub mod network_dns {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TrrConfirmationContextExtra {
        pub r#attemptCount: Option<u32>,
        pub r#captivePortal: Option<String>,
        pub r#contextReason: Option<String>,
        pub r#failedLookups: Option<String>,
        pub r#networkID: Option<String>,
        pub r#results: Option<String>,
        pub r#time: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for TrrConfirmationContextExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["attemptCount", "captivePortal", "contextReason", "failedLookups", "networkID", "results", "time", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#attemptCount.and_then(|val| map.insert("attemptCount".into(), val.to_string()));
          self.r#captivePortal.and_then(|val| map.insert("captivePortal".into(), val.to_string()));
          self.r#contextReason.and_then(|val| map.insert("contextReason".into(), val.to_string()));
          self.r#failedLookups.and_then(|val| map.insert("failedLookups".into(), val.to_string()));
          self.r#networkID.and_then(|val| map.insert("networkID".into(), val.to_string()));
          self.r#results.and_then(|val| map.insert("results".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.dns.trr_confirmation_context
    ///
    /// This telemetry records the status of the TRR confirmation across. The value of the event is one of:   "ok"   "trying" This event was generated to correspond to the Legacy Telemetry event network.dns.trrConfirmation#context.
    pub static trr_confirmation_context: Lazy<EventMetric<TrrConfirmationContextExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trr_confirmation_context".into(),
                category: "network.dns".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4207), meta)
    });

}
pub mod network_sso {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum EntraSuccessLabel {
        ESuccess = 0,
        EDeviceHeadersMissing = 1,
        EPrtHeadersMissing = 2,
        EBothHeadersMissing = 3,
        EInvalidCookie = 4,
        ENoCredential = 5,
        EBrokerError = 6,
        EInvalidControllerSetup = 7,
        __Other__,
    }
    impl From<u16> for EntraSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EDeviceHeadersMissing,
                2 => Self::EPrtHeadersMissing,
                3 => Self::EBothHeadersMissing,
                4 => Self::EInvalidCookie,
                5 => Self::ENoCredential,
                6 => Self::EBrokerError,
                7 => Self::EInvalidControllerSetup,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EntraSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EDeviceHeadersMissing => "device_headers_missing",
                Self::EPrtHeadersMissing => "prt_headers_missing",
                Self::EBothHeadersMissing => "both_headers_missing",
                Self::EInvalidCookie => "invalid_cookie",
                Self::ENoCredential => "no_credential",
                Self::EBrokerError => "broker_error",
                Self::EInvalidControllerSetup => "invalid_controller_setup",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from network.sso.entra_success
    ///
    /// Counts how often Entra SSO succeeded/failed (macOS only). Labels are ordered in reverse chronological relation to SSO success, meaning the labels higher up are closer to the SSO success. device_headers_missing: only device_headers is missing in the SSO cookie. prt_headers_missing: only prt_headers is missing in the SSO cookie. both_headers_missing: both prt_headers and device_headers are missing in the SSO cookie. invalid_cookie: Failed to parse SSO cookie (could be a null cookie/format is incorrect). no_credential: ASAuthorizationSingleSignOnCredential is not present broker_error: An error from Microsoft's broker. invalid_controller_setup: ASAuthorizationController is setup incorrectly.
    pub static entra_success: Lazy<LabeledMetric<LabeledCounterMetric, EntraSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "entra_success".into(),
                    category: "network.sso".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4208), meta, Some(vec![::std::borrow::Cow::from("both_headers_missing"), ::std::borrow::Cow::from("broker_error"), ::std::borrow::Cow::from("device_headers_missing"), ::std::borrow::Cow::from("invalid_controller_setup"), ::std::borrow::Cow::from("invalid_cookie"), ::std::borrow::Cow::from("no_credential"), ::std::borrow::Cow::from("prt_headers_missing"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from network.sso.total_entra_uses
    ///
    /// Counts how often Entra SSO is used (macOS only).
    pub static total_entra_uses: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4209,
            "network.sso",
            "total_entra_uses",
            "metrics"
        )
    });

}
pub mod predictor {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from predictor.base_confidence
    ///
    /// The base confidence calculated for a subresource
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PREDICTOR_BASE_CONFIDENCE.
    pub static base_confidence: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "base_confidence".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4210), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.confidence
    ///
    /// The final confidence calculated for a subresource
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PREDICTOR_CONFIDENCE.
    pub static confidence: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "confidence".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4211), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.global_degradation
    ///
    /// The global degradation calculated
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PREDICTOR_GLOBAL_DEGRADATION.
    pub static global_degradation: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "global_degradation".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4212), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.learn_attempts
    ///
    /// Number of times nsINetworkPredictor::Learn is called and attempts to learn
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_LEARN_ATTEMPTS.
    pub static learn_attempts: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_attempts".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4213), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.learn_work_time
    ///
    /// Amount of time spent doing the work for learn (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_LEARN_WORK_TIME.
    pub static learn_work_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_work_time".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4214), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.predict_time_to_action
    ///
    /// How long it takes from the time Predict() is called to the time we take action
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_PREDICT_TIME_TO_ACTION.
    pub static predict_time_to_action: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "predict_time_to_action".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4215), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.predict_time_to_inaction
    ///
    /// How long it takes from the time Predict() is called to the time we figure out there's nothing to do
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_PREDICT_TIME_TO_INACTION.
    pub static predict_time_to_inaction: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "predict_time_to_inaction".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4216), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.predict_work_time
    ///
    /// Amount of time spent doing the work for predict (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_PREDICT_WORK_TIME.
    pub static predict_work_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "predict_work_time".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4217), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.predictions_calculated
    ///
    /// How many prediction calculations are performed
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_PREDICTIONS_CALCULATED.
    pub static predictions_calculated: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "predictions_calculated".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4218), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.prefetch_decision_reason
    ///
    /// Why the predictor determined a particular resource was eligible for future prefetch (or not). See PrefetchDecisionReason in Predictor.cpp for value meanings
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PREDICTOR_PREFETCH_DECISION_REASON.
    pub static prefetch_decision_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefetch_decision_reason".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4219), meta, 0, 15, 16, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.prefetch_ignore_reason
    ///
    /// Why the predictor determined a particular resource that was marked eligible for prefetch should not be prefetched. See PrefetchIgnoreReason in Predictor.cpp for value meanings
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PREDICTOR_PREFETCH_IGNORE_REASON.
    pub static prefetch_ignore_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefetch_ignore_reason".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4220), meta, 0, 15, 16, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.prefetch_time
    ///
    /// How long it takes from OnStartRequest to OnStopRequest for a prefetch
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_PREFETCH_TIME.
    pub static prefetch_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefetch_time".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4221), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum PrefetchUseStatusLabel {
        EUsed = 0,
        ENot200 = 1,
        EExpired = 2,
        EWouldvary = 3,
        EWaitedtoolong = 4,
        EEtag = 5,
        EAuth = 6,
        ERedirect = 7,
        __Other__,
    }
    impl From<u16> for PrefetchUseStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUsed,
                1 => Self::ENot200,
                2 => Self::EExpired,
                3 => Self::EWouldvary,
                4 => Self::EWaitedtoolong,
                5 => Self::EEtag,
                6 => Self::EAuth,
                7 => Self::ERedirect,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrefetchUseStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUsed => "Used",
                Self::ENot200 => "Not200",
                Self::EExpired => "Expired",
                Self::EWouldvary => "WouldVary",
                Self::EWaitedtoolong => "WaitedTooLong",
                Self::EEtag => "Etag",
                Self::EAuth => "Auth",
                Self::ERedirect => "Redirect",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from predictor.prefetch_use_status
    ///
    /// If and why prefetches are used/unused.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram PREDICTOR_PREFETCH_USE_STATUS.
    pub static prefetch_use_status: Lazy<LabeledMetric<LabeledCounterMetric, PrefetchUseStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "prefetch_use_status".into(),
                    category: "predictor".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4222), meta, Some(vec![::std::borrow::Cow::from("Auth"), ::std::borrow::Cow::from("Etag"), ::std::borrow::Cow::from("Expired"), ::std::borrow::Cow::from("Not200"), ::std::borrow::Cow::from("Redirect"), ::std::borrow::Cow::from("Used"), ::std::borrow::Cow::from("WaitedTooLong"), ::std::borrow::Cow::from("WouldVary")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.subresource_degradation
    ///
    /// The degradation calculated for a subresource
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PREDICTOR_SUBRESOURCE_DEGRADATION.
    pub static subresource_degradation: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subresource_degradation".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4223), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.total_preconnects
    ///
    /// How many actual preconnects happen
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_TOTAL_PRECONNECTS.
    pub static total_preconnects: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_preconnects".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4224), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.total_predictions
    ///
    /// How many actual predictions (preresolves, preconnects, ...) happen
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_TOTAL_PREDICTIONS.
    pub static total_predictions: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_predictions".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4225), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.total_prefetches
    ///
    /// How many actual prefetches happen
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_TOTAL_PREFETCHES.
    pub static total_prefetches: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_prefetches".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4226), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.total_preresolves
    ///
    /// How many actual preresolves happen
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_TOTAL_PRERESOLVES.
    pub static total_preresolves: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_preresolves".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4227), meta, 1, 1000000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from predictor.wait_time
    ///
    /// Amount of time a predictor event waits in the queue (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PREDICTOR_WAIT_TIME.
    pub static wait_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wait_time".into(),
                category: "predictor".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4228), meta, TimeUnit::Millisecond)
    });

}
pub mod sts {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sts.poll_and_event_the_last_cycle
    ///
    /// The duraion of the socketThread cycle during shutdown, including polls and pending events. (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram STS_POLL_AND_EVENT_THE_LAST_CYCLE.
    pub static poll_and_event_the_last_cycle: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "poll_and_event_the_last_cycle".into(),
                category: "sts".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4229), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sts.poll_and_events_cycle
    ///
    /// The duraion of a socketThread cycle, including polls and pending events. (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram STS_POLL_AND_EVENTS_CYCLE.
    pub static poll_and_events_cycle: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "poll_and_events_cycle".into(),
                category: "sts".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4230), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sts.poll_block_time
    ///
    /// Time spent blocked on poll (ms).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram STS_POLL_BLOCK_TIME.
    pub static poll_block_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "poll_block_time".into(),
                category: "sts".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4231), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sts.poll_cycle
    ///
    /// The duration of poll. (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram STS_POLL_CYCLE.
    pub static poll_cycle: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "poll_cycle".into(),
                category: "sts".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4232), meta, TimeUnit::Millisecond)
    });

}
pub mod hpack {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from hpack.bytes_evicted_compressor
    ///
    /// HPACK: Number of bytes removed from dynamic table to make room for 1 new item
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_BYTES_EVICTED_COMPRESSOR.
    pub static bytes_evicted_compressor: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bytes_evicted_compressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4233), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.bytes_evicted_decompressor
    ///
    /// HPACK: Number of bytes removed from dynamic table to make room for 1 new item
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_BYTES_EVICTED_DECOMPRESSOR.
    pub static bytes_evicted_decompressor: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bytes_evicted_decompressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4234), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.bytes_evicted_ratio_compressor
    ///
    /// HPACK: Ratio of bytes evicted to bytes added (* 100)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_BYTES_EVICTED_RATIO_COMPRESSOR.
    pub static bytes_evicted_ratio_compressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bytes_evicted_ratio_compressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4235), meta, 1, 1024, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.bytes_evicted_ratio_decompressor
    ///
    /// HPACK: Ratio of bytes evicted to bytes added (* 100)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_BYTES_EVICTED_RATIO_DECOMPRESSOR.
    pub static bytes_evicted_ratio_decompressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bytes_evicted_ratio_decompressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4236), meta, 1, 1024, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.elements_evicted_compressor
    ///
    /// HPACK: Number of items removed from dynamic table to make room for 1 new item
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_ELEMENTS_EVICTED_COMPRESSOR.
    pub static elements_evicted_compressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elements_evicted_compressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4237), meta, 1, 256, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.elements_evicted_decompressor
    ///
    /// HPACK: Number of items removed from dynamic table to make room for 1 new item
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_ELEMENTS_EVICTED_DECOMPRESSOR.
    pub static elements_evicted_decompressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elements_evicted_decompressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4238), meta, 1, 256, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.peak_count_compressor
    ///
    /// HPACK: peak number of items in the dynamic table
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_PEAK_COUNT_COMPRESSOR.
    pub static peak_count_compressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_count_compressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4239), meta, 1, 1024, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.peak_count_decompressor
    ///
    /// HPACK: peak number of items in the dynamic table
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_PEAK_COUNT_DECOMPRESSOR.
    pub static peak_count_decompressor: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_count_decompressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4240), meta, 1, 1024, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.peak_size_compressor
    ///
    /// HPACK: peak size in bytes of the table
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_PEAK_SIZE_COMPRESSOR.
    pub static peak_size_compressor: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_size_compressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4241), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from hpack.peak_size_decompressor
    ///
    /// HPACK: peak size in bytes of the table
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HPACK_PEAK_SIZE_DECOMPRESSOR.
    pub static peak_size_decompressor: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "peak_size_decompressor".into(),
                category: "hpack".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4242), meta, MemoryUnit::Byte)
    });

}
pub mod http {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from http.altsvc_entries_per_header
    ///
    /// How many alt-svc productions were seen in a single Alt-Svc header
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_ALTSVC_ENTRIES_PER_HEADER.
    pub static altsvc_entries_per_header: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "altsvc_entries_per_header".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4243), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum AltsvcMappingChangedTargetLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for AltsvcMappingChangedTargetLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AltsvcMappingChangedTargetLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.altsvc_mapping_changed_target
    ///
    /// Whether or not a new alt-svc mapping would change the target hostname of the existing mapping
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_ALTSVC_MAPPING_CHANGED_TARGET.
    pub static altsvc_mapping_changed_target: Lazy<LabeledMetric<LabeledCounterMetric, AltsvcMappingChangedTargetLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "altsvc_mapping_changed_target".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4244), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum CacheLmInconsistentLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for CacheLmInconsistentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CacheLmInconsistentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.cache_lm_inconsistent
    ///
    /// Cache discovered inconsistent last-modified entry
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CACHE_LM_INCONSISTENT.
    pub static cache_lm_inconsistent: Lazy<LabeledMetric<LabeledCounterMetric, CacheLmInconsistentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cache_lm_inconsistent".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4245), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.channel_disposition
    ///
    /// Channel Disposition: 0=Cancel, 1=Disk, 2=NetOK, 3=NetEarlyFail, 4=NetlateFail, +8 for HTTPS
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_CHANNEL_DISPOSITION.
    pub static channel_disposition: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "channel_disposition".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4246), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ChannelOnstartSuccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ChannelOnstartSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ChannelOnstartSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.channel_onstart_success
    ///
    /// Successfully started HTTP channels
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_CHANNEL_ONSTART_SUCCESS.
    pub static channel_onstart_success: Lazy<LabeledMetric<LabeledCounterMetric, ChannelOnstartSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "channel_onstart_success".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4247), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.channel_page_onstart_success_trr
    ///
    /// Successfully started HTTP channels for page loading when TRR is enabled; Keyed by TRR domain
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_CHANNEL_PAGE_ONSTART_SUCCESS_TRR3.
    pub static channel_page_onstart_success_trr: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "channel_page_onstart_success_trr".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 16, bucket_count: 17, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4248), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.channel_sub_onstart_success_trr
    ///
    /// Successfully started HTTP channels for resource loading when TRR is enabled; Keyed by TRR domain
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_CHANNEL_SUB_ONSTART_SUCCESS_TRR3.
    pub static channel_sub_onstart_success_trr: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "channel_sub_onstart_success_trr".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 16, bucket_count: 17, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4249), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.connection_close_reason
    ///
    /// Reason for HTTP connection closure, keyed by properties like HTTP version and connection state.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_CONNECTION_CLOSE_REASON.
    pub static connection_close_reason: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "connection_close_reason".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4250), meta, None)
    });

    #[repr(u16)]
    pub enum ConnectionEntryCacheHitLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ConnectionEntryCacheHitLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ConnectionEntryCacheHitLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.connection_entry_cache_hit
    ///
    /// Fraction of sockets that used a nsConnectionEntry with history - size 300.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_CONNECTION_ENTRY_CACHE_HIT_1.
    pub static connection_entry_cache_hit: Lazy<LabeledMetric<LabeledCounterMetric, ConnectionEntryCacheHitLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "connection_entry_cache_hit".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4251), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.content_encoding
    ///
    /// encoding removed: 0=unknown, 1=gzip, 2=deflate, 3=brotli, 4=zstd
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_CONTENT_ENCODING.
    pub static content_encoding: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_encoding".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4252), meta, 0, 6, 7, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.dns_httpssvc_connection_failed_reason
    ///
    /// The reason why we failed to connect with an HTTPSSVC record
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DNS_HTTPSSVC_CONNECTION_FAILED_REASON.
    pub static dns_httpssvc_connection_failed_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_httpssvc_connection_failed_reason".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4253), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.dns_httpssvc_record_receiving_stage
    ///
    /// Record at which stage an HTTPSSVC record is received
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DNS_HTTPSSVC_RECORD_RECEIVING_STAGE.
    pub static dns_httpssvc_record_receiving_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dns_httpssvc_record_receiving_stage".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4254), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.dnt_usage
    ///
    /// I want to be tracked, I do NOT want to be tracked, DNT unset
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram DNT_USAGE.
    pub static dnt_usage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dnt_usage".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4255), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum EchconfigSuccessRateLabel {
        EEchconfigsucceeded = 0,
        EEchconfigfailed = 1,
        ENoechconfigsucceeded = 2,
        ENoechconfigfailed = 3,
        __Other__,
    }
    impl From<u16> for EchconfigSuccessRateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EEchconfigsucceeded,
                1 => Self::EEchconfigfailed,
                2 => Self::ENoechconfigsucceeded,
                3 => Self::ENoechconfigfailed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EchconfigSuccessRateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EEchconfigsucceeded => "EchConfigSucceeded",
                Self::EEchconfigfailed => "EchConfigFailed",
                Self::ENoechconfigsucceeded => "NoEchConfigSucceeded",
                Self::ENoechconfigfailed => "NoEchConfigFailed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.echconfig_success_rate
    ///
    /// TLS handshake with and without EchConfig success rate.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram ECHCONFIG_SUCCESS_RATE.
    pub static echconfig_success_rate: Lazy<LabeledMetric<LabeledCounterMetric, EchconfigSuccessRateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "echconfig_success_rate".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4256), meta, Some(vec![::std::borrow::Cow::from("EchConfigFailed"), ::std::borrow::Cow::from("EchConfigSucceeded"), ::std::borrow::Cow::from("NoEchConfigFailed"), ::std::borrow::Cow::from("NoEchConfigSucceeded")]))
    });

    #[repr(u16)]
    pub enum Http2FailBeforeSettingsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for Http2FailBeforeSettingsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http2FailBeforeSettingsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.http2_fail_before_settings
    ///
    /// Whether an HTTP/2 session failed because the peer did not handshake properly
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP2_FAIL_BEFORE_SETTINGS.
    pub static http2_fail_before_settings: Lazy<LabeledMetric<LabeledCounterMetric, Http2FailBeforeSettingsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http2_fail_before_settings".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4257), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.kbread_per_conn2
    ///
    /// HTTP: KB read per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_KBREAD_PER_CONN2.
    pub static kbread_per_conn2: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "kbread_per_conn2".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4258), meta, MemoryUnit::Kilobyte)
    });

    #[repr(u16)]
    pub enum PageloadIsSslLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for PageloadIsSslLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PageloadIsSslLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.pageload_is_ssl
    ///
    /// Whether a HTTP page load was over SSL or not. Recorded during response processing for all first-party page loads.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_PAGELOAD_IS_SSL.
    pub static pageload_is_ssl: Lazy<LabeledMetric<LabeledCounterMetric, PageloadIsSslLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pageload_is_ssl".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4259), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.proxy_type
    ///
    /// HTTP Proxy Type (none, http, socks)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_PROXY_TYPE.
    pub static proxy_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "proxy_type".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4260), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.request_per_conn
    ///
    /// HTTP: requests per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_REQUEST_PER_CONN.
    pub static request_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_per_conn".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4261), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.request_per_page
    ///
    /// HTTP: Requests per page (count)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_REQUEST_PER_PAGE.
    pub static request_per_page: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_per_page".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4262), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.request_per_page_from_cache
    ///
    /// HTTP: Requests serviced from cache (%)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_REQUEST_PER_PAGE_FROM_CACHE.
    pub static request_per_page_from_cache: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_per_page_from_cache".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4263), meta, 0, 101, 102, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.response_version
    ///
    /// HTTP: Protocol Version Used on Response from nsHttp.h
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_RESPONSE_VERSION.
    pub static response_version: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "response_version".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4264), meta, 0, 48, 49, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.saw_quic_alt_protocol
    ///
    /// Does a response has a h3(1), other quic(2) or non(0) alt-protocol advertisement.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_SAW_QUIC_ALT_PROTOCOL_2.
    pub static saw_quic_alt_protocol: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saw_quic_alt_protocol".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4265), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ScriptBlockIncorrectMimeLabel {
        EUnknown = 0,
        EJavascript = 1,
        EImage = 2,
        EAudio = 3,
        EVideo = 4,
        ETextPlain = 5,
        ETextCsv = 6,
        ETextXml = 7,
        EAppOctetStream = 8,
        EAppXml = 9,
        EAppJson = 10,
        ETextJson = 11,
        ETextHtml = 12,
        EEmpty = 13,
        EServiceworkerLoad = 14,
        EWorkerLoad = 15,
        EImportscriptLoad = 16,
        EScriptLoad = 17,
        ESameOrigin = 18,
        ECorsOrigin = 19,
        ECrossOrigin = 20,
        EWorkletLoad = 21,
        __Other__,
    }
    impl From<u16> for ScriptBlockIncorrectMimeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknown,
                1 => Self::EJavascript,
                2 => Self::EImage,
                3 => Self::EAudio,
                4 => Self::EVideo,
                5 => Self::ETextPlain,
                6 => Self::ETextCsv,
                7 => Self::ETextXml,
                8 => Self::EAppOctetStream,
                9 => Self::EAppXml,
                10 => Self::EAppJson,
                11 => Self::ETextJson,
                12 => Self::ETextHtml,
                13 => Self::EEmpty,
                14 => Self::EServiceworkerLoad,
                15 => Self::EWorkerLoad,
                16 => Self::EImportscriptLoad,
                17 => Self::EScriptLoad,
                18 => Self::ESameOrigin,
                19 => Self::ECorsOrigin,
                20 => Self::ECrossOrigin,
                21 => Self::EWorkletLoad,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ScriptBlockIncorrectMimeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknown => "unknown",
                Self::EJavascript => "javaScript",
                Self::EImage => "image",
                Self::EAudio => "audio",
                Self::EVideo => "video",
                Self::ETextPlain => "text_plain",
                Self::ETextCsv => "text_csv",
                Self::ETextXml => "text_xml",
                Self::EAppOctetStream => "app_octet_stream",
                Self::EAppXml => "app_xml",
                Self::EAppJson => "app_json",
                Self::ETextJson => "text_json",
                Self::ETextHtml => "text_html",
                Self::EEmpty => "empty",
                Self::EServiceworkerLoad => "serviceworker_load",
                Self::EWorkerLoad => "worker_load",
                Self::EImportscriptLoad => "importScript_load",
                Self::EScriptLoad => "script_load",
                Self::ESameOrigin => "same_origin",
                Self::ECorsOrigin => "CORS_origin",
                Self::ECrossOrigin => "cross_origin",
                Self::EWorkletLoad => "worklet_load",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.script_block_incorrect_mime
    ///
    /// Whether the script load has a MIME type of ...?  (unknown, javaScript, image, audio, video, text_plain, text_csv, text_xml, app_octet_stream, app_xml, app_json, text_json, text_html, empty). Whether the script load is from ...?  (serviceworker_load, worker_load, importSript_load, script_load). Whether the script load is of ...?  (same_origin, CORS_origin, cross_origin)
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram SCRIPT_BLOCK_INCORRECT_MIME_3.
    pub static script_block_incorrect_mime: Lazy<LabeledMetric<LabeledCounterMetric, ScriptBlockIncorrectMimeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "script_block_incorrect_mime".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4266), meta, Some(vec![::std::borrow::Cow::from("CORS_origin"), ::std::borrow::Cow::from("app_json"), ::std::borrow::Cow::from("app_octet_stream"), ::std::borrow::Cow::from("app_xml"), ::std::borrow::Cow::from("audio"), ::std::borrow::Cow::from("cross_origin"), ::std::borrow::Cow::from("empty"), ::std::borrow::Cow::from("image"), ::std::borrow::Cow::from("importScript_load"), ::std::borrow::Cow::from("javaScript"), ::std::borrow::Cow::from("same_origin"), ::std::borrow::Cow::from("script_load"), ::std::borrow::Cow::from("serviceworker_load"), ::std::borrow::Cow::from("text_csv"), ::std::borrow::Cow::from("text_html"), ::std::borrow::Cow::from("text_json"), ::std::borrow::Cow::from("text_plain"), ::std::borrow::Cow::from("text_xml"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("video"), ::std::borrow::Cow::from("worker_load"), ::std::borrow::Cow::from("worklet_load")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.subitem_first_byte_latency_time
    ///
    /// HTTP subitem channel: Page start -> first byte received for subitem reply (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_SUBITEM_FIRST_BYTE_LATENCY_TIME.
    pub static subitem_first_byte_latency_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subitem_first_byte_latency_time".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4267), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.subitem_open_latency_time
    ///
    /// HTTP subitem channel: Page start -> subitem open() (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_SUBITEM_OPEN_LATENCY_TIME.
    pub static subitem_open_latency_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subitem_open_latency_time".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4268), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum TlsEarlyDataAcceptedLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TlsEarlyDataAcceptedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TlsEarlyDataAcceptedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.tls_early_data_accepted
    ///
    /// TLS early data was used and it was accepted (true) or rejected (false) by the remote host.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram TLS_EARLY_DATA_ACCEPTED.
    pub static tls_early_data_accepted: Lazy<LabeledMetric<LabeledCounterMetric, TlsEarlyDataAcceptedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tls_early_data_accepted".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4269), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.tls_early_data_negotiated
    ///
    /// Sending TLS early data was possible: 0 - not possible, 1 - possible but not used, 2 - possible and used.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TLS_EARLY_DATA_NEGOTIATED.
    pub static tls_early_data_negotiated: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_early_data_negotiated".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4270), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_ech_retry_ech_failed_count
    ///
    /// When echConfig is enabled, number of times a transaction is retried because of SSL_ERROR_ECH_FAILED
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_ECH_RETRY_ECH_FAILED_COUNT.
    pub static transaction_ech_retry_ech_failed_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_ech_retry_ech_failed_count".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4271), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_ech_retry_others_count
    ///
    /// When echConfig is enabled, number of times a transaction is retried because of other error
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_ECH_RETRY_OTHERS_COUNT.
    pub static transaction_ech_retry_others_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_ech_retry_others_count".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4272), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_ech_retry_with_ech_count
    ///
    /// When echConfig is enabled, number of times a transaction is retried because of SSL_ERROR_ECH_RETRY_WITH_ECH
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_ECH_RETRY_WITH_ECH_COUNT.
    pub static transaction_ech_retry_with_ech_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_ech_retry_with_ech_count".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4273), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_ech_retry_without_ech_count
    ///
    /// When echConfig is enabled, number of times a transaction is retried because of SSL_ERROR_ECH_RETRY_WITHOUT_ECH
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_ECH_RETRY_WITHOUT_ECH_COUNT.
    pub static transaction_ech_retry_without_ech_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_ech_retry_without_ech_count".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4274), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum TransactionIsSslLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TransactionIsSslLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TransactionIsSslLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_is_ssl
    ///
    /// Whether an HTTP request occurred over TLS/SSL or not. Recorded during response processing for all requests.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_TRANSACTION_IS_SSL.
    pub static transaction_is_ssl: Lazy<LabeledMetric<LabeledCounterMetric, TransactionIsSslLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "transaction_is_ssl".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4275), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_restart_reason
    ///
    /// The reason why a HTTP transaction is restarted.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP_TRANSACTION_RESTART_REASON.
    pub static transaction_restart_reason: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_restart_reason".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4276), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum TransactionUseAltsvcLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TransactionUseAltsvcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TransactionUseAltsvcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_use_altsvc
    ///
    /// Whether a HTTP transaction was routed via Alt-Svc or not.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram HTTP_TRANSACTION_USE_ALTSVC.
    pub static transaction_use_altsvc: Lazy<LabeledMetric<LabeledCounterMetric, TransactionUseAltsvcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "transaction_use_altsvc".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4277), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_wait_time_http
    ///
    /// Time from submission to dispatch of HTTP transaction (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_WAIT_TIME_HTTP.
    pub static transaction_wait_time_http: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_http".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4278), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_wait_time_http2_sup_http3
    ///
    /// Time from submission to dispatch of HTTP2 transaction that has received a respone from a server that addretizes HTTP3 support (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_WAIT_TIME_HTTP2_SUP_HTTP3.
    pub static transaction_wait_time_http2_sup_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_http2_sup_http3".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4279), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_wait_time_http3
    ///
    /// Time from submission to dispatch of HTTP/3 transaction (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_WAIT_TIME_HTTP3.
    pub static transaction_wait_time_http3: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_http3".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4280), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.transaction_wait_time_spdy
    ///
    /// Time from submission to dispatch of SPDY transaction (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TRANSACTION_WAIT_TIME_SPDY.
    pub static transaction_wait_time_spdy: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "transaction_wait_time_spdy".into(),
                category: "http".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4281), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http.upload_bandwidth_mbps
    ///
    /// The upload bandwidth for requests larger than 10MB. Measured in megabits per second, Mbps. Keyed by HTTP protocol version.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP_UPLOAD_BANDWIDTH_MBPS.
    pub static upload_bandwidth_mbps: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "upload_bandwidth_mbps".into(),
                    category: "http".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 10000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4282), meta, None)
    });

}
pub mod http3 {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from http3.blocked_by_stream_limit_per_conn
    ///
    /// HTTP3: number of times a connection is blocked by maximum allowed number of parallel streams per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_BLOCKED_BY_STREAM_LIMIT_PER_CONN.
    pub static blocked_by_stream_limit_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blocked_by_stream_limit_per_conn".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4283), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.connection_close_code
    ///
    /// Error code when http3 connection is closed. Look at Http3Session for more details.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP3_CONNECTION_CLOSE_CODE_3.
    pub static connection_close_code: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "connection_close_code".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 100, bucket_count: 101, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4284), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.counts_pto
    ///
    /// HTTP3: the number of PTOs.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_COUNTS_PTO.
    pub static counts_pto: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "counts_pto".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 5000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4285), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.drop_dgrams
    ///
    /// HTTP3: the number of dropped datagrams.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_DROP_DGRAMS.
    pub static drop_dgrams: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "drop_dgrams".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4286), meta, 1, 5000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum EchOutcomeLabel {
        ENone = 0,
        EGrease = 1,
        EReal = 2,
        __Other__,
    }
    impl From<u16> for EchOutcomeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENone,
                1 => Self::EGrease,
                2 => Self::EReal,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EchOutcomeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENone => "NONE",
                Self::EGrease => "GREASE",
                Self::EReal => "REAL",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http3.ech_outcome
    ///
    /// Success / Fail Rates for HTTP3 Keyed by ECH Usage
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram HTTP3_ECH_OUTCOME.
    pub static ech_outcome: Lazy<LabeledMetric<LabeledCustomDistributionMetric, EchOutcomeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "ech_outcome".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 32, bucket_count: 33, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4287), meta, Some(vec![::std::borrow::Cow::from("GREASE"), ::std::borrow::Cow::from("NONE"), ::std::borrow::Cow::from("REAL")]))
    });

    #[repr(u16)]
    pub enum LateAckLabel {
        EAck = 0,
        EPto = 1,
        __Other__,
    }
    impl From<u16> for LateAckLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAck,
                1 => Self::EPto,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LateAckLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAck => "ack",
                Self::EPto => "pto",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http3.late_ack
    ///
    /// HTTP3: the number of spurious retransmissions.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_LATE_ACK.
    pub static late_ack: Lazy<LabeledMetric<LabeledCustomDistributionMetric, LateAckLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "late_ack".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 10000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4288), meta, Some(vec![::std::borrow::Cow::from("ack"), ::std::borrow::Cow::from("pto")]))
    });

    #[repr(u16)]
    pub enum LateAckRatioLabel {
        EAck = 0,
        EPto = 1,
        __Other__,
    }
    impl From<u16> for LateAckRatioLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAck,
                1 => Self::EPto,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for LateAckRatioLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAck => "ack",
                Self::EPto => "pto",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http3.late_ack_ratio
    ///
    /// HTTP3: spurious retransmissions ratio (spurios_retransmission / packet sent * 10000).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_LATE_ACK_RATIO.
    pub static late_ack_ratio: Lazy<LabeledMetric<LabeledCustomDistributionMetric, LateAckRatioLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "late_ack_ratio".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 2000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4289), meta, Some(vec![::std::borrow::Cow::from("ack"), ::std::borrow::Cow::from("pto")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.loss_ratio
    ///
    /// HTTP3: packet loss ratio (multiply by 10000).
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_LOSS_RATIO.
    pub static loss_ratio: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "loss_ratio".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4290), meta, 1, 2000, 100, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum ReceivedSentDgramsLabel {
        EReceived = 0,
        ESent = 1,
        __Other__,
    }
    impl From<u16> for ReceivedSentDgramsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EReceived,
                1 => Self::ESent,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReceivedSentDgramsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EReceived => "received",
                Self::ESent => "sent",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from http3.received_sent_dgrams
    ///
    /// HTTP3: the number of received/sent packets.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_RECEIVED_SENT_DGRAMS.
    pub static received_sent_dgrams: Lazy<LabeledMetric<LabeledCustomDistributionMetric, ReceivedSentDgramsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "received_sent_dgrams".into(),
                    category: "http3".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 100000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4291), meta, Some(vec![::std::borrow::Cow::from("received"), ::std::borrow::Cow::from("sent")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.request_per_conn
    ///
    /// HTTP3: Streams created per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_REQUEST_PER_CONN.
    pub static request_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_per_conn".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4292), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.saved_dgrams
    ///
    /// HTTP3: the number of saved datagrams that are waiting for keys to be available.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_SAVED_DGRAMS.
    pub static saved_dgrams: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_dgrams".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4293), meta, 1, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.sending_blocked_by_flow_control_per_trans
    ///
    /// HTTP3: number of times when a stream is blocked by the flow control while sendnig data.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_SENDING_BLOCKED_BY_FLOW_CONTROL_PER_TRANS.
    pub static sending_blocked_by_flow_control_per_trans: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sending_blocked_by_flow_control_per_trans".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4294), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.timer_delayed
    ///
    /// Time difference between setting timer value and actually firing the timer for calling neqo
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_TIMER_DELAYED.
    pub static timer_delayed: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "timer_delayed".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4295), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.trans_blocked_by_stream_limit_per_conn
    ///
    /// HTTP3: number of transactions that are blocked by maximum allowed number of parallel streams per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_TRANS_BLOCKED_BY_STREAM_LIMIT_PER_CONN.
    pub static trans_blocked_by_stream_limit_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trans_blocked_by_stream_limit_per_conn".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4296), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from http3.trans_sending_blocked_by_flow_control_per_conn
    ///
    /// HTTP3: number of times streams are blocked by the flow control while sending data per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_TRANS_SENDING_BLOCKED_BY_FLOW_CONTROL_PER_CONN.
    pub static trans_sending_blocked_by_flow_control_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trans_sending_blocked_by_flow_control_per_conn".into(),
                category: "http3".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4297), meta, 1, 1000, 50, HistogramType::Exponential)
    });

}
pub mod netwerk {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum Http30rttStateLabel {
        ENotUsed = 0,
        ESucceeded = 1,
        ERejected = 2,
        EConnError = 3,
        EConnClosedByNecko = 4,
        __Other__,
    }
    impl From<u16> for Http30rttStateLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotUsed,
                1 => Self::ESucceeded,
                2 => Self::ERejected,
                3 => Self::EConnError,
                4 => Self::EConnClosedByNecko,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http30rttStateLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotUsed => "not_used",
                Self::ESucceeded => "succeeded",
                Self::ERejected => "rejected",
                Self::EConnError => "conn_error",
                Self::EConnClosedByNecko => "conn_closed_by_necko",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.http3_0rtt_state
    ///
    /// Gather the outcome of 0-RTT usage: - "not_used": 0RTT_NOT_USED - "succeeded": 0RTT_USED_SUCCESS - "rejected": 0RTT_USED_REJECT - "conn_error": 0RTT_USED_CONN_ERROR - "conn_closed_by_necko": 0RTT_CONN_CLOSED_BY_NECKO
    pub static http3_0rtt_state: Lazy<LabeledMetric<LabeledCounterMetric, Http30rttStateLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "http3_0rtt_state".into(),
                    category: "netwerk".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4298), meta, Some(vec![::std::borrow::Cow::from("conn_closed_by_necko"), ::std::borrow::Cow::from("conn_error"), ::std::borrow::Cow::from("not_used"), ::std::borrow::Cow::from("rejected"), ::std::borrow::Cow::from("succeeded")]))
    });

    #[repr(u16)]
    pub enum Http30rttStateDurationLabel {
        ESucceeded = 0,
        ERejected = 1,
        EConnError = 2,
        EConnClosedByNecko = 3,
        ENotUsed = 4,
        __Other__,
    }
    impl From<u16> for Http30rttStateDurationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESucceeded,
                1 => Self::ERejected,
                2 => Self::EConnError,
                3 => Self::EConnClosedByNecko,
                4 => Self::ENotUsed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http30rttStateDurationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESucceeded => "succeeded",
                Self::ERejected => "rejected",
                Self::EConnError => "conn_error",
                Self::EConnClosedByNecko => "conn_closed_by_necko",
                Self::ENotUsed => "not_used",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.http3_0rtt_state_duration
    ///
    /// The time a connection was in the 0-RTT state
    pub static http3_0rtt_state_duration: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http30rttStateDurationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_0rtt_state_duration".into(),
                    category: "netwerk".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4299), meta, Some(vec![::std::borrow::Cow::from("conn_closed_by_necko"), ::std::borrow::Cow::from("conn_error"), ::std::borrow::Cow::from("not_used"), ::std::borrow::Cow::from("rejected"), ::std::borrow::Cow::from("succeeded")]))
    });

    #[repr(u16)]
    pub enum Http3TimeToReuseIdleConnectionLabel {
        ESucceeded = 0,
        EFailed = 1,
        __Other__,
    }
    impl From<u16> for Http3TimeToReuseIdleConnectionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESucceeded,
                1 => Self::EFailed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Http3TimeToReuseIdleConnectionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESucceeded => "succeeded",
                Self::EFailed => "failed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from netwerk.http3_time_to_reuse_idle_connection
    ///
    /// The time to reuse an idle connection in HTTP3 (ms); keyed by the transaction reusing an idle connection has succeeded or failed
    pub static http3_time_to_reuse_idle_connection: Lazy<LabeledMetric<LabeledTimingDistributionMetric, Http3TimeToReuseIdleConnectionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "http3_time_to_reuse_idle_connection".into(),
                    category: "netwerk".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4300), meta, Some(vec![::std::borrow::Cow::from("failed"), ::std::borrow::Cow::from("succeeded")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from netwerk.parent_connect_timeout
    ///
    /// Counts how often the parent-connect-timeout timer is necessary to clear up EarlyHintPreloader
    pub static parent_connect_timeout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4301,
            "netwerk",
            "parent_connect_timeout",
            "metrics"
        )
    });

}
pub mod opaque_response_blocking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from opaque.response.blocking.cross_origin_opaque_response_count
    ///
    /// The number of loads of cross origin opaque resources. This metric was generated to correspond to the Legacy Telemetry scalar opaque.response.blocking.cross_origin_opaque_response_count.
    pub static cross_origin_opaque_response_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4302,
            "opaque.response.blocking",
            "cross_origin_opaque_response_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from opaque.response.blocking.javascript_validation_count
    ///
    /// The number of times we run the JS validator. This metric was generated to correspond to the Legacy Telemetry scalar opaque.response.blocking.javascript_validation_count.
    pub static javascript_validation_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4303,
            "opaque.response.blocking",
            "javascript_validation_count",
            "metrics"
        )
    });

}
pub mod orb {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BlockInitiatorLabel {
        EInvalid = 0,
        EOther = 1,
        EFilteredFetch = 2,
        EBlockedFetch = 3,
        EJson = 4,
        EScript = 5,
        EImage = 6,
        EStylesheet = 7,
        EXmlhttprequest = 8,
        EDtd = 9,
        EFont = 10,
        EMedia = 11,
        ECspReport = 12,
        EXslt = 13,
        EImageset = 14,
        EWebManifest = 15,
        ESpeculative = 16,
        EUaFont = 17,
        EProxiedWebrtcMedia = 18,
        EPing = 19,
        EBeacon = 20,
        EWebTransport = 21,
        EExcluded = 22,
        __Other__,
    }
    impl From<u16> for BlockInitiatorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInvalid,
                1 => Self::EOther,
                2 => Self::EFilteredFetch,
                3 => Self::EBlockedFetch,
                4 => Self::EJson,
                5 => Self::EScript,
                6 => Self::EImage,
                7 => Self::EStylesheet,
                8 => Self::EXmlhttprequest,
                9 => Self::EDtd,
                10 => Self::EFont,
                11 => Self::EMedia,
                12 => Self::ECspReport,
                13 => Self::EXslt,
                14 => Self::EImageset,
                15 => Self::EWebManifest,
                16 => Self::ESpeculative,
                17 => Self::EUaFont,
                18 => Self::EProxiedWebrtcMedia,
                19 => Self::EPing,
                20 => Self::EBeacon,
                21 => Self::EWebTransport,
                22 => Self::EExcluded,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BlockInitiatorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInvalid => "INVALID",
                Self::EOther => "OTHER",
                Self::EFilteredFetch => "FILTERED_FETCH",
                Self::EBlockedFetch => "BLOCKED_FETCH",
                Self::EJson => "JSON",
                Self::EScript => "SCRIPT",
                Self::EImage => "IMAGE",
                Self::EStylesheet => "STYLESHEET",
                Self::EXmlhttprequest => "XMLHTTPREQUEST",
                Self::EDtd => "DTD",
                Self::EFont => "FONT",
                Self::EMedia => "MEDIA",
                Self::ECspReport => "CSP_REPORT",
                Self::EXslt => "XSLT",
                Self::EImageset => "IMAGESET",
                Self::EWebManifest => "WEB_MANIFEST",
                Self::ESpeculative => "SPECULATIVE",
                Self::EUaFont => "UA_FONT",
                Self::EProxiedWebrtcMedia => "PROXIED_WEBRTC_MEDIA",
                Self::EPing => "PING",
                Self::EBeacon => "BEACON",
                Self::EWebTransport => "WEB_TRANSPORT",
                Self::EExcluded => "EXCLUDED",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from orb.block_initiator
    ///
    /// The initiator of this ORB blocked request.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram ORB_BLOCK_INITIATOR.
    pub static block_initiator: Lazy<LabeledMetric<LabeledCounterMetric, BlockInitiatorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "block_initiator".into(),
                    category: "orb".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4304), meta, Some(vec![::std::borrow::Cow::from("BEACON"), ::std::borrow::Cow::from("BLOCKED_FETCH"), ::std::borrow::Cow::from("CSP_REPORT"), ::std::borrow::Cow::from("DTD"), ::std::borrow::Cow::from("EXCLUDED"), ::std::borrow::Cow::from("FILTERED_FETCH"), ::std::borrow::Cow::from("FONT"), ::std::borrow::Cow::from("IMAGE"), ::std::borrow::Cow::from("IMAGESET"), ::std::borrow::Cow::from("INVALID"), ::std::borrow::Cow::from("JSON"), ::std::borrow::Cow::from("MEDIA"), ::std::borrow::Cow::from("OTHER"), ::std::borrow::Cow::from("PING"), ::std::borrow::Cow::from("PROXIED_WEBRTC_MEDIA"), ::std::borrow::Cow::from("SCRIPT"), ::std::borrow::Cow::from("SPECULATIVE"), ::std::borrow::Cow::from("STYLESHEET"), ::std::borrow::Cow::from("UA_FONT"), ::std::borrow::Cow::from("WEB_MANIFEST"), ::std::borrow::Cow::from("WEB_TRANSPORT"), ::std::borrow::Cow::from("XMLHTTPREQUEST"), ::std::borrow::Cow::from("XSLT")]))
    });

    #[repr(u16)]
    pub enum BlockReasonLabel {
        EMimeNeverSniffed = 0,
        EResp206Blclisted = 1,
        ENosniffBlcOrTextp = 2,
        EResp206NoFirst = 3,
        EAfterSniffMedia = 4,
        EAfterSniffNosniff = 5,
        EAfterSniffStaCode = 6,
        EAfterSniffCtFail = 7,
        EMediaNotInitial = 8,
        EMediaIncorrectResp = 9,
        EJsValidationFailed = 10,
        __Other__,
    }
    impl From<u16> for BlockReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMimeNeverSniffed,
                1 => Self::EResp206Blclisted,
                2 => Self::ENosniffBlcOrTextp,
                3 => Self::EResp206NoFirst,
                4 => Self::EAfterSniffMedia,
                5 => Self::EAfterSniffNosniff,
                6 => Self::EAfterSniffStaCode,
                7 => Self::EAfterSniffCtFail,
                8 => Self::EMediaNotInitial,
                9 => Self::EMediaIncorrectResp,
                10 => Self::EJsValidationFailed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BlockReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMimeNeverSniffed => "MIME_NEVER_SNIFFED",
                Self::EResp206Blclisted => "RESP_206_BLCLISTED",
                Self::ENosniffBlcOrTextp => "NOSNIFF_BLC_OR_TEXTP",
                Self::EResp206NoFirst => "RESP_206_NO_FIRST",
                Self::EAfterSniffMedia => "AFTER_SNIFF_MEDIA",
                Self::EAfterSniffNosniff => "AFTER_SNIFF_NOSNIFF",
                Self::EAfterSniffStaCode => "AFTER_SNIFF_STA_CODE",
                Self::EAfterSniffCtFail => "AFTER_SNIFF_CT_FAIL",
                Self::EMediaNotInitial => "MEDIA_NOT_INITIAL",
                Self::EMediaIncorrectResp => "MEDIA_INCORRECT_RESP",
                Self::EJsValidationFailed => "JS_VALIDATION_FAILED",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from orb.block_reason
    ///
    /// The reason of why this request was blocked by ORB
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram ORB_BLOCK_REASON.
    pub static block_reason: Lazy<LabeledMetric<LabeledCounterMetric, BlockReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "block_reason".into(),
                    category: "orb".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4305), meta, Some(vec![::std::borrow::Cow::from("AFTER_SNIFF_CT_FAIL"), ::std::borrow::Cow::from("AFTER_SNIFF_MEDIA"), ::std::borrow::Cow::from("AFTER_SNIFF_NOSNIFF"), ::std::borrow::Cow::from("AFTER_SNIFF_STA_CODE"), ::std::borrow::Cow::from("JS_VALIDATION_FAILED"), ::std::borrow::Cow::from("MEDIA_INCORRECT_RESP"), ::std::borrow::Cow::from("MEDIA_NOT_INITIAL"), ::std::borrow::Cow::from("MIME_NEVER_SNIFFED"), ::std::borrow::Cow::from("NOSNIFF_BLC_OR_TEXTP"), ::std::borrow::Cow::from("RESP_206_BLCLISTED"), ::std::borrow::Cow::from("RESP_206_NO_FIRST")]))
    });

    #[repr(u16)]
    pub enum DidEverBlockResponseLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for DidEverBlockResponseLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DidEverBlockResponseLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from orb.did_ever_block_response
    ///
    /// If any opaque response was blocked for a given top-level window context.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram ORB_DID_EVER_BLOCK_RESPONSE.
    pub static did_ever_block_response: Lazy<LabeledMetric<LabeledCounterMetric, DidEverBlockResponseLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "did_ever_block_response".into(),
                    category: "orb".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4306), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum JavascriptValidationLabel {
        EJavascript = 0,
        EJson = 1,
        EOther = 2,
        EFailure = 3,
        __Other__,
    }
    impl From<u16> for JavascriptValidationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EJavascript,
                1 => Self::EJson,
                2 => Self::EOther,
                3 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for JavascriptValidationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EJavascript => "javascript",
                Self::EJson => "json",
                Self::EOther => "other",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from orb.javascript_validation
    ///
    /// Time (in ms) that it takes for a ORB JavaScript validator to complete a validation, including IPC to the validator actor.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram ORB_JAVASCRIPT_VALIDATION_MS.
    pub static javascript_validation: Lazy<LabeledMetric<LabeledTimingDistributionMetric, JavascriptValidationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "javascript_validation".into(),
                    category: "orb".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4307), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("javascript"), ::std::borrow::Cow::from("json"), ::std::borrow::Cow::from("other")]))
    });

    #[repr(u16)]
    pub enum ReceiveDataForValidationLabel {
        EJavascript = 0,
        EJson = 1,
        EOther = 2,
        EFailure = 3,
        __Other__,
    }
    impl From<u16> for ReceiveDataForValidationLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EJavascript,
                1 => Self::EJson,
                2 => Self::EOther,
                3 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReceiveDataForValidationLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EJavascript => "javascript",
                Self::EJson => "json",
                Self::EOther => "other",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from orb.receive_data_for_validation
    ///
    /// Time (in ms) that it takes to receive data for ORB JavaScript validation, including IPC to the validator actor.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram ORB_RECEIVE_DATA_FOR_VALIDATION_MS.
    pub static receive_data_for_validation: Lazy<LabeledMetric<LabeledTimingDistributionMetric, ReceiveDataForValidationLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "receive_data_for_validation".into(),
                    category: "orb".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4308), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("javascript"), ::std::borrow::Cow::from("json"), ::std::borrow::Cow::from("other")]))
    });

}
pub mod spdy {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from spdy.chunk_recvd
    ///
    /// SPDY: Recvd Chunk Size (rounded to KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_CHUNK_RECVD.
    pub static chunk_recvd: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chunk_recvd".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4309), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.continued_headers
    ///
    /// Size of continued H2 headers in bytes.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_CONTINUED_HEADERS.
    pub static continued_headers: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "continued_headers".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4310), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.goaway_local
    ///
    /// H2: goaway reason client sent from rfc 7540. 31 is none sent.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SPDY_GOAWAY_LOCAL.
    pub static goaway_local: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "goaway_local".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4311), meta, 0, 32, 33, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.goaway_peer
    ///
    /// H2: goaway reason from peer from rfc 7540. 31 is none received.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SPDY_GOAWAY_PEER.
    pub static goaway_peer: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "goaway_peer".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4312), meta, 0, 32, 33, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.kbread_per_conn
    ///
    /// SPDY: KB read per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_KBREAD_PER_CONN2.
    pub static kbread_per_conn: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "kbread_per_conn".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4313), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.parallel_streams
    ///
    /// SPDY: Streams concurrent active per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_PARALLEL_STREAMS.
    pub static parallel_streams: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parallel_streams".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4314), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.request_per_conn
    ///
    /// SPDY: Streams created per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_REQUEST_PER_CONN_3.
    pub static request_per_conn: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_per_conn".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4315), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.server_initiated_streams
    ///
    /// SPDY: Streams received per connection
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_SERVER_INITIATED_STREAMS.
    pub static server_initiated_streams: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "server_initiated_streams".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4316), meta, 1, 100000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.settings_iw
    ///
    /// H2: Settings Initial Window (rounded to KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_SETTINGS_IW.
    pub static settings_iw: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_iw".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4317), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.settings_max_streams
    ///
    /// H2: Settings Max Streams parameter
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_SETTINGS_MAX_STREAMS.
    pub static settings_max_streams: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_max_streams".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4318), meta, 1, 5000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.syn_ratio
    ///
    /// SPDY: SYN Frame Header Ratio (lower better)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram SPDY_SYN_RATIO.
    pub static syn_ratio: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "syn_ratio".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4319), meta, 1, 99, 20, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.syn_reply_ratio
    ///
    /// SPDY: SYN Reply Header Ratio (lower better)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram SPDY_SYN_REPLY_RATIO.
    pub static syn_reply_ratio: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "syn_reply_ratio".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4320), meta, 1, 99, 20, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.syn_reply_size
    ///
    /// SPDY: SYN Reply Header Size
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_SYN_REPLY_SIZE.
    pub static syn_reply_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "syn_reply_size".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4321), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from spdy.syn_size
    ///
    /// SPDY: SYN Frame Header Size
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SPDY_SYN_SIZE.
    pub static syn_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "syn_size".into(),
                category: "spdy".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4322), meta, MemoryUnit::Byte)
    });

}
pub mod websockets {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from websockets.handshake_type
    ///
    /// Websockets Handshake Results (ws-ok-plain, ws-ok-proxy, ws-failed-plain, ws-failed-proxy, wss-ok-plain, wss-ok-proxy, wss-failed-plain, wss-failed-proxy)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEBSOCKETS_HANDSHAKE_TYPE.
    pub static handshake_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "handshake_type".into(),
                category: "websockets".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4323), meta, 0, 16, 17, HistogramType::Linear)
    });

}
pub mod parsing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from parsing.svg_unusual_pcdata
    ///
    /// The rate of svg elements that have child elements during parsing, where their HTML counterpart would not have children.
    pub static svg_unusual_pcdata: Lazy<RateMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "svg_unusual_pcdata".into(),
                category: "parsing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        RateMetric::new(BaseMetricId(4324), meta)
    });

}
pub mod ysod {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownYsodExtra {
        pub r#destroyed: Option<String>,
        pub r#error_code: Option<u32>,
        pub r#hidden: Option<bool>,
        pub r#last_line: Option<String>,
        pub r#last_line_len: Option<u32>,
        pub r#location: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownYsodExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["destroyed", "error_code", "hidden", "last_line", "last_line_len", "location", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#destroyed.and_then(|val| map.insert("destroyed".into(), val.to_string()));
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#hidden.and_then(|val| map.insert("hidden".into(), val.to_string()));
          self.r#last_line.and_then(|val| map.insert("last_line".into(), val.to_string()));
          self.r#last_line_len.and_then(|val| map.insert("last_line_len".into(), val.to_string()));
          self.r#location.and_then(|val| map.insert("location".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ysod.shown_ysod
    ///
    /// This event is recorded only for Firefox UI documents (chrome). Recorded when a Yellow Screen of Death is shown. The `value` is a url on which the error happened. Yellow Screen of Death happens when XML or XHTML document encounters a parsing error. It is commonly a result of the document being malformed or missing DTD entity. This data should be reviewed periodically for urls that error frequently. This event was generated to correspond to the Legacy Telemetry event ysod.shown#ysod.
    pub static shown_ysod: Lazy<EventMetric<ShownYsodExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_ysod".into(),
                category: "ysod".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4325), meta)
    });

}
pub mod cert_signature_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_signature_cache.hits
    ///
    /// How often a certificate signature to be verified is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "cert_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4326), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_signature_cache.total
    ///
    /// How many certificate signature verifications are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "cert_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(4327), meta, vec![CommonMetricData {name: "hits".into(), category: "cert_signature_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert_trust_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_trust_cache.hits
    ///
    /// How often a certificate's trust is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "cert_trust_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4328), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_trust_cache.total
    ///
    /// How many certificate trust lookups are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "cert_trust_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(4329), meta, vec![CommonMetricData {name: "hits".into(), category: "cert_trust_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert_verifier {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CertRevocationMechanismsLabel {
        ECrlite = 0,
        EStapledocsp = 1,
        ECachedocsp = 2,
        EOcsp = 3,
        EOnecrl = 4,
        EShortvalidity = 5,
        __Other__,
    }
    impl From<u16> for CertRevocationMechanismsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrlite,
                1 => Self::EStapledocsp,
                2 => Self::ECachedocsp,
                3 => Self::EOcsp,
                4 => Self::EOnecrl,
                5 => Self::EShortvalidity,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CertRevocationMechanismsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrlite => "CRLite",
                Self::EStapledocsp => "StapledOCSP",
                Self::ECachedocsp => "CachedOCSP",
                Self::EOcsp => "OCSP",
                Self::EOnecrl => "OneCRL",
                Self::EShortvalidity => "ShortValidity",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.cert_revocation_mechanisms
    ///
    /// Which revocation checking mechanisms were used in a TLS handshake?
    pub static cert_revocation_mechanisms: Lazy<LabeledMetric<LabeledCounterMetric, CertRevocationMechanismsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cert_revocation_mechanisms".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4330), meta, Some(vec![::std::borrow::Cow::from("CRLite"), ::std::borrow::Cow::from("CachedOCSP"), ::std::borrow::Cow::from("OCSP"), ::std::borrow::Cow::from("OneCRL"), ::std::borrow::Cow::from("ShortValidity"), ::std::borrow::Cow::from("StapledOCSP")]))
    });

    #[repr(u16)]
    pub enum CrliteStatusLabel {
        ENoFilter = 0,
        ENotCovered = 1,
        ENotEnrolled = 2,
        ENotRevoked = 3,
        ERevokedInFilter = 4,
        ERevokedInStash = 5,
        __Other__,
    }
    impl From<u16> for CrliteStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENoFilter,
                1 => Self::ENotCovered,
                2 => Self::ENotEnrolled,
                3 => Self::ENotRevoked,
                4 => Self::ERevokedInFilter,
                5 => Self::ERevokedInStash,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrliteStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENoFilter => "no_filter",
                Self::ENotCovered => "not_covered",
                Self::ENotEnrolled => "not_enrolled",
                Self::ENotRevoked => "not_revoked",
                Self::ERevokedInFilter => "revoked_in_filter",
                Self::ERevokedInStash => "revoked_in_stash",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.crlite_status
    ///
    /// Counts the number of times different CRLite statuses were returned.
    pub static crlite_status: Lazy<LabeledMetric<LabeledCounterMetric, CrliteStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crlite_status".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4331), meta, Some(vec![::std::borrow::Cow::from("no_filter"), ::std::borrow::Cow::from("not_covered"), ::std::borrow::Cow::from("not_enrolled"), ::std::borrow::Cow::from("not_revoked"), ::std::borrow::Cow::from("revoked_in_filter"), ::std::borrow::Cow::from("revoked_in_stash")]))
    });

    #[repr(u16)]
    pub enum CrliteVsOcspResultLabel {
        ECrliterevocspfail = 0,
        ECrliterevocspok = 1,
        ECrliterevocsprev = 2,
        ECrliterevocspunk = 3,
        ECrliterevocspsoft = 4,
        __Other__,
    }
    impl From<u16> for CrliteVsOcspResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrliterevocspfail,
                1 => Self::ECrliterevocspok,
                2 => Self::ECrliterevocsprev,
                3 => Self::ECrliterevocspunk,
                4 => Self::ECrliterevocspsoft,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CrliteVsOcspResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrliterevocspfail => "CRLiteRevOCSPFail",
                Self::ECrliterevocspok => "CRLiteRevOCSPOk",
                Self::ECrliterevocsprev => "CRLiteRevOCSPRev",
                Self::ECrliterevocspunk => "CRLiteRevOCSPUnk",
                Self::ECrliterevocspsoft => "CRLiteRevOCSPSoft",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.crlite_vs_ocsp_result
    ///
    /// The OCSP result when CRLite claims a certificate is revoked.
    pub static crlite_vs_ocsp_result: Lazy<LabeledMetric<LabeledCounterMetric, CrliteVsOcspResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "crlite_vs_ocsp_result".into(),
                    category: "cert_verifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4332), meta, Some(vec![::std::borrow::Cow::from("CRLiteRevOCSPFail"), ::std::borrow::Cow::from("CRLiteRevOCSPOk"), ::std::borrow::Cow::from("CRLiteRevOCSPRev"), ::std::borrow::Cow::from("CRLiteRevOCSPSoft"), ::std::borrow::Cow::from("CRLiteRevOCSPUnk")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_verifier.trust_obj_count
    ///
    /// The total number of trust objects in cert9.db
    pub static trust_obj_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trust_obj_count".into(),
                category: "cert_verifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4333), meta)
    });

}
pub mod sct_signature_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sct_signature_cache.hits
    ///
    /// How often an SCT signature to be verified is in the cache already.
    pub static hits: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hits".into(),
                category: "sct_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4334), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sct_signature_cache.total
    ///
    /// How many SCT signature verifications are performed.
    pub static total: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "sct_signature_cache".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(4335), meta, vec![CommonMetricData {name: "hits".into(), category: "sct_signature_cache".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

}
pub mod cert {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert.chain_key_size_status
    ///
    /// Does enforcing a larger minimum RSA key size cause verification failures? 1 = no, 2 = yes, 3 = another error prevented finding a verified chain
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_CHAIN_KEY_SIZE_STATUS.
    pub static chain_key_size_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "chain_key_size_status".into(),
                category: "cert".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4336), meta, 0, 4, 5, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert.ev_status
    ///
    /// EV status of a certificate, recorded on each TLS connection. 0=invalid, 1=DV, 2=EV
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_EV_STATUS.
    pub static ev_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ev_status".into(),
                category: "cert".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4337), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert.validation_http_request_result
    ///
    /// HTTP result of OCSP, etc.. (0=canceled, 1=OK, 2=FAILED, 3=internal-error)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_VALIDATION_HTTP_REQUEST_RESULT.
    pub static validation_http_request_result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_http_request_result".into(),
                category: "cert".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4338), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert.validation_success_by_ca
    ///
    /// Successful SSL server cert validations by CA (see RootHashes.inc for names of CAs)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_VALIDATION_SUCCESS_BY_CA_2.
    pub static validation_success_by_ca: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_success_by_ca".into(),
                category: "cert".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4339), meta, 0, 256, 257, HistogramType::Linear)
    });

}
pub mod cert_compression {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum FailuresLabel {
        EZlib = 0,
        EBrotli = 1,
        EZstd = 2,
        __Other__,
    }
    impl From<u16> for FailuresLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EZlib,
                1 => Self::EBrotli,
                2 => Self::EZstd,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FailuresLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EZlib => "zlib",
                Self::EBrotli => "brotli",
                Self::EZstd => "zstd",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_compression.failures
    ///
    /// The number of times each certificate compression algorithm returned an error.
    pub static failures: Lazy<LabeledMetric<LabeledCounterMetric, FailuresLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "failures".into(),
                    category: "cert_compression".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4340), meta, Some(vec![::std::borrow::Cow::from("brotli"), ::std::borrow::Cow::from("zlib"), ::std::borrow::Cow::from("zstd")]))
    });

}
pub mod cert_pinning {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_pinning.failures_by_ca
    ///
    /// Pinning failures by CA (see RootHashes.inc for names of CAs)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_PINNING_FAILURES_BY_CA_2.
    pub static failures_by_ca: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failures_by_ca".into(),
                category: "cert_pinning".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4341), meta, 0, 256, 257, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_pinning.moz_results_by_host
    ///
    /// Certificate pinning results by host for Mozilla operational sites
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_PINNING_MOZ_RESULTS_BY_HOST.
    pub static moz_results_by_host: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "moz_results_by_host".into(),
                category: "cert_pinning".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4342), meta, 0, 512, 513, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_pinning.moz_test_results_by_host
    ///
    /// Certificate pinning test results by host for Mozilla operational sites
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CERT_PINNING_MOZ_TEST_RESULTS_BY_HOST.
    pub static moz_test_results_by_host: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "moz_test_results_by_host".into(),
                category: "cert_pinning".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4343), meta, 0, 512, 513, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ResultsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ResultsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResultsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_pinning.results
    ///
    /// Certificate pinning results (0 = failure, 1 = success)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CERT_PINNING_RESULTS.
    pub static results: Lazy<LabeledMetric<LabeledCounterMetric, ResultsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "results".into(),
                    category: "cert_pinning".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4344), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum TestResultsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TestResultsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TestResultsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cert_pinning.test_results
    ///
    /// Certificate pinning test results (0 = failure, 1 = success)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CERT_PINNING_TEST_RESULTS.
    pub static test_results: Lazy<LabeledMetric<LabeledCounterMetric, TestResultsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "test_results".into(),
                    category: "cert_pinning".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4345), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod cert_storage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_storage.memory
    ///
    /// Heap memory used by cert_storage.
    pub static memory: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory".into(),
                category: "cert_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4346), meta, MemoryUnit::Byte)
    });

}
pub mod cert_verification_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cert_verification_time.failure
    ///
    /// The time it takes to fail to verify a certificate in a TLS handshake.
    pub static failure: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure".into(),
                category: "cert_verification_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4347), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cert_verification_time.success
    ///
    /// The time it takes to successfully verify a certificate in a TLS handshake.
    pub static success: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "success".into(),
                category: "cert_verification_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4348), meta, TimeUnit::Microsecond)
    });

}
pub mod data_storage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.alternate_services
    ///
    /// The number of entries stored in the AlternateServices nsIDataStorage
    pub static alternate_services: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "alternate_services".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4349), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.client_auth_remember_list
    ///
    /// The number of entries stored in the ClientAuthRememberList nsIDataStorage
    pub static client_auth_remember_list: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_auth_remember_list".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4350), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from data_storage.site_security_service_state
    ///
    /// The number of entries stored in the SiteSecurityServiceState nsIDataStorage
    pub static site_security_service_state: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "site_security_service_state".into(),
                category: "data_storage".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4351), meta)
    });

}
pub mod ocsp_request_time {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.cancel
    ///
    /// The time it takes to make an OCSP request that was cancelled.
    pub static cancel: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4352), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.failure
    ///
    /// The time it takes to make an OCSP request that failed.
    pub static failure: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failure".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4353), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ocsp_request_time.success
    ///
    /// The time it takes to make an OCSP request that succeeded.
    pub static success: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "success".into(),
                category: "ocsp_request_time".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4354), meta, TimeUnit::Millisecond)
    });

}
pub mod pkcs11 {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pkcs11.external_trust_anchor_module_loaded
    ///
    /// Whether or not an external trust anchor module was loaded.
    pub static external_trust_anchor_module_loaded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "external_trust_anchor_module_loaded".into(),
                category: "pkcs11".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4355), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pkcs11.third_party_modules_loaded
    ///
    /// The number of third-party PKCS#11 modules loaded.
    pub static third_party_modules_loaded: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_modules_loaded".into(),
                category: "pkcs11".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4356), meta)
    });

}
pub mod ssl {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ssl.auth_algorithm_full
    ///
    /// SSL Authentication Algorithm (null=0, rsa(KEA)=1, ecdsa=4, rsa(sign)=7) in full handshake
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_AUTH_ALGORITHM_FULL.
    pub static auth_algorithm_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auth_algorithm_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4357), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.auth_ecdsa_curve_full
    ///
    /// ECDSA signature curve for TLS_*_ECDSA_* in full handshake (23=P-256, 24=P-384, 25=P-521)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_AUTH_ECDSA_CURVE_FULL.
    pub static auth_ecdsa_curve_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auth_ecdsa_curve_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4358), meta, 0, 36, 37, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.auth_rsa_key_size_full
    ///
    /// RSA signature key size for TLS_*_RSA_* in full handshake
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_AUTH_RSA_KEY_SIZE_FULL.
    pub static auth_rsa_key_size_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auth_rsa_key_size_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4359), meta, 0, 24, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.bytes_before_cert_callback
    ///
    /// plaintext bytes read before a server certificate authenticated
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_BYTES_BEFORE_CERT_CALLBACK.
    pub static bytes_before_cert_callback: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bytes_before_cert_callback".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4360), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.cert_error_overrides
    ///
    /// Was a certificate error overridden on this handshake? What was it? (0=unknown error (indicating bug), 1=no, >1=a specific error)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_CERT_ERROR_OVERRIDES.
    pub static cert_error_overrides: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cert_error_overrides".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4361), meta, 0, 24, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.cert_verification_errors
    ///
    /// If certificate verification failed in a TLS handshake, what was the error? (see MapCertErrorToProbeValue in security/manager/ssl/SSLServerCertVerification.cpp and the values in security/pkix/include/pkix/Result.h)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_CERT_VERIFICATION_ERRORS.
    pub static cert_verification_errors: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cert_verification_errors".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4362), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.ct_policy_non_compliant_connections_by_ca
    ///
    /// Number of successfully established TLS connections NOT compliant with the Certificate Transparency Policy, by CA. See https://searchfox.org/mozilla-central/source/security/manager/ssl/RootHashes.inc for names of CAs. Bucket zero holds CAs not present in the list.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_CT_POLICY_NON_COMPLIANT_CONNECTIONS_BY_CA_2.
    pub static ct_policy_non_compliant_connections_by_ca: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ct_policy_non_compliant_connections_by_ca".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4363), meta, 0, 256, 257, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.kea_dhe_key_size_full
    ///
    /// DHE KEA (TLS_DHE_*) key size in full handshake
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_KEA_DHE_KEY_SIZE_FULL.
    pub static kea_dhe_key_size_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "kea_dhe_key_size_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4364), meta, 0, 24, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.kea_ecdhe_curve_full
    ///
    /// ECDHE KEA (TLS_ECDHE_*) curve (23=P-256, 24=P-384, 25=P-521, 29=Curve25519) in full handshake
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_KEA_ECDHE_CURVE_FULL.
    pub static kea_ecdhe_curve_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "kea_ecdhe_curve_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4365), meta, 0, 36, 37, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.kea_rsa_key_size_full
    ///
    /// RSA KEA (TLS_RSA_*) key size in full handshake
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_KEA_RSA_KEY_SIZE_FULL.
    pub static kea_rsa_key_size_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "kea_rsa_key_size_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4366), meta, 0, 24, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.key_exchange_algorithm_full
    ///
    /// SSL Handshake Key Exchange Algorithm for full handshake (null=0, rsa=1, dh=2, fortezza=3, ecdh=4)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_KEY_EXCHANGE_ALGORITHM_FULL.
    pub static key_exchange_algorithm_full: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "key_exchange_algorithm_full".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4367), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.key_exchange_algorithm_resumed
    ///
    /// SSL Handshake Key Exchange Algorithm for resumed handshake (null=0, rsa=1, dh=2, fortezza=3, ecdh=4)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_KEY_EXCHANGE_ALGORITHM_RESUMED.
    pub static key_exchange_algorithm_resumed: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "key_exchange_algorithm_resumed".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4368), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.npn_type
    ///
    /// NPN Results (0=none, 1=negotiated, 2=no-overlap, 3=selected(alpn))
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_NPN_TYPE.
    pub static npn_type: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "npn_type".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4369), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.ocsp_stapling
    ///
    /// Status of OCSP stapling on this handshake (1=present, good; 2=none; 3=present, expired; 4=present, other error)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_OCSP_STAPLING.
    pub static ocsp_stapling: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ocsp_stapling".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4370), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.permanent_cert_error_overrides
    ///
    /// How many permanent certificate overrides a user has stored.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_PERMANENT_CERT_ERROR_OVERRIDES.
    pub static permanent_cert_error_overrides: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "permanent_cert_error_overrides".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4371), meta, 1, 1024, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.reasons_for_not_false_starting
    ///
    /// Bitmask of reasons we did not false start when libssl would have let us (see key in nsNSSCallbacks.cpp)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_REASONS_FOR_NOT_FALSE_STARTING.
    pub static reasons_for_not_false_starting: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reasons_for_not_false_starting".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4372), meta, 0, 512, 513, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ResumedSessionLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ResumedSessionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ResumedSessionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from ssl.resumed_session
    ///
    /// complete TLS connect that used TLS Session Resumption (collected at same time as SSL_TIME_UNTIL_HANDSHAKE_FINISHED)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram SSL_RESUMED_SESSION.
    pub static resumed_session: Lazy<LabeledMetric<LabeledCounterMetric, ResumedSessionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "resumed_session".into(),
                    category: "ssl".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4373), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.scts_origin
    ///
    /// Origin of Signed Certificate Timestamps received (1=Embedded, 2=TLS handshake extension, 3=Stapled OCSP response)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_SCTS_ORIGIN.
    pub static scts_origin: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scts_origin".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4374), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.scts_per_connection
    ///
    /// Histogram of Signed Certificate Timestamps per SSL connection, from all sources (embedded / OCSP Stapling / TLS handshake). Bucket 0 counts the cases when no SCTs were received, or none were extracted due to parsing errors.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_SCTS_PER_CONNECTION.
    pub static scts_per_connection: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scts_per_connection".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4375), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.scts_verification_status
    ///
    /// Verification status of Signed Certificate Timestamps received (0=Decoding error, 1=Valid SCT, 2=SCT from unknown log, 3=Invalid SCT signature, 4=SCT timestamp is in the future, 5=Valid SCT from a disqualified log)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_SCTS_VERIFICATION_STATUS.
    pub static scts_verification_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "scts_verification_status".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4376), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_handshake_finished_keyed_by_ka
    ///
    /// ms of SSL wait time for full handshake including TCP and proxy tunneling, keyed by the key exchange algorithm used
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_HANDSHAKE_FINISHED_KEYED_BY_KA.
    pub static time_until_handshake_finished_keyed_by_ka: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "time_until_handshake_finished_keyed_by_ka".into(),
                    category: "ssl".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4377), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_ready
    ///
    /// ms of SSL wait time including TCP and proxy tunneling
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_READY.
    pub static time_until_ready: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_until_ready".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4378), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_ready_conservative
    ///
    /// ms of SSL wait time including TCP and proxy tunneling for conservative-mode connections
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_READY_CONSERVATIVE.
    pub static time_until_ready_conservative: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_until_ready_conservative".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4379), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_ready_ech
    ///
    /// ms of SSL wait time including TCP and proxy tunneling for connections using ECH 'Real'
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_READY_ECH.
    pub static time_until_ready_ech: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_until_ready_ech".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4380), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_ready_ech_grease
    ///
    /// ms of SSL wait time including TCP and proxy tunneling for connections using ECH GREASE
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_READY_ECH_GREASE.
    pub static time_until_ready_ech_grease: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_until_ready_ech_grease".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4381), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.time_until_ready_first_try
    ///
    /// ms of SSL wait time including TCP and proxy tunneling for first-try connections
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SSL_TIME_UNTIL_READY_FIRST_TRY.
    pub static time_until_ready_first_try: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_until_ready_first_try".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4382), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls10_intolerance_reason_post
    ///
    /// Potential TLS 1.0 intolerance, after considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS10_INTOLERANCE_REASON_POST.
    pub static tls10_intolerance_reason_post: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls10_intolerance_reason_post".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4383), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls10_intolerance_reason_pre
    ///
    /// Potential TLS 1.0 intolerance, before considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS10_INTOLERANCE_REASON_PRE.
    pub static tls10_intolerance_reason_pre: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls10_intolerance_reason_pre".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4384), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls11_intolerance_reason_post
    ///
    /// Potential TLS 1.1 intolerance, after considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS11_INTOLERANCE_REASON_POST.
    pub static tls11_intolerance_reason_post: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls11_intolerance_reason_post".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4385), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls11_intolerance_reason_pre
    ///
    /// Potential TLS 1.1 intolerance, before considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS11_INTOLERANCE_REASON_PRE.
    pub static tls11_intolerance_reason_pre: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls11_intolerance_reason_pre".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4386), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls12_intolerance_reason_post
    ///
    /// Potential TLS 1.2 intolerance, after considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS12_INTOLERANCE_REASON_POST.
    pub static tls12_intolerance_reason_post: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls12_intolerance_reason_post".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4387), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls12_intolerance_reason_pre
    ///
    /// Potential TLS 1.2 intolerance, before considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS12_INTOLERANCE_REASON_PRE.
    pub static tls12_intolerance_reason_pre: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls12_intolerance_reason_pre".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4388), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls13_intolerance_reason_post
    ///
    /// Potential TLS 1.3 intolerance, after considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS13_INTOLERANCE_REASON_POST.
    pub static tls13_intolerance_reason_post: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls13_intolerance_reason_post".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4389), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.tls13_intolerance_reason_pre
    ///
    /// Potential TLS 1.3 intolerance, before considering historical info (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_TLS13_INTOLERANCE_REASON_PRE.
    pub static tls13_intolerance_reason_pre: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls13_intolerance_reason_pre".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4390), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl.version_fallback_inappropriate
    ///
    /// TLS/SSL version intolerance was falsely detected, server rejected handshake (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_VERSION_FALLBACK_INAPPROPRIATE.
    pub static version_fallback_inappropriate: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version_fallback_inappropriate".into(),
                category: "ssl".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4391), meta, 0, 64, 65, HistogramType::Linear)
    });

}
pub mod ssl_handshake {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.completed
    ///
    /// Type of handshake (1=resumption, 2=false started, 3=chose not to false start, 4=not allowed to false start)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_TYPE.
    pub static completed: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "completed".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4392), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.privacy
    ///
    /// 0th bit - TLS13 used? 1th bit - Revocation Privacy, 2nd bit - DNS Privacy, 3rd bit - ECH Privacy
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_PRIVACY.
    pub static privacy: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4393), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.result
    ///
    /// SSL handshake result, 0=success, 1-255=NSS error offset, 256-511=SEC error offset + 256, 512-639=NSPR error offset + 512, 640-670=PKIX error, 671=unknown err
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_RESULT.
    pub static result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "result".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4394), meta, 0, 672, 673, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.result_conservative
    ///
    /// SSL handshake result for conservative mode connections, 0=success, 1-255=NSS error offset, 256-511=SEC error offset + 256, 512-639=NSPR error offset + 512, 640-670=PKIX error, 671=unknown err
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_RESULT_CONSERVATIVE.
    pub static result_conservative: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "result_conservative".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4395), meta, 0, 672, 673, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.result_ech
    ///
    /// SSL handshake result for connections which used ECH 'Real', 0=success, 1-255=NSS error offset, 256-511=SEC error offset + 256, 512-639=NSPR error offset + 512, 640-670=PKIX error, 671=unknown err
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_RESULT_ECH.
    pub static result_ech: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "result_ech".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4396), meta, 0, 672, 673, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.result_ech_grease
    ///
    /// SSL handshake result for connections which used ECH GREASE, 0=success, 1-255=NSS error offset, 256-511=SEC error offset + 256, 512-639=NSPR error offset + 512, 640-670=PKIX error, 671=unknown err
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_RESULT_ECH_GREASE.
    pub static result_ech_grease: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "result_ech_grease".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4397), meta, 0, 672, 673, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.result_first_try
    ///
    /// SSL handshake result for first-try connections, 0=success, 1-255=NSS error offset, 256-511=SEC error offset + 256, 512-639=NSPR error offset + 512, 640-670=PKIX error, 671=unknown err
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_RESULT_FIRST_TRY.
    pub static result_first_try: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "result_first_try".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4398), meta, 0, 672, 673, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from ssl_handshake.version
    ///
    /// Negotiated SSL Version (1=tls1, 2=tls1.1, 3=tls1.2, 4=tls1.3)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SSL_HANDSHAKE_VERSION.
    pub static version: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "ssl_handshake".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4399), meta, 0, 16, 17, HistogramType::Linear)
    });

}
pub mod tls {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from tls.certificate_verifications
    ///
    /// The total number of successful TLS server certificate verifications.
    pub static certificate_verifications: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "certificate_verifications".into(),
                category: "tls".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(4400), meta, vec![CommonMetricData {name: "built_in_roots_module".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "nss_cert_db".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "preloaded_intermediates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "third_party_certificates".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}, CommonMetricData {name: "tls_handshake".into(), category: "verification_used_cert_from".into(), send_in_pings: vec!["metrics".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from tls.cipher_suite
    ///
    /// Negotiated cipher suite in TLS handshake (see key in AccumulateCipherSuite in nsNSSCallbacks.cpp)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TLS_CIPHER_SUITE.
    pub static cipher_suite: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cipher_suite".into(),
                category: "tls".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4401), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum XyberIntoleranceReasonLabel {
        EPrConnectResetError = 0,
        EPrEndOfFileError = 1,
        ESslErrorBadHandshakeHashValue = 2,
        ESslErrorBadMacAlert = 3,
        ESslErrorBadMacRead = 4,
        ESslErrorDecodeErrorAlert = 5,
        ESslErrorHandshakeFailed = 6,
        ESslErrorHandshakeFailureAlert = 7,
        ESslErrorHandshakeUnexpectedAlert = 8,
        ESslErrorIllegalParameterAlert = 9,
        ESslErrorInternalErrorAlert = 10,
        ESslErrorKeyExchangeFailure = 11,
        ESslErrorNoCypherOverlap = 12,
        ESslErrorProtocolVersionAlert = 13,
        ESslErrorRxUnexpectedRecordType = 14,
        ESslErrorRxMalformedHybridKeyShare = 15,
        ESslErrorUnsupportedVersion = 16,
        __Other__,
    }
    impl From<u16> for XyberIntoleranceReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPrConnectResetError,
                1 => Self::EPrEndOfFileError,
                2 => Self::ESslErrorBadHandshakeHashValue,
                3 => Self::ESslErrorBadMacAlert,
                4 => Self::ESslErrorBadMacRead,
                5 => Self::ESslErrorDecodeErrorAlert,
                6 => Self::ESslErrorHandshakeFailed,
                7 => Self::ESslErrorHandshakeFailureAlert,
                8 => Self::ESslErrorHandshakeUnexpectedAlert,
                9 => Self::ESslErrorIllegalParameterAlert,
                10 => Self::ESslErrorInternalErrorAlert,
                11 => Self::ESslErrorKeyExchangeFailure,
                12 => Self::ESslErrorNoCypherOverlap,
                13 => Self::ESslErrorProtocolVersionAlert,
                14 => Self::ESslErrorRxUnexpectedRecordType,
                15 => Self::ESslErrorRxMalformedHybridKeyShare,
                16 => Self::ESslErrorUnsupportedVersion,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for XyberIntoleranceReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPrConnectResetError => "PR_CONNECT_RESET_ERROR",
                Self::EPrEndOfFileError => "PR_END_OF_FILE_ERROR",
                Self::ESslErrorBadHandshakeHashValue => "SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE",
                Self::ESslErrorBadMacAlert => "SSL_ERROR_BAD_MAC_ALERT",
                Self::ESslErrorBadMacRead => "SSL_ERROR_BAD_MAC_READ",
                Self::ESslErrorDecodeErrorAlert => "SSL_ERROR_DECODE_ERROR_ALERT",
                Self::ESslErrorHandshakeFailed => "SSL_ERROR_HANDSHAKE_FAILED",
                Self::ESslErrorHandshakeFailureAlert => "SSL_ERROR_HANDSHAKE_FAILURE_ALERT",
                Self::ESslErrorHandshakeUnexpectedAlert => "SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT",
                Self::ESslErrorIllegalParameterAlert => "SSL_ERROR_ILLEGAL_PARAMETER_ALERT",
                Self::ESslErrorInternalErrorAlert => "SSL_ERROR_INTERNAL_ERROR_ALERT",
                Self::ESslErrorKeyExchangeFailure => "SSL_ERROR_KEY_EXCHANGE_FAILURE",
                Self::ESslErrorNoCypherOverlap => "SSL_ERROR_NO_CYPHER_OVERLAP",
                Self::ESslErrorProtocolVersionAlert => "SSL_ERROR_PROTOCOL_VERSION_ALERT",
                Self::ESslErrorRxUnexpectedRecordType => "SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE",
                Self::ESslErrorRxMalformedHybridKeyShare => "SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE",
                Self::ESslErrorUnsupportedVersion => "SSL_ERROR_UNSUPPORTED_VERSION",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from tls.xyber_intolerance_reason
    ///
    /// The error that was returned from a failed TLS 1.3 handshake in which the client sent a mlkem768x25519 key share (see tlsIntoleranceTelemetryBucket() in nsNSSIOLayer.cpp).
    pub static xyber_intolerance_reason: Lazy<LabeledMetric<LabeledCounterMetric, XyberIntoleranceReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "xyber_intolerance_reason".into(),
                    category: "tls".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4402), meta, Some(vec![::std::borrow::Cow::from("PR_CONNECT_RESET_ERROR"), ::std::borrow::Cow::from("PR_END_OF_FILE_ERROR"), ::std::borrow::Cow::from("SSL_ERROR_BAD_HANDSHAKE_HASH_VALUE"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_BAD_MAC_READ"), ::std::borrow::Cow::from("SSL_ERROR_DECODE_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILED"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_FAILURE_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_HANDSHAKE_UNEXPECTED_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_ILLEGAL_PARAMETER_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_INTERNAL_ERROR_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_KEY_EXCHANGE_FAILURE"), ::std::borrow::Cow::from("SSL_ERROR_NO_CYPHER_OVERLAP"), ::std::borrow::Cow::from("SSL_ERROR_PROTOCOL_VERSION_ALERT"), ::std::borrow::Cow::from("SSL_ERROR_RX_MALFORMED_HYBRID_KEY_SHARE"), ::std::borrow::Cow::from("SSL_ERROR_RX_UNEXPECTED_RECORD_TYPE"), ::std::borrow::Cow::from("SSL_ERROR_UNSUPPORTED_VERSION")]))
    });

}
pub mod verification_used_cert_from {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.built_in_roots_module
    ///
    /// How many successfully-built certificate chains used a certificate from the built-in roots module.
    pub static built_in_roots_module: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "built_in_roots_module".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4403), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.nss_cert_db
    ///
    /// How many successfully-built certificate chains used a certificate from the NSS cert DB.
    pub static nss_cert_db: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nss_cert_db".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4404), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.preloaded_intermediates
    ///
    /// How many successfully-built certificate chains used a certificate from preloaded intermediates.
    pub static preloaded_intermediates: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "preloaded_intermediates".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4405), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.third_party_certificates
    ///
    /// How many successfully-built certificate chains used a third-party certificate from the OS.
    pub static third_party_certificates: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_certificates".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4406), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from verification_used_cert_from.tls_handshake
    ///
    /// How many successfully-built certificate chains used a certificate from the TLS handshake.
    pub static tls_handshake: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tls_handshake".into(),
                category: "verification_used_cert_from".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4407), meta)
    });

}
pub mod sandbox {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sandbox.failed_launch_keyed
    ///
    /// Error code when a Windows sandboxed process fails to launch, keyed by process type and Windows error code. See https://searchfox.org/mozilla-central/search?q=ResultCode++path%3Asandbox_types.h&redirect=true for definitions of the error codes.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SANDBOX_FAILED_LAUNCH_KEYED.
    pub static failed_launch_keyed: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "failed_launch_keyed".into(),
                    category: "sandbox".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 50, bucket_count: 51, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4408), meta, None)
    });

    #[repr(u16)]
    pub enum HasUserNamespacesLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for HasUserNamespacesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for HasUserNamespacesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sandbox.has_user_namespaces
    ///
    /// Whether our process succedeed in creating a user namespace
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram SANDBOX_HAS_USER_NAMESPACES.
    pub static has_user_namespaces: Lazy<LabeledMetric<LabeledCounterMetric, HasUserNamespacesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "has_user_namespaces".into(),
                    category: "sandbox".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4409), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from sandbox.rejected_syscalls
    ///
    /// System calls blocked by a seccomp-bpf sandbox policy; limited to syscalls where we would crash on Nightly.  The key is generally the architecture and syscall ID but in some cases we include non-personally-identifying information from the syscall arguments; see the function SubmitToTelemetry in security/sandbox/linux/reporter/SandboxReporter.cpp for details.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram SANDBOX_REJECTED_SYSCALLS.
    pub static rejected_syscalls: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "rejected_syscalls".into(),
                    category: "sandbox".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4410), meta, None)
    });

}
pub mod uptake_remotecontent_result {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UptakeNormandyExtra {
        pub r#age: Option<String>,
        pub r#duration: Option<String>,
        pub r#errorName: Option<String>,
        pub r#source: Option<String>,
        pub r#timestamp: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UptakeNormandyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["age", "duration", "errorName", "source", "timestamp", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#age.and_then(|val| map.insert("age".into(), val.to_string()));
          self.r#duration.and_then(|val| map.insert("duration".into(), val.to_string()));
          self.r#errorName.and_then(|val| map.insert("errorName".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#timestamp.and_then(|val| map.insert("timestamp".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from uptake.remotecontent.result.uptake_normandy
    ///
    /// Was the remote content successfully pulled? This uptake telemetry allows to monitor the behaviour of our clients when it comes to fetching data from remote servers. This helps defect-detection and allow observation of the proportion of success among clients and sources, the distribution of error causes, and its evolution over time. This event was generated to correspond to the Legacy Telemetry event uptake.remotecontent.result.uptake#normandy.
    pub static uptake_normandy: Lazy<EventMetric<UptakeNormandyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptake_normandy".into(),
                category: "uptake.remotecontent.result".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4411), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UptakeRemotesettingsExtra {
        pub r#age: Option<String>,
        pub r#duration: Option<String>,
        pub r#errorName: Option<String>,
        pub r#source: Option<String>,
        pub r#timestamp: Option<String>,
        pub r#trigger: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UptakeRemotesettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["age", "duration", "errorName", "source", "timestamp", "trigger", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#age.and_then(|val| map.insert("age".into(), val.to_string()));
          self.r#duration.and_then(|val| map.insert("duration".into(), val.to_string()));
          self.r#errorName.and_then(|val| map.insert("errorName".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#timestamp.and_then(|val| map.insert("timestamp".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from uptake.remotecontent.result.uptake_remotesettings
    ///
    /// Was the remote content successfully pulled? This uptake telemetry allows to monitor the behaviour of our clients when it comes to fetching data from remote servers. This helps defect-detection and allow observation of the proportion of success among clients and sources, the distribution of error causes, and its evolution over time. This event was generated to correspond to the Legacy Telemetry event uptake.remotecontent.result.uptake#remotesettings.
    pub static uptake_remotesettings: Lazy<EventMetric<UptakeRemotesettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptake_remotesettings".into(),
                category: "uptake.remotecontent.result".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4412), meta)
    });

}
pub mod client_association {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from client_association.legacy_client_id
    ///
    /// The legacy Telemetry client ID associated with this user profile.
    pub static legacy_client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "legacy_client_id".into(),
                category: "client_association".into(),
                send_in_pings: vec!["fx-accounts".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(4413), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from client_association.uid
    ///
    /// The Mozilla Account UID associated with the user.
    pub static uid: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uid".into(),
                category: "client_association".into(),
                send_in_pings: vec!["fx-accounts".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4414), meta)
    });

}
pub mod fxa {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ConnectAccountExtra {
        pub r#fxa: Option<String>,
        pub r#sync: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ConnectAccountExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa", "sync", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa.and_then(|val| map.insert("fxa".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa.connect_account
    ///
    /// Records when a Firefox Account, or a Firefox Account service, is explicitly connected from the browser via an intentional user action. This event was generated to correspond to the Legacy Telemetry event fxa.connect#account.
    pub static connect_account: Lazy<EventMetric<ConnectAccountExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "connect_account".into(),
                category: "fxa".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4415), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisconnectAccountExtra {
        pub r#fxa: Option<String>,
        pub r#sync: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisconnectAccountExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa", "sync", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa.and_then(|val| map.insert("fxa".into(), val.to_string()));
          self.r#sync.and_then(|val| map.insert("sync".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa.disconnect_account
    ///
    /// Records when a Firefox Account, or a Firefox Account service, is explicitly disconnected from the browser via an intentional user action. This event was generated to correspond to the Legacy Telemetry event fxa.disconnect#account.
    pub static disconnect_account: Lazy<EventMetric<DisconnectAccountExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disconnect_account".into(),
                category: "fxa".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4416), meta)
    });

}
pub mod sync_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenChooseWhatToSyncMenuExtra {
        pub r#why: Option<String>,
    }

    impl ExtraKeys for OpenChooseWhatToSyncMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["why"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#why.and_then(|val| map.insert("why".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sync_settings.open_choose_what_to_sync_menu
    ///
    /// Records when the user opens the choose what to sync menu.
    pub static open_choose_what_to_sync_menu: Lazy<EventMetric<OpenChooseWhatToSyncMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_choose_what_to_sync_menu".into(),
                category: "sync_settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4417), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sync_settings.save
    ///
    /// Records when the user clicks the save button after opening the choose what to sync menu.
    pub static save: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "sync_settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4418), meta)
    });

}
pub mod fxa_app_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAccountSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickAccountSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_account_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#account_settings.
    pub static click_account_settings: Lazy<EventMetric<ClickAccountSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_account_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4419), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickCadExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickCadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_cad
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#cad.
    pub static click_cad: Lazy<EventMetric<ClickCadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cad".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4420), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLoginExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_login
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#login.
    pub static click_login: Lazy<EventMetric<ClickLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_login".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4421), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMonitorCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickMonitorCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_monitor_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#monitor_cta.
    pub static click_monitor_cta: Lazy<EventMetric<ClickMonitorCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_monitor_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4422), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenMonitorExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickOpenMonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_open_monitor
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#open_monitor.
    pub static click_open_monitor: Lazy<EventMetric<ClickOpenMonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_monitor".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4423), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenSendExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickOpenSendExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_open_send
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#open_send.
    pub static click_open_send: Lazy<EventMetric<ClickOpenSendExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_send".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4424), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickRelayCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickRelayCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_relay_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#relay_cta.
    pub static click_relay_cta: Lazy<EventMetric<ClickRelayCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_relay_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4425), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSendTabExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSendTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_send_tab
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#send_tab.
    pub static click_send_tab: Lazy<EventMetric<ClickSendTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_send_tab".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4426), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#sync_cta.
    pub static click_sync_cta: Lazy<EventMetric<ClickSyncCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4427), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncNowExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncNowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_now
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#sync_now.
    pub static click_sync_now: Lazy<EventMetric<ClickSyncNowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_now".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4428), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#sync_settings.
    pub static click_sync_settings: Lazy<EventMetric<ClickSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4429), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_tabs
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#sync_tabs.
    pub static click_sync_tabs: Lazy<EventMetric<ClickSyncTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4430), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsSidebarExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_sync_tabs_sidebar
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#sync_tabs_sidebar.
    pub static click_sync_tabs_sidebar: Lazy<EventMetric<ClickSyncTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs_sidebar".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4431), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickToolbarIconExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickToolbarIconExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_toolbar_icon
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#toolbar_icon.
    pub static click_toolbar_icon: Lazy<EventMetric<ClickToolbarIconExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_toolbar_icon".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4432), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUnverSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickUnverSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_unver_sync_settings
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#unver_sync_settings.
    pub static click_unver_sync_settings: Lazy<EventMetric<ClickUnverSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_unver_sync_settings".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4433), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickVpnCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_app_menu.click_vpn_cta
    ///
    /// This is recorded on interactions with the FxA menu in the app (hamburger) menu This event was generated to correspond to the Legacy Telemetry event fxa_app_menu.click#vpn_cta.
    pub static click_vpn_cta: Lazy<EventMetric<ClickVpnCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_cta".into(),
                category: "fxa_app_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4434), meta)
    });

}
pub mod fxa_avatar_menu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAccountSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickAccountSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_account_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#account_settings.
    pub static click_account_settings: Lazy<EventMetric<ClickAccountSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_account_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4435), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickCadExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickCadExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_cad
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#cad.
    pub static click_cad: Lazy<EventMetric<ClickCadExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_cad".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4436), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLoginExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_login
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#login.
    pub static click_login: Lazy<EventMetric<ClickLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_login".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4437), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickMonitorCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickMonitorCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_monitor_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#monitor_cta.
    pub static click_monitor_cta: Lazy<EventMetric<ClickMonitorCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_monitor_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4438), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenMonitorExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickOpenMonitorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_open_monitor
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#open_monitor.
    pub static click_open_monitor: Lazy<EventMetric<ClickOpenMonitorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_monitor".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4439), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickOpenSendExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickOpenSendExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_open_send
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#open_send.
    pub static click_open_send: Lazy<EventMetric<ClickOpenSendExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_open_send".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4440), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickRelayCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickRelayCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_relay_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#relay_cta.
    pub static click_relay_cta: Lazy<EventMetric<ClickRelayCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_relay_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4441), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSendTabExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSendTabExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_send_tab
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#send_tab.
    pub static click_send_tab: Lazy<EventMetric<ClickSendTabExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_send_tab".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4442), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#sync_cta.
    pub static click_sync_cta: Lazy<EventMetric<ClickSyncCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4443), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncNowExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncNowExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_now
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#sync_now.
    pub static click_sync_now: Lazy<EventMetric<ClickSyncNowExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_now".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4444), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#sync_settings.
    pub static click_sync_settings: Lazy<EventMetric<ClickSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4445), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_tabs
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#sync_tabs.
    pub static click_sync_tabs: Lazy<EventMetric<ClickSyncTabsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4446), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSyncTabsSidebarExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickSyncTabsSidebarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_sync_tabs_sidebar
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#sync_tabs_sidebar.
    pub static click_sync_tabs_sidebar: Lazy<EventMetric<ClickSyncTabsSidebarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_sync_tabs_sidebar".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4447), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickToolbarIconExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickToolbarIconExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_toolbar_icon
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#toolbar_icon.
    pub static click_toolbar_icon: Lazy<EventMetric<ClickToolbarIconExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_toolbar_icon".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4448), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickUnverSyncSettingsExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickUnverSyncSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_unver_sync_settings
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#unver_sync_settings.
    pub static click_unver_sync_settings: Lazy<EventMetric<ClickUnverSyncSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_unver_sync_settings".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4449), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickVpnCtaExtra {
        pub r#fxa_avatar: Option<String>,
        pub r#fxa_status: Option<String>,
        pub r#fxa_sync_on: Option<String>,
    }

    impl ExtraKeys for ClickVpnCtaExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fxa_avatar", "fxa_status", "fxa_sync_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fxa_avatar.and_then(|val| map.insert("fxa_avatar".into(), val.to_string()));
          self.r#fxa_status.and_then(|val| map.insert("fxa_status".into(), val.to_string()));
          self.r#fxa_sync_on.and_then(|val| map.insert("fxa_sync_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from fxa_avatar_menu.click_vpn_cta
    ///
    /// This is recorded on interactions with the FxA avatar menu on the toolbar This event was generated to correspond to the Legacy Telemetry event fxa_avatar_menu.click#vpn_cta.
    pub static click_vpn_cta: Lazy<EventMetric<ClickVpnCtaExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_vpn_cta".into(),
                category: "fxa_avatar_menu".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4450), meta)
    });

}
pub mod sync {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from sync.device_count_desktop
    ///
    /// Number of desktop devices (including this device) associated with this Sync account. Recorded each time Sync successfully completes the 'clients' engine.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEAVE_DEVICE_COUNT_DESKTOP.
    pub static device_count_desktop: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_count_desktop".into(),
                category: "sync".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4451), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from sync.device_count_mobile
    ///
    /// Number of mobile devices associated with this Sync account. Recorded each time Sync successfully completes the 'clients' engine.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram WEAVE_DEVICE_COUNT_MOBILE.
    pub static device_count_mobile: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_count_mobile".into(),
                category: "sync".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4452), meta, 0, 10, 11, HistogramType::Linear)
    });

}
pub mod sync_merge_dialog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickedExtra {
        pub r#option_clicked: Option<String>,
        pub r#variant_shown: Option<String>,
    }

    impl ExtraKeys for ClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["option_clicked", "variant_shown"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#option_clicked.and_then(|val| map.insert("option_clicked".into(), val.to_string()));
          self.r#variant_shown.and_then(|val| map.insert("variant_shown".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from sync_merge_dialog.clicked
    ///
    /// Event to record that showed the user a warning for potentially merging data from multiple accounts and recorded
    pub static clicked: Lazy<EventMetric<ClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clicked".into(),
                category: "sync_merge_dialog".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4453), meta)
    });

}
pub mod startup_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum RequestsLabel {
        EHitmemory = 0,
        EHitdisk = 1,
        EMiss = 2,
        __Other__,
    }
    impl From<u16> for RequestsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHitmemory,
                1 => Self::EHitdisk,
                2 => Self::EMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHitmemory => "HitMemory",
                Self::EHitdisk => "HitDisk",
                Self::EMiss => "Miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from startup_cache.requests
    ///
    /// Record hits and misses to the startup cache, with categories.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram STARTUP_CACHE_REQUESTS.
    pub static requests: Lazy<LabeledMetric<LabeledCounterMetric, RequestsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "requests".into(),
                    category: "startup_cache".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4454), meta, Some(vec![::std::borrow::Cow::from("HitDisk"), ::std::borrow::Cow::from("HitMemory"), ::std::borrow::Cow::from("Miss")]))
    });

}
pub mod bounce_tracking_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.mode
    ///
    /// Records the pref value of privacy.bounceTrackingProtection.mode. Values are any of nsIBounceTrackingProtection#Modes.
    pub static mode: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mode".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4455), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.num_hosts_per_purge_run
    ///
    /// Number of bounce trackers purged successfully per scheduled purge.
    pub static num_hosts_per_purge_run: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "num_hosts_per_purge_run".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4456), meta, 1, 99, 100, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PurgeActionExtra {
        pub r#bounce_time: Option<u32>,
        pub r#is_dry_run: Option<bool>,
        pub r#require_stateful_bounces: Option<bool>,
        pub r#site_host: Option<String>,
        pub r#success: Option<bool>,
    }

    impl ExtraKeys for PurgeActionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["bounce_time", "is_dry_run", "require_stateful_bounces", "site_host", "success"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#bounce_time.and_then(|val| map.insert("bounce_time".into(), val.to_string()));
          self.r#is_dry_run.and_then(|val| map.insert("is_dry_run".into(), val.to_string()));
          self.r#require_stateful_bounces.and_then(|val| map.insert("require_stateful_bounces".into(), val.to_string()));
          self.r#site_host.and_then(|val| map.insert("site_host".into(), val.to_string()));
          self.r#success.and_then(|val| map.insert("success".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_action
    ///
    /// Dispatched whenever a bounce tracker site is purged.
    pub static purge_action: Lazy<EventMetric<PurgeActionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purge_action".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["bounce-tracking-protection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4457), meta)
    });

    #[repr(u16)]
    pub enum PurgeCountLabel {
        ESuccess = 0,
        EFailure = 1,
        EDry = 2,
        __Other__,
    }
    impl From<u16> for PurgeCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                2 => Self::EDry,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PurgeCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::EDry => "dry",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count
    ///
    /// Counts how often we purge trackers. Giving a high level overview about the effectivness of bounce tracking protection. Allows determining error rate with failure/success label. When in dry mode, we count the purges that would have happened under the dry label.
    pub static purge_count: Lazy<LabeledMetric<LabeledCounterMetric, PurgeCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "purge_count".into(),
                    category: "bounce.tracking.protection".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4458), meta, Some(vec![::std::borrow::Cow::from("dry"), ::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_count_classified_tracker
    ///
    /// Counts sites purged from BTP that are classified as trackers as part of the following lists: [emailtracking-protection, fingerprinting-protection, socialtracking-protection, tracking-protection]
    pub static purge_count_classified_tracker: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4459,
            "bounce.tracking.protection",
            "purge_count_classified_tracker",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from bounce.tracking.protection.purge_duration
    ///
    /// For every purge that is scheduled, we call the ClearDataService to purge persistent storage for each detected bounce tracker. This may do some blocking work on main thread and dispatch some cleanups to other threads. Collect telemetry on how long it takes to clear in the wild to determine whether we need to improve performance here.
    pub static purge_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purge_duration".into(),
                category: "bounce.tracking.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4460), meta, TimeUnit::Nanosecond)
    });

}
pub mod contentblocking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum CanvasFingerprintingPerTabLabel {
        EKnownText = 0,
        EUnknown = 1,
        __Other__,
    }
    impl From<u16> for CanvasFingerprintingPerTabLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EKnownText,
                1 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CanvasFingerprintingPerTabLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EKnownText => "known_text",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.canvas_fingerprinting_per_tab
    ///
    /// Type of canvas fingerprinter detected (keyed by known_fingerprinting_text or unknown), 0 = none
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram CANVAS_FINGERPRINTING_PER_TAB.
    pub static canvas_fingerprinting_per_tab: Lazy<LabeledMetric<LabeledCustomDistributionMetric, CanvasFingerprintingPerTabLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "canvas_fingerprinting_per_tab".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 8, bucket_count: 9, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4461), meta, Some(vec![::std::borrow::Cow::from("known_text"), ::std::borrow::Cow::from("unknown")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.category
    ///
    /// This scalar reports the value of the content blocking category pref (0 = "standard", 1 = "strict", 2 = "custom", 3 = some other value, this is not supported). This metric was generated to correspond to the Legacy Telemetry scalar contentblocking.category.
    pub static category: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "category".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4462), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.cookie_behavior
    ///
    /// Records the cookie behavior pref at startup.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram COOKIE_BEHAVIOR.
    pub static cookie_behavior: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_behavior".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4463), meta, 0, 15, 16, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum CryptominersBlockedCountLabel {
        EPageload = 0,
        EBlocked = 1,
        EAllowed = 2,
        __Other__,
    }
    impl From<u16> for CryptominersBlockedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPageload,
                1 => Self::EBlocked,
                2 => Self::EAllowed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CryptominersBlockedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPageload => "pageLoad",
                Self::EBlocked => "blocked",
                Self::EAllowed => "allowed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.cryptominers_blocked_count
    ///
    /// A count of the status of cryptominer blocking per top level page load. ('pageLoad' = There was a page load, 'blocked' = at least one cryptominer was blocked, 'allowed' = at least one cryptominer was detected and allowed.) Note, pageLoad is used as a baseline measurement.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram CRYPTOMINERS_BLOCKED_COUNT.
    pub static cryptominers_blocked_count: Lazy<LabeledMetric<LabeledCounterMetric, CryptominersBlockedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cryptominers_blocked_count".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4464), meta, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("blocked"), ::std::borrow::Cow::from("pageLoad")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.cryptomining_blocking_enabled
    ///
    /// True if cryptominer blocking is enabled globally at startup. This metric was generated to correspond to the Legacy Telemetry scalar contentblocking.cryptomining_blocking_enabled.
    pub static cryptomining_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cryptomining_blocking_enabled".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4465), meta)
    });

    #[repr(u16)]
    pub enum EmailTrackerCountLabel {
        EBaseNormal = 0,
        EContentNormal = 1,
        EBaseEmailWebapp = 2,
        EContentEmailWebapp = 3,
        __Other__,
    }
    impl From<u16> for EmailTrackerCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBaseNormal,
                1 => Self::EContentNormal,
                2 => Self::EBaseEmailWebapp,
                3 => Self::EContentEmailWebapp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EmailTrackerCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBaseNormal => "base_normal",
                Self::EContentNormal => "content_normal",
                Self::EBaseEmailWebapp => "base_email_webapp",
                Self::EContentEmailWebapp => "content_email_webapp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.email_tracker_count
    ///
    /// A count of the classified email trackers. ('base_normal' = The classified email tracker is in base category and loaded under a normal site, 'content_normal' = The classified email tracker is in content category and loaded under a normal site, 'base_email_webapp' = The classified email tracker is in base category and loaded under a known email webapp, 'content_email_webapp' = The classified email tracker is in content category and loaded under a known email webapp.)
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram EMAIL_TRACKER_COUNT.
    pub static email_tracker_count: Lazy<LabeledMetric<LabeledCounterMetric, EmailTrackerCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "email_tracker_count".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4466), meta, Some(vec![::std::borrow::Cow::from("base_email_webapp"), ::std::borrow::Cow::from("base_normal"), ::std::borrow::Cow::from("content_email_webapp"), ::std::borrow::Cow::from("content_normal")]))
    });

    #[repr(u16)]
    pub enum EmailTrackerEmbeddedPerTabLabel {
        EBaseNormal = 0,
        EContentNormal = 1,
        EAllNormal = 2,
        EBaseEmailapp = 3,
        EContentEmailapp = 4,
        EAllEmailapp = 5,
        __Other__,
    }
    impl From<u16> for EmailTrackerEmbeddedPerTabLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBaseNormal,
                1 => Self::EContentNormal,
                2 => Self::EAllNormal,
                3 => Self::EBaseEmailapp,
                4 => Self::EContentEmailapp,
                5 => Self::EAllEmailapp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EmailTrackerEmbeddedPerTabLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBaseNormal => "base_normal",
                Self::EContentNormal => "content_normal",
                Self::EAllNormal => "all_normal",
                Self::EBaseEmailapp => "base_emailapp",
                Self::EContentEmailapp => "content_emailapp",
                Self::EAllEmailapp => "all_emailapp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.email_tracker_embedded_per_tab
    ///
    /// A count of the embedded third-party email trackers for known email web apps. ('base_normal' = The count of loaded base email trackers under normal sites, 'content_normal' = The count of loaded content email trackers under normal sites, 'all_normal' = The count of all loaded email trackers under normal sites, 'base_emailapp' = The count of loaded base email trackers under email webapps, 'content_emailapp' = The count of loaded content email trackers under email webapps, 'all_emailapp' = The count of all loaded email trackers under email webapps.)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram EMAIL_TRACKER_EMBEDDED_PER_TAB.
    pub static email_tracker_embedded_per_tab: Lazy<LabeledMetric<LabeledCustomDistributionMetric, EmailTrackerEmbeddedPerTabLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "email_tracker_embedded_per_tab".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 1000, bucket_count: 100, histogram_type: HistogramType::Exponential};
        LabeledMetric::new(BaseMetricId(4467), meta, Some(vec![::std::borrow::Cow::from("all_emailapp"), ::std::borrow::Cow::from("all_normal"), ::std::borrow::Cow::from("base_emailapp"), ::std::borrow::Cow::from("base_normal"), ::std::borrow::Cow::from("content_emailapp"), ::std::borrow::Cow::from("content_normal")]))
    });

    #[repr(u16)]
    pub enum FingerprintersBlockedCountLabel {
        EPageload = 0,
        EBlocked = 1,
        EAllowed = 2,
        __Other__,
    }
    impl From<u16> for FingerprintersBlockedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPageload,
                1 => Self::EBlocked,
                2 => Self::EAllowed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FingerprintersBlockedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPageload => "pageLoad",
                Self::EBlocked => "blocked",
                Self::EAllowed => "allowed",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.fingerprinters_blocked_count
    ///
    /// A count of the status of fingerprinter blocking per top level page load. ('pageLoad' = There was a page load, 'blocked' = at least one fingerprinter was blocked, 'allowed' = at least one fingerprinter was detected and allowed.) Note, pageLoad is used as a baseline measurement.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram FINGERPRINTERS_BLOCKED_COUNT.
    pub static fingerprinters_blocked_count: Lazy<LabeledMetric<LabeledCounterMetric, FingerprintersBlockedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "fingerprinters_blocked_count".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4468), meta, Some(vec![::std::borrow::Cow::from("allowed"), ::std::borrow::Cow::from("blocked"), ::std::borrow::Cow::from("pageLoad")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.fingerprinting_blocking_enabled
    ///
    /// True if fingerprinter blocking is enabled globally at startup. This metric was generated to correspond to the Legacy Telemetry scalar contentblocking.fingerprinting_blocking_enabled.
    pub static fingerprinting_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fingerprinting_blocking_enabled".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4469), meta)
    });

    #[repr(u16)]
    pub enum FontFingerprintingPerTabLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for FontFingerprintingPerTabLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FontFingerprintingPerTabLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.font_fingerprinting_per_tab
    ///
    /// Whether a probable font fingerprinting attempt was detected
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram FONT_FINGERPRINTING_PER_TAB.
    pub static font_fingerprinting_per_tab: Lazy<LabeledMetric<LabeledCounterMetric, FontFingerprintingPerTabLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "font_fingerprinting_per_tab".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4470), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum QueryStrippingCountLabel {
        ENavigation = 0,
        ERedirect = 1,
        EStripfornavigation = 2,
        EStripforredirect = 3,
        __Other__,
    }
    impl From<u16> for QueryStrippingCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENavigation,
                1 => Self::ERedirect,
                2 => Self::EStripfornavigation,
                3 => Self::EStripforredirect,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for QueryStrippingCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENavigation => "Navigation",
                Self::ERedirect => "Redirect",
                Self::EStripfornavigation => "StripForNavigation",
                Self::EStripforredirect => "StripForRedirect",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.query_stripping_count
    ///
    /// A count of the query stripping. ('Navigation' = There was a top-level loading via navigation, 'Redirect' = There was a top-level loading via redirect, 'StripForNavigation' = There was a stripping happened for a top-level navigation, 'StripForRedirect' = There was a stripping happened for a top-level redirect.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram QUERY_STRIPPING_COUNT.
    pub static query_stripping_count: Lazy<LabeledMetric<LabeledCounterMetric, QueryStrippingCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "query_stripping_count".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4471), meta, Some(vec![::std::borrow::Cow::from("Navigation"), ::std::borrow::Cow::from("Redirect"), ::std::borrow::Cow::from("StripForNavigation"), ::std::borrow::Cow::from("StripForRedirect")]))
    });

    #[repr(u16)]
    pub enum QueryStrippingCountByParamLabel {
        EParamMcEid = 0,
        EParamOlyAnonId = 1,
        EParamOlyEncId = 2,
        EParamS = 3,
        EParamVeroId = 4,
        EParamHsenc = 5,
        EParamMktTok = 6,
        EParamFbclid = 7,
        EParamGclid = 8,
        EParamDclid = 9,
        EParamMsclkid = 10,
        EParamOpenstat = 11,
        EParamYclid = 12,
        EParamWickedid = 13,
        EParamTwclid = 14,
        EParamHssc = 15,
        EParamHstc = 16,
        EParamHsfp = 17,
        EParamHsctatracking = 18,
        EParamWbraid = 19,
        EParamGbraid = 20,
        EParamYsclid = 21,
        __Other__,
    }
    impl From<u16> for QueryStrippingCountByParamLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParamMcEid,
                1 => Self::EParamOlyAnonId,
                2 => Self::EParamOlyEncId,
                3 => Self::EParamS,
                4 => Self::EParamVeroId,
                5 => Self::EParamHsenc,
                6 => Self::EParamMktTok,
                7 => Self::EParamFbclid,
                8 => Self::EParamGclid,
                9 => Self::EParamDclid,
                10 => Self::EParamMsclkid,
                11 => Self::EParamOpenstat,
                12 => Self::EParamYclid,
                13 => Self::EParamWickedid,
                14 => Self::EParamTwclid,
                15 => Self::EParamHssc,
                16 => Self::EParamHstc,
                17 => Self::EParamHsfp,
                18 => Self::EParamHsctatracking,
                19 => Self::EParamWbraid,
                20 => Self::EParamGbraid,
                21 => Self::EParamYsclid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for QueryStrippingCountByParamLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParamMcEid => "param_mc_eid",
                Self::EParamOlyAnonId => "param_oly_anon_id",
                Self::EParamOlyEncId => "param_oly_enc_id",
                Self::EParamS => "param___s",
                Self::EParamVeroId => "param_vero_id",
                Self::EParamHsenc => "param__hsenc",
                Self::EParamMktTok => "param_mkt_tok",
                Self::EParamFbclid => "param_fbclid",
                Self::EParamGclid => "param_gclid",
                Self::EParamDclid => "param_dclid",
                Self::EParamMsclkid => "param_msclkid",
                Self::EParamOpenstat => "param__openstat",
                Self::EParamYclid => "param_yclid",
                Self::EParamWickedid => "param_wickedid",
                Self::EParamTwclid => "param_twclid",
                Self::EParamHssc => "param___hssc",
                Self::EParamHstc => "param___hstc",
                Self::EParamHsfp => "param___hsfp",
                Self::EParamHsctatracking => "param_hsctatracking",
                Self::EParamWbraid => "param_wbraid",
                Self::EParamGbraid => "param_gbraid",
                Self::EParamYsclid => "param_ysclid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.query_stripping_count_by_param
    ///
    /// Counts how often specific query parameters are stripped.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram QUERY_STRIPPING_COUNT_BY_PARAM.
    pub static query_stripping_count_by_param: Lazy<LabeledMetric<LabeledCounterMetric, QueryStrippingCountByParamLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "query_stripping_count_by_param".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4472), meta, Some(vec![::std::borrow::Cow::from("param___hsfp"), ::std::borrow::Cow::from("param___hssc"), ::std::borrow::Cow::from("param___hstc"), ::std::borrow::Cow::from("param___s"), ::std::borrow::Cow::from("param__hsenc"), ::std::borrow::Cow::from("param__openstat"), ::std::borrow::Cow::from("param_dclid"), ::std::borrow::Cow::from("param_fbclid"), ::std::borrow::Cow::from("param_gbraid"), ::std::borrow::Cow::from("param_gclid"), ::std::borrow::Cow::from("param_hsctatracking"), ::std::borrow::Cow::from("param_mc_eid"), ::std::borrow::Cow::from("param_mkt_tok"), ::std::borrow::Cow::from("param_msclkid"), ::std::borrow::Cow::from("param_oly_anon_id"), ::std::borrow::Cow::from("param_oly_enc_id"), ::std::borrow::Cow::from("param_twclid"), ::std::borrow::Cow::from("param_vero_id"), ::std::borrow::Cow::from("param_wbraid"), ::std::borrow::Cow::from("param_wickedid"), ::std::borrow::Cow::from("param_yclid"), ::std::borrow::Cow::from("param_ysclid")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.query_stripping_param_count
    ///
    /// If query params get stripped, how many per navigation/redirect.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram QUERY_STRIPPING_PARAM_COUNT.
    pub static query_stripping_param_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "query_stripping_param_count".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4473), meta, 1, 100, 25, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum StorageAccessGrantedCountLabel {
        EStoragegranted = 0,
        EStorageaccessapi = 1,
        EOpenerafterui = 2,
        EOpener = 3,
        ERedirect = 4,
        ERedirecttracker = 5,
        ENavigation = 6,
        EStoragegrantedCt = 7,
        EStorageaccessapiCt = 8,
        EOpenerafteruiCt = 9,
        EOpenerCt = 10,
        ERedirectCt = 11,
        ERedirecttrackerCt = 12,
        ENavigationCt = 13,
        __Other__,
    }
    impl From<u16> for StorageAccessGrantedCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EStoragegranted,
                1 => Self::EStorageaccessapi,
                2 => Self::EOpenerafterui,
                3 => Self::EOpener,
                4 => Self::ERedirect,
                5 => Self::ERedirecttracker,
                6 => Self::ENavigation,
                7 => Self::EStoragegrantedCt,
                8 => Self::EStorageaccessapiCt,
                9 => Self::EOpenerafteruiCt,
                10 => Self::EOpenerCt,
                11 => Self::ERedirectCt,
                12 => Self::ERedirecttrackerCt,
                13 => Self::ENavigationCt,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StorageAccessGrantedCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EStoragegranted => "StorageGranted",
                Self::EStorageaccessapi => "StorageAccessAPI",
                Self::EOpenerafterui => "OpenerAfterUI",
                Self::EOpener => "Opener",
                Self::ERedirect => "Redirect",
                Self::ERedirecttracker => "RedirectTracker",
                Self::ENavigation => "Navigation",
                Self::EStoragegrantedCt => "StorageGranted_CT",
                Self::EStorageaccessapiCt => "StorageAccessAPI_CT",
                Self::EOpenerafteruiCt => "OpenerAfterUI_CT",
                Self::EOpenerCt => "Opener_CT",
                Self::ERedirectCt => "Redirect_CT",
                Self::ERedirecttrackerCt => "RedirectTracker_CT",
                Self::ENavigationCt => "Navigation_CT",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.storage_access_granted_count
    ///
    /// A count of the granted storage access. ('StorageGranted' = There was a storage access granted, 'StorageAccessAPI' = the storage access was granted by the storage access API, 'OpenerAfterUserInteraction' = the storage access was granted due to the heuristic 'OpenerAfterUserInteraction', 'Opener' = the storage access was granted due to the heuristic 'Opener', 'Redirect' = the storage access was granted due to the heuristic 'Redirect', 'RedirectTracker' = the storage access was granted due to the heuristic 'RedirectTracker'.) Note, StorageGranted is used as a baseline measurement, which should be the sum of all other measurements. We also duplicate all data reported into a corresponding *_CT label where the grant is given to a known classified tracker.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram STORAGE_ACCESS_GRANTED_COUNT.
    pub static storage_access_granted_count: Lazy<LabeledMetric<LabeledCounterMetric, StorageAccessGrantedCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "storage_access_granted_count".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4474), meta, Some(vec![::std::borrow::Cow::from("Navigation"), ::std::borrow::Cow::from("Navigation_CT"), ::std::borrow::Cow::from("Opener"), ::std::borrow::Cow::from("OpenerAfterUI"), ::std::borrow::Cow::from("OpenerAfterUI_CT"), ::std::borrow::Cow::from("Opener_CT"), ::std::borrow::Cow::from("Redirect"), ::std::borrow::Cow::from("RedirectTracker"), ::std::borrow::Cow::from("RedirectTracker_CT"), ::std::borrow::Cow::from("Redirect_CT"), ::std::borrow::Cow::from("StorageAccessAPI"), ::std::borrow::Cow::from("StorageAccessAPI_CT"), ::std::borrow::Cow::from("StorageGranted"), ::std::borrow::Cow::from("StorageGranted_CT")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.storage_access_remaining_days
    ///
    /// The time remaining until expiration per storage access permissions, in days (one record per permission, not averaged).
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram STORAGE_ACCESS_REMAINING_DAYS.
    pub static storage_access_remaining_days: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_access_remaining_days".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4475), meta, 0, 60, 61, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.strip_on_share_length_decrease
    ///
    /// The decrease in the length of the URL when strip on share is used, only if at least one parameter is stripped
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram STRIP_ON_SHARE_LENGTH_DECREASE.
    pub static strip_on_share_length_decrease: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "strip_on_share_length_decrease".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4476), meta, 1, 1000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.strip_on_share_params_removed
    ///
    /// The number of query parameters removed, if any, when strip on share is used
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram STRIP_ON_SHARE_PARAMS_REMOVED.
    pub static strip_on_share_params_removed: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "strip_on_share_params_removed".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4477), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.trackers_blocked_count
    ///
    /// A count of the number of tracking events blocked. This metric was generated to correspond to the Legacy Telemetry scalar contentblocking.trackers_blocked_count.
    pub static trackers_blocked_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4478,
            "contentblocking",
            "trackers_blocked_count",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum TrackingProtectionEnabledLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TrackingProtectionEnabledLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrackingProtectionEnabledLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.tracking_protection_enabled
    ///
    /// True if tracking protection is enabled globally at startup.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram TRACKING_PROTECTION_ENABLED.
    pub static tracking_protection_enabled: Lazy<LabeledMetric<LabeledCounterMetric, TrackingProtectionEnabledLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tracking_protection_enabled".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4479), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum TrackingProtectionPbmDisabledLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TrackingProtectionPbmDisabledLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TrackingProtectionPbmDisabledLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.tracking_protection_pbm_disabled
    ///
    /// True if tracking protection in Private Browsing mode is disabled at startup.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram TRACKING_PROTECTION_PBM_DISABLED.
    pub static tracking_protection_pbm_disabled: Lazy<LabeledMetric<LabeledCounterMetric, TrackingProtectionPbmDisabledLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "tracking_protection_pbm_disabled".into(),
                    category: "contentblocking".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4480), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from contentblocking.tracking_protection_shield
    ///
    /// Status of the shield icon for each top-level pageload (outside of Private Browsing mode) when tracking protection is enabled (0 = there was a page load, this is used as a baseline, 1 = shield crossed out because CB was disabled on this page by the user, 2 = shield shown because some content was blocked)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram TRACKING_PROTECTION_SHIELD.
    pub static tracking_protection_shield: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tracking_protection_shield".into(),
                category: "contentblocking".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4481), meta, 0, 4, 5, HistogramType::Linear)
    });

}
pub mod cookie_purging {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie_purging.duration
    ///
    /// Time spent per daily cookie purging activity, in milliseconds. This measures the time for all batch iterations of that day.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram COOKIE_PURGING_DURATION_MS.
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "duration".into(),
                category: "cookie_purging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4482), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie_purging.interval_hours
    ///
    /// How much time (in hours) passed between the current cookie purging activity and the one before that (cookie purging is run on 'daily idle')
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram COOKIE_PURGING_INTERVAL_HOURS.
    pub static interval_hours: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "interval_hours".into(),
                category: "cookie_purging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4483), meta, TimeUnit::Hour)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie_purging.origins_purged
    ///
    /// The number of origins that were purged during one run of cookie purging.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram COOKIE_PURGING_ORIGINS_PURGED.
    pub static origins_purged: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "origins_purged".into(),
                category: "cookie_purging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4484), meta, 1, 500, 30, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie_purging.trackers_user_interaction_remaining_days
    ///
    /// The time remaining until expiration per user interaction permissions of trackers at the time of purging, in days (one record per tracker, not averaged).
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram COOKIE_PURGING_TRACKERS_USER_INTERACTION_REMAINING_DAYS.
    pub static trackers_user_interaction_remaining_days: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trackers_user_interaction_remaining_days".into(),
                category: "cookie_purging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4485), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie_purging.trackers_with_user_interaction
    ///
    /// The number of trackers that had user interaction at the time of purging.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram COOKIE_PURGING_TRACKERS_WITH_USER_INTERACTION.
    pub static trackers_with_user_interaction: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trackers_with_user_interaction".into(),
                category: "cookie_purging".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4486), meta, 1, 500, 30, HistogramType::Exponential)
    });

}
pub mod hangs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type ModulesObject = Vec<ModulesObjectItem>;

        pub type ModulesObjectItem = Vec<ModulesObjectItemItem>;

    pub type ModulesObjectItemItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from hangs.modules
    ///
    /// A set of modules found in hang reports sent in the same ping. The data is an array of string pairs (array of 2 strings). The first string of the pair is the module name (eg. "libxul.so"), the second string is the debug id (33 hexadecimal characters) which can be used to fetch the symbols from the Mozilla symbol server.
    pub static modules: Lazy<ObjectMetric<ModulesObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "modules".into(),
                category: "hangs".into(),
                send_in_pings: vec!["hang-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4487), meta)
    });

        pub type ReportsObject = Vec<ReportsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ReportsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub duration: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub thread: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub runnableName: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub process: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub remoteType: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub annotations: ReportsObjectItemItemAnnotations,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub stack: ReportsObjectItemItemStack,
    }

            pub type ReportsObjectItemItemAnnotations = Vec<ReportsObjectItemItemAnnotationsItem>;

        pub type ReportsObjectItemItemAnnotationsItem = Vec<ReportsObjectItemItemAnnotationsItemItem>;

    pub type ReportsObjectItemItemAnnotationsItemItem = String;
            pub type ReportsObjectItemItemStack = Vec<ReportsObjectItemItemStackItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ReportsObjectItemItemStackItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub frame: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub module: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from hangs.reports
    ///
    /// A set of hang reports from Background Hang Reporter.
    /// The data is an array with one item per hang report.
    /// Each hang report is an object with the following fields:
    ///  - duration: detected duration of the hang in milliseconds.
    ///  - thread: the name of the unresponsive thread.
    ///     (eg. "Gecko", "Gecko_Child", "Render")
    ///  - runnableName: the name of the runnable that was in the event
    ///                  loop at the time the stack was captured.
    ///  - process: the type of the process (eg. "default", "tab")
    ///  - remoteType: (optional) the type of remote process. Eg. "webIsolated".
    ///     Will be null for the parent process.
    ///  - annotations: (optional) an array of string pairs (array of 2 strings).
    ///     The first string of the pair will be the annotation name, the second
    ///     will be its value.
    ///  - stack: The frames of the stack that was recorded for the hang, stored
    ///      as an array of objects, one for each stack frame.
    ///      Stack frame objects contain the following fields:
    ///        - frame: either a plain text label or JS frame, or the hex offset
    ///            in the module if the module field is set.
    ///        - module: (optional) Will only be set for native frames, and will
    ///            be a module index (in the array of the 'modules' metric).
    pub static reports: Lazy<ObjectMetric<ReportsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reports".into(),
                category: "hangs".into(),
                send_in_pings: vec!["hang-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4488), meta)
    });

}
pub mod background_tasks_rmdir_base {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4489), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4490), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4491), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.retry_count
    ///
    /// The number of retries before the task started removing the child directory. This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4492), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4493), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4494), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4495), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.base.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.base".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4496), meta)
    });

}
pub mod background_tasks_rmdir_http_cache {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4497), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4498), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4499), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.retry_count
    ///
    /// The number of retries before the task started removing the child directory. This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4500), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4501), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4502), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4503), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.http_cache.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.http_cache".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4504), meta)
    });

}
pub mod background_tasks_rmdir_quota {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.elapsed_ms
    ///
    /// The amount of time the task took for removing the directories.
    pub static elapsed_ms: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed_ms".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4505), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.metric_base
    ///
    /// The base metric template for removeDirectory.
    pub static metric_base: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "metric_base".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4506), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.removal_count
    ///
    /// The number of the removed entries at each call, even if the target directory itself couldn't be removed.
    pub static removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "removal_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4507), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.retry_count
    ///
    /// The number of retries before the task started removing the child directory. This can happen when the target directory doesn't exist.
    pub static retry_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "retry_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4508), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.succeeded
    ///
    /// Whether the target directory removal succeeded.
    pub static succeeded: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeeded".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4509), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_ever_failed
    ///
    /// Whether removing the suffixed directories ever failed.
    pub static suffix_ever_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_ever_failed".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4510), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.suffix_removal_count
    ///
    /// The number of the removed entries of the suffixed directories.
    pub static suffix_removal_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suffix_removal_count".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4511), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from background_tasks.rmdir.quota.was_first
    ///
    /// Whether this task is the first one removing the directory.
    pub static was_first: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "was_first".into(),
                category: "background_tasks.rmdir.quota".into(),
                send_in_pings: vec!["background-tasks".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4512), meta)
    });

}
pub mod captcha_detection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_oc
    ///
    /// Number of times the ArkoseLabs was loaded since last ping submission.
    pub static arkoselabs_oc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4513,
            "captcha_detection",
            "arkoselabs_oc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_oc_pbm
    ///
    /// Number of times the ArkoseLabs was loaded since last ping submission.
    pub static arkoselabs_oc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4514,
            "captcha_detection",
            "arkoselabs_oc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_pc
    ///
    /// How many times the ArkoseLabs challenge was successfully completed.
    pub static arkoselabs_pc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4515,
            "captcha_detection",
            "arkoselabs_pc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_pc_pbm
    ///
    /// How many times the ArkoseLabs challenge was successfully completed.
    pub static arkoselabs_pc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4516,
            "captcha_detection",
            "arkoselabs_pc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_pf
    ///
    /// How many times the ArkoseLabs challenge was failed.
    pub static arkoselabs_pf: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4517,
            "captcha_detection",
            "arkoselabs_pf",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_pf_pbm
    ///
    /// How many times the ArkoseLabs challenge was failed.
    pub static arkoselabs_pf_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4518,
            "captcha_detection",
            "arkoselabs_pf_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_ps
    ///
    /// How many times the ArkoseLabs challenge was shown.
    pub static arkoselabs_ps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4519,
            "captcha_detection",
            "arkoselabs_ps",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_ps_pbm
    ///
    /// How many times the ArkoseLabs challenge was shown.
    pub static arkoselabs_ps_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4520,
            "captcha_detection",
            "arkoselabs_ps_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_solutions_required
    ///
    /// The number of solutions required to complete the ArkoseLabs challenge.
    pub static arkoselabs_solutions_required: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "arkoselabs_solutions_required".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4521), meta, 1, 25, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.arkoselabs_solutions_required_pbm
    ///
    /// The number of solutions required to complete the ArkoseLabs challenge.
    pub static arkoselabs_solutions_required_pbm: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "arkoselabs_solutions_required_pbm".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4522), meta, 1, 25, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_cc
    ///
    /// Number of times the Cloudflare Turnstile challenge was successfully completed since last ping submission.
    pub static cloudflare_turnstile_cc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4523,
            "captcha_detection",
            "cloudflare_turnstile_cc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_cc_pbm
    ///
    /// Number of times the Cloudflare Turnstile challenge was successfully completed since last ping submission.
    pub static cloudflare_turnstile_cc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4524,
            "captcha_detection",
            "cloudflare_turnstile_cc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_cf
    ///
    /// Number of times the Cloudflare Turnstile challenge was failed since last ping submission.
    pub static cloudflare_turnstile_cf: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4525,
            "captcha_detection",
            "cloudflare_turnstile_cf",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_cf_pbm
    ///
    /// Number of times the Cloudflare Turnstile challenge was failed since last ping submission.
    pub static cloudflare_turnstile_cf_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4526,
            "captcha_detection",
            "cloudflare_turnstile_cf_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_oc
    ///
    /// Number of times the Cloudflare Turnstile challenge was loaded since last ping submission.
    pub static cloudflare_turnstile_oc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4527,
            "captcha_detection",
            "cloudflare_turnstile_oc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.cloudflare_turnstile_oc_pbm
    ///
    /// Number of times the Cloudflare Turnstile challenge was loaded since last ping submission.
    pub static cloudflare_turnstile_oc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4528,
            "captcha_detection",
            "cloudflare_turnstile_oc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_bl
    ///
    /// How many times the Datadome blocked a user.
    pub static datadome_bl: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4529,
            "captcha_detection",
            "datadome_bl",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_bl_pbm
    ///
    /// How many times the Datadome blocked a user.
    pub static datadome_bl_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4530,
            "captcha_detection",
            "datadome_bl_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_oc
    ///
    /// Number of times the Datadome was loaded since last ping submission.
    pub static datadome_oc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4531,
            "captcha_detection",
            "datadome_oc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_pc
    ///
    /// How many times the user passed a Datadome puzzle.
    pub static datadome_pc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4532,
            "captcha_detection",
            "datadome_pc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_pc_pbm
    ///
    /// How many times the user completed a Datadome puzzle.
    pub static datadome_pc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4533,
            "captcha_detection",
            "datadome_pc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_ps
    ///
    /// The number of times the Datadome puzzle was shown.
    pub static datadome_ps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4534,
            "captcha_detection",
            "datadome_ps",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.datadome_ps_pbm
    ///
    /// The number of times the Datadome puzzle was shown.
    pub static datadome_ps_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4535,
            "captcha_detection",
            "datadome_ps_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_ac
    ///
    /// Number of times the user completed a Google reCAPTCHA v2 challenge automatically since last ping submission.
    pub static google_recaptcha_v2_ac: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4536,
            "captcha_detection",
            "google_recaptcha_v2_ac",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_ac_pbm
    ///
    /// Number of times the user completed a Google reCAPTCHA v2 challenge automatically since last ping submission.
    pub static google_recaptcha_v2_ac_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4537,
            "captcha_detection",
            "google_recaptcha_v2_ac_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_oc
    ///
    /// Number of times the Google reCAPTCHA v2 was loaded since last ping submission.
    pub static google_recaptcha_v2_oc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4538,
            "captcha_detection",
            "google_recaptcha_v2_oc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_oc_pbm
    ///
    /// Number of times the Google reCAPTCHA v2 was loaded since last ping submission.
    pub static google_recaptcha_v2_oc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4539,
            "captcha_detection",
            "google_recaptcha_v2_oc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_pc
    ///
    /// Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping submission.
    pub static google_recaptcha_v2_pc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4540,
            "captcha_detection",
            "google_recaptcha_v2_pc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_pc_pbm
    ///
    /// Number of times the user completed a Google reCAPTCHA v2 puzzle since last ping submission.
    pub static google_recaptcha_v2_pc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4541,
            "captcha_detection",
            "google_recaptcha_v2_pc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_ps
    ///
    /// Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping submission.
    pub static google_recaptcha_v2_ps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4542,
            "captcha_detection",
            "google_recaptcha_v2_ps",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.google_recaptcha_v2_ps_pbm
    ///
    /// Number of times the user has seen a Google reCAPTCHA v2 puzzle since last ping submission.
    pub static google_recaptcha_v2_ps_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4543,
            "captcha_detection",
            "google_recaptcha_v2_ps_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_ac
    ///
    /// Number of times the user completed an hCaptcha challenge automatically.
    pub static hcaptcha_ac: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4544,
            "captcha_detection",
            "hcaptcha_ac",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_ac_pbm
    ///
    /// Number of times the user completed an hCaptcha challenge automatically.
    pub static hcaptcha_ac_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4545,
            "captcha_detection",
            "hcaptcha_ac_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_oc
    ///
    /// Number of times the hCaptcha was loaded since last ping submission.
    pub static hcaptcha_oc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4546,
            "captcha_detection",
            "hcaptcha_oc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_oc_pbm
    ///
    /// Number of times the hCaptcha was loaded since last ping submission.
    pub static hcaptcha_oc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4547,
            "captcha_detection",
            "hcaptcha_oc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_pc
    ///
    /// Number of times the user completed an hCaptcha puzzle.
    pub static hcaptcha_pc: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4548,
            "captcha_detection",
            "hcaptcha_pc",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_pc_pbm
    ///
    /// Number of times the user completed an hCaptcha puzzle.
    pub static hcaptcha_pc_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4549,
            "captcha_detection",
            "hcaptcha_pc_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_ps
    ///
    /// Number of times the hCaptcha puzzle was shown.
    pub static hcaptcha_ps: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4550,
            "captcha_detection",
            "hcaptcha_ps",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.hcaptcha_ps_pbm
    ///
    /// Number of times the hCaptcha puzzle was shown.
    pub static hcaptcha_ps_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4551,
            "captcha_detection",
            "hcaptcha_ps_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.network_cookie_cookiebehavior
    ///
    /// The user's cookie behavior setting at the time of data collection.
    pub static network_cookie_cookiebehavior: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "network_cookie_cookiebehavior".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4552), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning
    ///
    /// Whether the user has enabled cookie partitioning at the time of data collection.
    pub static network_cookie_cookiebehavior_optinpartitioning: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "network_cookie_cookiebehavior_optinpartitioning".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4553), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.network_cookie_cookiebehavior_optinpartitioning_pbm
    ///
    /// Whether the user has enabled cookie partioning in PBM at the time of data collection.
    pub static network_cookie_cookiebehavior_optinpartitioning_pbm: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "network_cookie_cookiebehavior_optinpartitioning_pbm".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4554), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.pages_visited
    ///
    /// The number of pages visited since the last ping submission.
    pub static pages_visited: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4555,
            "captcha_detection",
            "pages_visited",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.pages_visited_pbm
    ///
    /// The number of pages visited since the last ping submission.
    pub static pages_visited_pbm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4556,
            "captcha_detection",
            "pages_visited_pbm",
            "captcha-detection"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_fingerprintingprotection
    ///
    /// Whether the user has enabled suspected fingerprinters protection at the time of data collection.
    pub static privacy_fingerprintingprotection: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_fingerprintingprotection".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4557), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_fingerprintingprotection_pbm
    ///
    /// Whether the user has enabled suspected fingerprinters protection in PBM at the time of data collection.
    pub static privacy_fingerprintingprotection_pbm: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_fingerprintingprotection_pbm".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4558), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_resistfingerprinting
    ///
    /// Whether the user has enabled resist fingerprinting at the time of data collection.
    pub static privacy_resistfingerprinting: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_resistfingerprinting".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4559), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_resistfingerprinting_pbmode
    ///
    /// Whether the user has enabled resist fingerprinting in PBM at the time of data collection.
    pub static privacy_resistfingerprinting_pbmode: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_resistfingerprinting_pbmode".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4560), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_trackingprotection_cryptomining_enabled
    ///
    /// Whether the user has enabled cryptomining protection at the time of data collection.
    pub static privacy_trackingprotection_cryptomining_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_trackingprotection_cryptomining_enabled".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4561), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_trackingprotection_enabled
    ///
    /// Whether the user has enabled tracking protection at the time of data collection.
    pub static privacy_trackingprotection_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_trackingprotection_enabled".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4562), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_trackingprotection_fingerprinting_enabled
    ///
    /// Whether the user has enabled known fingerprinters protection at the time of data collection.
    pub static privacy_trackingprotection_fingerprinting_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_trackingprotection_fingerprinting_enabled".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4563), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from captcha_detection.privacy_trackingprotection_pbm_enabled
    ///
    /// Whether the user has enabled tracking protection in PBM at the time of data collection.
    pub static privacy_trackingprotection_pbm_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "privacy_trackingprotection_pbm_enabled".into(),
                category: "captcha_detection".into(),
                send_in_pings: vec!["captcha-detection".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4564), meta)
    });

}
pub mod relevancy_classify {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.duration
    ///
    /// Record the duration (in ms) of a successful classification.
    pub static duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "duration".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4565), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FailExtra {
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for FailExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.fail
    ///
    /// Record an event of a failed / aborted user interest classification.
    pub static fail: Lazy<EventMetric<FailExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fail".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4566), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SucceedExtra {
        pub r#input_classified_size: Option<u32>,
        pub r#input_inconclusive_size: Option<u32>,
        pub r#input_size: Option<u32>,
        pub r#interest_top_1_hits: Option<u32>,
        pub r#interest_top_2_hits: Option<u32>,
        pub r#interest_top_3_hits: Option<u32>,
        pub r#output_interest_size: Option<u32>,
    }

    impl ExtraKeys for SucceedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["input_classified_size", "input_inconclusive_size", "input_size", "interest_top_1_hits", "interest_top_2_hits", "interest_top_3_hits", "output_interest_size"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#input_classified_size.and_then(|val| map.insert("input_classified_size".into(), val.to_string()));
          self.r#input_inconclusive_size.and_then(|val| map.insert("input_inconclusive_size".into(), val.to_string()));
          self.r#input_size.and_then(|val| map.insert("input_size".into(), val.to_string()));
          self.r#interest_top_1_hits.and_then(|val| map.insert("interest_top_1_hits".into(), val.to_string()));
          self.r#interest_top_2_hits.and_then(|val| map.insert("interest_top_2_hits".into(), val.to_string()));
          self.r#interest_top_3_hits.and_then(|val| map.insert("interest_top_3_hits".into(), val.to_string()));
          self.r#output_interest_size.and_then(|val| map.insert("output_interest_size".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relevancy.classify.succeed
    ///
    /// Record an event of a successful user interest classification.
    pub static succeed: Lazy<EventMetric<SucceedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "succeed".into(),
                category: "relevancy.classify".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4567), meta)
    });

}
pub mod cookie_banners {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie
    ///
    /// Records the GDPR choice on Google Search based on the "SOCS" cookie of the Google Search domains. The value could be "Accept", "Reject" or "Custom". We use the label to record different choices on different Google domains. We only collect this if the default search engine is Google.
    pub static google_gdpr_choice_cookie: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "google_gdpr_choice_cookie".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4568), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GoogleGdprChoiceCookieEventExtra {
        pub r#choice: Option<String>,
        pub r#region: Option<String>,
        pub r#search_domain: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice", "region", "search_domain"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          self.r#region.and_then(|val| map.insert("region".into(), val.to_string()));
          self.r#search_domain.and_then(|val| map.insert("search_domain".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page. We assess the "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event: Lazy<EventMetric<GoogleGdprChoiceCookieEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "google_gdpr_choice_cookie_event".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4569), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GoogleGdprChoiceCookieEventPbmExtra {
        pub r#choice: Option<String>,
    }

    impl ExtraKeys for GoogleGdprChoiceCookieEventPbmExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["choice"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#choice.and_then(|val| map.insert("choice".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.google_gdpr_choice_cookie_event_pbm
    ///
    /// Recorded whenever a GDPR choice is made on a Google Search page on private browsing windows. We assess the "SOCS" cookie to know the GDPR choice.
    pub static google_gdpr_choice_cookie_event_pbm: Lazy<EventMetric<GoogleGdprChoiceCookieEventPbmExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "google_gdpr_choice_cookie_event_pbm".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4570), meta)
    });

    #[repr(u16)]
    pub enum NormalWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for NormalWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NormalWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.normal_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for normal windows.
    pub static normal_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, NormalWindowServiceModeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "normal_window_service_mode".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4571), meta, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[repr(u16)]
    pub enum PrivateWindowServiceModeLabel {
        EDisabled = 0,
        EReject = 1,
        ERejectOrAccept = 2,
        EInvalid = 3,
        __Other__,
    }
    impl From<u16> for PrivateWindowServiceModeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDisabled,
                1 => Self::EReject,
                2 => Self::ERejectOrAccept,
                3 => Self::EInvalid,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrivateWindowServiceModeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDisabled => "disabled",
                Self::EReject => "reject",
                Self::ERejectOrAccept => "reject_or_accept",
                Self::EInvalid => "invalid",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.private_window_service_mode
    ///
    /// The pref value of the cookie banner service mode for private windows.
    pub static private_window_service_mode: Lazy<LabeledMetric<LabeledBooleanMetric, PrivateWindowServiceModeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "private_window_service_mode".into(),
                    category: "cookie.banners".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4572), meta, Some(vec![::std::borrow::Cow::from("disabled"), ::std::borrow::Cow::from("invalid"), ::std::borrow::Cow::from("reject"), ::std::borrow::Cow::from("reject_or_accept")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cookie.banners.service_detect_only
    ///
    /// Tracks the value of the cookiebanners.service.detectOnly pref.
    pub static service_detect_only: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "service_detect_only".into(),
                category: "cookie.banners".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4573), meta)
    });

}
pub mod crash {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_build
    ///
    /// The build id of the application. This may differ from `client_info` because a main process crash may be reported later by a different (e.g. updated) client.
    pub static app_build: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_build".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4574), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_channel
    ///
    /// The release channel of the application. This may differ from `client_info` because a main process crash may be reported later by a different (e.g. updated) client.
    pub static app_channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_channel".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4575), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.app_display_version
    ///
    /// The version of the application. This may differ from `client_info` because a main process crash may be reported later by a different (e.g. updated) client.
    pub static app_display_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_display_version".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4576), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct AsyncShutdownTimeoutObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub phase: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub conditions: Option<String>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub broken_add_blockers: AsyncShutdownTimeoutObjectItemBrokenAddBlockers,
    }

            pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockers = Vec<AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem>;

    pub type AsyncShutdownTimeoutObjectItemBrokenAddBlockersItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.async_shutdown_timeout
    ///
    /// Present when a shutdown blocker failed to respond within a reasonable amount of time.
    pub static async_shutdown_timeout: Lazy<ObjectMetric<AsyncShutdownTimeoutObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_shutdown_timeout".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4577), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.background_task_name
    ///
    /// The name of the background task if launched as one.
    pub static background_task_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_task_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4578), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.compressed_store_size
    ///
    /// Size (in bytes) of the compressed crash store JSON file.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CRASH_STORE_COMPRESSED_BYTES.
    pub static compressed_store_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compressed_store_size".into(),
                category: "crash".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4579), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.event_loop_nesting_level
    ///
    /// Indicates the nesting level of the event loop.
    pub static event_loop_nesting_level: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_loop_nesting_level".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4580), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.font_name
    ///
    /// The font family name that is being loaded when the crash occurred.
    pub static font_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4581), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.gpu_process_launch
    ///
    /// The number of times that the GPU process was launched.
    pub static gpu_process_launch: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gpu_process_launch".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4582), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.ipc_channel_error
    ///
    /// The error reason for an ipc-based content crash.
    pub static ipc_channel_error: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ipc_channel_error".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4583), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.is_garbage_collecting
    ///
    /// Indicates that the crash occurred while the garbage collector was running.
    pub static is_garbage_collecting: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_garbage_collecting".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4584), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.main_thread_runnable_name
    ///
    /// Name of the currently executing `nsIRunnable` on the main thread. Nightly-only.
    pub static main_thread_runnable_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "main_thread_runnable_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4585), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.minidump_sha256_hash
    ///
    /// The SHA256 hash of the associated minidump file, if any.
    pub static minidump_sha256_hash: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "minidump_sha256_hash".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4586), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.moz_crash_reason
    ///
    /// Contains the string passed to `MOZ_CRASH()`.
    pub static moz_crash_reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "moz_crash_reason".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4587), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.process_type
    ///
    /// The type of process that experienced a crash. See the full list of options [here](https://firefox-source-docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#process-types).
    pub static process_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "process_type".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4588), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.profiler_child_shutdown_phase
    ///
    /// The shutdown phase of the profiler.
    pub static profiler_child_shutdown_phase: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profiler_child_shutdown_phase".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4589), meta)
    });

        pub type QuotaManagerShutdownTimeoutObject = Vec<QuotaManagerShutdownTimeoutObjectItem>;

    pub type QuotaManagerShutdownTimeoutObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from crash.quota_manager_shutdown_timeout
    ///
    /// Contains a list of shutdown steps and status of the quota manager clients.
    pub static quota_manager_shutdown_timeout: Lazy<ObjectMetric<QuotaManagerShutdownTimeoutObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "quota_manager_shutdown_timeout".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4590), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.remote_type
    ///
    /// The type of the content process. See the full list of options [here](https://firefox-source-docs.mozilla.org/toolkit/components/telemetry/data/crash-ping.html#remote-process-types).
    pub static remote_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remote_type".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4591), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.shutdown_progress
    ///
    /// The shutdown phase in which the crash occurred.
    pub static shutdown_progress: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_progress".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4592), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub error: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_type: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_thread: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: StackTracesObjectItemModules,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub threads: StackTracesObjectItemThreads,
    }

            pub type StackTracesObjectItemModules = Vec<StackTracesObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub code_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_file: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub debug_id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub filename: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
    }

            pub type StackTracesObjectItemThreads = Vec<StackTracesObjectItemThreadsItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItem {
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub frames: StackTracesObjectItemThreadsItemItemFrames,
    }

            pub type StackTracesObjectItemThreadsItemItemFrames = Vec<StackTracesObjectItemThreadsItemItemFramesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct StackTracesObjectItemThreadsItemItemFramesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub module_index: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ip: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub trust: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from crash.stack_traces
    ///
    /// Stack trace and module information of the crashing process.
    pub static stack_traces: Lazy<ObjectMetric<StackTracesObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "stack_traces".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4593), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.startup
    ///
    /// If true, the crash occurred during process startup.
    pub static startup: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4594), meta)
    });

    #[repr(u16)]
    pub enum SubmitAttemptLabel {
        EMainCrash = 0,
        EMainHang = 1,
        EContentCrash = 2,
        EContentHang = 3,
        EPluginCrash = 4,
        EPluginHang = 5,
        EGmpluginCrash = 6,
        EGmpluginHang = 7,
        EGpuCrash = 8,
        EGpuHang = 9,
        EVrCrash = 10,
        EVrHang = 11,
        ERddCrash = 12,
        ERddHang = 13,
        ESocketCrash = 14,
        ESocketHang = 15,
        EUtilityCrash = 16,
        EUtilityHang = 17,
        ESandboxbrokerCrash = 18,
        ESandboxbrokerHang = 19,
        EForkserverCrash = 20,
        EForkserverHang = 21,
        __Other__,
    }
    impl From<u16> for SubmitAttemptLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMainCrash,
                1 => Self::EMainHang,
                2 => Self::EContentCrash,
                3 => Self::EContentHang,
                4 => Self::EPluginCrash,
                5 => Self::EPluginHang,
                6 => Self::EGmpluginCrash,
                7 => Self::EGmpluginHang,
                8 => Self::EGpuCrash,
                9 => Self::EGpuHang,
                10 => Self::EVrCrash,
                11 => Self::EVrHang,
                12 => Self::ERddCrash,
                13 => Self::ERddHang,
                14 => Self::ESocketCrash,
                15 => Self::ESocketHang,
                16 => Self::EUtilityCrash,
                17 => Self::EUtilityHang,
                18 => Self::ESandboxbrokerCrash,
                19 => Self::ESandboxbrokerHang,
                20 => Self::EForkserverCrash,
                21 => Self::EForkserverHang,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SubmitAttemptLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMainCrash => "main-crash",
                Self::EMainHang => "main-hang",
                Self::EContentCrash => "content-crash",
                Self::EContentHang => "content-hang",
                Self::EPluginCrash => "plugin-crash",
                Self::EPluginHang => "plugin-hang",
                Self::EGmpluginCrash => "gmplugin-crash",
                Self::EGmpluginHang => "gmplugin-hang",
                Self::EGpuCrash => "gpu-crash",
                Self::EGpuHang => "gpu-hang",
                Self::EVrCrash => "vr-crash",
                Self::EVrHang => "vr-hang",
                Self::ERddCrash => "rdd-crash",
                Self::ERddHang => "rdd-hang",
                Self::ESocketCrash => "socket-crash",
                Self::ESocketHang => "socket-hang",
                Self::EUtilityCrash => "utility-crash",
                Self::EUtilityHang => "utility-hang",
                Self::ESandboxbrokerCrash => "sandboxbroker-crash",
                Self::ESandboxbrokerHang => "sandboxbroker-hang",
                Self::EForkserverCrash => "forkserver-crash",
                Self::EForkserverHang => "forkserver-hang",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from crash.submit_attempt
    ///
    /// An attempt to submit a crash. Keyed on the CrashManager Crash.type.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram PROCESS_CRASH_SUBMIT_ATTEMPT.
    pub static submit_attempt: Lazy<LabeledMetric<LabeledCounterMetric, SubmitAttemptLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "submit_attempt".into(),
                    category: "crash".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4595), meta, Some(vec![::std::borrow::Cow::from("content-crash"), ::std::borrow::Cow::from("content-hang"), ::std::borrow::Cow::from("forkserver-crash"), ::std::borrow::Cow::from("forkserver-hang"), ::std::borrow::Cow::from("gmplugin-crash"), ::std::borrow::Cow::from("gmplugin-hang"), ::std::borrow::Cow::from("gpu-crash"), ::std::borrow::Cow::from("gpu-hang"), ::std::borrow::Cow::from("main-crash"), ::std::borrow::Cow::from("main-hang"), ::std::borrow::Cow::from("plugin-crash"), ::std::borrow::Cow::from("plugin-hang"), ::std::borrow::Cow::from("rdd-crash"), ::std::borrow::Cow::from("rdd-hang"), ::std::borrow::Cow::from("sandboxbroker-crash"), ::std::borrow::Cow::from("sandboxbroker-hang"), ::std::borrow::Cow::from("socket-crash"), ::std::borrow::Cow::from("socket-hang"), ::std::borrow::Cow::from("utility-crash"), ::std::borrow::Cow::from("utility-hang"), ::std::borrow::Cow::from("vr-crash"), ::std::borrow::Cow::from("vr-hang")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.time
    ///
    /// The time at which the crash occurred.
    pub static time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(4596), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.utility_actors_name
    ///
    /// List of IPC actor names running on a utility process instance (if the crashing process was a utility process).
    pub static utility_actors_name: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "utility_actors_name".into(),
                category: "crash".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(4597), meta)
    });

}
pub mod crash_windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.error_reporting
    ///
    /// Indicates if the crash was intercepted by the Windows Error Reporting runtime exception module.
    pub static error_reporting: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error_reporting".into(),
                category: "crash.windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4598), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash.windows.file_dialog_error_code
    ///
    /// The HRESULT returned from a Win32 system call leading to termination of the file-dialog utility process. MozCrashReason is expected to provide context for the value.
    pub static file_dialog_error_code: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "file_dialog_error_code".into(),
                category: "crash.windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4599), meta)
    });

}
pub mod crash_submission {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.channel_status
    ///
    /// Collecting XHR channel status on error code when statusCode == 0.
    pub static channel_status: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "channel_status".into(),
                    category: "crash_submission".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4600), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.collector_errors
    ///
    /// Amount and error name reported when performing crash submission.
    pub static collector_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "collector_errors".into(),
                    category: "crash_submission".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4601), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.failure
    ///
    /// Number of failed crash report submissions
    pub static failure: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4602,
            "crash_submission",
            "failure",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.pending
    ///
    /// Number of pending crash report submissions
    pub static pending: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4603,
            "crash_submission",
            "pending",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from crash_submission.success
    ///
    /// Number of successfull crash report submissions
    pub static success: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4604,
            "crash_submission",
            "success",
            "metrics"
        )
    });

}
pub mod dll_blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.init_failed
    ///
    /// Indicates whether initialization of the DLL blocklist failed.
    pub static init_failed: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "init_failed".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4605), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.list
    ///
    /// A list of blocked DLLs.
    pub static list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "list".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(4606), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from dll_blocklist.user32_loaded_before
    ///
    /// Indicates whether `user32.dll` was loaded before the DLL blocklist was initialized.
    pub static user32_loaded_before: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user32_loaded_before".into(),
                category: "dll_blocklist".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4607), meta)
    });

}
pub mod environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from environment.headless_mode
    ///
    /// Whether the app was invoked in headless mode via `--headless` or `--backgroundtask`.
    pub static headless_mode: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "headless_mode".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4608), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.nimbus_enrollments
    ///
    /// The active Nimbus experiments and rollouts, as well as their branches.
    pub static nimbus_enrollments: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "nimbus_enrollments".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(4609), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from environment.uptime
    ///
    /// The start time of the application.
    pub static uptime: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uptime".into(),
                category: "environment".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4610), meta, TimeUnit::Millisecond)
    });

}
pub mod memory {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_commit
    ///
    /// Available commit size.
    pub static available_commit: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_commit".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4611), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_physical
    ///
    /// Available physical memory.
    pub static available_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4612), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_swap
    ///
    /// Available swap memory.
    pub static available_swap: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_swap".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4613), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.available_virtual
    ///
    /// Available virtual memory.
    pub static available_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available_virtual".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4614), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.low_physical
    ///
    /// The number of times the available memory tracker has detected that free physical memory is running low.
    pub static low_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "low_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4615), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.oom_allocation_size
    ///
    /// The size of the allocation that caused on OOM crash.
    pub static oom_allocation_size: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "oom_allocation_size".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4616), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.purgeable_physical
    ///
    /// The amount of memory that can be deallocated by the OS in case of memory pressure.
    pub static purgeable_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "purgeable_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4617), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.system_use_percentage
    ///
    /// The percentage of memory in use.
    pub static system_use_percentage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_use_percentage".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4618), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.texture
    ///
    /// The amount of memory used in textures.
    pub static texture: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "texture".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4619), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_page_file
    ///
    /// The total page file size.
    pub static total_page_file: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_page_file".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4620), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_physical
    ///
    /// The total physical memory.
    pub static total_physical: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4621), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total_virtual
    ///
    /// The total virtual memory.
    pub static total_virtual: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_virtual".into(),
                category: "memory".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4622), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.collection_time
    ///
    /// Time spent gathering memory telemetry in milliseconds
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_COLLECTION_TIME.
    pub static collection_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "collection_time".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4623), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.distribution_among_content
    ///
    /// Absolute difference of each content process' USS and the mean of USS's, normalized by the mean, in percentage. It will be recorded with the rest of the memory probes when gatherMemory is called, if at least 2 content processes are alive. Example: in case of 4 content processes with USS's: 1G, 500MB, 1G, 1.5G, the reported numbers will be: 0, 50, 0, 50. Which indicates that 2 processes used 50% more or 50% less memory than the avarage and 2 used exactly as much as the avarage.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram MEMORY_DISTRIBUTION_AMONG_CONTENT.
    pub static distribution_among_content: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "distribution_among_content".into(),
                    category: "memory".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 200, bucket_count: 100, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4624), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.free_purged_pages
    ///
    /// Time(ms) to purge dirty heap pages.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_FREE_PURGED_PAGES_MS.
    pub static free_purged_pages: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "free_purged_pages".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4625), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.ghost_windows
    ///
    /// Number of ghost windows
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram GHOST_WINDOWS.
    pub static ghost_windows: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ghost_windows".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4626), meta, 1, 128, 32, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.heap_allocated
    ///
    /// Heap memory allocated (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_HEAP_ALLOCATED.
    pub static heap_allocated: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "heap_allocated".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4627), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.heap_overhead_fraction
    ///
    /// Fraction of committed heap memory that is overhead (percentage).
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram MEMORY_HEAP_OVERHEAD_FRACTION.
    pub static heap_overhead_fraction: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "heap_overhead_fraction".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4628), meta, 1, 100, 25, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.images_content_used_uncompressed
    ///
    /// Memory used for uncompressed, in-use content images (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_IMAGES_CONTENT_USED_UNCOMPRESSED.
    pub static images_content_used_uncompressed: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "images_content_used_uncompressed".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4629), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.js_compartments_system
    ///
    /// Total JavaScript compartments used for add-ons and internals.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_JS_COMPARTMENTS_SYSTEM.
    pub static js_compartments_system: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_compartments_system".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4630), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.js_compartments_user
    ///
    /// Total JavaScript compartments used for web pages
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_JS_COMPARTMENTS_USER.
    pub static js_compartments_user: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_compartments_user".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4631), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.js_gc_heap
    ///
    /// Memory used by the garbage-collected JavaScript heap (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_JS_GC_HEAP.
    pub static js_gc_heap: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_gc_heap".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4632), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.js_realms_system
    ///
    /// Total JavaScript realms used for add-ons and internals.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_JS_REALMS_SYSTEM.
    pub static js_realms_system: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_realms_system".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4633), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.js_realms_user
    ///
    /// Total JavaScript realms used for web pages.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_JS_REALMS_USER.
    pub static js_realms_user: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_realms_user".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4634), meta, 1, 1000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.low_memory_events_physical
    ///
    /// Number of low-physical-memory events fired since last ping
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram LOW_MEMORY_EVENTS_PHYSICAL.
    pub static low_memory_events_physical: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "low_memory_events_physical".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4635), meta, 1, 1024, 21, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.page_faults_hard
    ///
    /// Hard page faults (since last telemetry ping)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PAGE_FAULTS_HARD.
    pub static page_faults_hard: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_faults_hard".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4636), meta, 8, 65536, 13, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.resident_fast
    ///
    /// Resident memory size (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_RESIDENT_FAST.
    pub static resident_fast: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resident_fast".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4637), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.resident_peak
    ///
    /// Peak resident memory size (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_RESIDENT_PEAK.
    pub static resident_peak: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resident_peak".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4638), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.storage_sqlite
    ///
    /// Memory used by SQLite (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_STORAGE_SQLITE.
    pub static storage_sqlite: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_sqlite".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4639), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.total
    ///
    /// Total Memory Across All Processes (KB) (inaccurate WRT shared memory. See MemoryTelemetry.cpp)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_TOTAL.
    pub static total: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4640), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.unique
    ///
    /// Unique Set Size (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_UNIQUE.
    pub static unique: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unique".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4641), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.unique_content_startup
    ///
    /// Unique Set Size of Content Process at Startup (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_UNIQUE_CONTENT_STARTUP.
    pub static unique_content_startup: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unique_content_startup".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4642), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.vsize
    ///
    /// Virtual memory size (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_VSIZE.
    pub static vsize: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vsize".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4643), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory.vsize_max_contiguous
    ///
    /// Maximum-sized block of contiguous virtual memory (KB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_VSIZE_MAX_CONTIGUOUS.
    pub static vsize_max_contiguous: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vsize_max_contiguous".into(),
                category: "memory".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4644), meta, MemoryUnit::Kilobyte)
    });

}
pub mod windows {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from windows.package_family_name
    ///
    /// The Package Family Name of Firefox, if installed through an MSIX package.
    pub static package_family_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "package_family_name".into(),
                category: "windows".into(),
                send_in_pings: vec!["crash".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4645), meta)
    });

}
pub mod doh {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EvaluateV2HeuristicsExtra {
        pub r#canaries: Option<String>,
        pub r#captiveState: Option<String>,
        pub r#enterprise: Option<String>,
        pub r#evaluateReason: Option<String>,
        pub r#filtering: Option<String>,
        pub r#networkID: Option<String>,
        pub r#platform: Option<String>,
        pub r#steeredProvider: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EvaluateV2HeuristicsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["canaries", "captiveState", "enterprise", "evaluateReason", "filtering", "networkID", "platform", "steeredProvider", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#canaries.and_then(|val| map.insert("canaries".into(), val.to_string()));
          self.r#captiveState.and_then(|val| map.insert("captiveState".into(), val.to_string()));
          self.r#enterprise.and_then(|val| map.insert("enterprise".into(), val.to_string()));
          self.r#evaluateReason.and_then(|val| map.insert("evaluateReason".into(), val.to_string()));
          self.r#filtering.and_then(|val| map.insert("filtering".into(), val.to_string()));
          self.r#networkID.and_then(|val| map.insert("networkID".into(), val.to_string()));
          self.r#platform.and_then(|val| map.insert("platform".into(), val.to_string()));
          self.r#steeredProvider.and_then(|val| map.insert("steeredProvider".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.evaluate_v2_heuristics
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.evaluate_v2#heuristics.
    pub static evaluate_v2_heuristics: Lazy<EventMetric<EvaluateV2HeuristicsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_v2_heuristics".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4646), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#disabled.
    pub static state_disabled: Lazy<EventMetric<StateDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4647), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateEnabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateEnabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_enabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#enabled.
    pub static state_enabled: Lazy<EventMetric<StateEnabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_enabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4648), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateManuallyDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateManuallyDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_manually_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#manuallyDisabled.
    pub static state_manually_disabled: Lazy<EventMetric<StateManuallyDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_manually_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4649), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StatePolicyDisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StatePolicyDisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_policy_disabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#policyDisabled.
    pub static state_policy_disabled: Lazy<EventMetric<StatePolicyDisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_policy_disabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4650), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateRollbackExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_rollback
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#rollback.
    pub static state_rollback: Lazy<EventMetric<StateRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_rollback".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4651), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateShutdownExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateShutdownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_shutdown
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#shutdown.
    pub static state_shutdown: Lazy<EventMetric<StateShutdownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_shutdown".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4652), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUidisabledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUidisabledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uidisabled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#UIDisabled.
    pub static state_uidisabled: Lazy<EventMetric<StateUidisabledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uidisabled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4653), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUiokExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUiokExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uiok
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#UIOk.
    pub static state_uiok: Lazy<EventMetric<StateUiokExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uiok".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4654), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StateUninstalledExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for StateUninstalledExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from doh.state_uninstalled
    ///
    /// Results of DoH heuristics at startup and after network changes. This event was generated to correspond to the Legacy Telemetry event doh.state#uninstalled.
    pub static state_uninstalled: Lazy<EventMetric<StateUninstalledExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_uninstalled".into(),
                category: "doh".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4655), meta)
    });

}
pub mod security_doh_trr_performance {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResolvedRecordExtra {
        pub r#captivePortal: Option<String>,
        pub r#domain: Option<String>,
        pub r#networkUnstable: Option<String>,
        pub r#retryCount: Option<String>,
        pub r#status: Option<String>,
        pub r#time: Option<String>,
        pub r#trr: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ResolvedRecordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["captivePortal", "domain", "networkUnstable", "retryCount", "status", "time", "trr", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#captivePortal.and_then(|val| map.insert("captivePortal".into(), val.to_string()));
          self.r#domain.and_then(|val| map.insert("domain".into(), val.to_string()));
          self.r#networkUnstable.and_then(|val| map.insert("networkUnstable".into(), val.to_string()));
          self.r#retryCount.and_then(|val| map.insert("retryCount".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          self.r#trr.and_then(|val| map.insert("trr".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.trr_performance.resolved_record
    ///
    /// How long it took to resolve a test domain using TRR. This event was generated to correspond to the Legacy Telemetry event security.doh.trrPerformance.resolved#record.
    pub static resolved_record: Lazy<EventMetric<ResolvedRecordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resolved_record".into(),
                category: "security.doh.trr_performance".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4656), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TrrselectDryrunresultExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TrrselectDryrunresultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.trr_performance.trrselect_dryrunresult
    ///
    /// The URL of the DoH provider chosen by the TRR selection dry-run This event was generated to correspond to the Legacy Telemetry event security.doh.trrPerformance.trrselect#dryrunresult.
    pub static trrselect_dryrunresult: Lazy<EventMetric<TrrselectDryrunresultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "trrselect_dryrunresult".into(),
                category: "security.doh.trr_performance".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4657), meta)
    });

}
pub mod policies {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from policies.count
    ///
    /// A uint with the number of active enterprise policies, collected once at startup. This metric was generated to correspond to the Legacy Telemetry scalar policies.count.
    pub static count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "count".into(),
                category: "policies".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4658), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from policies.is_enterprise
    ///
    /// Attempt to determine if the user is an enterprise user based on various signals. This metric was generated to correspond to the Legacy Telemetry scalar policies.is_enterprise.
    pub static is_enterprise: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_enterprise".into(),
                category: "policies".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4659), meta)
    });

}
pub mod extensions {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ProcessEventLabel {
        ECrashedBg = 0,
        ECrashedFg = 1,
        ECreatedBg = 2,
        ECreatedFg = 3,
        ECrashedOverThresholdBg = 4,
        ECrashedOverThresholdFg = 5,
        __Other__,
    }
    impl From<u16> for ProcessEventLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECrashedBg,
                1 => Self::ECrashedFg,
                2 => Self::ECreatedBg,
                3 => Self::ECreatedFg,
                4 => Self::ECrashedOverThresholdBg,
                5 => Self::ECrashedOverThresholdFg,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ProcessEventLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECrashedBg => "crashed_bg",
                Self::ECrashedFg => "crashed_fg",
                Self::ECreatedBg => "created_bg",
                Self::ECreatedFg => "created_fg",
                Self::ECrashedOverThresholdBg => "crashed_over_threshold_bg",
                Self::ECrashedOverThresholdFg => "crashed_over_threshold_fg",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.process_event
    ///
    /// Counters for how many times the extension process has crashed or been created.
    /// The labels with "_fg" / "_bg" suffixes are only recorded in Android builds,
    /// while the "created" and "crashed" labels are recorded on both Desktop and Android
    /// builds.
    pub static process_event: Lazy<LabeledMetric<LabeledCounterMetric, ProcessEventLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "process_event".into(),
                    category: "extensions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4660), meta, Some(vec![::std::borrow::Cow::from("crashed_bg"), ::std::borrow::Cow::from("crashed_fg"), ::std::borrow::Cow::from("crashed_over_threshold_bg"), ::std::borrow::Cow::from("crashed_over_threshold_fg"), ::std::borrow::Cow::from("created_bg"), ::std::borrow::Cow::from("created_fg")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_load_time
    ///
    /// Time to load and deserialize the extensions startupCache data.
    pub static startup_cache_load_time: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_load_time".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4661), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_read_errors
    ///
    /// The number of times an unexpected error has been raised while reading
    /// the extensions StartupCache file.
    pub static startup_cache_read_errors: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "startup_cache_read_errors".into(),
                    category: "extensions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4662), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.startup_cache_write_bytelength
    ///
    /// The amount of bytes written to the extensions StartupCache file.
    pub static startup_cache_write_bytelength: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_bytelength".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4663), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_policy
    ///
    /// Corresponds to the value of `WebExtensionPolicy.useRemoteWebExtensions`.
    pub static use_remote_policy: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_remote_policy".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4664), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.use_remote_pref
    ///
    /// Corresponds to the value of `extensions.webextensions.remote` pref.
    pub static use_remote_pref: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_remote_pref".into(),
                category: "extensions".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4665), meta)
    });

}
pub mod extensions_apis_dnr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_count_max
    ///
    /// Max amount of DNR rules being evaluated.
    pub static evaluate_rules_count_max: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_rules_count_max".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4666), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.evaluate_rules_time
    ///
    /// Amount of time it takes to evaluate DNR rules for one network request.
    pub static evaluate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "evaluate_rules_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4667), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum StartupCacheEntriesLabel {
        EHit = 0,
        EMiss = 1,
        __Other__,
    }
    impl From<u16> for StartupCacheEntriesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EHit,
                1 => Self::EMiss,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StartupCacheEntriesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EHit => "hit",
                Self::EMiss => "miss",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_entries
    ///
    /// Counters for startup cache data hits or misses on initializating
    /// DNR rules for extensions loaded on application startup.
    pub static startup_cache_entries: Lazy<LabeledMetric<LabeledCounterMetric, StartupCacheEntriesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "startup_cache_entries".into(),
                    category: "extensions.apis.dnr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4668), meta, Some(vec![::std::borrow::Cow::from("hit"), ::std::borrow::Cow::from("miss")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_size
    ///
    /// Amount of data read from the DNR startup cache file.
    pub static startup_cache_read_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_read_size".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4669), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_read_time
    ///
    /// Amount of time it takes to read data into the DNR startup cache file.
    pub static startup_cache_read_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_read_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4670), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_size
    ///
    /// Amount of data written to the DNR startup cache file.
    pub static startup_cache_write_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_size".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4671), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.startup_cache_write_time
    ///
    /// Amount of time it takes to write data into the DNR startup cache file.
    pub static startup_cache_write_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_cache_write_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4672), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.apis.dnr.validate_rules_time
    ///
    /// Amount of time it takes to validate DNR rules of individual ruleset
    /// when dynamic or static rulesets have been loaded from disk.
    pub static validate_rules_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validate_rules_time".into(),
                category: "extensions.apis.dnr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4673), meta, TimeUnit::Millisecond)
    });

}
pub mod extensions_counters {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BrowserActionPreloadResultLabel {
        EPopupshown = 0,
        EClearafterhover = 1,
        EClearaftermousedown = 2,
        __Other__,
    }
    impl From<u16> for BrowserActionPreloadResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPopupshown,
                1 => Self::EClearafterhover,
                2 => Self::EClearaftermousedown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BrowserActionPreloadResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPopupshown => "popupShown",
                Self::EClearafterhover => "clearAfterHover",
                Self::EClearaftermousedown => "clearAfterMousedown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.browser_action_preload_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the labels.
    pub static browser_action_preload_result: Lazy<LabeledMetric<LabeledCounterMetric, BrowserActionPreloadResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "browser_action_preload_result".into(),
                    category: "extensions.counters".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4674), meta, Some(vec![::std::borrow::Cow::from("clearAfterHover"), ::std::borrow::Cow::from("clearAfterMousedown"), ::std::borrow::Cow::from("popupShown")]))
    });

    #[repr(u16)]
    pub enum EventPageIdleResultLabel {
        ESuspend = 0,
        EResetOther = 1,
        EResetEvent = 2,
        EResetListeners = 3,
        EResetNativeapp = 4,
        EResetStreamfilter = 5,
        EResetParentapicall = 6,
        EPermissionsRequest = 7,
        ELaunchwebauthflow = 8,
        __Other__,
    }
    impl From<u16> for EventPageIdleResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuspend,
                1 => Self::EResetOther,
                2 => Self::EResetEvent,
                3 => Self::EResetListeners,
                4 => Self::EResetNativeapp,
                5 => Self::EResetStreamfilter,
                6 => Self::EResetParentapicall,
                7 => Self::EPermissionsRequest,
                8 => Self::ELaunchwebauthflow,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventPageIdleResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuspend => "suspend",
                Self::EResetOther => "reset_other",
                Self::EResetEvent => "reset_event",
                Self::EResetListeners => "reset_listeners",
                Self::EResetNativeapp => "reset_nativeapp",
                Self::EResetStreamfilter => "reset_streamfilter",
                Self::EResetParentapicall => "reset_parentapicall",
                Self::EPermissionsRequest => "permissions_request",
                Self::ELaunchwebauthflow => "launchWebAuthFlow",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.counters.event_page_idle_result
    ///
    /// Number of times an event page hit the idle timeout and results in one of the labels.
    pub static event_page_idle_result: Lazy<LabeledMetric<LabeledCounterMetric, EventPageIdleResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "event_page_idle_result".into(),
                    category: "extensions.counters".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Application,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4675), meta, Some(vec![::std::borrow::Cow::from("launchWebAuthFlow"), ::std::borrow::Cow::from("permissions_request"), ::std::borrow::Cow::from("reset_event"), ::std::borrow::Cow::from("reset_listeners"), ::std::borrow::Cow::from("reset_nativeapp"), ::std::borrow::Cow::from("reset_other"), ::std::borrow::Cow::from("reset_parentapicall"), ::std::borrow::Cow::from("reset_streamfilter"), ::std::borrow::Cow::from("suspend")]))
    });

}
pub mod extensions_data {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrateResultExtra {
        pub r#addon_id: Option<String>,
        pub r#backend: Option<String>,
        pub r#data_migrated: Option<String>,
        pub r#error_name: Option<String>,
        pub r#has_jsonfile: Option<String>,
        pub r#has_olddata: Option<String>,
    }

    impl ExtraKeys for MigrateResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "backend", "data_migrated", "error_name", "has_jsonfile", "has_olddata"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#backend.and_then(|val| map.insert("backend".into(), val.to_string()));
          self.r#data_migrated.and_then(|val| map.insert("data_migrated".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#has_jsonfile.and_then(|val| map.insert("has_jsonfile".into(), val.to_string()));
          self.r#has_olddata.and_then(|val| map.insert("has_olddata".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.migrate_result
    ///
    /// These events are sent when an extension is migrating its data to the new
    /// IndexedDB backend.
    pub static migrate_result: Lazy<EventMetric<MigrateResultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migrate_result".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4676), meta)
    });

    #[repr(u16)]
    pub enum MigrateResultCountLabel {
        ESuccess = 0,
        EFailure = 1,
        __Other__,
    }
    impl From<u16> for MigrateResultCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESuccess,
                1 => Self::EFailure,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MigrateResultCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESuccess => "success",
                Self::EFailure => "failure",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.migrate_result_count
    ///
    /// The number of times a storage.local backend data migration has been completed and results in one of the categories.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram WEBEXT_STORAGE_LOCAL_IDB_MIGRATE_RESULT_COUNT.
    pub static migrate_result_count: Lazy<LabeledMetric<LabeledCounterMetric, MigrateResultCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "migrate_result_count".into(),
                    category: "extensions.data".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4677), meta, Some(vec![::std::borrow::Cow::from("failure"), ::std::borrow::Cow::from("success")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct StorageLocalErrorExtra {
        pub r#addon_id: Option<String>,
        pub r#error_name: Option<String>,
        pub r#method: Option<String>,
    }

    impl ExtraKeys for StorageLocalErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "error_name", "method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#error_name.and_then(|val| map.insert("error_name".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.storage_local_error
    ///
    /// These events are collected when an extension triggers an unexpected error
    /// while running a storage.local API call (e.g. because of some underlying
    /// QuotaManager and/or IndexedDB error).
    pub static storage_local_error: Lazy<EventMetric<StorageLocalErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_error".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4678), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SyncUsageQuotasExtra {
        pub r#addon_id: Option<String>,
        pub r#backend: Option<String>,
        pub r#items_count: Option<u32>,
        pub r#items_over_quota: Option<u32>,
        pub r#total_size_bytes: Option<u32>,
    }

    impl ExtraKeys for SyncUsageQuotasExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "backend", "items_count", "items_over_quota", "total_size_bytes"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#backend.and_then(|val| map.insert("backend".into(), val.to_string()));
          self.r#items_count.and_then(|val| map.insert("items_count".into(), val.to_string()));
          self.r#items_over_quota.and_then(|val| map.insert("items_over_quota".into(), val.to_string()));
          self.r#total_size_bytes.and_then(|val| map.insert("total_size_bytes".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from extensions.data.sync_usage_quotas
    ///
    /// These events record the basic stat about usage, and are collected the
    /// first time an extension uses the sync storage API during a session.
    pub static sync_usage_quotas: Lazy<EventMetric<SyncUsageQuotasExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sync_usage_quotas".into(),
                category: "extensions.data".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4679), meta)
    });

}
pub mod extensions_timing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.background_page_load
    ///
    /// Amount of time it takes to load a WebExtensions background page, from when the
    /// build function is called to when the page has finished processing the onload event.
    pub static background_page_load: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_page_load".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4680), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.background_page_load_by_addonid
    ///
    /// The amount of time it takes to load a WebExtensions background page, from when the build function is called to when the page has finished processing the onload event, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_BACKGROUND_PAGE_LOAD_MS_BY_ADDONID.
    pub static background_page_load_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "background_page_load_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4681), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.browser_action_popup_open
    ///
    /// Amount of time it takes for a BrowserAction popup to open.
    pub static browser_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_action_popup_open".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4682), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.browser_action_popup_open_by_addonid
    ///
    /// The amount of time it takes for a BrowserAction popup to open, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_BROWSERACTION_POPUP_OPEN_MS_BY_ADDONID.
    pub static browser_action_popup_open_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "browser_action_popup_open_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4683), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.content_script_injection
    ///
    /// Amount of time it takes for content scripts from a WebExtension to be injected into a window.
    pub static content_script_injection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "content_script_injection".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4684), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.content_script_injection_by_addonid
    ///
    /// The amount of time it takes for content scripts from a WebExtension to be injected into a window, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_CONTENT_SCRIPT_INJECTION_MS_BY_ADDONID.
    pub static content_script_injection_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "content_script_injection_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4685), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.event_page_running_time
    ///
    /// Amount of time (keyed by addon id) that an event page has been running before being suspended,
    /// or the entire addon shutdown.
    pub static event_page_running_time: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_page_running_time".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4686), meta, 1, 60000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.event_page_running_time_by_addonid
    ///
    /// The amount of time (keyed by addon id) that an event page has been running before being suspended, or the entire addon shutdown.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_EVENTPAGE_RUNNING_TIME_MS_BY_ADDONID.
    pub static event_page_running_time_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "event_page_running_time_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4687), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.extension_startup
    ///
    /// Amount of time it takes for a WebExtension to start up, from when the
    /// startup function is called to when the startup promise resolves.
    pub static extension_startup: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "extension_startup".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4688), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.extension_startup_by_addonid
    ///
    /// The amount of time it takes for a WebExtension to start up, from when the startup function is called to when the startup promise resolves, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_EXTENSION_STARTUP_MS_BY_ADDONID.
    pub static extension_startup_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "extension_startup_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4689), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.page_action_popup_open
    ///
    /// Amount of time it takes for a PageAction popup to open.
    pub static page_action_popup_open: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "page_action_popup_open".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4690), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.page_action_popup_open_by_addonid
    ///
    /// The amount of time it takes for a PageAction popup to open, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_PAGEACTION_POPUP_OPEN_MS_BY_ADDONID.
    pub static page_action_popup_open_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "page_action_popup_open_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4691), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_get_idb
    ///
    /// Amount of time it takes to perform a get via storage.local using the IndexedDB backend.
    pub static storage_local_get_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_get_idb".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4692), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_get_idb_by_addonid
    ///
    /// The amount of time it takes to perform a get via storage.local using the IndexedDB backend, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_STORAGE_LOCAL_IDB_GET_MS_BY_ADDONID.
    pub static storage_local_get_idb_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "storage_local_get_idb_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4693), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_set_idb
    ///
    /// Amount of time it takes to perform a set via storage.local using the Indexed backend.
    pub static storage_local_set_idb: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "storage_local_set_idb".into(),
                category: "extensions.timing".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4694), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from extensions.timing.storage_local_set_idb_by_addonid
    ///
    /// The amount of time it takes to perform a set via storage.local using the IndexedDB backend, keyed by addon id.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram WEBEXT_STORAGE_LOCAL_IDB_SET_MS_BY_ADDONID.
    pub static storage_local_set_idb_by_addonid: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "storage_local_set_idb_by_addonid".into(),
                    category: "extensions.timing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4695), meta, None)
    });

}
pub mod address {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.add_manage
    ///
    /// User interactions for address autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event address.add#manage.
    pub static add_manage: Lazy<EventMetric<AddManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4696), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.cancel#capture_doorhanger.
    pub static cancel_capture_doorhanger: Lazy<EventMetric<CancelCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4697), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.cancel#edit_doorhanger.
    pub static cancel_edit_doorhanger: Lazy<EventMetric<CancelEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4698), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cancel_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.cancel#update_doorhanger.
    pub static cancel_update_doorhanger: Lazy<EventMetric<CancelUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4699), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearedAddressFormExtra {
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClearedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.cleared_address_form
    ///
    /// Recorded when a form is cleared. Using field_name to record the field that triggers this event
    /// This event was generated to correspond to the Legacy Telemetry event address.cleared#address_form.
    pub static cleared_address_form: Lazy<EventMetric<ClearedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cleared_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4700), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeleteManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.delete_manage
    ///
    /// User interactions for address autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event address.delete#manage.
    pub static delete_manage: Lazy<EventMetric<DeleteManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4701), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.detected_address_form
    ///
    /// Recorded when a form is recognized as an address form. The possible values in the extra_keys are "true", "false", or 0. When the value is "true", the field is identified via autocomplete attribute. When the value is "false", the field is not detected in the form. When the value is an 0, then the field is identified by regexp-based heuristic.
    /// This event was generated to correspond to the Legacy Telemetry event address.detected#address_form.
    pub static detected_address_form: Lazy<EventMetric<DetectedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4702), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.detected_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above `address_form` telemetry This telemetry is used to record address fields that are not listed in `address_form` This event was generated to correspond to the Legacy Telemetry event address.detected#address_form_ext.
    pub static detected_address_form_ext: Lazy<EventMetric<DetectedAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4703), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.disable#capture_doorhanger.
    pub static disable_capture_doorhanger: Lazy<EventMetric<DisableCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4704), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.disable#edit_doorhanger.
    pub static disable_edit_doorhanger: Lazy<EventMetric<DisableEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4705), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.disable_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.disable#update_doorhanger.
    pub static disable_update_doorhanger: Lazy<EventMetric<DisableUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4706), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.edit_manage
    ///
    /// User interactions for address autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event address.edit#manage.
    pub static edit_manage: Lazy<EventMetric<EditManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4707), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_address_form
    ///
    /// Recorded when a form is autofiled. Possible values are `filled`, `not_filled`, `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event address.filled#address_form.
    pub static filled_address_form: Lazy<EventMetric<FilledAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4708), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above `address_form` telemetry This telemetry is used to record address fields that are not listed in `address_form` This event was generated to correspond to the Legacy Telemetry event address.filled#address_form_ext.
    pub static filled_address_form_ext: Lazy<EventMetric<FilledAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4709), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledModifiedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#field_name: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledModifiedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "field_name", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_modified_address_form
    ///
    /// Recorded when a field is autofilled and then modified by the user. Using field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event address.filled_modified#address_form.
    pub static filled_modified_address_form: Lazy<EventMetric<FilledModifiedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_modified_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4710), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledOnFieldsUpdateAddressFormExtra {
        pub r#additional_name: Option<String>,
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledOnFieldsUpdateAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "email", "family_name", "given_name", "name", "organization", "postal_code", "street_address", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.filled_on_fields_update_address_form
    ///
    /// Recorded when a previous autofill action for the address form causes an immediate fields update which triggers another autofill action including for the new/updated fields. Possible values are `filled`, `filled_on_fields_update`, `user_filled` or `unavailable`. Unlike the other address form interaction events, this doesn't need a `address_form` and `address_form_ext` event because it's only collected in Glean (not mirror to Legacy).
    pub static filled_on_fields_update_address_form: Lazy<EventMetric<FilledOnFieldsUpdateAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_on_fields_update_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4711), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.learn_more#capture_doorhanger.
    pub static learn_more_capture_doorhanger: Lazy<EventMetric<LearnMoreCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4712), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.learn_more#edit_doorhanger.
    pub static learn_more_edit_doorhanger: Lazy<EventMetric<LearnMoreEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4713), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LearnMoreUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.learn_more_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.learn_more#update_doorhanger.
    pub static learn_more_update_doorhanger: Lazy<EventMetric<LearnMoreUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4714), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PopupShownAddressFormExtra {
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PopupShownAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.popup_shown_address_form
    ///
    /// Recorded when autofill popup is shown. Using field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event address.popup_shown#address_form.
    pub static popup_shown_address_form: Lazy<EventMetric<PopupShownAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "popup_shown_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4715), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.pref#capture_doorhanger.
    pub static pref_capture_doorhanger: Lazy<EventMetric<PrefCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4716), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.pref#edit_doorhanger.
    pub static pref_edit_doorhanger: Lazy<EventMetric<PrefEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4717), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PrefUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PrefUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.pref_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.pref#update_doorhanger.
    pub static pref_update_doorhanger: Lazy<EventMetric<PrefUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4718), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.save#capture_doorhanger.
    pub static save_capture_doorhanger: Lazy<EventMetric<SaveCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4719), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.save#edit_doorhanger.
    pub static save_edit_doorhanger: Lazy<EventMetric<SaveEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4720), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.save_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.save#update_doorhanger.
    pub static save_update_doorhanger: Lazy<EventMetric<SaveUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4721), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.show#capture_doorhanger.
    pub static show_capture_doorhanger: Lazy<EventMetric<ShowCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4722), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.show#edit_doorhanger.
    pub static show_edit_doorhanger: Lazy<EventMetric<ShowEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4723), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEntryManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEntryManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_entry_manage
    ///
    /// User interactions for address autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event address.show_entry#manage.
    pub static show_entry_manage: Lazy<EventMetric<ShowEntryManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_entry_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4724), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_manage
    ///
    /// User interactions for address autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event address.show#manage.
    pub static show_manage: Lazy<EventMetric<ShowManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_manage".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4725), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.show_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.show#update_doorhanger.
    pub static show_update_doorhanger: Lazy<EventMetric<ShowUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4726), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedAddressFormExtra {
        pub r#address_level1: Option<String>,
        pub r#address_level2: Option<String>,
        pub r#address_line1: Option<String>,
        pub r#address_line2: Option<String>,
        pub r#address_line3: Option<String>,
        pub r#country: Option<String>,
        pub r#postal_code: Option<String>,
        pub r#street_address: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedAddressFormExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["address_level1", "address_level2", "address_line1", "address_line2", "address_line3", "country", "postal_code", "street_address", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#address_level1.and_then(|val| map.insert("address_level1".into(), val.to_string()));
          self.r#address_level2.and_then(|val| map.insert("address_level2".into(), val.to_string()));
          self.r#address_line1.and_then(|val| map.insert("address_line1".into(), val.to_string()));
          self.r#address_line2.and_then(|val| map.insert("address_line2".into(), val.to_string()));
          self.r#address_line3.and_then(|val| map.insert("address_line3".into(), val.to_string()));
          self.r#country.and_then(|val| map.insert("country".into(), val.to_string()));
          self.r#postal_code.and_then(|val| map.insert("postal_code".into(), val.to_string()));
          self.r#street_address.and_then(|val| map.insert("street_address".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.submitted_address_form
    ///
    /// Recorded when a form is submitted. Possible values are `autofilled`, `not_filled`, `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event address.submitted#address_form.
    pub static submitted_address_form: Lazy<EventMetric<SubmittedAddressFormExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_address_form".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4727), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedAddressFormExtExtra {
        pub r#additional_name: Option<String>,
        pub r#email: Option<String>,
        pub r#family_name: Option<String>,
        pub r#given_name: Option<String>,
        pub r#name: Option<String>,
        pub r#organization: Option<String>,
        pub r#tel: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedAddressFormExtExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["additional_name", "email", "family_name", "given_name", "name", "organization", "tel", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#additional_name.and_then(|val| map.insert("additional_name".into(), val.to_string()));
          self.r#email.and_then(|val| map.insert("email".into(), val.to_string()));
          self.r#family_name.and_then(|val| map.insert("family_name".into(), val.to_string()));
          self.r#given_name.and_then(|val| map.insert("given_name".into(), val.to_string()));
          self.r#name.and_then(|val| map.insert("name".into(), val.to_string()));
          self.r#organization.and_then(|val| map.insert("organization".into(), val.to_string()));
          self.r#tel.and_then(|val| map.insert("tel".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.submitted_address_form_ext
    ///
    /// Address has too many fields so we cannot cover them all in the above `address_form` telemetry This telemetry is used to record address fields that are not listed in `address_form` This event was generated to correspond to the Legacy Telemetry event address.submitted#address_form_ext.
    pub static submitted_address_form_ext: Lazy<EventMetric<SubmittedAddressFormExtExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_address_form_ext".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4728), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_capture_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.update#capture_doorhanger.
    pub static update_capture_doorhanger: Lazy<EventMetric<UpdateCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_capture_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4729), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateEditDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateEditDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_edit_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.update#edit_doorhanger.
    pub static update_edit_doorhanger: Lazy<EventMetric<UpdateEditDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_edit_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4730), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from address.update_update_doorhanger
    ///
    /// User interactions for the browser address autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event address.update#update_doorhanger.
    pub static update_update_doorhanger: Lazy<EventMetric<UpdateUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_update_doorhanger".into(),
                category: "address".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4731), meta)
    });

}
pub mod creditcard {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.add_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event creditcard.add#manage.
    pub static add_manage: Lazy<EventMetric<AddManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4732), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cancel_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.cancel#capture_doorhanger.
    pub static cancel_capture_doorhanger: Lazy<EventMetric<CancelCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4733), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for CancelUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cancel_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.cancel#update_doorhanger.
    pub static cancel_update_doorhanger: Lazy<EventMetric<CancelUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4734), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClearedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClearedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.cleared_cc_form_v2
    ///
    /// Recorded when a form is cleared. Using field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.cleared#cc_form_v2.
    pub static cleared_cc_form_v2: Lazy<EventMetric<ClearedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cleared_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4735), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DeleteManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.delete_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event creditcard.delete#manage.
    pub static delete_manage: Lazy<EventMetric<DeleteManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4736), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DetectedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DetectedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.detected_cc_form_v2
    ///
    /// Recorded when a form is recognized as a credit card form. The possible value of cc_* in extra_keys are "true", "false", or an integer between 0-100. When the value is "true", the field is identified via autocomplete attribute. When the value is "false", the field is not detected in the form. When the value is an integer greater than 0, the value indicates the confidence value from fathom (normalized to 0-100). When the value is an 0, then the field is identified by regexp-based heuristic.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.detected#cc_form_v2.
    pub static detected_cc_form_v2: Lazy<EventMetric<DetectedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "detected_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4737), meta)
    });

    #[repr(u16)]
    pub enum DetectedCcNumberFieldsCountLabel {
        ECcNumberFields1 = 0,
        ECcNumberFields2 = 1,
        ECcNumberFields3 = 2,
        ECcNumberFields4 = 3,
        ECcNumberFieldsOther = 4,
        __Other__,
    }
    impl From<u16> for DetectedCcNumberFieldsCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECcNumberFields1,
                1 => Self::ECcNumberFields2,
                2 => Self::ECcNumberFields3,
                3 => Self::ECcNumberFields4,
                4 => Self::ECcNumberFieldsOther,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for DetectedCcNumberFieldsCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECcNumberFields1 => "cc_number_fields_1",
                Self::ECcNumberFields2 => "cc_number_fields_2",
                Self::ECcNumberFields3 => "cc_number_fields_3",
                Self::ECcNumberFields4 => "cc_number_fields_4",
                Self::ECcNumberFieldsOther => "cc_number_fields_other",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.detected_cc_number_fields_count
    ///
    /// The count of detected input fields that a website plans on splitting the cc number digits across
    pub static detected_cc_number_fields_count: Lazy<LabeledMetric<LabeledCounterMetric, DetectedCcNumberFieldsCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "detected_cc_number_fields_count".into(),
                    category: "creditcard".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4738), meta, Some(vec![::std::borrow::Cow::from("cc_number_fields_1"), ::std::borrow::Cow::from("cc_number_fields_2"), ::std::borrow::Cow::from("cc_number_fields_3"), ::std::borrow::Cow::from("cc_number_fields_4"), ::std::borrow::Cow::from("cc_number_fields_other")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.disable_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.disable#capture_doorhanger.
    pub static disable_capture_doorhanger: Lazy<EventMetric<DisableCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4739), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.disable_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.disable#update_doorhanger.
    pub static disable_update_doorhanger: Lazy<EventMetric<DisableUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4740), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EditManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.edit_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event creditcard.edit#manage.
    pub static edit_manage: Lazy<EventMetric<EditManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4741), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.filled_cc_form_v2
    ///
    /// Recorded when a form is autofiled. Possible values are `filled`, `not_filled`, `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.filled#cc_form_v2.
    pub static filled_cc_form_v2: Lazy<EventMetric<FilledCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4742), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledModifiedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledModifiedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.filled_modified_cc_form_v2
    ///
    /// Recorded when a field is autofilled and then modified by the user. Using field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.filled_modified#cc_form_v2.
    pub static filled_modified_cc_form_v2: Lazy<EventMetric<FilledModifiedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_modified_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4743), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FilledOnFieldsUpdateCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FilledOnFieldsUpdateCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.filled_on_fields_update_cc_form_v2
    ///
    /// Recorded when a previous autofill action for the credit card form causes an immediate fields update which triggers another autofill action including for the new/updated fields. Possible values are `filled`, `filled_on_fields_update`, `user_filled` or `unavailable`.
    pub static filled_on_fields_update_cc_form_v2: Lazy<EventMetric<FilledOnFieldsUpdateCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_on_fields_update_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4744), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OsKeystoreDecryptExtra {
        pub r#errorResult: Option<String>,
        pub r#isDecryptSuccess: Option<bool>,
        pub r#trigger: Option<String>,
    }

    impl ExtraKeys for OsKeystoreDecryptExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["errorResult", "isDecryptSuccess", "trigger"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#errorResult.and_then(|val| map.insert("errorResult".into(), val.to_string()));
          self.r#isDecryptSuccess.and_then(|val| map.insert("isDecryptSuccess".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.os_keystore_decrypt
    ///
    /// Captures the result of the OS Keystore decryption, which user interaction triggered the OS Keystore, and any error messages upon failure.
    pub static os_keystore_decrypt: Lazy<EventMetric<OsKeystoreDecryptExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_keystore_decrypt".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4745), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PopupShownCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PopupShownCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.popup_shown_cc_form_v2
    ///
    /// Recorded when autofill popup is shown. Using field_name to record the field that triggers this event.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.popup_shown#cc_form_v2.
    pub static popup_shown_cc_form_v2: Lazy<EventMetric<PopupShownCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "popup_shown_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4746), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.save_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.save#capture_doorhanger.
    pub static save_capture_doorhanger: Lazy<EventMetric<SaveCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4747), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SaveUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.save_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.save#update_doorhanger.
    pub static save_update_doorhanger: Lazy<EventMetric<SaveUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4748), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.show#capture_doorhanger.
    pub static show_capture_doorhanger: Lazy<EventMetric<ShowCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4749), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowEntryManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowEntryManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_entry_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event creditcard.show_entry#manage.
    pub static show_entry_manage: Lazy<EventMetric<ShowEntryManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_entry_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4750), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowManageExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_manage
    ///
    /// User interactions for credit card autofill preferences management UI. This event was generated to correspond to the Legacy Telemetry event creditcard.show#manage.
    pub static show_manage: Lazy<EventMetric<ShowManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_manage".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4751), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShowUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.show_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.show#update_doorhanger.
    pub static show_update_doorhanger: Lazy<EventMetric<ShowUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4752), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubmittedCcFormV2Extra {
        pub r#cc_exp: Option<String>,
        pub r#cc_exp_month: Option<String>,
        pub r#cc_exp_year: Option<String>,
        pub r#cc_name: Option<String>,
        pub r#cc_number: Option<String>,
        pub r#cc_type: Option<String>,
        pub r#field_name: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SubmittedCcFormV2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["cc_exp", "cc_exp_month", "cc_exp_year", "cc_name", "cc_number", "cc_type", "field_name", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#cc_exp.and_then(|val| map.insert("cc_exp".into(), val.to_string()));
          self.r#cc_exp_month.and_then(|val| map.insert("cc_exp_month".into(), val.to_string()));
          self.r#cc_exp_year.and_then(|val| map.insert("cc_exp_year".into(), val.to_string()));
          self.r#cc_name.and_then(|val| map.insert("cc_name".into(), val.to_string()));
          self.r#cc_number.and_then(|val| map.insert("cc_number".into(), val.to_string()));
          self.r#cc_type.and_then(|val| map.insert("cc_type".into(), val.to_string()));
          self.r#field_name.and_then(|val| map.insert("field_name".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.submitted_cc_form_v2
    ///
    /// Recorded when a form is submitted. Possible values are `autofilled`, `user_filled` or `unavailable`.
    /// This event was generated to correspond to the Legacy Telemetry event creditcard.submitted#cc_form_v2.
    pub static submitted_cc_form_v2: Lazy<EventMetric<SubmittedCcFormV2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submitted_cc_form_v2".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4753), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateCaptureDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateCaptureDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.update_capture_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.update#capture_doorhanger.
    pub static update_capture_doorhanger: Lazy<EventMetric<UpdateCaptureDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_capture_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4754), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUpdateDoorhangerExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUpdateDoorhangerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from creditcard.update_update_doorhanger
    ///
    /// User interactions for the browser credit card autofill doorhanger. This event was generated to correspond to the Legacy Telemetry event creditcard.update#update_doorhanger.
    pub static update_update_doorhanger: Lazy<EventMetric<UpdateUpdateDoorhangerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_update_doorhanger".into(),
                category: "creditcard".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4755), meta)
    });

}
pub mod formautofill {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.availability
    ///
    /// A boolean sent once per session to represent whether the formautofill is available in the build This metric was generated to correspond to the Legacy Telemetry scalar formautofill.availability.
    pub static availability: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "availability".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4756), meta)
    });

    #[repr(u16)]
    pub enum FormSubmissionHeuristicLabel {
        EFormSubmitEvent = 0,
        EFormRemovalAfterFetch = 1,
        EPageNavigation = 2,
        EIframePagehide = 3,
        __Other__,
    }
    impl From<u16> for FormSubmissionHeuristicLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFormSubmitEvent,
                1 => Self::EFormRemovalAfterFetch,
                2 => Self::EPageNavigation,
                3 => Self::EIframePagehide,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormSubmissionHeuristicLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFormSubmitEvent => "form-submit-event",
                Self::EFormRemovalAfterFetch => "form-removal-after-fetch",
                Self::EPageNavigation => "page-navigation",
                Self::EIframePagehide => "iframe-pagehide",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.form_submission_heuristic
    ///
    /// The heuristic that detected the form submission.
    pub static form_submission_heuristic: Lazy<LabeledMetric<LabeledCounterMetric, FormSubmissionHeuristicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "form_submission_heuristic".into(),
                    category: "formautofill".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4757), meta, Some(vec![::std::borrow::Cow::from("form-removal-after-fetch"), ::std::borrow::Cow::from("form-submit-event"), ::std::borrow::Cow::from("iframe-pagehide"), ::std::borrow::Cow::from("page-navigation")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct IframeLayoutDetectionExtra {
        pub r#category: Option<String>,
        pub r#cross_origin: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#iframe: Option<String>,
        pub r#iframe_count: Option<u32>,
        pub r#main_frame: Option<String>,
        pub r#sandboxed: Option<String>,
    }

    impl ExtraKeys for IframeLayoutDetectionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["category", "cross_origin", "flow_id", "iframe", "iframe_count", "main_frame", "sandboxed"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#category.and_then(|val| map.insert("category".into(), val.to_string()));
          self.r#cross_origin.and_then(|val| map.insert("cross_origin".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#iframe.and_then(|val| map.insert("iframe".into(), val.to_string()));
          self.r#iframe_count.and_then(|val| map.insert("iframe_count".into(), val.to_string()));
          self.r#main_frame.and_then(|val| map.insert("main_frame".into(), val.to_string()));
          self.r#sandboxed.and_then(|val| map.insert("sandboxed".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.iframe_layout_detection
    ///
    /// Record the number of iframe in a form and what fields are in an iframe when a form is detected
    pub static iframe_layout_detection: Lazy<EventMetric<IframeLayoutDetectionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "iframe_layout_detection".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4758), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.os_auth_enabled
    ///
    /// Check at startup whether OS Authentication has been enabled for credit cards.
    pub static os_auth_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_auth_enabled".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4759), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PromptShownOsReauthExtra {
        pub r#result: Option<String>,
        pub r#trigger: Option<String>,
    }

    impl ExtraKeys for PromptShownOsReauthExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["result", "trigger"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.prompt_shown_os_reauth
    ///
    /// Captures the method of user interaction initiating the prompt and the result of the prompt. Possible triggers include:
    ///   "autofill" when a user attempts to autofill a payment method.
    ///   "edit" when a user edits a login in about:preferences
    ///   "toggle_pref_os_auth" when a user toggles "Autofill / Require device sign in" in about:preferences
    /// Possible results include:
    ///   "success" should be used when the user is shown the OS Auth prompt and successfully authenticates.
    ///   "fail_user_canceled" should be used when the user cancels the authentication prompt. The user may or may not have provided an incorrect password before cancelling.
    ///   "fail_error" should be used when an unexpected exception is encountered.
    pub static prompt_shown_os_reauth: Lazy<EventMetric<PromptShownOsReauthExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prompt_shown_os_reauth".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4760), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RequireOsReauthToggleExtra {
        pub r#toggle_state: Option<bool>,
    }

    impl ExtraKeys for RequireOsReauthToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["toggle_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#toggle_state.and_then(|val| map.insert("toggle_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.require_os_reauth_toggle
    ///
    /// Toggle states include:
    ///   True means the OS Auth preference is enabled.
    ///   False means it is disabled.
    pub static require_os_reauth_toggle: Lazy<EventMetric<RequireOsReauthToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "require_os_reauth_toggle".into(),
                category: "formautofill".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4761), meta)
    });

}
pub mod formautofill_addresses {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.addresses.autofill_profiles_count
    ///
    /// Count at store time how many address autofill profiles user has. This metric was generated to correspond to the Legacy Telemetry scalar formautofill.addresses.autofill_profiles_count.
    pub static autofill_profiles_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autofill_profiles_count".into(),
                category: "formautofill.addresses".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4762), meta)
    });

}
pub mod formautofill_creditcards {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from formautofill.creditcards.autofill_profiles_count
    ///
    /// Count at store time how many credit card autofill profiles the user has.
    pub static autofill_profiles_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autofill_profiles_count".into(),
                category: "formautofill.creditcards".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4763), meta)
    });

}
pub mod formautofill_ml {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FieldInferResultExtra {
        pub r#fathom_infer_label: Option<String>,
        pub r#fathom_infer_score: Option<String>,
        pub r#infer_field_name: Option<String>,
        pub r#infer_reason: Option<String>,
        pub r#is_valid_section: Option<bool>,
        pub r#ml_infer_label: Option<String>,
        pub r#ml_infer_score: Option<String>,
        pub r#ml_revision: Option<String>,
    }

    impl ExtraKeys for FieldInferResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["fathom_infer_label", "fathom_infer_score", "infer_field_name", "infer_reason", "is_valid_section", "ml_infer_label", "ml_infer_score", "ml_revision"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#fathom_infer_label.and_then(|val| map.insert("fathom_infer_label".into(), val.to_string()));
          self.r#fathom_infer_score.and_then(|val| map.insert("fathom_infer_score".into(), val.to_string()));
          self.r#infer_field_name.and_then(|val| map.insert("infer_field_name".into(), val.to_string()));
          self.r#infer_reason.and_then(|val| map.insert("infer_reason".into(), val.to_string()));
          self.r#is_valid_section.and_then(|val| map.insert("is_valid_section".into(), val.to_string()));
          self.r#ml_infer_label.and_then(|val| map.insert("ml_infer_label".into(), val.to_string()));
          self.r#ml_infer_score.and_then(|val| map.insert("ml_infer_score".into(), val.to_string()));
          self.r#ml_revision.and_then(|val| map.insert("ml_revision".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from formautofill.ml.field_infer_result
    ///
    /// Captures the result from both ML-based model and existing heuristics for autofill field classification.
    pub static field_infer_result: Lazy<EventMetric<FieldInferResultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "field_infer_result".into(),
                category: "formautofill.ml".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4764), meta)
    });

}
pub mod fog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.failed_idle_registration
    ///
    /// True if we failed to register with the idle service. Absent otherwise.
    /// Means IPC probably isn't working well.
    /// Child-process data will likely be absent, or incomplete.
    pub static failed_idle_registration: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "failed_idle_registration".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4765), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.initialization
    ///
    /// Time the FOG initialization takes.
    pub static initialization: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initialization".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4766), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.inits_during_shutdown
    ///
    /// Counts the number of times init had to be called during shutdown.
    /// Should never have a value for any session long enough to grow idle.
    pub static inits_during_shutdown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4767,
            "fog",
            "inits_during_shutdown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.max_pings_per_minute
    ///
    /// Value of the configurable rate limit, in pings per minute, for Glean pings as set at init.
    pub static max_pings_per_minute: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_pings_per_minute".into(),
                category: "fog".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4768), meta)
    });

}
pub mod fog_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.buffer_sizes
    ///
    /// The number and size of the IPC buffers being received over FOG IPC.
    pub static buffer_sizes: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "buffer_sizes".into(),
                category: "fog.ipc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4769), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_durations
    ///
    /// The length of time between asking the child processes for their
    /// IPC buffers and all of them being received by the parent.
    pub static flush_durations: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "flush_durations".into(),
                category: "fog.ipc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4770), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.flush_failures
    ///
    /// The number of times we failed to flush all non-parent-process data,
    /// throwing even partial results into the trash.
    /// If this number is high, we might consider writing custom `MozPromise`-
    /// handling code instead of using `MozPromise::All`.
    pub static flush_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4771,
            "fog.ipc",
            "flush_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.replay_failures
    ///
    /// The number of times the ipc buffer failed to be replayed in the
    /// parent process.
    pub static replay_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4772,
            "fog.ipc",
            "replay_failures",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from fog.ipc.shutdown_registration_failures
    ///
    /// The number of times we tried to register shutdown flush routines for
    /// content child processes, and failed (probably because there was no main
    /// thread).
    /// As a result there may be data loss from content child processes.
    /// Large or rising number of clients experiencing this indicates we should
    /// perhaps refactor content child shutdown in FOG to try harder to register
    /// flush operations.
    /// Will likely be obsoleted by bug 1641989.
    pub static shutdown_registration_failures: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4773,
            "fog.ipc",
            "shutdown_registration_failures",
            "metrics"
        )
    });

}
pub mod test_only {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.bad_code
    ///
    /// Number of times we encountered bad code.
    /// This is a test-only metric.
    pub static bad_code: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bad_code".into(),
                category: "test_only".into(),
                send_in_pings: vec!["ride-along-ping".into(), "test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(BaseMetricId(4774), meta)
    });

        pub type BalloonsObject = Vec<BalloonsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct BalloonsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub colour: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub diameter: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub CamelCasedParameter: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.balloons
    ///
    /// A collection of balloons
    pub static balloons: Lazy<ObjectMetric<BalloonsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "balloons".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4775), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.button_jars
    ///
    /// The number of buttons in each button jar.
    /// This is a test-only metric.
    pub static button_jars: Lazy<LabeledMetric<LabeledQuantityMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "button_jars".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4776), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_flag_it
    ///
    /// Test metric for a boolean.
    /// This is a test-only metric.
    pub static can_we_flag_it: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_we_flag_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4777), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.can_we_time_it
    ///
    /// Test metric for a timespan.
    /// This is a test-only metric.
    pub static can_we_time_it: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_we_time_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4778), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string
    ///
    /// Only the cheesiest of strings.
    /// This is a test-only metric.
    pub static cheesy_string: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cheesy_string".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4779), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.cheesy_string_list
    ///
    /// Only the cheesiest of strings. In list form!
    /// This is a test-only metric.
    pub static cheesy_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cheesy_string_list".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(4780), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.collection_disabled_counter
    ///
    /// Number of times we count.
    /// This is a test-only metric.
    pub static collection_disabled_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4781,
            "test_only",
            "collection_disabled_counter",
            "collection-disabled-ping"
        )
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub status: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub main_module: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crash_info: Option<CrashStackObjectItemCrashInfoObject>,
          #[serde(skip_serializing_if = "Vec::is_empty", default = "Vec::new")]
          pub modules: CrashStackObjectItemModules,
    }

            #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemCrashInfoObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub typ: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub address: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub crashing_thread: Option<i64>,
    }

            pub type CrashStackObjectItemModules = Vec<CrashStackObjectItemModulesItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct CrashStackObjectItemModulesItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub base_addr: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub end_addr: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from test_only.crash_stack
    ///
    /// A not-real crash stack
    pub static crash_stack: Lazy<ObjectMetric<CrashStackObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "crash_stack".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4782), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.default_products
    ///
    /// A testing uint scalar; not meant to be touched This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.default_products.
    pub static default_products: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4783,
            "test_only",
            "default_products",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.desktop_only
    ///
    /// A testing uint scalar; not meant to be touched This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.desktop_only.
    pub static desktop_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4784,
            "test_only",
            "desktop_only",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.disabled_counter
    ///
    /// Number of times we count.
    /// This is a test-only metric.
    pub static disabled_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4785,
            "test_only",
            "disabled_counter",
            "disabled-ping"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.do_you_remember
    ///
    /// They say it's the second thing to go.
    /// This is a test-only metric.
    pub static do_you_remember: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "do_you_remember".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4786), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.expired
    ///
    /// This mirrors to an expired testing scalar. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.expired.
    pub static expired: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4787,
            "test_only",
            "expired",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.expired_hist
    ///
    /// a testing histogram; not meant to be touched
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_TEST_EXPIRED.
    pub static expired_hist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expired_hist".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4788), meta, 1, 10, 3, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.impression_id_only
    ///
    /// This is a test uint type with only the deletion-request store. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.impression_id_only.
    pub static impression_id_only: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "impression_id_only".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4789), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.keyed_expired
    ///
    /// This mirrors to an expired testing scalar. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.keyed_expired.
    pub static keyed_expired: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyed_expired".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4790), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.keyed_mobile_only
    ///
    /// A keyed testing uint scalar; not meant to be touched This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.keyed_mobile_only.
    pub static keyed_mobile_only: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyed_mobile_only".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4791), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.keyed_release_optin
    ///
    /// A testing scalar; not meant to be touched. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.keyed_release_optin.
    pub static keyed_release_optin: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyed_release_optin".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4792), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.keyed_release_optout
    ///
    /// A testing scalar; not meant to be touched. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.keyed_release_optout.
    pub static keyed_release_optout: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "keyed_release_optout".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4793), meta, None)
    });

    #[repr(u16)]
    pub enum MabelsBalloonLabelsLabel {
        ECelebratory = 0,
        ECelebratoryAndSnarky = 1,
        __Other__,
    }
    impl From<u16> for MabelsBalloonLabelsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECelebratory,
                1 => Self::ECelebratoryAndSnarky,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsBalloonLabelsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECelebratory => "celebratory",
                Self::ECelebratoryAndSnarky => "celebratory_and_snarky",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_labels
    ///
    /// How does Mabel label her balloons?
    /// This is a test-only metric.
    pub static mabels_balloon_labels: Lazy<LabeledMetric<LabeledStringMetric, MabelsBalloonLabelsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_balloon_labels".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4794), meta, Some(vec![::std::borrow::Cow::from("celebratory"), ::std::borrow::Cow::from("celebratory_and_snarky")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_balloon_strings
    ///
    /// What do the labeled Mabel's liked balloons' strings say?
    /// This is a test-only metric.
    pub static mabels_balloon_strings: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_balloon_strings".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4795), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_bathroom_counters
    ///
    /// Counts Mabels labeled by their bathroom counters.
    /// This is a test-only metric.
    pub static mabels_bathroom_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_bathroom_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4796), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_custom_label_lengths
    ///
    /// Mabel wants to track the length of their new label maker's labels.
    pub static mabels_custom_label_lengths: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "mabels_custom_label_lengths".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 1, range_max: 2147483646, bucket_count: 10, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(4797), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_kitchen_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// This is a test-only metric.
    pub static mabels_kitchen_counters: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_kitchen_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4798), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_label_maker
    ///
    /// Mabel just got a label maker and wants to party like it's
    /// 1999.
    /// This is a test-only metric.
    pub static mabels_label_maker: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_label_maker".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4799), meta, None)
    });

    #[repr(u16)]
    pub enum MabelsLabeledCountersLabel {
        ENextToTheFridge = 0,
        EClean = 1,
        E1stCounter = 2,
        __Other__,
    }
    impl From<u16> for MabelsLabeledCountersLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENextToTheFridge,
                1 => Self::EClean,
                2 => Self::E1stCounter,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLabeledCountersLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENextToTheFridge => "next_to_the_fridge",
                Self::EClean => "clean",
                Self::E1stCounter => "1st_counter",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_labeled_counters
    ///
    /// Counts Mabels labeled by their kitchen counters.
    /// Now with static labels.
    /// This is a test-only metric.
    pub static mabels_labeled_counters: Lazy<LabeledMetric<LabeledCounterMetric, MabelsLabeledCountersLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_labeled_counters".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4800), meta, Some(vec![::std::borrow::Cow::from("1st_counter"), ::std::borrow::Cow::from("clean"), ::std::borrow::Cow::from("next_to_the_fridge")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_like_balloons".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4801), meta, None)
    });

    #[repr(u16)]
    pub enum MabelsLikeLabeledBalloonsLabel {
        EWater = 0,
        EBirthdayParty = 1,
        __Other__,
    }
    impl From<u16> for MabelsLikeLabeledBalloonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWater,
                1 => Self::EBirthdayParty,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MabelsLikeLabeledBalloonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWater => "water",
                Self::EBirthdayParty => "birthday_party",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.mabels_like_labeled_balloons
    ///
    /// Does the labeled Mabel like balloons?
    /// This is a test-only metric.
    pub static mabels_like_labeled_balloons: Lazy<LabeledMetric<LabeledBooleanMetric, MabelsLikeLabeledBalloonsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mabels_like_labeled_balloons".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4802), meta, Some(vec![::std::borrow::Cow::from("birthday_party"), ::std::borrow::Cow::from("water")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.main_only
    ///
    /// This is a test uint type with only the main store. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.main_only.
    pub static main_only: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "main_only".into(),
                category: "test_only".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4803), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.meaning_of_life
    ///
    /// Measures the one true answer to the Ultimate Question of Life,
    /// the Universe, and Everything.
    /// Approximately.
    /// This is a test-only metric.
    pub static meaning_of_life: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "meaning_of_life".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4804), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mirror_time".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4805), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirror_time_nanos
    ///
    /// Mirrored metric for a timespan.
    /// This is a test-only metric.
    pub static mirror_time_nanos: Lazy<TimespanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mirror_time_nanos".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimespanMetric::new(BaseMetricId(4806), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mirrors_for_labeled_bools
    ///
    /// Mirrored metric.
    /// This is a test-only metric.
    pub static mirrors_for_labeled_bools: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mirrors_for_labeled_bools".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4807), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.mobile_only
    ///
    /// A testing uint scalar; not meant to be touched This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.mobile_only.
    pub static mobile_only: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4808,
            "test_only",
            "mobile_only",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.multiproduct
    ///
    /// A testing uint scalar; not meant to be touched This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.multiproduct.
    pub static multiproduct: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4809,
            "test_only",
            "multiproduct",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.one_ping_one_bool
    ///
    /// One bool for one ping only.
    /// This is a test-only metric.
    pub static one_ping_one_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "one_ping_one_bool".into(),
                category: "test_only".into(),
                send_in_pings: vec!["one-ping-only".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4810), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.release_optin
    ///
    /// A testing scalar; not meant to be touched. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.release_optin.
    pub static release_optin: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4811,
            "test_only",
            "release_optin",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.release_optout
    ///
    /// A testing scalar; not meant to be touched. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.release_optout.
    pub static release_optout: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4812,
            "test_only",
            "release_optout",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.unexpired
    ///
    /// This is an unexpired testing scalar; not meant to be touched. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.test.unexpired.
    pub static unexpired: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4813,
            "test_only",
            "unexpired",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_a_date
    ///
    /// ...To be writing FOG code. This is a test-only metric.
    pub static what_a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_a_date".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(4814), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_do_you_remember
    ///
    /// What do they say is the second thing to go?
    /// This is a test-only metric.
    pub static what_do_you_remember: Lazy<LabeledMetric<LabeledMemoryDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::MemoryDistribution {
                cmd: CommonMetricData {
                    name: "what_do_you_remember".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: MemoryUnit::Megabyte};
        LabeledMetric::new(BaseMetricId(4815), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_id_it
    ///
    /// Just a UUID.
    /// This is a test-only metric.
    pub static what_id_it: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_id_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(4816), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.what_time_is_it
    ///
    /// Adheres to at least two of the top ten fallacies programmers believe
    /// about time.
    /// This is a test-only metric.
    pub static what_time_is_it: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "what_time_is_it".into(),
                category: "test_only".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4817), meta, TimeUnit::Microsecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.where_has_the_time_gone
    ///
    /// Time is different in different places.
    /// This is a test-only metric.
    pub static where_has_the_time_gone: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "where_has_the_time_gone".into(),
                    category: "test_only".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Microsecond};
        LabeledMetric::new(BaseMetricId(4818), meta, None)
    });

}
pub mod test_only_ipc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things.
    pub static a_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_bool".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4819), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4820,
            "test_only.ipc",
            "a_counter",
            "test-ping"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_counter_for_hgram
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_counter_for_hgram: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4821,
            "test_only.ipc",
            "a_counter_for_hgram",
            "test-ping"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_custom_dist
    ///
    /// This is a test-only metric.
    /// Just measuring samples.
    pub static a_custom_dist: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_custom_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4822), meta, 1, 2147483646, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_date
    ///
    /// This is a test-only metric.
    /// Just putting things on the calendar.
    pub static a_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_date".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(4823), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just counting labeled things.
    pub static a_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a_labeled_counter".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4824), meta, None)
    });

    #[repr(u16)]
    pub enum ALabeledCounterForCategoricalLabel {
        ECommonlabel = 0,
        ELabel4 = 1,
        ELabel5 = 2,
        ELabel6 = 3,
        __Other__,
    }
    impl From<u16> for ALabeledCounterForCategoricalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECommonlabel,
                1 => Self::ELabel4,
                2 => Self::ELabel5,
                3 => Self::ELabel6,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ALabeledCounterForCategoricalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECommonlabel => "CommonLabel",
                Self::ELabel4 => "Label4",
                Self::ELabel5 => "Label5",
                Self::ELabel6 => "Label6",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter_for_categorical
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_labeled_counter_for_categorical: Lazy<LabeledMetric<LabeledCounterMetric, ALabeledCounterForCategoricalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a_labeled_counter_for_categorical".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4825), meta, Some(vec![::std::borrow::Cow::from("CommonLabel"), ::std::borrow::Cow::from("Label4"), ::std::borrow::Cow::from("Label5"), ::std::borrow::Cow::from("Label6")]))
    });

    #[repr(u16)]
    pub enum ALabeledCounterForHgramLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ALabeledCounterForHgramLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ALabeledCounterForHgramLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter_for_hgram
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_labeled_counter_for_hgram: Lazy<LabeledMetric<LabeledCounterMetric, ALabeledCounterForHgramLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a_labeled_counter_for_hgram".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4826), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_labeled_counter_for_keyed_count_hgram
    ///
    /// This is a test-only metric.
    /// Just counting things.
    pub static a_labeled_counter_for_keyed_count_hgram: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "a_labeled_counter_for_keyed_count_hgram".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4827), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_memory_dist
    ///
    /// This is a test-only metric.
    /// Just measuring memory.
    pub static a_memory_dist: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_memory_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(4828), meta, MemoryUnit::Kilobyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_quantity
    ///
    /// This is a test-only metric.
    /// Just quantifying things.
    pub static a_quantity: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_quantity".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4829), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string
    ///
    /// This is a test-only metric.
    /// Just setting some strings.
    pub static a_string: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_string".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4830), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_string_list
    ///
    /// This is a test-only metric.
    /// Just appending some strings.
    pub static a_string_list: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_string_list".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(4831), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_text
    ///
    /// This is a test-only metric.
    /// For holding Text data.
    pub static a_text: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_text".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(4832), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_timing_dist
    ///
    /// This is a test-only metric.
    /// Just measuring time.
    pub static a_timing_dist: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_timing_dist".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(4833), meta, TimeUnit::Nanosecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_url
    ///
    /// This is a test-only metric.
    /// Just setting some Urls.
    pub static a_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_url".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(4834), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.a_uuid
    ///
    /// This is a test-only metric.
    /// Just recording some unique identifiers.
    pub static a_uuid: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "a_uuid".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(4835), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AnEventExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_event".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4836), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_external_denominator
    ///
    /// This is a test-only metric.
    /// A denominator not from around here.
    pub static an_external_denominator: Lazy<DenominatorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_external_denominator".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        DenominatorMetric::new(BaseMetricId(4837), meta, vec![CommonMetricData {name: "rate_with_external_denominator".into(), category: "test_only.ipc".into(), send_in_pings: vec!["test-ping".into()], lifetime: Lifetime::Ping, disabled: false,  ..Default::default()}])
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_unordered_bool
    ///
    /// This is a test-only metric.
    /// Just flagging things unorderedly in child processes.
    pub static an_unordered_bool: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_unordered_bool".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::with_unordered_ipc(BaseMetricId(4838), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.an_unordered_labeled_boolean
    ///
    /// This is a test-only metric.
    /// Just flagging labeled things unorderedly in child processes.
    pub static an_unordered_labeled_boolean: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "an_unordered_labeled_boolean".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::with_unordered_ipc(BaseMetricId(4839), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.another_labeled_counter
    ///
    /// This is a test-only metric.
    /// Just another metric counting labeled things.
    pub static another_labeled_counter: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "another_labeled_counter".into(),
                    category: "test_only.ipc".into(),
                    send_in_pings: vec!["test-ping".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4840), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EventWithExtraExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<u32>,
        pub r#extra3_longer_name: Option<bool>,
        pub r#extra4CamelCase: Option<bool>,
    }

    impl ExtraKeys for EventWithExtraExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2", "extra3_longer_name", "extra4CamelCase"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          self.r#extra3_longer_name.and_then(|val| map.insert("extra3_longer_name".into(), val.to_string()));
          self.r#extra4CamelCase.and_then(|val| map.insert("extra4CamelCase".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.event_with_extra
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    pub static event_with_extra: Lazy<EventMetric<EventWithExtraExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "event_with_extra".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4841), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.irate
    ///
    /// This is a test-only metric.
    /// A rate that isn't happy about it.
    pub static irate: Lazy<RateMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "irate".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        RateMetric::new(BaseMetricId(4842), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.no_extra_event
    ///
    /// This is a test-only metric.
    /// Just recording some events without the extra fuss.
    pub static no_extra_event: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "no_extra_event".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4843), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from test_only.ipc.rate_with_external_denominator
    ///
    /// This is a test-only metric.
    /// A rate with a denominator that is Out There.
    pub static rate_with_external_denominator: Lazy<NumeratorMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "rate_with_external_denominator".into(),
                category: "test_only.ipc".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        NumeratorMetric::new(BaseMetricId(4844), meta)
    });

}
pub mod test_only_jog {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.a_counter
    ///
    /// This is a test-only metric.
    /// Just counting things.
    /// Tied closely to test_jog_name_collision.
    pub static a_counter: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            4845,
            "test_only.jog",
            "a_counter",
            "test-ping"
        )
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AnEventExtra {
        pub r#extra1: Option<String>,
        pub r#extra2: Option<String>,
    }

    impl ExtraKeys for AnEventExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["extra1", "extra2"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#extra1.and_then(|val| map.insert("extra1".into(), val.to_string()));
          self.r#extra2.and_then(|val| map.insert("extra2".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from test_only.jog.an_event
    ///
    /// This is a test-only metric.
    /// Just recording some events.
    /// Tied closely to test_jog_name_collision.
    pub static an_event: Lazy<EventMetric<AnEventExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "an_event".into(),
                category: "test_only.jog".into(),
                send_in_pings: vec!["test-ping".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4846), meta)
    });

}
pub mod media_sniffer {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum Mp4BrandPatternLabel {
        EFtypMp4 = 0,
        EFtypAvc = 1,
        EFtyp3gp4 = 2,
        EFtyp3gp = 3,
        EFtypM4v = 4,
        EFtypM4a = 5,
        EFtypM4p = 6,
        EFtypQt = 7,
        EFtypIso = 8,
        EFtypMmp4 = 9,
        EFtypAvif = 10,
        EFtypCrx = 11,
        __Other__,
    }
    impl From<u16> for Mp4BrandPatternLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFtypMp4,
                1 => Self::EFtypAvc,
                2 => Self::EFtyp3gp4,
                3 => Self::EFtyp3gp,
                4 => Self::EFtypM4v,
                5 => Self::EFtypM4a,
                6 => Self::EFtypM4p,
                7 => Self::EFtypQt,
                8 => Self::EFtypIso,
                9 => Self::EFtypMmp4,
                10 => Self::EFtypAvif,
                11 => Self::EFtypCrx,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Mp4BrandPatternLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFtypMp4 => "ftyp_mp4",
                Self::EFtypAvc => "ftyp_avc",
                Self::EFtyp3gp4 => "ftyp_3gp4",
                Self::EFtyp3gp => "ftyp_3gp",
                Self::EFtypM4v => "ftyp_M4V",
                Self::EFtypM4a => "ftyp_M4A",
                Self::EFtypM4p => "ftyp_M4P",
                Self::EFtypQt => "ftyp_qt",
                Self::EFtypIso => "ftyp_iso",
                Self::EFtypMmp4 => "ftyp_mmp4",
                Self::EFtypAvif => "ftyp_avif",
                Self::EFtypCrx => "ftyp_crx",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from media_sniffer.mp4_brand_pattern
    ///
    /// ISOBMFF brand pattern used to identify MP4 in media sniffer
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram MEDIA_SNIFFER_MP4_BRAND_PATTERN.
    pub static mp4_brand_pattern: Lazy<LabeledMetric<LabeledCounterMetric, Mp4BrandPatternLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "mp4_brand_pattern".into(),
                    category: "media_sniffer".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4847), meta, Some(vec![::std::borrow::Cow::from("ftyp_3gp"), ::std::borrow::Cow::from("ftyp_3gp4"), ::std::borrow::Cow::from("ftyp_M4A"), ::std::borrow::Cow::from("ftyp_M4P"), ::std::borrow::Cow::from("ftyp_M4V"), ::std::borrow::Cow::from("ftyp_avc"), ::std::borrow::Cow::from("ftyp_avif"), ::std::borrow::Cow::from("ftyp_crx"), ::std::borrow::Cow::from("ftyp_iso"), ::std::borrow::Cow::from("ftyp_mmp4"), ::std::borrow::Cow::from("ftyp_mp4"), ::std::borrow::Cow::from("ftyp_qt")]))
    });

}
pub mod messaging_experiments {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachCfrExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachCfrExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_cfr
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#cfr.
    pub static reach_cfr: Lazy<EventMetric<ReachCfrExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_cfr".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4848), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFeatureCalloutExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFeatureCalloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_feature_callout
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#featureCallout.
    pub static reach_feature_callout: Lazy<EventMetric<ReachFeatureCalloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_feature_callout".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4849), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsBmbButtonExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsBmbButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_bmb_button
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_bmb_button.
    pub static reach_fxms_bmb_button: Lazy<EventMetric<ReachFxmsBmbButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_bmb_button".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4850), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage1Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_1
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_1.
    pub static reach_fxms_message_1: Lazy<EventMetric<ReachFxmsMessage1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_1".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4851), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage10Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage10Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_10
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_10.
    pub static reach_fxms_message_10: Lazy<EventMetric<ReachFxmsMessage10Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_10".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4852), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage11Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage11Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_11
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_11.
    pub static reach_fxms_message_11: Lazy<EventMetric<ReachFxmsMessage11Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_11".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4853), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage2Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_2
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_2.
    pub static reach_fxms_message_2: Lazy<EventMetric<ReachFxmsMessage2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_2".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4854), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage3Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage3Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_3
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_3.
    pub static reach_fxms_message_3: Lazy<EventMetric<ReachFxmsMessage3Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_3".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4855), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage4Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage4Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_4
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_4.
    pub static reach_fxms_message_4: Lazy<EventMetric<ReachFxmsMessage4Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_4".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4856), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage5Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage5Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_5
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_5.
    pub static reach_fxms_message_5: Lazy<EventMetric<ReachFxmsMessage5Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_5".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4857), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage6Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage6Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_6
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_6.
    pub static reach_fxms_message_6: Lazy<EventMetric<ReachFxmsMessage6Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_6".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4858), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage7Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage7Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_7
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_7.
    pub static reach_fxms_message_7: Lazy<EventMetric<ReachFxmsMessage7Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_7".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4859), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage8Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage8Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_8
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_8.
    pub static reach_fxms_message_8: Lazy<EventMetric<ReachFxmsMessage8Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_8".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4860), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachFxmsMessage9Extra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachFxmsMessage9Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_fxms_message_9
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#fxms_message_9.
    pub static reach_fxms_message_9: Lazy<EventMetric<ReachFxmsMessage9Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_fxms_message_9".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4861), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachInfobarExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachInfobarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_infobar
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#infobar.
    pub static reach_infobar: Lazy<EventMetric<ReachInfobarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_infobar".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4862), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachMomentsPageExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachMomentsPageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_moments_page
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#moments_page.
    pub static reach_moments_page: Lazy<EventMetric<ReachMomentsPageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_moments_page".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4863), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReachSpotlightExtra {
        pub r#branches: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReachSpotlightExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branches", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branches.and_then(|val| map.insert("branches".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.reach_spotlight
    ///
    /// This records whether a branch's targeting is satisfied for Messaging System experiments. All qualified branch ID(s) will be recorded in the 'extra_keys' for each active experiment, and the event 'value' will be the experiment ID This event was generated to correspond to the Legacy Telemetry event messaging_experiments.reach#spotlight.
    pub static reach_spotlight: Lazy<EventMetric<ReachSpotlightExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reach_spotlight".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4864), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TargetingAttributeErrorExtra {
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TargetingAttributeErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.targeting_attribute_error
    ///
    /// Record generic JEXL errors that result from issues with experiment or message targeting expressions. The value field contains the namespace and attribute name that caused the error. This event was generated to correspond to the Legacy Telemetry event messaging_experiments.targeting#attribute_error.
    pub static targeting_attribute_error: Lazy<EventMetric<TargetingAttributeErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_attribute_error".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4865), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TargetingAttributeTimeoutExtra {
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for TargetingAttributeTimeoutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from messaging_experiments.targeting_attribute_timeout
    ///
    /// Record generic JEXL errors that result from issues with experiment or message targeting expressions. The value field contains the namespace and attribute name that caused the error. This event was generated to correspond to the Legacy Telemetry event messaging_experiments.targeting#attribute_timeout.
    pub static targeting_attribute_timeout: Lazy<EventMetric<TargetingAttributeTimeoutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_attribute_timeout".into(),
                category: "messaging_experiments".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4866), meta)
    });

}
pub mod firefox_ai_runtime {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EngineCreationFailureExtra {
        pub r#engineId: Option<String>,
        pub r#error: Option<String>,
        pub r#featureId: Option<String>,
        pub r#modelId: Option<String>,
        pub r#taskName: Option<String>,
    }

    impl ExtraKeys for EngineCreationFailureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["engineId", "error", "featureId", "modelId", "taskName"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#engineId.and_then(|val| map.insert("engineId".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#featureId.and_then(|val| map.insert("featureId".into(), val.to_string()));
          self.r#modelId.and_then(|val| map.insert("modelId".into(), val.to_string()));
          self.r#taskName.and_then(|val| map.insert("taskName".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefox.ai.runtime.engine_creation_failure
    ///
    /// An inference engine has failed to create
    pub static engine_creation_failure: Lazy<EventMetric<EngineCreationFailureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_creation_failure".into(),
                category: "firefox.ai.runtime".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4867), meta)
    });

    #[repr(u16)]
    pub enum EngineCreationSuccessLabel {
        EAutofillMl = 0,
        EPdfjs = 1,
        EMlSuggestIntent = 2,
        EMlSuggestNer = 3,
        EAboutInference = 4,
        EWebextension = 5,
        EWllamapreview = 6,
        EDefaultEngine = 7,
        ESmartTabEmbeddingEngine = 8,
        ESmartTabTopicEngine = 9,
        __Other__,
    }
    impl From<u16> for EngineCreationSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAutofillMl,
                1 => Self::EPdfjs,
                2 => Self::EMlSuggestIntent,
                3 => Self::EMlSuggestNer,
                4 => Self::EAboutInference,
                5 => Self::EWebextension,
                6 => Self::EWllamapreview,
                7 => Self::EDefaultEngine,
                8 => Self::ESmartTabEmbeddingEngine,
                9 => Self::ESmartTabTopicEngine,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EngineCreationSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAutofillMl => "autofill-ml",
                Self::EPdfjs => "pdfjs",
                Self::EMlSuggestIntent => "ml-suggest-intent",
                Self::EMlSuggestNer => "ml-suggest-ner",
                Self::EAboutInference => "about-inference",
                Self::EWebextension => "webextension",
                Self::EWllamapreview => "wllamapreview",
                Self::EDefaultEngine => "default-engine",
                Self::ESmartTabEmbeddingEngine => "smart-tab-embedding-engine",
                Self::ESmartTabTopicEngine => "smart-tab-topic-engine",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefox.ai.runtime.engine_creation_success
    ///
    /// An inference engine was created
    pub static engine_creation_success: Lazy<LabeledMetric<LabeledTimingDistributionMetric, EngineCreationSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "engine_creation_success".into(),
                    category: "firefox.ai.runtime".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4868), meta, Some(vec![::std::borrow::Cow::from("about-inference"), ::std::borrow::Cow::from("autofill-ml"), ::std::borrow::Cow::from("default-engine"), ::std::borrow::Cow::from("ml-suggest-intent"), ::std::borrow::Cow::from("ml-suggest-ner"), ::std::borrow::Cow::from("pdfjs"), ::std::borrow::Cow::from("smart-tab-embedding-engine"), ::std::borrow::Cow::from("smart-tab-topic-engine"), ::std::borrow::Cow::from("webextension"), ::std::borrow::Cow::from("wllamapreview")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RunInferenceFailureExtra {
        pub r#engineId: Option<String>,
        pub r#featureId: Option<String>,
        pub r#modelId: Option<String>,
    }

    impl ExtraKeys for RunInferenceFailureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["engineId", "featureId", "modelId"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#engineId.and_then(|val| map.insert("engineId".into(), val.to_string()));
          self.r#featureId.and_then(|val| map.insert("featureId".into(), val.to_string()));
          self.r#modelId.and_then(|val| map.insert("modelId".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefox.ai.runtime.run_inference_failure
    ///
    /// An inference run has failed
    pub static run_inference_failure: Lazy<EventMetric<RunInferenceFailureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "run_inference_failure".into(),
                category: "firefox.ai.runtime".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4869), meta)
    });

    #[repr(u16)]
    pub enum RunInferenceSuccessLabel {
        EAutofillMl = 0,
        EPdfjs = 1,
        EMlSuggestIntent = 2,
        EMlSuggestNer = 3,
        EAboutInference = 4,
        EWebextension = 5,
        EWllamapreview = 6,
        EDefaultEngine = 7,
        ESmartTabEmbeddingEngine = 8,
        ESmartTabTopicEngine = 9,
        __Other__,
    }
    impl From<u16> for RunInferenceSuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAutofillMl,
                1 => Self::EPdfjs,
                2 => Self::EMlSuggestIntent,
                3 => Self::EMlSuggestNer,
                4 => Self::EAboutInference,
                5 => Self::EWebextension,
                6 => Self::EWllamapreview,
                7 => Self::EDefaultEngine,
                8 => Self::ESmartTabEmbeddingEngine,
                9 => Self::ESmartTabTopicEngine,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RunInferenceSuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAutofillMl => "autofill-ml",
                Self::EPdfjs => "pdfjs",
                Self::EMlSuggestIntent => "ml-suggest-intent",
                Self::EMlSuggestNer => "ml-suggest-ner",
                Self::EAboutInference => "about-inference",
                Self::EWebextension => "webextension",
                Self::EWllamapreview => "wllamapreview",
                Self::EDefaultEngine => "default-engine",
                Self::ESmartTabEmbeddingEngine => "smart-tab-embedding-engine",
                Self::ESmartTabTopicEngine => "smart-tab-topic-engine",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from firefox.ai.runtime.run_inference_success
    ///
    /// An inference engine was created
    pub static run_inference_success: Lazy<LabeledMetric<LabeledTimingDistributionMetric, RunInferenceSuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "run_inference_success".into(),
                    category: "firefox.ai.runtime".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(4870), meta, Some(vec![::std::borrow::Cow::from("about-inference"), ::std::borrow::Cow::from("autofill-ml"), ::std::borrow::Cow::from("default-engine"), ::std::borrow::Cow::from("ml-suggest-intent"), ::std::borrow::Cow::from("ml-suggest-ner"), ::std::borrow::Cow::from("pdfjs"), ::std::borrow::Cow::from("smart-tab-embedding-engine"), ::std::borrow::Cow::from("smart-tab-topic-engine"), ::std::borrow::Cow::from("webextension"), ::std::borrow::Cow::from("wllamapreview")]))
    });

}
pub mod nimbus_events {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for EnrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enroll_failed
    ///
    /// Recorded when an enrollment fails, including the reason for the failure.
    pub static enroll_failed: Lazy<EventMetric<EnrollFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4871), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollmentExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#experiment_type: Option<String>,
    }

    impl ExtraKeys for EnrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "experiment_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#experiment_type.and_then(|val| map.insert("experiment_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment
    ///
    /// Recorded when a user has met the conditions and is first bucketed into an experiment (i.e. targeting matched and they were randomized into a bucket and branch of the experiment). Expected a maximum of once per experiment per user.
    pub static enrollment: Lazy<EventMetric<EnrollmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollment".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4872), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollmentStatusExtra {
        pub r#branch: Option<String>,
        pub r#conflict_slug: Option<String>,
        pub r#error_string: Option<String>,
        pub r#reason: Option<String>,
        pub r#slug: Option<String>,
        pub r#status: Option<String>,
    }

    impl ExtraKeys for EnrollmentStatusExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "conflict_slug", "error_string", "reason", "slug", "status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflict_slug.and_then(|val| map.insert("conflict_slug".into(), val.to_string()));
          self.r#error_string.and_then(|val| map.insert("error_string".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#slug.and_then(|val| map.insert("slug".into(), val.to_string()));
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.enrollment_status
    ///
    /// Recorded for each enrollment status each time the SDK completes application of pending experiments.
    pub static enrollment_status: Lazy<EventMetric<EnrollmentStatusExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollment_status".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4873), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposureExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#feature_id: Option<String>,
    }

    impl ExtraKeys for ExposureExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#feature_id.and_then(|val| map.insert("feature_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.exposure
    ///
    /// Recorded when a user actually observes an experimental treatment, or would have observed an experimental treatment if they had been in a branch that would have shown one.
    pub static exposure: Lazy<EventMetric<ExposureExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exposure".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4874), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.is_ready
    ///
    /// An event sent when Nimbus is ready — sent upon completion of each update of the recipes.
    pub static is_ready: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_ready".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4875), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct MigrationExtra {
        pub r#enrollments: Option<String>,
        pub r#error_reason: Option<String>,
        pub r#migration_id: Option<String>,
        pub r#success: Option<bool>,
    }

    impl ExtraKeys for MigrationExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enrollments", "error_reason", "migration_id", "success"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enrollments.and_then(|val| map.insert("enrollments".into(), val.to_string()));
          self.r#error_reason.and_then(|val| map.insert("error_reason".into(), val.to_string()));
          self.r#migration_id.and_then(|val| map.insert("migration_id".into(), val.to_string()));
          self.r#success.and_then(|val| map.insert("success".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.migration
    ///
    /// Triggered whenever a Nimbus migration is attempted, whether or not it succeeds.
    pub static migration: Lazy<EventMetric<MigrationExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "migration".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4876), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedExtra {
        pub r#experiment: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["experiment", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenroll_failed
    ///
    /// Recorded when an unenrollment fails, including the reason for the failure.
    pub static unenroll_failed: Lazy<EventMetric<UnenrollFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4877), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollmentExtra {
        pub r#branch: Option<String>,
        pub r#changed_pref: Option<String>,
        pub r#conflicting_slug: Option<String>,
        pub r#experiment: Option<String>,
        pub r#pref_name: Option<String>,
        pub r#pref_type: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for UnenrollmentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "changed_pref", "conflicting_slug", "experiment", "pref_name", "pref_type", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changed_pref.and_then(|val| map.insert("changed_pref".into(), val.to_string()));
          self.r#conflicting_slug.and_then(|val| map.insert("conflicting_slug".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#pref_name.and_then(|val| map.insert("pref_name".into(), val.to_string()));
          self.r#pref_type.and_then(|val| map.insert("pref_type".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.unenrollment
    ///
    /// Recorded when either telemetry is disabled, or the experiment has run for its designed duration (i.e. it is no longer present in the Nimbus Remote Settings collection)
    pub static unenrollment: Lazy<EventMetric<UnenrollmentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenrollment".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4878), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ValidationFailedExtra {
        pub r#branch: Option<String>,
        pub r#experiment: Option<String>,
        pub r#feature_ids: Option<String>,
        pub r#l10n_ids: Option<String>,
        pub r#locale: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ValidationFailedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "experiment", "feature_ids", "l10n_ids", "locale", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experiment.and_then(|val| map.insert("experiment".into(), val.to_string()));
          self.r#feature_ids.and_then(|val| map.insert("feature_ids".into(), val.to_string()));
          self.r#l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.r#locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_events.validation_failed
    ///
    /// This records when validation of a recipe fails.
    pub static validation_failed: Lazy<EventMetric<ValidationFailedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_failed".into(),
                category: "nimbus_events".into(),
                send_in_pings: vec!["background-update".into(), "events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4879), meta)
    });

}
pub mod nimbus_targeting_context {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type ActiveExperimentsObject = Vec<ActiveExperimentsObjectItem>;

    pub type ActiveExperimentsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.active_experiments
    ///
    /// The slugs of the actively enrolled experiments
    pub static active_experiments: Lazy<ObjectMetric<ActiveExperimentsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_experiments".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4880), meta)
    });

        pub type ActiveRolloutsObject = Vec<ActiveRolloutsObjectItem>;

    pub type ActiveRolloutsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.active_rollouts
    ///
    /// The slugs of the actively enrolled rollouts
    pub static active_rollouts: Lazy<ObjectMetric<ActiveRolloutsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_rollouts".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4881), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.addresses_saved
    ///
    /// The number of addresses the user has saved.
    pub static addresses_saved: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addresses_saved".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4882), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.arch_bits
    ///
    /// The architecture of the user's CPU (32-bit or 64-bit)
    pub static arch_bits: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "arch_bits".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4883), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct AttributionDataObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub medium: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub source: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub ua: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.attribution_data
    ///
    /// Attribution data.
    pub static attribution_data: Lazy<ObjectMetric<AttributionDataObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "attribution_data".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4884), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct BrowserSettingsObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub update: Option<BrowserSettingsObjectItemUpdateObject>,
    }

            #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct BrowserSettingsObjectItemUpdateObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub channel: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.browser_settings
    ///
    /// Information about the browser's update channel.
    pub static browser_settings: Lazy<ObjectMetric<BrowserSettingsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser_settings".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4885), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.current_date
    ///
    /// The current date, as an ISO-8601 string.
    pub static current_date: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "current_date".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4886), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct DefaultPdfHandlerObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub knownBrowser: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub registered: Option<bool>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.default_pdf_handler
    ///
    /// Information about the system's default PDF handler.
    pub static default_pdf_handler: Lazy<ObjectMetric<DefaultPdfHandlerObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_pdf_handler".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4887), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.distribution_id
    ///
    /// The installation's distribution ID.
    pub static distribution_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "distribution_id".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4888), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.does_app_need_pin
    ///
    /// Does the app need pinning (i.e., is the app not pinned).
    pub static does_app_need_pin: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "does_app_need_pin".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4889), meta)
    });

        pub type EnrollmentsMapObject = Vec<EnrollmentsMapObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct EnrollmentsMapObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub experimentSlug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branchSlug: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.enrollments_map
    ///
    /// Information about historic enrollments, including the branches enrolled.
    pub static enrollments_map: Lazy<ObjectMetric<EnrollmentsMapObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollments_map".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4890), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.firefox_version
    ///
    /// The Firefox major version number.
    pub static firefox_version: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "firefox_version".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4891), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.has_active_enterprise_policies
    ///
    /// Whether the profile has any active enterprise policies.
    pub static has_active_enterprise_policies: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_active_enterprise_policies".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4892), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct HomePageSettingsObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isCustomUrl: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isDefault: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isLocked: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isWebExt: Option<bool>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.home_page_settings
    ///
    /// Information about the user's home page settings.
    pub static home_page_settings: Lazy<ObjectMetric<HomePageSettingsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "home_page_settings".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4893), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_default_browser
    ///
    /// Whether the current browser is the default browser.
    pub static is_default_browser: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_default_browser".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4894), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct IsDefaultHandlerObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub html: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub pdf: Option<bool>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_default_handler
    ///
    /// Whether the current browser is registered as the default handler for various filetypes.
    pub static is_default_handler: Lazy<ObjectMetric<IsDefaultHandlerObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_default_handler".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4895), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_first_startup
    ///
    /// Is this the first startup of the browser on this install? (NB: Must have been explicitly launched with the --first-startup commandline flag.)
    pub static is_first_startup: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_first_startup".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4896), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_fx_a_enabled
    ///
    /// Whether Firefox Accounts and Sync are enabled.
    pub static is_fx_a_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_fx_a_enabled".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4897), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_fx_a_signed_in
    ///
    /// Whether the user is logged in to Firefox Accounts.
    pub static is_fx_a_signed_in: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_fx_a_signed_in".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4898), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.is_msix
    ///
    /// Is this copy of Firefox installed from an MSIX installer?
    pub static is_msix: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_msix".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4899), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.locale
    ///
    /// What is the active locale of the browser?
    pub static locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "locale".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4900), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.memory_mb
    ///
    /// The amount of system memory, in mebibytes (MiB).
    pub static memory_mb: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory_mb".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4901), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct OsObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isLinux: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isMac: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isWindows: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub windowsBuildNumber: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub windowsVersion: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.os
    ///
    /// Information about the operating system.
    pub static os: Lazy<ObjectMetric<OsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4902), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct PrimaryResolutionObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub height: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub width: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.primary_resolution
    ///
    /// The resolution of the primary display.
    pub static primary_resolution: Lazy<ObjectMetric<PrimaryResolutionObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "primary_resolution".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4903), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.profile_age_created
    ///
    /// The UNIX timestamp of when the profile was created.
    pub static profile_age_created: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_age_created".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4904), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.region
    ///
    /// What region is the browser located in?
    pub static region: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "region".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4905), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.total_bookmarks_count
    ///
    /// The number of bookmarks.
    pub static total_bookmarks_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "total_bookmarks_count".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4906), meta)
    });

        pub type UserMonthlyActivityObject = Vec<UserMonthlyActivityObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct UserMonthlyActivityObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub numberOfURLsVisited: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub date: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.user_monthly_activity
    ///
    /// Information about the user's activity over the last 28 days.
    pub static user_monthly_activity: Lazy<ObjectMetric<UserMonthlyActivityObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_monthly_activity".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4907), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.user_prefers_reduced_motion
    ///
    /// Whether the user prefers reduced motion.
    pub static user_prefers_reduced_motion: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_prefers_reduced_motion".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4908), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.uses_firefox_sync
    ///
    /// Whether the user uses Firefox Sync.
    pub static uses_firefox_sync: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uses_firefox_sync".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4909), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_context.version
    ///
    /// The full Firefox version string.
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "nimbus_targeting_context".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(4910), meta)
    });

}
pub mod nimbus_targeting_environment {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum AttrEvalErrorsLabel {
        EActiveexperiments = 0,
        EActiverollouts = 1,
        EAddressessaved = 2,
        EArchbits = 3,
        EAttributiondata = 4,
        EBrowsersettings = 5,
        ECurrentdate = 6,
        EDefaultpdfhandler = 7,
        EDistributionid = 8,
        EDoesappneedpin = 9,
        EEnrollmentsmap = 10,
        EFirefoxversion = 11,
        EHasactiveenterprisepolicies = 12,
        EHomepagesettings = 13,
        EIsdefaultbrowser = 14,
        EIsdefaulthandler = 15,
        EIsfirststartup = 16,
        EIsfxaenabled = 17,
        EIsfxasignedin = 18,
        EIsmsix = 19,
        ELocale = 20,
        EMemorymb = 21,
        EOs = 22,
        EPrimaryresolution = 23,
        EProfileagecreated = 24,
        ERegion = 25,
        ETotalbookmarkscount = 26,
        EUsermonthlyactivity = 27,
        EUserprefersreducedmotion = 28,
        EUsesfirefoxsync = 29,
        EVersion = 30,
        __Other__,
    }
    impl From<u16> for AttrEvalErrorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EActiveexperiments,
                1 => Self::EActiverollouts,
                2 => Self::EAddressessaved,
                3 => Self::EArchbits,
                4 => Self::EAttributiondata,
                5 => Self::EBrowsersettings,
                6 => Self::ECurrentdate,
                7 => Self::EDefaultpdfhandler,
                8 => Self::EDistributionid,
                9 => Self::EDoesappneedpin,
                10 => Self::EEnrollmentsmap,
                11 => Self::EFirefoxversion,
                12 => Self::EHasactiveenterprisepolicies,
                13 => Self::EHomepagesettings,
                14 => Self::EIsdefaultbrowser,
                15 => Self::EIsdefaulthandler,
                16 => Self::EIsfirststartup,
                17 => Self::EIsfxaenabled,
                18 => Self::EIsfxasignedin,
                19 => Self::EIsmsix,
                20 => Self::ELocale,
                21 => Self::EMemorymb,
                22 => Self::EOs,
                23 => Self::EPrimaryresolution,
                24 => Self::EProfileagecreated,
                25 => Self::ERegion,
                26 => Self::ETotalbookmarkscount,
                27 => Self::EUsermonthlyactivity,
                28 => Self::EUserprefersreducedmotion,
                29 => Self::EUsesfirefoxsync,
                30 => Self::EVersion,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AttrEvalErrorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EActiveexperiments => "activeExperiments",
                Self::EActiverollouts => "activeRollouts",
                Self::EAddressessaved => "addressesSaved",
                Self::EArchbits => "archBits",
                Self::EAttributiondata => "attributionData",
                Self::EBrowsersettings => "browserSettings",
                Self::ECurrentdate => "currentDate",
                Self::EDefaultpdfhandler => "defaultPDFHandler",
                Self::EDistributionid => "distributionId",
                Self::EDoesappneedpin => "doesAppNeedPin",
                Self::EEnrollmentsmap => "enrollmentsMap",
                Self::EFirefoxversion => "firefoxVersion",
                Self::EHasactiveenterprisepolicies => "hasActiveEnterprisePolicies",
                Self::EHomepagesettings => "homePageSettings",
                Self::EIsdefaultbrowser => "isDefaultBrowser",
                Self::EIsdefaulthandler => "isDefaultHandler",
                Self::EIsfirststartup => "isFirstStartup",
                Self::EIsfxaenabled => "isFxAEnabled",
                Self::EIsfxasignedin => "isFxASignedIn",
                Self::EIsmsix => "isMSIX",
                Self::ELocale => "locale",
                Self::EMemorymb => "memoryMB",
                Self::EOs => "os",
                Self::EPrimaryresolution => "primaryResolution",
                Self::EProfileagecreated => "profileAgeCreated",
                Self::ERegion => "region",
                Self::ETotalbookmarkscount => "totalBookmarksCount",
                Self::EUsermonthlyactivity => "userMonthlyActivity",
                Self::EUserprefersreducedmotion => "userPrefersReducedMotion",
                Self::EUsesfirefoxsync => "usesFirefoxSync",
                Self::EVersion => "version",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_environment.attr_eval_errors
    ///
    /// When a metric in `nimbus_targeting_context` cannot be recorded because an exception was thrown during evaluation of the targeting context attribute the name of the attribute is recorded in this metric.
    pub static attr_eval_errors: Lazy<LabeledMetric<LabeledCounterMetric, AttrEvalErrorsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "attr_eval_errors".into(),
                    category: "nimbus_targeting_environment".into(),
                    send_in_pings: vec!["nimbus-targeting-context".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4911), meta, Some(vec![::std::borrow::Cow::from("activeExperiments"), ::std::borrow::Cow::from("activeRollouts"), ::std::borrow::Cow::from("addressesSaved"), ::std::borrow::Cow::from("archBits"), ::std::borrow::Cow::from("attributionData"), ::std::borrow::Cow::from("browserSettings"), ::std::borrow::Cow::from("currentDate"), ::std::borrow::Cow::from("defaultPDFHandler"), ::std::borrow::Cow::from("distributionId"), ::std::borrow::Cow::from("doesAppNeedPin"), ::std::borrow::Cow::from("enrollmentsMap"), ::std::borrow::Cow::from("firefoxVersion"), ::std::borrow::Cow::from("hasActiveEnterprisePolicies"), ::std::borrow::Cow::from("homePageSettings"), ::std::borrow::Cow::from("isDefaultBrowser"), ::std::borrow::Cow::from("isDefaultHandler"), ::std::borrow::Cow::from("isFirstStartup"), ::std::borrow::Cow::from("isFxAEnabled"), ::std::borrow::Cow::from("isFxASignedIn"), ::std::borrow::Cow::from("isMSIX"), ::std::borrow::Cow::from("locale"), ::std::borrow::Cow::from("memoryMB"), ::std::borrow::Cow::from("os"), ::std::borrow::Cow::from("primaryResolution"), ::std::borrow::Cow::from("profileAgeCreated"), ::std::borrow::Cow::from("region"), ::std::borrow::Cow::from("totalBookmarksCount"), ::std::borrow::Cow::from("userMonthlyActivity"), ::std::borrow::Cow::from("userPrefersReducedMotion"), ::std::borrow::Cow::from("usesFirefoxSync"), ::std::borrow::Cow::from("version")]))
    });

    #[repr(u16)]
    pub enum PrefTypeErrorsLabel {
        EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrAddons = 0,
        EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrFeatures = 1,
        EBrowserNewtabpageActivityStreamFeedsSectionHighlights = 2,
        EBrowserNewtabpageActivityStreamFeedsSectionTopstories = 3,
        EBrowserNewtabpageActivityStreamFeedsTopsites = 4,
        EBrowserNewtabpageActivityStreamShowsearch = 5,
        EBrowserNewtabpageActivityStreamShowsponsoredtopsites = 6,
        EBrowserNewtabpageEnabled = 7,
        EBrowserShoppingExperience2023Autoactivatecount = 8,
        EBrowserShoppingExperience2023Optedin = 9,
        EBrowserToolbarsBookmarksVisibility = 10,
        EBrowserUrlbarQuicksuggestDatacollectionEnabled = 11,
        EBrowserUrlbarShowsearchsuggestionsfirst = 12,
        EBrowserUrlbarSuggestQuicksuggestSponsored = 13,
        EMediaVideocontrolsPictureInPictureEnabled = 14,
        EMediaVideocontrolsPictureInPictureVideoToggleEnabled = 15,
        EMediaVideocontrolsPictureInPictureVideoToggleHasUsed = 16,
        EMessagingSystemActionTestday = 17,
        ENetworkTrrMode = 18,
        ENimbusQaPref1 = 19,
        ENimbusQaPref2 = 20,
        ESecuritySandboxContentLevel = 21,
        ETrailheadFirstrunDidseeaboutwelcome = 22,
        __Other__,
    }
    impl From<u16> for PrefTypeErrorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrAddons,
                1 => Self::EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrFeatures,
                2 => Self::EBrowserNewtabpageActivityStreamFeedsSectionHighlights,
                3 => Self::EBrowserNewtabpageActivityStreamFeedsSectionTopstories,
                4 => Self::EBrowserNewtabpageActivityStreamFeedsTopsites,
                5 => Self::EBrowserNewtabpageActivityStreamShowsearch,
                6 => Self::EBrowserNewtabpageActivityStreamShowsponsoredtopsites,
                7 => Self::EBrowserNewtabpageEnabled,
                8 => Self::EBrowserShoppingExperience2023Autoactivatecount,
                9 => Self::EBrowserShoppingExperience2023Optedin,
                10 => Self::EBrowserToolbarsBookmarksVisibility,
                11 => Self::EBrowserUrlbarQuicksuggestDatacollectionEnabled,
                12 => Self::EBrowserUrlbarShowsearchsuggestionsfirst,
                13 => Self::EBrowserUrlbarSuggestQuicksuggestSponsored,
                14 => Self::EMediaVideocontrolsPictureInPictureEnabled,
                15 => Self::EMediaVideocontrolsPictureInPictureVideoToggleEnabled,
                16 => Self::EMediaVideocontrolsPictureInPictureVideoToggleHasUsed,
                17 => Self::EMessagingSystemActionTestday,
                18 => Self::ENetworkTrrMode,
                19 => Self::ENimbusQaPref1,
                20 => Self::ENimbusQaPref2,
                21 => Self::ESecuritySandboxContentLevel,
                22 => Self::ETrailheadFirstrunDidseeaboutwelcome,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PrefTypeErrorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrAddons => "browser.newtabpage.activity-stream.asrouter.userprefs.cfr.addons",
                Self::EBrowserNewtabpageActivityStreamAsrouterUserprefsCfrFeatures => "browser.newtabpage.activity-stream.asrouter.userprefs.cfr.features",
                Self::EBrowserNewtabpageActivityStreamFeedsSectionHighlights => "browser.newtabpage.activity-stream.feeds.section.highlights",
                Self::EBrowserNewtabpageActivityStreamFeedsSectionTopstories => "browser.newtabpage.activity-stream.feeds.section.topstories",
                Self::EBrowserNewtabpageActivityStreamFeedsTopsites => "browser.newtabpage.activity-stream.feeds.topsites",
                Self::EBrowserNewtabpageActivityStreamShowsearch => "browser.newtabpage.activity-stream.showSearch",
                Self::EBrowserNewtabpageActivityStreamShowsponsoredtopsites => "browser.newtabpage.activity-stream.showSponsoredTopSites",
                Self::EBrowserNewtabpageEnabled => "browser.newtabpage.enabled",
                Self::EBrowserShoppingExperience2023Autoactivatecount => "browser.shopping.experience2023.autoActivateCount",
                Self::EBrowserShoppingExperience2023Optedin => "browser.shopping.experience2023.optedIn",
                Self::EBrowserToolbarsBookmarksVisibility => "browser.toolbars.bookmarks.visibility",
                Self::EBrowserUrlbarQuicksuggestDatacollectionEnabled => "browser.urlbar.quicksuggest.dataCollection.enabled",
                Self::EBrowserUrlbarShowsearchsuggestionsfirst => "browser.urlbar.showSearchSuggestionsFirst",
                Self::EBrowserUrlbarSuggestQuicksuggestSponsored => "browser.urlbar.suggest.quicksuggest.sponsored",
                Self::EMediaVideocontrolsPictureInPictureEnabled => "media.videocontrols.picture-in-picture.enabled",
                Self::EMediaVideocontrolsPictureInPictureVideoToggleEnabled => "media.videocontrols.picture-in-picture.video-toggle.enabled",
                Self::EMediaVideocontrolsPictureInPictureVideoToggleHasUsed => "media.videocontrols.picture-in-picture.video-toggle.has-used",
                Self::EMessagingSystemActionTestday => "messaging-system-action.testday",
                Self::ENetworkTrrMode => "network.trr.mode",
                Self::ENimbusQaPref1 => "nimbus.qa.pref-1",
                Self::ENimbusQaPref2 => "nimbus.qa.pref-2",
                Self::ESecuritySandboxContentLevel => "security.sandbox.content.level",
                Self::ETrailheadFirstrunDidseeaboutwelcome => "trailhead.firstrun.didSeeAboutWelcome",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_environment.pref_type_errors
    ///
    /// When a pref in `nimbus_targeting_environment.pref_values` cannot be recorded because the type in the metric does not match the type of the pref, it is recorded in this metric.
    pub static pref_type_errors: Lazy<LabeledMetric<LabeledCounterMetric, PrefTypeErrorsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pref_type_errors".into(),
                    category: "nimbus_targeting_environment".into(),
                    send_in_pings: vec!["nimbus-targeting-context".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4912), meta, Some(vec![::std::borrow::Cow::from("browser.newtabpage.activity-stream.asrouter.userprefs.cfr.addons"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.asrouter.userprefs.cfr.features"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.feeds.section.highlights"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.feeds.section.topstories"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.feeds.topsites"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.showSearch"), ::std::borrow::Cow::from("browser.newtabpage.activity-stream.showSponsoredTopSites"), ::std::borrow::Cow::from("browser.newtabpage.enabled"), ::std::borrow::Cow::from("browser.shopping.experience2023.autoActivateCount"), ::std::borrow::Cow::from("browser.shopping.experience2023.optedIn"), ::std::borrow::Cow::from("browser.toolbars.bookmarks.visibility"), ::std::borrow::Cow::from("browser.urlbar.quicksuggest.dataCollection.enabled"), ::std::borrow::Cow::from("browser.urlbar.showSearchSuggestionsFirst"), ::std::borrow::Cow::from("browser.urlbar.suggest.quicksuggest.sponsored"), ::std::borrow::Cow::from("media.videocontrols.picture-in-picture.enabled"), ::std::borrow::Cow::from("media.videocontrols.picture-in-picture.video-toggle.enabled"), ::std::borrow::Cow::from("media.videocontrols.picture-in-picture.video-toggle.has-used"), ::std::borrow::Cow::from("messaging-system-action.testday"), ::std::borrow::Cow::from("network.trr.mode"), ::std::borrow::Cow::from("nimbus.qa.pref-1"), ::std::borrow::Cow::from("nimbus.qa.pref-2"), ::std::borrow::Cow::from("security.sandbox.content.level"), ::std::borrow::Cow::from("trailhead.firstrun.didSeeAboutWelcome")]))
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct PrefValuesObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__asrouter__userprefs__cfr__addons: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__asrouter__userprefs__cfr__features: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__feeds__section__highlights: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__feeds__section__topstories: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__feeds__topsites: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__showSearch: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__activity_stream__showSponsoredTopSites: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__newtabpage__enabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__shopping__experience2023__autoActivateCount: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__shopping__experience2023__optedIn: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__toolbars__bookmarks__visibility: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__urlbar__quicksuggest__dataCollection__enabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__urlbar__showSearchSuggestionsFirst: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub browser__urlbar__suggest__quicksuggest__sponsored: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub media__videocontrols__picture_in_picture__enabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub media__videocontrols__picture_in_picture__video_toggle__enabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub media__videocontrols__picture_in_picture__video_toggle__has_used: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub messaging_system_action__testday: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub network__trr__mode: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub security__sandbox__content__level: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub trailhead__firstrun__didSeeAboutWelcome: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub nimbus__qa__pref_1: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub nimbus__qa__pref_2: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_environment.pref_values
    ///
    /// Values of specific preferences we want to target on.
    pub static pref_values: Lazy<ObjectMetric<PrefValuesObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_values".into(),
                category: "nimbus_targeting_environment".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4913), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_environment.targeting_context_value
    ///
    /// The entirety of the Nimbus targeting context as a stringified JSON object.
    /// This is disabled by default and only intended to be enabled via server knobs to debug recording failures in individual nimbus_targeting_context metric values.
    pub static targeting_context_value: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "targeting_context_value".into(),
                category: "nimbus_targeting_environment".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: true,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(4914), meta)
    });

        pub type UserSetPrefsObject = Vec<UserSetPrefsObjectItem>;

    pub type UserSetPrefsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from nimbus_targeting_environment.user_set_prefs
    ///
    /// An array of preferences that are user set.
    pub static user_set_prefs: Lazy<ObjectMetric<UserSetPrefsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_set_prefs".into(),
                category: "nimbus_targeting_environment".into(),
                send_in_pings: vec!["nimbus-targeting-context".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(4915), meta)
    });

}
pub mod normandy {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExposeNimbusExperimentExtra {
        pub r#branchSlug: Option<String>,
        pub r#featureId: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExposeNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branchSlug", "featureId", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branchSlug.and_then(|val| map.insert("branchSlug".into(), val.to_string()));
          self.r#featureId.and_then(|val| map.insert("featureId".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.expose_nimbus_experiment
    ///
    /// This records an event at the moment the user is exposed to an experiment treatment. The event is triggered either by the code checking that a certain experiment feature is enabled or when that feature value is used. This is different from enrollment or experiment activation because it registers when a user actually gets exposed to the experiment feature. This event was generated to correspond to the Legacy Telemetry event normandy.expose#nimbus_experiment.
    pub static expose_nimbus_experiment: Lazy<EventMetric<ExposeNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expose_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4916), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_addon_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This event was generated to correspond to the Legacy Telemetry event normandy.enroll#addon_rollout.
    pub static enroll_addon_rollout: Lazy<EventMetric<EnrollAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4917), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_addon_study
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This event was generated to correspond to the Legacy Telemetry event normandy.enroll#addon_study.
    pub static enroll_addon_study: Lazy<EventMetric<EnrollAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4918), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_addon_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event was generated to correspond to the Legacy Telemetry event normandy.enrollFailed#addon_rollout.
    pub static enroll_failed_addon_rollout: Lazy<EventMetric<EnrollFailedAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4919), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_addon_study
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event was generated to correspond to the Legacy Telemetry event normandy.enrollFailed#addon_study.
    pub static enroll_failed_addon_study: Lazy<EventMetric<EnrollFailedAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4920), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_nimbus_experiment
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event was generated to correspond to the Legacy Telemetry event normandy.enrollFailed#nimbus_experiment.
    pub static enroll_failed_nimbus_experiment: Lazy<EventMetric<EnrollFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4921), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedPreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedPreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_preference_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event was generated to correspond to the Legacy Telemetry event normandy.enrollFailed#preference_rollout.
    pub static enroll_failed_preference_rollout: Lazy<EventMetric<EnrollFailedPreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4922), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollFailedPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#branch: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefBranch: Option<String>,
        pub r#preference: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollFailedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "branch", "conflictingSlug", "detail", "enrollmentId", "prefBranch", "preference", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefBranch.and_then(|val| map.insert("prefBranch".into(), val.to_string()));
          self.r#preference.and_then(|val| map.insert("preference".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_failed_preference_study
    ///
    /// Sent when applying a Normandy recipe of the above types has failed. This event was generated to correspond to the Legacy Telemetry event normandy.enrollFailed#preference_study.
    pub static enroll_failed_preference_study: Lazy<EventMetric<EnrollFailedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_failed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4923), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_nimbus_experiment
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This event was generated to correspond to the Legacy Telemetry event normandy.enroll#nimbus_experiment.
    pub static enroll_nimbus_experiment: Lazy<EventMetric<EnrollNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4924), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollPreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollPreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_preference_rollout
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This event was generated to correspond to the Legacy Telemetry event normandy.enroll#preference_rollout.
    pub static enroll_preference_rollout: Lazy<EventMetric<EnrollPreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4925), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnrollPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#experimentType: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnrollPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "experimentType", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#experimentType.and_then(|val| map.insert("experimentType".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.enroll_preference_study
    ///
    /// Sent when applying a Normandy recipe of the above types has succeeded. This event was generated to correspond to the Legacy Telemetry event normandy.enroll#preference_study.
    pub static enroll_preference_study: Lazy<EventMetric<EnrollPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enroll_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4926), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ExpPrefChangedPreferenceStudyExtra {
        pub r#enrollmentId: Option<String>,
        pub r#preferenceName: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ExpPrefChangedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enrollmentId", "preferenceName", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#preferenceName.and_then(|val| map.insert("preferenceName".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.exp_pref_changed_preference_study
    ///
    /// This records that a preference that was set by an experiment has been changed away from its experimental value. This can be triggered by a user changing a preference at runtime, by the preference being changed on disk when Firefox is not running, or by the preference already having a user-set value when a user has enrolls in a default branch experiment. This event was generated to correspond to the Legacy Telemetry event normandy.expPrefChanged#preference_study.
    pub static exp_pref_changed_preference_study: Lazy<EventMetric<ExpPrefChangedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "exp_pref_changed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4927), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GraduatePreferenceRolloutExtra {
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for GraduatePreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.graduate_preference_rollout
    ///
    /// Sent when a preference rollout ends due to the rolled-out preference becoming a new default. This event was generated to correspond to the Legacy Telemetry event normandy.graduate#preference_rollout.
    pub static graduate_preference_rollout: Lazy<EventMetric<GraduatePreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "graduate_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4928), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from normandy.recipe_freshness
    ///
    /// For each recipe ID seen by the Normandy client, its last_modified. This metric was generated to correspond to the Legacy Telemetry scalar normandy.recipe_freshness.
    pub static recipe_freshness: Lazy<LabeledMetric<LabeledQuantityMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "recipe_freshness".into(),
                    category: "normandy".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4929), meta, None)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollAddonRollbackExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollAddonRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_addon_rollback
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For preference_rollback, this is fired when the recipe is fired (the recipe that "ends" is a corresponding preference_rollout). This event was generated to correspond to the Legacy Telemetry event normandy.unenroll#addon_rollback.
    pub static unenroll_addon_rollback: Lazy<EventMetric<UnenrollAddonRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_addon_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4930), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_addon_study
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For preference_rollback, this is fired when the recipe is fired (the recipe that "ends" is a corresponding preference_rollout). This event was generated to correspond to the Legacy Telemetry event normandy.unenroll#addon_study.
    pub static unenroll_addon_study: Lazy<EventMetric<UnenrollAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4931), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedAddonRollbackExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedAddonRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_addon_rollback
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was generated to correspond to the Legacy Telemetry event normandy.unenrollFailed#addon_rollback.
    pub static unenroll_failed_addon_rollback: Lazy<EventMetric<UnenrollFailedAddonRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_addon_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4932), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedNimbusExperimentExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_nimbus_experiment
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was generated to correspond to the Legacy Telemetry event normandy.unenrollFailed#nimbus_experiment.
    pub static unenroll_failed_nimbus_experiment: Lazy<EventMetric<UnenrollFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4933), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedPreferenceRollbackExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedPreferenceRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_preference_rollback
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was generated to correspond to the Legacy Telemetry event normandy.unenrollFailed#preference_rollback.
    pub static unenroll_failed_preference_rollback: Lazy<EventMetric<UnenrollFailedPreferenceRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_preference_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4934), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollFailedPreferenceStudyExtra {
        pub r#caller: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#originalReason: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollFailedPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["caller", "changedPref", "enrollmentId", "originalReason", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#caller.and_then(|val| map.insert("caller".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#originalReason.and_then(|val| map.insert("originalReason".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_failed_preference_study
    ///
    /// Sent when unenrolling a user fails (see the unenroll event). This event was generated to correspond to the Legacy Telemetry event normandy.unenrollFailed#preference_study.
    pub static unenroll_failed_preference_study: Lazy<EventMetric<UnenrollFailedPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_failed_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4935), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_nimbus_experiment
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For preference_rollback, this is fired when the recipe is fired (the recipe that "ends" is a corresponding preference_rollout). This event was generated to correspond to the Legacy Telemetry event normandy.unenroll#nimbus_experiment.
    pub static unenroll_nimbus_experiment: Lazy<EventMetric<UnenrollNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4936), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollPreferenceRollbackExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollPreferenceRollbackExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_preference_rollback
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For preference_rollback, this is fired when the recipe is fired (the recipe that "ends" is a corresponding preference_rollout). This event was generated to correspond to the Legacy Telemetry event normandy.unenroll#preference_rollback.
    pub static unenroll_preference_rollback: Lazy<EventMetric<UnenrollPreferenceRollbackExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_preference_rollback".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4937), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnenrollPreferenceStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#changedPref: Option<String>,
        pub r#conflictingSlug: Option<String>,
        pub r#didResetValue: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#prefName: Option<String>,
        pub r#prefType: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UnenrollPreferenceStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "changedPref", "conflictingSlug", "didResetValue", "enrollmentId", "prefName", "prefType", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#changedPref.and_then(|val| map.insert("changedPref".into(), val.to_string()));
          self.r#conflictingSlug.and_then(|val| map.insert("conflictingSlug".into(), val.to_string()));
          self.r#didResetValue.and_then(|val| map.insert("didResetValue".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#prefName.and_then(|val| map.insert("prefName".into(), val.to_string()));
          self.r#prefType.and_then(|val| map.insert("prefType".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.unenroll_preference_study
    ///
    /// Sent when a Normandy recipe of certain types "ends".  N.B. For preference_rollback, this is fired when the recipe is fired (the recipe that "ends" is a corresponding preference_rollout). This event was generated to correspond to the Legacy Telemetry event normandy.unenroll#preference_study.
    pub static unenroll_preference_study: Lazy<EventMetric<UnenrollPreferenceStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unenroll_preference_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4938), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateAddonRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_addon_rollout
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has changed on the server, and the new version of the recipe is being applied over an existing, older version previously fetched from the server. This event was generated to correspond to the Legacy Telemetry event normandy.update#addon_rollout.
    pub static update_addon_rollout: Lazy<EventMetric<UpdateAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4939), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateAddonStudyExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_addon_study
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has changed on the server, and the new version of the recipe is being applied over an existing, older version previously fetched from the server. This event was generated to correspond to the Legacy Telemetry event normandy.update#addon_study.
    pub static update_addon_study: Lazy<EventMetric<UpdateAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4940), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateFailedAddonRolloutExtra {
        pub r#branch: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateFailedAddonRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "detail", "enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_failed_addon_rollout
    ///
    /// Sent when applying a new version of a Normandy recipe of the above types (over an existing, older version previously fetched from the server) has failed. This event was generated to correspond to the Legacy Telemetry event normandy.updateFailed#addon_rollout.
    pub static update_failed_addon_rollout: Lazy<EventMetric<UpdateFailedAddonRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_failed_addon_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4941), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateFailedAddonStudyExtra {
        pub r#branch: Option<String>,
        pub r#detail: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateFailedAddonStudyExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "detail", "enrollmentId", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#detail.and_then(|val| map.insert("detail".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_failed_addon_study
    ///
    /// Sent when applying a new version of a Normandy recipe of the above types (over an existing, older version previously fetched from the server) has failed. This event was generated to correspond to the Legacy Telemetry event normandy.updateFailed#addon_study.
    pub static update_failed_addon_study: Lazy<EventMetric<UpdateFailedAddonStudyExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_failed_addon_study".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4942), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateNimbusExperimentExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_nimbus_experiment
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has changed on the server, and the new version of the recipe is being applied over an existing, older version previously fetched from the server. This event was generated to correspond to the Legacy Telemetry event normandy.update#nimbus_experiment.
    pub static update_nimbus_experiment: Lazy<EventMetric<UpdateNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4943), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdatePreferenceRolloutExtra {
        pub r#addonId: Option<String>,
        pub r#addonVersion: Option<String>,
        pub r#branch: Option<String>,
        pub r#enrollmentId: Option<String>,
        pub r#previousState: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdatePreferenceRolloutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addonId", "addonVersion", "branch", "enrollmentId", "previousState", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addonId.and_then(|val| map.insert("addonId".into(), val.to_string()));
          self.r#addonVersion.and_then(|val| map.insert("addonVersion".into(), val.to_string()));
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#enrollmentId.and_then(|val| map.insert("enrollmentId".into(), val.to_string()));
          self.r#previousState.and_then(|val| map.insert("previousState".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.update_preference_rollout
    ///
    /// This event is fired when a client detects that a recipe of the ahove types has changed on the server, and the new version of the recipe is being applied over an existing, older version previously fetched from the server. This event was generated to correspond to the Legacy Telemetry event normandy.update#preference_rollout.
    pub static update_preference_rollout: Lazy<EventMetric<UpdatePreferenceRolloutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_preference_rollout".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4944), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ValidationFailedNimbusExperimentExtra {
        pub r#branch: Option<String>,
        pub r#feature_ids: Option<String>,
        pub r#l10n_ids: Option<String>,
        pub r#locale: Option<String>,
        pub r#reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ValidationFailedNimbusExperimentExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["branch", "feature_ids", "l10n_ids", "locale", "reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#branch.and_then(|val| map.insert("branch".into(), val.to_string()));
          self.r#feature_ids.and_then(|val| map.insert("feature_ids".into(), val.to_string()));
          self.r#l10n_ids.and_then(|val| map.insert("l10n_ids".into(), val.to_string()));
          self.r#locale.and_then(|val| map.insert("locale".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from normandy.validation_failed_nimbus_experiment
    ///
    /// This records when validation of a recipe fails. This event was generated to correspond to the Legacy Telemetry event normandy.validationFailed#nimbus_experiment.
    pub static validation_failed_nimbus_experiment: Lazy<EventMetric<ValidationFailedNimbusExperimentExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "validation_failed_nimbus_experiment".into(),
                category: "normandy".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4945), meta)
    });

}
pub mod form_autocomplete {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowLoginsExtra {
        pub r#acFieldName: Option<String>,
        pub r#fieldType: Option<String>,
        pub r#generatedPasswo: Option<String>,
        pub r#hadPrevious: Option<String>,
        pub r#importableLogin: Option<String>,
        pub r#insecureWarning: Option<String>,
        pub r#login: Option<String>,
        pub r#loginsFooter: Option<String>,
        pub r#stringLength: Option<String>,
        pub r#typeWasPassword: Option<String>,
        pub r#value: Option<u32>,
    }

    impl ExtraKeys for ShowLoginsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["acFieldName", "fieldType", "generatedPasswo", "hadPrevious", "importableLogin", "insecureWarning", "login", "loginsFooter", "stringLength", "typeWasPassword", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#acFieldName.and_then(|val| map.insert("acFieldName".into(), val.to_string()));
          self.r#fieldType.and_then(|val| map.insert("fieldType".into(), val.to_string()));
          self.r#generatedPasswo.and_then(|val| map.insert("generatedPasswo".into(), val.to_string()));
          self.r#hadPrevious.and_then(|val| map.insert("hadPrevious".into(), val.to_string()));
          self.r#importableLogin.and_then(|val| map.insert("importableLogin".into(), val.to_string()));
          self.r#insecureWarning.and_then(|val| map.insert("insecureWarning".into(), val.to_string()));
          self.r#login.and_then(|val| map.insert("login".into(), val.to_string()));
          self.r#loginsFooter.and_then(|val| map.insert("loginsFooter".into(), val.to_string()));
          self.r#stringLength.and_then(|val| map.insert("stringLength".into(), val.to_string()));
          self.r#typeWasPassword.and_then(|val| map.insert("typeWasPassword".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from form_autocomplete.show_logins
    ///
    /// An content form autocomplete popup was shown. Details on the timing and context are provided. This event was generated to correspond to the Legacy Telemetry event form_autocomplete.show#logins.
    pub static show_logins: Lazy<EventMetric<ShowLoginsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_logins".into(),
                category: "form_autocomplete".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4946), meta)
    });

}
pub mod pwmgr {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.autocomplete_field_generatedpassword
    ///
    /// "autocomplete_field": The first time each unique generated password is used to fill a login field - i.e. the user selects it from from the autocomplete dropdown on a password input "autocomplete_shown": The first time the password generation option is shown in the autocomplete dropdown on a password input for a site per session This event was generated to correspond to the Legacy Telemetry event pwmgr.autocomplete_field#generatedpassword.
    pub static autocomplete_field_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_field_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4947), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.autocomplete_shown_generatedpassword
    ///
    /// "autocomplete_field": The first time each unique generated password is used to fill a login field - i.e. the user selects it from from the autocomplete dropdown on a password input "autocomplete_shown": The first time the password generation option is shown in the autocomplete dropdown on a password input for a site per session This event was generated to correspond to the Legacy Telemetry event pwmgr.autocomplete_shown#generatedpassword.
    pub static autocomplete_shown_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "autocomplete_shown_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4948), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CancelExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.cancel_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.cancel#existing_login.
    pub static cancel_existing_login: Lazy<EventMetric<CancelExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4949), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CancelNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.cancel_new_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.cancel#new_login.
    pub static cancel_new_login: Lazy<EventMetric<CancelNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4950), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyPasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CopyPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.copy_password
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.copy#password.
    pub static copy_password: Lazy<EventMetric<CopyPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4951), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyUsernameExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for CopyUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.copy_username
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.copy#username.
    pub static copy_username: Lazy<EventMetric<CopyUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_username".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4952), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for DeleteExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.delete_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.delete#existing_login.
    pub static delete_existing_login: Lazy<EventMetric<DeleteExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4953), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for DeleteNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.delete_new_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.delete#new_login.
    pub static delete_new_login: Lazy<EventMetric<DeleteNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4954), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoorhangerSubmittedSaveExtra {
        pub r#did_edit_pw: Option<bool>,
        pub r#did_edit_un: Option<bool>,
        pub r#did_select_pw: Option<bool>,
        pub r#did_select_un: Option<bool>,
    }

    impl ExtraKeys for DoorhangerSubmittedSaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_edit_pw", "did_edit_un", "did_select_pw", "did_select_un"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_edit_pw.and_then(|val| map.insert("did_edit_pw".into(), val.to_string()));
          self.r#did_edit_un.and_then(|val| map.insert("did_edit_un".into(), val.to_string()));
          self.r#did_select_pw.and_then(|val| map.insert("did_select_pw".into(), val.to_string()));
          self.r#did_select_un.and_then(|val| map.insert("did_select_un".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.doorhanger_submitted_save
    ///
    /// A login is saved or updated via the capture doorhanger. Carries information about whether the username and password _that were saved/updated by the user_ were modified in the doorhanger, selected from the suggestion autocomplete, or neither. `did_edit_X` and `did_select_X` will never both be true in the same event. The `object` describes the type of doorhanger when it was originally created. Note that user updates to the doorhanger may change whether a login is actually saved or updated, but will not impact the sent object. This event was generated to correspond to the Legacy Telemetry event pwmgr.doorhanger_submitted#save.
    pub static doorhanger_submitted_save: Lazy<EventMetric<DoorhangerSubmittedSaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doorhanger_submitted_save".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4955), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoorhangerSubmittedUpdateExtra {
        pub r#did_edit_pw: Option<bool>,
        pub r#did_edit_un: Option<bool>,
        pub r#did_select_pw: Option<bool>,
        pub r#did_select_un: Option<bool>,
    }

    impl ExtraKeys for DoorhangerSubmittedUpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["did_edit_pw", "did_edit_un", "did_select_pw", "did_select_un"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#did_edit_pw.and_then(|val| map.insert("did_edit_pw".into(), val.to_string()));
          self.r#did_edit_un.and_then(|val| map.insert("did_edit_un".into(), val.to_string()));
          self.r#did_select_pw.and_then(|val| map.insert("did_select_pw".into(), val.to_string()));
          self.r#did_select_un.and_then(|val| map.insert("did_select_un".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.doorhanger_submitted_update
    ///
    /// A login is saved or updated via the capture doorhanger. Carries information about whether the username and password _that were saved/updated by the user_ were modified in the doorhanger, selected from the suggestion autocomplete, or neither. `did_edit_X` and `did_select_X` will never both be true in the same event. The `object` describes the type of doorhanger when it was originally created. Note that user updates to the doorhanger may change whether a login is actually saved or updated, but will not impact the sent object. This event was generated to correspond to the Legacy Telemetry event pwmgr.doorhanger_submitted#update.
    pub static doorhanger_submitted_update: Lazy<EventMetric<DoorhangerSubmittedUpdateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "doorhanger_submitted_update".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4956), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EditExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for EditExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.edit_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.edit#existing_login.
    pub static edit_existing_login: Lazy<EventMetric<EditExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "edit_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4957), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.filled_field_edited_generatedpassword
    ///
    /// The first time each generated password filled in a website form field is edited by the user in a field it was filled in This event was generated to correspond to the Legacy Telemetry event pwmgr.filled_field_edited#generatedpassword.
    pub static filled_field_edited_generatedpassword: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filled_field_edited_generatedpassword".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4958), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.filter_list
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.filter#list.
    pub static filter_list: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "filter_list".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4959), meta)
    });

    #[repr(u16)]
    pub enum FormAutofillResultLabel {
        EFilled = 0,
        ENoPasswordField = 1,
        EPasswordDisabledReadonly = 2,
        ENoLoginsFit = 3,
        ENoSavedLogins = 4,
        EExistingPassword = 5,
        EExistingUsername = 6,
        EMultipleLogins = 7,
        ENoAutofillForms = 8,
        EAutocompleteOff = 9,
        EInsecure = 10,
        EPasswordAutocompleteNewPassword = 11,
        ETypeNoLongerPassword = 12,
        EFormInCrossoriginSubframe = 13,
        EFilledUsernameOnlyForm = 14,
        __Other__,
    }
    impl From<u16> for FormAutofillResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFilled,
                1 => Self::ENoPasswordField,
                2 => Self::EPasswordDisabledReadonly,
                3 => Self::ENoLoginsFit,
                4 => Self::ENoSavedLogins,
                5 => Self::EExistingPassword,
                6 => Self::EExistingUsername,
                7 => Self::EMultipleLogins,
                8 => Self::ENoAutofillForms,
                9 => Self::EAutocompleteOff,
                10 => Self::EInsecure,
                11 => Self::EPasswordAutocompleteNewPassword,
                12 => Self::ETypeNoLongerPassword,
                13 => Self::EFormInCrossoriginSubframe,
                14 => Self::EFilledUsernameOnlyForm,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FormAutofillResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFilled => "filled",
                Self::ENoPasswordField => "no_password_field",
                Self::EPasswordDisabledReadonly => "password_disabled_readonly",
                Self::ENoLoginsFit => "no_logins_fit",
                Self::ENoSavedLogins => "no_saved_logins",
                Self::EExistingPassword => "existing_password",
                Self::EExistingUsername => "existing_username",
                Self::EMultipleLogins => "multiple_logins",
                Self::ENoAutofillForms => "no_autofill_forms",
                Self::EAutocompleteOff => "autocomplete_off",
                Self::EInsecure => "insecure",
                Self::EPasswordAutocompleteNewPassword => "password_autocomplete_new_password",
                Self::ETypeNoLongerPassword => "type_no_longer_password",
                Self::EFormInCrossoriginSubframe => "form_in_crossorigin_subframe",
                Self::EFilledUsernameOnlyForm => "filled_username_only_form",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.form_autofill_result
    ///
    /// The result of auto-filling a login form.
    pub static form_autofill_result: Lazy<LabeledMetric<LabeledCounterMetric, FormAutofillResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "form_autofill_result".into(),
                    category: "pwmgr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4960), meta, Some(vec![::std::borrow::Cow::from("autocomplete_off"), ::std::borrow::Cow::from("existing_password"), ::std::borrow::Cow::from("existing_username"), ::std::borrow::Cow::from("filled"), ::std::borrow::Cow::from("filled_username_only_form"), ::std::borrow::Cow::from("form_in_crossorigin_subframe"), ::std::borrow::Cow::from("insecure"), ::std::borrow::Cow::from("multiple_logins"), ::std::borrow::Cow::from("no_autofill_forms"), ::std::borrow::Cow::from("no_logins_fit"), ::std::borrow::Cow::from("no_password_field"), ::std::borrow::Cow::from("no_saved_logins"), ::std::borrow::Cow::from("password_autocomplete_new_password"), ::std::borrow::Cow::from("password_disabled_readonly"), ::std::borrow::Cow::from("type_no_longer_password")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct HidePasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for HidePasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.hide_password
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.hide#password.
    pub static hide_password: Lazy<EventMetric<HidePasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "hide_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4961), meta)
    });

    #[repr(u16)]
    pub enum ImportLoginsFromFileCategoricalLabel {
        EAdded = 0,
        EModified = 1,
        EError = 2,
        ENoChange = 3,
        __Other__,
    }
    impl From<u16> for ImportLoginsFromFileCategoricalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAdded,
                1 => Self::EModified,
                2 => Self::EError,
                3 => Self::ENoChange,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ImportLoginsFromFileCategoricalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAdded => "added",
                Self::EModified => "modified",
                Self::EError => "error",
                Self::ENoChange => "no_change",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.import_logins_from_file_categorical
    ///
    /// Results of login import from a CSV/TSV file, by category
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram PWMGR_IMPORT_LOGINS_FROM_FILE_CATEGORICAL.
    pub static import_logins_from_file_categorical: Lazy<LabeledMetric<LabeledCounterMetric, ImportLoginsFromFileCategoricalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "import_logins_from_file_categorical".into(),
                    category: "pwmgr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4962), meta, Some(vec![::std::borrow::Cow::from("added"), ::std::borrow::Cow::from("error"), ::std::borrow::Cow::from("modified"), ::std::borrow::Cow::from("no_change")]))
    });

    #[repr(u16)]
    pub enum IsUsernameOnlyFormLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for IsUsernameOnlyFormLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for IsUsernameOnlyFormLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.is_username_only_form
    ///
    /// Whether a <form> is a username-only form. (0=Form has a possible username field but is not considered as a username-only form, 1=Form is considered as a username-only form)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram PWMGR_IS_USERNAME_ONLY_FORM.
    pub static is_username_only_form: Lazy<LabeledMetric<LabeledCounterMetric, IsUsernameOnlyFormLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "is_username_only_form".into(),
                    category: "pwmgr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4963), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreVulnExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for LearnMoreVulnExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.learn_more_vuln_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.learn_more_vuln#existing_login.
    pub static learn_more_vuln_existing_login: Lazy<EventMetric<LearnMoreVulnExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more_vuln_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4964), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.login_page_safety
    ///
    /// The safety of a page where we see a password field. (0: safe page & safe submit; 1: safe page & unsafe submit; 2: safe page & unknown submit; 3: unsafe page & safe submit; 4: unsafe page & unsafe submit; 5: unsafe page & unknown submit)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PWMGR_LOGIN_PAGE_SAFETY.
    pub static login_page_safety: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "login_page_safety".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4965), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_export
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#export.
    pub static mgmt_menu_item_used_export: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_export".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4966), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_export_complete
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#export_complete.
    pub static mgmt_menu_item_used_export_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_export_complete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4967), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_csv_complete
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#import_csv_complete.
    pub static mgmt_menu_item_used_import_csv_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_csv_complete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4968), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_from_browser
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#import_from_browser.
    pub static mgmt_menu_item_used_import_from_browser: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_from_browser".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4969), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_import_from_csv
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#import_from_csv.
    pub static mgmt_menu_item_used_import_from_csv: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_import_from_csv".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4970), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.mgmt_menu_item_used_preferences
    ///
    /// Record interactions with the about:logins menu. This event was generated to correspond to the Legacy Telemetry event pwmgr.mgmt_menu_item_used#preferences.
    pub static mgmt_menu_item_used_preferences: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mgmt_menu_item_used_preferences".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4971), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.new_new_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.new#new_login.
    pub static new_new_login: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4972), meta)
    });

    #[repr(u16)]
    pub enum NumImprovedGeneratedPasswordsLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for NumImprovedGeneratedPasswordsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NumImprovedGeneratedPasswordsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.num_improved_generated_passwords
    ///
    /// The number of passwords generated when 'signon.improvedPasswordRules.enabled' is true. 0 = Password generated by default rules, 1 = Password generated by custom rules
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram PWMGR_NUM_IMPROVED_GENERATED_PASSWORDS.
    pub static num_improved_generated_passwords: Lazy<LabeledMetric<LabeledCounterMetric, NumImprovedGeneratedPasswordsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "num_improved_generated_passwords".into(),
                    category: "pwmgr".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(4973), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.num_saved_passwords
    ///
    /// The number of saved logins, including those that cannot be decrypted.
    /// Similar to the legacy telemetry histogram PWMGR_NUM_SAVED_PASSWORDS.
    pub static num_saved_passwords: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "num_saved_passwords".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4974), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_aboutprotections
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#aboutprotections.
    pub static open_management_aboutprotections: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_aboutprotections".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4975), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_autocomplete
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#autocomplete.
    pub static open_management_autocomplete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_autocomplete".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4976), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_contextmenu
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#contextmenu.
    pub static open_management_contextmenu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_contextmenu".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4977), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_direct
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#direct.
    pub static open_management_direct: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_direct".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4978), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_mainmenu
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#mainmenu.
    pub static open_management_mainmenu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_mainmenu".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4979), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_pageinfo
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#pageinfo.
    pub static open_management_pageinfo: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_pageinfo".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4980), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_preferences
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#preferences.
    pub static open_management_preferences: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_preferences".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4981), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_management_snippet
    ///
    /// Sent when opening the password management UI. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_management#snippet.
    pub static open_management_snippet: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_management_snippet".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4982), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSiteExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for OpenSiteExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.open_site_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.open_site#existing_login.
    pub static open_site_existing_login: Lazy<EventMetric<OpenSiteExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_site_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4983), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.os_auth_enabled
    ///
    /// Check at startup whether OS Authentication has been enabled for passwords.
    pub static os_auth_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_auth_enabled".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(4984), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.potentially_breached_passwords
    ///
    /// The number of potentially breached passwords, as determined by LoginBreaches.getPotentialBreachesByLoginGUID. This metric was generated to correspond to the Legacy Telemetry scalar pwmgr.potentially_breached_passwords.
    pub static potentially_breached_passwords: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "potentially_breached_passwords".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(4985), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.prompt_remember_action
    ///
    /// Action taken by user through prompt for creating a login. (0=Prompt displayed [always recorded], 1=Add login, 2=Don't save now, 3=Never save)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PWMGR_PROMPT_REMEMBER_ACTION.
    pub static prompt_remember_action: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prompt_remember_action".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4986), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PromptShownOsReauthExtra {
        pub r#result: Option<String>,
        pub r#trigger: Option<String>,
    }

    impl ExtraKeys for PromptShownOsReauthExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["result", "trigger"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#result.and_then(|val| map.insert("result".into(), val.to_string()));
          self.r#trigger.and_then(|val| map.insert("trigger".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.prompt_shown_os_reauth
    ///
    /// Captures the method of user interaction initiating the prompt and the result of the prompt. Possible triggers include:
    ///   "copy_logins" when a user copies a password in about:logins
    ///   "copy_cpm" when a user copies a password in contextual password manager
    ///   "edit_logins" when a user edits a login in about:logins
    ///   "edit_cpm" when a user edits a login in contextual password manager
    ///   "export_logins" when a user exports all passwords in about:logins
    ///   "export_cpm" when a user exports all passwords in contextual password manager
    ///   "reveal_logins" when a user reveals a password a login in about:logins
    ///   "reveal_cpm" when a user reveals a password a login in contextual password manager
    ///   "toggle_pref_primary_password" when a user toggles "Use a Primary Password" in about:preferences
    ///   "toggle_pref_os_auth" when a user toggles "Passwords / Require device sign in" in about:preferences
    /// Possible results include:
    ///   "success" should be used when the user is shown the OS Auth prompt and successfully authenticates.
    ///   "fail_user_canceled" should be used when the user cancels the authentication prompt. The user may or may not have provided an incorrect password before cancelling.
    ///   "fail_error" should be used when an unexpected exception is encountered.
    pub static prompt_shown_os_reauth: Lazy<EventMetric<PromptShownOsReauthExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prompt_shown_os_reauth".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4987), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.prompt_update_action
    ///
    /// Action taken by user through prompt for modifying a login. (0=Prompt displayed [always recorded], 1=Update login, 2=Don't update, 3=Remove saved login)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PWMGR_PROMPT_UPDATE_ACTION.
    pub static prompt_update_action: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prompt_update_action".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(4988), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReauthenticateMasterPasswordExtra {
        pub r#auto_admin: Option<String>,
        pub r#require_signon: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReauthenticateMasterPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_admin", "require_signon", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_admin.and_then(|val| map.insert("auto_admin".into(), val.to_string()));
          self.r#require_signon.and_then(|val| map.insert("require_signon".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.reauthenticate_master_password
    ///
    /// Measure how often users are asked to authenticate with their Operating System or Master Password to gain access to stored passwords. Possible values are as follows,
    ///   "success" should be used when the user authenticates and provides a password or other authentication factor.
    ///   "success_no_prompt" should be used when the feature is enabled but no prompt is given to the user because they have recently authenticated.
    ///   "success_disabled" is used when the feature is disabled.
    ///   "success_unsupported_platform" should be set when the user attempts to authenticate on an unsupported platform.
    ///   "success_no_password" should be used when the user doesn't have an OS password set.
    ///   "fail" should be used when the user cancels the authentication prompt or an unexpected exception is encountered. The user may or may not have provided an incorrect password before cancelling.
    /// This event was generated to correspond to the Legacy Telemetry event pwmgr.reauthenticate#master_password.
    pub static reauthenticate_master_password: Lazy<EventMetric<ReauthenticateMasterPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reauthenticate_master_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4989), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReauthenticateOsAuthExtra {
        pub r#auto_admin: Option<String>,
        pub r#require_signon: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReauthenticateOsAuthExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_admin", "require_signon", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_admin.and_then(|val| map.insert("auto_admin".into(), val.to_string()));
          self.r#require_signon.and_then(|val| map.insert("require_signon".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.reauthenticate_os_auth
    ///
    /// Measure how often users are asked to authenticate with their Operating System or Master Password to gain access to stored passwords. Possible values are as follows,
    ///   "success" should be used when the user authenticates and provides a password or other authentication factor.
    ///   "success_no_prompt" should be used when the feature is enabled but no prompt is given to the user because they have recently authenticated.
    ///   "success_disabled" is used when the feature is disabled.
    ///   "success_unsupported_platform" should be set when the user attempts to authenticate on an unsupported platform.
    ///   "success_no_password" should be used when the user doesn't have an OS password set.
    ///   "fail" should be used when the user cancels the authentication prompt or an unexpected exception is encountered. The user may or may not have provided an incorrect password before cancelling.
    /// This event was generated to correspond to the Legacy Telemetry event pwmgr.reauthenticate#os_auth.
    pub static reauthenticate_os_auth: Lazy<EventMetric<ReauthenticateOsAuthExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reauthenticate_os_auth".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4990), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RequireOsReauthToggleExtra {
        pub r#toggle_state: Option<bool>,
    }

    impl ExtraKeys for RequireOsReauthToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["toggle_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#toggle_state.and_then(|val| map.insert("toggle_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.require_os_reauth_toggle
    ///
    /// Captures the state of the toggle after the change was made. Toggle states include:
    ///   True means the OS Auth preference is enabeled.
    ///   False means it is disabled.
    pub static require_os_reauth_toggle: Lazy<EventMetric<RequireOsReauthToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "require_os_reauth_toggle".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4991), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SaveExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.save_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.save#existing_login.
    pub static save_existing_login: Lazy<EventMetric<SaveExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4992), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveNewLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SaveNewLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.save_new_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.save#new_login.
    pub static save_new_login: Lazy<EventMetric<SaveNewLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save_new_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4993), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedAuthLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedAuthLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_auth_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event was generated to correspond to the Legacy Telemetry event pwmgr.saved_login_used#auth_login.
    pub static saved_login_used_auth_login: Lazy<EventMetric<SavedLoginUsedAuthLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_auth_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4994), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedFormLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedFormLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_form_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event was generated to correspond to the Legacy Telemetry event pwmgr.saved_login_used#form_login.
    pub static saved_login_used_form_login: Lazy<EventMetric<SavedLoginUsedFormLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_form_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4995), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedFormPasswordExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedFormPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_form_password
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event was generated to correspond to the Legacy Telemetry event pwmgr.saved_login_used#form_password.
    pub static saved_login_used_form_password: Lazy<EventMetric<SavedLoginUsedFormPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_form_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4996), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SavedLoginUsedPromptLoginExtra {
        pub r#filled: Option<bool>,
    }

    impl ExtraKeys for SavedLoginUsedPromptLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["filled"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#filled.and_then(|val| map.insert("filled".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saved_login_used_prompt_login
    ///
    /// Each time a saved login is used in a form or authentication dialog. This event was generated to correspond to the Legacy Telemetry event pwmgr.saved_login_used#prompt_login.
    pub static saved_login_used_prompt_login: Lazy<EventMetric<SavedLoginUsedPromptLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saved_login_used_prompt_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4997), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.saving_enabled
    ///
    /// Whether password saving is enabled globally.
    /// Tracks the pref `signon.rememberSignons`.
    pub static saving_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saving_enabled".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::with_unordered_ipc(BaseMetricId(4998), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SelectExistingLoginExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for SelectExistingLoginExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.select_existing_login
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.select#existing_login.
    pub static select_existing_login: Lazy<EventMetric<SelectExistingLoginExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "select_existing_login".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(4999), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShowPasswordExtra {
        pub r#breached: Option<bool>,
        pub r#vulnerable: Option<bool>,
    }

    impl ExtraKeys for ShowPasswordExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["breached", "vulnerable"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#breached.and_then(|val| map.insert("breached".into(), val.to_string()));
          self.r#vulnerable.and_then(|val| map.insert("vulnerable".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.show_password
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.show#password.
    pub static show_password: Lazy<EventMetric<ShowPasswordExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_password".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5000), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.signup_form_detection
    ///
    /// Elapsed time to detect whether a <form> element is a signup form.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PWMGR_SIGNUP_FORM_DETECTION_MS.
    pub static signup_form_detection: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "signup_form_detection".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5001), meta, TimeUnit::Millisecond)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SortListExtra {
        pub r#sort_key: Option<String>,
    }

    impl ExtraKeys for SortListExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["sort_key"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#sort_key.and_then(|val| map.insert("sort_key".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pwmgr.sort_list
    ///
    /// These events record interactions on the about:logins page. This event was generated to correspond to the Legacy Telemetry event pwmgr.sort#list.
    pub static sort_list: Lazy<EventMetric<SortListExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sort_list".into(),
                category: "pwmgr".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5002), meta)
    });

}
pub mod relay_integration {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickedFillUsernameExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickedFillUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.clicked_fill_username
    ///
    /// Firefox relay integration autocomplete popup This event was generated to correspond to the Legacy Telemetry event relay_integration.clicked#fill_username.
    pub static clicked_fill_username: Lazy<EventMetric<ClickedFillUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clicked_fill_username".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5003), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickedOfferRelayExtra {
        pub r#scenario: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickedOfferRelayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["scenario", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#scenario.and_then(|val| map.insert("scenario".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.clicked_offer_relay
    ///
    /// Firefox relay integration autocomplete popup This event was generated to correspond to the Legacy Telemetry event relay_integration.clicked#offer_relay.
    pub static clicked_offer_relay: Lazy<EventMetric<ClickedOfferRelayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "clicked_offer_relay".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5004), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisabledOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisabledOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.disabled_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to correspond to the Legacy Telemetry event relay_integration.disabled#opt_in_panel.
    pub static disabled_opt_in_panel: Lazy<EventMetric<DisabledOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5005), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.disabled_pref_change
    ///
    /// Checkbox in the settings page to enable/disable relay This event was generated to correspond to the Legacy Telemetry event relay_integration.disabled#pref_change.
    pub static disabled_pref_change: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disabled_pref_change".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5006), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnabledOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnabledOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.enabled_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to correspond to the Legacy Telemetry event relay_integration.enabled#opt_in_panel.
    pub static enabled_opt_in_panel: Lazy<EventMetric<EnabledOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5007), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.enabled_pref_change
    ///
    /// Checkbox in the settings page to enable/disable relay This event was generated to correspond to the Legacy Telemetry event relay_integration.enabled#pref_change.
    pub static enabled_pref_change: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled_pref_change".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5008), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct GetUnlimitedMasksReusePanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for GetUnlimitedMasksReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.get_unlimited_masks_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated to correspond to the Legacy Telemetry event relay_integration.get_unlimited_masks#reuse_panel.
    pub static get_unlimited_masks_reuse_panel: Lazy<EventMetric<GetUnlimitedMasksReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "get_unlimited_masks_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5009), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct PostponedOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for PostponedOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.postponed_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to correspond to the Legacy Telemetry event relay_integration.postponed#opt_in_panel.
    pub static postponed_opt_in_panel: Lazy<EventMetric<PostponedOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "postponed_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5010), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReuseMaskReusePanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ReuseMaskReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.reuse_mask_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated to correspond to the Legacy Telemetry event relay_integration.reuse_mask#reuse_panel.
    pub static reuse_mask_reuse_panel: Lazy<EventMetric<ReuseMaskReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reuse_mask_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5011), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownFillUsernameExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownFillUsernameExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_fill_username
    ///
    /// Firefox relay integration autocomplete popup This event was generated to correspond to the Legacy Telemetry event relay_integration.shown#fill_username.
    pub static shown_fill_username: Lazy<EventMetric<ShownFillUsernameExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_fill_username".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5012), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownOfferRelayExtra {
        pub r#scenario: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownOfferRelayExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["scenario", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#scenario.and_then(|val| map.insert("scenario".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_offer_relay
    ///
    /// Firefox relay integration autocomplete popup This event was generated to correspond to the Legacy Telemetry event relay_integration.shown#offer_relay.
    pub static shown_offer_relay: Lazy<EventMetric<ShownOfferRelayExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_offer_relay".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5013), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownOptInPanelExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownOptInPanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_opt_in_panel
    ///
    /// Panel to opt-in Firefox Relay Integration This event was generated to correspond to the Legacy Telemetry event relay_integration.shown#opt_in_panel.
    pub static shown_opt_in_panel: Lazy<EventMetric<ShownOptInPanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_opt_in_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5014), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ShownReusePanelExtra {
        pub r#error_code: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ShownReusePanelExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_code", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_code.and_then(|val| map.insert("error_code".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from relay_integration.shown_reuse_panel
    ///
    /// Panels to show the state of the email alias generation This event was generated to correspond to the Legacy Telemetry event relay_integration.shown#reuse_panel.
    pub static shown_reuse_panel: Lazy<EventMetric<ShownReusePanelExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shown_reuse_panel".into(),
                category: "relay_integration".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5015), meta)
    });

}
pub mod pdfjs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ButtonsLabel {
        EPresentationMode = 0,
        EPresentationModeKeyboard = 1,
        EViewBookmark = 2,
        EFirstPage = 3,
        ELastPage = 4,
        EPageRotateCw = 5,
        EPageRotateCcw = 6,
        ECursorSelectTool = 7,
        ECursorHandTool = 8,
        EScrollPage = 9,
        EScrollVertical = 10,
        EScrollHorizontal = 11,
        EScrollWrapped = 12,
        ESpreadNone = 13,
        ESpreadOdd = 14,
        ESpreadEven = 15,
        EDocumentProperties = 16,
        __Other__,
    }
    impl From<u16> for ButtonsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPresentationMode,
                1 => Self::EPresentationModeKeyboard,
                2 => Self::EViewBookmark,
                3 => Self::EFirstPage,
                4 => Self::ELastPage,
                5 => Self::EPageRotateCw,
                6 => Self::EPageRotateCcw,
                7 => Self::ECursorSelectTool,
                8 => Self::ECursorHandTool,
                9 => Self::EScrollPage,
                10 => Self::EScrollVertical,
                11 => Self::EScrollHorizontal,
                12 => Self::EScrollWrapped,
                13 => Self::ESpreadNone,
                14 => Self::ESpreadOdd,
                15 => Self::ESpreadEven,
                16 => Self::EDocumentProperties,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ButtonsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPresentationMode => "presentation_mode",
                Self::EPresentationModeKeyboard => "presentation_mode_keyboard",
                Self::EViewBookmark => "view_bookmark",
                Self::EFirstPage => "first_page",
                Self::ELastPage => "last_page",
                Self::EPageRotateCw => "page_rotate_cw",
                Self::EPageRotateCcw => "page_rotate_ccw",
                Self::ECursorSelectTool => "cursor_select_tool",
                Self::ECursorHandTool => "cursor_hand_tool",
                Self::EScrollPage => "scroll_page",
                Self::EScrollVertical => "scroll_vertical",
                Self::EScrollHorizontal => "scroll_horizontal",
                Self::EScrollWrapped => "scroll_wrapped",
                Self::ESpreadNone => "spread_none",
                Self::ESpreadOdd => "spread_odd",
                Self::ESpreadEven => "spread_even",
                Self::EDocumentProperties => "document_properties",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.buttons
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static buttons: Lazy<LabeledMetric<LabeledCounterMetric, ButtonsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "buttons".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5016), meta, Some(vec![::std::borrow::Cow::from("cursor_hand_tool"), ::std::borrow::Cow::from("cursor_select_tool"), ::std::borrow::Cow::from("document_properties"), ::std::borrow::Cow::from("first_page"), ::std::borrow::Cow::from("last_page"), ::std::borrow::Cow::from("page_rotate_ccw"), ::std::borrow::Cow::from("page_rotate_cw"), ::std::borrow::Cow::from("presentation_mode"), ::std::borrow::Cow::from("presentation_mode_keyboard"), ::std::borrow::Cow::from("scroll_horizontal"), ::std::borrow::Cow::from("scroll_page"), ::std::borrow::Cow::from("scroll_vertical"), ::std::borrow::Cow::from("scroll_wrapped"), ::std::borrow::Cow::from("spread_even"), ::std::borrow::Cow::from("spread_none"), ::std::borrow::Cow::from("spread_odd"), ::std::borrow::Cow::from("view_bookmark")]))
    });

    #[repr(u16)]
    pub enum EditingLabel {
        EInk = 0,
        EFreetext = 1,
        EStamp = 2,
        ESignature = 3,
        ESave = 4,
        EPrint = 5,
        __Other__,
    }
    impl From<u16> for EditingLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInk,
                1 => Self::EFreetext,
                2 => Self::EStamp,
                3 => Self::ESignature,
                4 => Self::ESave,
                5 => Self::EPrint,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EditingLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInk => "ink",
                Self::EFreetext => "freetext",
                Self::EStamp => "stamp",
                Self::ESignature => "signature",
                Self::ESave => "save",
                Self::EPrint => "print",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static editing: Lazy<LabeledMetric<LabeledCounterMetric, EditingLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "editing".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5017), meta, Some(vec![::std::borrow::Cow::from("freetext"), ::std::borrow::Cow::from("ink"), ::std::borrow::Cow::from("print"), ::std::borrow::Cow::from("save"), ::std::borrow::Cow::from("signature"), ::std::borrow::Cow::from("stamp")]))
    });

    #[repr(u16)]
    pub enum GeckoviewLabel {
        EDownloadTapped = 0,
        EOpenInAppTapped = 1,
        EOpenInAppJustOnce = 2,
        EOpenInAppAlways = 3,
        EDownloadFailed = 4,
        EDownloadSucceeded = 5,
        ESaveAsPdfTapped = 6,
        __Other__,
    }
    impl From<u16> for GeckoviewLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EDownloadTapped,
                1 => Self::EOpenInAppTapped,
                2 => Self::EOpenInAppJustOnce,
                3 => Self::EOpenInAppAlways,
                4 => Self::EDownloadFailed,
                5 => Self::EDownloadSucceeded,
                6 => Self::ESaveAsPdfTapped,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GeckoviewLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EDownloadTapped => "download_tapped",
                Self::EOpenInAppTapped => "open_in_app_tapped",
                Self::EOpenInAppJustOnce => "open_in_app_just_once",
                Self::EOpenInAppAlways => "open_in_app_always",
                Self::EDownloadFailed => "download_failed",
                Self::EDownloadSucceeded => "download_succeeded",
                Self::ESaveAsPdfTapped => "save_as_pdf_tapped",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.geckoview
    ///
    /// Counts the number of times some actions are executed in the PDF viewer.
    pub static geckoview: Lazy<LabeledMetric<LabeledCounterMetric, GeckoviewLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "geckoview".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5018), meta, Some(vec![::std::borrow::Cow::from("download_failed"), ::std::borrow::Cow::from("download_succeeded"), ::std::borrow::Cow::from("download_tapped"), ::std::borrow::Cow::from("open_in_app_always"), ::std::borrow::Cow::from("open_in_app_just_once"), ::std::borrow::Cow::from("open_in_app_tapped"), ::std::borrow::Cow::from("save_as_pdf_tapped")]))
    });

    #[repr(u16)]
    pub enum StampLabel {
        EInsertedImage = 0,
        EAltTextSave = 1,
        EAltTextCancel = 2,
        EAltTextTooltip = 3,
        EAltTextEdit = 4,
        EAltTextDescription = 5,
        EAltTextDecorative = 6,
        EAltTextKeyboard = 7,
        __Other__,
    }
    impl From<u16> for StampLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EInsertedImage,
                1 => Self::EAltTextSave,
                2 => Self::EAltTextCancel,
                3 => Self::EAltTextTooltip,
                4 => Self::EAltTextEdit,
                5 => Self::EAltTextDescription,
                6 => Self::EAltTextDecorative,
                7 => Self::EAltTextKeyboard,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StampLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EInsertedImage => "inserted_image",
                Self::EAltTextSave => "alt_text_save",
                Self::EAltTextCancel => "alt_text_cancel",
                Self::EAltTextTooltip => "alt_text_tooltip",
                Self::EAltTextEdit => "alt_text_edit",
                Self::EAltTextDescription => "alt_text_description",
                Self::EAltTextDecorative => "alt_text_decorative",
                Self::EAltTextKeyboard => "alt_text_keyboard",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.stamp
    ///
    /// Counts the number of times some PDF editing features are used.
    pub static stamp: Lazy<LabeledMetric<LabeledCounterMetric, StampLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "stamp".into(),
                    category: "pdfjs".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5019), meta, Some(vec![::std::borrow::Cow::from("alt_text_cancel"), ::std::borrow::Cow::from("alt_text_decorative"), ::std::borrow::Cow::from("alt_text_description"), ::std::borrow::Cow::from("alt_text_edit"), ::std::borrow::Cow::from("alt_text_keyboard"), ::std::borrow::Cow::from("alt_text_save"), ::std::borrow::Cow::from("alt_text_tooltip"), ::std::borrow::Cow::from("inserted_image")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.time_to_view
    ///
    /// Time spent to display first page in PDF Viewer (ms).
    pub static time_to_view: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_to_view".into(),
                category: "pdfjs".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5020), meta, 1, 10000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.used
    ///
    /// How many times PDF Viewer was used.
    pub static used: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5021,
            "pdfjs",
            "used",
            "metrics"
        )
    });

}
pub mod pdfjs_editing_highlight {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ColorLabel {
        EYellow = 0,
        EGreen = 1,
        EBlue = 2,
        EPink = 3,
        ERed = 4,
        __Other__,
    }
    impl From<u16> for ColorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EYellow,
                1 => Self::EGreen,
                2 => Self::EBlue,
                3 => Self::EPink,
                4 => Self::ERed,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ColorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EYellow => "yellow",
                Self::EGreen => "green",
                Self::EBlue => "blue",
                Self::EPink => "pink",
                Self::ERed => "red",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color
    ///
    /// Counts the number of times a given color is used to highlight.
    pub static color: Lazy<LabeledMetric<LabeledCounterMetric, ColorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "color".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5022), meta, Some(vec![::std::borrow::Cow::from("blue"), ::std::borrow::Cow::from("green"), ::std::borrow::Cow::from("pink"), ::std::borrow::Cow::from("red"), ::std::borrow::Cow::from("yellow")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.color_changed
    ///
    /// Counts the number of times the user changes the color of a highlight.
    pub static color_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5023,
            "pdfjs.editing.highlight",
            "color_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.deleted
    ///
    /// Counts the number of times the user deletes highlights.
    pub static deleted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5024,
            "pdfjs.editing.highlight",
            "deleted",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.edited
    ///
    /// Counts the number of times the user edits highlights.
    pub static edited: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5025,
            "pdfjs.editing.highlight",
            "edited",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum KindLabel {
        EFreeHighlight = 0,
        EHighlight = 1,
        __Other__,
    }
    impl From<u16> for KindLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFreeHighlight,
                1 => Self::EHighlight,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for KindLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFreeHighlight => "free_highlight",
                Self::EHighlight => "highlight",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.kind
    ///
    /// Counts the number of times a given kind is used to highlight.
    pub static kind: Lazy<LabeledMetric<LabeledCounterMetric, KindLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "kind".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5026), meta, Some(vec![::std::borrow::Cow::from("free_highlight"), ::std::borrow::Cow::from("highlight")]))
    });

    #[repr(u16)]
    pub enum MethodLabel {
        EContextMenu = 0,
        EMainToolbar = 1,
        EFloatingButton = 2,
        __Other__,
    }
    impl From<u16> for MethodLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EContextMenu,
                1 => Self::EMainToolbar,
                2 => Self::EFloatingButton,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for MethodLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EContextMenu => "context_menu",
                Self::EMainToolbar => "main_toolbar",
                Self::EFloatingButton => "floating_button",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.method
    ///
    /// Counts the number of times a given method is used to highlight.
    pub static method: Lazy<LabeledMetric<LabeledCounterMetric, MethodLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "method".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5027), meta, Some(vec![::std::borrow::Cow::from("context_menu"), ::std::borrow::Cow::from("floating_button"), ::std::borrow::Cow::from("main_toolbar")]))
    });

    #[repr(u16)]
    pub enum NumberOfColorsLabel {
        EOne = 0,
        ETwo = 1,
        EThree = 2,
        EFour = 3,
        EFive = 4,
        __Other__,
    }
    impl From<u16> for NumberOfColorsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOne,
                1 => Self::ETwo,
                2 => Self::EThree,
                3 => Self::EFour,
                4 => Self::EFive,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NumberOfColorsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOne => "one",
                Self::ETwo => "two",
                Self::EThree => "three",
                Self::EFour => "four",
                Self::EFive => "five",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.number_of_colors
    ///
    /// Counts the number of different colors used to highlight.
    pub static number_of_colors: Lazy<LabeledMetric<LabeledCounterMetric, NumberOfColorsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "number_of_colors".into(),
                    category: "pdfjs.editing.highlight".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5028), meta, Some(vec![::std::borrow::Cow::from("five"), ::std::borrow::Cow::from("four"), ::std::borrow::Cow::from("one"), ::std::borrow::Cow::from("three"), ::std::borrow::Cow::from("two")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.print
    ///
    /// Counts the number of times the user prints a PDF with highlights.
    pub static print: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5029,
            "pdfjs.editing.highlight",
            "print",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.save
    ///
    /// Counts the number of times the user saves a PDF with highlights.
    pub static save: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5030,
            "pdfjs.editing.highlight",
            "save",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness
    ///
    /// The thickness used to draw a free highlight.
    pub static thickness: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "thickness".into(),
                category: "pdfjs.editing.highlight".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5031), meta, 8, 24, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.thickness_changed
    ///
    /// Counts the number of times the user changes the thickness of a free highlight.
    pub static thickness_changed: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5032,
            "pdfjs.editing.highlight",
            "thickness_changed",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.editing.highlight.toggle_visibility
    ///
    /// Counts the number of times the user toggles the visibility of highlights.
    pub static toggle_visibility: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5033,
            "pdfjs.editing.highlight",
            "toggle_visibility",
            "metrics"
        )
    });

}
pub mod pdfjs_image {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.add_image_click
    ///
    /// Recorded when the Add Image label is clicked.
    pub static add_image_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "add_image_click".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5034), meta)
    });

    #[repr(u16)]
    pub enum AddedLabel {
        EWithAltText = 0,
        EWithoutAltText = 1,
        __Other__,
    }
    impl From<u16> for AddedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EWithAltText,
                1 => Self::EWithoutAltText,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AddedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EWithAltText => "with_alt_text",
                Self::EWithoutAltText => "without_alt_text",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.added
    ///
    /// Number of images added with/without alt text.
    pub static added: Lazy<LabeledMetric<LabeledCounterMetric, AddedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "added".into(),
                    category: "pdfjs.image".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5035), meta, Some(vec![::std::borrow::Cow::from("with_alt_text"), ::std::borrow::Cow::from("without_alt_text")]))
    });

    #[repr(u16)]
    pub enum AltTextEditLabel {
        EAskToEdit = 0,
        EAiGeneration = 1,
        __Other__,
    }
    impl From<u16> for AltTextEditLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAskToEdit,
                1 => Self::EAiGeneration,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for AltTextEditLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAskToEdit => "ask_to_edit",
                Self::EAiGeneration => "ai_generation",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text_edit
    ///
    /// Stores alt text modal settings for the user.
    pub static alt_text_edit: Lazy<LabeledMetric<LabeledBooleanMetric, AltTextEditLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "alt_text_edit".into(),
                    category: "pdfjs.image".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5036), meta, Some(vec![::std::borrow::Cow::from("ai_generation"), ::std::borrow::Cow::from("ask_to_edit")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.icon_click
    ///
    /// Recorded when the image toolbar icon is clicked.
    pub static icon_click: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "icon_click".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5037), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageAddedExtra {
        pub r#alt_text_modal: Option<bool>,
        pub r#alt_text_type: Option<String>,
    }

    impl ExtraKeys for ImageAddedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_modal", "alt_text_type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_modal.and_then(|val| map.insert("alt_text_modal".into(), val.to_string()));
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.image_added
    ///
    /// Recorded once the image is added to the pdf.
    pub static image_added: Lazy<EventMetric<ImageAddedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_added".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5038), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageSelectedExtra {
        pub r#alt_text_modal: Option<bool>,
    }

    impl ExtraKeys for ImageSelectedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_modal"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_modal.and_then(|val| map.insert("alt_text_modal".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.image_selected
    ///
    /// Recorded when the user selects an image file from their computer.
    pub static image_selected: Lazy<EventMetric<ImageSelectedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_selected".into(),
                category: "pdfjs.image".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5039), meta)
    });

}
pub mod pdfjs_image_alt_text {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AiGenerationCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for AiGenerationCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.ai_generation_check
    ///
    /// Recorded when the user interacts with the alt text setting in the alt text modal to create alt text with AI.
    pub static ai_generation_check: Lazy<EventMetric<AiGenerationCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ai_generation_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5040), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.callout_dismissed
    ///
    /// Recorded when the callout describing automatic alt text generation is dismissed.
    pub static callout_dismissed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "callout_dismissed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5041), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.callout_displayed
    ///
    /// Recorded when the callout describing automatic alt text generation is displayed.
    pub static callout_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "callout_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5042), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissExtra {
        pub r#alt_text_type: Option<String>,
        pub r#flow: Option<String>,
    }

    impl ExtraKeys for DismissExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_type", "flow"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          self.r#flow.and_then(|val| map.insert("flow".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.dismiss
    ///
    /// Recorded when the user clicks Not now or Cancel on the alt text modal.
    pub static dismiss: Lazy<EventMetric<DismissExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5043), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageStatusLabelClickedExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ImageStatusLabelClickedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.image_status_label_clicked
    ///
    /// Recorded when the user clicks on the alt text status button.
    pub static image_status_label_clicked: Lazy<EventMetric<ImageStatusLabelClickedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_status_label_clicked".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5044), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ImageStatusLabelDisplayedExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ImageStatusLabelDisplayedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.image_status_label_displayed
    ///
    /// Recorded when the alt text status button on an image is shown .
    pub static image_status_label_displayed: Lazy<EventMetric<ImageStatusLabelDisplayedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "image_status_label_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5045), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InfoExtra {
        pub r#topic: Option<String>,
    }

    impl ExtraKeys for InfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["topic"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#topic.and_then(|val| map.insert("topic".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.info
    ///
    /// Recorded on the alt text modal when the user clicks on "i" to learn about alt text or "Learn More" to learn about AI generation.
    pub static info: Lazy<EventMetric<InfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "info".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5046), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_deleted
    ///
    /// Recorded when the user clicks to delete the model from the alt text settings.
    pub static model_deleted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_deleted".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5047), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_complete
    ///
    /// Recorded when download completes for the alt text generation model.
    pub static model_download_complete: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_complete".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5048), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModelDownloadErrorExtra {
        pub r#error: Option<String>,
    }

    impl ExtraKeys for ModelDownloadErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_error
    ///
    /// Recorded when an error occurs during the download for the alt text generation model.
    pub static model_download_error: Lazy<EventMetric<ModelDownloadErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_error".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5049), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_download_start
    ///
    /// Recorded when download starts for the alt text generation model.
    pub static model_download_start: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_download_start".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5050), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ModelResultExtra {
        pub r#length: Option<u32>,
        pub r#time: Option<u32>,
    }

    impl ExtraKeys for ModelResultExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["length", "time"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#length.and_then(|val| map.insert("length".into(), val.to_string()));
          self.r#time.and_then(|val| map.insert("time".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.model_result
    ///
    /// Records how long it takes to generate the alt text and what is the length of the result.
    pub static model_result: Lazy<EventMetric<ModelResultExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model_result".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5051), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SaveExtra {
        pub r#alt_text_type: Option<String>,
        pub r#flow: Option<String>,
    }

    impl ExtraKeys for SaveExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["alt_text_type", "flow"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#alt_text_type.and_then(|val| map.insert("alt_text_type".into(), val.to_string()));
          self.r#flow.and_then(|val| map.insert("flow".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.save
    ///
    /// Recorded when the user clicks Save on the alt text modal.
    pub static save: Lazy<EventMetric<SaveExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "save".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5052), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SettingsAiGenerationCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for SettingsAiGenerationCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_ai_generation_check
    ///
    /// Recorded when the user interacts with the alt text setting to create alt text with AI.
    pub static settings_ai_generation_check: Lazy<EventMetric<SettingsAiGenerationCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_ai_generation_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5053), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_displayed
    ///
    /// Recorded when alt text settings dialog is displayed to a user.
    pub static settings_displayed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_displayed".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5054), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SettingsEditAltTextCheckExtra {
        pub r#status: Option<bool>,
    }

    impl ExtraKeys for SettingsEditAltTextCheckExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["status"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#status.and_then(|val| map.insert("status".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.settings_edit_alt_text_check
    ///
    /// Recorded when the user interacts with the alt text modal setting to edit alt text on this pdf.
    pub static settings_edit_alt_text_check: Lazy<EventMetric<SettingsEditAltTextCheckExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "settings_edit_alt_text_check".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5055), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UserEditExtra {
        pub r#total_words: Option<u32>,
        pub r#words_added: Option<u32>,
        pub r#words_removed: Option<u32>,
    }

    impl ExtraKeys for UserEditExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["total_words", "words_added", "words_removed"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#total_words.and_then(|val| map.insert("total_words".into(), val.to_string()));
          self.r#words_added.and_then(|val| map.insert("words_added".into(), val.to_string()));
          self.r#words_removed.and_then(|val| map.insert("words_removed".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.image.alt_text.user_edit
    ///
    /// Recorded once the alt text is confirmed, when the user makes changes to the alt text generated. By comparing the initially generated text with the final version, quantifies how many words were changed.
    pub static user_edit: Lazy<EventMetric<UserEditExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_edit".into(),
                category: "pdfjs.image.alt_text".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5056), meta)
    });

}
pub mod pdfjs_signature {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddedExtra {
        pub r#has_alt_text: Option<u32>,
        pub r#has_no_alt_text: Option<u32>,
    }

    impl ExtraKeys for AddedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_alt_text", "has_no_alt_text"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_alt_text.and_then(|val| map.insert("has_alt_text".into(), val.to_string()));
          self.r#has_no_alt_text.and_then(|val| map.insert("has_no_alt_text".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.added
    ///
    /// Recorded when the user print/save a pdf containing some added signatures.
    pub static added: Lazy<EventMetric<AddedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "added".into(),
                category: "pdfjs.signature".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5057), meta)
    });

    #[repr(u16)]
    pub enum ClearLabel {
        EType = 0,
        EDraw = 1,
        EText = 2,
        __Other__,
    }
    impl From<u16> for ClearLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EType,
                1 => Self::EDraw,
                2 => Self::EText,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ClearLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EType => "type",
                Self::EDraw => "draw",
                Self::EText => "text",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.clear
    ///
    /// Counts the number of times the user clears the signature while editing it.
    pub static clear: Lazy<LabeledMetric<LabeledCounterMetric, ClearLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "clear".into(),
                    category: "pdfjs.signature".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5058), meta, Some(vec![::std::borrow::Cow::from("draw"), ::std::borrow::Cow::from("text"), ::std::borrow::Cow::from("type")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CreatedExtra {
        pub r#description_changed: Option<bool>,
        pub r#saved: Option<bool>,
        pub r#saved_count: Option<u32>,
        pub r#type: Option<String>,
    }

    impl ExtraKeys for CreatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["description_changed", "saved", "saved_count", "type"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#description_changed.and_then(|val| map.insert("description_changed".into(), val.to_string()));
          self.r#saved.and_then(|val| map.insert("saved".into(), val.to_string()));
          self.r#saved_count.and_then(|val| map.insert("saved_count".into(), val.to_string()));
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.created
    ///
    /// Recorded when the user creates a new signature.
    pub static created: Lazy<EventMetric<CreatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "created".into(),
                category: "pdfjs.signature".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5059), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DeleteSavedExtra {
        pub r#saved_count: Option<u32>,
    }

    impl ExtraKeys for DeleteSavedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["saved_count"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#saved_count.and_then(|val| map.insert("saved_count".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.delete_saved
    ///
    /// Recorded when a saved signature is deleted.
    pub static delete_saved: Lazy<EventMetric<DeleteSavedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_saved".into(),
                category: "pdfjs.signature".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5060), meta)
    });

    #[repr(u16)]
    pub enum EditDescriptionLabel {
        ESaved = 0,
        EUnsaved = 1,
        __Other__,
    }
    impl From<u16> for EditDescriptionLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESaved,
                1 => Self::EUnsaved,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EditDescriptionLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESaved => "saved",
                Self::EUnsaved => "unsaved",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.edit_description
    ///
    /// Counts the number of times the user edit the description of a signature instance.
    pub static edit_description: Lazy<LabeledMetric<LabeledCounterMetric, EditDescriptionLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "edit_description".into(),
                    category: "pdfjs.signature".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5061), meta, Some(vec![::std::borrow::Cow::from("saved"), ::std::borrow::Cow::from("unsaved")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InsertedExtra {
        pub r#has_been_saved: Option<bool>,
        pub r#has_description: Option<bool>,
    }

    impl ExtraKeys for InsertedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_been_saved", "has_description"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_been_saved.and_then(|val| map.insert("has_been_saved".into(), val.to_string()));
          self.r#has_description.and_then(|val| map.insert("has_description".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pdfjs.signature.inserted
    ///
    /// Recorded when the user inserts a signature in a pdf (can be from the UI, copy & paste, ...).
    pub static inserted: Lazy<EventMetric<InsertedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inserted".into(),
                category: "pdfjs.signature".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5062), meta)
    });

}
pub mod pictureinpicture {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.background_tab_playing_duration
    ///
    /// The length of time (in seconds) that a video was in Picture-in-Picture mode in a background tab.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_PICTURE_IN_PICTURE_BACKGROUND_TAB_PLAYING_DURATION.
    pub static background_tab_playing_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_tab_playing_duration".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5063), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_browser_crash
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#browserCrash.
    pub static closed_method_browser_crash: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_browser_crash".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5064), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_close_button
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#closeButton.
    pub static closed_method_close_button: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_close_button".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5065), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_close_player_shortcut
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#closePlayerShortcut.
    pub static closed_method_close_player_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_close_player_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5066), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_context_menu
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#contextMenu.
    pub static closed_method_context_menu: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_context_menu".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5067), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_foregrounded
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#foregrounded.
    pub static closed_method_foregrounded: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_foregrounded".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5068), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_fullscreen
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#fullscreen.
    pub static closed_method_fullscreen: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_fullscreen".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5069), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_pagehide
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#pagehide.
    pub static closed_method_pagehide: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_pagehide".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5070), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_setup_failure
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#setupFailure.
    pub static closed_method_setup_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_setup_failure".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5071), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_shortcut
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#shortcut.
    pub static closed_method_shortcut: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5072), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_unpip
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#unpip.
    pub static closed_method_unpip: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_unpip".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5073), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_url_bar
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#urlBar.
    pub static closed_method_url_bar: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5074), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_video_el_emptied
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#videoElEmptied.
    pub static closed_method_video_el_emptied: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_video_el_emptied".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5075), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.closed_method_video_el_remove
    ///
    /// Records the method for closing the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.closed_method#videoElRemove.
    pub static closed_method_video_el_remove: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "closed_method_video_el_remove".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5076), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CreatePlayerExtra {
        pub r#ccEnabled: Option<bool>,
        pub r#height: Option<u32>,
        pub r#screenX: Option<u32>,
        pub r#screenY: Option<u32>,
        pub r#value: Option<String>,
        pub r#webVTTSubtitles: Option<bool>,
        pub r#width: Option<u32>,
    }

    impl ExtraKeys for CreatePlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["ccEnabled", "height", "screenX", "screenY", "value", "webVTTSubtitles", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#ccEnabled.and_then(|val| map.insert("ccEnabled".into(), val.to_string()));
          self.r#height.and_then(|val| map.insert("height".into(), val.to_string()));
          self.r#screenX.and_then(|val| map.insert("screenX".into(), val.to_string()));
          self.r#screenY.and_then(|val| map.insert("screenY".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#webVTTSubtitles.and_then(|val| map.insert("webVTTSubtitles".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.create_player
    ///
    /// Recorded when the Picture-in-Picture player window is created. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.create#player.
    pub static create_player: Lazy<EventMetric<CreatePlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "create_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5077), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.disrespect_disable_url_bar
    ///
    /// Recorded when the user chooses to enable PiP anyway on a PiP disabled video This event was generated to correspond to the Legacy Telemetry event pictureinpicture.disrespect_disable#urlBar.
    pub static disrespect_disable_url_bar: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disrespect_disable_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5078), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.foreground_tab_playing_duration
    ///
    /// The length of time (in seconds) that a video was in Picture-in-Picture mode in a foreground tab.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_PICTURE_IN_PICTURE_FOREGROUND_TAB_PLAYING_DURATION.
    pub static foreground_tab_playing_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "foreground_tab_playing_duration".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5079), meta, TimeUnit::Second)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct FullscreenPlayerExtra {
        pub r#enter: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for FullscreenPlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["enter", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#enter.and_then(|val| map.insert("enter".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.fullscreen_player
    ///
    /// Recorded when the user clicks the fullscreen button This event was generated to correspond to the Legacy Telemetry event pictureinpicture.fullscreen#player.
    pub static fullscreen_player: Lazy<EventMetric<FullscreenPlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fullscreen_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5080), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.most_concurrent_players
    ///
    /// The most concurrent Picture-in-Picture players the user had open at any one time. This metric was generated to correspond to the Legacy Telemetry scalar pictureinpicture.most_concurrent_players.
    pub static most_concurrent_players: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "most_concurrent_players".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5081), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodAutoPipExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodAutoPipExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_auto_pip
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.opened_method#autoPip.
    pub static opened_method_auto_pip: Lazy<EventMetric<OpenedMethodAutoPipExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_auto_pip".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5082), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodContextMenuExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodContextMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_context_menu
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.opened_method#contextMenu.
    pub static opened_method_context_menu: Lazy<EventMetric<OpenedMethodContextMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_context_menu".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5083), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodShortcutExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodShortcutExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_shortcut
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.opened_method#shortcut.
    pub static opened_method_shortcut: Lazy<EventMetric<OpenedMethodShortcutExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_shortcut".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5084), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodToggleExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_toggle
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.opened_method#toggle.
    pub static opened_method_toggle: Lazy<EventMetric<OpenedMethodToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_toggle".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5085), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedMethodUrlBarExtra {
        pub r#callout: Option<bool>,
        pub r#disableDialog: Option<bool>,
        pub r#firstTimeToggle: Option<bool>,
    }

    impl ExtraKeys for OpenedMethodUrlBarExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["callout", "disableDialog", "firstTimeToggle"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#callout.and_then(|val| map.insert("callout".into(), val.to_string()));
          self.r#disableDialog.and_then(|val| map.insert("disableDialog".into(), val.to_string()));
          self.r#firstTimeToggle.and_then(|val| map.insert("firstTimeToggle".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.opened_method_url_bar
    ///
    /// Records the method for opening the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.opened_method#urlBar.
    pub static opened_method_url_bar: Lazy<EventMetric<OpenedMethodUrlBarExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened_method_url_bar".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5086), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ResizePlayerExtra {
        pub r#height: Option<u32>,
        pub r#value: Option<String>,
        pub r#width: Option<u32>,
    }

    impl ExtraKeys for ResizePlayerExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["height", "value", "width"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#height.and_then(|val| map.insert("height".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          self.r#width.and_then(|val| map.insert("width".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.resize_player
    ///
    /// Recorded when the Picture-in-Picture player window is resized. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.resize#player.
    pub static resize_player: Lazy<EventMetric<ResizePlayerExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resize_player".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5087), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SawToggleToggleExtra {
        pub r#firstTime: Option<bool>,
    }

    impl ExtraKeys for SawToggleToggleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["firstTime"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#firstTime.and_then(|val| map.insert("firstTime".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.saw_toggle_toggle
    ///
    /// Recorded when the Picture-in-Picture toggle is shown This event was generated to correspond to the Legacy Telemetry event pictureinpicture.saw_toggle#toggle.
    pub static saw_toggle_toggle: Lazy<EventMetric<SawToggleToggleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "saw_toggle_toggle".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5088), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SubtitlesShownSubtitlesExtra {
        pub r#webVTTSubtitles: Option<bool>,
    }

    impl ExtraKeys for SubtitlesShownSubtitlesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["webVTTSubtitles"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#webVTTSubtitles.and_then(|val| map.insert("webVTTSubtitles".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.subtitles_shown_subtitles
    ///
    /// Records if subtitles are shown in the Picture-in-Picture window. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.subtitles_shown#subtitles.
    pub static subtitles_shown_subtitles: Lazy<EventMetric<SubtitlesShownSubtitlesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "subtitles_shown_subtitles".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5089), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.toggle_enabled
    ///
    /// Whether the user has Picture-in-Picture enabled. This metric was generated to correspond to the Legacy Telemetry scalar pictureinpicture.toggle_enabled.
    pub static toggle_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "toggle_enabled".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5090), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.window_open_duration
    ///
    /// The length of time (in seconds) that a Picture-in-Picture window was open.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_PICTURE_IN_PICTURE_WINDOW_OPEN_DURATION.
    pub static window_open_duration: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "window_open_duration".into(),
                category: "pictureinpicture".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5091), meta, TimeUnit::Second)
    });

}
pub mod pictureinpicture_settings {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.disable_player
    ///
    /// Recorded with "settings" object when Picture-in-Picture is disabled via settings Recorded with "player" object when Picture-in-Picture is disabled via PiP context menu This event was generated to correspond to the Legacy Telemetry event pictureinpicture.settings.disable#player.
    pub static disable_player: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_player".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5092), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.disable_settings
    ///
    /// Recorded with "settings" object when Picture-in-Picture is disabled via settings Recorded with "player" object when Picture-in-Picture is disabled via PiP context menu This event was generated to correspond to the Legacy Telemetry event pictureinpicture.settings.disable#settings.
    pub static disable_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5093), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.enable_autotrigger_settings
    ///
    /// Recorded when the Picture-in-Picture auto-trigger is enabled. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.settings.enable_autotrigger#settings.
    pub static enable_autotrigger_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_autotrigger_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5094), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from pictureinpicture.settings.enable_settings
    ///
    /// Recorded when Picture-in-Picture is enabled. This event was generated to correspond to the Legacy Telemetry event pictureinpicture.settings.enable#settings.
    pub static enable_settings: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_settings".into(),
                category: "pictureinpicture.settings".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5095), meta)
    });

}
pub mod page_icon {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from page_icon.fit_icon_count
    ///
    /// Number of times the page-icon protocol serves an icon equal to or larger than requested.
    pub static fit_icon_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5096,
            "page_icon",
            "fit_icon_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from page_icon.small_icon_count
    ///
    /// Number of times the page-icon protocol serves an icon smaller than requested.
    pub static small_icon_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5097,
            "page_icon",
            "small_icon_count",
            "metrics"
        )
    });

}
pub mod places {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from places.annos_pages_count
    ///
    /// PLACES: Number of pages annotations
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_ANNOS_PAGES_COUNT.
    pub static annos_pages_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "annos_pages_count".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5098), meta, 50, 5000, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.backups_bookmarkstree
    ///
    /// PLACES: Time to build the bookmarks tree
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_BACKUPS_BOOKMARKSTREE_MS.
    pub static backups_bookmarkstree: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backups_bookmarkstree".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5099), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.backups_daysfromlast
    ///
    /// PLACES: Days from last backup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_BACKUPS_DAYSFROMLAST.
    pub static backups_daysfromlast: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backups_daysfromlast".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5100), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.backups_tojson
    ///
    /// PLACES: Time to convert and write the backup
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_BACKUPS_TOJSON_MS.
    pub static backups_tojson: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "backups_tojson".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5101), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.bookmarks_count
    ///
    /// PLACES: Number of bookmarks
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_BOOKMARKS_COUNT.
    pub static bookmarks_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bookmarks_count".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5102), meta, 100, 8000, 15, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.database_favicons_filesize
    ///
    /// PLACES: Favicons database filesize (MB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_DATABASE_FAVICONS_FILESIZE_MB.
    pub static database_favicons_filesize: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "database_favicons_filesize".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5103), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.database_filesize
    ///
    /// PLACES: Database filesize (MB)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_DATABASE_FILESIZE_MB.
    pub static database_filesize: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "database_filesize".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5104), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.expiration_steps_to_clean
    ///
    /// PLACES: Expiration steps to cleanup the database
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram PLACES_EXPIRATION_STEPS_TO_CLEAN2.
    pub static expiration_steps_to_clean: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "expiration_steps_to_clean".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5105), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.export_tohtml
    ///
    /// PLACES: Time to convert and write bookmarks.html
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_EXPORT_TOHTML_MS.
    pub static export_tohtml: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "export_tohtml".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5106), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.frecency_recalc_chunk_time
    ///
    /// PLACES: Time to recalculate frecency for a chunk of pages (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_FRECENCY_RECALC_CHUNK_TIME_MS.
    pub static frecency_recalc_chunk_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "frecency_recalc_chunk_time".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5107), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.idle_frecency_decay_time
    ///
    /// PLACES: Time to decay all frecencies values on idle (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_IDLE_FRECENCY_DECAY_TIME_MS.
    pub static idle_frecency_decay_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "idle_frecency_decay_time".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5108), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.idle_maintenance_time
    ///
    /// PLACES: Time to execute maintenance tasks on idle (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_IDLE_MAINTENANCE_TIME_MS.
    pub static idle_maintenance_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "idle_maintenance_time".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5109), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.keywords_count
    ///
    /// PLACES: Number of keywords
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_KEYWORDS_COUNT.
    pub static keywords_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keywords_count".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5110), meta, 1, 200, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.maintenance_daysfromlast
    ///
    /// PLACES: Days from last maintenance
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_MAINTENANCE_DAYSFROMLAST.
    pub static maintenance_daysfromlast: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "maintenance_daysfromlast".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5111), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.most_recent_expired_visit
    ///
    /// PLACES: the most recent expired visit in days
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PLACES_MOST_RECENT_EXPIRED_VISIT_DAYS.
    pub static most_recent_expired_visit: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "most_recent_expired_visit".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5112), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.pages_count
    ///
    /// PLACES: Number of unique pages
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_PAGES_COUNT.
    pub static pages_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pages_count".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5113), meta, 1000, 150000, 20, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.pages_need_frecency_recalculation
    ///
    /// Number of pages that need a frecency recalculation. This metric was generated to correspond to the Legacy Telemetry scalar places.pages_need_frecency_recalculation.
    pub static pages_need_frecency_recalculation: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pages_need_frecency_recalculation".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5114), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.places_database_corruption_handling_stage
    ///
    /// PLACES - stage reached when trying to fix a database corruption, see Places::Database::eCorruptDBReplaceStage.
    pub static places_database_corruption_handling_stage: Lazy<LabeledMetric<LabeledStringMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "places_database_corruption_handling_stage".into(),
                    category: "places".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5115), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.previousday_visits
    ///
    /// Number of history entries for the previous day. This metric was generated to correspond to the Legacy Telemetry scalar places.previousday_visits.
    pub static previousday_visits: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previousday_visits".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5116), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.sorted_bookmarks_perc
    ///
    /// PLACES: Percentage of bookmarks organized in folders
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PLACES_SORTED_BOOKMARKS_PERC.
    pub static sorted_bookmarks_perc: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sorted_bookmarks_perc".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5117), meta, 1, 100, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.sponsored_visit_no_triggering_url
    ///
    /// Number of sponsored visits that could not find their triggering URL in history. We expect this to be a small number just due to the navigation layer manipulating URLs. A large or growing value may be a concern. This metric was generated to correspond to the Legacy Telemetry scalar places.sponsored_visit_no_triggering_url.
    pub static sponsored_visit_no_triggering_url: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5118,
            "places",
            "sponsored_visit_no_triggering_url",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.tagged_bookmarks_perc
    ///
    /// PLACES: Percentage of tagged bookmarks
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram PLACES_TAGGED_BOOKMARKS_PERC.
    pub static tagged_bookmarks_perc: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tagged_bookmarks_perc".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5119), meta, 1, 100, 10, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from places.tags_count
    ///
    /// PLACES: Number of tags
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram PLACES_TAGS_COUNT.
    pub static tags_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "tags_count".into(),
                category: "places".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5120), meta, 1, 200, 10, HistogramType::Exponential)
    });

}
pub mod printing {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from printing.dialog_opened_via_preview_tm
    ///
    /// A counter incremented every time a user opens the system print dialog from the print preview interface. This metric was generated to correspond to the Legacy Telemetry scalar printing.dialog_opened_via_preview_tm.
    pub static dialog_opened_via_preview_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5121,
            "printing",
            "dialog_opened_via_preview_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.dialog_via_preview_cancelled_tm
    ///
    /// A counter incremented every time a user cancels a system print dialog that they opened from the print preview interface. This metric was generated to correspond to the Legacy Telemetry scalar printing.dialog_via_preview_cancelled_tm.
    pub static dialog_via_preview_cancelled_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5122,
            "printing",
            "dialog_via_preview_cancelled_tm",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum ErrorLabel {
        EGfxPrinterNoPrinterAvailable = 0,
        EGfxPrinterNameNotFound = 1,
        EGfxPrinterCouldNotOpenFile = 2,
        EGfxPrinterStartdoc = 3,
        EGfxPrinterEnddoc = 4,
        EGfxPrinterStartpage = 5,
        EGfxPrinterDocIsBusy = 6,
        EAbort = 7,
        ENotAvailable = 8,
        ENotImplemented = 9,
        EOutOfMemory = 10,
        EUnexpected = 11,
        EFailure = 12,
        EFallbackPaperList = 13,
        ELastUsedPrinter = 14,
        EPaperMargins = 15,
        EPrintDestinations = 16,
        EPrintPreview = 17,
        EPrinterList = 18,
        EPrinterProperties = 19,
        EPrinterSettings = 20,
        EUnwriteableMargin = 21,
        __Other__,
    }
    impl From<u16> for ErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EGfxPrinterNoPrinterAvailable,
                1 => Self::EGfxPrinterNameNotFound,
                2 => Self::EGfxPrinterCouldNotOpenFile,
                3 => Self::EGfxPrinterStartdoc,
                4 => Self::EGfxPrinterEnddoc,
                5 => Self::EGfxPrinterStartpage,
                6 => Self::EGfxPrinterDocIsBusy,
                7 => Self::EAbort,
                8 => Self::ENotAvailable,
                9 => Self::ENotImplemented,
                10 => Self::EOutOfMemory,
                11 => Self::EUnexpected,
                12 => Self::EFailure,
                13 => Self::EFallbackPaperList,
                14 => Self::ELastUsedPrinter,
                15 => Self::EPaperMargins,
                16 => Self::EPrintDestinations,
                17 => Self::EPrintPreview,
                18 => Self::EPrinterList,
                19 => Self::EPrinterProperties,
                20 => Self::EPrinterSettings,
                21 => Self::EUnwriteableMargin,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EGfxPrinterNoPrinterAvailable => "GFX_PRINTER_NO_PRINTER_AVAILABLE",
                Self::EGfxPrinterNameNotFound => "GFX_PRINTER_NAME_NOT_FOUND",
                Self::EGfxPrinterCouldNotOpenFile => "GFX_PRINTER_COULD_NOT_OPEN_FILE",
                Self::EGfxPrinterStartdoc => "GFX_PRINTER_STARTDOC",
                Self::EGfxPrinterEnddoc => "GFX_PRINTER_ENDDOC",
                Self::EGfxPrinterStartpage => "GFX_PRINTER_STARTPAGE",
                Self::EGfxPrinterDocIsBusy => "GFX_PRINTER_DOC_IS_BUSY",
                Self::EAbort => "ABORT",
                Self::ENotAvailable => "NOT_AVAILABLE",
                Self::ENotImplemented => "NOT_IMPLEMENTED",
                Self::EOutOfMemory => "OUT_OF_MEMORY",
                Self::EUnexpected => "UNEXPECTED",
                Self::EFailure => "FAILURE",
                Self::EFallbackPaperList => "FALLBACK_PAPER_LIST",
                Self::ELastUsedPrinter => "LAST_USED_PRINTER",
                Self::EPaperMargins => "PAPER_MARGINS",
                Self::EPrintDestinations => "PRINT_DESTINATIONS",
                Self::EPrintPreview => "PRINT_PREVIEW",
                Self::EPrinterList => "PRINTER_LIST",
                Self::EPrinterProperties => "PRINTER_PROPERTIES",
                Self::EPrinterSettings => "PRINTER_SETTINGS",
                Self::EUnwriteableMargin => "UNWRITEABLE_MARGIN",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from printing.error
    ///
    /// A counter incremented every time the user encounters an error printing. The result is split into keys which represent the values of error codes related to printing. Possible values are listed in 'keys'. "FAILURE" is a catch-all code for an error we don't recognize. This metric was generated to correspond to the Legacy Telemetry scalar printing.error.
    pub static error: Lazy<LabeledMetric<LabeledCounterMetric, ErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "error".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5123), meta, Some(vec![::std::borrow::Cow::from("ABORT"), ::std::borrow::Cow::from("FAILURE"), ::std::borrow::Cow::from("FALLBACK_PAPER_LIST"), ::std::borrow::Cow::from("GFX_PRINTER_COULD_NOT_OPEN_FILE"), ::std::borrow::Cow::from("GFX_PRINTER_DOC_IS_BUSY"), ::std::borrow::Cow::from("GFX_PRINTER_ENDDOC"), ::std::borrow::Cow::from("GFX_PRINTER_NAME_NOT_FOUND"), ::std::borrow::Cow::from("GFX_PRINTER_NO_PRINTER_AVAILABLE"), ::std::borrow::Cow::from("GFX_PRINTER_STARTDOC"), ::std::borrow::Cow::from("GFX_PRINTER_STARTPAGE"), ::std::borrow::Cow::from("LAST_USED_PRINTER"), ::std::borrow::Cow::from("NOT_AVAILABLE"), ::std::borrow::Cow::from("NOT_IMPLEMENTED"), ::std::borrow::Cow::from("OUT_OF_MEMORY"), ::std::borrow::Cow::from("PAPER_MARGINS"), ::std::borrow::Cow::from("PRINTER_LIST"), ::std::borrow::Cow::from("PRINTER_PROPERTIES"), ::std::borrow::Cow::from("PRINTER_SETTINGS"), ::std::borrow::Cow::from("PRINT_DESTINATIONS"), ::std::borrow::Cow::from("PRINT_PREVIEW"), ::std::borrow::Cow::from("UNEXPECTED"), ::std::borrow::Cow::from("UNWRITEABLE_MARGIN")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.preview_cancelled_tm
    ///
    /// A counter incremented every time a user exits print preview without printing. This metric was generated to correspond to the Legacy Telemetry scalar printing.preview_cancelled_tm.
    pub static preview_cancelled_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5124,
            "printing",
            "preview_cancelled_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.preview_opened_tm
    ///
    /// A counter incremented every time a user opens print preview. This metric was generated to correspond to the Legacy Telemetry scalar printing.preview_opened_tm.
    pub static preview_opened_tm: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5125,
            "printing",
            "preview_opened_tm",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.settings_changed
    ///
    /// A count of how many times the user changed a setting in print preview, broken down per setting. This metric was generated to correspond to the Legacy Telemetry scalar printing.settings_changed.
    pub static settings_changed: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "settings_changed".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5126), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from printing.silent_print
    ///
    /// A counter incremented every time a silent print (a print without a print settings dialog being opened) is initiated.  This happens when extensions invoke ExtensionAPI.tabs.saveAsPDF, for example, or when the print.always_print_silent pref is set. This metric was generated to correspond to the Legacy Telemetry scalar printing.silent_print.
    pub static silent_print: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5127,
            "printing",
            "silent_print",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum TargetTypeLabel {
        EPdfFile = 0,
        EPdfUnknown = 1,
        EXpsFile = 2,
        EUnknown = 3,
        __Other__,
    }
    impl From<u16> for TargetTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPdfFile,
                1 => Self::EPdfUnknown,
                2 => Self::EXpsFile,
                3 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TargetTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPdfFile => "pdf_file",
                Self::EPdfUnknown => "pdf_unknown",
                Self::EXpsFile => "xps_file",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from printing.target_type
    ///
    /// A counter incremented every time the user prints to a certain target type.  The 'pdf_unknown' count is for printers with names that we don't know about/check for, but that have 'pdf' in their name, and is mainly a sanity check that we're not missing significant counts in 'pdf_file'. For the most part, the 'unknown' count will be prints to a physical printer, but we can't know for sure since third party drivers could also be print to file drivers that we don't otherwise catch in the other counts. This metric was generated to correspond to the Legacy Telemetry scalar printing.target_type.
    pub static target_type: Lazy<LabeledMetric<LabeledCounterMetric, TargetTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "target_type".into(),
                    category: "printing".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5128), meta, Some(vec![::std::borrow::Cow::from("pdf_file"), ::std::borrow::Cow::from("pdf_unknown"), ::std::borrow::Cow::from("unknown"), ::std::borrow::Cow::from("xps_file")]))
    });

}
pub mod power {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_bogus_values
    ///
    /// Impossibly large CPU time values that were discarded.
    pub static cpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5129,
            "power",
            "cpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum CpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for CpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_process_type_ms
    ///
    /// CPU time used by each process type in ms.
    pub static cpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cpu_time_per_process_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5130), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[repr(u16)]
    pub enum CpuTimePerTrackerTypeMsLabel {
        EAd = 0,
        EAnalytics = 1,
        ECryptomining = 2,
        EFingerprinting = 3,
        ESocial = 4,
        EUnknown = 5,
        __Other__,
    }
    impl From<u16> for CpuTimePerTrackerTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAd,
                1 => Self::EAnalytics,
                2 => Self::ECryptomining,
                3 => Self::EFingerprinting,
                4 => Self::ESocial,
                5 => Self::EUnknown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CpuTimePerTrackerTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAd => "ad",
                Self::EAnalytics => "analytics",
                Self::ECryptomining => "cryptomining",
                Self::EFingerprinting => "fingerprinting",
                Self::ESocial => "social",
                Self::EUnknown => "unknown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_time_per_tracker_type_ms
    ///
    /// CPU time used by content processes used only for tracking resources, labeled by the category of the tracker.
    pub static cpu_time_per_tracker_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, CpuTimePerTrackerTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "cpu_time_per_tracker_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5131), meta, Some(vec![::std::borrow::Cow::from("ad"), ::std::borrow::Cow::from("analytics"), ::std::borrow::Cow::from("cryptomining"), ::std::borrow::Cow::from("fingerprinting"), ::std::borrow::Cow::from("social"), ::std::borrow::Cow::from("unknown")]))
    });

    #[repr(u16)]
    pub enum EnergyPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for EnergyPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EnergyPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.energy_per_process_type
    ///
    /// How much energy (in µWh) has been used, broken down by process type. Only available on Apple Silicon.
    pub static energy_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, EnergyPerProcessTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "energy_per_process_type".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5132), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_bogus_values
    ///
    /// Impossibly large GPU time values that were discarded.
    pub static gpu_time_bogus_values: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5133,
            "power",
            "gpu_time_bogus_values",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum GpuTimePerProcessTypeMsLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for GpuTimePerProcessTypeMsLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuTimePerProcessTypeMsLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.gpu_time_per_process_type_ms
    ///
    /// GPU time used by each process type in ms.
    pub static gpu_time_per_process_type_ms: Lazy<LabeledMetric<LabeledCounterMetric, GpuTimePerProcessTypeMsLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_time_per_process_type_ms".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5134), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_cpu_time_ms
    ///
    /// Total CPU time used by all processes in ms.
    pub static total_cpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5135,
            "power",
            "total_cpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_gpu_time_ms
    ///
    /// Total GPU time used by all processes in ms.
    pub static total_gpu_time_ms: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5136,
            "power",
            "total_gpu_time_ms",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from power.total_thread_wakeups
    ///
    /// How many times threads woke up and could have woken up a CPU core.
    pub static total_thread_wakeups: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5137,
            "power",
            "total_thread_wakeups",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum WakeupsPerProcessTypeLabel {
        EParentActive = 0,
        EParentActivePlayingAudio = 1,
        EParentActivePlayingVideo = 2,
        EParentInactive = 3,
        EParentInactivePlayingAudio = 4,
        EParentInactivePlayingVideo = 5,
        EPrealloc = 6,
        EPrivilegedabout = 7,
        ERdd = 8,
        ESocket = 9,
        EWebBackground = 10,
        EWebBackgroundPerceivable = 11,
        EWebForeground = 12,
        EExtension = 13,
        EGpu = 14,
        EGmplugin = 15,
        EUtility = 16,
        __Other__,
    }
    impl From<u16> for WakeupsPerProcessTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EParentActive,
                1 => Self::EParentActivePlayingAudio,
                2 => Self::EParentActivePlayingVideo,
                3 => Self::EParentInactive,
                4 => Self::EParentInactivePlayingAudio,
                5 => Self::EParentInactivePlayingVideo,
                6 => Self::EPrealloc,
                7 => Self::EPrivilegedabout,
                8 => Self::ERdd,
                9 => Self::ESocket,
                10 => Self::EWebBackground,
                11 => Self::EWebBackgroundPerceivable,
                12 => Self::EWebForeground,
                13 => Self::EExtension,
                14 => Self::EGpu,
                15 => Self::EGmplugin,
                16 => Self::EUtility,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WakeupsPerProcessTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EParentActive => "parent.active",
                Self::EParentActivePlayingAudio => "parent.active.playing-audio",
                Self::EParentActivePlayingVideo => "parent.active.playing-video",
                Self::EParentInactive => "parent.inactive",
                Self::EParentInactivePlayingAudio => "parent.inactive.playing-audio",
                Self::EParentInactivePlayingVideo => "parent.inactive.playing-video",
                Self::EPrealloc => "prealloc",
                Self::EPrivilegedabout => "privilegedabout",
                Self::ERdd => "rdd",
                Self::ESocket => "socket",
                Self::EWebBackground => "web.background",
                Self::EWebBackgroundPerceivable => "web.background-perceivable",
                Self::EWebForeground => "web.foreground",
                Self::EExtension => "extension",
                Self::EGpu => "gpu",
                Self::EGmplugin => "gmplugin",
                Self::EUtility => "utility",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_process_type
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by process type.
    pub static wakeups_per_process_type: Lazy<LabeledMetric<LabeledCounterMetric, WakeupsPerProcessTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "wakeups_per_process_type".into(),
                    category: "power".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5138), meta, Some(vec![::std::borrow::Cow::from("extension"), ::std::borrow::Cow::from("gmplugin"), ::std::borrow::Cow::from("gpu"), ::std::borrow::Cow::from("parent.active"), ::std::borrow::Cow::from("parent.active.playing-audio"), ::std::borrow::Cow::from("parent.active.playing-video"), ::std::borrow::Cow::from("parent.inactive"), ::std::borrow::Cow::from("parent.inactive.playing-audio"), ::std::borrow::Cow::from("parent.inactive.playing-video"), ::std::borrow::Cow::from("prealloc"), ::std::borrow::Cow::from("privilegedabout"), ::std::borrow::Cow::from("rdd"), ::std::borrow::Cow::from("socket"), ::std::borrow::Cow::from("utility"), ::std::borrow::Cow::from("web.background"), ::std::borrow::Cow::from("web.background-perceivable"), ::std::borrow::Cow::from("web.foreground")]))
    });

}
pub mod power_battery {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from power.battery.percentage_when_user_active
    ///
    /// Records how many percent of battery was available for each period of user activity.
    pub static percentage_when_user_active: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "percentage_when_user_active".into(),
                category: "power.battery".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5139), meta, 0, 100, 100, HistogramType::Linear)
    });

}
pub mod power_cpu_ms_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_background
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_background".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5140), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.content_foreground
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_foreground".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5141), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.gpu_process
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_process".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5142), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_active
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_active".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5143), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.cpu_ms_per_thread.parent_inactive
    ///
    /// How many miliseconds of CPU time were used. Broken down by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_inactive".into(),
                    category: "power.cpu_ms_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5144), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod power_wakeups_per_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum ContentBackgroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentBackgroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentBackgroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_background
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by thread name for a given process type.
    pub static content_background: Lazy<LabeledMetric<LabeledCounterMetric, ContentBackgroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_background".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5145), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ContentForegroundLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ContentForegroundLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ContentForegroundLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.content_foreground
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by thread name for a given process type.
    pub static content_foreground: Lazy<LabeledMetric<LabeledCounterMetric, ContentForegroundLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "content_foreground".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5146), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum GpuProcessLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for GpuProcessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for GpuProcessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.gpu_process
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by thread name for a given process type.
    pub static gpu_process: Lazy<LabeledMetric<LabeledCounterMetric, GpuProcessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "gpu_process".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5147), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentActiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentActiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentActiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_active
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by thread name for a given process type.
    pub static parent_active: Lazy<LabeledMetric<LabeledCounterMetric, ParentActiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_active".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5148), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

    #[repr(u16)]
    pub enum ParentInactiveLabel {
        EAndroidui = 0,
        EAsynclogger = 1,
        EAudioipc = 2,
        EAudioipcCallbackRpc = 3,
        EAudioipcClientCallback = 4,
        EAudioipcClientRpc = 5,
        EAudioipcDevicecollectionRpc = 6,
        EAudioipcServerCallback = 7,
        EAudioipcServerRpc = 8,
        EBackgroundthreadpool = 9,
        EBgiothreadpool = 10,
        EBgreadurls = 11,
        EBhmgrMonitor = 12,
        EBhmgrProcessor = 13,
        ECamerasIpc = 14,
        ECanvasrenderer = 15,
        ECapturethread = 16,
        EClassifierUpdate = 17,
        EComMta = 18,
        ECompositor = 19,
        EConvolverworker = 20,
        ECookie = 21,
        ECubeboperation = 22,
        EDatachannelIo = 23,
        EDnsResolver = 24,
        EDomWorker = 25,
        EDomWorklet = 26,
        EDomcachethread = 27,
        EExtensionprotocolhandler = 28,
        EFontLoader = 29,
        EFontenumthread = 30,
        EFsBroker = 31,
        EGeckomain = 32,
        EGmpthread = 33,
        EGraphrunner = 34,
        EHrtfdatabaseldr = 35,
        EHtml5Parser = 36,
        EImagebridgechld = 37,
        EImageio = 38,
        EIndexeddb = 39,
        EInitfontlist = 40,
        EInotifyeventthread = 41,
        EIndexeddbIo = 42,
        EIpcIOChild = 43,
        EIpcIOParent = 44,
        EIpcLaunch = 45,
        EIpdlBackground = 46,
        EJsWatchdog = 47,
        EJumpList = 48,
        ELibwebrtcmodulethread = 49,
        ELinkMonitor = 50,
        ELsThread = 51,
        EMdnsService = 52,
        EMediacache = 53,
        EMediadecoderstatemachine = 54,
        EMediapdecoder = 55,
        EMediasupervisor = 56,
        EMediatimer = 57,
        EMediatrackgrph = 58,
        EMemorypoller = 59,
        EMozstorage = 60,
        EMtransport = 61,
        ENetlinkMonitor = 62,
        EPacerthread = 63,
        EPermission = 64,
        EPlayeventsound = 65,
        EProcesshangmon = 66,
        EProfilerchild = 67,
        EProxyresolution = 68,
        EQuotamanagerIo = 69,
        ERegisterfonts = 70,
        ERemotebackbuffer = 71,
        ERemotelzystream = 72,
        ERemvidchild = 73,
        ERenderer = 74,
        ESandboxreporter = 75,
        ESavescripts = 76,
        ESocketThread = 77,
        ESoftwarevsyncthread = 78,
        ESqldbContentPrefsSqlite = 79,
        ESqldbCookiesSqlite = 80,
        ESqldbFormhistorySqlite = 81,
        ESslCert = 82,
        EStartupcache = 83,
        EStreamtrans = 84,
        EStylethread = 85,
        ESwcomposite = 86,
        ETaskcontroller = 87,
        ETimer = 88,
        EToastbgthread = 89,
        ETrrBackground = 90,
        EUntrustedModules = 91,
        EUrlClassifier = 92,
        EVideocapture = 93,
        EVsynciothread = 94,
        EWebrtccallthread = 95,
        EWebrtcworker = 96,
        EWincompositor = 97,
        EWindowsvsyncthread = 98,
        EWinwindowocclusioncalc = 99,
        EWifiTickler = 100,
        EWorkerLauncher = 101,
        EWrrenderbackend = 102,
        EWrscenebuilder = 103,
        EWrscenebuilderlp = 104,
        EWrworker = 105,
        EWrworkerlp = 106,
        __Other__,
    }
    impl From<u16> for ParentInactiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EAndroidui,
                1 => Self::EAsynclogger,
                2 => Self::EAudioipc,
                3 => Self::EAudioipcCallbackRpc,
                4 => Self::EAudioipcClientCallback,
                5 => Self::EAudioipcClientRpc,
                6 => Self::EAudioipcDevicecollectionRpc,
                7 => Self::EAudioipcServerCallback,
                8 => Self::EAudioipcServerRpc,
                9 => Self::EBackgroundthreadpool,
                10 => Self::EBgiothreadpool,
                11 => Self::EBgreadurls,
                12 => Self::EBhmgrMonitor,
                13 => Self::EBhmgrProcessor,
                14 => Self::ECamerasIpc,
                15 => Self::ECanvasrenderer,
                16 => Self::ECapturethread,
                17 => Self::EClassifierUpdate,
                18 => Self::EComMta,
                19 => Self::ECompositor,
                20 => Self::EConvolverworker,
                21 => Self::ECookie,
                22 => Self::ECubeboperation,
                23 => Self::EDatachannelIo,
                24 => Self::EDnsResolver,
                25 => Self::EDomWorker,
                26 => Self::EDomWorklet,
                27 => Self::EDomcachethread,
                28 => Self::EExtensionprotocolhandler,
                29 => Self::EFontLoader,
                30 => Self::EFontenumthread,
                31 => Self::EFsBroker,
                32 => Self::EGeckomain,
                33 => Self::EGmpthread,
                34 => Self::EGraphrunner,
                35 => Self::EHrtfdatabaseldr,
                36 => Self::EHtml5Parser,
                37 => Self::EImagebridgechld,
                38 => Self::EImageio,
                39 => Self::EIndexeddb,
                40 => Self::EInitfontlist,
                41 => Self::EInotifyeventthread,
                42 => Self::EIndexeddbIo,
                43 => Self::EIpcIOChild,
                44 => Self::EIpcIOParent,
                45 => Self::EIpcLaunch,
                46 => Self::EIpdlBackground,
                47 => Self::EJsWatchdog,
                48 => Self::EJumpList,
                49 => Self::ELibwebrtcmodulethread,
                50 => Self::ELinkMonitor,
                51 => Self::ELsThread,
                52 => Self::EMdnsService,
                53 => Self::EMediacache,
                54 => Self::EMediadecoderstatemachine,
                55 => Self::EMediapdecoder,
                56 => Self::EMediasupervisor,
                57 => Self::EMediatimer,
                58 => Self::EMediatrackgrph,
                59 => Self::EMemorypoller,
                60 => Self::EMozstorage,
                61 => Self::EMtransport,
                62 => Self::ENetlinkMonitor,
                63 => Self::EPacerthread,
                64 => Self::EPermission,
                65 => Self::EPlayeventsound,
                66 => Self::EProcesshangmon,
                67 => Self::EProfilerchild,
                68 => Self::EProxyresolution,
                69 => Self::EQuotamanagerIo,
                70 => Self::ERegisterfonts,
                71 => Self::ERemotebackbuffer,
                72 => Self::ERemotelzystream,
                73 => Self::ERemvidchild,
                74 => Self::ERenderer,
                75 => Self::ESandboxreporter,
                76 => Self::ESavescripts,
                77 => Self::ESocketThread,
                78 => Self::ESoftwarevsyncthread,
                79 => Self::ESqldbContentPrefsSqlite,
                80 => Self::ESqldbCookiesSqlite,
                81 => Self::ESqldbFormhistorySqlite,
                82 => Self::ESslCert,
                83 => Self::EStartupcache,
                84 => Self::EStreamtrans,
                85 => Self::EStylethread,
                86 => Self::ESwcomposite,
                87 => Self::ETaskcontroller,
                88 => Self::ETimer,
                89 => Self::EToastbgthread,
                90 => Self::ETrrBackground,
                91 => Self::EUntrustedModules,
                92 => Self::EUrlClassifier,
                93 => Self::EVideocapture,
                94 => Self::EVsynciothread,
                95 => Self::EWebrtccallthread,
                96 => Self::EWebrtcworker,
                97 => Self::EWincompositor,
                98 => Self::EWindowsvsyncthread,
                99 => Self::EWinwindowocclusioncalc,
                100 => Self::EWifiTickler,
                101 => Self::EWorkerLauncher,
                102 => Self::EWrrenderbackend,
                103 => Self::EWrscenebuilder,
                104 => Self::EWrscenebuilderlp,
                105 => Self::EWrworker,
                106 => Self::EWrworkerlp,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ParentInactiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EAndroidui => "androidui",
                Self::EAsynclogger => "asynclogger",
                Self::EAudioipc => "audioipc",
                Self::EAudioipcCallbackRpc => "audioipc_callback_rpc",
                Self::EAudioipcClientCallback => "audioipc_client_callback",
                Self::EAudioipcClientRpc => "audioipc_client_rpc",
                Self::EAudioipcDevicecollectionRpc => "audioipc_devicecollection_rpc",
                Self::EAudioipcServerCallback => "audioipc_server_callback",
                Self::EAudioipcServerRpc => "audioipc_server_rpc",
                Self::EBackgroundthreadpool => "backgroundthreadpool",
                Self::EBgiothreadpool => "bgiothreadpool",
                Self::EBgreadurls => "bgreadurls",
                Self::EBhmgrMonitor => "bhmgr_monitor",
                Self::EBhmgrProcessor => "bhmgr_processor",
                Self::ECamerasIpc => "cameras_ipc",
                Self::ECanvasrenderer => "canvasrenderer",
                Self::ECapturethread => "capturethread",
                Self::EClassifierUpdate => "classifier_update",
                Self::EComMta => "com_mta",
                Self::ECompositor => "compositor",
                Self::EConvolverworker => "convolverworker",
                Self::ECookie => "cookie",
                Self::ECubeboperation => "cubeboperation",
                Self::EDatachannelIo => "datachannel_io",
                Self::EDnsResolver => "dns_resolver",
                Self::EDomWorker => "dom_worker",
                Self::EDomWorklet => "dom_worklet",
                Self::EDomcachethread => "domcachethread",
                Self::EExtensionprotocolhandler => "extensionprotocolhandler",
                Self::EFontLoader => "font_loader",
                Self::EFontenumthread => "fontenumthread",
                Self::EFsBroker => "fs_broker",
                Self::EGeckomain => "geckomain",
                Self::EGmpthread => "gmpthread",
                Self::EGraphrunner => "graphrunner",
                Self::EHrtfdatabaseldr => "hrtfdatabaseldr",
                Self::EHtml5Parser => "html5_parser",
                Self::EImagebridgechld => "imagebridgechld",
                Self::EImageio => "imageio",
                Self::EIndexeddb => "indexeddb",
                Self::EInitfontlist => "initfontlist",
                Self::EInotifyeventthread => "inotifyeventthread",
                Self::EIndexeddbIo => "indexeddb_io",
                Self::EIpcIOChild => "ipc_i_o_child",
                Self::EIpcIOParent => "ipc_i_o_parent",
                Self::EIpcLaunch => "ipc_launch",
                Self::EIpdlBackground => "ipdl_background",
                Self::EJsWatchdog => "js_watchdog",
                Self::EJumpList => "jump_list",
                Self::ELibwebrtcmodulethread => "libwebrtcmodulethread",
                Self::ELinkMonitor => "link_monitor",
                Self::ELsThread => "ls_thread",
                Self::EMdnsService => "mdns_service",
                Self::EMediacache => "mediacache",
                Self::EMediadecoderstatemachine => "mediadecoderstatemachine",
                Self::EMediapdecoder => "mediapdecoder",
                Self::EMediasupervisor => "mediasupervisor",
                Self::EMediatimer => "mediatimer",
                Self::EMediatrackgrph => "mediatrackgrph",
                Self::EMemorypoller => "memorypoller",
                Self::EMozstorage => "mozstorage",
                Self::EMtransport => "mtransport",
                Self::ENetlinkMonitor => "netlink_monitor",
                Self::EPacerthread => "pacerthread",
                Self::EPermission => "permission",
                Self::EPlayeventsound => "playeventsound",
                Self::EProcesshangmon => "processhangmon",
                Self::EProfilerchild => "profilerchild",
                Self::EProxyresolution => "proxyresolution",
                Self::EQuotamanagerIo => "quotamanager_io",
                Self::ERegisterfonts => "registerfonts",
                Self::ERemotebackbuffer => "remotebackbuffer",
                Self::ERemotelzystream => "remotelzystream",
                Self::ERemvidchild => "remvidchild",
                Self::ERenderer => "renderer",
                Self::ESandboxreporter => "sandboxreporter",
                Self::ESavescripts => "savescripts",
                Self::ESocketThread => "socket_thread",
                Self::ESoftwarevsyncthread => "softwarevsyncthread",
                Self::ESqldbContentPrefsSqlite => "sqldb_content-prefs_sqlite",
                Self::ESqldbCookiesSqlite => "sqldb_cookies_sqlite",
                Self::ESqldbFormhistorySqlite => "sqldb_formhistory_sqlite",
                Self::ESslCert => "ssl_cert",
                Self::EStartupcache => "startupcache",
                Self::EStreamtrans => "streamtrans",
                Self::EStylethread => "stylethread",
                Self::ESwcomposite => "swcomposite",
                Self::ETaskcontroller => "taskcontroller",
                Self::ETimer => "timer",
                Self::EToastbgthread => "toastbgthread",
                Self::ETrrBackground => "trr_background",
                Self::EUntrustedModules => "untrusted_modules",
                Self::EUrlClassifier => "url_classifier",
                Self::EVideocapture => "videocapture",
                Self::EVsynciothread => "vsynciothread",
                Self::EWebrtccallthread => "webrtccallthread",
                Self::EWebrtcworker => "webrtcworker",
                Self::EWincompositor => "wincompositor",
                Self::EWindowsvsyncthread => "windowsvsyncthread",
                Self::EWinwindowocclusioncalc => "winwindowocclusioncalc",
                Self::EWifiTickler => "wifi_tickler",
                Self::EWorkerLauncher => "worker_launcher",
                Self::EWrrenderbackend => "wrrenderbackend",
                Self::EWrscenebuilder => "wrscenebuilder",
                Self::EWrscenebuilderlp => "wrscenebuilderlp",
                Self::EWrworker => "wrworker",
                Self::EWrworkerlp => "wrworkerlp",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from power.wakeups_per_thread.parent_inactive
    ///
    /// How many times threads woke up and could have woken up a CPU core. Broken down by thread name for a given process type.
    pub static parent_inactive: Lazy<LabeledMetric<LabeledCounterMetric, ParentInactiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "parent_inactive".into(),
                    category: "power.wakeups_per_thread".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5149), meta, Some(vec![::std::borrow::Cow::from("androidui"), ::std::borrow::Cow::from("asynclogger"), ::std::borrow::Cow::from("audioipc"), ::std::borrow::Cow::from("audioipc_callback_rpc"), ::std::borrow::Cow::from("audioipc_client_callback"), ::std::borrow::Cow::from("audioipc_client_rpc"), ::std::borrow::Cow::from("audioipc_devicecollection_rpc"), ::std::borrow::Cow::from("audioipc_server_callback"), ::std::borrow::Cow::from("audioipc_server_rpc"), ::std::borrow::Cow::from("backgroundthreadpool"), ::std::borrow::Cow::from("bgiothreadpool"), ::std::borrow::Cow::from("bgreadurls"), ::std::borrow::Cow::from("bhmgr_monitor"), ::std::borrow::Cow::from("bhmgr_processor"), ::std::borrow::Cow::from("cameras_ipc"), ::std::borrow::Cow::from("canvasrenderer"), ::std::borrow::Cow::from("capturethread"), ::std::borrow::Cow::from("classifier_update"), ::std::borrow::Cow::from("com_mta"), ::std::borrow::Cow::from("compositor"), ::std::borrow::Cow::from("convolverworker"), ::std::borrow::Cow::from("cookie"), ::std::borrow::Cow::from("cubeboperation"), ::std::borrow::Cow::from("datachannel_io"), ::std::borrow::Cow::from("dns_resolver"), ::std::borrow::Cow::from("dom_worker"), ::std::borrow::Cow::from("dom_worklet"), ::std::borrow::Cow::from("domcachethread"), ::std::borrow::Cow::from("extensionprotocolhandler"), ::std::borrow::Cow::from("font_loader"), ::std::borrow::Cow::from("fontenumthread"), ::std::borrow::Cow::from("fs_broker"), ::std::borrow::Cow::from("geckomain"), ::std::borrow::Cow::from("gmpthread"), ::std::borrow::Cow::from("graphrunner"), ::std::borrow::Cow::from("hrtfdatabaseldr"), ::std::borrow::Cow::from("html5_parser"), ::std::borrow::Cow::from("imagebridgechld"), ::std::borrow::Cow::from("imageio"), ::std::borrow::Cow::from("indexeddb"), ::std::borrow::Cow::from("indexeddb_io"), ::std::borrow::Cow::from("initfontlist"), ::std::borrow::Cow::from("inotifyeventthread"), ::std::borrow::Cow::from("ipc_i_o_child"), ::std::borrow::Cow::from("ipc_i_o_parent"), ::std::borrow::Cow::from("ipc_launch"), ::std::borrow::Cow::from("ipdl_background"), ::std::borrow::Cow::from("js_watchdog"), ::std::borrow::Cow::from("jump_list"), ::std::borrow::Cow::from("libwebrtcmodulethread"), ::std::borrow::Cow::from("link_monitor"), ::std::borrow::Cow::from("ls_thread"), ::std::borrow::Cow::from("mdns_service"), ::std::borrow::Cow::from("mediacache"), ::std::borrow::Cow::from("mediadecoderstatemachine"), ::std::borrow::Cow::from("mediapdecoder"), ::std::borrow::Cow::from("mediasupervisor"), ::std::borrow::Cow::from("mediatimer"), ::std::borrow::Cow::from("mediatrackgrph"), ::std::borrow::Cow::from("memorypoller"), ::std::borrow::Cow::from("mozstorage"), ::std::borrow::Cow::from("mtransport"), ::std::borrow::Cow::from("netlink_monitor"), ::std::borrow::Cow::from("pacerthread"), ::std::borrow::Cow::from("permission"), ::std::borrow::Cow::from("playeventsound"), ::std::borrow::Cow::from("processhangmon"), ::std::borrow::Cow::from("profilerchild"), ::std::borrow::Cow::from("proxyresolution"), ::std::borrow::Cow::from("quotamanager_io"), ::std::borrow::Cow::from("registerfonts"), ::std::borrow::Cow::from("remotebackbuffer"), ::std::borrow::Cow::from("remotelzystream"), ::std::borrow::Cow::from("remvidchild"), ::std::borrow::Cow::from("renderer"), ::std::borrow::Cow::from("sandboxreporter"), ::std::borrow::Cow::from("savescripts"), ::std::borrow::Cow::from("socket_thread"), ::std::borrow::Cow::from("softwarevsyncthread"), ::std::borrow::Cow::from("sqldb_content-prefs_sqlite"), ::std::borrow::Cow::from("sqldb_cookies_sqlite"), ::std::borrow::Cow::from("sqldb_formhistory_sqlite"), ::std::borrow::Cow::from("ssl_cert"), ::std::borrow::Cow::from("startupcache"), ::std::borrow::Cow::from("streamtrans"), ::std::borrow::Cow::from("stylethread"), ::std::borrow::Cow::from("swcomposite"), ::std::borrow::Cow::from("taskcontroller"), ::std::borrow::Cow::from("timer"), ::std::borrow::Cow::from("toastbgthread"), ::std::borrow::Cow::from("trr_background"), ::std::borrow::Cow::from("untrusted_modules"), ::std::borrow::Cow::from("url_classifier"), ::std::borrow::Cow::from("videocapture"), ::std::borrow::Cow::from("vsynciothread"), ::std::borrow::Cow::from("webrtccallthread"), ::std::borrow::Cow::from("webrtcworker"), ::std::borrow::Cow::from("wifi_tickler"), ::std::borrow::Cow::from("wincompositor"), ::std::borrow::Cow::from("windowsvsyncthread"), ::std::borrow::Cow::from("winwindowocclusioncalc"), ::std::borrow::Cow::from("worker_launcher"), ::std::borrow::Cow::from("wrrenderbackend"), ::std::borrow::Cow::from("wrscenebuilder"), ::std::borrow::Cow::from("wrscenebuilderlp"), ::std::borrow::Cow::from("wrworker"), ::std::borrow::Cow::from("wrworkerlp")]))
    });

}
pub mod readermode {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ButtonClickExtra {
        pub r#label: Option<String>,
    }

    impl ExtraKeys for ButtonClickExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["label"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#label.and_then(|val| map.insert("label".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.button_click
    ///
    /// This is recorded any time a Reader Mode button is clicked. This event was generated to correspond to the Legacy Telemetry event readermode.button#click.
    pub static button_click: Lazy<EventMetric<ButtonClickExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "button_click".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5150), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from readermode.download_result
    ///
    /// The result of trying to download a document to show in reader view (0=Success, 1=Error XHR, 2=Error no document)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram READER_MODE_DOWNLOAD_RESULT.
    pub static download_result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_result".into(),
                category: "readermode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5151), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from readermode.parse_result
    ///
    /// The result of trying to parse a document to show in reader view (0=Success, 1=Error too many elements, 2=Error in worker, 3=Error no article)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram READER_MODE_PARSE_RESULT.
    pub static parse_result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "parse_result".into(),
                category: "readermode".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5152), meta, 0, 5, 6, HistogramType::Linear)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ViewOffExtra {
        pub r#reader_time: Option<String>,
        pub r#scroll_position: Option<String>,
        pub r#subcategory: Option<String>,
    }

    impl ExtraKeys for ViewOffExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reader_time", "scroll_position", "subcategory"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reader_time.and_then(|val| map.insert("reader_time".into(), val.to_string()));
          self.r#scroll_position.and_then(|val| map.insert("scroll_position".into(), val.to_string()));
          self.r#subcategory.and_then(|val| map.insert("subcategory".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.view_off
    ///
    /// This is recorded any time Reader Mode is turned on or off. This event was generated to correspond to the Legacy Telemetry event readermode.view#off.
    pub static view_off: Lazy<EventMetric<ViewOffExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "view_off".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5153), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ViewOnExtra {
        pub r#reader_time: Option<String>,
        pub r#scroll_position: Option<String>,
        pub r#subcategory: Option<String>,
    }

    impl ExtraKeys for ViewOnExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["reader_time", "scroll_position", "subcategory"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#reader_time.and_then(|val| map.insert("reader_time".into(), val.to_string()));
          self.r#scroll_position.and_then(|val| map.insert("scroll_position".into(), val.to_string()));
          self.r#subcategory.and_then(|val| map.insert("subcategory".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from readermode.view_on
    ///
    /// This is recorded any time Reader Mode is turned on or off. This event was generated to correspond to the Legacy Telemetry event readermode.view#on.
    pub static view_on: Lazy<EventMetric<ViewOnExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "view_on".into(),
                category: "readermode".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5154), meta)
    });

}
pub mod broken_site_report {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.breakage_category
    ///
    /// An optional select-box choice (options may eventually change)
    pub static breakage_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "breakage_category".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5155), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.description
    ///
    /// An optional description of the site issue the user is experiencing. May contain PII.
    pub static description: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "description".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5156), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.url
    ///
    /// The URL of the site being reported. May contain PII.
    pub static url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "url".into(),
                category: "broken_site_report".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(5157), meta)
    });

}
pub mod broken_site_report_browser_info {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type AddonsObject = Vec<AddonsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct AddonsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub name: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub temporary: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.addons
    ///
    /// Active user-installed addons (not themes). List of objects with `id`, `name`, `temporary`, and `version`. For instance, `[{"id":"addon-name@email.org", "name":"My Addon", "temporary":false, "version":"0.1.0"}]`
    pub static addons: Lazy<ObjectMetric<AddonsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addons".into(),
                category: "broken_site_report.browser_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5158), meta)
    });

        pub type ExperimentsObject = Vec<ExperimentsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ExperimentsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branch: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub slug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub kind: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.experiments
    ///
    /// Experiments in which the user is actively enrolled. List of objects with `branch`, `slug`, and `kind`. For instance, `[{"branch":"some-branch", "slug":"some-experiment", "kind":"nimbusExperiment"}]`
    pub static experiments: Lazy<ObjectMetric<ExperimentsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "experiments".into(),
                category: "broken_site_report.browser_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5159), meta)
    });

}
pub mod broken_site_report_browser_info_app {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_locales
    ///
    /// Locale strings, ie `["en-US", "en"]`
    pub static default_locales: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_locales".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5160), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.default_useragent_string
    ///
    /// The default user-agent string of the browser
    pub static default_useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "default_useragent_string".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5161), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.app.fission_enabled
    ///
    /// Whether Fission is enabled
    pub static fission_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fission_enabled".into(),
                category: "broken_site_report.browser_info.app".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5162), meta)
    });

}
pub mod broken_site_report_browser_info_graphics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.device_pixel_ratio
    ///
    /// A decimal number
    pub static device_pixel_ratio: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "device_pixel_ratio".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5163), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.devices_json
    ///
    /// JSON array of objects with `vendorID` and `deviceID`. For instance, `[{"vendorID":"0x000", "deviceID":"0x001"}]`
    pub static devices_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "devices_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5164), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.drivers_json
    ///
    /// JSON array of objects with `renderer` and `version`. For instance, `[{"renderer":"demo", "version":"0.2"}]`
    pub static drivers_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "drivers_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5165), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.features_json
    ///
    /// JSON object. For instance, `{"WEBRENDER":"available","WEBRENDER_PARTIAL":"disabled (User disabled via pref)"}`
    pub static features_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "features_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5166), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.has_touch_screen
    ///
    /// Whether a touch screen was detected
    pub static has_touch_screen: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_touch_screen".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5167), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.graphics.monitors_json
    ///
    /// JSON array of objects with `screenWidth`, 'screenHeight`, and `scale`. For instance, `[{"screenWidth":3584,"screenHeight":2240,"scale":2}]`
    pub static monitors_json: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "monitors_json".into(),
                category: "broken_site_report.browser_info.graphics".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5168), meta)
    });

}
pub mod broken_site_report_browser_info_prefs {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.cookie_behavior
    ///
    /// Value of `network.cookie.cookieBehavior`
    pub static cookie_behavior: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cookie_behavior".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5169), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.forced_accelerated_layers
    ///
    /// Value of `layers.acceleration_force.enabled`
    pub static forced_accelerated_layers: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forced_accelerated_layers".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5170), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.global_privacy_control_enabled
    ///
    /// Value of `privacy.globalprivacycontrol.enabled`
    pub static global_privacy_control_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "global_privacy_control_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5171), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.h1_in_section_useragent_styles_enabled
    ///
    /// Value of `layout.css.h1-in-section-ua-styles.enabled`
    pub static h1_in_section_useragent_styles_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "h1_in_section_useragent_styles_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5172), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.installtrigger_enabled
    ///
    /// Value of `extensions.InstallTrigger.enabled`
    pub static installtrigger_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "installtrigger_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5173), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.opaque_response_blocking
    ///
    /// Value of `browser.opaqueResponseBlocking`
    pub static opaque_response_blocking: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opaque_response_blocking".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5174), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.resist_fingerprinting_enabled
    ///
    /// Value of `privacy.resistFingerprinting`
    pub static resist_fingerprinting_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "resist_fingerprinting_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5175), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.software_webrender
    ///
    /// Value of `gfx.webrender.software`
    pub static software_webrender: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "software_webrender".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5176), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled
    ///
    /// Value of `network.cookie.cookieBehavior.optInPartitioning`
    pub static third_party_cookie_blocking_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_cookie_blocking_enabled".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5177), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.prefs.third_party_cookie_blocking_enabled_in_pbm
    ///
    /// Value of `network.cookie.cookieBehavior.optInPartitioning.pbmode`
    pub static third_party_cookie_blocking_enabled_in_pbm: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "third_party_cookie_blocking_enabled_in_pbm".into(),
                category: "broken_site_report.browser_info.prefs".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5178), meta)
    });

}
pub mod broken_site_report_browser_info_security {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antispyware
    ///
    /// Which antispyware software was reported on this system.
    pub static antispyware: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "antispyware".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5179), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.antivirus
    ///
    /// Which antivirus software was reported on this system.
    pub static antivirus: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "antivirus".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5180), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.security.firewall
    ///
    /// Which firewall software was reported on this system.
    pub static firewall: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "firewall".into(),
                category: "broken_site_report.browser_info.security".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5181), meta)
    });

}
pub mod broken_site_report_browser_info_system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.is_tablet
    ///
    /// Whether the device is a tablet
    pub static is_tablet: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_tablet".into(),
                category: "broken_site_report.browser_info.system".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5182), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.browser_info.system.memory
    ///
    /// How many mb of RAM is reported for the system
    pub static memory: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "memory".into(),
                category: "broken_site_report.browser_info.system".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5183), meta)
    });

}
pub mod broken_site_report_tab_info {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.languages
    ///
    /// The languages the site actually sees (may be overridden)
    pub static languages: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "languages".into(),
                category: "broken_site_report.tab_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5184), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.useragent_string
    ///
    /// The userAgent the site actually sees (may be overridden)
    pub static useragent_string: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "useragent_string".into(),
                category: "broken_site_report.tab_info".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5185), meta)
    });

}
pub mod broken_site_report_tab_info_antitracking {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.block_list
    ///
    /// Currently either `basic` or `strict`, may change in the future.
    pub static block_list: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "block_list".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5186), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.btp_has_purged_site
    ///
    /// Whether the site in the current tab has recently been purged by Bounce Tracking Protection.
    pub static btp_has_purged_site: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "btp_has_purged_site".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5187), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.etp_category
    ///
    /// The current ETP category, either `standard`, `strict`, or `custom`.
    pub static etp_category: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "etp_category".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5188), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_active_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed active content
    pub static has_mixed_active_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_mixed_active_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5189), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_mixed_display_content_blocked
    ///
    /// Whether the reported tab has any blocked mixed display content
    pub static has_mixed_display_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_mixed_display_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5190), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.has_tracking_content_blocked
    ///
    /// Whether the reported tab has any blocked tracking content
    pub static has_tracking_content_blocked: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "has_tracking_content_blocked".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5191), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.antitracking.is_private_browsing
    ///
    /// Whether the tab the user was on when reporting is in private browsing mode
    pub static is_private_browsing: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_private_browsing".into(),
                category: "broken_site_report.tab_info.antitracking".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5192), meta)
    });

}
pub mod broken_site_report_tab_info_frameworks {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.fastclick
    ///
    /// Whether the FastClick web library was detected on the original tab.
    pub static fastclick: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fastclick".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5193), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.marfeel
    ///
    /// Whether the Marfeel web framework was detected on the original tab.
    pub static marfeel: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "marfeel".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5194), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from broken_site_report.tab_info.frameworks.mobify
    ///
    /// Whether the Mobify web framework was detected on the original tab.
    pub static mobify: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mobify".into(),
                category: "broken_site_report.tab_info.frameworks".into(),
                send_in_pings: vec!["broken-site-report".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5195), meta)
    });

}
pub mod webcompatreporting {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenedExtra {
        pub r#source: Option<String>,
    }

    impl ExtraKeys for OpenedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.opened
    ///
    /// Records the method for opening the webcompat reporting window.
    pub static opened: Lazy<EventMetric<OpenedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "opened".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5196), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReasonDropdownExtra {
        pub r#setting: Option<String>,
    }

    impl ExtraKeys for ReasonDropdownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["setting"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#setting.and_then(|val| map.insert("setting".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.reason_dropdown
    ///
    /// Record whether the user has a dropdown enabled + whether the dropdown menu is optional or mandatory.
    pub static reason_dropdown: Lazy<EventMetric<ReasonDropdownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reason_dropdown".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5197), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send
    ///
    /// Recorded when a user selects the Send button to submit webcompat report data.
    pub static send: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5198), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from webcompatreporting.send_more_info
    ///
    /// Recorded when a user clicks on the Send More Info link in the reporting UI The user will be redirected to webcompat.com to submit a more comprehensive report. (This is only enabled on beta/nightly/pre-release channels).
    pub static send_more_info: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send_more_info".into(),
                category: "webcompatreporting".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5199), meta)
    });

}
pub mod application_reputation {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum BinaryArchiveLabel {
        EOtherbinaryfile = 0,
        EDmgfile = 1,
        ERarfile = 2,
        EZipfile = 3,
        __Other__,
    }
    impl From<u16> for BinaryArchiveLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOtherbinaryfile,
                1 => Self::EDmgfile,
                2 => Self::ERarfile,
                3 => Self::EZipfile,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BinaryArchiveLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOtherbinaryfile => "OtherBinaryFile",
                Self::EDmgfile => "DmgFile",
                Self::ERarfile => "RarFile",
                Self::EZipfile => "ZipFile",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.binary_archive
    ///
    /// Whether a binary file examined by download protection is one of the common archive formats.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram APPLICATION_REPUTATION_BINARY_ARCHIVE.
    pub static binary_archive: Lazy<LabeledMetric<LabeledCounterMetric, BinaryArchiveLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "binary_archive".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5200), meta, Some(vec![::std::borrow::Cow::from("DmgFile"), ::std::borrow::Cow::from("OtherBinaryFile"), ::std::borrow::Cow::from("RarFile"), ::std::borrow::Cow::from("ZipFile")]))
    });

    #[repr(u16)]
    pub enum BinaryTypeLabel {
        EBinaryfile = 0,
        ENonbinaryfile = 1,
        EMoznonbinaryfile = 2,
        EUnknownfile = 3,
        EMissingfilename = 4,
        __Other__,
    }
    impl From<u16> for BinaryTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EBinaryfile,
                1 => Self::ENonbinaryfile,
                2 => Self::EMoznonbinaryfile,
                3 => Self::EUnknownfile,
                4 => Self::EMissingfilename,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for BinaryTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EBinaryfile => "BinaryFile",
                Self::ENonbinaryfile => "NonBinaryFile",
                Self::EMoznonbinaryfile => "MozNonBinaryFile",
                Self::EUnknownfile => "UnknownFile",
                Self::EMissingfilename => "MissingFilename",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.binary_type
    ///
    /// Whether or not the file examined by download protection is a binary type (or it's not possible to tell because the filename is missing).
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram APPLICATION_REPUTATION_BINARY_TYPE.
    pub static binary_type: Lazy<LabeledMetric<LabeledCounterMetric, BinaryTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "binary_type".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5201), meta, Some(vec![::std::borrow::Cow::from("BinaryFile"), ::std::borrow::Cow::from("MissingFilename"), ::std::borrow::Cow::from("MozNonBinaryFile"), ::std::borrow::Cow::from("NonBinaryFile"), ::std::borrow::Cow::from("UnknownFile")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.local
    ///
    /// Application reputation local results (0=ALLOW, 1=BLOCK, 2=NONE)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram APPLICATION_REPUTATION_LOCAL.
    pub static local: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "local".into(),
                category: "application_reputation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5202), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ReasonLabel {
        ENotset = 0,
        ELocalwhitelist = 1,
        ELocalblocklist = 2,
        ENonbinaryfile = 3,
        EVerdictsafe = 4,
        EVerdictunknown = 5,
        EVerdictdangerous = 6,
        EVerdictdangeroushost = 7,
        EVerdictunwanted = 8,
        EVerdictuncommon = 9,
        EVerdictunrecognized = 10,
        EDangerousprefoff = 11,
        EDangeroushostprefoff = 12,
        EUnwantedprefoff = 13,
        EUncommonprefoff = 14,
        ENetworkerror = 15,
        ERemotelookupdisabled = 16,
        EInternalerror = 17,
        EDpdisabled = 18,
        __Other__,
    }
    impl From<u16> for ReasonLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ENotset,
                1 => Self::ELocalwhitelist,
                2 => Self::ELocalblocklist,
                3 => Self::ENonbinaryfile,
                4 => Self::EVerdictsafe,
                5 => Self::EVerdictunknown,
                6 => Self::EVerdictdangerous,
                7 => Self::EVerdictdangeroushost,
                8 => Self::EVerdictunwanted,
                9 => Self::EVerdictuncommon,
                10 => Self::EVerdictunrecognized,
                11 => Self::EDangerousprefoff,
                12 => Self::EDangeroushostprefoff,
                13 => Self::EUnwantedprefoff,
                14 => Self::EUncommonprefoff,
                15 => Self::ENetworkerror,
                16 => Self::ERemotelookupdisabled,
                17 => Self::EInternalerror,
                18 => Self::EDpdisabled,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ReasonLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ENotset => "NotSet",
                Self::ELocalwhitelist => "LocalWhitelist",
                Self::ELocalblocklist => "LocalBlocklist",
                Self::ENonbinaryfile => "NonBinaryFile",
                Self::EVerdictsafe => "VerdictSafe",
                Self::EVerdictunknown => "VerdictUnknown",
                Self::EVerdictdangerous => "VerdictDangerous",
                Self::EVerdictdangeroushost => "VerdictDangerousHost",
                Self::EVerdictunwanted => "VerdictUnwanted",
                Self::EVerdictuncommon => "VerdictUncommon",
                Self::EVerdictunrecognized => "VerdictUnrecognized",
                Self::EDangerousprefoff => "DangerousPrefOff",
                Self::EDangeroushostprefoff => "DangerousHostPrefOff",
                Self::EUnwantedprefoff => "UnwantedPrefOff",
                Self::EUncommonprefoff => "UncommonPrefOff",
                Self::ENetworkerror => "NetworkError",
                Self::ERemotelookupdisabled => "RemoteLookupDisabled",
                Self::EInternalerror => "InternalError",
                Self::EDpdisabled => "DPDisabled",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.reason
    ///
    /// The reason application reputation service blocks or allows the download.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram APPLICATION_REPUTATION_REASON.
    pub static reason: Lazy<LabeledMetric<LabeledCounterMetric, ReasonLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "reason".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5203), meta, Some(vec![::std::borrow::Cow::from("DPDisabled"), ::std::borrow::Cow::from("DangerousHostPrefOff"), ::std::borrow::Cow::from("DangerousPrefOff"), ::std::borrow::Cow::from("InternalError"), ::std::borrow::Cow::from("LocalBlocklist"), ::std::borrow::Cow::from("LocalWhitelist"), ::std::borrow::Cow::from("NetworkError"), ::std::borrow::Cow::from("NonBinaryFile"), ::std::borrow::Cow::from("NotSet"), ::std::borrow::Cow::from("RemoteLookupDisabled"), ::std::borrow::Cow::from("UncommonPrefOff"), ::std::borrow::Cow::from("UnwantedPrefOff"), ::std::borrow::Cow::from("VerdictDangerous"), ::std::borrow::Cow::from("VerdictDangerousHost"), ::std::borrow::Cow::from("VerdictSafe"), ::std::borrow::Cow::from("VerdictUncommon"), ::std::borrow::Cow::from("VerdictUnknown"), ::std::borrow::Cow::from("VerdictUnrecognized"), ::std::borrow::Cow::from("VerdictUnwanted")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.remote_lookup_response_time
    ///
    /// Server response time to remote lookup request (ms).
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram APPLICATION_REPUTATION_REMOTE_LOOKUP_RESPONSE_TIME.
    pub static remote_lookup_response_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "remote_lookup_response_time".into(),
                category: "application_reputation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5204), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum RemoteLookupTimeoutLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for RemoteLookupTimeoutLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RemoteLookupTimeoutLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.remote_lookup_timeout
    ///
    /// Recorded when application reputation remote lookup is performed, `true` is recorded if the lookup times out.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram APPLICATION_REPUTATION_REMOTE_LOOKUP_TIMEOUT.
    pub static remote_lookup_timeout: Lazy<LabeledMetric<LabeledCounterMetric, RemoteLookupTimeoutLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "remote_lookup_timeout".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5205), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.server
    ///
    /// Status of the application reputation remote lookup (0=OK, 1=failed, 2=invalid protobuf response)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram APPLICATION_REPUTATION_SERVER.
    pub static server: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "server".into(),
                category: "application_reputation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5206), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum Server2Label {
        EErrothers = 0,
        EResponsevalid = 1,
        EFailgetchannel = 2,
        EFailgetresponse = 3,
        EHttp1xx = 4,
        EHttp2xx = 5,
        EHttp204 = 6,
        EHttp3xx = 7,
        EHttp400 = 8,
        EHttp4xx = 9,
        EHttp403 = 10,
        EHttp404 = 11,
        EHttp408 = 12,
        EHttp413 = 13,
        EHttp5xx = 14,
        EHttp502504511 = 15,
        EHttp503 = 16,
        EHttp505 = 17,
        EHttpothers = 18,
        EErralreadyconnected = 19,
        EErrnotconnected = 20,
        EErrconnectionrefused = 21,
        EErrnettimeout = 22,
        EErroffline = 23,
        EErrportaccess = 24,
        EErrnetreset = 25,
        EErrnetinterrupt = 26,
        EErrproxyconnection = 27,
        EErrnetpartial = 28,
        EErrnetinadequate = 29,
        EErrunknownhost = 30,
        EErrdnslookupqueue = 31,
        EErrunknownproxyhost = 32,
        __Other__,
    }
    impl From<u16> for Server2Label {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EErrothers,
                1 => Self::EResponsevalid,
                2 => Self::EFailgetchannel,
                3 => Self::EFailgetresponse,
                4 => Self::EHttp1xx,
                5 => Self::EHttp2xx,
                6 => Self::EHttp204,
                7 => Self::EHttp3xx,
                8 => Self::EHttp400,
                9 => Self::EHttp4xx,
                10 => Self::EHttp403,
                11 => Self::EHttp404,
                12 => Self::EHttp408,
                13 => Self::EHttp413,
                14 => Self::EHttp5xx,
                15 => Self::EHttp502504511,
                16 => Self::EHttp503,
                17 => Self::EHttp505,
                18 => Self::EHttpothers,
                19 => Self::EErralreadyconnected,
                20 => Self::EErrnotconnected,
                21 => Self::EErrconnectionrefused,
                22 => Self::EErrnettimeout,
                23 => Self::EErroffline,
                24 => Self::EErrportaccess,
                25 => Self::EErrnetreset,
                26 => Self::EErrnetinterrupt,
                27 => Self::EErrproxyconnection,
                28 => Self::EErrnetpartial,
                29 => Self::EErrnetinadequate,
                30 => Self::EErrunknownhost,
                31 => Self::EErrdnslookupqueue,
                32 => Self::EErrunknownproxyhost,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for Server2Label {
        fn into(self) -> &'static str {
            match self {
                Self::EErrothers => "ErrOthers",
                Self::EResponsevalid => "ResponseValid",
                Self::EFailgetchannel => "FailGetChannel",
                Self::EFailgetresponse => "FailGetResponse",
                Self::EHttp1xx => "HTTP1xx",
                Self::EHttp2xx => "HTTP2xx",
                Self::EHttp204 => "HTTP204",
                Self::EHttp3xx => "HTTP3xx",
                Self::EHttp400 => "HTTP400",
                Self::EHttp4xx => "HTTP4xx",
                Self::EHttp403 => "HTTP403",
                Self::EHttp404 => "HTTP404",
                Self::EHttp408 => "HTTP408",
                Self::EHttp413 => "HTTP413",
                Self::EHttp5xx => "HTTP5xx",
                Self::EHttp502504511 => "HTTP502_504_511",
                Self::EHttp503 => "HTTP503",
                Self::EHttp505 => "HTTP505",
                Self::EHttpothers => "HTTPOthers",
                Self::EErralreadyconnected => "ErrAlreadyConnected",
                Self::EErrnotconnected => "ErrNotConnected",
                Self::EErrconnectionrefused => "ErrConnectionRefused",
                Self::EErrnettimeout => "ErrNetTimeout",
                Self::EErroffline => "ErrOffline",
                Self::EErrportaccess => "ErrPortAccess",
                Self::EErrnetreset => "ErrNetReset",
                Self::EErrnetinterrupt => "ErrNetInterrupt",
                Self::EErrproxyconnection => "ErrProxyConnection",
                Self::EErrnetpartial => "ErrNetPartial",
                Self::EErrnetinadequate => "ErrNetInadequate",
                Self::EErrunknownhost => "ErrUnknownHost",
                Self::EErrdnslookupqueue => "ErrDNSLookupQueue",
                Self::EErrunknownproxyhost => "ErrUnknownProxyHost",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.server_2
    ///
    /// Network status of the application reputation remote lookup
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram APPLICATION_REPUTATION_SERVER_2.
    pub static server_2: Lazy<LabeledMetric<LabeledCounterMetric, Server2Label>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "server_2".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5207), meta, Some(vec![::std::borrow::Cow::from("ErrAlreadyConnected"), ::std::borrow::Cow::from("ErrConnectionRefused"), ::std::borrow::Cow::from("ErrDNSLookupQueue"), ::std::borrow::Cow::from("ErrNetInadequate"), ::std::borrow::Cow::from("ErrNetInterrupt"), ::std::borrow::Cow::from("ErrNetPartial"), ::std::borrow::Cow::from("ErrNetReset"), ::std::borrow::Cow::from("ErrNetTimeout"), ::std::borrow::Cow::from("ErrNotConnected"), ::std::borrow::Cow::from("ErrOffline"), ::std::borrow::Cow::from("ErrOthers"), ::std::borrow::Cow::from("ErrPortAccess"), ::std::borrow::Cow::from("ErrProxyConnection"), ::std::borrow::Cow::from("ErrUnknownHost"), ::std::borrow::Cow::from("ErrUnknownProxyHost"), ::std::borrow::Cow::from("FailGetChannel"), ::std::borrow::Cow::from("FailGetResponse"), ::std::borrow::Cow::from("HTTP1xx"), ::std::borrow::Cow::from("HTTP204"), ::std::borrow::Cow::from("HTTP2xx"), ::std::borrow::Cow::from("HTTP3xx"), ::std::borrow::Cow::from("HTTP400"), ::std::borrow::Cow::from("HTTP403"), ::std::borrow::Cow::from("HTTP404"), ::std::borrow::Cow::from("HTTP408"), ::std::borrow::Cow::from("HTTP413"), ::std::borrow::Cow::from("HTTP4xx"), ::std::borrow::Cow::from("HTTP502_504_511"), ::std::borrow::Cow::from("HTTP503"), ::std::borrow::Cow::from("HTTP505"), ::std::borrow::Cow::from("HTTP5xx"), ::std::borrow::Cow::from("HTTPOthers"), ::std::borrow::Cow::from("ResponseValid")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.server_verdict
    ///
    /// Application reputation remote verdict (0=SAFE, 1=DANGEROUS, 2=UNCOMMON, 3=POTENTIALLY_UNWANTED, 4=DANGEROUS_HOST, 5=UNKNOWN)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram APPLICATION_REPUTATION_SERVER_VERDICT.
    pub static server_verdict: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "server_verdict".into(),
                category: "application_reputation".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5208), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ShouldBlockLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ShouldBlockLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ShouldBlockLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from application_reputation.should_block
    ///
    /// Overall (local or remote) application reputation verdict (shouldBlock=false is OK).
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram APPLICATION_REPUTATION_SHOULD_BLOCK.
    pub static should_block: Lazy<LabeledMetric<LabeledCounterMetric, ShouldBlockLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "should_block".into(),
                    category: "application_reputation".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5209), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod characteristics {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.any_pointer_type
    ///
    /// Union of pointers available. We apply union to determine if the user have both coarse and fine pointer.
    pub static any_pointer_type: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "any_pointer_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5210), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_channels
    ///
    /// Audio sampling rate
    pub static audio_channels: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_channels".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5211), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_fingerprint
    ///
    /// Audio fingerprint of the user. A float number multiplied by 10e7.
    pub static audio_fingerprint: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_fingerprint".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5212), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_frames
    ///
    /// Audio frames
    pub static audio_frames: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_frames".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5213), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.audio_rate
    ///
    /// Audio sampling rate
    pub static audio_rate: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "audio_rate".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5214), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_height
    ///
    /// Available height property
    pub static avail_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avail_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5215), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.avail_width
    ///
    /// Available width property
    pub static avail_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "avail_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5216), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.build_date
    ///
    /// Firefox build's build date in unix time
    pub static build_date: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_date".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5217), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.camera_count
    ///
    /// Number of cameras available on the device.
    pub static camera_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "camera_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5218), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvas_dpr
    ///
    /// The device pixel ratio of the canvas rendering context
    pub static canvas_dpr: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvas_dpr".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5219), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvas_feature_status
    ///
    /// Status of and failure id (if failed) of ACCELERATED_CANVAS2D feature
    pub static canvas_feature_status: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvas_feature_status".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5220), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata1
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a simple organge box and used as a control image
    pub static canvasdata1: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5221), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata10
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped with Firefox rendered with italics, rotation, and shadow-blur.
    pub static canvasdata10: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata10".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5222), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata10software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped with Firefox rendered with italics, rotation, and shadow-blur.
    pub static canvasdata10software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata10software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5223), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata11_webgl
    ///
    /// The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT is a RGB gradient cube.
    pub static canvasdata11_webgl: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata11_webgl".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5224), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata11_webglsoftware
    ///
    /// The sha1 hash of an image rendered on a WebGL canvas (instead of Canvas2D). IT is a RGB gradient cube.
    pub static canvasdata11_webglsoftware: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata11_webglsoftware".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5225), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata12_fingerprintjs1
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs' text canvas
    pub static canvasdata12_fingerprintjs1: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata12_fingerprintjs1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5226), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata12_fingerprintjs1software
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs' text canvas
    pub static canvasdata12_fingerprintjs1software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata12_fingerprintjs1software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5227), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata13_fingerprintjs2
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs' geometry canvas
    pub static canvasdata13_fingerprintjs2: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata13_fingerprintjs2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5228), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata13_fingerprintjs2software
    ///
    /// The sha1 hash of an image rendered on a canvas, it is a copy of fingerprintjs' geometry canvas
    pub static canvasdata13_fingerprintjs2software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata13_fingerprintjs2software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5229), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata1software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a simple organge box and used as a control image
    pub static canvasdata1software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata1software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5230), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata2
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a bordered triage, and used to test point interpolation
    pub static canvasdata2: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5231), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata2software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a bordered triage, and used to test point interpolation
    pub static canvasdata2software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata2software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5232), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata3
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a stretched photographic image, used to test image operations.
    pub static canvasdata3: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata3".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5233), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata3software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a stretched photographic image, used to test image operations.
    pub static canvasdata3software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata3software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5234), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata4
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-transparenct overlapping squares, used to test transparency and point interpolation.
    pub static canvasdata4: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata4".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5235), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata4software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is two rotated, semi-transparenct overlapping squares, used to test transparency and point interpolation.
    pub static canvasdata4software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata4software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5236), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata5
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font rendered normally.
    pub static canvasdata5: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata5".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5237), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata5software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font rendered normally.
    pub static canvasdata5software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata5software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5238), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata6
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata6: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata6".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5239), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata6software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a local font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata6software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata6software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5240), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata7
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font rendered normally.
    pub static canvasdata7: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata7".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5241), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata7software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font rendered normally.
    pub static canvasdata7software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata7software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5242), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata8
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata8: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata8".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5243), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata8software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a system-ui font rendered with italics, rotation, and shadow-blur.
    pub static canvasdata8software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata8software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5244), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata9
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped with Firefox rendered normally.
    pub static canvasdata9: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata9".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5245), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.canvasdata9software
    ///
    /// The sha1 hash of an image rendered on a canvas. The image is a font shipped with Firefox rendered normally.
    pub static canvasdata9software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvasdata9software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5246), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.changed_media_prefs
    ///
    /// Changed media prefs and their values.
    pub static changed_media_prefs: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed_media_prefs".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5247), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.channel
    ///
    /// Firefox build channel
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "channel".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5248), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.client_identifier
    ///
    /// A unique identifier for a user, not the same as the normal Telemetry client_id, but needed so we can deduplicate reports and only take the most recent one per user.
    pub static client_identifier: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_identifier".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["deletion-request".into(), "user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(5249), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolor
    ///
    /// The CSS system-color Accentcolor.
    pub static color_accentcolor: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_accentcolor".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5250), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_accentcolortext
    ///
    /// The CSS system-color Accentcolortext.
    pub static color_accentcolortext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_accentcolortext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5251), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvas
    ///
    /// The CSS system-color Canvas.
    pub static color_canvas: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_canvas".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5252), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_canvastext
    ///
    /// The CSS system-color Canvastext.
    pub static color_canvastext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_canvastext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5253), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlight
    ///
    /// The CSS system-color Highlight.
    pub static color_highlight: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_highlight".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5254), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_highlighttext
    ///
    /// The CSS system-color Highlighttext.
    pub static color_highlighttext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_highlighttext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5255), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_scheme
    ///
    /// The Color Scheme used for Content, from ContentPrefs() Preference Sheet.
    pub static color_scheme: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_scheme".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5256), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditem
    ///
    /// The CSS system-color Selecteditem.
    pub static color_selecteditem: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_selecteditem".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5257), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.color_selecteditemtext
    ///
    /// The CSS system-color Selecteditemtext.
    pub static color_selecteditemtext: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "color_selecteditemtext".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5258), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.cpu_arch
    ///
    /// Arch of the user's device
    pub static cpu_arch: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cpu_arch".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5259), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.cpu_model
    ///
    /// CPU model of the user's device
    pub static cpu_model: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cpu_model".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5260), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.errors
    ///
    /// Errors occured on C++ side of data collection
    pub static errors: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "errors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5261), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_default_group
    ///
    /// The value of the font.default.<default language group> pref
    pub static font_default_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5262), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_modified
    ///
    /// The number of other modified font.default prefs.
    pub static font_default_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5263), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_default_western
    ///
    /// The value of the font.default.x-western pref
    pub static font_default_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_default_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5264), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_default_group
    ///
    /// The value of the font.minimum-size.<default language group> pref
    pub static font_minimum_size_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5265), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_modified
    ///
    /// The number of other modified font.minimum-size prefs.
    pub static font_minimum_size_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5266), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_minimum_size_western
    ///
    /// The value of the font.minimum-size.x-western pref
    pub static font_minimum_size_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_minimum_size_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5267), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_cursive_modified
    ///
    /// The number of modified font.name-list.cursive. prefs.
    pub static font_name_list_cursive_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_cursive_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5268), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_emoji_modified
    ///
    /// Whether the pref font.name-list.emoji was modified.
    pub static font_name_list_emoji_modified: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_emoji_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5269), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_monospace_modified
    ///
    /// The number of modified font.name-list.monospace. prefs.
    pub static font_name_list_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5270), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_sans_serif_modified
    ///
    /// The number of modified font.name-list.sans-serif. prefs.
    pub static font_name_list_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_sans_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5271), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_list_serif_modified
    ///
    /// The number of modified font.name-list.serif. prefs.
    pub static font_name_list_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_list_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5272), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_default_group
    ///
    /// The value of the font.name.monospace.<default language group> pref
    pub static font_name_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5273), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_modified
    ///
    /// The number of other modified font.name.monospace prefs.
    pub static font_name_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5274), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_monospace_western
    ///
    /// The value of the font.name.monospace.x-western pref
    pub static font_name_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_monospace_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5275), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_default_group
    ///
    /// The value of the font.name.sans-serif.<default language group> pref
    pub static font_name_sans_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5276), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_modified
    ///
    /// The number of other modified font.name.sans-serif prefs.
    pub static font_name_sans_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5277), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_sans_serif_western
    ///
    /// The value of the font.name.sans-serif.x-western pref
    pub static font_name_sans_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_sans_serif_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5278), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_default_group
    ///
    /// The value of the font.name.serif.<default language group> pref
    pub static font_name_serif_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5279), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_modified
    ///
    /// The number of other modified font.name.serif prefs.
    pub static font_name_serif_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5280), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_name_serif_western
    ///
    /// The value of the font.name.serif.x-western pref
    pub static font_name_serif_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_name_serif_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5281), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_default_group
    ///
    /// The value of the font.size.monospace.<default language group> pref
    pub static font_size_monospace_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5282), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_modified
    ///
    /// The number of other modified font.size.monospace prefs.
    pub static font_size_monospace_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5283), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_monospace_western
    ///
    /// The value of the font.size.monospace.x-western pref
    pub static font_size_monospace_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_monospace_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5284), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_default_group
    ///
    /// The value of the font.size.variable.<default language group> pref
    pub static font_size_variable_default_group: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_default_group".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5285), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_modified
    ///
    /// The number of other modified font.size.variable prefs.
    pub static font_size_variable_modified: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_modified".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5286), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.font_size_variable_western
    ///
    /// The value of the font.size.variable.x-western pref
    pub static font_size_variable_western: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "font_size_variable_western".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5287), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_fpjs_allowlisted
    ///
    /// SHA256 of allowlisted fonts queried by FPJS
    pub static fonts_fpjs_allowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_fpjs_allowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5288), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_fpjs_nonallowlisted
    ///
    /// SHA256 of non-allowlisted fonts queried by FPJS
    pub static fonts_fpjs_nonallowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_fpjs_nonallowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5289), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_variant_a_allowlisted
    ///
    /// SHA256 of allowlisted fonts queried of variant A
    pub static fonts_variant_a_allowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_variant_a_allowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5290), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_variant_a_nonallowlisted
    ///
    /// SHA256 of non-allowlisted fonts queried of variant A
    pub static fonts_variant_a_nonallowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_variant_a_nonallowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5291), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_variant_b_allowlisted
    ///
    /// SHA256 of allowlisted fonts queried of variant B
    pub static fonts_variant_b_allowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_variant_b_allowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5292), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.fonts_variant_b_nonallowlisted
    ///
    /// SHA256 of non-allowlisted fonts queried of variant B
    pub static fonts_variant_b_nonallowlisted: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fonts_variant_b_nonallowlisted".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5293), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gamepads
    ///
    /// The information of the gamepads inserted on the user device. Each string represents one gamepad. We use a JSON array to describe a gamepad, every value represents one property of the gamepad. Following are the details:
    ///   index 0: The ID of the game pad
    ///   index 1: Which hand for the gamepad.
    ///   index 2: Number of buttons
    ///   index 3: Number of axes
    ///   index 4: Number of haptics
    ///   index 5: Number of lights
    ///   index 6: Number of touches
    pub static gamepads: Lazy<StringListMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gamepads".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringListMetric::new(BaseMetricId(5294), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_context_type
    ///
    /// The type of the GL context (EGL, GLX, WGL, etc).
    pub static gl2_context_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_context_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5295), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_context_type_software
    ///
    /// The type of the GL context (EGL, GLX, WGL, etc).
    pub static gl2_context_type_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_context_type_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5296), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_extensions
    ///
    /// The list of OpenGL extensions supported by the user's system.
    pub static gl2_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5297), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_extensions_raw
    ///
    /// The raw list of OpenGL extensions supported by the user's system.
    pub static gl2_extensions_raw: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_extensions_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5298), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_extensions_raw_software
    ///
    /// The raw list of OpenGL extensions supported by the user's system.
    pub static gl2_extensions_raw_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_extensions_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5299), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_extensions_software
    ///
    /// The list of OpenGL extensions supported by the user's system.
    pub static gl2_extensions_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_extensions_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5300), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_fragment_shader
    ///
    /// Hash of the transformed source of the fragment shader.
    pub static gl2_fragment_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_fragment_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5301), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_fragment_shader_software
    ///
    /// Hash of the transformed source of the fragment shader.
    pub static gl2_fragment_shader_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_fragment_shader_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5302), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_minimal_source
    ///
    /// Transformed source of the minimal shader.
    pub static gl2_minimal_source: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_minimal_source".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5303), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_minimal_source_software
    ///
    /// Transformed source of the minimal shader.
    pub static gl2_minimal_source_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_minimal_source_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5304), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_params
    ///
    /// The list of GL parameters of GL2.
    pub static gl2_params: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_params".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5305), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_params_extensions
    ///
    /// The list of GL parameters of the extensions.
    pub static gl2_params_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_params_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5306), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_params_extensions_software
    ///
    /// The list of GL parameters of the extensions.
    pub static gl2_params_extensions_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_params_extensions_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5307), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_params_software
    ///
    /// The list of GL parameters of GL2.
    pub static gl2_params_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_params_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5308), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_precision_fragment
    ///
    /// Precisions of the fragment shader.
    pub static gl2_precision_fragment: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_precision_fragment".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5309), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_precision_fragment_software
    ///
    /// Precisions of the fragment shader.
    pub static gl2_precision_fragment_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_precision_fragment_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5310), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_precision_vertex
    ///
    /// Precisions of the vertex shader.
    pub static gl2_precision_vertex: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_precision_vertex".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5311), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_precision_vertex_software
    ///
    /// Precisions of the vertex shader.
    pub static gl2_precision_vertex_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_precision_vertex_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5312), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_renderer
    ///
    /// The OpenGL renderer string.
    pub static gl2_renderer: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_renderer".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5313), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_renderer_raw
    ///
    /// The raw OpenGL renderer string.
    pub static gl2_renderer_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_renderer_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5314), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_renderer_raw_software
    ///
    /// The raw OpenGL renderer string.
    pub static gl2_renderer_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_renderer_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5315), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_renderer_software
    ///
    /// The OpenGL renderer string.
    pub static gl2_renderer_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_renderer_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5316), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vendor
    ///
    /// The OpenGL vendor string.
    pub static gl2_vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vendor".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5317), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vendor_raw
    ///
    /// The raw OpenGL vendor string.
    pub static gl2_vendor_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vendor_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5318), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vendor_raw_software
    ///
    /// The raw OpenGL vendor string.
    pub static gl2_vendor_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vendor_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5319), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vendor_software
    ///
    /// The OpenGL vendor string.
    pub static gl2_vendor_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vendor_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5320), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_version_raw
    ///
    /// The raw OpenGL version string.
    pub static gl2_version_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_version_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5321), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_version_raw_software
    ///
    /// The raw OpenGL version string.
    pub static gl2_version_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_version_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5322), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vertex_shader
    ///
    /// Hash of the transformed source of the vertex shader.
    pub static gl2_vertex_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vertex_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5323), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl2_vertex_shader_software
    ///
    /// Hash of the transformed source of the vertex shader.
    pub static gl2_vertex_shader_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl2_vertex_shader_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5324), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_context_type
    ///
    /// The type of the GL context (EGL, GLX, WGL, etc).
    pub static gl_context_type: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_context_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5325), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_context_type_software
    ///
    /// The type of the GL context (EGL, GLX, WGL, etc).
    pub static gl_context_type_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_context_type_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5326), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions
    ///
    /// The list of OpenGL extensions supported by the user's system.
    pub static gl_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5327), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions_raw
    ///
    /// The raw list of OpenGL extensions supported by the user's system.
    pub static gl_extensions_raw: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5328), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions_raw_software
    ///
    /// The raw list of OpenGL extensions supported by the user's system.
    pub static gl_extensions_raw_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5329), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_extensions_software
    ///
    /// The list of OpenGL extensions supported by the user's system.
    pub static gl_extensions_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_extensions_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5330), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_fragment_shader
    ///
    /// Hash of the transformed source of the fragment shader.
    pub static gl_fragment_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_fragment_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5331), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_fragment_shader_software
    ///
    /// Hash of the transformed source of the fragment shader.
    pub static gl_fragment_shader_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_fragment_shader_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5332), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_minimal_source
    ///
    /// Transformed source of the minimal shader.
    pub static gl_minimal_source: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_minimal_source".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5333), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_minimal_source_software
    ///
    /// Transformed source of the minimal shader.
    pub static gl_minimal_source_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_minimal_source_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5334), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params
    ///
    /// The list of GL parameters of GL1.
    pub static gl_params: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5335), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_extensions
    ///
    /// The list of GL parameters of the extensions.
    pub static gl_params_extensions: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_extensions".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5336), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_extensions_software
    ///
    /// The list of GL parameters of the extensions.
    pub static gl_params_extensions_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_extensions_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5337), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_params_software
    ///
    /// The list of GL parameters of GL1.
    pub static gl_params_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_params_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5338), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_fragment
    ///
    /// Precisions of the fragment shader.
    pub static gl_precision_fragment: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_fragment".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5339), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_fragment_software
    ///
    /// Precisions of the fragment shader.
    pub static gl_precision_fragment_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_fragment_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5340), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_vertex
    ///
    /// Precisions of the vertex shader.
    pub static gl_precision_vertex: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_vertex".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5341), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_precision_vertex_software
    ///
    /// Precisions of the vertex shader.
    pub static gl_precision_vertex_software: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_precision_vertex_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5342), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer
    ///
    /// The OpenGL renderer string.
    pub static gl_renderer: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5343), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer_raw
    ///
    /// The raw OpenGL renderer string.
    pub static gl_renderer_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5344), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer_raw_software
    ///
    /// The raw OpenGL renderer string.
    pub static gl_renderer_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5345), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_renderer_software
    ///
    /// The OpenGL renderer string.
    pub static gl_renderer_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_renderer_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5346), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor
    ///
    /// The OpenGL vendor string.
    pub static gl_vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5347), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor_raw
    ///
    /// The raw OpenGL vendor string.
    pub static gl_vendor_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5348), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor_raw_software
    ///
    /// The raw OpenGL vendor string.
    pub static gl_vendor_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5349), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vendor_software
    ///
    /// The OpenGL vendor string.
    pub static gl_vendor_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vendor_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5350), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_version_raw
    ///
    /// The raw OpenGL version string.
    pub static gl_version_raw: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_version_raw".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5351), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_version_raw_software
    ///
    /// The raw OpenGL version string.
    pub static gl_version_raw_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_version_raw_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5352), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vertex_shader
    ///
    /// Hash of the transformed source of the vertex shader.
    pub static gl_vertex_shader: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vertex_shader".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5353), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.gl_vertex_shader_software
    ///
    /// Hash of the transformed source of the vertex shader.
    pub static gl_vertex_shader_software: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gl_vertex_shader_software".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5354), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.group_count
    ///
    /// Number of device groups reported by the device.
    pub static group_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "group_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5355), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.group_count_wo_speakers
    ///
    /// Number of device groups without speakers reported by the device.
    pub static group_count_wo_speakers: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "group_count_wo_speakers".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5356), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.ice_order
    ///
    /// Unique ICE foundations occurrence count
    pub static ice_order: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ice_order".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5357), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.ice_sd
    ///
    /// ICE foundation discovery latency standard deviation sum multiplied by 1000
    pub static ice_sd: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ice_sd".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5358), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_height
    ///
    /// Inner height of user's browser.
    pub static inner_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inner_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5359), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inner_width
    ///
    /// Inner width of user's browser.
    pub static inner_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inner_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5360), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.intl_locale
    ///
    /// Locale information provided by Intl
    pub static intl_locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "intl_locale".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5361), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.inverted_colors
    ///
    /// What LookAndFeel(InvertedColors) reports.
    pub static inverted_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "inverted_colors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5362), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.js_errors
    ///
    /// Errors occured on JavaScript side of data collection
    pub static js_errors: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "js_errors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5363), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.keyboard_layout
    ///
    /// Name of the current keyboard layout.
    pub static keyboard_layout: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "keyboard_layout".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5364), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.languages
    ///
    /// Languages the user set. Returns intl.accept_languages pref, if it is empty, returns the first matched OS's language or the default language.
    pub static languages: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "languages".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5365), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.machine_model_name
    ///
    /// Machine model name
    pub static machine_model_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "machine_model_name".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5366), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.math_ops
    ///
    /// Result of fingerprintable math operations
    pub static math_ops: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "math_ops".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5367), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.math_ops_fdlibm
    ///
    /// Windows only fdlibm math operation results
    pub static math_ops_fdlibm: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "math_ops_fdlibm".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5368), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml1
    ///
    /// Width of the drawn MathML element
    pub static mathml1: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5369), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml10
    ///
    /// Width of the drawn MathML element
    pub static mathml10: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml10".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5370), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml2
    ///
    /// Width of the drawn MathML element
    pub static mathml2: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml2".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5371), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml3
    ///
    /// Width of the drawn MathML element
    pub static mathml3: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml3".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5372), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml4
    ///
    /// Width of the drawn MathML element
    pub static mathml4: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml4".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5373), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml5
    ///
    /// Width of the drawn MathML element
    pub static mathml5: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml5".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5374), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml6
    ///
    /// Width of the drawn MathML element
    pub static mathml6: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml6".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5375), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml7
    ///
    /// Width of the drawn MathML element
    pub static mathml7: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml7".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5376), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml8
    ///
    /// Width of the drawn MathML element
    pub static mathml8: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml8".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5377), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.mathml9
    ///
    /// Width of the drawn MathML element
    pub static mathml9: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mathml9".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5378), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.max_touch_points
    ///
    /// The number of touch points we will report to the web. On Android, this is based on Android's FEATURE_TOUCHSCREEN* constants - Mozilla caps this at 5 as Android stops distinguishing between numbers greater than 5.  On Windows this comes from the SM_MAXIMUMTOUCHES System Metric.
    pub static max_touch_points: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_touch_points".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5379), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_h264
    ///
    /// Levels of support for H264 codec.
    pub static media_capabilities_h264: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_h264".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5380), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_not_efficient
    ///
    /// Which, if any, media types are not power efficient.
    pub static media_capabilities_not_efficient: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_not_efficient".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5381), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_not_smooth
    ///
    /// Which, if any, media types are not smooth.
    pub static media_capabilities_not_smooth: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_not_smooth".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5382), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.media_capabilities_unsupported
    ///
    /// Which, if any, media types are not supported.
    pub static media_capabilities_unsupported: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "media_capabilities_unsupported".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5383), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.microphone_count
    ///
    /// Number of microphones available on the device.
    pub static microphone_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "microphone_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5384), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.missing_fonts
    ///
    /// If a Font List is available for the user's platform, this string_list contains the fonts that are missing from the user's computer.
    pub static missing_fonts: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "missing_fonts".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5385), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.monochrome
    ///
    /// Whether the user's device is monochrome
    pub static monochrome: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "monochrome".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5386), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.motion_decimals
    ///
    /// devicemotion event's decimal places count
    pub static motion_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "motion_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5387), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.motion_freq
    ///
    /// devicemotion event's frequency
    pub static motion_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "motion_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5388), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_decimals
    ///
    /// deviceorientation event's decimal places count
    pub static orientation_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientation_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5389), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientation_freq
    ///
    /// deviceorientation event's frequency
    pub static orientation_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientation_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5390), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientationabs_decimals
    ///
    /// deviceorientationabsolute event's decimal places count
    pub static orientationabs_decimals: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientationabs_decimals".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5391), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.orientationabs_freq
    ///
    /// deviceorientationabsolute event's frequency
    pub static orientationabs_freq: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "orientationabs_freq".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5392), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.os_name
    ///
    /// User's OS name
    pub static os_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_name".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5393), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.os_version
    ///
    /// User's OS version
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_version".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5394), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.oscpu
    ///
    /// User's OS CPU reported by the navigator
    pub static oscpu: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "oscpu".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5395), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_height
    ///
    /// Outer height of user's browser.
    pub static outer_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "outer_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5396), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.outer_width
    ///
    /// Outer width of user's browser.
    pub static outer_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "outer_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5397), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pdf_viewer
    ///
    /// PDF viewer support reported by the navigator
    pub static pdf_viewer: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pdf_viewer".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5398), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pixel_ratio
    ///
    /// The value of window.devicePixelRatio
    pub static pixel_ratio: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pixel_ratio".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5399), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.platform
    ///
    /// Platform reported by the navigator
    pub static platform: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "platform".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5400), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_height
    ///
    /// Height of user's pointer
    pub static pointer_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5401), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_pressure
    ///
    /// Pressure of user's pointer
    pub static pointer_pressure: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_pressure".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5402), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tangentinal_pressure
    ///
    /// Tangential Pressure of user's pointer
    pub static pointer_tangentinal_pressure: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tangentinal_pressure".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5403), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tiltx
    ///
    /// TiltX of user's pointer
    pub static pointer_tiltx: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tiltx".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5404), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_tilty
    ///
    /// TiltY of user's pointer
    pub static pointer_tilty: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_tilty".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5405), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_twist
    ///
    /// Twist of user's pointer
    pub static pointer_twist: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_twist".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5406), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_type
    ///
    /// Pointer type of the user's primary pointer device.
    pub static pointer_type: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_type".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5407), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.pointer_width
    ///
    /// Width of user's pointer
    pub static pointer_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pointer_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5408), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_contrast
    ///
    /// What Gecko_MediaFeatures_PrefersContrast reports for a ContentDocument
    pub static prefers_contrast: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_contrast".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5409), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_motion
    ///
    /// What LookAndFeel(PrefersReducedMotion) reports.
    pub static prefers_reduced_motion: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_reduced_motion".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5410), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefers_reduced_transparency
    ///
    /// What LookAndFeel(PrefersReducedTransparency) reports.
    pub static prefers_reduced_transparency: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefers_reduced_transparency".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5411), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_block_popups
    ///
    /// Block pop-up windows (The dom.disable_open_during_load pref)
    pub static prefs_block_popups: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_block_popups".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5412), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_browser_display_use_document_fonts
    ///
    /// Allow pages to choose their own fonts.
    pub static prefs_browser_display_use_document_fonts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_browser_display_use_document_fonts".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5413), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_autoscroll
    ///
    /// Use autoscrolling
    pub static prefs_general_autoscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_general_autoscroll".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5414), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_general_smoothscroll
    ///
    /// Use smooth scrolling
    pub static prefs_general_smoothscroll: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_general_smoothscroll".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5415), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_intl_accept_languages
    ///
    /// Value of the intl.accept_languages pref.
    pub static prefs_intl_accept_languages: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_intl_accept_languages".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5416), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_media_eme_enabled
    ///
    /// Value of the media.eme.enabled pref.
    pub static prefs_media_eme_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_media_eme_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5417), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_network_cookie_cookiebehavior
    ///
    /// Value of the network.cookie.cookieBehavior pref.
    pub static prefs_network_cookie_cookiebehavior: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_network_cookie_cookiebehavior".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5418), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_overlay_scrollbars
    ///
    /// Use overlay scrollbars (or otherwise "Always show scrollbars")
    pub static prefs_overlay_scrollbars: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_overlay_scrollbars".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5419), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_donottrackheader_enabled
    ///
    /// Sending "do not track" HTTP header
    pub static prefs_privacy_donottrackheader_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_privacy_donottrackheader_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5420), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_privacy_globalprivacycontrol_enabled
    ///
    /// Sending "global privacy control" HTTP header
    pub static prefs_privacy_globalprivacycontrol_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_privacy_globalprivacycontrol_enabled".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5421), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.prefs_zoom_text_only
    ///
    /// Text-only zoom enabled (vs. full-zoom)
    pub static prefs_zoom_text_only: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "prefs_zoom_text_only".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5422), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.processor_count
    ///
    /// Number of processors.
    pub static processor_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "processor_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5423), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_height
    ///
    /// Screen height from a window.
    pub static screen_height: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screen_height".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5424), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screen_width
    ///
    /// Screen width from a window.
    pub static screen_width: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screen_width".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5425), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.screens
    ///
    /// JSON string of screen properties
    pub static screens: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "screens".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5426), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.size_mode
    ///
    /// Whether window is maximized, minimized, normal or fullscreen
    pub static size_mode: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "size_mode".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5427), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.speaker_count
    ///
    /// Number of speakers available on the device.
    pub static speaker_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speaker_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5428), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.submission_schema
    ///
    /// An incrementing constant that represents the current schema/source of the data present in a ping. By referring to this value in a ping, one can know for certain the provenance of other data present in the ping, and what data may or may not be present.
    pub static submission_schema: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_schema".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5429), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.system_locale
    ///
    /// The locale used by the host OS for localization.
    pub static system_locale: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "system_locale".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5430), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.target_frame_rate
    ///
    /// The target frame rate in frames-per-second.
    pub static target_frame_rate: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "target_frame_rate".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5431), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.text_anti_aliasing
    ///
    /// Font anti aliasing level
    pub static text_anti_aliasing: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "text_anti_aliasing".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5432), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.timezone
    ///
    /// The the current timezone of the system
    pub static timezone: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "timezone".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5433), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.touch_rotation_angle
    ///
    /// Rotation angle of user's touch
    pub static touch_rotation_angle: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "touch_rotation_angle".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5434), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.use_document_colors
    ///
    /// This is the derived PreferenceSheet::Prefs::mUseDocumentColors value.
    pub static use_document_colors: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "use_document_colors".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5435), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.user_agent
    ///
    /// User agent string
    pub static user_agent: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "user_agent".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5436), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.using_accelerated_canvas
    ///
    /// Whether the user's device is using accelerated canvas
    pub static using_accelerated_canvas: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "using_accelerated_canvas".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5437), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.version
    ///
    /// Firefox build version
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5438), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_all_ssdeep
    ///
    /// ssdeep hash of all speechSynthesis voices.
    pub static voices_all_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_all_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5439), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_count
    ///
    /// Number of speechSynthesis voices available to the user.
    pub static voices_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5440), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_default
    ///
    /// The default speechSynthesis voice.
    pub static voices_default: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_default".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5441), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_local_count
    ///
    /// Number of local speechSynthesis voices available to the user.
    pub static voices_local_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_local_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5442), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_local_ssdeep
    ///
    /// ssdeep hash of local speechSynthesis voices.
    pub static voices_local_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_local_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5443), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_nonlocal_ssdeep
    ///
    /// ssdeep hash of non-local speechSynthesis voices.
    pub static voices_nonlocal_ssdeep: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_nonlocal_ssdeep".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5444), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_sample
    ///
    /// Names of 5 sample speechSynthesis voices.
    pub static voices_sample: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_sample".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5445), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.voices_sha1
    ///
    /// SHA1 hash of all the voices.
    pub static voices_sha1: Lazy<TextMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "voices_sha1".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        TextMetric::new(BaseMetricId(5446), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxbindgroups
    ///
    /// WebGPU limit maxBindGroups
    pub static wgpu_maxbindgroups: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxbindgroups".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5447), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxbindgroupsplusvertexbuffers
    ///
    /// WebGPU limit maxBindGroupsPlusVertexBuffers
    pub static wgpu_maxbindgroupsplusvertexbuffers: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxbindgroupsplusvertexbuffers".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5448), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxbindingsperbindgroup
    ///
    /// WebGPU limit maxBindingsPerBindGroup
    pub static wgpu_maxbindingsperbindgroup: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxbindingsperbindgroup".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5449), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxbuffersize
    ///
    /// WebGPU limit maxBufferSize
    pub static wgpu_maxbuffersize: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxbuffersize".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5450), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcolorattachmentbytespersample
    ///
    /// WebGPU limit maxColorAttachmentBytesPerSample
    pub static wgpu_maxcolorattachmentbytespersample: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcolorattachmentbytespersample".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5451), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcolorattachments
    ///
    /// WebGPU limit maxColorAttachments
    pub static wgpu_maxcolorattachments: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcolorattachments".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5452), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeinvocationsperworkgroup
    ///
    /// WebGPU limit maxComputeInvocationsPerWorkgroup
    pub static wgpu_maxcomputeinvocationsperworkgroup: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeinvocationsperworkgroup".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5453), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeworkgroupsizex
    ///
    /// WebGPU limit maxComputeWorkgroupSizeX
    pub static wgpu_maxcomputeworkgroupsizex: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeworkgroupsizex".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5454), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeworkgroupsizey
    ///
    /// WebGPU limit maxComputeWorkgroupSizeY
    pub static wgpu_maxcomputeworkgroupsizey: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeworkgroupsizey".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5455), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeworkgroupsizez
    ///
    /// WebGPU limit maxComputeWorkgroupSizeZ
    pub static wgpu_maxcomputeworkgroupsizez: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeworkgroupsizez".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5456), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeworkgroupsperdimension
    ///
    /// WebGPU limit maxComputeWorkgroupsPerDimension
    pub static wgpu_maxcomputeworkgroupsperdimension: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeworkgroupsperdimension".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5457), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxcomputeworkgroupstoragesize
    ///
    /// WebGPU limit maxComputeWorkgroupStorageSize
    pub static wgpu_maxcomputeworkgroupstoragesize: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxcomputeworkgroupstoragesize".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5458), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxdynamicstoragebuffersperpipelinelayout
    ///
    /// WebGPU limit maxDynamicStorageBuffersPerPipelineLayout
    pub static wgpu_maxdynamicstoragebuffersperpipelinelayout: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxdynamicstoragebuffersperpipelinelayout".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5459), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxdynamicuniformbuffersperpipelinelayout
    ///
    /// WebGPU limit maxDynamicUniformBuffersPerPipelineLayout
    pub static wgpu_maxdynamicuniformbuffersperpipelinelayout: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxdynamicuniformbuffersperpipelinelayout".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5460), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxinterstageshadervariables
    ///
    /// WebGPU limit maxInterStageShaderVariables
    pub static wgpu_maxinterstageshadervariables: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxinterstageshadervariables".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5461), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxsampledtexturespershaderstage
    ///
    /// WebGPU limit maxSampledTexturesPerShaderStage
    pub static wgpu_maxsampledtexturespershaderstage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxsampledtexturespershaderstage".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5462), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxsamplerspershaderstage
    ///
    /// WebGPU limit maxSamplersPerShaderStage
    pub static wgpu_maxsamplerspershaderstage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxsamplerspershaderstage".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5463), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxstoragebufferbindingsize
    ///
    /// WebGPU limit maxStorageBufferBindingSize
    pub static wgpu_maxstoragebufferbindingsize: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxstoragebufferbindingsize".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5464), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxstoragebufferspershaderstage
    ///
    /// WebGPU limit maxStorageBuffersPerShaderStage
    pub static wgpu_maxstoragebufferspershaderstage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxstoragebufferspershaderstage".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5465), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxstoragetexturespershaderstage
    ///
    /// WebGPU limit maxStorageTexturesPerShaderStage
    pub static wgpu_maxstoragetexturespershaderstage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxstoragetexturespershaderstage".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5466), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxtexturearraylayers
    ///
    /// WebGPU limit maxTextureArrayLayers
    pub static wgpu_maxtexturearraylayers: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxtexturearraylayers".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5467), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxtexturedimension1d
    ///
    /// WebGPU limit maxTextureDimension1D
    pub static wgpu_maxtexturedimension1d: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxtexturedimension1d".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5468), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxtexturedimension2d
    ///
    /// WebGPU limit maxTextureDimension2D
    pub static wgpu_maxtexturedimension2d: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxtexturedimension2d".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5469), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxtexturedimension3d
    ///
    /// WebGPU limit maxTextureDimension3D
    pub static wgpu_maxtexturedimension3d: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxtexturedimension3d".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5470), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxuniformbufferbindingsize
    ///
    /// WebGPU limit maxUniformBufferBindingSize
    pub static wgpu_maxuniformbufferbindingsize: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxuniformbufferbindingsize".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5471), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxuniformbufferspershaderstage
    ///
    /// WebGPU limit maxUniformBuffersPerShaderStage
    pub static wgpu_maxuniformbufferspershaderstage: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxuniformbufferspershaderstage".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5472), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxvertexattributes
    ///
    /// WebGPU limit maxVertexAttributes
    pub static wgpu_maxvertexattributes: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxvertexattributes".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5473), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxvertexbufferarraystride
    ///
    /// WebGPU limit maxVertexBufferArrayStride
    pub static wgpu_maxvertexbufferarraystride: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxvertexbufferarraystride".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5474), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_maxvertexbuffers
    ///
    /// WebGPU limit maxVertexBuffers
    pub static wgpu_maxvertexbuffers: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_maxvertexbuffers".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5475), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_minstoragebufferoffsetalignment
    ///
    /// WebGPU limit minStorageBufferOffsetAlignment
    pub static wgpu_minstoragebufferoffsetalignment: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_minstoragebufferoffsetalignment".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5476), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_minuniformbufferoffsetalignment
    ///
    /// WebGPU limit minUniformBufferOffsetAlignment
    pub static wgpu_minuniformbufferoffsetalignment: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_minuniformbufferoffsetalignment".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5477), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.wgpu_missing_features
    ///
    /// Missing features of WebGPU as a bitset
    pub static wgpu_missing_features: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "wgpu_missing_features".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5478), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from characteristics.zoom_count
    ///
    /// Number of domains the users has a non-default zoom level.
    pub static zoom_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "zoom_count".into(),
                category: "characteristics".into(),
                send_in_pings: vec!["user-characteristics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5479), meta)
    });

}
pub mod fingerprinting_protection {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fingerprinting.protection.canvas_noise_calculate_time_2
    ///
    /// Counts how long to generate canvas random noises.
    pub static canvas_noise_calculate_time_2: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "canvas_noise_calculate_time_2".into(),
                category: "fingerprinting.protection".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5480), meta, TimeUnit::Nanosecond)
    });

}
pub mod browser_searchinit {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from browser.searchinit.engine_invalid_webextension
    ///
    /// Records the WebExtension ID of a search engine where the WebExtension is not installed (= 1), disabled (= 2), search engine no longer specified (= 4), a different name (= 5), where the submission URL is different between the search engine and the WebExtension (= 6). The value '3' has been replaced by '6' to distinguish newer entries. This metric was generated to correspond to the Legacy Telemetry scalar browser.searchinit.engine_invalid_webextension, which was removed in Fx 139.
    pub static engine_invalid_webextension: Lazy<LabeledMetric<LabeledQuantityMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "engine_invalid_webextension".into(),
                    category: "browser.searchinit".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5481), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.searchinit.insecure_opensearch_engine_count
    ///
    /// Records the number of insecure (i.e., using http) OpenSearch search engines a given user has installed. This metric was generated to correspond to the Legacy Telemetry scalar browser.searchinit.insecure_opensearch_engine_count.
    pub static insecure_opensearch_engine_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "insecure_opensearch_engine_count".into(),
                category: "browser.searchinit".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5482), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.searchinit.insecure_opensearch_update_count
    ///
    /// Records the number of OpenSearch search engines with insecure updates enabled (i.e., using http) a given user has installed. This metric was generated to correspond to the Legacy Telemetry scalar browser.searchinit.insecure_opensearch_update_count.
    pub static insecure_opensearch_update_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "insecure_opensearch_update_count".into(),
                category: "browser.searchinit".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5483), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.searchinit.secure_opensearch_engine_count
    ///
    /// Records the number of secure (i.e., using https) OpenSearch search engines a given user has installed. This metric was generated to correspond to the Legacy Telemetry scalar browser.searchinit.secure_opensearch_engine_count.
    pub static secure_opensearch_engine_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "secure_opensearch_engine_count".into(),
                category: "browser.searchinit".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5484), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from browser.searchinit.secure_opensearch_update_count
    ///
    /// Records the number of OpenSearch search engines with secure updates enabled (i.e., using https) a given user has installed. This metric was generated to correspond to the Legacy Telemetry scalar browser.searchinit.secure_opensearch_update_count.
    pub static secure_opensearch_update_count: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "secure_opensearch_update_count".into(),
                category: "browser.searchinit".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5485), meta)
    });

}
pub mod search {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from search.suggestions_latency
    ///
    /// Records the latencies (ms) of search suggestions fetches per search engine. Keys in this histogram are search engine identifiers for built-in search engines and 'other' for non-built-in search engines.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SEARCH_SUGGESTIONS_LATENCY_MS.
    pub static suggestions_latency: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "suggestions_latency".into(),
                    category: "search".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5486), meta, None)
    });

}
pub mod search_engine_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangedExtra {
        pub r#change_reason: Option<String>,
        pub r#new_display_name: Option<String>,
        pub r#new_engine_id: Option<String>,
        pub r#new_load_path: Option<String>,
        pub r#new_submission_url: Option<String>,
        pub r#previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_reason", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#change_reason.and_then(|val| map.insert("change_reason".into(), val.to_string()));
          self.r#new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.r#new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.r#new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.r#new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.r#previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.changed
    ///
    /// Recorded when the default search engine is changed.
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5487), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.display_name
    ///
    /// The display name of the user's default engine.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_name".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5488), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.engine_id
    ///
    /// Deprecated in Fx139, please use provider_id, partner_code,
    /// overridden_by_third_party and display_name instead.
    /// 
    /// The telemetry id of the search engine.
    /// For example: "engine1"
    /// 
    /// For application-provided engines, this is the identifier plus telemetry
    /// suffix supplied by the configuration.
    /// For other engines, this is `other-<engineName>`.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_id".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5489), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[app]appDefault` for an app-provided engine.
    ///   `[addon]<extension id>` for a WebExtension-based engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch-based
    ///   engine.
    ///   `[policy]` for an enteprise policy engine.
    ///   `[user]` for a search engine defined by the user or generated from a
    ///   web page.
    /// Note: this metric is truncated at 100 characters.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_path".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5490), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.overridden_by_third_party
    ///
    /// Set to true if the user's default search engine has been allowed to be
    /// overridden by a third-party add-on or OpenSearch engine.
    pub static overridden_by_third_party: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "overridden_by_third_party".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5491), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.partner_code
    ///
    /// The partner code of the user's default search engine, if defined/known,
    /// that is being used for the search. Not all search engines have partner
    /// codes.
    /// 
    /// May be empty for engines that are overridden by a third-party add-on or
    /// OpenSearch engine.
    pub static partner_code: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "partner_code".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5492), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.provider_id
    ///
    /// The identifier of the user's default search engine if the search engine is
    /// an application provided engine. For user installed engines, this value will
    /// be `other`.
    pub static provider_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_id".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5493), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.default.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_url".into(),
                category: "search.engine.default".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(5494), meta)
    });

}
pub mod search_engine_private {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangedExtra {
        pub r#change_reason: Option<String>,
        pub r#new_display_name: Option<String>,
        pub r#new_engine_id: Option<String>,
        pub r#new_load_path: Option<String>,
        pub r#new_submission_url: Option<String>,
        pub r#previous_engine_id: Option<String>,
    }

    impl ExtraKeys for ChangedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["change_reason", "new_display_name", "new_engine_id", "new_load_path", "new_submission_url", "previous_engine_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#change_reason.and_then(|val| map.insert("change_reason".into(), val.to_string()));
          self.r#new_display_name.and_then(|val| map.insert("new_display_name".into(), val.to_string()));
          self.r#new_engine_id.and_then(|val| map.insert("new_engine_id".into(), val.to_string()));
          self.r#new_load_path.and_then(|val| map.insert("new_load_path".into(), val.to_string()));
          self.r#new_submission_url.and_then(|val| map.insert("new_submission_url".into(), val.to_string()));
          self.r#previous_engine_id.and_then(|val| map.insert("previous_engine_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.changed
    ///
    /// Recorded when the default search engine is changed
    pub static changed: Lazy<EventMetric<ChangedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "changed".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5495), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.display_name
    ///
    /// The display name of the user's default engine.
    /// 
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static display_name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "display_name".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5496), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.engine_id
    ///
    /// Deprecated in Fx139, please use provider_id, partner_code,
    /// overridden_by_third_party and display_name instead.
    /// 
    /// The telemetry id of the search engine.
    /// For example: "engine1"
    /// 
    /// For application-provided engines, this is the identifier plus telemetry
    /// suffix supplied by the configuration.
    /// For other engines, this is `other-<engineName>`.
    /// 
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static engine_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_id".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5497), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.load_path
    ///
    /// A path relating to where the search engine was installed/loaded from.
    /// For example:
    ///   `[app]appDefault` for an app-provided engine.
    ///   `[addon]<extension id>` for a WebExtension-based engine.
    ///   `[https]developer.mozilla.org/mdn-web-docs.xml` for an OpenSearch-based
    ///   engine.
    ///   `[policy]` for an enteprise policy engine.
    ///   `[user]` for a search engine defined by the user or generated from a
    ///   web page.
    /// Note: this metric is truncated at 100 characters.
    /// 
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static load_path: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_path".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5498), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.overridden_by_third_party
    ///
    /// Set to true if the user's default search engine has been allowed to be
    /// overridden by a third-party add-on or OpenSearch engine.
    pub static overridden_by_third_party: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "overridden_by_third_party".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5499), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.partner_code
    ///
    /// The partner code of the user's default search engine, if defined/known,
    /// that is being used for the search. Not all search engines have partner
    /// codes.
    /// 
    /// May be empty for engines that are overridden by a third-party add-on or
    /// OpenSearch engine.
    pub static partner_code: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "partner_code".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5500), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.provider_id
    ///
    /// The identifier of the user's default search engine if the search engine is
    /// an application provided engine. For user installed engines, this value will
    /// be `other`.
    pub static provider_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "provider_id".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into(), "newtab".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5501), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.engine.private.submission_url
    ///
    /// The submission URL of the default engine. This is only reported in the
    /// cases where:
    ///   The engine is an application provided engine.
    ///   The engine has the same name as an application provided engine.
    ///   The engine matches one of a specific list of well known search engines.
    /// If this string is an empty string (`""`), this means that one or both of
    /// the preferences `browser.search.separatePrivateDefault` and
    /// `browser.search.separatePrivateDefault.ui.enabled` are set to false.
    /// It is possible that the user selects the same private engine as for the
    /// default engine, and hence both versions of these fields will be filled in.
    pub static submission_url: Lazy<UrlMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "submission_url".into(),
                category: "search.engine.private".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UrlMetric::new(BaseMetricId(5502), meta)
    });

}
pub mod search_service {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[repr(u16)]
    pub enum InitializationStatusLabel {
        EFailedsettings = 0,
        EFailedfetchengines = 1,
        EFailedloadengines = 2,
        EFailedloadsettingsaddonmanager = 3,
        ESettingscorrupt = 4,
        ESuccess = 5,
        __Other__,
    }
    impl From<u16> for InitializationStatusLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFailedsettings,
                1 => Self::EFailedfetchengines,
                2 => Self::EFailedloadengines,
                3 => Self::EFailedloadsettingsaddonmanager,
                4 => Self::ESettingscorrupt,
                5 => Self::ESuccess,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for InitializationStatusLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFailedsettings => "failedSettings",
                Self::EFailedfetchengines => "failedFetchEngines",
                Self::EFailedloadengines => "failedLoadEngines",
                Self::EFailedloadsettingsaddonmanager => "failedLoadSettingsAddonManager",
                Self::ESettingscorrupt => "settingsCorrupt",
                Self::ESuccess => "success",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from search.service.initialization_status
    ///
    /// Counts the type of initialization statuses on start up.
    /// failedSettings - failed loading and migrating the search settings file.
    /// failedFetchEngines - failed to load or parse the configuration from remote
    ///                      settings.
    /// failedLoadEngines - failed to create all the search engines from the
    ///                     configuration or user installed engines.
    /// failedLoadSettingsAddonManager - the addon manager ready promise was rejected. (from FF135)
    /// settingsCorrupt - the search settings were reset because of an exception, but
    ///                   the search service still finished initializing. (from FF136)
    /// success - search service successfully initialized.
    pub static initialization_status: Lazy<LabeledMetric<LabeledCounterMetric, InitializationStatusLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "initialization_status".into(),
                    category: "search.service".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5503), meta, Some(vec![::std::borrow::Cow::from("failedFetchEngines"), ::std::borrow::Cow::from("failedLoadEngines"), ::std::borrow::Cow::from("failedLoadSettingsAddonManager"), ::std::borrow::Cow::from("failedSettings"), ::std::borrow::Cow::from("settingsCorrupt"), ::std::borrow::Cow::from("success")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.service.startup_time
    ///
    /// The time duration it takes for the search service to start up.
    pub static startup_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "startup_time".into(),
                category: "search.service".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5504), meta, TimeUnit::Nanosecond)
    });

}
pub mod search_suggestions {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from search.suggestions.aborted_requests
    ///
    /// Counts the number of aborted search suggestion fetches per search engine. Only records app provided engines using their short IDs ('id', not 'identifier') as labels.
    pub static aborted_requests: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "aborted_requests".into(),
                    category: "search.suggestions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5505), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.suggestions.failed_requests
    ///
    /// Counts the number of failed search suggestion fetches per search engine. Only records app provided engines using their short IDs ('id', not 'identifier') as labels.
    pub static failed_requests: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "failed_requests".into(),
                    category: "search.suggestions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5506), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from search.suggestions.successful_requests
    ///
    /// Counts the number of successful search suggestion fetches per search engine. Only records app provided engines using their short IDs ('id', not 'identifier') as labels.
    pub static successful_requests: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "successful_requests".into(),
                    category: "search.suggestions".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5507), meta, None)
    });

}
pub mod shopping_product {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_ohttp_config
    ///
    /// OHTTP was configured for shopping but the config is invalid.
    pub static invalid_ohttp_config: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_ohttp_config".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5508), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_request
    ///
    /// An invalid JSON request was sent to the Fakespot API.
    pub static invalid_request: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_request".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5509), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.invalid_response
    ///
    /// An invalid JSON response was received from the Fakespot API.
    pub static invalid_response: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "invalid_response".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5510), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_aborted
    ///
    /// Request to the Fakespot API was aborted.
    pub static request_aborted: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_aborted".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5511), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_error
    ///
    /// There was an error requesting the Fakespot API.
    pub static request_error: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_error".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5512), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_failure
    ///
    /// There was a failure with the request to the Fakespot API.
    pub static request_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_failure".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5513), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retried
    ///
    /// Status returned a 500 error when requesting the Fakespot API
    /// and will be retried.
    pub static request_retried: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_retried".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5514), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.request_retries_failed
    ///
    /// Request still failed after the maxiumn number of
    /// retry events.
    pub static request_retries_failed: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "request_retries_failed".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5515), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from shopping_product.server_failure
    ///
    /// There was a Fakespot API server issue that prevented
    /// the request from succeeding.
    pub static server_failure: Lazy<EventMetric<NoExtraKeys>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "server_failure".into(),
                category: "shopping_product".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5516), meta)
    });

}
pub mod legacy_telemetry {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.client_id
    ///
    /// The client_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Value may be the canary client id `c0ffeec0-ffee-c0ff-eec0-ffeec0ffeec0`
    /// in pings near when the data upload pref is disabled (if Telemetry gets
    /// to go first), or between when a client_id has been removed and when it
    /// has been regenerated.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static client_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "client_id".into(),
                category: "legacy.telemetry".into(),
                send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into(), "newtab".into(), "nimbus-targeting-context".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(5517), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from legacy.telemetry.profile_group_id
    ///
    /// The profile_group_id according to Telemetry.
    /// Might not always have a value due to being too early for it to have
    /// loaded.
    /// Does not need to be sent in the Glean "deletion-request" ping.
    pub static profile_group_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_group_id".into(),
                category: "legacy.telemetry".into(),
                send_in_pings: vec!["baseline".into(), "events".into(), "metrics".into(), "newtab".into(), "nimbus-targeting-context".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(5518), meta)
    });

}
pub mod onboarding_opt_out {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type ActiveExperimentsObject = Vec<ActiveExperimentsObjectItem>;

    pub type ActiveExperimentsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from onboarding_opt_out.active_experiments
    ///
    /// The slugs of the actively enrolled experiments.
    pub static active_experiments: Lazy<ObjectMetric<ActiveExperimentsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_experiments".into(),
                category: "onboarding_opt_out".into(),
                send_in_pings: vec!["onboarding-opt-out".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5519), meta)
    });

        pub type ActiveRolloutsObject = Vec<ActiveRolloutsObjectItem>;

    pub type ActiveRolloutsObjectItem = String;
    #[allow(non_upper_case_globals)]
    /// generated from onboarding_opt_out.active_rollouts
    ///
    /// The slugs of the actively enrolled rollouts.
    pub static active_rollouts: Lazy<ObjectMetric<ActiveRolloutsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_rollouts".into(),
                category: "onboarding_opt_out".into(),
                send_in_pings: vec!["onboarding-opt-out".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5520), meta)
    });

        pub type EnrollmentsMapObject = Vec<EnrollmentsMapObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct EnrollmentsMapObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub experimentSlug: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub branchSlug: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from onboarding_opt_out.enrollments_map
    ///
    /// Information about historic enrollments, including the branches enrolled.
    pub static enrollments_map: Lazy<ObjectMetric<EnrollmentsMapObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enrollments_map".into(),
                category: "onboarding_opt_out".into(),
                send_in_pings: vec!["onboarding-opt-out".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5521), meta)
    });

}
pub mod telemetry {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_checking_over_quota
    ///
    /// Time (ms) it takes for checking if the archive is over-quota
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_ARCHIVE_CHECKING_OVER_QUOTA_MS.
    pub static archive_checking_over_quota: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_checking_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5522), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_directories_count
    ///
    /// Number of directories in the archive at scan
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_ARCHIVE_DIRECTORIES_COUNT.
    pub static archive_directories_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_directories_count".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5523), meta, 1, 13, 12, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_evicted_old_dirs
    ///
    /// Number of Telemetry directories evicted from the archive during cleanup, because they were too old
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_ARCHIVE_EVICTED_OLD_DIRS.
    pub static archive_evicted_old_dirs: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_evicted_old_dirs".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5524), meta, 1, 13, 12, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_evicted_over_quota
    ///
    /// Number of Telemetry pings evicted from the archive during cleanup, because they were over the quota
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_ARCHIVE_EVICTED_OVER_QUOTA.
    pub static archive_evicted_over_quota: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_evicted_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5525), meta, 1, 100000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_evicting_dirs
    ///
    /// Time (ms) it takes for evicting old directories
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_ARCHIVE_EVICTING_DIRS_MS.
    pub static archive_evicting_dirs: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_evicting_dirs".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5526), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_evicting_over_quota
    ///
    /// Time (ms) it takes for evicting over-quota pings
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_ARCHIVE_EVICTING_OVER_QUOTA_MS.
    pub static archive_evicting_over_quota: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_evicting_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5527), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_oldest_directory_age
    ///
    /// The age of the oldest Telemetry archive directory in months
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_ARCHIVE_OLDEST_DIRECTORY_AGE.
    pub static archive_oldest_directory_age: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_oldest_directory_age".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5528), meta, 1, 13, 12, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_scan_ping_count
    ///
    /// Number of Telemetry pings in the archive at scan
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_ARCHIVE_SCAN_PING_COUNT.
    pub static archive_scan_ping_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_scan_ping_count".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5529), meta, 1, 100000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_session_ping_count
    ///
    /// Number of Telemetry pings added to the archive during the session
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_ARCHIVE_SESSION_PING_COUNT.
    pub static archive_session_ping_count: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5530,
            "telemetry",
            "archive_session_ping_count",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.archive_size
    ///
    /// The size of the Telemetry archive (MB)
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_ARCHIVE_SIZE_MB.
    pub static archive_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "archive_size".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5531), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.compress
    ///
    /// Time taken to compress telemetry object (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_COMPRESS.
    pub static compress: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compress".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5532), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.data_upload_optin
    ///
    /// User opted into sending Telemetry data again. This metric was generated to correspond to the Legacy Telemetry scalar telemetry.data_upload_optin.
    pub static data_upload_optin: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "data_upload_optin".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5533), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.discarded_archived_pings_size
    ///
    /// The size (MB) of the Telemetry archived, compressed, pings exceeding the maximum file size
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_DISCARDED_ARCHIVED_PINGS_SIZE_MB.
    pub static discarded_archived_pings_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "discarded_archived_pings_size".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5534), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.discarded_pending_pings_size
    ///
    /// The size (MB) of the Telemetry pending pings exceeding the maximum file size
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_DISCARDED_PENDING_PINGS_SIZE_MB.
    pub static discarded_pending_pings_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "discarded_pending_pings_size".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5535), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.discarded_send_pings_size
    ///
    /// The size (MB) of the ping data submitted to Telemetry exceeding the maximum size
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_DISCARDED_SEND_PINGS_SIZE_MB.
    pub static discarded_send_pings_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "discarded_send_pings_size".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5536), meta, MemoryUnit::Megabyte)
    });

    #[repr(u16)]
    pub enum EventPingSentLabel {
        EPeriodic = 0,
        EMax = 1,
        EShutdown = 2,
        __Other__,
    }
    impl From<u16> for EventPingSentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EPeriodic,
                1 => Self::EMax,
                2 => Self::EShutdown,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventPingSentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EPeriodic => "periodic",
                Self::EMax => "max",
                Self::EShutdown => "shutdown",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.event_ping_sent
    ///
    /// Number of 'event' pings sent, by reason
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram TELEMETRY_EVENT_PING_SENT.
    pub static event_ping_sent: Lazy<LabeledMetric<LabeledCounterMetric, EventPingSentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "event_ping_sent".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5537), meta, Some(vec![::std::borrow::Cow::from("max"), ::std::borrow::Cow::from("periodic"), ::std::borrow::Cow::from("shutdown")]))
    });

    #[repr(u16)]
    pub enum EventRecordingErrorLabel {
        EUnknownevent = 0,
        EExpired = 1,
        EExtrakey = 2,
        EValue = 3,
        EExtra = 4,
        __Other__,
    }
    impl From<u16> for EventRecordingErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EUnknownevent,
                1 => Self::EExpired,
                2 => Self::EExtrakey,
                3 => Self::EValue,
                4 => Self::EExtra,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventRecordingErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EUnknownevent => "UnknownEvent",
                Self::EExpired => "Expired",
                Self::EExtrakey => "ExtraKey",
                Self::EValue => "Value",
                Self::EExtra => "Extra",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.event_recording_error
    ///
    /// Number of event recording failures, by type of failure
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram TELEMETRY_EVENT_RECORDING_ERROR.
    pub static event_recording_error: Lazy<LabeledMetric<LabeledCounterMetric, EventRecordingErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "event_recording_error".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5538), meta, Some(vec![::std::borrow::Cow::from("Expired"), ::std::borrow::Cow::from("Extra"), ::std::borrow::Cow::from("ExtraKey"), ::std::borrow::Cow::from("UnknownEvent"), ::std::borrow::Cow::from("Value")]))
    });

    #[repr(u16)]
    pub enum EventRegistrationErrorLabel {
        EOther = 0,
        EName = 1,
        ECategory = 2,
        EMethod = 3,
        EObject = 4,
        EExtrakeys = 5,
        __Other__,
    }
    impl From<u16> for EventRegistrationErrorLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EOther,
                1 => Self::EName,
                2 => Self::ECategory,
                3 => Self::EMethod,
                4 => Self::EObject,
                5 => Self::EExtrakeys,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for EventRegistrationErrorLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EOther => "Other",
                Self::EName => "Name",
                Self::ECategory => "Category",
                Self::EMethod => "Method",
                Self::EObject => "Object",
                Self::EExtrakeys => "ExtraKeys",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.event_registration_error
    ///
    /// Number of event registration failures, by field causing the failure
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram TELEMETRY_EVENT_REGISTRATION_ERROR.
    pub static event_registration_error: Lazy<LabeledMetric<LabeledCounterMetric, EventRegistrationErrorLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "event_registration_error".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5539), meta, Some(vec![::std::borrow::Cow::from("Category"), ::std::borrow::Cow::from("ExtraKeys"), ::std::borrow::Cow::from("Method"), ::std::borrow::Cow::from("Name"), ::std::borrow::Cow::from("Object"), ::std::borrow::Cow::from("Other")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.invalid_payload_submitted
    ///
    /// Count of individual invalid payloads that were submitted to Telemetry.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_INVALID_PAYLOAD_SUBMITTED.
    pub static invalid_payload_submitted: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5540,
            "telemetry",
            "invalid_payload_submitted",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.invalid_ping_type_submitted
    ///
    /// Count of individual invalid ping types that were submitted to Telemetry.
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_INVALID_PING_TYPE_SUBMITTED.
    pub static invalid_ping_type_submitted: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "invalid_ping_type_submitted".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5541), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_checking_over_quota
    ///
    /// Time (ms) it takes for checking if the pending pings are over-quota
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_PENDING_CHECKING_OVER_QUOTA_MS.
    pub static pending_checking_over_quota: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pending_checking_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5542), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_evicting_over_quota
    ///
    /// Time (ms) it takes for evicting over-quota pending pings
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_PENDING_EVICTING_OVER_QUOTA_MS.
    pub static pending_evicting_over_quota: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pending_evicting_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5543), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_load_failure_parse
    ///
    /// Number of pending Telemetry pings that failed to parse once loaded from the disk
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PENDING_LOAD_FAILURE_PARSE.
    pub static pending_load_failure_parse: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5544,
            "telemetry",
            "pending_load_failure_parse",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_load_failure_read
    ///
    /// Number of pending Telemetry pings that failed to load from the disk
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PENDING_LOAD_FAILURE_READ.
    pub static pending_load_failure_read: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5545,
            "telemetry",
            "pending_load_failure_read",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_pings_age
    ///
    /// The age, in days, of the pending pings.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_PENDING_PINGS_AGE.
    pub static pending_pings_age: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pending_pings_age".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5546), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_pings_evicted_over_quota
    ///
    /// Number of Telemetry pings evicted from the pending pings directory during cleanup, because they were over the quota
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_PENDING_PINGS_EVICTED_OVER_QUOTA.
    pub static pending_pings_evicted_over_quota: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pending_pings_evicted_over_quota".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5547), meta, 1, 100000, 100, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.pending_pings_size
    ///
    /// The size of the Telemetry pending pings directory (MB). The special value 17 is used to indicate over quota pings.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram TELEMETRY_PENDING_PINGS_SIZE_MB.
    pub static pending_pings_size: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pending_pings_size".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5548), meta, MemoryUnit::Megabyte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.ping_evicted_for_server_errors
    ///
    /// Number of Telemetry ping files evicted due to server errors (4XX HTTP code received)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PING_EVICTED_FOR_SERVER_ERRORS.
    pub static ping_evicted_for_server_errors: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5549,
            "telemetry",
            "ping_evicted_for_server_errors",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.ping_size_exceeded_archived
    ///
    /// Number of archived Telemetry pings discarded because they exceeded the maximum size
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PING_SIZE_EXCEEDED_ARCHIVED.
    pub static ping_size_exceeded_archived: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5550,
            "telemetry",
            "ping_size_exceeded_archived",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.ping_size_exceeded_pending
    ///
    /// Number of Telemetry pending pings discarded because they exceeded the maximum size
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PING_SIZE_EXCEEDED_PENDING.
    pub static ping_size_exceeded_pending: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5551,
            "telemetry",
            "ping_size_exceeded_pending",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.ping_size_exceeded_send
    ///
    /// Number of Telemetry pings discarded before sending because they exceeded the maximum size
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PING_SIZE_EXCEEDED_SEND.
    pub static ping_size_exceeded_send: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5552,
            "telemetry",
            "ping_size_exceeded_send",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.ping_submission_waiting_clientid
    ///
    /// The number of pings that were submitted and had to wait for a client id (i.e. before it was cached or loaded from disk)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram TELEMETRY_PING_SUBMISSION_WAITING_CLIENTID.
    pub static ping_submission_waiting_clientid: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5553,
            "telemetry",
            "ping_submission_waiting_clientid",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.send_failure
    ///
    /// Time needed (in ms) for a failed send of a Telemetry ping to the servers and getting a reply back.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_SEND_FAILURE.
    pub static send_failure: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send_failure".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5554), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SendFailureTypeLabel {
        EEok = 0,
        EErequest = 1,
        EEunreachable = 2,
        EEchannelopen = 3,
        EEredirect = 4,
        EAbort = 5,
        ETimeout = 6,
        EEtoolate = 7,
        EEterminated = 8,
        __Other__,
    }
    impl From<u16> for SendFailureTypeLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EEok,
                1 => Self::EErequest,
                2 => Self::EEunreachable,
                3 => Self::EEchannelopen,
                4 => Self::EEredirect,
                5 => Self::EAbort,
                6 => Self::ETimeout,
                7 => Self::EEtoolate,
                8 => Self::EEterminated,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SendFailureTypeLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EEok => "eOK",
                Self::EErequest => "eRequest",
                Self::EEunreachable => "eUnreachable",
                Self::EEchannelopen => "eChannelOpen",
                Self::EEredirect => "eRedirect",
                Self::EAbort => "abort",
                Self::ETimeout => "timeout",
                Self::EEtoolate => "eTooLate",
                Self::EEterminated => "eTerminated",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.send_failure_type
    ///
    /// Counts of the different ways sending a Telemetry ping can fail.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram TELEMETRY_SEND_FAILURE_TYPE.
    pub static send_failure_type: Lazy<LabeledMetric<LabeledCounterMetric, SendFailureTypeLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "send_failure_type".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5555), meta, Some(vec![::std::borrow::Cow::from("abort"), ::std::borrow::Cow::from("eChannelOpen"), ::std::borrow::Cow::from("eOK"), ::std::borrow::Cow::from("eRedirect"), ::std::borrow::Cow::from("eRequest"), ::std::borrow::Cow::from("eTerminated"), ::std::borrow::Cow::from("eTooLate"), ::std::borrow::Cow::from("eUnreachable"), ::std::borrow::Cow::from("timeout")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.send_success
    ///
    /// Time needed (in ms) for a successful send of a Telemetry ping to the servers and getting a reply back.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_SEND_SUCCESS.
    pub static send_success: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "send_success".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5556), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from telemetry.stringify
    ///
    /// Time to stringify telemetry object (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram TELEMETRY_STRINGIFY.
    pub static stringify: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "stringify".into(),
                category: "telemetry".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5557), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum SuccessLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SuccessLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SuccessLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.success
    ///
    /// Successful telemetry submission
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram TELEMETRY_SUCCESS.
    pub static success: Lazy<LabeledMetric<LabeledCounterMetric, SuccessLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "success".into(),
                    category: "telemetry".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5558), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod usage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from usage.app_build
    ///
    /// The build identifier generated by the CI system (e.g. "1234/A").
    /// If the value was not provided through configuration,
    /// this metric gets set to `Unknown`.
    pub static app_build: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_build".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5559), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.app_channel
    ///
    /// The channel the application is being distributed on.
    pub static app_channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_channel".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5560), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.app_display_version
    ///
    /// The user visible version string (e.g. "1.0.3").
    /// If the value was not provided through configuration,
    /// this metric gets set to `Unknown`.
    pub static app_display_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "app_display_version".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5561), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.distribution_id
    ///
    /// The distribution id associated with the install of Firefox.
    pub static distribution_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "distribution_id".into(),
                category: "usage".into(),
                send_in_pings: vec!["baseline".into(), "onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5562), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.first_run_date
    ///
    /// The date of the profile's first use. Set from `ProfileAge.firstUse`
    pub static first_run_date: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "first_run_date".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5563), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.is_default_browser
    ///
    /// Whether Firefox is set as the default browser.
    pub static is_default_browser: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "is_default_browser".into(),
                category: "usage".into(),
                send_in_pings: vec!["baseline".into(), "onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5564), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.os
    ///
    /// The name of the operating system.
    /// Possible values:
    /// Android, iOS, Linux, Darwin, Windows,
    /// FreeBSD, NetBSD, OpenBSD, Solaris, Unknown
    pub static os: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5565), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.os_version
    ///
    /// The user-visible version of the operating system (e.g. "1.2.3").
    /// If the version detection fails, this metric gets set to `Unknown`.
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_version".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5566), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.profile_group_id
    ///
    /// A UUID uniquely identifying the profile group,
    /// not shared with other telemetry data.
    pub static profile_group_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_group_id".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-deletion-request".into(), "usage-reporting".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(5567), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.profile_id
    ///
    /// A UUID uniquely identifying the profile,
    /// not shared with other telemetry data.
    pub static profile_id: Lazy<UuidMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "profile_id".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-deletion-request".into(), "usage-reporting".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        UuidMetric::new(BaseMetricId(5568), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.reason
    ///
    /// The reason the usage-reporting ping was sent.
    pub static reason: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "reason".into(),
                category: "usage".into(),
                send_in_pings: vec!["usage-reporting".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5569), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from usage.windows_build_number
    ///
    /// The optional Windows build number, reported by Windows
    /// (e.g. 22000) and not set for other platforms.
    pub static windows_build_number: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "windows_build_number".into(),
                category: "usage".into(),
                send_in_pings: vec!["onboarding-opt-out".into(), "usage-reporting".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5570), meta)
    });

}
pub mod telemetry_test {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test1Object1Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test1Object1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test1_object1
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to the Legacy Telemetry event telemetry.test.test1#object1.
    pub static test1_object1: Lazy<EventMetric<Test1Object1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test1_object1".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5571), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test2Object1Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test2Object1Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test2_object1
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to the Legacy Telemetry event telemetry.test.test2#object1.
    pub static test2_object1: Lazy<EventMetric<Test2Object1Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test2_object1".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5572), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct Test2Object2Extra {
        pub r#key1: Option<String>,
        pub r#key2: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for Test2Object2Extra {
        const ALLOWED_KEYS: &'static [&'static str] = &["key1", "key2", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#key1.and_then(|val| map.insert("key1".into(), val.to_string()));
          self.r#key2.and_then(|val| map.insert("key2".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from telemetry.test.test2_object2
    ///
    /// This is a test entry for Telemetry. This event was generated to correspond to the Legacy Telemetry event telemetry.test.test2#object2.
    pub static test2_object2: Lazy<EventMetric<Test2Object2Extra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "test2_object2".into(),
                category: "telemetry.test".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5573), meta)
    });

}
pub mod thumbnails {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.capture_canvas_draw_time
    ///
    /// BACKGROUND THUMBNAILS: Time it took to draw the capture's window to canvas (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_BG_CAPTURE_CANVAS_DRAW_TIME_MS.
    pub static capture_canvas_draw_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "capture_canvas_draw_time".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5574), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.capture_done_reason_2
    ///
    /// BACKGROUND THUMBNAILS: Reason the capture completed (see TEL_CAPTURE_DONE_* constants in BackgroundPageThumbs.sys.mjs)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram FX_THUMBNAILS_BG_CAPTURE_DONE_REASON_2.
    pub static capture_done_reason_2: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "capture_done_reason_2".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5575), meta, 0, 10, 11, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.capture_page_load_time
    ///
    /// BACKGROUND THUMBNAILS: Time the capture's page load took (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_BG_CAPTURE_PAGE_LOAD_TIME_MS.
    pub static capture_page_load_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "capture_page_load_time".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5576), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.capture_queue_time
    ///
    /// BACKGROUND THUMBNAILS: Time the capture request spent in the queue before being serviced (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_BG_CAPTURE_QUEUE_TIME_MS.
    pub static capture_queue_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "capture_queue_time".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5577), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.capture_time
    ///
    /// THUMBNAILS: Time (ms) it takes to capture a thumbnail
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_CAPTURE_TIME_MS.
    pub static capture_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "capture_time".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5578), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.queue_size_on_capture
    ///
    /// BACKGROUND THUMBNAILS: Size of capture queue when a capture request is received
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_BG_QUEUE_SIZE_ON_CAPTURE.
    pub static queue_size_on_capture: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "queue_size_on_capture".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5579), meta, 1, 100, 15, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from thumbnails.store_time
    ///
    /// THUMBNAILS: Time (ms) it takes to store a thumbnail in the cache
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FX_THUMBNAILS_STORE_TIME_MS.
    pub static store_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "store_time".into(),
                category: "thumbnails".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5580), meta, TimeUnit::Millisecond)
    });

}
pub mod translations {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnginePerformanceExtra {
        pub r#average_words_per_request: Option<u32>,
        pub r#average_words_per_second: Option<u32>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#to_language: Option<String>,
        pub r#total_completed_requests: Option<u32>,
        pub r#total_inference_seconds: Option<u32>,
        pub r#total_translated_words: Option<u32>,
    }

    impl ExtraKeys for EnginePerformanceExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["average_words_per_request", "average_words_per_second", "flow_id", "from_language", "to_language", "total_completed_requests", "total_inference_seconds", "total_translated_words"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#average_words_per_request.and_then(|val| map.insert("average_words_per_request".into(), val.to_string()));
          self.r#average_words_per_second.and_then(|val| map.insert("average_words_per_second".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.r#total_completed_requests.and_then(|val| map.insert("total_completed_requests".into(), val.to_string()));
          self.r#total_inference_seconds.and_then(|val| map.insert("total_inference_seconds".into(), val.to_string()));
          self.r#total_translated_words.and_then(|val| map.insert("total_translated_words".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.engine_performance
    ///
    /// Metrics related to the performance of the TranslationsEngine.
    pub static engine_performance: Lazy<EventMetric<EnginePerformanceExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "engine_performance".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5581), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ErrorExtra {
        pub r#flow_id: Option<String>,
        pub r#reason: Option<String>,
    }

    impl ExtraKeys for ErrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "reason"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#reason.and_then(|val| map.insert("reason".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.error
    ///
    /// The specific translations error that caused a full_page translation failure.
    pub static error: Lazy<EventMetric<ErrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "error".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5582), meta)
    });

    #[repr(u16)]
    pub enum RequestCountLabel {
        EFullPage = 0,
        ESelect = 1,
        __Other__,
    }
    impl From<u16> for RequestCountLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFullPage,
                1 => Self::ESelect,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for RequestCountLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFullPage => "full_page",
                Self::ESelect => "select",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.request_count
    ///
    /// The count of translation requests, along with their type.
    pub static request_count: Lazy<LabeledMetric<LabeledCounterMetric, RequestCountLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "request_count".into(),
                    category: "translations".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5583), meta, Some(vec![::std::borrow::Cow::from("full_page"), ::std::borrow::Cow::from("select")]))
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RestorePageExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.restore_page
    ///
    /// Triggers when the a restore-page event is triggered.
    pub static restore_page: Lazy<EventMetric<RestorePageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "restore_page".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5584), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationRequestExtra {
        pub r#auto_translate: Option<bool>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#request_target: Option<String>,
        pub r#source_text_code_units: Option<u32>,
        pub r#source_text_word_count: Option<u32>,
        pub r#to_language: Option<String>,
        pub r#top_preferred_language: Option<String>,
    }

    impl ExtraKeys for TranslationRequestExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_translate", "document_language", "flow_id", "from_language", "request_target", "source_text_code_units", "source_text_word_count", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_translate.and_then(|val| map.insert("auto_translate".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#request_target.and_then(|val| map.insert("request_target".into(), val.to_string()));
          self.r#source_text_code_units.and_then(|val| map.insert("source_text_code_units".into(), val.to_string()));
          self.r#source_text_word_count.and_then(|val| map.insert("source_text_word_count".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.r#top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.translation_request
    ///
    /// Triggers when a full-page translation request is sent.
    pub static translation_request: Lazy<EventMetric<TranslationRequestExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_request".into(),
                category: "translations".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5585), meta)
    });

}
pub mod translations_about_translations_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.about_translations_page.open
    ///
    /// Triggers when the about-translations page is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open".into(),
                category: "translations.about_translations_page".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5586), meta)
    });

}
pub mod translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AboutTranslationsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the full-page translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "about_translations".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5587), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlwaysOfferTranslationsExtra {
        pub r#flow_id: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysOfferTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_offer_translations
    ///
    /// Triggers when the always-offer-translations menuitem is invoked in the full-page translations panel seeings.
    pub static always_offer_translations: Lazy<EventMetric<AlwaysOfferTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_offer_translations".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5588), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AlwaysTranslateLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for AlwaysTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.always_translate_language
    ///
    /// Triggers when the always-translate-language menuitem is invoked in the full-page translations panel settings.
    pub static always_translate_language: Lazy<EventMetric<AlwaysTranslateLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "always_translate_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5589), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the full-page translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5590), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeFromLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_from_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5591), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeSourceLanguageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for ChangeSourceLanguageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_source_language_button
    ///
    /// Triggers when the change-source-language button is invoked in the full-page translations panel.
    pub static change_source_language_button: Lazy<EventMetric<ChangeSourceLanguageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_source_language_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5592), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeToLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_to_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5593), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close
    ///
    /// Triggers when full-page translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5594), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseFromLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_from_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page translations panel.
    pub static close_from_language_menu: Lazy<EventMetric<CloseFromLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_from_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5595), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_settings_menu
    ///
    /// Triggers when the settings menu is closed in the full-page translations panel.
    pub static close_settings_menu: Lazy<EventMetric<CloseSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_settings_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5596), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseToLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.close_to_language_menu
    ///
    /// Triggers when the from-language dropdown is closed in the full-page translations panel.
    pub static close_to_language_menu: Lazy<EventMetric<CloseToLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close_to_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5597), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DismissErrorButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for DismissErrorButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.dismiss_error_button
    ///
    /// Triggers when the dismiss-error button is invoked in the full-page translations panel.
    pub static dismiss_error_button: Lazy<EventMetric<DismissErrorButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dismiss_error_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5598), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LearnMoreExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for LearnMoreExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.learn_more
    ///
    /// Triggers when the learn-more link is invoked in the full-page translations panel first interaction.
    pub static learn_more: Lazy<EventMetric<LearnMoreExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "learn_more".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5599), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageLanguagesExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for ManageLanguagesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.manage_languages
    ///
    /// Triggers when the manage-languages menuitem is invoked in the full-page translations panel settings.
    pub static manage_languages: Lazy<EventMetric<ManageLanguagesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage_languages".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5600), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NeverTranslateLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_language
    ///
    /// Triggers when the never-translate-language menuitem is invoked in the full-page translations panel settings.
    pub static never_translate_language: Lazy<EventMetric<NeverTranslateLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "never_translate_language".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5601), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct NeverTranslateSiteExtra {
        pub r#flow_id: Option<String>,
        pub r#toggled_on: Option<bool>,
    }

    impl ExtraKeys for NeverTranslateSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "toggled_on"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#toggled_on.and_then(|val| map.insert("toggled_on".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.never_translate_site
    ///
    /// Triggers when the never-translate-site menuitem is invoked in the full-page translations panel settings.
    pub static never_translate_site: Lazy<EventMetric<NeverTranslateSiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "never_translate_site".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5602), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenExtra {
        pub r#auto_show: Option<bool>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#opened_from: Option<String>,
        pub r#view_name: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["auto_show", "document_language", "flow_id", "opened_from", "view_name"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#auto_show.and_then(|val| map.insert("auto_show".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#opened_from.and_then(|val| map.insert("opened_from".into(), val.to_string()));
          self.r#view_name.and_then(|val| map.insert("view_name".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open
    ///
    /// Triggers when the full-page translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5603), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenFromLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenFromLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_from_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page translations panel.
    pub static open_from_language_menu: Lazy<EventMetric<OpenFromLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_from_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5604), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the full-page translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_settings_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5605), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenToLanguageMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenToLanguageMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.open_to_language_menu
    ///
    /// Triggers when the from-language dropdown is opened in the full-page translations panel.
    pub static open_to_language_menu: Lazy<EventMetric<OpenToLanguageMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_to_language_menu".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5606), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct RestorePageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for RestorePageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.restore_page_button
    ///
    /// Triggers when the restore-page button is invoked in the full-page translations panel.
    pub static restore_page_button: Lazy<EventMetric<RestorePageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "restore_page_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5607), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the full-page translations panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_button".into(),
                category: "translations.panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5608), meta)
    });

}
pub mod translations_select_translations_panel {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AboutTranslationsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for AboutTranslationsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.about_translations
    ///
    /// Triggers when the about-translations menuitem is invoked in the select translations panel settings.
    pub static about_translations: Lazy<EventMetric<AboutTranslationsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "about_translations".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5609), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CancelButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CancelButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.cancel_button
    ///
    /// Triggers when the cancel button is invoked in the select translations panel.
    pub static cancel_button: Lazy<EventMetric<CancelButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cancel_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5610), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeFromLanguageExtra {
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
        pub r#previous_language: Option<String>,
    }

    impl ExtraKeys for ChangeFromLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "language", "previous_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          self.r#previous_language.and_then(|val| map.insert("previous_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_from_language
    ///
    /// Triggers when the from-language selected value is changed.
    pub static change_from_language: Lazy<EventMetric<ChangeFromLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_from_language".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5611), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ChangeToLanguageExtra {
        pub r#flow_id: Option<String>,
        pub r#language: Option<String>,
    }

    impl ExtraKeys for ChangeToLanguageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#language.and_then(|val| map.insert("language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.change_to_language
    ///
    /// Triggers when the to-language selected value is changed.
    pub static change_to_language: Lazy<EventMetric<ChangeToLanguageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "change_to_language".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5612), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CloseExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CloseExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.close
    ///
    /// Triggers when the select translations panel is closed.
    pub static close: Lazy<EventMetric<CloseExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "close".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5613), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct CopyButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for CopyButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.copy_button
    ///
    /// Triggers when the copy button is invoked in the select translations panel.
    pub static copy_button: Lazy<EventMetric<CopyButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "copy_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5614), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DoneButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for DoneButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.done_button
    ///
    /// Triggers when the done button is invoked in the select translations panel.
    pub static done_button: Lazy<EventMetric<DoneButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "done_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5615), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InitializationFailureMessageExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for InitializationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.initialization_failure_message
    ///
    /// Triggers when the initialization-failure message is shown in the select translations panel.
    pub static initialization_failure_message: Lazy<EventMetric<InitializationFailureMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "initialization_failure_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5616), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenExtra {
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#text_source: Option<String>,
        pub r#to_language: Option<String>,
        pub r#top_preferred_language: Option<String>,
    }

    impl ExtraKeys for OpenExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["document_language", "flow_id", "from_language", "text_source", "to_language", "top_preferred_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#text_source.and_then(|val| map.insert("text_source".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          self.r#top_preferred_language.and_then(|val| map.insert("top_preferred_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open
    ///
    /// Triggers when the select translations panel is opened.
    pub static open: Lazy<EventMetric<OpenExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5617), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OpenSettingsMenuExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for OpenSettingsMenuExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.open_settings_menu
    ///
    /// Triggers when the settings menu is opened in the select translations panel.
    pub static open_settings_menu: Lazy<EventMetric<OpenSettingsMenuExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "open_settings_menu".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5618), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateButtonExtra {
        pub r#detected_language: Option<String>,
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#to_language: Option<String>,
    }

    impl ExtraKeys for TranslateButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_button
    ///
    /// Triggers when the translate button is invoked in the select translations panel.
    pub static translate_button: Lazy<EventMetric<TranslateButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5619), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslateFullPageButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslateFullPageButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translate_full_page_button
    ///
    /// Triggers when the translate-full-page button is invoked in the select translations panel.
    pub static translate_full_page_button: Lazy<EventMetric<TranslateFullPageButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translate_full_page_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5620), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationFailureMessageExtra {
        pub r#flow_id: Option<String>,
        pub r#from_language: Option<String>,
        pub r#to_language: Option<String>,
    }

    impl ExtraKeys for TranslationFailureMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id", "from_language", "to_language"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          self.r#from_language.and_then(|val| map.insert("from_language".into(), val.to_string()));
          self.r#to_language.and_then(|val| map.insert("to_language".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_failure_message
    ///
    /// Triggers when the translation-failure message is shown in the select translations panel.
    pub static translation_failure_message: Lazy<EventMetric<TranslationFailureMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_failure_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5621), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TranslationSettingsExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TranslationSettingsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.translation_settings
    ///
    /// Triggers when the translation-settings menuitem is invoked in the select translations panel settings.
    pub static translation_settings: Lazy<EventMetric<TranslationSettingsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "translation_settings".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5622), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct TryAgainButtonExtra {
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for TryAgainButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.try_again_button
    ///
    /// Triggers when the try-again button is invoked in the select translations panel.
    pub static try_again_button: Lazy<EventMetric<TryAgainButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "try_again_button".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5623), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UnsupportedLanguageMessageExtra {
        pub r#detected_language: Option<String>,
        pub r#document_language: Option<String>,
        pub r#flow_id: Option<String>,
    }

    impl ExtraKeys for UnsupportedLanguageMessageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["detected_language", "document_language", "flow_id"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#detected_language.and_then(|val| map.insert("detected_language".into(), val.to_string()));
          self.r#document_language.and_then(|val| map.insert("document_language".into(), val.to_string()));
          self.r#flow_id.and_then(|val| map.insert("flow_id".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from translations.select_translations_panel.unsupported_language_message
    ///
    /// Triggers when the unsupported-language message is shown in the select translations panel.
    pub static unsupported_language_message: Lazy<EventMetric<UnsupportedLanguageMessageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "unsupported_language_message".into(),
                category: "translations.select_translations_panel".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5624), meta)
    });

}
pub mod urlclassifier {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.async_classifylocal_time
    ///
    /// Time spent per AsyncClassifyLocalWithTables (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_ASYNC_CLASSIFYLOCAL_TIME.
    pub static async_classifylocal_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_classifylocal_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5625), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.cl_check_time
    ///
    /// Time spent per classifier lookup (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_CL_CHECK_TIME.
    pub static cl_check_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "cl_check_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5626), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.cl_keyed_update_time
    ///
    /// Time spent per classifier update (ms), keyed by the name of the provider.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_CL_KEYED_UPDATE_TIME.
    pub static cl_keyed_update_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "cl_keyed_update_time".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5627), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.complete_remote_status2
    ///
    /// Server HTTP status code from remote SafeBrowsing gethash lookups. (0=1xx, 1=200, 2=2xx, 3=204, 4=3xx, 5=400, 6=4xx, 7=403, 8=404, 9=408, 10=413, 11=5xx, 12=502|504|511, 13=503, 14=505, 15=Other). Keyed by provider
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_COMPLETE_REMOTE_STATUS2.
    pub static complete_remote_status2: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "complete_remote_status2".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 16, bucket_count: 17, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5628), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.complete_server_response_time
    ///
    /// Server response time to getHash request (ms). Keyed by provider
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_COMPLETE_SERVER_RESPONSE_TIME.
    pub static complete_server_response_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "complete_server_response_time".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5629), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.completion_error
    ///
    /// SafeBrowsing v4 hash completion error (0 = success, 1 = parsing failure, 2 = unknown threat type)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_COMPLETION_ERROR.
    pub static completion_error: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "completion_error".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5630), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.lookup_time_2
    ///
    /// Time spent per dbservice lookup (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_LOOKUP_TIME_2.
    pub static lookup_time_2: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "lookup_time_2".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5631), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.shutdown_time
    ///
    /// Time spent per dbservice shutdown (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_SHUTDOWN_TIME.
    pub static shutdown_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "shutdown_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5632), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.threathit_network_error
    ///
    /// Whether or not an error was encountered while sending a Safe Browsing ThreatHit report. (0=sucess, 1=unknown error, 2=already connected, 3=not connected, 4=connection refused,5=net timeout, 6=offline, 7=port access not allowed, 8=net reset, 9=net interrupt, 10=proxy connection refused, 11=partial transfer, 12=inadequate security, 13=unknown host, 14=dns lookup queue full, 15=unknown proxy host)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_THREATHIT_NETWORK_ERROR.
    pub static threathit_network_error: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "threathit_network_error".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5633), meta, 0, 30, 31, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.threathit_remote_status
    ///
    /// Server HTTP status code from Safe Browsing ThreatHit report. (0=1xx, 1=200, 2=2xx, 3=204, 4=3xx, 5=400, 6=4xx, 7=403, 8=404, 9=408, 10=413, 11=5xx, 12=502|504|511, 13=503, 14=505, 15=Other)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_THREATHIT_REMOTE_STATUS.
    pub static threathit_remote_status: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "threathit_remote_status".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5634), meta, 0, 16, 17, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.ui_events
    ///
    /// URL CLassifier-related (aka Safe Browsing) UI events. See nsIUrlClassifierUITelemetry.idl for the specific values.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_UI_EVENTS.
    pub static ui_events: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "ui_events".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5635), meta, 0, 64, 65, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.update_error
    ///
    /// Whether or not an error was encountered while processing a Safe Browsing update (0 = success, 1 = unspecified error, 2 = addition of an already existing prefix, 3 = parser got into an infinite loop, 4 = removal index out of bounds, 5 = checksum mismatch, 6 = missing checksum, 7 = update while shutdown, 8 = cannot find table, 9 = build prefix failure, 10 = write disk failure, 11 = protocol parser error). Keyed by provider
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_UPDATE_ERROR.
    pub static update_error: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "update_error".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 16, bucket_count: 17, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5636), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.update_remote_network_error
    ///
    /// Network error from SafeBrowsing database updates. (0=sucess, 1=unknown error, 2=already connected, 3=not connected, 4=connection refused,5=net timeout, 6=offline, 7=port access not allowed, 8=net reset, 9=net interrupt, 10=proxy connection refused,11=partial transfer,12=inadequate security,13=unknown host,14=dns lookup queue full,15=unknown proxy host
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_UPDATE_REMOTE_NETWORK_ERROR.
    pub static update_remote_network_error: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "update_remote_network_error".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 30, bucket_count: 31, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5637), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.update_remote_status2
    ///
    /// Server HTTP status code from SafeBrowsing database updates. (0=1xx, 1=200, 2=2xx, 3=204, 4=3xx, 5=400, 6=4xx, 7=403, 8=404, 9=408, 10=413, 11=5xx, 12=502|504|511, 13=503, 14=505, 15=Other). Keyed by provider
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_UPDATE_REMOTE_STATUS2.
    pub static update_remote_status2: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "update_remote_status2".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 16, bucket_count: 17, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5638), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.update_server_response_time
    ///
    /// Server response time to update request (ms). Keyed by provider
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_UPDATE_SERVER_RESPONSE_TIME.
    pub static update_server_response_time: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "update_server_response_time".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5639), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.update_timeout
    ///
    /// Whether or not an update timed out (0 = no timeout, 1 = server respond
    /// timeout, 2 = overall timeout). Keyed by provider This metric was generated to correspond to the Legacy Telemetry enumerated histogram URLCLASSIFIER_UPDATE_TIMEOUT.
    pub static update_timeout: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "update_timeout".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 4, bucket_count: 5, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5640), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.vlps_construct_time
    ///
    /// Time spent constructing Variable-Length PrefixSet from file (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_VLPS_CONSTRUCT_TIME.
    pub static vlps_construct_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vlps_construct_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5641), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.vlps_fallocate_time
    ///
    /// Time spent fallocating Variable-Length PrefixSet (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_VLPS_FALLOCATE_TIME.
    pub static vlps_fallocate_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vlps_fallocate_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5642), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.vlps_fileload_time
    ///
    /// Time spent loading Variable-Length PrefixSet from file (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram URLCLASSIFIER_VLPS_FILELOAD_TIME.
    pub static vlps_fileload_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vlps_fileload_time".into(),
                category: "urlclassifier".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5643), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum VlpsMetadataCorruptLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for VlpsMetadataCorruptLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for VlpsMetadataCorruptLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from urlclassifier.vlps_metadata_corrupt
    ///
    /// Whether or not the metadata for a variable-length prefix set loaded from disk is corrupted (true = file corrupted).
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram URLCLASSIFIER_VLPS_METADATA_CORRUPT.
    pub static vlps_metadata_corrupt: Lazy<LabeledMetric<LabeledCounterMetric, VlpsMetadataCorruptLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "vlps_metadata_corrupt".into(),
                    category: "urlclassifier".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5644), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod findbar {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from findbar.find_next
    ///
    /// The count of how many times the find next button was used per session. This metric was generated to correspond to the Legacy Telemetry scalar findbar.find_next.
    pub static find_next: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5645,
            "findbar",
            "find_next",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.find_prev
    ///
    /// The count of how many times the find previous button was used per session. This metric was generated to correspond to the Legacy Telemetry scalar findbar.find_prev.
    pub static find_prev: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5646,
            "findbar",
            "find_prev",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.highlight_all
    ///
    /// The count of how many times the "Highlight All" button was used in find toolbar. This metric was generated to correspond to the Legacy Telemetry scalar findbar.highlight_all.
    pub static highlight_all: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5647,
            "findbar",
            "highlight_all",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.match_case
    ///
    /// The count of how many times the "Match Case" button was used in find toolbar. This metric was generated to correspond to the Legacy Telemetry scalar findbar.match_case.
    pub static match_case: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5648,
            "findbar",
            "match_case",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.match_diacritics
    ///
    /// The count of how many times the "Match Diacritics" button was used in find toolbar. This metric was generated to correspond to the Legacy Telemetry scalar findbar.match_diacritics.
    pub static match_diacritics: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5649,
            "findbar",
            "match_diacritics",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.shown
    ///
    /// The count of how many times the "Find toolbar" was shown per session. This metric was generated to correspond to the Legacy Telemetry scalar findbar.shown.
    pub static shown: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5650,
            "findbar",
            "shown",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from findbar.whole_words
    ///
    /// The count of how many times the "Whole Words" button was used in find toolbar. This metric was generated to correspond to the Legacy Telemetry scalar findbar.whole_words.
    pub static whole_words: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5651,
            "findbar",
            "whole_words",
            "metrics"
        )
    });

}
pub mod security_doh_neterror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAddExceptionButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAddExceptionButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_add_exception_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#add_exception_button.
    pub static click_add_exception_button: Lazy<EventMetric<ClickAddExceptionButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_add_exception_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5652), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickContinueButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickContinueButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_continue_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#continue_button.
    pub static click_continue_button: Lazy<EventMetric<ClickContinueButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_continue_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5653), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickDisableWarningExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickDisableWarningExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_disable_warning
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#disable_warning.
    pub static click_disable_warning: Lazy<EventMetric<ClickDisableWarningExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_disable_warning".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5654), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLearnMoreLinkExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLearnMoreLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_learn_more_link
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#learn_more_link.
    pub static click_learn_more_link: Lazy<EventMetric<ClickLearnMoreLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_learn_more_link".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5655), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickSettingsButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickSettingsButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_settings_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#settings_button.
    pub static click_settings_button: Lazy<EventMetric<ClickSettingsButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_settings_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5656), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickTryAgainButtonExtra {
        pub r#mode: Option<String>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickTryAgainButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.click_try_again_button
    ///
    /// User interaction by click buttons on the DoH warning page. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.click#try_again_button.
    pub static click_try_again_button: Lazy<EventMetric<ClickTryAgainButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_try_again_button".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5657), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadDohwarningExtra {
        pub r#mode: Option<u32>,
        pub r#provider_key: Option<String>,
        pub r#skip_reason: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadDohwarningExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["mode", "provider_key", "skip_reason", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#mode.and_then(|val| map.insert("mode".into(), val.to_string()));
          self.r#provider_key.and_then(|val| map.insert("provider_key".into(), val.to_string()));
          self.r#skip_reason.and_then(|val| map.insert("skip_reason".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.doh.neterror.load_dohwarning
    ///
    /// The DoH warning page is loaded. This event was generated to correspond to the Legacy Telemetry event security.doh.neterror.load#dohwarning.
    pub static load_dohwarning: Lazy<EventMetric<LoadDohwarningExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_dohwarning".into(),
                category: "security.doh.neterror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5658), meta)
    });

}
pub mod security_ui_certerror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAdvancedButtonExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAdvancedButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_advanced_button
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#advanced_button.
    pub static click_advanced_button: Lazy<EventMetric<ClickAdvancedButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_advanced_button".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5659), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickAutoReportCbExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickAutoReportCbExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_auto_report_cb
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#auto_report_cb.
    pub static click_auto_report_cb: Lazy<EventMetric<ClickAutoReportCbExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_auto_report_cb".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5660), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickClipboardButtonBotExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickClipboardButtonBotExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_clipboard_button_bot
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#clipboard_button_bot.
    pub static click_clipboard_button_bot: Lazy<EventMetric<ClickClipboardButtonBotExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_clipboard_button_bot".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5661), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickClipboardButtonTopExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickClipboardButtonTopExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_clipboard_button_top
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#clipboard_button_top.
    pub static click_clipboard_button_top: Lazy<EventMetric<ClickClipboardButtonTopExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_clipboard_button_top".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5662), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickErrorCodeLinkExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickErrorCodeLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_error_code_link
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#error_code_link.
    pub static click_error_code_link: Lazy<EventMetric<ClickErrorCodeLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_error_code_link".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5663), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickExceptionButtonExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickExceptionButtonExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_exception_button
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#exception_button.
    pub static click_exception_button: Lazy<EventMetric<ClickExceptionButtonExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_exception_button".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5664), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickLearnMoreLinkExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickLearnMoreLinkExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_learn_more_link
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#learn_more_link.
    pub static click_learn_more_link: Lazy<EventMetric<ClickLearnMoreLinkExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_learn_more_link".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5665), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickReturnButtonAdvExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickReturnButtonAdvExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_return_button_adv
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#return_button_adv.
    pub static click_return_button_adv: Lazy<EventMetric<ClickReturnButtonAdvExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_return_button_adv".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5666), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ClickReturnButtonTopExtra {
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for ClickReturnButtonTopExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["has_sts", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.click_return_button_top
    ///
    /// User interaction by click events on the cert error page. Keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.click#return_button_top.
    pub static click_return_button_top: Lazy<EventMetric<ClickReturnButtonTopExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "click_return_button_top".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5667), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAboutcerterrorExtra {
        pub r#channel_status: Option<u32>,
        pub r#has_sts: Option<bool>,
        pub r#is_frame: Option<bool>,
        pub r#issued_by_cca: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAboutcerterrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["channel_status", "has_sts", "is_frame", "issued_by_cca", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#channel_status.and_then(|val| map.insert("channel_status".into(), val.to_string()));
          self.r#has_sts.and_then(|val| map.insert("has_sts".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#issued_by_cca.and_then(|val| map.insert("issued_by_cca".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.certerror.load_aboutcerterror
    ///
    /// The about:certerror page is loaded, keyed by error code, see https://searchfox.org/mozilla- central/source/security/nss/lib/mozpkix/include/pkix/Result.h This event was generated to correspond to the Legacy Telemetry event security.ui.certerror.load#aboutcerterror.
    pub static load_aboutcerterror: Lazy<EventMetric<LoadAboutcerterrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_aboutcerterror".into(),
                category: "security.ui.certerror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5668), meta)
    });

}
pub mod security_ui_tlserror {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAbouttlserrorExtra {
        pub r#channel_status: Option<u32>,
        pub r#is_frame: Option<bool>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAbouttlserrorExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["channel_status", "is_frame", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#channel_status.and_then(|val| map.insert("channel_status".into(), val.to_string()));
          self.r#is_frame.and_then(|val| map.insert("is_frame".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from security.ui.tlserror.load_abouttlserror
    ///
    /// The about:neterror page is loaded with a TLS error or non- overridable certificate error, keyed by error code. This event was generated to correspond to the Legacy Telemetry event security.ui.tlserror.load#abouttlserror.
    pub static load_abouttlserror: Lazy<EventMetric<LoadAbouttlserrorExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_abouttlserror".into(),
                category: "security.ui.tlserror".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5669), meta)
    });

}
pub mod mozstorage {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from mozstorage.sqlitejsm_transaction_timeout
    ///
    /// Collection of javascript modules that created a Sqlite.sys.mjs transaction taking too long and timing out. This can be used to identify and optimize those modules transactions. This metric was generated to correspond to the Legacy Telemetry scalar mozstorage.sqlitejsm_transaction_timeout.
    pub static sqlitejsm_transaction_timeout: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sqlitejsm_transaction_timeout".into(),
                    category: "mozstorage".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5670), meta, None)
    });

}
pub mod region {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from region.fetch_result
    ///
    /// Result of XHR request fetching the country-code. 0=SUCCESS, 1=SUCCESS_WITHOUT_DATA, 2=XHRTIMEOUT, 3=ERROR (rest reserved for finer-grained error codes later)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SEARCH_SERVICE_COUNTRY_FETCH_RESULT.
    pub static fetch_result: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fetch_result".into(),
                category: "region".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5671), meta, 0, 8, 9, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from region.fetch_time
    ///
    /// Time (ms) it takes to fetch the country code
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram SEARCH_SERVICE_COUNTRY_FETCH_TIME_MS.
    pub static fetch_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "fetch_time".into(),
                category: "region".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5672), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from region.home_region
    ///
    /// Records the detected home region of the user. This is the general region of the user's machine.
    /// If a machine moves location, there is a minimum 2-week delay before this will be updated.
    /// See the [Region documentation](https://firefox-source-docs.mozilla.org/toolkit/modules/toolkit_modules/Region.html) for more information about updates.
    pub static home_region: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "home_region".into(),
                category: "region".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5673), meta)
    });

    #[repr(u16)]
    pub enum StoreRegionResultLabel {
        ESetforrestofworld = 0,
        ESetforunitedstates = 1,
        EIgnoredunitedstatesincorrecttimezone = 2,
        __Other__,
    }
    impl From<u16> for StoreRegionResultLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ESetforrestofworld,
                1 => Self::ESetforunitedstates,
                2 => Self::EIgnoredunitedstatesincorrecttimezone,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for StoreRegionResultLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ESetforrestofworld => "setForRestOfWorld",
                Self::ESetforunitedstates => "setForUnitedStates",
                Self::EIgnoredunitedstatesincorrecttimezone => "ignoredUnitedStatesIncorrectTimezone",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from region.store_region_result
    ///
    /// Records if a detected region value was stored or ignored. A region might be ignored if it is the US but the set timezone is not the US.
    pub static store_region_result: Lazy<LabeledMetric<LabeledCounterMetric, StoreRegionResultLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "store_region_result".into(),
                    category: "region".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5674), meta, Some(vec![::std::borrow::Cow::from("ignoredUnitedStatesIncorrectTimezone"), ::std::borrow::Cow::from("setForRestOfWorld"), ::std::borrow::Cow::from("setForUnitedStates")]))
    });

}
pub mod first_startup {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.delete_tasks_time
    ///
    /// Number of milliseconds until TaskScheduler.deleteAllTasks resolved in FirstStartup.
    pub static delete_tasks_time: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "delete_tasks_time".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5675), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.elapsed
    ///
    /// Number of milliseconds the FirstStartup service took to run.
    pub static elapsed: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "elapsed".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5676), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.new_profile
    ///
    /// True if FirstStartup was initted after a new profile was just created. If false, this means that FirstStartup was initted with a pre-existing profile, which is a no-op.
    pub static new_profile: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "new_profile".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5677), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.normandy_init_time
    ///
    /// Number of milliseconds until Normandy.init resolved in FirstStartup.
    pub static normandy_init_time: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "normandy_init_time".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5678), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from first_startup.status_code
    ///
    /// Status of the FirstStartup service, which runs
    /// post-install/early-startup in Firefox.
    pub static status_code: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_code".into(),
                category: "first_startup".into(),
                send_in_pings: vec!["first-startup".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5679), meta)
    });

}
pub mod jsonfile {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadAutofillprofilesExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadAutofillprofilesExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from jsonfile.load_autofillprofiles
    ///
    /// Records when JSONFile.sys.mjs consumers are trying to access a missing or corrupt json file. For example, Login Store trying to access logins.json when it has gone missing or corrupt. This event was generated to correspond to the Legacy Telemetry event jsonfile.load#autofillprofiles.
    pub static load_autofillprofiles: Lazy<EventMetric<LoadAutofillprofilesExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_autofillprofiles".into(),
                category: "jsonfile".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5680), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct LoadLoginsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for LoadLoginsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from jsonfile.load_logins
    ///
    /// Records when JSONFile.sys.mjs consumers are trying to access a missing or corrupt json file. For example, Login Store trying to access logins.json when it has gone missing or corrupt. This event was generated to correspond to the Legacy Telemetry event jsonfile.load#logins.
    pub static load_logins: Lazy<EventMetric<LoadLoginsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "load_logins".into(),
                category: "jsonfile".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5681), meta)
    });

}
pub mod newtab_page {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from newtab_page.blocked_sites_count
    ///
    /// Number of sites blocked from the new tab page.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram NEWTAB_PAGE_BLOCKED_SITES_COUNT.
    pub static blocked_sites_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "blocked_sites_count".into(),
                category: "newtab_page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5682), meta, 1, 100, 10, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from newtab_page.pinned_sites_count
    ///
    /// Number of pinned sites on the new tab page.
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram NEWTAB_PAGE_PINNED_SITES_COUNT.
    pub static pinned_sites_count: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pinned_sites_count".into(),
                category: "newtab_page".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5683), meta, 0, 9, 10, HistogramType::Linear)
    });

}
pub mod popup_notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from popup_notification.dismissal
    ///
    /// (Bug 1207089) Time in ms between displaying a popup notification and dismissing it without an action the first time, keyed by ID
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram POPUP_NOTIFICATION_DISMISSAL_MS.
    pub static dismissal: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "dismissal".into(),
                    category: "popup_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5684), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from popup_notification.main_action
    ///
    /// (Bug 1207089) Time in ms between initially requesting a popup notification and triggering the main action, keyed by ID
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram POPUP_NOTIFICATION_MAIN_ACTION_MS.
    pub static main_action: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "main_action".into(),
                    category: "popup_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5685), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from popup_notification.stats
    ///
    /// (Bug 1207089) Usage of popup notifications, keyed by ID (0 = Offered, 1..4 = Action (3 is unused), 5 = Click outside (unused), 6 = Leave page, 7 = Use 'X' (unused), 8 = Not now (unused), 10 = Open submenu, 11 = Learn more. Add 20 if happened after reopen.)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram POPUP_NOTIFICATION_STATS.
    pub static stats: Lazy<LabeledMetric<LabeledCustomDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::CustomDistribution {
                cmd: CommonMetricData {
                    name: "stats".into(),
                    category: "popup_notification".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, range_min: 0, range_max: 40, bucket_count: 41, histogram_type: HistogramType::Linear};
        LabeledMetric::new(BaseMetricId(5686), meta, None)
    });

}
pub mod service_request {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct BypassProxyInfoExtra {
        pub r#source: Option<String>,
        pub r#type: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for BypassProxyInfoExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["source", "type", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#type.and_then(|val| map.insert("type".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from service_request.bypass_proxy_info
    ///
    /// This event is recorded by a small set of services when a proxy failure causes a service to re-request with a proxy bypass.  It records some basic information such as the type of proxy configuration, and the source of the proxy configuration.  The value of the event is the name of the service that triggers the event (e.g. telemetry, remote-settings). This event was generated to correspond to the Legacy Telemetry event service_request.bypass#proxy_info.
    pub static bypass_proxy_info: Lazy<EventMetric<BypassProxyInfoExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bypass_proxy_info".into(),
                category: "service_request".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5687), meta)
    });

}
pub mod defaultagent {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from defaultagent.days_since_last_app_launch
    ///
    /// Number of days since the app last launched. Once this reaches 90 days, the installation will stop running the default browser agent.
    pub static days_since_last_app_launch: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "days_since_last_app_launch".into(),
                category: "defaultagent".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5688), meta)
    });

}
pub mod notification {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from notification.action
    ///
    /// The action that the user took in response to the notification. Possible values currently include the following: * “dismissed-by-timeout” * “dismissed-to-action-center” * “dismissed-by-button” * “dismissed-by-application-hidden” * “make-firefox-default-button” * “toast-clicked”
    /// Many of the values correspond to buttons on the notification and should be pretty self explanatory, but a few are less so. * “dismissed-to-action-center” will be used if the user clicks the arrow in
    ///   the top right corner of the notification to dismiss it to the
    ///   action center.
    /// * “dismissed-by-application-hidden” is provided because that is a method of
    ///   dismissal that the notification API could give but, in practice, should
    ///   never be seen.
    /// * “dismissed-by-timeout” indicates that the user did not interact with the
    ///   notification and it timed out.
    pub static action: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "action".into(),
                category: "notification".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5689), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from notification.show_success
    ///
    /// Whether a notification was shown or not. Possible value include "shown" and "error".
    pub static show_success: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "show_success".into(),
                category: "notification".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5690), meta)
    });

}
pub mod system {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system.os_version
    ///
    /// The current Windows OS version, usually as a dotted quad ("x.y.z.w") with Windows Update Build Revision (UBR), but potentially as a dotted triple ("x.y.z") without UBR.
    pub static os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "os_version".into(),
                category: "system".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5691), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.previous_os_version
    ///
    /// The Windows OS version before it was changed to the current setting. The possible values are the same as for `system.os_version`.
    /// The OS does not keep track of the previous OS version, so the agent records this information itself. That means that it will be inaccurate until the first time the default is changed after the agent task begins running. Before then, the value of `previous_os_version` will be the same as `os_version`.
    /// This value is updated every time the Default Agent runs, so when the default browser is first changed the values for `os_version` and `previous_os_version` will be different. But on subsequent executions of the Default Agent, the two values will be the same.
    pub static previous_os_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previous_os_version".into(),
                category: "system".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5692), meta)
    });

}
pub mod system_default {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system_default.browser
    ///
    /// Which browser is currently set as the system default web browser. This is simply a string with the name of the browser binned to a fixed set of known browsers.
    /// Possible values currently include the following (from [DefaultBrowser.cpp](https://searchfox.org/mozilla-central/source/toolkit/mozapps/defaultagent/DefaultBrowser.cpp)): * "error" * "" (unknown) * "firefox" * "chrome" * "edge" * "edge-chrome" * "ie" * "opera" * "brave" * "yandex" * "qq-browser" * "360-browser" * "sogou" * "duckduckgo"
    pub static browser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "browser".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5693), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.pdf_handler
    ///
    /// Which pdf handler is currently set as the system default handler. This is simply a string with the name of the handler binned to a fixed set of known handlers.
    /// Possible values currently include the following (from [DefaultPDF.cpp](https://searchfox.org/mozilla-central/source/toolkit/mozapps/defaultagent/DefaultPDF.cpp)): * "Error" * "" (unknown) * "Firefox" * "Microsoft Edge" * "Google Chrome" * "Adobe Acrobat" * "WPS" * "Nitro" * "Foxit" * "PDF-XChange" * "Avast" * "Sumatra"
    pub static pdf_handler: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pdf_handler".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5694), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system_default.previous_browser
    ///
    /// Which browser was set as the system default before it was changed to the current setting. The possible values are the same as for `system_default.browser`.
    /// The OS does not keep track of previous default settings, so the agent records this information itself. That means that it will be inaccurate until the first time the default is changed after the agent task begins running. Before then, the value of `previous_browser` will be the same as `browser`.
    /// This value is updated every time the Default Agent runs, so when the default browser is first changed the values for `browser` and `previous_browser` will be different. But on subsequent executions of the Default Agent, the two values will be the same.
    pub static previous_browser: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "previous_browser".into(),
                category: "system_default".into(),
                send_in_pings: vec!["default-agent".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5695), meta)
    });

}
pub mod addons {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

        pub type ActiveAddonsObject = Vec<ActiveAddonsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ActiveAddonsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub blocklisted: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub description: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub name: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub userDisabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub appDisabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub scope: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub addonType: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub foreignInstall: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub hasBinaryComponents: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub installDay: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub updateDay: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub signedState: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub signedTypes: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isSystem: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub isWebExtension: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub multiprocessCompatible: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub quarantineIgnoredByApp: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub quarantineIgnoredByUser: Option<bool>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from addons.active_addons
    ///
    /// The list of currently enabled addons.
    /// 
    /// Some of the addon fields are not available during startup. The fields
    /// that will always be present are id, version, addonType, updateDay, scope,
    /// isSystem, isWebExtension, and multiprocessCompatible. All the other
    /// fields become present shortly after the `sessionstore-windows-restored`
    /// observer topic is notified.
    /// 
    /// This metric is an echo of the Legacy Telemetry Environment field
    /// addons.activeAddons. Like its counterpart, it will only have data in
    /// Firefox Desktop and at times and on platforms where the environment would
    /// have values.
    pub static active_addons: Lazy<ObjectMetric<ActiveAddonsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_addons".into(),
                category: "addons".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5696), meta)
    });

        pub type ActiveGMPluginsObject = Vec<ActiveGMPluginsObjectItem>;

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ActiveGMPluginsObjectItem {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub userDisabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub applyBackgroundUpdates: Option<i64>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from addons.active_g_m_plugins
    ///
    /// The list of currently enabled Gecko Media Plugins.
    /// 
    /// Some of the addon fields are not available during startup. The fields
    /// that will always be present are id and version. All the other
    /// fields become present shortly after the `sessionstore-windows-restored`
    /// observer topic is notified.
    /// 
    /// This metric is an echo of the Legacy Telemetry Environment field
    /// addons.activeGMPlugins. Like its counterpart, it will only have data in
    /// Firefox Desktop and at times and on platforms where the environment would
    /// have values.
    pub static active_g_m_plugins: Lazy<ObjectMetric<ActiveGMPluginsObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "active_g_m_plugins".into(),
                category: "addons".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5697), meta)
    });

        #[derive(Debug, Hash, Eq, PartialEq, Clone, ::glean::traits::__serde::Serialize, ::glean::traits::__serde::Deserialize)]
    #[allow(non_snake_case)]
    #[serde(deny_unknown_fields)]
    pub struct ThemeObject {
          #[serde(skip_serializing_if = "Option::is_none")]
          pub id: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub blocklisted: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub description: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub name: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub userDisabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub appDisabled: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub version: Option<String>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub scope: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub foreignInstall: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub hasBinaryComponents: Option<bool>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub installDay: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub updateDay: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub signedState: Option<i64>,
          #[serde(skip_serializing_if = "Option::is_none")]
          pub signedTypes: Option<String>,
    }

    #[allow(non_upper_case_globals)]
    /// generated from addons.theme
    ///
    /// The currently active theme.
    /// 
    /// Some of the addon fields are not available during startup. The fields
    /// that will always be present are id, version, updateDay, and scope. All
    /// the other fields become present shortly after the
    /// `sessionstore-windows-restored` observer topic is notified.
    /// 
    /// This metric is an echo of the Legacy Telemetry Environment field
    /// addons.theme. Like its counterpart, it will only have data in Firefox
    /// Desktop and at times and on platforms where the environment would have
    /// values.
    pub static theme: Lazy<ObjectMetric<ThemeObject>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "theme".into(),
                category: "addons".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        ObjectMetric::new(BaseMetricId(5698), meta)
    });

}
pub mod addons_manager {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.compatibility_check_enabled
    ///
    /// Whether application compatibility is enforced for add-ons.
    pub static compatibility_check_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "compatibility_check_enabled".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5699), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#download_time: Option<u32>,
        pub r#error: Option<String>,
        pub r#install_id: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
    }

    impl ExtraKeys for InstallExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static install: Lazy<EventMetric<InstallExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5700), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
    }

    impl ExtraKeys for InstallStatsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats
    ///
    /// These events are recorded at the end of the install flow, but only
    /// when the source that originally triggered the add-on installation
    /// is "amo", "rtamo" or "disco".
    pub static install_stats: Lazy<EventMetric<InstallStatsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5701), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ManageExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
    }

    impl ExtraKeys for ManageExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "blocklist_state", "method", "num_strings", "source", "source_method"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.manage
    ///
    /// This events are recorded when an installed add-ons is being
    /// disable/enabled/uninstalled.
    pub static manage: Lazy<EventMetric<ManageExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "manage".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5702), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct ReportSuspiciousSiteExtra {
        pub r#suspicious_site: Option<String>,
    }

    impl ExtraKeys for ReportSuspiciousSiteExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["suspicious_site"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#suspicious_site.and_then(|val| map.insert("suspicious_site".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.report_suspicious_site
    ///
    /// Sent when a user clicks "Report Suspicious Site" on the dropdown
    /// menu of the third-party xpinstall doorhanger.
    pub static report_suspicious_site: Lazy<EventMetric<ReportSuspiciousSiteExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "report_suspicious_site".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5703), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateExtra {
        pub r#addon_id: Option<String>,
        pub r#addon_type: Option<String>,
        pub r#download_time: Option<u32>,
        pub r#error: Option<String>,
        pub r#install_id: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#num_strings: Option<u32>,
        pub r#source: Option<String>,
        pub r#source_method: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
    }

    impl ExtraKeys for UpdateExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "addon_type", "download_time", "error", "install_id", "install_origins", "num_strings", "source", "source_method", "step", "updated_from"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#addon_type.and_then(|val| map.insert("addon_type".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_id.and_then(|val| map.insert("install_id".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#source_method.and_then(|val| map.insert("source_method".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update
    ///
    /// These events are recorded during the install and update flow for
    /// extensions and themes.
    pub static update: Lazy<EventMetric<UpdateExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5704), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct XpistatesWriteErrorsExtra {
        pub r#error_type: Option<String>,
        pub r#profile_state: Option<String>,
    }

    impl ExtraKeys for XpistatesWriteErrorsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["error_type", "profile_state"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#error_type.and_then(|val| map.insert("error_type".into(), val.to_string()));
          self.r#profile_state.and_then(|val| map.insert("profile_state".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.xpistates_write_errors
    ///
    /// Sent when saving addonStartup.json.lz4 data back to disk fails.
    pub static xpistates_write_errors: Lazy<EventMetric<XpistatesWriteErrorsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "xpistates_write_errors".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5705), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_dictionary
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#dictionary.
    pub static disable_dictionary: Lazy<EventMetric<DisableDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5706), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_extension
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#extension.
    pub static disable_extension: Lazy<EventMetric<DisableExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5707), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_locale
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#locale.
    pub static disable_locale: Lazy<EventMetric<DisableLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5708), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_other
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#other.
    pub static disable_other: Lazy<EventMetric<DisableOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5709), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#siteperm_deprecated.
    pub static disable_siteperm_deprecated: Lazy<EventMetric<DisableSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5710), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#sitepermission.
    pub static disable_sitepermission: Lazy<EventMetric<DisableSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5711), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_theme
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#theme.
    pub static disable_theme: Lazy<EventMetric<DisableThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5712), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct DisableUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for DisableUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.disable_unknown
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.disable#unknown.
    pub static disable_unknown: Lazy<EventMetric<DisableUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "disable_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5713), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_dictionary
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#dictionary.
    pub static enable_dictionary: Lazy<EventMetric<EnableDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5714), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_extension
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#extension.
    pub static enable_extension: Lazy<EventMetric<EnableExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5715), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_locale
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#locale.
    pub static enable_locale: Lazy<EventMetric<EnableLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5716), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_other
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#other.
    pub static enable_other: Lazy<EventMetric<EnableOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5717), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#siteperm_deprecated.
    pub static enable_siteperm_deprecated: Lazy<EventMetric<EnableSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5718), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#sitepermission.
    pub static enable_sitepermission: Lazy<EventMetric<EnableSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5719), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_theme
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#theme.
    pub static enable_theme: Lazy<EventMetric<EnableThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5720), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct EnableUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for EnableUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.enable_unknown
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.enable#unknown.
    pub static enable_unknown: Lazy<EventMetric<EnableUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enable_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5721), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_dictionary
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#dictionary.
    pub static install_dictionary: Lazy<EventMetric<InstallDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5722), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_extension
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#extension.
    pub static install_extension: Lazy<EventMetric<InstallExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5723), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_locale
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#locale.
    pub static install_locale: Lazy<EventMetric<InstallLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5724), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_other
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#other.
    pub static install_other: Lazy<EventMetric<InstallOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5725), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_siteperm_deprecated
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#siteperm_deprecated.
    pub static install_siteperm_deprecated: Lazy<EventMetric<InstallSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5726), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_sitepermission
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#sitepermission.
    pub static install_sitepermission: Lazy<EventMetric<InstallSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5727), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_dictionary
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#dictionary.
    pub static install_stats_dictionary: Lazy<EventMetric<InstallStatsDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5728), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_extension
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#extension.
    pub static install_stats_extension: Lazy<EventMetric<InstallStatsExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5729), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_locale
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#locale.
    pub static install_stats_locale: Lazy<EventMetric<InstallStatsLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5730), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_other
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#other.
    pub static install_stats_other: Lazy<EventMetric<InstallStatsOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5731), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_siteperm_deprecated
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#siteperm_deprecated.
    pub static install_stats_siteperm_deprecated: Lazy<EventMetric<InstallStatsSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5732), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_sitepermission
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#sitepermission.
    pub static install_stats_sitepermission: Lazy<EventMetric<InstallStatsSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5733), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_theme
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#theme.
    pub static install_stats_theme: Lazy<EventMetric<InstallStatsThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5734), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallStatsUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#taar_based: Option<String>,
        pub r#utm_campaign: Option<String>,
        pub r#utm_content: Option<String>,
        pub r#utm_medium: Option<String>,
        pub r#utm_source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallStatsUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "taar_based", "utm_campaign", "utm_content", "utm_medium", "utm_source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#taar_based.and_then(|val| map.insert("taar_based".into(), val.to_string()));
          self.r#utm_campaign.and_then(|val| map.insert("utm_campaign".into(), val.to_string()));
          self.r#utm_content.and_then(|val| map.insert("utm_content".into(), val.to_string()));
          self.r#utm_medium.and_then(|val| map.insert("utm_medium".into(), val.to_string()));
          self.r#utm_source.and_then(|val| map.insert("utm_source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_stats_unknown
    ///
    /// These events are recorded at the end of the install flow, but only when the source that originally triggered the add-on installation is "amo", "rtamo" or "disco". The value of an event is the SHA256 hash of the addon_id. This event was generated to correspond to the Legacy Telemetry event addonsManager.install_stats#unknown.
    pub static install_stats_unknown: Lazy<EventMetric<InstallStatsUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_stats_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5735), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_theme
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#theme.
    pub static install_theme: Lazy<EventMetric<InstallThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5736), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct InstallUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for InstallUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.install_unknown
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.install#unknown.
    pub static install_unknown: Lazy<EventMetric<InstallUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "install_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5737), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_dictionary
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#dictionary.
    pub static sideload_prompt_dictionary: Lazy<EventMetric<SideloadPromptDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5738), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_extension
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#extension.
    pub static sideload_prompt_extension: Lazy<EventMetric<SideloadPromptExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5739), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_locale
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#locale.
    pub static sideload_prompt_locale: Lazy<EventMetric<SideloadPromptLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5740), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_other
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#other.
    pub static sideload_prompt_other: Lazy<EventMetric<SideloadPromptOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5741), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#siteperm_deprecated.
    pub static sideload_prompt_siteperm_deprecated: Lazy<EventMetric<SideloadPromptSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5742), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#sitepermission.
    pub static sideload_prompt_sitepermission: Lazy<EventMetric<SideloadPromptSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5743), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_theme
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#theme.
    pub static sideload_prompt_theme: Lazy<EventMetric<SideloadPromptThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5744), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct SideloadPromptUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for SideloadPromptUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.sideload_prompt_unknown
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.sideload_prompt#unknown.
    pub static sideload_prompt_unknown: Lazy<EventMetric<SideloadPromptUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "sideload_prompt_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5745), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallDictionaryExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_dictionary
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#dictionary.
    pub static uninstall_dictionary: Lazy<EventMetric<UninstallDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5746), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallExtensionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_extension
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#extension.
    pub static uninstall_extension: Lazy<EventMetric<UninstallExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5747), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallLocaleExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_locale
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#locale.
    pub static uninstall_locale: Lazy<EventMetric<UninstallLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5748), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallOtherExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_other
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#other.
    pub static uninstall_other: Lazy<EventMetric<UninstallOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5749), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallSitepermDeprecatedExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_siteperm_deprecated
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#siteperm_deprecated.
    pub static uninstall_siteperm_deprecated: Lazy<EventMetric<UninstallSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5750), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallSitepermissionExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_sitepermission
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#sitepermission.
    pub static uninstall_sitepermission: Lazy<EventMetric<UninstallSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5751), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallThemeExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_theme
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#theme.
    pub static uninstall_theme: Lazy<EventMetric<UninstallThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5752), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UninstallUnknownExtra {
        pub r#blocklist_state: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UninstallUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["blocklist_state", "method", "num_strings", "source", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.uninstall_unknown
    ///
    /// This events are recorded when an installed add-ons is being disable/enabled/uninstalled, the value of the event is the addon_id (which also allow to correlate multiple events related to each other). This event was generated to correspond to the Legacy Telemetry event addonsManager.uninstall#unknown.
    pub static uninstall_unknown: Lazy<EventMetric<UninstallUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "uninstall_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5753), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateDictionaryExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateDictionaryExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_dictionary
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#dictionary.
    pub static update_dictionary: Lazy<EventMetric<UpdateDictionaryExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_dictionary".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5754), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateExtensionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateExtensionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_extension
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#extension.
    pub static update_extension: Lazy<EventMetric<UpdateExtensionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_extension".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5755), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateLocaleExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateLocaleExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_locale
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#locale.
    pub static update_locale: Lazy<EventMetric<UpdateLocaleExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_locale".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5756), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateOtherExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateOtherExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_other
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#other.
    pub static update_other: Lazy<EventMetric<UpdateOtherExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_other".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5757), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateSitepermDeprecatedExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateSitepermDeprecatedExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_siteperm_deprecated
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#siteperm_deprecated.
    pub static update_siteperm_deprecated: Lazy<EventMetric<UpdateSitepermDeprecatedExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_siteperm_deprecated".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5758), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateSitepermissionExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateSitepermissionExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_sitepermission
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#sitepermission.
    pub static update_sitepermission: Lazy<EventMetric<UpdateSitepermissionExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_sitepermission".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5759), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateThemeExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateThemeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_theme
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#theme.
    pub static update_theme: Lazy<EventMetric<UpdateThemeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_theme".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5760), meta)
    });

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct UpdateUnknownExtra {
        pub r#addon_id: Option<String>,
        pub r#download_time: Option<String>,
        pub r#error: Option<String>,
        pub r#install_origins: Option<String>,
        pub r#method: Option<String>,
        pub r#num_strings: Option<String>,
        pub r#source: Option<String>,
        pub r#step: Option<String>,
        pub r#updated_from: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for UpdateUnknownExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_id", "download_time", "error", "install_origins", "method", "num_strings", "source", "step", "updated_from", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_id.and_then(|val| map.insert("addon_id".into(), val.to_string()));
          self.r#download_time.and_then(|val| map.insert("download_time".into(), val.to_string()));
          self.r#error.and_then(|val| map.insert("error".into(), val.to_string()));
          self.r#install_origins.and_then(|val| map.insert("install_origins".into(), val.to_string()));
          self.r#method.and_then(|val| map.insert("method".into(), val.to_string()));
          self.r#num_strings.and_then(|val| map.insert("num_strings".into(), val.to_string()));
          self.r#source.and_then(|val| map.insert("source".into(), val.to_string()));
          self.r#step.and_then(|val| map.insert("step".into(), val.to_string()));
          self.r#updated_from.and_then(|val| map.insert("updated_from".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from addons_manager.update_unknown
    ///
    /// These events are recorded during the install and update flow for extensions and themes, the value of the event is an install_id shared by the events related to the same install or update flow. This event was generated to correspond to the Legacy Telemetry event addonsManager.update#unknown.
    pub static update_unknown: Lazy<EventMetric<UpdateUnknownExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "update_unknown".into(),
                category: "addons_manager".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5761), meta)
    });

}
pub mod blocklist {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct AddonBlockChangeExtra {
        pub r#addon_version: Option<String>,
        pub r#blocklist_state: Option<String>,
        pub r#hours_since: Option<String>,
        pub r#mlbf_generation: Option<String>,
        pub r#mlbf_last_time: Option<String>,
        pub r#mlbf_softblocks_generation: Option<String>,
        pub r#mlbf_softblocks_source: Option<String>,
        pub r#mlbf_source: Option<String>,
        pub r#object: Option<String>,
        pub r#signed_date: Option<String>,
        pub r#value: Option<String>,
    }

    impl ExtraKeys for AddonBlockChangeExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["addon_version", "blocklist_state", "hours_since", "mlbf_generation", "mlbf_last_time", "mlbf_softblocks_generation", "mlbf_softblocks_source", "mlbf_source", "object", "signed_date", "value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#addon_version.and_then(|val| map.insert("addon_version".into(), val.to_string()));
          self.r#blocklist_state.and_then(|val| map.insert("blocklist_state".into(), val.to_string()));
          self.r#hours_since.and_then(|val| map.insert("hours_since".into(), val.to_string()));
          self.r#mlbf_generation.and_then(|val| map.insert("mlbf_generation".into(), val.to_string()));
          self.r#mlbf_last_time.and_then(|val| map.insert("mlbf_last_time".into(), val.to_string()));
          self.r#mlbf_softblocks_generation.and_then(|val| map.insert("mlbf_softblocks_generation".into(), val.to_string()));
          self.r#mlbf_softblocks_source.and_then(|val| map.insert("mlbf_softblocks_source".into(), val.to_string()));
          self.r#mlbf_source.and_then(|val| map.insert("mlbf_source".into(), val.to_string()));
          self.r#object.and_then(|val| map.insert("object".into(), val.to_string()));
          self.r#signed_date.and_then(|val| map.insert("signed_date".into(), val.to_string()));
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from blocklist.addon_block_change
    ///
    /// An add-on is blocked, or an installed add-on is unblocked. When an add-on install/update is blocked, its installation is aborted and the add-on is no longer listed in the activeAddons field of TelemetryEnvironment.
    pub static addon_block_change: Lazy<EventMetric<AddonBlockChangeExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "addon_block_change".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5762), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.enabled
    ///
    /// Whether the extension blocklist is enabled.
    /// Corresponds to the `extensions.blocklist.enabled` pref.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5763), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.last_modified_rs_addons_mblf
    ///
    /// Keep track of the last time the "addons-bloomfilters" remotesetting blocklist has been successfully updated.
    pub static last_modified_rs_addons_mblf: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_modified_rs_addons_mblf".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5764), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This marks the point in time until which signed add-ons are recognized by the selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_generation_time".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5765), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_softblocks_generation_time
    ///
    /// Keep track of the generation time of the addon blocklist's bloom filter. This marks the point in time until which signed add-ons are recognized by the selected bloom filter from the addons-bloomfilters collection.
    pub static mlbf_softblocks_generation_time: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_softblocks_generation_time".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5766), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_softblocks_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter. Possible values are "dump_match", "cache_match", "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match", "cache_match" and "remote_match" are expected known-good values, and means that the loaded bloomfilter matches the blocklist record in the RemoteSettings collection. The prefix denotes the immediate source of the loaded data: "dump" means packaged with the application, "remote" means a freshly downloaded bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback" and "cache_fallback" means that the last known bloomfilter was used, despite it not matching the latest record in the RemoteSettings collection. In this case the outdated bloomfilter is used as a fallback (e.g. because the latest version cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded at all. This can happen if the blocklist is disabled via preferences or enterprise policies.
    pub static mlbf_softblocks_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_softblocks_source".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5767), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_source
    ///
    /// The source of the RemoteSettings attachment that holds the bloom filter. Possible values are "dump_match", "cache_match", "remote_match","dump_fallback", "cache_fallback", "unknown". "dump_match", "cache_match" and "remote_match" are expected known-good values, and means that the loaded bloomfilter matches the blocklist record in the RemoteSettings collection. The prefix denotes the immediate source of the loaded data: "dump" means packaged with the application, "remote" means a freshly downloaded bloomfilter, "cache" means a previously downloaded bloomfilter. "dump_fallback" and "cache_fallback" means that the last known bloomfilter was used, despite it not matching the latest record in the RemoteSettings collection. In this case the outdated bloomfilter is used as a fallback (e.g. because the latest version cannot be downloaded). "unknown"  means that the bloomfilter cannot be loaded at all. This can happen if the blocklist is disabled via preferences or enterprise policies.
    pub static mlbf_source: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_source".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5768), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_newest
    ///
    /// Keep track of the timestamp of the most recent stash of the addons blocklist.
    pub static mlbf_stash_time_newest: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_stash_time_newest".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5769), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from blocklist.mlbf_stash_time_oldest
    ///
    /// Keep track of the timestamp of the oldest stash of the addons blocklist.
    pub static mlbf_stash_time_oldest: Lazy<DatetimeMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "mlbf_stash_time_oldest".into(),
                category: "blocklist".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        DatetimeMetric::new(BaseMetricId(5770), meta, TimeUnit::Millisecond)
    });

}
pub mod update {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from update.auto_download
    ///
    /// Per-installation preference "app.update.auto": whether to fetch and install updates without user intervention.
    pub static auto_download: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "auto_download".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5771), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.background_update
    ///
    /// Per-installation preference "app.update.background.enabled": whether to fetch and install updates in the background when Firefox is not running.
    pub static background_update: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "background_update".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5772), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_apply_updates
    ///
    /// Whether or not the Update Service can usually download and install updates. See `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_apply_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_apply_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5773), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_check_for_updates
    ///
    /// Whether or not the Update Service can usually check for updates. See `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_check_for_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_check_for_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5774), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_stage_updates
    ///
    /// Whether the Update Service is usually able to stage updates. See `canUsuallyStageUpdates` in https://searchfox.org/mozilla-central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_stage_updates: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_stage_updates".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5775), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.can_usually_use_bits
    ///
    /// On Windows, whether the Update Service can usually use BITS. See `canUsuallyUseBits` in https://searchfox.org/mozilla-central/source/toolkit/mozapps/update/nsIUpdateService.idl.
    pub static can_usually_use_bits: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "can_usually_use_bits".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5776), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.channel
    ///
    /// The update channel.
    pub static channel: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "channel".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5777), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.enabled
    ///
    /// True when policies are disabled or when the "DisableAppUpdate" is not in effect.
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5778), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_enabled
    ///
    /// Preference "app.update.service.enabled": whether the Mozilla Maintenance Service is enabled.
    pub static service_enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "service_enabled".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5779), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.bits_result_complete
    ///
    /// Update: Result code from downloading a complete update via BITS
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_BITS_RESULT_COMPLETE.
    pub static bits_result_complete: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bits_result_complete".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5780), meta, 0, 99, 100, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.bits_result_partial
    ///
    /// Update: Result code from downloading a partial update via BITS
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_BITS_RESULT_PARTIAL.
    pub static bits_result_partial: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "bits_result_partial".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5781), meta, 0, 99, 100, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum CanUseBitsExternalLabel {
        ECanusebits = 0,
        ENobitsNotwindows = 1,
        ENobitsFeatureoff = 2,
        ENobitsPref = 3,
        ENobitsProxy = 4,
        ENobitsOtheruser = 5,
        __Other__,
    }
    impl From<u16> for CanUseBitsExternalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECanusebits,
                1 => Self::ENobitsNotwindows,
                2 => Self::ENobitsFeatureoff,
                3 => Self::ENobitsPref,
                4 => Self::ENobitsProxy,
                5 => Self::ENobitsOtheruser,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CanUseBitsExternalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECanusebits => "CanUseBits",
                Self::ENobitsNotwindows => "NoBits_NotWindows",
                Self::ENobitsFeatureoff => "NoBits_FeatureOff",
                Self::ENobitsPref => "NoBits_Pref",
                Self::ENobitsProxy => "NoBits_Proxy",
                Self::ENobitsOtheruser => "NoBits_OtherUser",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.can_use_bits_external
    ///
    /// Update: Whether BITS could be used to download updates (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_CAN_USE_BITS_EXTERNAL.
    pub static can_use_bits_external: Lazy<LabeledMetric<LabeledCounterMetric, CanUseBitsExternalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "can_use_bits_external".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5782), meta, Some(vec![::std::borrow::Cow::from("CanUseBits"), ::std::borrow::Cow::from("NoBits_FeatureOff"), ::std::borrow::Cow::from("NoBits_NotWindows"), ::std::borrow::Cow::from("NoBits_OtherUser"), ::std::borrow::Cow::from("NoBits_Pref"), ::std::borrow::Cow::from("NoBits_Proxy")]))
    });

    #[repr(u16)]
    pub enum CanUseBitsNotifyLabel {
        ECanusebits = 0,
        ENobitsNotwindows = 1,
        ENobitsFeatureoff = 2,
        ENobitsPref = 3,
        ENobitsProxy = 4,
        ENobitsOtheruser = 5,
        __Other__,
    }
    impl From<u16> for CanUseBitsNotifyLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECanusebits,
                1 => Self::ENobitsNotwindows,
                2 => Self::ENobitsFeatureoff,
                3 => Self::ENobitsPref,
                4 => Self::ENobitsProxy,
                5 => Self::ENobitsOtheruser,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CanUseBitsNotifyLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECanusebits => "CanUseBits",
                Self::ENobitsNotwindows => "NoBits_NotWindows",
                Self::ENobitsFeatureoff => "NoBits_FeatureOff",
                Self::ENobitsPref => "NoBits_Pref",
                Self::ENobitsProxy => "NoBits_Proxy",
                Self::ENobitsOtheruser => "NoBits_OtherUser",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.can_use_bits_notify
    ///
    /// Update: Whether BITS could be used to download updates (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_CAN_USE_BITS_NOTIFY.
    pub static can_use_bits_notify: Lazy<LabeledMetric<LabeledCounterMetric, CanUseBitsNotifyLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "can_use_bits_notify".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5783), meta, Some(vec![::std::borrow::Cow::from("CanUseBits"), ::std::borrow::Cow::from("NoBits_FeatureOff"), ::std::borrow::Cow::from("NoBits_NotWindows"), ::std::borrow::Cow::from("NoBits_OtherUser"), ::std::borrow::Cow::from("NoBits_Pref"), ::std::borrow::Cow::from("NoBits_Proxy")]))
    });

    #[repr(u16)]
    pub enum CanUseBitsSubsequentLabel {
        ECanusebits = 0,
        ENobitsNotwindows = 1,
        ENobitsFeatureoff = 2,
        ENobitsPref = 3,
        ENobitsProxy = 4,
        ENobitsOtheruser = 5,
        __Other__,
    }
    impl From<u16> for CanUseBitsSubsequentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ECanusebits,
                1 => Self::ENobitsNotwindows,
                2 => Self::ENobitsFeatureoff,
                3 => Self::ENobitsPref,
                4 => Self::ENobitsProxy,
                5 => Self::ENobitsOtheruser,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for CanUseBitsSubsequentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ECanusebits => "CanUseBits",
                Self::ENobitsNotwindows => "NoBits_NotWindows",
                Self::ENobitsFeatureoff => "NoBits_FeatureOff",
                Self::ENobitsPref => "NoBits_Pref",
                Self::ENobitsProxy => "NoBits_Proxy",
                Self::ENobitsOtheruser => "NoBits_OtherUser",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.can_use_bits_subsequent
    ///
    /// Update: Whether BITS could be used to download updates (after we already have an update ready)
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_CAN_USE_BITS_SUBSEQUENT.
    pub static can_use_bits_subsequent: Lazy<LabeledMetric<LabeledCounterMetric, CanUseBitsSubsequentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "can_use_bits_subsequent".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5784), meta, Some(vec![::std::borrow::Cow::from("CanUseBits"), ::std::borrow::Cow::from("NoBits_FeatureOff"), ::std::borrow::Cow::from("NoBits_NotWindows"), ::std::borrow::Cow::from("NoBits_OtherUser"), ::std::borrow::Cow::from("NoBits_Pref"), ::std::borrow::Cow::from("NoBits_Proxy")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.cannot_stage_external
    ///
    /// Update: count of systems that cannot stage updates (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CANNOT_STAGE_EXTERNAL.
    pub static cannot_stage_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5785,
            "update",
            "cannot_stage_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.cannot_stage_notify
    ///
    /// Update: count of systems that cannot stage updates (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CANNOT_STAGE_NOTIFY.
    pub static cannot_stage_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5786,
            "update",
            "cannot_stage_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.cannot_stage_subsequent
    ///
    /// Update: count of systems that cannot stage updates (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CANNOT_STAGE_SUBSEQUENT.
    pub static cannot_stage_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5787,
            "update",
            "cannot_stage_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_code_external
    ///
    /// Update: background update check result code except for no updates found (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_CHECK_CODE_EXTERNAL.
    pub static check_code_external: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "check_code_external".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5788), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_code_notify
    ///
    /// Update: background update check result code except for no updates found (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_CHECK_CODE_NOTIFY.
    pub static check_code_notify: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "check_code_notify".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5789), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_code_subsequent
    ///
    /// Update: background update check result code except for no updates found (after we already have an update ready). Possible codes are enumerated by constants starting with CHK_ in toolkit/mozapps/update/UpdateTelemetry.sys.mjs
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_CHECK_CODE_SUBSEQUENT.
    pub static check_code_subsequent: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "check_code_subsequent".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5790), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_extended_error_external
    ///
    /// Update: keyed count (key names are prefixed with AUS_CHECK_EX_ERR_) of background update check extended error code (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_EXTENDED_ERROR_EXTERNAL.
    pub static check_extended_error_external: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "check_extended_error_external".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5791), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_extended_error_notify
    ///
    /// Update: keyed count (key names are prefixed with AUS_CHECK_EX_ERR_) of background update check extended error code (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_EXTENDED_ERROR_NOTIFY.
    pub static check_extended_error_notify: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "check_extended_error_notify".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5792), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_extended_error_subsequent
    ///
    /// Update: keyed count (key names are prefixed with AUS_CHECK_EX_ERR_) of background update check extended error code (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_EXTENDED_ERROR_SUBSEQUENT.
    pub static check_extended_error_subsequent: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "check_extended_error_subsequent".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5793), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_no_update_external
    ///
    /// Update: count of no updates were found for a background update check (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_NO_UPDATE_EXTERNAL.
    pub static check_no_update_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5794,
            "update",
            "check_no_update_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_no_update_notify
    ///
    /// Update: count of no updates were found for a background update check (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_NO_UPDATE_NOTIFY.
    pub static check_no_update_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5795,
            "update",
            "check_no_update_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.check_no_update_subsequent
    ///
    /// Update: count of no updates were found for a background update check (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_CHECK_NO_UPDATE_SUBSEQUENT.
    pub static check_no_update_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5796,
            "update",
            "check_no_update_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.download_code_complete
    ///
    /// Update: complete patch type download result code
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_DOWNLOAD_CODE_COMPLETE.
    pub static download_code_complete: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_code_complete".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5797), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.download_code_partial
    ///
    /// Update: partial patch type download result code
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_DOWNLOAD_CODE_PARTIAL.
    pub static download_code_partial: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_code_partial".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5798), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.download_code_unknown
    ///
    /// Update: unknown patch type download result code
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_DOWNLOAD_CODE_UNKNOWN.
    pub static download_code_unknown: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "download_code_unknown".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5799), meta, 0, 50, 51, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.invalid_lastupdatetime_external
    ///
    /// Update: count of systems that have a last update time greater than the current time (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_INVALID_LASTUPDATETIME_EXTERNAL.
    pub static invalid_lastupdatetime_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5800,
            "update",
            "invalid_lastupdatetime_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.invalid_lastupdatetime_notify
    ///
    /// Update: count of systems that have a last update time greater than the current time (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_INVALID_LASTUPDATETIME_NOTIFY.
    pub static invalid_lastupdatetime_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5801,
            "update",
            "invalid_lastupdatetime_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.invalid_lastupdatetime_subsequent
    ///
    /// Update: count of systems that have a last update time greater than the current time (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_INVALID_LASTUPDATETIME_SUBSEQUENT.
    pub static invalid_lastupdatetime_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5802,
            "update",
            "invalid_lastupdatetime_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.langpack_overtime
    ///
    /// Update: How much longer langpacks took to download than the app update in seconds.
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram UPDATE_LANGPACK_OVERTIME.
    pub static langpack_overtime: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "langpack_overtime".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5803), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.last_notify_interval_days_external
    ///
    /// Update: interval in days since the last background update check (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram UPDATE_LAST_NOTIFY_INTERVAL_DAYS_EXTERNAL.
    pub static last_notify_interval_days_external: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_notify_interval_days_external".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5804), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.last_notify_interval_days_notify
    ///
    /// Update: interval in days since the last background update check (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram UPDATE_LAST_NOTIFY_INTERVAL_DAYS_NOTIFY.
    pub static last_notify_interval_days_notify: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_notify_interval_days_notify".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5805), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.last_notify_interval_days_subsequent
    ///
    /// Update: interval in days since the last background update check (after we already have an update ready)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram UPDATE_LAST_NOTIFY_INTERVAL_DAYS_SUBSEQUENT.
    pub static last_notify_interval_days_subsequent: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "last_notify_interval_days_subsequent".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5806), meta, TimeUnit::Day)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_auto_external
    ///
    /// Update: count of when getAppUpdateAutoEnabled from UpdateUtils.sys.mjs does not return the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_AUTO_EXTERNAL.
    pub static not_pref_update_auto_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5807,
            "update",
            "not_pref_update_auto_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_auto_notify
    ///
    /// Update: count of when getAppUpdateAutoEnabled from UpdateUtils.sys.mjs does not return the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_AUTO_NOTIFY.
    pub static not_pref_update_auto_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5808,
            "update",
            "not_pref_update_auto_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_auto_subsequent
    ///
    /// Update: count of when getAppUpdateAutoEnabled from UpdateUtils.sys.mjs does not return the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_AUTO_SUBSEQUENT.
    pub static not_pref_update_auto_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5809,
            "update",
            "not_pref_update_auto_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_service_enabled_external
    ///
    /// Update: count of when the app.update.service.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_SERVICE_ENABLED_EXTERNAL.
    pub static not_pref_update_service_enabled_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5810,
            "update",
            "not_pref_update_service_enabled_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_service_enabled_notify
    ///
    /// Update: count of when the app.update.service.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_SERVICE_ENABLED_NOTIFY.
    pub static not_pref_update_service_enabled_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5811,
            "update",
            "not_pref_update_service_enabled_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_service_enabled_subsequent
    ///
    /// Update: count of when the app.update.service.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_SERVICE_ENABLED_SUBSEQUENT.
    pub static not_pref_update_service_enabled_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5812,
            "update",
            "not_pref_update_service_enabled_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_staging_enabled_external
    ///
    /// Update: count of when the app.update.staging.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_STAGING_ENABLED_EXTERNAL.
    pub static not_pref_update_staging_enabled_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5813,
            "update",
            "not_pref_update_staging_enabled_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_staging_enabled_notify
    ///
    /// Update: count of when the app.update.staging.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_STAGING_ENABLED_NOTIFY.
    pub static not_pref_update_staging_enabled_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5814,
            "update",
            "not_pref_update_staging_enabled_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.not_pref_update_staging_enabled_subsequent
    ///
    /// Update: count of when the app.update.staging.enabled boolean preference is not the default value of true (true values are not submitted)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_NOT_PREF_UPDATE_STAGING_ENABLED_SUBSEQUENT.
    pub static not_pref_update_staging_enabled_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5815,
            "update",
            "not_pref_update_staging_enabled_subsequent",
            "metrics"
        )
    });

    #[repr(u16)]
    pub enum NotificationBadgeShownLabel {
        ERestart = 0,
        EAvailable = 1,
        EManual = 2,
        EUnsupported = 3,
        EOtherinstance = 4,
        __Other__,
    }
    impl From<u16> for NotificationBadgeShownLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERestart,
                1 => Self::EAvailable,
                2 => Self::EManual,
                3 => Self::EUnsupported,
                4 => Self::EOtherinstance,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NotificationBadgeShownLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERestart => "restart",
                Self::EAvailable => "available",
                Self::EManual => "manual",
                Self::EUnsupported => "unsupported",
                Self::EOtherinstance => "otherinstance",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.notification_badge_shown
    ///
    /// Update: the application update badge type that was displayed.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_NOTIFICATION_BADGE_SHOWN.
    pub static notification_badge_shown: Lazy<LabeledMetric<LabeledCounterMetric, NotificationBadgeShownLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "notification_badge_shown".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5816), meta, Some(vec![::std::borrow::Cow::from("available"), ::std::borrow::Cow::from("manual"), ::std::borrow::Cow::from("otherinstance"), ::std::borrow::Cow::from("restart"), ::std::borrow::Cow::from("unsupported")]))
    });

    #[repr(u16)]
    pub enum NotificationDismissedLabel {
        ERestart = 0,
        EAvailable = 1,
        EManual = 2,
        EUnsupported = 3,
        EOtherinstance = 4,
        __Other__,
    }
    impl From<u16> for NotificationDismissedLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERestart,
                1 => Self::EAvailable,
                2 => Self::EManual,
                3 => Self::EUnsupported,
                4 => Self::EOtherinstance,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NotificationDismissedLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERestart => "restart",
                Self::EAvailable => "available",
                Self::EManual => "manual",
                Self::EUnsupported => "unsupported",
                Self::EOtherinstance => "otherinstance",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.notification_dismissed
    ///
    /// Update: the dismiss action was executed for this application update doorhanger type.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_NOTIFICATION_DISMISSED.
    pub static notification_dismissed: Lazy<LabeledMetric<LabeledCounterMetric, NotificationDismissedLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "notification_dismissed".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5817), meta, Some(vec![::std::borrow::Cow::from("available"), ::std::borrow::Cow::from("manual"), ::std::borrow::Cow::from("otherinstance"), ::std::borrow::Cow::from("restart"), ::std::borrow::Cow::from("unsupported")]))
    });

    #[repr(u16)]
    pub enum NotificationMainActionDoorhangerLabel {
        ERestart = 0,
        EAvailable = 1,
        EManual = 2,
        EUnsupported = 3,
        EOtherinstance = 4,
        __Other__,
    }
    impl From<u16> for NotificationMainActionDoorhangerLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERestart,
                1 => Self::EAvailable,
                2 => Self::EManual,
                3 => Self::EUnsupported,
                4 => Self::EOtherinstance,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NotificationMainActionDoorhangerLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERestart => "restart",
                Self::EAvailable => "available",
                Self::EManual => "manual",
                Self::EUnsupported => "unsupported",
                Self::EOtherinstance => "otherinstance",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.notification_main_action_doorhanger
    ///
    /// Update: the main update action was initiated for this application update doorhanger type.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_NOTIFICATION_MAIN_ACTION_DOORHANGER.
    pub static notification_main_action_doorhanger: Lazy<LabeledMetric<LabeledCounterMetric, NotificationMainActionDoorhangerLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "notification_main_action_doorhanger".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5818), meta, Some(vec![::std::borrow::Cow::from("available"), ::std::borrow::Cow::from("manual"), ::std::borrow::Cow::from("otherinstance"), ::std::borrow::Cow::from("restart"), ::std::borrow::Cow::from("unsupported")]))
    });

    #[repr(u16)]
    pub enum NotificationMainActionMenuLabel {
        ERestart = 0,
        EAvailable = 1,
        EManual = 2,
        EUnsupported = 3,
        EOtherinstance = 4,
        __Other__,
    }
    impl From<u16> for NotificationMainActionMenuLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERestart,
                1 => Self::EAvailable,
                2 => Self::EManual,
                3 => Self::EUnsupported,
                4 => Self::EOtherinstance,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NotificationMainActionMenuLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERestart => "restart",
                Self::EAvailable => "available",
                Self::EManual => "manual",
                Self::EUnsupported => "unsupported",
                Self::EOtherinstance => "otherinstance",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.notification_main_action_menu
    ///
    /// Update: the update action was initiated from the PanelUI application update menu item.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_NOTIFICATION_MAIN_ACTION_MENU.
    pub static notification_main_action_menu: Lazy<LabeledMetric<LabeledCounterMetric, NotificationMainActionMenuLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "notification_main_action_menu".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5819), meta, Some(vec![::std::borrow::Cow::from("available"), ::std::borrow::Cow::from("manual"), ::std::borrow::Cow::from("otherinstance"), ::std::borrow::Cow::from("restart"), ::std::borrow::Cow::from("unsupported")]))
    });

    #[repr(u16)]
    pub enum NotificationShownLabel {
        ERestart = 0,
        EAvailable = 1,
        EManual = 2,
        EUnsupported = 3,
        EOtherinstance = 4,
        __Other__,
    }
    impl From<u16> for NotificationShownLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::ERestart,
                1 => Self::EAvailable,
                2 => Self::EManual,
                3 => Self::EUnsupported,
                4 => Self::EOtherinstance,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NotificationShownLabel {
        fn into(self) -> &'static str {
            match self {
                Self::ERestart => "restart",
                Self::EAvailable => "available",
                Self::EManual => "manual",
                Self::EUnsupported => "unsupported",
                Self::EOtherinstance => "otherinstance",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.notification_shown
    ///
    /// Update: the application update doorhanger type that was displayed.
    /// This metric was generated to correspond to the Legacy Telemetry categorical histogram UPDATE_NOTIFICATION_SHOWN.
    pub static notification_shown: Lazy<LabeledMetric<LabeledCounterMetric, NotificationShownLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "notification_shown".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5820), meta, Some(vec![::std::borrow::Cow::from("available"), ::std::borrow::Cow::from("manual"), ::std::borrow::Cow::from("otherinstance"), ::std::borrow::Cow::from("restart"), ::std::borrow::Cow::from("unsupported")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.ping_count_external
    ///
    /// Update: count of systems for this ping for comparison with other pings (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_PING_COUNT_EXTERNAL.
    pub static ping_count_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5821,
            "update",
            "ping_count_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.ping_count_notify
    ///
    /// Update: count of systems for this ping for comparison with other pings (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_PING_COUNT_NOTIFY.
    pub static ping_count_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5822,
            "update",
            "ping_count_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.ping_count_subsequent
    ///
    /// Update: count of systems for this ping for comparison with other pings (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_PING_COUNT_SUBSEQUENT.
    pub static ping_count_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5823,
            "update",
            "ping_count_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_service_errors_external
    ///
    /// Update: number of sequential update service errors greater than 0 (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_SERVICE_ERRORS_EXTERNAL.
    pub static pref_service_errors_external: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_service_errors_external".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5824), meta, 0, 30, 31, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_service_errors_notify
    ///
    /// Update: number of sequential update service errors greater than 0 (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_SERVICE_ERRORS_NOTIFY.
    pub static pref_service_errors_notify: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_service_errors_notify".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5825), meta, 0, 30, 31, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_service_errors_subsequent
    ///
    /// Update: number of sequential update service errors greater than 0 (after we already have an update ready)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_SERVICE_ERRORS_SUBSEQUENT.
    pub static pref_service_errors_subsequent: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_service_errors_subsequent".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5826), meta, 0, 30, 31, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_update_cancelations_external
    ///
    /// Update: number of sequential update elevation request cancelations greater than 0 (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_UPDATE_CANCELATIONS_EXTERNAL.
    pub static pref_update_cancelations_external: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_update_cancelations_external".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5827), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_update_cancelations_notify
    ///
    /// Update: number of sequential update elevation request cancelations greater than 0 (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_UPDATE_CANCELATIONS_NOTIFY.
    pub static pref_update_cancelations_notify: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_update_cancelations_notify".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5828), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.pref_update_cancelations_subsequent
    ///
    /// Update: number of sequential update elevation request cancelations greater than 0 (after we already have an update ready)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_PREF_UPDATE_CANCELATIONS_SUBSEQUENT.
    pub static pref_update_cancelations_subsequent: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "pref_update_cancelations_subsequent".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5829), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum ServiceInstalledExternalLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ServiceInstalledExternalLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ServiceInstalledExternalLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.service_installed_external
    ///
    /// Update: whether the service is installed (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram UPDATE_SERVICE_INSTALLED_EXTERNAL.
    pub static service_installed_external: Lazy<LabeledMetric<LabeledCounterMetric, ServiceInstalledExternalLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "service_installed_external".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5830), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ServiceInstalledNotifyLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ServiceInstalledNotifyLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ServiceInstalledNotifyLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.service_installed_notify
    ///
    /// Update: whether the service is installed (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram UPDATE_SERVICE_INSTALLED_NOTIFY.
    pub static service_installed_notify: Lazy<LabeledMetric<LabeledCounterMetric, ServiceInstalledNotifyLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "service_installed_notify".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5831), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[repr(u16)]
    pub enum ServiceInstalledSubsequentLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for ServiceInstalledSubsequentLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for ServiceInstalledSubsequentLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from update.service_installed_subsequent
    ///
    /// Update: whether the service is installed (after we already have an update ready)
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram UPDATE_SERVICE_INSTALLED_SUBSEQUENT.
    pub static service_installed_subsequent: Lazy<LabeledMetric<LabeledCounterMetric, ServiceInstalledSubsequentLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "service_installed_subsequent".into(),
                    category: "update".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5832), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_manually_uninstalled_external
    ///
    /// Update: count of systems that manually uninstalled the service (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_SERVICE_MANUALLY_UNINSTALLED_EXTERNAL.
    pub static service_manually_uninstalled_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5833,
            "update",
            "service_manually_uninstalled_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_manually_uninstalled_notify
    ///
    /// Update: count of systems that manually uninstalled the service (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_SERVICE_MANUALLY_UNINSTALLED_NOTIFY.
    pub static service_manually_uninstalled_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5834,
            "update",
            "service_manually_uninstalled_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.service_manually_uninstalled_subsequent
    ///
    /// Update: count of systems that manually uninstalled the service (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_SERVICE_MANUALLY_UNINSTALLED_SUBSEQUENT.
    pub static service_manually_uninstalled_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5835,
            "update",
            "service_manually_uninstalled_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_complete_stage
    ///
    /// Update: the state of a complete patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_COMPLETE_STAGE.
    pub static state_code_complete_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_complete_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5836), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_complete_startup
    ///
    /// Update: the state of a complete update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_COMPLETE_STARTUP.
    pub static state_code_complete_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_complete_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5837), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_partial_stage
    ///
    /// Update: the state of a partial patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_PARTIAL_STAGE.
    pub static state_code_partial_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_partial_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5838), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_partial_startup
    ///
    /// Update: the state of a partial patch update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_PARTIAL_STARTUP.
    pub static state_code_partial_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_partial_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5839), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_unknown_stage
    ///
    /// Update: the state of an unknown patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_UNKNOWN_STAGE.
    pub static state_code_unknown_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_unknown_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5840), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.state_code_unknown_startup
    ///
    /// Update: the state of an unknown patch update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATE_CODE_UNKNOWN_STARTUP.
    pub static state_code_unknown_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state_code_unknown_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5841), meta, 0, 20, 21, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_complete_stage
    ///
    /// Update: the status error code for a failed complete patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_COMPLETE_STAGE.
    pub static status_error_code_complete_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_complete_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5842), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_complete_startup
    ///
    /// Update: the status error code for a failed complete patch update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_COMPLETE_STARTUP.
    pub static status_error_code_complete_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_complete_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5843), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_partial_stage
    ///
    /// Update: the status error code for a failed partial patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_PARTIAL_STAGE.
    pub static status_error_code_partial_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_partial_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5844), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_partial_startup
    ///
    /// Update: the status error code for a failed partial patch update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_PARTIAL_STARTUP.
    pub static status_error_code_partial_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_partial_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5845), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_unknown_stage
    ///
    /// Update: the status error code for a failed unknown patch update from update.status after staging
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_UNKNOWN_STAGE.
    pub static status_error_code_unknown_stage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_unknown_stage".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5846), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.status_error_code_unknown_startup
    ///
    /// Update: the status error code for a failed unknown patch update from update.status on startup
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram UPDATE_STATUS_ERROR_CODE_UNKNOWN_STARTUP.
    pub static status_error_code_unknown_startup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "status_error_code_unknown_startup".into(),
                category: "update".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5847), meta, 0, 100, 101, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.unable_to_apply_external
    ///
    /// Update: count of systems that cannot apply updates (externally initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_UNABLE_TO_APPLY_EXTERNAL.
    pub static unable_to_apply_external: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5848,
            "update",
            "unable_to_apply_external",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.unable_to_apply_notify
    ///
    /// Update: count of systems that cannot apply updates (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_UNABLE_TO_APPLY_NOTIFY.
    pub static unable_to_apply_notify: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5849,
            "update",
            "unable_to_apply_notify",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.unable_to_apply_subsequent
    ///
    /// Update: count of systems that cannot apply updates (timer initiated)
    /// This metric was generated to correspond to the Legacy Telemetry count histogram UPDATE_UNABLE_TO_APPLY_SUBSEQUENT.
    pub static unable_to_apply_subsequent: Lazy<CounterMetric> = Lazy::new(|| {
        CounterMetric::codegen_new(
            5850,
            "update",
            "unable_to_apply_subsequent",
            "metrics"
        )
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.bitshresult
    ///
    /// If a BITS download fails on the Windows side (that is to say, BITS ecounters an error rather than Firefox failing to interact with BITS), it will likely give an hresult error indicating what happened. This probe reports those error codes to allow us to see if BITS is commonly failing on some systems. This probe is keyed on the type of update download, either "PARTIAL" or "COMPLETE". This metric was generated to correspond to the Legacy Telemetry scalar update.bitshresult.
    pub static bitshresult: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "bitshresult".into(),
                    category: "update".into(),
                    send_in_pings: vec!["background-update".into(), "metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5851), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.move_result
    ///
    /// Firefox keeps downloading updates in a different place from updates that are ready to install. Once the download completes, the resulting file has to be moved from the downloading update directory to the ready update directory. This probe counts the results that we get when attempting to perform this file move. Valid values for the keys for this probe are stored in the MOVE_RESULT_* values in UpdateTelemetry.sys.mjs. This metric was generated to correspond to the Legacy Telemetry scalar update.move_result.
    pub static move_result: Lazy<LabeledMetric<LabeledCounterMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "move_result".into(),
                    category: "update".into(),
                    send_in_pings: vec!["background-update".into(), "metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5852), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.no_window_auto_restarts
    ///
    /// On macOS, all browser windows can be closed without exiting Firefox. If there is an update pending in that case, and we can install it silently, we restart automatically in order to do so. This probe counts the number of times the browser restarts to silently install a pending update. This metric was generated to correspond to the Legacy Telemetry scalar update.no_window_auto_restarts.
    pub static no_window_auto_restarts: Lazy<CounterMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "no_window_auto_restarts".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CounterMetric::new(BaseMetricId(5853), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.suppress_prompts
    ///
    /// When an update is available and app.update.auto is disabled, a popup is opened prompting the user to download and install the update. The pref app.update.suppressPrompts causes Firefox Nightly to wait up to 7 days before showing the prompt, instead showing a badge and banner in the meantime. It also prevents Nightly from showing update restart prompts, instead showing a badge and banner immediately. This value is set for the users who set this pref to true. This metric was generated to correspond to the Legacy Telemetry scalar update.suppress_prompts.
    pub static suppress_prompts: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "suppress_prompts".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5854), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from update.version_pin
    ///
    /// The AppUpdatePin Enterprise Policy controls the maximum version that the browser can update to. If the policy is set, this probe will report the policy's value. The possible policy values are "X." and "X.Y.", where X is the pinned major version and Y is the pinned minor version. This metric was generated to correspond to the Legacy Telemetry scalar update.version_pin.
    pub static version_pin: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version_pin".into(),
                category: "update".into(),
                send_in_pings: vec!["background-update".into(), "metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5855), meta)
    });

}
pub mod updater {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from updater.available
    ///
    /// Whether the app was built with the updater binary.
    /// Corresponds to the value of the `MOZ_UPDATER` define.
    pub static available: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "available".into(),
                category: "updater".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5856), meta)
    });

}
pub mod e10s {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from e10s.enabled
    ///
    /// Whether e10s is on, i.e. browser tabs open by default in a different
    /// process.
    /// See `nsIXULRuntime.browserTabsRemoteAutostart`
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "e10s".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5857), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from e10s.multi_processes
    ///
    /// Maximum number of processes that will be launched for regular web content.
    /// See `nsIXULRuntime.maxWebProcessCount`
    pub static multi_processes: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "multi_processes".into(),
                category: "e10s".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5858), meta)
    });

}
pub mod fission {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from fission.enabled
    ///
    /// Whether fission is enabled this session, and subframes can load in a
    /// different process.
    /// See `nsIXULRuntime.fissionAutostart`
    pub static enabled: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "enabled".into(),
                category: "fission".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5859), meta)
    });

}
pub mod gecko {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from gecko.build_id
    ///
    /// The Buildid of the Gecko engine, example: 20200205124310 (Migrated from the geckoview metric of the same name).
    pub static build_id: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "build_id".into(),
                category: "gecko".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5860), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gecko.safe_mode_usage
    ///
    /// Whether the user is in safe mode (No, Yes, Forced)
    /// This metric was generated to correspond to the Legacy Telemetry enumerated histogram SAFE_MODE_USAGE.
    pub static safe_mode_usage: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "safe_mode_usage".into(),
                category: "gecko".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5861), meta, 0, 3, 4, HistogramType::Linear)
    });

    #[allow(non_upper_case_globals)]
    /// generated from gecko.version
    ///
    /// The version of the Gecko engine, example: 74.0a1 (Migrated from the geckoview metric of the same name).
    pub static version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "version".into(),
                category: "gecko".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::User,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5862), meta)
    });

}
pub mod launcher_process {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from launcher.process.state
    ///
    /// Whether, and in what mode, the launcher process is enabled (or not).
    /// See `nsIXULRuntime.launcherProcessState`
    pub static state: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "state".into(),
                category: "launcher.process".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5863), meta)
    });

}
pub mod widget {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_mac
    ///
    /// Name of IME which was selected by users on macOS.  The value is Input Source ID if non-Japanese IME was open.  Otherwise, if Japanese IME was open, the value is Bundle ID.  Input Source ID includes input mode, but Bundle ID does not include input mode. This metric was generated to correspond to the Legacy Telemetry scalar widget.ime_name_on_mac.
    pub static ime_name_on_mac: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_mac".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5864), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.gtk_version
    ///
    /// The version of Gtk 3 in use. This metric was generated to correspond to the Legacy Telemetry scalar widget.gtk_version.
    pub static gtk_version: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "gtk_version".into(),
                category: "widget".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5865), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_linux
    ///
    /// Name of active IM (e.g., xim, fcitx, ibus, etc) which was actually set by env on Linux.  Different from Windows and macOS, this value includes non-IME users even though this is recoded when first compositionstart event because dead key is also implemented by IME on Linux. This metric was generated to correspond to the Legacy Telemetry scalar widget.ime_name_on_linux.
    pub static ime_name_on_linux: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_linux".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5866), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.dark_mode
    ///
    /// Whether the OS theme is dark. This metric was generated to correspond to the Legacy Telemetry scalar widget.dark_mode.
    pub static dark_mode: Lazy<BooleanMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "dark_mode".into(),
                category: "widget".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        BooleanMetric::new(BaseMetricId(5867), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.notify_idle
    ///
    /// Time spent checking for and notifying listeners that the user is idle (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram IDLE_NOTIFY_IDLE_MS.
    pub static notify_idle: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "notify_idle".into(),
                category: "widget".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5868), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum PointingDevicesLabel {
        EMouse = 0,
        ETouch = 1,
        EPen = 2,
        __Other__,
    }
    impl From<u16> for PointingDevicesLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EMouse,
                1 => Self::ETouch,
                2 => Self::EPen,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for PointingDevicesLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EMouse => "mouse",
                Self::ETouch => "touch",
                Self::EPen => "pen",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from widget.pointing_devices
    ///
    /// Whether the system has any matching pointing device for each label.
    pub static pointing_devices: Lazy<LabeledMetric<LabeledBooleanMetric, PointingDevicesLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "pointing_devices".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5869), meta, Some(vec![::std::borrow::Cow::from("mouse"), ::std::borrow::Cow::from("pen"), ::std::borrow::Cow::from("touch")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_windows
    ///
    /// Locale ID and name of IME which was selected by users on Windows. This does NOT collect legacy IMM-IME names since we cannot get readable names and we do not support IMM-IME so aggressively because IME vendors should've already released TIP for TSF for supporting Windows 8 or later completely. This metric was generated to correspond to the Legacy Telemetry scalar widget.ime_name_on_windows.
    pub static ime_name_on_windows: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_windows".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5870), meta, None)
    });

    #[allow(non_upper_case_globals)]
    /// generated from widget.ime_name_on_windows_inserted_crlf
    ///
    /// Same data as ime_name_on_windows, but only collecting IME names which inserted CRLF to check whether the feature works. This metric was generated to correspond to the Legacy Telemetry scalar widget.ime_name_on_windows_inserted_crlf.
    pub static ime_name_on_windows_inserted_crlf: Lazy<LabeledMetric<LabeledBooleanMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "ime_name_on_windows_inserted_crlf".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5871), meta, None)
    });

    #[repr(u16)]
    pub enum TouchEnabledDeviceLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for TouchEnabledDeviceLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for TouchEnabledDeviceLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from widget.touch_enabled_device
    ///
    /// Boolean indicating if a touch input device is detected.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram TOUCH_ENABLED_DEVICE.
    pub static touch_enabled_device: Lazy<LabeledMetric<LabeledCounterMetric, TouchEnabledDeviceLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "touch_enabled_device".into(),
                    category: "widget".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5872), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

}
pub mod cycle_collector {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.async_snow_white_freeing
    ///
    /// Time spent on one asynchronous SnowWhite freeing (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_ASYNC_SNOW_WHITE_FREEING.
    pub static async_snow_white_freeing: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "async_snow_white_freeing".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5873), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.collected
    ///
    /// Number of objects collected by the cycle collector
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_COLLECTED.
    pub static collected: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "collected".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5874), meta, 1, 100000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.deferred_finalize_async
    ///
    /// Pause time for asynchronous deferred finalization (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram DEFERRED_FINALIZE_ASYNC.
    pub static deferred_finalize_async: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "deferred_finalize_async".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5875), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum FinishIgcLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for FinishIgcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for FinishIgcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.finish_igc
    ///
    /// Cycle collection finished an incremental GC
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_FINISH_IGC.
    pub static finish_igc: Lazy<LabeledMetric<LabeledCounterMetric, FinishIgcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "finish_igc".into(),
                    category: "cycle_collector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5876), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.forget_skippable_max
    ///
    /// Max time spent on one forget skippable (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram FORGET_SKIPPABLE_MAX.
    pub static forget_skippable_max: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "forget_skippable_max".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5877), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.full
    ///
    /// Full pause time for one cycle collection, including preparation (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_FULL.
    pub static full: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "full".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5878), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.max_pause
    ///
    /// Longest pause for an individual slice of one cycle collection, including preparation (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_MAX_PAUSE.
    pub static max_pause: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "max_pause".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5879), meta, TimeUnit::Millisecond)
    });

    #[repr(u16)]
    pub enum NeedGcLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for NeedGcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for NeedGcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.need_gc
    ///
    /// Needed garbage collection before cycle collection.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_NEED_GC.
    pub static need_gc: Lazy<LabeledMetric<LabeledCounterMetric, NeedGcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "need_gc".into(),
                    category: "cycle_collector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5880), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.slice_during_idle
    ///
    /// Percent of cycle collector slice done during idle time
    /// This metric was generated to correspond to the Legacy Telemetry linear histogram CYCLE_COLLECTOR_SLICE_DURING_IDLE.
    pub static slice_during_idle: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slice_during_idle".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5881), meta, 1, 100, 50, HistogramType::Linear)
    });

    #[repr(u16)]
    pub enum SyncSkippableLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for SyncSkippableLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for SyncSkippableLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.sync_skippable
    ///
    /// Cycle collection synchronously ran forget skippable
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_SYNC_SKIPPABLE.
    pub static sync_skippable: Lazy<LabeledMetric<LabeledCounterMetric, SyncSkippableLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "sync_skippable".into(),
                    category: "cycle_collector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5882), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.time
    ///
    /// Time spent on one cycle collection (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR.
    pub static time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5883), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.time_between
    ///
    /// Time spent in between cycle collections (seconds)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_TIME_BETWEEN.
    pub static time_between: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "time_between".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5884), meta, TimeUnit::Second)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.visited_gced
    ///
    /// Number of JS objects visited by the cycle collector
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_VISITED_GCED.
    pub static visited_gced: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "visited_gced".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5885), meta, 1, 300000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.visited_ref_counted
    ///
    /// Number of ref counted objects visited by the cycle collector
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_VISITED_REF_COUNTED.
    pub static visited_ref_counted: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "visited_ref_counted".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5886), meta, 1, 300000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.worker_collected
    ///
    /// Number of objects collected by the cycle collector in a worker
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_COLLECTED.
    pub static worker_collected: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "worker_collected".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5887), meta, 1, 100000, 50, HistogramType::Exponential)
    });

    #[repr(u16)]
    pub enum WorkerNeedGcLabel {
        EFalse = 0,
        ETrue = 1,
        __Other__,
    }
    impl From<u16> for WorkerNeedGcLabel {
        fn from(v: u16) -> Self {
            match v {
                0 => Self::EFalse,
                1 => Self::ETrue,
                _ => Self::__Other__,
            }
        }
    }
    impl Into<&'static str> for WorkerNeedGcLabel {
        fn into(self) -> &'static str {
            match self {
                Self::EFalse => "false",
                Self::ETrue => "true",
                Self::__Other__ => "__other__",
            }
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.worker_need_gc
    ///
    /// Needed garbage collection before cycle collection in a worker.
    /// This metric was generated to correspond to the Legacy Telemetry boolean histogram CYCLE_COLLECTOR_WORKER_NEED_GC.
    pub static worker_need_gc: Lazy<LabeledMetric<LabeledCounterMetric, WorkerNeedGcLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::Common {
                cmd: CommonMetricData {
                    name: "worker_need_gc".into(),
                    category: "cycle_collector".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                },
            };
        LabeledMetric::new(BaseMetricId(5888), meta, Some(vec![::std::borrow::Cow::from("false"), ::std::borrow::Cow::from("true")]))
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.worker_time
    ///
    /// Time spent on one cycle collection in a worker (ms)
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER.
    pub static worker_time: Lazy<TimingDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "worker_time".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        TimingDistributionMetric::new(BaseMetricId(5889), meta, TimeUnit::Millisecond)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.worker_visited_gced
    ///
    /// Number of JS objects visited by the cycle collector in a worker
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_VISITED_GCED.
    pub static worker_visited_gced: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "worker_visited_gced".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5890), meta, 1, 300000, 50, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from cycle_collector.worker_visited_ref_counted
    ///
    /// Number of ref counted objects visited by the cycle collector in a worker
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram CYCLE_COLLECTOR_WORKER_VISITED_REF_COUNTED.
    pub static worker_visited_ref_counted: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "worker_visited_ref_counted".into(),
                category: "cycle_collector".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5891), meta, 1, 300000, 50, HistogramType::Exponential)
    });

}
pub mod event {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from event.longtask
    ///
    /// LongTask events for parent process (keys: event name): time the event ran in ms
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram EVENT_LONGTASK.
    pub static longtask: Lazy<LabeledMetric<LabeledTimingDistributionMetric, super::DynamicLabel>> = Lazy::new(|| {
        let meta =
            LabeledMetricData::TimingDistribution {
                cmd: CommonMetricData {
                    name: "longtask".into(),
                    category: "event".into(),
                    send_in_pings: vec!["metrics".into()],
                    lifetime: Lifetime::Ping,
                    disabled: false,
                    ..Default::default()
                }, unit: TimeUnit::Millisecond};
        LabeledMetric::new(BaseMetricId(5892), meta, None)
    });

}
pub mod memory_phc {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from memory_phc.slop
    ///
    /// Over-allocation due to PHC's rounding (aka internal fragmentation).  Measured in bytes.
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOP.
    pub static slop: Lazy<MemoryDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slop".into(),
                category: "memory_phc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        MemoryDistributionMetric::new(BaseMetricId(5893), meta, MemoryUnit::Byte)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory_phc.slots_allocated
    ///
    /// Number of PHC slots currently allocated
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOTS_ALLOCATED.
    pub static slots_allocated: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slots_allocated".into(),
                category: "memory_phc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5894), meta, 1, 16384, 64, HistogramType::Exponential)
    });

    #[allow(non_upper_case_globals)]
    /// generated from memory_phc.slots_freed
    ///
    /// Number of PHC slots allocated-then-freed
    /// This metric was generated to correspond to the Legacy Telemetry exponential histogram MEMORY_PHC_SLOTS_FREED.
    pub static slots_freed: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "slots_freed".into(),
                category: "memory_phc".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5895), meta, 1, 16384, 64, HistogramType::Exponential)
    });

}
pub mod memory_watcher {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[derive(Default, Debug, Clone, Hash, Eq, PartialEq)]
    #[allow(non_snake_case)]
    pub struct OnHighMemoryStatsExtra {
        pub r#value: Option<String>,
    }

    impl ExtraKeys for OnHighMemoryStatsExtra {
        const ALLOWED_KEYS: &'static [&'static str] = &["value"];

        fn into_ffi_extra(self) -> ::std::collections::HashMap<String, String> {
          let mut map = ::std::collections::HashMap::new();
          self.r#value.and_then(|val| map.insert("value".into(), val.to_string()));
          map
        }
    }
    #[allow(non_upper_case_globals)]
    /// generated from memory_watcher.on_high_memory_stats
    ///
    /// This event is recorded when the memory situation is no longer low. The "stats" object consists of three numbers comma-delimited: 1) how many times a tab was unloaded 2) how many memory-pressure events were dispatched 3) how long we were in the low-memory situation in seconds This event was generated to correspond to the Legacy Telemetry event memory_watcher.on_high_memory#stats.
    pub static on_high_memory_stats: Lazy<EventMetric<OnHighMemoryStatsExtra>> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "on_high_memory_stats".into(),
                category: "memory_watcher".into(),
                send_in_pings: vec!["events".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        EventMetric::new(BaseMetricId(5896), meta)
    });

}
pub mod system_cpu {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.big_cores
    ///
    /// Big (or Performance) CPU cores.
    pub static big_cores: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "big_cores".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5897), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.family
    ///
    /// CPU family.
    pub static family: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "family".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5898), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.l2_cache
    ///
    /// L2 cache size (only on Windows and Mac).
    pub static l2_cache: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "l2_cache".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5899), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.l3_cache
    ///
    /// L3 cache size.
    pub static l3_cache: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "l3_cache".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5900), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.little_cores
    ///
    /// Little (or Efficient) CPU cores.
    pub static little_cores: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "little_cores".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5901), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.logical_cores
    ///
    /// Logical CPU cores.
    pub static logical_cores: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "logical_cores".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5902), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.medium_cores
    ///
    /// Medium CPU cores.
    pub static medium_cores: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "medium_cores".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5903), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.model
    ///
    /// CPU model.
    pub static model: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "model".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5904), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.name
    ///
    /// The user readable CPU name. (e.g. "Intel(R) Core(TM) i9-8950HK CPU @ 2.90GHz")
    pub static name: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "name".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5905), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.physical_cores
    ///
    /// Physical CPU cores.
    pub static physical_cores: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "physical_cores".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5906), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.speed
    ///
    /// CPU speed in MHz.
    pub static speed: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "speed".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5907), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.stepping
    ///
    /// CPU stepping.
    pub static stepping: Lazy<QuantityMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "stepping".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        QuantityMetric::new(BaseMetricId(5908), meta)
    });

    #[allow(non_upper_case_globals)]
    /// generated from system.cpu.vendor
    ///
    /// The CPU vendor (e.g. "GenuineIntel").
    pub static vendor: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "vendor".into(),
                category: "system.cpu".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5909), meta)
    });

}
pub mod timer_thread {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from timer_thread.timers_fired_per_wakeup
    ///
    /// How many timers were processed in a single wake-up of the Timer Thread.
    pub static timers_fired_per_wakeup: Lazy<CustomDistributionMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "timers_fired_per_wakeup".into(),
                category: "timer_thread".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Ping,
                disabled: false,
                ..Default::default()
            };
        CustomDistributionMetric::new(BaseMetricId(5910), meta, 0, 80, 20, HistogramType::Exponential)
    });

}
pub mod xpcom {
    use crate::private::*;
    #[allow(unused_imports)] // CommonMetricData might be unused, let's avoid warnings
    use glean::CommonMetricData;
    #[allow(unused_imports)] // HistogramType might be unusued, let's avoid warnings
    use glean::HistogramType;
    use once_cell::sync::Lazy;

    #[allow(unused_imports)]
    use std::convert::TryFrom;

    #[allow(non_upper_case_globals)]
    /// generated from xpcom.abi
    ///
    /// A string tag identifying the binary ABI of the current processor and
    /// compiler vtable. This is taken from the TARGET_XPCOM_ABI configure
    /// variable. It may not be available on all platforms, especially
    /// unusual processor or compiler combinations.
    /// 
    /// The result takes the form <processor>-<compilerABI>, for example:
    ///   - x86-msvc
    ///   - ppc-gcc3
    /// 
    /// This value should almost always be used in combination with the
    /// operating system.
    pub static abi: Lazy<StringMetric> = Lazy::new(|| {
        let meta =
            CommonMetricData {
                name: "abi".into(),
                category: "xpcom".into(),
                send_in_pings: vec!["metrics".into()],
                lifetime: Lifetime::Application,
                disabled: false,
                ..Default::default()
            };
        StringMetric::new(BaseMetricId(5911), meta)
    });

}

#[allow(dead_code)]
pub(crate) mod __glean_metric_maps {
    use std::collections::HashMap;
    use std::sync::Arc;

    use crate::metrics::extra_keys_len;
    use crate::private::*;
    use once_cell::sync::Lazy;

    pub static BOOLEAN_MAP: Lazy<HashMap<BaseMetricId, &Lazy<BooleanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(186);
        map.insert(BaseMetricId(1), &super::a11y::always_underline_links);
        map.insert(BaseMetricId(2), &super::a11y::backplate);
        map.insert(BaseMetricId(7), &super::a11y::invert_colors);
        map.insert(BaseMetricId(10), &super::a11y::use_system_colors);
        map.insert(BaseMetricId(189), &super::networking::http3_enabled);
        map.insert(BaseMetricId(261), &super::browser_backup::enabled);
        map.insert(BaseMetricId(279), &super::browser_backup::pswd_encrypted);
        map.insert(BaseMetricId(280), &super::browser_backup::scheduler_enabled);
        map.insert(BaseMetricId(327), &super::genai_chatbot::enabled);
        map.insert(BaseMetricId(341), &super::genai_chatbot::shortcuts);
        map.insert(BaseMetricId(343), &super::genai_chatbot::shortcuts_custom);
        map.insert(BaseMetricId(348), &super::genai_chatbot::sidebar);
        map.insert(BaseMetricId(356), &super::genai_linkpreview::enabled);
        map.insert(BaseMetricId(363), &super::background_update::automatic_restart_attempted);
        map.insert(BaseMetricId(364), &super::background_update::automatic_restart_success);
        map.insert(BaseMetricId(366), &super::background_update::exit_code_exception);
        map.insert(BaseMetricId(367), &super::background_update::exit_code_success);
        map.insert(BaseMetricId(374), &super::background_update::targeting_exception);
        map.insert(BaseMetricId(375), &super::background_update::targeting_exists);
        map.insert(BaseMetricId(378), &super::browser::default_at_launch);
        map.insert(BaseMetricId(389), &super::browser_startup::abouthome_cache_shutdownwrite);
        map.insert(BaseMetricId(390), &super::datasanitization::privacy_clear_on_shutdown_cache);
        map.insert(BaseMetricId(391), &super::datasanitization::privacy_clear_on_shutdown_cookies);
        map.insert(BaseMetricId(392), &super::datasanitization::privacy_clear_on_shutdown_downloads);
        map.insert(BaseMetricId(393), &super::datasanitization::privacy_clear_on_shutdown_formdata);
        map.insert(BaseMetricId(394), &super::datasanitization::privacy_clear_on_shutdown_history);
        map.insert(BaseMetricId(395), &super::datasanitization::privacy_clear_on_shutdown_offline_apps);
        map.insert(BaseMetricId(396), &super::datasanitization::privacy_clear_on_shutdown_open_windows);
        map.insert(BaseMetricId(397), &super::datasanitization::privacy_clear_on_shutdown_sessions);
        map.insert(BaseMetricId(398), &super::datasanitization::privacy_clear_on_shutdown_site_settings);
        map.insert(BaseMetricId(399), &super::datasanitization::privacy_sanitize_sanitize_on_shutdown);
        map.insert(BaseMetricId(404), &super::os_environment::is_kept_in_dock);
        map.insert(BaseMetricId(405), &super::os_environment::is_taskbar_pinned);
        map.insert(BaseMetricId(406), &super::os_environment::is_taskbar_pinned_private);
        map.insert(BaseMetricId(410), &super::os_environment::is_admin_without_uac);
        map.insert(BaseMetricId(411), &super::primary_password::enabled);
        map.insert(BaseMetricId(428), &super::sslkeylogging::enabled);
        map.insert(BaseMetricId(430), &super::startup::is_cold);
        map.insert(BaseMetricId(460), &super::migration::uninstaller_profile_refresh);
        map.insert(BaseMetricId(554), &super::newtab::weather_enabled);
        map.insert(BaseMetricId(559), &super::newtab_handoff_preference::enabled);
        map.insert(BaseMetricId(560), &super::newtab_search::enabled);
        map.insert(BaseMetricId(581), &super::pocket::enabled);
        map.insert(BaseMetricId(584), &super::pocket::is_signed_in);
        map.insert(BaseMetricId(588), &super::pocket::sponsored_stories_enabled);
        map.insert(BaseMetricId(600), &super::topsites::enabled);
        map.insert(BaseMetricId(605), &super::topsites::sponsored_enabled);
        map.insert(BaseMetricId(625), &super::pocket_button::pocket_logged_in_status);
        map.insert(BaseMetricId(852), &super::shopping_settings::auto_open_user_disabled);
        map.insert(BaseMetricId(853), &super::shopping_settings::component_opted_out);
        map.insert(BaseMetricId(854), &super::shopping_settings::disabled_ads);
        map.insert(BaseMetricId(855), &super::shopping_settings::has_onboarded);
        map.insert(BaseMetricId(856), &super::shopping_settings::nimbus_disabled_shopping);
        map.insert(BaseMetricId(944), &super::tabgroup::smart_tab_enabled);
        map.insert(BaseMetricId(960), &super::quick_suggest::improve_suggest_experience);
        map.insert(BaseMetricId(961), &super::quick_suggest::is_clicked);
        map.insert(BaseMetricId(969), &super::quick_suggest::suggested_index_relative_to_group);
        map.insert(BaseMetricId(984), &super::urlbar::pref_suggest_data_collection);
        map.insert(BaseMetricId(985), &super::urlbar::pref_suggest_nonsponsored);
        map.insert(BaseMetricId(986), &super::urlbar::pref_suggest_sponsored);
        map.insert(BaseMetricId(987), &super::urlbar::pref_suggest_topsites);
        map.insert(BaseMetricId(1019), &super::installation_first_seen::admin_user);
        map.insert(BaseMetricId(1020), &super::installation_first_seen::default_path);
        map.insert(BaseMetricId(1022), &super::installation_first_seen::from_msi);
        map.insert(BaseMetricId(1023), &super::installation_first_seen::install_existed);
        map.insert(BaseMetricId(1025), &super::installation_first_seen::other_inst);
        map.insert(BaseMetricId(1026), &super::installation_first_seen::other_msix_inst);
        map.insert(BaseMetricId(1027), &super::installation_first_seen::profdir_existed);
        map.insert(BaseMetricId(1028), &super::installation_first_seen::silent);
        map.insert(BaseMetricId(1128), &super::devtools_shadowdom::reveal_link_clicked);
        map.insert(BaseMetricId(1129), &super::devtools_shadowdom::shadow_root_displayed);
        map.insert(BaseMetricId(1130), &super::devtools_shadowdom::shadow_root_expanded);
        map.insert(BaseMetricId(3783), &super::dom_parentprocess::private_window_used);
        map.insert(BaseMetricId(3908), &super::gfx::os_compositor);
        map.insert(BaseMetricId(3912), &super::gfx::supports_hdr);
        map.insert(BaseMetricId(3945), &super::gfx_status::headless);
        map.insert(BaseMetricId(4095), &super::preferences::prefs_file_was_invalid);
        map.insert(BaseMetricId(4355), &super::pkcs11::external_trust_anchor_module_loaded);
        map.insert(BaseMetricId(4465), &super::contentblocking::cryptomining_blocking_enabled);
        map.insert(BaseMetricId(4469), &super::contentblocking::fingerprinting_blocking_enabled);
        map.insert(BaseMetricId(4493), &super::background_tasks_rmdir_base::succeeded);
        map.insert(BaseMetricId(4494), &super::background_tasks_rmdir_base::suffix_ever_failed);
        map.insert(BaseMetricId(4496), &super::background_tasks_rmdir_base::was_first);
        map.insert(BaseMetricId(4501), &super::background_tasks_rmdir_http_cache::succeeded);
        map.insert(BaseMetricId(4502), &super::background_tasks_rmdir_http_cache::suffix_ever_failed);
        map.insert(BaseMetricId(4504), &super::background_tasks_rmdir_http_cache::was_first);
        map.insert(BaseMetricId(4509), &super::background_tasks_rmdir_quota::succeeded);
        map.insert(BaseMetricId(4510), &super::background_tasks_rmdir_quota::suffix_ever_failed);
        map.insert(BaseMetricId(4512), &super::background_tasks_rmdir_quota::was_first);
        map.insert(BaseMetricId(4553), &super::captcha_detection::network_cookie_cookiebehavior_optinpartitioning);
        map.insert(BaseMetricId(4554), &super::captcha_detection::network_cookie_cookiebehavior_optinpartitioning_pbm);
        map.insert(BaseMetricId(4557), &super::captcha_detection::privacy_fingerprintingprotection);
        map.insert(BaseMetricId(4558), &super::captcha_detection::privacy_fingerprintingprotection_pbm);
        map.insert(BaseMetricId(4559), &super::captcha_detection::privacy_resistfingerprinting);
        map.insert(BaseMetricId(4560), &super::captcha_detection::privacy_resistfingerprinting_pbmode);
        map.insert(BaseMetricId(4561), &super::captcha_detection::privacy_trackingprotection_cryptomining_enabled);
        map.insert(BaseMetricId(4562), &super::captcha_detection::privacy_trackingprotection_enabled);
        map.insert(BaseMetricId(4563), &super::captcha_detection::privacy_trackingprotection_fingerprinting_enabled);
        map.insert(BaseMetricId(4564), &super::captcha_detection::privacy_trackingprotection_pbm_enabled);
        map.insert(BaseMetricId(4573), &super::cookie_banners::service_detect_only);
        map.insert(BaseMetricId(4584), &super::crash::is_garbage_collecting);
        map.insert(BaseMetricId(4594), &super::crash::startup);
        map.insert(BaseMetricId(4598), &super::crash_windows::error_reporting);
        map.insert(BaseMetricId(4605), &super::dll_blocklist::init_failed);
        map.insert(BaseMetricId(4607), &super::dll_blocklist::user32_loaded_before);
        map.insert(BaseMetricId(4608), &super::environment::headless_mode);
        map.insert(BaseMetricId(4659), &super::policies::is_enterprise);
        map.insert(BaseMetricId(4664), &super::extensions::use_remote_policy);
        map.insert(BaseMetricId(4665), &super::extensions::use_remote_pref);
        map.insert(BaseMetricId(4756), &super::formautofill::availability);
        map.insert(BaseMetricId(4759), &super::formautofill::os_auth_enabled);
        map.insert(BaseMetricId(4765), &super::fog::failed_idle_registration);
        map.insert(BaseMetricId(4777), &super::test_only::can_we_flag_it);
        map.insert(BaseMetricId(4810), &super::test_only::one_ping_one_bool);
        map.insert(BaseMetricId(4819), &super::test_only_ipc::a_bool);
        map.insert(BaseMetricId(4838), &super::test_only_ipc::an_unordered_bool);
        map.insert(BaseMetricId(4889), &super::nimbus_targeting_context::does_app_need_pin);
        map.insert(BaseMetricId(4892), &super::nimbus_targeting_context::has_active_enterprise_policies);
        map.insert(BaseMetricId(4894), &super::nimbus_targeting_context::is_default_browser);
        map.insert(BaseMetricId(4896), &super::nimbus_targeting_context::is_first_startup);
        map.insert(BaseMetricId(4897), &super::nimbus_targeting_context::is_fx_a_enabled);
        map.insert(BaseMetricId(4898), &super::nimbus_targeting_context::is_fx_a_signed_in);
        map.insert(BaseMetricId(4899), &super::nimbus_targeting_context::is_msix);
        map.insert(BaseMetricId(4908), &super::nimbus_targeting_context::user_prefers_reduced_motion);
        map.insert(BaseMetricId(4909), &super::nimbus_targeting_context::uses_firefox_sync);
        map.insert(BaseMetricId(4984), &super::pwmgr::os_auth_enabled);
        map.insert(BaseMetricId(4998), &super::pwmgr::saving_enabled);
        map.insert(BaseMetricId(5090), &super::pictureinpicture::toggle_enabled);
        map.insert(BaseMetricId(5162), &super::broken_site_report_browser_info_app::fission_enabled);
        map.insert(BaseMetricId(5167), &super::broken_site_report_browser_info_graphics::has_touch_screen);
        map.insert(BaseMetricId(5170), &super::broken_site_report_browser_info_prefs::forced_accelerated_layers);
        map.insert(BaseMetricId(5171), &super::broken_site_report_browser_info_prefs::global_privacy_control_enabled);
        map.insert(BaseMetricId(5172), &super::broken_site_report_browser_info_prefs::h1_in_section_useragent_styles_enabled);
        map.insert(BaseMetricId(5173), &super::broken_site_report_browser_info_prefs::installtrigger_enabled);
        map.insert(BaseMetricId(5174), &super::broken_site_report_browser_info_prefs::opaque_response_blocking);
        map.insert(BaseMetricId(5175), &super::broken_site_report_browser_info_prefs::resist_fingerprinting_enabled);
        map.insert(BaseMetricId(5176), &super::broken_site_report_browser_info_prefs::software_webrender);
        map.insert(BaseMetricId(5177), &super::broken_site_report_browser_info_prefs::third_party_cookie_blocking_enabled);
        map.insert(BaseMetricId(5178), &super::broken_site_report_browser_info_prefs::third_party_cookie_blocking_enabled_in_pbm);
        map.insert(BaseMetricId(5182), &super::broken_site_report_browser_info_system::is_tablet);
        map.insert(BaseMetricId(5187), &super::broken_site_report_tab_info_antitracking::btp_has_purged_site);
        map.insert(BaseMetricId(5189), &super::broken_site_report_tab_info_antitracking::has_mixed_active_content_blocked);
        map.insert(BaseMetricId(5190), &super::broken_site_report_tab_info_antitracking::has_mixed_display_content_blocked);
        map.insert(BaseMetricId(5191), &super::broken_site_report_tab_info_antitracking::has_tracking_content_blocked);
        map.insert(BaseMetricId(5192), &super::broken_site_report_tab_info_antitracking::is_private_browsing);
        map.insert(BaseMetricId(5193), &super::broken_site_report_tab_info_frameworks::fastclick);
        map.insert(BaseMetricId(5194), &super::broken_site_report_tab_info_frameworks::marfeel);
        map.insert(BaseMetricId(5195), &super::broken_site_report_tab_info_frameworks::mobify);
        map.insert(BaseMetricId(5269), &super::characteristics::font_name_list_emoji_modified);
        map.insert(BaseMetricId(5362), &super::characteristics::inverted_colors);
        map.insert(BaseMetricId(5386), &super::characteristics::monochrome);
        map.insert(BaseMetricId(5398), &super::characteristics::pdf_viewer);
        map.insert(BaseMetricId(5410), &super::characteristics::prefers_reduced_motion);
        map.insert(BaseMetricId(5411), &super::characteristics::prefers_reduced_transparency);
        map.insert(BaseMetricId(5412), &super::characteristics::prefs_block_popups);
        map.insert(BaseMetricId(5413), &super::characteristics::prefs_browser_display_use_document_fonts);
        map.insert(BaseMetricId(5414), &super::characteristics::prefs_general_autoscroll);
        map.insert(BaseMetricId(5415), &super::characteristics::prefs_general_smoothscroll);
        map.insert(BaseMetricId(5417), &super::characteristics::prefs_media_eme_enabled);
        map.insert(BaseMetricId(5419), &super::characteristics::prefs_overlay_scrollbars);
        map.insert(BaseMetricId(5420), &super::characteristics::prefs_privacy_donottrackheader_enabled);
        map.insert(BaseMetricId(5421), &super::characteristics::prefs_privacy_globalprivacycontrol_enabled);
        map.insert(BaseMetricId(5422), &super::characteristics::prefs_zoom_text_only);
        map.insert(BaseMetricId(5435), &super::characteristics::use_document_colors);
        map.insert(BaseMetricId(5437), &super::characteristics::using_accelerated_canvas);
        map.insert(BaseMetricId(5491), &super::search_engine_default::overridden_by_third_party);
        map.insert(BaseMetricId(5499), &super::search_engine_private::overridden_by_third_party);
        map.insert(BaseMetricId(5533), &super::telemetry::data_upload_optin);
        map.insert(BaseMetricId(5564), &super::usage::is_default_browser);
        map.insert(BaseMetricId(5677), &super::first_startup::new_profile);
        map.insert(BaseMetricId(5690), &super::notification::show_success);
        map.insert(BaseMetricId(5699), &super::addons_manager::compatibility_check_enabled);
        map.insert(BaseMetricId(5763), &super::blocklist::enabled);
        map.insert(BaseMetricId(5771), &super::update::auto_download);
        map.insert(BaseMetricId(5772), &super::update::background_update);
        map.insert(BaseMetricId(5773), &super::update::can_usually_apply_updates);
        map.insert(BaseMetricId(5774), &super::update::can_usually_check_for_updates);
        map.insert(BaseMetricId(5775), &super::update::can_usually_stage_updates);
        map.insert(BaseMetricId(5776), &super::update::can_usually_use_bits);
        map.insert(BaseMetricId(5778), &super::update::enabled);
        map.insert(BaseMetricId(5779), &super::update::service_enabled);
        map.insert(BaseMetricId(5854), &super::update::suppress_prompts);
        map.insert(BaseMetricId(5856), &super::updater::available);
        map.insert(BaseMetricId(5857), &super::e10s::enabled);
        map.insert(BaseMetricId(5859), &super::fission::enabled);
        map.insert(BaseMetricId(5867), &super::widget::dark_mode);
        map
    });

    pub static CUSTOM_DISTRIBUTION_MAP: Lazy<HashMap<BaseMetricId, &Lazy<CustomDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(343);
        map.insert(BaseMetricId(3), &super::a11y::consumers);
        map.insert(BaseMetricId(21), &super::browser_engagement::loaded_tab_count);
        map.insert(BaseMetricId(28), &super::browser_engagement::tab_count);
        map.insert(BaseMetricId(52), &super::networking::cookie_access_fixup_diff);
        map.insert(BaseMetricId(53), &super::networking::cookie_chips_partition_limit_overflow);
        map.insert(BaseMetricId(55), &super::networking::cookie_count_part_by_key);
        map.insert(BaseMetricId(56), &super::networking::cookie_count_partitioned);
        map.insert(BaseMetricId(57), &super::networking::cookie_count_total);
        map.insert(BaseMetricId(58), &super::networking::cookie_count_unpart_by_key);
        map.insert(BaseMetricId(59), &super::networking::cookie_count_unpartitioned);
        map.insert(BaseMetricId(60), &super::networking::cookie_creation_fixup_diff);
        map.insert(BaseMetricId(61), &super::networking::cookie_purge_entry_max);
        map.insert(BaseMetricId(62), &super::networking::cookie_purge_max);
        map.insert(BaseMetricId(72), &super::networking::http_1_download_throughput);
        map.insert(BaseMetricId(73), &super::networking::http_1_download_throughput_100);
        map.insert(BaseMetricId(74), &super::networking::http_1_download_throughput_10_50);
        map.insert(BaseMetricId(75), &super::networking::http_1_download_throughput_50_100);
        map.insert(BaseMetricId(76), &super::networking::http_1_upload_throughput);
        map.insert(BaseMetricId(77), &super::networking::http_1_upload_throughput_100);
        map.insert(BaseMetricId(78), &super::networking::http_1_upload_throughput_10_50);
        map.insert(BaseMetricId(79), &super::networking::http_1_upload_throughput_50_100);
        map.insert(BaseMetricId(80), &super::networking::http_2_download_throughput);
        map.insert(BaseMetricId(81), &super::networking::http_2_download_throughput_100);
        map.insert(BaseMetricId(82), &super::networking::http_2_download_throughput_10_50);
        map.insert(BaseMetricId(83), &super::networking::http_2_download_throughput_50_100);
        map.insert(BaseMetricId(84), &super::networking::http_2_upload_throughput);
        map.insert(BaseMetricId(85), &super::networking::http_2_upload_throughput_100);
        map.insert(BaseMetricId(86), &super::networking::http_2_upload_throughput_10_50);
        map.insert(BaseMetricId(87), &super::networking::http_2_upload_throughput_50_100);
        map.insert(BaseMetricId(89), &super::networking::http_3_download_throughput);
        map.insert(BaseMetricId(90), &super::networking::http_3_download_throughput_100);
        map.insert(BaseMetricId(91), &super::networking::http_3_download_throughput_10_50);
        map.insert(BaseMetricId(92), &super::networking::http_3_download_throughput_50_100);
        map.insert(BaseMetricId(93), &super::networking::http_3_ecn_ce_ect0_ratio_received);
        map.insert(BaseMetricId(94), &super::networking::http_3_ecn_ce_ect0_ratio_sent);
        map.insert(BaseMetricId(96), &super::networking::http_3_loss_ratio);
        map.insert(BaseMetricId(100), &super::networking::http_3_udp_datagram_segments_received);
        map.insert(BaseMetricId(102), &super::networking::http_3_upload_throughput);
        map.insert(BaseMetricId(103), &super::networking::http_3_upload_throughput_100);
        map.insert(BaseMetricId(104), &super::networking::http_3_upload_throughput_10_50);
        map.insert(BaseMetricId(105), &super::networking::http_3_upload_throughput_50_100);
        map.insert(BaseMetricId(382), &super::browser::set_default_dialog_prompt_rawcount);
        map.insert(BaseMetricId(385), &super::browser::set_default_result);
        map.insert(BaseMetricId(421), &super::security::referrer_policy_count);
        map.insert(BaseMetricId(424), &super::security::addon_signature_verification_status);
        map.insert(BaseMetricId(426), &super::security::content_signature_verification_status);
        map.insert(BaseMetricId(427), &super::security::ntlm_module_used);
        map.insert(BaseMetricId(455), &super::browser_migration::source_browser);
        map.insert(BaseMetricId(608), &super::bookmarks_sidebar::cumulative_searches);
        map.insert(BaseMetricId(610), &super::history_sidebar::cumulative_filter_count);
        map.insert(BaseMetricId(611), &super::history_sidebar::cumulative_searches);
        map.insert(BaseMetricId(614), &super::library::cumulative_bookmark_searches);
        map.insert(BaseMetricId(615), &super::library::cumulative_history_searches);
        map.insert(BaseMetricId(805), &super::session_restore::number_of_eager_tabs_restored);
        map.insert(BaseMetricId(806), &super::session_restore::number_of_tabs_restored);
        map.insert(BaseMetricId(807), &super::session_restore::number_of_windows_restored);
        map.insert(BaseMetricId(955), &super::text_recognition::text_length);
        map.insert(BaseMetricId(1030), &super::link_icon_sizes_attr::dimension);
        map.insert(BaseMetricId(1031), &super::link_icon_sizes_attr::usage);
        map.insert(BaseMetricId(1053), &super::devtools::toolbox_host);
        map.insert(BaseMetricId(1110), &super::devtools::heap_snapshot_edge_count);
        map.insert(BaseMetricId(1111), &super::devtools::heap_snapshot_node_count);
        map.insert(BaseMetricId(1120), &super::devtools_inspector::number_of_css_grids_in_a_page);
        map.insert(BaseMetricId(3639), &super::webcrypto::alg);
        map.insert(BaseMetricId(3644), &super::webcrypto::method);
        map.insert(BaseMetricId(3646), &super::geolocation::accuracy);
        map.insert(BaseMetricId(3669), &super::media::video_dropped_compositor_frames_proportion_exponential);
        map.insert(BaseMetricId(3670), &super::media::video_dropped_decoded_frames_proportion_exponential);
        map.insert(BaseMetricId(3671), &super::media::video_dropped_frames_proportion);
        map.insert(BaseMetricId(3672), &super::media::video_dropped_frames_proportion_exponential);
        map.insert(BaseMetricId(3673), &super::media::video_dropped_sink_frames_proportion_exponential);
        map.insert(BaseMetricId(3683), &super::media::decoder_backend_used);
        map.insert(BaseMetricId(3690), &super::media_mp4_parse::num_sample_description_entries);
        map.insert(BaseMetricId(3712), &super::webrtc::audio_quality_inbound_bandwidth_kbits);
        map.insert(BaseMetricId(3714), &super::webrtc::audio_quality_inbound_packetloss_rate);
        map.insert(BaseMetricId(3716), &super::webrtc::audio_quality_outbound_packetloss_rate);
        map.insert(BaseMetricId(3721), &super::webrtc::call_type);
        map.insert(BaseMetricId(3723), &super::webrtc::get_user_media_type);
        map.insert(BaseMetricId(3728), &super::webrtc::max_audio_receive_track);
        map.insert(BaseMetricId(3729), &super::webrtc::max_audio_send_track);
        map.insert(BaseMetricId(3730), &super::webrtc::max_video_receive_track);
        map.insert(BaseMetricId(3731), &super::webrtc::max_video_send_track);
        map.insert(BaseMetricId(3732), &super::webrtc::renegotiations);
        map.insert(BaseMetricId(3734), &super::webrtc::video_decoder_bitrate_avg_per_call_kbps);
        map.insert(BaseMetricId(3735), &super::webrtc::video_decoder_bitrate_std_dev_per_call_kbps);
        map.insert(BaseMetricId(3736), &super::webrtc::video_decoder_discarded_packets_per_call_ppm);
        map.insert(BaseMetricId(3737), &super::webrtc::video_decoder_framerate_10x_std_dev_per_call);
        map.insert(BaseMetricId(3738), &super::webrtc::video_decoder_framerate_avg_per_call);
        map.insert(BaseMetricId(3739), &super::webrtc::video_encoder_bitrate_avg_per_call_kbps);
        map.insert(BaseMetricId(3740), &super::webrtc::video_encoder_bitrate_std_dev_per_call_kbps);
        map.insert(BaseMetricId(3741), &super::webrtc::video_encoder_framerate_10x_std_dev_per_call);
        map.insert(BaseMetricId(3742), &super::webrtc::video_encoder_framerate_avg_per_call);
        map.insert(BaseMetricId(3743), &super::webrtc::video_quality_inbound_bandwidth_kbits);
        map.insert(BaseMetricId(3745), &super::webrtc::video_quality_inbound_packetloss_rate);
        map.insert(BaseMetricId(3747), &super::webrtc::video_quality_outbound_packetloss_rate);
        map.insert(BaseMetricId(3762), &super::dom::forget_skippable_during_idle);
        map.insert(BaseMetricId(3763), &super::dom::forget_skippable_frequency);
        map.insert(BaseMetricId(3766), &super::dom::gc_slice_during_idle);
        map.insert(BaseMetricId(3827), &super::screenwakelock::release_battery_level_discharging);
        map.insert(BaseMetricId(3849), &super::mixed_content::hsts);
        map.insert(BaseMetricId(3851), &super::mixed_content::page_load);
        map.insert(BaseMetricId(3852), &super::mixed_content::unblock_counter);
        map.insert(BaseMetricId(3854), &super::security_ui::events);
        map.insert(BaseMetricId(3883), &super::apz_zoom::pinchsource);
        map.insert(BaseMetricId(3887), &super::fontlist::dwritefont_delayedinit_count);
        map.insert(BaseMetricId(3889), &super::fontlist::dwritefont_init_problem);
        map.insert(BaseMetricId(3899), &super::gfx::composite_swap_time);
        map.insert(BaseMetricId(3901), &super::gfx::content_failed_to_acquire_device);
        map.insert(BaseMetricId(3902), &super::gfx::crash);
        map.insert(BaseMetricId(3903), &super::gfx::device_reset_reason);
        map.insert(BaseMetricId(3904), &super::gfx::forced_device_reset_reason);
        map.insert(BaseMetricId(3905), &super::gfx::graphics_driver_startup_test);
        map.insert(BaseMetricId(3909), &super::gfx::sanity_test);
        map.insert(BaseMetricId(3923), &super::gfx_checkerboard::peak_pixel_count);
        map.insert(BaseMetricId(3925), &super::gfx_checkerboard::severity);
        map.insert(BaseMetricId(3932), &super::gfx_content_frame_time::from_paint);
        map.insert(BaseMetricId(3933), &super::gfx_content_frame_time::from_vsync);
        map.insert(BaseMetricId(3935), &super::gfx_content_frame_time::with_svg);
        map.insert(BaseMetricId(3936), &super::gfx_content_frame_time::without_resource_upload);
        map.insert(BaseMetricId(3937), &super::gfx_content_frame_time::without_upload);
        map.insert(BaseMetricId(3941), &super::gfx_display::scaling);
        map.insert(BaseMetricId(3954), &super::webfont::compression_woff);
        map.insert(BaseMetricId(3955), &super::webfont::compression_woff2);
        map.insert(BaseMetricId(3957), &super::webfont::fonttype);
        map.insert(BaseMetricId(3961), &super::webfont::srctype);
        map.insert(BaseMetricId(3996), &super::image_decode::chunks);
        map.insert(BaseMetricId(3997), &super::image_decode::count);
        map.insert(BaseMetricId(4017), &super::javascript_gc::effectiveness);
        map.insert(BaseMetricId(4020), &super::javascript_gc::mark_rate);
        map.insert(BaseMetricId(4028), &super::javascript_gc::mmu_50);
        map.insert(BaseMetricId(4032), &super::javascript_gc::nursery_promotion_rate);
        map.insert(BaseMetricId(4033), &super::javascript_gc::parallel_mark_interruptions);
        map.insert(BaseMetricId(4034), &super::javascript_gc::parallel_mark_speedup);
        map.insert(BaseMetricId(4036), &super::javascript_gc::parallel_mark_utilization);
        map.insert(BaseMetricId(4038), &super::javascript_gc::pretenure_count);
        map.insert(BaseMetricId(4042), &super::javascript_gc::slice_count);
        map.insert(BaseMetricId(4049), &super::javascript_gc::tenured_survival_rate);
        map.insert(BaseMetricId(4053), &super::javascript_gc::zone_count);
        map.insert(BaseMetricId(4054), &super::javascript_gc::zones_collected);
        map.insert(BaseMetricId(4056), &super::performance_clone_deserialize::items);
        map.insert(BaseMetricId(4077), &super::geckoview::document_site_origins);
        map.insert(BaseMetricId(4081), &super::geckoview::per_document_site_origins);
        map.insert(BaseMetricId(4101), &super::network::cache_v2_input_stream_status);
        map.insert(BaseMetricId(4102), &super::network::cache_v2_output_stream_status);
        map.insert(BaseMetricId(4107), &super::network::http_cache_entry_reuse_count);
        map.insert(BaseMetricId(4108), &super::network::backgroundfilesaver_thread_count);
        map.insert(BaseMetricId(4109), &super::network::id);
        map.insert(BaseMetricId(4111), &super::network::ipv4_and_ipv6_address_connectivity);
        map.insert(BaseMetricId(4115), &super::network::back_pressure_suspension_cp_type);
        map.insert(BaseMetricId(4175), &super::network::tls_early_data_bytes_written);
        map.insert(BaseMetricId(4181), &super::dns::blocklist_count);
        map.insert(BaseMetricId(4189), &super::dns::lookup_method);
        map.insert(BaseMetricId(4210), &super::predictor::base_confidence);
        map.insert(BaseMetricId(4211), &super::predictor::confidence);
        map.insert(BaseMetricId(4212), &super::predictor::global_degradation);
        map.insert(BaseMetricId(4213), &super::predictor::learn_attempts);
        map.insert(BaseMetricId(4218), &super::predictor::predictions_calculated);
        map.insert(BaseMetricId(4219), &super::predictor::prefetch_decision_reason);
        map.insert(BaseMetricId(4220), &super::predictor::prefetch_ignore_reason);
        map.insert(BaseMetricId(4223), &super::predictor::subresource_degradation);
        map.insert(BaseMetricId(4224), &super::predictor::total_preconnects);
        map.insert(BaseMetricId(4225), &super::predictor::total_predictions);
        map.insert(BaseMetricId(4226), &super::predictor::total_prefetches);
        map.insert(BaseMetricId(4227), &super::predictor::total_preresolves);
        map.insert(BaseMetricId(4235), &super::hpack::bytes_evicted_ratio_compressor);
        map.insert(BaseMetricId(4236), &super::hpack::bytes_evicted_ratio_decompressor);
        map.insert(BaseMetricId(4237), &super::hpack::elements_evicted_compressor);
        map.insert(BaseMetricId(4238), &super::hpack::elements_evicted_decompressor);
        map.insert(BaseMetricId(4239), &super::hpack::peak_count_compressor);
        map.insert(BaseMetricId(4240), &super::hpack::peak_count_decompressor);
        map.insert(BaseMetricId(4243), &super::http::altsvc_entries_per_header);
        map.insert(BaseMetricId(4246), &super::http::channel_disposition);
        map.insert(BaseMetricId(4252), &super::http::content_encoding);
        map.insert(BaseMetricId(4253), &super::http::dns_httpssvc_connection_failed_reason);
        map.insert(BaseMetricId(4254), &super::http::dns_httpssvc_record_receiving_stage);
        map.insert(BaseMetricId(4255), &super::http::dnt_usage);
        map.insert(BaseMetricId(4260), &super::http::proxy_type);
        map.insert(BaseMetricId(4261), &super::http::request_per_conn);
        map.insert(BaseMetricId(4262), &super::http::request_per_page);
        map.insert(BaseMetricId(4263), &super::http::request_per_page_from_cache);
        map.insert(BaseMetricId(4264), &super::http::response_version);
        map.insert(BaseMetricId(4265), &super::http::saw_quic_alt_protocol);
        map.insert(BaseMetricId(4270), &super::http::tls_early_data_negotiated);
        map.insert(BaseMetricId(4271), &super::http::transaction_ech_retry_ech_failed_count);
        map.insert(BaseMetricId(4272), &super::http::transaction_ech_retry_others_count);
        map.insert(BaseMetricId(4273), &super::http::transaction_ech_retry_with_ech_count);
        map.insert(BaseMetricId(4274), &super::http::transaction_ech_retry_without_ech_count);
        map.insert(BaseMetricId(4276), &super::http::transaction_restart_reason);
        map.insert(BaseMetricId(4283), &super::http3::blocked_by_stream_limit_per_conn);
        map.insert(BaseMetricId(4286), &super::http3::drop_dgrams);
        map.insert(BaseMetricId(4290), &super::http3::loss_ratio);
        map.insert(BaseMetricId(4292), &super::http3::request_per_conn);
        map.insert(BaseMetricId(4293), &super::http3::saved_dgrams);
        map.insert(BaseMetricId(4294), &super::http3::sending_blocked_by_flow_control_per_trans);
        map.insert(BaseMetricId(4296), &super::http3::trans_blocked_by_stream_limit_per_conn);
        map.insert(BaseMetricId(4297), &super::http3::trans_sending_blocked_by_flow_control_per_conn);
        map.insert(BaseMetricId(4311), &super::spdy::goaway_local);
        map.insert(BaseMetricId(4312), &super::spdy::goaway_peer);
        map.insert(BaseMetricId(4314), &super::spdy::parallel_streams);
        map.insert(BaseMetricId(4315), &super::spdy::request_per_conn);
        map.insert(BaseMetricId(4316), &super::spdy::server_initiated_streams);
        map.insert(BaseMetricId(4318), &super::spdy::settings_max_streams);
        map.insert(BaseMetricId(4319), &super::spdy::syn_ratio);
        map.insert(BaseMetricId(4320), &super::spdy::syn_reply_ratio);
        map.insert(BaseMetricId(4323), &super::websockets::handshake_type);
        map.insert(BaseMetricId(4336), &super::cert::chain_key_size_status);
        map.insert(BaseMetricId(4337), &super::cert::ev_status);
        map.insert(BaseMetricId(4338), &super::cert::validation_http_request_result);
        map.insert(BaseMetricId(4339), &super::cert::validation_success_by_ca);
        map.insert(BaseMetricId(4341), &super::cert_pinning::failures_by_ca);
        map.insert(BaseMetricId(4342), &super::cert_pinning::moz_results_by_host);
        map.insert(BaseMetricId(4343), &super::cert_pinning::moz_test_results_by_host);
        map.insert(BaseMetricId(4357), &super::ssl::auth_algorithm_full);
        map.insert(BaseMetricId(4358), &super::ssl::auth_ecdsa_curve_full);
        map.insert(BaseMetricId(4359), &super::ssl::auth_rsa_key_size_full);
        map.insert(BaseMetricId(4361), &super::ssl::cert_error_overrides);
        map.insert(BaseMetricId(4362), &super::ssl::cert_verification_errors);
        map.insert(BaseMetricId(4363), &super::ssl::ct_policy_non_compliant_connections_by_ca);
        map.insert(BaseMetricId(4364), &super::ssl::kea_dhe_key_size_full);
        map.insert(BaseMetricId(4365), &super::ssl::kea_ecdhe_curve_full);
        map.insert(BaseMetricId(4366), &super::ssl::kea_rsa_key_size_full);
        map.insert(BaseMetricId(4367), &super::ssl::key_exchange_algorithm_full);
        map.insert(BaseMetricId(4368), &super::ssl::key_exchange_algorithm_resumed);
        map.insert(BaseMetricId(4369), &super::ssl::npn_type);
        map.insert(BaseMetricId(4370), &super::ssl::ocsp_stapling);
        map.insert(BaseMetricId(4371), &super::ssl::permanent_cert_error_overrides);
        map.insert(BaseMetricId(4372), &super::ssl::reasons_for_not_false_starting);
        map.insert(BaseMetricId(4374), &super::ssl::scts_origin);
        map.insert(BaseMetricId(4375), &super::ssl::scts_per_connection);
        map.insert(BaseMetricId(4376), &super::ssl::scts_verification_status);
        map.insert(BaseMetricId(4383), &super::ssl::tls10_intolerance_reason_post);
        map.insert(BaseMetricId(4384), &super::ssl::tls10_intolerance_reason_pre);
        map.insert(BaseMetricId(4385), &super::ssl::tls11_intolerance_reason_post);
        map.insert(BaseMetricId(4386), &super::ssl::tls11_intolerance_reason_pre);
        map.insert(BaseMetricId(4387), &super::ssl::tls12_intolerance_reason_post);
        map.insert(BaseMetricId(4388), &super::ssl::tls12_intolerance_reason_pre);
        map.insert(BaseMetricId(4389), &super::ssl::tls13_intolerance_reason_post);
        map.insert(BaseMetricId(4390), &super::ssl::tls13_intolerance_reason_pre);
        map.insert(BaseMetricId(4391), &super::ssl::version_fallback_inappropriate);
        map.insert(BaseMetricId(4392), &super::ssl_handshake::completed);
        map.insert(BaseMetricId(4393), &super::ssl_handshake::privacy);
        map.insert(BaseMetricId(4394), &super::ssl_handshake::result);
        map.insert(BaseMetricId(4395), &super::ssl_handshake::result_conservative);
        map.insert(BaseMetricId(4396), &super::ssl_handshake::result_ech);
        map.insert(BaseMetricId(4397), &super::ssl_handshake::result_ech_grease);
        map.insert(BaseMetricId(4398), &super::ssl_handshake::result_first_try);
        map.insert(BaseMetricId(4399), &super::ssl_handshake::version);
        map.insert(BaseMetricId(4401), &super::tls::cipher_suite);
        map.insert(BaseMetricId(4451), &super::sync::device_count_desktop);
        map.insert(BaseMetricId(4452), &super::sync::device_count_mobile);
        map.insert(BaseMetricId(4456), &super::bounce_tracking_protection::num_hosts_per_purge_run);
        map.insert(BaseMetricId(4463), &super::contentblocking::cookie_behavior);
        map.insert(BaseMetricId(4473), &super::contentblocking::query_stripping_param_count);
        map.insert(BaseMetricId(4475), &super::contentblocking::storage_access_remaining_days);
        map.insert(BaseMetricId(4476), &super::contentblocking::strip_on_share_length_decrease);
        map.insert(BaseMetricId(4477), &super::contentblocking::strip_on_share_params_removed);
        map.insert(BaseMetricId(4481), &super::contentblocking::tracking_protection_shield);
        map.insert(BaseMetricId(4484), &super::cookie_purging::origins_purged);
        map.insert(BaseMetricId(4486), &super::cookie_purging::trackers_with_user_interaction);
        map.insert(BaseMetricId(4521), &super::captcha_detection::arkoselabs_solutions_required);
        map.insert(BaseMetricId(4522), &super::captcha_detection::arkoselabs_solutions_required_pbm);
        map.insert(BaseMetricId(4626), &super::memory::ghost_windows);
        map.insert(BaseMetricId(4628), &super::memory::heap_overhead_fraction);
        map.insert(BaseMetricId(4630), &super::memory::js_compartments_system);
        map.insert(BaseMetricId(4631), &super::memory::js_compartments_user);
        map.insert(BaseMetricId(4633), &super::memory::js_realms_system);
        map.insert(BaseMetricId(4634), &super::memory::js_realms_user);
        map.insert(BaseMetricId(4635), &super::memory::low_memory_events_physical);
        map.insert(BaseMetricId(4636), &super::memory::page_faults_hard);
        map.insert(BaseMetricId(4686), &super::extensions_timing::event_page_running_time);
        map.insert(BaseMetricId(4788), &super::test_only::expired_hist);
        map.insert(BaseMetricId(4822), &super::test_only_ipc::a_custom_dist);
        map.insert(BaseMetricId(4965), &super::pwmgr::login_page_safety);
        map.insert(BaseMetricId(4986), &super::pwmgr::prompt_remember_action);
        map.insert(BaseMetricId(4988), &super::pwmgr::prompt_update_action);
        map.insert(BaseMetricId(5020), &super::pdfjs::time_to_view);
        map.insert(BaseMetricId(5031), &super::pdfjs_editing_highlight::thickness);
        map.insert(BaseMetricId(5098), &super::places::annos_pages_count);
        map.insert(BaseMetricId(5102), &super::places::bookmarks_count);
        map.insert(BaseMetricId(5105), &super::places::expiration_steps_to_clean);
        map.insert(BaseMetricId(5110), &super::places::keywords_count);
        map.insert(BaseMetricId(5113), &super::places::pages_count);
        map.insert(BaseMetricId(5117), &super::places::sorted_bookmarks_perc);
        map.insert(BaseMetricId(5119), &super::places::tagged_bookmarks_perc);
        map.insert(BaseMetricId(5120), &super::places::tags_count);
        map.insert(BaseMetricId(5139), &super::power_battery::percentage_when_user_active);
        map.insert(BaseMetricId(5151), &super::readermode::download_result);
        map.insert(BaseMetricId(5152), &super::readermode::parse_result);
        map.insert(BaseMetricId(5202), &super::application_reputation::local);
        map.insert(BaseMetricId(5206), &super::application_reputation::server);
        map.insert(BaseMetricId(5208), &super::application_reputation::server_verdict);
        map.insert(BaseMetricId(5523), &super::telemetry::archive_directories_count);
        map.insert(BaseMetricId(5524), &super::telemetry::archive_evicted_old_dirs);
        map.insert(BaseMetricId(5525), &super::telemetry::archive_evicted_over_quota);
        map.insert(BaseMetricId(5528), &super::telemetry::archive_oldest_directory_age);
        map.insert(BaseMetricId(5529), &super::telemetry::archive_scan_ping_count);
        map.insert(BaseMetricId(5547), &super::telemetry::pending_pings_evicted_over_quota);
        map.insert(BaseMetricId(5575), &super::thumbnails::capture_done_reason_2);
        map.insert(BaseMetricId(5579), &super::thumbnails::queue_size_on_capture);
        map.insert(BaseMetricId(5630), &super::urlclassifier::completion_error);
        map.insert(BaseMetricId(5633), &super::urlclassifier::threathit_network_error);
        map.insert(BaseMetricId(5634), &super::urlclassifier::threathit_remote_status);
        map.insert(BaseMetricId(5635), &super::urlclassifier::ui_events);
        map.insert(BaseMetricId(5671), &super::region::fetch_result);
        map.insert(BaseMetricId(5682), &super::newtab_page::blocked_sites_count);
        map.insert(BaseMetricId(5683), &super::newtab_page::pinned_sites_count);
        map.insert(BaseMetricId(5780), &super::update::bits_result_complete);
        map.insert(BaseMetricId(5781), &super::update::bits_result_partial);
        map.insert(BaseMetricId(5788), &super::update::check_code_external);
        map.insert(BaseMetricId(5789), &super::update::check_code_notify);
        map.insert(BaseMetricId(5790), &super::update::check_code_subsequent);
        map.insert(BaseMetricId(5797), &super::update::download_code_complete);
        map.insert(BaseMetricId(5798), &super::update::download_code_partial);
        map.insert(BaseMetricId(5799), &super::update::download_code_unknown);
        map.insert(BaseMetricId(5824), &super::update::pref_service_errors_external);
        map.insert(BaseMetricId(5825), &super::update::pref_service_errors_notify);
        map.insert(BaseMetricId(5826), &super::update::pref_service_errors_subsequent);
        map.insert(BaseMetricId(5827), &super::update::pref_update_cancelations_external);
        map.insert(BaseMetricId(5828), &super::update::pref_update_cancelations_notify);
        map.insert(BaseMetricId(5829), &super::update::pref_update_cancelations_subsequent);
        map.insert(BaseMetricId(5836), &super::update::state_code_complete_stage);
        map.insert(BaseMetricId(5837), &super::update::state_code_complete_startup);
        map.insert(BaseMetricId(5838), &super::update::state_code_partial_stage);
        map.insert(BaseMetricId(5839), &super::update::state_code_partial_startup);
        map.insert(BaseMetricId(5840), &super::update::state_code_unknown_stage);
        map.insert(BaseMetricId(5841), &super::update::state_code_unknown_startup);
        map.insert(BaseMetricId(5842), &super::update::status_error_code_complete_stage);
        map.insert(BaseMetricId(5843), &super::update::status_error_code_complete_startup);
        map.insert(BaseMetricId(5844), &super::update::status_error_code_partial_stage);
        map.insert(BaseMetricId(5845), &super::update::status_error_code_partial_startup);
        map.insert(BaseMetricId(5846), &super::update::status_error_code_unknown_stage);
        map.insert(BaseMetricId(5847), &super::update::status_error_code_unknown_startup);
        map.insert(BaseMetricId(5861), &super::gecko::safe_mode_usage);
        map.insert(BaseMetricId(5874), &super::cycle_collector::collected);
        map.insert(BaseMetricId(5881), &super::cycle_collector::slice_during_idle);
        map.insert(BaseMetricId(5885), &super::cycle_collector::visited_gced);
        map.insert(BaseMetricId(5886), &super::cycle_collector::visited_ref_counted);
        map.insert(BaseMetricId(5887), &super::cycle_collector::worker_collected);
        map.insert(BaseMetricId(5890), &super::cycle_collector::worker_visited_gced);
        map.insert(BaseMetricId(5891), &super::cycle_collector::worker_visited_ref_counted);
        map.insert(BaseMetricId(5894), &super::memory_phc::slots_allocated);
        map.insert(BaseMetricId(5895), &super::memory_phc::slots_freed);
        map.insert(BaseMetricId(5910), &super::timer_thread::timers_fired_per_wakeup);
        map
    });

    pub static QUANTITY_MAP: Lazy<HashMap<BaseMetricId, &Lazy<QuantityMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(236);
        map.insert(BaseMetricId(4), &super::a11y::hcm_background);
        map.insert(BaseMetricId(5), &super::a11y::hcm_foreground);
        map.insert(BaseMetricId(22), &super::browser_engagement::max_concurrent_tab_count);
        map.insert(BaseMetricId(23), &super::browser_engagement::max_concurrent_tab_pinned_count);
        map.insert(BaseMetricId(24), &super::browser_engagement::max_concurrent_vertical_tab_count);
        map.insert(BaseMetricId(25), &super::browser_engagement::max_concurrent_vertical_tab_pinned_count);
        map.insert(BaseMetricId(26), &super::browser_engagement::max_concurrent_window_count);
        map.insert(BaseMetricId(27), &super::browser_engagement::profile_count);
        map.insert(BaseMetricId(32), &super::browser_engagement::unique_domains_count);
        map.insert(BaseMetricId(38), &super::browser_engagement::session_time_excluding_suspend);
        map.insert(BaseMetricId(39), &super::browser_engagement::session_time_including_suspend);
        map.insert(BaseMetricId(45), &super::browser_timings::last_shutdown);
        map.insert(BaseMetricId(191), &super::networking::https_rr_prefs_usage);
        map.insert(BaseMetricId(193), &super::networking::loading_certs_task);
        map.insert(BaseMetricId(194), &super::networking::nss_initialization);
        map.insert(BaseMetricId(198), &super::networking::doh_heuristics_result);
        map.insert(BaseMetricId(229), &super::messaging_system::event_screen_index);
        map.insert(BaseMetricId(255), &super::browser_backup::browser_extension_data_size);
        map.insert(BaseMetricId(258), &super::browser_backup::cookies_size);
        map.insert(BaseMetricId(260), &super::browser_backup::credentials_data_size);
        map.insert(BaseMetricId(263), &super::browser_backup::extension_store_permissions_data_size);
        map.insert(BaseMetricId(264), &super::browser_backup::extensions_json_size);
        map.insert(BaseMetricId(265), &super::browser_backup::extensions_storage_size);
        map.insert(BaseMetricId(266), &super::browser_backup::extensions_xpi_directory_size);
        map.insert(BaseMetricId(267), &super::browser_backup::favicons_size);
        map.insert(BaseMetricId(269), &super::browser_backup::form_history_size);
        map.insert(BaseMetricId(270), &super::browser_backup::location_on_device);
        map.insert(BaseMetricId(271), &super::browser_backup::misc_data_size);
        map.insert(BaseMetricId(275), &super::browser_backup::places_size);
        map.insert(BaseMetricId(277), &super::browser_backup::preferences_size);
        map.insert(BaseMetricId(278), &super::browser_backup::prof_d_disk_space);
        map.insert(BaseMetricId(281), &super::browser_backup::security_data_size);
        map.insert(BaseMetricId(282), &super::browser_backup::session_store_backups_directory_size);
        map.insert(BaseMetricId(283), &super::browser_backup::session_store_size);
        map.insert(BaseMetricId(284), &super::browser_backup::storage_sync_size);
        map.insert(BaseMetricId(372), &super::background_update::targeting_env_firefox_version);
        map.insert(BaseMetricId(376), &super::background_update::targeting_version);
        map.insert(BaseMetricId(388), &super::browser_startup::abouthome_cache_result);
        map.insert(BaseMetricId(400), &super::datasanitization::session_permission_exceptions);
        map.insert(BaseMetricId(412), &super::security::global_privacy_control_enabled);
        map.insert(BaseMetricId(413), &super::security::https_only_mode_enabled);
        map.insert(BaseMetricId(414), &super::security::https_only_mode_enabled_pbm);
        map.insert(BaseMetricId(431), &super::startup::seconds_since_last_os_restart);
        map.insert(BaseMetricId(432), &super::startup::profile_count);
        map.insert(BaseMetricId(578), &super::newtab_content::utc_offset);
        map.insert(BaseMetricId(594), &super::top_sites::position);
        map.insert(BaseMetricId(603), &super::topsites::rows);
        map.insert(BaseMetricId(606), &super::topsites::sponsored_tiles_configured);
        map.insert(BaseMetricId(621), &super::pocket_button::event_position);
        map.insert(BaseMetricId(626), &super::pocket_button::profile_creation_date);
        map.insert(BaseMetricId(881), &super::sidebar::width);
        map.insert(BaseMetricId(942), &super::tabgroup::saved_groups);
        map.insert(BaseMetricId(964), &super::quick_suggest::position);
        map.insert(BaseMetricId(983), &super::urlbar::pref_max_results);
        map.insert(BaseMetricId(1040), &super::timestamps::about_home_topsites_first_paint);
        map.insert(BaseMetricId(1041), &super::timestamps::first_paint);
        map.insert(BaseMetricId(1042), &super::timestamps::first_paint_two);
        map.insert(BaseMetricId(3919), &super::gfx_adapter_primary::ram);
        map.insert(BaseMetricId(3938), &super::gfx_display::count);
        map.insert(BaseMetricId(3939), &super::gfx_display::primary_height);
        map.insert(BaseMetricId(3940), &super::gfx_display::primary_width);
        map.insert(BaseMetricId(3943), &super::gfx_hdr::windows_display_colorspace_bitfield);
        map.insert(BaseMetricId(3951), &super::gpu_process::total_launch_attempts);
        map.insert(BaseMetricId(3952), &super::gpu_process::unstable_launch_attempts);
        map.insert(BaseMetricId(4333), &super::cert_verifier::trust_obj_count);
        map.insert(BaseMetricId(4349), &super::data_storage::alternate_services);
        map.insert(BaseMetricId(4350), &super::data_storage::client_auth_remember_list);
        map.insert(BaseMetricId(4351), &super::data_storage::site_security_service_state);
        map.insert(BaseMetricId(4356), &super::pkcs11::third_party_modules_loaded);
        map.insert(BaseMetricId(4455), &super::bounce_tracking_protection::mode);
        map.insert(BaseMetricId(4462), &super::contentblocking::category);
        map.insert(BaseMetricId(4489), &super::background_tasks_rmdir_base::elapsed_ms);
        map.insert(BaseMetricId(4491), &super::background_tasks_rmdir_base::removal_count);
        map.insert(BaseMetricId(4492), &super::background_tasks_rmdir_base::retry_count);
        map.insert(BaseMetricId(4495), &super::background_tasks_rmdir_base::suffix_removal_count);
        map.insert(BaseMetricId(4497), &super::background_tasks_rmdir_http_cache::elapsed_ms);
        map.insert(BaseMetricId(4499), &super::background_tasks_rmdir_http_cache::removal_count);
        map.insert(BaseMetricId(4500), &super::background_tasks_rmdir_http_cache::retry_count);
        map.insert(BaseMetricId(4503), &super::background_tasks_rmdir_http_cache::suffix_removal_count);
        map.insert(BaseMetricId(4505), &super::background_tasks_rmdir_quota::elapsed_ms);
        map.insert(BaseMetricId(4507), &super::background_tasks_rmdir_quota::removal_count);
        map.insert(BaseMetricId(4508), &super::background_tasks_rmdir_quota::retry_count);
        map.insert(BaseMetricId(4511), &super::background_tasks_rmdir_quota::suffix_removal_count);
        map.insert(BaseMetricId(4580), &super::crash::event_loop_nesting_level);
        map.insert(BaseMetricId(4582), &super::crash::gpu_process_launch);
        map.insert(BaseMetricId(4611), &super::memory::available_commit);
        map.insert(BaseMetricId(4612), &super::memory::available_physical);
        map.insert(BaseMetricId(4613), &super::memory::available_swap);
        map.insert(BaseMetricId(4614), &super::memory::available_virtual);
        map.insert(BaseMetricId(4615), &super::memory::low_physical);
        map.insert(BaseMetricId(4616), &super::memory::oom_allocation_size);
        map.insert(BaseMetricId(4617), &super::memory::purgeable_physical);
        map.insert(BaseMetricId(4618), &super::memory::system_use_percentage);
        map.insert(BaseMetricId(4619), &super::memory::texture);
        map.insert(BaseMetricId(4620), &super::memory::total_page_file);
        map.insert(BaseMetricId(4621), &super::memory::total_physical);
        map.insert(BaseMetricId(4622), &super::memory::total_virtual);
        map.insert(BaseMetricId(4658), &super::policies::count);
        map.insert(BaseMetricId(4663), &super::extensions::startup_cache_write_bytelength);
        map.insert(BaseMetricId(4666), &super::extensions_apis_dnr::evaluate_rules_count_max);
        map.insert(BaseMetricId(4762), &super::formautofill_addresses::autofill_profiles_count);
        map.insert(BaseMetricId(4763), &super::formautofill_creditcards::autofill_profiles_count);
        map.insert(BaseMetricId(4768), &super::fog::max_pings_per_minute);
        map.insert(BaseMetricId(4803), &super::test_only::main_only);
        map.insert(BaseMetricId(4804), &super::test_only::meaning_of_life);
        map.insert(BaseMetricId(4829), &super::test_only_ipc::a_quantity);
        map.insert(BaseMetricId(4882), &super::nimbus_targeting_context::addresses_saved);
        map.insert(BaseMetricId(4883), &super::nimbus_targeting_context::arch_bits);
        map.insert(BaseMetricId(4891), &super::nimbus_targeting_context::firefox_version);
        map.insert(BaseMetricId(4901), &super::nimbus_targeting_context::memory_mb);
        map.insert(BaseMetricId(4904), &super::nimbus_targeting_context::profile_age_created);
        map.insert(BaseMetricId(4906), &super::nimbus_targeting_context::total_bookmarks_count);
        map.insert(BaseMetricId(4974), &super::pwmgr::num_saved_passwords);
        map.insert(BaseMetricId(4985), &super::pwmgr::potentially_breached_passwords);
        map.insert(BaseMetricId(5081), &super::pictureinpicture::most_concurrent_players);
        map.insert(BaseMetricId(5114), &super::places::pages_need_frecency_recalculation);
        map.insert(BaseMetricId(5116), &super::places::previousday_visits);
        map.insert(BaseMetricId(5169), &super::broken_site_report_browser_info_prefs::cookie_behavior);
        map.insert(BaseMetricId(5183), &super::broken_site_report_browser_info_system::memory);
        map.insert(BaseMetricId(5210), &super::characteristics::any_pointer_type);
        map.insert(BaseMetricId(5211), &super::characteristics::audio_channels);
        map.insert(BaseMetricId(5212), &super::characteristics::audio_fingerprint);
        map.insert(BaseMetricId(5213), &super::characteristics::audio_frames);
        map.insert(BaseMetricId(5214), &super::characteristics::audio_rate);
        map.insert(BaseMetricId(5215), &super::characteristics::avail_height);
        map.insert(BaseMetricId(5216), &super::characteristics::avail_width);
        map.insert(BaseMetricId(5217), &super::characteristics::build_date);
        map.insert(BaseMetricId(5218), &super::characteristics::camera_count);
        map.insert(BaseMetricId(5250), &super::characteristics::color_accentcolor);
        map.insert(BaseMetricId(5251), &super::characteristics::color_accentcolortext);
        map.insert(BaseMetricId(5252), &super::characteristics::color_canvas);
        map.insert(BaseMetricId(5253), &super::characteristics::color_canvastext);
        map.insert(BaseMetricId(5254), &super::characteristics::color_highlight);
        map.insert(BaseMetricId(5255), &super::characteristics::color_highlighttext);
        map.insert(BaseMetricId(5256), &super::characteristics::color_scheme);
        map.insert(BaseMetricId(5257), &super::characteristics::color_selecteditem);
        map.insert(BaseMetricId(5258), &super::characteristics::color_selecteditemtext);
        map.insert(BaseMetricId(5263), &super::characteristics::font_default_modified);
        map.insert(BaseMetricId(5266), &super::characteristics::font_minimum_size_modified);
        map.insert(BaseMetricId(5268), &super::characteristics::font_name_list_cursive_modified);
        map.insert(BaseMetricId(5270), &super::characteristics::font_name_list_monospace_modified);
        map.insert(BaseMetricId(5271), &super::characteristics::font_name_list_sans_serif_modified);
        map.insert(BaseMetricId(5272), &super::characteristics::font_name_list_serif_modified);
        map.insert(BaseMetricId(5274), &super::characteristics::font_name_monospace_modified);
        map.insert(BaseMetricId(5277), &super::characteristics::font_name_sans_serif_modified);
        map.insert(BaseMetricId(5280), &super::characteristics::font_name_serif_modified);
        map.insert(BaseMetricId(5283), &super::characteristics::font_size_monospace_modified);
        map.insert(BaseMetricId(5286), &super::characteristics::font_size_variable_modified);
        map.insert(BaseMetricId(5355), &super::characteristics::group_count);
        map.insert(BaseMetricId(5356), &super::characteristics::group_count_wo_speakers);
        map.insert(BaseMetricId(5357), &super::characteristics::ice_order);
        map.insert(BaseMetricId(5358), &super::characteristics::ice_sd);
        map.insert(BaseMetricId(5359), &super::characteristics::inner_height);
        map.insert(BaseMetricId(5360), &super::characteristics::inner_width);
        map.insert(BaseMetricId(5379), &super::characteristics::max_touch_points);
        map.insert(BaseMetricId(5384), &super::characteristics::microphone_count);
        map.insert(BaseMetricId(5387), &super::characteristics::motion_decimals);
        map.insert(BaseMetricId(5388), &super::characteristics::motion_freq);
        map.insert(BaseMetricId(5389), &super::characteristics::orientation_decimals);
        map.insert(BaseMetricId(5390), &super::characteristics::orientation_freq);
        map.insert(BaseMetricId(5391), &super::characteristics::orientationabs_decimals);
        map.insert(BaseMetricId(5392), &super::characteristics::orientationabs_freq);
        map.insert(BaseMetricId(5396), &super::characteristics::outer_height);
        map.insert(BaseMetricId(5397), &super::characteristics::outer_width);
        map.insert(BaseMetricId(5401), &super::characteristics::pointer_height);
        map.insert(BaseMetricId(5404), &super::characteristics::pointer_tiltx);
        map.insert(BaseMetricId(5405), &super::characteristics::pointer_tilty);
        map.insert(BaseMetricId(5406), &super::characteristics::pointer_twist);
        map.insert(BaseMetricId(5407), &super::characteristics::pointer_type);
        map.insert(BaseMetricId(5408), &super::characteristics::pointer_width);
        map.insert(BaseMetricId(5409), &super::characteristics::prefers_contrast);
        map.insert(BaseMetricId(5418), &super::characteristics::prefs_network_cookie_cookiebehavior);
        map.insert(BaseMetricId(5423), &super::characteristics::processor_count);
        map.insert(BaseMetricId(5424), &super::characteristics::screen_height);
        map.insert(BaseMetricId(5425), &super::characteristics::screen_width);
        map.insert(BaseMetricId(5427), &super::characteristics::size_mode);
        map.insert(BaseMetricId(5428), &super::characteristics::speaker_count);
        map.insert(BaseMetricId(5429), &super::characteristics::submission_schema);
        map.insert(BaseMetricId(5431), &super::characteristics::target_frame_rate);
        map.insert(BaseMetricId(5440), &super::characteristics::voices_count);
        map.insert(BaseMetricId(5442), &super::characteristics::voices_local_count);
        map.insert(BaseMetricId(5447), &super::characteristics::wgpu_maxbindgroups);
        map.insert(BaseMetricId(5448), &super::characteristics::wgpu_maxbindgroupsplusvertexbuffers);
        map.insert(BaseMetricId(5449), &super::characteristics::wgpu_maxbindingsperbindgroup);
        map.insert(BaseMetricId(5450), &super::characteristics::wgpu_maxbuffersize);
        map.insert(BaseMetricId(5451), &super::characteristics::wgpu_maxcolorattachmentbytespersample);
        map.insert(BaseMetricId(5452), &super::characteristics::wgpu_maxcolorattachments);
        map.insert(BaseMetricId(5453), &super::characteristics::wgpu_maxcomputeinvocationsperworkgroup);
        map.insert(BaseMetricId(5454), &super::characteristics::wgpu_maxcomputeworkgroupsizex);
        map.insert(BaseMetricId(5455), &super::characteristics::wgpu_maxcomputeworkgroupsizey);
        map.insert(BaseMetricId(5456), &super::characteristics::wgpu_maxcomputeworkgroupsizez);
        map.insert(BaseMetricId(5457), &super::characteristics::wgpu_maxcomputeworkgroupsperdimension);
        map.insert(BaseMetricId(5458), &super::characteristics::wgpu_maxcomputeworkgroupstoragesize);
        map.insert(BaseMetricId(5459), &super::characteristics::wgpu_maxdynamicstoragebuffersperpipelinelayout);
        map.insert(BaseMetricId(5460), &super::characteristics::wgpu_maxdynamicuniformbuffersperpipelinelayout);
        map.insert(BaseMetricId(5461), &super::characteristics::wgpu_maxinterstageshadervariables);
        map.insert(BaseMetricId(5462), &super::characteristics::wgpu_maxsampledtexturespershaderstage);
        map.insert(BaseMetricId(5463), &super::characteristics::wgpu_maxsamplerspershaderstage);
        map.insert(BaseMetricId(5464), &super::characteristics::wgpu_maxstoragebufferbindingsize);
        map.insert(BaseMetricId(5465), &super::characteristics::wgpu_maxstoragebufferspershaderstage);
        map.insert(BaseMetricId(5466), &super::characteristics::wgpu_maxstoragetexturespershaderstage);
        map.insert(BaseMetricId(5467), &super::characteristics::wgpu_maxtexturearraylayers);
        map.insert(BaseMetricId(5468), &super::characteristics::wgpu_maxtexturedimension1d);
        map.insert(BaseMetricId(5469), &super::characteristics::wgpu_maxtexturedimension2d);
        map.insert(BaseMetricId(5470), &super::characteristics::wgpu_maxtexturedimension3d);
        map.insert(BaseMetricId(5471), &super::characteristics::wgpu_maxuniformbufferbindingsize);
        map.insert(BaseMetricId(5472), &super::characteristics::wgpu_maxuniformbufferspershaderstage);
        map.insert(BaseMetricId(5473), &super::characteristics::wgpu_maxvertexattributes);
        map.insert(BaseMetricId(5474), &super::characteristics::wgpu_maxvertexbufferarraystride);
        map.insert(BaseMetricId(5475), &super::characteristics::wgpu_maxvertexbuffers);
        map.insert(BaseMetricId(5476), &super::characteristics::wgpu_minstoragebufferoffsetalignment);
        map.insert(BaseMetricId(5477), &super::characteristics::wgpu_minuniformbufferoffsetalignment);
        map.insert(BaseMetricId(5479), &super::characteristics::zoom_count);
        map.insert(BaseMetricId(5482), &super::browser_searchinit::insecure_opensearch_engine_count);
        map.insert(BaseMetricId(5483), &super::browser_searchinit::insecure_opensearch_update_count);
        map.insert(BaseMetricId(5484), &super::browser_searchinit::secure_opensearch_engine_count);
        map.insert(BaseMetricId(5485), &super::browser_searchinit::secure_opensearch_update_count);
        map.insert(BaseMetricId(5570), &super::usage::windows_build_number);
        map.insert(BaseMetricId(5675), &super::first_startup::delete_tasks_time);
        map.insert(BaseMetricId(5676), &super::first_startup::elapsed);
        map.insert(BaseMetricId(5678), &super::first_startup::normandy_init_time);
        map.insert(BaseMetricId(5679), &super::first_startup::status_code);
        map.insert(BaseMetricId(5688), &super::defaultagent::days_since_last_app_launch);
        map.insert(BaseMetricId(5858), &super::e10s::multi_processes);
        map.insert(BaseMetricId(5863), &super::launcher_process::state);
        map.insert(BaseMetricId(5897), &super::system_cpu::big_cores);
        map.insert(BaseMetricId(5898), &super::system_cpu::family);
        map.insert(BaseMetricId(5899), &super::system_cpu::l2_cache);
        map.insert(BaseMetricId(5900), &super::system_cpu::l3_cache);
        map.insert(BaseMetricId(5901), &super::system_cpu::little_cores);
        map.insert(BaseMetricId(5902), &super::system_cpu::logical_cores);
        map.insert(BaseMetricId(5903), &super::system_cpu::medium_cores);
        map.insert(BaseMetricId(5904), &super::system_cpu::model);
        map.insert(BaseMetricId(5906), &super::system_cpu::physical_cores);
        map.insert(BaseMetricId(5907), &super::system_cpu::speed);
        map.insert(BaseMetricId(5908), &super::system_cpu::stepping);
        map
    });

    pub static STRING_MAP: Lazy<HashMap<BaseMetricId, &Lazy<StringMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(248);
        map.insert(BaseMetricId(6), &super::a11y::instantiators);
        map.insert(BaseMetricId(218), &super::messaging_system::addon_version);
        map.insert(BaseMetricId(220), &super::messaging_system::bucket_id);
        map.insert(BaseMetricId(222), &super::messaging_system::event);
        map.insert(BaseMetricId(225), &super::messaging_system::event_page);
        map.insert(BaseMetricId(226), &super::messaging_system::event_reason);
        map.insert(BaseMetricId(231), &super::messaging_system::event_source);
        map.insert(BaseMetricId(235), &super::messaging_system::locale);
        map.insert(BaseMetricId(238), &super::messaging_system::ping_type);
        map.insert(BaseMetricId(239), &super::messaging_system::source);
        map.insert(BaseMetricId(242), &super::messaging_system_attribution::campaign);
        map.insert(BaseMetricId(243), &super::messaging_system_attribution::content);
        map.insert(BaseMetricId(244), &super::messaging_system_attribution::dlsource);
        map.insert(BaseMetricId(245), &super::messaging_system_attribution::dltoken);
        map.insert(BaseMetricId(246), &super::messaging_system_attribution::experiment);
        map.insert(BaseMetricId(247), &super::messaging_system_attribution::medium);
        map.insert(BaseMetricId(248), &super::messaging_system_attribution::msstoresignedin);
        map.insert(BaseMetricId(249), &super::messaging_system_attribution::source);
        map.insert(BaseMetricId(250), &super::messaging_system_attribution::ua);
        map.insert(BaseMetricId(252), &super::messaging_system_attribution::variation);
        map.insert(BaseMetricId(339), &super::genai_chatbot::provider);
        map.insert(BaseMetricId(368), &super::background_update::final_state);
        map.insert(BaseMetricId(407), &super::os_environment::launch_method);
        map.insert(BaseMetricId(409), &super::os_environment::allowed_app_sources);
        map.insert(BaseMetricId(433), &super::startup::profile_database_version);
        map.insert(BaseMetricId(434), &super::startup::profile_selection_reason);
        map.insert(BaseMetricId(516), &super::deletion_request::context_id);
        map.insert(BaseMetricId(517), &super::deletion_request::impression_id);
        map.insert(BaseMetricId(518), &super::deletion_request::sync_device_id);
        map.insert(BaseMetricId(528), &super::newtab::homepage_category);
        map.insert(BaseMetricId(531), &super::newtab::locale);
        map.insert(BaseMetricId(533), &super::newtab::newtab_category);
        map.insert(BaseMetricId(565), &super::newtab_content::coarse_os);
        map.insert(BaseMetricId(566), &super::newtab_content::coarse_os_version);
        map.insert(BaseMetricId(576), &super::newtab_content::surface_id);
        map.insert(BaseMetricId(591), &super::top_sites::advertiser);
        map.insert(BaseMetricId(593), &super::top_sites::ping_type);
        map.insert(BaseMetricId(596), &super::top_sites::source);
        map.insert(BaseMetricId(597), &super::top_sites::tile_id);
        map.insert(BaseMetricId(620), &super::pocket_button::event_action);
        map.insert(BaseMetricId(622), &super::pocket_button::event_source);
        map.insert(BaseMetricId(624), &super::pocket_button::model);
        map.insert(BaseMetricId(870), &super::sidebar::display_settings);
        map.insert(BaseMetricId(875), &super::sidebar::position_settings);
        map.insert(BaseMetricId(880), &super::sidebar::tabs_layout);
        map.insert(BaseMetricId(956), &super::quick_suggest::advertiser);
        map.insert(BaseMetricId(957), &super::quick_suggest::block_id);
        map.insert(BaseMetricId(959), &super::quick_suggest::iab_category);
        map.insert(BaseMetricId(962), &super::quick_suggest::match_type);
        map.insert(BaseMetricId(963), &super::quick_suggest::ping_type);
        map.insert(BaseMetricId(966), &super::quick_suggest::request_id);
        map.insert(BaseMetricId(967), &super::quick_suggest::source);
        map.insert(BaseMetricId(968), &super::quick_suggest::suggested_index);
        map.insert(BaseMetricId(1021), &super::installation_first_seen::failure_reason);
        map.insert(BaseMetricId(1024), &super::installation_first_seen::installer_type);
        map.insert(BaseMetricId(1029), &super::installation_first_seen::version);
        map.insert(BaseMetricId(3906), &super::gfx::linux_window_protocol);
        map.insert(BaseMetricId(3913), &super::gfx_adapter_primary::description);
        map.insert(BaseMetricId(3914), &super::gfx_adapter_primary::device_id);
        map.insert(BaseMetricId(3915), &super::gfx_adapter_primary::driver_date);
        map.insert(BaseMetricId(3916), &super::gfx_adapter_primary::driver_files);
        map.insert(BaseMetricId(3917), &super::gfx_adapter_primary::driver_vendor);
        map.insert(BaseMetricId(3918), &super::gfx_adapter_primary::driver_version);
        map.insert(BaseMetricId(3920), &super::gfx_adapter_primary::subsystem_id);
        map.insert(BaseMetricId(3921), &super::gfx_adapter_primary::vendor_id);
        map.insert(BaseMetricId(3942), &super::gfx_feature::webrender);
        map.insert(BaseMetricId(3944), &super::gfx_status::compositor);
        map.insert(BaseMetricId(3946), &super::gfx_status::last_compositor_gecko_version);
        map.insert(BaseMetricId(3948), &super::gpu_process::feature_status);
        map.insert(BaseMetricId(4414), &super::client_association::uid);
        map.insert(BaseMetricId(4552), &super::captcha_detection::network_cookie_cookiebehavior);
        map.insert(BaseMetricId(4574), &super::crash::app_build);
        map.insert(BaseMetricId(4575), &super::crash::app_channel);
        map.insert(BaseMetricId(4576), &super::crash::app_display_version);
        map.insert(BaseMetricId(4578), &super::crash::background_task_name);
        map.insert(BaseMetricId(4581), &super::crash::font_name);
        map.insert(BaseMetricId(4583), &super::crash::ipc_channel_error);
        map.insert(BaseMetricId(4585), &super::crash::main_thread_runnable_name);
        map.insert(BaseMetricId(4586), &super::crash::minidump_sha256_hash);
        map.insert(BaseMetricId(4587), &super::crash::moz_crash_reason);
        map.insert(BaseMetricId(4588), &super::crash::process_type);
        map.insert(BaseMetricId(4589), &super::crash::profiler_child_shutdown_phase);
        map.insert(BaseMetricId(4591), &super::crash::remote_type);
        map.insert(BaseMetricId(4592), &super::crash::shutdown_progress);
        map.insert(BaseMetricId(4599), &super::crash_windows::file_dialog_error_code);
        map.insert(BaseMetricId(4645), &super::windows::package_family_name);
        map.insert(BaseMetricId(4779), &super::test_only::cheesy_string);
        map.insert(BaseMetricId(4789), &super::test_only::impression_id_only);
        map.insert(BaseMetricId(4830), &super::test_only_ipc::a_string);
        map.insert(BaseMetricId(4886), &super::nimbus_targeting_context::current_date);
        map.insert(BaseMetricId(4888), &super::nimbus_targeting_context::distribution_id);
        map.insert(BaseMetricId(4900), &super::nimbus_targeting_context::locale);
        map.insert(BaseMetricId(4905), &super::nimbus_targeting_context::region);
        map.insert(BaseMetricId(4910), &super::nimbus_targeting_context::version);
        map.insert(BaseMetricId(5155), &super::broken_site_report::breakage_category);
        map.insert(BaseMetricId(5163), &super::broken_site_report_browser_info_graphics::device_pixel_ratio);
        map.insert(BaseMetricId(5186), &super::broken_site_report_tab_info_antitracking::block_list);
        map.insert(BaseMetricId(5188), &super::broken_site_report_tab_info_antitracking::etp_category);
        map.insert(BaseMetricId(5219), &super::characteristics::canvas_dpr);
        map.insert(BaseMetricId(5220), &super::characteristics::canvas_feature_status);
        map.insert(BaseMetricId(5221), &super::characteristics::canvasdata1);
        map.insert(BaseMetricId(5222), &super::characteristics::canvasdata10);
        map.insert(BaseMetricId(5223), &super::characteristics::canvasdata10software);
        map.insert(BaseMetricId(5224), &super::characteristics::canvasdata11_webgl);
        map.insert(BaseMetricId(5225), &super::characteristics::canvasdata11_webglsoftware);
        map.insert(BaseMetricId(5226), &super::characteristics::canvasdata12_fingerprintjs1);
        map.insert(BaseMetricId(5227), &super::characteristics::canvasdata12_fingerprintjs1software);
        map.insert(BaseMetricId(5228), &super::characteristics::canvasdata13_fingerprintjs2);
        map.insert(BaseMetricId(5229), &super::characteristics::canvasdata13_fingerprintjs2software);
        map.insert(BaseMetricId(5230), &super::characteristics::canvasdata1software);
        map.insert(BaseMetricId(5231), &super::characteristics::canvasdata2);
        map.insert(BaseMetricId(5232), &super::characteristics::canvasdata2software);
        map.insert(BaseMetricId(5233), &super::characteristics::canvasdata3);
        map.insert(BaseMetricId(5234), &super::characteristics::canvasdata3software);
        map.insert(BaseMetricId(5235), &super::characteristics::canvasdata4);
        map.insert(BaseMetricId(5236), &super::characteristics::canvasdata4software);
        map.insert(BaseMetricId(5237), &super::characteristics::canvasdata5);
        map.insert(BaseMetricId(5238), &super::characteristics::canvasdata5software);
        map.insert(BaseMetricId(5239), &super::characteristics::canvasdata6);
        map.insert(BaseMetricId(5240), &super::characteristics::canvasdata6software);
        map.insert(BaseMetricId(5241), &super::characteristics::canvasdata7);
        map.insert(BaseMetricId(5242), &super::characteristics::canvasdata7software);
        map.insert(BaseMetricId(5243), &super::characteristics::canvasdata8);
        map.insert(BaseMetricId(5244), &super::characteristics::canvasdata8software);
        map.insert(BaseMetricId(5245), &super::characteristics::canvasdata9);
        map.insert(BaseMetricId(5246), &super::characteristics::canvasdata9software);
        map.insert(BaseMetricId(5247), &super::characteristics::changed_media_prefs);
        map.insert(BaseMetricId(5248), &super::characteristics::channel);
        map.insert(BaseMetricId(5259), &super::characteristics::cpu_arch);
        map.insert(BaseMetricId(5260), &super::characteristics::cpu_model);
        map.insert(BaseMetricId(5262), &super::characteristics::font_default_default_group);
        map.insert(BaseMetricId(5264), &super::characteristics::font_default_western);
        map.insert(BaseMetricId(5265), &super::characteristics::font_minimum_size_default_group);
        map.insert(BaseMetricId(5267), &super::characteristics::font_minimum_size_western);
        map.insert(BaseMetricId(5273), &super::characteristics::font_name_monospace_default_group);
        map.insert(BaseMetricId(5275), &super::characteristics::font_name_monospace_western);
        map.insert(BaseMetricId(5276), &super::characteristics::font_name_sans_serif_default_group);
        map.insert(BaseMetricId(5278), &super::characteristics::font_name_sans_serif_western);
        map.insert(BaseMetricId(5279), &super::characteristics::font_name_serif_default_group);
        map.insert(BaseMetricId(5281), &super::characteristics::font_name_serif_western);
        map.insert(BaseMetricId(5282), &super::characteristics::font_size_monospace_default_group);
        map.insert(BaseMetricId(5284), &super::characteristics::font_size_monospace_western);
        map.insert(BaseMetricId(5285), &super::characteristics::font_size_variable_default_group);
        map.insert(BaseMetricId(5287), &super::characteristics::font_size_variable_western);
        map.insert(BaseMetricId(5288), &super::characteristics::fonts_fpjs_allowlisted);
        map.insert(BaseMetricId(5289), &super::characteristics::fonts_fpjs_nonallowlisted);
        map.insert(BaseMetricId(5290), &super::characteristics::fonts_variant_a_allowlisted);
        map.insert(BaseMetricId(5291), &super::characteristics::fonts_variant_a_nonallowlisted);
        map.insert(BaseMetricId(5292), &super::characteristics::fonts_variant_b_allowlisted);
        map.insert(BaseMetricId(5293), &super::characteristics::fonts_variant_b_nonallowlisted);
        map.insert(BaseMetricId(5295), &super::characteristics::gl2_context_type);
        map.insert(BaseMetricId(5296), &super::characteristics::gl2_context_type_software);
        map.insert(BaseMetricId(5301), &super::characteristics::gl2_fragment_shader);
        map.insert(BaseMetricId(5302), &super::characteristics::gl2_fragment_shader_software);
        map.insert(BaseMetricId(5313), &super::characteristics::gl2_renderer);
        map.insert(BaseMetricId(5314), &super::characteristics::gl2_renderer_raw);
        map.insert(BaseMetricId(5315), &super::characteristics::gl2_renderer_raw_software);
        map.insert(BaseMetricId(5316), &super::characteristics::gl2_renderer_software);
        map.insert(BaseMetricId(5317), &super::characteristics::gl2_vendor);
        map.insert(BaseMetricId(5318), &super::characteristics::gl2_vendor_raw);
        map.insert(BaseMetricId(5319), &super::characteristics::gl2_vendor_raw_software);
        map.insert(BaseMetricId(5320), &super::characteristics::gl2_vendor_software);
        map.insert(BaseMetricId(5321), &super::characteristics::gl2_version_raw);
        map.insert(BaseMetricId(5322), &super::characteristics::gl2_version_raw_software);
        map.insert(BaseMetricId(5323), &super::characteristics::gl2_vertex_shader);
        map.insert(BaseMetricId(5324), &super::characteristics::gl2_vertex_shader_software);
        map.insert(BaseMetricId(5325), &super::characteristics::gl_context_type);
        map.insert(BaseMetricId(5326), &super::characteristics::gl_context_type_software);
        map.insert(BaseMetricId(5331), &super::characteristics::gl_fragment_shader);
        map.insert(BaseMetricId(5332), &super::characteristics::gl_fragment_shader_software);
        map.insert(BaseMetricId(5343), &super::characteristics::gl_renderer);
        map.insert(BaseMetricId(5344), &super::characteristics::gl_renderer_raw);
        map.insert(BaseMetricId(5345), &super::characteristics::gl_renderer_raw_software);
        map.insert(BaseMetricId(5346), &super::characteristics::gl_renderer_software);
        map.insert(BaseMetricId(5347), &super::characteristics::gl_vendor);
        map.insert(BaseMetricId(5348), &super::characteristics::gl_vendor_raw);
        map.insert(BaseMetricId(5349), &super::characteristics::gl_vendor_raw_software);
        map.insert(BaseMetricId(5350), &super::characteristics::gl_vendor_software);
        map.insert(BaseMetricId(5351), &super::characteristics::gl_version_raw);
        map.insert(BaseMetricId(5352), &super::characteristics::gl_version_raw_software);
        map.insert(BaseMetricId(5353), &super::characteristics::gl_vertex_shader);
        map.insert(BaseMetricId(5354), &super::characteristics::gl_vertex_shader_software);
        map.insert(BaseMetricId(5361), &super::characteristics::intl_locale);
        map.insert(BaseMetricId(5364), &super::characteristics::keyboard_layout);
        map.insert(BaseMetricId(5365), &super::characteristics::languages);
        map.insert(BaseMetricId(5366), &super::characteristics::machine_model_name);
        map.insert(BaseMetricId(5369), &super::characteristics::mathml1);
        map.insert(BaseMetricId(5370), &super::characteristics::mathml10);
        map.insert(BaseMetricId(5371), &super::characteristics::mathml2);
        map.insert(BaseMetricId(5372), &super::characteristics::mathml3);
        map.insert(BaseMetricId(5373), &super::characteristics::mathml4);
        map.insert(BaseMetricId(5374), &super::characteristics::mathml5);
        map.insert(BaseMetricId(5375), &super::characteristics::mathml6);
        map.insert(BaseMetricId(5376), &super::characteristics::mathml7);
        map.insert(BaseMetricId(5377), &super::characteristics::mathml8);
        map.insert(BaseMetricId(5378), &super::characteristics::mathml9);
        map.insert(BaseMetricId(5393), &super::characteristics::os_name);
        map.insert(BaseMetricId(5394), &super::characteristics::os_version);
        map.insert(BaseMetricId(5395), &super::characteristics::oscpu);
        map.insert(BaseMetricId(5399), &super::characteristics::pixel_ratio);
        map.insert(BaseMetricId(5400), &super::characteristics::platform);
        map.insert(BaseMetricId(5402), &super::characteristics::pointer_pressure);
        map.insert(BaseMetricId(5403), &super::characteristics::pointer_tangentinal_pressure);
        map.insert(BaseMetricId(5416), &super::characteristics::prefs_intl_accept_languages);
        map.insert(BaseMetricId(5430), &super::characteristics::system_locale);
        map.insert(BaseMetricId(5432), &super::characteristics::text_anti_aliasing);
        map.insert(BaseMetricId(5433), &super::characteristics::timezone);
        map.insert(BaseMetricId(5434), &super::characteristics::touch_rotation_angle);
        map.insert(BaseMetricId(5438), &super::characteristics::version);
        map.insert(BaseMetricId(5439), &super::characteristics::voices_all_ssdeep);
        map.insert(BaseMetricId(5441), &super::characteristics::voices_default);
        map.insert(BaseMetricId(5443), &super::characteristics::voices_local_ssdeep);
        map.insert(BaseMetricId(5444), &super::characteristics::voices_nonlocal_ssdeep);
        map.insert(BaseMetricId(5478), &super::characteristics::wgpu_missing_features);
        map.insert(BaseMetricId(5488), &super::search_engine_default::display_name);
        map.insert(BaseMetricId(5489), &super::search_engine_default::engine_id);
        map.insert(BaseMetricId(5490), &super::search_engine_default::load_path);
        map.insert(BaseMetricId(5492), &super::search_engine_default::partner_code);
        map.insert(BaseMetricId(5493), &super::search_engine_default::provider_id);
        map.insert(BaseMetricId(5496), &super::search_engine_private::display_name);
        map.insert(BaseMetricId(5497), &super::search_engine_private::engine_id);
        map.insert(BaseMetricId(5498), &super::search_engine_private::load_path);
        map.insert(BaseMetricId(5500), &super::search_engine_private::partner_code);
        map.insert(BaseMetricId(5501), &super::search_engine_private::provider_id);
        map.insert(BaseMetricId(5559), &super::usage::app_build);
        map.insert(BaseMetricId(5560), &super::usage::app_channel);
        map.insert(BaseMetricId(5561), &super::usage::app_display_version);
        map.insert(BaseMetricId(5562), &super::usage::distribution_id);
        map.insert(BaseMetricId(5565), &super::usage::os);
        map.insert(BaseMetricId(5566), &super::usage::os_version);
        map.insert(BaseMetricId(5569), &super::usage::reason);
        map.insert(BaseMetricId(5673), &super::region::home_region);
        map.insert(BaseMetricId(5689), &super::notification::action);
        map.insert(BaseMetricId(5691), &super::system::os_version);
        map.insert(BaseMetricId(5692), &super::system::previous_os_version);
        map.insert(BaseMetricId(5693), &super::system_default::browser);
        map.insert(BaseMetricId(5694), &super::system_default::pdf_handler);
        map.insert(BaseMetricId(5695), &super::system_default::previous_browser);
        map.insert(BaseMetricId(5767), &super::blocklist::mlbf_softblocks_source);
        map.insert(BaseMetricId(5768), &super::blocklist::mlbf_source);
        map.insert(BaseMetricId(5777), &super::update::channel);
        map.insert(BaseMetricId(5855), &super::update::version_pin);
        map.insert(BaseMetricId(5860), &super::gecko::build_id);
        map.insert(BaseMetricId(5862), &super::gecko::version);
        map.insert(BaseMetricId(5865), &super::widget::gtk_version);
        map.insert(BaseMetricId(5905), &super::system_cpu::name);
        map.insert(BaseMetricId(5909), &super::system_cpu::vendor);
        map.insert(BaseMetricId(5911), &super::xpcom::abi);
        map
    });

    pub static TIMING_DISTRIBUTION_MAP: Lazy<HashMap<BaseMetricId, &Lazy<TimingDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(415);
        map.insert(BaseMetricId(9), &super::a11y::tree_update_timing);
        map.insert(BaseMetricId(11), &super::fullscreen::change);
        map.insert(BaseMetricId(19), &super::browser_engagement::tab_unload_to_reload);
        map.insert(BaseMetricId(40), &super::browser_timings::new_window);
        map.insert(BaseMetricId(41), &super::browser_timings::page_load);
        map.insert(BaseMetricId(42), &super::browser_timings::page_reload_normal);
        map.insert(BaseMetricId(43), &super::browser_timings::page_reload_skip_cache);
        map.insert(BaseMetricId(44), &super::browser_timings::tab_click);
        map.insert(BaseMetricId(48), &super::networking::cache_metadata_first_read_time);
        map.insert(BaseMetricId(49), &super::networking::cache_metadata_second_read_time);
        map.insert(BaseMetricId(64), &super::networking::dns_failed_lookup_time);
        map.insert(BaseMetricId(65), &super::networking::dns_lookup_time);
        map.insert(BaseMetricId(67), &super::networking::dns_native_https_call_time);
        map.insert(BaseMetricId(68), &super::networking::dns_renewal_time);
        map.insert(BaseMetricId(69), &super::networking::dns_renewal_time_for_ttl);
        map.insert(BaseMetricId(115), &super::networking::http_channel_page_open_to_first_sent);
        map.insert(BaseMetricId(116), &super::networking::http_channel_page_open_to_first_sent_https_rr);
        map.insert(BaseMetricId(117), &super::networking::http_channel_sub_open_to_first_sent);
        map.insert(BaseMetricId(118), &super::networking::http_channel_sub_open_to_first_sent_https_rr);
        map.insert(BaseMetricId(119), &super::networking::http_content_cssloader_ondatafinished_to_onstop_delay);
        map.insert(BaseMetricId(120), &super::networking::http_content_html5parser_ondatafinished_to_onstop_delay);
        map.insert(BaseMetricId(121), &super::networking::http_content_ondatafinished_delay);
        map.insert(BaseMetricId(122), &super::networking::http_content_ondatafinished_delay_2);
        map.insert(BaseMetricId(123), &super::networking::http_content_ondatafinished_to_onstop_delay);
        map.insert(BaseMetricId(124), &super::networking::http_content_onstart_delay);
        map.insert(BaseMetricId(125), &super::networking::http_content_onstop_delay);
        map.insert(BaseMetricId(128), &super::networking::http_onstart_suspend_total_time);
        map.insert(BaseMetricId(137), &super::networking::prclose_tcp_blocking_time_connectivity_change);
        map.insert(BaseMetricId(138), &super::networking::prclose_tcp_blocking_time_link_change);
        map.insert(BaseMetricId(139), &super::networking::prclose_tcp_blocking_time_normal);
        map.insert(BaseMetricId(140), &super::networking::prclose_tcp_blocking_time_offline);
        map.insert(BaseMetricId(141), &super::networking::prclose_tcp_blocking_time_shutdown);
        map.insert(BaseMetricId(142), &super::networking::prclose_udp_blocking_time_connectivity_change);
        map.insert(BaseMetricId(143), &super::networking::prclose_udp_blocking_time_link_change);
        map.insert(BaseMetricId(144), &super::networking::prclose_udp_blocking_time_normal);
        map.insert(BaseMetricId(145), &super::networking::prclose_udp_blocking_time_offline);
        map.insert(BaseMetricId(146), &super::networking::prclose_udp_blocking_time_shutdown);
        map.insert(BaseMetricId(147), &super::networking::prconnect_blocking_time_connectivity_change);
        map.insert(BaseMetricId(148), &super::networking::prconnect_blocking_time_link_change);
        map.insert(BaseMetricId(149), &super::networking::prconnect_blocking_time_normal);
        map.insert(BaseMetricId(150), &super::networking::prconnect_blocking_time_offline);
        map.insert(BaseMetricId(151), &super::networking::prconnect_blocking_time_shutdown);
        map.insert(BaseMetricId(152), &super::networking::prconnect_fail_blocking_time_connectivity_change);
        map.insert(BaseMetricId(153), &super::networking::prconnect_fail_blocking_time_link_change);
        map.insert(BaseMetricId(154), &super::networking::prconnect_fail_blocking_time_normal);
        map.insert(BaseMetricId(155), &super::networking::prconnect_fail_blocking_time_offline);
        map.insert(BaseMetricId(156), &super::networking::prconnect_fail_blocking_time_shutdown);
        map.insert(BaseMetricId(157), &super::networking::prconnectcontinue_blocking_time_connectivity_change);
        map.insert(BaseMetricId(158), &super::networking::prconnectcontinue_blocking_time_link_change);
        map.insert(BaseMetricId(159), &super::networking::prconnectcontinue_blocking_time_normal);
        map.insert(BaseMetricId(160), &super::networking::prconnectcontinue_blocking_time_offline);
        map.insert(BaseMetricId(161), &super::networking::prconnectcontinue_blocking_time_shutdown);
        map.insert(BaseMetricId(171), &super::networking::sqlite_cookies_block_main_thread);
        map.insert(BaseMetricId(172), &super::networking::sqlite_cookies_time_to_block_main_thread);
        map.insert(BaseMetricId(173), &super::networking::transaction_wait_time);
        map.insert(BaseMetricId(174), &super::networking::transaction_wait_time_https_rr);
        map.insert(BaseMetricId(237), &super::messaging_system::message_request_time);
        map.insert(BaseMetricId(268), &super::browser_backup::favicons_time);
        map.insert(BaseMetricId(276), &super::browser_backup::places_time);
        map.insert(BaseMetricId(288), &super::browser_backup::total_backup_time);
        map.insert(BaseMetricId(295), &super::glam_experiment::largest_contentful_paint);
        map.insert(BaseMetricId(296), &super::glam_experiment::protect_time);
        map.insert(BaseMetricId(297), &super::glam_experiment::time);
        map.insert(BaseMetricId(298), &super::glam_experiment::async_sheet_load);
        map.insert(BaseMetricId(299), &super::glam_experiment::http_content_html5parser_ondatafinished_to_onstop_delay);
        map.insert(BaseMetricId(301), &super::glam_experiment::sub_complete_load_net);
        map.insert(BaseMetricId(519), &super::newtab::abouthome_cache_construction);
        map.insert(BaseMetricId(609), &super::bookmarks_toolbar::init);
        map.insert(BaseMetricId(613), &super::history_sidebar::lastvisited_tree_query_time);
        map.insert(BaseMetricId(616), &super::library::history_search_time);
        map.insert(BaseMetricId(776), &super::serp::categorization_duration);
        map.insert(BaseMetricId(797), &super::session_restore::auto_restore_duration_until_eager_tabs_restored);
        map.insert(BaseMetricId(799), &super::session_restore::collect_all_windows_data);
        map.insert(BaseMetricId(800), &super::session_restore::collect_data);
        map.insert(BaseMetricId(801), &super::session_restore::collect_session_history);
        map.insert(BaseMetricId(804), &super::session_restore::manual_restore_duration_until_eager_tabs_restored);
        map.insert(BaseMetricId(808), &super::session_restore::read_file);
        map.insert(BaseMetricId(809), &super::session_restore::restore_window);
        map.insert(BaseMetricId(812), &super::session_restore::startup_init_session);
        map.insert(BaseMetricId(813), &super::session_restore::startup_onload_initial_window);
        map.insert(BaseMetricId(814), &super::session_restore::write_file);
        map.insert(BaseMetricId(900), &super::browser_tabclose::permit_unload_time);
        map.insert(BaseMetricId(901), &super::browser_tabclose::time_anim);
        map.insert(BaseMetricId(902), &super::browser_tabclose::time_no_anim);
        map.insert(BaseMetricId(903), &super::browser_tabswitch::spinner_visible);
        map.insert(BaseMetricId(905), &super::browser_tabswitch::total);
        map.insert(BaseMetricId(906), &super::browser_tabswitch::update);
        map.insert(BaseMetricId(953), &super::text_recognition::api_performance);
        map.insert(BaseMetricId(954), &super::text_recognition::interaction_timing);
        map.insert(BaseMetricId(976), &super::urlbar::autocomplete_first_result_time);
        map.insert(BaseMetricId(977), &super::urlbar::autocomplete_sixth_result_time);
        map.insert(BaseMetricId(1002), &super::browser_sanitizer::cache);
        map.insert(BaseMetricId(1003), &super::browser_sanitizer::cookies);
        map.insert(BaseMetricId(1004), &super::browser_sanitizer::downloads);
        map.insert(BaseMetricId(1005), &super::browser_sanitizer::formdata);
        map.insert(BaseMetricId(1006), &super::browser_sanitizer::history);
        map.insert(BaseMetricId(1007), &super::browser_sanitizer::openwindows);
        map.insert(BaseMetricId(1008), &super::browser_sanitizer::sessions);
        map.insert(BaseMetricId(1009), &super::browser_sanitizer::sitesettings);
        map.insert(BaseMetricId(1010), &super::browser_sanitizer::total);
        map.insert(BaseMetricId(1037), &super::performance_interaction::tab_switch_composite);
        map.insert(BaseMetricId(1038), &super::performance_interaction::keypress_present_latency);
        map.insert(BaseMetricId(1039), &super::performance_interaction::mouseup_click_present_latency);
        map.insert(BaseMetricId(1057), &super::devtools::aboutdebugging_time_active);
        map.insert(BaseMetricId(1058), &super::devtools::accessibility_picker_time_active);
        map.insert(BaseMetricId(1059), &super::devtools::accessibility_service_time_active);
        map.insert(BaseMetricId(1060), &super::devtools::accessibility_time_active);
        map.insert(BaseMetricId(1062), &super::devtools::animationinspector_time_active);
        map.insert(BaseMetricId(1064), &super::devtools::browserconsole_time_active);
        map.insert(BaseMetricId(1065), &super::devtools::changesview_time_active);
        map.insert(BaseMetricId(1067), &super::devtools::compatibilityview_time_active);
        map.insert(BaseMetricId(1069), &super::devtools::computedview_time_active);
        map.insert(BaseMetricId(1071), &super::devtools::custom_time_active);
        map.insert(BaseMetricId(1073), &super::devtools::dom_time_active);
        map.insert(BaseMetricId(1076), &super::devtools::flexbox_highlighter_time_active);
        map.insert(BaseMetricId(1078), &super::devtools::fontinspector_time_active);
        map.insert(BaseMetricId(1079), &super::devtools::grid_highlighter_time_active);
        map.insert(BaseMetricId(1081), &super::devtools::inspector_time_active);
        map.insert(BaseMetricId(1083), &super::devtools::jsbrowserdebugger_time_active);
        map.insert(BaseMetricId(1085), &super::devtools::jsdebugger_time_active);
        map.insert(BaseMetricId(1087), &super::devtools::jsprofiler_time_active);
        map.insert(BaseMetricId(1089), &super::devtools::layoutview_time_active);
        map.insert(BaseMetricId(1091), &super::devtools::memory_time_active);
        map.insert(BaseMetricId(1094), &super::devtools::netmonitor_time_active);
        map.insert(BaseMetricId(1096), &super::devtools::options_time_active);
        map.insert(BaseMetricId(1099), &super::devtools::responsive_time_active);
        map.insert(BaseMetricId(1101), &super::devtools::ruleview_time_active);
        map.insert(BaseMetricId(1103), &super::devtools::storage_time_active);
        map.insert(BaseMetricId(1105), &super::devtools::styleeditor_time_active);
        map.insert(BaseMetricId(1107), &super::devtools::toolbox_time_active);
        map.insert(BaseMetricId(1109), &super::devtools::webconsole_time_active);
        map.insert(BaseMetricId(1112), &super::devtools::read_heap_snapshot);
        map.insert(BaseMetricId(1113), &super::devtools::save_heap_snapshot);
        map.insert(BaseMetricId(1118), &super::devtools_inspector::new_root_to_reload_delay);
        map.insert(BaseMetricId(1229), &super::performance_page::total_content_page_load);
        map.insert(BaseMetricId(1230), &super::performance_page::non_blank_paint);
        map.insert(BaseMetricId(3650), &super::localstorage_database::new_object_setup_time);
        map.insert(BaseMetricId(3651), &super::localstorage_database::request_allow_to_close_response_time);
        map.insert(BaseMetricId(3652), &super::localstorage_request::prepare_datastore_processing_time);
        map.insert(BaseMetricId(3668), &super::media::video_clearkey_play_time);
        map.insert(BaseMetricId(3674), &super::media::video_encrypted_play_time);
        map.insert(BaseMetricId(3677), &super::media::video_hdr_play_time);
        map.insert(BaseMetricId(3678), &super::media::video_hidden_play_time);
        map.insert(BaseMetricId(3680), &super::media::video_play_time);
        map.insert(BaseMetricId(3682), &super::media::video_widevine_play_time);
        map.insert(BaseMetricId(3713), &super::webrtc::audio_quality_inbound_jitter);
        map.insert(BaseMetricId(3715), &super::webrtc::audio_quality_outbound_jitter);
        map.insert(BaseMetricId(3717), &super::webrtc::audio_quality_outbound_rtt);
        map.insert(BaseMetricId(3718), &super::webrtc::av_call_duration);
        map.insert(BaseMetricId(3720), &super::webrtc::call_duration);
        map.insert(BaseMetricId(3744), &super::webrtc::video_quality_inbound_jitter);
        map.insert(BaseMetricId(3746), &super::webrtc::video_quality_outbound_jitter);
        map.insert(BaseMetricId(3748), &super::webrtc::video_quality_outbound_rtt);
        map.insert(BaseMetricId(3764), &super::dom::fullscreen_transition_black);
        map.insert(BaseMetricId(3765), &super::dom::gc_in_progress);
        map.insert(BaseMetricId(3777), &super::dom_contentprocess::launch_mainthread);
        map.insert(BaseMetricId(3778), &super::dom_contentprocess::launch_total);
        map.insert(BaseMetricId(3782), &super::dom_contentprocess::sync_launch);
        map.insert(BaseMetricId(3785), &super::dom_textfragment::create_directive);
        map.insert(BaseMetricId(3786), &super::dom_textfragment::find_directives);
        map.insert(BaseMetricId(3787), &super::javascript_pageload::baseline_compile_time);
        map.insert(BaseMetricId(3788), &super::javascript_pageload::delazification_time);
        map.insert(BaseMetricId(3789), &super::javascript_pageload::execution_time);
        map.insert(BaseMetricId(3790), &super::javascript_pageload::gc_time);
        map.insert(BaseMetricId(3791), &super::javascript_pageload::parse_time);
        map.insert(BaseMetricId(3792), &super::javascript_pageload::protect_time);
        map.insert(BaseMetricId(3793), &super::javascript_pageload::xdr_encode_time);
        map.insert(BaseMetricId(3800), &super::perf::largest_contentful_paint);
        map.insert(BaseMetricId(3801), &super::perf::largest_contentful_paint_from_response_start);
        map.insert(BaseMetricId(3803), &super::performance_pageload::fcp);
        map.insert(BaseMetricId(3804), &super::performance_pageload::fcp_responsestart);
        map.insert(BaseMetricId(3805), &super::performance_pageload::h3p_fcp_with_priority);
        map.insert(BaseMetricId(3806), &super::performance_pageload::http3_fcp_http3);
        map.insert(BaseMetricId(3807), &super::performance_pageload::http3_fcp_supports_http3);
        map.insert(BaseMetricId(3808), &super::performance_pageload::http3_fcp_without_priority);
        map.insert(BaseMetricId(3809), &super::performance_pageload::load_time);
        map.insert(BaseMetricId(3810), &super::performance_pageload::load_time_responsestart);
        map.insert(BaseMetricId(3811), &super::performance_pageload::async_sheet_load);
        map.insert(BaseMetricId(3812), &super::performance_time::dom_complete);
        map.insert(BaseMetricId(3813), &super::performance_time::dom_content_loaded_end);
        map.insert(BaseMetricId(3814), &super::performance_time::dom_content_loaded_start);
        map.insert(BaseMetricId(3815), &super::performance_time::dom_interactive);
        map.insert(BaseMetricId(3816), &super::performance_time::load_event_end);
        map.insert(BaseMetricId(3817), &super::performance_time::load_event_start);
        map.insert(BaseMetricId(3818), &super::performance_time::to_dom_loading);
        map.insert(BaseMetricId(3819), &super::performance_time::to_first_contentful_paint);
        map.insert(BaseMetricId(3820), &super::performance_time::response_start);
        map.insert(BaseMetricId(3826), &super::screenwakelock::held_duration);
        map.insert(BaseMetricId(3838), &super::quotamanager_initialize_temporarystorage::total_time_excluding_suspend);
        map.insert(BaseMetricId(3839), &super::quotamanager_shutdown::total_time_excluding_suspend);
        map.insert(BaseMetricId(3840), &super::httpsfirst::downgrade_time);
        map.insert(BaseMetricId(3841), &super::httpsfirst::downgrade_time_schemeless);
        map.insert(BaseMetricId(3859), &super::service_worker::isolated_launch_time);
        map.insert(BaseMetricId(3860), &super::service_worker::launch_time);
        map.insert(BaseMetricId(3861), &super::service_worker::registration_loading);
        map.insert(BaseMetricId(3864), &super::localdomstorage::shutdown_database);
        map.insert(BaseMetricId(3885), &super::fontlist::bundledfonts_activate);
        map.insert(BaseMetricId(3886), &super::fontlist::dwritefont_delayedinit_collect);
        map.insert(BaseMetricId(3888), &super::fontlist::dwritefont_delayedinit_total);
        map.insert(BaseMetricId(3891), &super::fontlist::gdi_init_total);
        map.insert(BaseMetricId(3892), &super::fontlist::initfacenamelists);
        map.insert(BaseMetricId(3893), &super::fontlist::initotherfamilynames);
        map.insert(BaseMetricId(3894), &super::fontlist::initotherfamilynames_no_deferring);
        map.insert(BaseMetricId(3895), &super::fontlist::mac_init_total);
        map.insert(BaseMetricId(3896), &super::fontlist::system_font_fallback);
        map.insert(BaseMetricId(3897), &super::fontlist::system_font_fallback_first);
        map.insert(BaseMetricId(3898), &super::gfx::composite_frame_roundtrip_time);
        map.insert(BaseMetricId(3900), &super::gfx::composite_time);
        map.insert(BaseMetricId(3910), &super::gfx::scroll_present_latency);
        map.insert(BaseMetricId(3922), &super::gfx_checkerboard::duration);
        map.insert(BaseMetricId(3924), &super::gfx_checkerboard::potential_duration);
        map.insert(BaseMetricId(3926), &super::gfx_content::full_paint_time);
        map.insert(BaseMetricId(3929), &super::gfx_content::paint_time);
        map.insert(BaseMetricId(3949), &super::gpu_process::initialization_time);
        map.insert(BaseMetricId(3950), &super::gpu_process::launch_time);
        map.insert(BaseMetricId(3953), &super::paint::build_displaylist_time);
        map.insert(BaseMetricId(3956), &super::webfont::download_time);
        map.insert(BaseMetricId(3962), &super::wr::framebuild_time);
        map.insert(BaseMetricId(3963), &super::wr::gpu_wait_time);
        map.insert(BaseMetricId(3964), &super::wr::rasterize_blobs_time);
        map.insert(BaseMetricId(3965), &super::wr::rasterize_glyphs_time);
        map.insert(BaseMetricId(3966), &super::wr::renderer_time);
        map.insert(BaseMetricId(3967), &super::wr::renderer_time_no_sc);
        map.insert(BaseMetricId(3968), &super::wr::scenebuild_time);
        map.insert(BaseMetricId(3969), &super::wr::sceneswap_time);
        map.insert(BaseMetricId(3970), &super::wr::shaderload_time);
        map.insert(BaseMetricId(3971), &super::wr::texture_cache_update_time);
        map.insert(BaseMetricId(3972), &super::wr::time_to_frame_build);
        map.insert(BaseMetricId(3973), &super::wr::time_to_render_start);
        map.insert(BaseMetricId(3998), &super::image_decode::on_draw_latency);
        map.insert(BaseMetricId(4004), &super::image_decode::time);
        map.insert(BaseMetricId(4006), &super::process::child_launch);
        map.insert(BaseMetricId(4007), &super::process::lifetime);
        map.insert(BaseMetricId(4012), &super::javascript_gc::animation);
        map.insert(BaseMetricId(4013), &super::javascript_gc::budget);
        map.insert(BaseMetricId(4014), &super::javascript_gc::budget_overrun);
        map.insert(BaseMetricId(4016), &super::javascript_gc::compact_time);
        map.insert(BaseMetricId(4019), &super::javascript_gc::mark_gray);
        map.insert(BaseMetricId(4021), &super::javascript_gc::mark_roots_time);
        map.insert(BaseMetricId(4022), &super::javascript_gc::mark_time);
        map.insert(BaseMetricId(4023), &super::javascript_gc::mark_weak);
        map.insert(BaseMetricId(4024), &super::javascript_gc::max_pause);
        map.insert(BaseMetricId(4027), &super::javascript_gc::minor_time);
        map.insert(BaseMetricId(4037), &super::javascript_gc::prepare_time);
        map.insert(BaseMetricId(4043), &super::javascript_gc::slice_time);
        map.insert(BaseMetricId(4047), &super::javascript_gc::sweep_time);
        map.insert(BaseMetricId(4048), &super::javascript_gc::task_start_delay);
        map.insert(BaseMetricId(4050), &super::javascript_gc::time_between);
        map.insert(BaseMetricId(4051), &super::javascript_gc::time_between_slices);
        map.insert(BaseMetricId(4052), &super::javascript_gc::total_time);
        map.insert(BaseMetricId(4055), &super::javascript_ion::compile_time);
        map.insert(BaseMetricId(4058), &super::performance_clone_deserialize::time);
        map.insert(BaseMetricId(4061), &super::script_preloader::wait_time);
        map.insert(BaseMetricId(4062), &super::slow_script_warning::notify_delay);
        map.insert(BaseMetricId(4065), &super::layout::input_event_queued_click);
        map.insert(BaseMetricId(4066), &super::layout::input_event_queued_keyboard);
        map.insert(BaseMetricId(4067), &super::layout::input_event_response);
        map.insert(BaseMetricId(4068), &super::layout::input_event_response_coalesced);
        map.insert(BaseMetricId(4069), &super::layout::load_input_event_response);
        map.insert(BaseMetricId(4071), &super::layout::paint_rasterize_time);
        map.insert(BaseMetricId(4072), &super::layout::refresh_driver_chrome_frame_delay);
        map.insert(BaseMetricId(4073), &super::layout::refresh_driver_content_frame_delay);
        map.insert(BaseMetricId(4074), &super::layout::refresh_driver_tick);
        map.insert(BaseMetricId(4075), &super::layout::time_to_first_interaction);
        map.insert(BaseMetricId(4076), &super::geckoview::content_process_lifetime);
        map.insert(BaseMetricId(4078), &super::geckoview::page_load_progress_time);
        map.insert(BaseMetricId(4079), &super::geckoview::page_load_time);
        map.insert(BaseMetricId(4080), &super::geckoview::page_reload_time);
        map.insert(BaseMetricId(4082), &super::geckoview::startup_runtime);
        map.insert(BaseMetricId(4103), &super::network::disk_cache2_shutdown_clear_private);
        map.insert(BaseMetricId(4104), &super::network::disk_cache_shutdown_v2);
        map.insert(BaseMetricId(4105), &super::network::http_cache_entry_alive_time);
        map.insert(BaseMetricId(4106), &super::network::http_cache_entry_reload_time);
        map.insert(BaseMetricId(4116), &super::network::back_pressure_suspension_delay_time);
        map.insert(BaseMetricId(4121), &super::network::cache_hit_time);
        map.insert(BaseMetricId(4122), &super::network::cache_miss_time);
        map.insert(BaseMetricId(4123), &super::network::cache_read_time);
        map.insert(BaseMetricId(4124), &super::network::complete_load);
        map.insert(BaseMetricId(4125), &super::network::complete_load_cached);
        map.insert(BaseMetricId(4126), &super::network::complete_load_net);
        map.insert(BaseMetricId(4128), &super::network::dns_end);
        map.insert(BaseMetricId(4130), &super::network::dns_start);
        map.insert(BaseMetricId(4131), &super::network::first_from_cache);
        map.insert(BaseMetricId(4132), &super::network::first_sent_to_last_received);
        map.insert(BaseMetricId(4133), &super::network::font_download_end);
        map.insert(BaseMetricId(4140), &super::network::http_revalidation);
        map.insert(BaseMetricId(4141), &super::network::open_to_first_received);
        map.insert(BaseMetricId(4142), &super::network::open_to_first_sent);
        map.insert(BaseMetricId(4147), &super::network::race_cache_with_network_ocec_on_start_diff);
        map.insert(BaseMetricId(4148), &super::network::race_cache_with_network_saved_time);
        map.insert(BaseMetricId(4152), &super::network::sub_cache_read_time);
        map.insert(BaseMetricId(4153), &super::network::sub_complete_load);
        map.insert(BaseMetricId(4154), &super::network::sub_complete_load_cached);
        map.insert(BaseMetricId(4155), &super::network::sub_complete_load_net);
        map.insert(BaseMetricId(4156), &super::network::sub_dns_end);
        map.insert(BaseMetricId(4157), &super::network::sub_dns_start);
        map.insert(BaseMetricId(4158), &super::network::sub_first_from_cache);
        map.insert(BaseMetricId(4159), &super::network::sub_first_sent_to_last_received);
        map.insert(BaseMetricId(4160), &super::network::sub_http_revalidation);
        map.insert(BaseMetricId(4161), &super::network::sub_open_to_first_received);
        map.insert(BaseMetricId(4162), &super::network::sub_open_to_first_sent);
        map.insert(BaseMetricId(4163), &super::network::sub_tcp_connection);
        map.insert(BaseMetricId(4164), &super::network::sub_tls_handshake);
        map.insert(BaseMetricId(4173), &super::network::tcp_connection);
        map.insert(BaseMetricId(4177), &super::network::tls_handshake);
        map.insert(BaseMetricId(4182), &super::dns::by_type_cleanup_age);
        map.insert(BaseMetricId(4183), &super::dns::by_type_failed_lookup_time);
        map.insert(BaseMetricId(4184), &super::dns::by_type_premature_eviction);
        map.insert(BaseMetricId(4185), &super::dns::by_type_succeeded_lookup_time);
        map.insert(BaseMetricId(4186), &super::dns::cleanup_age);
        map.insert(BaseMetricId(4190), &super::dns::native_lookup_time);
        map.insert(BaseMetricId(4191), &super::dns::native_queuing);
        map.insert(BaseMetricId(4192), &super::dns::premature_eviction);
        map.insert(BaseMetricId(4195), &super::dns::trr_processing_time);
        map.insert(BaseMetricId(4206), &super::network_cookies::sqlite_open_readahead);
        map.insert(BaseMetricId(4214), &super::predictor::learn_work_time);
        map.insert(BaseMetricId(4215), &super::predictor::predict_time_to_action);
        map.insert(BaseMetricId(4216), &super::predictor::predict_time_to_inaction);
        map.insert(BaseMetricId(4217), &super::predictor::predict_work_time);
        map.insert(BaseMetricId(4221), &super::predictor::prefetch_time);
        map.insert(BaseMetricId(4228), &super::predictor::wait_time);
        map.insert(BaseMetricId(4229), &super::sts::poll_and_event_the_last_cycle);
        map.insert(BaseMetricId(4230), &super::sts::poll_and_events_cycle);
        map.insert(BaseMetricId(4231), &super::sts::poll_block_time);
        map.insert(BaseMetricId(4232), &super::sts::poll_cycle);
        map.insert(BaseMetricId(4267), &super::http::subitem_first_byte_latency_time);
        map.insert(BaseMetricId(4268), &super::http::subitem_open_latency_time);
        map.insert(BaseMetricId(4278), &super::http::transaction_wait_time_http);
        map.insert(BaseMetricId(4279), &super::http::transaction_wait_time_http2_sup_http3);
        map.insert(BaseMetricId(4280), &super::http::transaction_wait_time_http3);
        map.insert(BaseMetricId(4281), &super::http::transaction_wait_time_spdy);
        map.insert(BaseMetricId(4295), &super::http3::timer_delayed);
        map.insert(BaseMetricId(4347), &super::cert_verification_time::failure);
        map.insert(BaseMetricId(4348), &super::cert_verification_time::success);
        map.insert(BaseMetricId(4352), &super::ocsp_request_time::cancel);
        map.insert(BaseMetricId(4353), &super::ocsp_request_time::failure);
        map.insert(BaseMetricId(4354), &super::ocsp_request_time::success);
        map.insert(BaseMetricId(4378), &super::ssl::time_until_ready);
        map.insert(BaseMetricId(4379), &super::ssl::time_until_ready_conservative);
        map.insert(BaseMetricId(4380), &super::ssl::time_until_ready_ech);
        map.insert(BaseMetricId(4381), &super::ssl::time_until_ready_ech_grease);
        map.insert(BaseMetricId(4382), &super::ssl::time_until_ready_first_try);
        map.insert(BaseMetricId(4460), &super::bounce_tracking_protection::purge_duration);
        map.insert(BaseMetricId(4482), &super::cookie_purging::duration);
        map.insert(BaseMetricId(4483), &super::cookie_purging::interval_hours);
        map.insert(BaseMetricId(4485), &super::cookie_purging::trackers_user_interaction_remaining_days);
        map.insert(BaseMetricId(4565), &super::relevancy_classify::duration);
        map.insert(BaseMetricId(4623), &super::memory::collection_time);
        map.insert(BaseMetricId(4625), &super::memory::free_purged_pages);
        map.insert(BaseMetricId(4667), &super::extensions_apis_dnr::evaluate_rules_time);
        map.insert(BaseMetricId(4670), &super::extensions_apis_dnr::startup_cache_read_time);
        map.insert(BaseMetricId(4672), &super::extensions_apis_dnr::startup_cache_write_time);
        map.insert(BaseMetricId(4673), &super::extensions_apis_dnr::validate_rules_time);
        map.insert(BaseMetricId(4680), &super::extensions_timing::background_page_load);
        map.insert(BaseMetricId(4682), &super::extensions_timing::browser_action_popup_open);
        map.insert(BaseMetricId(4684), &super::extensions_timing::content_script_injection);
        map.insert(BaseMetricId(4688), &super::extensions_timing::extension_startup);
        map.insert(BaseMetricId(4690), &super::extensions_timing::page_action_popup_open);
        map.insert(BaseMetricId(4692), &super::extensions_timing::storage_local_get_idb);
        map.insert(BaseMetricId(4694), &super::extensions_timing::storage_local_set_idb);
        map.insert(BaseMetricId(4770), &super::fog_ipc::flush_durations);
        map.insert(BaseMetricId(4817), &super::test_only::what_time_is_it);
        map.insert(BaseMetricId(4833), &super::test_only_ipc::a_timing_dist);
        map.insert(BaseMetricId(5001), &super::pwmgr::signup_form_detection);
        map.insert(BaseMetricId(5063), &super::pictureinpicture::background_tab_playing_duration);
        map.insert(BaseMetricId(5079), &super::pictureinpicture::foreground_tab_playing_duration);
        map.insert(BaseMetricId(5091), &super::pictureinpicture::window_open_duration);
        map.insert(BaseMetricId(5099), &super::places::backups_bookmarkstree);
        map.insert(BaseMetricId(5100), &super::places::backups_daysfromlast);
        map.insert(BaseMetricId(5101), &super::places::backups_tojson);
        map.insert(BaseMetricId(5106), &super::places::export_tohtml);
        map.insert(BaseMetricId(5107), &super::places::frecency_recalc_chunk_time);
        map.insert(BaseMetricId(5108), &super::places::idle_frecency_decay_time);
        map.insert(BaseMetricId(5109), &super::places::idle_maintenance_time);
        map.insert(BaseMetricId(5111), &super::places::maintenance_daysfromlast);
        map.insert(BaseMetricId(5112), &super::places::most_recent_expired_visit);
        map.insert(BaseMetricId(5204), &super::application_reputation::remote_lookup_response_time);
        map.insert(BaseMetricId(5480), &super::fingerprinting_protection::canvas_noise_calculate_time_2);
        map.insert(BaseMetricId(5504), &super::search_service::startup_time);
        map.insert(BaseMetricId(5522), &super::telemetry::archive_checking_over_quota);
        map.insert(BaseMetricId(5526), &super::telemetry::archive_evicting_dirs);
        map.insert(BaseMetricId(5527), &super::telemetry::archive_evicting_over_quota);
        map.insert(BaseMetricId(5532), &super::telemetry::compress);
        map.insert(BaseMetricId(5542), &super::telemetry::pending_checking_over_quota);
        map.insert(BaseMetricId(5543), &super::telemetry::pending_evicting_over_quota);
        map.insert(BaseMetricId(5546), &super::telemetry::pending_pings_age);
        map.insert(BaseMetricId(5554), &super::telemetry::send_failure);
        map.insert(BaseMetricId(5556), &super::telemetry::send_success);
        map.insert(BaseMetricId(5557), &super::telemetry::stringify);
        map.insert(BaseMetricId(5574), &super::thumbnails::capture_canvas_draw_time);
        map.insert(BaseMetricId(5576), &super::thumbnails::capture_page_load_time);
        map.insert(BaseMetricId(5577), &super::thumbnails::capture_queue_time);
        map.insert(BaseMetricId(5578), &super::thumbnails::capture_time);
        map.insert(BaseMetricId(5580), &super::thumbnails::store_time);
        map.insert(BaseMetricId(5625), &super::urlclassifier::async_classifylocal_time);
        map.insert(BaseMetricId(5626), &super::urlclassifier::cl_check_time);
        map.insert(BaseMetricId(5631), &super::urlclassifier::lookup_time_2);
        map.insert(BaseMetricId(5632), &super::urlclassifier::shutdown_time);
        map.insert(BaseMetricId(5641), &super::urlclassifier::vlps_construct_time);
        map.insert(BaseMetricId(5642), &super::urlclassifier::vlps_fallocate_time);
        map.insert(BaseMetricId(5643), &super::urlclassifier::vlps_fileload_time);
        map.insert(BaseMetricId(5672), &super::region::fetch_time);
        map.insert(BaseMetricId(5803), &super::update::langpack_overtime);
        map.insert(BaseMetricId(5804), &super::update::last_notify_interval_days_external);
        map.insert(BaseMetricId(5805), &super::update::last_notify_interval_days_notify);
        map.insert(BaseMetricId(5806), &super::update::last_notify_interval_days_subsequent);
        map.insert(BaseMetricId(5868), &super::widget::notify_idle);
        map.insert(BaseMetricId(5873), &super::cycle_collector::async_snow_white_freeing);
        map.insert(BaseMetricId(5875), &super::cycle_collector::deferred_finalize_async);
        map.insert(BaseMetricId(5877), &super::cycle_collector::forget_skippable_max);
        map.insert(BaseMetricId(5878), &super::cycle_collector::full);
        map.insert(BaseMetricId(5879), &super::cycle_collector::max_pause);
        map.insert(BaseMetricId(5883), &super::cycle_collector::time);
        map.insert(BaseMetricId(5884), &super::cycle_collector::time_between);
        map.insert(BaseMetricId(5889), &super::cycle_collector::worker_time);
        map
    });

    pub static COUNTER_MAP: Lazy<HashMap<BaseMetricId, &Lazy<CounterMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2653);
        map.insert(BaseMetricId(12), &super::browser_engagement::bookmarks_toolbar_bookmark_added);
        map.insert(BaseMetricId(13), &super::browser_engagement::bookmarks_toolbar_bookmark_opened);
        map.insert(BaseMetricId(17), &super::browser_engagement::tab_reload_count);
        map.insert(BaseMetricId(18), &super::browser_engagement::tab_unload_count);
        map.insert(BaseMetricId(20), &super::browser_engagement::active_ticks);
        map.insert(BaseMetricId(29), &super::browser_engagement::tab_open_event_count);
        map.insert(BaseMetricId(30), &super::browser_engagement::tab_pinned_event_count);
        map.insert(BaseMetricId(31), &super::browser_engagement::unfiltered_uri_count);
        map.insert(BaseMetricId(33), &super::browser_engagement::uri_count);
        map.insert(BaseMetricId(34), &super::browser_engagement::uri_count_normal_mode);
        map.insert(BaseMetricId(35), &super::browser_engagement::vertical_tab_open_event_count);
        map.insert(BaseMetricId(36), &super::browser_engagement::vertical_tab_pinned_event_count);
        map.insert(BaseMetricId(37), &super::browser_engagement::window_open_event_count);
        map.insert(BaseMetricId(47), &super::networking::captive_portal_banner_displayed);
        map.insert(BaseMetricId(54), &super::networking::cookie_count_invalid_first_party_partitioned_in_db);
        map.insert(BaseMetricId(136), &super::networking::os_socket_limit_reached);
        map.insert(BaseMetricId(163), &super::networking::residual_cache_folder_count);
        map.insert(BaseMetricId(169), &super::networking::set_invalid_first_party_partitioned_cookie);
        map.insert(BaseMetricId(196), &super::networking::doh_heuristics_attempts);
        map.insert(BaseMetricId(197), &super::networking::doh_heuristics_pass_count);
        map.insert(BaseMetricId(217), &super::security_ui_protectionspopup::smartblockembeds_shown);
        map.insert(BaseMetricId(224), &super::messaging_system::event_context_parse_error);
        map.insert(BaseMetricId(232), &super::messaging_system::glean_ping_for_ping_failures);
        map.insert(BaseMetricId(240), &super::messaging_system::unknown_key_count);
        map.insert(BaseMetricId(289), &super::downloads::panel_shown);
        map.insert(BaseMetricId(291), &super::downloads::file_opened);
        map.insert(BaseMetricId(293), &super::glam_experiment::panel_shown);
        map.insert(BaseMetricId(294), &super::glam_experiment::active_ticks);
        map.insert(BaseMetricId(300), &super::glam_experiment::os_socket_limit_reached);
        map.insert(BaseMetricId(302), &super::glam_experiment::used);
        map.insert(BaseMetricId(303), &super::glam_experiment::cpu_time_bogus_values);
        map.insert(BaseMetricId(304), &super::glam_experiment::total_cpu_time_ms);
        map.insert(BaseMetricId(777), &super::serp::categorization_no_map_found);
        map.insert(BaseMetricId(818), &super::shopping::product_page_visits);
        map.insert(BaseMetricId(907), &super::browser_ui_interaction::all_tabs_panel_dragstart_tab_event_count);
        map.insert(BaseMetricId(909), &super::browser_ui_interaction::textrecognition_error);
        map.insert(BaseMetricId(978), &super::urlbar::autofill_deletion);
        map.insert(BaseMetricId(989), &super::urlbar_persistedsearchterms::revert_by_popup_count);
        map.insert(BaseMetricId(990), &super::urlbar_persistedsearchterms::view_count);
        map.insert(BaseMetricId(992), &super::urlbar_trending::block);
        map.insert(BaseMetricId(993), &super::urlbar_unifiedsearchbutton::opened);
        map.insert(BaseMetricId(995), &super::urlbar_zeroprefix::abandonment);
        map.insert(BaseMetricId(996), &super::urlbar_zeroprefix::engagement);
        map.insert(BaseMetricId(997), &super::urlbar_zeroprefix::exposure);
        map.insert(BaseMetricId(1000), &super::browser_content_crash::dump_unavailable);
        map.insert(BaseMetricId(1001), &super::browser_content_crash::not_submitted);
        map.insert(BaseMetricId(1044), &super::devtools_accessibility::accessible_context_menu_opened);
        map.insert(BaseMetricId(1046), &super::devtools_accessibility::node_inspected_count);
        map.insert(BaseMetricId(1049), &super::devtools_accessibility::opened_count);
        map.insert(BaseMetricId(1050), &super::devtools_accessibility::picker_used_count);
        map.insert(BaseMetricId(1056), &super::devtools::aboutdebugging_opened_count);
        map.insert(BaseMetricId(1061), &super::devtools::animationinspector_opened_count);
        map.insert(BaseMetricId(1063), &super::devtools::browserconsole_opened_count);
        map.insert(BaseMetricId(1066), &super::devtools::compatibilityview_opened_count);
        map.insert(BaseMetricId(1068), &super::devtools::computedview_opened_count);
        map.insert(BaseMetricId(1070), &super::devtools::custom_opened_count);
        map.insert(BaseMetricId(1072), &super::devtools::dom_opened_count);
        map.insert(BaseMetricId(1075), &super::devtools::eyedropper_opened_count);
        map.insert(BaseMetricId(1077), &super::devtools::fontinspector_opened_count);
        map.insert(BaseMetricId(1080), &super::devtools::inspector_opened_count);
        map.insert(BaseMetricId(1082), &super::devtools::jsbrowserdebugger_opened_count);
        map.insert(BaseMetricId(1084), &super::devtools::jsdebugger_opened_count);
        map.insert(BaseMetricId(1086), &super::devtools::jsprofiler_opened_count);
        map.insert(BaseMetricId(1088), &super::devtools::layoutview_opened_count);
        map.insert(BaseMetricId(1090), &super::devtools::memory_opened_count);
        map.insert(BaseMetricId(1092), &super::devtools::menu_eyedropper_opened_count);
        map.insert(BaseMetricId(1093), &super::devtools::netmonitor_opened_count);
        map.insert(BaseMetricId(1095), &super::devtools::options_opened_count);
        map.insert(BaseMetricId(1097), &super::devtools::picker_eyedropper_opened_count);
        map.insert(BaseMetricId(1098), &super::devtools::responsive_opened_count);
        map.insert(BaseMetricId(1100), &super::devtools::ruleview_opened_count);
        map.insert(BaseMetricId(1102), &super::devtools::storage_opened_count);
        map.insert(BaseMetricId(1104), &super::devtools::styleeditor_opened_count);
        map.insert(BaseMetricId(1106), &super::devtools::toolbox_opened_count);
        map.insert(BaseMetricId(1108), &super::devtools::webconsole_opened_count);
        map.insert(BaseMetricId(1116), &super::devtools_grid_gridinspector::opened);
        map.insert(BaseMetricId(1119), &super::devtools_inspector::node_selection_count);
        map.insert(BaseMetricId(1122), &super::devtools_layout_flexboxhighlighter::opened);
        map.insert(BaseMetricId(1123), &super::devtools_markup_flexboxhighlighter::opened);
        map.insert(BaseMetricId(1124), &super::devtools_markup_gridinspector::opened);
        map.insert(BaseMetricId(1125), &super::devtools_markup_scrollable_badge::clicked);
        map.insert(BaseMetricId(1126), &super::devtools_rules_flexboxhighlighter::opened);
        map.insert(BaseMetricId(1127), &super::devtools_rules_gridinspector::opened);
        map.insert(BaseMetricId(1133), &super::devtools_responsive::toolbox_opened_first);
        map.insert(BaseMetricId(1134), &super::devtools_changesview::opened_count);
        map.insert(BaseMetricId(1231), &super::use_counter::content_documents_destroyed);
        map.insert(BaseMetricId(1232), &super::use_counter::dedicated_workers_destroyed);
        map.insert(BaseMetricId(1233), &super::use_counter::service_workers_destroyed);
        map.insert(BaseMetricId(1234), &super::use_counter::shared_workers_destroyed);
        map.insert(BaseMetricId(1235), &super::use_counter::top_level_content_documents_destroyed);
        map.insert(BaseMetricId(1236), &super::use_counter_css_doc::alignment_baseline);
        map.insert(BaseMetricId(1237), &super::use_counter_css_doc::background_repeat_x);
        map.insert(BaseMetricId(1238), &super::use_counter_css_doc::background_repeat_y);
        map.insert(BaseMetricId(1239), &super::use_counter_css_doc::baseline_shift);
        map.insert(BaseMetricId(1240), &super::use_counter_css_doc::buffered_rendering);
        map.insert(BaseMetricId(1241), &super::use_counter_css_doc::color_rendering);
        map.insert(BaseMetricId(1242), &super::use_counter_css_doc::css_accent_color);
        map.insert(BaseMetricId(1243), &super::use_counter_css_doc::css_align_content);
        map.insert(BaseMetricId(1244), &super::use_counter_css_doc::css_align_items);
        map.insert(BaseMetricId(1245), &super::use_counter_css_doc::css_align_self);
        map.insert(BaseMetricId(1246), &super::use_counter_css_doc::css_all);
        map.insert(BaseMetricId(1247), &super::use_counter_css_doc::css_anchor_name);
        map.insert(BaseMetricId(1248), &super::use_counter_css_doc::css_anchor_scope);
        map.insert(BaseMetricId(1249), &super::use_counter_css_doc::css_animation);
        map.insert(BaseMetricId(1250), &super::use_counter_css_doc::css_animation_composition);
        map.insert(BaseMetricId(1251), &super::use_counter_css_doc::css_animation_delay);
        map.insert(BaseMetricId(1252), &super::use_counter_css_doc::css_animation_direction);
        map.insert(BaseMetricId(1253), &super::use_counter_css_doc::css_animation_duration);
        map.insert(BaseMetricId(1254), &super::use_counter_css_doc::css_animation_fill_mode);
        map.insert(BaseMetricId(1255), &super::use_counter_css_doc::css_animation_iteration_count);
        map.insert(BaseMetricId(1256), &super::use_counter_css_doc::css_animation_name);
        map.insert(BaseMetricId(1257), &super::use_counter_css_doc::css_animation_play_state);
        map.insert(BaseMetricId(1258), &super::use_counter_css_doc::css_animation_timeline);
        map.insert(BaseMetricId(1259), &super::use_counter_css_doc::css_animation_timing_function);
        map.insert(BaseMetricId(1260), &super::use_counter_css_doc::css_appearance);
        map.insert(BaseMetricId(1261), &super::use_counter_css_doc::css_aspect_ratio);
        map.insert(BaseMetricId(1262), &super::use_counter_css_doc::css_backdrop_filter);
        map.insert(BaseMetricId(1263), &super::use_counter_css_doc::css_backface_visibility);
        map.insert(BaseMetricId(1264), &super::use_counter_css_doc::css_background);
        map.insert(BaseMetricId(1265), &super::use_counter_css_doc::css_background_attachment);
        map.insert(BaseMetricId(1266), &super::use_counter_css_doc::css_background_blend_mode);
        map.insert(BaseMetricId(1267), &super::use_counter_css_doc::css_background_clip);
        map.insert(BaseMetricId(1268), &super::use_counter_css_doc::css_background_color);
        map.insert(BaseMetricId(1269), &super::use_counter_css_doc::css_background_image);
        map.insert(BaseMetricId(1270), &super::use_counter_css_doc::css_background_origin);
        map.insert(BaseMetricId(1271), &super::use_counter_css_doc::css_background_position);
        map.insert(BaseMetricId(1272), &super::use_counter_css_doc::css_background_position_x);
        map.insert(BaseMetricId(1273), &super::use_counter_css_doc::css_background_position_y);
        map.insert(BaseMetricId(1274), &super::use_counter_css_doc::css_background_repeat);
        map.insert(BaseMetricId(1275), &super::use_counter_css_doc::css_background_size);
        map.insert(BaseMetricId(1276), &super::use_counter_css_doc::css_baseline_source);
        map.insert(BaseMetricId(1277), &super::use_counter_css_doc::css_block_size);
        map.insert(BaseMetricId(1278), &super::use_counter_css_doc::css_border);
        map.insert(BaseMetricId(1279), &super::use_counter_css_doc::css_border_block);
        map.insert(BaseMetricId(1280), &super::use_counter_css_doc::css_border_block_color);
        map.insert(BaseMetricId(1281), &super::use_counter_css_doc::css_border_block_end);
        map.insert(BaseMetricId(1282), &super::use_counter_css_doc::css_border_block_end_color);
        map.insert(BaseMetricId(1283), &super::use_counter_css_doc::css_border_block_end_style);
        map.insert(BaseMetricId(1284), &super::use_counter_css_doc::css_border_block_end_width);
        map.insert(BaseMetricId(1285), &super::use_counter_css_doc::css_border_block_start);
        map.insert(BaseMetricId(1286), &super::use_counter_css_doc::css_border_block_start_color);
        map.insert(BaseMetricId(1287), &super::use_counter_css_doc::css_border_block_start_style);
        map.insert(BaseMetricId(1288), &super::use_counter_css_doc::css_border_block_start_width);
        map.insert(BaseMetricId(1289), &super::use_counter_css_doc::css_border_block_style);
        map.insert(BaseMetricId(1290), &super::use_counter_css_doc::css_border_block_width);
        map.insert(BaseMetricId(1291), &super::use_counter_css_doc::css_border_bottom);
        map.insert(BaseMetricId(1292), &super::use_counter_css_doc::css_border_bottom_color);
        map.insert(BaseMetricId(1293), &super::use_counter_css_doc::css_border_bottom_left_radius);
        map.insert(BaseMetricId(1294), &super::use_counter_css_doc::css_border_bottom_right_radius);
        map.insert(BaseMetricId(1295), &super::use_counter_css_doc::css_border_bottom_style);
        map.insert(BaseMetricId(1296), &super::use_counter_css_doc::css_border_bottom_width);
        map.insert(BaseMetricId(1297), &super::use_counter_css_doc::css_border_collapse);
        map.insert(BaseMetricId(1298), &super::use_counter_css_doc::css_border_color);
        map.insert(BaseMetricId(1299), &super::use_counter_css_doc::css_border_end_end_radius);
        map.insert(BaseMetricId(1300), &super::use_counter_css_doc::css_border_end_start_radius);
        map.insert(BaseMetricId(1301), &super::use_counter_css_doc::css_border_image);
        map.insert(BaseMetricId(1302), &super::use_counter_css_doc::css_border_image_outset);
        map.insert(BaseMetricId(1303), &super::use_counter_css_doc::css_border_image_repeat);
        map.insert(BaseMetricId(1304), &super::use_counter_css_doc::css_border_image_slice);
        map.insert(BaseMetricId(1305), &super::use_counter_css_doc::css_border_image_source);
        map.insert(BaseMetricId(1306), &super::use_counter_css_doc::css_border_image_width);
        map.insert(BaseMetricId(1307), &super::use_counter_css_doc::css_border_inline);
        map.insert(BaseMetricId(1308), &super::use_counter_css_doc::css_border_inline_color);
        map.insert(BaseMetricId(1309), &super::use_counter_css_doc::css_border_inline_end);
        map.insert(BaseMetricId(1310), &super::use_counter_css_doc::css_border_inline_end_color);
        map.insert(BaseMetricId(1311), &super::use_counter_css_doc::css_border_inline_end_style);
        map.insert(BaseMetricId(1312), &super::use_counter_css_doc::css_border_inline_end_width);
        map.insert(BaseMetricId(1313), &super::use_counter_css_doc::css_border_inline_start);
        map.insert(BaseMetricId(1314), &super::use_counter_css_doc::css_border_inline_start_color);
        map.insert(BaseMetricId(1315), &super::use_counter_css_doc::css_border_inline_start_style);
        map.insert(BaseMetricId(1316), &super::use_counter_css_doc::css_border_inline_start_width);
        map.insert(BaseMetricId(1317), &super::use_counter_css_doc::css_border_inline_style);
        map.insert(BaseMetricId(1318), &super::use_counter_css_doc::css_border_inline_width);
        map.insert(BaseMetricId(1319), &super::use_counter_css_doc::css_border_left);
        map.insert(BaseMetricId(1320), &super::use_counter_css_doc::css_border_left_color);
        map.insert(BaseMetricId(1321), &super::use_counter_css_doc::css_border_left_style);
        map.insert(BaseMetricId(1322), &super::use_counter_css_doc::css_border_left_width);
        map.insert(BaseMetricId(1323), &super::use_counter_css_doc::css_border_radius);
        map.insert(BaseMetricId(1324), &super::use_counter_css_doc::css_border_right);
        map.insert(BaseMetricId(1325), &super::use_counter_css_doc::css_border_right_color);
        map.insert(BaseMetricId(1326), &super::use_counter_css_doc::css_border_right_style);
        map.insert(BaseMetricId(1327), &super::use_counter_css_doc::css_border_right_width);
        map.insert(BaseMetricId(1328), &super::use_counter_css_doc::css_border_spacing);
        map.insert(BaseMetricId(1329), &super::use_counter_css_doc::css_border_start_end_radius);
        map.insert(BaseMetricId(1330), &super::use_counter_css_doc::css_border_start_start_radius);
        map.insert(BaseMetricId(1331), &super::use_counter_css_doc::css_border_style);
        map.insert(BaseMetricId(1332), &super::use_counter_css_doc::css_border_top);
        map.insert(BaseMetricId(1333), &super::use_counter_css_doc::css_border_top_color);
        map.insert(BaseMetricId(1334), &super::use_counter_css_doc::css_border_top_left_radius);
        map.insert(BaseMetricId(1335), &super::use_counter_css_doc::css_border_top_right_radius);
        map.insert(BaseMetricId(1336), &super::use_counter_css_doc::css_border_top_style);
        map.insert(BaseMetricId(1337), &super::use_counter_css_doc::css_border_top_width);
        map.insert(BaseMetricId(1338), &super::use_counter_css_doc::css_border_width);
        map.insert(BaseMetricId(1339), &super::use_counter_css_doc::css_bottom);
        map.insert(BaseMetricId(1340), &super::use_counter_css_doc::css_box_decoration_break);
        map.insert(BaseMetricId(1341), &super::use_counter_css_doc::css_box_shadow);
        map.insert(BaseMetricId(1342), &super::use_counter_css_doc::css_box_sizing);
        map.insert(BaseMetricId(1343), &super::use_counter_css_doc::css_break_after);
        map.insert(BaseMetricId(1344), &super::use_counter_css_doc::css_break_before);
        map.insert(BaseMetricId(1345), &super::use_counter_css_doc::css_break_inside);
        map.insert(BaseMetricId(1346), &super::use_counter_css_doc::css_caption_side);
        map.insert(BaseMetricId(1347), &super::use_counter_css_doc::css_caret_color);
        map.insert(BaseMetricId(1348), &super::use_counter_css_doc::css_clear);
        map.insert(BaseMetricId(1349), &super::use_counter_css_doc::css_clip);
        map.insert(BaseMetricId(1350), &super::use_counter_css_doc::css_clip_path);
        map.insert(BaseMetricId(1351), &super::use_counter_css_doc::css_clip_rule);
        map.insert(BaseMetricId(1352), &super::use_counter_css_doc::css_color);
        map.insert(BaseMetricId(1353), &super::use_counter_css_doc::css_color_adjust);
        map.insert(BaseMetricId(1354), &super::use_counter_css_doc::css_color_interpolation);
        map.insert(BaseMetricId(1355), &super::use_counter_css_doc::css_color_interpolation_filters);
        map.insert(BaseMetricId(1356), &super::use_counter_css_doc::css_color_scheme);
        map.insert(BaseMetricId(1357), &super::use_counter_css_doc::css_column_count);
        map.insert(BaseMetricId(1358), &super::use_counter_css_doc::css_column_fill);
        map.insert(BaseMetricId(1359), &super::use_counter_css_doc::css_column_gap);
        map.insert(BaseMetricId(1360), &super::use_counter_css_doc::css_column_rule);
        map.insert(BaseMetricId(1361), &super::use_counter_css_doc::css_column_rule_color);
        map.insert(BaseMetricId(1362), &super::use_counter_css_doc::css_column_rule_style);
        map.insert(BaseMetricId(1363), &super::use_counter_css_doc::css_column_rule_width);
        map.insert(BaseMetricId(1364), &super::use_counter_css_doc::css_column_span);
        map.insert(BaseMetricId(1365), &super::use_counter_css_doc::css_column_width);
        map.insert(BaseMetricId(1366), &super::use_counter_css_doc::css_columns);
        map.insert(BaseMetricId(1367), &super::use_counter_css_doc::css_contain);
        map.insert(BaseMetricId(1368), &super::use_counter_css_doc::css_contain_intrinsic_block_size);
        map.insert(BaseMetricId(1369), &super::use_counter_css_doc::css_contain_intrinsic_height);
        map.insert(BaseMetricId(1370), &super::use_counter_css_doc::css_contain_intrinsic_inline_size);
        map.insert(BaseMetricId(1371), &super::use_counter_css_doc::css_contain_intrinsic_size);
        map.insert(BaseMetricId(1372), &super::use_counter_css_doc::css_contain_intrinsic_width);
        map.insert(BaseMetricId(1373), &super::use_counter_css_doc::css_container);
        map.insert(BaseMetricId(1374), &super::use_counter_css_doc::css_container_name);
        map.insert(BaseMetricId(1375), &super::use_counter_css_doc::css_container_type);
        map.insert(BaseMetricId(1376), &super::use_counter_css_doc::css_content);
        map.insert(BaseMetricId(1377), &super::use_counter_css_doc::css_content_visibility);
        map.insert(BaseMetricId(1378), &super::use_counter_css_doc::css_counter_increment);
        map.insert(BaseMetricId(1379), &super::use_counter_css_doc::css_counter_reset);
        map.insert(BaseMetricId(1380), &super::use_counter_css_doc::css_counter_set);
        map.insert(BaseMetricId(1381), &super::use_counter_css_doc::css_cursor);
        map.insert(BaseMetricId(1382), &super::use_counter_css_doc::css_cx);
        map.insert(BaseMetricId(1383), &super::use_counter_css_doc::css_cy);
        map.insert(BaseMetricId(1384), &super::use_counter_css_doc::css_d);
        map.insert(BaseMetricId(1385), &super::use_counter_css_doc::css_direction);
        map.insert(BaseMetricId(1386), &super::use_counter_css_doc::css_display);
        map.insert(BaseMetricId(1387), &super::use_counter_css_doc::css_dominant_baseline);
        map.insert(BaseMetricId(1388), &super::use_counter_css_doc::css_empty_cells);
        map.insert(BaseMetricId(1389), &super::use_counter_css_doc::css_field_sizing);
        map.insert(BaseMetricId(1390), &super::use_counter_css_doc::css_fill);
        map.insert(BaseMetricId(1391), &super::use_counter_css_doc::css_fill_opacity);
        map.insert(BaseMetricId(1392), &super::use_counter_css_doc::css_fill_rule);
        map.insert(BaseMetricId(1393), &super::use_counter_css_doc::css_filter);
        map.insert(BaseMetricId(1394), &super::use_counter_css_doc::css_flex);
        map.insert(BaseMetricId(1395), &super::use_counter_css_doc::css_flex_basis);
        map.insert(BaseMetricId(1396), &super::use_counter_css_doc::css_flex_direction);
        map.insert(BaseMetricId(1397), &super::use_counter_css_doc::css_flex_flow);
        map.insert(BaseMetricId(1398), &super::use_counter_css_doc::css_flex_grow);
        map.insert(BaseMetricId(1399), &super::use_counter_css_doc::css_flex_shrink);
        map.insert(BaseMetricId(1400), &super::use_counter_css_doc::css_flex_wrap);
        map.insert(BaseMetricId(1401), &super::use_counter_css_doc::css_float);
        map.insert(BaseMetricId(1402), &super::use_counter_css_doc::css_flood_color);
        map.insert(BaseMetricId(1403), &super::use_counter_css_doc::css_flood_opacity);
        map.insert(BaseMetricId(1404), &super::use_counter_css_doc::css_font);
        map.insert(BaseMetricId(1405), &super::use_counter_css_doc::css_font_family);
        map.insert(BaseMetricId(1406), &super::use_counter_css_doc::css_font_feature_settings);
        map.insert(BaseMetricId(1407), &super::use_counter_css_doc::css_font_kerning);
        map.insert(BaseMetricId(1408), &super::use_counter_css_doc::css_font_language_override);
        map.insert(BaseMetricId(1409), &super::use_counter_css_doc::css_font_optical_sizing);
        map.insert(BaseMetricId(1410), &super::use_counter_css_doc::css_font_palette);
        map.insert(BaseMetricId(1411), &super::use_counter_css_doc::css_font_size);
        map.insert(BaseMetricId(1412), &super::use_counter_css_doc::css_font_size_adjust);
        map.insert(BaseMetricId(1413), &super::use_counter_css_doc::css_font_stretch);
        map.insert(BaseMetricId(1414), &super::use_counter_css_doc::css_font_style);
        map.insert(BaseMetricId(1415), &super::use_counter_css_doc::css_font_synthesis);
        map.insert(BaseMetricId(1416), &super::use_counter_css_doc::css_font_synthesis_position);
        map.insert(BaseMetricId(1417), &super::use_counter_css_doc::css_font_synthesis_small_caps);
        map.insert(BaseMetricId(1418), &super::use_counter_css_doc::css_font_synthesis_style);
        map.insert(BaseMetricId(1419), &super::use_counter_css_doc::css_font_synthesis_weight);
        map.insert(BaseMetricId(1420), &super::use_counter_css_doc::css_font_variant);
        map.insert(BaseMetricId(1421), &super::use_counter_css_doc::css_font_variant_alternates);
        map.insert(BaseMetricId(1422), &super::use_counter_css_doc::css_font_variant_caps);
        map.insert(BaseMetricId(1423), &super::use_counter_css_doc::css_font_variant_east_asian);
        map.insert(BaseMetricId(1424), &super::use_counter_css_doc::css_font_variant_emoji);
        map.insert(BaseMetricId(1425), &super::use_counter_css_doc::css_font_variant_ligatures);
        map.insert(BaseMetricId(1426), &super::use_counter_css_doc::css_font_variant_numeric);
        map.insert(BaseMetricId(1427), &super::use_counter_css_doc::css_font_variant_position);
        map.insert(BaseMetricId(1428), &super::use_counter_css_doc::css_font_variation_settings);
        map.insert(BaseMetricId(1429), &super::use_counter_css_doc::css_font_weight);
        map.insert(BaseMetricId(1430), &super::use_counter_css_doc::css_forced_color_adjust);
        map.insert(BaseMetricId(1431), &super::use_counter_css_doc::css_gap);
        map.insert(BaseMetricId(1432), &super::use_counter_css_doc::css_grid);
        map.insert(BaseMetricId(1433), &super::use_counter_css_doc::css_grid_area);
        map.insert(BaseMetricId(1434), &super::use_counter_css_doc::css_grid_auto_columns);
        map.insert(BaseMetricId(1435), &super::use_counter_css_doc::css_grid_auto_flow);
        map.insert(BaseMetricId(1436), &super::use_counter_css_doc::css_grid_auto_rows);
        map.insert(BaseMetricId(1437), &super::use_counter_css_doc::css_grid_column);
        map.insert(BaseMetricId(1438), &super::use_counter_css_doc::css_grid_column_end);
        map.insert(BaseMetricId(1439), &super::use_counter_css_doc::css_grid_column_gap);
        map.insert(BaseMetricId(1440), &super::use_counter_css_doc::css_grid_column_start);
        map.insert(BaseMetricId(1441), &super::use_counter_css_doc::css_grid_gap);
        map.insert(BaseMetricId(1442), &super::use_counter_css_doc::css_grid_row);
        map.insert(BaseMetricId(1443), &super::use_counter_css_doc::css_grid_row_end);
        map.insert(BaseMetricId(1444), &super::use_counter_css_doc::css_grid_row_gap);
        map.insert(BaseMetricId(1445), &super::use_counter_css_doc::css_grid_row_start);
        map.insert(BaseMetricId(1446), &super::use_counter_css_doc::css_grid_template);
        map.insert(BaseMetricId(1447), &super::use_counter_css_doc::css_grid_template_areas);
        map.insert(BaseMetricId(1448), &super::use_counter_css_doc::css_grid_template_columns);
        map.insert(BaseMetricId(1449), &super::use_counter_css_doc::css_grid_template_rows);
        map.insert(BaseMetricId(1450), &super::use_counter_css_doc::css_height);
        map.insert(BaseMetricId(1451), &super::use_counter_css_doc::css_hyphenate_character);
        map.insert(BaseMetricId(1452), &super::use_counter_css_doc::css_hyphenate_limit_chars);
        map.insert(BaseMetricId(1453), &super::use_counter_css_doc::css_hyphens);
        map.insert(BaseMetricId(1454), &super::use_counter_css_doc::css_image_orientation);
        map.insert(BaseMetricId(1455), &super::use_counter_css_doc::css_image_rendering);
        map.insert(BaseMetricId(1456), &super::use_counter_css_doc::css_ime_mode);
        map.insert(BaseMetricId(1457), &super::use_counter_css_doc::css_initial_letter);
        map.insert(BaseMetricId(1458), &super::use_counter_css_doc::css_inline_size);
        map.insert(BaseMetricId(1459), &super::use_counter_css_doc::css_inset);
        map.insert(BaseMetricId(1460), &super::use_counter_css_doc::css_inset_block);
        map.insert(BaseMetricId(1461), &super::use_counter_css_doc::css_inset_block_end);
        map.insert(BaseMetricId(1462), &super::use_counter_css_doc::css_inset_block_start);
        map.insert(BaseMetricId(1463), &super::use_counter_css_doc::css_inset_inline);
        map.insert(BaseMetricId(1464), &super::use_counter_css_doc::css_inset_inline_end);
        map.insert(BaseMetricId(1465), &super::use_counter_css_doc::css_inset_inline_start);
        map.insert(BaseMetricId(1466), &super::use_counter_css_doc::css_isolation);
        map.insert(BaseMetricId(1467), &super::use_counter_css_doc::css_justify_content);
        map.insert(BaseMetricId(1468), &super::use_counter_css_doc::css_justify_items);
        map.insert(BaseMetricId(1469), &super::use_counter_css_doc::css_justify_self);
        map.insert(BaseMetricId(1470), &super::use_counter_css_doc::css_left);
        map.insert(BaseMetricId(1471), &super::use_counter_css_doc::css_letter_spacing);
        map.insert(BaseMetricId(1472), &super::use_counter_css_doc::css_lighting_color);
        map.insert(BaseMetricId(1473), &super::use_counter_css_doc::css_line_break);
        map.insert(BaseMetricId(1474), &super::use_counter_css_doc::css_line_height);
        map.insert(BaseMetricId(1475), &super::use_counter_css_doc::css_list_style);
        map.insert(BaseMetricId(1476), &super::use_counter_css_doc::css_list_style_image);
        map.insert(BaseMetricId(1477), &super::use_counter_css_doc::css_list_style_position);
        map.insert(BaseMetricId(1478), &super::use_counter_css_doc::css_list_style_type);
        map.insert(BaseMetricId(1479), &super::use_counter_css_doc::css_margin);
        map.insert(BaseMetricId(1480), &super::use_counter_css_doc::css_margin_block);
        map.insert(BaseMetricId(1481), &super::use_counter_css_doc::css_margin_block_end);
        map.insert(BaseMetricId(1482), &super::use_counter_css_doc::css_margin_block_start);
        map.insert(BaseMetricId(1483), &super::use_counter_css_doc::css_margin_bottom);
        map.insert(BaseMetricId(1484), &super::use_counter_css_doc::css_margin_inline);
        map.insert(BaseMetricId(1485), &super::use_counter_css_doc::css_margin_inline_end);
        map.insert(BaseMetricId(1486), &super::use_counter_css_doc::css_margin_inline_start);
        map.insert(BaseMetricId(1487), &super::use_counter_css_doc::css_margin_left);
        map.insert(BaseMetricId(1488), &super::use_counter_css_doc::css_margin_right);
        map.insert(BaseMetricId(1489), &super::use_counter_css_doc::css_margin_top);
        map.insert(BaseMetricId(1490), &super::use_counter_css_doc::css_marker);
        map.insert(BaseMetricId(1491), &super::use_counter_css_doc::css_marker_end);
        map.insert(BaseMetricId(1492), &super::use_counter_css_doc::css_marker_mid);
        map.insert(BaseMetricId(1493), &super::use_counter_css_doc::css_marker_start);
        map.insert(BaseMetricId(1494), &super::use_counter_css_doc::css_mask);
        map.insert(BaseMetricId(1495), &super::use_counter_css_doc::css_mask_clip);
        map.insert(BaseMetricId(1496), &super::use_counter_css_doc::css_mask_composite);
        map.insert(BaseMetricId(1497), &super::use_counter_css_doc::css_mask_image);
        map.insert(BaseMetricId(1498), &super::use_counter_css_doc::css_mask_mode);
        map.insert(BaseMetricId(1499), &super::use_counter_css_doc::css_mask_origin);
        map.insert(BaseMetricId(1500), &super::use_counter_css_doc::css_mask_position);
        map.insert(BaseMetricId(1501), &super::use_counter_css_doc::css_mask_position_x);
        map.insert(BaseMetricId(1502), &super::use_counter_css_doc::css_mask_position_y);
        map.insert(BaseMetricId(1503), &super::use_counter_css_doc::css_mask_repeat);
        map.insert(BaseMetricId(1504), &super::use_counter_css_doc::css_mask_size);
        map.insert(BaseMetricId(1505), &super::use_counter_css_doc::css_mask_type);
        map.insert(BaseMetricId(1506), &super::use_counter_css_doc::css_masonry_auto_flow);
        map.insert(BaseMetricId(1507), &super::use_counter_css_doc::css_math_depth);
        map.insert(BaseMetricId(1508), &super::use_counter_css_doc::css_math_style);
        map.insert(BaseMetricId(1509), &super::use_counter_css_doc::css_max_block_size);
        map.insert(BaseMetricId(1510), &super::use_counter_css_doc::css_max_height);
        map.insert(BaseMetricId(1511), &super::use_counter_css_doc::css_max_inline_size);
        map.insert(BaseMetricId(1512), &super::use_counter_css_doc::css_max_width);
        map.insert(BaseMetricId(1513), &super::use_counter_css_doc::css_min_block_size);
        map.insert(BaseMetricId(1514), &super::use_counter_css_doc::css_min_height);
        map.insert(BaseMetricId(1515), &super::use_counter_css_doc::css_min_inline_size);
        map.insert(BaseMetricId(1516), &super::use_counter_css_doc::css_min_width);
        map.insert(BaseMetricId(1517), &super::use_counter_css_doc::css_mix_blend_mode);
        map.insert(BaseMetricId(1518), &super::use_counter_css_doc::css_moz_animation);
        map.insert(BaseMetricId(1519), &super::use_counter_css_doc::css_moz_animation_delay);
        map.insert(BaseMetricId(1520), &super::use_counter_css_doc::css_moz_animation_direction);
        map.insert(BaseMetricId(1521), &super::use_counter_css_doc::css_moz_animation_duration);
        map.insert(BaseMetricId(1522), &super::use_counter_css_doc::css_moz_animation_fill_mode);
        map.insert(BaseMetricId(1523), &super::use_counter_css_doc::css_moz_animation_iteration_count);
        map.insert(BaseMetricId(1524), &super::use_counter_css_doc::css_moz_animation_name);
        map.insert(BaseMetricId(1525), &super::use_counter_css_doc::css_moz_animation_play_state);
        map.insert(BaseMetricId(1526), &super::use_counter_css_doc::css_moz_animation_timing_function);
        map.insert(BaseMetricId(1527), &super::use_counter_css_doc::css_moz_appearance);
        map.insert(BaseMetricId(1528), &super::use_counter_css_doc::css_moz_backface_visibility);
        map.insert(BaseMetricId(1529), &super::use_counter_css_doc::css_moz_border_end);
        map.insert(BaseMetricId(1530), &super::use_counter_css_doc::css_moz_border_end_color);
        map.insert(BaseMetricId(1531), &super::use_counter_css_doc::css_moz_border_end_style);
        map.insert(BaseMetricId(1532), &super::use_counter_css_doc::css_moz_border_end_width);
        map.insert(BaseMetricId(1533), &super::use_counter_css_doc::css_moz_border_image);
        map.insert(BaseMetricId(1534), &super::use_counter_css_doc::css_moz_border_start);
        map.insert(BaseMetricId(1535), &super::use_counter_css_doc::css_moz_border_start_color);
        map.insert(BaseMetricId(1536), &super::use_counter_css_doc::css_moz_border_start_style);
        map.insert(BaseMetricId(1537), &super::use_counter_css_doc::css_moz_border_start_width);
        map.insert(BaseMetricId(1538), &super::use_counter_css_doc::css_moz_box_align);
        map.insert(BaseMetricId(1539), &super::use_counter_css_doc::css_moz_box_collapse);
        map.insert(BaseMetricId(1540), &super::use_counter_css_doc::css_moz_box_direction);
        map.insert(BaseMetricId(1541), &super::use_counter_css_doc::css_moz_box_flex);
        map.insert(BaseMetricId(1542), &super::use_counter_css_doc::css_moz_box_ordinal_group);
        map.insert(BaseMetricId(1543), &super::use_counter_css_doc::css_moz_box_orient);
        map.insert(BaseMetricId(1544), &super::use_counter_css_doc::css_moz_box_pack);
        map.insert(BaseMetricId(1545), &super::use_counter_css_doc::css_moz_box_sizing);
        map.insert(BaseMetricId(1546), &super::use_counter_css_doc::css_moz_context_properties);
        map.insert(BaseMetricId(1547), &super::use_counter_css_doc::css_moz_control_character_visibility);
        map.insert(BaseMetricId(1548), &super::use_counter_css_doc::css_moz_default_appearance);
        map.insert(BaseMetricId(1549), &super::use_counter_css_doc::css_moz_float_edge);
        map.insert(BaseMetricId(1550), &super::use_counter_css_doc::css_moz_font_feature_settings);
        map.insert(BaseMetricId(1551), &super::use_counter_css_doc::css_moz_font_language_override);
        map.insert(BaseMetricId(1552), &super::use_counter_css_doc::css_moz_force_broken_image_icon);
        map.insert(BaseMetricId(1553), &super::use_counter_css_doc::css_moz_hyphens);
        map.insert(BaseMetricId(1554), &super::use_counter_css_doc::css_moz_inert);
        map.insert(BaseMetricId(1555), &super::use_counter_css_doc::css_moz_margin_end);
        map.insert(BaseMetricId(1556), &super::use_counter_css_doc::css_moz_margin_start);
        map.insert(BaseMetricId(1557), &super::use_counter_css_doc::css_moz_math_variant);
        map.insert(BaseMetricId(1558), &super::use_counter_css_doc::css_moz_min_font_size_ratio);
        map.insert(BaseMetricId(1559), &super::use_counter_css_doc::css_moz_orient);
        map.insert(BaseMetricId(1560), &super::use_counter_css_doc::css_moz_osx_font_smoothing);
        map.insert(BaseMetricId(1561), &super::use_counter_css_doc::css_moz_padding_end);
        map.insert(BaseMetricId(1562), &super::use_counter_css_doc::css_moz_padding_start);
        map.insert(BaseMetricId(1563), &super::use_counter_css_doc::css_moz_perspective);
        map.insert(BaseMetricId(1564), &super::use_counter_css_doc::css_moz_perspective_origin);
        map.insert(BaseMetricId(1565), &super::use_counter_css_doc::css_moz_subtree_hidden_only_visually);
        map.insert(BaseMetricId(1566), &super::use_counter_css_doc::css_moz_tab_size);
        map.insert(BaseMetricId(1567), &super::use_counter_css_doc::css_moz_text_size_adjust);
        map.insert(BaseMetricId(1568), &super::use_counter_css_doc::css_moz_theme);
        map.insert(BaseMetricId(1569), &super::use_counter_css_doc::css_moz_top_layer);
        map.insert(BaseMetricId(1570), &super::use_counter_css_doc::css_moz_transform);
        map.insert(BaseMetricId(1571), &super::use_counter_css_doc::css_moz_transform_origin);
        map.insert(BaseMetricId(1572), &super::use_counter_css_doc::css_moz_transform_style);
        map.insert(BaseMetricId(1573), &super::use_counter_css_doc::css_moz_transition);
        map.insert(BaseMetricId(1574), &super::use_counter_css_doc::css_moz_transition_delay);
        map.insert(BaseMetricId(1575), &super::use_counter_css_doc::css_moz_transition_duration);
        map.insert(BaseMetricId(1576), &super::use_counter_css_doc::css_moz_transition_property);
        map.insert(BaseMetricId(1577), &super::use_counter_css_doc::css_moz_transition_timing_function);
        map.insert(BaseMetricId(1578), &super::use_counter_css_doc::css_moz_user_focus);
        map.insert(BaseMetricId(1579), &super::use_counter_css_doc::css_moz_user_input);
        map.insert(BaseMetricId(1580), &super::use_counter_css_doc::css_moz_user_select);
        map.insert(BaseMetricId(1581), &super::use_counter_css_doc::css_moz_window_dragging);
        map.insert(BaseMetricId(1582), &super::use_counter_css_doc::css_moz_window_input_region_margin);
        map.insert(BaseMetricId(1583), &super::use_counter_css_doc::css_moz_window_opacity);
        map.insert(BaseMetricId(1584), &super::use_counter_css_doc::css_moz_window_shadow);
        map.insert(BaseMetricId(1585), &super::use_counter_css_doc::css_moz_window_transform);
        map.insert(BaseMetricId(1586), &super::use_counter_css_doc::css_object_fit);
        map.insert(BaseMetricId(1587), &super::use_counter_css_doc::css_object_position);
        map.insert(BaseMetricId(1588), &super::use_counter_css_doc::css_offset);
        map.insert(BaseMetricId(1589), &super::use_counter_css_doc::css_offset_anchor);
        map.insert(BaseMetricId(1590), &super::use_counter_css_doc::css_offset_distance);
        map.insert(BaseMetricId(1591), &super::use_counter_css_doc::css_offset_path);
        map.insert(BaseMetricId(1592), &super::use_counter_css_doc::css_offset_position);
        map.insert(BaseMetricId(1593), &super::use_counter_css_doc::css_offset_rotate);
        map.insert(BaseMetricId(1594), &super::use_counter_css_doc::css_opacity);
        map.insert(BaseMetricId(1595), &super::use_counter_css_doc::css_order);
        map.insert(BaseMetricId(1596), &super::use_counter_css_doc::css_outline);
        map.insert(BaseMetricId(1597), &super::use_counter_css_doc::css_outline_color);
        map.insert(BaseMetricId(1598), &super::use_counter_css_doc::css_outline_offset);
        map.insert(BaseMetricId(1599), &super::use_counter_css_doc::css_outline_style);
        map.insert(BaseMetricId(1600), &super::use_counter_css_doc::css_outline_width);
        map.insert(BaseMetricId(1601), &super::use_counter_css_doc::css_overflow);
        map.insert(BaseMetricId(1602), &super::use_counter_css_doc::css_overflow_anchor);
        map.insert(BaseMetricId(1603), &super::use_counter_css_doc::css_overflow_block);
        map.insert(BaseMetricId(1604), &super::use_counter_css_doc::css_overflow_clip_box);
        map.insert(BaseMetricId(1605), &super::use_counter_css_doc::css_overflow_clip_box_block);
        map.insert(BaseMetricId(1606), &super::use_counter_css_doc::css_overflow_clip_box_inline);
        map.insert(BaseMetricId(1607), &super::use_counter_css_doc::css_overflow_clip_margin);
        map.insert(BaseMetricId(1608), &super::use_counter_css_doc::css_overflow_inline);
        map.insert(BaseMetricId(1609), &super::use_counter_css_doc::css_overflow_wrap);
        map.insert(BaseMetricId(1610), &super::use_counter_css_doc::css_overflow_x);
        map.insert(BaseMetricId(1611), &super::use_counter_css_doc::css_overflow_y);
        map.insert(BaseMetricId(1612), &super::use_counter_css_doc::css_overscroll_behavior);
        map.insert(BaseMetricId(1613), &super::use_counter_css_doc::css_overscroll_behavior_block);
        map.insert(BaseMetricId(1614), &super::use_counter_css_doc::css_overscroll_behavior_inline);
        map.insert(BaseMetricId(1615), &super::use_counter_css_doc::css_overscroll_behavior_x);
        map.insert(BaseMetricId(1616), &super::use_counter_css_doc::css_overscroll_behavior_y);
        map.insert(BaseMetricId(1617), &super::use_counter_css_doc::css_padding);
        map.insert(BaseMetricId(1618), &super::use_counter_css_doc::css_padding_block);
        map.insert(BaseMetricId(1619), &super::use_counter_css_doc::css_padding_block_end);
        map.insert(BaseMetricId(1620), &super::use_counter_css_doc::css_padding_block_start);
        map.insert(BaseMetricId(1621), &super::use_counter_css_doc::css_padding_bottom);
        map.insert(BaseMetricId(1622), &super::use_counter_css_doc::css_padding_inline);
        map.insert(BaseMetricId(1623), &super::use_counter_css_doc::css_padding_inline_end);
        map.insert(BaseMetricId(1624), &super::use_counter_css_doc::css_padding_inline_start);
        map.insert(BaseMetricId(1625), &super::use_counter_css_doc::css_padding_left);
        map.insert(BaseMetricId(1626), &super::use_counter_css_doc::css_padding_right);
        map.insert(BaseMetricId(1627), &super::use_counter_css_doc::css_padding_top);
        map.insert(BaseMetricId(1628), &super::use_counter_css_doc::css_page);
        map.insert(BaseMetricId(1629), &super::use_counter_css_doc::css_page_break_after);
        map.insert(BaseMetricId(1630), &super::use_counter_css_doc::css_page_break_before);
        map.insert(BaseMetricId(1631), &super::use_counter_css_doc::css_page_break_inside);
        map.insert(BaseMetricId(1632), &super::use_counter_css_doc::css_page_orientation);
        map.insert(BaseMetricId(1633), &super::use_counter_css_doc::css_paint_order);
        map.insert(BaseMetricId(1634), &super::use_counter_css_doc::css_perspective);
        map.insert(BaseMetricId(1635), &super::use_counter_css_doc::css_perspective_origin);
        map.insert(BaseMetricId(1636), &super::use_counter_css_doc::css_place_content);
        map.insert(BaseMetricId(1637), &super::use_counter_css_doc::css_place_items);
        map.insert(BaseMetricId(1638), &super::use_counter_css_doc::css_place_self);
        map.insert(BaseMetricId(1639), &super::use_counter_css_doc::css_pointer_events);
        map.insert(BaseMetricId(1640), &super::use_counter_css_doc::css_position);
        map.insert(BaseMetricId(1641), &super::use_counter_css_doc::css_position_anchor);
        map.insert(BaseMetricId(1642), &super::use_counter_css_doc::css_position_area);
        map.insert(BaseMetricId(1643), &super::use_counter_css_doc::css_position_try);
        map.insert(BaseMetricId(1644), &super::use_counter_css_doc::css_position_try_fallbacks);
        map.insert(BaseMetricId(1645), &super::use_counter_css_doc::css_position_try_order);
        map.insert(BaseMetricId(1646), &super::use_counter_css_doc::css_position_visibility);
        map.insert(BaseMetricId(1647), &super::use_counter_css_doc::css_print_color_adjust);
        map.insert(BaseMetricId(1648), &super::use_counter_css_doc::css_quotes);
        map.insert(BaseMetricId(1649), &super::use_counter_css_doc::css_r);
        map.insert(BaseMetricId(1650), &super::use_counter_css_doc::css_resize);
        map.insert(BaseMetricId(1651), &super::use_counter_css_doc::css_right);
        map.insert(BaseMetricId(1652), &super::use_counter_css_doc::css_rotate);
        map.insert(BaseMetricId(1653), &super::use_counter_css_doc::css_row_gap);
        map.insert(BaseMetricId(1654), &super::use_counter_css_doc::css_ruby_align);
        map.insert(BaseMetricId(1655), &super::use_counter_css_doc::css_ruby_position);
        map.insert(BaseMetricId(1656), &super::use_counter_css_doc::css_rx);
        map.insert(BaseMetricId(1657), &super::use_counter_css_doc::css_ry);
        map.insert(BaseMetricId(1658), &super::use_counter_css_doc::css_scale);
        map.insert(BaseMetricId(1659), &super::use_counter_css_doc::css_scroll_behavior);
        map.insert(BaseMetricId(1660), &super::use_counter_css_doc::css_scroll_margin);
        map.insert(BaseMetricId(1661), &super::use_counter_css_doc::css_scroll_margin_block);
        map.insert(BaseMetricId(1662), &super::use_counter_css_doc::css_scroll_margin_block_end);
        map.insert(BaseMetricId(1663), &super::use_counter_css_doc::css_scroll_margin_block_start);
        map.insert(BaseMetricId(1664), &super::use_counter_css_doc::css_scroll_margin_bottom);
        map.insert(BaseMetricId(1665), &super::use_counter_css_doc::css_scroll_margin_inline);
        map.insert(BaseMetricId(1666), &super::use_counter_css_doc::css_scroll_margin_inline_end);
        map.insert(BaseMetricId(1667), &super::use_counter_css_doc::css_scroll_margin_inline_start);
        map.insert(BaseMetricId(1668), &super::use_counter_css_doc::css_scroll_margin_left);
        map.insert(BaseMetricId(1669), &super::use_counter_css_doc::css_scroll_margin_right);
        map.insert(BaseMetricId(1670), &super::use_counter_css_doc::css_scroll_margin_top);
        map.insert(BaseMetricId(1671), &super::use_counter_css_doc::css_scroll_padding);
        map.insert(BaseMetricId(1672), &super::use_counter_css_doc::css_scroll_padding_block);
        map.insert(BaseMetricId(1673), &super::use_counter_css_doc::css_scroll_padding_block_end);
        map.insert(BaseMetricId(1674), &super::use_counter_css_doc::css_scroll_padding_block_start);
        map.insert(BaseMetricId(1675), &super::use_counter_css_doc::css_scroll_padding_bottom);
        map.insert(BaseMetricId(1676), &super::use_counter_css_doc::css_scroll_padding_inline);
        map.insert(BaseMetricId(1677), &super::use_counter_css_doc::css_scroll_padding_inline_end);
        map.insert(BaseMetricId(1678), &super::use_counter_css_doc::css_scroll_padding_inline_start);
        map.insert(BaseMetricId(1679), &super::use_counter_css_doc::css_scroll_padding_left);
        map.insert(BaseMetricId(1680), &super::use_counter_css_doc::css_scroll_padding_right);
        map.insert(BaseMetricId(1681), &super::use_counter_css_doc::css_scroll_padding_top);
        map.insert(BaseMetricId(1682), &super::use_counter_css_doc::css_scroll_snap_align);
        map.insert(BaseMetricId(1683), &super::use_counter_css_doc::css_scroll_snap_stop);
        map.insert(BaseMetricId(1684), &super::use_counter_css_doc::css_scroll_snap_type);
        map.insert(BaseMetricId(1685), &super::use_counter_css_doc::css_scroll_timeline);
        map.insert(BaseMetricId(1686), &super::use_counter_css_doc::css_scroll_timeline_axis);
        map.insert(BaseMetricId(1687), &super::use_counter_css_doc::css_scroll_timeline_name);
        map.insert(BaseMetricId(1688), &super::use_counter_css_doc::css_scrollbar_color);
        map.insert(BaseMetricId(1689), &super::use_counter_css_doc::css_scrollbar_gutter);
        map.insert(BaseMetricId(1690), &super::use_counter_css_doc::css_scrollbar_width);
        map.insert(BaseMetricId(1691), &super::use_counter_css_doc::css_shape_image_threshold);
        map.insert(BaseMetricId(1692), &super::use_counter_css_doc::css_shape_margin);
        map.insert(BaseMetricId(1693), &super::use_counter_css_doc::css_shape_outside);
        map.insert(BaseMetricId(1694), &super::use_counter_css_doc::css_shape_rendering);
        map.insert(BaseMetricId(1695), &super::use_counter_css_doc::css_size);
        map.insert(BaseMetricId(1696), &super::use_counter_css_doc::css_stop_color);
        map.insert(BaseMetricId(1697), &super::use_counter_css_doc::css_stop_opacity);
        map.insert(BaseMetricId(1698), &super::use_counter_css_doc::css_stroke);
        map.insert(BaseMetricId(1699), &super::use_counter_css_doc::css_stroke_dasharray);
        map.insert(BaseMetricId(1700), &super::use_counter_css_doc::css_stroke_dashoffset);
        map.insert(BaseMetricId(1701), &super::use_counter_css_doc::css_stroke_linecap);
        map.insert(BaseMetricId(1702), &super::use_counter_css_doc::css_stroke_linejoin);
        map.insert(BaseMetricId(1703), &super::use_counter_css_doc::css_stroke_miterlimit);
        map.insert(BaseMetricId(1704), &super::use_counter_css_doc::css_stroke_opacity);
        map.insert(BaseMetricId(1705), &super::use_counter_css_doc::css_stroke_width);
        map.insert(BaseMetricId(1706), &super::use_counter_css_doc::css_tab_size);
        map.insert(BaseMetricId(1707), &super::use_counter_css_doc::css_table_layout);
        map.insert(BaseMetricId(1708), &super::use_counter_css_doc::css_text_align);
        map.insert(BaseMetricId(1709), &super::use_counter_css_doc::css_text_align_last);
        map.insert(BaseMetricId(1710), &super::use_counter_css_doc::css_text_anchor);
        map.insert(BaseMetricId(1711), &super::use_counter_css_doc::css_text_combine_upright);
        map.insert(BaseMetricId(1712), &super::use_counter_css_doc::css_text_decoration);
        map.insert(BaseMetricId(1713), &super::use_counter_css_doc::css_text_decoration_color);
        map.insert(BaseMetricId(1714), &super::use_counter_css_doc::css_text_decoration_line);
        map.insert(BaseMetricId(1715), &super::use_counter_css_doc::css_text_decoration_skip_ink);
        map.insert(BaseMetricId(1716), &super::use_counter_css_doc::css_text_decoration_style);
        map.insert(BaseMetricId(1717), &super::use_counter_css_doc::css_text_decoration_thickness);
        map.insert(BaseMetricId(1718), &super::use_counter_css_doc::css_text_emphasis);
        map.insert(BaseMetricId(1719), &super::use_counter_css_doc::css_text_emphasis_color);
        map.insert(BaseMetricId(1720), &super::use_counter_css_doc::css_text_emphasis_position);
        map.insert(BaseMetricId(1721), &super::use_counter_css_doc::css_text_emphasis_style);
        map.insert(BaseMetricId(1722), &super::use_counter_css_doc::css_text_indent);
        map.insert(BaseMetricId(1723), &super::use_counter_css_doc::css_text_justify);
        map.insert(BaseMetricId(1724), &super::use_counter_css_doc::css_text_orientation);
        map.insert(BaseMetricId(1725), &super::use_counter_css_doc::css_text_overflow);
        map.insert(BaseMetricId(1726), &super::use_counter_css_doc::css_text_rendering);
        map.insert(BaseMetricId(1727), &super::use_counter_css_doc::css_text_shadow);
        map.insert(BaseMetricId(1728), &super::use_counter_css_doc::css_text_transform);
        map.insert(BaseMetricId(1729), &super::use_counter_css_doc::css_text_underline_offset);
        map.insert(BaseMetricId(1730), &super::use_counter_css_doc::css_text_underline_position);
        map.insert(BaseMetricId(1731), &super::use_counter_css_doc::css_text_wrap);
        map.insert(BaseMetricId(1732), &super::use_counter_css_doc::css_text_wrap_mode);
        map.insert(BaseMetricId(1733), &super::use_counter_css_doc::css_text_wrap_style);
        map.insert(BaseMetricId(1734), &super::use_counter_css_doc::css_top);
        map.insert(BaseMetricId(1735), &super::use_counter_css_doc::css_touch_action);
        map.insert(BaseMetricId(1736), &super::use_counter_css_doc::css_transform);
        map.insert(BaseMetricId(1737), &super::use_counter_css_doc::css_transform_box);
        map.insert(BaseMetricId(1738), &super::use_counter_css_doc::css_transform_origin);
        map.insert(BaseMetricId(1739), &super::use_counter_css_doc::css_transform_style);
        map.insert(BaseMetricId(1740), &super::use_counter_css_doc::css_transition);
        map.insert(BaseMetricId(1741), &super::use_counter_css_doc::css_transition_behavior);
        map.insert(BaseMetricId(1742), &super::use_counter_css_doc::css_transition_delay);
        map.insert(BaseMetricId(1743), &super::use_counter_css_doc::css_transition_duration);
        map.insert(BaseMetricId(1744), &super::use_counter_css_doc::css_transition_property);
        map.insert(BaseMetricId(1745), &super::use_counter_css_doc::css_transition_timing_function);
        map.insert(BaseMetricId(1746), &super::use_counter_css_doc::css_translate);
        map.insert(BaseMetricId(1747), &super::use_counter_css_doc::css_unicode_bidi);
        map.insert(BaseMetricId(1748), &super::use_counter_css_doc::css_user_select);
        map.insert(BaseMetricId(1749), &super::use_counter_css_doc::css_vector_effect);
        map.insert(BaseMetricId(1750), &super::use_counter_css_doc::css_vertical_align);
        map.insert(BaseMetricId(1751), &super::use_counter_css_doc::css_view_timeline);
        map.insert(BaseMetricId(1752), &super::use_counter_css_doc::css_view_timeline_axis);
        map.insert(BaseMetricId(1753), &super::use_counter_css_doc::css_view_timeline_inset);
        map.insert(BaseMetricId(1754), &super::use_counter_css_doc::css_view_timeline_name);
        map.insert(BaseMetricId(1755), &super::use_counter_css_doc::css_view_transition_name);
        map.insert(BaseMetricId(1756), &super::use_counter_css_doc::css_visibility);
        map.insert(BaseMetricId(1757), &super::use_counter_css_doc::css_webkit_align_content);
        map.insert(BaseMetricId(1758), &super::use_counter_css_doc::css_webkit_align_items);
        map.insert(BaseMetricId(1759), &super::use_counter_css_doc::css_webkit_align_self);
        map.insert(BaseMetricId(1760), &super::use_counter_css_doc::css_webkit_animation);
        map.insert(BaseMetricId(1761), &super::use_counter_css_doc::css_webkit_animation_delay);
        map.insert(BaseMetricId(1762), &super::use_counter_css_doc::css_webkit_animation_direction);
        map.insert(BaseMetricId(1763), &super::use_counter_css_doc::css_webkit_animation_duration);
        map.insert(BaseMetricId(1764), &super::use_counter_css_doc::css_webkit_animation_fill_mode);
        map.insert(BaseMetricId(1765), &super::use_counter_css_doc::css_webkit_animation_iteration_count);
        map.insert(BaseMetricId(1766), &super::use_counter_css_doc::css_webkit_animation_name);
        map.insert(BaseMetricId(1767), &super::use_counter_css_doc::css_webkit_animation_play_state);
        map.insert(BaseMetricId(1768), &super::use_counter_css_doc::css_webkit_animation_timing_function);
        map.insert(BaseMetricId(1769), &super::use_counter_css_doc::css_webkit_appearance);
        map.insert(BaseMetricId(1770), &super::use_counter_css_doc::css_webkit_backface_visibility);
        map.insert(BaseMetricId(1771), &super::use_counter_css_doc::css_webkit_background_clip);
        map.insert(BaseMetricId(1772), &super::use_counter_css_doc::css_webkit_background_origin);
        map.insert(BaseMetricId(1773), &super::use_counter_css_doc::css_webkit_background_size);
        map.insert(BaseMetricId(1774), &super::use_counter_css_doc::css_webkit_border_bottom_left_radius);
        map.insert(BaseMetricId(1775), &super::use_counter_css_doc::css_webkit_border_bottom_right_radius);
        map.insert(BaseMetricId(1776), &super::use_counter_css_doc::css_webkit_border_image);
        map.insert(BaseMetricId(1777), &super::use_counter_css_doc::css_webkit_border_radius);
        map.insert(BaseMetricId(1778), &super::use_counter_css_doc::css_webkit_border_top_left_radius);
        map.insert(BaseMetricId(1779), &super::use_counter_css_doc::css_webkit_border_top_right_radius);
        map.insert(BaseMetricId(1780), &super::use_counter_css_doc::css_webkit_box_align);
        map.insert(BaseMetricId(1781), &super::use_counter_css_doc::css_webkit_box_direction);
        map.insert(BaseMetricId(1782), &super::use_counter_css_doc::css_webkit_box_flex);
        map.insert(BaseMetricId(1783), &super::use_counter_css_doc::css_webkit_box_ordinal_group);
        map.insert(BaseMetricId(1784), &super::use_counter_css_doc::css_webkit_box_orient);
        map.insert(BaseMetricId(1785), &super::use_counter_css_doc::css_webkit_box_pack);
        map.insert(BaseMetricId(1786), &super::use_counter_css_doc::css_webkit_box_shadow);
        map.insert(BaseMetricId(1787), &super::use_counter_css_doc::css_webkit_box_sizing);
        map.insert(BaseMetricId(1788), &super::use_counter_css_doc::css_webkit_clip_path);
        map.insert(BaseMetricId(1789), &super::use_counter_css_doc::css_webkit_filter);
        map.insert(BaseMetricId(1790), &super::use_counter_css_doc::css_webkit_flex);
        map.insert(BaseMetricId(1791), &super::use_counter_css_doc::css_webkit_flex_basis);
        map.insert(BaseMetricId(1792), &super::use_counter_css_doc::css_webkit_flex_direction);
        map.insert(BaseMetricId(1793), &super::use_counter_css_doc::css_webkit_flex_flow);
        map.insert(BaseMetricId(1794), &super::use_counter_css_doc::css_webkit_flex_grow);
        map.insert(BaseMetricId(1795), &super::use_counter_css_doc::css_webkit_flex_shrink);
        map.insert(BaseMetricId(1796), &super::use_counter_css_doc::css_webkit_flex_wrap);
        map.insert(BaseMetricId(1797), &super::use_counter_css_doc::css_webkit_font_feature_settings);
        map.insert(BaseMetricId(1798), &super::use_counter_css_doc::css_webkit_font_smoothing);
        map.insert(BaseMetricId(1799), &super::use_counter_css_doc::css_webkit_justify_content);
        map.insert(BaseMetricId(1800), &super::use_counter_css_doc::css_webkit_line_clamp);
        map.insert(BaseMetricId(1801), &super::use_counter_css_doc::css_webkit_mask);
        map.insert(BaseMetricId(1802), &super::use_counter_css_doc::css_webkit_mask_clip);
        map.insert(BaseMetricId(1803), &super::use_counter_css_doc::css_webkit_mask_composite);
        map.insert(BaseMetricId(1804), &super::use_counter_css_doc::css_webkit_mask_image);
        map.insert(BaseMetricId(1805), &super::use_counter_css_doc::css_webkit_mask_origin);
        map.insert(BaseMetricId(1806), &super::use_counter_css_doc::css_webkit_mask_position);
        map.insert(BaseMetricId(1807), &super::use_counter_css_doc::css_webkit_mask_position_x);
        map.insert(BaseMetricId(1808), &super::use_counter_css_doc::css_webkit_mask_position_y);
        map.insert(BaseMetricId(1809), &super::use_counter_css_doc::css_webkit_mask_repeat);
        map.insert(BaseMetricId(1810), &super::use_counter_css_doc::css_webkit_mask_size);
        map.insert(BaseMetricId(1811), &super::use_counter_css_doc::css_webkit_order);
        map.insert(BaseMetricId(1812), &super::use_counter_css_doc::css_webkit_perspective);
        map.insert(BaseMetricId(1813), &super::use_counter_css_doc::css_webkit_perspective_origin);
        map.insert(BaseMetricId(1814), &super::use_counter_css_doc::css_webkit_text_fill_color);
        map.insert(BaseMetricId(1815), &super::use_counter_css_doc::css_webkit_text_security);
        map.insert(BaseMetricId(1816), &super::use_counter_css_doc::css_webkit_text_size_adjust);
        map.insert(BaseMetricId(1817), &super::use_counter_css_doc::css_webkit_text_stroke);
        map.insert(BaseMetricId(1818), &super::use_counter_css_doc::css_webkit_text_stroke_color);
        map.insert(BaseMetricId(1819), &super::use_counter_css_doc::css_webkit_text_stroke_width);
        map.insert(BaseMetricId(1820), &super::use_counter_css_doc::css_webkit_transform);
        map.insert(BaseMetricId(1821), &super::use_counter_css_doc::css_webkit_transform_origin);
        map.insert(BaseMetricId(1822), &super::use_counter_css_doc::css_webkit_transform_style);
        map.insert(BaseMetricId(1823), &super::use_counter_css_doc::css_webkit_transition);
        map.insert(BaseMetricId(1824), &super::use_counter_css_doc::css_webkit_transition_delay);
        map.insert(BaseMetricId(1825), &super::use_counter_css_doc::css_webkit_transition_duration);
        map.insert(BaseMetricId(1826), &super::use_counter_css_doc::css_webkit_transition_property);
        map.insert(BaseMetricId(1827), &super::use_counter_css_doc::css_webkit_transition_timing_function);
        map.insert(BaseMetricId(1828), &super::use_counter_css_doc::css_webkit_user_select);
        map.insert(BaseMetricId(1829), &super::use_counter_css_doc::css_white_space);
        map.insert(BaseMetricId(1830), &super::use_counter_css_doc::css_white_space_collapse);
        map.insert(BaseMetricId(1831), &super::use_counter_css_doc::css_width);
        map.insert(BaseMetricId(1832), &super::use_counter_css_doc::css_will_change);
        map.insert(BaseMetricId(1833), &super::use_counter_css_doc::css_word_break);
        map.insert(BaseMetricId(1834), &super::use_counter_css_doc::css_word_spacing);
        map.insert(BaseMetricId(1835), &super::use_counter_css_doc::css_word_wrap);
        map.insert(BaseMetricId(1836), &super::use_counter_css_doc::css_writing_mode);
        map.insert(BaseMetricId(1837), &super::use_counter_css_doc::css_x);
        map.insert(BaseMetricId(1838), &super::use_counter_css_doc::css_x_lang);
        map.insert(BaseMetricId(1839), &super::use_counter_css_doc::css_x_span);
        map.insert(BaseMetricId(1840), &super::use_counter_css_doc::css_x_text_scale);
        map.insert(BaseMetricId(1841), &super::use_counter_css_doc::css_y);
        map.insert(BaseMetricId(1842), &super::use_counter_css_doc::css_z_index);
        map.insert(BaseMetricId(1843), &super::use_counter_css_doc::css_zoom);
        map.insert(BaseMetricId(1844), &super::use_counter_css_doc::max_zoom);
        map.insert(BaseMetricId(1845), &super::use_counter_css_doc::min_zoom);
        map.insert(BaseMetricId(1846), &super::use_counter_css_doc::orientation);
        map.insert(BaseMetricId(1847), &super::use_counter_css_doc::orphans);
        map.insert(BaseMetricId(1848), &super::use_counter_css_doc::speak);
        map.insert(BaseMetricId(1849), &super::use_counter_css_doc::text_size_adjust);
        map.insert(BaseMetricId(1850), &super::use_counter_css_doc::user_zoom);
        map.insert(BaseMetricId(1851), &super::use_counter_css_doc::webkit_app_region);
        map.insert(BaseMetricId(1852), &super::use_counter_css_doc::webkit_border_after);
        map.insert(BaseMetricId(1853), &super::use_counter_css_doc::webkit_border_after_color);
        map.insert(BaseMetricId(1854), &super::use_counter_css_doc::webkit_border_after_style);
        map.insert(BaseMetricId(1855), &super::use_counter_css_doc::webkit_border_after_width);
        map.insert(BaseMetricId(1856), &super::use_counter_css_doc::webkit_border_before);
        map.insert(BaseMetricId(1857), &super::use_counter_css_doc::webkit_border_before_color);
        map.insert(BaseMetricId(1858), &super::use_counter_css_doc::webkit_border_before_style);
        map.insert(BaseMetricId(1859), &super::use_counter_css_doc::webkit_border_before_width);
        map.insert(BaseMetricId(1860), &super::use_counter_css_doc::webkit_border_end);
        map.insert(BaseMetricId(1861), &super::use_counter_css_doc::webkit_border_end_color);
        map.insert(BaseMetricId(1862), &super::use_counter_css_doc::webkit_border_end_style);
        map.insert(BaseMetricId(1863), &super::use_counter_css_doc::webkit_border_end_width);
        map.insert(BaseMetricId(1864), &super::use_counter_css_doc::webkit_border_horizontal_spacing);
        map.insert(BaseMetricId(1865), &super::use_counter_css_doc::webkit_border_start);
        map.insert(BaseMetricId(1866), &super::use_counter_css_doc::webkit_border_start_color);
        map.insert(BaseMetricId(1867), &super::use_counter_css_doc::webkit_border_start_style);
        map.insert(BaseMetricId(1868), &super::use_counter_css_doc::webkit_border_start_width);
        map.insert(BaseMetricId(1869), &super::use_counter_css_doc::webkit_border_vertical_spacing);
        map.insert(BaseMetricId(1870), &super::use_counter_css_doc::webkit_box_decoration_break);
        map.insert(BaseMetricId(1871), &super::use_counter_css_doc::webkit_box_reflect);
        map.insert(BaseMetricId(1872), &super::use_counter_css_doc::webkit_column_break_after);
        map.insert(BaseMetricId(1873), &super::use_counter_css_doc::webkit_column_break_before);
        map.insert(BaseMetricId(1874), &super::use_counter_css_doc::webkit_column_break_inside);
        map.insert(BaseMetricId(1875), &super::use_counter_css_doc::webkit_column_count);
        map.insert(BaseMetricId(1876), &super::use_counter_css_doc::webkit_column_gap);
        map.insert(BaseMetricId(1877), &super::use_counter_css_doc::webkit_column_rule);
        map.insert(BaseMetricId(1878), &super::use_counter_css_doc::webkit_column_rule_color);
        map.insert(BaseMetricId(1879), &super::use_counter_css_doc::webkit_column_rule_style);
        map.insert(BaseMetricId(1880), &super::use_counter_css_doc::webkit_column_rule_width);
        map.insert(BaseMetricId(1881), &super::use_counter_css_doc::webkit_column_span);
        map.insert(BaseMetricId(1882), &super::use_counter_css_doc::webkit_column_width);
        map.insert(BaseMetricId(1883), &super::use_counter_css_doc::webkit_columns);
        map.insert(BaseMetricId(1884), &super::use_counter_css_doc::webkit_font_size_delta);
        map.insert(BaseMetricId(1885), &super::use_counter_css_doc::webkit_highlight);
        map.insert(BaseMetricId(1886), &super::use_counter_css_doc::webkit_hyphenate_character);
        map.insert(BaseMetricId(1887), &super::use_counter_css_doc::webkit_line_break);
        map.insert(BaseMetricId(1888), &super::use_counter_css_doc::webkit_locale);
        map.insert(BaseMetricId(1889), &super::use_counter_css_doc::webkit_logical_height);
        map.insert(BaseMetricId(1890), &super::use_counter_css_doc::webkit_logical_width);
        map.insert(BaseMetricId(1891), &super::use_counter_css_doc::webkit_margin_after);
        map.insert(BaseMetricId(1892), &super::use_counter_css_doc::webkit_margin_after_collapse);
        map.insert(BaseMetricId(1893), &super::use_counter_css_doc::webkit_margin_before);
        map.insert(BaseMetricId(1894), &super::use_counter_css_doc::webkit_margin_before_collapse);
        map.insert(BaseMetricId(1895), &super::use_counter_css_doc::webkit_margin_bottom_collapse);
        map.insert(BaseMetricId(1896), &super::use_counter_css_doc::webkit_margin_collapse);
        map.insert(BaseMetricId(1897), &super::use_counter_css_doc::webkit_margin_end);
        map.insert(BaseMetricId(1898), &super::use_counter_css_doc::webkit_margin_start);
        map.insert(BaseMetricId(1899), &super::use_counter_css_doc::webkit_margin_top_collapse);
        map.insert(BaseMetricId(1900), &super::use_counter_css_doc::webkit_mask_box_image);
        map.insert(BaseMetricId(1901), &super::use_counter_css_doc::webkit_mask_box_image_outset);
        map.insert(BaseMetricId(1902), &super::use_counter_css_doc::webkit_mask_box_image_repeat);
        map.insert(BaseMetricId(1903), &super::use_counter_css_doc::webkit_mask_box_image_slice);
        map.insert(BaseMetricId(1904), &super::use_counter_css_doc::webkit_mask_box_image_source);
        map.insert(BaseMetricId(1905), &super::use_counter_css_doc::webkit_mask_box_image_width);
        map.insert(BaseMetricId(1906), &super::use_counter_css_doc::webkit_mask_repeat_x);
        map.insert(BaseMetricId(1907), &super::use_counter_css_doc::webkit_mask_repeat_y);
        map.insert(BaseMetricId(1908), &super::use_counter_css_doc::webkit_max_logical_height);
        map.insert(BaseMetricId(1909), &super::use_counter_css_doc::webkit_max_logical_width);
        map.insert(BaseMetricId(1910), &super::use_counter_css_doc::webkit_min_logical_height);
        map.insert(BaseMetricId(1911), &super::use_counter_css_doc::webkit_min_logical_width);
        map.insert(BaseMetricId(1912), &super::use_counter_css_doc::webkit_opacity);
        map.insert(BaseMetricId(1913), &super::use_counter_css_doc::webkit_padding_after);
        map.insert(BaseMetricId(1914), &super::use_counter_css_doc::webkit_padding_before);
        map.insert(BaseMetricId(1915), &super::use_counter_css_doc::webkit_padding_end);
        map.insert(BaseMetricId(1916), &super::use_counter_css_doc::webkit_padding_start);
        map.insert(BaseMetricId(1917), &super::use_counter_css_doc::webkit_perspective_origin_x);
        map.insert(BaseMetricId(1918), &super::use_counter_css_doc::webkit_perspective_origin_y);
        map.insert(BaseMetricId(1919), &super::use_counter_css_doc::webkit_print_color_adjust);
        map.insert(BaseMetricId(1920), &super::use_counter_css_doc::webkit_rtl_ordering);
        map.insert(BaseMetricId(1921), &super::use_counter_css_doc::webkit_ruby_position);
        map.insert(BaseMetricId(1922), &super::use_counter_css_doc::webkit_shape_image_threshold);
        map.insert(BaseMetricId(1923), &super::use_counter_css_doc::webkit_shape_margin);
        map.insert(BaseMetricId(1924), &super::use_counter_css_doc::webkit_shape_outside);
        map.insert(BaseMetricId(1925), &super::use_counter_css_doc::webkit_tap_highlight_color);
        map.insert(BaseMetricId(1926), &super::use_counter_css_doc::webkit_text_combine);
        map.insert(BaseMetricId(1927), &super::use_counter_css_doc::webkit_text_decorations_in_effect);
        map.insert(BaseMetricId(1928), &super::use_counter_css_doc::webkit_text_emphasis);
        map.insert(BaseMetricId(1929), &super::use_counter_css_doc::webkit_text_emphasis_color);
        map.insert(BaseMetricId(1930), &super::use_counter_css_doc::webkit_text_emphasis_position);
        map.insert(BaseMetricId(1931), &super::use_counter_css_doc::webkit_text_emphasis_style);
        map.insert(BaseMetricId(1932), &super::use_counter_css_doc::webkit_text_orientation);
        map.insert(BaseMetricId(1933), &super::use_counter_css_doc::webkit_transform_origin_x);
        map.insert(BaseMetricId(1934), &super::use_counter_css_doc::webkit_transform_origin_y);
        map.insert(BaseMetricId(1935), &super::use_counter_css_doc::webkit_transform_origin_z);
        map.insert(BaseMetricId(1936), &super::use_counter_css_doc::webkit_user_drag);
        map.insert(BaseMetricId(1937), &super::use_counter_css_doc::webkit_user_modify);
        map.insert(BaseMetricId(1938), &super::use_counter_css_doc::webkit_writing_mode);
        map.insert(BaseMetricId(1939), &super::use_counter_css_doc::widows);
        map.insert(BaseMetricId(1940), &super::use_counter_css_page::alignment_baseline);
        map.insert(BaseMetricId(1941), &super::use_counter_css_page::background_repeat_x);
        map.insert(BaseMetricId(1942), &super::use_counter_css_page::background_repeat_y);
        map.insert(BaseMetricId(1943), &super::use_counter_css_page::baseline_shift);
        map.insert(BaseMetricId(1944), &super::use_counter_css_page::buffered_rendering);
        map.insert(BaseMetricId(1945), &super::use_counter_css_page::color_rendering);
        map.insert(BaseMetricId(1946), &super::use_counter_css_page::css_accent_color);
        map.insert(BaseMetricId(1947), &super::use_counter_css_page::css_align_content);
        map.insert(BaseMetricId(1948), &super::use_counter_css_page::css_align_items);
        map.insert(BaseMetricId(1949), &super::use_counter_css_page::css_align_self);
        map.insert(BaseMetricId(1950), &super::use_counter_css_page::css_all);
        map.insert(BaseMetricId(1951), &super::use_counter_css_page::css_anchor_name);
        map.insert(BaseMetricId(1952), &super::use_counter_css_page::css_anchor_scope);
        map.insert(BaseMetricId(1953), &super::use_counter_css_page::css_animation);
        map.insert(BaseMetricId(1954), &super::use_counter_css_page::css_animation_composition);
        map.insert(BaseMetricId(1955), &super::use_counter_css_page::css_animation_delay);
        map.insert(BaseMetricId(1956), &super::use_counter_css_page::css_animation_direction);
        map.insert(BaseMetricId(1957), &super::use_counter_css_page::css_animation_duration);
        map.insert(BaseMetricId(1958), &super::use_counter_css_page::css_animation_fill_mode);
        map.insert(BaseMetricId(1959), &super::use_counter_css_page::css_animation_iteration_count);
        map.insert(BaseMetricId(1960), &super::use_counter_css_page::css_animation_name);
        map.insert(BaseMetricId(1961), &super::use_counter_css_page::css_animation_play_state);
        map.insert(BaseMetricId(1962), &super::use_counter_css_page::css_animation_timeline);
        map.insert(BaseMetricId(1963), &super::use_counter_css_page::css_animation_timing_function);
        map.insert(BaseMetricId(1964), &super::use_counter_css_page::css_appearance);
        map.insert(BaseMetricId(1965), &super::use_counter_css_page::css_aspect_ratio);
        map.insert(BaseMetricId(1966), &super::use_counter_css_page::css_backdrop_filter);
        map.insert(BaseMetricId(1967), &super::use_counter_css_page::css_backface_visibility);
        map.insert(BaseMetricId(1968), &super::use_counter_css_page::css_background);
        map.insert(BaseMetricId(1969), &super::use_counter_css_page::css_background_attachment);
        map.insert(BaseMetricId(1970), &super::use_counter_css_page::css_background_blend_mode);
        map.insert(BaseMetricId(1971), &super::use_counter_css_page::css_background_clip);
        map.insert(BaseMetricId(1972), &super::use_counter_css_page::css_background_color);
        map.insert(BaseMetricId(1973), &super::use_counter_css_page::css_background_image);
        map.insert(BaseMetricId(1974), &super::use_counter_css_page::css_background_origin);
        map.insert(BaseMetricId(1975), &super::use_counter_css_page::css_background_position);
        map.insert(BaseMetricId(1976), &super::use_counter_css_page::css_background_position_x);
        map.insert(BaseMetricId(1977), &super::use_counter_css_page::css_background_position_y);
        map.insert(BaseMetricId(1978), &super::use_counter_css_page::css_background_repeat);
        map.insert(BaseMetricId(1979), &super::use_counter_css_page::css_background_size);
        map.insert(BaseMetricId(1980), &super::use_counter_css_page::css_baseline_source);
        map.insert(BaseMetricId(1981), &super::use_counter_css_page::css_block_size);
        map.insert(BaseMetricId(1982), &super::use_counter_css_page::css_border);
        map.insert(BaseMetricId(1983), &super::use_counter_css_page::css_border_block);
        map.insert(BaseMetricId(1984), &super::use_counter_css_page::css_border_block_color);
        map.insert(BaseMetricId(1985), &super::use_counter_css_page::css_border_block_end);
        map.insert(BaseMetricId(1986), &super::use_counter_css_page::css_border_block_end_color);
        map.insert(BaseMetricId(1987), &super::use_counter_css_page::css_border_block_end_style);
        map.insert(BaseMetricId(1988), &super::use_counter_css_page::css_border_block_end_width);
        map.insert(BaseMetricId(1989), &super::use_counter_css_page::css_border_block_start);
        map.insert(BaseMetricId(1990), &super::use_counter_css_page::css_border_block_start_color);
        map.insert(BaseMetricId(1991), &super::use_counter_css_page::css_border_block_start_style);
        map.insert(BaseMetricId(1992), &super::use_counter_css_page::css_border_block_start_width);
        map.insert(BaseMetricId(1993), &super::use_counter_css_page::css_border_block_style);
        map.insert(BaseMetricId(1994), &super::use_counter_css_page::css_border_block_width);
        map.insert(BaseMetricId(1995), &super::use_counter_css_page::css_border_bottom);
        map.insert(BaseMetricId(1996), &super::use_counter_css_page::css_border_bottom_color);
        map.insert(BaseMetricId(1997), &super::use_counter_css_page::css_border_bottom_left_radius);
        map.insert(BaseMetricId(1998), &super::use_counter_css_page::css_border_bottom_right_radius);
        map.insert(BaseMetricId(1999), &super::use_counter_css_page::css_border_bottom_style);
        map.insert(BaseMetricId(2000), &super::use_counter_css_page::css_border_bottom_width);
        map.insert(BaseMetricId(2001), &super::use_counter_css_page::css_border_collapse);
        map.insert(BaseMetricId(2002), &super::use_counter_css_page::css_border_color);
        map.insert(BaseMetricId(2003), &super::use_counter_css_page::css_border_end_end_radius);
        map.insert(BaseMetricId(2004), &super::use_counter_css_page::css_border_end_start_radius);
        map.insert(BaseMetricId(2005), &super::use_counter_css_page::css_border_image);
        map.insert(BaseMetricId(2006), &super::use_counter_css_page::css_border_image_outset);
        map.insert(BaseMetricId(2007), &super::use_counter_css_page::css_border_image_repeat);
        map.insert(BaseMetricId(2008), &super::use_counter_css_page::css_border_image_slice);
        map.insert(BaseMetricId(2009), &super::use_counter_css_page::css_border_image_source);
        map.insert(BaseMetricId(2010), &super::use_counter_css_page::css_border_image_width);
        map.insert(BaseMetricId(2011), &super::use_counter_css_page::css_border_inline);
        map.insert(BaseMetricId(2012), &super::use_counter_css_page::css_border_inline_color);
        map.insert(BaseMetricId(2013), &super::use_counter_css_page::css_border_inline_end);
        map.insert(BaseMetricId(2014), &super::use_counter_css_page::css_border_inline_end_color);
        map.insert(BaseMetricId(2015), &super::use_counter_css_page::css_border_inline_end_style);
        map.insert(BaseMetricId(2016), &super::use_counter_css_page::css_border_inline_end_width);
        map.insert(BaseMetricId(2017), &super::use_counter_css_page::css_border_inline_start);
        map.insert(BaseMetricId(2018), &super::use_counter_css_page::css_border_inline_start_color);
        map.insert(BaseMetricId(2019), &super::use_counter_css_page::css_border_inline_start_style);
        map.insert(BaseMetricId(2020), &super::use_counter_css_page::css_border_inline_start_width);
        map.insert(BaseMetricId(2021), &super::use_counter_css_page::css_border_inline_style);
        map.insert(BaseMetricId(2022), &super::use_counter_css_page::css_border_inline_width);
        map.insert(BaseMetricId(2023), &super::use_counter_css_page::css_border_left);
        map.insert(BaseMetricId(2024), &super::use_counter_css_page::css_border_left_color);
        map.insert(BaseMetricId(2025), &super::use_counter_css_page::css_border_left_style);
        map.insert(BaseMetricId(2026), &super::use_counter_css_page::css_border_left_width);
        map.insert(BaseMetricId(2027), &super::use_counter_css_page::css_border_radius);
        map.insert(BaseMetricId(2028), &super::use_counter_css_page::css_border_right);
        map.insert(BaseMetricId(2029), &super::use_counter_css_page::css_border_right_color);
        map.insert(BaseMetricId(2030), &super::use_counter_css_page::css_border_right_style);
        map.insert(BaseMetricId(2031), &super::use_counter_css_page::css_border_right_width);
        map.insert(BaseMetricId(2032), &super::use_counter_css_page::css_border_spacing);
        map.insert(BaseMetricId(2033), &super::use_counter_css_page::css_border_start_end_radius);
        map.insert(BaseMetricId(2034), &super::use_counter_css_page::css_border_start_start_radius);
        map.insert(BaseMetricId(2035), &super::use_counter_css_page::css_border_style);
        map.insert(BaseMetricId(2036), &super::use_counter_css_page::css_border_top);
        map.insert(BaseMetricId(2037), &super::use_counter_css_page::css_border_top_color);
        map.insert(BaseMetricId(2038), &super::use_counter_css_page::css_border_top_left_radius);
        map.insert(BaseMetricId(2039), &super::use_counter_css_page::css_border_top_right_radius);
        map.insert(BaseMetricId(2040), &super::use_counter_css_page::css_border_top_style);
        map.insert(BaseMetricId(2041), &super::use_counter_css_page::css_border_top_width);
        map.insert(BaseMetricId(2042), &super::use_counter_css_page::css_border_width);
        map.insert(BaseMetricId(2043), &super::use_counter_css_page::css_bottom);
        map.insert(BaseMetricId(2044), &super::use_counter_css_page::css_box_decoration_break);
        map.insert(BaseMetricId(2045), &super::use_counter_css_page::css_box_shadow);
        map.insert(BaseMetricId(2046), &super::use_counter_css_page::css_box_sizing);
        map.insert(BaseMetricId(2047), &super::use_counter_css_page::css_break_after);
        map.insert(BaseMetricId(2048), &super::use_counter_css_page::css_break_before);
        map.insert(BaseMetricId(2049), &super::use_counter_css_page::css_break_inside);
        map.insert(BaseMetricId(2050), &super::use_counter_css_page::css_caption_side);
        map.insert(BaseMetricId(2051), &super::use_counter_css_page::css_caret_color);
        map.insert(BaseMetricId(2052), &super::use_counter_css_page::css_clear);
        map.insert(BaseMetricId(2053), &super::use_counter_css_page::css_clip);
        map.insert(BaseMetricId(2054), &super::use_counter_css_page::css_clip_path);
        map.insert(BaseMetricId(2055), &super::use_counter_css_page::css_clip_rule);
        map.insert(BaseMetricId(2056), &super::use_counter_css_page::css_color);
        map.insert(BaseMetricId(2057), &super::use_counter_css_page::css_color_adjust);
        map.insert(BaseMetricId(2058), &super::use_counter_css_page::css_color_interpolation);
        map.insert(BaseMetricId(2059), &super::use_counter_css_page::css_color_interpolation_filters);
        map.insert(BaseMetricId(2060), &super::use_counter_css_page::css_color_scheme);
        map.insert(BaseMetricId(2061), &super::use_counter_css_page::css_column_count);
        map.insert(BaseMetricId(2062), &super::use_counter_css_page::css_column_fill);
        map.insert(BaseMetricId(2063), &super::use_counter_css_page::css_column_gap);
        map.insert(BaseMetricId(2064), &super::use_counter_css_page::css_column_rule);
        map.insert(BaseMetricId(2065), &super::use_counter_css_page::css_column_rule_color);
        map.insert(BaseMetricId(2066), &super::use_counter_css_page::css_column_rule_style);
        map.insert(BaseMetricId(2067), &super::use_counter_css_page::css_column_rule_width);
        map.insert(BaseMetricId(2068), &super::use_counter_css_page::css_column_span);
        map.insert(BaseMetricId(2069), &super::use_counter_css_page::css_column_width);
        map.insert(BaseMetricId(2070), &super::use_counter_css_page::css_columns);
        map.insert(BaseMetricId(2071), &super::use_counter_css_page::css_contain);
        map.insert(BaseMetricId(2072), &super::use_counter_css_page::css_contain_intrinsic_block_size);
        map.insert(BaseMetricId(2073), &super::use_counter_css_page::css_contain_intrinsic_height);
        map.insert(BaseMetricId(2074), &super::use_counter_css_page::css_contain_intrinsic_inline_size);
        map.insert(BaseMetricId(2075), &super::use_counter_css_page::css_contain_intrinsic_size);
        map.insert(BaseMetricId(2076), &super::use_counter_css_page::css_contain_intrinsic_width);
        map.insert(BaseMetricId(2077), &super::use_counter_css_page::css_container);
        map.insert(BaseMetricId(2078), &super::use_counter_css_page::css_container_name);
        map.insert(BaseMetricId(2079), &super::use_counter_css_page::css_container_type);
        map.insert(BaseMetricId(2080), &super::use_counter_css_page::css_content);
        map.insert(BaseMetricId(2081), &super::use_counter_css_page::css_content_visibility);
        map.insert(BaseMetricId(2082), &super::use_counter_css_page::css_counter_increment);
        map.insert(BaseMetricId(2083), &super::use_counter_css_page::css_counter_reset);
        map.insert(BaseMetricId(2084), &super::use_counter_css_page::css_counter_set);
        map.insert(BaseMetricId(2085), &super::use_counter_css_page::css_cursor);
        map.insert(BaseMetricId(2086), &super::use_counter_css_page::css_cx);
        map.insert(BaseMetricId(2087), &super::use_counter_css_page::css_cy);
        map.insert(BaseMetricId(2088), &super::use_counter_css_page::css_d);
        map.insert(BaseMetricId(2089), &super::use_counter_css_page::css_direction);
        map.insert(BaseMetricId(2090), &super::use_counter_css_page::css_display);
        map.insert(BaseMetricId(2091), &super::use_counter_css_page::css_dominant_baseline);
        map.insert(BaseMetricId(2092), &super::use_counter_css_page::css_empty_cells);
        map.insert(BaseMetricId(2093), &super::use_counter_css_page::css_field_sizing);
        map.insert(BaseMetricId(2094), &super::use_counter_css_page::css_fill);
        map.insert(BaseMetricId(2095), &super::use_counter_css_page::css_fill_opacity);
        map.insert(BaseMetricId(2096), &super::use_counter_css_page::css_fill_rule);
        map.insert(BaseMetricId(2097), &super::use_counter_css_page::css_filter);
        map.insert(BaseMetricId(2098), &super::use_counter_css_page::css_flex);
        map.insert(BaseMetricId(2099), &super::use_counter_css_page::css_flex_basis);
        map.insert(BaseMetricId(2100), &super::use_counter_css_page::css_flex_direction);
        map.insert(BaseMetricId(2101), &super::use_counter_css_page::css_flex_flow);
        map.insert(BaseMetricId(2102), &super::use_counter_css_page::css_flex_grow);
        map.insert(BaseMetricId(2103), &super::use_counter_css_page::css_flex_shrink);
        map.insert(BaseMetricId(2104), &super::use_counter_css_page::css_flex_wrap);
        map.insert(BaseMetricId(2105), &super::use_counter_css_page::css_float);
        map.insert(BaseMetricId(2106), &super::use_counter_css_page::css_flood_color);
        map.insert(BaseMetricId(2107), &super::use_counter_css_page::css_flood_opacity);
        map.insert(BaseMetricId(2108), &super::use_counter_css_page::css_font);
        map.insert(BaseMetricId(2109), &super::use_counter_css_page::css_font_family);
        map.insert(BaseMetricId(2110), &super::use_counter_css_page::css_font_feature_settings);
        map.insert(BaseMetricId(2111), &super::use_counter_css_page::css_font_kerning);
        map.insert(BaseMetricId(2112), &super::use_counter_css_page::css_font_language_override);
        map.insert(BaseMetricId(2113), &super::use_counter_css_page::css_font_optical_sizing);
        map.insert(BaseMetricId(2114), &super::use_counter_css_page::css_font_palette);
        map.insert(BaseMetricId(2115), &super::use_counter_css_page::css_font_size);
        map.insert(BaseMetricId(2116), &super::use_counter_css_page::css_font_size_adjust);
        map.insert(BaseMetricId(2117), &super::use_counter_css_page::css_font_stretch);
        map.insert(BaseMetricId(2118), &super::use_counter_css_page::css_font_style);
        map.insert(BaseMetricId(2119), &super::use_counter_css_page::css_font_synthesis);
        map.insert(BaseMetricId(2120), &super::use_counter_css_page::css_font_synthesis_position);
        map.insert(BaseMetricId(2121), &super::use_counter_css_page::css_font_synthesis_small_caps);
        map.insert(BaseMetricId(2122), &super::use_counter_css_page::css_font_synthesis_style);
        map.insert(BaseMetricId(2123), &super::use_counter_css_page::css_font_synthesis_weight);
        map.insert(BaseMetricId(2124), &super::use_counter_css_page::css_font_variant);
        map.insert(BaseMetricId(2125), &super::use_counter_css_page::css_font_variant_alternates);
        map.insert(BaseMetricId(2126), &super::use_counter_css_page::css_font_variant_caps);
        map.insert(BaseMetricId(2127), &super::use_counter_css_page::css_font_variant_east_asian);
        map.insert(BaseMetricId(2128), &super::use_counter_css_page::css_font_variant_emoji);
        map.insert(BaseMetricId(2129), &super::use_counter_css_page::css_font_variant_ligatures);
        map.insert(BaseMetricId(2130), &super::use_counter_css_page::css_font_variant_numeric);
        map.insert(BaseMetricId(2131), &super::use_counter_css_page::css_font_variant_position);
        map.insert(BaseMetricId(2132), &super::use_counter_css_page::css_font_variation_settings);
        map.insert(BaseMetricId(2133), &super::use_counter_css_page::css_font_weight);
        map.insert(BaseMetricId(2134), &super::use_counter_css_page::css_forced_color_adjust);
        map.insert(BaseMetricId(2135), &super::use_counter_css_page::css_gap);
        map.insert(BaseMetricId(2136), &super::use_counter_css_page::css_grid);
        map.insert(BaseMetricId(2137), &super::use_counter_css_page::css_grid_area);
        map.insert(BaseMetricId(2138), &super::use_counter_css_page::css_grid_auto_columns);
        map.insert(BaseMetricId(2139), &super::use_counter_css_page::css_grid_auto_flow);
        map.insert(BaseMetricId(2140), &super::use_counter_css_page::css_grid_auto_rows);
        map.insert(BaseMetricId(2141), &super::use_counter_css_page::css_grid_column);
        map.insert(BaseMetricId(2142), &super::use_counter_css_page::css_grid_column_end);
        map.insert(BaseMetricId(2143), &super::use_counter_css_page::css_grid_column_gap);
        map.insert(BaseMetricId(2144), &super::use_counter_css_page::css_grid_column_start);
        map.insert(BaseMetricId(2145), &super::use_counter_css_page::css_grid_gap);
        map.insert(BaseMetricId(2146), &super::use_counter_css_page::css_grid_row);
        map.insert(BaseMetricId(2147), &super::use_counter_css_page::css_grid_row_end);
        map.insert(BaseMetricId(2148), &super::use_counter_css_page::css_grid_row_gap);
        map.insert(BaseMetricId(2149), &super::use_counter_css_page::css_grid_row_start);
        map.insert(BaseMetricId(2150), &super::use_counter_css_page::css_grid_template);
        map.insert(BaseMetricId(2151), &super::use_counter_css_page::css_grid_template_areas);
        map.insert(BaseMetricId(2152), &super::use_counter_css_page::css_grid_template_columns);
        map.insert(BaseMetricId(2153), &super::use_counter_css_page::css_grid_template_rows);
        map.insert(BaseMetricId(2154), &super::use_counter_css_page::css_height);
        map.insert(BaseMetricId(2155), &super::use_counter_css_page::css_hyphenate_character);
        map.insert(BaseMetricId(2156), &super::use_counter_css_page::css_hyphenate_limit_chars);
        map.insert(BaseMetricId(2157), &super::use_counter_css_page::css_hyphens);
        map.insert(BaseMetricId(2158), &super::use_counter_css_page::css_image_orientation);
        map.insert(BaseMetricId(2159), &super::use_counter_css_page::css_image_rendering);
        map.insert(BaseMetricId(2160), &super::use_counter_css_page::css_ime_mode);
        map.insert(BaseMetricId(2161), &super::use_counter_css_page::css_initial_letter);
        map.insert(BaseMetricId(2162), &super::use_counter_css_page::css_inline_size);
        map.insert(BaseMetricId(2163), &super::use_counter_css_page::css_inset);
        map.insert(BaseMetricId(2164), &super::use_counter_css_page::css_inset_block);
        map.insert(BaseMetricId(2165), &super::use_counter_css_page::css_inset_block_end);
        map.insert(BaseMetricId(2166), &super::use_counter_css_page::css_inset_block_start);
        map.insert(BaseMetricId(2167), &super::use_counter_css_page::css_inset_inline);
        map.insert(BaseMetricId(2168), &super::use_counter_css_page::css_inset_inline_end);
        map.insert(BaseMetricId(2169), &super::use_counter_css_page::css_inset_inline_start);
        map.insert(BaseMetricId(2170), &super::use_counter_css_page::css_isolation);
        map.insert(BaseMetricId(2171), &super::use_counter_css_page::css_justify_content);
        map.insert(BaseMetricId(2172), &super::use_counter_css_page::css_justify_items);
        map.insert(BaseMetricId(2173), &super::use_counter_css_page::css_justify_self);
        map.insert(BaseMetricId(2174), &super::use_counter_css_page::css_left);
        map.insert(BaseMetricId(2175), &super::use_counter_css_page::css_letter_spacing);
        map.insert(BaseMetricId(2176), &super::use_counter_css_page::css_lighting_color);
        map.insert(BaseMetricId(2177), &super::use_counter_css_page::css_line_break);
        map.insert(BaseMetricId(2178), &super::use_counter_css_page::css_line_height);
        map.insert(BaseMetricId(2179), &super::use_counter_css_page::css_list_style);
        map.insert(BaseMetricId(2180), &super::use_counter_css_page::css_list_style_image);
        map.insert(BaseMetricId(2181), &super::use_counter_css_page::css_list_style_position);
        map.insert(BaseMetricId(2182), &super::use_counter_css_page::css_list_style_type);
        map.insert(BaseMetricId(2183), &super::use_counter_css_page::css_margin);
        map.insert(BaseMetricId(2184), &super::use_counter_css_page::css_margin_block);
        map.insert(BaseMetricId(2185), &super::use_counter_css_page::css_margin_block_end);
        map.insert(BaseMetricId(2186), &super::use_counter_css_page::css_margin_block_start);
        map.insert(BaseMetricId(2187), &super::use_counter_css_page::css_margin_bottom);
        map.insert(BaseMetricId(2188), &super::use_counter_css_page::css_margin_inline);
        map.insert(BaseMetricId(2189), &super::use_counter_css_page::css_margin_inline_end);
        map.insert(BaseMetricId(2190), &super::use_counter_css_page::css_margin_inline_start);
        map.insert(BaseMetricId(2191), &super::use_counter_css_page::css_margin_left);
        map.insert(BaseMetricId(2192), &super::use_counter_css_page::css_margin_right);
        map.insert(BaseMetricId(2193), &super::use_counter_css_page::css_margin_top);
        map.insert(BaseMetricId(2194), &super::use_counter_css_page::css_marker);
        map.insert(BaseMetricId(2195), &super::use_counter_css_page::css_marker_end);
        map.insert(BaseMetricId(2196), &super::use_counter_css_page::css_marker_mid);
        map.insert(BaseMetricId(2197), &super::use_counter_css_page::css_marker_start);
        map.insert(BaseMetricId(2198), &super::use_counter_css_page::css_mask);
        map.insert(BaseMetricId(2199), &super::use_counter_css_page::css_mask_clip);
        map.insert(BaseMetricId(2200), &super::use_counter_css_page::css_mask_composite);
        map.insert(BaseMetricId(2201), &super::use_counter_css_page::css_mask_image);
        map.insert(BaseMetricId(2202), &super::use_counter_css_page::css_mask_mode);
        map.insert(BaseMetricId(2203), &super::use_counter_css_page::css_mask_origin);
        map.insert(BaseMetricId(2204), &super::use_counter_css_page::css_mask_position);
        map.insert(BaseMetricId(2205), &super::use_counter_css_page::css_mask_position_x);
        map.insert(BaseMetricId(2206), &super::use_counter_css_page::css_mask_position_y);
        map.insert(BaseMetricId(2207), &super::use_counter_css_page::css_mask_repeat);
        map.insert(BaseMetricId(2208), &super::use_counter_css_page::css_mask_size);
        map.insert(BaseMetricId(2209), &super::use_counter_css_page::css_mask_type);
        map.insert(BaseMetricId(2210), &super::use_counter_css_page::css_masonry_auto_flow);
        map.insert(BaseMetricId(2211), &super::use_counter_css_page::css_math_depth);
        map.insert(BaseMetricId(2212), &super::use_counter_css_page::css_math_style);
        map.insert(BaseMetricId(2213), &super::use_counter_css_page::css_max_block_size);
        map.insert(BaseMetricId(2214), &super::use_counter_css_page::css_max_height);
        map.insert(BaseMetricId(2215), &super::use_counter_css_page::css_max_inline_size);
        map.insert(BaseMetricId(2216), &super::use_counter_css_page::css_max_width);
        map.insert(BaseMetricId(2217), &super::use_counter_css_page::css_min_block_size);
        map.insert(BaseMetricId(2218), &super::use_counter_css_page::css_min_height);
        map.insert(BaseMetricId(2219), &super::use_counter_css_page::css_min_inline_size);
        map.insert(BaseMetricId(2220), &super::use_counter_css_page::css_min_width);
        map.insert(BaseMetricId(2221), &super::use_counter_css_page::css_mix_blend_mode);
        map.insert(BaseMetricId(2222), &super::use_counter_css_page::css_moz_animation);
        map.insert(BaseMetricId(2223), &super::use_counter_css_page::css_moz_animation_delay);
        map.insert(BaseMetricId(2224), &super::use_counter_css_page::css_moz_animation_direction);
        map.insert(BaseMetricId(2225), &super::use_counter_css_page::css_moz_animation_duration);
        map.insert(BaseMetricId(2226), &super::use_counter_css_page::css_moz_animation_fill_mode);
        map.insert(BaseMetricId(2227), &super::use_counter_css_page::css_moz_animation_iteration_count);
        map.insert(BaseMetricId(2228), &super::use_counter_css_page::css_moz_animation_name);
        map.insert(BaseMetricId(2229), &super::use_counter_css_page::css_moz_animation_play_state);
        map.insert(BaseMetricId(2230), &super::use_counter_css_page::css_moz_animation_timing_function);
        map.insert(BaseMetricId(2231), &super::use_counter_css_page::css_moz_appearance);
        map.insert(BaseMetricId(2232), &super::use_counter_css_page::css_moz_backface_visibility);
        map.insert(BaseMetricId(2233), &super::use_counter_css_page::css_moz_border_end);
        map.insert(BaseMetricId(2234), &super::use_counter_css_page::css_moz_border_end_color);
        map.insert(BaseMetricId(2235), &super::use_counter_css_page::css_moz_border_end_style);
        map.insert(BaseMetricId(2236), &super::use_counter_css_page::css_moz_border_end_width);
        map.insert(BaseMetricId(2237), &super::use_counter_css_page::css_moz_border_image);
        map.insert(BaseMetricId(2238), &super::use_counter_css_page::css_moz_border_start);
        map.insert(BaseMetricId(2239), &super::use_counter_css_page::css_moz_border_start_color);
        map.insert(BaseMetricId(2240), &super::use_counter_css_page::css_moz_border_start_style);
        map.insert(BaseMetricId(2241), &super::use_counter_css_page::css_moz_border_start_width);
        map.insert(BaseMetricId(2242), &super::use_counter_css_page::css_moz_box_align);
        map.insert(BaseMetricId(2243), &super::use_counter_css_page::css_moz_box_collapse);
        map.insert(BaseMetricId(2244), &super::use_counter_css_page::css_moz_box_direction);
        map.insert(BaseMetricId(2245), &super::use_counter_css_page::css_moz_box_flex);
        map.insert(BaseMetricId(2246), &super::use_counter_css_page::css_moz_box_ordinal_group);
        map.insert(BaseMetricId(2247), &super::use_counter_css_page::css_moz_box_orient);
        map.insert(BaseMetricId(2248), &super::use_counter_css_page::css_moz_box_pack);
        map.insert(BaseMetricId(2249), &super::use_counter_css_page::css_moz_box_sizing);
        map.insert(BaseMetricId(2250), &super::use_counter_css_page::css_moz_context_properties);
        map.insert(BaseMetricId(2251), &super::use_counter_css_page::css_moz_control_character_visibility);
        map.insert(BaseMetricId(2252), &super::use_counter_css_page::css_moz_default_appearance);
        map.insert(BaseMetricId(2253), &super::use_counter_css_page::css_moz_float_edge);
        map.insert(BaseMetricId(2254), &super::use_counter_css_page::css_moz_font_feature_settings);
        map.insert(BaseMetricId(2255), &super::use_counter_css_page::css_moz_font_language_override);
        map.insert(BaseMetricId(2256), &super::use_counter_css_page::css_moz_force_broken_image_icon);
        map.insert(BaseMetricId(2257), &super::use_counter_css_page::css_moz_hyphens);
        map.insert(BaseMetricId(2258), &super::use_counter_css_page::css_moz_inert);
        map.insert(BaseMetricId(2259), &super::use_counter_css_page::css_moz_margin_end);
        map.insert(BaseMetricId(2260), &super::use_counter_css_page::css_moz_margin_start);
        map.insert(BaseMetricId(2261), &super::use_counter_css_page::css_moz_math_variant);
        map.insert(BaseMetricId(2262), &super::use_counter_css_page::css_moz_min_font_size_ratio);
        map.insert(BaseMetricId(2263), &super::use_counter_css_page::css_moz_orient);
        map.insert(BaseMetricId(2264), &super::use_counter_css_page::css_moz_osx_font_smoothing);
        map.insert(BaseMetricId(2265), &super::use_counter_css_page::css_moz_padding_end);
        map.insert(BaseMetricId(2266), &super::use_counter_css_page::css_moz_padding_start);
        map.insert(BaseMetricId(2267), &super::use_counter_css_page::css_moz_perspective);
        map.insert(BaseMetricId(2268), &super::use_counter_css_page::css_moz_perspective_origin);
        map.insert(BaseMetricId(2269), &super::use_counter_css_page::css_moz_subtree_hidden_only_visually);
        map.insert(BaseMetricId(2270), &super::use_counter_css_page::css_moz_tab_size);
        map.insert(BaseMetricId(2271), &super::use_counter_css_page::css_moz_text_size_adjust);
        map.insert(BaseMetricId(2272), &super::use_counter_css_page::css_moz_theme);
        map.insert(BaseMetricId(2273), &super::use_counter_css_page::css_moz_top_layer);
        map.insert(BaseMetricId(2274), &super::use_counter_css_page::css_moz_transform);
        map.insert(BaseMetricId(2275), &super::use_counter_css_page::css_moz_transform_origin);
        map.insert(BaseMetricId(2276), &super::use_counter_css_page::css_moz_transform_style);
        map.insert(BaseMetricId(2277), &super::use_counter_css_page::css_moz_transition);
        map.insert(BaseMetricId(2278), &super::use_counter_css_page::css_moz_transition_delay);
        map.insert(BaseMetricId(2279), &super::use_counter_css_page::css_moz_transition_duration);
        map.insert(BaseMetricId(2280), &super::use_counter_css_page::css_moz_transition_property);
        map.insert(BaseMetricId(2281), &super::use_counter_css_page::css_moz_transition_timing_function);
        map.insert(BaseMetricId(2282), &super::use_counter_css_page::css_moz_user_focus);
        map.insert(BaseMetricId(2283), &super::use_counter_css_page::css_moz_user_input);
        map.insert(BaseMetricId(2284), &super::use_counter_css_page::css_moz_user_select);
        map.insert(BaseMetricId(2285), &super::use_counter_css_page::css_moz_window_dragging);
        map.insert(BaseMetricId(2286), &super::use_counter_css_page::css_moz_window_input_region_margin);
        map.insert(BaseMetricId(2287), &super::use_counter_css_page::css_moz_window_opacity);
        map.insert(BaseMetricId(2288), &super::use_counter_css_page::css_moz_window_shadow);
        map.insert(BaseMetricId(2289), &super::use_counter_css_page::css_moz_window_transform);
        map.insert(BaseMetricId(2290), &super::use_counter_css_page::css_object_fit);
        map.insert(BaseMetricId(2291), &super::use_counter_css_page::css_object_position);
        map.insert(BaseMetricId(2292), &super::use_counter_css_page::css_offset);
        map.insert(BaseMetricId(2293), &super::use_counter_css_page::css_offset_anchor);
        map.insert(BaseMetricId(2294), &super::use_counter_css_page::css_offset_distance);
        map.insert(BaseMetricId(2295), &super::use_counter_css_page::css_offset_path);
        map.insert(BaseMetricId(2296), &super::use_counter_css_page::css_offset_position);
        map.insert(BaseMetricId(2297), &super::use_counter_css_page::css_offset_rotate);
        map.insert(BaseMetricId(2298), &super::use_counter_css_page::css_opacity);
        map.insert(BaseMetricId(2299), &super::use_counter_css_page::css_order);
        map.insert(BaseMetricId(2300), &super::use_counter_css_page::css_outline);
        map.insert(BaseMetricId(2301), &super::use_counter_css_page::css_outline_color);
        map.insert(BaseMetricId(2302), &super::use_counter_css_page::css_outline_offset);
        map.insert(BaseMetricId(2303), &super::use_counter_css_page::css_outline_style);
        map.insert(BaseMetricId(2304), &super::use_counter_css_page::css_outline_width);
        map.insert(BaseMetricId(2305), &super::use_counter_css_page::css_overflow);
        map.insert(BaseMetricId(2306), &super::use_counter_css_page::css_overflow_anchor);
        map.insert(BaseMetricId(2307), &super::use_counter_css_page::css_overflow_block);
        map.insert(BaseMetricId(2308), &super::use_counter_css_page::css_overflow_clip_box);
        map.insert(BaseMetricId(2309), &super::use_counter_css_page::css_overflow_clip_box_block);
        map.insert(BaseMetricId(2310), &super::use_counter_css_page::css_overflow_clip_box_inline);
        map.insert(BaseMetricId(2311), &super::use_counter_css_page::css_overflow_clip_margin);
        map.insert(BaseMetricId(2312), &super::use_counter_css_page::css_overflow_inline);
        map.insert(BaseMetricId(2313), &super::use_counter_css_page::css_overflow_wrap);
        map.insert(BaseMetricId(2314), &super::use_counter_css_page::css_overflow_x);
        map.insert(BaseMetricId(2315), &super::use_counter_css_page::css_overflow_y);
        map.insert(BaseMetricId(2316), &super::use_counter_css_page::css_overscroll_behavior);
        map.insert(BaseMetricId(2317), &super::use_counter_css_page::css_overscroll_behavior_block);
        map.insert(BaseMetricId(2318), &super::use_counter_css_page::css_overscroll_behavior_inline);
        map.insert(BaseMetricId(2319), &super::use_counter_css_page::css_overscroll_behavior_x);
        map.insert(BaseMetricId(2320), &super::use_counter_css_page::css_overscroll_behavior_y);
        map.insert(BaseMetricId(2321), &super::use_counter_css_page::css_padding);
        map.insert(BaseMetricId(2322), &super::use_counter_css_page::css_padding_block);
        map.insert(BaseMetricId(2323), &super::use_counter_css_page::css_padding_block_end);
        map.insert(BaseMetricId(2324), &super::use_counter_css_page::css_padding_block_start);
        map.insert(BaseMetricId(2325), &super::use_counter_css_page::css_padding_bottom);
        map.insert(BaseMetricId(2326), &super::use_counter_css_page::css_padding_inline);
        map.insert(BaseMetricId(2327), &super::use_counter_css_page::css_padding_inline_end);
        map.insert(BaseMetricId(2328), &super::use_counter_css_page::css_padding_inline_start);
        map.insert(BaseMetricId(2329), &super::use_counter_css_page::css_padding_left);
        map.insert(BaseMetricId(2330), &super::use_counter_css_page::css_padding_right);
        map.insert(BaseMetricId(2331), &super::use_counter_css_page::css_padding_top);
        map.insert(BaseMetricId(2332), &super::use_counter_css_page::css_page);
        map.insert(BaseMetricId(2333), &super::use_counter_css_page::css_page_break_after);
        map.insert(BaseMetricId(2334), &super::use_counter_css_page::css_page_break_before);
        map.insert(BaseMetricId(2335), &super::use_counter_css_page::css_page_break_inside);
        map.insert(BaseMetricId(2336), &super::use_counter_css_page::css_page_orientation);
        map.insert(BaseMetricId(2337), &super::use_counter_css_page::css_paint_order);
        map.insert(BaseMetricId(2338), &super::use_counter_css_page::css_perspective);
        map.insert(BaseMetricId(2339), &super::use_counter_css_page::css_perspective_origin);
        map.insert(BaseMetricId(2340), &super::use_counter_css_page::css_place_content);
        map.insert(BaseMetricId(2341), &super::use_counter_css_page::css_place_items);
        map.insert(BaseMetricId(2342), &super::use_counter_css_page::css_place_self);
        map.insert(BaseMetricId(2343), &super::use_counter_css_page::css_pointer_events);
        map.insert(BaseMetricId(2344), &super::use_counter_css_page::css_position);
        map.insert(BaseMetricId(2345), &super::use_counter_css_page::css_position_anchor);
        map.insert(BaseMetricId(2346), &super::use_counter_css_page::css_position_area);
        map.insert(BaseMetricId(2347), &super::use_counter_css_page::css_position_try);
        map.insert(BaseMetricId(2348), &super::use_counter_css_page::css_position_try_fallbacks);
        map.insert(BaseMetricId(2349), &super::use_counter_css_page::css_position_try_order);
        map.insert(BaseMetricId(2350), &super::use_counter_css_page::css_position_visibility);
        map.insert(BaseMetricId(2351), &super::use_counter_css_page::css_print_color_adjust);
        map.insert(BaseMetricId(2352), &super::use_counter_css_page::css_quotes);
        map.insert(BaseMetricId(2353), &super::use_counter_css_page::css_r);
        map.insert(BaseMetricId(2354), &super::use_counter_css_page::css_resize);
        map.insert(BaseMetricId(2355), &super::use_counter_css_page::css_right);
        map.insert(BaseMetricId(2356), &super::use_counter_css_page::css_rotate);
        map.insert(BaseMetricId(2357), &super::use_counter_css_page::css_row_gap);
        map.insert(BaseMetricId(2358), &super::use_counter_css_page::css_ruby_align);
        map.insert(BaseMetricId(2359), &super::use_counter_css_page::css_ruby_position);
        map.insert(BaseMetricId(2360), &super::use_counter_css_page::css_rx);
        map.insert(BaseMetricId(2361), &super::use_counter_css_page::css_ry);
        map.insert(BaseMetricId(2362), &super::use_counter_css_page::css_scale);
        map.insert(BaseMetricId(2363), &super::use_counter_css_page::css_scroll_behavior);
        map.insert(BaseMetricId(2364), &super::use_counter_css_page::css_scroll_margin);
        map.insert(BaseMetricId(2365), &super::use_counter_css_page::css_scroll_margin_block);
        map.insert(BaseMetricId(2366), &super::use_counter_css_page::css_scroll_margin_block_end);
        map.insert(BaseMetricId(2367), &super::use_counter_css_page::css_scroll_margin_block_start);
        map.insert(BaseMetricId(2368), &super::use_counter_css_page::css_scroll_margin_bottom);
        map.insert(BaseMetricId(2369), &super::use_counter_css_page::css_scroll_margin_inline);
        map.insert(BaseMetricId(2370), &super::use_counter_css_page::css_scroll_margin_inline_end);
        map.insert(BaseMetricId(2371), &super::use_counter_css_page::css_scroll_margin_inline_start);
        map.insert(BaseMetricId(2372), &super::use_counter_css_page::css_scroll_margin_left);
        map.insert(BaseMetricId(2373), &super::use_counter_css_page::css_scroll_margin_right);
        map.insert(BaseMetricId(2374), &super::use_counter_css_page::css_scroll_margin_top);
        map.insert(BaseMetricId(2375), &super::use_counter_css_page::css_scroll_padding);
        map.insert(BaseMetricId(2376), &super::use_counter_css_page::css_scroll_padding_block);
        map.insert(BaseMetricId(2377), &super::use_counter_css_page::css_scroll_padding_block_end);
        map.insert(BaseMetricId(2378), &super::use_counter_css_page::css_scroll_padding_block_start);
        map.insert(BaseMetricId(2379), &super::use_counter_css_page::css_scroll_padding_bottom);
        map.insert(BaseMetricId(2380), &super::use_counter_css_page::css_scroll_padding_inline);
        map.insert(BaseMetricId(2381), &super::use_counter_css_page::css_scroll_padding_inline_end);
        map.insert(BaseMetricId(2382), &super::use_counter_css_page::css_scroll_padding_inline_start);
        map.insert(BaseMetricId(2383), &super::use_counter_css_page::css_scroll_padding_left);
        map.insert(BaseMetricId(2384), &super::use_counter_css_page::css_scroll_padding_right);
        map.insert(BaseMetricId(2385), &super::use_counter_css_page::css_scroll_padding_top);
        map.insert(BaseMetricId(2386), &super::use_counter_css_page::css_scroll_snap_align);
        map.insert(BaseMetricId(2387), &super::use_counter_css_page::css_scroll_snap_stop);
        map.insert(BaseMetricId(2388), &super::use_counter_css_page::css_scroll_snap_type);
        map.insert(BaseMetricId(2389), &super::use_counter_css_page::css_scroll_timeline);
        map.insert(BaseMetricId(2390), &super::use_counter_css_page::css_scroll_timeline_axis);
        map.insert(BaseMetricId(2391), &super::use_counter_css_page::css_scroll_timeline_name);
        map.insert(BaseMetricId(2392), &super::use_counter_css_page::css_scrollbar_color);
        map.insert(BaseMetricId(2393), &super::use_counter_css_page::css_scrollbar_gutter);
        map.insert(BaseMetricId(2394), &super::use_counter_css_page::css_scrollbar_width);
        map.insert(BaseMetricId(2395), &super::use_counter_css_page::css_shape_image_threshold);
        map.insert(BaseMetricId(2396), &super::use_counter_css_page::css_shape_margin);
        map.insert(BaseMetricId(2397), &super::use_counter_css_page::css_shape_outside);
        map.insert(BaseMetricId(2398), &super::use_counter_css_page::css_shape_rendering);
        map.insert(BaseMetricId(2399), &super::use_counter_css_page::css_size);
        map.insert(BaseMetricId(2400), &super::use_counter_css_page::css_stop_color);
        map.insert(BaseMetricId(2401), &super::use_counter_css_page::css_stop_opacity);
        map.insert(BaseMetricId(2402), &super::use_counter_css_page::css_stroke);
        map.insert(BaseMetricId(2403), &super::use_counter_css_page::css_stroke_dasharray);
        map.insert(BaseMetricId(2404), &super::use_counter_css_page::css_stroke_dashoffset);
        map.insert(BaseMetricId(2405), &super::use_counter_css_page::css_stroke_linecap);
        map.insert(BaseMetricId(2406), &super::use_counter_css_page::css_stroke_linejoin);
        map.insert(BaseMetricId(2407), &super::use_counter_css_page::css_stroke_miterlimit);
        map.insert(BaseMetricId(2408), &super::use_counter_css_page::css_stroke_opacity);
        map.insert(BaseMetricId(2409), &super::use_counter_css_page::css_stroke_width);
        map.insert(BaseMetricId(2410), &super::use_counter_css_page::css_tab_size);
        map.insert(BaseMetricId(2411), &super::use_counter_css_page::css_table_layout);
        map.insert(BaseMetricId(2412), &super::use_counter_css_page::css_text_align);
        map.insert(BaseMetricId(2413), &super::use_counter_css_page::css_text_align_last);
        map.insert(BaseMetricId(2414), &super::use_counter_css_page::css_text_anchor);
        map.insert(BaseMetricId(2415), &super::use_counter_css_page::css_text_combine_upright);
        map.insert(BaseMetricId(2416), &super::use_counter_css_page::css_text_decoration);
        map.insert(BaseMetricId(2417), &super::use_counter_css_page::css_text_decoration_color);
        map.insert(BaseMetricId(2418), &super::use_counter_css_page::css_text_decoration_line);
        map.insert(BaseMetricId(2419), &super::use_counter_css_page::css_text_decoration_skip_ink);
        map.insert(BaseMetricId(2420), &super::use_counter_css_page::css_text_decoration_style);
        map.insert(BaseMetricId(2421), &super::use_counter_css_page::css_text_decoration_thickness);
        map.insert(BaseMetricId(2422), &super::use_counter_css_page::css_text_emphasis);
        map.insert(BaseMetricId(2423), &super::use_counter_css_page::css_text_emphasis_color);
        map.insert(BaseMetricId(2424), &super::use_counter_css_page::css_text_emphasis_position);
        map.insert(BaseMetricId(2425), &super::use_counter_css_page::css_text_emphasis_style);
        map.insert(BaseMetricId(2426), &super::use_counter_css_page::css_text_indent);
        map.insert(BaseMetricId(2427), &super::use_counter_css_page::css_text_justify);
        map.insert(BaseMetricId(2428), &super::use_counter_css_page::css_text_orientation);
        map.insert(BaseMetricId(2429), &super::use_counter_css_page::css_text_overflow);
        map.insert(BaseMetricId(2430), &super::use_counter_css_page::css_text_rendering);
        map.insert(BaseMetricId(2431), &super::use_counter_css_page::css_text_shadow);
        map.insert(BaseMetricId(2432), &super::use_counter_css_page::css_text_transform);
        map.insert(BaseMetricId(2433), &super::use_counter_css_page::css_text_underline_offset);
        map.insert(BaseMetricId(2434), &super::use_counter_css_page::css_text_underline_position);
        map.insert(BaseMetricId(2435), &super::use_counter_css_page::css_text_wrap);
        map.insert(BaseMetricId(2436), &super::use_counter_css_page::css_text_wrap_mode);
        map.insert(BaseMetricId(2437), &super::use_counter_css_page::css_text_wrap_style);
        map.insert(BaseMetricId(2438), &super::use_counter_css_page::css_top);
        map.insert(BaseMetricId(2439), &super::use_counter_css_page::css_touch_action);
        map.insert(BaseMetricId(2440), &super::use_counter_css_page::css_transform);
        map.insert(BaseMetricId(2441), &super::use_counter_css_page::css_transform_box);
        map.insert(BaseMetricId(2442), &super::use_counter_css_page::css_transform_origin);
        map.insert(BaseMetricId(2443), &super::use_counter_css_page::css_transform_style);
        map.insert(BaseMetricId(2444), &super::use_counter_css_page::css_transition);
        map.insert(BaseMetricId(2445), &super::use_counter_css_page::css_transition_behavior);
        map.insert(BaseMetricId(2446), &super::use_counter_css_page::css_transition_delay);
        map.insert(BaseMetricId(2447), &super::use_counter_css_page::css_transition_duration);
        map.insert(BaseMetricId(2448), &super::use_counter_css_page::css_transition_property);
        map.insert(BaseMetricId(2449), &super::use_counter_css_page::css_transition_timing_function);
        map.insert(BaseMetricId(2450), &super::use_counter_css_page::css_translate);
        map.insert(BaseMetricId(2451), &super::use_counter_css_page::css_unicode_bidi);
        map.insert(BaseMetricId(2452), &super::use_counter_css_page::css_user_select);
        map.insert(BaseMetricId(2453), &super::use_counter_css_page::css_vector_effect);
        map.insert(BaseMetricId(2454), &super::use_counter_css_page::css_vertical_align);
        map.insert(BaseMetricId(2455), &super::use_counter_css_page::css_view_timeline);
        map.insert(BaseMetricId(2456), &super::use_counter_css_page::css_view_timeline_axis);
        map.insert(BaseMetricId(2457), &super::use_counter_css_page::css_view_timeline_inset);
        map.insert(BaseMetricId(2458), &super::use_counter_css_page::css_view_timeline_name);
        map.insert(BaseMetricId(2459), &super::use_counter_css_page::css_view_transition_name);
        map.insert(BaseMetricId(2460), &super::use_counter_css_page::css_visibility);
        map.insert(BaseMetricId(2461), &super::use_counter_css_page::css_webkit_align_content);
        map.insert(BaseMetricId(2462), &super::use_counter_css_page::css_webkit_align_items);
        map.insert(BaseMetricId(2463), &super::use_counter_css_page::css_webkit_align_self);
        map.insert(BaseMetricId(2464), &super::use_counter_css_page::css_webkit_animation);
        map.insert(BaseMetricId(2465), &super::use_counter_css_page::css_webkit_animation_delay);
        map.insert(BaseMetricId(2466), &super::use_counter_css_page::css_webkit_animation_direction);
        map.insert(BaseMetricId(2467), &super::use_counter_css_page::css_webkit_animation_duration);
        map.insert(BaseMetricId(2468), &super::use_counter_css_page::css_webkit_animation_fill_mode);
        map.insert(BaseMetricId(2469), &super::use_counter_css_page::css_webkit_animation_iteration_count);
        map.insert(BaseMetricId(2470), &super::use_counter_css_page::css_webkit_animation_name);
        map.insert(BaseMetricId(2471), &super::use_counter_css_page::css_webkit_animation_play_state);
        map.insert(BaseMetricId(2472), &super::use_counter_css_page::css_webkit_animation_timing_function);
        map.insert(BaseMetricId(2473), &super::use_counter_css_page::css_webkit_appearance);
        map.insert(BaseMetricId(2474), &super::use_counter_css_page::css_webkit_backface_visibility);
        map.insert(BaseMetricId(2475), &super::use_counter_css_page::css_webkit_background_clip);
        map.insert(BaseMetricId(2476), &super::use_counter_css_page::css_webkit_background_origin);
        map.insert(BaseMetricId(2477), &super::use_counter_css_page::css_webkit_background_size);
        map.insert(BaseMetricId(2478), &super::use_counter_css_page::css_webkit_border_bottom_left_radius);
        map.insert(BaseMetricId(2479), &super::use_counter_css_page::css_webkit_border_bottom_right_radius);
        map.insert(BaseMetricId(2480), &super::use_counter_css_page::css_webkit_border_image);
        map.insert(BaseMetricId(2481), &super::use_counter_css_page::css_webkit_border_radius);
        map.insert(BaseMetricId(2482), &super::use_counter_css_page::css_webkit_border_top_left_radius);
        map.insert(BaseMetricId(2483), &super::use_counter_css_page::css_webkit_border_top_right_radius);
        map.insert(BaseMetricId(2484), &super::use_counter_css_page::css_webkit_box_align);
        map.insert(BaseMetricId(2485), &super::use_counter_css_page::css_webkit_box_direction);
        map.insert(BaseMetricId(2486), &super::use_counter_css_page::css_webkit_box_flex);
        map.insert(BaseMetricId(2487), &super::use_counter_css_page::css_webkit_box_ordinal_group);
        map.insert(BaseMetricId(2488), &super::use_counter_css_page::css_webkit_box_orient);
        map.insert(BaseMetricId(2489), &super::use_counter_css_page::css_webkit_box_pack);
        map.insert(BaseMetricId(2490), &super::use_counter_css_page::css_webkit_box_shadow);
        map.insert(BaseMetricId(2491), &super::use_counter_css_page::css_webkit_box_sizing);
        map.insert(BaseMetricId(2492), &super::use_counter_css_page::css_webkit_clip_path);
        map.insert(BaseMetricId(2493), &super::use_counter_css_page::css_webkit_filter);
        map.insert(BaseMetricId(2494), &super::use_counter_css_page::css_webkit_flex);
        map.insert(BaseMetricId(2495), &super::use_counter_css_page::css_webkit_flex_basis);
        map.insert(BaseMetricId(2496), &super::use_counter_css_page::css_webkit_flex_direction);
        map.insert(BaseMetricId(2497), &super::use_counter_css_page::css_webkit_flex_flow);
        map.insert(BaseMetricId(2498), &super::use_counter_css_page::css_webkit_flex_grow);
        map.insert(BaseMetricId(2499), &super::use_counter_css_page::css_webkit_flex_shrink);
        map.insert(BaseMetricId(2500), &super::use_counter_css_page::css_webkit_flex_wrap);
        map.insert(BaseMetricId(2501), &super::use_counter_css_page::css_webkit_font_feature_settings);
        map.insert(BaseMetricId(2502), &super::use_counter_css_page::css_webkit_font_smoothing);
        map.insert(BaseMetricId(2503), &super::use_counter_css_page::css_webkit_justify_content);
        map.insert(BaseMetricId(2504), &super::use_counter_css_page::css_webkit_line_clamp);
        map.insert(BaseMetricId(2505), &super::use_counter_css_page::css_webkit_mask);
        map.insert(BaseMetricId(2506), &super::use_counter_css_page::css_webkit_mask_clip);
        map.insert(BaseMetricId(2507), &super::use_counter_css_page::css_webkit_mask_composite);
        map.insert(BaseMetricId(2508), &super::use_counter_css_page::css_webkit_mask_image);
        map.insert(BaseMetricId(2509), &super::use_counter_css_page::css_webkit_mask_origin);
        map.insert(BaseMetricId(2510), &super::use_counter_css_page::css_webkit_mask_position);
        map.insert(BaseMetricId(2511), &super::use_counter_css_page::css_webkit_mask_position_x);
        map.insert(BaseMetricId(2512), &super::use_counter_css_page::css_webkit_mask_position_y);
        map.insert(BaseMetricId(2513), &super::use_counter_css_page::css_webkit_mask_repeat);
        map.insert(BaseMetricId(2514), &super::use_counter_css_page::css_webkit_mask_size);
        map.insert(BaseMetricId(2515), &super::use_counter_css_page::css_webkit_order);
        map.insert(BaseMetricId(2516), &super::use_counter_css_page::css_webkit_perspective);
        map.insert(BaseMetricId(2517), &super::use_counter_css_page::css_webkit_perspective_origin);
        map.insert(BaseMetricId(2518), &super::use_counter_css_page::css_webkit_text_fill_color);
        map.insert(BaseMetricId(2519), &super::use_counter_css_page::css_webkit_text_security);
        map.insert(BaseMetricId(2520), &super::use_counter_css_page::css_webkit_text_size_adjust);
        map.insert(BaseMetricId(2521), &super::use_counter_css_page::css_webkit_text_stroke);
        map.insert(BaseMetricId(2522), &super::use_counter_css_page::css_webkit_text_stroke_color);
        map.insert(BaseMetricId(2523), &super::use_counter_css_page::css_webkit_text_stroke_width);
        map.insert(BaseMetricId(2524), &super::use_counter_css_page::css_webkit_transform);
        map.insert(BaseMetricId(2525), &super::use_counter_css_page::css_webkit_transform_origin);
        map.insert(BaseMetricId(2526), &super::use_counter_css_page::css_webkit_transform_style);
        map.insert(BaseMetricId(2527), &super::use_counter_css_page::css_webkit_transition);
        map.insert(BaseMetricId(2528), &super::use_counter_css_page::css_webkit_transition_delay);
        map.insert(BaseMetricId(2529), &super::use_counter_css_page::css_webkit_transition_duration);
        map.insert(BaseMetricId(2530), &super::use_counter_css_page::css_webkit_transition_property);
        map.insert(BaseMetricId(2531), &super::use_counter_css_page::css_webkit_transition_timing_function);
        map.insert(BaseMetricId(2532), &super::use_counter_css_page::css_webkit_user_select);
        map.insert(BaseMetricId(2533), &super::use_counter_css_page::css_white_space);
        map.insert(BaseMetricId(2534), &super::use_counter_css_page::css_white_space_collapse);
        map.insert(BaseMetricId(2535), &super::use_counter_css_page::css_width);
        map.insert(BaseMetricId(2536), &super::use_counter_css_page::css_will_change);
        map.insert(BaseMetricId(2537), &super::use_counter_css_page::css_word_break);
        map.insert(BaseMetricId(2538), &super::use_counter_css_page::css_word_spacing);
        map.insert(BaseMetricId(2539), &super::use_counter_css_page::css_word_wrap);
        map.insert(BaseMetricId(2540), &super::use_counter_css_page::css_writing_mode);
        map.insert(BaseMetricId(2541), &super::use_counter_css_page::css_x);
        map.insert(BaseMetricId(2542), &super::use_counter_css_page::css_x_lang);
        map.insert(BaseMetricId(2543), &super::use_counter_css_page::css_x_span);
        map.insert(BaseMetricId(2544), &super::use_counter_css_page::css_x_text_scale);
        map.insert(BaseMetricId(2545), &super::use_counter_css_page::css_y);
        map.insert(BaseMetricId(2546), &super::use_counter_css_page::css_z_index);
        map.insert(BaseMetricId(2547), &super::use_counter_css_page::css_zoom);
        map.insert(BaseMetricId(2548), &super::use_counter_css_page::max_zoom);
        map.insert(BaseMetricId(2549), &super::use_counter_css_page::min_zoom);
        map.insert(BaseMetricId(2550), &super::use_counter_css_page::orientation);
        map.insert(BaseMetricId(2551), &super::use_counter_css_page::orphans);
        map.insert(BaseMetricId(2552), &super::use_counter_css_page::speak);
        map.insert(BaseMetricId(2553), &super::use_counter_css_page::text_size_adjust);
        map.insert(BaseMetricId(2554), &super::use_counter_css_page::user_zoom);
        map.insert(BaseMetricId(2555), &super::use_counter_css_page::webkit_app_region);
        map.insert(BaseMetricId(2556), &super::use_counter_css_page::webkit_border_after);
        map.insert(BaseMetricId(2557), &super::use_counter_css_page::webkit_border_after_color);
        map.insert(BaseMetricId(2558), &super::use_counter_css_page::webkit_border_after_style);
        map.insert(BaseMetricId(2559), &super::use_counter_css_page::webkit_border_after_width);
        map.insert(BaseMetricId(2560), &super::use_counter_css_page::webkit_border_before);
        map.insert(BaseMetricId(2561), &super::use_counter_css_page::webkit_border_before_color);
        map.insert(BaseMetricId(2562), &super::use_counter_css_page::webkit_border_before_style);
        map.insert(BaseMetricId(2563), &super::use_counter_css_page::webkit_border_before_width);
        map.insert(BaseMetricId(2564), &super::use_counter_css_page::webkit_border_end);
        map.insert(BaseMetricId(2565), &super::use_counter_css_page::webkit_border_end_color);
        map.insert(BaseMetricId(2566), &super::use_counter_css_page::webkit_border_end_style);
        map.insert(BaseMetricId(2567), &super::use_counter_css_page::webkit_border_end_width);
        map.insert(BaseMetricId(2568), &super::use_counter_css_page::webkit_border_horizontal_spacing);
        map.insert(BaseMetricId(2569), &super::use_counter_css_page::webkit_border_start);
        map.insert(BaseMetricId(2570), &super::use_counter_css_page::webkit_border_start_color);
        map.insert(BaseMetricId(2571), &super::use_counter_css_page::webkit_border_start_style);
        map.insert(BaseMetricId(2572), &super::use_counter_css_page::webkit_border_start_width);
        map.insert(BaseMetricId(2573), &super::use_counter_css_page::webkit_border_vertical_spacing);
        map.insert(BaseMetricId(2574), &super::use_counter_css_page::webkit_box_decoration_break);
        map.insert(BaseMetricId(2575), &super::use_counter_css_page::webkit_box_reflect);
        map.insert(BaseMetricId(2576), &super::use_counter_css_page::webkit_column_break_after);
        map.insert(BaseMetricId(2577), &super::use_counter_css_page::webkit_column_break_before);
        map.insert(BaseMetricId(2578), &super::use_counter_css_page::webkit_column_break_inside);
        map.insert(BaseMetricId(2579), &super::use_counter_css_page::webkit_column_count);
        map.insert(BaseMetricId(2580), &super::use_counter_css_page::webkit_column_gap);
        map.insert(BaseMetricId(2581), &super::use_counter_css_page::webkit_column_rule);
        map.insert(BaseMetricId(2582), &super::use_counter_css_page::webkit_column_rule_color);
        map.insert(BaseMetricId(2583), &super::use_counter_css_page::webkit_column_rule_style);
        map.insert(BaseMetricId(2584), &super::use_counter_css_page::webkit_column_rule_width);
        map.insert(BaseMetricId(2585), &super::use_counter_css_page::webkit_column_span);
        map.insert(BaseMetricId(2586), &super::use_counter_css_page::webkit_column_width);
        map.insert(BaseMetricId(2587), &super::use_counter_css_page::webkit_columns);
        map.insert(BaseMetricId(2588), &super::use_counter_css_page::webkit_font_size_delta);
        map.insert(BaseMetricId(2589), &super::use_counter_css_page::webkit_highlight);
        map.insert(BaseMetricId(2590), &super::use_counter_css_page::webkit_hyphenate_character);
        map.insert(BaseMetricId(2591), &super::use_counter_css_page::webkit_line_break);
        map.insert(BaseMetricId(2592), &super::use_counter_css_page::webkit_locale);
        map.insert(BaseMetricId(2593), &super::use_counter_css_page::webkit_logical_height);
        map.insert(BaseMetricId(2594), &super::use_counter_css_page::webkit_logical_width);
        map.insert(BaseMetricId(2595), &super::use_counter_css_page::webkit_margin_after);
        map.insert(BaseMetricId(2596), &super::use_counter_css_page::webkit_margin_after_collapse);
        map.insert(BaseMetricId(2597), &super::use_counter_css_page::webkit_margin_before);
        map.insert(BaseMetricId(2598), &super::use_counter_css_page::webkit_margin_before_collapse);
        map.insert(BaseMetricId(2599), &super::use_counter_css_page::webkit_margin_bottom_collapse);
        map.insert(BaseMetricId(2600), &super::use_counter_css_page::webkit_margin_collapse);
        map.insert(BaseMetricId(2601), &super::use_counter_css_page::webkit_margin_end);
        map.insert(BaseMetricId(2602), &super::use_counter_css_page::webkit_margin_start);
        map.insert(BaseMetricId(2603), &super::use_counter_css_page::webkit_margin_top_collapse);
        map.insert(BaseMetricId(2604), &super::use_counter_css_page::webkit_mask_box_image);
        map.insert(BaseMetricId(2605), &super::use_counter_css_page::webkit_mask_box_image_outset);
        map.insert(BaseMetricId(2606), &super::use_counter_css_page::webkit_mask_box_image_repeat);
        map.insert(BaseMetricId(2607), &super::use_counter_css_page::webkit_mask_box_image_slice);
        map.insert(BaseMetricId(2608), &super::use_counter_css_page::webkit_mask_box_image_source);
        map.insert(BaseMetricId(2609), &super::use_counter_css_page::webkit_mask_box_image_width);
        map.insert(BaseMetricId(2610), &super::use_counter_css_page::webkit_mask_repeat_x);
        map.insert(BaseMetricId(2611), &super::use_counter_css_page::webkit_mask_repeat_y);
        map.insert(BaseMetricId(2612), &super::use_counter_css_page::webkit_max_logical_height);
        map.insert(BaseMetricId(2613), &super::use_counter_css_page::webkit_max_logical_width);
        map.insert(BaseMetricId(2614), &super::use_counter_css_page::webkit_min_logical_height);
        map.insert(BaseMetricId(2615), &super::use_counter_css_page::webkit_min_logical_width);
        map.insert(BaseMetricId(2616), &super::use_counter_css_page::webkit_opacity);
        map.insert(BaseMetricId(2617), &super::use_counter_css_page::webkit_padding_after);
        map.insert(BaseMetricId(2618), &super::use_counter_css_page::webkit_padding_before);
        map.insert(BaseMetricId(2619), &super::use_counter_css_page::webkit_padding_end);
        map.insert(BaseMetricId(2620), &super::use_counter_css_page::webkit_padding_start);
        map.insert(BaseMetricId(2621), &super::use_counter_css_page::webkit_perspective_origin_x);
        map.insert(BaseMetricId(2622), &super::use_counter_css_page::webkit_perspective_origin_y);
        map.insert(BaseMetricId(2623), &super::use_counter_css_page::webkit_print_color_adjust);
        map.insert(BaseMetricId(2624), &super::use_counter_css_page::webkit_rtl_ordering);
        map.insert(BaseMetricId(2625), &super::use_counter_css_page::webkit_ruby_position);
        map.insert(BaseMetricId(2626), &super::use_counter_css_page::webkit_shape_image_threshold);
        map.insert(BaseMetricId(2627), &super::use_counter_css_page::webkit_shape_margin);
        map.insert(BaseMetricId(2628), &super::use_counter_css_page::webkit_shape_outside);
        map.insert(BaseMetricId(2629), &super::use_counter_css_page::webkit_tap_highlight_color);
        map.insert(BaseMetricId(2630), &super::use_counter_css_page::webkit_text_combine);
        map.insert(BaseMetricId(2631), &super::use_counter_css_page::webkit_text_decorations_in_effect);
        map.insert(BaseMetricId(2632), &super::use_counter_css_page::webkit_text_emphasis);
        map.insert(BaseMetricId(2633), &super::use_counter_css_page::webkit_text_emphasis_color);
        map.insert(BaseMetricId(2634), &super::use_counter_css_page::webkit_text_emphasis_position);
        map.insert(BaseMetricId(2635), &super::use_counter_css_page::webkit_text_emphasis_style);
        map.insert(BaseMetricId(2636), &super::use_counter_css_page::webkit_text_orientation);
        map.insert(BaseMetricId(2637), &super::use_counter_css_page::webkit_transform_origin_x);
        map.insert(BaseMetricId(2638), &super::use_counter_css_page::webkit_transform_origin_y);
        map.insert(BaseMetricId(2639), &super::use_counter_css_page::webkit_transform_origin_z);
        map.insert(BaseMetricId(2640), &super::use_counter_css_page::webkit_user_drag);
        map.insert(BaseMetricId(2641), &super::use_counter_css_page::webkit_user_modify);
        map.insert(BaseMetricId(2642), &super::use_counter_css_page::webkit_writing_mode);
        map.insert(BaseMetricId(2643), &super::use_counter_css_page::widows);
        map.insert(BaseMetricId(2644), &super::use_counter_deprecated_ops_doc::after_script_execute_event);
        map.insert(BaseMetricId(2645), &super::use_counter_deprecated_ops_doc::ambient_light_event);
        map.insert(BaseMetricId(2646), &super::use_counter_deprecated_ops_doc::app_cache);
        map.insert(BaseMetricId(2647), &super::use_counter_deprecated_ops_doc::before_script_execute_event);
        map.insert(BaseMetricId(2648), &super::use_counter_deprecated_ops_doc::components);
        map.insert(BaseMetricId(2649), &super::use_counter_deprecated_ops_doc::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(BaseMetricId(2650), &super::use_counter_deprecated_ops_doc::deprecated_testing_attribute);
        map.insert(BaseMetricId(2651), &super::use_counter_deprecated_ops_doc::deprecated_testing_interface);
        map.insert(BaseMetricId(2652), &super::use_counter_deprecated_ops_doc::deprecated_testing_method);
        map.insert(BaseMetricId(2653), &super::use_counter_deprecated_ops_doc::document_release_capture);
        map.insert(BaseMetricId(2654), &super::use_counter_deprecated_ops_doc::domattr_modified);
        map.insert(BaseMetricId(2655), &super::use_counter_deprecated_ops_doc::domcharacter_data_modified);
        map.insert(BaseMetricId(2656), &super::use_counter_deprecated_ops_doc::domnode_inserted);
        map.insert(BaseMetricId(2657), &super::use_counter_deprecated_ops_doc::domnode_inserted_into_document);
        map.insert(BaseMetricId(2658), &super::use_counter_deprecated_ops_doc::domnode_removed);
        map.insert(BaseMetricId(2659), &super::use_counter_deprecated_ops_doc::domnode_removed_from_document);
        map.insert(BaseMetricId(2660), &super::use_counter_deprecated_ops_doc::domquad_bounds_attr);
        map.insert(BaseMetricId(2661), &super::use_counter_deprecated_ops_doc::domsubtree_modified);
        map.insert(BaseMetricId(2662), &super::use_counter_deprecated_ops_doc::draw_window_canvas_rendering_context2_d);
        map.insert(BaseMetricId(2663), &super::use_counter_deprecated_ops_doc::element_release_capture);
        map.insert(BaseMetricId(2664), &super::use_counter_deprecated_ops_doc::element_set_capture);
        map.insert(BaseMetricId(2665), &super::use_counter_deprecated_ops_doc::external__add_search_provider);
        map.insert(BaseMetricId(2666), &super::use_counter_deprecated_ops_doc::form_submission_untrusted_event);
        map.insert(BaseMetricId(2667), &super::use_counter_deprecated_ops_doc::idbobject_store_create_index_locale);
        map.insert(BaseMetricId(2668), &super::use_counter_deprecated_ops_doc::idbopen_dboptions__storage_type);
        map.insert(BaseMetricId(2669), &super::use_counter_deprecated_ops_doc::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(BaseMetricId(2670), &super::use_counter_deprecated_ops_doc::import_xulinto_content);
        map.insert(BaseMetricId(2671), &super::use_counter_deprecated_ops_doc::init_mouse_event);
        map.insert(BaseMetricId(2672), &super::use_counter_deprecated_ops_doc::init_nsmouse_event);
        map.insert(BaseMetricId(2673), &super::use_counter_deprecated_ops_doc::install_trigger_deprecated);
        map.insert(BaseMetricId(2674), &super::use_counter_deprecated_ops_doc::install_trigger_install_deprecated);
        map.insert(BaseMetricId(2675), &super::use_counter_deprecated_ops_doc::lenient_setter);
        map.insert(BaseMetricId(2676), &super::use_counter_deprecated_ops_doc::lenient_this);
        map.insert(BaseMetricId(2677), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_space_value2);
        map.insert(BaseMetricId(2678), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_math_variant);
        map.insert(BaseMetricId(2679), &super::use_counter_deprecated_ops_doc::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(BaseMetricId(2680), &super::use_counter_deprecated_ops_doc::motion_event);
        map.insert(BaseMetricId(2681), &super::use_counter_deprecated_ops_doc::mouse_event__moz_pressure);
        map.insert(BaseMetricId(2682), &super::use_counter_deprecated_ops_doc::moz_input_source);
        map.insert(BaseMetricId(2683), &super::use_counter_deprecated_ops_doc::moz_request_full_screen_deprecated_prefix);
        map.insert(BaseMetricId(2684), &super::use_counter_deprecated_ops_doc::mozfullscreenchange_deprecated_prefix);
        map.insert(BaseMetricId(2685), &super::use_counter_deprecated_ops_doc::mozfullscreenerror_deprecated_prefix);
        map.insert(BaseMetricId(2686), &super::use_counter_deprecated_ops_doc::navigator_get_user_media);
        map.insert(BaseMetricId(2687), &super::use_counter_deprecated_ops_doc::node_iterator_detach);
        map.insert(BaseMetricId(2688), &super::use_counter_deprecated_ops_doc::offscreen_canvas_to_blob);
        map.insert(BaseMetricId(2689), &super::use_counter_deprecated_ops_doc::orientation_event);
        map.insert(BaseMetricId(2690), &super::use_counter_deprecated_ops_doc::proximity_event);
        map.insert(BaseMetricId(2691), &super::use_counter_deprecated_ops_doc::rtcpeer_connection_get_streams);
        map.insert(BaseMetricId(2692), &super::use_counter_deprecated_ops_doc::svgdeselect_all);
        map.insert(BaseMetricId(2693), &super::use_counter_deprecated_ops_doc::svgfarthest_viewport_element);
        map.insert(BaseMetricId(2694), &super::use_counter_deprecated_ops_doc::svgnearest_viewport_element);
        map.insert(BaseMetricId(2695), &super::use_counter_deprecated_ops_doc::sync_xmlhttp_request_deprecated);
        map.insert(BaseMetricId(2696), &super::use_counter_deprecated_ops_doc::use_of_capture_events);
        map.insert(BaseMetricId(2697), &super::use_counter_deprecated_ops_doc::use_of_release_events);
        map.insert(BaseMetricId(2698), &super::use_counter_deprecated_ops_doc::webrtc_deprecated_prefix);
        map.insert(BaseMetricId(2699), &super::use_counter_deprecated_ops_doc::window__cc_ontrollers);
        map.insert(BaseMetricId(2700), &super::use_counter_deprecated_ops_doc::window_content_untrusted);
        map.insert(BaseMetricId(2701), &super::use_counter_deprecated_ops_page::after_script_execute_event);
        map.insert(BaseMetricId(2702), &super::use_counter_deprecated_ops_page::ambient_light_event);
        map.insert(BaseMetricId(2703), &super::use_counter_deprecated_ops_page::app_cache);
        map.insert(BaseMetricId(2704), &super::use_counter_deprecated_ops_page::before_script_execute_event);
        map.insert(BaseMetricId(2705), &super::use_counter_deprecated_ops_page::components);
        map.insert(BaseMetricId(2706), &super::use_counter_deprecated_ops_page::create_image_bitmap_canvas_rendering_context2_d);
        map.insert(BaseMetricId(2707), &super::use_counter_deprecated_ops_page::deprecated_testing_attribute);
        map.insert(BaseMetricId(2708), &super::use_counter_deprecated_ops_page::deprecated_testing_interface);
        map.insert(BaseMetricId(2709), &super::use_counter_deprecated_ops_page::deprecated_testing_method);
        map.insert(BaseMetricId(2710), &super::use_counter_deprecated_ops_page::document_release_capture);
        map.insert(BaseMetricId(2711), &super::use_counter_deprecated_ops_page::domattr_modified);
        map.insert(BaseMetricId(2712), &super::use_counter_deprecated_ops_page::domcharacter_data_modified);
        map.insert(BaseMetricId(2713), &super::use_counter_deprecated_ops_page::domnode_inserted);
        map.insert(BaseMetricId(2714), &super::use_counter_deprecated_ops_page::domnode_inserted_into_document);
        map.insert(BaseMetricId(2715), &super::use_counter_deprecated_ops_page::domnode_removed);
        map.insert(BaseMetricId(2716), &super::use_counter_deprecated_ops_page::domnode_removed_from_document);
        map.insert(BaseMetricId(2717), &super::use_counter_deprecated_ops_page::domquad_bounds_attr);
        map.insert(BaseMetricId(2718), &super::use_counter_deprecated_ops_page::domsubtree_modified);
        map.insert(BaseMetricId(2719), &super::use_counter_deprecated_ops_page::draw_window_canvas_rendering_context2_d);
        map.insert(BaseMetricId(2720), &super::use_counter_deprecated_ops_page::element_release_capture);
        map.insert(BaseMetricId(2721), &super::use_counter_deprecated_ops_page::element_set_capture);
        map.insert(BaseMetricId(2722), &super::use_counter_deprecated_ops_page::external__add_search_provider);
        map.insert(BaseMetricId(2723), &super::use_counter_deprecated_ops_page::form_submission_untrusted_event);
        map.insert(BaseMetricId(2724), &super::use_counter_deprecated_ops_page::idbobject_store_create_index_locale);
        map.insert(BaseMetricId(2725), &super::use_counter_deprecated_ops_page::idbopen_dboptions__storage_type);
        map.insert(BaseMetricId(2726), &super::use_counter_deprecated_ops_page::image_bitmap_rendering_context__transfer_image_bitmap);
        map.insert(BaseMetricId(2727), &super::use_counter_deprecated_ops_page::import_xulinto_content);
        map.insert(BaseMetricId(2728), &super::use_counter_deprecated_ops_page::init_mouse_event);
        map.insert(BaseMetricId(2729), &super::use_counter_deprecated_ops_page::init_nsmouse_event);
        map.insert(BaseMetricId(2730), &super::use_counter_deprecated_ops_page::install_trigger_deprecated);
        map.insert(BaseMetricId(2731), &super::use_counter_deprecated_ops_page::install_trigger_install_deprecated);
        map.insert(BaseMetricId(2732), &super::use_counter_deprecated_ops_page::lenient_setter);
        map.insert(BaseMetricId(2733), &super::use_counter_deprecated_ops_page::lenient_this);
        map.insert(BaseMetricId(2734), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_space_value2);
        map.insert(BaseMetricId(2735), &super::use_counter_deprecated_ops_page::math_ml__deprecated_math_variant);
        map.insert(BaseMetricId(2736), &super::use_counter_deprecated_ops_page::math_ml__deprecated_stixgeneral_operator_stretching);
        map.insert(BaseMetricId(2737), &super::use_counter_deprecated_ops_page::motion_event);
        map.insert(BaseMetricId(2738), &super::use_counter_deprecated_ops_page::mouse_event__moz_pressure);
        map.insert(BaseMetricId(2739), &super::use_counter_deprecated_ops_page::moz_input_source);
        map.insert(BaseMetricId(2740), &super::use_counter_deprecated_ops_page::moz_request_full_screen_deprecated_prefix);
        map.insert(BaseMetricId(2741), &super::use_counter_deprecated_ops_page::mozfullscreenchange_deprecated_prefix);
        map.insert(BaseMetricId(2742), &super::use_counter_deprecated_ops_page::mozfullscreenerror_deprecated_prefix);
        map.insert(BaseMetricId(2743), &super::use_counter_deprecated_ops_page::navigator_get_user_media);
        map.insert(BaseMetricId(2744), &super::use_counter_deprecated_ops_page::node_iterator_detach);
        map.insert(BaseMetricId(2745), &super::use_counter_deprecated_ops_page::offscreen_canvas_to_blob);
        map.insert(BaseMetricId(2746), &super::use_counter_deprecated_ops_page::orientation_event);
        map.insert(BaseMetricId(2747), &super::use_counter_deprecated_ops_page::proximity_event);
        map.insert(BaseMetricId(2748), &super::use_counter_deprecated_ops_page::rtcpeer_connection_get_streams);
        map.insert(BaseMetricId(2749), &super::use_counter_deprecated_ops_page::svgdeselect_all);
        map.insert(BaseMetricId(2750), &super::use_counter_deprecated_ops_page::svgfarthest_viewport_element);
        map.insert(BaseMetricId(2751), &super::use_counter_deprecated_ops_page::svgnearest_viewport_element);
        map.insert(BaseMetricId(2752), &super::use_counter_deprecated_ops_page::sync_xmlhttp_request_deprecated);
        map.insert(BaseMetricId(2753), &super::use_counter_deprecated_ops_page::use_of_capture_events);
        map.insert(BaseMetricId(2754), &super::use_counter_deprecated_ops_page::use_of_release_events);
        map.insert(BaseMetricId(2755), &super::use_counter_deprecated_ops_page::webrtc_deprecated_prefix);
        map.insert(BaseMetricId(2756), &super::use_counter_deprecated_ops_page::window__cc_ontrollers);
        map.insert(BaseMetricId(2757), &super::use_counter_deprecated_ops_page::window_content_untrusted);
        map.insert(BaseMetricId(2758), &super::use_counter_doc::animation_commitstyles);
        map.insert(BaseMetricId(2759), &super::use_counter_doc::commit_styles_non_filling_final_value);
        map.insert(BaseMetricId(2760), &super::use_counter_doc::components_shim_resolved);
        map.insert(BaseMetricId(2761), &super::use_counter_doc::console_assert);
        map.insert(BaseMetricId(2762), &super::use_counter_doc::console_clear);
        map.insert(BaseMetricId(2763), &super::use_counter_doc::console_count);
        map.insert(BaseMetricId(2764), &super::use_counter_doc::console_countreset);
        map.insert(BaseMetricId(2765), &super::use_counter_doc::console_debug);
        map.insert(BaseMetricId(2766), &super::use_counter_doc::console_dir);
        map.insert(BaseMetricId(2767), &super::use_counter_doc::console_dirxml);
        map.insert(BaseMetricId(2768), &super::use_counter_doc::console_error);
        map.insert(BaseMetricId(2769), &super::use_counter_doc::console_exception);
        map.insert(BaseMetricId(2770), &super::use_counter_doc::console_group);
        map.insert(BaseMetricId(2771), &super::use_counter_doc::console_groupcollapsed);
        map.insert(BaseMetricId(2772), &super::use_counter_doc::console_groupend);
        map.insert(BaseMetricId(2773), &super::use_counter_doc::console_info);
        map.insert(BaseMetricId(2774), &super::use_counter_doc::console_log);
        map.insert(BaseMetricId(2775), &super::use_counter_doc::console_profile);
        map.insert(BaseMetricId(2776), &super::use_counter_doc::console_profileend);
        map.insert(BaseMetricId(2777), &super::use_counter_doc::console_table);
        map.insert(BaseMetricId(2778), &super::use_counter_doc::console_time);
        map.insert(BaseMetricId(2779), &super::use_counter_doc::console_timeend);
        map.insert(BaseMetricId(2780), &super::use_counter_doc::console_timelog);
        map.insert(BaseMetricId(2781), &super::use_counter_doc::console_timestamp);
        map.insert(BaseMetricId(2782), &super::use_counter_doc::console_trace);
        map.insert(BaseMetricId(2783), &super::use_counter_doc::console_warn);
        map.insert(BaseMetricId(2784), &super::use_counter_doc::cookiestore_delete);
        map.insert(BaseMetricId(2785), &super::use_counter_doc::cookiestore_get);
        map.insert(BaseMetricId(2786), &super::use_counter_doc::cookiestore_getall);
        map.insert(BaseMetricId(2787), &super::use_counter_doc::cookiestore_set);
        map.insert(BaseMetricId(2788), &super::use_counter_doc::customelementregistry_define);
        map.insert(BaseMetricId(2789), &super::use_counter_doc::customized_builtin);
        map.insert(BaseMetricId(2790), &super::use_counter_doc::datatransfer_addelement);
        map.insert(BaseMetricId(2791), &super::use_counter_doc::datatransfer_mozcleardataat);
        map.insert(BaseMetricId(2792), &super::use_counter_doc::datatransfer_mozcursor_getter);
        map.insert(BaseMetricId(2793), &super::use_counter_doc::datatransfer_mozcursor_setter);
        map.insert(BaseMetricId(2794), &super::use_counter_doc::datatransfer_mozgetdataat);
        map.insert(BaseMetricId(2795), &super::use_counter_doc::datatransfer_mozitemcount_getter);
        map.insert(BaseMetricId(2796), &super::use_counter_doc::datatransfer_mozitemcount_setter);
        map.insert(BaseMetricId(2797), &super::use_counter_doc::datatransfer_mozsetdataat);
        map.insert(BaseMetricId(2798), &super::use_counter_doc::datatransfer_mozsourcenode_getter);
        map.insert(BaseMetricId(2799), &super::use_counter_doc::datatransfer_mozsourcenode_setter);
        map.insert(BaseMetricId(2800), &super::use_counter_doc::datatransfer_moztypesat);
        map.insert(BaseMetricId(2801), &super::use_counter_doc::datatransfer_mozusercancelled_getter);
        map.insert(BaseMetricId(2802), &super::use_counter_doc::datatransfer_mozusercancelled_setter);
        map.insert(BaseMetricId(2803), &super::use_counter_doc::document_exec_command_content_read_only);
        map.insert(BaseMetricId(2804), &super::use_counter_doc::document_mozsetimageelement);
        map.insert(BaseMetricId(2805), &super::use_counter_doc::document_open);
        map.insert(BaseMetricId(2806), &super::use_counter_doc::document_query_command_state_or_value_content_read_only);
        map.insert(BaseMetricId(2807), &super::use_counter_doc::document_query_command_state_or_value_insert_br_on_return);
        map.insert(BaseMetricId(2808), &super::use_counter_doc::document_query_command_supported_or_enabled_content_read_only);
        map.insert(BaseMetricId(2809), &super::use_counter_doc::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(BaseMetricId(2810), &super::use_counter_doc::domparser_parsefromstring);
        map.insert(BaseMetricId(2811), &super::use_counter_doc::element_attachshadow);
        map.insert(BaseMetricId(2812), &super::use_counter_doc::element_releasecapture);
        map.insert(BaseMetricId(2813), &super::use_counter_doc::element_releasepointercapture);
        map.insert(BaseMetricId(2814), &super::use_counter_doc::element_setcapture);
        map.insert(BaseMetricId(2815), &super::use_counter_doc::element_sethtml);
        map.insert(BaseMetricId(2816), &super::use_counter_doc::element_setpointercapture);
        map.insert(BaseMetricId(2817), &super::use_counter_doc::enumerate_devices_insec);
        map.insert(BaseMetricId(2818), &super::use_counter_doc::enumerate_devices_unfocused);
        map.insert(BaseMetricId(2819), &super::use_counter_doc::fe_blend);
        map.insert(BaseMetricId(2820), &super::use_counter_doc::fe_color_matrix);
        map.insert(BaseMetricId(2821), &super::use_counter_doc::fe_component_transfer);
        map.insert(BaseMetricId(2822), &super::use_counter_doc::fe_composite);
        map.insert(BaseMetricId(2823), &super::use_counter_doc::fe_convolve_matrix);
        map.insert(BaseMetricId(2824), &super::use_counter_doc::fe_diffuse_lighting);
        map.insert(BaseMetricId(2825), &super::use_counter_doc::fe_displacement_map);
        map.insert(BaseMetricId(2826), &super::use_counter_doc::fe_flood);
        map.insert(BaseMetricId(2827), &super::use_counter_doc::fe_gaussian_blur);
        map.insert(BaseMetricId(2828), &super::use_counter_doc::fe_image);
        map.insert(BaseMetricId(2829), &super::use_counter_doc::fe_merge);
        map.insert(BaseMetricId(2830), &super::use_counter_doc::fe_morphology);
        map.insert(BaseMetricId(2831), &super::use_counter_doc::fe_offset);
        map.insert(BaseMetricId(2832), &super::use_counter_doc::fe_specular_lighting);
        map.insert(BaseMetricId(2833), &super::use_counter_doc::fe_tile);
        map.insert(BaseMetricId(2834), &super::use_counter_doc::fe_turbulence);
        map.insert(BaseMetricId(2835), &super::use_counter_doc::filtered_cross_origin_iframe);
        map.insert(BaseMetricId(2836), &super::use_counter_doc::get_user_media_insec);
        map.insert(BaseMetricId(2837), &super::use_counter_doc::get_user_media_unfocused);
        map.insert(BaseMetricId(2838), &super::use_counter_doc::htmldialogelement_show);
        map.insert(BaseMetricId(2839), &super::use_counter_doc::htmldocument_caretrangefrompoint);
        map.insert(BaseMetricId(2840), &super::use_counter_doc::htmldocument_exitpictureinpicture);
        map.insert(BaseMetricId(2841), &super::use_counter_doc::htmldocument_featurepolicy);
        map.insert(BaseMetricId(2842), &super::use_counter_doc::htmldocument_named_getter_hit);
        map.insert(BaseMetricId(2843), &super::use_counter_doc::htmldocument_onbeforecopy);
        map.insert(BaseMetricId(2844), &super::use_counter_doc::htmldocument_onbeforecut);
        map.insert(BaseMetricId(2845), &super::use_counter_doc::htmldocument_onbeforepaste);
        map.insert(BaseMetricId(2846), &super::use_counter_doc::htmldocument_oncancel);
        map.insert(BaseMetricId(2847), &super::use_counter_doc::htmldocument_onfreeze);
        map.insert(BaseMetricId(2848), &super::use_counter_doc::htmldocument_onmousewheel);
        map.insert(BaseMetricId(2849), &super::use_counter_doc::htmldocument_onresume);
        map.insert(BaseMetricId(2850), &super::use_counter_doc::htmldocument_onsearch);
        map.insert(BaseMetricId(2851), &super::use_counter_doc::htmldocument_onwebkitfullscreenchange);
        map.insert(BaseMetricId(2852), &super::use_counter_doc::htmldocument_onwebkitfullscreenerror);
        map.insert(BaseMetricId(2853), &super::use_counter_doc::htmldocument_pictureinpictureelement);
        map.insert(BaseMetricId(2854), &super::use_counter_doc::htmldocument_pictureinpictureenabled);
        map.insert(BaseMetricId(2855), &super::use_counter_doc::htmldocument_registerelement);
        map.insert(BaseMetricId(2856), &super::use_counter_doc::htmldocument_wasdiscarded);
        map.insert(BaseMetricId(2857), &super::use_counter_doc::htmldocument_webkitcancelfullscreen);
        map.insert(BaseMetricId(2858), &super::use_counter_doc::htmldocument_webkitcurrentfullscreenelement);
        map.insert(BaseMetricId(2859), &super::use_counter_doc::htmldocument_webkitexitfullscreen);
        map.insert(BaseMetricId(2860), &super::use_counter_doc::htmldocument_webkitfullscreenelement);
        map.insert(BaseMetricId(2861), &super::use_counter_doc::htmldocument_webkitfullscreenenabled);
        map.insert(BaseMetricId(2862), &super::use_counter_doc::htmldocument_webkithidden);
        map.insert(BaseMetricId(2863), &super::use_counter_doc::htmldocument_webkitisfullscreen);
        map.insert(BaseMetricId(2864), &super::use_counter_doc::htmldocument_webkitvisibilitystate);
        map.insert(BaseMetricId(2865), &super::use_counter_doc::htmldocument_xmlencoding);
        map.insert(BaseMetricId(2866), &super::use_counter_doc::htmldocument_xmlstandalone);
        map.insert(BaseMetricId(2867), &super::use_counter_doc::htmldocument_xmlversion);
        map.insert(BaseMetricId(2868), &super::use_counter_doc::invalid_text_directives);
        map.insert(BaseMetricId(2869), &super::use_counter_doc::js_asmjs);
        map.insert(BaseMetricId(2870), &super::use_counter_doc::js_dateparse);
        map.insert(BaseMetricId(2871), &super::use_counter_doc::js_dateparse_impl_def);
        map.insert(BaseMetricId(2872), &super::use_counter_doc::js_errorstack_getter);
        map.insert(BaseMetricId(2873), &super::use_counter_doc::js_errorstack_getter_no_errordata);
        map.insert(BaseMetricId(2874), &super::use_counter_doc::js_errorstack_setter);
        map.insert(BaseMetricId(2875), &super::use_counter_doc::js_errorstack_setter_no_errordata);
        map.insert(BaseMetricId(2876), &super::use_counter_doc::js_errorstack_setter_nonstring);
        map.insert(BaseMetricId(2877), &super::use_counter_doc::js_ic_stub_oom);
        map.insert(BaseMetricId(2878), &super::use_counter_doc::js_ic_stub_too_large);
        map.insert(BaseMetricId(2879), &super::use_counter_doc::js_is_htmldda_fuse);
        map.insert(BaseMetricId(2880), &super::use_counter_doc::js_legacy_lang_subtag);
        map.insert(BaseMetricId(2881), &super::use_counter_doc::js_optimize_array_species_fuse);
        map.insert(BaseMetricId(2882), &super::use_counter_doc::js_optimize_get_iterator_fuse);
        map.insert(BaseMetricId(2883), &super::use_counter_doc::js_optimize_promise_lookup_fuse);
        map.insert(BaseMetricId(2884), &super::use_counter_doc::js_regexp_symbol_protocol_on_primitive);
        map.insert(BaseMetricId(2885), &super::use_counter_doc::js_thenable);
        map.insert(BaseMetricId(2886), &super::use_counter_doc::js_thenable_object_proto);
        map.insert(BaseMetricId(2887), &super::use_counter_doc::js_thenable_proto);
        map.insert(BaseMetricId(2888), &super::use_counter_doc::js_thenable_standard_proto);
        map.insert(BaseMetricId(2889), &super::use_counter_doc::js_wasm);
        map.insert(BaseMetricId(2890), &super::use_counter_doc::js_wasm_legacy_exceptions);
        map.insert(BaseMetricId(2891), &super::use_counter_doc::location_ancestororigins);
        map.insert(BaseMetricId(2892), &super::use_counter_doc::math_mlused);
        map.insert(BaseMetricId(2893), &super::use_counter_doc::mediadevices_enumeratedevices);
        map.insert(BaseMetricId(2894), &super::use_counter_doc::mediadevices_getdisplaymedia);
        map.insert(BaseMetricId(2895), &super::use_counter_doc::mediadevices_getusermedia);
        map.insert(BaseMetricId(2896), &super::use_counter_doc::mixed_content_not_upgraded_audio_failure);
        map.insert(BaseMetricId(2897), &super::use_counter_doc::mixed_content_not_upgraded_audio_success);
        map.insert(BaseMetricId(2898), &super::use_counter_doc::mixed_content_not_upgraded_image_failure);
        map.insert(BaseMetricId(2899), &super::use_counter_doc::mixed_content_not_upgraded_image_success);
        map.insert(BaseMetricId(2900), &super::use_counter_doc::mixed_content_not_upgraded_video_failure);
        map.insert(BaseMetricId(2901), &super::use_counter_doc::mixed_content_not_upgraded_video_success);
        map.insert(BaseMetricId(2902), &super::use_counter_doc::mixed_content_upgraded_audio_failure);
        map.insert(BaseMetricId(2903), &super::use_counter_doc::mixed_content_upgraded_audio_success);
        map.insert(BaseMetricId(2904), &super::use_counter_doc::mixed_content_upgraded_image_failure);
        map.insert(BaseMetricId(2905), &super::use_counter_doc::mixed_content_upgraded_image_success);
        map.insert(BaseMetricId(2906), &super::use_counter_doc::mixed_content_upgraded_video_failure);
        map.insert(BaseMetricId(2907), &super::use_counter_doc::mixed_content_upgraded_video_success);
        map.insert(BaseMetricId(2908), &super::use_counter_doc::mls_deriveexporter);
        map.insert(BaseMetricId(2909), &super::use_counter_doc::mls_generatecredentialbasic);
        map.insert(BaseMetricId(2910), &super::use_counter_doc::mls_generatekeypackage);
        map.insert(BaseMetricId(2911), &super::use_counter_doc::mls_generatesignaturekeypair);
        map.insert(BaseMetricId(2912), &super::use_counter_doc::mls_groupadd);
        map.insert(BaseMetricId(2913), &super::use_counter_doc::mls_groupclose);
        map.insert(BaseMetricId(2914), &super::use_counter_doc::mls_groupcreate);
        map.insert(BaseMetricId(2915), &super::use_counter_doc::mls_groupjoin);
        map.insert(BaseMetricId(2916), &super::use_counter_doc::mls_groupmembers);
        map.insert(BaseMetricId(2917), &super::use_counter_doc::mls_groupproposeadd);
        map.insert(BaseMetricId(2918), &super::use_counter_doc::mls_groupproposeremove);
        map.insert(BaseMetricId(2919), &super::use_counter_doc::mls_groupremove);
        map.insert(BaseMetricId(2920), &super::use_counter_doc::mls_receive);
        map.insert(BaseMetricId(2921), &super::use_counter_doc::mls_send);
        map.insert(BaseMetricId(2922), &super::use_counter_doc::mls_statedelete);
        map.insert(BaseMetricId(2923), &super::use_counter_doc::mls_statedeletegroup);
        map.insert(BaseMetricId(2924), &super::use_counter_doc::navigator_mozgetusermedia);
        map.insert(BaseMetricId(2925), &super::use_counter_doc::ondommousescroll);
        map.insert(BaseMetricId(2926), &super::use_counter_doc::onmozmousepixelscroll);
        map.insert(BaseMetricId(2927), &super::use_counter_doc::percentage_stroke_width_in_svg);
        map.insert(BaseMetricId(2928), &super::use_counter_doc::percentage_stroke_width_in_svgtext);
        map.insert(BaseMetricId(2929), &super::use_counter_doc::private_browsing_caches_delete);
        map.insert(BaseMetricId(2930), &super::use_counter_doc::private_browsing_caches_has);
        map.insert(BaseMetricId(2931), &super::use_counter_doc::private_browsing_caches_keys);
        map.insert(BaseMetricId(2932), &super::use_counter_doc::private_browsing_caches_match);
        map.insert(BaseMetricId(2933), &super::use_counter_doc::private_browsing_caches_open);
        map.insert(BaseMetricId(2934), &super::use_counter_doc::private_browsing_idbfactory_delete_database);
        map.insert(BaseMetricId(2935), &super::use_counter_doc::private_browsing_idbfactory_open);
        map.insert(BaseMetricId(2936), &super::use_counter_doc::private_browsing_navigator_service_worker);
        map.insert(BaseMetricId(2937), &super::use_counter_doc::pushmanager_subscribe);
        map.insert(BaseMetricId(2938), &super::use_counter_doc::pushsubscription_unsubscribe);
        map.insert(BaseMetricId(2939), &super::use_counter_doc::range_createcontextualfragment);
        map.insert(BaseMetricId(2940), &super::use_counter_doc::sanitizer_constructor);
        map.insert(BaseMetricId(2941), &super::use_counter_doc::sanitizer_sanitize);
        map.insert(BaseMetricId(2942), &super::use_counter_doc::scheduler_posttask);
        map.insert(BaseMetricId(2943), &super::use_counter_doc::sectioning_h1_with_no_font_size_or_margins);
        map.insert(BaseMetricId(2944), &super::use_counter_doc::svgsvgelement_currentscale_getter);
        map.insert(BaseMetricId(2945), &super::use_counter_doc::svgsvgelement_currentscale_setter);
        map.insert(BaseMetricId(2946), &super::use_counter_doc::svgsvgelement_getelementbyid);
        map.insert(BaseMetricId(2947), &super::use_counter_doc::text_directive_not_created);
        map.insert(BaseMetricId(2948), &super::use_counter_doc::text_directive_pages);
        map.insert(BaseMetricId(2949), &super::use_counter_doc::window_absoluteorientationsensor);
        map.insert(BaseMetricId(2950), &super::use_counter_doc::window_accelerometer);
        map.insert(BaseMetricId(2951), &super::use_counter_doc::window_backgroundfetchmanager);
        map.insert(BaseMetricId(2952), &super::use_counter_doc::window_backgroundfetchrecord);
        map.insert(BaseMetricId(2953), &super::use_counter_doc::window_backgroundfetchregistration);
        map.insert(BaseMetricId(2954), &super::use_counter_doc::window_beforeinstallpromptevent);
        map.insert(BaseMetricId(2955), &super::use_counter_doc::window_bluetooth);
        map.insert(BaseMetricId(2956), &super::use_counter_doc::window_bluetoothcharacteristicproperties);
        map.insert(BaseMetricId(2957), &super::use_counter_doc::window_bluetoothdevice);
        map.insert(BaseMetricId(2958), &super::use_counter_doc::window_bluetoothremotegattcharacteristic);
        map.insert(BaseMetricId(2959), &super::use_counter_doc::window_bluetoothremotegattdescriptor);
        map.insert(BaseMetricId(2960), &super::use_counter_doc::window_bluetoothremotegattserver);
        map.insert(BaseMetricId(2961), &super::use_counter_doc::window_bluetoothremotegattservice);
        map.insert(BaseMetricId(2962), &super::use_counter_doc::window_bluetoothuuid);
        map.insert(BaseMetricId(2963), &super::use_counter_doc::window_canvascapturemediastreamtrack);
        map.insert(BaseMetricId(2964), &super::use_counter_doc::window_chrome);
        map.insert(BaseMetricId(2965), &super::use_counter_doc::window_clipboarditem);
        map.insert(BaseMetricId(2966), &super::use_counter_doc::window_cssimagevalue);
        map.insert(BaseMetricId(2967), &super::use_counter_doc::window_csskeywordvalue);
        map.insert(BaseMetricId(2968), &super::use_counter_doc::window_cssmathclamp);
        map.insert(BaseMetricId(2969), &super::use_counter_doc::window_cssmathinvert);
        map.insert(BaseMetricId(2970), &super::use_counter_doc::window_cssmathmax);
        map.insert(BaseMetricId(2971), &super::use_counter_doc::window_cssmathmin);
        map.insert(BaseMetricId(2972), &super::use_counter_doc::window_cssmathnegate);
        map.insert(BaseMetricId(2973), &super::use_counter_doc::window_cssmathproduct);
        map.insert(BaseMetricId(2974), &super::use_counter_doc::window_cssmathsum);
        map.insert(BaseMetricId(2975), &super::use_counter_doc::window_cssmathvalue);
        map.insert(BaseMetricId(2976), &super::use_counter_doc::window_cssmatrixcomponent);
        map.insert(BaseMetricId(2977), &super::use_counter_doc::window_cssnumericarray);
        map.insert(BaseMetricId(2978), &super::use_counter_doc::window_cssnumericvalue);
        map.insert(BaseMetricId(2979), &super::use_counter_doc::window_cssperspective);
        map.insert(BaseMetricId(2980), &super::use_counter_doc::window_csspositionvalue);
        map.insert(BaseMetricId(2981), &super::use_counter_doc::window_csspropertyrule);
        map.insert(BaseMetricId(2982), &super::use_counter_doc::window_cssrotate);
        map.insert(BaseMetricId(2983), &super::use_counter_doc::window_cssscale);
        map.insert(BaseMetricId(2984), &super::use_counter_doc::window_cssskew);
        map.insert(BaseMetricId(2985), &super::use_counter_doc::window_cssskewx);
        map.insert(BaseMetricId(2986), &super::use_counter_doc::window_cssskewy);
        map.insert(BaseMetricId(2987), &super::use_counter_doc::window_cssstylevalue);
        map.insert(BaseMetricId(2988), &super::use_counter_doc::window_csstransformcomponent);
        map.insert(BaseMetricId(2989), &super::use_counter_doc::window_csstransformvalue);
        map.insert(BaseMetricId(2990), &super::use_counter_doc::window_csstranslate);
        map.insert(BaseMetricId(2991), &super::use_counter_doc::window_cssunitvalue);
        map.insert(BaseMetricId(2992), &super::use_counter_doc::window_cssunparsedvalue);
        map.insert(BaseMetricId(2993), &super::use_counter_doc::window_cssvariablereferencevalue);
        map.insert(BaseMetricId(2994), &super::use_counter_doc::window_defaultstatus);
        map.insert(BaseMetricId(2995), &super::use_counter_doc::window_devicemotioneventacceleration);
        map.insert(BaseMetricId(2996), &super::use_counter_doc::window_devicemotioneventrotationrate);
        map.insert(BaseMetricId(2997), &super::use_counter_doc::window_domerror);
        map.insert(BaseMetricId(2998), &super::use_counter_doc::window_encodedvideochunk);
        map.insert(BaseMetricId(2999), &super::use_counter_doc::window_enterpictureinpictureevent);
        map.insert(BaseMetricId(3000), &super::use_counter_doc::window_external);
        map.insert(BaseMetricId(3001), &super::use_counter_doc::window_federatedcredential);
        map.insert(BaseMetricId(3002), &super::use_counter_doc::window_gyroscope);
        map.insert(BaseMetricId(3003), &super::use_counter_doc::window_htmlcontentelement);
        map.insert(BaseMetricId(3004), &super::use_counter_doc::window_htmlshadowelement);
        map.insert(BaseMetricId(3005), &super::use_counter_doc::window_imagecapture);
        map.insert(BaseMetricId(3006), &super::use_counter_doc::window_inputdevicecapabilities);
        map.insert(BaseMetricId(3007), &super::use_counter_doc::window_inputdeviceinfo);
        map.insert(BaseMetricId(3008), &super::use_counter_doc::window_keyboard);
        map.insert(BaseMetricId(3009), &super::use_counter_doc::window_keyboardlayoutmap);
        map.insert(BaseMetricId(3010), &super::use_counter_doc::window_linearaccelerationsensor);
        map.insert(BaseMetricId(3011), &super::use_counter_doc::window_mediasettingsrange);
        map.insert(BaseMetricId(3012), &super::use_counter_doc::window_midiaccess);
        map.insert(BaseMetricId(3013), &super::use_counter_doc::window_midiconnectionevent);
        map.insert(BaseMetricId(3014), &super::use_counter_doc::window_midiinput);
        map.insert(BaseMetricId(3015), &super::use_counter_doc::window_midiinputmap);
        map.insert(BaseMetricId(3016), &super::use_counter_doc::window_midimessageevent);
        map.insert(BaseMetricId(3017), &super::use_counter_doc::window_midioutput);
        map.insert(BaseMetricId(3018), &super::use_counter_doc::window_midioutputmap);
        map.insert(BaseMetricId(3019), &super::use_counter_doc::window_midiport);
        map.insert(BaseMetricId(3020), &super::use_counter_doc::window_networkinformation);
        map.insert(BaseMetricId(3021), &super::use_counter_doc::window_offscreenbuffering);
        map.insert(BaseMetricId(3022), &super::use_counter_doc::window_onbeforeinstallprompt);
        map.insert(BaseMetricId(3023), &super::use_counter_doc::window_oncancel);
        map.insert(BaseMetricId(3024), &super::use_counter_doc::window_onmousewheel);
        map.insert(BaseMetricId(3025), &super::use_counter_doc::window_onorientationchange);
        map.insert(BaseMetricId(3026), &super::use_counter_doc::window_onsearch);
        map.insert(BaseMetricId(3027), &super::use_counter_doc::window_onselectionchange);
        map.insert(BaseMetricId(3028), &super::use_counter_doc::window_open_empty_url);
        map.insert(BaseMetricId(3029), &super::use_counter_doc::window_opendatabase);
        map.insert(BaseMetricId(3030), &super::use_counter_doc::window_orientation);
        map.insert(BaseMetricId(3031), &super::use_counter_doc::window_orientationsensor);
        map.insert(BaseMetricId(3032), &super::use_counter_doc::window_overconstrainederror);
        map.insert(BaseMetricId(3033), &super::use_counter_doc::window_passwordcredential);
        map.insert(BaseMetricId(3034), &super::use_counter_doc::window_paymentaddress);
        map.insert(BaseMetricId(3035), &super::use_counter_doc::window_paymentinstruments);
        map.insert(BaseMetricId(3036), &super::use_counter_doc::window_paymentmanager);
        map.insert(BaseMetricId(3037), &super::use_counter_doc::window_paymentmethodchangeevent);
        map.insert(BaseMetricId(3038), &super::use_counter_doc::window_paymentrequest);
        map.insert(BaseMetricId(3039), &super::use_counter_doc::window_paymentrequestupdateevent);
        map.insert(BaseMetricId(3040), &super::use_counter_doc::window_paymentresponse);
        map.insert(BaseMetricId(3041), &super::use_counter_doc::window_performancelongtasktiming);
        map.insert(BaseMetricId(3042), &super::use_counter_doc::window_photocapabilities);
        map.insert(BaseMetricId(3043), &super::use_counter_doc::window_pictureinpictureevent);
        map.insert(BaseMetricId(3044), &super::use_counter_doc::window_pictureinpicturewindow);
        map.insert(BaseMetricId(3045), &super::use_counter_doc::window_presentation);
        map.insert(BaseMetricId(3046), &super::use_counter_doc::window_presentationavailability);
        map.insert(BaseMetricId(3047), &super::use_counter_doc::window_presentationconnection);
        map.insert(BaseMetricId(3048), &super::use_counter_doc::window_presentationconnectionavailableevent);
        map.insert(BaseMetricId(3049), &super::use_counter_doc::window_presentationconnectioncloseevent);
        map.insert(BaseMetricId(3050), &super::use_counter_doc::window_presentationconnectionlist);
        map.insert(BaseMetricId(3051), &super::use_counter_doc::window_presentationreceiver);
        map.insert(BaseMetricId(3052), &super::use_counter_doc::window_presentationrequest);
        map.insert(BaseMetricId(3053), &super::use_counter_doc::window_relativeorientationsensor);
        map.insert(BaseMetricId(3054), &super::use_counter_doc::window_remoteplayback);
        map.insert(BaseMetricId(3055), &super::use_counter_doc::window_report);
        map.insert(BaseMetricId(3056), &super::use_counter_doc::window_reportbody);
        map.insert(BaseMetricId(3057), &super::use_counter_doc::window_reportingobserver);
        map.insert(BaseMetricId(3058), &super::use_counter_doc::window_rtcerror);
        map.insert(BaseMetricId(3059), &super::use_counter_doc::window_rtcerrorevent);
        map.insert(BaseMetricId(3060), &super::use_counter_doc::window_rtcicetransport);
        map.insert(BaseMetricId(3061), &super::use_counter_doc::window_rtcpeerconnectioniceerrorevent);
        map.insert(BaseMetricId(3062), &super::use_counter_doc::window_sensor);
        map.insert(BaseMetricId(3063), &super::use_counter_doc::window_sensorerrorevent);
        map.insert(BaseMetricId(3064), &super::use_counter_doc::window_sidebar_getter);
        map.insert(BaseMetricId(3065), &super::use_counter_doc::window_sidebar_setter);
        map.insert(BaseMetricId(3066), &super::use_counter_doc::window_speechrecognitionalternative);
        map.insert(BaseMetricId(3067), &super::use_counter_doc::window_speechrecognitionresult);
        map.insert(BaseMetricId(3068), &super::use_counter_doc::window_speechrecognitionresultlist);
        map.insert(BaseMetricId(3069), &super::use_counter_doc::window_stylemedia);
        map.insert(BaseMetricId(3070), &super::use_counter_doc::window_stylepropertymap);
        map.insert(BaseMetricId(3071), &super::use_counter_doc::window_stylepropertymapreadonly);
        map.insert(BaseMetricId(3072), &super::use_counter_doc::window_svgdiscardelement);
        map.insert(BaseMetricId(3073), &super::use_counter_doc::window_syncmanager);
        map.insert(BaseMetricId(3074), &super::use_counter_doc::window_taskattributiontiming);
        map.insert(BaseMetricId(3075), &super::use_counter_doc::window_textevent);
        map.insert(BaseMetricId(3076), &super::use_counter_doc::window_touch);
        map.insert(BaseMetricId(3077), &super::use_counter_doc::window_touchevent);
        map.insert(BaseMetricId(3078), &super::use_counter_doc::window_touchlist);
        map.insert(BaseMetricId(3079), &super::use_counter_doc::window_usb);
        map.insert(BaseMetricId(3080), &super::use_counter_doc::window_usbalternateinterface);
        map.insert(BaseMetricId(3081), &super::use_counter_doc::window_usbconfiguration);
        map.insert(BaseMetricId(3082), &super::use_counter_doc::window_usbconnectionevent);
        map.insert(BaseMetricId(3083), &super::use_counter_doc::window_usbdevice);
        map.insert(BaseMetricId(3084), &super::use_counter_doc::window_usbendpoint);
        map.insert(BaseMetricId(3085), &super::use_counter_doc::window_usbinterface);
        map.insert(BaseMetricId(3086), &super::use_counter_doc::window_usbintransferresult);
        map.insert(BaseMetricId(3087), &super::use_counter_doc::window_usbisochronousintransferpacket);
        map.insert(BaseMetricId(3088), &super::use_counter_doc::window_usbisochronousintransferresult);
        map.insert(BaseMetricId(3089), &super::use_counter_doc::window_usbisochronousouttransferpacket);
        map.insert(BaseMetricId(3090), &super::use_counter_doc::window_usbisochronousouttransferresult);
        map.insert(BaseMetricId(3091), &super::use_counter_doc::window_usbouttransferresult);
        map.insert(BaseMetricId(3092), &super::use_counter_doc::window_useractivation);
        map.insert(BaseMetricId(3093), &super::use_counter_doc::window_videocolorspace);
        map.insert(BaseMetricId(3094), &super::use_counter_doc::window_videodecoder);
        map.insert(BaseMetricId(3095), &super::use_counter_doc::window_videoencoder);
        map.insert(BaseMetricId(3096), &super::use_counter_doc::window_videoframe);
        map.insert(BaseMetricId(3097), &super::use_counter_doc::window_wakelock);
        map.insert(BaseMetricId(3098), &super::use_counter_doc::window_wakelocksentinel);
        map.insert(BaseMetricId(3099), &super::use_counter_doc::window_webkitcancelanimationframe);
        map.insert(BaseMetricId(3100), &super::use_counter_doc::window_webkitmediastream);
        map.insert(BaseMetricId(3101), &super::use_counter_doc::window_webkitmutationobserver);
        map.insert(BaseMetricId(3102), &super::use_counter_doc::window_webkitrequestanimationframe);
        map.insert(BaseMetricId(3103), &super::use_counter_doc::window_webkitrequestfilesystem);
        map.insert(BaseMetricId(3104), &super::use_counter_doc::window_webkitresolvelocalfilesystemurl);
        map.insert(BaseMetricId(3105), &super::use_counter_doc::window_webkitrtcpeerconnection);
        map.insert(BaseMetricId(3106), &super::use_counter_doc::window_webkitspeechgrammar);
        map.insert(BaseMetricId(3107), &super::use_counter_doc::window_webkitspeechgrammarlist);
        map.insert(BaseMetricId(3108), &super::use_counter_doc::window_webkitspeechrecognition);
        map.insert(BaseMetricId(3109), &super::use_counter_doc::window_webkitspeechrecognitionerror);
        map.insert(BaseMetricId(3110), &super::use_counter_doc::window_webkitspeechrecognitionevent);
        map.insert(BaseMetricId(3111), &super::use_counter_doc::window_webkitstorageinfo);
        map.insert(BaseMetricId(3112), &super::use_counter_doc::wr_filter_fallback);
        map.insert(BaseMetricId(3113), &super::use_counter_doc::xslstylesheet);
        map.insert(BaseMetricId(3114), &super::use_counter_doc::xsltprocessor_constructor);
        map.insert(BaseMetricId(3115), &super::use_counter_doc::you_tube_flash_embed);
        map.insert(BaseMetricId(3116), &super::use_counter_page::animation_commitstyles);
        map.insert(BaseMetricId(3117), &super::use_counter_page::commit_styles_non_filling_final_value);
        map.insert(BaseMetricId(3118), &super::use_counter_page::components_shim_resolved);
        map.insert(BaseMetricId(3119), &super::use_counter_page::console_assert);
        map.insert(BaseMetricId(3120), &super::use_counter_page::console_clear);
        map.insert(BaseMetricId(3121), &super::use_counter_page::console_count);
        map.insert(BaseMetricId(3122), &super::use_counter_page::console_countreset);
        map.insert(BaseMetricId(3123), &super::use_counter_page::console_debug);
        map.insert(BaseMetricId(3124), &super::use_counter_page::console_dir);
        map.insert(BaseMetricId(3125), &super::use_counter_page::console_dirxml);
        map.insert(BaseMetricId(3126), &super::use_counter_page::console_error);
        map.insert(BaseMetricId(3127), &super::use_counter_page::console_exception);
        map.insert(BaseMetricId(3128), &super::use_counter_page::console_group);
        map.insert(BaseMetricId(3129), &super::use_counter_page::console_groupcollapsed);
        map.insert(BaseMetricId(3130), &super::use_counter_page::console_groupend);
        map.insert(BaseMetricId(3131), &super::use_counter_page::console_info);
        map.insert(BaseMetricId(3132), &super::use_counter_page::console_log);
        map.insert(BaseMetricId(3133), &super::use_counter_page::console_profile);
        map.insert(BaseMetricId(3134), &super::use_counter_page::console_profileend);
        map.insert(BaseMetricId(3135), &super::use_counter_page::console_table);
        map.insert(BaseMetricId(3136), &super::use_counter_page::console_time);
        map.insert(BaseMetricId(3137), &super::use_counter_page::console_timeend);
        map.insert(BaseMetricId(3138), &super::use_counter_page::console_timelog);
        map.insert(BaseMetricId(3139), &super::use_counter_page::console_timestamp);
        map.insert(BaseMetricId(3140), &super::use_counter_page::console_trace);
        map.insert(BaseMetricId(3141), &super::use_counter_page::console_warn);
        map.insert(BaseMetricId(3142), &super::use_counter_page::cookiestore_delete);
        map.insert(BaseMetricId(3143), &super::use_counter_page::cookiestore_get);
        map.insert(BaseMetricId(3144), &super::use_counter_page::cookiestore_getall);
        map.insert(BaseMetricId(3145), &super::use_counter_page::cookiestore_set);
        map.insert(BaseMetricId(3146), &super::use_counter_page::customelementregistry_define);
        map.insert(BaseMetricId(3147), &super::use_counter_page::customized_builtin);
        map.insert(BaseMetricId(3148), &super::use_counter_page::datatransfer_addelement);
        map.insert(BaseMetricId(3149), &super::use_counter_page::datatransfer_mozcleardataat);
        map.insert(BaseMetricId(3150), &super::use_counter_page::datatransfer_mozcursor_getter);
        map.insert(BaseMetricId(3151), &super::use_counter_page::datatransfer_mozcursor_setter);
        map.insert(BaseMetricId(3152), &super::use_counter_page::datatransfer_mozgetdataat);
        map.insert(BaseMetricId(3153), &super::use_counter_page::datatransfer_mozitemcount_getter);
        map.insert(BaseMetricId(3154), &super::use_counter_page::datatransfer_mozitemcount_setter);
        map.insert(BaseMetricId(3155), &super::use_counter_page::datatransfer_mozsetdataat);
        map.insert(BaseMetricId(3156), &super::use_counter_page::datatransfer_mozsourcenode_getter);
        map.insert(BaseMetricId(3157), &super::use_counter_page::datatransfer_mozsourcenode_setter);
        map.insert(BaseMetricId(3158), &super::use_counter_page::datatransfer_moztypesat);
        map.insert(BaseMetricId(3159), &super::use_counter_page::datatransfer_mozusercancelled_getter);
        map.insert(BaseMetricId(3160), &super::use_counter_page::datatransfer_mozusercancelled_setter);
        map.insert(BaseMetricId(3161), &super::use_counter_page::document_exec_command_content_read_only);
        map.insert(BaseMetricId(3162), &super::use_counter_page::document_mozsetimageelement);
        map.insert(BaseMetricId(3163), &super::use_counter_page::document_open);
        map.insert(BaseMetricId(3164), &super::use_counter_page::document_query_command_state_or_value_content_read_only);
        map.insert(BaseMetricId(3165), &super::use_counter_page::document_query_command_state_or_value_insert_br_on_return);
        map.insert(BaseMetricId(3166), &super::use_counter_page::document_query_command_supported_or_enabled_content_read_only);
        map.insert(BaseMetricId(3167), &super::use_counter_page::document_query_command_supported_or_enabled_insert_br_on_return);
        map.insert(BaseMetricId(3168), &super::use_counter_page::domparser_parsefromstring);
        map.insert(BaseMetricId(3169), &super::use_counter_page::element_attachshadow);
        map.insert(BaseMetricId(3170), &super::use_counter_page::element_releasecapture);
        map.insert(BaseMetricId(3171), &super::use_counter_page::element_releasepointercapture);
        map.insert(BaseMetricId(3172), &super::use_counter_page::element_setcapture);
        map.insert(BaseMetricId(3173), &super::use_counter_page::element_sethtml);
        map.insert(BaseMetricId(3174), &super::use_counter_page::element_setpointercapture);
        map.insert(BaseMetricId(3175), &super::use_counter_page::enumerate_devices_insec);
        map.insert(BaseMetricId(3176), &super::use_counter_page::enumerate_devices_unfocused);
        map.insert(BaseMetricId(3177), &super::use_counter_page::fe_blend);
        map.insert(BaseMetricId(3178), &super::use_counter_page::fe_color_matrix);
        map.insert(BaseMetricId(3179), &super::use_counter_page::fe_component_transfer);
        map.insert(BaseMetricId(3180), &super::use_counter_page::fe_composite);
        map.insert(BaseMetricId(3181), &super::use_counter_page::fe_convolve_matrix);
        map.insert(BaseMetricId(3182), &super::use_counter_page::fe_diffuse_lighting);
        map.insert(BaseMetricId(3183), &super::use_counter_page::fe_displacement_map);
        map.insert(BaseMetricId(3184), &super::use_counter_page::fe_flood);
        map.insert(BaseMetricId(3185), &super::use_counter_page::fe_gaussian_blur);
        map.insert(BaseMetricId(3186), &super::use_counter_page::fe_image);
        map.insert(BaseMetricId(3187), &super::use_counter_page::fe_merge);
        map.insert(BaseMetricId(3188), &super::use_counter_page::fe_morphology);
        map.insert(BaseMetricId(3189), &super::use_counter_page::fe_offset);
        map.insert(BaseMetricId(3190), &super::use_counter_page::fe_specular_lighting);
        map.insert(BaseMetricId(3191), &super::use_counter_page::fe_tile);
        map.insert(BaseMetricId(3192), &super::use_counter_page::fe_turbulence);
        map.insert(BaseMetricId(3193), &super::use_counter_page::filtered_cross_origin_iframe);
        map.insert(BaseMetricId(3194), &super::use_counter_page::get_user_media_insec);
        map.insert(BaseMetricId(3195), &super::use_counter_page::get_user_media_unfocused);
        map.insert(BaseMetricId(3196), &super::use_counter_page::htmldialogelement_show);
        map.insert(BaseMetricId(3197), &super::use_counter_page::htmldocument_caretrangefrompoint);
        map.insert(BaseMetricId(3198), &super::use_counter_page::htmldocument_exitpictureinpicture);
        map.insert(BaseMetricId(3199), &super::use_counter_page::htmldocument_featurepolicy);
        map.insert(BaseMetricId(3200), &super::use_counter_page::htmldocument_named_getter_hit);
        map.insert(BaseMetricId(3201), &super::use_counter_page::htmldocument_onbeforecopy);
        map.insert(BaseMetricId(3202), &super::use_counter_page::htmldocument_onbeforecut);
        map.insert(BaseMetricId(3203), &super::use_counter_page::htmldocument_onbeforepaste);
        map.insert(BaseMetricId(3204), &super::use_counter_page::htmldocument_oncancel);
        map.insert(BaseMetricId(3205), &super::use_counter_page::htmldocument_onfreeze);
        map.insert(BaseMetricId(3206), &super::use_counter_page::htmldocument_onmousewheel);
        map.insert(BaseMetricId(3207), &super::use_counter_page::htmldocument_onresume);
        map.insert(BaseMetricId(3208), &super::use_counter_page::htmldocument_onsearch);
        map.insert(BaseMetricId(3209), &super::use_counter_page::htmldocument_onwebkitfullscreenchange);
        map.insert(BaseMetricId(3210), &super::use_counter_page::htmldocument_onwebkitfullscreenerror);
        map.insert(BaseMetricId(3211), &super::use_counter_page::htmldocument_pictureinpictureelement);
        map.insert(BaseMetricId(3212), &super::use_counter_page::htmldocument_pictureinpictureenabled);
        map.insert(BaseMetricId(3213), &super::use_counter_page::htmldocument_registerelement);
        map.insert(BaseMetricId(3214), &super::use_counter_page::htmldocument_wasdiscarded);
        map.insert(BaseMetricId(3215), &super::use_counter_page::htmldocument_webkitcancelfullscreen);
        map.insert(BaseMetricId(3216), &super::use_counter_page::htmldocument_webkitcurrentfullscreenelement);
        map.insert(BaseMetricId(3217), &super::use_counter_page::htmldocument_webkitexitfullscreen);
        map.insert(BaseMetricId(3218), &super::use_counter_page::htmldocument_webkitfullscreenelement);
        map.insert(BaseMetricId(3219), &super::use_counter_page::htmldocument_webkitfullscreenenabled);
        map.insert(BaseMetricId(3220), &super::use_counter_page::htmldocument_webkithidden);
        map.insert(BaseMetricId(3221), &super::use_counter_page::htmldocument_webkitisfullscreen);
        map.insert(BaseMetricId(3222), &super::use_counter_page::htmldocument_webkitvisibilitystate);
        map.insert(BaseMetricId(3223), &super::use_counter_page::htmldocument_xmlencoding);
        map.insert(BaseMetricId(3224), &super::use_counter_page::htmldocument_xmlstandalone);
        map.insert(BaseMetricId(3225), &super::use_counter_page::htmldocument_xmlversion);
        map.insert(BaseMetricId(3226), &super::use_counter_page::invalid_text_directives);
        map.insert(BaseMetricId(3227), &super::use_counter_page::js_asmjs);
        map.insert(BaseMetricId(3228), &super::use_counter_page::js_dateparse);
        map.insert(BaseMetricId(3229), &super::use_counter_page::js_dateparse_impl_def);
        map.insert(BaseMetricId(3230), &super::use_counter_page::js_errorstack_getter);
        map.insert(BaseMetricId(3231), &super::use_counter_page::js_errorstack_getter_no_errordata);
        map.insert(BaseMetricId(3232), &super::use_counter_page::js_errorstack_setter);
        map.insert(BaseMetricId(3233), &super::use_counter_page::js_errorstack_setter_no_errordata);
        map.insert(BaseMetricId(3234), &super::use_counter_page::js_errorstack_setter_nonstring);
        map.insert(BaseMetricId(3235), &super::use_counter_page::js_ic_stub_oom);
        map.insert(BaseMetricId(3236), &super::use_counter_page::js_ic_stub_too_large);
        map.insert(BaseMetricId(3237), &super::use_counter_page::js_is_htmldda_fuse);
        map.insert(BaseMetricId(3238), &super::use_counter_page::js_legacy_lang_subtag);
        map.insert(BaseMetricId(3239), &super::use_counter_page::js_optimize_array_species_fuse);
        map.insert(BaseMetricId(3240), &super::use_counter_page::js_optimize_get_iterator_fuse);
        map.insert(BaseMetricId(3241), &super::use_counter_page::js_optimize_promise_lookup_fuse);
        map.insert(BaseMetricId(3242), &super::use_counter_page::js_regexp_symbol_protocol_on_primitive);
        map.insert(BaseMetricId(3243), &super::use_counter_page::js_thenable);
        map.insert(BaseMetricId(3244), &super::use_counter_page::js_thenable_object_proto);
        map.insert(BaseMetricId(3245), &super::use_counter_page::js_thenable_proto);
        map.insert(BaseMetricId(3246), &super::use_counter_page::js_thenable_standard_proto);
        map.insert(BaseMetricId(3247), &super::use_counter_page::js_wasm);
        map.insert(BaseMetricId(3248), &super::use_counter_page::js_wasm_legacy_exceptions);
        map.insert(BaseMetricId(3249), &super::use_counter_page::location_ancestororigins);
        map.insert(BaseMetricId(3250), &super::use_counter_page::math_mlused);
        map.insert(BaseMetricId(3251), &super::use_counter_page::mediadevices_enumeratedevices);
        map.insert(BaseMetricId(3252), &super::use_counter_page::mediadevices_getdisplaymedia);
        map.insert(BaseMetricId(3253), &super::use_counter_page::mediadevices_getusermedia);
        map.insert(BaseMetricId(3254), &super::use_counter_page::mixed_content_not_upgraded_audio_failure);
        map.insert(BaseMetricId(3255), &super::use_counter_page::mixed_content_not_upgraded_audio_success);
        map.insert(BaseMetricId(3256), &super::use_counter_page::mixed_content_not_upgraded_image_failure);
        map.insert(BaseMetricId(3257), &super::use_counter_page::mixed_content_not_upgraded_image_success);
        map.insert(BaseMetricId(3258), &super::use_counter_page::mixed_content_not_upgraded_video_failure);
        map.insert(BaseMetricId(3259), &super::use_counter_page::mixed_content_not_upgraded_video_success);
        map.insert(BaseMetricId(3260), &super::use_counter_page::mixed_content_upgraded_audio_failure);
        map.insert(BaseMetricId(3261), &super::use_counter_page::mixed_content_upgraded_audio_success);
        map.insert(BaseMetricId(3262), &super::use_counter_page::mixed_content_upgraded_image_failure);
        map.insert(BaseMetricId(3263), &super::use_counter_page::mixed_content_upgraded_image_success);
        map.insert(BaseMetricId(3264), &super::use_counter_page::mixed_content_upgraded_video_failure);
        map.insert(BaseMetricId(3265), &super::use_counter_page::mixed_content_upgraded_video_success);
        map.insert(BaseMetricId(3266), &super::use_counter_page::mls_deriveexporter);
        map.insert(BaseMetricId(3267), &super::use_counter_page::mls_generatecredentialbasic);
        map.insert(BaseMetricId(3268), &super::use_counter_page::mls_generatekeypackage);
        map.insert(BaseMetricId(3269), &super::use_counter_page::mls_generatesignaturekeypair);
        map.insert(BaseMetricId(3270), &super::use_counter_page::mls_groupadd);
        map.insert(BaseMetricId(3271), &super::use_counter_page::mls_groupclose);
        map.insert(BaseMetricId(3272), &super::use_counter_page::mls_groupcreate);
        map.insert(BaseMetricId(3273), &super::use_counter_page::mls_groupjoin);
        map.insert(BaseMetricId(3274), &super::use_counter_page::mls_groupmembers);
        map.insert(BaseMetricId(3275), &super::use_counter_page::mls_groupproposeadd);
        map.insert(BaseMetricId(3276), &super::use_counter_page::mls_groupproposeremove);
        map.insert(BaseMetricId(3277), &super::use_counter_page::mls_groupremove);
        map.insert(BaseMetricId(3278), &super::use_counter_page::mls_receive);
        map.insert(BaseMetricId(3279), &super::use_counter_page::mls_send);
        map.insert(BaseMetricId(3280), &super::use_counter_page::mls_statedelete);
        map.insert(BaseMetricId(3281), &super::use_counter_page::mls_statedeletegroup);
        map.insert(BaseMetricId(3282), &super::use_counter_page::navigator_mozgetusermedia);
        map.insert(BaseMetricId(3283), &super::use_counter_page::ondommousescroll);
        map.insert(BaseMetricId(3284), &super::use_counter_page::onmozmousepixelscroll);
        map.insert(BaseMetricId(3285), &super::use_counter_page::percentage_stroke_width_in_svg);
        map.insert(BaseMetricId(3286), &super::use_counter_page::percentage_stroke_width_in_svgtext);
        map.insert(BaseMetricId(3287), &super::use_counter_page::private_browsing_caches_delete);
        map.insert(BaseMetricId(3288), &super::use_counter_page::private_browsing_caches_has);
        map.insert(BaseMetricId(3289), &super::use_counter_page::private_browsing_caches_keys);
        map.insert(BaseMetricId(3290), &super::use_counter_page::private_browsing_caches_match);
        map.insert(BaseMetricId(3291), &super::use_counter_page::private_browsing_caches_open);
        map.insert(BaseMetricId(3292), &super::use_counter_page::private_browsing_idbfactory_delete_database);
        map.insert(BaseMetricId(3293), &super::use_counter_page::private_browsing_idbfactory_open);
        map.insert(BaseMetricId(3294), &super::use_counter_page::private_browsing_navigator_service_worker);
        map.insert(BaseMetricId(3295), &super::use_counter_page::pushmanager_subscribe);
        map.insert(BaseMetricId(3296), &super::use_counter_page::pushsubscription_unsubscribe);
        map.insert(BaseMetricId(3297), &super::use_counter_page::range_createcontextualfragment);
        map.insert(BaseMetricId(3298), &super::use_counter_page::sanitizer_constructor);
        map.insert(BaseMetricId(3299), &super::use_counter_page::sanitizer_sanitize);
        map.insert(BaseMetricId(3300), &super::use_counter_page::scheduler_posttask);
        map.insert(BaseMetricId(3301), &super::use_counter_page::sectioning_h1_with_no_font_size_or_margins);
        map.insert(BaseMetricId(3302), &super::use_counter_page::svgsvgelement_currentscale_getter);
        map.insert(BaseMetricId(3303), &super::use_counter_page::svgsvgelement_currentscale_setter);
        map.insert(BaseMetricId(3304), &super::use_counter_page::svgsvgelement_getelementbyid);
        map.insert(BaseMetricId(3305), &super::use_counter_page::text_directive_not_created);
        map.insert(BaseMetricId(3306), &super::use_counter_page::text_directive_pages);
        map.insert(BaseMetricId(3307), &super::use_counter_page::window_absoluteorientationsensor);
        map.insert(BaseMetricId(3308), &super::use_counter_page::window_accelerometer);
        map.insert(BaseMetricId(3309), &super::use_counter_page::window_backgroundfetchmanager);
        map.insert(BaseMetricId(3310), &super::use_counter_page::window_backgroundfetchrecord);
        map.insert(BaseMetricId(3311), &super::use_counter_page::window_backgroundfetchregistration);
        map.insert(BaseMetricId(3312), &super::use_counter_page::window_beforeinstallpromptevent);
        map.insert(BaseMetricId(3313), &super::use_counter_page::window_bluetooth);
        map.insert(BaseMetricId(3314), &super::use_counter_page::window_bluetoothcharacteristicproperties);
        map.insert(BaseMetricId(3315), &super::use_counter_page::window_bluetoothdevice);
        map.insert(BaseMetricId(3316), &super::use_counter_page::window_bluetoothremotegattcharacteristic);
        map.insert(BaseMetricId(3317), &super::use_counter_page::window_bluetoothremotegattdescriptor);
        map.insert(BaseMetricId(3318), &super::use_counter_page::window_bluetoothremotegattserver);
        map.insert(BaseMetricId(3319), &super::use_counter_page::window_bluetoothremotegattservice);
        map.insert(BaseMetricId(3320), &super::use_counter_page::window_bluetoothuuid);
        map.insert(BaseMetricId(3321), &super::use_counter_page::window_canvascapturemediastreamtrack);
        map.insert(BaseMetricId(3322), &super::use_counter_page::window_chrome);
        map.insert(BaseMetricId(3323), &super::use_counter_page::window_clipboarditem);
        map.insert(BaseMetricId(3324), &super::use_counter_page::window_cssimagevalue);
        map.insert(BaseMetricId(3325), &super::use_counter_page::window_csskeywordvalue);
        map.insert(BaseMetricId(3326), &super::use_counter_page::window_cssmathclamp);
        map.insert(BaseMetricId(3327), &super::use_counter_page::window_cssmathinvert);
        map.insert(BaseMetricId(3328), &super::use_counter_page::window_cssmathmax);
        map.insert(BaseMetricId(3329), &super::use_counter_page::window_cssmathmin);
        map.insert(BaseMetricId(3330), &super::use_counter_page::window_cssmathnegate);
        map.insert(BaseMetricId(3331), &super::use_counter_page::window_cssmathproduct);
        map.insert(BaseMetricId(3332), &super::use_counter_page::window_cssmathsum);
        map.insert(BaseMetricId(3333), &super::use_counter_page::window_cssmathvalue);
        map.insert(BaseMetricId(3334), &super::use_counter_page::window_cssmatrixcomponent);
        map.insert(BaseMetricId(3335), &super::use_counter_page::window_cssnumericarray);
        map.insert(BaseMetricId(3336), &super::use_counter_page::window_cssnumericvalue);
        map.insert(BaseMetricId(3337), &super::use_counter_page::window_cssperspective);
        map.insert(BaseMetricId(3338), &super::use_counter_page::window_csspositionvalue);
        map.insert(BaseMetricId(3339), &super::use_counter_page::window_csspropertyrule);
        map.insert(BaseMetricId(3340), &super::use_counter_page::window_cssrotate);
        map.insert(BaseMetricId(3341), &super::use_counter_page::window_cssscale);
        map.insert(BaseMetricId(3342), &super::use_counter_page::window_cssskew);
        map.insert(BaseMetricId(3343), &super::use_counter_page::window_cssskewx);
        map.insert(BaseMetricId(3344), &super::use_counter_page::window_cssskewy);
        map.insert(BaseMetricId(3345), &super::use_counter_page::window_cssstylevalue);
        map.insert(BaseMetricId(3346), &super::use_counter_page::window_csstransformcomponent);
        map.insert(BaseMetricId(3347), &super::use_counter_page::window_csstransformvalue);
        map.insert(BaseMetricId(3348), &super::use_counter_page::window_csstranslate);
        map.insert(BaseMetricId(3349), &super::use_counter_page::window_cssunitvalue);
        map.insert(BaseMetricId(3350), &super::use_counter_page::window_cssunparsedvalue);
        map.insert(BaseMetricId(3351), &super::use_counter_page::window_cssvariablereferencevalue);
        map.insert(BaseMetricId(3352), &super::use_counter_page::window_defaultstatus);
        map.insert(BaseMetricId(3353), &super::use_counter_page::window_devicemotioneventacceleration);
        map.insert(BaseMetricId(3354), &super::use_counter_page::window_devicemotioneventrotationrate);
        map.insert(BaseMetricId(3355), &super::use_counter_page::window_domerror);
        map.insert(BaseMetricId(3356), &super::use_counter_page::window_encodedvideochunk);
        map.insert(BaseMetricId(3357), &super::use_counter_page::window_enterpictureinpictureevent);
        map.insert(BaseMetricId(3358), &super::use_counter_page::window_external);
        map.insert(BaseMetricId(3359), &super::use_counter_page::window_federatedcredential);
        map.insert(BaseMetricId(3360), &super::use_counter_page::window_gyroscope);
        map.insert(BaseMetricId(3361), &super::use_counter_page::window_htmlcontentelement);
        map.insert(BaseMetricId(3362), &super::use_counter_page::window_htmlshadowelement);
        map.insert(BaseMetricId(3363), &super::use_counter_page::window_imagecapture);
        map.insert(BaseMetricId(3364), &super::use_counter_page::window_inputdevicecapabilities);
        map.insert(BaseMetricId(3365), &super::use_counter_page::window_inputdeviceinfo);
        map.insert(BaseMetricId(3366), &super::use_counter_page::window_keyboard);
        map.insert(BaseMetricId(3367), &super::use_counter_page::window_keyboardlayoutmap);
        map.insert(BaseMetricId(3368), &super::use_counter_page::window_linearaccelerationsensor);
        map.insert(BaseMetricId(3369), &super::use_counter_page::window_mediasettingsrange);
        map.insert(BaseMetricId(3370), &super::use_counter_page::window_midiaccess);
        map.insert(BaseMetricId(3371), &super::use_counter_page::window_midiconnectionevent);
        map.insert(BaseMetricId(3372), &super::use_counter_page::window_midiinput);
        map.insert(BaseMetricId(3373), &super::use_counter_page::window_midiinputmap);
        map.insert(BaseMetricId(3374), &super::use_counter_page::window_midimessageevent);
        map.insert(BaseMetricId(3375), &super::use_counter_page::window_midioutput);
        map.insert(BaseMetricId(3376), &super::use_counter_page::window_midioutputmap);
        map.insert(BaseMetricId(3377), &super::use_counter_page::window_midiport);
        map.insert(BaseMetricId(3378), &super::use_counter_page::window_networkinformation);
        map.insert(BaseMetricId(3379), &super::use_counter_page::window_offscreenbuffering);
        map.insert(BaseMetricId(3380), &super::use_counter_page::window_onbeforeinstallprompt);
        map.insert(BaseMetricId(3381), &super::use_counter_page::window_oncancel);
        map.insert(BaseMetricId(3382), &super::use_counter_page::window_onmousewheel);
        map.insert(BaseMetricId(3383), &super::use_counter_page::window_onorientationchange);
        map.insert(BaseMetricId(3384), &super::use_counter_page::window_onsearch);
        map.insert(BaseMetricId(3385), &super::use_counter_page::window_onselectionchange);
        map.insert(BaseMetricId(3386), &super::use_counter_page::window_open_empty_url);
        map.insert(BaseMetricId(3387), &super::use_counter_page::window_opendatabase);
        map.insert(BaseMetricId(3388), &super::use_counter_page::window_orientation);
        map.insert(BaseMetricId(3389), &super::use_counter_page::window_orientationsensor);
        map.insert(BaseMetricId(3390), &super::use_counter_page::window_overconstrainederror);
        map.insert(BaseMetricId(3391), &super::use_counter_page::window_passwordcredential);
        map.insert(BaseMetricId(3392), &super::use_counter_page::window_paymentaddress);
        map.insert(BaseMetricId(3393), &super::use_counter_page::window_paymentinstruments);
        map.insert(BaseMetricId(3394), &super::use_counter_page::window_paymentmanager);
        map.insert(BaseMetricId(3395), &super::use_counter_page::window_paymentmethodchangeevent);
        map.insert(BaseMetricId(3396), &super::use_counter_page::window_paymentrequest);
        map.insert(BaseMetricId(3397), &super::use_counter_page::window_paymentrequestupdateevent);
        map.insert(BaseMetricId(3398), &super::use_counter_page::window_paymentresponse);
        map.insert(BaseMetricId(3399), &super::use_counter_page::window_performancelongtasktiming);
        map.insert(BaseMetricId(3400), &super::use_counter_page::window_photocapabilities);
        map.insert(BaseMetricId(3401), &super::use_counter_page::window_pictureinpictureevent);
        map.insert(BaseMetricId(3402), &super::use_counter_page::window_pictureinpicturewindow);
        map.insert(BaseMetricId(3403), &super::use_counter_page::window_presentation);
        map.insert(BaseMetricId(3404), &super::use_counter_page::window_presentationavailability);
        map.insert(BaseMetricId(3405), &super::use_counter_page::window_presentationconnection);
        map.insert(BaseMetricId(3406), &super::use_counter_page::window_presentationconnectionavailableevent);
        map.insert(BaseMetricId(3407), &super::use_counter_page::window_presentationconnectioncloseevent);
        map.insert(BaseMetricId(3408), &super::use_counter_page::window_presentationconnectionlist);
        map.insert(BaseMetricId(3409), &super::use_counter_page::window_presentationreceiver);
        map.insert(BaseMetricId(3410), &super::use_counter_page::window_presentationrequest);
        map.insert(BaseMetricId(3411), &super::use_counter_page::window_relativeorientationsensor);
        map.insert(BaseMetricId(3412), &super::use_counter_page::window_remoteplayback);
        map.insert(BaseMetricId(3413), &super::use_counter_page::window_report);
        map.insert(BaseMetricId(3414), &super::use_counter_page::window_reportbody);
        map.insert(BaseMetricId(3415), &super::use_counter_page::window_reportingobserver);
        map.insert(BaseMetricId(3416), &super::use_counter_page::window_rtcerror);
        map.insert(BaseMetricId(3417), &super::use_counter_page::window_rtcerrorevent);
        map.insert(BaseMetricId(3418), &super::use_counter_page::window_rtcicetransport);
        map.insert(BaseMetricId(3419), &super::use_counter_page::window_rtcpeerconnectioniceerrorevent);
        map.insert(BaseMetricId(3420), &super::use_counter_page::window_sensor);
        map.insert(BaseMetricId(3421), &super::use_counter_page::window_sensorerrorevent);
        map.insert(BaseMetricId(3422), &super::use_counter_page::window_sidebar_getter);
        map.insert(BaseMetricId(3423), &super::use_counter_page::window_sidebar_setter);
        map.insert(BaseMetricId(3424), &super::use_counter_page::window_speechrecognitionalternative);
        map.insert(BaseMetricId(3425), &super::use_counter_page::window_speechrecognitionresult);
        map.insert(BaseMetricId(3426), &super::use_counter_page::window_speechrecognitionresultlist);
        map.insert(BaseMetricId(3427), &super::use_counter_page::window_stylemedia);
        map.insert(BaseMetricId(3428), &super::use_counter_page::window_stylepropertymap);
        map.insert(BaseMetricId(3429), &super::use_counter_page::window_stylepropertymapreadonly);
        map.insert(BaseMetricId(3430), &super::use_counter_page::window_svgdiscardelement);
        map.insert(BaseMetricId(3431), &super::use_counter_page::window_syncmanager);
        map.insert(BaseMetricId(3432), &super::use_counter_page::window_taskattributiontiming);
        map.insert(BaseMetricId(3433), &super::use_counter_page::window_textevent);
        map.insert(BaseMetricId(3434), &super::use_counter_page::window_touch);
        map.insert(BaseMetricId(3435), &super::use_counter_page::window_touchevent);
        map.insert(BaseMetricId(3436), &super::use_counter_page::window_touchlist);
        map.insert(BaseMetricId(3437), &super::use_counter_page::window_usb);
        map.insert(BaseMetricId(3438), &super::use_counter_page::window_usbalternateinterface);
        map.insert(BaseMetricId(3439), &super::use_counter_page::window_usbconfiguration);
        map.insert(BaseMetricId(3440), &super::use_counter_page::window_usbconnectionevent);
        map.insert(BaseMetricId(3441), &super::use_counter_page::window_usbdevice);
        map.insert(BaseMetricId(3442), &super::use_counter_page::window_usbendpoint);
        map.insert(BaseMetricId(3443), &super::use_counter_page::window_usbinterface);
        map.insert(BaseMetricId(3444), &super::use_counter_page::window_usbintransferresult);
        map.insert(BaseMetricId(3445), &super::use_counter_page::window_usbisochronousintransferpacket);
        map.insert(BaseMetricId(3446), &super::use_counter_page::window_usbisochronousintransferresult);
        map.insert(BaseMetricId(3447), &super::use_counter_page::window_usbisochronousouttransferpacket);
        map.insert(BaseMetricId(3448), &super::use_counter_page::window_usbisochronousouttransferresult);
        map.insert(BaseMetricId(3449), &super::use_counter_page::window_usbouttransferresult);
        map.insert(BaseMetricId(3450), &super::use_counter_page::window_useractivation);
        map.insert(BaseMetricId(3451), &super::use_counter_page::window_videocolorspace);
        map.insert(BaseMetricId(3452), &super::use_counter_page::window_videodecoder);
        map.insert(BaseMetricId(3453), &super::use_counter_page::window_videoencoder);
        map.insert(BaseMetricId(3454), &super::use_counter_page::window_videoframe);
        map.insert(BaseMetricId(3455), &super::use_counter_page::window_wakelock);
        map.insert(BaseMetricId(3456), &super::use_counter_page::window_wakelocksentinel);
        map.insert(BaseMetricId(3457), &super::use_counter_page::window_webkitcancelanimationframe);
        map.insert(BaseMetricId(3458), &super::use_counter_page::window_webkitmediastream);
        map.insert(BaseMetricId(3459), &super::use_counter_page::window_webkitmutationobserver);
        map.insert(BaseMetricId(3460), &super::use_counter_page::window_webkitrequestanimationframe);
        map.insert(BaseMetricId(3461), &super::use_counter_page::window_webkitrequestfilesystem);
        map.insert(BaseMetricId(3462), &super::use_counter_page::window_webkitresolvelocalfilesystemurl);
        map.insert(BaseMetricId(3463), &super::use_counter_page::window_webkitrtcpeerconnection);
        map.insert(BaseMetricId(3464), &super::use_counter_page::window_webkitspeechgrammar);
        map.insert(BaseMetricId(3465), &super::use_counter_page::window_webkitspeechgrammarlist);
        map.insert(BaseMetricId(3466), &super::use_counter_page::window_webkitspeechrecognition);
        map.insert(BaseMetricId(3467), &super::use_counter_page::window_webkitspeechrecognitionerror);
        map.insert(BaseMetricId(3468), &super::use_counter_page::window_webkitspeechrecognitionevent);
        map.insert(BaseMetricId(3469), &super::use_counter_page::window_webkitstorageinfo);
        map.insert(BaseMetricId(3470), &super::use_counter_page::wr_filter_fallback);
        map.insert(BaseMetricId(3471), &super::use_counter_page::xslstylesheet);
        map.insert(BaseMetricId(3472), &super::use_counter_page::xsltprocessor_constructor);
        map.insert(BaseMetricId(3473), &super::use_counter_page::you_tube_flash_embed);
        map.insert(BaseMetricId(3474), &super::use_counter_worker_dedicated::console_assert);
        map.insert(BaseMetricId(3475), &super::use_counter_worker_dedicated::console_clear);
        map.insert(BaseMetricId(3476), &super::use_counter_worker_dedicated::console_count);
        map.insert(BaseMetricId(3477), &super::use_counter_worker_dedicated::console_countreset);
        map.insert(BaseMetricId(3478), &super::use_counter_worker_dedicated::console_debug);
        map.insert(BaseMetricId(3479), &super::use_counter_worker_dedicated::console_dir);
        map.insert(BaseMetricId(3480), &super::use_counter_worker_dedicated::console_dirxml);
        map.insert(BaseMetricId(3481), &super::use_counter_worker_dedicated::console_error);
        map.insert(BaseMetricId(3482), &super::use_counter_worker_dedicated::console_exception);
        map.insert(BaseMetricId(3483), &super::use_counter_worker_dedicated::console_group);
        map.insert(BaseMetricId(3484), &super::use_counter_worker_dedicated::console_groupcollapsed);
        map.insert(BaseMetricId(3485), &super::use_counter_worker_dedicated::console_groupend);
        map.insert(BaseMetricId(3486), &super::use_counter_worker_dedicated::console_info);
        map.insert(BaseMetricId(3487), &super::use_counter_worker_dedicated::console_log);
        map.insert(BaseMetricId(3488), &super::use_counter_worker_dedicated::console_profile);
        map.insert(BaseMetricId(3489), &super::use_counter_worker_dedicated::console_profileend);
        map.insert(BaseMetricId(3490), &super::use_counter_worker_dedicated::console_table);
        map.insert(BaseMetricId(3491), &super::use_counter_worker_dedicated::console_time);
        map.insert(BaseMetricId(3492), &super::use_counter_worker_dedicated::console_timeend);
        map.insert(BaseMetricId(3493), &super::use_counter_worker_dedicated::console_timelog);
        map.insert(BaseMetricId(3494), &super::use_counter_worker_dedicated::console_timestamp);
        map.insert(BaseMetricId(3495), &super::use_counter_worker_dedicated::console_trace);
        map.insert(BaseMetricId(3496), &super::use_counter_worker_dedicated::console_warn);
        map.insert(BaseMetricId(3497), &super::use_counter_worker_dedicated::cookiestore_delete);
        map.insert(BaseMetricId(3498), &super::use_counter_worker_dedicated::cookiestore_get);
        map.insert(BaseMetricId(3499), &super::use_counter_worker_dedicated::cookiestore_getall);
        map.insert(BaseMetricId(3500), &super::use_counter_worker_dedicated::cookiestore_set);
        map.insert(BaseMetricId(3501), &super::use_counter_worker_dedicated::mls_deriveexporter);
        map.insert(BaseMetricId(3502), &super::use_counter_worker_dedicated::mls_generatecredentialbasic);
        map.insert(BaseMetricId(3503), &super::use_counter_worker_dedicated::mls_generatekeypackage);
        map.insert(BaseMetricId(3504), &super::use_counter_worker_dedicated::mls_generatesignaturekeypair);
        map.insert(BaseMetricId(3505), &super::use_counter_worker_dedicated::mls_groupadd);
        map.insert(BaseMetricId(3506), &super::use_counter_worker_dedicated::mls_groupclose);
        map.insert(BaseMetricId(3507), &super::use_counter_worker_dedicated::mls_groupcreate);
        map.insert(BaseMetricId(3508), &super::use_counter_worker_dedicated::mls_groupjoin);
        map.insert(BaseMetricId(3509), &super::use_counter_worker_dedicated::mls_groupmembers);
        map.insert(BaseMetricId(3510), &super::use_counter_worker_dedicated::mls_groupproposeadd);
        map.insert(BaseMetricId(3511), &super::use_counter_worker_dedicated::mls_groupproposeremove);
        map.insert(BaseMetricId(3512), &super::use_counter_worker_dedicated::mls_groupremove);
        map.insert(BaseMetricId(3513), &super::use_counter_worker_dedicated::mls_receive);
        map.insert(BaseMetricId(3514), &super::use_counter_worker_dedicated::mls_send);
        map.insert(BaseMetricId(3515), &super::use_counter_worker_dedicated::mls_statedelete);
        map.insert(BaseMetricId(3516), &super::use_counter_worker_dedicated::mls_statedeletegroup);
        map.insert(BaseMetricId(3517), &super::use_counter_worker_dedicated::private_browsing_caches_delete);
        map.insert(BaseMetricId(3518), &super::use_counter_worker_dedicated::private_browsing_caches_has);
        map.insert(BaseMetricId(3519), &super::use_counter_worker_dedicated::private_browsing_caches_keys);
        map.insert(BaseMetricId(3520), &super::use_counter_worker_dedicated::private_browsing_caches_match);
        map.insert(BaseMetricId(3521), &super::use_counter_worker_dedicated::private_browsing_caches_open);
        map.insert(BaseMetricId(3522), &super::use_counter_worker_dedicated::private_browsing_idbfactory_delete_database);
        map.insert(BaseMetricId(3523), &super::use_counter_worker_dedicated::private_browsing_idbfactory_open);
        map.insert(BaseMetricId(3524), &super::use_counter_worker_dedicated::pushmanager_subscribe);
        map.insert(BaseMetricId(3525), &super::use_counter_worker_dedicated::pushsubscription_unsubscribe);
        map.insert(BaseMetricId(3526), &super::use_counter_worker_dedicated::scheduler_posttask);
        map.insert(BaseMetricId(3527), &super::use_counter_worker_service::console_assert);
        map.insert(BaseMetricId(3528), &super::use_counter_worker_service::console_clear);
        map.insert(BaseMetricId(3529), &super::use_counter_worker_service::console_count);
        map.insert(BaseMetricId(3530), &super::use_counter_worker_service::console_countreset);
        map.insert(BaseMetricId(3531), &super::use_counter_worker_service::console_debug);
        map.insert(BaseMetricId(3532), &super::use_counter_worker_service::console_dir);
        map.insert(BaseMetricId(3533), &super::use_counter_worker_service::console_dirxml);
        map.insert(BaseMetricId(3534), &super::use_counter_worker_service::console_error);
        map.insert(BaseMetricId(3535), &super::use_counter_worker_service::console_exception);
        map.insert(BaseMetricId(3536), &super::use_counter_worker_service::console_group);
        map.insert(BaseMetricId(3537), &super::use_counter_worker_service::console_groupcollapsed);
        map.insert(BaseMetricId(3538), &super::use_counter_worker_service::console_groupend);
        map.insert(BaseMetricId(3539), &super::use_counter_worker_service::console_info);
        map.insert(BaseMetricId(3540), &super::use_counter_worker_service::console_log);
        map.insert(BaseMetricId(3541), &super::use_counter_worker_service::console_profile);
        map.insert(BaseMetricId(3542), &super::use_counter_worker_service::console_profileend);
        map.insert(BaseMetricId(3543), &super::use_counter_worker_service::console_table);
        map.insert(BaseMetricId(3544), &super::use_counter_worker_service::console_time);
        map.insert(BaseMetricId(3545), &super::use_counter_worker_service::console_timeend);
        map.insert(BaseMetricId(3546), &super::use_counter_worker_service::console_timelog);
        map.insert(BaseMetricId(3547), &super::use_counter_worker_service::console_timestamp);
        map.insert(BaseMetricId(3548), &super::use_counter_worker_service::console_trace);
        map.insert(BaseMetricId(3549), &super::use_counter_worker_service::console_warn);
        map.insert(BaseMetricId(3550), &super::use_counter_worker_service::cookiestore_delete);
        map.insert(BaseMetricId(3551), &super::use_counter_worker_service::cookiestore_get);
        map.insert(BaseMetricId(3552), &super::use_counter_worker_service::cookiestore_getall);
        map.insert(BaseMetricId(3553), &super::use_counter_worker_service::cookiestore_set);
        map.insert(BaseMetricId(3554), &super::use_counter_worker_service::mls_deriveexporter);
        map.insert(BaseMetricId(3555), &super::use_counter_worker_service::mls_generatecredentialbasic);
        map.insert(BaseMetricId(3556), &super::use_counter_worker_service::mls_generatekeypackage);
        map.insert(BaseMetricId(3557), &super::use_counter_worker_service::mls_generatesignaturekeypair);
        map.insert(BaseMetricId(3558), &super::use_counter_worker_service::mls_groupadd);
        map.insert(BaseMetricId(3559), &super::use_counter_worker_service::mls_groupclose);
        map.insert(BaseMetricId(3560), &super::use_counter_worker_service::mls_groupcreate);
        map.insert(BaseMetricId(3561), &super::use_counter_worker_service::mls_groupjoin);
        map.insert(BaseMetricId(3562), &super::use_counter_worker_service::mls_groupmembers);
        map.insert(BaseMetricId(3563), &super::use_counter_worker_service::mls_groupproposeadd);
        map.insert(BaseMetricId(3564), &super::use_counter_worker_service::mls_groupproposeremove);
        map.insert(BaseMetricId(3565), &super::use_counter_worker_service::mls_groupremove);
        map.insert(BaseMetricId(3566), &super::use_counter_worker_service::mls_receive);
        map.insert(BaseMetricId(3567), &super::use_counter_worker_service::mls_send);
        map.insert(BaseMetricId(3568), &super::use_counter_worker_service::mls_statedelete);
        map.insert(BaseMetricId(3569), &super::use_counter_worker_service::mls_statedeletegroup);
        map.insert(BaseMetricId(3570), &super::use_counter_worker_service::private_browsing_caches_delete);
        map.insert(BaseMetricId(3571), &super::use_counter_worker_service::private_browsing_caches_has);
        map.insert(BaseMetricId(3572), &super::use_counter_worker_service::private_browsing_caches_keys);
        map.insert(BaseMetricId(3573), &super::use_counter_worker_service::private_browsing_caches_match);
        map.insert(BaseMetricId(3574), &super::use_counter_worker_service::private_browsing_caches_open);
        map.insert(BaseMetricId(3575), &super::use_counter_worker_service::private_browsing_idbfactory_delete_database);
        map.insert(BaseMetricId(3576), &super::use_counter_worker_service::private_browsing_idbfactory_open);
        map.insert(BaseMetricId(3577), &super::use_counter_worker_service::pushmanager_subscribe);
        map.insert(BaseMetricId(3578), &super::use_counter_worker_service::pushsubscription_unsubscribe);
        map.insert(BaseMetricId(3579), &super::use_counter_worker_service::scheduler_posttask);
        map.insert(BaseMetricId(3580), &super::use_counter_worker_shared::console_assert);
        map.insert(BaseMetricId(3581), &super::use_counter_worker_shared::console_clear);
        map.insert(BaseMetricId(3582), &super::use_counter_worker_shared::console_count);
        map.insert(BaseMetricId(3583), &super::use_counter_worker_shared::console_countreset);
        map.insert(BaseMetricId(3584), &super::use_counter_worker_shared::console_debug);
        map.insert(BaseMetricId(3585), &super::use_counter_worker_shared::console_dir);
        map.insert(BaseMetricId(3586), &super::use_counter_worker_shared::console_dirxml);
        map.insert(BaseMetricId(3587), &super::use_counter_worker_shared::console_error);
        map.insert(BaseMetricId(3588), &super::use_counter_worker_shared::console_exception);
        map.insert(BaseMetricId(3589), &super::use_counter_worker_shared::console_group);
        map.insert(BaseMetricId(3590), &super::use_counter_worker_shared::console_groupcollapsed);
        map.insert(BaseMetricId(3591), &super::use_counter_worker_shared::console_groupend);
        map.insert(BaseMetricId(3592), &super::use_counter_worker_shared::console_info);
        map.insert(BaseMetricId(3593), &super::use_counter_worker_shared::console_log);
        map.insert(BaseMetricId(3594), &super::use_counter_worker_shared::console_profile);
        map.insert(BaseMetricId(3595), &super::use_counter_worker_shared::console_profileend);
        map.insert(BaseMetricId(3596), &super::use_counter_worker_shared::console_table);
        map.insert(BaseMetricId(3597), &super::use_counter_worker_shared::console_time);
        map.insert(BaseMetricId(3598), &super::use_counter_worker_shared::console_timeend);
        map.insert(BaseMetricId(3599), &super::use_counter_worker_shared::console_timelog);
        map.insert(BaseMetricId(3600), &super::use_counter_worker_shared::console_timestamp);
        map.insert(BaseMetricId(3601), &super::use_counter_worker_shared::console_trace);
        map.insert(BaseMetricId(3602), &super::use_counter_worker_shared::console_warn);
        map.insert(BaseMetricId(3603), &super::use_counter_worker_shared::cookiestore_delete);
        map.insert(BaseMetricId(3604), &super::use_counter_worker_shared::cookiestore_get);
        map.insert(BaseMetricId(3605), &super::use_counter_worker_shared::cookiestore_getall);
        map.insert(BaseMetricId(3606), &super::use_counter_worker_shared::cookiestore_set);
        map.insert(BaseMetricId(3607), &super::use_counter_worker_shared::mls_deriveexporter);
        map.insert(BaseMetricId(3608), &super::use_counter_worker_shared::mls_generatecredentialbasic);
        map.insert(BaseMetricId(3609), &super::use_counter_worker_shared::mls_generatekeypackage);
        map.insert(BaseMetricId(3610), &super::use_counter_worker_shared::mls_generatesignaturekeypair);
        map.insert(BaseMetricId(3611), &super::use_counter_worker_shared::mls_groupadd);
        map.insert(BaseMetricId(3612), &super::use_counter_worker_shared::mls_groupclose);
        map.insert(BaseMetricId(3613), &super::use_counter_worker_shared::mls_groupcreate);
        map.insert(BaseMetricId(3614), &super::use_counter_worker_shared::mls_groupjoin);
        map.insert(BaseMetricId(3615), &super::use_counter_worker_shared::mls_groupmembers);
        map.insert(BaseMetricId(3616), &super::use_counter_worker_shared::mls_groupproposeadd);
        map.insert(BaseMetricId(3617), &super::use_counter_worker_shared::mls_groupproposeremove);
        map.insert(BaseMetricId(3618), &super::use_counter_worker_shared::mls_groupremove);
        map.insert(BaseMetricId(3619), &super::use_counter_worker_shared::mls_receive);
        map.insert(BaseMetricId(3620), &super::use_counter_worker_shared::mls_send);
        map.insert(BaseMetricId(3621), &super::use_counter_worker_shared::mls_statedelete);
        map.insert(BaseMetricId(3622), &super::use_counter_worker_shared::mls_statedeletegroup);
        map.insert(BaseMetricId(3623), &super::use_counter_worker_shared::private_browsing_caches_delete);
        map.insert(BaseMetricId(3624), &super::use_counter_worker_shared::private_browsing_caches_has);
        map.insert(BaseMetricId(3625), &super::use_counter_worker_shared::private_browsing_caches_keys);
        map.insert(BaseMetricId(3626), &super::use_counter_worker_shared::private_browsing_caches_match);
        map.insert(BaseMetricId(3627), &super::use_counter_worker_shared::private_browsing_caches_open);
        map.insert(BaseMetricId(3628), &super::use_counter_worker_shared::private_browsing_idbfactory_delete_database);
        map.insert(BaseMetricId(3629), &super::use_counter_worker_shared::private_browsing_idbfactory_open);
        map.insert(BaseMetricId(3630), &super::use_counter_worker_shared::pushmanager_subscribe);
        map.insert(BaseMetricId(3631), &super::use_counter_worker_shared::pushsubscription_unsubscribe);
        map.insert(BaseMetricId(3632), &super::use_counter_worker_shared::scheduler_posttask);
        map.insert(BaseMetricId(3653), &super::localstorage_request::recv_cancel_counter);
        map.insert(BaseMetricId(3654), &super::localstorage_request::send_cancel_counter);
        map.insert(BaseMetricId(3657), &super::hls::canplay_requested);
        map.insert(BaseMetricId(3658), &super::hls::canplay_supported);
        map.insert(BaseMetricId(3663), &super::media::element_in_page_count);
        map.insert(BaseMetricId(3719), &super::webrtc::call_count_3);
        map.insert(BaseMetricId(3756), &super::webrtcdtls::client_handshake_started_counter);
        map.insert(BaseMetricId(3759), &super::webrtcdtls::server_handshake_started_counter);
        map.insert(BaseMetricId(3769), &super::dom::slow_script_notice_count);
        map.insert(BaseMetricId(3770), &super::dom::slow_script_page_count);
        map.insert(BaseMetricId(3774), &super::dom_contentprocess::build_id_mismatch);
        map.insert(BaseMetricId(3775), &super::dom_contentprocess::build_id_mismatch_false_positive);
        map.insert(BaseMetricId(3779), &super::dom_contentprocess::os_priority_change_considered);
        map.insert(BaseMetricId(3780), &super::dom_contentprocess::os_priority_lowered);
        map.insert(BaseMetricId(3781), &super::dom_contentprocess::os_priority_raised);
        map.insert(BaseMetricId(3822), &super::web_notification::insecure_context_permission_request);
        map.insert(BaseMetricId(3828), &super::web_push::api_notify);
        map.insert(BaseMetricId(3830), &super::web_push::detected_duplicated_message_ids);
        map.insert(BaseMetricId(3832), &super::web_push::unsubscribed_by_clearing_data);
        map.insert(BaseMetricId(3836), &super::quotamanager::restore_origin_directory_metadata_counter);
        map.insert(BaseMetricId(3846), &super::httpsfirst::upgraded);
        map.insert(BaseMetricId(3847), &super::httpsfirst::upgraded_schemeless);
        map.insert(BaseMetricId(3866), &super::webauthn_create::failure);
        map.insert(BaseMetricId(3867), &super::webauthn_create::passkey);
        map.insert(BaseMetricId(3868), &super::webauthn_create::success);
        map.insert(BaseMetricId(3870), &super::webauthn_get::failure);
        map.insert(BaseMetricId(3871), &super::webauthn_get::success);
        map.insert(BaseMetricId(3872), &super::workers::dedicated_worker_spawn_gets_queued);
        map.insert(BaseMetricId(3873), &super::workers::service_worker_spawn_gets_queued);
        map.insert(BaseMetricId(3874), &super::workers::shared_worker_spawn_gets_queued);
        map.insert(BaseMetricId(3880), &super::permissions::defective_sql_removed);
        map.insert(BaseMetricId(3881), &super::permissions::sql_corrupted);
        map.insert(BaseMetricId(3911), &super::gfx::skipped_composites);
        map.insert(BaseMetricId(3958), &super::webfont::per_page);
        map.insert(BaseMetricId(4059), &super::script_preloader::mainthread_recompile);
        map.insert(BaseMetricId(4209), &super::network_sso::total_entra_uses);
        map.insert(BaseMetricId(4301), &super::netwerk::parent_connect_timeout);
        map.insert(BaseMetricId(4302), &super::opaque_response_blocking::cross_origin_opaque_response_count);
        map.insert(BaseMetricId(4303), &super::opaque_response_blocking::javascript_validation_count);
        map.insert(BaseMetricId(4459), &super::bounce_tracking_protection::purge_count_classified_tracker);
        map.insert(BaseMetricId(4478), &super::contentblocking::trackers_blocked_count);
        map.insert(BaseMetricId(4513), &super::captcha_detection::arkoselabs_oc);
        map.insert(BaseMetricId(4514), &super::captcha_detection::arkoselabs_oc_pbm);
        map.insert(BaseMetricId(4515), &super::captcha_detection::arkoselabs_pc);
        map.insert(BaseMetricId(4516), &super::captcha_detection::arkoselabs_pc_pbm);
        map.insert(BaseMetricId(4517), &super::captcha_detection::arkoselabs_pf);
        map.insert(BaseMetricId(4518), &super::captcha_detection::arkoselabs_pf_pbm);
        map.insert(BaseMetricId(4519), &super::captcha_detection::arkoselabs_ps);
        map.insert(BaseMetricId(4520), &super::captcha_detection::arkoselabs_ps_pbm);
        map.insert(BaseMetricId(4523), &super::captcha_detection::cloudflare_turnstile_cc);
        map.insert(BaseMetricId(4524), &super::captcha_detection::cloudflare_turnstile_cc_pbm);
        map.insert(BaseMetricId(4525), &super::captcha_detection::cloudflare_turnstile_cf);
        map.insert(BaseMetricId(4526), &super::captcha_detection::cloudflare_turnstile_cf_pbm);
        map.insert(BaseMetricId(4527), &super::captcha_detection::cloudflare_turnstile_oc);
        map.insert(BaseMetricId(4528), &super::captcha_detection::cloudflare_turnstile_oc_pbm);
        map.insert(BaseMetricId(4529), &super::captcha_detection::datadome_bl);
        map.insert(BaseMetricId(4530), &super::captcha_detection::datadome_bl_pbm);
        map.insert(BaseMetricId(4531), &super::captcha_detection::datadome_oc);
        map.insert(BaseMetricId(4532), &super::captcha_detection::datadome_pc);
        map.insert(BaseMetricId(4533), &super::captcha_detection::datadome_pc_pbm);
        map.insert(BaseMetricId(4534), &super::captcha_detection::datadome_ps);
        map.insert(BaseMetricId(4535), &super::captcha_detection::datadome_ps_pbm);
        map.insert(BaseMetricId(4536), &super::captcha_detection::google_recaptcha_v2_ac);
        map.insert(BaseMetricId(4537), &super::captcha_detection::google_recaptcha_v2_ac_pbm);
        map.insert(BaseMetricId(4538), &super::captcha_detection::google_recaptcha_v2_oc);
        map.insert(BaseMetricId(4539), &super::captcha_detection::google_recaptcha_v2_oc_pbm);
        map.insert(BaseMetricId(4540), &super::captcha_detection::google_recaptcha_v2_pc);
        map.insert(BaseMetricId(4541), &super::captcha_detection::google_recaptcha_v2_pc_pbm);
        map.insert(BaseMetricId(4542), &super::captcha_detection::google_recaptcha_v2_ps);
        map.insert(BaseMetricId(4543), &super::captcha_detection::google_recaptcha_v2_ps_pbm);
        map.insert(BaseMetricId(4544), &super::captcha_detection::hcaptcha_ac);
        map.insert(BaseMetricId(4545), &super::captcha_detection::hcaptcha_ac_pbm);
        map.insert(BaseMetricId(4546), &super::captcha_detection::hcaptcha_oc);
        map.insert(BaseMetricId(4547), &super::captcha_detection::hcaptcha_oc_pbm);
        map.insert(BaseMetricId(4548), &super::captcha_detection::hcaptcha_pc);
        map.insert(BaseMetricId(4549), &super::captcha_detection::hcaptcha_pc_pbm);
        map.insert(BaseMetricId(4550), &super::captcha_detection::hcaptcha_ps);
        map.insert(BaseMetricId(4551), &super::captcha_detection::hcaptcha_ps_pbm);
        map.insert(BaseMetricId(4555), &super::captcha_detection::pages_visited);
        map.insert(BaseMetricId(4556), &super::captcha_detection::pages_visited_pbm);
        map.insert(BaseMetricId(4602), &super::crash_submission::failure);
        map.insert(BaseMetricId(4603), &super::crash_submission::pending);
        map.insert(BaseMetricId(4604), &super::crash_submission::success);
        map.insert(BaseMetricId(4767), &super::fog::inits_during_shutdown);
        map.insert(BaseMetricId(4771), &super::fog_ipc::flush_failures);
        map.insert(BaseMetricId(4772), &super::fog_ipc::replay_failures);
        map.insert(BaseMetricId(4773), &super::fog_ipc::shutdown_registration_failures);
        map.insert(BaseMetricId(4774), &super::test_only::bad_code);
        map.insert(BaseMetricId(4781), &super::test_only::collection_disabled_counter);
        map.insert(BaseMetricId(4783), &super::test_only::default_products);
        map.insert(BaseMetricId(4784), &super::test_only::desktop_only);
        map.insert(BaseMetricId(4785), &super::test_only::disabled_counter);
        map.insert(BaseMetricId(4787), &super::test_only::expired);
        map.insert(BaseMetricId(4808), &super::test_only::mobile_only);
        map.insert(BaseMetricId(4809), &super::test_only::multiproduct);
        map.insert(BaseMetricId(4811), &super::test_only::release_optin);
        map.insert(BaseMetricId(4812), &super::test_only::release_optout);
        map.insert(BaseMetricId(4813), &super::test_only::unexpired);
        map.insert(BaseMetricId(4820), &super::test_only_ipc::a_counter);
        map.insert(BaseMetricId(4821), &super::test_only_ipc::a_counter_for_hgram);
        map.insert(BaseMetricId(4845), &super::test_only_jog::a_counter);
        map.insert(BaseMetricId(5021), &super::pdfjs::used);
        map.insert(BaseMetricId(5023), &super::pdfjs_editing_highlight::color_changed);
        map.insert(BaseMetricId(5024), &super::pdfjs_editing_highlight::deleted);
        map.insert(BaseMetricId(5025), &super::pdfjs_editing_highlight::edited);
        map.insert(BaseMetricId(5029), &super::pdfjs_editing_highlight::print);
        map.insert(BaseMetricId(5030), &super::pdfjs_editing_highlight::save);
        map.insert(BaseMetricId(5032), &super::pdfjs_editing_highlight::thickness_changed);
        map.insert(BaseMetricId(5033), &super::pdfjs_editing_highlight::toggle_visibility);
        map.insert(BaseMetricId(5096), &super::page_icon::fit_icon_count);
        map.insert(BaseMetricId(5097), &super::page_icon::small_icon_count);
        map.insert(BaseMetricId(5118), &super::places::sponsored_visit_no_triggering_url);
        map.insert(BaseMetricId(5121), &super::printing::dialog_opened_via_preview_tm);
        map.insert(BaseMetricId(5122), &super::printing::dialog_via_preview_cancelled_tm);
        map.insert(BaseMetricId(5124), &super::printing::preview_cancelled_tm);
        map.insert(BaseMetricId(5125), &super::printing::preview_opened_tm);
        map.insert(BaseMetricId(5127), &super::printing::silent_print);
        map.insert(BaseMetricId(5129), &super::power::cpu_time_bogus_values);
        map.insert(BaseMetricId(5133), &super::power::gpu_time_bogus_values);
        map.insert(BaseMetricId(5135), &super::power::total_cpu_time_ms);
        map.insert(BaseMetricId(5136), &super::power::total_gpu_time_ms);
        map.insert(BaseMetricId(5137), &super::power::total_thread_wakeups);
        map.insert(BaseMetricId(5530), &super::telemetry::archive_session_ping_count);
        map.insert(BaseMetricId(5540), &super::telemetry::invalid_payload_submitted);
        map.insert(BaseMetricId(5544), &super::telemetry::pending_load_failure_parse);
        map.insert(BaseMetricId(5545), &super::telemetry::pending_load_failure_read);
        map.insert(BaseMetricId(5549), &super::telemetry::ping_evicted_for_server_errors);
        map.insert(BaseMetricId(5550), &super::telemetry::ping_size_exceeded_archived);
        map.insert(BaseMetricId(5551), &super::telemetry::ping_size_exceeded_pending);
        map.insert(BaseMetricId(5552), &super::telemetry::ping_size_exceeded_send);
        map.insert(BaseMetricId(5553), &super::telemetry::ping_submission_waiting_clientid);
        map.insert(BaseMetricId(5645), &super::findbar::find_next);
        map.insert(BaseMetricId(5646), &super::findbar::find_prev);
        map.insert(BaseMetricId(5647), &super::findbar::highlight_all);
        map.insert(BaseMetricId(5648), &super::findbar::match_case);
        map.insert(BaseMetricId(5649), &super::findbar::match_diacritics);
        map.insert(BaseMetricId(5650), &super::findbar::shown);
        map.insert(BaseMetricId(5651), &super::findbar::whole_words);
        map.insert(BaseMetricId(5785), &super::update::cannot_stage_external);
        map.insert(BaseMetricId(5786), &super::update::cannot_stage_notify);
        map.insert(BaseMetricId(5787), &super::update::cannot_stage_subsequent);
        map.insert(BaseMetricId(5794), &super::update::check_no_update_external);
        map.insert(BaseMetricId(5795), &super::update::check_no_update_notify);
        map.insert(BaseMetricId(5796), &super::update::check_no_update_subsequent);
        map.insert(BaseMetricId(5800), &super::update::invalid_lastupdatetime_external);
        map.insert(BaseMetricId(5801), &super::update::invalid_lastupdatetime_notify);
        map.insert(BaseMetricId(5802), &super::update::invalid_lastupdatetime_subsequent);
        map.insert(BaseMetricId(5807), &super::update::not_pref_update_auto_external);
        map.insert(BaseMetricId(5808), &super::update::not_pref_update_auto_notify);
        map.insert(BaseMetricId(5809), &super::update::not_pref_update_auto_subsequent);
        map.insert(BaseMetricId(5810), &super::update::not_pref_update_service_enabled_external);
        map.insert(BaseMetricId(5811), &super::update::not_pref_update_service_enabled_notify);
        map.insert(BaseMetricId(5812), &super::update::not_pref_update_service_enabled_subsequent);
        map.insert(BaseMetricId(5813), &super::update::not_pref_update_staging_enabled_external);
        map.insert(BaseMetricId(5814), &super::update::not_pref_update_staging_enabled_notify);
        map.insert(BaseMetricId(5815), &super::update::not_pref_update_staging_enabled_subsequent);
        map.insert(BaseMetricId(5821), &super::update::ping_count_external);
        map.insert(BaseMetricId(5822), &super::update::ping_count_notify);
        map.insert(BaseMetricId(5823), &super::update::ping_count_subsequent);
        map.insert(BaseMetricId(5833), &super::update::service_manually_uninstalled_external);
        map.insert(BaseMetricId(5834), &super::update::service_manually_uninstalled_notify);
        map.insert(BaseMetricId(5835), &super::update::service_manually_uninstalled_subsequent);
        map.insert(BaseMetricId(5848), &super::update::unable_to_apply_external);
        map.insert(BaseMetricId(5849), &super::update::unable_to_apply_notify);
        map.insert(BaseMetricId(5850), &super::update::unable_to_apply_subsequent);
        map.insert(BaseMetricId(5853), &super::update::no_window_auto_restarts);
        map
    });

    pub static MEMORY_DISTRIBUTION_MAP: Lazy<HashMap<BaseMetricId, &Lazy<MemoryDistributionMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(57);
        map.insert(BaseMetricId(50), &super::networking::cache_metadata_size);
        map.insert(BaseMetricId(98), &super::networking::http_3_udp_datagram_segment_size_received);
        map.insert(BaseMetricId(99), &super::networking::http_3_udp_datagram_segment_size_sent);
        map.insert(BaseMetricId(101), &super::networking::http_3_udp_datagram_size_received);
        map.insert(BaseMetricId(257), &super::browser_backup::compressed_archive_size);
        map.insert(BaseMetricId(287), &super::browser_backup::total_backup_size);
        map.insert(BaseMetricId(803), &super::session_restore::file_size_bytes);
        map.insert(BaseMetricId(3959), &super::webfont::size);
        map.insert(BaseMetricId(3960), &super::webfont::size_per_page);
        map.insert(BaseMetricId(3999), &super::image_decode::speed_avif);
        map.insert(BaseMetricId(4000), &super::image_decode::speed_gif);
        map.insert(BaseMetricId(4001), &super::image_decode::speed_jpeg);
        map.insert(BaseMetricId(4002), &super::image_decode::speed_png);
        map.insert(BaseMetricId(4003), &super::image_decode::speed_webp);
        map.insert(BaseMetricId(4031), &super::javascript_gc::nursery_bytes);
        map.insert(BaseMetricId(4057), &super::performance_clone_deserialize::size);
        map.insert(BaseMetricId(4143), &super::network::race_cache_bandwidth_not_race);
        map.insert(BaseMetricId(4144), &super::network::race_cache_bandwidth_race_cache_win);
        map.insert(BaseMetricId(4145), &super::network::race_cache_bandwidth_race_network_win);
        map.insert(BaseMetricId(4233), &super::hpack::bytes_evicted_compressor);
        map.insert(BaseMetricId(4234), &super::hpack::bytes_evicted_decompressor);
        map.insert(BaseMetricId(4241), &super::hpack::peak_size_compressor);
        map.insert(BaseMetricId(4242), &super::hpack::peak_size_decompressor);
        map.insert(BaseMetricId(4258), &super::http::kbread_per_conn2);
        map.insert(BaseMetricId(4309), &super::spdy::chunk_recvd);
        map.insert(BaseMetricId(4310), &super::spdy::continued_headers);
        map.insert(BaseMetricId(4313), &super::spdy::kbread_per_conn);
        map.insert(BaseMetricId(4317), &super::spdy::settings_iw);
        map.insert(BaseMetricId(4321), &super::spdy::syn_reply_size);
        map.insert(BaseMetricId(4322), &super::spdy::syn_size);
        map.insert(BaseMetricId(4346), &super::cert_storage::memory);
        map.insert(BaseMetricId(4360), &super::ssl::bytes_before_cert_callback);
        map.insert(BaseMetricId(4579), &super::crash::compressed_store_size);
        map.insert(BaseMetricId(4627), &super::memory::heap_allocated);
        map.insert(BaseMetricId(4629), &super::memory::images_content_used_uncompressed);
        map.insert(BaseMetricId(4632), &super::memory::js_gc_heap);
        map.insert(BaseMetricId(4637), &super::memory::resident_fast);
        map.insert(BaseMetricId(4638), &super::memory::resident_peak);
        map.insert(BaseMetricId(4639), &super::memory::storage_sqlite);
        map.insert(BaseMetricId(4640), &super::memory::total);
        map.insert(BaseMetricId(4641), &super::memory::unique);
        map.insert(BaseMetricId(4642), &super::memory::unique_content_startup);
        map.insert(BaseMetricId(4643), &super::memory::vsize);
        map.insert(BaseMetricId(4644), &super::memory::vsize_max_contiguous);
        map.insert(BaseMetricId(4669), &super::extensions_apis_dnr::startup_cache_read_size);
        map.insert(BaseMetricId(4671), &super::extensions_apis_dnr::startup_cache_write_size);
        map.insert(BaseMetricId(4769), &super::fog_ipc::buffer_sizes);
        map.insert(BaseMetricId(4786), &super::test_only::do_you_remember);
        map.insert(BaseMetricId(4828), &super::test_only_ipc::a_memory_dist);
        map.insert(BaseMetricId(5103), &super::places::database_favicons_filesize);
        map.insert(BaseMetricId(5104), &super::places::database_filesize);
        map.insert(BaseMetricId(5531), &super::telemetry::archive_size);
        map.insert(BaseMetricId(5534), &super::telemetry::discarded_archived_pings_size);
        map.insert(BaseMetricId(5535), &super::telemetry::discarded_pending_pings_size);
        map.insert(BaseMetricId(5536), &super::telemetry::discarded_send_pings_size);
        map.insert(BaseMetricId(5548), &super::telemetry::pending_pings_size);
        map.insert(BaseMetricId(5893), &super::memory_phc::slop);
        map
    });

    pub static DENOMINATOR_MAP: Lazy<HashMap<BaseMetricId, &Lazy<DenominatorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(10);
        map.insert(BaseMetricId(165), &super::networking::set_cookie);
        map.insert(BaseMetricId(3699), &super::rtcrtpsender::count);
        map.insert(BaseMetricId(3700), &super::rtcrtpsender::count_setparameters_compat);
        map.insert(BaseMetricId(3842), &super::httpsfirst::downgraded);
        map.insert(BaseMetricId(3845), &super::httpsfirst::downgraded_schemeless);
        map.insert(BaseMetricId(4327), &super::cert_signature_cache::total);
        map.insert(BaseMetricId(4329), &super::cert_trust_cache::total);
        map.insert(BaseMetricId(4335), &super::sct_signature_cache::total);
        map.insert(BaseMetricId(4400), &super::tls::certificate_verifications);
        map.insert(BaseMetricId(4837), &super::test_only_ipc::an_external_denominator);
        map
    });

    pub static NUMERATOR_MAP: Lazy<HashMap<BaseMetricId, &Lazy<NumeratorMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(25);
        map.insert(BaseMetricId(166), &super::networking::set_cookie_foreign);
        map.insert(BaseMetricId(167), &super::networking::set_cookie_foreign_partitioned);
        map.insert(BaseMetricId(168), &super::networking::set_cookie_partitioned);
        map.insert(BaseMetricId(3701), &super::rtcrtpsender::used_sendencodings);
        map.insert(BaseMetricId(3702), &super::rtcrtpsender_setparameters::fail_length_changed);
        map.insert(BaseMetricId(3703), &super::rtcrtpsender_setparameters::fail_no_encodings);
        map.insert(BaseMetricId(3704), &super::rtcrtpsender_setparameters::fail_no_getparameters);
        map.insert(BaseMetricId(3705), &super::rtcrtpsender_setparameters::fail_no_transactionid);
        map.insert(BaseMetricId(3706), &super::rtcrtpsender_setparameters::fail_other);
        map.insert(BaseMetricId(3707), &super::rtcrtpsender_setparameters::fail_rid_changed);
        map.insert(BaseMetricId(3708), &super::rtcrtpsender_setparameters::fail_stale_transactionid);
        map.insert(BaseMetricId(3709), &super::rtcrtpsender_setparameters::warn_length_changed);
        map.insert(BaseMetricId(3710), &super::rtcrtpsender_setparameters::warn_no_getparameters);
        map.insert(BaseMetricId(3711), &super::rtcrtpsender_setparameters::warn_no_transactionid);
        map.insert(BaseMetricId(3843), &super::httpsfirst::downgraded_on_timer);
        map.insert(BaseMetricId(3844), &super::httpsfirst::downgraded_on_timer_schemeless);
        map.insert(BaseMetricId(4326), &super::cert_signature_cache::hits);
        map.insert(BaseMetricId(4328), &super::cert_trust_cache::hits);
        map.insert(BaseMetricId(4334), &super::sct_signature_cache::hits);
        map.insert(BaseMetricId(4403), &super::verification_used_cert_from::built_in_roots_module);
        map.insert(BaseMetricId(4404), &super::verification_used_cert_from::nss_cert_db);
        map.insert(BaseMetricId(4405), &super::verification_used_cert_from::preloaded_intermediates);
        map.insert(BaseMetricId(4406), &super::verification_used_cert_from::third_party_certificates);
        map.insert(BaseMetricId(4407), &super::verification_used_cert_from::tls_handshake);
        map.insert(BaseMetricId(4844), &super::test_only_ipc::rate_with_external_denominator);
        map
    });

    pub static UUID_MAP: Lazy<HashMap<BaseMetricId, &Lazy<UuidMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(16);
        map.insert(BaseMetricId(219), &super::messaging_system::browser_session_id);
        map.insert(BaseMetricId(221), &super::messaging_system::client_id);
        map.insert(BaseMetricId(233), &super::messaging_system::impression_id);
        map.insert(BaseMetricId(365), &super::background_update::client_id);
        map.insert(BaseMetricId(592), &super::top_sites::context_id);
        map.insert(BaseMetricId(623), &super::pocket_button::impression_id);
        map.insert(BaseMetricId(769), &super::search_with::context_id);
        map.insert(BaseMetricId(958), &super::quick_suggest::context_id);
        map.insert(BaseMetricId(4413), &super::client_association::legacy_client_id);
        map.insert(BaseMetricId(4816), &super::test_only::what_id_it);
        map.insert(BaseMetricId(4835), &super::test_only_ipc::a_uuid);
        map.insert(BaseMetricId(5249), &super::characteristics::client_identifier);
        map.insert(BaseMetricId(5517), &super::legacy_telemetry::client_id);
        map.insert(BaseMetricId(5518), &super::legacy_telemetry::profile_group_id);
        map.insert(BaseMetricId(5567), &super::usage::profile_group_id);
        map.insert(BaseMetricId(5568), &super::usage::profile_id);
        map
    });

    pub static TEXT_MAP: Lazy<HashMap<BaseMetricId, &Lazy<TextMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(57);
        map.insert(BaseMetricId(223), &super::messaging_system::event_context);
        map.insert(BaseMetricId(227), &super::messaging_system::event_screen_family);
        map.insert(BaseMetricId(228), &super::messaging_system::event_screen_id);
        map.insert(BaseMetricId(230), &super::messaging_system::event_screen_initials);
        map.insert(BaseMetricId(236), &super::messaging_system::message_id);
        map.insert(BaseMetricId(587), &super::pocket::shim);
        map.insert(BaseMetricId(607), &super::topsites::sponsored_tiles_received);
        map.insert(BaseMetricId(4832), &super::test_only_ipc::a_text);
        map.insert(BaseMetricId(4914), &super::nimbus_targeting_environment::targeting_context_value);
        map.insert(BaseMetricId(5156), &super::broken_site_report::description);
        map.insert(BaseMetricId(5161), &super::broken_site_report_browser_info_app::default_useragent_string);
        map.insert(BaseMetricId(5164), &super::broken_site_report_browser_info_graphics::devices_json);
        map.insert(BaseMetricId(5165), &super::broken_site_report_browser_info_graphics::drivers_json);
        map.insert(BaseMetricId(5166), &super::broken_site_report_browser_info_graphics::features_json);
        map.insert(BaseMetricId(5168), &super::broken_site_report_browser_info_graphics::monitors_json);
        map.insert(BaseMetricId(5185), &super::broken_site_report_tab_info::useragent_string);
        map.insert(BaseMetricId(5261), &super::characteristics::errors);
        map.insert(BaseMetricId(5297), &super::characteristics::gl2_extensions);
        map.insert(BaseMetricId(5298), &super::characteristics::gl2_extensions_raw);
        map.insert(BaseMetricId(5299), &super::characteristics::gl2_extensions_raw_software);
        map.insert(BaseMetricId(5300), &super::characteristics::gl2_extensions_software);
        map.insert(BaseMetricId(5303), &super::characteristics::gl2_minimal_source);
        map.insert(BaseMetricId(5304), &super::characteristics::gl2_minimal_source_software);
        map.insert(BaseMetricId(5305), &super::characteristics::gl2_params);
        map.insert(BaseMetricId(5306), &super::characteristics::gl2_params_extensions);
        map.insert(BaseMetricId(5307), &super::characteristics::gl2_params_extensions_software);
        map.insert(BaseMetricId(5308), &super::characteristics::gl2_params_software);
        map.insert(BaseMetricId(5309), &super::characteristics::gl2_precision_fragment);
        map.insert(BaseMetricId(5310), &super::characteristics::gl2_precision_fragment_software);
        map.insert(BaseMetricId(5311), &super::characteristics::gl2_precision_vertex);
        map.insert(BaseMetricId(5312), &super::characteristics::gl2_precision_vertex_software);
        map.insert(BaseMetricId(5327), &super::characteristics::gl_extensions);
        map.insert(BaseMetricId(5328), &super::characteristics::gl_extensions_raw);
        map.insert(BaseMetricId(5329), &super::characteristics::gl_extensions_raw_software);
        map.insert(BaseMetricId(5330), &super::characteristics::gl_extensions_software);
        map.insert(BaseMetricId(5333), &super::characteristics::gl_minimal_source);
        map.insert(BaseMetricId(5334), &super::characteristics::gl_minimal_source_software);
        map.insert(BaseMetricId(5335), &super::characteristics::gl_params);
        map.insert(BaseMetricId(5336), &super::characteristics::gl_params_extensions);
        map.insert(BaseMetricId(5337), &super::characteristics::gl_params_extensions_software);
        map.insert(BaseMetricId(5338), &super::characteristics::gl_params_software);
        map.insert(BaseMetricId(5339), &super::characteristics::gl_precision_fragment);
        map.insert(BaseMetricId(5340), &super::characteristics::gl_precision_fragment_software);
        map.insert(BaseMetricId(5341), &super::characteristics::gl_precision_vertex);
        map.insert(BaseMetricId(5342), &super::characteristics::gl_precision_vertex_software);
        map.insert(BaseMetricId(5363), &super::characteristics::js_errors);
        map.insert(BaseMetricId(5367), &super::characteristics::math_ops);
        map.insert(BaseMetricId(5368), &super::characteristics::math_ops_fdlibm);
        map.insert(BaseMetricId(5380), &super::characteristics::media_capabilities_h264);
        map.insert(BaseMetricId(5381), &super::characteristics::media_capabilities_not_efficient);
        map.insert(BaseMetricId(5382), &super::characteristics::media_capabilities_not_smooth);
        map.insert(BaseMetricId(5383), &super::characteristics::media_capabilities_unsupported);
        map.insert(BaseMetricId(5385), &super::characteristics::missing_fonts);
        map.insert(BaseMetricId(5426), &super::characteristics::screens);
        map.insert(BaseMetricId(5436), &super::characteristics::user_agent);
        map.insert(BaseMetricId(5445), &super::characteristics::voices_sample);
        map.insert(BaseMetricId(5446), &super::characteristics::voices_sha1);
        map
    });

    pub static STRING_LIST_MAP: Lazy<HashMap<BaseMetricId, &Lazy<StringListMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(20);
        map.insert(BaseMetricId(361), &super::background_update::reasons_to_not_update);
        map.insert(BaseMetricId(369), &super::background_update::reasons);
        map.insert(BaseMetricId(370), &super::background_update::states);
        map.insert(BaseMetricId(446), &super::browser_migration::matched_extensions);
        map.insert(BaseMetricId(456), &super::browser_migration::unmatched_extensions);
        map.insert(BaseMetricId(520), &super::newtab::blocked_sponsors);
        map.insert(BaseMetricId(543), &super::newtab::selected_topics);
        map.insert(BaseMetricId(544), &super::newtab::sov_allocation);
        map.insert(BaseMetricId(569), &super::newtab_content::followed_sections);
        map.insert(BaseMetricId(4597), &super::crash::utility_actors_name);
        map.insert(BaseMetricId(4606), &super::dll_blocklist::list);
        map.insert(BaseMetricId(4609), &super::environment::nimbus_enrollments);
        map.insert(BaseMetricId(4780), &super::test_only::cheesy_string_list);
        map.insert(BaseMetricId(4831), &super::test_only_ipc::a_string_list);
        map.insert(BaseMetricId(5160), &super::broken_site_report_browser_info_app::default_locales);
        map.insert(BaseMetricId(5179), &super::broken_site_report_browser_info_security::antispyware);
        map.insert(BaseMetricId(5180), &super::broken_site_report_browser_info_security::antivirus);
        map.insert(BaseMetricId(5181), &super::broken_site_report_browser_info_security::firewall);
        map.insert(BaseMetricId(5184), &super::broken_site_report_tab_info::languages);
        map.insert(BaseMetricId(5294), &super::characteristics::gamepads);
        map
    });

    pub static DATETIME_MAP: Lazy<HashMap<BaseMetricId, &Lazy<DatetimeMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(14);
        map.insert(BaseMetricId(362), &super::background_update::time_last_update_scheduled);
        map.insert(BaseMetricId(371), &super::background_update::targeting_env_current_date);
        map.insert(BaseMetricId(373), &super::background_update::targeting_env_profile_age);
        map.insert(BaseMetricId(582), &super::pocket::fetch_timestamp);
        map.insert(BaseMetricId(585), &super::pocket::newtab_creation_timestamp);
        map.insert(BaseMetricId(4596), &super::crash::time);
        map.insert(BaseMetricId(4814), &super::test_only::what_a_date);
        map.insert(BaseMetricId(4823), &super::test_only_ipc::a_date);
        map.insert(BaseMetricId(5563), &super::usage::first_run_date);
        map.insert(BaseMetricId(5764), &super::blocklist::last_modified_rs_addons_mblf);
        map.insert(BaseMetricId(5765), &super::blocklist::mlbf_generation_time);
        map.insert(BaseMetricId(5766), &super::blocklist::mlbf_softblocks_generation_time);
        map.insert(BaseMetricId(5769), &super::blocklist::mlbf_stash_time_newest);
        map.insert(BaseMetricId(5770), &super::blocklist::mlbf_stash_time_oldest);
        map
    });

    pub static TIMESPAN_MAP: Lazy<HashMap<BaseMetricId, &Lazy<TimespanMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(BaseMetricId(459), &super::migration::time_to_produce_migrator_list);
        map.insert(BaseMetricId(4610), &super::environment::uptime);
        map.insert(BaseMetricId(4661), &super::extensions::startup_cache_load_time);
        map.insert(BaseMetricId(4766), &super::fog::initialization);
        map.insert(BaseMetricId(4778), &super::test_only::can_we_time_it);
        map.insert(BaseMetricId(4805), &super::test_only::mirror_time);
        map.insert(BaseMetricId(4806), &super::test_only::mirror_time_nanos);
        map
    });

    pub static URL_MAP: Lazy<HashMap<BaseMetricId, &Lazy<UrlMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(7);
        map.insert(BaseMetricId(595), &super::top_sites::reporting_url);
        map.insert(BaseMetricId(770), &super::search_with::reporting_url);
        map.insert(BaseMetricId(965), &super::quick_suggest::reporting_url);
        map.insert(BaseMetricId(4834), &super::test_only_ipc::a_url);
        map.insert(BaseMetricId(5157), &super::broken_site_report::url);
        map.insert(BaseMetricId(5494), &super::search_engine_default::submission_url);
        map.insert(BaseMetricId(5502), &super::search_engine_private::submission_url);
        map
    });

    pub static RATE_MAP: Lazy<HashMap<BaseMetricId, &Lazy<RateMetric>>> = Lazy::new(|| {
        let mut map = HashMap::with_capacity(2);
        map.insert(BaseMetricId(4324), &super::parsing::svg_unusual_pcdata);
        map.insert(BaseMetricId(4842), &super::test_only_ipc::irate);
        map
    });


    pub(crate) fn set_object_by_id(metric_id: u32, value: String) -> Result<(), ()> {
        match metric_id {
          253 => {
              super::glean_attribution::ext.set_string(value);
              Ok(())
          }
          254 => {
              super::glean_distribution::ext.set_string(value);
              Ok(())
          }
          562 => {
              super::newtab_content::active_experiments.set_string(value);
              Ok(())
          }
          563 => {
              super::newtab_content::active_rollouts.set_string(value);
              Ok(())
          }
          568 => {
              super::newtab_content::enrollments_map.set_string(value);
              Ok(())
          }
          779 => {
              super::serp::experiment_info.set_string(value);
              Ok(())
          }
          1013 => {
              super::browser_ui::toolbar_widgets.set_string(value);
              Ok(())
          }
          4096 => {
              super::preferences::user_prefs.set_string(value);
              Ok(())
          }
          4487 => {
              super::hangs::modules.set_string(value);
              Ok(())
          }
          4488 => {
              super::hangs::reports.set_string(value);
              Ok(())
          }
          4577 => {
              super::crash::async_shutdown_timeout.set_string(value);
              Ok(())
          }
          4590 => {
              super::crash::quota_manager_shutdown_timeout.set_string(value);
              Ok(())
          }
          4593 => {
              super::crash::stack_traces.set_string(value);
              Ok(())
          }
          4775 => {
              super::test_only::balloons.set_string(value);
              Ok(())
          }
          4782 => {
              super::test_only::crash_stack.set_string(value);
              Ok(())
          }
          4880 => {
              super::nimbus_targeting_context::active_experiments.set_string(value);
              Ok(())
          }
          4881 => {
              super::nimbus_targeting_context::active_rollouts.set_string(value);
              Ok(())
          }
          4884 => {
              super::nimbus_targeting_context::attribution_data.set_string(value);
              Ok(())
          }
          4885 => {
              super::nimbus_targeting_context::browser_settings.set_string(value);
              Ok(())
          }
          4887 => {
              super::nimbus_targeting_context::default_pdf_handler.set_string(value);
              Ok(())
          }
          4890 => {
              super::nimbus_targeting_context::enrollments_map.set_string(value);
              Ok(())
          }
          4893 => {
              super::nimbus_targeting_context::home_page_settings.set_string(value);
              Ok(())
          }
          4895 => {
              super::nimbus_targeting_context::is_default_handler.set_string(value);
              Ok(())
          }
          4902 => {
              super::nimbus_targeting_context::os.set_string(value);
              Ok(())
          }
          4903 => {
              super::nimbus_targeting_context::primary_resolution.set_string(value);
              Ok(())
          }
          4907 => {
              super::nimbus_targeting_context::user_monthly_activity.set_string(value);
              Ok(())
          }
          4913 => {
              super::nimbus_targeting_environment::pref_values.set_string(value);
              Ok(())
          }
          4915 => {
              super::nimbus_targeting_environment::user_set_prefs.set_string(value);
              Ok(())
          }
          5158 => {
              super::broken_site_report_browser_info::addons.set_string(value);
              Ok(())
          }
          5159 => {
              super::broken_site_report_browser_info::experiments.set_string(value);
              Ok(())
          }
          5519 => {
              super::onboarding_opt_out::active_experiments.set_string(value);
              Ok(())
          }
          5520 => {
              super::onboarding_opt_out::active_rollouts.set_string(value);
              Ok(())
          }
          5521 => {
              super::onboarding_opt_out::enrollments_map.set_string(value);
              Ok(())
          }
          5696 => {
              super::addons::active_addons.set_string(value);
              Ok(())
          }
          5697 => {
              super::addons::active_g_m_plugins.set_string(value);
              Ok(())
          }
          5698 => {
              super::addons::theme.set_string(value);
              Ok(())
          }
           _ => Err(()),
        }
    }

    /// Wrapper to get the currently stored object for object metric as a string.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded object serialized as a JSON string or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    pub(crate) fn object_test_get_value(metric_id: u32, ping_name: Option<String>) -> Option<String> {
        match metric_id {
           253 => super::glean_attribution::ext.test_get_value_as_str(ping_name.as_deref()),
           254 => super::glean_distribution::ext.test_get_value_as_str(ping_name.as_deref()),
           562 => super::newtab_content::active_experiments.test_get_value_as_str(ping_name.as_deref()),
           563 => super::newtab_content::active_rollouts.test_get_value_as_str(ping_name.as_deref()),
           568 => super::newtab_content::enrollments_map.test_get_value_as_str(ping_name.as_deref()),
           779 => super::serp::experiment_info.test_get_value_as_str(ping_name.as_deref()),
           1013 => super::browser_ui::toolbar_widgets.test_get_value_as_str(ping_name.as_deref()),
           4096 => super::preferences::user_prefs.test_get_value_as_str(ping_name.as_deref()),
           4487 => super::hangs::modules.test_get_value_as_str(ping_name.as_deref()),
           4488 => super::hangs::reports.test_get_value_as_str(ping_name.as_deref()),
           4577 => super::crash::async_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           4590 => super::crash::quota_manager_shutdown_timeout.test_get_value_as_str(ping_name.as_deref()),
           4593 => super::crash::stack_traces.test_get_value_as_str(ping_name.as_deref()),
           4775 => super::test_only::balloons.test_get_value_as_str(ping_name.as_deref()),
           4782 => super::test_only::crash_stack.test_get_value_as_str(ping_name.as_deref()),
           4880 => super::nimbus_targeting_context::active_experiments.test_get_value_as_str(ping_name.as_deref()),
           4881 => super::nimbus_targeting_context::active_rollouts.test_get_value_as_str(ping_name.as_deref()),
           4884 => super::nimbus_targeting_context::attribution_data.test_get_value_as_str(ping_name.as_deref()),
           4885 => super::nimbus_targeting_context::browser_settings.test_get_value_as_str(ping_name.as_deref()),
           4887 => super::nimbus_targeting_context::default_pdf_handler.test_get_value_as_str(ping_name.as_deref()),
           4890 => super::nimbus_targeting_context::enrollments_map.test_get_value_as_str(ping_name.as_deref()),
           4893 => super::nimbus_targeting_context::home_page_settings.test_get_value_as_str(ping_name.as_deref()),
           4895 => super::nimbus_targeting_context::is_default_handler.test_get_value_as_str(ping_name.as_deref()),
           4902 => super::nimbus_targeting_context::os.test_get_value_as_str(ping_name.as_deref()),
           4903 => super::nimbus_targeting_context::primary_resolution.test_get_value_as_str(ping_name.as_deref()),
           4907 => super::nimbus_targeting_context::user_monthly_activity.test_get_value_as_str(ping_name.as_deref()),
           4913 => super::nimbus_targeting_environment::pref_values.test_get_value_as_str(ping_name.as_deref()),
           4915 => super::nimbus_targeting_environment::user_set_prefs.test_get_value_as_str(ping_name.as_deref()),
           5158 => super::broken_site_report_browser_info::addons.test_get_value_as_str(ping_name.as_deref()),
           5159 => super::broken_site_report_browser_info::experiments.test_get_value_as_str(ping_name.as_deref()),
           5519 => super::onboarding_opt_out::active_experiments.test_get_value_as_str(ping_name.as_deref()),
           5520 => super::onboarding_opt_out::active_rollouts.test_get_value_as_str(ping_name.as_deref()),
           5521 => super::onboarding_opt_out::enrollments_map.test_get_value_as_str(ping_name.as_deref()),
           5696 => super::addons::active_addons.test_get_value_as_str(ping_name.as_deref()),
           5697 => super::addons::active_g_m_plugins.test_get_value_as_str(ping_name.as_deref()),
           5698 => super::addons::theme.test_get_value_as_str(ping_name.as_deref()),
           _ => panic!("No object for metric id {}", metric_id),
        }
    }

    /// Check the provided object for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no object by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn object_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           253 => test_get_errors!(super::glean_attribution::ext),
           254 => test_get_errors!(super::glean_distribution::ext),
           562 => test_get_errors!(super::newtab_content::active_experiments),
           563 => test_get_errors!(super::newtab_content::active_rollouts),
           568 => test_get_errors!(super::newtab_content::enrollments_map),
           779 => test_get_errors!(super::serp::experiment_info),
           1013 => test_get_errors!(super::browser_ui::toolbar_widgets),
           4096 => test_get_errors!(super::preferences::user_prefs),
           4487 => test_get_errors!(super::hangs::modules),
           4488 => test_get_errors!(super::hangs::reports),
           4577 => test_get_errors!(super::crash::async_shutdown_timeout),
           4590 => test_get_errors!(super::crash::quota_manager_shutdown_timeout),
           4593 => test_get_errors!(super::crash::stack_traces),
           4775 => test_get_errors!(super::test_only::balloons),
           4782 => test_get_errors!(super::test_only::crash_stack),
           4880 => test_get_errors!(super::nimbus_targeting_context::active_experiments),
           4881 => test_get_errors!(super::nimbus_targeting_context::active_rollouts),
           4884 => test_get_errors!(super::nimbus_targeting_context::attribution_data),
           4885 => test_get_errors!(super::nimbus_targeting_context::browser_settings),
           4887 => test_get_errors!(super::nimbus_targeting_context::default_pdf_handler),
           4890 => test_get_errors!(super::nimbus_targeting_context::enrollments_map),
           4893 => test_get_errors!(super::nimbus_targeting_context::home_page_settings),
           4895 => test_get_errors!(super::nimbus_targeting_context::is_default_handler),
           4902 => test_get_errors!(super::nimbus_targeting_context::os),
           4903 => test_get_errors!(super::nimbus_targeting_context::primary_resolution),
           4907 => test_get_errors!(super::nimbus_targeting_context::user_monthly_activity),
           4913 => test_get_errors!(super::nimbus_targeting_environment::pref_values),
           4915 => test_get_errors!(super::nimbus_targeting_environment::user_set_prefs),
           5158 => test_get_errors!(super::broken_site_report_browser_info::addons),
           5159 => test_get_errors!(super::broken_site_report_browser_info::experiments),
           5519 => test_get_errors!(super::onboarding_opt_out::active_experiments),
           5520 => test_get_errors!(super::onboarding_opt_out::active_rollouts),
           5521 => test_get_errors!(super::onboarding_opt_out::enrollments_map),
           5696 => test_get_errors!(super::addons::active_addons),
           5697 => test_get_errors!(super::addons::active_g_m_plugins),
           5698 => test_get_errors!(super::addons::theme),
           _ => panic!("No object for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Wrapper to record an event based on its metric ID.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the `extra` map could not be deserialized.
    pub(crate) fn record_event_by_id(metric_id: u32, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          16 => {
              super::browser_engagement::tab_explicit_unload.record_raw(extra);
              Ok(())
          }
          199 => {
              super::security_ui_protectionspopup::click_cookieb_toggle_off.record_raw(extra);
              Ok(())
          }
          200 => {
              super::security_ui_protectionspopup::click_cookieb_toggle_on.record_raw(extra);
              Ok(())
          }
          201 => {
              super::security_ui_protectionspopup::click_cookies.record_raw(extra);
              Ok(())
          }
          202 => {
              super::security_ui_protectionspopup::click_cryptominers.record_raw(extra);
              Ok(())
          }
          203 => {
              super::security_ui_protectionspopup::click_etp_toggle_off.record_raw(extra);
              Ok(())
          }
          204 => {
              super::security_ui_protectionspopup::click_etp_toggle_on.record_raw(extra);
              Ok(())
          }
          205 => {
              super::security_ui_protectionspopup::click_fingerprinters.record_raw(extra);
              Ok(())
          }
          206 => {
              super::security_ui_protectionspopup::click_full_report.record_raw(extra);
              Ok(())
          }
          207 => {
              super::security_ui_protectionspopup::click_milestone_message.record_raw(extra);
              Ok(())
          }
          208 => {
              super::security_ui_protectionspopup::click_protectionspopup_cfr.record_raw(extra);
              Ok(())
          }
          209 => {
              super::security_ui_protectionspopup::click_settings.record_raw(extra);
              Ok(())
          }
          210 => {
              super::security_ui_protectionspopup::click_smartblockembeds_toggle.record_raw(extra);
              Ok(())
          }
          211 => {
              super::security_ui_protectionspopup::click_social.record_raw(extra);
              Ok(())
          }
          212 => {
              super::security_ui_protectionspopup::click_subview_settings.record_raw(extra);
              Ok(())
          }
          213 => {
              super::security_ui_protectionspopup::click_trackers.record_raw(extra);
              Ok(())
          }
          214 => {
              super::security_ui_protectionspopup::close_protections_popup.record_raw(extra);
              Ok(())
          }
          215 => {
              super::security_ui_protectionspopup::open_protections_popup.record_raw(extra);
              Ok(())
          }
          216 => {
              super::security_ui_protectionspopup::open_protectionspopup_cfr.record_raw(extra);
              Ok(())
          }
          256 => {
              super::browser_backup::change_location.record_raw(extra);
              Ok(())
          }
          259 => {
              super::browser_backup::created.record_raw(extra);
              Ok(())
          }
          262 => {
              super::browser_backup::error.record_raw(extra);
              Ok(())
          }
          272 => {
              super::browser_backup::password_added.record_raw(extra);
              Ok(())
          }
          273 => {
              super::browser_backup::password_changed.record_raw(extra);
              Ok(())
          }
          274 => {
              super::browser_backup::password_removed.record_raw(extra);
              Ok(())
          }
          285 => {
              super::browser_backup::toggle_off.record_raw(extra);
              Ok(())
          }
          286 => {
              super::browser_backup::toggle_on.record_raw(extra);
              Ok(())
          }
          290 => {
              super::downloads::added_file_extension.record_raw(extra);
              Ok(())
          }
          306 => {
              super::firefoxview_next::browser_context_menu_tabs.record_raw(extra);
              Ok(())
          }
          307 => {
              super::firefoxview_next::card_collapsed_card_container.record_raw(extra);
              Ok(())
          }
          308 => {
              super::firefoxview_next::card_expanded_card_container.record_raw(extra);
              Ok(())
          }
          309 => {
              super::firefoxview_next::change_page_navigation.record_raw(extra);
              Ok(())
          }
          310 => {
              super::firefoxview_next::close_open_tab_tabs.record_raw(extra);
              Ok(())
          }
          311 => {
              super::firefoxview_next::context_menu_tabs.record_raw(extra);
              Ok(())
          }
          312 => {
              super::firefoxview_next::dismiss_closed_tab_tabs.record_raw(extra);
              Ok(())
          }
          313 => {
              super::firefoxview_next::entered_firefoxview.record_raw(extra);
              Ok(())
          }
          314 => {
              super::firefoxview_next::fxa_continue_sync.record_raw(extra);
              Ok(())
          }
          315 => {
              super::firefoxview_next::fxa_mobile_sync.record_raw(extra);
              Ok(())
          }
          316 => {
              super::firefoxview_next::history_visits.record_raw(extra);
              Ok(())
          }
          317 => {
              super::firefoxview_next::open_tab_tabs.record_raw(extra);
              Ok(())
          }
          318 => {
              super::firefoxview_next::recently_closed_tabs.record_raw(extra);
              Ok(())
          }
          319 => {
              super::firefoxview_next::search_initiated_search.record_raw(extra);
              Ok(())
          }
          320 => {
              super::firefoxview_next::search_show_all_showallbutton.record_raw(extra);
              Ok(())
          }
          321 => {
              super::firefoxview_next::show_all_history_tabs.record_raw(extra);
              Ok(())
          }
          322 => {
              super::firefoxview_next::sort_history_tabs.record_raw(extra);
              Ok(())
          }
          323 => {
              super::firefoxview_next::synced_tabs_tabs.record_raw(extra);
              Ok(())
          }
          324 => {
              super::firefoxview_next::tab_selected_toolbarbutton.record_raw(extra);
              Ok(())
          }
          325 => {
              super::genai_chatbot::contextmenu_prompt_click.record_raw(extra);
              Ok(())
          }
          326 => {
              super::genai_chatbot::contextmenu_remove.record_raw(extra);
              Ok(())
          }
          328 => {
              super::genai_chatbot::experiment_checkbox_click.record_raw(extra);
              Ok(())
          }
          329 => {
              super::genai_chatbot::keyboard_shortcut.record_raw(extra);
              Ok(())
          }
          330 => {
              super::genai_chatbot::onboarding_close.record_raw(extra);
              Ok(())
          }
          331 => {
              super::genai_chatbot::onboarding_continue.record_raw(extra);
              Ok(())
          }
          332 => {
              super::genai_chatbot::onboarding_finish.record_raw(extra);
              Ok(())
          }
          333 => {
              super::genai_chatbot::onboarding_learn_more.record_raw(extra);
              Ok(())
          }
          334 => {
              super::genai_chatbot::onboarding_provider_choice_displayed.record_raw(extra);
              Ok(())
          }
          335 => {
              super::genai_chatbot::onboarding_provider_learn.record_raw(extra);
              Ok(())
          }
          336 => {
              super::genai_chatbot::onboarding_provider_selection.record_raw(extra);
              Ok(())
          }
          337 => {
              super::genai_chatbot::onboarding_provider_terms.record_raw(extra);
              Ok(())
          }
          338 => {
              super::genai_chatbot::onboarding_text_highlight_displayed.record_raw(extra);
              Ok(())
          }
          340 => {
              super::genai_chatbot::provider_change.record_raw(extra);
              Ok(())
          }
          342 => {
              super::genai_chatbot::shortcuts_checkbox_click.record_raw(extra);
              Ok(())
          }
          344 => {
              super::genai_chatbot::shortcuts_displayed.record_raw(extra);
              Ok(())
          }
          345 => {
              super::genai_chatbot::shortcuts_expanded.record_raw(extra);
              Ok(())
          }
          346 => {
              super::genai_chatbot::shortcuts_hide_click.record_raw(extra);
              Ok(())
          }
          347 => {
              super::genai_chatbot::shortcuts_prompt_click.record_raw(extra);
              Ok(())
          }
          349 => {
              super::genai_chatbot::sidebar_close_click.record_raw(extra);
              Ok(())
          }
          350 => {
              super::genai_chatbot::sidebar_more_menu_click.record_raw(extra);
              Ok(())
          }
          351 => {
              super::genai_chatbot::sidebar_more_menu_display.record_raw(extra);
              Ok(())
          }
          352 => {
              super::genai_chatbot::sidebar_provider_menu_click.record_raw(extra);
              Ok(())
          }
          353 => {
              super::genai_chatbot::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          354 => {
              super::genai_linkpreview::card_close.record_raw(extra);
              Ok(())
          }
          355 => {
              super::genai_linkpreview::card_link.record_raw(extra);
              Ok(())
          }
          357 => {
              super::genai_linkpreview::fetch.record_raw(extra);
              Ok(())
          }
          358 => {
              super::genai_linkpreview::generate.record_raw(extra);
              Ok(())
          }
          359 => {
              super::genai_linkpreview::labs_checkbox.record_raw(extra);
              Ok(())
          }
          360 => {
              super::genai_linkpreview::start.record_raw(extra);
              Ok(())
          }
          387 => {
              super::browser_launched_to_handle::system_notification.record_raw(extra);
              Ok(())
          }
          401 => {
              super::launch_on_login::last_profile_disable_startup.record_raw(extra);
              Ok(())
          }
          415 => {
              super::security::fission_principals.record_raw(extra);
              Ok(())
          }
          416 => {
              super::security::csp_violation_internal_page.record_raw(extra);
              Ok(())
          }
          417 => {
              super::security::eval_usage_parent_process.record_raw(extra);
              Ok(())
          }
          418 => {
              super::security::eval_usage_system_context.record_raw(extra);
              Ok(())
          }
          420 => {
              super::security::javascript_load_parent_process.record_raw(extra);
              Ok(())
          }
          422 => {
              super::security::unexpected_load.record_raw(extra);
              Ok(())
          }
          423 => {
              super::security::pref_usage_content_process.record_raw(extra);
              Ok(())
          }
          429 => {
              super::start_menu::manually_unpinned_since_last_launch.record_raw(extra);
              Ok(())
          }
          435 => {
              super::upgrade_dialog::trigger_reason.record_raw(extra);
              Ok(())
          }
          437 => {
              super::browser_migration::browser_selected_wizard.record_raw(extra);
              Ok(())
          }
          439 => {
              super::browser_migration::chrome_password_file_wizard.record_raw(extra);
              Ok(())
          }
          444 => {
              super::browser_migration::linux_perms_wizard.record_raw(extra);
              Ok(())
          }
          447 => {
              super::browser_migration::migration_finished_wizard.record_raw(extra);
              Ok(())
          }
          448 => {
              super::browser_migration::migration_started_wizard.record_raw(extra);
              Ok(())
          }
          449 => {
              super::browser_migration::no_browsers_found_wizard.record_raw(extra);
              Ok(())
          }
          450 => {
              super::browser_migration::opened_wizard.record_raw(extra);
              Ok(())
          }
          451 => {
              super::browser_migration::profile_selected_wizard.record_raw(extra);
              Ok(())
          }
          452 => {
              super::browser_migration::resources_selected_wizard.record_raw(extra);
              Ok(())
          }
          453 => {
              super::browser_migration::safari_password_file_wizard.record_raw(extra);
              Ok(())
          }
          454 => {
              super::browser_migration::safari_perms_wizard.record_raw(extra);
              Ok(())
          }
          461 => {
              super::activity_stream::end_session.record_raw(extra);
              Ok(())
          }
          462 => {
              super::activity_stream::event_archive_from_pocket.record_raw(extra);
              Ok(())
          }
          463 => {
              super::activity_stream::event_block.record_raw(extra);
              Ok(())
          }
          464 => {
              super::activity_stream::event_bookmark_add.record_raw(extra);
              Ok(())
          }
          465 => {
              super::activity_stream::event_bookmark_delete.record_raw(extra);
              Ok(())
          }
          466 => {
              super::activity_stream::event_click.record_raw(extra);
              Ok(())
          }
          467 => {
              super::activity_stream::event_click_privacy_info.record_raw(extra);
              Ok(())
          }
          468 => {
              super::activity_stream::event_close_newtab_prefs.record_raw(extra);
              Ok(())
          }
          469 => {
              super::activity_stream::event_delete.record_raw(extra);
              Ok(())
          }
          470 => {
              super::activity_stream::event_delete_confirm.record_raw(extra);
              Ok(())
          }
          471 => {
              super::activity_stream::event_delete_from_pocket.record_raw(extra);
              Ok(())
          }
          472 => {
              super::activity_stream::event_dialog_cancel.record_raw(extra);
              Ok(())
          }
          473 => {
              super::activity_stream::event_dialog_open.record_raw(extra);
              Ok(())
          }
          474 => {
              super::activity_stream::event_disclaimer_acked.record_raw(extra);
              Ok(())
          }
          475 => {
              super::activity_stream::event_drag.record_raw(extra);
              Ok(())
          }
          476 => {
              super::activity_stream::event_drop.record_raw(extra);
              Ok(())
          }
          477 => {
              super::activity_stream::event_fakespot_category.record_raw(extra);
              Ok(())
          }
          478 => {
              super::activity_stream::event_fakespot_click.record_raw(extra);
              Ok(())
          }
          479 => {
              super::activity_stream::event_hide_personalize.record_raw(extra);
              Ok(())
          }
          480 => {
              super::activity_stream::event_impression.record_raw(extra);
              Ok(())
          }
          481 => {
              super::activity_stream::event_menu_add_search.record_raw(extra);
              Ok(())
          }
          482 => {
              super::activity_stream::event_menu_add_topsite.record_raw(extra);
              Ok(())
          }
          483 => {
              super::activity_stream::event_menu_collapse.record_raw(extra);
              Ok(())
          }
          484 => {
              super::activity_stream::event_menu_expand.record_raw(extra);
              Ok(())
          }
          485 => {
              super::activity_stream::event_menu_manage.record_raw(extra);
              Ok(())
          }
          486 => {
              super::activity_stream::event_menu_move_down.record_raw(extra);
              Ok(())
          }
          487 => {
              super::activity_stream::event_menu_move_up.record_raw(extra);
              Ok(())
          }
          488 => {
              super::activity_stream::event_menu_privacy_notice.record_raw(extra);
              Ok(())
          }
          489 => {
              super::activity_stream::event_menu_remove.record_raw(extra);
              Ok(())
          }
          490 => {
              super::activity_stream::event_migration_cancel.record_raw(extra);
              Ok(())
          }
          491 => {
              super::activity_stream::event_migration_start.record_raw(extra);
              Ok(())
          }
          492 => {
              super::activity_stream::event_open_new_window.record_raw(extra);
              Ok(())
          }
          493 => {
              super::activity_stream::event_open_newtab_prefs.record_raw(extra);
              Ok(())
          }
          494 => {
              super::activity_stream::event_open_private_window.record_raw(extra);
              Ok(())
          }
          495 => {
              super::activity_stream::event_pin.record_raw(extra);
              Ok(())
          }
          496 => {
              super::activity_stream::event_pocket_thumbs_down.record_raw(extra);
              Ok(())
          }
          497 => {
              super::activity_stream::event_pocket_thumbs_up.record_raw(extra);
              Ok(())
          }
          498 => {
              super::activity_stream::event_pref_changed.record_raw(extra);
              Ok(())
          }
          499 => {
              super::activity_stream::event_preview_request.record_raw(extra);
              Ok(())
          }
          500 => {
              super::activity_stream::event_save_to_pocket.record_raw(extra);
              Ok(())
          }
          501 => {
              super::activity_stream::event_search.record_raw(extra);
              Ok(())
          }
          502 => {
              super::activity_stream::event_search_edit_add.record_raw(extra);
              Ok(())
          }
          503 => {
              super::activity_stream::event_search_edit_close.record_raw(extra);
              Ok(())
          }
          504 => {
              super::activity_stream::event_search_edit_delete.record_raw(extra);
              Ok(())
          }
          505 => {
              super::activity_stream::event_search_handoff.record_raw(extra);
              Ok(())
          }
          506 => {
              super::activity_stream::event_show_personalize.record_raw(extra);
              Ok(())
          }
          507 => {
              super::activity_stream::event_show_privacy_info.record_raw(extra);
              Ok(())
          }
          508 => {
              super::activity_stream::event_skipped_signin.record_raw(extra);
              Ok(())
          }
          509 => {
              super::activity_stream::event_submit_email.record_raw(extra);
              Ok(())
          }
          510 => {
              super::activity_stream::event_top_sites_edit.record_raw(extra);
              Ok(())
          }
          511 => {
              super::activity_stream::event_top_sites_edit_close.record_raw(extra);
              Ok(())
          }
          512 => {
              super::activity_stream::event_topsite_sponsor_info.record_raw(extra);
              Ok(())
          }
          513 => {
              super::activity_stream::event_unpin.record_raw(extra);
              Ok(())
          }
          521 => {
              super::newtab::closed.record_raw(extra);
              Ok(())
          }
          522 => {
              super::newtab::fakespot_about_click.record_raw(extra);
              Ok(())
          }
          523 => {
              super::newtab::fakespot_category.record_raw(extra);
              Ok(())
          }
          524 => {
              super::newtab::fakespot_click.record_raw(extra);
              Ok(())
          }
          525 => {
              super::newtab::fakespot_cta_click.record_raw(extra);
              Ok(())
          }
          526 => {
              super::newtab::fakespot_dismiss.record_raw(extra);
              Ok(())
          }
          527 => {
              super::newtab::fakespot_product_impression.record_raw(extra);
              Ok(())
          }
          529 => {
              super::newtab::inline_selection_click.record_raw(extra);
              Ok(())
          }
          530 => {
              super::newtab::inline_selection_impression.record_raw(extra);
              Ok(())
          }
          534 => {
              super::newtab::opened.record_raw(extra);
              Ok(())
          }
          536 => {
              super::newtab::report_content_open.record_raw(extra);
              Ok(())
          }
          537 => {
              super::newtab::report_content_submit.record_raw(extra);
              Ok(())
          }
          538 => {
              super::newtab::sections_block_section.record_raw(extra);
              Ok(())
          }
          539 => {
              super::newtab::sections_follow_section.record_raw(extra);
              Ok(())
          }
          540 => {
              super::newtab::sections_impression.record_raw(extra);
              Ok(())
          }
          541 => {
              super::newtab::sections_unblock_section.record_raw(extra);
              Ok(())
          }
          542 => {
              super::newtab::sections_unfollow_section.record_raw(extra);
              Ok(())
          }
          545 => {
              super::newtab::tooltip_click.record_raw(extra);
              Ok(())
          }
          546 => {
              super::newtab::topic_selection_dismiss.record_raw(extra);
              Ok(())
          }
          547 => {
              super::newtab::topic_selection_open.record_raw(extra);
              Ok(())
          }
          548 => {
              super::newtab::topic_selection_topics_saved.record_raw(extra);
              Ok(())
          }
          549 => {
              super::newtab::wallpaper_category_click.record_raw(extra);
              Ok(())
          }
          550 => {
              super::newtab::wallpaper_click.record_raw(extra);
              Ok(())
          }
          551 => {
              super::newtab::wallpaper_highlight_cta_click.record_raw(extra);
              Ok(())
          }
          552 => {
              super::newtab::wallpaper_highlight_dismissed.record_raw(extra);
              Ok(())
          }
          553 => {
              super::newtab::weather_change_display.record_raw(extra);
              Ok(())
          }
          555 => {
              super::newtab::weather_impression.record_raw(extra);
              Ok(())
          }
          556 => {
              super::newtab::weather_load_error.record_raw(extra);
              Ok(())
          }
          557 => {
              super::newtab::weather_location_selected.record_raw(extra);
              Ok(())
          }
          558 => {
              super::newtab::weather_open_provider_url.record_raw(extra);
              Ok(())
          }
          561 => {
              super::newtab_search::issued.record_raw(extra);
              Ok(())
          }
          564 => {
              super::newtab_content::click.record_raw(extra);
              Ok(())
          }
          567 => {
              super::newtab_content::dismiss.record_raw(extra);
              Ok(())
          }
          570 => {
              super::newtab_content::impression.record_raw(extra);
              Ok(())
          }
          571 => {
              super::newtab_content::sections_block_section.record_raw(extra);
              Ok(())
          }
          572 => {
              super::newtab_content::sections_follow_section.record_raw(extra);
              Ok(())
          }
          573 => {
              super::newtab_content::sections_impression.record_raw(extra);
              Ok(())
          }
          574 => {
              super::newtab_content::sections_unblock_section.record_raw(extra);
              Ok(())
          }
          575 => {
              super::newtab_content::sections_unfollow_section.record_raw(extra);
              Ok(())
          }
          577 => {
              super::newtab_content::thumb_voting_interaction.record_raw(extra);
              Ok(())
          }
          579 => {
              super::pocket::click.record_raw(extra);
              Ok(())
          }
          580 => {
              super::pocket::dismiss.record_raw(extra);
              Ok(())
          }
          583 => {
              super::pocket::impression.record_raw(extra);
              Ok(())
          }
          586 => {
              super::pocket::save.record_raw(extra);
              Ok(())
          }
          589 => {
              super::pocket::thumb_voting_interaction.record_raw(extra);
              Ok(())
          }
          590 => {
              super::pocket::topic_click.record_raw(extra);
              Ok(())
          }
          598 => {
              super::topsites::click.record_raw(extra);
              Ok(())
          }
          599 => {
              super::topsites::dismiss.record_raw(extra);
              Ok(())
          }
          601 => {
              super::topsites::impression.record_raw(extra);
              Ok(())
          }
          602 => {
              super::topsites::pref_changed.record_raw(extra);
              Ok(())
          }
          604 => {
              super::topsites::show_privacy_click.record_raw(extra);
              Ok(())
          }
          627 => {
              super::aboutpreferences::show_click.record_raw(extra);
              Ok(())
          }
          628 => {
              super::aboutpreferences::show_hash.record_raw(extra);
              Ok(())
          }
          629 => {
              super::aboutpreferences::show_initial.record_raw(extra);
              Ok(())
          }
          630 => {
              super::intl_ui_browser_language::accept_dialog.record_raw(extra);
              Ok(())
          }
          631 => {
              super::intl_ui_browser_language::add_dialog.record_raw(extra);
              Ok(())
          }
          632 => {
              super::intl_ui_browser_language::apply_main.record_raw(extra);
              Ok(())
          }
          633 => {
              super::intl_ui_browser_language::cancel_dialog.record_raw(extra);
              Ok(())
          }
          634 => {
              super::intl_ui_browser_language::manage_main.record_raw(extra);
              Ok(())
          }
          635 => {
              super::intl_ui_browser_language::remove_dialog.record_raw(extra);
              Ok(())
          }
          636 => {
              super::intl_ui_browser_language::reorder_dialog.record_raw(extra);
              Ok(())
          }
          637 => {
              super::intl_ui_browser_language::reorder_main.record_raw(extra);
              Ok(())
          }
          638 => {
              super::intl_ui_browser_language::search_dialog.record_raw(extra);
              Ok(())
          }
          639 => {
              super::intl_ui_browser_language::search_main.record_raw(extra);
              Ok(())
          }
          640 => {
              super::intl_ui_browser_language::set_fallback_dialog.record_raw(extra);
              Ok(())
          }
          641 => {
              super::network_proxy_settings::proxy_type_preference.record_raw(extra);
              Ok(())
          }
          642 => {
              super::privacy_ui_fpp_click::checkbox.record_raw(extra);
              Ok(())
          }
          643 => {
              super::privacy_ui_fpp_click::menu.record_raw(extra);
              Ok(())
          }
          644 => {
              super::security_doh_settings::mode_changed_button.record_raw(extra);
              Ok(())
          }
          645 => {
              super::security_doh_settings::provider_choice_value.record_raw(extra);
              Ok(())
          }
          646 => {
              super::aboutprivatebrowsing::click_dismiss_button.record_raw(extra);
              Ok(())
          }
          647 => {
              super::aboutprivatebrowsing::click_info_link.record_raw(extra);
              Ok(())
          }
          648 => {
              super::aboutprivatebrowsing::click_promo_link.record_raw(extra);
              Ok(())
          }
          649 => {
              super::private_browsing_reset_pbm::confirm_panel.record_raw(extra);
              Ok(())
          }
          650 => {
              super::private_browsing_reset_pbm::reset_action.record_raw(extra);
              Ok(())
          }
          651 => {
              super::profiles_default::updated.record_raw(extra);
              Ok(())
          }
          652 => {
              super::profiles_delete::cancel.record_raw(extra);
              Ok(())
          }
          653 => {
              super::profiles_delete::confirm.record_raw(extra);
              Ok(())
          }
          654 => {
              super::profiles_delete::displayed.record_raw(extra);
              Ok(())
          }
          655 => {
              super::profiles_existing::alert.record_raw(extra);
              Ok(())
          }
          656 => {
              super::profiles_existing::avatar.record_raw(extra);
              Ok(())
          }
          657 => {
              super::profiles_existing::closed.record_raw(extra);
              Ok(())
          }
          658 => {
              super::profiles_existing::deleted.record_raw(extra);
              Ok(())
          }
          659 => {
              super::profiles_existing::displayed.record_raw(extra);
              Ok(())
          }
          660 => {
              super::profiles_existing::learn_more.record_raw(extra);
              Ok(())
          }
          661 => {
              super::profiles_existing::name.record_raw(extra);
              Ok(())
          }
          662 => {
              super::profiles_existing::theme.record_raw(extra);
              Ok(())
          }
          663 => {
              super::profiles_new::alert.record_raw(extra);
              Ok(())
          }
          664 => {
              super::profiles_new::avatar.record_raw(extra);
              Ok(())
          }
          665 => {
              super::profiles_new::closed.record_raw(extra);
              Ok(())
          }
          666 => {
              super::profiles_new::deleted.record_raw(extra);
              Ok(())
          }
          667 => {
              super::profiles_new::displayed.record_raw(extra);
              Ok(())
          }
          668 => {
              super::profiles_new::learn_more.record_raw(extra);
              Ok(())
          }
          669 => {
              super::profiles_new::name.record_raw(extra);
              Ok(())
          }
          670 => {
              super::profiles_new::theme.record_raw(extra);
              Ok(())
          }
          671 => {
              super::profiles_selector_window::launch.record_raw(extra);
              Ok(())
          }
          672 => {
              super::profiles_selector_window::show_at_startup.record_raw(extra);
              Ok(())
          }
          673 => {
              super::security_ui_protections::click_lw_about_link.record_raw(extra);
              Ok(())
          }
          674 => {
              super::security_ui_protections::click_lw_open_button.record_raw(extra);
              Ok(())
          }
          675 => {
              super::security_ui_protections::click_lw_sync_link.record_raw(extra);
              Ok(())
          }
          676 => {
              super::security_ui_protections::click_mobile_app_link.record_raw(extra);
              Ok(())
          }
          677 => {
              super::security_ui_protections::click_mtr_about_link.record_raw(extra);
              Ok(())
          }
          678 => {
              super::security_ui_protections::click_mtr_report_link.record_raw(extra);
              Ok(())
          }
          679 => {
              super::security_ui_protections::click_mtr_signup_button.record_raw(extra);
              Ok(())
          }
          680 => {
              super::security_ui_protections::click_settings_link.record_raw(extra);
              Ok(())
          }
          681 => {
              super::security_ui_protections::click_trackers_about_link.record_raw(extra);
              Ok(())
          }
          682 => {
              super::security_ui_protections::click_vpn_app_link_android.record_raw(extra);
              Ok(())
          }
          683 => {
              super::security_ui_protections::click_vpn_app_link_ios.record_raw(extra);
              Ok(())
          }
          684 => {
              super::security_ui_protections::click_vpn_banner_close.record_raw(extra);
              Ok(())
          }
          685 => {
              super::security_ui_protections::click_vpn_banner_link.record_raw(extra);
              Ok(())
          }
          686 => {
              super::security_ui_protections::click_vpn_card_link.record_raw(extra);
              Ok(())
          }
          687 => {
              super::security_ui_protections::close_protection_report.record_raw(extra);
              Ok(())
          }
          688 => {
              super::security_ui_protections::show_protection_report.record_raw(extra);
              Ok(())
          }
          689 => {
              super::security_ui_protections::show_vpn_banner.record_raw(extra);
              Ok(())
          }
          692 => {
              super::protocolhandler_mailto::visit.record_raw(extra);
              Ok(())
          }
          693 => {
              super::screenshots::canceled_context_menu.record_raw(extra);
              Ok(())
          }
          694 => {
              super::screenshots::canceled_escape.record_raw(extra);
              Ok(())
          }
          695 => {
              super::screenshots::canceled_navigation.record_raw(extra);
              Ok(())
          }
          696 => {
              super::screenshots::canceled_overlay_cancel.record_raw(extra);
              Ok(())
          }
          697 => {
              super::screenshots::canceled_preview_cancel.record_raw(extra);
              Ok(())
          }
          698 => {
              super::screenshots::canceled_quick_actions.record_raw(extra);
              Ok(())
          }
          699 => {
              super::screenshots::canceled_shortcut.record_raw(extra);
              Ok(())
          }
          700 => {
              super::screenshots::canceled_toolbar_button.record_raw(extra);
              Ok(())
          }
          701 => {
              super::screenshots::copy_overlay_copy.record_raw(extra);
              Ok(())
          }
          702 => {
              super::screenshots::copy_preview_copy.record_raw(extra);
              Ok(())
          }
          703 => {
              super::screenshots::download_overlay_download.record_raw(extra);
              Ok(())
          }
          704 => {
              super::screenshots::download_preview_download.record_raw(extra);
              Ok(())
          }
          705 => {
              super::screenshots::failed_screenshot_too_large.record_raw(extra);
              Ok(())
          }
          706 => {
              super::screenshots::selected_element.record_raw(extra);
              Ok(())
          }
          707 => {
              super::screenshots::selected_full_page.record_raw(extra);
              Ok(())
          }
          708 => {
              super::screenshots::selected_region_selection.record_raw(extra);
              Ok(())
          }
          709 => {
              super::screenshots::selected_visible.record_raw(extra);
              Ok(())
          }
          710 => {
              super::screenshots::started_context_menu.record_raw(extra);
              Ok(())
          }
          711 => {
              super::screenshots::started_overlay_retry.record_raw(extra);
              Ok(())
          }
          712 => {
              super::screenshots::started_preview_retry.record_raw(extra);
              Ok(())
          }
          713 => {
              super::screenshots::started_quick_actions.record_raw(extra);
              Ok(())
          }
          714 => {
              super::screenshots::started_shortcut.record_raw(extra);
              Ok(())
          }
          715 => {
              super::screenshots::started_toolbar_button.record_raw(extra);
              Ok(())
          }
          764 => {
              super::newtab_search_ad::click.record_raw(extra);
              Ok(())
          }
          765 => {
              super::newtab_search_ad::impression.record_raw(extra);
              Ok(())
          }
          766 => {
              super::sap::counts.record_raw(extra);
              Ok(())
          }
          768 => {
              super::sap::search_form_counts.record_raw(extra);
              Ok(())
          }
          772 => {
              super::serp::abandonment.record_raw(extra);
              Ok(())
          }
          773 => {
              super::serp::ad_impression.record_raw(extra);
              Ok(())
          }
          775 => {
              super::serp::categorization.record_raw(extra);
              Ok(())
          }
          778 => {
              super::serp::engagement.record_raw(extra);
              Ok(())
          }
          780 => {
              super::serp::impression.record_raw(extra);
              Ok(())
          }
          798 => {
              super::session_restore::backup_can_be_loaded_session_file.record_raw(extra);
              Ok(())
          }
          811 => {
              super::session_restore::shutdown_success_session_startup.record_raw(extra);
              Ok(())
          }
          815 => {
              super::shopping::address_bar_feature_callout_displayed.record_raw(extra);
              Ok(())
          }
          816 => {
              super::shopping::address_bar_icon_clicked.record_raw(extra);
              Ok(())
          }
          817 => {
              super::shopping::address_bar_icon_displayed.record_raw(extra);
              Ok(())
          }
          819 => {
              super::shopping::surface_ads_clicked.record_raw(extra);
              Ok(())
          }
          820 => {
              super::shopping::surface_ads_impression.record_raw(extra);
              Ok(())
          }
          821 => {
              super::shopping::surface_ads_placement.record_raw(extra);
              Ok(())
          }
          822 => {
              super::shopping::surface_ads_setting_toggled.record_raw(extra);
              Ok(())
          }
          823 => {
              super::shopping::surface_analyze_reviews_none_available_clicked.record_raw(extra);
              Ok(())
          }
          824 => {
              super::shopping::surface_auto_open_setting_toggled.record_raw(extra);
              Ok(())
          }
          825 => {
              super::shopping::surface_closed.record_raw(extra);
              Ok(())
          }
          826 => {
              super::shopping::surface_displayed.record_raw(extra);
              Ok(())
          }
          827 => {
              super::shopping::surface_learn_more_clicked.record_raw(extra);
              Ok(())
          }
          828 => {
              super::shopping::surface_no_ads_available.record_raw(extra);
              Ok(())
          }
          829 => {
              super::shopping::surface_no_review_reliability_available.record_raw(extra);
              Ok(())
          }
          830 => {
              super::shopping::surface_no_thanks_button_clicked.record_raw(extra);
              Ok(())
          }
          831 => {
              super::shopping::surface_not_now_clicked.record_raw(extra);
              Ok(())
          }
          832 => {
              super::shopping::surface_notification_card_dismiss_clicked.record_raw(extra);
              Ok(())
          }
          833 => {
              super::shopping::surface_notification_card_impression.record_raw(extra);
              Ok(())
          }
          834 => {
              super::shopping::surface_notification_card_move_left_clicked.record_raw(extra);
              Ok(())
          }
          835 => {
              super::shopping::surface_notification_card_move_right_clicked.record_raw(extra);
              Ok(())
          }
          836 => {
              super::shopping::surface_notification_card_sidebar_settings_clicked.record_raw(extra);
              Ok(())
          }
          837 => {
              super::shopping::surface_onboarding_displayed.record_raw(extra);
              Ok(())
          }
          838 => {
              super::shopping::surface_opt_in_clicked.record_raw(extra);
              Ok(())
          }
          839 => {
              super::shopping::surface_opt_out_button_clicked.record_raw(extra);
              Ok(())
          }
          840 => {
              super::shopping::surface_powered_by_fakespot_link_clicked.record_raw(extra);
              Ok(())
          }
          841 => {
              super::shopping::surface_reactivated_button_clicked.record_raw(extra);
              Ok(())
          }
          842 => {
              super::shopping::surface_reanalyze_clicked.record_raw(extra);
              Ok(())
          }
          843 => {
              super::shopping::surface_settings_expand_clicked.record_raw(extra);
              Ok(())
          }
          844 => {
              super::shopping::surface_show_more_reviews_button_clicked.record_raw(extra);
              Ok(())
          }
          845 => {
              super::shopping::surface_show_privacy_policy_clicked.record_raw(extra);
              Ok(())
          }
          846 => {
              super::shopping::surface_show_quality_explainer_clicked.record_raw(extra);
              Ok(())
          }
          847 => {
              super::shopping::surface_show_quality_explainer_url_clicked.record_raw(extra);
              Ok(())
          }
          848 => {
              super::shopping::surface_show_terms_clicked.record_raw(extra);
              Ok(())
          }
          849 => {
              super::shopping::surface_stale_analysis_shown.record_raw(extra);
              Ok(())
          }
          850 => {
              super::shopping::surface_yes_keep_closed_button_clicked.record_raw(extra);
              Ok(())
          }
          851 => {
              super::shopping::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          857 => {
              super::bookmarks::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          858 => {
              super::contextual_manager::passwords_enabled.record_raw(extra);
              Ok(())
          }
          859 => {
              super::contextual_manager::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          860 => {
              super::contextual_manager::notification_interaction.record_raw(extra);
              Ok(())
          }
          861 => {
              super::contextual_manager::notification_shown.record_raw(extra);
              Ok(())
          }
          862 => {
              super::contextual_manager::records_interaction.record_raw(extra);
              Ok(())
          }
          863 => {
              super::contextual_manager::records_update.record_raw(extra);
              Ok(())
          }
          864 => {
              super::contextual_manager::toolbar_action.record_raw(extra);
              Ok(())
          }
          865 => {
              super::extension::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          866 => {
              super::history::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          867 => {
              super::sidebar::addon_icon_click.record_raw(extra);
              Ok(())
          }
          868 => {
              super::sidebar::bookmarks_icon_click.record_raw(extra);
              Ok(())
          }
          869 => {
              super::sidebar::chatbot_icon_click.record_raw(extra);
              Ok(())
          }
          871 => {
              super::sidebar::expand.record_raw(extra);
              Ok(())
          }
          872 => {
              super::sidebar::history_icon_click.record_raw(extra);
              Ok(())
          }
          873 => {
              super::sidebar::keyboard_shortcut.record_raw(extra);
              Ok(())
          }
          876 => {
              super::sidebar::resize.record_raw(extra);
              Ok(())
          }
          878 => {
              super::sidebar::shopping_review_checker_icon_click.record_raw(extra);
              Ok(())
          }
          879 => {
              super::sidebar::synced_tabs_icon_click.record_raw(extra);
              Ok(())
          }
          882 => {
              super::sidebar_customize::bookmarks_enabled.record_raw(extra);
              Ok(())
          }
          883 => {
              super::sidebar_customize::chatbot_enabled.record_raw(extra);
              Ok(())
          }
          884 => {
              super::sidebar_customize::expand_on_hover_enabled.record_raw(extra);
              Ok(())
          }
          885 => {
              super::sidebar_customize::extensions_clicked.record_raw(extra);
              Ok(())
          }
          886 => {
              super::sidebar_customize::firefox_settings_clicked.record_raw(extra);
              Ok(())
          }
          887 => {
              super::sidebar_customize::history_enabled.record_raw(extra);
              Ok(())
          }
          888 => {
              super::sidebar_customize::icon_click.record_raw(extra);
              Ok(())
          }
          889 => {
              super::sidebar_customize::panel_toggle.record_raw(extra);
              Ok(())
          }
          890 => {
              super::sidebar_customize::shopping_review_checker_enabled.record_raw(extra);
              Ok(())
          }
          891 => {
              super::sidebar_customize::sidebar_display.record_raw(extra);
              Ok(())
          }
          892 => {
              super::sidebar_customize::sidebar_position.record_raw(extra);
              Ok(())
          }
          893 => {
              super::sidebar_customize::synced_tabs_enabled.record_raw(extra);
              Ok(())
          }
          894 => {
              super::sidebar_customize::tabs_display.record_raw(extra);
              Ok(())
          }
          895 => {
              super::sidebar_customize::tabs_layout.record_raw(extra);
              Ok(())
          }
          896 => {
              super::synced_tabs::sidebar_toggle.record_raw(extra);
              Ok(())
          }
          897 => {
              super::synced_tabs::click_fxa_app_menu.record_raw(extra);
              Ok(())
          }
          898 => {
              super::synced_tabs::click_fxa_avatar_menu.record_raw(extra);
              Ok(())
          }
          899 => {
              super::synced_tabs::click_synced_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          936 => {
              super::tabgroup::add_tab.record_raw(extra);
              Ok(())
          }
          937 => {
              super::tabgroup::create_group.record_raw(extra);
              Ok(())
          }
          938 => {
              super::tabgroup::delete.record_raw(extra);
              Ok(())
          }
          940 => {
              super::tabgroup::reopen.record_raw(extra);
              Ok(())
          }
          941 => {
              super::tabgroup::save.record_raw(extra);
              Ok(())
          }
          943 => {
              super::tabgroup::smart_tab.record_raw(extra);
              Ok(())
          }
          945 => {
              super::tabgroup::smart_tab_optin.record_raw(extra);
              Ok(())
          }
          946 => {
              super::tabgroup::smart_tab_suggest.record_raw(extra);
              Ok(())
          }
          947 => {
              super::tabgroup::smart_tab_topic.record_raw(extra);
              Ok(())
          }
          952 => {
              super::tabgroup::ungroup.record_raw(extra);
              Ok(())
          }
          975 => {
              super::urlbar::abandonment.record_raw(extra);
              Ok(())
          }
          979 => {
              super::urlbar::engagement.record_raw(extra);
              Ok(())
          }
          980 => {
              super::urlbar::exposure.record_raw(extra);
              Ok(())
          }
          981 => {
              super::urlbar::fakespot_engagement.record_raw(extra);
              Ok(())
          }
          982 => {
              super::urlbar::keyword_exposure.record_raw(extra);
              Ok(())
          }
          988 => {
              super::urlbar::quick_suggest_contextual_opt_in.record_raw(extra);
              Ok(())
          }
          998 => {
              super::addons_search_detection::etld_change_other.record_raw(extra);
              Ok(())
          }
          999 => {
              super::addons_search_detection::etld_change_webrequest.record_raw(extra);
              Ok(())
          }
          1014 => {
              super::browser_usage::interaction.record_raw(extra);
              Ok(())
          }
          1015 => {
              super::homepage::preference_ignore.record_raw(extra);
              Ok(())
          }
          1016 => {
              super::installation::first_seen_full.record_raw(extra);
              Ok(())
          }
          1017 => {
              super::installation::first_seen_msix.record_raw(extra);
              Ok(())
          }
          1018 => {
              super::installation::first_seen_stub.record_raw(extra);
              Ok(())
          }
          1032 => {
              super::partner_link::attribution_abort.record_raw(extra);
              Ok(())
          }
          1033 => {
              super::partner_link::attribution_failure.record_raw(extra);
              Ok(())
          }
          1034 => {
              super::partner_link::attribution_success.record_raw(extra);
              Ok(())
          }
          1035 => {
              super::partner_link::click_newtab.record_raw(extra);
              Ok(())
          }
          1036 => {
              super::partner_link::click_urlbar.record_raw(extra);
              Ok(())
          }
          1135 => {
              super::devtools_main::activate_responsive_design.record_raw(extra);
              Ok(())
          }
          1136 => {
              super::devtools_main::activate_split_console.record_raw(extra);
              Ok(())
          }
          1137 => {
              super::devtools_main::add_breakpoint_debugger.record_raw(extra);
              Ok(())
          }
          1138 => {
              super::devtools_main::blackbox_debugger.record_raw(extra);
              Ok(())
          }
          1139 => {
              super::devtools_main::close_adbg_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1140 => {
              super::devtools_main::close_tools.record_raw(extra);
              Ok(())
          }
          1141 => {
              super::devtools_main::connection_attempt_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1142 => {
              super::devtools_main::continue_debugger.record_raw(extra);
              Ok(())
          }
          1143 => {
              super::devtools_main::deactivate_responsive_design.record_raw(extra);
              Ok(())
          }
          1144 => {
              super::devtools_main::deactivate_split_console.record_raw(extra);
              Ok(())
          }
          1145 => {
              super::devtools_main::device_added_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1146 => {
              super::devtools_main::device_removed_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1147 => {
              super::devtools_main::edit_html_inspector.record_raw(extra);
              Ok(())
          }
          1148 => {
              super::devtools_main::edit_resend_netmonitor.record_raw(extra);
              Ok(())
          }
          1149 => {
              super::devtools_main::edit_rule_ruleview.record_raw(extra);
              Ok(())
          }
          1150 => {
              super::devtools_main::enter_accessibility.record_raw(extra);
              Ok(())
          }
          1151 => {
              super::devtools_main::enter_application.record_raw(extra);
              Ok(())
          }
          1152 => {
              super::devtools_main::enter_dom.record_raw(extra);
              Ok(())
          }
          1153 => {
              super::devtools_main::enter_fake_tool4242.record_raw(extra);
              Ok(())
          }
          1154 => {
              super::devtools_main::enter_inspector.record_raw(extra);
              Ok(())
          }
          1155 => {
              super::devtools_main::enter_jsdebugger.record_raw(extra);
              Ok(())
          }
          1156 => {
              super::devtools_main::enter_memory.record_raw(extra);
              Ok(())
          }
          1157 => {
              super::devtools_main::enter_netmonitor.record_raw(extra);
              Ok(())
          }
          1158 => {
              super::devtools_main::enter_options.record_raw(extra);
              Ok(())
          }
          1159 => {
              super::devtools_main::enter_other.record_raw(extra);
              Ok(())
          }
          1160 => {
              super::devtools_main::enter_performance.record_raw(extra);
              Ok(())
          }
          1161 => {
              super::devtools_main::enter_storage.record_raw(extra);
              Ok(())
          }
          1162 => {
              super::devtools_main::enter_styleeditor.record_raw(extra);
              Ok(())
          }
          1163 => {
              super::devtools_main::enter_test_blank_panel.record_raw(extra);
              Ok(())
          }
          1164 => {
              super::devtools_main::enter_test_tool.record_raw(extra);
              Ok(())
          }
          1165 => {
              super::devtools_main::enter_test_tool1072208.record_raw(extra);
              Ok(())
          }
          1166 => {
              super::devtools_main::enter_testtool1.record_raw(extra);
              Ok(())
          }
          1167 => {
              super::devtools_main::enter_testtool2.record_raw(extra);
              Ok(())
          }
          1168 => {
              super::devtools_main::enter_webconsole.record_raw(extra);
              Ok(())
          }
          1169 => {
              super::devtools_main::enter_whatsnew.record_raw(extra);
              Ok(())
          }
          1170 => {
              super::devtools_main::execute_js_webconsole.record_raw(extra);
              Ok(())
          }
          1171 => {
              super::devtools_main::exit_accessibility.record_raw(extra);
              Ok(())
          }
          1172 => {
              super::devtools_main::exit_application.record_raw(extra);
              Ok(())
          }
          1173 => {
              super::devtools_main::exit_dom.record_raw(extra);
              Ok(())
          }
          1174 => {
              super::devtools_main::exit_fake_tool4242.record_raw(extra);
              Ok(())
          }
          1175 => {
              super::devtools_main::exit_inspector.record_raw(extra);
              Ok(())
          }
          1176 => {
              super::devtools_main::exit_jsdebugger.record_raw(extra);
              Ok(())
          }
          1177 => {
              super::devtools_main::exit_memory.record_raw(extra);
              Ok(())
          }
          1178 => {
              super::devtools_main::exit_netmonitor.record_raw(extra);
              Ok(())
          }
          1179 => {
              super::devtools_main::exit_options.record_raw(extra);
              Ok(())
          }
          1180 => {
              super::devtools_main::exit_other.record_raw(extra);
              Ok(())
          }
          1181 => {
              super::devtools_main::exit_performance.record_raw(extra);
              Ok(())
          }
          1182 => {
              super::devtools_main::exit_storage.record_raw(extra);
              Ok(())
          }
          1183 => {
              super::devtools_main::exit_styleeditor.record_raw(extra);
              Ok(())
          }
          1184 => {
              super::devtools_main::exit_test_blank_panel.record_raw(extra);
              Ok(())
          }
          1185 => {
              super::devtools_main::exit_test_tool.record_raw(extra);
              Ok(())
          }
          1186 => {
              super::devtools_main::exit_test_tool1072208.record_raw(extra);
              Ok(())
          }
          1187 => {
              super::devtools_main::exit_testtool1.record_raw(extra);
              Ok(())
          }
          1188 => {
              super::devtools_main::exit_testtool2.record_raw(extra);
              Ok(())
          }
          1189 => {
              super::devtools_main::exit_webconsole.record_raw(extra);
              Ok(())
          }
          1190 => {
              super::devtools_main::exit_whatsnew.record_raw(extra);
              Ok(())
          }
          1191 => {
              super::devtools_main::filters_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          1192 => {
              super::devtools_main::filters_changed_webconsole.record_raw(extra);
              Ok(())
          }
          1193 => {
              super::devtools_main::inspect_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1194 => {
              super::devtools_main::jump_to_definition_webconsole.record_raw(extra);
              Ok(())
          }
          1195 => {
              super::devtools_main::jump_to_source_webconsole.record_raw(extra);
              Ok(())
          }
          1196 => {
              super::devtools_main::object_expanded_webconsole.record_raw(extra);
              Ok(())
          }
          1197 => {
              super::devtools_main::open_adbg_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1198 => {
              super::devtools_main::open_tools.record_raw(extra);
              Ok(())
          }
          1199 => {
              super::devtools_main::pause_debugger.record_raw(extra);
              Ok(())
          }
          1200 => {
              super::devtools_main::pause_on_exceptions_debugger.record_raw(extra);
              Ok(())
          }
          1201 => {
              super::devtools_main::persist_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          1202 => {
              super::devtools_main::persist_changed_webconsole.record_raw(extra);
              Ok(())
          }
          1203 => {
              super::devtools_main::pretty_print_debugger.record_raw(extra);
              Ok(())
          }
          1204 => {
              super::devtools_main::remove_breakpoint_debugger.record_raw(extra);
              Ok(())
          }
          1205 => {
              super::devtools_main::reverse_search_webconsole.record_raw(extra);
              Ok(())
          }
          1206 => {
              super::devtools_main::runtime_added_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1207 => {
              super::devtools_main::runtime_connected_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1208 => {
              super::devtools_main::runtime_disconnected_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1209 => {
              super::devtools_main::runtime_removed_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1210 => {
              super::devtools_main::select_page_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1211 => {
              super::devtools_main::select_page_application.record_raw(extra);
              Ok(())
          }
          1212 => {
              super::devtools_main::select_ws_frame_netmonitor.record_raw(extra);
              Ok(())
          }
          1213 => {
              super::devtools_main::show_profiler_aboutdebugging.record_raw(extra);
              Ok(())
          }
          1214 => {
              super::devtools_main::sidepanel_changed_inspector.record_raw(extra);
              Ok(())
          }
          1215 => {
              super::devtools_main::sidepanel_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          1216 => {
              super::devtools_main::start_worker_application.record_raw(extra);
              Ok(())
          }
          1217 => {
              super::devtools_main::throttle_changed_netmonitor.record_raw(extra);
              Ok(())
          }
          1218 => {
              super::devtools_main::tool_timer_animationinspector.record_raw(extra);
              Ok(())
          }
          1219 => {
              super::devtools_main::tool_timer_changesview.record_raw(extra);
              Ok(())
          }
          1220 => {
              super::devtools_main::tool_timer_compatibilityview.record_raw(extra);
              Ok(())
          }
          1221 => {
              super::devtools_main::tool_timer_computedview.record_raw(extra);
              Ok(())
          }
          1222 => {
              super::devtools_main::tool_timer_fontinspector.record_raw(extra);
              Ok(())
          }
          1223 => {
              super::devtools_main::tool_timer_layoutview.record_raw(extra);
              Ok(())
          }
          1224 => {
              super::devtools_main::tool_timer_ruleview.record_raw(extra);
              Ok(())
          }
          1225 => {
              super::devtools_main::unregister_worker_application.record_raw(extra);
              Ok(())
          }
          1226 => {
              super::devtools_main::update_conn_prompt_aboutdebugging.record_raw(extra);
              Ok(())
          }
          3656 => {
              super::mediadrm::eme_playback.record_raw(extra);
              Ok(())
          }
          3659 => {
              super::hls::media_load.record_raw(extra);
              Ok(())
          }
          3664 => {
              super::media::error.record_raw(extra);
              Ok(())
          }
          3686 => {
              super::media_playback::decode_error.record_raw(extra);
              Ok(())
          }
          3688 => {
              super::media_playback::first_frame_loaded.record_raw(extra);
              Ok(())
          }
          3693 => {
              super::mfcdm::eme_playback.record_raw(extra);
              Ok(())
          }
          3694 => {
              super::mfcdm::error.record_raw(extra);
              Ok(())
          }
          3749 => {
              super::webrtc_signaling::audio_msection_negotiated.record_raw(extra);
              Ok(())
          }
          3750 => {
              super::webrtc_signaling::sdp_negotiated.record_raw(extra);
              Ok(())
          }
          3751 => {
              super::webrtc_signaling::video_msection_negotiated.record_raw(extra);
              Ok(())
          }
          3802 => {
              super::perf::page_load.record_raw(extra);
              Ok(())
          }
          3835 => {
              super::dom_quota_try::error_step.record_raw(extra);
              Ok(())
          }
          3984 => {
              super::avif::dav1d_get_picture_return_value.record_raw(extra);
              Ok(())
          }
          4063 => {
              super::slow_script_warning::shown_browser.record_raw(extra);
              Ok(())
          }
          4064 => {
              super::slow_script_warning::shown_content.record_raw(extra);
              Ok(())
          }
          4083 => {
              super::zero_byte_load::load_css.record_raw(extra);
              Ok(())
          }
          4084 => {
              super::zero_byte_load::load_dtd.record_raw(extra);
              Ok(())
          }
          4085 => {
              super::zero_byte_load::load_ftl.record_raw(extra);
              Ok(())
          }
          4086 => {
              super::zero_byte_load::load_html.record_raw(extra);
              Ok(())
          }
          4087 => {
              super::zero_byte_load::load_js.record_raw(extra);
              Ok(())
          }
          4088 => {
              super::zero_byte_load::load_json.record_raw(extra);
              Ok(())
          }
          4089 => {
              super::zero_byte_load::load_others.record_raw(extra);
              Ok(())
          }
          4090 => {
              super::zero_byte_load::load_png.record_raw(extra);
              Ok(())
          }
          4091 => {
              super::zero_byte_load::load_properties.record_raw(extra);
              Ok(())
          }
          4092 => {
              super::zero_byte_load::load_svg.record_raw(extra);
              Ok(())
          }
          4093 => {
              super::zero_byte_load::load_xhtml.record_raw(extra);
              Ok(())
          }
          4094 => {
              super::zero_byte_load::load_xml.record_raw(extra);
              Ok(())
          }
          4207 => {
              super::network_dns::trr_confirmation_context.record_raw(extra);
              Ok(())
          }
          4325 => {
              super::ysod::shown_ysod.record_raw(extra);
              Ok(())
          }
          4411 => {
              super::uptake_remotecontent_result::uptake_normandy.record_raw(extra);
              Ok(())
          }
          4412 => {
              super::uptake_remotecontent_result::uptake_remotesettings.record_raw(extra);
              Ok(())
          }
          4415 => {
              super::fxa::connect_account.record_raw(extra);
              Ok(())
          }
          4416 => {
              super::fxa::disconnect_account.record_raw(extra);
              Ok(())
          }
          4417 => {
              super::sync_settings::open_choose_what_to_sync_menu.record_raw(extra);
              Ok(())
          }
          4418 => {
              super::sync_settings::save.record_raw(extra);
              Ok(())
          }
          4419 => {
              super::fxa_app_menu::click_account_settings.record_raw(extra);
              Ok(())
          }
          4420 => {
              super::fxa_app_menu::click_cad.record_raw(extra);
              Ok(())
          }
          4421 => {
              super::fxa_app_menu::click_login.record_raw(extra);
              Ok(())
          }
          4422 => {
              super::fxa_app_menu::click_monitor_cta.record_raw(extra);
              Ok(())
          }
          4423 => {
              super::fxa_app_menu::click_open_monitor.record_raw(extra);
              Ok(())
          }
          4424 => {
              super::fxa_app_menu::click_open_send.record_raw(extra);
              Ok(())
          }
          4425 => {
              super::fxa_app_menu::click_relay_cta.record_raw(extra);
              Ok(())
          }
          4426 => {
              super::fxa_app_menu::click_send_tab.record_raw(extra);
              Ok(())
          }
          4427 => {
              super::fxa_app_menu::click_sync_cta.record_raw(extra);
              Ok(())
          }
          4428 => {
              super::fxa_app_menu::click_sync_now.record_raw(extra);
              Ok(())
          }
          4429 => {
              super::fxa_app_menu::click_sync_settings.record_raw(extra);
              Ok(())
          }
          4430 => {
              super::fxa_app_menu::click_sync_tabs.record_raw(extra);
              Ok(())
          }
          4431 => {
              super::fxa_app_menu::click_sync_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          4432 => {
              super::fxa_app_menu::click_toolbar_icon.record_raw(extra);
              Ok(())
          }
          4433 => {
              super::fxa_app_menu::click_unver_sync_settings.record_raw(extra);
              Ok(())
          }
          4434 => {
              super::fxa_app_menu::click_vpn_cta.record_raw(extra);
              Ok(())
          }
          4435 => {
              super::fxa_avatar_menu::click_account_settings.record_raw(extra);
              Ok(())
          }
          4436 => {
              super::fxa_avatar_menu::click_cad.record_raw(extra);
              Ok(())
          }
          4437 => {
              super::fxa_avatar_menu::click_login.record_raw(extra);
              Ok(())
          }
          4438 => {
              super::fxa_avatar_menu::click_monitor_cta.record_raw(extra);
              Ok(())
          }
          4439 => {
              super::fxa_avatar_menu::click_open_monitor.record_raw(extra);
              Ok(())
          }
          4440 => {
              super::fxa_avatar_menu::click_open_send.record_raw(extra);
              Ok(())
          }
          4441 => {
              super::fxa_avatar_menu::click_relay_cta.record_raw(extra);
              Ok(())
          }
          4442 => {
              super::fxa_avatar_menu::click_send_tab.record_raw(extra);
              Ok(())
          }
          4443 => {
              super::fxa_avatar_menu::click_sync_cta.record_raw(extra);
              Ok(())
          }
          4444 => {
              super::fxa_avatar_menu::click_sync_now.record_raw(extra);
              Ok(())
          }
          4445 => {
              super::fxa_avatar_menu::click_sync_settings.record_raw(extra);
              Ok(())
          }
          4446 => {
              super::fxa_avatar_menu::click_sync_tabs.record_raw(extra);
              Ok(())
          }
          4447 => {
              super::fxa_avatar_menu::click_sync_tabs_sidebar.record_raw(extra);
              Ok(())
          }
          4448 => {
              super::fxa_avatar_menu::click_toolbar_icon.record_raw(extra);
              Ok(())
          }
          4449 => {
              super::fxa_avatar_menu::click_unver_sync_settings.record_raw(extra);
              Ok(())
          }
          4450 => {
              super::fxa_avatar_menu::click_vpn_cta.record_raw(extra);
              Ok(())
          }
          4453 => {
              super::sync_merge_dialog::clicked.record_raw(extra);
              Ok(())
          }
          4457 => {
              super::bounce_tracking_protection::purge_action.record_raw(extra);
              Ok(())
          }
          4490 => {
              super::background_tasks_rmdir_base::metric_base.record_raw(extra);
              Ok(())
          }
          4498 => {
              super::background_tasks_rmdir_http_cache::metric_base.record_raw(extra);
              Ok(())
          }
          4506 => {
              super::background_tasks_rmdir_quota::metric_base.record_raw(extra);
              Ok(())
          }
          4566 => {
              super::relevancy_classify::fail.record_raw(extra);
              Ok(())
          }
          4567 => {
              super::relevancy_classify::succeed.record_raw(extra);
              Ok(())
          }
          4569 => {
              super::cookie_banners::google_gdpr_choice_cookie_event.record_raw(extra);
              Ok(())
          }
          4570 => {
              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_raw(extra);
              Ok(())
          }
          4646 => {
              super::doh::evaluate_v2_heuristics.record_raw(extra);
              Ok(())
          }
          4647 => {
              super::doh::state_disabled.record_raw(extra);
              Ok(())
          }
          4648 => {
              super::doh::state_enabled.record_raw(extra);
              Ok(())
          }
          4649 => {
              super::doh::state_manually_disabled.record_raw(extra);
              Ok(())
          }
          4650 => {
              super::doh::state_policy_disabled.record_raw(extra);
              Ok(())
          }
          4651 => {
              super::doh::state_rollback.record_raw(extra);
              Ok(())
          }
          4652 => {
              super::doh::state_shutdown.record_raw(extra);
              Ok(())
          }
          4653 => {
              super::doh::state_uidisabled.record_raw(extra);
              Ok(())
          }
          4654 => {
              super::doh::state_uiok.record_raw(extra);
              Ok(())
          }
          4655 => {
              super::doh::state_uninstalled.record_raw(extra);
              Ok(())
          }
          4656 => {
              super::security_doh_trr_performance::resolved_record.record_raw(extra);
              Ok(())
          }
          4657 => {
              super::security_doh_trr_performance::trrselect_dryrunresult.record_raw(extra);
              Ok(())
          }
          4676 => {
              super::extensions_data::migrate_result.record_raw(extra);
              Ok(())
          }
          4678 => {
              super::extensions_data::storage_local_error.record_raw(extra);
              Ok(())
          }
          4679 => {
              super::extensions_data::sync_usage_quotas.record_raw(extra);
              Ok(())
          }
          4696 => {
              super::address::add_manage.record_raw(extra);
              Ok(())
          }
          4697 => {
              super::address::cancel_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4698 => {
              super::address::cancel_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4699 => {
              super::address::cancel_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4700 => {
              super::address::cleared_address_form.record_raw(extra);
              Ok(())
          }
          4701 => {
              super::address::delete_manage.record_raw(extra);
              Ok(())
          }
          4702 => {
              super::address::detected_address_form.record_raw(extra);
              Ok(())
          }
          4703 => {
              super::address::detected_address_form_ext.record_raw(extra);
              Ok(())
          }
          4704 => {
              super::address::disable_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4705 => {
              super::address::disable_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4706 => {
              super::address::disable_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4707 => {
              super::address::edit_manage.record_raw(extra);
              Ok(())
          }
          4708 => {
              super::address::filled_address_form.record_raw(extra);
              Ok(())
          }
          4709 => {
              super::address::filled_address_form_ext.record_raw(extra);
              Ok(())
          }
          4710 => {
              super::address::filled_modified_address_form.record_raw(extra);
              Ok(())
          }
          4711 => {
              super::address::filled_on_fields_update_address_form.record_raw(extra);
              Ok(())
          }
          4712 => {
              super::address::learn_more_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4713 => {
              super::address::learn_more_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4714 => {
              super::address::learn_more_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4715 => {
              super::address::popup_shown_address_form.record_raw(extra);
              Ok(())
          }
          4716 => {
              super::address::pref_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4717 => {
              super::address::pref_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4718 => {
              super::address::pref_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4719 => {
              super::address::save_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4720 => {
              super::address::save_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4721 => {
              super::address::save_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4722 => {
              super::address::show_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4723 => {
              super::address::show_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4724 => {
              super::address::show_entry_manage.record_raw(extra);
              Ok(())
          }
          4725 => {
              super::address::show_manage.record_raw(extra);
              Ok(())
          }
          4726 => {
              super::address::show_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4727 => {
              super::address::submitted_address_form.record_raw(extra);
              Ok(())
          }
          4728 => {
              super::address::submitted_address_form_ext.record_raw(extra);
              Ok(())
          }
          4729 => {
              super::address::update_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4730 => {
              super::address::update_edit_doorhanger.record_raw(extra);
              Ok(())
          }
          4731 => {
              super::address::update_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4732 => {
              super::creditcard::add_manage.record_raw(extra);
              Ok(())
          }
          4733 => {
              super::creditcard::cancel_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4734 => {
              super::creditcard::cancel_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4735 => {
              super::creditcard::cleared_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4736 => {
              super::creditcard::delete_manage.record_raw(extra);
              Ok(())
          }
          4737 => {
              super::creditcard::detected_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4739 => {
              super::creditcard::disable_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4740 => {
              super::creditcard::disable_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4741 => {
              super::creditcard::edit_manage.record_raw(extra);
              Ok(())
          }
          4742 => {
              super::creditcard::filled_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4743 => {
              super::creditcard::filled_modified_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4744 => {
              super::creditcard::filled_on_fields_update_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4745 => {
              super::creditcard::os_keystore_decrypt.record_raw(extra);
              Ok(())
          }
          4746 => {
              super::creditcard::popup_shown_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4747 => {
              super::creditcard::save_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4748 => {
              super::creditcard::save_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4749 => {
              super::creditcard::show_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4750 => {
              super::creditcard::show_entry_manage.record_raw(extra);
              Ok(())
          }
          4751 => {
              super::creditcard::show_manage.record_raw(extra);
              Ok(())
          }
          4752 => {
              super::creditcard::show_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4753 => {
              super::creditcard::submitted_cc_form_v2.record_raw(extra);
              Ok(())
          }
          4754 => {
              super::creditcard::update_capture_doorhanger.record_raw(extra);
              Ok(())
          }
          4755 => {
              super::creditcard::update_update_doorhanger.record_raw(extra);
              Ok(())
          }
          4758 => {
              super::formautofill::iframe_layout_detection.record_raw(extra);
              Ok(())
          }
          4760 => {
              super::formautofill::prompt_shown_os_reauth.record_raw(extra);
              Ok(())
          }
          4761 => {
              super::formautofill::require_os_reauth_toggle.record_raw(extra);
              Ok(())
          }
          4764 => {
              super::formautofill_ml::field_infer_result.record_raw(extra);
              Ok(())
          }
          4836 => {
              super::test_only_ipc::an_event.record_raw(extra);
              Ok(())
          }
          4841 => {
              super::test_only_ipc::event_with_extra.record_raw(extra);
              Ok(())
          }
          4843 => {
              super::test_only_ipc::no_extra_event.record_raw(extra);
              Ok(())
          }
          4846 => {
              super::test_only_jog::an_event.record_raw(extra);
              Ok(())
          }
          4848 => {
              super::messaging_experiments::reach_cfr.record_raw(extra);
              Ok(())
          }
          4849 => {
              super::messaging_experiments::reach_feature_callout.record_raw(extra);
              Ok(())
          }
          4850 => {
              super::messaging_experiments::reach_fxms_bmb_button.record_raw(extra);
              Ok(())
          }
          4851 => {
              super::messaging_experiments::reach_fxms_message_1.record_raw(extra);
              Ok(())
          }
          4852 => {
              super::messaging_experiments::reach_fxms_message_10.record_raw(extra);
              Ok(())
          }
          4853 => {
              super::messaging_experiments::reach_fxms_message_11.record_raw(extra);
              Ok(())
          }
          4854 => {
              super::messaging_experiments::reach_fxms_message_2.record_raw(extra);
              Ok(())
          }
          4855 => {
              super::messaging_experiments::reach_fxms_message_3.record_raw(extra);
              Ok(())
          }
          4856 => {
              super::messaging_experiments::reach_fxms_message_4.record_raw(extra);
              Ok(())
          }
          4857 => {
              super::messaging_experiments::reach_fxms_message_5.record_raw(extra);
              Ok(())
          }
          4858 => {
              super::messaging_experiments::reach_fxms_message_6.record_raw(extra);
              Ok(())
          }
          4859 => {
              super::messaging_experiments::reach_fxms_message_7.record_raw(extra);
              Ok(())
          }
          4860 => {
              super::messaging_experiments::reach_fxms_message_8.record_raw(extra);
              Ok(())
          }
          4861 => {
              super::messaging_experiments::reach_fxms_message_9.record_raw(extra);
              Ok(())
          }
          4862 => {
              super::messaging_experiments::reach_infobar.record_raw(extra);
              Ok(())
          }
          4863 => {
              super::messaging_experiments::reach_moments_page.record_raw(extra);
              Ok(())
          }
          4864 => {
              super::messaging_experiments::reach_spotlight.record_raw(extra);
              Ok(())
          }
          4865 => {
              super::messaging_experiments::targeting_attribute_error.record_raw(extra);
              Ok(())
          }
          4866 => {
              super::messaging_experiments::targeting_attribute_timeout.record_raw(extra);
              Ok(())
          }
          4867 => {
              super::firefox_ai_runtime::engine_creation_failure.record_raw(extra);
              Ok(())
          }
          4869 => {
              super::firefox_ai_runtime::run_inference_failure.record_raw(extra);
              Ok(())
          }
          4871 => {
              super::nimbus_events::enroll_failed.record_raw(extra);
              Ok(())
          }
          4872 => {
              super::nimbus_events::enrollment.record_raw(extra);
              Ok(())
          }
          4873 => {
              super::nimbus_events::enrollment_status.record_raw(extra);
              Ok(())
          }
          4874 => {
              super::nimbus_events::exposure.record_raw(extra);
              Ok(())
          }
          4875 => {
              super::nimbus_events::is_ready.record_raw(extra);
              Ok(())
          }
          4876 => {
              super::nimbus_events::migration.record_raw(extra);
              Ok(())
          }
          4877 => {
              super::nimbus_events::unenroll_failed.record_raw(extra);
              Ok(())
          }
          4878 => {
              super::nimbus_events::unenrollment.record_raw(extra);
              Ok(())
          }
          4879 => {
              super::nimbus_events::validation_failed.record_raw(extra);
              Ok(())
          }
          4916 => {
              super::normandy::expose_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4917 => {
              super::normandy::enroll_addon_rollout.record_raw(extra);
              Ok(())
          }
          4918 => {
              super::normandy::enroll_addon_study.record_raw(extra);
              Ok(())
          }
          4919 => {
              super::normandy::enroll_failed_addon_rollout.record_raw(extra);
              Ok(())
          }
          4920 => {
              super::normandy::enroll_failed_addon_study.record_raw(extra);
              Ok(())
          }
          4921 => {
              super::normandy::enroll_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4922 => {
              super::normandy::enroll_failed_preference_rollout.record_raw(extra);
              Ok(())
          }
          4923 => {
              super::normandy::enroll_failed_preference_study.record_raw(extra);
              Ok(())
          }
          4924 => {
              super::normandy::enroll_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4925 => {
              super::normandy::enroll_preference_rollout.record_raw(extra);
              Ok(())
          }
          4926 => {
              super::normandy::enroll_preference_study.record_raw(extra);
              Ok(())
          }
          4927 => {
              super::normandy::exp_pref_changed_preference_study.record_raw(extra);
              Ok(())
          }
          4928 => {
              super::normandy::graduate_preference_rollout.record_raw(extra);
              Ok(())
          }
          4930 => {
              super::normandy::unenroll_addon_rollback.record_raw(extra);
              Ok(())
          }
          4931 => {
              super::normandy::unenroll_addon_study.record_raw(extra);
              Ok(())
          }
          4932 => {
              super::normandy::unenroll_failed_addon_rollback.record_raw(extra);
              Ok(())
          }
          4933 => {
              super::normandy::unenroll_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4934 => {
              super::normandy::unenroll_failed_preference_rollback.record_raw(extra);
              Ok(())
          }
          4935 => {
              super::normandy::unenroll_failed_preference_study.record_raw(extra);
              Ok(())
          }
          4936 => {
              super::normandy::unenroll_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4937 => {
              super::normandy::unenroll_preference_rollback.record_raw(extra);
              Ok(())
          }
          4938 => {
              super::normandy::unenroll_preference_study.record_raw(extra);
              Ok(())
          }
          4939 => {
              super::normandy::update_addon_rollout.record_raw(extra);
              Ok(())
          }
          4940 => {
              super::normandy::update_addon_study.record_raw(extra);
              Ok(())
          }
          4941 => {
              super::normandy::update_failed_addon_rollout.record_raw(extra);
              Ok(())
          }
          4942 => {
              super::normandy::update_failed_addon_study.record_raw(extra);
              Ok(())
          }
          4943 => {
              super::normandy::update_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4944 => {
              super::normandy::update_preference_rollout.record_raw(extra);
              Ok(())
          }
          4945 => {
              super::normandy::validation_failed_nimbus_experiment.record_raw(extra);
              Ok(())
          }
          4946 => {
              super::form_autocomplete::show_logins.record_raw(extra);
              Ok(())
          }
          4947 => {
              super::pwmgr::autocomplete_field_generatedpassword.record_raw(extra);
              Ok(())
          }
          4948 => {
              super::pwmgr::autocomplete_shown_generatedpassword.record_raw(extra);
              Ok(())
          }
          4949 => {
              super::pwmgr::cancel_existing_login.record_raw(extra);
              Ok(())
          }
          4950 => {
              super::pwmgr::cancel_new_login.record_raw(extra);
              Ok(())
          }
          4951 => {
              super::pwmgr::copy_password.record_raw(extra);
              Ok(())
          }
          4952 => {
              super::pwmgr::copy_username.record_raw(extra);
              Ok(())
          }
          4953 => {
              super::pwmgr::delete_existing_login.record_raw(extra);
              Ok(())
          }
          4954 => {
              super::pwmgr::delete_new_login.record_raw(extra);
              Ok(())
          }
          4955 => {
              super::pwmgr::doorhanger_submitted_save.record_raw(extra);
              Ok(())
          }
          4956 => {
              super::pwmgr::doorhanger_submitted_update.record_raw(extra);
              Ok(())
          }
          4957 => {
              super::pwmgr::edit_existing_login.record_raw(extra);
              Ok(())
          }
          4958 => {
              super::pwmgr::filled_field_edited_generatedpassword.record_raw(extra);
              Ok(())
          }
          4959 => {
              super::pwmgr::filter_list.record_raw(extra);
              Ok(())
          }
          4961 => {
              super::pwmgr::hide_password.record_raw(extra);
              Ok(())
          }
          4964 => {
              super::pwmgr::learn_more_vuln_existing_login.record_raw(extra);
              Ok(())
          }
          4966 => {
              super::pwmgr::mgmt_menu_item_used_export.record_raw(extra);
              Ok(())
          }
          4967 => {
              super::pwmgr::mgmt_menu_item_used_export_complete.record_raw(extra);
              Ok(())
          }
          4968 => {
              super::pwmgr::mgmt_menu_item_used_import_csv_complete.record_raw(extra);
              Ok(())
          }
          4969 => {
              super::pwmgr::mgmt_menu_item_used_import_from_browser.record_raw(extra);
              Ok(())
          }
          4970 => {
              super::pwmgr::mgmt_menu_item_used_import_from_csv.record_raw(extra);
              Ok(())
          }
          4971 => {
              super::pwmgr::mgmt_menu_item_used_preferences.record_raw(extra);
              Ok(())
          }
          4972 => {
              super::pwmgr::new_new_login.record_raw(extra);
              Ok(())
          }
          4975 => {
              super::pwmgr::open_management_aboutprotections.record_raw(extra);
              Ok(())
          }
          4976 => {
              super::pwmgr::open_management_autocomplete.record_raw(extra);
              Ok(())
          }
          4977 => {
              super::pwmgr::open_management_contextmenu.record_raw(extra);
              Ok(())
          }
          4978 => {
              super::pwmgr::open_management_direct.record_raw(extra);
              Ok(())
          }
          4979 => {
              super::pwmgr::open_management_mainmenu.record_raw(extra);
              Ok(())
          }
          4980 => {
              super::pwmgr::open_management_pageinfo.record_raw(extra);
              Ok(())
          }
          4981 => {
              super::pwmgr::open_management_preferences.record_raw(extra);
              Ok(())
          }
          4982 => {
              super::pwmgr::open_management_snippet.record_raw(extra);
              Ok(())
          }
          4983 => {
              super::pwmgr::open_site_existing_login.record_raw(extra);
              Ok(())
          }
          4987 => {
              super::pwmgr::prompt_shown_os_reauth.record_raw(extra);
              Ok(())
          }
          4989 => {
              super::pwmgr::reauthenticate_master_password.record_raw(extra);
              Ok(())
          }
          4990 => {
              super::pwmgr::reauthenticate_os_auth.record_raw(extra);
              Ok(())
          }
          4991 => {
              super::pwmgr::require_os_reauth_toggle.record_raw(extra);
              Ok(())
          }
          4992 => {
              super::pwmgr::save_existing_login.record_raw(extra);
              Ok(())
          }
          4993 => {
              super::pwmgr::save_new_login.record_raw(extra);
              Ok(())
          }
          4994 => {
              super::pwmgr::saved_login_used_auth_login.record_raw(extra);
              Ok(())
          }
          4995 => {
              super::pwmgr::saved_login_used_form_login.record_raw(extra);
              Ok(())
          }
          4996 => {
              super::pwmgr::saved_login_used_form_password.record_raw(extra);
              Ok(())
          }
          4997 => {
              super::pwmgr::saved_login_used_prompt_login.record_raw(extra);
              Ok(())
          }
          4999 => {
              super::pwmgr::select_existing_login.record_raw(extra);
              Ok(())
          }
          5000 => {
              super::pwmgr::show_password.record_raw(extra);
              Ok(())
          }
          5002 => {
              super::pwmgr::sort_list.record_raw(extra);
              Ok(())
          }
          5003 => {
              super::relay_integration::clicked_fill_username.record_raw(extra);
              Ok(())
          }
          5004 => {
              super::relay_integration::clicked_offer_relay.record_raw(extra);
              Ok(())
          }
          5005 => {
              super::relay_integration::disabled_opt_in_panel.record_raw(extra);
              Ok(())
          }
          5006 => {
              super::relay_integration::disabled_pref_change.record_raw(extra);
              Ok(())
          }
          5007 => {
              super::relay_integration::enabled_opt_in_panel.record_raw(extra);
              Ok(())
          }
          5008 => {
              super::relay_integration::enabled_pref_change.record_raw(extra);
              Ok(())
          }
          5009 => {
              super::relay_integration::get_unlimited_masks_reuse_panel.record_raw(extra);
              Ok(())
          }
          5010 => {
              super::relay_integration::postponed_opt_in_panel.record_raw(extra);
              Ok(())
          }
          5011 => {
              super::relay_integration::reuse_mask_reuse_panel.record_raw(extra);
              Ok(())
          }
          5012 => {
              super::relay_integration::shown_fill_username.record_raw(extra);
              Ok(())
          }
          5013 => {
              super::relay_integration::shown_offer_relay.record_raw(extra);
              Ok(())
          }
          5014 => {
              super::relay_integration::shown_opt_in_panel.record_raw(extra);
              Ok(())
          }
          5015 => {
              super::relay_integration::shown_reuse_panel.record_raw(extra);
              Ok(())
          }
          5034 => {
              super::pdfjs_image::add_image_click.record_raw(extra);
              Ok(())
          }
          5037 => {
              super::pdfjs_image::icon_click.record_raw(extra);
              Ok(())
          }
          5038 => {
              super::pdfjs_image::image_added.record_raw(extra);
              Ok(())
          }
          5039 => {
              super::pdfjs_image::image_selected.record_raw(extra);
              Ok(())
          }
          5040 => {
              super::pdfjs_image_alt_text::ai_generation_check.record_raw(extra);
              Ok(())
          }
          5041 => {
              super::pdfjs_image_alt_text::callout_dismissed.record_raw(extra);
              Ok(())
          }
          5042 => {
              super::pdfjs_image_alt_text::callout_displayed.record_raw(extra);
              Ok(())
          }
          5043 => {
              super::pdfjs_image_alt_text::dismiss.record_raw(extra);
              Ok(())
          }
          5044 => {
              super::pdfjs_image_alt_text::image_status_label_clicked.record_raw(extra);
              Ok(())
          }
          5045 => {
              super::pdfjs_image_alt_text::image_status_label_displayed.record_raw(extra);
              Ok(())
          }
          5046 => {
              super::pdfjs_image_alt_text::info.record_raw(extra);
              Ok(())
          }
          5047 => {
              super::pdfjs_image_alt_text::model_deleted.record_raw(extra);
              Ok(())
          }
          5048 => {
              super::pdfjs_image_alt_text::model_download_complete.record_raw(extra);
              Ok(())
          }
          5049 => {
              super::pdfjs_image_alt_text::model_download_error.record_raw(extra);
              Ok(())
          }
          5050 => {
              super::pdfjs_image_alt_text::model_download_start.record_raw(extra);
              Ok(())
          }
          5051 => {
              super::pdfjs_image_alt_text::model_result.record_raw(extra);
              Ok(())
          }
          5052 => {
              super::pdfjs_image_alt_text::save.record_raw(extra);
              Ok(())
          }
          5053 => {
              super::pdfjs_image_alt_text::settings_ai_generation_check.record_raw(extra);
              Ok(())
          }
          5054 => {
              super::pdfjs_image_alt_text::settings_displayed.record_raw(extra);
              Ok(())
          }
          5055 => {
              super::pdfjs_image_alt_text::settings_edit_alt_text_check.record_raw(extra);
              Ok(())
          }
          5056 => {
              super::pdfjs_image_alt_text::user_edit.record_raw(extra);
              Ok(())
          }
          5057 => {
              super::pdfjs_signature::added.record_raw(extra);
              Ok(())
          }
          5059 => {
              super::pdfjs_signature::created.record_raw(extra);
              Ok(())
          }
          5060 => {
              super::pdfjs_signature::delete_saved.record_raw(extra);
              Ok(())
          }
          5062 => {
              super::pdfjs_signature::inserted.record_raw(extra);
              Ok(())
          }
          5064 => {
              super::pictureinpicture::closed_method_browser_crash.record_raw(extra);
              Ok(())
          }
          5065 => {
              super::pictureinpicture::closed_method_close_button.record_raw(extra);
              Ok(())
          }
          5066 => {
              super::pictureinpicture::closed_method_close_player_shortcut.record_raw(extra);
              Ok(())
          }
          5067 => {
              super::pictureinpicture::closed_method_context_menu.record_raw(extra);
              Ok(())
          }
          5068 => {
              super::pictureinpicture::closed_method_foregrounded.record_raw(extra);
              Ok(())
          }
          5069 => {
              super::pictureinpicture::closed_method_fullscreen.record_raw(extra);
              Ok(())
          }
          5070 => {
              super::pictureinpicture::closed_method_pagehide.record_raw(extra);
              Ok(())
          }
          5071 => {
              super::pictureinpicture::closed_method_setup_failure.record_raw(extra);
              Ok(())
          }
          5072 => {
              super::pictureinpicture::closed_method_shortcut.record_raw(extra);
              Ok(())
          }
          5073 => {
              super::pictureinpicture::closed_method_unpip.record_raw(extra);
              Ok(())
          }
          5074 => {
              super::pictureinpicture::closed_method_url_bar.record_raw(extra);
              Ok(())
          }
          5075 => {
              super::pictureinpicture::closed_method_video_el_emptied.record_raw(extra);
              Ok(())
          }
          5076 => {
              super::pictureinpicture::closed_method_video_el_remove.record_raw(extra);
              Ok(())
          }
          5077 => {
              super::pictureinpicture::create_player.record_raw(extra);
              Ok(())
          }
          5078 => {
              super::pictureinpicture::disrespect_disable_url_bar.record_raw(extra);
              Ok(())
          }
          5080 => {
              super::pictureinpicture::fullscreen_player.record_raw(extra);
              Ok(())
          }
          5082 => {
              super::pictureinpicture::opened_method_auto_pip.record_raw(extra);
              Ok(())
          }
          5083 => {
              super::pictureinpicture::opened_method_context_menu.record_raw(extra);
              Ok(())
          }
          5084 => {
              super::pictureinpicture::opened_method_shortcut.record_raw(extra);
              Ok(())
          }
          5085 => {
              super::pictureinpicture::opened_method_toggle.record_raw(extra);
              Ok(())
          }
          5086 => {
              super::pictureinpicture::opened_method_url_bar.record_raw(extra);
              Ok(())
          }
          5087 => {
              super::pictureinpicture::resize_player.record_raw(extra);
              Ok(())
          }
          5088 => {
              super::pictureinpicture::saw_toggle_toggle.record_raw(extra);
              Ok(())
          }
          5089 => {
              super::pictureinpicture::subtitles_shown_subtitles.record_raw(extra);
              Ok(())
          }
          5092 => {
              super::pictureinpicture_settings::disable_player.record_raw(extra);
              Ok(())
          }
          5093 => {
              super::pictureinpicture_settings::disable_settings.record_raw(extra);
              Ok(())
          }
          5094 => {
              super::pictureinpicture_settings::enable_autotrigger_settings.record_raw(extra);
              Ok(())
          }
          5095 => {
              super::pictureinpicture_settings::enable_settings.record_raw(extra);
              Ok(())
          }
          5150 => {
              super::readermode::button_click.record_raw(extra);
              Ok(())
          }
          5153 => {
              super::readermode::view_off.record_raw(extra);
              Ok(())
          }
          5154 => {
              super::readermode::view_on.record_raw(extra);
              Ok(())
          }
          5196 => {
              super::webcompatreporting::opened.record_raw(extra);
              Ok(())
          }
          5197 => {
              super::webcompatreporting::reason_dropdown.record_raw(extra);
              Ok(())
          }
          5198 => {
              super::webcompatreporting::send.record_raw(extra);
              Ok(())
          }
          5199 => {
              super::webcompatreporting::send_more_info.record_raw(extra);
              Ok(())
          }
          5487 => {
              super::search_engine_default::changed.record_raw(extra);
              Ok(())
          }
          5495 => {
              super::search_engine_private::changed.record_raw(extra);
              Ok(())
          }
          5508 => {
              super::shopping_product::invalid_ohttp_config.record_raw(extra);
              Ok(())
          }
          5509 => {
              super::shopping_product::invalid_request.record_raw(extra);
              Ok(())
          }
          5510 => {
              super::shopping_product::invalid_response.record_raw(extra);
              Ok(())
          }
          5511 => {
              super::shopping_product::request_aborted.record_raw(extra);
              Ok(())
          }
          5512 => {
              super::shopping_product::request_error.record_raw(extra);
              Ok(())
          }
          5513 => {
              super::shopping_product::request_failure.record_raw(extra);
              Ok(())
          }
          5514 => {
              super::shopping_product::request_retried.record_raw(extra);
              Ok(())
          }
          5515 => {
              super::shopping_product::request_retries_failed.record_raw(extra);
              Ok(())
          }
          5516 => {
              super::shopping_product::server_failure.record_raw(extra);
              Ok(())
          }
          5571 => {
              super::telemetry_test::test1_object1.record_raw(extra);
              Ok(())
          }
          5572 => {
              super::telemetry_test::test2_object1.record_raw(extra);
              Ok(())
          }
          5573 => {
              super::telemetry_test::test2_object2.record_raw(extra);
              Ok(())
          }
          5581 => {
              super::translations::engine_performance.record_raw(extra);
              Ok(())
          }
          5582 => {
              super::translations::error.record_raw(extra);
              Ok(())
          }
          5584 => {
              super::translations::restore_page.record_raw(extra);
              Ok(())
          }
          5585 => {
              super::translations::translation_request.record_raw(extra);
              Ok(())
          }
          5586 => {
              super::translations_about_translations_page::open.record_raw(extra);
              Ok(())
          }
          5587 => {
              super::translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          5588 => {
              super::translations_panel::always_offer_translations.record_raw(extra);
              Ok(())
          }
          5589 => {
              super::translations_panel::always_translate_language.record_raw(extra);
              Ok(())
          }
          5590 => {
              super::translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          5591 => {
              super::translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          5592 => {
              super::translations_panel::change_source_language_button.record_raw(extra);
              Ok(())
          }
          5593 => {
              super::translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          5594 => {
              super::translations_panel::close.record_raw(extra);
              Ok(())
          }
          5595 => {
              super::translations_panel::close_from_language_menu.record_raw(extra);
              Ok(())
          }
          5596 => {
              super::translations_panel::close_settings_menu.record_raw(extra);
              Ok(())
          }
          5597 => {
              super::translations_panel::close_to_language_menu.record_raw(extra);
              Ok(())
          }
          5598 => {
              super::translations_panel::dismiss_error_button.record_raw(extra);
              Ok(())
          }
          5599 => {
              super::translations_panel::learn_more.record_raw(extra);
              Ok(())
          }
          5600 => {
              super::translations_panel::manage_languages.record_raw(extra);
              Ok(())
          }
          5601 => {
              super::translations_panel::never_translate_language.record_raw(extra);
              Ok(())
          }
          5602 => {
              super::translations_panel::never_translate_site.record_raw(extra);
              Ok(())
          }
          5603 => {
              super::translations_panel::open.record_raw(extra);
              Ok(())
          }
          5604 => {
              super::translations_panel::open_from_language_menu.record_raw(extra);
              Ok(())
          }
          5605 => {
              super::translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          5606 => {
              super::translations_panel::open_to_language_menu.record_raw(extra);
              Ok(())
          }
          5607 => {
              super::translations_panel::restore_page_button.record_raw(extra);
              Ok(())
          }
          5608 => {
              super::translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          5609 => {
              super::translations_select_translations_panel::about_translations.record_raw(extra);
              Ok(())
          }
          5610 => {
              super::translations_select_translations_panel::cancel_button.record_raw(extra);
              Ok(())
          }
          5611 => {
              super::translations_select_translations_panel::change_from_language.record_raw(extra);
              Ok(())
          }
          5612 => {
              super::translations_select_translations_panel::change_to_language.record_raw(extra);
              Ok(())
          }
          5613 => {
              super::translations_select_translations_panel::close.record_raw(extra);
              Ok(())
          }
          5614 => {
              super::translations_select_translations_panel::copy_button.record_raw(extra);
              Ok(())
          }
          5615 => {
              super::translations_select_translations_panel::done_button.record_raw(extra);
              Ok(())
          }
          5616 => {
              super::translations_select_translations_panel::initialization_failure_message.record_raw(extra);
              Ok(())
          }
          5617 => {
              super::translations_select_translations_panel::open.record_raw(extra);
              Ok(())
          }
          5618 => {
              super::translations_select_translations_panel::open_settings_menu.record_raw(extra);
              Ok(())
          }
          5619 => {
              super::translations_select_translations_panel::translate_button.record_raw(extra);
              Ok(())
          }
          5620 => {
              super::translations_select_translations_panel::translate_full_page_button.record_raw(extra);
              Ok(())
          }
          5621 => {
              super::translations_select_translations_panel::translation_failure_message.record_raw(extra);
              Ok(())
          }
          5622 => {
              super::translations_select_translations_panel::translation_settings.record_raw(extra);
              Ok(())
          }
          5623 => {
              super::translations_select_translations_panel::try_again_button.record_raw(extra);
              Ok(())
          }
          5624 => {
              super::translations_select_translations_panel::unsupported_language_message.record_raw(extra);
              Ok(())
          }
          5652 => {
              super::security_doh_neterror::click_add_exception_button.record_raw(extra);
              Ok(())
          }
          5653 => {
              super::security_doh_neterror::click_continue_button.record_raw(extra);
              Ok(())
          }
          5654 => {
              super::security_doh_neterror::click_disable_warning.record_raw(extra);
              Ok(())
          }
          5655 => {
              super::security_doh_neterror::click_learn_more_link.record_raw(extra);
              Ok(())
          }
          5656 => {
              super::security_doh_neterror::click_settings_button.record_raw(extra);
              Ok(())
          }
          5657 => {
              super::security_doh_neterror::click_try_again_button.record_raw(extra);
              Ok(())
          }
          5658 => {
              super::security_doh_neterror::load_dohwarning.record_raw(extra);
              Ok(())
          }
          5659 => {
              super::security_ui_certerror::click_advanced_button.record_raw(extra);
              Ok(())
          }
          5660 => {
              super::security_ui_certerror::click_auto_report_cb.record_raw(extra);
              Ok(())
          }
          5661 => {
              super::security_ui_certerror::click_clipboard_button_bot.record_raw(extra);
              Ok(())
          }
          5662 => {
              super::security_ui_certerror::click_clipboard_button_top.record_raw(extra);
              Ok(())
          }
          5663 => {
              super::security_ui_certerror::click_error_code_link.record_raw(extra);
              Ok(())
          }
          5664 => {
              super::security_ui_certerror::click_exception_button.record_raw(extra);
              Ok(())
          }
          5665 => {
              super::security_ui_certerror::click_learn_more_link.record_raw(extra);
              Ok(())
          }
          5666 => {
              super::security_ui_certerror::click_return_button_adv.record_raw(extra);
              Ok(())
          }
          5667 => {
              super::security_ui_certerror::click_return_button_top.record_raw(extra);
              Ok(())
          }
          5668 => {
              super::security_ui_certerror::load_aboutcerterror.record_raw(extra);
              Ok(())
          }
          5669 => {
              super::security_ui_tlserror::load_abouttlserror.record_raw(extra);
              Ok(())
          }
          5680 => {
              super::jsonfile::load_autofillprofiles.record_raw(extra);
              Ok(())
          }
          5681 => {
              super::jsonfile::load_logins.record_raw(extra);
              Ok(())
          }
          5687 => {
              super::service_request::bypass_proxy_info.record_raw(extra);
              Ok(())
          }
          5700 => {
              super::addons_manager::install.record_raw(extra);
              Ok(())
          }
          5701 => {
              super::addons_manager::install_stats.record_raw(extra);
              Ok(())
          }
          5702 => {
              super::addons_manager::manage.record_raw(extra);
              Ok(())
          }
          5703 => {
              super::addons_manager::report_suspicious_site.record_raw(extra);
              Ok(())
          }
          5704 => {
              super::addons_manager::update.record_raw(extra);
              Ok(())
          }
          5705 => {
              super::addons_manager::xpistates_write_errors.record_raw(extra);
              Ok(())
          }
          5706 => {
              super::addons_manager::disable_dictionary.record_raw(extra);
              Ok(())
          }
          5707 => {
              super::addons_manager::disable_extension.record_raw(extra);
              Ok(())
          }
          5708 => {
              super::addons_manager::disable_locale.record_raw(extra);
              Ok(())
          }
          5709 => {
              super::addons_manager::disable_other.record_raw(extra);
              Ok(())
          }
          5710 => {
              super::addons_manager::disable_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5711 => {
              super::addons_manager::disable_sitepermission.record_raw(extra);
              Ok(())
          }
          5712 => {
              super::addons_manager::disable_theme.record_raw(extra);
              Ok(())
          }
          5713 => {
              super::addons_manager::disable_unknown.record_raw(extra);
              Ok(())
          }
          5714 => {
              super::addons_manager::enable_dictionary.record_raw(extra);
              Ok(())
          }
          5715 => {
              super::addons_manager::enable_extension.record_raw(extra);
              Ok(())
          }
          5716 => {
              super::addons_manager::enable_locale.record_raw(extra);
              Ok(())
          }
          5717 => {
              super::addons_manager::enable_other.record_raw(extra);
              Ok(())
          }
          5718 => {
              super::addons_manager::enable_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5719 => {
              super::addons_manager::enable_sitepermission.record_raw(extra);
              Ok(())
          }
          5720 => {
              super::addons_manager::enable_theme.record_raw(extra);
              Ok(())
          }
          5721 => {
              super::addons_manager::enable_unknown.record_raw(extra);
              Ok(())
          }
          5722 => {
              super::addons_manager::install_dictionary.record_raw(extra);
              Ok(())
          }
          5723 => {
              super::addons_manager::install_extension.record_raw(extra);
              Ok(())
          }
          5724 => {
              super::addons_manager::install_locale.record_raw(extra);
              Ok(())
          }
          5725 => {
              super::addons_manager::install_other.record_raw(extra);
              Ok(())
          }
          5726 => {
              super::addons_manager::install_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5727 => {
              super::addons_manager::install_sitepermission.record_raw(extra);
              Ok(())
          }
          5728 => {
              super::addons_manager::install_stats_dictionary.record_raw(extra);
              Ok(())
          }
          5729 => {
              super::addons_manager::install_stats_extension.record_raw(extra);
              Ok(())
          }
          5730 => {
              super::addons_manager::install_stats_locale.record_raw(extra);
              Ok(())
          }
          5731 => {
              super::addons_manager::install_stats_other.record_raw(extra);
              Ok(())
          }
          5732 => {
              super::addons_manager::install_stats_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5733 => {
              super::addons_manager::install_stats_sitepermission.record_raw(extra);
              Ok(())
          }
          5734 => {
              super::addons_manager::install_stats_theme.record_raw(extra);
              Ok(())
          }
          5735 => {
              super::addons_manager::install_stats_unknown.record_raw(extra);
              Ok(())
          }
          5736 => {
              super::addons_manager::install_theme.record_raw(extra);
              Ok(())
          }
          5737 => {
              super::addons_manager::install_unknown.record_raw(extra);
              Ok(())
          }
          5738 => {
              super::addons_manager::sideload_prompt_dictionary.record_raw(extra);
              Ok(())
          }
          5739 => {
              super::addons_manager::sideload_prompt_extension.record_raw(extra);
              Ok(())
          }
          5740 => {
              super::addons_manager::sideload_prompt_locale.record_raw(extra);
              Ok(())
          }
          5741 => {
              super::addons_manager::sideload_prompt_other.record_raw(extra);
              Ok(())
          }
          5742 => {
              super::addons_manager::sideload_prompt_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5743 => {
              super::addons_manager::sideload_prompt_sitepermission.record_raw(extra);
              Ok(())
          }
          5744 => {
              super::addons_manager::sideload_prompt_theme.record_raw(extra);
              Ok(())
          }
          5745 => {
              super::addons_manager::sideload_prompt_unknown.record_raw(extra);
              Ok(())
          }
          5746 => {
              super::addons_manager::uninstall_dictionary.record_raw(extra);
              Ok(())
          }
          5747 => {
              super::addons_manager::uninstall_extension.record_raw(extra);
              Ok(())
          }
          5748 => {
              super::addons_manager::uninstall_locale.record_raw(extra);
              Ok(())
          }
          5749 => {
              super::addons_manager::uninstall_other.record_raw(extra);
              Ok(())
          }
          5750 => {
              super::addons_manager::uninstall_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5751 => {
              super::addons_manager::uninstall_sitepermission.record_raw(extra);
              Ok(())
          }
          5752 => {
              super::addons_manager::uninstall_theme.record_raw(extra);
              Ok(())
          }
          5753 => {
              super::addons_manager::uninstall_unknown.record_raw(extra);
              Ok(())
          }
          5754 => {
              super::addons_manager::update_dictionary.record_raw(extra);
              Ok(())
          }
          5755 => {
              super::addons_manager::update_extension.record_raw(extra);
              Ok(())
          }
          5756 => {
              super::addons_manager::update_locale.record_raw(extra);
              Ok(())
          }
          5757 => {
              super::addons_manager::update_other.record_raw(extra);
              Ok(())
          }
          5758 => {
              super::addons_manager::update_siteperm_deprecated.record_raw(extra);
              Ok(())
          }
          5759 => {
              super::addons_manager::update_sitepermission.record_raw(extra);
              Ok(())
          }
          5760 => {
              super::addons_manager::update_theme.record_raw(extra);
              Ok(())
          }
          5761 => {
              super::addons_manager::update_unknown.record_raw(extra);
              Ok(())
          }
          5762 => {
              super::blocklist::addon_block_change.record_raw(extra);
              Ok(())
          }
          5896 => {
              super::memory_watcher::on_high_memory_stats.record_raw(extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to record an event based on its metric ID, with a provided timestamp.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `timestamp` - The time at which this event was recorded.
    /// * `extra`     - An map of (extra key id, string) pairs.
    ///                 The map will be decoded into the appropriate `ExtraKeys` type.
    /// # Returns
    ///
    /// Returns `Ok(())` if the event was found and `record` was called with the given `extra`,
    /// or an `EventRecordingError::InvalidId` if no event by that ID exists
    /// or an `EventRecordingError::InvalidExtraKey` if the event doesn't take extra pairs,
    /// but some are passed in.
    pub(crate) fn record_event_by_id_with_time(metric_id: BaseMetricId, timestamp: u64, extra: HashMap<String, String>) -> Result<(), EventRecordingError> {
        match metric_id {
          BaseMetricId(16) => {
              if extra_keys_len(&super::browser_engagement::tab_explicit_unload) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_engagement::tab_explicit_unload.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(199) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookieb_toggle_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookieb_toggle_off.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(200) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookieb_toggle_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookieb_toggle_on.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(201) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cookies) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cookies.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(202) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_cryptominers) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_cryptominers.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(203) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_etp_toggle_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_etp_toggle_off.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(204) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_etp_toggle_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_etp_toggle_on.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(205) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_fingerprinters) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_fingerprinters.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(206) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_full_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_full_report.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(207) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_milestone_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_milestone_message.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(208) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_protectionspopup_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_protectionspopup_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(209) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(210) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_smartblockembeds_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_smartblockembeds_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(211) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_social) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_social.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(212) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_subview_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_subview_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(213) => {
              if extra_keys_len(&super::security_ui_protectionspopup::click_trackers) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::click_trackers.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(214) => {
              if extra_keys_len(&super::security_ui_protectionspopup::close_protections_popup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::close_protections_popup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(215) => {
              if extra_keys_len(&super::security_ui_protectionspopup::open_protections_popup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::open_protections_popup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(216) => {
              if extra_keys_len(&super::security_ui_protectionspopup::open_protectionspopup_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protectionspopup::open_protectionspopup_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(256) => {
              if extra_keys_len(&super::browser_backup::change_location) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::change_location.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(259) => {
              if extra_keys_len(&super::browser_backup::created) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::created.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(262) => {
              if extra_keys_len(&super::browser_backup::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(272) => {
              if extra_keys_len(&super::browser_backup::password_added) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::password_added.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(273) => {
              if extra_keys_len(&super::browser_backup::password_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::password_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(274) => {
              if extra_keys_len(&super::browser_backup::password_removed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::password_removed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(285) => {
              if extra_keys_len(&super::browser_backup::toggle_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::toggle_off.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(286) => {
              if extra_keys_len(&super::browser_backup::toggle_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_backup::toggle_on.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(290) => {
              if extra_keys_len(&super::downloads::added_file_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::downloads::added_file_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(306) => {
              if extra_keys_len(&super::firefoxview_next::browser_context_menu_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::browser_context_menu_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(307) => {
              if extra_keys_len(&super::firefoxview_next::card_collapsed_card_container) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::card_collapsed_card_container.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(308) => {
              if extra_keys_len(&super::firefoxview_next::card_expanded_card_container) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::card_expanded_card_container.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(309) => {
              if extra_keys_len(&super::firefoxview_next::change_page_navigation) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::change_page_navigation.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(310) => {
              if extra_keys_len(&super::firefoxview_next::close_open_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::close_open_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(311) => {
              if extra_keys_len(&super::firefoxview_next::context_menu_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::context_menu_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(312) => {
              if extra_keys_len(&super::firefoxview_next::dismiss_closed_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::dismiss_closed_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(313) => {
              if extra_keys_len(&super::firefoxview_next::entered_firefoxview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::entered_firefoxview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(314) => {
              if extra_keys_len(&super::firefoxview_next::fxa_continue_sync) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::fxa_continue_sync.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(315) => {
              if extra_keys_len(&super::firefoxview_next::fxa_mobile_sync) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::fxa_mobile_sync.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(316) => {
              if extra_keys_len(&super::firefoxview_next::history_visits) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::history_visits.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(317) => {
              if extra_keys_len(&super::firefoxview_next::open_tab_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::open_tab_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(318) => {
              if extra_keys_len(&super::firefoxview_next::recently_closed_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::recently_closed_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(319) => {
              if extra_keys_len(&super::firefoxview_next::search_initiated_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::search_initiated_search.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(320) => {
              if extra_keys_len(&super::firefoxview_next::search_show_all_showallbutton) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::search_show_all_showallbutton.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(321) => {
              if extra_keys_len(&super::firefoxview_next::show_all_history_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::show_all_history_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(322) => {
              if extra_keys_len(&super::firefoxview_next::sort_history_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::sort_history_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(323) => {
              if extra_keys_len(&super::firefoxview_next::synced_tabs_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::synced_tabs_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(324) => {
              if extra_keys_len(&super::firefoxview_next::tab_selected_toolbarbutton) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefoxview_next::tab_selected_toolbarbutton.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(325) => {
              if extra_keys_len(&super::genai_chatbot::contextmenu_prompt_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::contextmenu_prompt_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(326) => {
              if extra_keys_len(&super::genai_chatbot::contextmenu_remove) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::contextmenu_remove.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(328) => {
              if extra_keys_len(&super::genai_chatbot::experiment_checkbox_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::experiment_checkbox_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(329) => {
              if extra_keys_len(&super::genai_chatbot::keyboard_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::keyboard_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(330) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(331) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_continue) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_continue.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(332) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_finish) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_finish.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(333) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(334) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_choice_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_choice_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(335) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_learn) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_learn.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(336) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_selection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_selection.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(337) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_provider_terms) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_provider_terms.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(338) => {
              if extra_keys_len(&super::genai_chatbot::onboarding_text_highlight_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::onboarding_text_highlight_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(340) => {
              if extra_keys_len(&super::genai_chatbot::provider_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::provider_change.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(342) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_checkbox_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_checkbox_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(344) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(345) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_expanded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_expanded.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(346) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_hide_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_hide_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(347) => {
              if extra_keys_len(&super::genai_chatbot::shortcuts_prompt_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::shortcuts_prompt_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(349) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_close_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_close_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(350) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_more_menu_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_more_menu_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(351) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_more_menu_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_more_menu_display.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(352) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_provider_menu_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_provider_menu_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(353) => {
              if extra_keys_len(&super::genai_chatbot::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_chatbot::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(354) => {
              if extra_keys_len(&super::genai_linkpreview::card_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::card_close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(355) => {
              if extra_keys_len(&super::genai_linkpreview::card_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::card_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(357) => {
              if extra_keys_len(&super::genai_linkpreview::fetch) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::fetch.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(358) => {
              if extra_keys_len(&super::genai_linkpreview::generate) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::generate.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(359) => {
              if extra_keys_len(&super::genai_linkpreview::labs_checkbox) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::labs_checkbox.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(360) => {
              if extra_keys_len(&super::genai_linkpreview::start) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::genai_linkpreview::start.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(387) => {
              if extra_keys_len(&super::browser_launched_to_handle::system_notification) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_launched_to_handle::system_notification.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(401) => {
              if extra_keys_len(&super::launch_on_login::last_profile_disable_startup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::launch_on_login::last_profile_disable_startup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(415) => {
              if extra_keys_len(&super::security::fission_principals) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::fission_principals.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(416) => {
              if extra_keys_len(&super::security::csp_violation_internal_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::csp_violation_internal_page.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(417) => {
              if extra_keys_len(&super::security::eval_usage_parent_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::eval_usage_parent_process.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(418) => {
              if extra_keys_len(&super::security::eval_usage_system_context) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::eval_usage_system_context.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(420) => {
              if extra_keys_len(&super::security::javascript_load_parent_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::javascript_load_parent_process.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(422) => {
              if extra_keys_len(&super::security::unexpected_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::unexpected_load.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(423) => {
              if extra_keys_len(&super::security::pref_usage_content_process) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security::pref_usage_content_process.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(429) => {
              if extra_keys_len(&super::start_menu::manually_unpinned_since_last_launch) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::start_menu::manually_unpinned_since_last_launch.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(435) => {
              if extra_keys_len(&super::upgrade_dialog::trigger_reason) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::upgrade_dialog::trigger_reason.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(437) => {
              if extra_keys_len(&super::browser_migration::browser_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::browser_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(439) => {
              if extra_keys_len(&super::browser_migration::chrome_password_file_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::chrome_password_file_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(444) => {
              if extra_keys_len(&super::browser_migration::linux_perms_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::linux_perms_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(447) => {
              if extra_keys_len(&super::browser_migration::migration_finished_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::migration_finished_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(448) => {
              if extra_keys_len(&super::browser_migration::migration_started_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::migration_started_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(449) => {
              if extra_keys_len(&super::browser_migration::no_browsers_found_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::no_browsers_found_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(450) => {
              if extra_keys_len(&super::browser_migration::opened_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::opened_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(451) => {
              if extra_keys_len(&super::browser_migration::profile_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::profile_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(452) => {
              if extra_keys_len(&super::browser_migration::resources_selected_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::resources_selected_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(453) => {
              if extra_keys_len(&super::browser_migration::safari_password_file_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::safari_password_file_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(454) => {
              if extra_keys_len(&super::browser_migration::safari_perms_wizard) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_migration::safari_perms_wizard.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(461) => {
              if extra_keys_len(&super::activity_stream::end_session) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::end_session.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(462) => {
              if extra_keys_len(&super::activity_stream::event_archive_from_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_archive_from_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(463) => {
              if extra_keys_len(&super::activity_stream::event_block) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_block.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(464) => {
              if extra_keys_len(&super::activity_stream::event_bookmark_add) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_bookmark_add.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(465) => {
              if extra_keys_len(&super::activity_stream::event_bookmark_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_bookmark_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(466) => {
              if extra_keys_len(&super::activity_stream::event_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(467) => {
              if extra_keys_len(&super::activity_stream::event_click_privacy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_click_privacy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(468) => {
              if extra_keys_len(&super::activity_stream::event_close_newtab_prefs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_close_newtab_prefs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(469) => {
              if extra_keys_len(&super::activity_stream::event_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(470) => {
              if extra_keys_len(&super::activity_stream::event_delete_confirm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete_confirm.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(471) => {
              if extra_keys_len(&super::activity_stream::event_delete_from_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_delete_from_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(472) => {
              if extra_keys_len(&super::activity_stream::event_dialog_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_dialog_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(473) => {
              if extra_keys_len(&super::activity_stream::event_dialog_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_dialog_open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(474) => {
              if extra_keys_len(&super::activity_stream::event_disclaimer_acked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_disclaimer_acked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(475) => {
              if extra_keys_len(&super::activity_stream::event_drag) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_drag.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(476) => {
              if extra_keys_len(&super::activity_stream::event_drop) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_drop.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(477) => {
              if extra_keys_len(&super::activity_stream::event_fakespot_category) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_fakespot_category.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(478) => {
              if extra_keys_len(&super::activity_stream::event_fakespot_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_fakespot_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(479) => {
              if extra_keys_len(&super::activity_stream::event_hide_personalize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_hide_personalize.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(480) => {
              if extra_keys_len(&super::activity_stream::event_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(481) => {
              if extra_keys_len(&super::activity_stream::event_menu_add_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_add_search.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(482) => {
              if extra_keys_len(&super::activity_stream::event_menu_add_topsite) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_add_topsite.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(483) => {
              if extra_keys_len(&super::activity_stream::event_menu_collapse) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_collapse.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(484) => {
              if extra_keys_len(&super::activity_stream::event_menu_expand) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_expand.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(485) => {
              if extra_keys_len(&super::activity_stream::event_menu_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(486) => {
              if extra_keys_len(&super::activity_stream::event_menu_move_down) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_move_down.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(487) => {
              if extra_keys_len(&super::activity_stream::event_menu_move_up) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_move_up.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(488) => {
              if extra_keys_len(&super::activity_stream::event_menu_privacy_notice) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_privacy_notice.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(489) => {
              if extra_keys_len(&super::activity_stream::event_menu_remove) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_menu_remove.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(490) => {
              if extra_keys_len(&super::activity_stream::event_migration_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_migration_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(491) => {
              if extra_keys_len(&super::activity_stream::event_migration_start) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_migration_start.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(492) => {
              if extra_keys_len(&super::activity_stream::event_open_new_window) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_new_window.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(493) => {
              if extra_keys_len(&super::activity_stream::event_open_newtab_prefs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_newtab_prefs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(494) => {
              if extra_keys_len(&super::activity_stream::event_open_private_window) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_open_private_window.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(495) => {
              if extra_keys_len(&super::activity_stream::event_pin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pin.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(496) => {
              if extra_keys_len(&super::activity_stream::event_pocket_thumbs_down) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pocket_thumbs_down.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(497) => {
              if extra_keys_len(&super::activity_stream::event_pocket_thumbs_up) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pocket_thumbs_up.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(498) => {
              if extra_keys_len(&super::activity_stream::event_pref_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_pref_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(499) => {
              if extra_keys_len(&super::activity_stream::event_preview_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_preview_request.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(500) => {
              if extra_keys_len(&super::activity_stream::event_save_to_pocket) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_save_to_pocket.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(501) => {
              if extra_keys_len(&super::activity_stream::event_search) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(502) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_add) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_add.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(503) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(504) => {
              if extra_keys_len(&super::activity_stream::event_search_edit_delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_edit_delete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(505) => {
              if extra_keys_len(&super::activity_stream::event_search_handoff) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_search_handoff.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(506) => {
              if extra_keys_len(&super::activity_stream::event_show_personalize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_show_personalize.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(507) => {
              if extra_keys_len(&super::activity_stream::event_show_privacy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_show_privacy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(508) => {
              if extra_keys_len(&super::activity_stream::event_skipped_signin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_skipped_signin.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(509) => {
              if extra_keys_len(&super::activity_stream::event_submit_email) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_submit_email.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(510) => {
              if extra_keys_len(&super::activity_stream::event_top_sites_edit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_top_sites_edit.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(511) => {
              if extra_keys_len(&super::activity_stream::event_top_sites_edit_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_top_sites_edit_close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(512) => {
              if extra_keys_len(&super::activity_stream::event_topsite_sponsor_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_topsite_sponsor_info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(513) => {
              if extra_keys_len(&super::activity_stream::event_unpin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::activity_stream::event_unpin.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(521) => {
              if extra_keys_len(&super::newtab::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(522) => {
              if extra_keys_len(&super::newtab::fakespot_about_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_about_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(523) => {
              if extra_keys_len(&super::newtab::fakespot_category) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_category.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(524) => {
              if extra_keys_len(&super::newtab::fakespot_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(525) => {
              if extra_keys_len(&super::newtab::fakespot_cta_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_cta_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(526) => {
              if extra_keys_len(&super::newtab::fakespot_dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(527) => {
              if extra_keys_len(&super::newtab::fakespot_product_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::fakespot_product_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(529) => {
              if extra_keys_len(&super::newtab::inline_selection_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::inline_selection_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(530) => {
              if extra_keys_len(&super::newtab::inline_selection_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::inline_selection_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(534) => {
              if extra_keys_len(&super::newtab::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(536) => {
              if extra_keys_len(&super::newtab::report_content_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::report_content_open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(537) => {
              if extra_keys_len(&super::newtab::report_content_submit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::report_content_submit.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(538) => {
              if extra_keys_len(&super::newtab::sections_block_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::sections_block_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(539) => {
              if extra_keys_len(&super::newtab::sections_follow_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::sections_follow_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(540) => {
              if extra_keys_len(&super::newtab::sections_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::sections_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(541) => {
              if extra_keys_len(&super::newtab::sections_unblock_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::sections_unblock_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(542) => {
              if extra_keys_len(&super::newtab::sections_unfollow_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::sections_unfollow_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(545) => {
              if extra_keys_len(&super::newtab::tooltip_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::tooltip_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(546) => {
              if extra_keys_len(&super::newtab::topic_selection_dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(547) => {
              if extra_keys_len(&super::newtab::topic_selection_open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(548) => {
              if extra_keys_len(&super::newtab::topic_selection_topics_saved) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::topic_selection_topics_saved.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(549) => {
              if extra_keys_len(&super::newtab::wallpaper_category_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_category_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(550) => {
              if extra_keys_len(&super::newtab::wallpaper_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(551) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_cta_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_cta_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(552) => {
              if extra_keys_len(&super::newtab::wallpaper_highlight_dismissed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::wallpaper_highlight_dismissed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(553) => {
              if extra_keys_len(&super::newtab::weather_change_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_change_display.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(555) => {
              if extra_keys_len(&super::newtab::weather_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(556) => {
              if extra_keys_len(&super::newtab::weather_load_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_load_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(557) => {
              if extra_keys_len(&super::newtab::weather_location_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_location_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(558) => {
              if extra_keys_len(&super::newtab::weather_open_provider_url) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab::weather_open_provider_url.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(561) => {
              if extra_keys_len(&super::newtab_search::issued) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search::issued.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(564) => {
              if extra_keys_len(&super::newtab_content::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(567) => {
              if extra_keys_len(&super::newtab_content::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(570) => {
              if extra_keys_len(&super::newtab_content::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(571) => {
              if extra_keys_len(&super::newtab_content::sections_block_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::sections_block_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(572) => {
              if extra_keys_len(&super::newtab_content::sections_follow_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::sections_follow_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(573) => {
              if extra_keys_len(&super::newtab_content::sections_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::sections_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(574) => {
              if extra_keys_len(&super::newtab_content::sections_unblock_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::sections_unblock_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(575) => {
              if extra_keys_len(&super::newtab_content::sections_unfollow_section) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::sections_unfollow_section.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(577) => {
              if extra_keys_len(&super::newtab_content::thumb_voting_interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_content::thumb_voting_interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(579) => {
              if extra_keys_len(&super::pocket::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(580) => {
              if extra_keys_len(&super::pocket::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(583) => {
              if extra_keys_len(&super::pocket::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(586) => {
              if extra_keys_len(&super::pocket::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::save.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(589) => {
              if extra_keys_len(&super::pocket::thumb_voting_interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::thumb_voting_interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(590) => {
              if extra_keys_len(&super::pocket::topic_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pocket::topic_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(598) => {
              if extra_keys_len(&super::topsites::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(599) => {
              if extra_keys_len(&super::topsites::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(601) => {
              if extra_keys_len(&super::topsites::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(602) => {
              if extra_keys_len(&super::topsites::pref_changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::pref_changed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(604) => {
              if extra_keys_len(&super::topsites::show_privacy_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::topsites::show_privacy_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(627) => {
              if extra_keys_len(&super::aboutpreferences::show_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(628) => {
              if extra_keys_len(&super::aboutpreferences::show_hash) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_hash.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(629) => {
              if extra_keys_len(&super::aboutpreferences::show_initial) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutpreferences::show_initial.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(630) => {
              if extra_keys_len(&super::intl_ui_browser_language::accept_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::accept_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(631) => {
              if extra_keys_len(&super::intl_ui_browser_language::add_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::add_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(632) => {
              if extra_keys_len(&super::intl_ui_browser_language::apply_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::apply_main.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(633) => {
              if extra_keys_len(&super::intl_ui_browser_language::cancel_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::cancel_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(634) => {
              if extra_keys_len(&super::intl_ui_browser_language::manage_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::manage_main.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(635) => {
              if extra_keys_len(&super::intl_ui_browser_language::remove_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::remove_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(636) => {
              if extra_keys_len(&super::intl_ui_browser_language::reorder_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::reorder_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(637) => {
              if extra_keys_len(&super::intl_ui_browser_language::reorder_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::reorder_main.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(638) => {
              if extra_keys_len(&super::intl_ui_browser_language::search_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::search_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(639) => {
              if extra_keys_len(&super::intl_ui_browser_language::search_main) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::search_main.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(640) => {
              if extra_keys_len(&super::intl_ui_browser_language::set_fallback_dialog) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::intl_ui_browser_language::set_fallback_dialog.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(641) => {
              if extra_keys_len(&super::network_proxy_settings::proxy_type_preference) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::network_proxy_settings::proxy_type_preference.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(642) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::checkbox) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::checkbox.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(643) => {
              if extra_keys_len(&super::privacy_ui_fpp_click::menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::privacy_ui_fpp_click::menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(644) => {
              if extra_keys_len(&super::security_doh_settings::mode_changed_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_settings::mode_changed_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(645) => {
              if extra_keys_len(&super::security_doh_settings::provider_choice_value) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_settings::provider_choice_value.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(646) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_dismiss_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_dismiss_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(647) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_info_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_info_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(648) => {
              if extra_keys_len(&super::aboutprivatebrowsing::click_promo_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::aboutprivatebrowsing::click_promo_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(649) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::confirm_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::confirm_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(650) => {
              if extra_keys_len(&super::private_browsing_reset_pbm::reset_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::private_browsing_reset_pbm::reset_action.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(651) => {
              if extra_keys_len(&super::profiles_default::updated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_default::updated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(652) => {
              if extra_keys_len(&super::profiles_delete::cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_delete::cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(653) => {
              if extra_keys_len(&super::profiles_delete::confirm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_delete::confirm.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(654) => {
              if extra_keys_len(&super::profiles_delete::displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_delete::displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(655) => {
              if extra_keys_len(&super::profiles_existing::alert) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::alert.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(656) => {
              if extra_keys_len(&super::profiles_existing::avatar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::avatar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(657) => {
              if extra_keys_len(&super::profiles_existing::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(658) => {
              if extra_keys_len(&super::profiles_existing::deleted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::deleted.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(659) => {
              if extra_keys_len(&super::profiles_existing::displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(660) => {
              if extra_keys_len(&super::profiles_existing::learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(661) => {
              if extra_keys_len(&super::profiles_existing::name) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::name.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(662) => {
              if extra_keys_len(&super::profiles_existing::theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_existing::theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(663) => {
              if extra_keys_len(&super::profiles_new::alert) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::alert.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(664) => {
              if extra_keys_len(&super::profiles_new::avatar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::avatar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(665) => {
              if extra_keys_len(&super::profiles_new::closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::closed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(666) => {
              if extra_keys_len(&super::profiles_new::deleted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::deleted.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(667) => {
              if extra_keys_len(&super::profiles_new::displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(668) => {
              if extra_keys_len(&super::profiles_new::learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(669) => {
              if extra_keys_len(&super::profiles_new::name) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::name.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(670) => {
              if extra_keys_len(&super::profiles_new::theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_new::theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(671) => {
              if extra_keys_len(&super::profiles_selector_window::launch) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_selector_window::launch.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(672) => {
              if extra_keys_len(&super::profiles_selector_window::show_at_startup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::profiles_selector_window::show_at_startup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(673) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(674) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_open_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_open_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(675) => {
              if extra_keys_len(&super::security_ui_protections::click_lw_sync_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_lw_sync_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(676) => {
              if extra_keys_len(&super::security_ui_protections::click_mobile_app_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mobile_app_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(677) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(678) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_report_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_report_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(679) => {
              if extra_keys_len(&super::security_ui_protections::click_mtr_signup_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_mtr_signup_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(680) => {
              if extra_keys_len(&super::security_ui_protections::click_settings_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_settings_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(681) => {
              if extra_keys_len(&super::security_ui_protections::click_trackers_about_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_trackers_about_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(682) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_app_link_android) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_app_link_android.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(683) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_app_link_ios) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_app_link_ios.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(684) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_banner_close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_banner_close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(685) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_banner_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_banner_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(686) => {
              if extra_keys_len(&super::security_ui_protections::click_vpn_card_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::click_vpn_card_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(687) => {
              if extra_keys_len(&super::security_ui_protections::close_protection_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::close_protection_report.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(688) => {
              if extra_keys_len(&super::security_ui_protections::show_protection_report) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::show_protection_report.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(689) => {
              if extra_keys_len(&super::security_ui_protections::show_vpn_banner) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_protections::show_vpn_banner.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(692) => {
              if extra_keys_len(&super::protocolhandler_mailto::visit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::protocolhandler_mailto::visit.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(693) => {
              if extra_keys_len(&super::screenshots::canceled_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(694) => {
              if extra_keys_len(&super::screenshots::canceled_escape) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_escape.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(695) => {
              if extra_keys_len(&super::screenshots::canceled_navigation) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_navigation.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(696) => {
              if extra_keys_len(&super::screenshots::canceled_overlay_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_overlay_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(697) => {
              if extra_keys_len(&super::screenshots::canceled_preview_cancel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_preview_cancel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(698) => {
              if extra_keys_len(&super::screenshots::canceled_quick_actions) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_quick_actions.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(699) => {
              if extra_keys_len(&super::screenshots::canceled_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(700) => {
              if extra_keys_len(&super::screenshots::canceled_toolbar_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::canceled_toolbar_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(701) => {
              if extra_keys_len(&super::screenshots::copy_overlay_copy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::copy_overlay_copy.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(702) => {
              if extra_keys_len(&super::screenshots::copy_preview_copy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::copy_preview_copy.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(703) => {
              if extra_keys_len(&super::screenshots::download_overlay_download) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::download_overlay_download.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(704) => {
              if extra_keys_len(&super::screenshots::download_preview_download) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::download_preview_download.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(705) => {
              if extra_keys_len(&super::screenshots::failed_screenshot_too_large) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::failed_screenshot_too_large.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(706) => {
              if extra_keys_len(&super::screenshots::selected_element) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_element.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(707) => {
              if extra_keys_len(&super::screenshots::selected_full_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_full_page.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(708) => {
              if extra_keys_len(&super::screenshots::selected_region_selection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_region_selection.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(709) => {
              if extra_keys_len(&super::screenshots::selected_visible) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::selected_visible.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(710) => {
              if extra_keys_len(&super::screenshots::started_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(711) => {
              if extra_keys_len(&super::screenshots::started_overlay_retry) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_overlay_retry.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(712) => {
              if extra_keys_len(&super::screenshots::started_preview_retry) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_preview_retry.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(713) => {
              if extra_keys_len(&super::screenshots::started_quick_actions) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_quick_actions.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(714) => {
              if extra_keys_len(&super::screenshots::started_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(715) => {
              if extra_keys_len(&super::screenshots::started_toolbar_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::screenshots::started_toolbar_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(764) => {
              if extra_keys_len(&super::newtab_search_ad::click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(765) => {
              if extra_keys_len(&super::newtab_search_ad::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::newtab_search_ad::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(766) => {
              if extra_keys_len(&super::sap::counts) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sap::counts.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(768) => {
              if extra_keys_len(&super::sap::search_form_counts) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sap::search_form_counts.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(772) => {
              if extra_keys_len(&super::serp::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(773) => {
              if extra_keys_len(&super::serp::ad_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::ad_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(775) => {
              if extra_keys_len(&super::serp::categorization) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::categorization.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(778) => {
              if extra_keys_len(&super::serp::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(780) => {
              if extra_keys_len(&super::serp::impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::serp::impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(798) => {
              if extra_keys_len(&super::session_restore::backup_can_be_loaded_session_file) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::session_restore::backup_can_be_loaded_session_file.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(811) => {
              if extra_keys_len(&super::session_restore::shutdown_success_session_startup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::session_restore::shutdown_success_session_startup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(815) => {
              if extra_keys_len(&super::shopping::address_bar_feature_callout_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_feature_callout_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(816) => {
              if extra_keys_len(&super::shopping::address_bar_icon_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(817) => {
              if extra_keys_len(&super::shopping::address_bar_icon_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::address_bar_icon_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(819) => {
              if extra_keys_len(&super::shopping::surface_ads_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(820) => {
              if extra_keys_len(&super::shopping::surface_ads_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(821) => {
              if extra_keys_len(&super::shopping::surface_ads_placement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_placement.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(822) => {
              if extra_keys_len(&super::shopping::surface_ads_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_ads_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(823) => {
              if extra_keys_len(&super::shopping::surface_analyze_reviews_none_available_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_analyze_reviews_none_available_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(824) => {
              if extra_keys_len(&super::shopping::surface_auto_open_setting_toggled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_auto_open_setting_toggled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(825) => {
              if extra_keys_len(&super::shopping::surface_closed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_closed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(826) => {
              if extra_keys_len(&super::shopping::surface_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(827) => {
              if extra_keys_len(&super::shopping::surface_learn_more_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_learn_more_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(828) => {
              if extra_keys_len(&super::shopping::surface_no_ads_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_ads_available.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(829) => {
              if extra_keys_len(&super::shopping::surface_no_review_reliability_available) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_review_reliability_available.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(830) => {
              if extra_keys_len(&super::shopping::surface_no_thanks_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_no_thanks_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(831) => {
              if extra_keys_len(&super::shopping::surface_not_now_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_not_now_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(832) => {
              if extra_keys_len(&super::shopping::surface_notification_card_dismiss_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_notification_card_dismiss_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(833) => {
              if extra_keys_len(&super::shopping::surface_notification_card_impression) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_notification_card_impression.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(834) => {
              if extra_keys_len(&super::shopping::surface_notification_card_move_left_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_notification_card_move_left_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(835) => {
              if extra_keys_len(&super::shopping::surface_notification_card_move_right_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_notification_card_move_right_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(836) => {
              if extra_keys_len(&super::shopping::surface_notification_card_sidebar_settings_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_notification_card_sidebar_settings_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(837) => {
              if extra_keys_len(&super::shopping::surface_onboarding_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_onboarding_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(838) => {
              if extra_keys_len(&super::shopping::surface_opt_in_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_in_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(839) => {
              if extra_keys_len(&super::shopping::surface_opt_out_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_opt_out_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(840) => {
              if extra_keys_len(&super::shopping::surface_powered_by_fakespot_link_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_powered_by_fakespot_link_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(841) => {
              if extra_keys_len(&super::shopping::surface_reactivated_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reactivated_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(842) => {
              if extra_keys_len(&super::shopping::surface_reanalyze_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_reanalyze_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(843) => {
              if extra_keys_len(&super::shopping::surface_settings_expand_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_settings_expand_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(844) => {
              if extra_keys_len(&super::shopping::surface_show_more_reviews_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_more_reviews_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(845) => {
              if extra_keys_len(&super::shopping::surface_show_privacy_policy_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_privacy_policy_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(846) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(847) => {
              if extra_keys_len(&super::shopping::surface_show_quality_explainer_url_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_quality_explainer_url_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(848) => {
              if extra_keys_len(&super::shopping::surface_show_terms_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_show_terms_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(849) => {
              if extra_keys_len(&super::shopping::surface_stale_analysis_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_stale_analysis_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(850) => {
              if extra_keys_len(&super::shopping::surface_yes_keep_closed_button_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::surface_yes_keep_closed_button_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(851) => {
              if extra_keys_len(&super::shopping::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(857) => {
              if extra_keys_len(&super::bookmarks::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::bookmarks::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(858) => {
              if extra_keys_len(&super::contextual_manager::passwords_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::passwords_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(859) => {
              if extra_keys_len(&super::contextual_manager::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(860) => {
              if extra_keys_len(&super::contextual_manager::notification_interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::notification_interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(861) => {
              if extra_keys_len(&super::contextual_manager::notification_shown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::notification_shown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(862) => {
              if extra_keys_len(&super::contextual_manager::records_interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::records_interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(863) => {
              if extra_keys_len(&super::contextual_manager::records_update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::records_update.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(864) => {
              if extra_keys_len(&super::contextual_manager::toolbar_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::contextual_manager::toolbar_action.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(865) => {
              if extra_keys_len(&super::extension::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extension::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(866) => {
              if extra_keys_len(&super::history::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::history::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(867) => {
              if extra_keys_len(&super::sidebar::addon_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::addon_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(868) => {
              if extra_keys_len(&super::sidebar::bookmarks_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::bookmarks_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(869) => {
              if extra_keys_len(&super::sidebar::chatbot_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::chatbot_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(871) => {
              if extra_keys_len(&super::sidebar::expand) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::expand.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(872) => {
              if extra_keys_len(&super::sidebar::history_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::history_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(873) => {
              if extra_keys_len(&super::sidebar::keyboard_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::keyboard_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(876) => {
              if extra_keys_len(&super::sidebar::resize) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::resize.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(878) => {
              if extra_keys_len(&super::sidebar::shopping_review_checker_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::shopping_review_checker_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(879) => {
              if extra_keys_len(&super::sidebar::synced_tabs_icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar::synced_tabs_icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(882) => {
              if extra_keys_len(&super::sidebar_customize::bookmarks_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::bookmarks_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(883) => {
              if extra_keys_len(&super::sidebar_customize::chatbot_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::chatbot_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(884) => {
              if extra_keys_len(&super::sidebar_customize::expand_on_hover_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::expand_on_hover_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(885) => {
              if extra_keys_len(&super::sidebar_customize::extensions_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::extensions_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(886) => {
              if extra_keys_len(&super::sidebar_customize::firefox_settings_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::firefox_settings_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(887) => {
              if extra_keys_len(&super::sidebar_customize::history_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::history_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(888) => {
              if extra_keys_len(&super::sidebar_customize::icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(889) => {
              if extra_keys_len(&super::sidebar_customize::panel_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::panel_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(890) => {
              if extra_keys_len(&super::sidebar_customize::shopping_review_checker_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::shopping_review_checker_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(891) => {
              if extra_keys_len(&super::sidebar_customize::sidebar_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::sidebar_display.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(892) => {
              if extra_keys_len(&super::sidebar_customize::sidebar_position) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::sidebar_position.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(893) => {
              if extra_keys_len(&super::sidebar_customize::synced_tabs_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::synced_tabs_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(894) => {
              if extra_keys_len(&super::sidebar_customize::tabs_display) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::tabs_display.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(895) => {
              if extra_keys_len(&super::sidebar_customize::tabs_layout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sidebar_customize::tabs_layout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(896) => {
              if extra_keys_len(&super::synced_tabs::sidebar_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::sidebar_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(897) => {
              if extra_keys_len(&super::synced_tabs::click_fxa_app_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_fxa_app_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(898) => {
              if extra_keys_len(&super::synced_tabs::click_fxa_avatar_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_fxa_avatar_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(899) => {
              if extra_keys_len(&super::synced_tabs::click_synced_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::synced_tabs::click_synced_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(936) => {
              if extra_keys_len(&super::tabgroup::add_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::add_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(937) => {
              if extra_keys_len(&super::tabgroup::create_group) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::create_group.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(938) => {
              if extra_keys_len(&super::tabgroup::delete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::delete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(940) => {
              if extra_keys_len(&super::tabgroup::reopen) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::reopen.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(941) => {
              if extra_keys_len(&super::tabgroup::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::save.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(943) => {
              if extra_keys_len(&super::tabgroup::smart_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::smart_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(945) => {
              if extra_keys_len(&super::tabgroup::smart_tab_optin) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::smart_tab_optin.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(946) => {
              if extra_keys_len(&super::tabgroup::smart_tab_suggest) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::smart_tab_suggest.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(947) => {
              if extra_keys_len(&super::tabgroup::smart_tab_topic) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::smart_tab_topic.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(952) => {
              if extra_keys_len(&super::tabgroup::ungroup) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::tabgroup::ungroup.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(975) => {
              if extra_keys_len(&super::urlbar::abandonment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::abandonment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(979) => {
              if extra_keys_len(&super::urlbar::engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(980) => {
              if extra_keys_len(&super::urlbar::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(981) => {
              if extra_keys_len(&super::urlbar::fakespot_engagement) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::fakespot_engagement.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(982) => {
              if extra_keys_len(&super::urlbar::keyword_exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::keyword_exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(988) => {
              if extra_keys_len(&super::urlbar::quick_suggest_contextual_opt_in) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::urlbar::quick_suggest_contextual_opt_in.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(998) => {
              if extra_keys_len(&super::addons_search_detection::etld_change_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_search_detection::etld_change_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(999) => {
              if extra_keys_len(&super::addons_search_detection::etld_change_webrequest) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_search_detection::etld_change_webrequest.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1014) => {
              if extra_keys_len(&super::browser_usage::interaction) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::browser_usage::interaction.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1015) => {
              if extra_keys_len(&super::homepage::preference_ignore) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::homepage::preference_ignore.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1016) => {
              if extra_keys_len(&super::installation::first_seen_full) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_full.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1017) => {
              if extra_keys_len(&super::installation::first_seen_msix) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_msix.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1018) => {
              if extra_keys_len(&super::installation::first_seen_stub) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::installation::first_seen_stub.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1032) => {
              if extra_keys_len(&super::partner_link::attribution_abort) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_abort.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1033) => {
              if extra_keys_len(&super::partner_link::attribution_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1034) => {
              if extra_keys_len(&super::partner_link::attribution_success) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::attribution_success.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1035) => {
              if extra_keys_len(&super::partner_link::click_newtab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::click_newtab.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1036) => {
              if extra_keys_len(&super::partner_link::click_urlbar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::partner_link::click_urlbar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1135) => {
              if extra_keys_len(&super::devtools_main::activate_responsive_design) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::activate_responsive_design.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1136) => {
              if extra_keys_len(&super::devtools_main::activate_split_console) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::activate_split_console.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1137) => {
              if extra_keys_len(&super::devtools_main::add_breakpoint_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::add_breakpoint_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1138) => {
              if extra_keys_len(&super::devtools_main::blackbox_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::blackbox_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1139) => {
              if extra_keys_len(&super::devtools_main::close_adbg_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::close_adbg_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1140) => {
              if extra_keys_len(&super::devtools_main::close_tools) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::close_tools.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1141) => {
              if extra_keys_len(&super::devtools_main::connection_attempt_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::connection_attempt_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1142) => {
              if extra_keys_len(&super::devtools_main::continue_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::continue_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1143) => {
              if extra_keys_len(&super::devtools_main::deactivate_responsive_design) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::deactivate_responsive_design.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1144) => {
              if extra_keys_len(&super::devtools_main::deactivate_split_console) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::deactivate_split_console.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1145) => {
              if extra_keys_len(&super::devtools_main::device_added_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::device_added_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1146) => {
              if extra_keys_len(&super::devtools_main::device_removed_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::device_removed_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1147) => {
              if extra_keys_len(&super::devtools_main::edit_html_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_html_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1148) => {
              if extra_keys_len(&super::devtools_main::edit_resend_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_resend_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1149) => {
              if extra_keys_len(&super::devtools_main::edit_rule_ruleview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::edit_rule_ruleview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1150) => {
              if extra_keys_len(&super::devtools_main::enter_accessibility) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_accessibility.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1151) => {
              if extra_keys_len(&super::devtools_main::enter_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_application.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1152) => {
              if extra_keys_len(&super::devtools_main::enter_dom) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_dom.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1153) => {
              if extra_keys_len(&super::devtools_main::enter_fake_tool4242) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_fake_tool4242.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1154) => {
              if extra_keys_len(&super::devtools_main::enter_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1155) => {
              if extra_keys_len(&super::devtools_main::enter_jsdebugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_jsdebugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1156) => {
              if extra_keys_len(&super::devtools_main::enter_memory) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_memory.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1157) => {
              if extra_keys_len(&super::devtools_main::enter_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1158) => {
              if extra_keys_len(&super::devtools_main::enter_options) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_options.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1159) => {
              if extra_keys_len(&super::devtools_main::enter_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1160) => {
              if extra_keys_len(&super::devtools_main::enter_performance) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_performance.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1161) => {
              if extra_keys_len(&super::devtools_main::enter_storage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_storage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1162) => {
              if extra_keys_len(&super::devtools_main::enter_styleeditor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_styleeditor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1163) => {
              if extra_keys_len(&super::devtools_main::enter_test_blank_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_blank_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1164) => {
              if extra_keys_len(&super::devtools_main::enter_test_tool) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_tool.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1165) => {
              if extra_keys_len(&super::devtools_main::enter_test_tool1072208) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_test_tool1072208.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1166) => {
              if extra_keys_len(&super::devtools_main::enter_testtool1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_testtool1.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1167) => {
              if extra_keys_len(&super::devtools_main::enter_testtool2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_testtool2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1168) => {
              if extra_keys_len(&super::devtools_main::enter_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1169) => {
              if extra_keys_len(&super::devtools_main::enter_whatsnew) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::enter_whatsnew.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1170) => {
              if extra_keys_len(&super::devtools_main::execute_js_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::execute_js_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1171) => {
              if extra_keys_len(&super::devtools_main::exit_accessibility) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_accessibility.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1172) => {
              if extra_keys_len(&super::devtools_main::exit_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_application.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1173) => {
              if extra_keys_len(&super::devtools_main::exit_dom) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_dom.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1174) => {
              if extra_keys_len(&super::devtools_main::exit_fake_tool4242) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_fake_tool4242.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1175) => {
              if extra_keys_len(&super::devtools_main::exit_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1176) => {
              if extra_keys_len(&super::devtools_main::exit_jsdebugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_jsdebugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1177) => {
              if extra_keys_len(&super::devtools_main::exit_memory) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_memory.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1178) => {
              if extra_keys_len(&super::devtools_main::exit_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1179) => {
              if extra_keys_len(&super::devtools_main::exit_options) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_options.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1180) => {
              if extra_keys_len(&super::devtools_main::exit_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1181) => {
              if extra_keys_len(&super::devtools_main::exit_performance) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_performance.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1182) => {
              if extra_keys_len(&super::devtools_main::exit_storage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_storage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1183) => {
              if extra_keys_len(&super::devtools_main::exit_styleeditor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_styleeditor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1184) => {
              if extra_keys_len(&super::devtools_main::exit_test_blank_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_blank_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1185) => {
              if extra_keys_len(&super::devtools_main::exit_test_tool) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_tool.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1186) => {
              if extra_keys_len(&super::devtools_main::exit_test_tool1072208) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_test_tool1072208.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1187) => {
              if extra_keys_len(&super::devtools_main::exit_testtool1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_testtool1.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1188) => {
              if extra_keys_len(&super::devtools_main::exit_testtool2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_testtool2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1189) => {
              if extra_keys_len(&super::devtools_main::exit_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1190) => {
              if extra_keys_len(&super::devtools_main::exit_whatsnew) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::exit_whatsnew.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1191) => {
              if extra_keys_len(&super::devtools_main::filters_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::filters_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1192) => {
              if extra_keys_len(&super::devtools_main::filters_changed_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::filters_changed_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1193) => {
              if extra_keys_len(&super::devtools_main::inspect_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::inspect_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1194) => {
              if extra_keys_len(&super::devtools_main::jump_to_definition_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::jump_to_definition_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1195) => {
              if extra_keys_len(&super::devtools_main::jump_to_source_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::jump_to_source_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1196) => {
              if extra_keys_len(&super::devtools_main::object_expanded_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::object_expanded_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1197) => {
              if extra_keys_len(&super::devtools_main::open_adbg_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::open_adbg_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1198) => {
              if extra_keys_len(&super::devtools_main::open_tools) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::open_tools.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1199) => {
              if extra_keys_len(&super::devtools_main::pause_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pause_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1200) => {
              if extra_keys_len(&super::devtools_main::pause_on_exceptions_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pause_on_exceptions_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1201) => {
              if extra_keys_len(&super::devtools_main::persist_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::persist_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1202) => {
              if extra_keys_len(&super::devtools_main::persist_changed_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::persist_changed_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1203) => {
              if extra_keys_len(&super::devtools_main::pretty_print_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::pretty_print_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1204) => {
              if extra_keys_len(&super::devtools_main::remove_breakpoint_debugger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::remove_breakpoint_debugger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1205) => {
              if extra_keys_len(&super::devtools_main::reverse_search_webconsole) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::reverse_search_webconsole.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1206) => {
              if extra_keys_len(&super::devtools_main::runtime_added_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_added_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1207) => {
              if extra_keys_len(&super::devtools_main::runtime_connected_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_connected_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1208) => {
              if extra_keys_len(&super::devtools_main::runtime_disconnected_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_disconnected_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1209) => {
              if extra_keys_len(&super::devtools_main::runtime_removed_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::runtime_removed_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1210) => {
              if extra_keys_len(&super::devtools_main::select_page_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_page_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1211) => {
              if extra_keys_len(&super::devtools_main::select_page_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_page_application.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1212) => {
              if extra_keys_len(&super::devtools_main::select_ws_frame_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::select_ws_frame_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1213) => {
              if extra_keys_len(&super::devtools_main::show_profiler_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::show_profiler_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1214) => {
              if extra_keys_len(&super::devtools_main::sidepanel_changed_inspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::sidepanel_changed_inspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1215) => {
              if extra_keys_len(&super::devtools_main::sidepanel_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::sidepanel_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1216) => {
              if extra_keys_len(&super::devtools_main::start_worker_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::start_worker_application.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1217) => {
              if extra_keys_len(&super::devtools_main::throttle_changed_netmonitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::throttle_changed_netmonitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1218) => {
              if extra_keys_len(&super::devtools_main::tool_timer_animationinspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_animationinspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1219) => {
              if extra_keys_len(&super::devtools_main::tool_timer_changesview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_changesview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1220) => {
              if extra_keys_len(&super::devtools_main::tool_timer_compatibilityview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_compatibilityview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1221) => {
              if extra_keys_len(&super::devtools_main::tool_timer_computedview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_computedview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1222) => {
              if extra_keys_len(&super::devtools_main::tool_timer_fontinspector) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_fontinspector.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1223) => {
              if extra_keys_len(&super::devtools_main::tool_timer_layoutview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_layoutview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1224) => {
              if extra_keys_len(&super::devtools_main::tool_timer_ruleview) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::tool_timer_ruleview.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1225) => {
              if extra_keys_len(&super::devtools_main::unregister_worker_application) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::unregister_worker_application.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(1226) => {
              if extra_keys_len(&super::devtools_main::update_conn_prompt_aboutdebugging) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::devtools_main::update_conn_prompt_aboutdebugging.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3656) => {
              if extra_keys_len(&super::mediadrm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mediadrm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3659) => {
              if extra_keys_len(&super::hls::media_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::hls::media_load.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3664) => {
              if extra_keys_len(&super::media::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::media::error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3686) => {
              if extra_keys_len(&super::media_playback::decode_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::media_playback::decode_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3688) => {
              if extra_keys_len(&super::media_playback::first_frame_loaded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::media_playback::first_frame_loaded.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3693) => {
              if extra_keys_len(&super::mfcdm::eme_playback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::eme_playback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3694) => {
              if extra_keys_len(&super::mfcdm::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::mfcdm::error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3749) => {
              if extra_keys_len(&super::webrtc_signaling::audio_msection_negotiated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webrtc_signaling::audio_msection_negotiated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3750) => {
              if extra_keys_len(&super::webrtc_signaling::sdp_negotiated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webrtc_signaling::sdp_negotiated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3751) => {
              if extra_keys_len(&super::webrtc_signaling::video_msection_negotiated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webrtc_signaling::video_msection_negotiated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3802) => {
              if extra_keys_len(&super::perf::page_load) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::perf::page_load.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3835) => {
              if extra_keys_len(&super::dom_quota_try::error_step) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::dom_quota_try::error_step.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(3984) => {
              if extra_keys_len(&super::avif::dav1d_get_picture_return_value) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::avif::dav1d_get_picture_return_value.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4063) => {
              if extra_keys_len(&super::slow_script_warning::shown_browser) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::slow_script_warning::shown_browser.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4064) => {
              if extra_keys_len(&super::slow_script_warning::shown_content) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::slow_script_warning::shown_content.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4083) => {
              if extra_keys_len(&super::zero_byte_load::load_css) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_css.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4084) => {
              if extra_keys_len(&super::zero_byte_load::load_dtd) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_dtd.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4085) => {
              if extra_keys_len(&super::zero_byte_load::load_ftl) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_ftl.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4086) => {
              if extra_keys_len(&super::zero_byte_load::load_html) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_html.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4087) => {
              if extra_keys_len(&super::zero_byte_load::load_js) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_js.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4088) => {
              if extra_keys_len(&super::zero_byte_load::load_json) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_json.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4089) => {
              if extra_keys_len(&super::zero_byte_load::load_others) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_others.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4090) => {
              if extra_keys_len(&super::zero_byte_load::load_png) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_png.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4091) => {
              if extra_keys_len(&super::zero_byte_load::load_properties) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_properties.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4092) => {
              if extra_keys_len(&super::zero_byte_load::load_svg) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_svg.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4093) => {
              if extra_keys_len(&super::zero_byte_load::load_xhtml) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_xhtml.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4094) => {
              if extra_keys_len(&super::zero_byte_load::load_xml) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::zero_byte_load::load_xml.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4207) => {
              if extra_keys_len(&super::network_dns::trr_confirmation_context) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::network_dns::trr_confirmation_context.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4325) => {
              if extra_keys_len(&super::ysod::shown_ysod) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::ysod::shown_ysod.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4411) => {
              if extra_keys_len(&super::uptake_remotecontent_result::uptake_normandy) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::uptake_remotecontent_result::uptake_normandy.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4412) => {
              if extra_keys_len(&super::uptake_remotecontent_result::uptake_remotesettings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::uptake_remotecontent_result::uptake_remotesettings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4415) => {
              if extra_keys_len(&super::fxa::connect_account) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa::connect_account.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4416) => {
              if extra_keys_len(&super::fxa::disconnect_account) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa::disconnect_account.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4417) => {
              if extra_keys_len(&super::sync_settings::open_choose_what_to_sync_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sync_settings::open_choose_what_to_sync_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4418) => {
              if extra_keys_len(&super::sync_settings::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sync_settings::save.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4419) => {
              if extra_keys_len(&super::fxa_app_menu::click_account_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_account_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4420) => {
              if extra_keys_len(&super::fxa_app_menu::click_cad) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_cad.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4421) => {
              if extra_keys_len(&super::fxa_app_menu::click_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4422) => {
              if extra_keys_len(&super::fxa_app_menu::click_monitor_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_monitor_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4423) => {
              if extra_keys_len(&super::fxa_app_menu::click_open_monitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_open_monitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4424) => {
              if extra_keys_len(&super::fxa_app_menu::click_open_send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_open_send.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4425) => {
              if extra_keys_len(&super::fxa_app_menu::click_relay_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_relay_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4426) => {
              if extra_keys_len(&super::fxa_app_menu::click_send_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_send_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4427) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4428) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_now) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_now.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4429) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4430) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4431) => {
              if extra_keys_len(&super::fxa_app_menu::click_sync_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_sync_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4432) => {
              if extra_keys_len(&super::fxa_app_menu::click_toolbar_icon) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_toolbar_icon.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4433) => {
              if extra_keys_len(&super::fxa_app_menu::click_unver_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_unver_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4434) => {
              if extra_keys_len(&super::fxa_app_menu::click_vpn_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_app_menu::click_vpn_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4435) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_account_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_account_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4436) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_cad) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_cad.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4437) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4438) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_monitor_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_monitor_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4439) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_open_monitor) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_open_monitor.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4440) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_open_send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_open_send.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4441) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_relay_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_relay_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4442) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_send_tab) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_send_tab.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4443) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4444) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_now) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_now.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4445) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4446) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_tabs) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_tabs.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4447) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_sync_tabs_sidebar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_sync_tabs_sidebar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4448) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_toolbar_icon) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_toolbar_icon.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4449) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_unver_sync_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_unver_sync_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4450) => {
              if extra_keys_len(&super::fxa_avatar_menu::click_vpn_cta) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::fxa_avatar_menu::click_vpn_cta.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4453) => {
              if extra_keys_len(&super::sync_merge_dialog::clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::sync_merge_dialog::clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4457) => {
              if extra_keys_len(&super::bounce_tracking_protection::purge_action) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::bounce_tracking_protection::purge_action.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4490) => {
              if extra_keys_len(&super::background_tasks_rmdir_base::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_base::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4498) => {
              if extra_keys_len(&super::background_tasks_rmdir_http_cache::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_http_cache::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4506) => {
              if extra_keys_len(&super::background_tasks_rmdir_quota::metric_base) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::background_tasks_rmdir_quota::metric_base.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4566) => {
              if extra_keys_len(&super::relevancy_classify::fail) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::fail.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4567) => {
              if extra_keys_len(&super::relevancy_classify::succeed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relevancy_classify::succeed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4569) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4570) => {
              if extra_keys_len(&super::cookie_banners::google_gdpr_choice_cookie_event_pbm) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::cookie_banners::google_gdpr_choice_cookie_event_pbm.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4646) => {
              if extra_keys_len(&super::doh::evaluate_v2_heuristics) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::evaluate_v2_heuristics.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4647) => {
              if extra_keys_len(&super::doh::state_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4648) => {
              if extra_keys_len(&super::doh::state_enabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_enabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4649) => {
              if extra_keys_len(&super::doh::state_manually_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_manually_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4650) => {
              if extra_keys_len(&super::doh::state_policy_disabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_policy_disabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4651) => {
              if extra_keys_len(&super::doh::state_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4652) => {
              if extra_keys_len(&super::doh::state_shutdown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_shutdown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4653) => {
              if extra_keys_len(&super::doh::state_uidisabled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uidisabled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4654) => {
              if extra_keys_len(&super::doh::state_uiok) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uiok.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4655) => {
              if extra_keys_len(&super::doh::state_uninstalled) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::doh::state_uninstalled.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4656) => {
              if extra_keys_len(&super::security_doh_trr_performance::resolved_record) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_trr_performance::resolved_record.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4657) => {
              if extra_keys_len(&super::security_doh_trr_performance::trrselect_dryrunresult) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_trr_performance::trrselect_dryrunresult.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4676) => {
              if extra_keys_len(&super::extensions_data::migrate_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::migrate_result.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4678) => {
              if extra_keys_len(&super::extensions_data::storage_local_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::storage_local_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4679) => {
              if extra_keys_len(&super::extensions_data::sync_usage_quotas) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::extensions_data::sync_usage_quotas.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4696) => {
              if extra_keys_len(&super::address::add_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::add_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4697) => {
              if extra_keys_len(&super::address::cancel_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4698) => {
              if extra_keys_len(&super::address::cancel_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4699) => {
              if extra_keys_len(&super::address::cancel_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cancel_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4700) => {
              if extra_keys_len(&super::address::cleared_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::cleared_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4701) => {
              if extra_keys_len(&super::address::delete_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::delete_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4702) => {
              if extra_keys_len(&super::address::detected_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::detected_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4703) => {
              if extra_keys_len(&super::address::detected_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::detected_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4704) => {
              if extra_keys_len(&super::address::disable_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4705) => {
              if extra_keys_len(&super::address::disable_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4706) => {
              if extra_keys_len(&super::address::disable_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::disable_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4707) => {
              if extra_keys_len(&super::address::edit_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::edit_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4708) => {
              if extra_keys_len(&super::address::filled_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4709) => {
              if extra_keys_len(&super::address::filled_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4710) => {
              if extra_keys_len(&super::address::filled_modified_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_modified_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4711) => {
              if extra_keys_len(&super::address::filled_on_fields_update_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::filled_on_fields_update_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4712) => {
              if extra_keys_len(&super::address::learn_more_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4713) => {
              if extra_keys_len(&super::address::learn_more_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4714) => {
              if extra_keys_len(&super::address::learn_more_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::learn_more_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4715) => {
              if extra_keys_len(&super::address::popup_shown_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::popup_shown_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4716) => {
              if extra_keys_len(&super::address::pref_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4717) => {
              if extra_keys_len(&super::address::pref_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4718) => {
              if extra_keys_len(&super::address::pref_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::pref_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4719) => {
              if extra_keys_len(&super::address::save_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4720) => {
              if extra_keys_len(&super::address::save_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4721) => {
              if extra_keys_len(&super::address::save_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::save_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4722) => {
              if extra_keys_len(&super::address::show_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4723) => {
              if extra_keys_len(&super::address::show_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4724) => {
              if extra_keys_len(&super::address::show_entry_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_entry_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4725) => {
              if extra_keys_len(&super::address::show_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4726) => {
              if extra_keys_len(&super::address::show_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::show_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4727) => {
              if extra_keys_len(&super::address::submitted_address_form) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::submitted_address_form.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4728) => {
              if extra_keys_len(&super::address::submitted_address_form_ext) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::submitted_address_form_ext.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4729) => {
              if extra_keys_len(&super::address::update_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4730) => {
              if extra_keys_len(&super::address::update_edit_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_edit_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4731) => {
              if extra_keys_len(&super::address::update_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::address::update_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4732) => {
              if extra_keys_len(&super::creditcard::add_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::add_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4733) => {
              if extra_keys_len(&super::creditcard::cancel_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cancel_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4734) => {
              if extra_keys_len(&super::creditcard::cancel_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cancel_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4735) => {
              if extra_keys_len(&super::creditcard::cleared_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::cleared_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4736) => {
              if extra_keys_len(&super::creditcard::delete_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::delete_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4737) => {
              if extra_keys_len(&super::creditcard::detected_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::detected_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4739) => {
              if extra_keys_len(&super::creditcard::disable_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::disable_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4740) => {
              if extra_keys_len(&super::creditcard::disable_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::disable_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4741) => {
              if extra_keys_len(&super::creditcard::edit_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::edit_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4742) => {
              if extra_keys_len(&super::creditcard::filled_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::filled_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4743) => {
              if extra_keys_len(&super::creditcard::filled_modified_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::filled_modified_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4744) => {
              if extra_keys_len(&super::creditcard::filled_on_fields_update_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::filled_on_fields_update_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4745) => {
              if extra_keys_len(&super::creditcard::os_keystore_decrypt) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::os_keystore_decrypt.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4746) => {
              if extra_keys_len(&super::creditcard::popup_shown_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::popup_shown_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4747) => {
              if extra_keys_len(&super::creditcard::save_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::save_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4748) => {
              if extra_keys_len(&super::creditcard::save_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::save_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4749) => {
              if extra_keys_len(&super::creditcard::show_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4750) => {
              if extra_keys_len(&super::creditcard::show_entry_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_entry_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4751) => {
              if extra_keys_len(&super::creditcard::show_manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4752) => {
              if extra_keys_len(&super::creditcard::show_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::show_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4753) => {
              if extra_keys_len(&super::creditcard::submitted_cc_form_v2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::submitted_cc_form_v2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4754) => {
              if extra_keys_len(&super::creditcard::update_capture_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::update_capture_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4755) => {
              if extra_keys_len(&super::creditcard::update_update_doorhanger) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::creditcard::update_update_doorhanger.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4758) => {
              if extra_keys_len(&super::formautofill::iframe_layout_detection) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill::iframe_layout_detection.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4760) => {
              if extra_keys_len(&super::formautofill::prompt_shown_os_reauth) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill::prompt_shown_os_reauth.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4761) => {
              if extra_keys_len(&super::formautofill::require_os_reauth_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill::require_os_reauth_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4764) => {
              if extra_keys_len(&super::formautofill_ml::field_infer_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::formautofill_ml::field_infer_result.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4836) => {
              if extra_keys_len(&super::test_only_ipc::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4841) => {
              if extra_keys_len(&super::test_only_ipc::event_with_extra) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::event_with_extra.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4843) => {
              if extra_keys_len(&super::test_only_ipc::no_extra_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_ipc::no_extra_event.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4846) => {
              if extra_keys_len(&super::test_only_jog::an_event) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::test_only_jog::an_event.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4848) => {
              if extra_keys_len(&super::messaging_experiments::reach_cfr) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_cfr.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4849) => {
              if extra_keys_len(&super::messaging_experiments::reach_feature_callout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_feature_callout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4850) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_bmb_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_bmb_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4851) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_1.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4852) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_10) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_10.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4853) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_11) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_11.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4854) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4855) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_3) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_3.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4856) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_4) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_4.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4857) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_5) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_5.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4858) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_6) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_6.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4859) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_7) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_7.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4860) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_8) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_8.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4861) => {
              if extra_keys_len(&super::messaging_experiments::reach_fxms_message_9) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_fxms_message_9.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4862) => {
              if extra_keys_len(&super::messaging_experiments::reach_infobar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_infobar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4863) => {
              if extra_keys_len(&super::messaging_experiments::reach_moments_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_moments_page.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4864) => {
              if extra_keys_len(&super::messaging_experiments::reach_spotlight) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::reach_spotlight.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4865) => {
              if extra_keys_len(&super::messaging_experiments::targeting_attribute_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::targeting_attribute_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4866) => {
              if extra_keys_len(&super::messaging_experiments::targeting_attribute_timeout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::messaging_experiments::targeting_attribute_timeout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4867) => {
              if extra_keys_len(&super::firefox_ai_runtime::engine_creation_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefox_ai_runtime::engine_creation_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4869) => {
              if extra_keys_len(&super::firefox_ai_runtime::run_inference_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::firefox_ai_runtime::run_inference_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4871) => {
              if extra_keys_len(&super::nimbus_events::enroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4872) => {
              if extra_keys_len(&super::nimbus_events::enrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4873) => {
              if extra_keys_len(&super::nimbus_events::enrollment_status) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::enrollment_status.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4874) => {
              if extra_keys_len(&super::nimbus_events::exposure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::exposure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4875) => {
              if extra_keys_len(&super::nimbus_events::is_ready) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::is_ready.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4876) => {
              if extra_keys_len(&super::nimbus_events::migration) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::migration.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4877) => {
              if extra_keys_len(&super::nimbus_events::unenroll_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenroll_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4878) => {
              if extra_keys_len(&super::nimbus_events::unenrollment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::unenrollment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4879) => {
              if extra_keys_len(&super::nimbus_events::validation_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::nimbus_events::validation_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4916) => {
              if extra_keys_len(&super::normandy::expose_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::expose_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4917) => {
              if extra_keys_len(&super::normandy::enroll_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4918) => {
              if extra_keys_len(&super::normandy::enroll_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4919) => {
              if extra_keys_len(&super::normandy::enroll_failed_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4920) => {
              if extra_keys_len(&super::normandy::enroll_failed_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4921) => {
              if extra_keys_len(&super::normandy::enroll_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4922) => {
              if extra_keys_len(&super::normandy::enroll_failed_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4923) => {
              if extra_keys_len(&super::normandy::enroll_failed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_failed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4924) => {
              if extra_keys_len(&super::normandy::enroll_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4925) => {
              if extra_keys_len(&super::normandy::enroll_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4926) => {
              if extra_keys_len(&super::normandy::enroll_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::enroll_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4927) => {
              if extra_keys_len(&super::normandy::exp_pref_changed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::exp_pref_changed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4928) => {
              if extra_keys_len(&super::normandy::graduate_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::graduate_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4930) => {
              if extra_keys_len(&super::normandy::unenroll_addon_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_addon_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4931) => {
              if extra_keys_len(&super::normandy::unenroll_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4932) => {
              if extra_keys_len(&super::normandy::unenroll_failed_addon_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_addon_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4933) => {
              if extra_keys_len(&super::normandy::unenroll_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4934) => {
              if extra_keys_len(&super::normandy::unenroll_failed_preference_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_preference_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4935) => {
              if extra_keys_len(&super::normandy::unenroll_failed_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_failed_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4936) => {
              if extra_keys_len(&super::normandy::unenroll_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4937) => {
              if extra_keys_len(&super::normandy::unenroll_preference_rollback) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_preference_rollback.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4938) => {
              if extra_keys_len(&super::normandy::unenroll_preference_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::unenroll_preference_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4939) => {
              if extra_keys_len(&super::normandy::update_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4940) => {
              if extra_keys_len(&super::normandy::update_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4941) => {
              if extra_keys_len(&super::normandy::update_failed_addon_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_failed_addon_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4942) => {
              if extra_keys_len(&super::normandy::update_failed_addon_study) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_failed_addon_study.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4943) => {
              if extra_keys_len(&super::normandy::update_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4944) => {
              if extra_keys_len(&super::normandy::update_preference_rollout) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::update_preference_rollout.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4945) => {
              if extra_keys_len(&super::normandy::validation_failed_nimbus_experiment) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::normandy::validation_failed_nimbus_experiment.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4946) => {
              if extra_keys_len(&super::form_autocomplete::show_logins) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::form_autocomplete::show_logins.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4947) => {
              if extra_keys_len(&super::pwmgr::autocomplete_field_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::autocomplete_field_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4948) => {
              if extra_keys_len(&super::pwmgr::autocomplete_shown_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::autocomplete_shown_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4949) => {
              if extra_keys_len(&super::pwmgr::cancel_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::cancel_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4950) => {
              if extra_keys_len(&super::pwmgr::cancel_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::cancel_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4951) => {
              if extra_keys_len(&super::pwmgr::copy_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::copy_password.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4952) => {
              if extra_keys_len(&super::pwmgr::copy_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::copy_username.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4953) => {
              if extra_keys_len(&super::pwmgr::delete_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::delete_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4954) => {
              if extra_keys_len(&super::pwmgr::delete_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::delete_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4955) => {
              if extra_keys_len(&super::pwmgr::doorhanger_submitted_save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::doorhanger_submitted_save.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4956) => {
              if extra_keys_len(&super::pwmgr::doorhanger_submitted_update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::doorhanger_submitted_update.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4957) => {
              if extra_keys_len(&super::pwmgr::edit_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::edit_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4958) => {
              if extra_keys_len(&super::pwmgr::filled_field_edited_generatedpassword) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::filled_field_edited_generatedpassword.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4959) => {
              if extra_keys_len(&super::pwmgr::filter_list) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::filter_list.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4961) => {
              if extra_keys_len(&super::pwmgr::hide_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::hide_password.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4964) => {
              if extra_keys_len(&super::pwmgr::learn_more_vuln_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::learn_more_vuln_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4966) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_export) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_export.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4967) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_export_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_export_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4968) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_csv_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_csv_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4969) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_from_browser) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_from_browser.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4970) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_import_from_csv) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_import_from_csv.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4971) => {
              if extra_keys_len(&super::pwmgr::mgmt_menu_item_used_preferences) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::mgmt_menu_item_used_preferences.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4972) => {
              if extra_keys_len(&super::pwmgr::new_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::new_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4975) => {
              if extra_keys_len(&super::pwmgr::open_management_aboutprotections) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_aboutprotections.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4976) => {
              if extra_keys_len(&super::pwmgr::open_management_autocomplete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_autocomplete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4977) => {
              if extra_keys_len(&super::pwmgr::open_management_contextmenu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_contextmenu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4978) => {
              if extra_keys_len(&super::pwmgr::open_management_direct) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_direct.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4979) => {
              if extra_keys_len(&super::pwmgr::open_management_mainmenu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_mainmenu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4980) => {
              if extra_keys_len(&super::pwmgr::open_management_pageinfo) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_pageinfo.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4981) => {
              if extra_keys_len(&super::pwmgr::open_management_preferences) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_preferences.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4982) => {
              if extra_keys_len(&super::pwmgr::open_management_snippet) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_management_snippet.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4983) => {
              if extra_keys_len(&super::pwmgr::open_site_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::open_site_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4987) => {
              if extra_keys_len(&super::pwmgr::prompt_shown_os_reauth) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::prompt_shown_os_reauth.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4989) => {
              if extra_keys_len(&super::pwmgr::reauthenticate_master_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::reauthenticate_master_password.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4990) => {
              if extra_keys_len(&super::pwmgr::reauthenticate_os_auth) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::reauthenticate_os_auth.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4991) => {
              if extra_keys_len(&super::pwmgr::require_os_reauth_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::require_os_reauth_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4992) => {
              if extra_keys_len(&super::pwmgr::save_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::save_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4993) => {
              if extra_keys_len(&super::pwmgr::save_new_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::save_new_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4994) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_auth_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_auth_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4995) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_form_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_form_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4996) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_form_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_form_password.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4997) => {
              if extra_keys_len(&super::pwmgr::saved_login_used_prompt_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::saved_login_used_prompt_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(4999) => {
              if extra_keys_len(&super::pwmgr::select_existing_login) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::select_existing_login.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5000) => {
              if extra_keys_len(&super::pwmgr::show_password) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::show_password.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5002) => {
              if extra_keys_len(&super::pwmgr::sort_list) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pwmgr::sort_list.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5003) => {
              if extra_keys_len(&super::relay_integration::clicked_fill_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::clicked_fill_username.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5004) => {
              if extra_keys_len(&super::relay_integration::clicked_offer_relay) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::clicked_offer_relay.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5005) => {
              if extra_keys_len(&super::relay_integration::disabled_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::disabled_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5006) => {
              if extra_keys_len(&super::relay_integration::disabled_pref_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::disabled_pref_change.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5007) => {
              if extra_keys_len(&super::relay_integration::enabled_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::enabled_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5008) => {
              if extra_keys_len(&super::relay_integration::enabled_pref_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::enabled_pref_change.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5009) => {
              if extra_keys_len(&super::relay_integration::get_unlimited_masks_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::get_unlimited_masks_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5010) => {
              if extra_keys_len(&super::relay_integration::postponed_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::postponed_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5011) => {
              if extra_keys_len(&super::relay_integration::reuse_mask_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::reuse_mask_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5012) => {
              if extra_keys_len(&super::relay_integration::shown_fill_username) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_fill_username.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5013) => {
              if extra_keys_len(&super::relay_integration::shown_offer_relay) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_offer_relay.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5014) => {
              if extra_keys_len(&super::relay_integration::shown_opt_in_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_opt_in_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5015) => {
              if extra_keys_len(&super::relay_integration::shown_reuse_panel) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::relay_integration::shown_reuse_panel.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5034) => {
              if extra_keys_len(&super::pdfjs_image::add_image_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::add_image_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5037) => {
              if extra_keys_len(&super::pdfjs_image::icon_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::icon_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5038) => {
              if extra_keys_len(&super::pdfjs_image::image_added) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::image_added.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5039) => {
              if extra_keys_len(&super::pdfjs_image::image_selected) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image::image_selected.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5040) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::ai_generation_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::ai_generation_check.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5041) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::callout_dismissed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::callout_dismissed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5042) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::callout_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::callout_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5043) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::dismiss) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::dismiss.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5044) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::image_status_label_clicked) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::image_status_label_clicked.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5045) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::image_status_label_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::image_status_label_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5046) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5047) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_deleted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_deleted.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5048) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_complete) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_complete.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5049) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5050) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_download_start) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_download_start.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5051) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::model_result) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::model_result.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5052) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::save) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::save.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5053) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_ai_generation_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_ai_generation_check.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5054) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_displayed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_displayed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5055) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::settings_edit_alt_text_check) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::settings_edit_alt_text_check.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5056) => {
              if extra_keys_len(&super::pdfjs_image_alt_text::user_edit) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_image_alt_text::user_edit.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5057) => {
              if extra_keys_len(&super::pdfjs_signature::added) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_signature::added.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5059) => {
              if extra_keys_len(&super::pdfjs_signature::created) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_signature::created.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5060) => {
              if extra_keys_len(&super::pdfjs_signature::delete_saved) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_signature::delete_saved.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5062) => {
              if extra_keys_len(&super::pdfjs_signature::inserted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pdfjs_signature::inserted.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5064) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_browser_crash) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_browser_crash.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5065) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_close_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_close_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5066) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_close_player_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_close_player_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5067) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5068) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_foregrounded) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_foregrounded.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5069) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_fullscreen) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_fullscreen.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5070) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_pagehide) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_pagehide.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5071) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_setup_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_setup_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5072) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5073) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_unpip) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_unpip.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5074) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5075) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_video_el_emptied) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_video_el_emptied.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5076) => {
              if extra_keys_len(&super::pictureinpicture::closed_method_video_el_remove) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::closed_method_video_el_remove.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5077) => {
              if extra_keys_len(&super::pictureinpicture::create_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::create_player.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5078) => {
              if extra_keys_len(&super::pictureinpicture::disrespect_disable_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::disrespect_disable_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5080) => {
              if extra_keys_len(&super::pictureinpicture::fullscreen_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::fullscreen_player.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5082) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_auto_pip) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_auto_pip.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5083) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_context_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_context_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5084) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_shortcut) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_shortcut.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5085) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5086) => {
              if extra_keys_len(&super::pictureinpicture::opened_method_url_bar) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::opened_method_url_bar.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5087) => {
              if extra_keys_len(&super::pictureinpicture::resize_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::resize_player.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5088) => {
              if extra_keys_len(&super::pictureinpicture::saw_toggle_toggle) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::saw_toggle_toggle.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5089) => {
              if extra_keys_len(&super::pictureinpicture::subtitles_shown_subtitles) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture::subtitles_shown_subtitles.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5092) => {
              if extra_keys_len(&super::pictureinpicture_settings::disable_player) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::disable_player.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5093) => {
              if extra_keys_len(&super::pictureinpicture_settings::disable_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::disable_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5094) => {
              if extra_keys_len(&super::pictureinpicture_settings::enable_autotrigger_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::enable_autotrigger_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5095) => {
              if extra_keys_len(&super::pictureinpicture_settings::enable_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::pictureinpicture_settings::enable_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5150) => {
              if extra_keys_len(&super::readermode::button_click) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::button_click.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5153) => {
              if extra_keys_len(&super::readermode::view_off) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::view_off.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5154) => {
              if extra_keys_len(&super::readermode::view_on) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::readermode::view_on.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5196) => {
              if extra_keys_len(&super::webcompatreporting::opened) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::opened.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5197) => {
              if extra_keys_len(&super::webcompatreporting::reason_dropdown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::reason_dropdown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5198) => {
              if extra_keys_len(&super::webcompatreporting::send) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5199) => {
              if extra_keys_len(&super::webcompatreporting::send_more_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::webcompatreporting::send_more_info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5487) => {
              if extra_keys_len(&super::search_engine_default::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_default::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5495) => {
              if extra_keys_len(&super::search_engine_private::changed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::search_engine_private::changed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5508) => {
              if extra_keys_len(&super::shopping_product::invalid_ohttp_config) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_ohttp_config.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5509) => {
              if extra_keys_len(&super::shopping_product::invalid_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_request.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5510) => {
              if extra_keys_len(&super::shopping_product::invalid_response) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::invalid_response.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5511) => {
              if extra_keys_len(&super::shopping_product::request_aborted) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_aborted.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5512) => {
              if extra_keys_len(&super::shopping_product::request_error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5513) => {
              if extra_keys_len(&super::shopping_product::request_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5514) => {
              if extra_keys_len(&super::shopping_product::request_retried) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retried.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5515) => {
              if extra_keys_len(&super::shopping_product::request_retries_failed) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::request_retries_failed.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5516) => {
              if extra_keys_len(&super::shopping_product::server_failure) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::shopping_product::server_failure.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5571) => {
              if extra_keys_len(&super::telemetry_test::test1_object1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test1_object1.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5572) => {
              if extra_keys_len(&super::telemetry_test::test2_object1) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test2_object1.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5573) => {
              if extra_keys_len(&super::telemetry_test::test2_object2) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::telemetry_test::test2_object2.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5581) => {
              if extra_keys_len(&super::translations::engine_performance) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::engine_performance.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5582) => {
              if extra_keys_len(&super::translations::error) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::error.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5584) => {
              if extra_keys_len(&super::translations::restore_page) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::restore_page.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5585) => {
              if extra_keys_len(&super::translations::translation_request) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations::translation_request.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5586) => {
              if extra_keys_len(&super::translations_about_translations_page::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_about_translations_page::open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5587) => {
              if extra_keys_len(&super::translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5588) => {
              if extra_keys_len(&super::translations_panel::always_offer_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_offer_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5589) => {
              if extra_keys_len(&super::translations_panel::always_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::always_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5590) => {
              if extra_keys_len(&super::translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5591) => {
              if extra_keys_len(&super::translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5592) => {
              if extra_keys_len(&super::translations_panel::change_source_language_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_source_language_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5593) => {
              if extra_keys_len(&super::translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5594) => {
              if extra_keys_len(&super::translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5595) => {
              if extra_keys_len(&super::translations_panel::close_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5596) => {
              if extra_keys_len(&super::translations_panel::close_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5597) => {
              if extra_keys_len(&super::translations_panel::close_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::close_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5598) => {
              if extra_keys_len(&super::translations_panel::dismiss_error_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::dismiss_error_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5599) => {
              if extra_keys_len(&super::translations_panel::learn_more) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::learn_more.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5600) => {
              if extra_keys_len(&super::translations_panel::manage_languages) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::manage_languages.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5601) => {
              if extra_keys_len(&super::translations_panel::never_translate_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5602) => {
              if extra_keys_len(&super::translations_panel::never_translate_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::never_translate_site.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5603) => {
              if extra_keys_len(&super::translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5604) => {
              if extra_keys_len(&super::translations_panel::open_from_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_from_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5605) => {
              if extra_keys_len(&super::translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5606) => {
              if extra_keys_len(&super::translations_panel::open_to_language_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::open_to_language_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5607) => {
              if extra_keys_len(&super::translations_panel::restore_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::restore_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5608) => {
              if extra_keys_len(&super::translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5609) => {
              if extra_keys_len(&super::translations_select_translations_panel::about_translations) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::about_translations.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5610) => {
              if extra_keys_len(&super::translations_select_translations_panel::cancel_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::cancel_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5611) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_from_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_from_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5612) => {
              if extra_keys_len(&super::translations_select_translations_panel::change_to_language) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::change_to_language.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5613) => {
              if extra_keys_len(&super::translations_select_translations_panel::close) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::close.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5614) => {
              if extra_keys_len(&super::translations_select_translations_panel::copy_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::copy_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5615) => {
              if extra_keys_len(&super::translations_select_translations_panel::done_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::done_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5616) => {
              if extra_keys_len(&super::translations_select_translations_panel::initialization_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::initialization_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5617) => {
              if extra_keys_len(&super::translations_select_translations_panel::open) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5618) => {
              if extra_keys_len(&super::translations_select_translations_panel::open_settings_menu) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::open_settings_menu.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5619) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5620) => {
              if extra_keys_len(&super::translations_select_translations_panel::translate_full_page_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translate_full_page_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5621) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_failure_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_failure_message.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5622) => {
              if extra_keys_len(&super::translations_select_translations_panel::translation_settings) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::translation_settings.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5623) => {
              if extra_keys_len(&super::translations_select_translations_panel::try_again_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::try_again_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5624) => {
              if extra_keys_len(&super::translations_select_translations_panel::unsupported_language_message) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::translations_select_translations_panel::unsupported_language_message.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5652) => {
              if extra_keys_len(&super::security_doh_neterror::click_add_exception_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_add_exception_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5653) => {
              if extra_keys_len(&super::security_doh_neterror::click_continue_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_continue_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5654) => {
              if extra_keys_len(&super::security_doh_neterror::click_disable_warning) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_disable_warning.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5655) => {
              if extra_keys_len(&super::security_doh_neterror::click_learn_more_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_learn_more_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5656) => {
              if extra_keys_len(&super::security_doh_neterror::click_settings_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_settings_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5657) => {
              if extra_keys_len(&super::security_doh_neterror::click_try_again_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::click_try_again_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5658) => {
              if extra_keys_len(&super::security_doh_neterror::load_dohwarning) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_doh_neterror::load_dohwarning.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5659) => {
              if extra_keys_len(&super::security_ui_certerror::click_advanced_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_advanced_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5660) => {
              if extra_keys_len(&super::security_ui_certerror::click_auto_report_cb) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_auto_report_cb.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5661) => {
              if extra_keys_len(&super::security_ui_certerror::click_clipboard_button_bot) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_clipboard_button_bot.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5662) => {
              if extra_keys_len(&super::security_ui_certerror::click_clipboard_button_top) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_clipboard_button_top.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5663) => {
              if extra_keys_len(&super::security_ui_certerror::click_error_code_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_error_code_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5664) => {
              if extra_keys_len(&super::security_ui_certerror::click_exception_button) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_exception_button.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5665) => {
              if extra_keys_len(&super::security_ui_certerror::click_learn_more_link) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_learn_more_link.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5666) => {
              if extra_keys_len(&super::security_ui_certerror::click_return_button_adv) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_return_button_adv.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5667) => {
              if extra_keys_len(&super::security_ui_certerror::click_return_button_top) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::click_return_button_top.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5668) => {
              if extra_keys_len(&super::security_ui_certerror::load_aboutcerterror) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_certerror::load_aboutcerterror.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5669) => {
              if extra_keys_len(&super::security_ui_tlserror::load_abouttlserror) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::security_ui_tlserror::load_abouttlserror.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5680) => {
              if extra_keys_len(&super::jsonfile::load_autofillprofiles) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::jsonfile::load_autofillprofiles.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5681) => {
              if extra_keys_len(&super::jsonfile::load_logins) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::jsonfile::load_logins.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5687) => {
              if extra_keys_len(&super::service_request::bypass_proxy_info) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::service_request::bypass_proxy_info.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5700) => {
              if extra_keys_len(&super::addons_manager::install) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5701) => {
              if extra_keys_len(&super::addons_manager::install_stats) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5702) => {
              if extra_keys_len(&super::addons_manager::manage) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::manage.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5703) => {
              if extra_keys_len(&super::addons_manager::report_suspicious_site) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::report_suspicious_site.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5704) => {
              if extra_keys_len(&super::addons_manager::update) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5705) => {
              if extra_keys_len(&super::addons_manager::xpistates_write_errors) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::xpistates_write_errors.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5706) => {
              if extra_keys_len(&super::addons_manager::disable_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5707) => {
              if extra_keys_len(&super::addons_manager::disable_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5708) => {
              if extra_keys_len(&super::addons_manager::disable_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5709) => {
              if extra_keys_len(&super::addons_manager::disable_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5710) => {
              if extra_keys_len(&super::addons_manager::disable_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5711) => {
              if extra_keys_len(&super::addons_manager::disable_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5712) => {
              if extra_keys_len(&super::addons_manager::disable_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5713) => {
              if extra_keys_len(&super::addons_manager::disable_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::disable_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5714) => {
              if extra_keys_len(&super::addons_manager::enable_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5715) => {
              if extra_keys_len(&super::addons_manager::enable_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5716) => {
              if extra_keys_len(&super::addons_manager::enable_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5717) => {
              if extra_keys_len(&super::addons_manager::enable_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5718) => {
              if extra_keys_len(&super::addons_manager::enable_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5719) => {
              if extra_keys_len(&super::addons_manager::enable_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5720) => {
              if extra_keys_len(&super::addons_manager::enable_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5721) => {
              if extra_keys_len(&super::addons_manager::enable_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::enable_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5722) => {
              if extra_keys_len(&super::addons_manager::install_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5723) => {
              if extra_keys_len(&super::addons_manager::install_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5724) => {
              if extra_keys_len(&super::addons_manager::install_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5725) => {
              if extra_keys_len(&super::addons_manager::install_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5726) => {
              if extra_keys_len(&super::addons_manager::install_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5727) => {
              if extra_keys_len(&super::addons_manager::install_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5728) => {
              if extra_keys_len(&super::addons_manager::install_stats_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5729) => {
              if extra_keys_len(&super::addons_manager::install_stats_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5730) => {
              if extra_keys_len(&super::addons_manager::install_stats_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5731) => {
              if extra_keys_len(&super::addons_manager::install_stats_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5732) => {
              if extra_keys_len(&super::addons_manager::install_stats_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5733) => {
              if extra_keys_len(&super::addons_manager::install_stats_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5734) => {
              if extra_keys_len(&super::addons_manager::install_stats_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5735) => {
              if extra_keys_len(&super::addons_manager::install_stats_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_stats_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5736) => {
              if extra_keys_len(&super::addons_manager::install_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5737) => {
              if extra_keys_len(&super::addons_manager::install_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::install_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5738) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5739) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5740) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5741) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5742) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5743) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5744) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5745) => {
              if extra_keys_len(&super::addons_manager::sideload_prompt_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::sideload_prompt_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5746) => {
              if extra_keys_len(&super::addons_manager::uninstall_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5747) => {
              if extra_keys_len(&super::addons_manager::uninstall_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5748) => {
              if extra_keys_len(&super::addons_manager::uninstall_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5749) => {
              if extra_keys_len(&super::addons_manager::uninstall_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5750) => {
              if extra_keys_len(&super::addons_manager::uninstall_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5751) => {
              if extra_keys_len(&super::addons_manager::uninstall_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5752) => {
              if extra_keys_len(&super::addons_manager::uninstall_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5753) => {
              if extra_keys_len(&super::addons_manager::uninstall_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::uninstall_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5754) => {
              if extra_keys_len(&super::addons_manager::update_dictionary) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_dictionary.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5755) => {
              if extra_keys_len(&super::addons_manager::update_extension) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_extension.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5756) => {
              if extra_keys_len(&super::addons_manager::update_locale) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_locale.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5757) => {
              if extra_keys_len(&super::addons_manager::update_other) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_other.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5758) => {
              if extra_keys_len(&super::addons_manager::update_siteperm_deprecated) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_siteperm_deprecated.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5759) => {
              if extra_keys_len(&super::addons_manager::update_sitepermission) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_sitepermission.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5760) => {
              if extra_keys_len(&super::addons_manager::update_theme) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_theme.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5761) => {
              if extra_keys_len(&super::addons_manager::update_unknown) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::addons_manager::update_unknown.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5762) => {
              if extra_keys_len(&super::blocklist::addon_block_change) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::blocklist::addon_block_change.record_with_time(timestamp, extra);
              Ok(())
          }
          BaseMetricId(5896) => {
              if extra_keys_len(&super::memory_watcher::on_high_memory_stats) == 0 && !extra.is_empty() {
                return Err(EventRecordingError::InvalidExtraKey);
              }

              super::memory_watcher::on_high_memory_stats.record_with_time(timestamp, extra);
              Ok(())
          }
           _ => Err(EventRecordingError::InvalidId),
        }
    }

    /// Wrapper to get the currently stored events for event metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns the recorded events or `None` if nothing stored.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    pub(crate) fn event_test_get_value_wrapper(metric_id: u32, ping_name: Option<String>) -> Option<Vec<RecordedEvent>> {
        match metric_id {
           16 => super::browser_engagement::tab_explicit_unload.test_get_value(ping_name.as_deref()),
           199 => super::security_ui_protectionspopup::click_cookieb_toggle_off.test_get_value(ping_name.as_deref()),
           200 => super::security_ui_protectionspopup::click_cookieb_toggle_on.test_get_value(ping_name.as_deref()),
           201 => super::security_ui_protectionspopup::click_cookies.test_get_value(ping_name.as_deref()),
           202 => super::security_ui_protectionspopup::click_cryptominers.test_get_value(ping_name.as_deref()),
           203 => super::security_ui_protectionspopup::click_etp_toggle_off.test_get_value(ping_name.as_deref()),
           204 => super::security_ui_protectionspopup::click_etp_toggle_on.test_get_value(ping_name.as_deref()),
           205 => super::security_ui_protectionspopup::click_fingerprinters.test_get_value(ping_name.as_deref()),
           206 => super::security_ui_protectionspopup::click_full_report.test_get_value(ping_name.as_deref()),
           207 => super::security_ui_protectionspopup::click_milestone_message.test_get_value(ping_name.as_deref()),
           208 => super::security_ui_protectionspopup::click_protectionspopup_cfr.test_get_value(ping_name.as_deref()),
           209 => super::security_ui_protectionspopup::click_settings.test_get_value(ping_name.as_deref()),
           210 => super::security_ui_protectionspopup::click_smartblockembeds_toggle.test_get_value(ping_name.as_deref()),
           211 => super::security_ui_protectionspopup::click_social.test_get_value(ping_name.as_deref()),
           212 => super::security_ui_protectionspopup::click_subview_settings.test_get_value(ping_name.as_deref()),
           213 => super::security_ui_protectionspopup::click_trackers.test_get_value(ping_name.as_deref()),
           214 => super::security_ui_protectionspopup::close_protections_popup.test_get_value(ping_name.as_deref()),
           215 => super::security_ui_protectionspopup::open_protections_popup.test_get_value(ping_name.as_deref()),
           216 => super::security_ui_protectionspopup::open_protectionspopup_cfr.test_get_value(ping_name.as_deref()),
           256 => super::browser_backup::change_location.test_get_value(ping_name.as_deref()),
           259 => super::browser_backup::created.test_get_value(ping_name.as_deref()),
           262 => super::browser_backup::error.test_get_value(ping_name.as_deref()),
           272 => super::browser_backup::password_added.test_get_value(ping_name.as_deref()),
           273 => super::browser_backup::password_changed.test_get_value(ping_name.as_deref()),
           274 => super::browser_backup::password_removed.test_get_value(ping_name.as_deref()),
           285 => super::browser_backup::toggle_off.test_get_value(ping_name.as_deref()),
           286 => super::browser_backup::toggle_on.test_get_value(ping_name.as_deref()),
           290 => super::downloads::added_file_extension.test_get_value(ping_name.as_deref()),
           306 => super::firefoxview_next::browser_context_menu_tabs.test_get_value(ping_name.as_deref()),
           307 => super::firefoxview_next::card_collapsed_card_container.test_get_value(ping_name.as_deref()),
           308 => super::firefoxview_next::card_expanded_card_container.test_get_value(ping_name.as_deref()),
           309 => super::firefoxview_next::change_page_navigation.test_get_value(ping_name.as_deref()),
           310 => super::firefoxview_next::close_open_tab_tabs.test_get_value(ping_name.as_deref()),
           311 => super::firefoxview_next::context_menu_tabs.test_get_value(ping_name.as_deref()),
           312 => super::firefoxview_next::dismiss_closed_tab_tabs.test_get_value(ping_name.as_deref()),
           313 => super::firefoxview_next::entered_firefoxview.test_get_value(ping_name.as_deref()),
           314 => super::firefoxview_next::fxa_continue_sync.test_get_value(ping_name.as_deref()),
           315 => super::firefoxview_next::fxa_mobile_sync.test_get_value(ping_name.as_deref()),
           316 => super::firefoxview_next::history_visits.test_get_value(ping_name.as_deref()),
           317 => super::firefoxview_next::open_tab_tabs.test_get_value(ping_name.as_deref()),
           318 => super::firefoxview_next::recently_closed_tabs.test_get_value(ping_name.as_deref()),
           319 => super::firefoxview_next::search_initiated_search.test_get_value(ping_name.as_deref()),
           320 => super::firefoxview_next::search_show_all_showallbutton.test_get_value(ping_name.as_deref()),
           321 => super::firefoxview_next::show_all_history_tabs.test_get_value(ping_name.as_deref()),
           322 => super::firefoxview_next::sort_history_tabs.test_get_value(ping_name.as_deref()),
           323 => super::firefoxview_next::synced_tabs_tabs.test_get_value(ping_name.as_deref()),
           324 => super::firefoxview_next::tab_selected_toolbarbutton.test_get_value(ping_name.as_deref()),
           325 => super::genai_chatbot::contextmenu_prompt_click.test_get_value(ping_name.as_deref()),
           326 => super::genai_chatbot::contextmenu_remove.test_get_value(ping_name.as_deref()),
           328 => super::genai_chatbot::experiment_checkbox_click.test_get_value(ping_name.as_deref()),
           329 => super::genai_chatbot::keyboard_shortcut.test_get_value(ping_name.as_deref()),
           330 => super::genai_chatbot::onboarding_close.test_get_value(ping_name.as_deref()),
           331 => super::genai_chatbot::onboarding_continue.test_get_value(ping_name.as_deref()),
           332 => super::genai_chatbot::onboarding_finish.test_get_value(ping_name.as_deref()),
           333 => super::genai_chatbot::onboarding_learn_more.test_get_value(ping_name.as_deref()),
           334 => super::genai_chatbot::onboarding_provider_choice_displayed.test_get_value(ping_name.as_deref()),
           335 => super::genai_chatbot::onboarding_provider_learn.test_get_value(ping_name.as_deref()),
           336 => super::genai_chatbot::onboarding_provider_selection.test_get_value(ping_name.as_deref()),
           337 => super::genai_chatbot::onboarding_provider_terms.test_get_value(ping_name.as_deref()),
           338 => super::genai_chatbot::onboarding_text_highlight_displayed.test_get_value(ping_name.as_deref()),
           340 => super::genai_chatbot::provider_change.test_get_value(ping_name.as_deref()),
           342 => super::genai_chatbot::shortcuts_checkbox_click.test_get_value(ping_name.as_deref()),
           344 => super::genai_chatbot::shortcuts_displayed.test_get_value(ping_name.as_deref()),
           345 => super::genai_chatbot::shortcuts_expanded.test_get_value(ping_name.as_deref()),
           346 => super::genai_chatbot::shortcuts_hide_click.test_get_value(ping_name.as_deref()),
           347 => super::genai_chatbot::shortcuts_prompt_click.test_get_value(ping_name.as_deref()),
           349 => super::genai_chatbot::sidebar_close_click.test_get_value(ping_name.as_deref()),
           350 => super::genai_chatbot::sidebar_more_menu_click.test_get_value(ping_name.as_deref()),
           351 => super::genai_chatbot::sidebar_more_menu_display.test_get_value(ping_name.as_deref()),
           352 => super::genai_chatbot::sidebar_provider_menu_click.test_get_value(ping_name.as_deref()),
           353 => super::genai_chatbot::sidebar_toggle.test_get_value(ping_name.as_deref()),
           354 => super::genai_linkpreview::card_close.test_get_value(ping_name.as_deref()),
           355 => super::genai_linkpreview::card_link.test_get_value(ping_name.as_deref()),
           357 => super::genai_linkpreview::fetch.test_get_value(ping_name.as_deref()),
           358 => super::genai_linkpreview::generate.test_get_value(ping_name.as_deref()),
           359 => super::genai_linkpreview::labs_checkbox.test_get_value(ping_name.as_deref()),
           360 => super::genai_linkpreview::start.test_get_value(ping_name.as_deref()),
           387 => super::browser_launched_to_handle::system_notification.test_get_value(ping_name.as_deref()),
           401 => super::launch_on_login::last_profile_disable_startup.test_get_value(ping_name.as_deref()),
           415 => super::security::fission_principals.test_get_value(ping_name.as_deref()),
           416 => super::security::csp_violation_internal_page.test_get_value(ping_name.as_deref()),
           417 => super::security::eval_usage_parent_process.test_get_value(ping_name.as_deref()),
           418 => super::security::eval_usage_system_context.test_get_value(ping_name.as_deref()),
           420 => super::security::javascript_load_parent_process.test_get_value(ping_name.as_deref()),
           422 => super::security::unexpected_load.test_get_value(ping_name.as_deref()),
           423 => super::security::pref_usage_content_process.test_get_value(ping_name.as_deref()),
           429 => super::start_menu::manually_unpinned_since_last_launch.test_get_value(ping_name.as_deref()),
           435 => super::upgrade_dialog::trigger_reason.test_get_value(ping_name.as_deref()),
           437 => super::browser_migration::browser_selected_wizard.test_get_value(ping_name.as_deref()),
           439 => super::browser_migration::chrome_password_file_wizard.test_get_value(ping_name.as_deref()),
           444 => super::browser_migration::linux_perms_wizard.test_get_value(ping_name.as_deref()),
           447 => super::browser_migration::migration_finished_wizard.test_get_value(ping_name.as_deref()),
           448 => super::browser_migration::migration_started_wizard.test_get_value(ping_name.as_deref()),
           449 => super::browser_migration::no_browsers_found_wizard.test_get_value(ping_name.as_deref()),
           450 => super::browser_migration::opened_wizard.test_get_value(ping_name.as_deref()),
           451 => super::browser_migration::profile_selected_wizard.test_get_value(ping_name.as_deref()),
           452 => super::browser_migration::resources_selected_wizard.test_get_value(ping_name.as_deref()),
           453 => super::browser_migration::safari_password_file_wizard.test_get_value(ping_name.as_deref()),
           454 => super::browser_migration::safari_perms_wizard.test_get_value(ping_name.as_deref()),
           461 => super::activity_stream::end_session.test_get_value(ping_name.as_deref()),
           462 => super::activity_stream::event_archive_from_pocket.test_get_value(ping_name.as_deref()),
           463 => super::activity_stream::event_block.test_get_value(ping_name.as_deref()),
           464 => super::activity_stream::event_bookmark_add.test_get_value(ping_name.as_deref()),
           465 => super::activity_stream::event_bookmark_delete.test_get_value(ping_name.as_deref()),
           466 => super::activity_stream::event_click.test_get_value(ping_name.as_deref()),
           467 => super::activity_stream::event_click_privacy_info.test_get_value(ping_name.as_deref()),
           468 => super::activity_stream::event_close_newtab_prefs.test_get_value(ping_name.as_deref()),
           469 => super::activity_stream::event_delete.test_get_value(ping_name.as_deref()),
           470 => super::activity_stream::event_delete_confirm.test_get_value(ping_name.as_deref()),
           471 => super::activity_stream::event_delete_from_pocket.test_get_value(ping_name.as_deref()),
           472 => super::activity_stream::event_dialog_cancel.test_get_value(ping_name.as_deref()),
           473 => super::activity_stream::event_dialog_open.test_get_value(ping_name.as_deref()),
           474 => super::activity_stream::event_disclaimer_acked.test_get_value(ping_name.as_deref()),
           475 => super::activity_stream::event_drag.test_get_value(ping_name.as_deref()),
           476 => super::activity_stream::event_drop.test_get_value(ping_name.as_deref()),
           477 => super::activity_stream::event_fakespot_category.test_get_value(ping_name.as_deref()),
           478 => super::activity_stream::event_fakespot_click.test_get_value(ping_name.as_deref()),
           479 => super::activity_stream::event_hide_personalize.test_get_value(ping_name.as_deref()),
           480 => super::activity_stream::event_impression.test_get_value(ping_name.as_deref()),
           481 => super::activity_stream::event_menu_add_search.test_get_value(ping_name.as_deref()),
           482 => super::activity_stream::event_menu_add_topsite.test_get_value(ping_name.as_deref()),
           483 => super::activity_stream::event_menu_collapse.test_get_value(ping_name.as_deref()),
           484 => super::activity_stream::event_menu_expand.test_get_value(ping_name.as_deref()),
           485 => super::activity_stream::event_menu_manage.test_get_value(ping_name.as_deref()),
           486 => super::activity_stream::event_menu_move_down.test_get_value(ping_name.as_deref()),
           487 => super::activity_stream::event_menu_move_up.test_get_value(ping_name.as_deref()),
           488 => super::activity_stream::event_menu_privacy_notice.test_get_value(ping_name.as_deref()),
           489 => super::activity_stream::event_menu_remove.test_get_value(ping_name.as_deref()),
           490 => super::activity_stream::event_migration_cancel.test_get_value(ping_name.as_deref()),
           491 => super::activity_stream::event_migration_start.test_get_value(ping_name.as_deref()),
           492 => super::activity_stream::event_open_new_window.test_get_value(ping_name.as_deref()),
           493 => super::activity_stream::event_open_newtab_prefs.test_get_value(ping_name.as_deref()),
           494 => super::activity_stream::event_open_private_window.test_get_value(ping_name.as_deref()),
           495 => super::activity_stream::event_pin.test_get_value(ping_name.as_deref()),
           496 => super::activity_stream::event_pocket_thumbs_down.test_get_value(ping_name.as_deref()),
           497 => super::activity_stream::event_pocket_thumbs_up.test_get_value(ping_name.as_deref()),
           498 => super::activity_stream::event_pref_changed.test_get_value(ping_name.as_deref()),
           499 => super::activity_stream::event_preview_request.test_get_value(ping_name.as_deref()),
           500 => super::activity_stream::event_save_to_pocket.test_get_value(ping_name.as_deref()),
           501 => super::activity_stream::event_search.test_get_value(ping_name.as_deref()),
           502 => super::activity_stream::event_search_edit_add.test_get_value(ping_name.as_deref()),
           503 => super::activity_stream::event_search_edit_close.test_get_value(ping_name.as_deref()),
           504 => super::activity_stream::event_search_edit_delete.test_get_value(ping_name.as_deref()),
           505 => super::activity_stream::event_search_handoff.test_get_value(ping_name.as_deref()),
           506 => super::activity_stream::event_show_personalize.test_get_value(ping_name.as_deref()),
           507 => super::activity_stream::event_show_privacy_info.test_get_value(ping_name.as_deref()),
           508 => super::activity_stream::event_skipped_signin.test_get_value(ping_name.as_deref()),
           509 => super::activity_stream::event_submit_email.test_get_value(ping_name.as_deref()),
           510 => super::activity_stream::event_top_sites_edit.test_get_value(ping_name.as_deref()),
           511 => super::activity_stream::event_top_sites_edit_close.test_get_value(ping_name.as_deref()),
           512 => super::activity_stream::event_topsite_sponsor_info.test_get_value(ping_name.as_deref()),
           513 => super::activity_stream::event_unpin.test_get_value(ping_name.as_deref()),
           521 => super::newtab::closed.test_get_value(ping_name.as_deref()),
           522 => super::newtab::fakespot_about_click.test_get_value(ping_name.as_deref()),
           523 => super::newtab::fakespot_category.test_get_value(ping_name.as_deref()),
           524 => super::newtab::fakespot_click.test_get_value(ping_name.as_deref()),
           525 => super::newtab::fakespot_cta_click.test_get_value(ping_name.as_deref()),
           526 => super::newtab::fakespot_dismiss.test_get_value(ping_name.as_deref()),
           527 => super::newtab::fakespot_product_impression.test_get_value(ping_name.as_deref()),
           529 => super::newtab::inline_selection_click.test_get_value(ping_name.as_deref()),
           530 => super::newtab::inline_selection_impression.test_get_value(ping_name.as_deref()),
           534 => super::newtab::opened.test_get_value(ping_name.as_deref()),
           536 => super::newtab::report_content_open.test_get_value(ping_name.as_deref()),
           537 => super::newtab::report_content_submit.test_get_value(ping_name.as_deref()),
           538 => super::newtab::sections_block_section.test_get_value(ping_name.as_deref()),
           539 => super::newtab::sections_follow_section.test_get_value(ping_name.as_deref()),
           540 => super::newtab::sections_impression.test_get_value(ping_name.as_deref()),
           541 => super::newtab::sections_unblock_section.test_get_value(ping_name.as_deref()),
           542 => super::newtab::sections_unfollow_section.test_get_value(ping_name.as_deref()),
           545 => super::newtab::tooltip_click.test_get_value(ping_name.as_deref()),
           546 => super::newtab::topic_selection_dismiss.test_get_value(ping_name.as_deref()),
           547 => super::newtab::topic_selection_open.test_get_value(ping_name.as_deref()),
           548 => super::newtab::topic_selection_topics_saved.test_get_value(ping_name.as_deref()),
           549 => super::newtab::wallpaper_category_click.test_get_value(ping_name.as_deref()),
           550 => super::newtab::wallpaper_click.test_get_value(ping_name.as_deref()),
           551 => super::newtab::wallpaper_highlight_cta_click.test_get_value(ping_name.as_deref()),
           552 => super::newtab::wallpaper_highlight_dismissed.test_get_value(ping_name.as_deref()),
           553 => super::newtab::weather_change_display.test_get_value(ping_name.as_deref()),
           555 => super::newtab::weather_impression.test_get_value(ping_name.as_deref()),
           556 => super::newtab::weather_load_error.test_get_value(ping_name.as_deref()),
           557 => super::newtab::weather_location_selected.test_get_value(ping_name.as_deref()),
           558 => super::newtab::weather_open_provider_url.test_get_value(ping_name.as_deref()),
           561 => super::newtab_search::issued.test_get_value(ping_name.as_deref()),
           564 => super::newtab_content::click.test_get_value(ping_name.as_deref()),
           567 => super::newtab_content::dismiss.test_get_value(ping_name.as_deref()),
           570 => super::newtab_content::impression.test_get_value(ping_name.as_deref()),
           571 => super::newtab_content::sections_block_section.test_get_value(ping_name.as_deref()),
           572 => super::newtab_content::sections_follow_section.test_get_value(ping_name.as_deref()),
           573 => super::newtab_content::sections_impression.test_get_value(ping_name.as_deref()),
           574 => super::newtab_content::sections_unblock_section.test_get_value(ping_name.as_deref()),
           575 => super::newtab_content::sections_unfollow_section.test_get_value(ping_name.as_deref()),
           577 => super::newtab_content::thumb_voting_interaction.test_get_value(ping_name.as_deref()),
           579 => super::pocket::click.test_get_value(ping_name.as_deref()),
           580 => super::pocket::dismiss.test_get_value(ping_name.as_deref()),
           583 => super::pocket::impression.test_get_value(ping_name.as_deref()),
           586 => super::pocket::save.test_get_value(ping_name.as_deref()),
           589 => super::pocket::thumb_voting_interaction.test_get_value(ping_name.as_deref()),
           590 => super::pocket::topic_click.test_get_value(ping_name.as_deref()),
           598 => super::topsites::click.test_get_value(ping_name.as_deref()),
           599 => super::topsites::dismiss.test_get_value(ping_name.as_deref()),
           601 => super::topsites::impression.test_get_value(ping_name.as_deref()),
           602 => super::topsites::pref_changed.test_get_value(ping_name.as_deref()),
           604 => super::topsites::show_privacy_click.test_get_value(ping_name.as_deref()),
           627 => super::aboutpreferences::show_click.test_get_value(ping_name.as_deref()),
           628 => super::aboutpreferences::show_hash.test_get_value(ping_name.as_deref()),
           629 => super::aboutpreferences::show_initial.test_get_value(ping_name.as_deref()),
           630 => super::intl_ui_browser_language::accept_dialog.test_get_value(ping_name.as_deref()),
           631 => super::intl_ui_browser_language::add_dialog.test_get_value(ping_name.as_deref()),
           632 => super::intl_ui_browser_language::apply_main.test_get_value(ping_name.as_deref()),
           633 => super::intl_ui_browser_language::cancel_dialog.test_get_value(ping_name.as_deref()),
           634 => super::intl_ui_browser_language::manage_main.test_get_value(ping_name.as_deref()),
           635 => super::intl_ui_browser_language::remove_dialog.test_get_value(ping_name.as_deref()),
           636 => super::intl_ui_browser_language::reorder_dialog.test_get_value(ping_name.as_deref()),
           637 => super::intl_ui_browser_language::reorder_main.test_get_value(ping_name.as_deref()),
           638 => super::intl_ui_browser_language::search_dialog.test_get_value(ping_name.as_deref()),
           639 => super::intl_ui_browser_language::search_main.test_get_value(ping_name.as_deref()),
           640 => super::intl_ui_browser_language::set_fallback_dialog.test_get_value(ping_name.as_deref()),
           641 => super::network_proxy_settings::proxy_type_preference.test_get_value(ping_name.as_deref()),
           642 => super::privacy_ui_fpp_click::checkbox.test_get_value(ping_name.as_deref()),
           643 => super::privacy_ui_fpp_click::menu.test_get_value(ping_name.as_deref()),
           644 => super::security_doh_settings::mode_changed_button.test_get_value(ping_name.as_deref()),
           645 => super::security_doh_settings::provider_choice_value.test_get_value(ping_name.as_deref()),
           646 => super::aboutprivatebrowsing::click_dismiss_button.test_get_value(ping_name.as_deref()),
           647 => super::aboutprivatebrowsing::click_info_link.test_get_value(ping_name.as_deref()),
           648 => super::aboutprivatebrowsing::click_promo_link.test_get_value(ping_name.as_deref()),
           649 => super::private_browsing_reset_pbm::confirm_panel.test_get_value(ping_name.as_deref()),
           650 => super::private_browsing_reset_pbm::reset_action.test_get_value(ping_name.as_deref()),
           651 => super::profiles_default::updated.test_get_value(ping_name.as_deref()),
           652 => super::profiles_delete::cancel.test_get_value(ping_name.as_deref()),
           653 => super::profiles_delete::confirm.test_get_value(ping_name.as_deref()),
           654 => super::profiles_delete::displayed.test_get_value(ping_name.as_deref()),
           655 => super::profiles_existing::alert.test_get_value(ping_name.as_deref()),
           656 => super::profiles_existing::avatar.test_get_value(ping_name.as_deref()),
           657 => super::profiles_existing::closed.test_get_value(ping_name.as_deref()),
           658 => super::profiles_existing::deleted.test_get_value(ping_name.as_deref()),
           659 => super::profiles_existing::displayed.test_get_value(ping_name.as_deref()),
           660 => super::profiles_existing::learn_more.test_get_value(ping_name.as_deref()),
           661 => super::profiles_existing::name.test_get_value(ping_name.as_deref()),
           662 => super::profiles_existing::theme.test_get_value(ping_name.as_deref()),
           663 => super::profiles_new::alert.test_get_value(ping_name.as_deref()),
           664 => super::profiles_new::avatar.test_get_value(ping_name.as_deref()),
           665 => super::profiles_new::closed.test_get_value(ping_name.as_deref()),
           666 => super::profiles_new::deleted.test_get_value(ping_name.as_deref()),
           667 => super::profiles_new::displayed.test_get_value(ping_name.as_deref()),
           668 => super::profiles_new::learn_more.test_get_value(ping_name.as_deref()),
           669 => super::profiles_new::name.test_get_value(ping_name.as_deref()),
           670 => super::profiles_new::theme.test_get_value(ping_name.as_deref()),
           671 => super::profiles_selector_window::launch.test_get_value(ping_name.as_deref()),
           672 => super::profiles_selector_window::show_at_startup.test_get_value(ping_name.as_deref()),
           673 => super::security_ui_protections::click_lw_about_link.test_get_value(ping_name.as_deref()),
           674 => super::security_ui_protections::click_lw_open_button.test_get_value(ping_name.as_deref()),
           675 => super::security_ui_protections::click_lw_sync_link.test_get_value(ping_name.as_deref()),
           676 => super::security_ui_protections::click_mobile_app_link.test_get_value(ping_name.as_deref()),
           677 => super::security_ui_protections::click_mtr_about_link.test_get_value(ping_name.as_deref()),
           678 => super::security_ui_protections::click_mtr_report_link.test_get_value(ping_name.as_deref()),
           679 => super::security_ui_protections::click_mtr_signup_button.test_get_value(ping_name.as_deref()),
           680 => super::security_ui_protections::click_settings_link.test_get_value(ping_name.as_deref()),
           681 => super::security_ui_protections::click_trackers_about_link.test_get_value(ping_name.as_deref()),
           682 => super::security_ui_protections::click_vpn_app_link_android.test_get_value(ping_name.as_deref()),
           683 => super::security_ui_protections::click_vpn_app_link_ios.test_get_value(ping_name.as_deref()),
           684 => super::security_ui_protections::click_vpn_banner_close.test_get_value(ping_name.as_deref()),
           685 => super::security_ui_protections::click_vpn_banner_link.test_get_value(ping_name.as_deref()),
           686 => super::security_ui_protections::click_vpn_card_link.test_get_value(ping_name.as_deref()),
           687 => super::security_ui_protections::close_protection_report.test_get_value(ping_name.as_deref()),
           688 => super::security_ui_protections::show_protection_report.test_get_value(ping_name.as_deref()),
           689 => super::security_ui_protections::show_vpn_banner.test_get_value(ping_name.as_deref()),
           692 => super::protocolhandler_mailto::visit.test_get_value(ping_name.as_deref()),
           693 => super::screenshots::canceled_context_menu.test_get_value(ping_name.as_deref()),
           694 => super::screenshots::canceled_escape.test_get_value(ping_name.as_deref()),
           695 => super::screenshots::canceled_navigation.test_get_value(ping_name.as_deref()),
           696 => super::screenshots::canceled_overlay_cancel.test_get_value(ping_name.as_deref()),
           697 => super::screenshots::canceled_preview_cancel.test_get_value(ping_name.as_deref()),
           698 => super::screenshots::canceled_quick_actions.test_get_value(ping_name.as_deref()),
           699 => super::screenshots::canceled_shortcut.test_get_value(ping_name.as_deref()),
           700 => super::screenshots::canceled_toolbar_button.test_get_value(ping_name.as_deref()),
           701 => super::screenshots::copy_overlay_copy.test_get_value(ping_name.as_deref()),
           702 => super::screenshots::copy_preview_copy.test_get_value(ping_name.as_deref()),
           703 => super::screenshots::download_overlay_download.test_get_value(ping_name.as_deref()),
           704 => super::screenshots::download_preview_download.test_get_value(ping_name.as_deref()),
           705 => super::screenshots::failed_screenshot_too_large.test_get_value(ping_name.as_deref()),
           706 => super::screenshots::selected_element.test_get_value(ping_name.as_deref()),
           707 => super::screenshots::selected_full_page.test_get_value(ping_name.as_deref()),
           708 => super::screenshots::selected_region_selection.test_get_value(ping_name.as_deref()),
           709 => super::screenshots::selected_visible.test_get_value(ping_name.as_deref()),
           710 => super::screenshots::started_context_menu.test_get_value(ping_name.as_deref()),
           711 => super::screenshots::started_overlay_retry.test_get_value(ping_name.as_deref()),
           712 => super::screenshots::started_preview_retry.test_get_value(ping_name.as_deref()),
           713 => super::screenshots::started_quick_actions.test_get_value(ping_name.as_deref()),
           714 => super::screenshots::started_shortcut.test_get_value(ping_name.as_deref()),
           715 => super::screenshots::started_toolbar_button.test_get_value(ping_name.as_deref()),
           764 => super::newtab_search_ad::click.test_get_value(ping_name.as_deref()),
           765 => super::newtab_search_ad::impression.test_get_value(ping_name.as_deref()),
           766 => super::sap::counts.test_get_value(ping_name.as_deref()),
           768 => super::sap::search_form_counts.test_get_value(ping_name.as_deref()),
           772 => super::serp::abandonment.test_get_value(ping_name.as_deref()),
           773 => super::serp::ad_impression.test_get_value(ping_name.as_deref()),
           775 => super::serp::categorization.test_get_value(ping_name.as_deref()),
           778 => super::serp::engagement.test_get_value(ping_name.as_deref()),
           780 => super::serp::impression.test_get_value(ping_name.as_deref()),
           798 => super::session_restore::backup_can_be_loaded_session_file.test_get_value(ping_name.as_deref()),
           811 => super::session_restore::shutdown_success_session_startup.test_get_value(ping_name.as_deref()),
           815 => super::shopping::address_bar_feature_callout_displayed.test_get_value(ping_name.as_deref()),
           816 => super::shopping::address_bar_icon_clicked.test_get_value(ping_name.as_deref()),
           817 => super::shopping::address_bar_icon_displayed.test_get_value(ping_name.as_deref()),
           819 => super::shopping::surface_ads_clicked.test_get_value(ping_name.as_deref()),
           820 => super::shopping::surface_ads_impression.test_get_value(ping_name.as_deref()),
           821 => super::shopping::surface_ads_placement.test_get_value(ping_name.as_deref()),
           822 => super::shopping::surface_ads_setting_toggled.test_get_value(ping_name.as_deref()),
           823 => super::shopping::surface_analyze_reviews_none_available_clicked.test_get_value(ping_name.as_deref()),
           824 => super::shopping::surface_auto_open_setting_toggled.test_get_value(ping_name.as_deref()),
           825 => super::shopping::surface_closed.test_get_value(ping_name.as_deref()),
           826 => super::shopping::surface_displayed.test_get_value(ping_name.as_deref()),
           827 => super::shopping::surface_learn_more_clicked.test_get_value(ping_name.as_deref()),
           828 => super::shopping::surface_no_ads_available.test_get_value(ping_name.as_deref()),
           829 => super::shopping::surface_no_review_reliability_available.test_get_value(ping_name.as_deref()),
           830 => super::shopping::surface_no_thanks_button_clicked.test_get_value(ping_name.as_deref()),
           831 => super::shopping::surface_not_now_clicked.test_get_value(ping_name.as_deref()),
           832 => super::shopping::surface_notification_card_dismiss_clicked.test_get_value(ping_name.as_deref()),
           833 => super::shopping::surface_notification_card_impression.test_get_value(ping_name.as_deref()),
           834 => super::shopping::surface_notification_card_move_left_clicked.test_get_value(ping_name.as_deref()),
           835 => super::shopping::surface_notification_card_move_right_clicked.test_get_value(ping_name.as_deref()),
           836 => super::shopping::surface_notification_card_sidebar_settings_clicked.test_get_value(ping_name.as_deref()),
           837 => super::shopping::surface_onboarding_displayed.test_get_value(ping_name.as_deref()),
           838 => super::shopping::surface_opt_in_clicked.test_get_value(ping_name.as_deref()),
           839 => super::shopping::surface_opt_out_button_clicked.test_get_value(ping_name.as_deref()),
           840 => super::shopping::surface_powered_by_fakespot_link_clicked.test_get_value(ping_name.as_deref()),
           841 => super::shopping::surface_reactivated_button_clicked.test_get_value(ping_name.as_deref()),
           842 => super::shopping::surface_reanalyze_clicked.test_get_value(ping_name.as_deref()),
           843 => super::shopping::surface_settings_expand_clicked.test_get_value(ping_name.as_deref()),
           844 => super::shopping::surface_show_more_reviews_button_clicked.test_get_value(ping_name.as_deref()),
           845 => super::shopping::surface_show_privacy_policy_clicked.test_get_value(ping_name.as_deref()),
           846 => super::shopping::surface_show_quality_explainer_clicked.test_get_value(ping_name.as_deref()),
           847 => super::shopping::surface_show_quality_explainer_url_clicked.test_get_value(ping_name.as_deref()),
           848 => super::shopping::surface_show_terms_clicked.test_get_value(ping_name.as_deref()),
           849 => super::shopping::surface_stale_analysis_shown.test_get_value(ping_name.as_deref()),
           850 => super::shopping::surface_yes_keep_closed_button_clicked.test_get_value(ping_name.as_deref()),
           851 => super::shopping::sidebar_toggle.test_get_value(ping_name.as_deref()),
           857 => super::bookmarks::sidebar_toggle.test_get_value(ping_name.as_deref()),
           858 => super::contextual_manager::passwords_enabled.test_get_value(ping_name.as_deref()),
           859 => super::contextual_manager::sidebar_toggle.test_get_value(ping_name.as_deref()),
           860 => super::contextual_manager::notification_interaction.test_get_value(ping_name.as_deref()),
           861 => super::contextual_manager::notification_shown.test_get_value(ping_name.as_deref()),
           862 => super::contextual_manager::records_interaction.test_get_value(ping_name.as_deref()),
           863 => super::contextual_manager::records_update.test_get_value(ping_name.as_deref()),
           864 => super::contextual_manager::toolbar_action.test_get_value(ping_name.as_deref()),
           865 => super::extension::sidebar_toggle.test_get_value(ping_name.as_deref()),
           866 => super::history::sidebar_toggle.test_get_value(ping_name.as_deref()),
           867 => super::sidebar::addon_icon_click.test_get_value(ping_name.as_deref()),
           868 => super::sidebar::bookmarks_icon_click.test_get_value(ping_name.as_deref()),
           869 => super::sidebar::chatbot_icon_click.test_get_value(ping_name.as_deref()),
           871 => super::sidebar::expand.test_get_value(ping_name.as_deref()),
           872 => super::sidebar::history_icon_click.test_get_value(ping_name.as_deref()),
           873 => super::sidebar::keyboard_shortcut.test_get_value(ping_name.as_deref()),
           876 => super::sidebar::resize.test_get_value(ping_name.as_deref()),
           878 => super::sidebar::shopping_review_checker_icon_click.test_get_value(ping_name.as_deref()),
           879 => super::sidebar::synced_tabs_icon_click.test_get_value(ping_name.as_deref()),
           882 => super::sidebar_customize::bookmarks_enabled.test_get_value(ping_name.as_deref()),
           883 => super::sidebar_customize::chatbot_enabled.test_get_value(ping_name.as_deref()),
           884 => super::sidebar_customize::expand_on_hover_enabled.test_get_value(ping_name.as_deref()),
           885 => super::sidebar_customize::extensions_clicked.test_get_value(ping_name.as_deref()),
           886 => super::sidebar_customize::firefox_settings_clicked.test_get_value(ping_name.as_deref()),
           887 => super::sidebar_customize::history_enabled.test_get_value(ping_name.as_deref()),
           888 => super::sidebar_customize::icon_click.test_get_value(ping_name.as_deref()),
           889 => super::sidebar_customize::panel_toggle.test_get_value(ping_name.as_deref()),
           890 => super::sidebar_customize::shopping_review_checker_enabled.test_get_value(ping_name.as_deref()),
           891 => super::sidebar_customize::sidebar_display.test_get_value(ping_name.as_deref()),
           892 => super::sidebar_customize::sidebar_position.test_get_value(ping_name.as_deref()),
           893 => super::sidebar_customize::synced_tabs_enabled.test_get_value(ping_name.as_deref()),
           894 => super::sidebar_customize::tabs_display.test_get_value(ping_name.as_deref()),
           895 => super::sidebar_customize::tabs_layout.test_get_value(ping_name.as_deref()),
           896 => super::synced_tabs::sidebar_toggle.test_get_value(ping_name.as_deref()),
           897 => super::synced_tabs::click_fxa_app_menu.test_get_value(ping_name.as_deref()),
           898 => super::synced_tabs::click_fxa_avatar_menu.test_get_value(ping_name.as_deref()),
           899 => super::synced_tabs::click_synced_tabs_sidebar.test_get_value(ping_name.as_deref()),
           936 => super::tabgroup::add_tab.test_get_value(ping_name.as_deref()),
           937 => super::tabgroup::create_group.test_get_value(ping_name.as_deref()),
           938 => super::tabgroup::delete.test_get_value(ping_name.as_deref()),
           940 => super::tabgroup::reopen.test_get_value(ping_name.as_deref()),
           941 => super::tabgroup::save.test_get_value(ping_name.as_deref()),
           943 => super::tabgroup::smart_tab.test_get_value(ping_name.as_deref()),
           945 => super::tabgroup::smart_tab_optin.test_get_value(ping_name.as_deref()),
           946 => super::tabgroup::smart_tab_suggest.test_get_value(ping_name.as_deref()),
           947 => super::tabgroup::smart_tab_topic.test_get_value(ping_name.as_deref()),
           952 => super::tabgroup::ungroup.test_get_value(ping_name.as_deref()),
           975 => super::urlbar::abandonment.test_get_value(ping_name.as_deref()),
           979 => super::urlbar::engagement.test_get_value(ping_name.as_deref()),
           980 => super::urlbar::exposure.test_get_value(ping_name.as_deref()),
           981 => super::urlbar::fakespot_engagement.test_get_value(ping_name.as_deref()),
           982 => super::urlbar::keyword_exposure.test_get_value(ping_name.as_deref()),
           988 => super::urlbar::quick_suggest_contextual_opt_in.test_get_value(ping_name.as_deref()),
           998 => super::addons_search_detection::etld_change_other.test_get_value(ping_name.as_deref()),
           999 => super::addons_search_detection::etld_change_webrequest.test_get_value(ping_name.as_deref()),
           1014 => super::browser_usage::interaction.test_get_value(ping_name.as_deref()),
           1015 => super::homepage::preference_ignore.test_get_value(ping_name.as_deref()),
           1016 => super::installation::first_seen_full.test_get_value(ping_name.as_deref()),
           1017 => super::installation::first_seen_msix.test_get_value(ping_name.as_deref()),
           1018 => super::installation::first_seen_stub.test_get_value(ping_name.as_deref()),
           1032 => super::partner_link::attribution_abort.test_get_value(ping_name.as_deref()),
           1033 => super::partner_link::attribution_failure.test_get_value(ping_name.as_deref()),
           1034 => super::partner_link::attribution_success.test_get_value(ping_name.as_deref()),
           1035 => super::partner_link::click_newtab.test_get_value(ping_name.as_deref()),
           1036 => super::partner_link::click_urlbar.test_get_value(ping_name.as_deref()),
           1135 => super::devtools_main::activate_responsive_design.test_get_value(ping_name.as_deref()),
           1136 => super::devtools_main::activate_split_console.test_get_value(ping_name.as_deref()),
           1137 => super::devtools_main::add_breakpoint_debugger.test_get_value(ping_name.as_deref()),
           1138 => super::devtools_main::blackbox_debugger.test_get_value(ping_name.as_deref()),
           1139 => super::devtools_main::close_adbg_aboutdebugging.test_get_value(ping_name.as_deref()),
           1140 => super::devtools_main::close_tools.test_get_value(ping_name.as_deref()),
           1141 => super::devtools_main::connection_attempt_aboutdebugging.test_get_value(ping_name.as_deref()),
           1142 => super::devtools_main::continue_debugger.test_get_value(ping_name.as_deref()),
           1143 => super::devtools_main::deactivate_responsive_design.test_get_value(ping_name.as_deref()),
           1144 => super::devtools_main::deactivate_split_console.test_get_value(ping_name.as_deref()),
           1145 => super::devtools_main::device_added_aboutdebugging.test_get_value(ping_name.as_deref()),
           1146 => super::devtools_main::device_removed_aboutdebugging.test_get_value(ping_name.as_deref()),
           1147 => super::devtools_main::edit_html_inspector.test_get_value(ping_name.as_deref()),
           1148 => super::devtools_main::edit_resend_netmonitor.test_get_value(ping_name.as_deref()),
           1149 => super::devtools_main::edit_rule_ruleview.test_get_value(ping_name.as_deref()),
           1150 => super::devtools_main::enter_accessibility.test_get_value(ping_name.as_deref()),
           1151 => super::devtools_main::enter_application.test_get_value(ping_name.as_deref()),
           1152 => super::devtools_main::enter_dom.test_get_value(ping_name.as_deref()),
           1153 => super::devtools_main::enter_fake_tool4242.test_get_value(ping_name.as_deref()),
           1154 => super::devtools_main::enter_inspector.test_get_value(ping_name.as_deref()),
           1155 => super::devtools_main::enter_jsdebugger.test_get_value(ping_name.as_deref()),
           1156 => super::devtools_main::enter_memory.test_get_value(ping_name.as_deref()),
           1157 => super::devtools_main::enter_netmonitor.test_get_value(ping_name.as_deref()),
           1158 => super::devtools_main::enter_options.test_get_value(ping_name.as_deref()),
           1159 => super::devtools_main::enter_other.test_get_value(ping_name.as_deref()),
           1160 => super::devtools_main::enter_performance.test_get_value(ping_name.as_deref()),
           1161 => super::devtools_main::enter_storage.test_get_value(ping_name.as_deref()),
           1162 => super::devtools_main::enter_styleeditor.test_get_value(ping_name.as_deref()),
           1163 => super::devtools_main::enter_test_blank_panel.test_get_value(ping_name.as_deref()),
           1164 => super::devtools_main::enter_test_tool.test_get_value(ping_name.as_deref()),
           1165 => super::devtools_main::enter_test_tool1072208.test_get_value(ping_name.as_deref()),
           1166 => super::devtools_main::enter_testtool1.test_get_value(ping_name.as_deref()),
           1167 => super::devtools_main::enter_testtool2.test_get_value(ping_name.as_deref()),
           1168 => super::devtools_main::enter_webconsole.test_get_value(ping_name.as_deref()),
           1169 => super::devtools_main::enter_whatsnew.test_get_value(ping_name.as_deref()),
           1170 => super::devtools_main::execute_js_webconsole.test_get_value(ping_name.as_deref()),
           1171 => super::devtools_main::exit_accessibility.test_get_value(ping_name.as_deref()),
           1172 => super::devtools_main::exit_application.test_get_value(ping_name.as_deref()),
           1173 => super::devtools_main::exit_dom.test_get_value(ping_name.as_deref()),
           1174 => super::devtools_main::exit_fake_tool4242.test_get_value(ping_name.as_deref()),
           1175 => super::devtools_main::exit_inspector.test_get_value(ping_name.as_deref()),
           1176 => super::devtools_main::exit_jsdebugger.test_get_value(ping_name.as_deref()),
           1177 => super::devtools_main::exit_memory.test_get_value(ping_name.as_deref()),
           1178 => super::devtools_main::exit_netmonitor.test_get_value(ping_name.as_deref()),
           1179 => super::devtools_main::exit_options.test_get_value(ping_name.as_deref()),
           1180 => super::devtools_main::exit_other.test_get_value(ping_name.as_deref()),
           1181 => super::devtools_main::exit_performance.test_get_value(ping_name.as_deref()),
           1182 => super::devtools_main::exit_storage.test_get_value(ping_name.as_deref()),
           1183 => super::devtools_main::exit_styleeditor.test_get_value(ping_name.as_deref()),
           1184 => super::devtools_main::exit_test_blank_panel.test_get_value(ping_name.as_deref()),
           1185 => super::devtools_main::exit_test_tool.test_get_value(ping_name.as_deref()),
           1186 => super::devtools_main::exit_test_tool1072208.test_get_value(ping_name.as_deref()),
           1187 => super::devtools_main::exit_testtool1.test_get_value(ping_name.as_deref()),
           1188 => super::devtools_main::exit_testtool2.test_get_value(ping_name.as_deref()),
           1189 => super::devtools_main::exit_webconsole.test_get_value(ping_name.as_deref()),
           1190 => super::devtools_main::exit_whatsnew.test_get_value(ping_name.as_deref()),
           1191 => super::devtools_main::filters_changed_netmonitor.test_get_value(ping_name.as_deref()),
           1192 => super::devtools_main::filters_changed_webconsole.test_get_value(ping_name.as_deref()),
           1193 => super::devtools_main::inspect_aboutdebugging.test_get_value(ping_name.as_deref()),
           1194 => super::devtools_main::jump_to_definition_webconsole.test_get_value(ping_name.as_deref()),
           1195 => super::devtools_main::jump_to_source_webconsole.test_get_value(ping_name.as_deref()),
           1196 => super::devtools_main::object_expanded_webconsole.test_get_value(ping_name.as_deref()),
           1197 => super::devtools_main::open_adbg_aboutdebugging.test_get_value(ping_name.as_deref()),
           1198 => super::devtools_main::open_tools.test_get_value(ping_name.as_deref()),
           1199 => super::devtools_main::pause_debugger.test_get_value(ping_name.as_deref()),
           1200 => super::devtools_main::pause_on_exceptions_debugger.test_get_value(ping_name.as_deref()),
           1201 => super::devtools_main::persist_changed_netmonitor.test_get_value(ping_name.as_deref()),
           1202 => super::devtools_main::persist_changed_webconsole.test_get_value(ping_name.as_deref()),
           1203 => super::devtools_main::pretty_print_debugger.test_get_value(ping_name.as_deref()),
           1204 => super::devtools_main::remove_breakpoint_debugger.test_get_value(ping_name.as_deref()),
           1205 => super::devtools_main::reverse_search_webconsole.test_get_value(ping_name.as_deref()),
           1206 => super::devtools_main::runtime_added_aboutdebugging.test_get_value(ping_name.as_deref()),
           1207 => super::devtools_main::runtime_connected_aboutdebugging.test_get_value(ping_name.as_deref()),
           1208 => super::devtools_main::runtime_disconnected_aboutdebugging.test_get_value(ping_name.as_deref()),
           1209 => super::devtools_main::runtime_removed_aboutdebugging.test_get_value(ping_name.as_deref()),
           1210 => super::devtools_main::select_page_aboutdebugging.test_get_value(ping_name.as_deref()),
           1211 => super::devtools_main::select_page_application.test_get_value(ping_name.as_deref()),
           1212 => super::devtools_main::select_ws_frame_netmonitor.test_get_value(ping_name.as_deref()),
           1213 => super::devtools_main::show_profiler_aboutdebugging.test_get_value(ping_name.as_deref()),
           1214 => super::devtools_main::sidepanel_changed_inspector.test_get_value(ping_name.as_deref()),
           1215 => super::devtools_main::sidepanel_changed_netmonitor.test_get_value(ping_name.as_deref()),
           1216 => super::devtools_main::start_worker_application.test_get_value(ping_name.as_deref()),
           1217 => super::devtools_main::throttle_changed_netmonitor.test_get_value(ping_name.as_deref()),
           1218 => super::devtools_main::tool_timer_animationinspector.test_get_value(ping_name.as_deref()),
           1219 => super::devtools_main::tool_timer_changesview.test_get_value(ping_name.as_deref()),
           1220 => super::devtools_main::tool_timer_compatibilityview.test_get_value(ping_name.as_deref()),
           1221 => super::devtools_main::tool_timer_computedview.test_get_value(ping_name.as_deref()),
           1222 => super::devtools_main::tool_timer_fontinspector.test_get_value(ping_name.as_deref()),
           1223 => super::devtools_main::tool_timer_layoutview.test_get_value(ping_name.as_deref()),
           1224 => super::devtools_main::tool_timer_ruleview.test_get_value(ping_name.as_deref()),
           1225 => super::devtools_main::unregister_worker_application.test_get_value(ping_name.as_deref()),
           1226 => super::devtools_main::update_conn_prompt_aboutdebugging.test_get_value(ping_name.as_deref()),
           3656 => super::mediadrm::eme_playback.test_get_value(ping_name.as_deref()),
           3659 => super::hls::media_load.test_get_value(ping_name.as_deref()),
           3664 => super::media::error.test_get_value(ping_name.as_deref()),
           3686 => super::media_playback::decode_error.test_get_value(ping_name.as_deref()),
           3688 => super::media_playback::first_frame_loaded.test_get_value(ping_name.as_deref()),
           3693 => super::mfcdm::eme_playback.test_get_value(ping_name.as_deref()),
           3694 => super::mfcdm::error.test_get_value(ping_name.as_deref()),
           3749 => super::webrtc_signaling::audio_msection_negotiated.test_get_value(ping_name.as_deref()),
           3750 => super::webrtc_signaling::sdp_negotiated.test_get_value(ping_name.as_deref()),
           3751 => super::webrtc_signaling::video_msection_negotiated.test_get_value(ping_name.as_deref()),
           3802 => super::perf::page_load.test_get_value(ping_name.as_deref()),
           3835 => super::dom_quota_try::error_step.test_get_value(ping_name.as_deref()),
           3984 => super::avif::dav1d_get_picture_return_value.test_get_value(ping_name.as_deref()),
           4063 => super::slow_script_warning::shown_browser.test_get_value(ping_name.as_deref()),
           4064 => super::slow_script_warning::shown_content.test_get_value(ping_name.as_deref()),
           4083 => super::zero_byte_load::load_css.test_get_value(ping_name.as_deref()),
           4084 => super::zero_byte_load::load_dtd.test_get_value(ping_name.as_deref()),
           4085 => super::zero_byte_load::load_ftl.test_get_value(ping_name.as_deref()),
           4086 => super::zero_byte_load::load_html.test_get_value(ping_name.as_deref()),
           4087 => super::zero_byte_load::load_js.test_get_value(ping_name.as_deref()),
           4088 => super::zero_byte_load::load_json.test_get_value(ping_name.as_deref()),
           4089 => super::zero_byte_load::load_others.test_get_value(ping_name.as_deref()),
           4090 => super::zero_byte_load::load_png.test_get_value(ping_name.as_deref()),
           4091 => super::zero_byte_load::load_properties.test_get_value(ping_name.as_deref()),
           4092 => super::zero_byte_load::load_svg.test_get_value(ping_name.as_deref()),
           4093 => super::zero_byte_load::load_xhtml.test_get_value(ping_name.as_deref()),
           4094 => super::zero_byte_load::load_xml.test_get_value(ping_name.as_deref()),
           4207 => super::network_dns::trr_confirmation_context.test_get_value(ping_name.as_deref()),
           4325 => super::ysod::shown_ysod.test_get_value(ping_name.as_deref()),
           4411 => super::uptake_remotecontent_result::uptake_normandy.test_get_value(ping_name.as_deref()),
           4412 => super::uptake_remotecontent_result::uptake_remotesettings.test_get_value(ping_name.as_deref()),
           4415 => super::fxa::connect_account.test_get_value(ping_name.as_deref()),
           4416 => super::fxa::disconnect_account.test_get_value(ping_name.as_deref()),
           4417 => super::sync_settings::open_choose_what_to_sync_menu.test_get_value(ping_name.as_deref()),
           4418 => super::sync_settings::save.test_get_value(ping_name.as_deref()),
           4419 => super::fxa_app_menu::click_account_settings.test_get_value(ping_name.as_deref()),
           4420 => super::fxa_app_menu::click_cad.test_get_value(ping_name.as_deref()),
           4421 => super::fxa_app_menu::click_login.test_get_value(ping_name.as_deref()),
           4422 => super::fxa_app_menu::click_monitor_cta.test_get_value(ping_name.as_deref()),
           4423 => super::fxa_app_menu::click_open_monitor.test_get_value(ping_name.as_deref()),
           4424 => super::fxa_app_menu::click_open_send.test_get_value(ping_name.as_deref()),
           4425 => super::fxa_app_menu::click_relay_cta.test_get_value(ping_name.as_deref()),
           4426 => super::fxa_app_menu::click_send_tab.test_get_value(ping_name.as_deref()),
           4427 => super::fxa_app_menu::click_sync_cta.test_get_value(ping_name.as_deref()),
           4428 => super::fxa_app_menu::click_sync_now.test_get_value(ping_name.as_deref()),
           4429 => super::fxa_app_menu::click_sync_settings.test_get_value(ping_name.as_deref()),
           4430 => super::fxa_app_menu::click_sync_tabs.test_get_value(ping_name.as_deref()),
           4431 => super::fxa_app_menu::click_sync_tabs_sidebar.test_get_value(ping_name.as_deref()),
           4432 => super::fxa_app_menu::click_toolbar_icon.test_get_value(ping_name.as_deref()),
           4433 => super::fxa_app_menu::click_unver_sync_settings.test_get_value(ping_name.as_deref()),
           4434 => super::fxa_app_menu::click_vpn_cta.test_get_value(ping_name.as_deref()),
           4435 => super::fxa_avatar_menu::click_account_settings.test_get_value(ping_name.as_deref()),
           4436 => super::fxa_avatar_menu::click_cad.test_get_value(ping_name.as_deref()),
           4437 => super::fxa_avatar_menu::click_login.test_get_value(ping_name.as_deref()),
           4438 => super::fxa_avatar_menu::click_monitor_cta.test_get_value(ping_name.as_deref()),
           4439 => super::fxa_avatar_menu::click_open_monitor.test_get_value(ping_name.as_deref()),
           4440 => super::fxa_avatar_menu::click_open_send.test_get_value(ping_name.as_deref()),
           4441 => super::fxa_avatar_menu::click_relay_cta.test_get_value(ping_name.as_deref()),
           4442 => super::fxa_avatar_menu::click_send_tab.test_get_value(ping_name.as_deref()),
           4443 => super::fxa_avatar_menu::click_sync_cta.test_get_value(ping_name.as_deref()),
           4444 => super::fxa_avatar_menu::click_sync_now.test_get_value(ping_name.as_deref()),
           4445 => super::fxa_avatar_menu::click_sync_settings.test_get_value(ping_name.as_deref()),
           4446 => super::fxa_avatar_menu::click_sync_tabs.test_get_value(ping_name.as_deref()),
           4447 => super::fxa_avatar_menu::click_sync_tabs_sidebar.test_get_value(ping_name.as_deref()),
           4448 => super::fxa_avatar_menu::click_toolbar_icon.test_get_value(ping_name.as_deref()),
           4449 => super::fxa_avatar_menu::click_unver_sync_settings.test_get_value(ping_name.as_deref()),
           4450 => super::fxa_avatar_menu::click_vpn_cta.test_get_value(ping_name.as_deref()),
           4453 => super::sync_merge_dialog::clicked.test_get_value(ping_name.as_deref()),
           4457 => super::bounce_tracking_protection::purge_action.test_get_value(ping_name.as_deref()),
           4490 => super::background_tasks_rmdir_base::metric_base.test_get_value(ping_name.as_deref()),
           4498 => super::background_tasks_rmdir_http_cache::metric_base.test_get_value(ping_name.as_deref()),
           4506 => super::background_tasks_rmdir_quota::metric_base.test_get_value(ping_name.as_deref()),
           4566 => super::relevancy_classify::fail.test_get_value(ping_name.as_deref()),
           4567 => super::relevancy_classify::succeed.test_get_value(ping_name.as_deref()),
           4569 => super::cookie_banners::google_gdpr_choice_cookie_event.test_get_value(ping_name.as_deref()),
           4570 => super::cookie_banners::google_gdpr_choice_cookie_event_pbm.test_get_value(ping_name.as_deref()),
           4646 => super::doh::evaluate_v2_heuristics.test_get_value(ping_name.as_deref()),
           4647 => super::doh::state_disabled.test_get_value(ping_name.as_deref()),
           4648 => super::doh::state_enabled.test_get_value(ping_name.as_deref()),
           4649 => super::doh::state_manually_disabled.test_get_value(ping_name.as_deref()),
           4650 => super::doh::state_policy_disabled.test_get_value(ping_name.as_deref()),
           4651 => super::doh::state_rollback.test_get_value(ping_name.as_deref()),
           4652 => super::doh::state_shutdown.test_get_value(ping_name.as_deref()),
           4653 => super::doh::state_uidisabled.test_get_value(ping_name.as_deref()),
           4654 => super::doh::state_uiok.test_get_value(ping_name.as_deref()),
           4655 => super::doh::state_uninstalled.test_get_value(ping_name.as_deref()),
           4656 => super::security_doh_trr_performance::resolved_record.test_get_value(ping_name.as_deref()),
           4657 => super::security_doh_trr_performance::trrselect_dryrunresult.test_get_value(ping_name.as_deref()),
           4676 => super::extensions_data::migrate_result.test_get_value(ping_name.as_deref()),
           4678 => super::extensions_data::storage_local_error.test_get_value(ping_name.as_deref()),
           4679 => super::extensions_data::sync_usage_quotas.test_get_value(ping_name.as_deref()),
           4696 => super::address::add_manage.test_get_value(ping_name.as_deref()),
           4697 => super::address::cancel_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4698 => super::address::cancel_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4699 => super::address::cancel_update_doorhanger.test_get_value(ping_name.as_deref()),
           4700 => super::address::cleared_address_form.test_get_value(ping_name.as_deref()),
           4701 => super::address::delete_manage.test_get_value(ping_name.as_deref()),
           4702 => super::address::detected_address_form.test_get_value(ping_name.as_deref()),
           4703 => super::address::detected_address_form_ext.test_get_value(ping_name.as_deref()),
           4704 => super::address::disable_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4705 => super::address::disable_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4706 => super::address::disable_update_doorhanger.test_get_value(ping_name.as_deref()),
           4707 => super::address::edit_manage.test_get_value(ping_name.as_deref()),
           4708 => super::address::filled_address_form.test_get_value(ping_name.as_deref()),
           4709 => super::address::filled_address_form_ext.test_get_value(ping_name.as_deref()),
           4710 => super::address::filled_modified_address_form.test_get_value(ping_name.as_deref()),
           4711 => super::address::filled_on_fields_update_address_form.test_get_value(ping_name.as_deref()),
           4712 => super::address::learn_more_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4713 => super::address::learn_more_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4714 => super::address::learn_more_update_doorhanger.test_get_value(ping_name.as_deref()),
           4715 => super::address::popup_shown_address_form.test_get_value(ping_name.as_deref()),
           4716 => super::address::pref_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4717 => super::address::pref_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4718 => super::address::pref_update_doorhanger.test_get_value(ping_name.as_deref()),
           4719 => super::address::save_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4720 => super::address::save_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4721 => super::address::save_update_doorhanger.test_get_value(ping_name.as_deref()),
           4722 => super::address::show_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4723 => super::address::show_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4724 => super::address::show_entry_manage.test_get_value(ping_name.as_deref()),
           4725 => super::address::show_manage.test_get_value(ping_name.as_deref()),
           4726 => super::address::show_update_doorhanger.test_get_value(ping_name.as_deref()),
           4727 => super::address::submitted_address_form.test_get_value(ping_name.as_deref()),
           4728 => super::address::submitted_address_form_ext.test_get_value(ping_name.as_deref()),
           4729 => super::address::update_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4730 => super::address::update_edit_doorhanger.test_get_value(ping_name.as_deref()),
           4731 => super::address::update_update_doorhanger.test_get_value(ping_name.as_deref()),
           4732 => super::creditcard::add_manage.test_get_value(ping_name.as_deref()),
           4733 => super::creditcard::cancel_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4734 => super::creditcard::cancel_update_doorhanger.test_get_value(ping_name.as_deref()),
           4735 => super::creditcard::cleared_cc_form_v2.test_get_value(ping_name.as_deref()),
           4736 => super::creditcard::delete_manage.test_get_value(ping_name.as_deref()),
           4737 => super::creditcard::detected_cc_form_v2.test_get_value(ping_name.as_deref()),
           4739 => super::creditcard::disable_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4740 => super::creditcard::disable_update_doorhanger.test_get_value(ping_name.as_deref()),
           4741 => super::creditcard::edit_manage.test_get_value(ping_name.as_deref()),
           4742 => super::creditcard::filled_cc_form_v2.test_get_value(ping_name.as_deref()),
           4743 => super::creditcard::filled_modified_cc_form_v2.test_get_value(ping_name.as_deref()),
           4744 => super::creditcard::filled_on_fields_update_cc_form_v2.test_get_value(ping_name.as_deref()),
           4745 => super::creditcard::os_keystore_decrypt.test_get_value(ping_name.as_deref()),
           4746 => super::creditcard::popup_shown_cc_form_v2.test_get_value(ping_name.as_deref()),
           4747 => super::creditcard::save_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4748 => super::creditcard::save_update_doorhanger.test_get_value(ping_name.as_deref()),
           4749 => super::creditcard::show_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4750 => super::creditcard::show_entry_manage.test_get_value(ping_name.as_deref()),
           4751 => super::creditcard::show_manage.test_get_value(ping_name.as_deref()),
           4752 => super::creditcard::show_update_doorhanger.test_get_value(ping_name.as_deref()),
           4753 => super::creditcard::submitted_cc_form_v2.test_get_value(ping_name.as_deref()),
           4754 => super::creditcard::update_capture_doorhanger.test_get_value(ping_name.as_deref()),
           4755 => super::creditcard::update_update_doorhanger.test_get_value(ping_name.as_deref()),
           4758 => super::formautofill::iframe_layout_detection.test_get_value(ping_name.as_deref()),
           4760 => super::formautofill::prompt_shown_os_reauth.test_get_value(ping_name.as_deref()),
           4761 => super::formautofill::require_os_reauth_toggle.test_get_value(ping_name.as_deref()),
           4764 => super::formautofill_ml::field_infer_result.test_get_value(ping_name.as_deref()),
           4836 => super::test_only_ipc::an_event.test_get_value(ping_name.as_deref()),
           4841 => super::test_only_ipc::event_with_extra.test_get_value(ping_name.as_deref()),
           4843 => super::test_only_ipc::no_extra_event.test_get_value(ping_name.as_deref()),
           4846 => super::test_only_jog::an_event.test_get_value(ping_name.as_deref()),
           4848 => super::messaging_experiments::reach_cfr.test_get_value(ping_name.as_deref()),
           4849 => super::messaging_experiments::reach_feature_callout.test_get_value(ping_name.as_deref()),
           4850 => super::messaging_experiments::reach_fxms_bmb_button.test_get_value(ping_name.as_deref()),
           4851 => super::messaging_experiments::reach_fxms_message_1.test_get_value(ping_name.as_deref()),
           4852 => super::messaging_experiments::reach_fxms_message_10.test_get_value(ping_name.as_deref()),
           4853 => super::messaging_experiments::reach_fxms_message_11.test_get_value(ping_name.as_deref()),
           4854 => super::messaging_experiments::reach_fxms_message_2.test_get_value(ping_name.as_deref()),
           4855 => super::messaging_experiments::reach_fxms_message_3.test_get_value(ping_name.as_deref()),
           4856 => super::messaging_experiments::reach_fxms_message_4.test_get_value(ping_name.as_deref()),
           4857 => super::messaging_experiments::reach_fxms_message_5.test_get_value(ping_name.as_deref()),
           4858 => super::messaging_experiments::reach_fxms_message_6.test_get_value(ping_name.as_deref()),
           4859 => super::messaging_experiments::reach_fxms_message_7.test_get_value(ping_name.as_deref()),
           4860 => super::messaging_experiments::reach_fxms_message_8.test_get_value(ping_name.as_deref()),
           4861 => super::messaging_experiments::reach_fxms_message_9.test_get_value(ping_name.as_deref()),
           4862 => super::messaging_experiments::reach_infobar.test_get_value(ping_name.as_deref()),
           4863 => super::messaging_experiments::reach_moments_page.test_get_value(ping_name.as_deref()),
           4864 => super::messaging_experiments::reach_spotlight.test_get_value(ping_name.as_deref()),
           4865 => super::messaging_experiments::targeting_attribute_error.test_get_value(ping_name.as_deref()),
           4866 => super::messaging_experiments::targeting_attribute_timeout.test_get_value(ping_name.as_deref()),
           4867 => super::firefox_ai_runtime::engine_creation_failure.test_get_value(ping_name.as_deref()),
           4869 => super::firefox_ai_runtime::run_inference_failure.test_get_value(ping_name.as_deref()),
           4871 => super::nimbus_events::enroll_failed.test_get_value(ping_name.as_deref()),
           4872 => super::nimbus_events::enrollment.test_get_value(ping_name.as_deref()),
           4873 => super::nimbus_events::enrollment_status.test_get_value(ping_name.as_deref()),
           4874 => super::nimbus_events::exposure.test_get_value(ping_name.as_deref()),
           4875 => super::nimbus_events::is_ready.test_get_value(ping_name.as_deref()),
           4876 => super::nimbus_events::migration.test_get_value(ping_name.as_deref()),
           4877 => super::nimbus_events::unenroll_failed.test_get_value(ping_name.as_deref()),
           4878 => super::nimbus_events::unenrollment.test_get_value(ping_name.as_deref()),
           4879 => super::nimbus_events::validation_failed.test_get_value(ping_name.as_deref()),
           4916 => super::normandy::expose_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4917 => super::normandy::enroll_addon_rollout.test_get_value(ping_name.as_deref()),
           4918 => super::normandy::enroll_addon_study.test_get_value(ping_name.as_deref()),
           4919 => super::normandy::enroll_failed_addon_rollout.test_get_value(ping_name.as_deref()),
           4920 => super::normandy::enroll_failed_addon_study.test_get_value(ping_name.as_deref()),
           4921 => super::normandy::enroll_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4922 => super::normandy::enroll_failed_preference_rollout.test_get_value(ping_name.as_deref()),
           4923 => super::normandy::enroll_failed_preference_study.test_get_value(ping_name.as_deref()),
           4924 => super::normandy::enroll_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4925 => super::normandy::enroll_preference_rollout.test_get_value(ping_name.as_deref()),
           4926 => super::normandy::enroll_preference_study.test_get_value(ping_name.as_deref()),
           4927 => super::normandy::exp_pref_changed_preference_study.test_get_value(ping_name.as_deref()),
           4928 => super::normandy::graduate_preference_rollout.test_get_value(ping_name.as_deref()),
           4930 => super::normandy::unenroll_addon_rollback.test_get_value(ping_name.as_deref()),
           4931 => super::normandy::unenroll_addon_study.test_get_value(ping_name.as_deref()),
           4932 => super::normandy::unenroll_failed_addon_rollback.test_get_value(ping_name.as_deref()),
           4933 => super::normandy::unenroll_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4934 => super::normandy::unenroll_failed_preference_rollback.test_get_value(ping_name.as_deref()),
           4935 => super::normandy::unenroll_failed_preference_study.test_get_value(ping_name.as_deref()),
           4936 => super::normandy::unenroll_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4937 => super::normandy::unenroll_preference_rollback.test_get_value(ping_name.as_deref()),
           4938 => super::normandy::unenroll_preference_study.test_get_value(ping_name.as_deref()),
           4939 => super::normandy::update_addon_rollout.test_get_value(ping_name.as_deref()),
           4940 => super::normandy::update_addon_study.test_get_value(ping_name.as_deref()),
           4941 => super::normandy::update_failed_addon_rollout.test_get_value(ping_name.as_deref()),
           4942 => super::normandy::update_failed_addon_study.test_get_value(ping_name.as_deref()),
           4943 => super::normandy::update_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4944 => super::normandy::update_preference_rollout.test_get_value(ping_name.as_deref()),
           4945 => super::normandy::validation_failed_nimbus_experiment.test_get_value(ping_name.as_deref()),
           4946 => super::form_autocomplete::show_logins.test_get_value(ping_name.as_deref()),
           4947 => super::pwmgr::autocomplete_field_generatedpassword.test_get_value(ping_name.as_deref()),
           4948 => super::pwmgr::autocomplete_shown_generatedpassword.test_get_value(ping_name.as_deref()),
           4949 => super::pwmgr::cancel_existing_login.test_get_value(ping_name.as_deref()),
           4950 => super::pwmgr::cancel_new_login.test_get_value(ping_name.as_deref()),
           4951 => super::pwmgr::copy_password.test_get_value(ping_name.as_deref()),
           4952 => super::pwmgr::copy_username.test_get_value(ping_name.as_deref()),
           4953 => super::pwmgr::delete_existing_login.test_get_value(ping_name.as_deref()),
           4954 => super::pwmgr::delete_new_login.test_get_value(ping_name.as_deref()),
           4955 => super::pwmgr::doorhanger_submitted_save.test_get_value(ping_name.as_deref()),
           4956 => super::pwmgr::doorhanger_submitted_update.test_get_value(ping_name.as_deref()),
           4957 => super::pwmgr::edit_existing_login.test_get_value(ping_name.as_deref()),
           4958 => super::pwmgr::filled_field_edited_generatedpassword.test_get_value(ping_name.as_deref()),
           4959 => super::pwmgr::filter_list.test_get_value(ping_name.as_deref()),
           4961 => super::pwmgr::hide_password.test_get_value(ping_name.as_deref()),
           4964 => super::pwmgr::learn_more_vuln_existing_login.test_get_value(ping_name.as_deref()),
           4966 => super::pwmgr::mgmt_menu_item_used_export.test_get_value(ping_name.as_deref()),
           4967 => super::pwmgr::mgmt_menu_item_used_export_complete.test_get_value(ping_name.as_deref()),
           4968 => super::pwmgr::mgmt_menu_item_used_import_csv_complete.test_get_value(ping_name.as_deref()),
           4969 => super::pwmgr::mgmt_menu_item_used_import_from_browser.test_get_value(ping_name.as_deref()),
           4970 => super::pwmgr::mgmt_menu_item_used_import_from_csv.test_get_value(ping_name.as_deref()),
           4971 => super::pwmgr::mgmt_menu_item_used_preferences.test_get_value(ping_name.as_deref()),
           4972 => super::pwmgr::new_new_login.test_get_value(ping_name.as_deref()),
           4975 => super::pwmgr::open_management_aboutprotections.test_get_value(ping_name.as_deref()),
           4976 => super::pwmgr::open_management_autocomplete.test_get_value(ping_name.as_deref()),
           4977 => super::pwmgr::open_management_contextmenu.test_get_value(ping_name.as_deref()),
           4978 => super::pwmgr::open_management_direct.test_get_value(ping_name.as_deref()),
           4979 => super::pwmgr::open_management_mainmenu.test_get_value(ping_name.as_deref()),
           4980 => super::pwmgr::open_management_pageinfo.test_get_value(ping_name.as_deref()),
           4981 => super::pwmgr::open_management_preferences.test_get_value(ping_name.as_deref()),
           4982 => super::pwmgr::open_management_snippet.test_get_value(ping_name.as_deref()),
           4983 => super::pwmgr::open_site_existing_login.test_get_value(ping_name.as_deref()),
           4987 => super::pwmgr::prompt_shown_os_reauth.test_get_value(ping_name.as_deref()),
           4989 => super::pwmgr::reauthenticate_master_password.test_get_value(ping_name.as_deref()),
           4990 => super::pwmgr::reauthenticate_os_auth.test_get_value(ping_name.as_deref()),
           4991 => super::pwmgr::require_os_reauth_toggle.test_get_value(ping_name.as_deref()),
           4992 => super::pwmgr::save_existing_login.test_get_value(ping_name.as_deref()),
           4993 => super::pwmgr::save_new_login.test_get_value(ping_name.as_deref()),
           4994 => super::pwmgr::saved_login_used_auth_login.test_get_value(ping_name.as_deref()),
           4995 => super::pwmgr::saved_login_used_form_login.test_get_value(ping_name.as_deref()),
           4996 => super::pwmgr::saved_login_used_form_password.test_get_value(ping_name.as_deref()),
           4997 => super::pwmgr::saved_login_used_prompt_login.test_get_value(ping_name.as_deref()),
           4999 => super::pwmgr::select_existing_login.test_get_value(ping_name.as_deref()),
           5000 => super::pwmgr::show_password.test_get_value(ping_name.as_deref()),
           5002 => super::pwmgr::sort_list.test_get_value(ping_name.as_deref()),
           5003 => super::relay_integration::clicked_fill_username.test_get_value(ping_name.as_deref()),
           5004 => super::relay_integration::clicked_offer_relay.test_get_value(ping_name.as_deref()),
           5005 => super::relay_integration::disabled_opt_in_panel.test_get_value(ping_name.as_deref()),
           5006 => super::relay_integration::disabled_pref_change.test_get_value(ping_name.as_deref()),
           5007 => super::relay_integration::enabled_opt_in_panel.test_get_value(ping_name.as_deref()),
           5008 => super::relay_integration::enabled_pref_change.test_get_value(ping_name.as_deref()),
           5009 => super::relay_integration::get_unlimited_masks_reuse_panel.test_get_value(ping_name.as_deref()),
           5010 => super::relay_integration::postponed_opt_in_panel.test_get_value(ping_name.as_deref()),
           5011 => super::relay_integration::reuse_mask_reuse_panel.test_get_value(ping_name.as_deref()),
           5012 => super::relay_integration::shown_fill_username.test_get_value(ping_name.as_deref()),
           5013 => super::relay_integration::shown_offer_relay.test_get_value(ping_name.as_deref()),
           5014 => super::relay_integration::shown_opt_in_panel.test_get_value(ping_name.as_deref()),
           5015 => super::relay_integration::shown_reuse_panel.test_get_value(ping_name.as_deref()),
           5034 => super::pdfjs_image::add_image_click.test_get_value(ping_name.as_deref()),
           5037 => super::pdfjs_image::icon_click.test_get_value(ping_name.as_deref()),
           5038 => super::pdfjs_image::image_added.test_get_value(ping_name.as_deref()),
           5039 => super::pdfjs_image::image_selected.test_get_value(ping_name.as_deref()),
           5040 => super::pdfjs_image_alt_text::ai_generation_check.test_get_value(ping_name.as_deref()),
           5041 => super::pdfjs_image_alt_text::callout_dismissed.test_get_value(ping_name.as_deref()),
           5042 => super::pdfjs_image_alt_text::callout_displayed.test_get_value(ping_name.as_deref()),
           5043 => super::pdfjs_image_alt_text::dismiss.test_get_value(ping_name.as_deref()),
           5044 => super::pdfjs_image_alt_text::image_status_label_clicked.test_get_value(ping_name.as_deref()),
           5045 => super::pdfjs_image_alt_text::image_status_label_displayed.test_get_value(ping_name.as_deref()),
           5046 => super::pdfjs_image_alt_text::info.test_get_value(ping_name.as_deref()),
           5047 => super::pdfjs_image_alt_text::model_deleted.test_get_value(ping_name.as_deref()),
           5048 => super::pdfjs_image_alt_text::model_download_complete.test_get_value(ping_name.as_deref()),
           5049 => super::pdfjs_image_alt_text::model_download_error.test_get_value(ping_name.as_deref()),
           5050 => super::pdfjs_image_alt_text::model_download_start.test_get_value(ping_name.as_deref()),
           5051 => super::pdfjs_image_alt_text::model_result.test_get_value(ping_name.as_deref()),
           5052 => super::pdfjs_image_alt_text::save.test_get_value(ping_name.as_deref()),
           5053 => super::pdfjs_image_alt_text::settings_ai_generation_check.test_get_value(ping_name.as_deref()),
           5054 => super::pdfjs_image_alt_text::settings_displayed.test_get_value(ping_name.as_deref()),
           5055 => super::pdfjs_image_alt_text::settings_edit_alt_text_check.test_get_value(ping_name.as_deref()),
           5056 => super::pdfjs_image_alt_text::user_edit.test_get_value(ping_name.as_deref()),
           5057 => super::pdfjs_signature::added.test_get_value(ping_name.as_deref()),
           5059 => super::pdfjs_signature::created.test_get_value(ping_name.as_deref()),
           5060 => super::pdfjs_signature::delete_saved.test_get_value(ping_name.as_deref()),
           5062 => super::pdfjs_signature::inserted.test_get_value(ping_name.as_deref()),
           5064 => super::pictureinpicture::closed_method_browser_crash.test_get_value(ping_name.as_deref()),
           5065 => super::pictureinpicture::closed_method_close_button.test_get_value(ping_name.as_deref()),
           5066 => super::pictureinpicture::closed_method_close_player_shortcut.test_get_value(ping_name.as_deref()),
           5067 => super::pictureinpicture::closed_method_context_menu.test_get_value(ping_name.as_deref()),
           5068 => super::pictureinpicture::closed_method_foregrounded.test_get_value(ping_name.as_deref()),
           5069 => super::pictureinpicture::closed_method_fullscreen.test_get_value(ping_name.as_deref()),
           5070 => super::pictureinpicture::closed_method_pagehide.test_get_value(ping_name.as_deref()),
           5071 => super::pictureinpicture::closed_method_setup_failure.test_get_value(ping_name.as_deref()),
           5072 => super::pictureinpicture::closed_method_shortcut.test_get_value(ping_name.as_deref()),
           5073 => super::pictureinpicture::closed_method_unpip.test_get_value(ping_name.as_deref()),
           5074 => super::pictureinpicture::closed_method_url_bar.test_get_value(ping_name.as_deref()),
           5075 => super::pictureinpicture::closed_method_video_el_emptied.test_get_value(ping_name.as_deref()),
           5076 => super::pictureinpicture::closed_method_video_el_remove.test_get_value(ping_name.as_deref()),
           5077 => super::pictureinpicture::create_player.test_get_value(ping_name.as_deref()),
           5078 => super::pictureinpicture::disrespect_disable_url_bar.test_get_value(ping_name.as_deref()),
           5080 => super::pictureinpicture::fullscreen_player.test_get_value(ping_name.as_deref()),
           5082 => super::pictureinpicture::opened_method_auto_pip.test_get_value(ping_name.as_deref()),
           5083 => super::pictureinpicture::opened_method_context_menu.test_get_value(ping_name.as_deref()),
           5084 => super::pictureinpicture::opened_method_shortcut.test_get_value(ping_name.as_deref()),
           5085 => super::pictureinpicture::opened_method_toggle.test_get_value(ping_name.as_deref()),
           5086 => super::pictureinpicture::opened_method_url_bar.test_get_value(ping_name.as_deref()),
           5087 => super::pictureinpicture::resize_player.test_get_value(ping_name.as_deref()),
           5088 => super::pictureinpicture::saw_toggle_toggle.test_get_value(ping_name.as_deref()),
           5089 => super::pictureinpicture::subtitles_shown_subtitles.test_get_value(ping_name.as_deref()),
           5092 => super::pictureinpicture_settings::disable_player.test_get_value(ping_name.as_deref()),
           5093 => super::pictureinpicture_settings::disable_settings.test_get_value(ping_name.as_deref()),
           5094 => super::pictureinpicture_settings::enable_autotrigger_settings.test_get_value(ping_name.as_deref()),
           5095 => super::pictureinpicture_settings::enable_settings.test_get_value(ping_name.as_deref()),
           5150 => super::readermode::button_click.test_get_value(ping_name.as_deref()),
           5153 => super::readermode::view_off.test_get_value(ping_name.as_deref()),
           5154 => super::readermode::view_on.test_get_value(ping_name.as_deref()),
           5196 => super::webcompatreporting::opened.test_get_value(ping_name.as_deref()),
           5197 => super::webcompatreporting::reason_dropdown.test_get_value(ping_name.as_deref()),
           5198 => super::webcompatreporting::send.test_get_value(ping_name.as_deref()),
           5199 => super::webcompatreporting::send_more_info.test_get_value(ping_name.as_deref()),
           5487 => super::search_engine_default::changed.test_get_value(ping_name.as_deref()),
           5495 => super::search_engine_private::changed.test_get_value(ping_name.as_deref()),
           5508 => super::shopping_product::invalid_ohttp_config.test_get_value(ping_name.as_deref()),
           5509 => super::shopping_product::invalid_request.test_get_value(ping_name.as_deref()),
           5510 => super::shopping_product::invalid_response.test_get_value(ping_name.as_deref()),
           5511 => super::shopping_product::request_aborted.test_get_value(ping_name.as_deref()),
           5512 => super::shopping_product::request_error.test_get_value(ping_name.as_deref()),
           5513 => super::shopping_product::request_failure.test_get_value(ping_name.as_deref()),
           5514 => super::shopping_product::request_retried.test_get_value(ping_name.as_deref()),
           5515 => super::shopping_product::request_retries_failed.test_get_value(ping_name.as_deref()),
           5516 => super::shopping_product::server_failure.test_get_value(ping_name.as_deref()),
           5571 => super::telemetry_test::test1_object1.test_get_value(ping_name.as_deref()),
           5572 => super::telemetry_test::test2_object1.test_get_value(ping_name.as_deref()),
           5573 => super::telemetry_test::test2_object2.test_get_value(ping_name.as_deref()),
           5581 => super::translations::engine_performance.test_get_value(ping_name.as_deref()),
           5582 => super::translations::error.test_get_value(ping_name.as_deref()),
           5584 => super::translations::restore_page.test_get_value(ping_name.as_deref()),
           5585 => super::translations::translation_request.test_get_value(ping_name.as_deref()),
           5586 => super::translations_about_translations_page::open.test_get_value(ping_name.as_deref()),
           5587 => super::translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           5588 => super::translations_panel::always_offer_translations.test_get_value(ping_name.as_deref()),
           5589 => super::translations_panel::always_translate_language.test_get_value(ping_name.as_deref()),
           5590 => super::translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           5591 => super::translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           5592 => super::translations_panel::change_source_language_button.test_get_value(ping_name.as_deref()),
           5593 => super::translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           5594 => super::translations_panel::close.test_get_value(ping_name.as_deref()),
           5595 => super::translations_panel::close_from_language_menu.test_get_value(ping_name.as_deref()),
           5596 => super::translations_panel::close_settings_menu.test_get_value(ping_name.as_deref()),
           5597 => super::translations_panel::close_to_language_menu.test_get_value(ping_name.as_deref()),
           5598 => super::translations_panel::dismiss_error_button.test_get_value(ping_name.as_deref()),
           5599 => super::translations_panel::learn_more.test_get_value(ping_name.as_deref()),
           5600 => super::translations_panel::manage_languages.test_get_value(ping_name.as_deref()),
           5601 => super::translations_panel::never_translate_language.test_get_value(ping_name.as_deref()),
           5602 => super::translations_panel::never_translate_site.test_get_value(ping_name.as_deref()),
           5603 => super::translations_panel::open.test_get_value(ping_name.as_deref()),
           5604 => super::translations_panel::open_from_language_menu.test_get_value(ping_name.as_deref()),
           5605 => super::translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           5606 => super::translations_panel::open_to_language_menu.test_get_value(ping_name.as_deref()),
           5607 => super::translations_panel::restore_page_button.test_get_value(ping_name.as_deref()),
           5608 => super::translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           5609 => super::translations_select_translations_panel::about_translations.test_get_value(ping_name.as_deref()),
           5610 => super::translations_select_translations_panel::cancel_button.test_get_value(ping_name.as_deref()),
           5611 => super::translations_select_translations_panel::change_from_language.test_get_value(ping_name.as_deref()),
           5612 => super::translations_select_translations_panel::change_to_language.test_get_value(ping_name.as_deref()),
           5613 => super::translations_select_translations_panel::close.test_get_value(ping_name.as_deref()),
           5614 => super::translations_select_translations_panel::copy_button.test_get_value(ping_name.as_deref()),
           5615 => super::translations_select_translations_panel::done_button.test_get_value(ping_name.as_deref()),
           5616 => super::translations_select_translations_panel::initialization_failure_message.test_get_value(ping_name.as_deref()),
           5617 => super::translations_select_translations_panel::open.test_get_value(ping_name.as_deref()),
           5618 => super::translations_select_translations_panel::open_settings_menu.test_get_value(ping_name.as_deref()),
           5619 => super::translations_select_translations_panel::translate_button.test_get_value(ping_name.as_deref()),
           5620 => super::translations_select_translations_panel::translate_full_page_button.test_get_value(ping_name.as_deref()),
           5621 => super::translations_select_translations_panel::translation_failure_message.test_get_value(ping_name.as_deref()),
           5622 => super::translations_select_translations_panel::translation_settings.test_get_value(ping_name.as_deref()),
           5623 => super::translations_select_translations_panel::try_again_button.test_get_value(ping_name.as_deref()),
           5624 => super::translations_select_translations_panel::unsupported_language_message.test_get_value(ping_name.as_deref()),
           5652 => super::security_doh_neterror::click_add_exception_button.test_get_value(ping_name.as_deref()),
           5653 => super::security_doh_neterror::click_continue_button.test_get_value(ping_name.as_deref()),
           5654 => super::security_doh_neterror::click_disable_warning.test_get_value(ping_name.as_deref()),
           5655 => super::security_doh_neterror::click_learn_more_link.test_get_value(ping_name.as_deref()),
           5656 => super::security_doh_neterror::click_settings_button.test_get_value(ping_name.as_deref()),
           5657 => super::security_doh_neterror::click_try_again_button.test_get_value(ping_name.as_deref()),
           5658 => super::security_doh_neterror::load_dohwarning.test_get_value(ping_name.as_deref()),
           5659 => super::security_ui_certerror::click_advanced_button.test_get_value(ping_name.as_deref()),
           5660 => super::security_ui_certerror::click_auto_report_cb.test_get_value(ping_name.as_deref()),
           5661 => super::security_ui_certerror::click_clipboard_button_bot.test_get_value(ping_name.as_deref()),
           5662 => super::security_ui_certerror::click_clipboard_button_top.test_get_value(ping_name.as_deref()),
           5663 => super::security_ui_certerror::click_error_code_link.test_get_value(ping_name.as_deref()),
           5664 => super::security_ui_certerror::click_exception_button.test_get_value(ping_name.as_deref()),
           5665 => super::security_ui_certerror::click_learn_more_link.test_get_value(ping_name.as_deref()),
           5666 => super::security_ui_certerror::click_return_button_adv.test_get_value(ping_name.as_deref()),
           5667 => super::security_ui_certerror::click_return_button_top.test_get_value(ping_name.as_deref()),
           5668 => super::security_ui_certerror::load_aboutcerterror.test_get_value(ping_name.as_deref()),
           5669 => super::security_ui_tlserror::load_abouttlserror.test_get_value(ping_name.as_deref()),
           5680 => super::jsonfile::load_autofillprofiles.test_get_value(ping_name.as_deref()),
           5681 => super::jsonfile::load_logins.test_get_value(ping_name.as_deref()),
           5687 => super::service_request::bypass_proxy_info.test_get_value(ping_name.as_deref()),
           5700 => super::addons_manager::install.test_get_value(ping_name.as_deref()),
           5701 => super::addons_manager::install_stats.test_get_value(ping_name.as_deref()),
           5702 => super::addons_manager::manage.test_get_value(ping_name.as_deref()),
           5703 => super::addons_manager::report_suspicious_site.test_get_value(ping_name.as_deref()),
           5704 => super::addons_manager::update.test_get_value(ping_name.as_deref()),
           5705 => super::addons_manager::xpistates_write_errors.test_get_value(ping_name.as_deref()),
           5706 => super::addons_manager::disable_dictionary.test_get_value(ping_name.as_deref()),
           5707 => super::addons_manager::disable_extension.test_get_value(ping_name.as_deref()),
           5708 => super::addons_manager::disable_locale.test_get_value(ping_name.as_deref()),
           5709 => super::addons_manager::disable_other.test_get_value(ping_name.as_deref()),
           5710 => super::addons_manager::disable_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5711 => super::addons_manager::disable_sitepermission.test_get_value(ping_name.as_deref()),
           5712 => super::addons_manager::disable_theme.test_get_value(ping_name.as_deref()),
           5713 => super::addons_manager::disable_unknown.test_get_value(ping_name.as_deref()),
           5714 => super::addons_manager::enable_dictionary.test_get_value(ping_name.as_deref()),
           5715 => super::addons_manager::enable_extension.test_get_value(ping_name.as_deref()),
           5716 => super::addons_manager::enable_locale.test_get_value(ping_name.as_deref()),
           5717 => super::addons_manager::enable_other.test_get_value(ping_name.as_deref()),
           5718 => super::addons_manager::enable_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5719 => super::addons_manager::enable_sitepermission.test_get_value(ping_name.as_deref()),
           5720 => super::addons_manager::enable_theme.test_get_value(ping_name.as_deref()),
           5721 => super::addons_manager::enable_unknown.test_get_value(ping_name.as_deref()),
           5722 => super::addons_manager::install_dictionary.test_get_value(ping_name.as_deref()),
           5723 => super::addons_manager::install_extension.test_get_value(ping_name.as_deref()),
           5724 => super::addons_manager::install_locale.test_get_value(ping_name.as_deref()),
           5725 => super::addons_manager::install_other.test_get_value(ping_name.as_deref()),
           5726 => super::addons_manager::install_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5727 => super::addons_manager::install_sitepermission.test_get_value(ping_name.as_deref()),
           5728 => super::addons_manager::install_stats_dictionary.test_get_value(ping_name.as_deref()),
           5729 => super::addons_manager::install_stats_extension.test_get_value(ping_name.as_deref()),
           5730 => super::addons_manager::install_stats_locale.test_get_value(ping_name.as_deref()),
           5731 => super::addons_manager::install_stats_other.test_get_value(ping_name.as_deref()),
           5732 => super::addons_manager::install_stats_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5733 => super::addons_manager::install_stats_sitepermission.test_get_value(ping_name.as_deref()),
           5734 => super::addons_manager::install_stats_theme.test_get_value(ping_name.as_deref()),
           5735 => super::addons_manager::install_stats_unknown.test_get_value(ping_name.as_deref()),
           5736 => super::addons_manager::install_theme.test_get_value(ping_name.as_deref()),
           5737 => super::addons_manager::install_unknown.test_get_value(ping_name.as_deref()),
           5738 => super::addons_manager::sideload_prompt_dictionary.test_get_value(ping_name.as_deref()),
           5739 => super::addons_manager::sideload_prompt_extension.test_get_value(ping_name.as_deref()),
           5740 => super::addons_manager::sideload_prompt_locale.test_get_value(ping_name.as_deref()),
           5741 => super::addons_manager::sideload_prompt_other.test_get_value(ping_name.as_deref()),
           5742 => super::addons_manager::sideload_prompt_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5743 => super::addons_manager::sideload_prompt_sitepermission.test_get_value(ping_name.as_deref()),
           5744 => super::addons_manager::sideload_prompt_theme.test_get_value(ping_name.as_deref()),
           5745 => super::addons_manager::sideload_prompt_unknown.test_get_value(ping_name.as_deref()),
           5746 => super::addons_manager::uninstall_dictionary.test_get_value(ping_name.as_deref()),
           5747 => super::addons_manager::uninstall_extension.test_get_value(ping_name.as_deref()),
           5748 => super::addons_manager::uninstall_locale.test_get_value(ping_name.as_deref()),
           5749 => super::addons_manager::uninstall_other.test_get_value(ping_name.as_deref()),
           5750 => super::addons_manager::uninstall_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5751 => super::addons_manager::uninstall_sitepermission.test_get_value(ping_name.as_deref()),
           5752 => super::addons_manager::uninstall_theme.test_get_value(ping_name.as_deref()),
           5753 => super::addons_manager::uninstall_unknown.test_get_value(ping_name.as_deref()),
           5754 => super::addons_manager::update_dictionary.test_get_value(ping_name.as_deref()),
           5755 => super::addons_manager::update_extension.test_get_value(ping_name.as_deref()),
           5756 => super::addons_manager::update_locale.test_get_value(ping_name.as_deref()),
           5757 => super::addons_manager::update_other.test_get_value(ping_name.as_deref()),
           5758 => super::addons_manager::update_siteperm_deprecated.test_get_value(ping_name.as_deref()),
           5759 => super::addons_manager::update_sitepermission.test_get_value(ping_name.as_deref()),
           5760 => super::addons_manager::update_theme.test_get_value(ping_name.as_deref()),
           5761 => super::addons_manager::update_unknown.test_get_value(ping_name.as_deref()),
           5762 => super::blocklist::addon_block_change.test_get_value(ping_name.as_deref()),
           5896 => super::memory_watcher::on_high_memory_stats.test_get_value(ping_name.as_deref()),
           _ => panic!("No event for metric id {}", metric_id),
        }
    }

    /// Check the provided event for errors.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `ping_name` - (Optional) The ping name to look into.
    ///                 Defaults to the first value in `send_in_pings`.
    ///
    /// # Returns
    ///
    /// Returns a string for the recorded error or `None`.
    ///
    /// # Panics
    ///
    /// Panics if no event by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn event_test_get_error(metric_id: u32) -> Option<String> {
        #[cfg(feature = "with_gecko")]
        match metric_id {
           16 => test_get_errors!(super::browser_engagement::tab_explicit_unload),
           199 => test_get_errors!(super::security_ui_protectionspopup::click_cookieb_toggle_off),
           200 => test_get_errors!(super::security_ui_protectionspopup::click_cookieb_toggle_on),
           201 => test_get_errors!(super::security_ui_protectionspopup::click_cookies),
           202 => test_get_errors!(super::security_ui_protectionspopup::click_cryptominers),
           203 => test_get_errors!(super::security_ui_protectionspopup::click_etp_toggle_off),
           204 => test_get_errors!(super::security_ui_protectionspopup::click_etp_toggle_on),
           205 => test_get_errors!(super::security_ui_protectionspopup::click_fingerprinters),
           206 => test_get_errors!(super::security_ui_protectionspopup::click_full_report),
           207 => test_get_errors!(super::security_ui_protectionspopup::click_milestone_message),
           208 => test_get_errors!(super::security_ui_protectionspopup::click_protectionspopup_cfr),
           209 => test_get_errors!(super::security_ui_protectionspopup::click_settings),
           210 => test_get_errors!(super::security_ui_protectionspopup::click_smartblockembeds_toggle),
           211 => test_get_errors!(super::security_ui_protectionspopup::click_social),
           212 => test_get_errors!(super::security_ui_protectionspopup::click_subview_settings),
           213 => test_get_errors!(super::security_ui_protectionspopup::click_trackers),
           214 => test_get_errors!(super::security_ui_protectionspopup::close_protections_popup),
           215 => test_get_errors!(super::security_ui_protectionspopup::open_protections_popup),
           216 => test_get_errors!(super::security_ui_protectionspopup::open_protectionspopup_cfr),
           256 => test_get_errors!(super::browser_backup::change_location),
           259 => test_get_errors!(super::browser_backup::created),
           262 => test_get_errors!(super::browser_backup::error),
           272 => test_get_errors!(super::browser_backup::password_added),
           273 => test_get_errors!(super::browser_backup::password_changed),
           274 => test_get_errors!(super::browser_backup::password_removed),
           285 => test_get_errors!(super::browser_backup::toggle_off),
           286 => test_get_errors!(super::browser_backup::toggle_on),
           290 => test_get_errors!(super::downloads::added_file_extension),
           306 => test_get_errors!(super::firefoxview_next::browser_context_menu_tabs),
           307 => test_get_errors!(super::firefoxview_next::card_collapsed_card_container),
           308 => test_get_errors!(super::firefoxview_next::card_expanded_card_container),
           309 => test_get_errors!(super::firefoxview_next::change_page_navigation),
           310 => test_get_errors!(super::firefoxview_next::close_open_tab_tabs),
           311 => test_get_errors!(super::firefoxview_next::context_menu_tabs),
           312 => test_get_errors!(super::firefoxview_next::dismiss_closed_tab_tabs),
           313 => test_get_errors!(super::firefoxview_next::entered_firefoxview),
           314 => test_get_errors!(super::firefoxview_next::fxa_continue_sync),
           315 => test_get_errors!(super::firefoxview_next::fxa_mobile_sync),
           316 => test_get_errors!(super::firefoxview_next::history_visits),
           317 => test_get_errors!(super::firefoxview_next::open_tab_tabs),
           318 => test_get_errors!(super::firefoxview_next::recently_closed_tabs),
           319 => test_get_errors!(super::firefoxview_next::search_initiated_search),
           320 => test_get_errors!(super::firefoxview_next::search_show_all_showallbutton),
           321 => test_get_errors!(super::firefoxview_next::show_all_history_tabs),
           322 => test_get_errors!(super::firefoxview_next::sort_history_tabs),
           323 => test_get_errors!(super::firefoxview_next::synced_tabs_tabs),
           324 => test_get_errors!(super::firefoxview_next::tab_selected_toolbarbutton),
           325 => test_get_errors!(super::genai_chatbot::contextmenu_prompt_click),
           326 => test_get_errors!(super::genai_chatbot::contextmenu_remove),
           328 => test_get_errors!(super::genai_chatbot::experiment_checkbox_click),
           329 => test_get_errors!(super::genai_chatbot::keyboard_shortcut),
           330 => test_get_errors!(super::genai_chatbot::onboarding_close),
           331 => test_get_errors!(super::genai_chatbot::onboarding_continue),
           332 => test_get_errors!(super::genai_chatbot::onboarding_finish),
           333 => test_get_errors!(super::genai_chatbot::onboarding_learn_more),
           334 => test_get_errors!(super::genai_chatbot::onboarding_provider_choice_displayed),
           335 => test_get_errors!(super::genai_chatbot::onboarding_provider_learn),
           336 => test_get_errors!(super::genai_chatbot::onboarding_provider_selection),
           337 => test_get_errors!(super::genai_chatbot::onboarding_provider_terms),
           338 => test_get_errors!(super::genai_chatbot::onboarding_text_highlight_displayed),
           340 => test_get_errors!(super::genai_chatbot::provider_change),
           342 => test_get_errors!(super::genai_chatbot::shortcuts_checkbox_click),
           344 => test_get_errors!(super::genai_chatbot::shortcuts_displayed),
           345 => test_get_errors!(super::genai_chatbot::shortcuts_expanded),
           346 => test_get_errors!(super::genai_chatbot::shortcuts_hide_click),
           347 => test_get_errors!(super::genai_chatbot::shortcuts_prompt_click),
           349 => test_get_errors!(super::genai_chatbot::sidebar_close_click),
           350 => test_get_errors!(super::genai_chatbot::sidebar_more_menu_click),
           351 => test_get_errors!(super::genai_chatbot::sidebar_more_menu_display),
           352 => test_get_errors!(super::genai_chatbot::sidebar_provider_menu_click),
           353 => test_get_errors!(super::genai_chatbot::sidebar_toggle),
           354 => test_get_errors!(super::genai_linkpreview::card_close),
           355 => test_get_errors!(super::genai_linkpreview::card_link),
           357 => test_get_errors!(super::genai_linkpreview::fetch),
           358 => test_get_errors!(super::genai_linkpreview::generate),
           359 => test_get_errors!(super::genai_linkpreview::labs_checkbox),
           360 => test_get_errors!(super::genai_linkpreview::start),
           387 => test_get_errors!(super::browser_launched_to_handle::system_notification),
           401 => test_get_errors!(super::launch_on_login::last_profile_disable_startup),
           415 => test_get_errors!(super::security::fission_principals),
           416 => test_get_errors!(super::security::csp_violation_internal_page),
           417 => test_get_errors!(super::security::eval_usage_parent_process),
           418 => test_get_errors!(super::security::eval_usage_system_context),
           420 => test_get_errors!(super::security::javascript_load_parent_process),
           422 => test_get_errors!(super::security::unexpected_load),
           423 => test_get_errors!(super::security::pref_usage_content_process),
           429 => test_get_errors!(super::start_menu::manually_unpinned_since_last_launch),
           435 => test_get_errors!(super::upgrade_dialog::trigger_reason),
           437 => test_get_errors!(super::browser_migration::browser_selected_wizard),
           439 => test_get_errors!(super::browser_migration::chrome_password_file_wizard),
           444 => test_get_errors!(super::browser_migration::linux_perms_wizard),
           447 => test_get_errors!(super::browser_migration::migration_finished_wizard),
           448 => test_get_errors!(super::browser_migration::migration_started_wizard),
           449 => test_get_errors!(super::browser_migration::no_browsers_found_wizard),
           450 => test_get_errors!(super::browser_migration::opened_wizard),
           451 => test_get_errors!(super::browser_migration::profile_selected_wizard),
           452 => test_get_errors!(super::browser_migration::resources_selected_wizard),
           453 => test_get_errors!(super::browser_migration::safari_password_file_wizard),
           454 => test_get_errors!(super::browser_migration::safari_perms_wizard),
           461 => test_get_errors!(super::activity_stream::end_session),
           462 => test_get_errors!(super::activity_stream::event_archive_from_pocket),
           463 => test_get_errors!(super::activity_stream::event_block),
           464 => test_get_errors!(super::activity_stream::event_bookmark_add),
           465 => test_get_errors!(super::activity_stream::event_bookmark_delete),
           466 => test_get_errors!(super::activity_stream::event_click),
           467 => test_get_errors!(super::activity_stream::event_click_privacy_info),
           468 => test_get_errors!(super::activity_stream::event_close_newtab_prefs),
           469 => test_get_errors!(super::activity_stream::event_delete),
           470 => test_get_errors!(super::activity_stream::event_delete_confirm),
           471 => test_get_errors!(super::activity_stream::event_delete_from_pocket),
           472 => test_get_errors!(super::activity_stream::event_dialog_cancel),
           473 => test_get_errors!(super::activity_stream::event_dialog_open),
           474 => test_get_errors!(super::activity_stream::event_disclaimer_acked),
           475 => test_get_errors!(super::activity_stream::event_drag),
           476 => test_get_errors!(super::activity_stream::event_drop),
           477 => test_get_errors!(super::activity_stream::event_fakespot_category),
           478 => test_get_errors!(super::activity_stream::event_fakespot_click),
           479 => test_get_errors!(super::activity_stream::event_hide_personalize),
           480 => test_get_errors!(super::activity_stream::event_impression),
           481 => test_get_errors!(super::activity_stream::event_menu_add_search),
           482 => test_get_errors!(super::activity_stream::event_menu_add_topsite),
           483 => test_get_errors!(super::activity_stream::event_menu_collapse),
           484 => test_get_errors!(super::activity_stream::event_menu_expand),
           485 => test_get_errors!(super::activity_stream::event_menu_manage),
           486 => test_get_errors!(super::activity_stream::event_menu_move_down),
           487 => test_get_errors!(super::activity_stream::event_menu_move_up),
           488 => test_get_errors!(super::activity_stream::event_menu_privacy_notice),
           489 => test_get_errors!(super::activity_stream::event_menu_remove),
           490 => test_get_errors!(super::activity_stream::event_migration_cancel),
           491 => test_get_errors!(super::activity_stream::event_migration_start),
           492 => test_get_errors!(super::activity_stream::event_open_new_window),
           493 => test_get_errors!(super::activity_stream::event_open_newtab_prefs),
           494 => test_get_errors!(super::activity_stream::event_open_private_window),
           495 => test_get_errors!(super::activity_stream::event_pin),
           496 => test_get_errors!(super::activity_stream::event_pocket_thumbs_down),
           497 => test_get_errors!(super::activity_stream::event_pocket_thumbs_up),
           498 => test_get_errors!(super::activity_stream::event_pref_changed),
           499 => test_get_errors!(super::activity_stream::event_preview_request),
           500 => test_get_errors!(super::activity_stream::event_save_to_pocket),
           501 => test_get_errors!(super::activity_stream::event_search),
           502 => test_get_errors!(super::activity_stream::event_search_edit_add),
           503 => test_get_errors!(super::activity_stream::event_search_edit_close),
           504 => test_get_errors!(super::activity_stream::event_search_edit_delete),
           505 => test_get_errors!(super::activity_stream::event_search_handoff),
           506 => test_get_errors!(super::activity_stream::event_show_personalize),
           507 => test_get_errors!(super::activity_stream::event_show_privacy_info),
           508 => test_get_errors!(super::activity_stream::event_skipped_signin),
           509 => test_get_errors!(super::activity_stream::event_submit_email),
           510 => test_get_errors!(super::activity_stream::event_top_sites_edit),
           511 => test_get_errors!(super::activity_stream::event_top_sites_edit_close),
           512 => test_get_errors!(super::activity_stream::event_topsite_sponsor_info),
           513 => test_get_errors!(super::activity_stream::event_unpin),
           521 => test_get_errors!(super::newtab::closed),
           522 => test_get_errors!(super::newtab::fakespot_about_click),
           523 => test_get_errors!(super::newtab::fakespot_category),
           524 => test_get_errors!(super::newtab::fakespot_click),
           525 => test_get_errors!(super::newtab::fakespot_cta_click),
           526 => test_get_errors!(super::newtab::fakespot_dismiss),
           527 => test_get_errors!(super::newtab::fakespot_product_impression),
           529 => test_get_errors!(super::newtab::inline_selection_click),
           530 => test_get_errors!(super::newtab::inline_selection_impression),
           534 => test_get_errors!(super::newtab::opened),
           536 => test_get_errors!(super::newtab::report_content_open),
           537 => test_get_errors!(super::newtab::report_content_submit),
           538 => test_get_errors!(super::newtab::sections_block_section),
           539 => test_get_errors!(super::newtab::sections_follow_section),
           540 => test_get_errors!(super::newtab::sections_impression),
           541 => test_get_errors!(super::newtab::sections_unblock_section),
           542 => test_get_errors!(super::newtab::sections_unfollow_section),
           545 => test_get_errors!(super::newtab::tooltip_click),
           546 => test_get_errors!(super::newtab::topic_selection_dismiss),
           547 => test_get_errors!(super::newtab::topic_selection_open),
           548 => test_get_errors!(super::newtab::topic_selection_topics_saved),
           549 => test_get_errors!(super::newtab::wallpaper_category_click),
           550 => test_get_errors!(super::newtab::wallpaper_click),
           551 => test_get_errors!(super::newtab::wallpaper_highlight_cta_click),
           552 => test_get_errors!(super::newtab::wallpaper_highlight_dismissed),
           553 => test_get_errors!(super::newtab::weather_change_display),
           555 => test_get_errors!(super::newtab::weather_impression),
           556 => test_get_errors!(super::newtab::weather_load_error),
           557 => test_get_errors!(super::newtab::weather_location_selected),
           558 => test_get_errors!(super::newtab::weather_open_provider_url),
           561 => test_get_errors!(super::newtab_search::issued),
           564 => test_get_errors!(super::newtab_content::click),
           567 => test_get_errors!(super::newtab_content::dismiss),
           570 => test_get_errors!(super::newtab_content::impression),
           571 => test_get_errors!(super::newtab_content::sections_block_section),
           572 => test_get_errors!(super::newtab_content::sections_follow_section),
           573 => test_get_errors!(super::newtab_content::sections_impression),
           574 => test_get_errors!(super::newtab_content::sections_unblock_section),
           575 => test_get_errors!(super::newtab_content::sections_unfollow_section),
           577 => test_get_errors!(super::newtab_content::thumb_voting_interaction),
           579 => test_get_errors!(super::pocket::click),
           580 => test_get_errors!(super::pocket::dismiss),
           583 => test_get_errors!(super::pocket::impression),
           586 => test_get_errors!(super::pocket::save),
           589 => test_get_errors!(super::pocket::thumb_voting_interaction),
           590 => test_get_errors!(super::pocket::topic_click),
           598 => test_get_errors!(super::topsites::click),
           599 => test_get_errors!(super::topsites::dismiss),
           601 => test_get_errors!(super::topsites::impression),
           602 => test_get_errors!(super::topsites::pref_changed),
           604 => test_get_errors!(super::topsites::show_privacy_click),
           627 => test_get_errors!(super::aboutpreferences::show_click),
           628 => test_get_errors!(super::aboutpreferences::show_hash),
           629 => test_get_errors!(super::aboutpreferences::show_initial),
           630 => test_get_errors!(super::intl_ui_browser_language::accept_dialog),
           631 => test_get_errors!(super::intl_ui_browser_language::add_dialog),
           632 => test_get_errors!(super::intl_ui_browser_language::apply_main),
           633 => test_get_errors!(super::intl_ui_browser_language::cancel_dialog),
           634 => test_get_errors!(super::intl_ui_browser_language::manage_main),
           635 => test_get_errors!(super::intl_ui_browser_language::remove_dialog),
           636 => test_get_errors!(super::intl_ui_browser_language::reorder_dialog),
           637 => test_get_errors!(super::intl_ui_browser_language::reorder_main),
           638 => test_get_errors!(super::intl_ui_browser_language::search_dialog),
           639 => test_get_errors!(super::intl_ui_browser_language::search_main),
           640 => test_get_errors!(super::intl_ui_browser_language::set_fallback_dialog),
           641 => test_get_errors!(super::network_proxy_settings::proxy_type_preference),
           642 => test_get_errors!(super::privacy_ui_fpp_click::checkbox),
           643 => test_get_errors!(super::privacy_ui_fpp_click::menu),
           644 => test_get_errors!(super::security_doh_settings::mode_changed_button),
           645 => test_get_errors!(super::security_doh_settings::provider_choice_value),
           646 => test_get_errors!(super::aboutprivatebrowsing::click_dismiss_button),
           647 => test_get_errors!(super::aboutprivatebrowsing::click_info_link),
           648 => test_get_errors!(super::aboutprivatebrowsing::click_promo_link),
           649 => test_get_errors!(super::private_browsing_reset_pbm::confirm_panel),
           650 => test_get_errors!(super::private_browsing_reset_pbm::reset_action),
           651 => test_get_errors!(super::profiles_default::updated),
           652 => test_get_errors!(super::profiles_delete::cancel),
           653 => test_get_errors!(super::profiles_delete::confirm),
           654 => test_get_errors!(super::profiles_delete::displayed),
           655 => test_get_errors!(super::profiles_existing::alert),
           656 => test_get_errors!(super::profiles_existing::avatar),
           657 => test_get_errors!(super::profiles_existing::closed),
           658 => test_get_errors!(super::profiles_existing::deleted),
           659 => test_get_errors!(super::profiles_existing::displayed),
           660 => test_get_errors!(super::profiles_existing::learn_more),
           661 => test_get_errors!(super::profiles_existing::name),
           662 => test_get_errors!(super::profiles_existing::theme),
           663 => test_get_errors!(super::profiles_new::alert),
           664 => test_get_errors!(super::profiles_new::avatar),
           665 => test_get_errors!(super::profiles_new::closed),
           666 => test_get_errors!(super::profiles_new::deleted),
           667 => test_get_errors!(super::profiles_new::displayed),
           668 => test_get_errors!(super::profiles_new::learn_more),
           669 => test_get_errors!(super::profiles_new::name),
           670 => test_get_errors!(super::profiles_new::theme),
           671 => test_get_errors!(super::profiles_selector_window::launch),
           672 => test_get_errors!(super::profiles_selector_window::show_at_startup),
           673 => test_get_errors!(super::security_ui_protections::click_lw_about_link),
           674 => test_get_errors!(super::security_ui_protections::click_lw_open_button),
           675 => test_get_errors!(super::security_ui_protections::click_lw_sync_link),
           676 => test_get_errors!(super::security_ui_protections::click_mobile_app_link),
           677 => test_get_errors!(super::security_ui_protections::click_mtr_about_link),
           678 => test_get_errors!(super::security_ui_protections::click_mtr_report_link),
           679 => test_get_errors!(super::security_ui_protections::click_mtr_signup_button),
           680 => test_get_errors!(super::security_ui_protections::click_settings_link),
           681 => test_get_errors!(super::security_ui_protections::click_trackers_about_link),
           682 => test_get_errors!(super::security_ui_protections::click_vpn_app_link_android),
           683 => test_get_errors!(super::security_ui_protections::click_vpn_app_link_ios),
           684 => test_get_errors!(super::security_ui_protections::click_vpn_banner_close),
           685 => test_get_errors!(super::security_ui_protections::click_vpn_banner_link),
           686 => test_get_errors!(super::security_ui_protections::click_vpn_card_link),
           687 => test_get_errors!(super::security_ui_protections::close_protection_report),
           688 => test_get_errors!(super::security_ui_protections::show_protection_report),
           689 => test_get_errors!(super::security_ui_protections::show_vpn_banner),
           692 => test_get_errors!(super::protocolhandler_mailto::visit),
           693 => test_get_errors!(super::screenshots::canceled_context_menu),
           694 => test_get_errors!(super::screenshots::canceled_escape),
           695 => test_get_errors!(super::screenshots::canceled_navigation),
           696 => test_get_errors!(super::screenshots::canceled_overlay_cancel),
           697 => test_get_errors!(super::screenshots::canceled_preview_cancel),
           698 => test_get_errors!(super::screenshots::canceled_quick_actions),
           699 => test_get_errors!(super::screenshots::canceled_shortcut),
           700 => test_get_errors!(super::screenshots::canceled_toolbar_button),
           701 => test_get_errors!(super::screenshots::copy_overlay_copy),
           702 => test_get_errors!(super::screenshots::copy_preview_copy),
           703 => test_get_errors!(super::screenshots::download_overlay_download),
           704 => test_get_errors!(super::screenshots::download_preview_download),
           705 => test_get_errors!(super::screenshots::failed_screenshot_too_large),
           706 => test_get_errors!(super::screenshots::selected_element),
           707 => test_get_errors!(super::screenshots::selected_full_page),
           708 => test_get_errors!(super::screenshots::selected_region_selection),
           709 => test_get_errors!(super::screenshots::selected_visible),
           710 => test_get_errors!(super::screenshots::started_context_menu),
           711 => test_get_errors!(super::screenshots::started_overlay_retry),
           712 => test_get_errors!(super::screenshots::started_preview_retry),
           713 => test_get_errors!(super::screenshots::started_quick_actions),
           714 => test_get_errors!(super::screenshots::started_shortcut),
           715 => test_get_errors!(super::screenshots::started_toolbar_button),
           764 => test_get_errors!(super::newtab_search_ad::click),
           765 => test_get_errors!(super::newtab_search_ad::impression),
           766 => test_get_errors!(super::sap::counts),
           768 => test_get_errors!(super::sap::search_form_counts),
           772 => test_get_errors!(super::serp::abandonment),
           773 => test_get_errors!(super::serp::ad_impression),
           775 => test_get_errors!(super::serp::categorization),
           778 => test_get_errors!(super::serp::engagement),
           780 => test_get_errors!(super::serp::impression),
           798 => test_get_errors!(super::session_restore::backup_can_be_loaded_session_file),
           811 => test_get_errors!(super::session_restore::shutdown_success_session_startup),
           815 => test_get_errors!(super::shopping::address_bar_feature_callout_displayed),
           816 => test_get_errors!(super::shopping::address_bar_icon_clicked),
           817 => test_get_errors!(super::shopping::address_bar_icon_displayed),
           819 => test_get_errors!(super::shopping::surface_ads_clicked),
           820 => test_get_errors!(super::shopping::surface_ads_impression),
           821 => test_get_errors!(super::shopping::surface_ads_placement),
           822 => test_get_errors!(super::shopping::surface_ads_setting_toggled),
           823 => test_get_errors!(super::shopping::surface_analyze_reviews_none_available_clicked),
           824 => test_get_errors!(super::shopping::surface_auto_open_setting_toggled),
           825 => test_get_errors!(super::shopping::surface_closed),
           826 => test_get_errors!(super::shopping::surface_displayed),
           827 => test_get_errors!(super::shopping::surface_learn_more_clicked),
           828 => test_get_errors!(super::shopping::surface_no_ads_available),
           829 => test_get_errors!(super::shopping::surface_no_review_reliability_available),
           830 => test_get_errors!(super::shopping::surface_no_thanks_button_clicked),
           831 => test_get_errors!(super::shopping::surface_not_now_clicked),
           832 => test_get_errors!(super::shopping::surface_notification_card_dismiss_clicked),
           833 => test_get_errors!(super::shopping::surface_notification_card_impression),
           834 => test_get_errors!(super::shopping::surface_notification_card_move_left_clicked),
           835 => test_get_errors!(super::shopping::surface_notification_card_move_right_clicked),
           836 => test_get_errors!(super::shopping::surface_notification_card_sidebar_settings_clicked),
           837 => test_get_errors!(super::shopping::surface_onboarding_displayed),
           838 => test_get_errors!(super::shopping::surface_opt_in_clicked),
           839 => test_get_errors!(super::shopping::surface_opt_out_button_clicked),
           840 => test_get_errors!(super::shopping::surface_powered_by_fakespot_link_clicked),
           841 => test_get_errors!(super::shopping::surface_reactivated_button_clicked),
           842 => test_get_errors!(super::shopping::surface_reanalyze_clicked),
           843 => test_get_errors!(super::shopping::surface_settings_expand_clicked),
           844 => test_get_errors!(super::shopping::surface_show_more_reviews_button_clicked),
           845 => test_get_errors!(super::shopping::surface_show_privacy_policy_clicked),
           846 => test_get_errors!(super::shopping::surface_show_quality_explainer_clicked),
           847 => test_get_errors!(super::shopping::surface_show_quality_explainer_url_clicked),
           848 => test_get_errors!(super::shopping::surface_show_terms_clicked),
           849 => test_get_errors!(super::shopping::surface_stale_analysis_shown),
           850 => test_get_errors!(super::shopping::surface_yes_keep_closed_button_clicked),
           851 => test_get_errors!(super::shopping::sidebar_toggle),
           857 => test_get_errors!(super::bookmarks::sidebar_toggle),
           858 => test_get_errors!(super::contextual_manager::passwords_enabled),
           859 => test_get_errors!(super::contextual_manager::sidebar_toggle),
           860 => test_get_errors!(super::contextual_manager::notification_interaction),
           861 => test_get_errors!(super::contextual_manager::notification_shown),
           862 => test_get_errors!(super::contextual_manager::records_interaction),
           863 => test_get_errors!(super::contextual_manager::records_update),
           864 => test_get_errors!(super::contextual_manager::toolbar_action),
           865 => test_get_errors!(super::extension::sidebar_toggle),
           866 => test_get_errors!(super::history::sidebar_toggle),
           867 => test_get_errors!(super::sidebar::addon_icon_click),
           868 => test_get_errors!(super::sidebar::bookmarks_icon_click),
           869 => test_get_errors!(super::sidebar::chatbot_icon_click),
           871 => test_get_errors!(super::sidebar::expand),
           872 => test_get_errors!(super::sidebar::history_icon_click),
           873 => test_get_errors!(super::sidebar::keyboard_shortcut),
           876 => test_get_errors!(super::sidebar::resize),
           878 => test_get_errors!(super::sidebar::shopping_review_checker_icon_click),
           879 => test_get_errors!(super::sidebar::synced_tabs_icon_click),
           882 => test_get_errors!(super::sidebar_customize::bookmarks_enabled),
           883 => test_get_errors!(super::sidebar_customize::chatbot_enabled),
           884 => test_get_errors!(super::sidebar_customize::expand_on_hover_enabled),
           885 => test_get_errors!(super::sidebar_customize::extensions_clicked),
           886 => test_get_errors!(super::sidebar_customize::firefox_settings_clicked),
           887 => test_get_errors!(super::sidebar_customize::history_enabled),
           888 => test_get_errors!(super::sidebar_customize::icon_click),
           889 => test_get_errors!(super::sidebar_customize::panel_toggle),
           890 => test_get_errors!(super::sidebar_customize::shopping_review_checker_enabled),
           891 => test_get_errors!(super::sidebar_customize::sidebar_display),
           892 => test_get_errors!(super::sidebar_customize::sidebar_position),
           893 => test_get_errors!(super::sidebar_customize::synced_tabs_enabled),
           894 => test_get_errors!(super::sidebar_customize::tabs_display),
           895 => test_get_errors!(super::sidebar_customize::tabs_layout),
           896 => test_get_errors!(super::synced_tabs::sidebar_toggle),
           897 => test_get_errors!(super::synced_tabs::click_fxa_app_menu),
           898 => test_get_errors!(super::synced_tabs::click_fxa_avatar_menu),
           899 => test_get_errors!(super::synced_tabs::click_synced_tabs_sidebar),
           936 => test_get_errors!(super::tabgroup::add_tab),
           937 => test_get_errors!(super::tabgroup::create_group),
           938 => test_get_errors!(super::tabgroup::delete),
           940 => test_get_errors!(super::tabgroup::reopen),
           941 => test_get_errors!(super::tabgroup::save),
           943 => test_get_errors!(super::tabgroup::smart_tab),
           945 => test_get_errors!(super::tabgroup::smart_tab_optin),
           946 => test_get_errors!(super::tabgroup::smart_tab_suggest),
           947 => test_get_errors!(super::tabgroup::smart_tab_topic),
           952 => test_get_errors!(super::tabgroup::ungroup),
           975 => test_get_errors!(super::urlbar::abandonment),
           979 => test_get_errors!(super::urlbar::engagement),
           980 => test_get_errors!(super::urlbar::exposure),
           981 => test_get_errors!(super::urlbar::fakespot_engagement),
           982 => test_get_errors!(super::urlbar::keyword_exposure),
           988 => test_get_errors!(super::urlbar::quick_suggest_contextual_opt_in),
           998 => test_get_errors!(super::addons_search_detection::etld_change_other),
           999 => test_get_errors!(super::addons_search_detection::etld_change_webrequest),
           1014 => test_get_errors!(super::browser_usage::interaction),
           1015 => test_get_errors!(super::homepage::preference_ignore),
           1016 => test_get_errors!(super::installation::first_seen_full),
           1017 => test_get_errors!(super::installation::first_seen_msix),
           1018 => test_get_errors!(super::installation::first_seen_stub),
           1032 => test_get_errors!(super::partner_link::attribution_abort),
           1033 => test_get_errors!(super::partner_link::attribution_failure),
           1034 => test_get_errors!(super::partner_link::attribution_success),
           1035 => test_get_errors!(super::partner_link::click_newtab),
           1036 => test_get_errors!(super::partner_link::click_urlbar),
           1135 => test_get_errors!(super::devtools_main::activate_responsive_design),
           1136 => test_get_errors!(super::devtools_main::activate_split_console),
           1137 => test_get_errors!(super::devtools_main::add_breakpoint_debugger),
           1138 => test_get_errors!(super::devtools_main::blackbox_debugger),
           1139 => test_get_errors!(super::devtools_main::close_adbg_aboutdebugging),
           1140 => test_get_errors!(super::devtools_main::close_tools),
           1141 => test_get_errors!(super::devtools_main::connection_attempt_aboutdebugging),
           1142 => test_get_errors!(super::devtools_main::continue_debugger),
           1143 => test_get_errors!(super::devtools_main::deactivate_responsive_design),
           1144 => test_get_errors!(super::devtools_main::deactivate_split_console),
           1145 => test_get_errors!(super::devtools_main::device_added_aboutdebugging),
           1146 => test_get_errors!(super::devtools_main::device_removed_aboutdebugging),
           1147 => test_get_errors!(super::devtools_main::edit_html_inspector),
           1148 => test_get_errors!(super::devtools_main::edit_resend_netmonitor),
           1149 => test_get_errors!(super::devtools_main::edit_rule_ruleview),
           1150 => test_get_errors!(super::devtools_main::enter_accessibility),
           1151 => test_get_errors!(super::devtools_main::enter_application),
           1152 => test_get_errors!(super::devtools_main::enter_dom),
           1153 => test_get_errors!(super::devtools_main::enter_fake_tool4242),
           1154 => test_get_errors!(super::devtools_main::enter_inspector),
           1155 => test_get_errors!(super::devtools_main::enter_jsdebugger),
           1156 => test_get_errors!(super::devtools_main::enter_memory),
           1157 => test_get_errors!(super::devtools_main::enter_netmonitor),
           1158 => test_get_errors!(super::devtools_main::enter_options),
           1159 => test_get_errors!(super::devtools_main::enter_other),
           1160 => test_get_errors!(super::devtools_main::enter_performance),
           1161 => test_get_errors!(super::devtools_main::enter_storage),
           1162 => test_get_errors!(super::devtools_main::enter_styleeditor),
           1163 => test_get_errors!(super::devtools_main::enter_test_blank_panel),
           1164 => test_get_errors!(super::devtools_main::enter_test_tool),
           1165 => test_get_errors!(super::devtools_main::enter_test_tool1072208),
           1166 => test_get_errors!(super::devtools_main::enter_testtool1),
           1167 => test_get_errors!(super::devtools_main::enter_testtool2),
           1168 => test_get_errors!(super::devtools_main::enter_webconsole),
           1169 => test_get_errors!(super::devtools_main::enter_whatsnew),
           1170 => test_get_errors!(super::devtools_main::execute_js_webconsole),
           1171 => test_get_errors!(super::devtools_main::exit_accessibility),
           1172 => test_get_errors!(super::devtools_main::exit_application),
           1173 => test_get_errors!(super::devtools_main::exit_dom),
           1174 => test_get_errors!(super::devtools_main::exit_fake_tool4242),
           1175 => test_get_errors!(super::devtools_main::exit_inspector),
           1176 => test_get_errors!(super::devtools_main::exit_jsdebugger),
           1177 => test_get_errors!(super::devtools_main::exit_memory),
           1178 => test_get_errors!(super::devtools_main::exit_netmonitor),
           1179 => test_get_errors!(super::devtools_main::exit_options),
           1180 => test_get_errors!(super::devtools_main::exit_other),
           1181 => test_get_errors!(super::devtools_main::exit_performance),
           1182 => test_get_errors!(super::devtools_main::exit_storage),
           1183 => test_get_errors!(super::devtools_main::exit_styleeditor),
           1184 => test_get_errors!(super::devtools_main::exit_test_blank_panel),
           1185 => test_get_errors!(super::devtools_main::exit_test_tool),
           1186 => test_get_errors!(super::devtools_main::exit_test_tool1072208),
           1187 => test_get_errors!(super::devtools_main::exit_testtool1),
           1188 => test_get_errors!(super::devtools_main::exit_testtool2),
           1189 => test_get_errors!(super::devtools_main::exit_webconsole),
           1190 => test_get_errors!(super::devtools_main::exit_whatsnew),
           1191 => test_get_errors!(super::devtools_main::filters_changed_netmonitor),
           1192 => test_get_errors!(super::devtools_main::filters_changed_webconsole),
           1193 => test_get_errors!(super::devtools_main::inspect_aboutdebugging),
           1194 => test_get_errors!(super::devtools_main::jump_to_definition_webconsole),
           1195 => test_get_errors!(super::devtools_main::jump_to_source_webconsole),
           1196 => test_get_errors!(super::devtools_main::object_expanded_webconsole),
           1197 => test_get_errors!(super::devtools_main::open_adbg_aboutdebugging),
           1198 => test_get_errors!(super::devtools_main::open_tools),
           1199 => test_get_errors!(super::devtools_main::pause_debugger),
           1200 => test_get_errors!(super::devtools_main::pause_on_exceptions_debugger),
           1201 => test_get_errors!(super::devtools_main::persist_changed_netmonitor),
           1202 => test_get_errors!(super::devtools_main::persist_changed_webconsole),
           1203 => test_get_errors!(super::devtools_main::pretty_print_debugger),
           1204 => test_get_errors!(super::devtools_main::remove_breakpoint_debugger),
           1205 => test_get_errors!(super::devtools_main::reverse_search_webconsole),
           1206 => test_get_errors!(super::devtools_main::runtime_added_aboutdebugging),
           1207 => test_get_errors!(super::devtools_main::runtime_connected_aboutdebugging),
           1208 => test_get_errors!(super::devtools_main::runtime_disconnected_aboutdebugging),
           1209 => test_get_errors!(super::devtools_main::runtime_removed_aboutdebugging),
           1210 => test_get_errors!(super::devtools_main::select_page_aboutdebugging),
           1211 => test_get_errors!(super::devtools_main::select_page_application),
           1212 => test_get_errors!(super::devtools_main::select_ws_frame_netmonitor),
           1213 => test_get_errors!(super::devtools_main::show_profiler_aboutdebugging),
           1214 => test_get_errors!(super::devtools_main::sidepanel_changed_inspector),
           1215 => test_get_errors!(super::devtools_main::sidepanel_changed_netmonitor),
           1216 => test_get_errors!(super::devtools_main::start_worker_application),
           1217 => test_get_errors!(super::devtools_main::throttle_changed_netmonitor),
           1218 => test_get_errors!(super::devtools_main::tool_timer_animationinspector),
           1219 => test_get_errors!(super::devtools_main::tool_timer_changesview),
           1220 => test_get_errors!(super::devtools_main::tool_timer_compatibilityview),
           1221 => test_get_errors!(super::devtools_main::tool_timer_computedview),
           1222 => test_get_errors!(super::devtools_main::tool_timer_fontinspector),
           1223 => test_get_errors!(super::devtools_main::tool_timer_layoutview),
           1224 => test_get_errors!(super::devtools_main::tool_timer_ruleview),
           1225 => test_get_errors!(super::devtools_main::unregister_worker_application),
           1226 => test_get_errors!(super::devtools_main::update_conn_prompt_aboutdebugging),
           3656 => test_get_errors!(super::mediadrm::eme_playback),
           3659 => test_get_errors!(super::hls::media_load),
           3664 => test_get_errors!(super::media::error),
           3686 => test_get_errors!(super::media_playback::decode_error),
           3688 => test_get_errors!(super::media_playback::first_frame_loaded),
           3693 => test_get_errors!(super::mfcdm::eme_playback),
           3694 => test_get_errors!(super::mfcdm::error),
           3749 => test_get_errors!(super::webrtc_signaling::audio_msection_negotiated),
           3750 => test_get_errors!(super::webrtc_signaling::sdp_negotiated),
           3751 => test_get_errors!(super::webrtc_signaling::video_msection_negotiated),
           3802 => test_get_errors!(super::perf::page_load),
           3835 => test_get_errors!(super::dom_quota_try::error_step),
           3984 => test_get_errors!(super::avif::dav1d_get_picture_return_value),
           4063 => test_get_errors!(super::slow_script_warning::shown_browser),
           4064 => test_get_errors!(super::slow_script_warning::shown_content),
           4083 => test_get_errors!(super::zero_byte_load::load_css),
           4084 => test_get_errors!(super::zero_byte_load::load_dtd),
           4085 => test_get_errors!(super::zero_byte_load::load_ftl),
           4086 => test_get_errors!(super::zero_byte_load::load_html),
           4087 => test_get_errors!(super::zero_byte_load::load_js),
           4088 => test_get_errors!(super::zero_byte_load::load_json),
           4089 => test_get_errors!(super::zero_byte_load::load_others),
           4090 => test_get_errors!(super::zero_byte_load::load_png),
           4091 => test_get_errors!(super::zero_byte_load::load_properties),
           4092 => test_get_errors!(super::zero_byte_load::load_svg),
           4093 => test_get_errors!(super::zero_byte_load::load_xhtml),
           4094 => test_get_errors!(super::zero_byte_load::load_xml),
           4207 => test_get_errors!(super::network_dns::trr_confirmation_context),
           4325 => test_get_errors!(super::ysod::shown_ysod),
           4411 => test_get_errors!(super::uptake_remotecontent_result::uptake_normandy),
           4412 => test_get_errors!(super::uptake_remotecontent_result::uptake_remotesettings),
           4415 => test_get_errors!(super::fxa::connect_account),
           4416 => test_get_errors!(super::fxa::disconnect_account),
           4417 => test_get_errors!(super::sync_settings::open_choose_what_to_sync_menu),
           4418 => test_get_errors!(super::sync_settings::save),
           4419 => test_get_errors!(super::fxa_app_menu::click_account_settings),
           4420 => test_get_errors!(super::fxa_app_menu::click_cad),
           4421 => test_get_errors!(super::fxa_app_menu::click_login),
           4422 => test_get_errors!(super::fxa_app_menu::click_monitor_cta),
           4423 => test_get_errors!(super::fxa_app_menu::click_open_monitor),
           4424 => test_get_errors!(super::fxa_app_menu::click_open_send),
           4425 => test_get_errors!(super::fxa_app_menu::click_relay_cta),
           4426 => test_get_errors!(super::fxa_app_menu::click_send_tab),
           4427 => test_get_errors!(super::fxa_app_menu::click_sync_cta),
           4428 => test_get_errors!(super::fxa_app_menu::click_sync_now),
           4429 => test_get_errors!(super::fxa_app_menu::click_sync_settings),
           4430 => test_get_errors!(super::fxa_app_menu::click_sync_tabs),
           4431 => test_get_errors!(super::fxa_app_menu::click_sync_tabs_sidebar),
           4432 => test_get_errors!(super::fxa_app_menu::click_toolbar_icon),
           4433 => test_get_errors!(super::fxa_app_menu::click_unver_sync_settings),
           4434 => test_get_errors!(super::fxa_app_menu::click_vpn_cta),
           4435 => test_get_errors!(super::fxa_avatar_menu::click_account_settings),
           4436 => test_get_errors!(super::fxa_avatar_menu::click_cad),
           4437 => test_get_errors!(super::fxa_avatar_menu::click_login),
           4438 => test_get_errors!(super::fxa_avatar_menu::click_monitor_cta),
           4439 => test_get_errors!(super::fxa_avatar_menu::click_open_monitor),
           4440 => test_get_errors!(super::fxa_avatar_menu::click_open_send),
           4441 => test_get_errors!(super::fxa_avatar_menu::click_relay_cta),
           4442 => test_get_errors!(super::fxa_avatar_menu::click_send_tab),
           4443 => test_get_errors!(super::fxa_avatar_menu::click_sync_cta),
           4444 => test_get_errors!(super::fxa_avatar_menu::click_sync_now),
           4445 => test_get_errors!(super::fxa_avatar_menu::click_sync_settings),
           4446 => test_get_errors!(super::fxa_avatar_menu::click_sync_tabs),
           4447 => test_get_errors!(super::fxa_avatar_menu::click_sync_tabs_sidebar),
           4448 => test_get_errors!(super::fxa_avatar_menu::click_toolbar_icon),
           4449 => test_get_errors!(super::fxa_avatar_menu::click_unver_sync_settings),
           4450 => test_get_errors!(super::fxa_avatar_menu::click_vpn_cta),
           4453 => test_get_errors!(super::sync_merge_dialog::clicked),
           4457 => test_get_errors!(super::bounce_tracking_protection::purge_action),
           4490 => test_get_errors!(super::background_tasks_rmdir_base::metric_base),
           4498 => test_get_errors!(super::background_tasks_rmdir_http_cache::metric_base),
           4506 => test_get_errors!(super::background_tasks_rmdir_quota::metric_base),
           4566 => test_get_errors!(super::relevancy_classify::fail),
           4567 => test_get_errors!(super::relevancy_classify::succeed),
           4569 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event),
           4570 => test_get_errors!(super::cookie_banners::google_gdpr_choice_cookie_event_pbm),
           4646 => test_get_errors!(super::doh::evaluate_v2_heuristics),
           4647 => test_get_errors!(super::doh::state_disabled),
           4648 => test_get_errors!(super::doh::state_enabled),
           4649 => test_get_errors!(super::doh::state_manually_disabled),
           4650 => test_get_errors!(super::doh::state_policy_disabled),
           4651 => test_get_errors!(super::doh::state_rollback),
           4652 => test_get_errors!(super::doh::state_shutdown),
           4653 => test_get_errors!(super::doh::state_uidisabled),
           4654 => test_get_errors!(super::doh::state_uiok),
           4655 => test_get_errors!(super::doh::state_uninstalled),
           4656 => test_get_errors!(super::security_doh_trr_performance::resolved_record),
           4657 => test_get_errors!(super::security_doh_trr_performance::trrselect_dryrunresult),
           4676 => test_get_errors!(super::extensions_data::migrate_result),
           4678 => test_get_errors!(super::extensions_data::storage_local_error),
           4679 => test_get_errors!(super::extensions_data::sync_usage_quotas),
           4696 => test_get_errors!(super::address::add_manage),
           4697 => test_get_errors!(super::address::cancel_capture_doorhanger),
           4698 => test_get_errors!(super::address::cancel_edit_doorhanger),
           4699 => test_get_errors!(super::address::cancel_update_doorhanger),
           4700 => test_get_errors!(super::address::cleared_address_form),
           4701 => test_get_errors!(super::address::delete_manage),
           4702 => test_get_errors!(super::address::detected_address_form),
           4703 => test_get_errors!(super::address::detected_address_form_ext),
           4704 => test_get_errors!(super::address::disable_capture_doorhanger),
           4705 => test_get_errors!(super::address::disable_edit_doorhanger),
           4706 => test_get_errors!(super::address::disable_update_doorhanger),
           4707 => test_get_errors!(super::address::edit_manage),
           4708 => test_get_errors!(super::address::filled_address_form),
           4709 => test_get_errors!(super::address::filled_address_form_ext),
           4710 => test_get_errors!(super::address::filled_modified_address_form),
           4711 => test_get_errors!(super::address::filled_on_fields_update_address_form),
           4712 => test_get_errors!(super::address::learn_more_capture_doorhanger),
           4713 => test_get_errors!(super::address::learn_more_edit_doorhanger),
           4714 => test_get_errors!(super::address::learn_more_update_doorhanger),
           4715 => test_get_errors!(super::address::popup_shown_address_form),
           4716 => test_get_errors!(super::address::pref_capture_doorhanger),
           4717 => test_get_errors!(super::address::pref_edit_doorhanger),
           4718 => test_get_errors!(super::address::pref_update_doorhanger),
           4719 => test_get_errors!(super::address::save_capture_doorhanger),
           4720 => test_get_errors!(super::address::save_edit_doorhanger),
           4721 => test_get_errors!(super::address::save_update_doorhanger),
           4722 => test_get_errors!(super::address::show_capture_doorhanger),
           4723 => test_get_errors!(super::address::show_edit_doorhanger),
           4724 => test_get_errors!(super::address::show_entry_manage),
           4725 => test_get_errors!(super::address::show_manage),
           4726 => test_get_errors!(super::address::show_update_doorhanger),
           4727 => test_get_errors!(super::address::submitted_address_form),
           4728 => test_get_errors!(super::address::submitted_address_form_ext),
           4729 => test_get_errors!(super::address::update_capture_doorhanger),
           4730 => test_get_errors!(super::address::update_edit_doorhanger),
           4731 => test_get_errors!(super::address::update_update_doorhanger),
           4732 => test_get_errors!(super::creditcard::add_manage),
           4733 => test_get_errors!(super::creditcard::cancel_capture_doorhanger),
           4734 => test_get_errors!(super::creditcard::cancel_update_doorhanger),
           4735 => test_get_errors!(super::creditcard::cleared_cc_form_v2),
           4736 => test_get_errors!(super::creditcard::delete_manage),
           4737 => test_get_errors!(super::creditcard::detected_cc_form_v2),
           4739 => test_get_errors!(super::creditcard::disable_capture_doorhanger),
           4740 => test_get_errors!(super::creditcard::disable_update_doorhanger),
           4741 => test_get_errors!(super::creditcard::edit_manage),
           4742 => test_get_errors!(super::creditcard::filled_cc_form_v2),
           4743 => test_get_errors!(super::creditcard::filled_modified_cc_form_v2),
           4744 => test_get_errors!(super::creditcard::filled_on_fields_update_cc_form_v2),
           4745 => test_get_errors!(super::creditcard::os_keystore_decrypt),
           4746 => test_get_errors!(super::creditcard::popup_shown_cc_form_v2),
           4747 => test_get_errors!(super::creditcard::save_capture_doorhanger),
           4748 => test_get_errors!(super::creditcard::save_update_doorhanger),
           4749 => test_get_errors!(super::creditcard::show_capture_doorhanger),
           4750 => test_get_errors!(super::creditcard::show_entry_manage),
           4751 => test_get_errors!(super::creditcard::show_manage),
           4752 => test_get_errors!(super::creditcard::show_update_doorhanger),
           4753 => test_get_errors!(super::creditcard::submitted_cc_form_v2),
           4754 => test_get_errors!(super::creditcard::update_capture_doorhanger),
           4755 => test_get_errors!(super::creditcard::update_update_doorhanger),
           4758 => test_get_errors!(super::formautofill::iframe_layout_detection),
           4760 => test_get_errors!(super::formautofill::prompt_shown_os_reauth),
           4761 => test_get_errors!(super::formautofill::require_os_reauth_toggle),
           4764 => test_get_errors!(super::formautofill_ml::field_infer_result),
           4836 => test_get_errors!(super::test_only_ipc::an_event),
           4841 => test_get_errors!(super::test_only_ipc::event_with_extra),
           4843 => test_get_errors!(super::test_only_ipc::no_extra_event),
           4846 => test_get_errors!(super::test_only_jog::an_event),
           4848 => test_get_errors!(super::messaging_experiments::reach_cfr),
           4849 => test_get_errors!(super::messaging_experiments::reach_feature_callout),
           4850 => test_get_errors!(super::messaging_experiments::reach_fxms_bmb_button),
           4851 => test_get_errors!(super::messaging_experiments::reach_fxms_message_1),
           4852 => test_get_errors!(super::messaging_experiments::reach_fxms_message_10),
           4853 => test_get_errors!(super::messaging_experiments::reach_fxms_message_11),
           4854 => test_get_errors!(super::messaging_experiments::reach_fxms_message_2),
           4855 => test_get_errors!(super::messaging_experiments::reach_fxms_message_3),
           4856 => test_get_errors!(super::messaging_experiments::reach_fxms_message_4),
           4857 => test_get_errors!(super::messaging_experiments::reach_fxms_message_5),
           4858 => test_get_errors!(super::messaging_experiments::reach_fxms_message_6),
           4859 => test_get_errors!(super::messaging_experiments::reach_fxms_message_7),
           4860 => test_get_errors!(super::messaging_experiments::reach_fxms_message_8),
           4861 => test_get_errors!(super::messaging_experiments::reach_fxms_message_9),
           4862 => test_get_errors!(super::messaging_experiments::reach_infobar),
           4863 => test_get_errors!(super::messaging_experiments::reach_moments_page),
           4864 => test_get_errors!(super::messaging_experiments::reach_spotlight),
           4865 => test_get_errors!(super::messaging_experiments::targeting_attribute_error),
           4866 => test_get_errors!(super::messaging_experiments::targeting_attribute_timeout),
           4867 => test_get_errors!(super::firefox_ai_runtime::engine_creation_failure),
           4869 => test_get_errors!(super::firefox_ai_runtime::run_inference_failure),
           4871 => test_get_errors!(super::nimbus_events::enroll_failed),
           4872 => test_get_errors!(super::nimbus_events::enrollment),
           4873 => test_get_errors!(super::nimbus_events::enrollment_status),
           4874 => test_get_errors!(super::nimbus_events::exposure),
           4875 => test_get_errors!(super::nimbus_events::is_ready),
           4876 => test_get_errors!(super::nimbus_events::migration),
           4877 => test_get_errors!(super::nimbus_events::unenroll_failed),
           4878 => test_get_errors!(super::nimbus_events::unenrollment),
           4879 => test_get_errors!(super::nimbus_events::validation_failed),
           4916 => test_get_errors!(super::normandy::expose_nimbus_experiment),
           4917 => test_get_errors!(super::normandy::enroll_addon_rollout),
           4918 => test_get_errors!(super::normandy::enroll_addon_study),
           4919 => test_get_errors!(super::normandy::enroll_failed_addon_rollout),
           4920 => test_get_errors!(super::normandy::enroll_failed_addon_study),
           4921 => test_get_errors!(super::normandy::enroll_failed_nimbus_experiment),
           4922 => test_get_errors!(super::normandy::enroll_failed_preference_rollout),
           4923 => test_get_errors!(super::normandy::enroll_failed_preference_study),
           4924 => test_get_errors!(super::normandy::enroll_nimbus_experiment),
           4925 => test_get_errors!(super::normandy::enroll_preference_rollout),
           4926 => test_get_errors!(super::normandy::enroll_preference_study),
           4927 => test_get_errors!(super::normandy::exp_pref_changed_preference_study),
           4928 => test_get_errors!(super::normandy::graduate_preference_rollout),
           4930 => test_get_errors!(super::normandy::unenroll_addon_rollback),
           4931 => test_get_errors!(super::normandy::unenroll_addon_study),
           4932 => test_get_errors!(super::normandy::unenroll_failed_addon_rollback),
           4933 => test_get_errors!(super::normandy::unenroll_failed_nimbus_experiment),
           4934 => test_get_errors!(super::normandy::unenroll_failed_preference_rollback),
           4935 => test_get_errors!(super::normandy::unenroll_failed_preference_study),
           4936 => test_get_errors!(super::normandy::unenroll_nimbus_experiment),
           4937 => test_get_errors!(super::normandy::unenroll_preference_rollback),
           4938 => test_get_errors!(super::normandy::unenroll_preference_study),
           4939 => test_get_errors!(super::normandy::update_addon_rollout),
           4940 => test_get_errors!(super::normandy::update_addon_study),
           4941 => test_get_errors!(super::normandy::update_failed_addon_rollout),
           4942 => test_get_errors!(super::normandy::update_failed_addon_study),
           4943 => test_get_errors!(super::normandy::update_nimbus_experiment),
           4944 => test_get_errors!(super::normandy::update_preference_rollout),
           4945 => test_get_errors!(super::normandy::validation_failed_nimbus_experiment),
           4946 => test_get_errors!(super::form_autocomplete::show_logins),
           4947 => test_get_errors!(super::pwmgr::autocomplete_field_generatedpassword),
           4948 => test_get_errors!(super::pwmgr::autocomplete_shown_generatedpassword),
           4949 => test_get_errors!(super::pwmgr::cancel_existing_login),
           4950 => test_get_errors!(super::pwmgr::cancel_new_login),
           4951 => test_get_errors!(super::pwmgr::copy_password),
           4952 => test_get_errors!(super::pwmgr::copy_username),
           4953 => test_get_errors!(super::pwmgr::delete_existing_login),
           4954 => test_get_errors!(super::pwmgr::delete_new_login),
           4955 => test_get_errors!(super::pwmgr::doorhanger_submitted_save),
           4956 => test_get_errors!(super::pwmgr::doorhanger_submitted_update),
           4957 => test_get_errors!(super::pwmgr::edit_existing_login),
           4958 => test_get_errors!(super::pwmgr::filled_field_edited_generatedpassword),
           4959 => test_get_errors!(super::pwmgr::filter_list),
           4961 => test_get_errors!(super::pwmgr::hide_password),
           4964 => test_get_errors!(super::pwmgr::learn_more_vuln_existing_login),
           4966 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_export),
           4967 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_export_complete),
           4968 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_csv_complete),
           4969 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_from_browser),
           4970 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_import_from_csv),
           4971 => test_get_errors!(super::pwmgr::mgmt_menu_item_used_preferences),
           4972 => test_get_errors!(super::pwmgr::new_new_login),
           4975 => test_get_errors!(super::pwmgr::open_management_aboutprotections),
           4976 => test_get_errors!(super::pwmgr::open_management_autocomplete),
           4977 => test_get_errors!(super::pwmgr::open_management_contextmenu),
           4978 => test_get_errors!(super::pwmgr::open_management_direct),
           4979 => test_get_errors!(super::pwmgr::open_management_mainmenu),
           4980 => test_get_errors!(super::pwmgr::open_management_pageinfo),
           4981 => test_get_errors!(super::pwmgr::open_management_preferences),
           4982 => test_get_errors!(super::pwmgr::open_management_snippet),
           4983 => test_get_errors!(super::pwmgr::open_site_existing_login),
           4987 => test_get_errors!(super::pwmgr::prompt_shown_os_reauth),
           4989 => test_get_errors!(super::pwmgr::reauthenticate_master_password),
           4990 => test_get_errors!(super::pwmgr::reauthenticate_os_auth),
           4991 => test_get_errors!(super::pwmgr::require_os_reauth_toggle),
           4992 => test_get_errors!(super::pwmgr::save_existing_login),
           4993 => test_get_errors!(super::pwmgr::save_new_login),
           4994 => test_get_errors!(super::pwmgr::saved_login_used_auth_login),
           4995 => test_get_errors!(super::pwmgr::saved_login_used_form_login),
           4996 => test_get_errors!(super::pwmgr::saved_login_used_form_password),
           4997 => test_get_errors!(super::pwmgr::saved_login_used_prompt_login),
           4999 => test_get_errors!(super::pwmgr::select_existing_login),
           5000 => test_get_errors!(super::pwmgr::show_password),
           5002 => test_get_errors!(super::pwmgr::sort_list),
           5003 => test_get_errors!(super::relay_integration::clicked_fill_username),
           5004 => test_get_errors!(super::relay_integration::clicked_offer_relay),
           5005 => test_get_errors!(super::relay_integration::disabled_opt_in_panel),
           5006 => test_get_errors!(super::relay_integration::disabled_pref_change),
           5007 => test_get_errors!(super::relay_integration::enabled_opt_in_panel),
           5008 => test_get_errors!(super::relay_integration::enabled_pref_change),
           5009 => test_get_errors!(super::relay_integration::get_unlimited_masks_reuse_panel),
           5010 => test_get_errors!(super::relay_integration::postponed_opt_in_panel),
           5011 => test_get_errors!(super::relay_integration::reuse_mask_reuse_panel),
           5012 => test_get_errors!(super::relay_integration::shown_fill_username),
           5013 => test_get_errors!(super::relay_integration::shown_offer_relay),
           5014 => test_get_errors!(super::relay_integration::shown_opt_in_panel),
           5015 => test_get_errors!(super::relay_integration::shown_reuse_panel),
           5034 => test_get_errors!(super::pdfjs_image::add_image_click),
           5037 => test_get_errors!(super::pdfjs_image::icon_click),
           5038 => test_get_errors!(super::pdfjs_image::image_added),
           5039 => test_get_errors!(super::pdfjs_image::image_selected),
           5040 => test_get_errors!(super::pdfjs_image_alt_text::ai_generation_check),
           5041 => test_get_errors!(super::pdfjs_image_alt_text::callout_dismissed),
           5042 => test_get_errors!(super::pdfjs_image_alt_text::callout_displayed),
           5043 => test_get_errors!(super::pdfjs_image_alt_text::dismiss),
           5044 => test_get_errors!(super::pdfjs_image_alt_text::image_status_label_clicked),
           5045 => test_get_errors!(super::pdfjs_image_alt_text::image_status_label_displayed),
           5046 => test_get_errors!(super::pdfjs_image_alt_text::info),
           5047 => test_get_errors!(super::pdfjs_image_alt_text::model_deleted),
           5048 => test_get_errors!(super::pdfjs_image_alt_text::model_download_complete),
           5049 => test_get_errors!(super::pdfjs_image_alt_text::model_download_error),
           5050 => test_get_errors!(super::pdfjs_image_alt_text::model_download_start),
           5051 => test_get_errors!(super::pdfjs_image_alt_text::model_result),
           5052 => test_get_errors!(super::pdfjs_image_alt_text::save),
           5053 => test_get_errors!(super::pdfjs_image_alt_text::settings_ai_generation_check),
           5054 => test_get_errors!(super::pdfjs_image_alt_text::settings_displayed),
           5055 => test_get_errors!(super::pdfjs_image_alt_text::settings_edit_alt_text_check),
           5056 => test_get_errors!(super::pdfjs_image_alt_text::user_edit),
           5057 => test_get_errors!(super::pdfjs_signature::added),
           5059 => test_get_errors!(super::pdfjs_signature::created),
           5060 => test_get_errors!(super::pdfjs_signature::delete_saved),
           5062 => test_get_errors!(super::pdfjs_signature::inserted),
           5064 => test_get_errors!(super::pictureinpicture::closed_method_browser_crash),
           5065 => test_get_errors!(super::pictureinpicture::closed_method_close_button),
           5066 => test_get_errors!(super::pictureinpicture::closed_method_close_player_shortcut),
           5067 => test_get_errors!(super::pictureinpicture::closed_method_context_menu),
           5068 => test_get_errors!(super::pictureinpicture::closed_method_foregrounded),
           5069 => test_get_errors!(super::pictureinpicture::closed_method_fullscreen),
           5070 => test_get_errors!(super::pictureinpicture::closed_method_pagehide),
           5071 => test_get_errors!(super::pictureinpicture::closed_method_setup_failure),
           5072 => test_get_errors!(super::pictureinpicture::closed_method_shortcut),
           5073 => test_get_errors!(super::pictureinpicture::closed_method_unpip),
           5074 => test_get_errors!(super::pictureinpicture::closed_method_url_bar),
           5075 => test_get_errors!(super::pictureinpicture::closed_method_video_el_emptied),
           5076 => test_get_errors!(super::pictureinpicture::closed_method_video_el_remove),
           5077 => test_get_errors!(super::pictureinpicture::create_player),
           5078 => test_get_errors!(super::pictureinpicture::disrespect_disable_url_bar),
           5080 => test_get_errors!(super::pictureinpicture::fullscreen_player),
           5082 => test_get_errors!(super::pictureinpicture::opened_method_auto_pip),
           5083 => test_get_errors!(super::pictureinpicture::opened_method_context_menu),
           5084 => test_get_errors!(super::pictureinpicture::opened_method_shortcut),
           5085 => test_get_errors!(super::pictureinpicture::opened_method_toggle),
           5086 => test_get_errors!(super::pictureinpicture::opened_method_url_bar),
           5087 => test_get_errors!(super::pictureinpicture::resize_player),
           5088 => test_get_errors!(super::pictureinpicture::saw_toggle_toggle),
           5089 => test_get_errors!(super::pictureinpicture::subtitles_shown_subtitles),
           5092 => test_get_errors!(super::pictureinpicture_settings::disable_player),
           5093 => test_get_errors!(super::pictureinpicture_settings::disable_settings),
           5094 => test_get_errors!(super::pictureinpicture_settings::enable_autotrigger_settings),
           5095 => test_get_errors!(super::pictureinpicture_settings::enable_settings),
           5150 => test_get_errors!(super::readermode::button_click),
           5153 => test_get_errors!(super::readermode::view_off),
           5154 => test_get_errors!(super::readermode::view_on),
           5196 => test_get_errors!(super::webcompatreporting::opened),
           5197 => test_get_errors!(super::webcompatreporting::reason_dropdown),
           5198 => test_get_errors!(super::webcompatreporting::send),
           5199 => test_get_errors!(super::webcompatreporting::send_more_info),
           5487 => test_get_errors!(super::search_engine_default::changed),
           5495 => test_get_errors!(super::search_engine_private::changed),
           5508 => test_get_errors!(super::shopping_product::invalid_ohttp_config),
           5509 => test_get_errors!(super::shopping_product::invalid_request),
           5510 => test_get_errors!(super::shopping_product::invalid_response),
           5511 => test_get_errors!(super::shopping_product::request_aborted),
           5512 => test_get_errors!(super::shopping_product::request_error),
           5513 => test_get_errors!(super::shopping_product::request_failure),
           5514 => test_get_errors!(super::shopping_product::request_retried),
           5515 => test_get_errors!(super::shopping_product::request_retries_failed),
           5516 => test_get_errors!(super::shopping_product::server_failure),
           5571 => test_get_errors!(super::telemetry_test::test1_object1),
           5572 => test_get_errors!(super::telemetry_test::test2_object1),
           5573 => test_get_errors!(super::telemetry_test::test2_object2),
           5581 => test_get_errors!(super::translations::engine_performance),
           5582 => test_get_errors!(super::translations::error),
           5584 => test_get_errors!(super::translations::restore_page),
           5585 => test_get_errors!(super::translations::translation_request),
           5586 => test_get_errors!(super::translations_about_translations_page::open),
           5587 => test_get_errors!(super::translations_panel::about_translations),
           5588 => test_get_errors!(super::translations_panel::always_offer_translations),
           5589 => test_get_errors!(super::translations_panel::always_translate_language),
           5590 => test_get_errors!(super::translations_panel::cancel_button),
           5591 => test_get_errors!(super::translations_panel::change_from_language),
           5592 => test_get_errors!(super::translations_panel::change_source_language_button),
           5593 => test_get_errors!(super::translations_panel::change_to_language),
           5594 => test_get_errors!(super::translations_panel::close),
           5595 => test_get_errors!(super::translations_panel::close_from_language_menu),
           5596 => test_get_errors!(super::translations_panel::close_settings_menu),
           5597 => test_get_errors!(super::translations_panel::close_to_language_menu),
           5598 => test_get_errors!(super::translations_panel::dismiss_error_button),
           5599 => test_get_errors!(super::translations_panel::learn_more),
           5600 => test_get_errors!(super::translations_panel::manage_languages),
           5601 => test_get_errors!(super::translations_panel::never_translate_language),
           5602 => test_get_errors!(super::translations_panel::never_translate_site),
           5603 => test_get_errors!(super::translations_panel::open),
           5604 => test_get_errors!(super::translations_panel::open_from_language_menu),
           5605 => test_get_errors!(super::translations_panel::open_settings_menu),
           5606 => test_get_errors!(super::translations_panel::open_to_language_menu),
           5607 => test_get_errors!(super::translations_panel::restore_page_button),
           5608 => test_get_errors!(super::translations_panel::translate_button),
           5609 => test_get_errors!(super::translations_select_translations_panel::about_translations),
           5610 => test_get_errors!(super::translations_select_translations_panel::cancel_button),
           5611 => test_get_errors!(super::translations_select_translations_panel::change_from_language),
           5612 => test_get_errors!(super::translations_select_translations_panel::change_to_language),
           5613 => test_get_errors!(super::translations_select_translations_panel::close),
           5614 => test_get_errors!(super::translations_select_translations_panel::copy_button),
           5615 => test_get_errors!(super::translations_select_translations_panel::done_button),
           5616 => test_get_errors!(super::translations_select_translations_panel::initialization_failure_message),
           5617 => test_get_errors!(super::translations_select_translations_panel::open),
           5618 => test_get_errors!(super::translations_select_translations_panel::open_settings_menu),
           5619 => test_get_errors!(super::translations_select_translations_panel::translate_button),
           5620 => test_get_errors!(super::translations_select_translations_panel::translate_full_page_button),
           5621 => test_get_errors!(super::translations_select_translations_panel::translation_failure_message),
           5622 => test_get_errors!(super::translations_select_translations_panel::translation_settings),
           5623 => test_get_errors!(super::translations_select_translations_panel::try_again_button),
           5624 => test_get_errors!(super::translations_select_translations_panel::unsupported_language_message),
           5652 => test_get_errors!(super::security_doh_neterror::click_add_exception_button),
           5653 => test_get_errors!(super::security_doh_neterror::click_continue_button),
           5654 => test_get_errors!(super::security_doh_neterror::click_disable_warning),
           5655 => test_get_errors!(super::security_doh_neterror::click_learn_more_link),
           5656 => test_get_errors!(super::security_doh_neterror::click_settings_button),
           5657 => test_get_errors!(super::security_doh_neterror::click_try_again_button),
           5658 => test_get_errors!(super::security_doh_neterror::load_dohwarning),
           5659 => test_get_errors!(super::security_ui_certerror::click_advanced_button),
           5660 => test_get_errors!(super::security_ui_certerror::click_auto_report_cb),
           5661 => test_get_errors!(super::security_ui_certerror::click_clipboard_button_bot),
           5662 => test_get_errors!(super::security_ui_certerror::click_clipboard_button_top),
           5663 => test_get_errors!(super::security_ui_certerror::click_error_code_link),
           5664 => test_get_errors!(super::security_ui_certerror::click_exception_button),
           5665 => test_get_errors!(super::security_ui_certerror::click_learn_more_link),
           5666 => test_get_errors!(super::security_ui_certerror::click_return_button_adv),
           5667 => test_get_errors!(super::security_ui_certerror::click_return_button_top),
           5668 => test_get_errors!(super::security_ui_certerror::load_aboutcerterror),
           5669 => test_get_errors!(super::security_ui_tlserror::load_abouttlserror),
           5680 => test_get_errors!(super::jsonfile::load_autofillprofiles),
           5681 => test_get_errors!(super::jsonfile::load_logins),
           5687 => test_get_errors!(super::service_request::bypass_proxy_info),
           5700 => test_get_errors!(super::addons_manager::install),
           5701 => test_get_errors!(super::addons_manager::install_stats),
           5702 => test_get_errors!(super::addons_manager::manage),
           5703 => test_get_errors!(super::addons_manager::report_suspicious_site),
           5704 => test_get_errors!(super::addons_manager::update),
           5705 => test_get_errors!(super::addons_manager::xpistates_write_errors),
           5706 => test_get_errors!(super::addons_manager::disable_dictionary),
           5707 => test_get_errors!(super::addons_manager::disable_extension),
           5708 => test_get_errors!(super::addons_manager::disable_locale),
           5709 => test_get_errors!(super::addons_manager::disable_other),
           5710 => test_get_errors!(super::addons_manager::disable_siteperm_deprecated),
           5711 => test_get_errors!(super::addons_manager::disable_sitepermission),
           5712 => test_get_errors!(super::addons_manager::disable_theme),
           5713 => test_get_errors!(super::addons_manager::disable_unknown),
           5714 => test_get_errors!(super::addons_manager::enable_dictionary),
           5715 => test_get_errors!(super::addons_manager::enable_extension),
           5716 => test_get_errors!(super::addons_manager::enable_locale),
           5717 => test_get_errors!(super::addons_manager::enable_other),
           5718 => test_get_errors!(super::addons_manager::enable_siteperm_deprecated),
           5719 => test_get_errors!(super::addons_manager::enable_sitepermission),
           5720 => test_get_errors!(super::addons_manager::enable_theme),
           5721 => test_get_errors!(super::addons_manager::enable_unknown),
           5722 => test_get_errors!(super::addons_manager::install_dictionary),
           5723 => test_get_errors!(super::addons_manager::install_extension),
           5724 => test_get_errors!(super::addons_manager::install_locale),
           5725 => test_get_errors!(super::addons_manager::install_other),
           5726 => test_get_errors!(super::addons_manager::install_siteperm_deprecated),
           5727 => test_get_errors!(super::addons_manager::install_sitepermission),
           5728 => test_get_errors!(super::addons_manager::install_stats_dictionary),
           5729 => test_get_errors!(super::addons_manager::install_stats_extension),
           5730 => test_get_errors!(super::addons_manager::install_stats_locale),
           5731 => test_get_errors!(super::addons_manager::install_stats_other),
           5732 => test_get_errors!(super::addons_manager::install_stats_siteperm_deprecated),
           5733 => test_get_errors!(super::addons_manager::install_stats_sitepermission),
           5734 => test_get_errors!(super::addons_manager::install_stats_theme),
           5735 => test_get_errors!(super::addons_manager::install_stats_unknown),
           5736 => test_get_errors!(super::addons_manager::install_theme),
           5737 => test_get_errors!(super::addons_manager::install_unknown),
           5738 => test_get_errors!(super::addons_manager::sideload_prompt_dictionary),
           5739 => test_get_errors!(super::addons_manager::sideload_prompt_extension),
           5740 => test_get_errors!(super::addons_manager::sideload_prompt_locale),
           5741 => test_get_errors!(super::addons_manager::sideload_prompt_other),
           5742 => test_get_errors!(super::addons_manager::sideload_prompt_siteperm_deprecated),
           5743 => test_get_errors!(super::addons_manager::sideload_prompt_sitepermission),
           5744 => test_get_errors!(super::addons_manager::sideload_prompt_theme),
           5745 => test_get_errors!(super::addons_manager::sideload_prompt_unknown),
           5746 => test_get_errors!(super::addons_manager::uninstall_dictionary),
           5747 => test_get_errors!(super::addons_manager::uninstall_extension),
           5748 => test_get_errors!(super::addons_manager::uninstall_locale),
           5749 => test_get_errors!(super::addons_manager::uninstall_other),
           5750 => test_get_errors!(super::addons_manager::uninstall_siteperm_deprecated),
           5751 => test_get_errors!(super::addons_manager::uninstall_sitepermission),
           5752 => test_get_errors!(super::addons_manager::uninstall_theme),
           5753 => test_get_errors!(super::addons_manager::uninstall_unknown),
           5754 => test_get_errors!(super::addons_manager::update_dictionary),
           5755 => test_get_errors!(super::addons_manager::update_extension),
           5756 => test_get_errors!(super::addons_manager::update_locale),
           5757 => test_get_errors!(super::addons_manager::update_other),
           5758 => test_get_errors!(super::addons_manager::update_siteperm_deprecated),
           5759 => test_get_errors!(super::addons_manager::update_sitepermission),
           5760 => test_get_errors!(super::addons_manager::update_theme),
           5761 => test_get_errors!(super::addons_manager::update_unknown),
           5762 => test_get_errors!(super::blocklist::addon_block_change),
           5896 => test_get_errors!(super::memory_watcher::on_high_memory_stats),
           _ => panic!("No event for metric id {}", metric_id),
        }

        #[cfg(not(feature = "with_gecko"))]
        {
            return None;
        }
    }

    /// Gets the submetric from the specified labeled_boolean metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the boolean submetric.
    ///
    /// # Returns
    ///
    /// Returns the boolean submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_boolean by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_boolean_get(metric_id: u32, label: &str) -> Arc<LabeledBooleanMetric> {
        match metric_id {
            8 => super::a11y::theme.get(label),
            195 => super::networking::doh_heuristic_ever_tripped.get(label),
            403 => super::os_environment::is_default_handler.get(label),
            532 => super::newtab::metric_registered.get(label),
            535 => super::newtab::ping_registered.get(label),
            1012 => super::browser_ui::mirror_for_toolbar_widgets.get(label),
            1114 => super::devtools_tool::registered.get(label),
            3648 => super::geolocation::linux_provider.get(label),
            3655 => super::mediadrm::decryption.get(label),
            3675 => super::media::video_hardware_decoding_support.get(label),
            3676 => super::media::video_hd_hardware_decoding_support.get(label),
            3687 => super::media_playback::device_hardware_decoder_support.get(label),
            4571 => super::cookie_banners::normal_window_service_mode.get(label),
            4572 => super::cookie_banners::private_window_service_mode.get(label),
            4801 => super::test_only::mabels_like_balloons.get(label),
            4802 => super::test_only::mabels_like_labeled_balloons.get(label),
            4807 => super::test_only::mirrors_for_labeled_bools.get(label),
            4839 => super::test_only_ipc::an_unordered_labeled_boolean.get(label),
            5036 => super::pdfjs_image::alt_text_edit.get(label),
            5864 => super::widget::ime_name_on_mac.get(label),
            5866 => super::widget::ime_name_on_linux.get(label),
            5869 => super::widget::pointing_devices.get(label),
            5870 => super::widget::ime_name_on_windows.get(label),
            5871 => super::widget::ime_name_on_windows_inserted_crlf.get(label),
            _ => panic!("No labeled_boolean for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_counter metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the counter submetric.
    ///
    /// # Returns
    ///
    /// Returns the counter submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_counter by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_counter_get(metric_id: u32, label: &str) -> Arc<LabeledCounterMetric> {
        match metric_id {
            14 => super::browser_engagement::total_top_visits.get(label),
            15 => super::browser_engagement::sessionrestore_interstitial.get(label),
            46 => super::networking::captive_portal_banner_display_time.get(label),
            51 => super::networking::cache_purge_due_to_memory_limit.get(label),
            63 => super::networking::cookie_timestamp_fixed_count.get(label),
            66 => super::networking::dns_native_count.get(label),
            70 => super::networking::fetch_keepalive_discard_count.get(label),
            71 => super::networking::fetch_keepalive_request_count.get(label),
            88 => super::networking::http_3_connection_close_reason.get(label),
            95 => super::networking::http_3_ecn_path_capability.get(label),
            97 => super::networking::http_3_quic_frame_count.get(label),
            106 => super::networking::http_channel_disposition.get(label),
            107 => super::networking::http_channel_disposition_disabled_no_reason.get(label),
            108 => super::networking::http_channel_disposition_disabled_upgrade.get(label),
            109 => super::networking::http_channel_disposition_disabled_wont.get(label),
            110 => super::networking::http_channel_disposition_enabled_no_reason.get(label),
            111 => super::networking::http_channel_disposition_enabled_upgrade.get(label),
            112 => super::networking::http_channel_disposition_enabled_wont.get(label),
            113 => super::networking::http_channel_onstart_status.get(label),
            114 => super::networking::http_channel_onstart_success_https_rr.get(label),
            126 => super::networking::http_ip_addr_any_count.get(label),
            127 => super::networking::http_ip_addr_any_hostnames.get(label),
            129 => super::networking::http_redirect_to_scheme_subresource.get(label),
            130 => super::networking::http_redirect_to_scheme_top_level.get(label),
            131 => super::networking::http_response_status_code.get(label),
            132 => super::networking::http_response_version.get(label),
            133 => super::networking::http_to_https_upgrade_reason.get(label),
            134 => super::networking::https_http_or_local.get(label),
            135 => super::networking::https_rr_presented.get(label),
            162 => super::networking::proxy_info_type.get(label),
            164 => super::networking::residual_cache_folder_removal.get(label),
            170 => super::networking::speculative_connect_outcome.get(label),
            182 => super::networking::trr_request_count.get(label),
            183 => super::networking::trr_request_count_per_conn.get(label),
            188 => super::networking::data_transferred_v3_kb.get(label),
            190 => super::networking::https_record_state.get(label),
            192 => super::networking::trr_connection_cycle_count.get(label),
            234 => super::messaging_system::invalid_nested_data.get(label),
            241 => super::messaging_system::unknown_keys.get(label),
            251 => super::messaging_system_attribution::unknown_keys.get(label),
            377 => super::browser::attribution_errors.get(label),
            379 => super::browser::is_user_default.get(label),
            380 => super::browser::is_user_default_error.get(label),
            381 => super::browser::set_default_always_check.get(label),
            383 => super::browser::set_default_error.get(label),
            384 => super::browser::set_default_pdf_handler_user_choice_result.get(label),
            386 => super::browser::set_default_user_choice_result.get(label),
            402 => super::os_environment::invoked_to_handle.get(label),
            408 => super::os_environment::launched_to_handle.get(label),
            425 => super::security::client_auth_cert_usage.get(label),
            440 => super::browser_migration::entry_point_categorical.get(label),
            458 => super::migration::discovered_migrators.get(label),
            514 => super::contextual_services_topsites::click.get(label),
            515 => super::contextual_services_topsites::impression.get(label),
            612 => super::history_sidebar::filter_type.get(label),
            617 => super::library::link.get(label),
            618 => super::library::opened.get(label),
            619 => super::library::search.get(label),
            690 => super::protocolhandler_mailto::handler_prompt_shown.get(label),
            691 => super::protocolhandler_mailto::prompt_clicked.get(label),
            716 => super::browser_engagement_navigation::about_home.get(label),
            717 => super::browser_engagement_navigation::about_newtab.get(label),
            718 => super::browser_engagement_navigation::contextmenu.get(label),
            719 => super::browser_engagement_navigation::searchbar.get(label),
            720 => super::browser_engagement_navigation::urlbar.get(label),
            721 => super::browser_engagement_navigation::urlbar_handoff.get(label),
            722 => super::browser_engagement_navigation::urlbar_persisted.get(label),
            723 => super::browser_engagement_navigation::urlbar_searchmode.get(label),
            724 => super::browser_engagement_navigation::webextension.get(label),
            725 => super::browser_search_adclicks::about_home.get(label),
            726 => super::browser_search_adclicks::about_newtab.get(label),
            727 => super::browser_search_adclicks::contextmenu.get(label),
            728 => super::browser_search_adclicks::reload.get(label),
            729 => super::browser_search_adclicks::searchbar.get(label),
            730 => super::browser_search_adclicks::system.get(label),
            731 => super::browser_search_adclicks::tabhistory.get(label),
            732 => super::browser_search_adclicks::unknown.get(label),
            733 => super::browser_search_adclicks::urlbar.get(label),
            734 => super::browser_search_adclicks::urlbar_handoff.get(label),
            735 => super::browser_search_adclicks::urlbar_persisted.get(label),
            736 => super::browser_search_adclicks::urlbar_searchmode.get(label),
            737 => super::browser_search_adclicks::webextension.get(label),
            738 => super::browser_search_content::about_home.get(label),
            739 => super::browser_search_content::about_newtab.get(label),
            740 => super::browser_search_content::contextmenu.get(label),
            741 => super::browser_search_content::reload.get(label),
            742 => super::browser_search_content::searchbar.get(label),
            743 => super::browser_search_content::system.get(label),
            744 => super::browser_search_content::tabhistory.get(label),
            745 => super::browser_search_content::unknown.get(label),
            746 => super::browser_search_content::urlbar.get(label),
            747 => super::browser_search_content::urlbar_handoff.get(label),
            748 => super::browser_search_content::urlbar_persisted.get(label),
            749 => super::browser_search_content::urlbar_searchmode.get(label),
            750 => super::browser_search_content::webextension.get(label),
            751 => super::browser_search_withads::about_home.get(label),
            752 => super::browser_search_withads::about_newtab.get(label),
            753 => super::browser_search_withads::contextmenu.get(label),
            754 => super::browser_search_withads::reload.get(label),
            755 => super::browser_search_withads::searchbar.get(label),
            756 => super::browser_search_withads::system.get(label),
            757 => super::browser_search_withads::tabhistory.get(label),
            758 => super::browser_search_withads::unknown.get(label),
            759 => super::browser_search_withads::urlbar.get(label),
            760 => super::browser_search_withads::urlbar_handoff.get(label),
            761 => super::browser_search_withads::urlbar_persisted.get(label),
            762 => super::browser_search_withads::urlbar_searchmode.get(label),
            763 => super::browser_search_withads::webextension.get(label),
            767 => super::sap::deprecated_counts.get(label),
            771 => super::searchbar::selected_result_method.get(label),
            774 => super::serp::ads_blocked_count.get(label),
            781 => super::urlbar_searchmode::bookmarkmenu.get(label),
            782 => super::urlbar_searchmode::handoff.get(label),
            783 => super::urlbar_searchmode::historymenu.get(label),
            784 => super::urlbar_searchmode::keywordoffer.get(label),
            785 => super::urlbar_searchmode::oneoff.get(label),
            786 => super::urlbar_searchmode::other.get(label),
            787 => super::urlbar_searchmode::searchbutton.get(label),
            788 => super::urlbar_searchmode::shortcut.get(label),
            789 => super::urlbar_searchmode::tabmenu.get(label),
            790 => super::urlbar_searchmode::tabtosearch.get(label),
            791 => super::urlbar_searchmode::tabtosearch_onboard.get(label),
            792 => super::urlbar_searchmode::topsites_newtab.get(label),
            793 => super::urlbar_searchmode::topsites_urlbar.get(label),
            794 => super::urlbar_searchmode::touchbar.get(label),
            795 => super::urlbar_searchmode::typed.get(label),
            796 => super::session_restore::all_files_corrupt.get(label),
            802 => super::session_restore::corrupt_file.get(label),
            810 => super::session_restore::shutdown_ok.get(label),
            874 => super::sidebar::link.get(label),
            877 => super::sidebar::search.get(label),
            904 => super::browser_tabswitch::spinner_visible_trigger.get(label),
            908 => super::browser_ui_interaction::all_tabs_panel_entrypoint.get(label),
            910 => super::browser_ui_interaction::app_menu.get(label),
            911 => super::browser_ui_interaction::bookmarks_bar.get(label),
            912 => super::browser_ui_interaction::content_context.get(label),
            913 => super::browser_ui_interaction::menu_bar.get(label),
            914 => super::browser_ui_interaction::nav_bar.get(label),
            915 => super::browser_ui_interaction::overflow_menu.get(label),
            916 => super::browser_ui_interaction::pageaction_panel.get(label),
            917 => super::browser_ui_interaction::pageaction_urlbar.get(label),
            918 => super::browser_ui_interaction::pinned_overflow_menu.get(label),
            919 => super::browser_ui_interaction::preferences_pane_containers.get(label),
            920 => super::browser_ui_interaction::preferences_pane_experimental.get(label),
            921 => super::browser_ui_interaction::preferences_pane_general.get(label),
            922 => super::browser_ui_interaction::preferences_pane_home.get(label),
            923 => super::browser_ui_interaction::preferences_pane_more_from_mozilla.get(label),
            924 => super::browser_ui_interaction::preferences_pane_privacy.get(label),
            925 => super::browser_ui_interaction::preferences_pane_search.get(label),
            926 => super::browser_ui_interaction::preferences_pane_search_results.get(label),
            927 => super::browser_ui_interaction::preferences_pane_sync.get(label),
            928 => super::browser_ui_interaction::preferences_pane_unknown.get(label),
            929 => super::browser_ui_interaction::tabs_bar.get(label),
            930 => super::browser_ui_interaction::tabs_context.get(label),
            931 => super::browser_ui_interaction::tabs_context_entrypoint.get(label),
            932 => super::browser_ui_interaction::unified_extensions_area.get(label),
            933 => super::browser_ui_interaction::vertical_tabs_container.get(label),
            934 => super::browser_ui_interaction::keyboard.get(label),
            939 => super::tabgroup::group_interactions.get(label),
            949 => super::tabgroup::tab_interactions.get(label),
            973 => super::suggest_relevance::outcome.get(label),
            974 => super::suggest_relevance::status.get(label),
            991 => super::urlbar_quickaction::picked.get(label),
            994 => super::urlbar_unifiedsearchbutton::picked.get(label),
            1011 => super::browser_ui::customized_widgets.get(label),
            1043 => super::devtools_accessibility::accessible_context_menu_item_activated.get(label),
            1045 => super::devtools_accessibility::audit_activated.get(label),
            1047 => super::devtools_accessibility::select_accessible_for_node.get(label),
            1048 => super::devtools_accessibility::simulation_activated.get(label),
            1052 => super::devtools::current_theme.get(label),
            1074 => super::devtools::entry_point.get(label),
            1115 => super::devtools_toolbox::tabs_reordered.get(label),
            1117 => super::devtools_inspector::fonteditor_font_type_displayed.get(label),
            1121 => super::devtools_inspector::three_pane_enabled.get(label),
            1131 => super::devtools_tooltip::shown.get(label),
            1132 => super::devtools_responsive::open_trigger.get(label),
            1227 => super::bfcache::combo.get(label),
            1228 => super::bfcache::page_restored.get(label),
            3633 => super::canvas::used_2d.get(label),
            3634 => super::canvas::webgl2_success.get(label),
            3635 => super::canvas::webgl_accl_failure_id.get(label),
            3636 => super::canvas::webgl_failure_id.get(label),
            3637 => super::canvas::webgl_success.get(label),
            3638 => super::canvas::webgl_used.get(label),
            3640 => super::webcrypto::extractable_enc.get(label),
            3641 => super::webcrypto::extractable_generate.get(label),
            3642 => super::webcrypto::extractable_import.get(label),
            3643 => super::webcrypto::extractable_sig.get(label),
            3645 => super::webcrypto::resolved.get(label),
            3647 => super::geolocation::fallback.get(label),
            3649 => super::geolocation::request_result.get(label),
            3660 => super::gmp::update_xml_fetch_result.get(label),
            3662 => super::media::codec_used.get(label),
            3666 => super::media::mse_source_buffer_type.get(label),
            3684 => super::media_audio::backend.get(label),
            3685 => super::media_audio::init_failure.get(label),
            3689 => super::media_playback::not_supported_video_per_mime_type.get(label),
            3691 => super::media_mp4_parse::sample_description_entries_have_multiple_codecs.get(label),
            3692 => super::media_mp4_parse::sample_description_entries_have_multiple_crypto.get(label),
            3695 => super::codec_stats::audio_preferred_codec.get(label),
            3696 => super::codec_stats::other_fec_signaled.get(label),
            3697 => super::codec_stats::ulpfec_negotiated.get(label),
            3698 => super::codec_stats::video_preferred_codec.get(label),
            3722 => super::webrtc::datachannel_negotiated.get(label),
            3724 => super::webrtc::gmp_init_success.get(label),
            3725 => super::webrtc::h264_enabled.get(label),
            3726 => super::webrtc::hardware_h264_enabled.get(label),
            3727 => super::webrtc::has_h264_hardware.get(label),
            3733 => super::webrtc::software_h264_enabled.get(label),
            3752 => super::webrtc_video::recv_codec_used.get(label),
            3753 => super::webrtc_video::send_codec_used.get(label),
            3754 => super::webrtcdtls::cipher.get(label),
            3755 => super::webrtcdtls::client_handshake_result.get(label),
            3757 => super::webrtcdtls::protocol_version.get(label),
            3758 => super::webrtcdtls::server_handshake_result.get(label),
            3760 => super::webrtcdtls::srtp_cipher.get(label),
            3761 => super::dom::blink_filesystem_used.get(label),
            3767 => super::dom::innerwindows_with_mutation_listeners.get(label),
            3768 => super::dom::script_loading_source.get(label),
            3771 => super::dom::storage_access_api_ui.get(label),
            3772 => super::dom::webkit_directory_used.get(label),
            3773 => super::dom::xmlhttprequest_async_or_sync.get(label),
            3776 => super::dom_contentprocess::launch_is_sync.get(label),
            3784 => super::dom_parentprocess::process_launch_errors.get(label),
            3821 => super::web_notification::icon_url_encoding.get(label),
            3823 => super::web_notification::permission_origin.get(label),
            3824 => super::web_notification::request_permission_origin.get(label),
            3825 => super::web_notification::show_origin.get(label),
            3829 => super::web_push::content_encoding.get(label),
            3831 => super::web_push::error_code.get(label),
            3848 => super::mixed_content::audio.get(label),
            3850 => super::mixed_content::images.get(label),
            3853 => super::mixed_content::video.get(label),
            3863 => super::localdomstorage::preload_pending_on_first_access.get(label),
            3865 => super::webauthn_create::authenticator_attachment.get(label),
            3869 => super::webauthn_get::authenticator_attachment.get(label),
            3876 => super::htmleditors::overridden_by_beforeinput_listeners.get(label),
            3877 => super::htmleditors::with_beforeinput_listeners.get(label),
            3878 => super::htmleditors::with_mutation_listeners_without_beforeinput_listeners.get(label),
            3879 => super::htmleditors::with_mutation_observers_without_beforeinput_listeners.get(label),
            3882 => super::apz_zoom::activity.get(label),
            3884 => super::fontlist::bad_fallback_font.get(label),
            3890 => super::fontlist::font_cache_hit.get(label),
            3907 => super::gfx::macos_video_low_power.get(label),
            3934 => super::gfx_content_frame_time::reason.get(label),
            3947 => super::gpu_process::crash_fallbacks.get(label),
            3974 => super::avif::a1lx.get(label),
            3975 => super::avif::a1op.get(label),
            3976 => super::avif::alpha.get(label),
            3977 => super::avif::aom_decode_error.get(label),
            3978 => super::avif::bit_depth.get(label),
            3979 => super::avif::cicp_cp.get(label),
            3980 => super::avif::cicp_mc.get(label),
            3981 => super::avif::cicp_tc.get(label),
            3982 => super::avif::clap.get(label),
            3983 => super::avif::colr.get(label),
            3985 => super::avif::decode_result.get(label),
            3986 => super::avif::decoder.get(label),
            3987 => super::avif::grid.get(label),
            3988 => super::avif::ipro.get(label),
            3989 => super::avif::ispe.get(label),
            3990 => super::avif::lsel.get(label),
            3991 => super::avif::major_brand.get(label),
            3992 => super::avif::pasp.get(label),
            3993 => super::avif::pixi.get(label),
            3994 => super::avif::sequence.get(label),
            3995 => super::avif::yuv_color_space.get(label),
            4005 => super::ipc::transaction_cancel.get(label),
            4008 => super::subprocess::abnormal_abort.get(label),
            4009 => super::subprocess::crashes_with_dump.get(label),
            4010 => super::subprocess::kill_hard.get(label),
            4011 => super::subprocess::launch_failure.get(label),
            4015 => super::javascript_gc::budget_was_increased.get(label),
            4018 => super::javascript_gc::is_zone_gc.get(label),
            4025 => super::javascript_gc::minor_reason.get(label),
            4026 => super::javascript_gc::minor_reason_long.get(label),
            4029 => super::javascript_gc::non_incremental.get(label),
            4030 => super::javascript_gc::non_incremental_reason.get(label),
            4035 => super::javascript_gc::parallel_mark_used.get(label),
            4039 => super::javascript_gc::reason.get(label),
            4040 => super::javascript_gc::reset.get(label),
            4041 => super::javascript_gc::reset_reason.get(label),
            4044 => super::javascript_gc::slice_was_long.get(label),
            4045 => super::javascript_gc::slow_phase.get(label),
            4046 => super::javascript_gc::slow_task.get(label),
            4060 => super::script_preloader::requests.get(label),
            4070 => super::layout::long_reflow_interruptible.get(label),
            4110 => super::network::id_online.get(label),
            4112 => super::network::rel_preload_miss_ratio.get(label),
            4113 => super::network::alpn_mismatch_count.get(label),
            4117 => super::network::back_pressure_suspension_rate.get(label),
            4118 => super::network::byte_range_request.get(label),
            4119 => super::network::cache_hit_miss_stat_per_cache_size.get(label),
            4127 => super::network::cors_authorization_header.get(label),
            4146 => super::network::race_cache_validation.get(label),
            4149 => super::network::race_cache_with_network_usage.get(label),
            4166 => super::network::system_channel_addon_status.get(label),
            4167 => super::network::system_channel_addonversion_status.get(label),
            4168 => super::network::system_channel_other_status.get(label),
            4169 => super::network::system_channel_remote_settings_status.get(label),
            4170 => super::network::system_channel_success_or_failure.get(label),
            4171 => super::network::system_channel_telemetry_status.get(label),
            4172 => super::network::system_channel_update_status.get(label),
            4174 => super::network::tls_early_data_accepted.get(label),
            4176 => super::network::tls_early_data_negotiated.get(label),
            4187 => super::dns::grace_period_renewal.get(label),
            4188 => super::dns::lookup_algorithm.get(label),
            4208 => super::network_sso::entra_success.get(label),
            4222 => super::predictor::prefetch_use_status.get(label),
            4244 => super::http::altsvc_mapping_changed_target.get(label),
            4245 => super::http::cache_lm_inconsistent.get(label),
            4247 => super::http::channel_onstart_success.get(label),
            4251 => super::http::connection_entry_cache_hit.get(label),
            4256 => super::http::echconfig_success_rate.get(label),
            4257 => super::http::http2_fail_before_settings.get(label),
            4259 => super::http::pageload_is_ssl.get(label),
            4266 => super::http::script_block_incorrect_mime.get(label),
            4269 => super::http::tls_early_data_accepted.get(label),
            4275 => super::http::transaction_is_ssl.get(label),
            4277 => super::http::transaction_use_altsvc.get(label),
            4298 => super::netwerk::http3_0rtt_state.get(label),
            4304 => super::orb::block_initiator.get(label),
            4305 => super::orb::block_reason.get(label),
            4306 => super::orb::did_ever_block_response.get(label),
            4330 => super::cert_verifier::cert_revocation_mechanisms.get(label),
            4331 => super::cert_verifier::crlite_status.get(label),
            4332 => super::cert_verifier::crlite_vs_ocsp_result.get(label),
            4340 => super::cert_compression::failures.get(label),
            4344 => super::cert_pinning::results.get(label),
            4345 => super::cert_pinning::test_results.get(label),
            4373 => super::ssl::resumed_session.get(label),
            4402 => super::tls::xyber_intolerance_reason.get(label),
            4409 => super::sandbox::has_user_namespaces.get(label),
            4410 => super::sandbox::rejected_syscalls.get(label),
            4454 => super::startup_cache::requests.get(label),
            4458 => super::bounce_tracking_protection::purge_count.get(label),
            4464 => super::contentblocking::cryptominers_blocked_count.get(label),
            4466 => super::contentblocking::email_tracker_count.get(label),
            4468 => super::contentblocking::fingerprinters_blocked_count.get(label),
            4470 => super::contentblocking::font_fingerprinting_per_tab.get(label),
            4471 => super::contentblocking::query_stripping_count.get(label),
            4472 => super::contentblocking::query_stripping_count_by_param.get(label),
            4474 => super::contentblocking::storage_access_granted_count.get(label),
            4479 => super::contentblocking::tracking_protection_enabled.get(label),
            4480 => super::contentblocking::tracking_protection_pbm_disabled.get(label),
            4595 => super::crash::submit_attempt.get(label),
            4600 => super::crash_submission::channel_status.get(label),
            4601 => super::crash_submission::collector_errors.get(label),
            4660 => super::extensions::process_event.get(label),
            4662 => super::extensions::startup_cache_read_errors.get(label),
            4668 => super::extensions_apis_dnr::startup_cache_entries.get(label),
            4674 => super::extensions_counters::browser_action_preload_result.get(label),
            4675 => super::extensions_counters::event_page_idle_result.get(label),
            4677 => super::extensions_data::migrate_result_count.get(label),
            4738 => super::creditcard::detected_cc_number_fields_count.get(label),
            4757 => super::formautofill::form_submission_heuristic.get(label),
            4790 => super::test_only::keyed_expired.get(label),
            4791 => super::test_only::keyed_mobile_only.get(label),
            4792 => super::test_only::keyed_release_optin.get(label),
            4793 => super::test_only::keyed_release_optout.get(label),
            4796 => super::test_only::mabels_bathroom_counters.get(label),
            4798 => super::test_only::mabels_kitchen_counters.get(label),
            4800 => super::test_only::mabels_labeled_counters.get(label),
            4824 => super::test_only_ipc::a_labeled_counter.get(label),
            4825 => super::test_only_ipc::a_labeled_counter_for_categorical.get(label),
            4826 => super::test_only_ipc::a_labeled_counter_for_hgram.get(label),
            4827 => super::test_only_ipc::a_labeled_counter_for_keyed_count_hgram.get(label),
            4840 => super::test_only_ipc::another_labeled_counter.get(label),
            4847 => super::media_sniffer::mp4_brand_pattern.get(label),
            4911 => super::nimbus_targeting_environment::attr_eval_errors.get(label),
            4912 => super::nimbus_targeting_environment::pref_type_errors.get(label),
            4960 => super::pwmgr::form_autofill_result.get(label),
            4962 => super::pwmgr::import_logins_from_file_categorical.get(label),
            4963 => super::pwmgr::is_username_only_form.get(label),
            4973 => super::pwmgr::num_improved_generated_passwords.get(label),
            5016 => super::pdfjs::buttons.get(label),
            5017 => super::pdfjs::editing.get(label),
            5018 => super::pdfjs::geckoview.get(label),
            5019 => super::pdfjs::stamp.get(label),
            5022 => super::pdfjs_editing_highlight::color.get(label),
            5026 => super::pdfjs_editing_highlight::kind.get(label),
            5027 => super::pdfjs_editing_highlight::method.get(label),
            5028 => super::pdfjs_editing_highlight::number_of_colors.get(label),
            5035 => super::pdfjs_image::added.get(label),
            5058 => super::pdfjs_signature::clear.get(label),
            5061 => super::pdfjs_signature::edit_description.get(label),
            5123 => super::printing::error.get(label),
            5126 => super::printing::settings_changed.get(label),
            5128 => super::printing::target_type.get(label),
            5130 => super::power::cpu_time_per_process_type_ms.get(label),
            5131 => super::power::cpu_time_per_tracker_type_ms.get(label),
            5132 => super::power::energy_per_process_type.get(label),
            5134 => super::power::gpu_time_per_process_type_ms.get(label),
            5138 => super::power::wakeups_per_process_type.get(label),
            5140 => super::power_cpu_ms_per_thread::content_background.get(label),
            5141 => super::power_cpu_ms_per_thread::content_foreground.get(label),
            5142 => super::power_cpu_ms_per_thread::gpu_process.get(label),
            5143 => super::power_cpu_ms_per_thread::parent_active.get(label),
            5144 => super::power_cpu_ms_per_thread::parent_inactive.get(label),
            5145 => super::power_wakeups_per_thread::content_background.get(label),
            5146 => super::power_wakeups_per_thread::content_foreground.get(label),
            5147 => super::power_wakeups_per_thread::gpu_process.get(label),
            5148 => super::power_wakeups_per_thread::parent_active.get(label),
            5149 => super::power_wakeups_per_thread::parent_inactive.get(label),
            5200 => super::application_reputation::binary_archive.get(label),
            5201 => super::application_reputation::binary_type.get(label),
            5203 => super::application_reputation::reason.get(label),
            5205 => super::application_reputation::remote_lookup_timeout.get(label),
            5207 => super::application_reputation::server_2.get(label),
            5209 => super::application_reputation::should_block.get(label),
            5503 => super::search_service::initialization_status.get(label),
            5505 => super::search_suggestions::aborted_requests.get(label),
            5506 => super::search_suggestions::failed_requests.get(label),
            5507 => super::search_suggestions::successful_requests.get(label),
            5537 => super::telemetry::event_ping_sent.get(label),
            5538 => super::telemetry::event_recording_error.get(label),
            5539 => super::telemetry::event_registration_error.get(label),
            5541 => super::telemetry::invalid_ping_type_submitted.get(label),
            5555 => super::telemetry::send_failure_type.get(label),
            5558 => super::telemetry::success.get(label),
            5583 => super::translations::request_count.get(label),
            5644 => super::urlclassifier::vlps_metadata_corrupt.get(label),
            5670 => super::mozstorage::sqlitejsm_transaction_timeout.get(label),
            5674 => super::region::store_region_result.get(label),
            5782 => super::update::can_use_bits_external.get(label),
            5783 => super::update::can_use_bits_notify.get(label),
            5784 => super::update::can_use_bits_subsequent.get(label),
            5791 => super::update::check_extended_error_external.get(label),
            5792 => super::update::check_extended_error_notify.get(label),
            5793 => super::update::check_extended_error_subsequent.get(label),
            5816 => super::update::notification_badge_shown.get(label),
            5817 => super::update::notification_dismissed.get(label),
            5818 => super::update::notification_main_action_doorhanger.get(label),
            5819 => super::update::notification_main_action_menu.get(label),
            5820 => super::update::notification_shown.get(label),
            5830 => super::update::service_installed_external.get(label),
            5831 => super::update::service_installed_notify.get(label),
            5832 => super::update::service_installed_subsequent.get(label),
            5851 => super::update::bitshresult.get(label),
            5852 => super::update::move_result.get(label),
            5872 => super::widget::touch_enabled_device.get(label),
            5876 => super::cycle_collector::finish_igc.get(label),
            5880 => super::cycle_collector::need_gc.get(label),
            5882 => super::cycle_collector::sync_skippable.get(label),
            5888 => super::cycle_collector::worker_need_gc.get(label),
            _ => panic!("No labeled_counter for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_timing_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the timing_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the timing_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_timing_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_timing_distribution_get(metric_id: u32, label: &str) -> Arc<LabeledTimingDistributionMetric> {
        match metric_id {
            175 => super::networking::trr_complete_load.get(label),
            176 => super::networking::trr_dns_end.get(label),
            177 => super::networking::trr_dns_start.get(label),
            178 => super::networking::trr_fetch_duration.get(label),
            179 => super::networking::trr_first_sent_to_last_received.get(label),
            180 => super::networking::trr_open_to_first_received.get(label),
            181 => super::networking::trr_open_to_first_sent.get(label),
            186 => super::networking::trr_tcp_connection.get(label),
            187 => super::networking::trr_tls_handshake.get(label),
            419 => super::security::https_only_mode_upgrade_time.get(label),
            970 => super::suggest::ingest_download_time.get(label),
            971 => super::suggest::ingest_time.get(label),
            972 => super::suggest::query_time.get(label),
            1051 => super::devtools::cold_toolbox_open_delay.get(label),
            1054 => super::devtools::toolbox_page_reload_delay.get(label),
            1055 => super::devtools::warm_toolbox_open_delay.get(label),
            3665 => super::media::media_play_time.get(label),
            3681 => super::media::video_visible_play_time.get(label),
            3794 => super::perf::dns_first_byte.get(label),
            3795 => super::perf::dns_first_contentful_paint.get(label),
            3796 => super::perf::h3p_first_contentful_paint.get(label),
            3797 => super::perf::h3p_page_load_time.get(label),
            3798 => super::perf::http3_first_contentful_paint.get(label),
            3799 => super::perf::http3_page_load_time.get(label),
            3833 => super::dom_quota::info_load_time.get(label),
            3834 => super::dom_quota::shutdown_time.get(label),
            3855 => super::service_worker::fetch_event_channel_reset.get(label),
            3856 => super::service_worker::fetch_event_dispatch.get(label),
            3857 => super::service_worker::fetch_event_finish_synthesized_response.get(label),
            3858 => super::service_worker::fetch_interception_duration.get(label),
            3875 => super::workers::sync_worker_operation.get(label),
            4114 => super::network::async_open_child_to_transaction_pending_exp.get(label),
            4129 => super::network::dns_end_to_connect_start_exp.get(label),
            4134 => super::network::http3_complete_load.get(label),
            4135 => super::network::http3_first_sent_to_last_received.get(label),
            4136 => super::network::http3_open_to_first_received.get(label),
            4137 => super::network::http3_open_to_first_sent.get(label),
            4138 => super::network::http3_tls_handshake.get(label),
            4139 => super::network::http_fetch_duration.get(label),
            4150 => super::network::response_end_parent_to_content.get(label),
            4151 => super::network::response_start_parent_to_content_exp.get(label),
            4165 => super::network::sup_http3_tcp_connection.get(label),
            4178 => super::network::trr_idle_close_time_h1.get(label),
            4179 => super::network::trr_idle_close_time_h2.get(label),
            4180 => super::network::trr_idle_close_time_h3.get(label),
            4194 => super::dns::trr_lookup_time.get(label),
            4299 => super::netwerk::http3_0rtt_state_duration.get(label),
            4300 => super::netwerk::http3_time_to_reuse_idle_connection.get(label),
            4307 => super::orb::javascript_validation.get(label),
            4308 => super::orb::receive_data_for_validation.get(label),
            4377 => super::ssl::time_until_handshake_finished_keyed_by_ka.get(label),
            4681 => super::extensions_timing::background_page_load_by_addonid.get(label),
            4683 => super::extensions_timing::browser_action_popup_open_by_addonid.get(label),
            4685 => super::extensions_timing::content_script_injection_by_addonid.get(label),
            4687 => super::extensions_timing::event_page_running_time_by_addonid.get(label),
            4689 => super::extensions_timing::extension_startup_by_addonid.get(label),
            4691 => super::extensions_timing::page_action_popup_open_by_addonid.get(label),
            4693 => super::extensions_timing::storage_local_get_idb_by_addonid.get(label),
            4695 => super::extensions_timing::storage_local_set_idb_by_addonid.get(label),
            4818 => super::test_only::where_has_the_time_gone.get(label),
            4868 => super::firefox_ai_runtime::engine_creation_success.get(label),
            4870 => super::firefox_ai_runtime::run_inference_success.get(label),
            5486 => super::search::suggestions_latency.get(label),
            5627 => super::urlclassifier::cl_keyed_update_time.get(label),
            5629 => super::urlclassifier::complete_server_response_time.get(label),
            5639 => super::urlclassifier::update_server_response_time.get(label),
            5684 => super::popup_notification::dismissal.get(label),
            5685 => super::popup_notification::main_action.get(label),
            5892 => super::event::longtask.get(label),
            _ => panic!("No labeled_timing_distribution for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_memory_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the memory_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the memory_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_memory_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_memory_distribution_get(metric_id: u32, label: &str) -> Arc<LabeledMemoryDistributionMetric> {
        match metric_id {
            184 => super::networking::trr_request_size.get(label),
            185 => super::networking::trr_response_size.get(label),
            4099 => super::network::cache_size.get(label),
            4815 => super::test_only::what_do_you_remember.get(label),
            _ => panic!("No labeled_memory_distribution for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_custom_distribution metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the custom_distribution submetric.
    ///
    /// # Returns
    ///
    /// Returns the custom_distribution submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_custom_distribution by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_custom_distribution_get(metric_id: u32, label: &str) -> Arc<LabeledCustomDistributionMetric> {
        match metric_id {
            292 => super::downloads::user_action_on_blocked_download.get(label),
            305 => super::firefoxview::cumulative_searches.get(label),
            436 => super::browser_migration::bookmarks_quantity.get(label),
            438 => super::browser_migration::cards_quantity.get(label),
            441 => super::browser_migration::errors.get(label),
            442 => super::browser_migration::extensions_quantity.get(label),
            443 => super::browser_migration::history_quantity.get(label),
            445 => super::browser_migration::logins_quantity.get(label),
            457 => super::browser_migration::usage.get(label),
            3661 => super::media::audible_play_time_percent.get(label),
            3667 => super::media::muted_play_time_percent.get(label),
            3679 => super::media::video_hidden_play_time_percentage.get(label),
            3837 => super::quotamanager_initialize_repository::number_of_iterations.get(label),
            3862 => super::service_worker::running.get(label),
            3927 => super::gfx_content::large_paint_phase_weight_full.get(label),
            3928 => super::gfx_content::large_paint_phase_weight_partial.get(label),
            3930 => super::gfx_content::small_paint_phase_weight_full.get(label),
            3931 => super::gfx_content::small_paint_phase_weight_partial.get(label),
            4097 => super::network::cache_entry_count.get(label),
            4098 => super::network::cache_entry_count_share.get(label),
            4100 => super::network::cache_size_share.get(label),
            4120 => super::network::cache_hit_rate_per_cache_size.get(label),
            4193 => super::dns::trr_attempt_count.get(label),
            4196 => super::dns::trr_relevant_skip_reason_native_failed.get(label),
            4197 => super::dns::trr_relevant_skip_reason_native_success.get(label),
            4198 => super::dns::trr_relevant_skip_reason_trr_first.get(label),
            4199 => super::dns::trr_relevant_skip_reason_trr_first_type_rec.get(label),
            4200 => super::dns::trr_skip_reason_native_failed.get(label),
            4201 => super::dns::trr_skip_reason_native_success.get(label),
            4202 => super::dns::trr_skip_reason_retry_failed.get(label),
            4203 => super::dns::trr_skip_reason_retry_success.get(label),
            4204 => super::dns::trr_skip_reason_strict_mode.get(label),
            4205 => super::dns::trr_skip_reason_trr_first.get(label),
            4248 => super::http::channel_page_onstart_success_trr.get(label),
            4249 => super::http::channel_sub_onstart_success_trr.get(label),
            4250 => super::http::connection_close_reason.get(label),
            4282 => super::http::upload_bandwidth_mbps.get(label),
            4284 => super::http3::connection_close_code.get(label),
            4285 => super::http3::counts_pto.get(label),
            4287 => super::http3::ech_outcome.get(label),
            4288 => super::http3::late_ack.get(label),
            4289 => super::http3::late_ack_ratio.get(label),
            4291 => super::http3::received_sent_dgrams.get(label),
            4408 => super::sandbox::failed_launch_keyed.get(label),
            4461 => super::contentblocking::canvas_fingerprinting_per_tab.get(label),
            4467 => super::contentblocking::email_tracker_embedded_per_tab.get(label),
            4624 => super::memory::distribution_among_content.get(label),
            4797 => super::test_only::mabels_custom_label_lengths.get(label),
            5628 => super::urlclassifier::complete_remote_status2.get(label),
            5636 => super::urlclassifier::update_error.get(label),
            5637 => super::urlclassifier::update_remote_network_error.get(label),
            5638 => super::urlclassifier::update_remote_status2.get(label),
            5640 => super::urlclassifier::update_timeout.get(label),
            5686 => super::popup_notification::stats.get(label),
            _ => panic!("No labeled_custom_distribution for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_quantity metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the quantity submetric.
    ///
    /// # Returns
    ///
    /// Returns the quantity submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_quantity by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_quantity_get(metric_id: u32, label: &str) -> Arc<LabeledQuantityMetric> {
        match metric_id {
            935 => super::tabgroup::active_groups.get(label),
            948 => super::tabgroup::tab_count_in_groups.get(label),
            950 => super::tabgroup::tabs_per_active_group.get(label),
            951 => super::tabgroup::tabs_per_saved_group.get(label),
            4776 => super::test_only::button_jars.get(label),
            4929 => super::normandy::recipe_freshness.get(label),
            5481 => super::browser_searchinit::engine_invalid_webextension.get(label),
            _ => panic!("No labeled_quantity for metric id {}", metric_id),
        }
    }
    /// Gets the submetric from the specified labeled_string metric.
    ///
    /// # Arguments
    ///
    /// * `metric_id` - The metric's ID to look up
    /// * `label` - The label identifying the string submetric.
    ///
    /// # Returns
    ///
    /// Returns the string submetric.
    ///
    /// # Panics
    ///
    /// Panics if no labeled_string by the given metric ID could be found.
    #[allow(unused_variables)]
    pub(crate) fn labeled_string_get(metric_id: u32, label: &str) -> Arc<LabeledStringMetric> {
        match metric_id {
            4568 => super::cookie_banners::google_gdpr_choice_cookie.get(label),
            4794 => super::test_only::mabels_balloon_labels.get(label),
            4795 => super::test_only::mabels_balloon_strings.get(label),
            4799 => super::test_only::mabels_label_maker.get(label),
            5115 => super::places::places_database_corruption_handling_stage.get(label),
            _ => panic!("No labeled_string for metric id {}", metric_id),
        }
    }

    pub(crate) fn labeled_enum_to_str(metric_id: u32, label: u16) -> &'static str {
        match metric_id {
            8 => super::a11y::ThemeLabel::from(label).into(),
            14 => super::browser_engagement::TotalTopVisitsLabel::from(label).into(),
            46 => super::networking::CaptivePortalBannerDisplayTimeLabel::from(label).into(),
            51 => super::networking::CachePurgeDueToMemoryLimitLabel::from(label).into(),
            63 => super::networking::CookieTimestampFixedCountLabel::from(label).into(),
            66 => super::networking::DnsNativeCountLabel::from(label).into(),
            70 => super::networking::FetchKeepaliveDiscardCountLabel::from(label).into(),
            71 => super::networking::FetchKeepaliveRequestCountLabel::from(label).into(),
            88 => super::networking::Http3ConnectionCloseReasonLabel::from(label).into(),
            95 => super::networking::Http3EcnPathCapabilityLabel::from(label).into(),
            97 => super::networking::Http3QuicFrameCountLabel::from(label).into(),
            106 => super::networking::HttpChannelDispositionLabel::from(label).into(),
            107 => super::networking::HttpChannelDispositionDisabledNoReasonLabel::from(label).into(),
            108 => super::networking::HttpChannelDispositionDisabledUpgradeLabel::from(label).into(),
            109 => super::networking::HttpChannelDispositionDisabledWontLabel::from(label).into(),
            110 => super::networking::HttpChannelDispositionEnabledNoReasonLabel::from(label).into(),
            111 => super::networking::HttpChannelDispositionEnabledUpgradeLabel::from(label).into(),
            112 => super::networking::HttpChannelDispositionEnabledWontLabel::from(label).into(),
            113 => super::networking::HttpChannelOnstartStatusLabel::from(label).into(),
            114 => super::networking::HttpChannelOnstartSuccessHttpsRrLabel::from(label).into(),
            126 => super::networking::HttpIpAddrAnyCountLabel::from(label).into(),
            127 => super::networking::HttpIpAddrAnyHostnamesLabel::from(label).into(),
            131 => super::networking::HttpResponseStatusCodeLabel::from(label).into(),
            132 => super::networking::HttpResponseVersionLabel::from(label).into(),
            133 => super::networking::HttpToHttpsUpgradeReasonLabel::from(label).into(),
            134 => super::networking::HttpsHttpOrLocalLabel::from(label).into(),
            135 => super::networking::HttpsRrPresentedLabel::from(label).into(),
            162 => super::networking::ProxyInfoTypeLabel::from(label).into(),
            164 => super::networking::ResidualCacheFolderRemovalLabel::from(label).into(),
            170 => super::networking::SpeculativeConnectOutcomeLabel::from(label).into(),
            175 => super::networking::TrrCompleteLoadLabel::from(label).into(),
            176 => super::networking::TrrDnsEndLabel::from(label).into(),
            177 => super::networking::TrrDnsStartLabel::from(label).into(),
            178 => super::networking::TrrFetchDurationLabel::from(label).into(),
            179 => super::networking::TrrFirstSentToLastReceivedLabel::from(label).into(),
            180 => super::networking::TrrOpenToFirstReceivedLabel::from(label).into(),
            181 => super::networking::TrrOpenToFirstSentLabel::from(label).into(),
            182 => super::networking::TrrRequestCountLabel::from(label).into(),
            183 => super::networking::TrrRequestCountPerConnLabel::from(label).into(),
            184 => super::networking::TrrRequestSizeLabel::from(label).into(),
            185 => super::networking::TrrResponseSizeLabel::from(label).into(),
            186 => super::networking::TrrTcpConnectionLabel::from(label).into(),
            187 => super::networking::TrrTlsHandshakeLabel::from(label).into(),
            190 => super::networking::HttpsRecordStateLabel::from(label).into(),
            305 => super::firefoxview::CumulativeSearchesLabel::from(label).into(),
            377 => super::browser::AttributionErrorsLabel::from(label).into(),
            379 => super::browser::IsUserDefaultLabel::from(label).into(),
            380 => super::browser::IsUserDefaultErrorLabel::from(label).into(),
            381 => super::browser::SetDefaultAlwaysCheckLabel::from(label).into(),
            383 => super::browser::SetDefaultErrorLabel::from(label).into(),
            384 => super::browser::SetDefaultPdfHandlerUserChoiceResultLabel::from(label).into(),
            386 => super::browser::SetDefaultUserChoiceResultLabel::from(label).into(),
            419 => super::security::HttpsOnlyModeUpgradeTimeLabel::from(label).into(),
            440 => super::browser_migration::EntryPointCategoricalLabel::from(label).into(),
            612 => super::history_sidebar::FilterTypeLabel::from(label).into(),
            690 => super::protocolhandler_mailto::HandlerPromptShownLabel::from(label).into(),
            691 => super::protocolhandler_mailto::PromptClickedLabel::from(label).into(),
            771 => super::searchbar::SelectedResultMethodLabel::from(label).into(),
            774 => super::serp::AdsBlockedCountLabel::from(label).into(),
            796 => super::session_restore::AllFilesCorruptLabel::from(label).into(),
            802 => super::session_restore::CorruptFileLabel::from(label).into(),
            810 => super::session_restore::ShutdownOkLabel::from(label).into(),
            904 => super::browser_tabswitch::SpinnerVisibleTriggerLabel::from(label).into(),
            935 => super::tabgroup::ActiveGroupsLabel::from(label).into(),
            939 => super::tabgroup::GroupInteractionsLabel::from(label).into(),
            948 => super::tabgroup::TabCountInGroupsLabel::from(label).into(),
            949 => super::tabgroup::TabInteractionsLabel::from(label).into(),
            950 => super::tabgroup::TabsPerActiveGroupLabel::from(label).into(),
            951 => super::tabgroup::TabsPerSavedGroupLabel::from(label).into(),
            970 => super::suggest::IngestDownloadTimeLabel::from(label).into(),
            971 => super::suggest::IngestTimeLabel::from(label).into(),
            972 => super::suggest::QueryTimeLabel::from(label).into(),
            973 => super::suggest_relevance::OutcomeLabel::from(label).into(),
            974 => super::suggest_relevance::StatusLabel::from(label).into(),
            1074 => super::devtools::EntryPointLabel::from(label).into(),
            1117 => super::devtools_inspector::FonteditorFontTypeDisplayedLabel::from(label).into(),
            1227 => super::bfcache::ComboLabel::from(label).into(),
            1228 => super::bfcache::PageRestoredLabel::from(label).into(),
            3633 => super::canvas::Used2dLabel::from(label).into(),
            3634 => super::canvas::Webgl2SuccessLabel::from(label).into(),
            3637 => super::canvas::WebglSuccessLabel::from(label).into(),
            3638 => super::canvas::WebglUsedLabel::from(label).into(),
            3640 => super::webcrypto::ExtractableEncLabel::from(label).into(),
            3641 => super::webcrypto::ExtractableGenerateLabel::from(label).into(),
            3642 => super::webcrypto::ExtractableImportLabel::from(label).into(),
            3643 => super::webcrypto::ExtractableSigLabel::from(label).into(),
            3645 => super::webcrypto::ResolvedLabel::from(label).into(),
            3647 => super::geolocation::FallbackLabel::from(label).into(),
            3648 => super::geolocation::LinuxProviderLabel::from(label).into(),
            3649 => super::geolocation::RequestResultLabel::from(label).into(),
            3655 => super::mediadrm::DecryptionLabel::from(label).into(),
            3660 => super::gmp::UpdateXmlFetchResultLabel::from(label).into(),
            3666 => super::media::MseSourceBufferTypeLabel::from(label).into(),
            3684 => super::media_audio::BackendLabel::from(label).into(),
            3685 => super::media_audio::InitFailureLabel::from(label).into(),
            3687 => super::media_playback::DeviceHardwareDecoderSupportLabel::from(label).into(),
            3691 => super::media_mp4_parse::SampleDescriptionEntriesHaveMultipleCodecsLabel::from(label).into(),
            3692 => super::media_mp4_parse::SampleDescriptionEntriesHaveMultipleCryptoLabel::from(label).into(),
            3697 => super::codec_stats::UlpfecNegotiatedLabel::from(label).into(),
            3722 => super::webrtc::DatachannelNegotiatedLabel::from(label).into(),
            3724 => super::webrtc::GmpInitSuccessLabel::from(label).into(),
            3725 => super::webrtc::H264EnabledLabel::from(label).into(),
            3726 => super::webrtc::HardwareH264EnabledLabel::from(label).into(),
            3727 => super::webrtc::HasH264HardwareLabel::from(label).into(),
            3733 => super::webrtc::SoftwareH264EnabledLabel::from(label).into(),
            3761 => super::dom::BlinkFilesystemUsedLabel::from(label).into(),
            3767 => super::dom::InnerwindowsWithMutationListenersLabel::from(label).into(),
            3768 => super::dom::ScriptLoadingSourceLabel::from(label).into(),
            3771 => super::dom::StorageAccessApiUiLabel::from(label).into(),
            3772 => super::dom::WebkitDirectoryUsedLabel::from(label).into(),
            3773 => super::dom::XmlhttprequestAsyncOrSyncLabel::from(label).into(),
            3776 => super::dom_contentprocess::LaunchIsSyncLabel::from(label).into(),
            3821 => super::web_notification::IconUrlEncodingLabel::from(label).into(),
            3823 => super::web_notification::PermissionOriginLabel::from(label).into(),
            3824 => super::web_notification::RequestPermissionOriginLabel::from(label).into(),
            3825 => super::web_notification::ShowOriginLabel::from(label).into(),
            3829 => super::web_push::ContentEncodingLabel::from(label).into(),
            3831 => super::web_push::ErrorCodeLabel::from(label).into(),
            3837 => super::quotamanager_initialize_repository::NumberOfIterationsLabel::from(label).into(),
            3848 => super::mixed_content::AudioLabel::from(label).into(),
            3850 => super::mixed_content::ImagesLabel::from(label).into(),
            3853 => super::mixed_content::VideoLabel::from(label).into(),
            3862 => super::service_worker::RunningLabel::from(label).into(),
            3863 => super::localdomstorage::PreloadPendingOnFirstAccessLabel::from(label).into(),
            3865 => super::webauthn_create::AuthenticatorAttachmentLabel::from(label).into(),
            3869 => super::webauthn_get::AuthenticatorAttachmentLabel::from(label).into(),
            3876 => super::htmleditors::OverriddenByBeforeinputListenersLabel::from(label).into(),
            3877 => super::htmleditors::WithBeforeinputListenersLabel::from(label).into(),
            3878 => super::htmleditors::WithMutationListenersWithoutBeforeinputListenersLabel::from(label).into(),
            3879 => super::htmleditors::WithMutationObserversWithoutBeforeinputListenersLabel::from(label).into(),
            3882 => super::apz_zoom::ActivityLabel::from(label).into(),
            3884 => super::fontlist::BadFallbackFontLabel::from(label).into(),
            3890 => super::fontlist::FontCacheHitLabel::from(label).into(),
            3907 => super::gfx::MacosVideoLowPowerLabel::from(label).into(),
            3927 => super::gfx_content::LargePaintPhaseWeightFullLabel::from(label).into(),
            3928 => super::gfx_content::LargePaintPhaseWeightPartialLabel::from(label).into(),
            3930 => super::gfx_content::SmallPaintPhaseWeightFullLabel::from(label).into(),
            3931 => super::gfx_content::SmallPaintPhaseWeightPartialLabel::from(label).into(),
            3934 => super::gfx_content_frame_time::ReasonLabel::from(label).into(),
            3947 => super::gpu_process::CrashFallbacksLabel::from(label).into(),
            3974 => super::avif::A1lxLabel::from(label).into(),
            3975 => super::avif::A1opLabel::from(label).into(),
            3976 => super::avif::AlphaLabel::from(label).into(),
            3977 => super::avif::AomDecodeErrorLabel::from(label).into(),
            3978 => super::avif::BitDepthLabel::from(label).into(),
            3979 => super::avif::CicpCpLabel::from(label).into(),
            3980 => super::avif::CicpMcLabel::from(label).into(),
            3981 => super::avif::CicpTcLabel::from(label).into(),
            3982 => super::avif::ClapLabel::from(label).into(),
            3983 => super::avif::ColrLabel::from(label).into(),
            3985 => super::avif::DecodeResultLabel::from(label).into(),
            3986 => super::avif::DecoderLabel::from(label).into(),
            3987 => super::avif::GridLabel::from(label).into(),
            3988 => super::avif::IproLabel::from(label).into(),
            3989 => super::avif::IspeLabel::from(label).into(),
            3990 => super::avif::LselLabel::from(label).into(),
            3991 => super::avif::MajorBrandLabel::from(label).into(),
            3992 => super::avif::PaspLabel::from(label).into(),
            3993 => super::avif::PixiLabel::from(label).into(),
            3994 => super::avif::SequenceLabel::from(label).into(),
            3995 => super::avif::YuvColorSpaceLabel::from(label).into(),
            4005 => super::ipc::TransactionCancelLabel::from(label).into(),
            4015 => super::javascript_gc::BudgetWasIncreasedLabel::from(label).into(),
            4018 => super::javascript_gc::IsZoneGcLabel::from(label).into(),
            4025 => super::javascript_gc::MinorReasonLabel::from(label).into(),
            4026 => super::javascript_gc::MinorReasonLongLabel::from(label).into(),
            4029 => super::javascript_gc::NonIncrementalLabel::from(label).into(),
            4030 => super::javascript_gc::NonIncrementalReasonLabel::from(label).into(),
            4035 => super::javascript_gc::ParallelMarkUsedLabel::from(label).into(),
            4039 => super::javascript_gc::ReasonLabel::from(label).into(),
            4040 => super::javascript_gc::ResetLabel::from(label).into(),
            4041 => super::javascript_gc::ResetReasonLabel::from(label).into(),
            4044 => super::javascript_gc::SliceWasLongLabel::from(label).into(),
            4045 => super::javascript_gc::SlowPhaseLabel::from(label).into(),
            4046 => super::javascript_gc::SlowTaskLabel::from(label).into(),
            4060 => super::script_preloader::RequestsLabel::from(label).into(),
            4070 => super::layout::LongReflowInterruptibleLabel::from(label).into(),
            4097 => super::network::CacheEntryCountLabel::from(label).into(),
            4098 => super::network::CacheEntryCountShareLabel::from(label).into(),
            4099 => super::network::CacheSizeLabel::from(label).into(),
            4100 => super::network::CacheSizeShareLabel::from(label).into(),
            4110 => super::network::IdOnlineLabel::from(label).into(),
            4112 => super::network::RelPreloadMissRatioLabel::from(label).into(),
            4117 => super::network::BackPressureSuspensionRateLabel::from(label).into(),
            4118 => super::network::ByteRangeRequestLabel::from(label).into(),
            4127 => super::network::CorsAuthorizationHeaderLabel::from(label).into(),
            4134 => super::network::Http3CompleteLoadLabel::from(label).into(),
            4135 => super::network::Http3FirstSentToLastReceivedLabel::from(label).into(),
            4136 => super::network::Http3OpenToFirstReceivedLabel::from(label).into(),
            4137 => super::network::Http3OpenToFirstSentLabel::from(label).into(),
            4138 => super::network::Http3TlsHandshakeLabel::from(label).into(),
            4139 => super::network::HttpFetchDurationLabel::from(label).into(),
            4146 => super::network::RaceCacheValidationLabel::from(label).into(),
            4149 => super::network::RaceCacheWithNetworkUsageLabel::from(label).into(),
            4165 => super::network::SupHttp3TcpConnectionLabel::from(label).into(),
            4166 => super::network::SystemChannelAddonStatusLabel::from(label).into(),
            4167 => super::network::SystemChannelAddonversionStatusLabel::from(label).into(),
            4168 => super::network::SystemChannelOtherStatusLabel::from(label).into(),
            4169 => super::network::SystemChannelRemoteSettingsStatusLabel::from(label).into(),
            4170 => super::network::SystemChannelSuccessOrFailureLabel::from(label).into(),
            4171 => super::network::SystemChannelTelemetryStatusLabel::from(label).into(),
            4172 => super::network::SystemChannelUpdateStatusLabel::from(label).into(),
            4174 => super::network::TlsEarlyDataAcceptedLabel::from(label).into(),
            4176 => super::network::TlsEarlyDataNegotiatedLabel::from(label).into(),
            4178 => super::network::TrrIdleCloseTimeH1Label::from(label).into(),
            4179 => super::network::TrrIdleCloseTimeH2Label::from(label).into(),
            4180 => super::network::TrrIdleCloseTimeH3Label::from(label).into(),
            4187 => super::dns::GracePeriodRenewalLabel::from(label).into(),
            4188 => super::dns::LookupAlgorithmLabel::from(label).into(),
            4208 => super::network_sso::EntraSuccessLabel::from(label).into(),
            4222 => super::predictor::PrefetchUseStatusLabel::from(label).into(),
            4244 => super::http::AltsvcMappingChangedTargetLabel::from(label).into(),
            4245 => super::http::CacheLmInconsistentLabel::from(label).into(),
            4247 => super::http::ChannelOnstartSuccessLabel::from(label).into(),
            4251 => super::http::ConnectionEntryCacheHitLabel::from(label).into(),
            4256 => super::http::EchconfigSuccessRateLabel::from(label).into(),
            4257 => super::http::Http2FailBeforeSettingsLabel::from(label).into(),
            4259 => super::http::PageloadIsSslLabel::from(label).into(),
            4266 => super::http::ScriptBlockIncorrectMimeLabel::from(label).into(),
            4269 => super::http::TlsEarlyDataAcceptedLabel::from(label).into(),
            4275 => super::http::TransactionIsSslLabel::from(label).into(),
            4277 => super::http::TransactionUseAltsvcLabel::from(label).into(),
            4287 => super::http3::EchOutcomeLabel::from(label).into(),
            4288 => super::http3::LateAckLabel::from(label).into(),
            4289 => super::http3::LateAckRatioLabel::from(label).into(),
            4291 => super::http3::ReceivedSentDgramsLabel::from(label).into(),
            4298 => super::netwerk::Http30rttStateLabel::from(label).into(),
            4299 => super::netwerk::Http30rttStateDurationLabel::from(label).into(),
            4300 => super::netwerk::Http3TimeToReuseIdleConnectionLabel::from(label).into(),
            4304 => super::orb::BlockInitiatorLabel::from(label).into(),
            4305 => super::orb::BlockReasonLabel::from(label).into(),
            4306 => super::orb::DidEverBlockResponseLabel::from(label).into(),
            4307 => super::orb::JavascriptValidationLabel::from(label).into(),
            4308 => super::orb::ReceiveDataForValidationLabel::from(label).into(),
            4330 => super::cert_verifier::CertRevocationMechanismsLabel::from(label).into(),
            4331 => super::cert_verifier::CrliteStatusLabel::from(label).into(),
            4332 => super::cert_verifier::CrliteVsOcspResultLabel::from(label).into(),
            4340 => super::cert_compression::FailuresLabel::from(label).into(),
            4344 => super::cert_pinning::ResultsLabel::from(label).into(),
            4345 => super::cert_pinning::TestResultsLabel::from(label).into(),
            4373 => super::ssl::ResumedSessionLabel::from(label).into(),
            4402 => super::tls::XyberIntoleranceReasonLabel::from(label).into(),
            4409 => super::sandbox::HasUserNamespacesLabel::from(label).into(),
            4454 => super::startup_cache::RequestsLabel::from(label).into(),
            4458 => super::bounce_tracking_protection::PurgeCountLabel::from(label).into(),
            4461 => super::contentblocking::CanvasFingerprintingPerTabLabel::from(label).into(),
            4464 => super::contentblocking::CryptominersBlockedCountLabel::from(label).into(),
            4466 => super::contentblocking::EmailTrackerCountLabel::from(label).into(),
            4467 => super::contentblocking::EmailTrackerEmbeddedPerTabLabel::from(label).into(),
            4468 => super::contentblocking::FingerprintersBlockedCountLabel::from(label).into(),
            4470 => super::contentblocking::FontFingerprintingPerTabLabel::from(label).into(),
            4471 => super::contentblocking::QueryStrippingCountLabel::from(label).into(),
            4472 => super::contentblocking::QueryStrippingCountByParamLabel::from(label).into(),
            4474 => super::contentblocking::StorageAccessGrantedCountLabel::from(label).into(),
            4479 => super::contentblocking::TrackingProtectionEnabledLabel::from(label).into(),
            4480 => super::contentblocking::TrackingProtectionPbmDisabledLabel::from(label).into(),
            4571 => super::cookie_banners::NormalWindowServiceModeLabel::from(label).into(),
            4572 => super::cookie_banners::PrivateWindowServiceModeLabel::from(label).into(),
            4595 => super::crash::SubmitAttemptLabel::from(label).into(),
            4660 => super::extensions::ProcessEventLabel::from(label).into(),
            4668 => super::extensions_apis_dnr::StartupCacheEntriesLabel::from(label).into(),
            4674 => super::extensions_counters::BrowserActionPreloadResultLabel::from(label).into(),
            4675 => super::extensions_counters::EventPageIdleResultLabel::from(label).into(),
            4677 => super::extensions_data::MigrateResultCountLabel::from(label).into(),
            4738 => super::creditcard::DetectedCcNumberFieldsCountLabel::from(label).into(),
            4757 => super::formautofill::FormSubmissionHeuristicLabel::from(label).into(),
            4794 => super::test_only::MabelsBalloonLabelsLabel::from(label).into(),
            4800 => super::test_only::MabelsLabeledCountersLabel::from(label).into(),
            4802 => super::test_only::MabelsLikeLabeledBalloonsLabel::from(label).into(),
            4825 => super::test_only_ipc::ALabeledCounterForCategoricalLabel::from(label).into(),
            4826 => super::test_only_ipc::ALabeledCounterForHgramLabel::from(label).into(),
            4847 => super::media_sniffer::Mp4BrandPatternLabel::from(label).into(),
            4868 => super::firefox_ai_runtime::EngineCreationSuccessLabel::from(label).into(),
            4870 => super::firefox_ai_runtime::RunInferenceSuccessLabel::from(label).into(),
            4911 => super::nimbus_targeting_environment::AttrEvalErrorsLabel::from(label).into(),
            4912 => super::nimbus_targeting_environment::PrefTypeErrorsLabel::from(label).into(),
            4960 => super::pwmgr::FormAutofillResultLabel::from(label).into(),
            4962 => super::pwmgr::ImportLoginsFromFileCategoricalLabel::from(label).into(),
            4963 => super::pwmgr::IsUsernameOnlyFormLabel::from(label).into(),
            4973 => super::pwmgr::NumImprovedGeneratedPasswordsLabel::from(label).into(),
            5016 => super::pdfjs::ButtonsLabel::from(label).into(),
            5017 => super::pdfjs::EditingLabel::from(label).into(),
            5018 => super::pdfjs::GeckoviewLabel::from(label).into(),
            5019 => super::pdfjs::StampLabel::from(label).into(),
            5022 => super::pdfjs_editing_highlight::ColorLabel::from(label).into(),
            5026 => super::pdfjs_editing_highlight::KindLabel::from(label).into(),
            5027 => super::pdfjs_editing_highlight::MethodLabel::from(label).into(),
            5028 => super::pdfjs_editing_highlight::NumberOfColorsLabel::from(label).into(),
            5035 => super::pdfjs_image::AddedLabel::from(label).into(),
            5036 => super::pdfjs_image::AltTextEditLabel::from(label).into(),
            5058 => super::pdfjs_signature::ClearLabel::from(label).into(),
            5061 => super::pdfjs_signature::EditDescriptionLabel::from(label).into(),
            5123 => super::printing::ErrorLabel::from(label).into(),
            5128 => super::printing::TargetTypeLabel::from(label).into(),
            5130 => super::power::CpuTimePerProcessTypeMsLabel::from(label).into(),
            5131 => super::power::CpuTimePerTrackerTypeMsLabel::from(label).into(),
            5132 => super::power::EnergyPerProcessTypeLabel::from(label).into(),
            5134 => super::power::GpuTimePerProcessTypeMsLabel::from(label).into(),
            5138 => super::power::WakeupsPerProcessTypeLabel::from(label).into(),
            5140 => super::power_cpu_ms_per_thread::ContentBackgroundLabel::from(label).into(),
            5141 => super::power_cpu_ms_per_thread::ContentForegroundLabel::from(label).into(),
            5142 => super::power_cpu_ms_per_thread::GpuProcessLabel::from(label).into(),
            5143 => super::power_cpu_ms_per_thread::ParentActiveLabel::from(label).into(),
            5144 => super::power_cpu_ms_per_thread::ParentInactiveLabel::from(label).into(),
            5145 => super::power_wakeups_per_thread::ContentBackgroundLabel::from(label).into(),
            5146 => super::power_wakeups_per_thread::ContentForegroundLabel::from(label).into(),
            5147 => super::power_wakeups_per_thread::GpuProcessLabel::from(label).into(),
            5148 => super::power_wakeups_per_thread::ParentActiveLabel::from(label).into(),
            5149 => super::power_wakeups_per_thread::ParentInactiveLabel::from(label).into(),
            5200 => super::application_reputation::BinaryArchiveLabel::from(label).into(),
            5201 => super::application_reputation::BinaryTypeLabel::from(label).into(),
            5203 => super::application_reputation::ReasonLabel::from(label).into(),
            5205 => super::application_reputation::RemoteLookupTimeoutLabel::from(label).into(),
            5207 => super::application_reputation::Server2Label::from(label).into(),
            5209 => super::application_reputation::ShouldBlockLabel::from(label).into(),
            5503 => super::search_service::InitializationStatusLabel::from(label).into(),
            5537 => super::telemetry::EventPingSentLabel::from(label).into(),
            5538 => super::telemetry::EventRecordingErrorLabel::from(label).into(),
            5539 => super::telemetry::EventRegistrationErrorLabel::from(label).into(),
            5555 => super::telemetry::SendFailureTypeLabel::from(label).into(),
            5558 => super::telemetry::SuccessLabel::from(label).into(),
            5583 => super::translations::RequestCountLabel::from(label).into(),
            5644 => super::urlclassifier::VlpsMetadataCorruptLabel::from(label).into(),
            5674 => super::region::StoreRegionResultLabel::from(label).into(),
            5782 => super::update::CanUseBitsExternalLabel::from(label).into(),
            5783 => super::update::CanUseBitsNotifyLabel::from(label).into(),
            5784 => super::update::CanUseBitsSubsequentLabel::from(label).into(),
            5816 => super::update::NotificationBadgeShownLabel::from(label).into(),
            5817 => super::update::NotificationDismissedLabel::from(label).into(),
            5818 => super::update::NotificationMainActionDoorhangerLabel::from(label).into(),
            5819 => super::update::NotificationMainActionMenuLabel::from(label).into(),
            5820 => super::update::NotificationShownLabel::from(label).into(),
            5830 => super::update::ServiceInstalledExternalLabel::from(label).into(),
            5831 => super::update::ServiceInstalledNotifyLabel::from(label).into(),
            5832 => super::update::ServiceInstalledSubsequentLabel::from(label).into(),
            5869 => super::widget::PointingDevicesLabel::from(label).into(),
            5872 => super::widget::TouchEnabledDeviceLabel::from(label).into(),
            5876 => super::cycle_collector::FinishIgcLabel::from(label).into(),
            5880 => super::cycle_collector::NeedGcLabel::from(label).into(),
            5882 => super::cycle_collector::SyncSkippableLabel::from(label).into(),
            5888 => super::cycle_collector::WorkerNeedGcLabel::from(label).into(),
            _ => panic!("Can't turn label enum to string for metric {} which isn't a labeled metric with static labels", metric_id),
        }
    }

    pub(crate) fn labeled_submetric_id_get(metric_id: u32, label: &str) -> u32 {
        match metric_id {
            8 => super::a11y::theme.get_submetric_id(label),
            14 => super::browser_engagement::total_top_visits.get_submetric_id(label),
            15 => super::browser_engagement::sessionrestore_interstitial.get_submetric_id(label),
            46 => super::networking::captive_portal_banner_display_time.get_submetric_id(label),
            51 => super::networking::cache_purge_due_to_memory_limit.get_submetric_id(label),
            63 => super::networking::cookie_timestamp_fixed_count.get_submetric_id(label),
            66 => super::networking::dns_native_count.get_submetric_id(label),
            70 => super::networking::fetch_keepalive_discard_count.get_submetric_id(label),
            71 => super::networking::fetch_keepalive_request_count.get_submetric_id(label),
            88 => super::networking::http_3_connection_close_reason.get_submetric_id(label),
            95 => super::networking::http_3_ecn_path_capability.get_submetric_id(label),
            97 => super::networking::http_3_quic_frame_count.get_submetric_id(label),
            106 => super::networking::http_channel_disposition.get_submetric_id(label),
            107 => super::networking::http_channel_disposition_disabled_no_reason.get_submetric_id(label),
            108 => super::networking::http_channel_disposition_disabled_upgrade.get_submetric_id(label),
            109 => super::networking::http_channel_disposition_disabled_wont.get_submetric_id(label),
            110 => super::networking::http_channel_disposition_enabled_no_reason.get_submetric_id(label),
            111 => super::networking::http_channel_disposition_enabled_upgrade.get_submetric_id(label),
            112 => super::networking::http_channel_disposition_enabled_wont.get_submetric_id(label),
            113 => super::networking::http_channel_onstart_status.get_submetric_id(label),
            114 => super::networking::http_channel_onstart_success_https_rr.get_submetric_id(label),
            126 => super::networking::http_ip_addr_any_count.get_submetric_id(label),
            127 => super::networking::http_ip_addr_any_hostnames.get_submetric_id(label),
            129 => super::networking::http_redirect_to_scheme_subresource.get_submetric_id(label),
            130 => super::networking::http_redirect_to_scheme_top_level.get_submetric_id(label),
            131 => super::networking::http_response_status_code.get_submetric_id(label),
            132 => super::networking::http_response_version.get_submetric_id(label),
            133 => super::networking::http_to_https_upgrade_reason.get_submetric_id(label),
            134 => super::networking::https_http_or_local.get_submetric_id(label),
            135 => super::networking::https_rr_presented.get_submetric_id(label),
            162 => super::networking::proxy_info_type.get_submetric_id(label),
            164 => super::networking::residual_cache_folder_removal.get_submetric_id(label),
            170 => super::networking::speculative_connect_outcome.get_submetric_id(label),
            175 => super::networking::trr_complete_load.get_submetric_id(label),
            176 => super::networking::trr_dns_end.get_submetric_id(label),
            177 => super::networking::trr_dns_start.get_submetric_id(label),
            178 => super::networking::trr_fetch_duration.get_submetric_id(label),
            179 => super::networking::trr_first_sent_to_last_received.get_submetric_id(label),
            180 => super::networking::trr_open_to_first_received.get_submetric_id(label),
            181 => super::networking::trr_open_to_first_sent.get_submetric_id(label),
            182 => super::networking::trr_request_count.get_submetric_id(label),
            183 => super::networking::trr_request_count_per_conn.get_submetric_id(label),
            184 => super::networking::trr_request_size.get_submetric_id(label),
            185 => super::networking::trr_response_size.get_submetric_id(label),
            186 => super::networking::trr_tcp_connection.get_submetric_id(label),
            187 => super::networking::trr_tls_handshake.get_submetric_id(label),
            188 => super::networking::data_transferred_v3_kb.get_submetric_id(label),
            190 => super::networking::https_record_state.get_submetric_id(label),
            192 => super::networking::trr_connection_cycle_count.get_submetric_id(label),
            195 => super::networking::doh_heuristic_ever_tripped.get_submetric_id(label),
            234 => super::messaging_system::invalid_nested_data.get_submetric_id(label),
            241 => super::messaging_system::unknown_keys.get_submetric_id(label),
            251 => super::messaging_system_attribution::unknown_keys.get_submetric_id(label),
            292 => super::downloads::user_action_on_blocked_download.get_submetric_id(label),
            305 => super::firefoxview::cumulative_searches.get_submetric_id(label),
            377 => super::browser::attribution_errors.get_submetric_id(label),
            379 => super::browser::is_user_default.get_submetric_id(label),
            380 => super::browser::is_user_default_error.get_submetric_id(label),
            381 => super::browser::set_default_always_check.get_submetric_id(label),
            383 => super::browser::set_default_error.get_submetric_id(label),
            384 => super::browser::set_default_pdf_handler_user_choice_result.get_submetric_id(label),
            386 => super::browser::set_default_user_choice_result.get_submetric_id(label),
            402 => super::os_environment::invoked_to_handle.get_submetric_id(label),
            403 => super::os_environment::is_default_handler.get_submetric_id(label),
            408 => super::os_environment::launched_to_handle.get_submetric_id(label),
            419 => super::security::https_only_mode_upgrade_time.get_submetric_id(label),
            425 => super::security::client_auth_cert_usage.get_submetric_id(label),
            436 => super::browser_migration::bookmarks_quantity.get_submetric_id(label),
            438 => super::browser_migration::cards_quantity.get_submetric_id(label),
            440 => super::browser_migration::entry_point_categorical.get_submetric_id(label),
            441 => super::browser_migration::errors.get_submetric_id(label),
            442 => super::browser_migration::extensions_quantity.get_submetric_id(label),
            443 => super::browser_migration::history_quantity.get_submetric_id(label),
            445 => super::browser_migration::logins_quantity.get_submetric_id(label),
            457 => super::browser_migration::usage.get_submetric_id(label),
            458 => super::migration::discovered_migrators.get_submetric_id(label),
            514 => super::contextual_services_topsites::click.get_submetric_id(label),
            515 => super::contextual_services_topsites::impression.get_submetric_id(label),
            532 => super::newtab::metric_registered.get_submetric_id(label),
            535 => super::newtab::ping_registered.get_submetric_id(label),
            612 => super::history_sidebar::filter_type.get_submetric_id(label),
            617 => super::library::link.get_submetric_id(label),
            618 => super::library::opened.get_submetric_id(label),
            619 => super::library::search.get_submetric_id(label),
            690 => super::protocolhandler_mailto::handler_prompt_shown.get_submetric_id(label),
            691 => super::protocolhandler_mailto::prompt_clicked.get_submetric_id(label),
            716 => super::browser_engagement_navigation::about_home.get_submetric_id(label),
            717 => super::browser_engagement_navigation::about_newtab.get_submetric_id(label),
            718 => super::browser_engagement_navigation::contextmenu.get_submetric_id(label),
            719 => super::browser_engagement_navigation::searchbar.get_submetric_id(label),
            720 => super::browser_engagement_navigation::urlbar.get_submetric_id(label),
            721 => super::browser_engagement_navigation::urlbar_handoff.get_submetric_id(label),
            722 => super::browser_engagement_navigation::urlbar_persisted.get_submetric_id(label),
            723 => super::browser_engagement_navigation::urlbar_searchmode.get_submetric_id(label),
            724 => super::browser_engagement_navigation::webextension.get_submetric_id(label),
            725 => super::browser_search_adclicks::about_home.get_submetric_id(label),
            726 => super::browser_search_adclicks::about_newtab.get_submetric_id(label),
            727 => super::browser_search_adclicks::contextmenu.get_submetric_id(label),
            728 => super::browser_search_adclicks::reload.get_submetric_id(label),
            729 => super::browser_search_adclicks::searchbar.get_submetric_id(label),
            730 => super::browser_search_adclicks::system.get_submetric_id(label),
            731 => super::browser_search_adclicks::tabhistory.get_submetric_id(label),
            732 => super::browser_search_adclicks::unknown.get_submetric_id(label),
            733 => super::browser_search_adclicks::urlbar.get_submetric_id(label),
            734 => super::browser_search_adclicks::urlbar_handoff.get_submetric_id(label),
            735 => super::browser_search_adclicks::urlbar_persisted.get_submetric_id(label),
            736 => super::browser_search_adclicks::urlbar_searchmode.get_submetric_id(label),
            737 => super::browser_search_adclicks::webextension.get_submetric_id(label),
            738 => super::browser_search_content::about_home.get_submetric_id(label),
            739 => super::browser_search_content::about_newtab.get_submetric_id(label),
            740 => super::browser_search_content::contextmenu.get_submetric_id(label),
            741 => super::browser_search_content::reload.get_submetric_id(label),
            742 => super::browser_search_content::searchbar.get_submetric_id(label),
            743 => super::browser_search_content::system.get_submetric_id(label),
            744 => super::browser_search_content::tabhistory.get_submetric_id(label),
            745 => super::browser_search_content::unknown.get_submetric_id(label),
            746 => super::browser_search_content::urlbar.get_submetric_id(label),
            747 => super::browser_search_content::urlbar_handoff.get_submetric_id(label),
            748 => super::browser_search_content::urlbar_persisted.get_submetric_id(label),
            749 => super::browser_search_content::urlbar_searchmode.get_submetric_id(label),
            750 => super::browser_search_content::webextension.get_submetric_id(label),
            751 => super::browser_search_withads::about_home.get_submetric_id(label),
            752 => super::browser_search_withads::about_newtab.get_submetric_id(label),
            753 => super::browser_search_withads::contextmenu.get_submetric_id(label),
            754 => super::browser_search_withads::reload.get_submetric_id(label),
            755 => super::browser_search_withads::searchbar.get_submetric_id(label),
            756 => super::browser_search_withads::system.get_submetric_id(label),
            757 => super::browser_search_withads::tabhistory.get_submetric_id(label),
            758 => super::browser_search_withads::unknown.get_submetric_id(label),
            759 => super::browser_search_withads::urlbar.get_submetric_id(label),
            760 => super::browser_search_withads::urlbar_handoff.get_submetric_id(label),
            761 => super::browser_search_withads::urlbar_persisted.get_submetric_id(label),
            762 => super::browser_search_withads::urlbar_searchmode.get_submetric_id(label),
            763 => super::browser_search_withads::webextension.get_submetric_id(label),
            767 => super::sap::deprecated_counts.get_submetric_id(label),
            771 => super::searchbar::selected_result_method.get_submetric_id(label),
            774 => super::serp::ads_blocked_count.get_submetric_id(label),
            781 => super::urlbar_searchmode::bookmarkmenu.get_submetric_id(label),
            782 => super::urlbar_searchmode::handoff.get_submetric_id(label),
            783 => super::urlbar_searchmode::historymenu.get_submetric_id(label),
            784 => super::urlbar_searchmode::keywordoffer.get_submetric_id(label),
            785 => super::urlbar_searchmode::oneoff.get_submetric_id(label),
            786 => super::urlbar_searchmode::other.get_submetric_id(label),
            787 => super::urlbar_searchmode::searchbutton.get_submetric_id(label),
            788 => super::urlbar_searchmode::shortcut.get_submetric_id(label),
            789 => super::urlbar_searchmode::tabmenu.get_submetric_id(label),
            790 => super::urlbar_searchmode::tabtosearch.get_submetric_id(label),
            791 => super::urlbar_searchmode::tabtosearch_onboard.get_submetric_id(label),
            792 => super::urlbar_searchmode::topsites_newtab.get_submetric_id(label),
            793 => super::urlbar_searchmode::topsites_urlbar.get_submetric_id(label),
            794 => super::urlbar_searchmode::touchbar.get_submetric_id(label),
            795 => super::urlbar_searchmode::typed.get_submetric_id(label),
            796 => super::session_restore::all_files_corrupt.get_submetric_id(label),
            802 => super::session_restore::corrupt_file.get_submetric_id(label),
            810 => super::session_restore::shutdown_ok.get_submetric_id(label),
            874 => super::sidebar::link.get_submetric_id(label),
            877 => super::sidebar::search.get_submetric_id(label),
            904 => super::browser_tabswitch::spinner_visible_trigger.get_submetric_id(label),
            908 => super::browser_ui_interaction::all_tabs_panel_entrypoint.get_submetric_id(label),
            910 => super::browser_ui_interaction::app_menu.get_submetric_id(label),
            911 => super::browser_ui_interaction::bookmarks_bar.get_submetric_id(label),
            912 => super::browser_ui_interaction::content_context.get_submetric_id(label),
            913 => super::browser_ui_interaction::menu_bar.get_submetric_id(label),
            914 => super::browser_ui_interaction::nav_bar.get_submetric_id(label),
            915 => super::browser_ui_interaction::overflow_menu.get_submetric_id(label),
            916 => super::browser_ui_interaction::pageaction_panel.get_submetric_id(label),
            917 => super::browser_ui_interaction::pageaction_urlbar.get_submetric_id(label),
            918 => super::browser_ui_interaction::pinned_overflow_menu.get_submetric_id(label),
            919 => super::browser_ui_interaction::preferences_pane_containers.get_submetric_id(label),
            920 => super::browser_ui_interaction::preferences_pane_experimental.get_submetric_id(label),
            921 => super::browser_ui_interaction::preferences_pane_general.get_submetric_id(label),
            922 => super::browser_ui_interaction::preferences_pane_home.get_submetric_id(label),
            923 => super::browser_ui_interaction::preferences_pane_more_from_mozilla.get_submetric_id(label),
            924 => super::browser_ui_interaction::preferences_pane_privacy.get_submetric_id(label),
            925 => super::browser_ui_interaction::preferences_pane_search.get_submetric_id(label),
            926 => super::browser_ui_interaction::preferences_pane_search_results.get_submetric_id(label),
            927 => super::browser_ui_interaction::preferences_pane_sync.get_submetric_id(label),
            928 => super::browser_ui_interaction::preferences_pane_unknown.get_submetric_id(label),
            929 => super::browser_ui_interaction::tabs_bar.get_submetric_id(label),
            930 => super::browser_ui_interaction::tabs_context.get_submetric_id(label),
            931 => super::browser_ui_interaction::tabs_context_entrypoint.get_submetric_id(label),
            932 => super::browser_ui_interaction::unified_extensions_area.get_submetric_id(label),
            933 => super::browser_ui_interaction::vertical_tabs_container.get_submetric_id(label),
            934 => super::browser_ui_interaction::keyboard.get_submetric_id(label),
            935 => super::tabgroup::active_groups.get_submetric_id(label),
            939 => super::tabgroup::group_interactions.get_submetric_id(label),
            948 => super::tabgroup::tab_count_in_groups.get_submetric_id(label),
            949 => super::tabgroup::tab_interactions.get_submetric_id(label),
            950 => super::tabgroup::tabs_per_active_group.get_submetric_id(label),
            951 => super::tabgroup::tabs_per_saved_group.get_submetric_id(label),
            970 => super::suggest::ingest_download_time.get_submetric_id(label),
            971 => super::suggest::ingest_time.get_submetric_id(label),
            972 => super::suggest::query_time.get_submetric_id(label),
            973 => super::suggest_relevance::outcome.get_submetric_id(label),
            974 => super::suggest_relevance::status.get_submetric_id(label),
            991 => super::urlbar_quickaction::picked.get_submetric_id(label),
            994 => super::urlbar_unifiedsearchbutton::picked.get_submetric_id(label),
            1011 => super::browser_ui::customized_widgets.get_submetric_id(label),
            1012 => super::browser_ui::mirror_for_toolbar_widgets.get_submetric_id(label),
            1043 => super::devtools_accessibility::accessible_context_menu_item_activated.get_submetric_id(label),
            1045 => super::devtools_accessibility::audit_activated.get_submetric_id(label),
            1047 => super::devtools_accessibility::select_accessible_for_node.get_submetric_id(label),
            1048 => super::devtools_accessibility::simulation_activated.get_submetric_id(label),
            1051 => super::devtools::cold_toolbox_open_delay.get_submetric_id(label),
            1052 => super::devtools::current_theme.get_submetric_id(label),
            1054 => super::devtools::toolbox_page_reload_delay.get_submetric_id(label),
            1055 => super::devtools::warm_toolbox_open_delay.get_submetric_id(label),
            1074 => super::devtools::entry_point.get_submetric_id(label),
            1114 => super::devtools_tool::registered.get_submetric_id(label),
            1115 => super::devtools_toolbox::tabs_reordered.get_submetric_id(label),
            1117 => super::devtools_inspector::fonteditor_font_type_displayed.get_submetric_id(label),
            1121 => super::devtools_inspector::three_pane_enabled.get_submetric_id(label),
            1131 => super::devtools_tooltip::shown.get_submetric_id(label),
            1132 => super::devtools_responsive::open_trigger.get_submetric_id(label),
            1227 => super::bfcache::combo.get_submetric_id(label),
            1228 => super::bfcache::page_restored.get_submetric_id(label),
            3633 => super::canvas::used_2d.get_submetric_id(label),
            3634 => super::canvas::webgl2_success.get_submetric_id(label),
            3635 => super::canvas::webgl_accl_failure_id.get_submetric_id(label),
            3636 => super::canvas::webgl_failure_id.get_submetric_id(label),
            3637 => super::canvas::webgl_success.get_submetric_id(label),
            3638 => super::canvas::webgl_used.get_submetric_id(label),
            3640 => super::webcrypto::extractable_enc.get_submetric_id(label),
            3641 => super::webcrypto::extractable_generate.get_submetric_id(label),
            3642 => super::webcrypto::extractable_import.get_submetric_id(label),
            3643 => super::webcrypto::extractable_sig.get_submetric_id(label),
            3645 => super::webcrypto::resolved.get_submetric_id(label),
            3647 => super::geolocation::fallback.get_submetric_id(label),
            3648 => super::geolocation::linux_provider.get_submetric_id(label),
            3649 => super::geolocation::request_result.get_submetric_id(label),
            3655 => super::mediadrm::decryption.get_submetric_id(label),
            3660 => super::gmp::update_xml_fetch_result.get_submetric_id(label),
            3661 => super::media::audible_play_time_percent.get_submetric_id(label),
            3662 => super::media::codec_used.get_submetric_id(label),
            3665 => super::media::media_play_time.get_submetric_id(label),
            3666 => super::media::mse_source_buffer_type.get_submetric_id(label),
            3667 => super::media::muted_play_time_percent.get_submetric_id(label),
            3675 => super::media::video_hardware_decoding_support.get_submetric_id(label),
            3676 => super::media::video_hd_hardware_decoding_support.get_submetric_id(label),
            3679 => super::media::video_hidden_play_time_percentage.get_submetric_id(label),
            3681 => super::media::video_visible_play_time.get_submetric_id(label),
            3684 => super::media_audio::backend.get_submetric_id(label),
            3685 => super::media_audio::init_failure.get_submetric_id(label),
            3687 => super::media_playback::device_hardware_decoder_support.get_submetric_id(label),
            3689 => super::media_playback::not_supported_video_per_mime_type.get_submetric_id(label),
            3691 => super::media_mp4_parse::sample_description_entries_have_multiple_codecs.get_submetric_id(label),
            3692 => super::media_mp4_parse::sample_description_entries_have_multiple_crypto.get_submetric_id(label),
            3695 => super::codec_stats::audio_preferred_codec.get_submetric_id(label),
            3696 => super::codec_stats::other_fec_signaled.get_submetric_id(label),
            3697 => super::codec_stats::ulpfec_negotiated.get_submetric_id(label),
            3698 => super::codec_stats::video_preferred_codec.get_submetric_id(label),
            3722 => super::webrtc::datachannel_negotiated.get_submetric_id(label),
            3724 => super::webrtc::gmp_init_success.get_submetric_id(label),
            3725 => super::webrtc::h264_enabled.get_submetric_id(label),
            3726 => super::webrtc::hardware_h264_enabled.get_submetric_id(label),
            3727 => super::webrtc::has_h264_hardware.get_submetric_id(label),
            3733 => super::webrtc::software_h264_enabled.get_submetric_id(label),
            3752 => super::webrtc_video::recv_codec_used.get_submetric_id(label),
            3753 => super::webrtc_video::send_codec_used.get_submetric_id(label),
            3754 => super::webrtcdtls::cipher.get_submetric_id(label),
            3755 => super::webrtcdtls::client_handshake_result.get_submetric_id(label),
            3757 => super::webrtcdtls::protocol_version.get_submetric_id(label),
            3758 => super::webrtcdtls::server_handshake_result.get_submetric_id(label),
            3760 => super::webrtcdtls::srtp_cipher.get_submetric_id(label),
            3761 => super::dom::blink_filesystem_used.get_submetric_id(label),
            3767 => super::dom::innerwindows_with_mutation_listeners.get_submetric_id(label),
            3768 => super::dom::script_loading_source.get_submetric_id(label),
            3771 => super::dom::storage_access_api_ui.get_submetric_id(label),
            3772 => super::dom::webkit_directory_used.get_submetric_id(label),
            3773 => super::dom::xmlhttprequest_async_or_sync.get_submetric_id(label),
            3776 => super::dom_contentprocess::launch_is_sync.get_submetric_id(label),
            3784 => super::dom_parentprocess::process_launch_errors.get_submetric_id(label),
            3794 => super::perf::dns_first_byte.get_submetric_id(label),
            3795 => super::perf::dns_first_contentful_paint.get_submetric_id(label),
            3796 => super::perf::h3p_first_contentful_paint.get_submetric_id(label),
            3797 => super::perf::h3p_page_load_time.get_submetric_id(label),
            3798 => super::perf::http3_first_contentful_paint.get_submetric_id(label),
            3799 => super::perf::http3_page_load_time.get_submetric_id(label),
            3821 => super::web_notification::icon_url_encoding.get_submetric_id(label),
            3823 => super::web_notification::permission_origin.get_submetric_id(label),
            3824 => super::web_notification::request_permission_origin.get_submetric_id(label),
            3825 => super::web_notification::show_origin.get_submetric_id(label),
            3829 => super::web_push::content_encoding.get_submetric_id(label),
            3831 => super::web_push::error_code.get_submetric_id(label),
            3833 => super::dom_quota::info_load_time.get_submetric_id(label),
            3834 => super::dom_quota::shutdown_time.get_submetric_id(label),
            3837 => super::quotamanager_initialize_repository::number_of_iterations.get_submetric_id(label),
            3848 => super::mixed_content::audio.get_submetric_id(label),
            3850 => super::mixed_content::images.get_submetric_id(label),
            3853 => super::mixed_content::video.get_submetric_id(label),
            3855 => super::service_worker::fetch_event_channel_reset.get_submetric_id(label),
            3856 => super::service_worker::fetch_event_dispatch.get_submetric_id(label),
            3857 => super::service_worker::fetch_event_finish_synthesized_response.get_submetric_id(label),
            3858 => super::service_worker::fetch_interception_duration.get_submetric_id(label),
            3862 => super::service_worker::running.get_submetric_id(label),
            3863 => super::localdomstorage::preload_pending_on_first_access.get_submetric_id(label),
            3865 => super::webauthn_create::authenticator_attachment.get_submetric_id(label),
            3869 => super::webauthn_get::authenticator_attachment.get_submetric_id(label),
            3875 => super::workers::sync_worker_operation.get_submetric_id(label),
            3876 => super::htmleditors::overridden_by_beforeinput_listeners.get_submetric_id(label),
            3877 => super::htmleditors::with_beforeinput_listeners.get_submetric_id(label),
            3878 => super::htmleditors::with_mutation_listeners_without_beforeinput_listeners.get_submetric_id(label),
            3879 => super::htmleditors::with_mutation_observers_without_beforeinput_listeners.get_submetric_id(label),
            3882 => super::apz_zoom::activity.get_submetric_id(label),
            3884 => super::fontlist::bad_fallback_font.get_submetric_id(label),
            3890 => super::fontlist::font_cache_hit.get_submetric_id(label),
            3907 => super::gfx::macos_video_low_power.get_submetric_id(label),
            3927 => super::gfx_content::large_paint_phase_weight_full.get_submetric_id(label),
            3928 => super::gfx_content::large_paint_phase_weight_partial.get_submetric_id(label),
            3930 => super::gfx_content::small_paint_phase_weight_full.get_submetric_id(label),
            3931 => super::gfx_content::small_paint_phase_weight_partial.get_submetric_id(label),
            3934 => super::gfx_content_frame_time::reason.get_submetric_id(label),
            3947 => super::gpu_process::crash_fallbacks.get_submetric_id(label),
            3974 => super::avif::a1lx.get_submetric_id(label),
            3975 => super::avif::a1op.get_submetric_id(label),
            3976 => super::avif::alpha.get_submetric_id(label),
            3977 => super::avif::aom_decode_error.get_submetric_id(label),
            3978 => super::avif::bit_depth.get_submetric_id(label),
            3979 => super::avif::cicp_cp.get_submetric_id(label),
            3980 => super::avif::cicp_mc.get_submetric_id(label),
            3981 => super::avif::cicp_tc.get_submetric_id(label),
            3982 => super::avif::clap.get_submetric_id(label),
            3983 => super::avif::colr.get_submetric_id(label),
            3985 => super::avif::decode_result.get_submetric_id(label),
            3986 => super::avif::decoder.get_submetric_id(label),
            3987 => super::avif::grid.get_submetric_id(label),
            3988 => super::avif::ipro.get_submetric_id(label),
            3989 => super::avif::ispe.get_submetric_id(label),
            3990 => super::avif::lsel.get_submetric_id(label),
            3991 => super::avif::major_brand.get_submetric_id(label),
            3992 => super::avif::pasp.get_submetric_id(label),
            3993 => super::avif::pixi.get_submetric_id(label),
            3994 => super::avif::sequence.get_submetric_id(label),
            3995 => super::avif::yuv_color_space.get_submetric_id(label),
            4005 => super::ipc::transaction_cancel.get_submetric_id(label),
            4008 => super::subprocess::abnormal_abort.get_submetric_id(label),
            4009 => super::subprocess::crashes_with_dump.get_submetric_id(label),
            4010 => super::subprocess::kill_hard.get_submetric_id(label),
            4011 => super::subprocess::launch_failure.get_submetric_id(label),
            4015 => super::javascript_gc::budget_was_increased.get_submetric_id(label),
            4018 => super::javascript_gc::is_zone_gc.get_submetric_id(label),
            4025 => super::javascript_gc::minor_reason.get_submetric_id(label),
            4026 => super::javascript_gc::minor_reason_long.get_submetric_id(label),
            4029 => super::javascript_gc::non_incremental.get_submetric_id(label),
            4030 => super::javascript_gc::non_incremental_reason.get_submetric_id(label),
            4035 => super::javascript_gc::parallel_mark_used.get_submetric_id(label),
            4039 => super::javascript_gc::reason.get_submetric_id(label),
            4040 => super::javascript_gc::reset.get_submetric_id(label),
            4041 => super::javascript_gc::reset_reason.get_submetric_id(label),
            4044 => super::javascript_gc::slice_was_long.get_submetric_id(label),
            4045 => super::javascript_gc::slow_phase.get_submetric_id(label),
            4046 => super::javascript_gc::slow_task.get_submetric_id(label),
            4060 => super::script_preloader::requests.get_submetric_id(label),
            4070 => super::layout::long_reflow_interruptible.get_submetric_id(label),
            4097 => super::network::cache_entry_count.get_submetric_id(label),
            4098 => super::network::cache_entry_count_share.get_submetric_id(label),
            4099 => super::network::cache_size.get_submetric_id(label),
            4100 => super::network::cache_size_share.get_submetric_id(label),
            4110 => super::network::id_online.get_submetric_id(label),
            4112 => super::network::rel_preload_miss_ratio.get_submetric_id(label),
            4113 => super::network::alpn_mismatch_count.get_submetric_id(label),
            4114 => super::network::async_open_child_to_transaction_pending_exp.get_submetric_id(label),
            4117 => super::network::back_pressure_suspension_rate.get_submetric_id(label),
            4118 => super::network::byte_range_request.get_submetric_id(label),
            4119 => super::network::cache_hit_miss_stat_per_cache_size.get_submetric_id(label),
            4120 => super::network::cache_hit_rate_per_cache_size.get_submetric_id(label),
            4127 => super::network::cors_authorization_header.get_submetric_id(label),
            4129 => super::network::dns_end_to_connect_start_exp.get_submetric_id(label),
            4134 => super::network::http3_complete_load.get_submetric_id(label),
            4135 => super::network::http3_first_sent_to_last_received.get_submetric_id(label),
            4136 => super::network::http3_open_to_first_received.get_submetric_id(label),
            4137 => super::network::http3_open_to_first_sent.get_submetric_id(label),
            4138 => super::network::http3_tls_handshake.get_submetric_id(label),
            4139 => super::network::http_fetch_duration.get_submetric_id(label),
            4146 => super::network::race_cache_validation.get_submetric_id(label),
            4149 => super::network::race_cache_with_network_usage.get_submetric_id(label),
            4150 => super::network::response_end_parent_to_content.get_submetric_id(label),
            4151 => super::network::response_start_parent_to_content_exp.get_submetric_id(label),
            4165 => super::network::sup_http3_tcp_connection.get_submetric_id(label),
            4166 => super::network::system_channel_addon_status.get_submetric_id(label),
            4167 => super::network::system_channel_addonversion_status.get_submetric_id(label),
            4168 => super::network::system_channel_other_status.get_submetric_id(label),
            4169 => super::network::system_channel_remote_settings_status.get_submetric_id(label),
            4170 => super::network::system_channel_success_or_failure.get_submetric_id(label),
            4171 => super::network::system_channel_telemetry_status.get_submetric_id(label),
            4172 => super::network::system_channel_update_status.get_submetric_id(label),
            4174 => super::network::tls_early_data_accepted.get_submetric_id(label),
            4176 => super::network::tls_early_data_negotiated.get_submetric_id(label),
            4178 => super::network::trr_idle_close_time_h1.get_submetric_id(label),
            4179 => super::network::trr_idle_close_time_h2.get_submetric_id(label),
            4180 => super::network::trr_idle_close_time_h3.get_submetric_id(label),
            4187 => super::dns::grace_period_renewal.get_submetric_id(label),
            4188 => super::dns::lookup_algorithm.get_submetric_id(label),
            4193 => super::dns::trr_attempt_count.get_submetric_id(label),
            4194 => super::dns::trr_lookup_time.get_submetric_id(label),
            4196 => super::dns::trr_relevant_skip_reason_native_failed.get_submetric_id(label),
            4197 => super::dns::trr_relevant_skip_reason_native_success.get_submetric_id(label),
            4198 => super::dns::trr_relevant_skip_reason_trr_first.get_submetric_id(label),
            4199 => super::dns::trr_relevant_skip_reason_trr_first_type_rec.get_submetric_id(label),
            4200 => super::dns::trr_skip_reason_native_failed.get_submetric_id(label),
            4201 => super::dns::trr_skip_reason_native_success.get_submetric_id(label),
            4202 => super::dns::trr_skip_reason_retry_failed.get_submetric_id(label),
            4203 => super::dns::trr_skip_reason_retry_success.get_submetric_id(label),
            4204 => super::dns::trr_skip_reason_strict_mode.get_submetric_id(label),
            4205 => super::dns::trr_skip_reason_trr_first.get_submetric_id(label),
            4208 => super::network_sso::entra_success.get_submetric_id(label),
            4222 => super::predictor::prefetch_use_status.get_submetric_id(label),
            4244 => super::http::altsvc_mapping_changed_target.get_submetric_id(label),
            4245 => super::http::cache_lm_inconsistent.get_submetric_id(label),
            4247 => super::http::channel_onstart_success.get_submetric_id(label),
            4248 => super::http::channel_page_onstart_success_trr.get_submetric_id(label),
            4249 => super::http::channel_sub_onstart_success_trr.get_submetric_id(label),
            4250 => super::http::connection_close_reason.get_submetric_id(label),
            4251 => super::http::connection_entry_cache_hit.get_submetric_id(label),
            4256 => super::http::echconfig_success_rate.get_submetric_id(label),
            4257 => super::http::http2_fail_before_settings.get_submetric_id(label),
            4259 => super::http::pageload_is_ssl.get_submetric_id(label),
            4266 => super::http::script_block_incorrect_mime.get_submetric_id(label),
            4269 => super::http::tls_early_data_accepted.get_submetric_id(label),
            4275 => super::http::transaction_is_ssl.get_submetric_id(label),
            4277 => super::http::transaction_use_altsvc.get_submetric_id(label),
            4282 => super::http::upload_bandwidth_mbps.get_submetric_id(label),
            4284 => super::http3::connection_close_code.get_submetric_id(label),
            4285 => super::http3::counts_pto.get_submetric_id(label),
            4287 => super::http3::ech_outcome.get_submetric_id(label),
            4288 => super::http3::late_ack.get_submetric_id(label),
            4289 => super::http3::late_ack_ratio.get_submetric_id(label),
            4291 => super::http3::received_sent_dgrams.get_submetric_id(label),
            4298 => super::netwerk::http3_0rtt_state.get_submetric_id(label),
            4299 => super::netwerk::http3_0rtt_state_duration.get_submetric_id(label),
            4300 => super::netwerk::http3_time_to_reuse_idle_connection.get_submetric_id(label),
            4304 => super::orb::block_initiator.get_submetric_id(label),
            4305 => super::orb::block_reason.get_submetric_id(label),
            4306 => super::orb::did_ever_block_response.get_submetric_id(label),
            4307 => super::orb::javascript_validation.get_submetric_id(label),
            4308 => super::orb::receive_data_for_validation.get_submetric_id(label),
            4330 => super::cert_verifier::cert_revocation_mechanisms.get_submetric_id(label),
            4331 => super::cert_verifier::crlite_status.get_submetric_id(label),
            4332 => super::cert_verifier::crlite_vs_ocsp_result.get_submetric_id(label),
            4340 => super::cert_compression::failures.get_submetric_id(label),
            4344 => super::cert_pinning::results.get_submetric_id(label),
            4345 => super::cert_pinning::test_results.get_submetric_id(label),
            4373 => super::ssl::resumed_session.get_submetric_id(label),
            4377 => super::ssl::time_until_handshake_finished_keyed_by_ka.get_submetric_id(label),
            4402 => super::tls::xyber_intolerance_reason.get_submetric_id(label),
            4408 => super::sandbox::failed_launch_keyed.get_submetric_id(label),
            4409 => super::sandbox::has_user_namespaces.get_submetric_id(label),
            4410 => super::sandbox::rejected_syscalls.get_submetric_id(label),
            4454 => super::startup_cache::requests.get_submetric_id(label),
            4458 => super::bounce_tracking_protection::purge_count.get_submetric_id(label),
            4461 => super::contentblocking::canvas_fingerprinting_per_tab.get_submetric_id(label),
            4464 => super::contentblocking::cryptominers_blocked_count.get_submetric_id(label),
            4466 => super::contentblocking::email_tracker_count.get_submetric_id(label),
            4467 => super::contentblocking::email_tracker_embedded_per_tab.get_submetric_id(label),
            4468 => super::contentblocking::fingerprinters_blocked_count.get_submetric_id(label),
            4470 => super::contentblocking::font_fingerprinting_per_tab.get_submetric_id(label),
            4471 => super::contentblocking::query_stripping_count.get_submetric_id(label),
            4472 => super::contentblocking::query_stripping_count_by_param.get_submetric_id(label),
            4474 => super::contentblocking::storage_access_granted_count.get_submetric_id(label),
            4479 => super::contentblocking::tracking_protection_enabled.get_submetric_id(label),
            4480 => super::contentblocking::tracking_protection_pbm_disabled.get_submetric_id(label),
            4568 => super::cookie_banners::google_gdpr_choice_cookie.get_submetric_id(label),
            4571 => super::cookie_banners::normal_window_service_mode.get_submetric_id(label),
            4572 => super::cookie_banners::private_window_service_mode.get_submetric_id(label),
            4595 => super::crash::submit_attempt.get_submetric_id(label),
            4600 => super::crash_submission::channel_status.get_submetric_id(label),
            4601 => super::crash_submission::collector_errors.get_submetric_id(label),
            4624 => super::memory::distribution_among_content.get_submetric_id(label),
            4660 => super::extensions::process_event.get_submetric_id(label),
            4662 => super::extensions::startup_cache_read_errors.get_submetric_id(label),
            4668 => super::extensions_apis_dnr::startup_cache_entries.get_submetric_id(label),
            4674 => super::extensions_counters::browser_action_preload_result.get_submetric_id(label),
            4675 => super::extensions_counters::event_page_idle_result.get_submetric_id(label),
            4677 => super::extensions_data::migrate_result_count.get_submetric_id(label),
            4681 => super::extensions_timing::background_page_load_by_addonid.get_submetric_id(label),
            4683 => super::extensions_timing::browser_action_popup_open_by_addonid.get_submetric_id(label),
            4685 => super::extensions_timing::content_script_injection_by_addonid.get_submetric_id(label),
            4687 => super::extensions_timing::event_page_running_time_by_addonid.get_submetric_id(label),
            4689 => super::extensions_timing::extension_startup_by_addonid.get_submetric_id(label),
            4691 => super::extensions_timing::page_action_popup_open_by_addonid.get_submetric_id(label),
            4693 => super::extensions_timing::storage_local_get_idb_by_addonid.get_submetric_id(label),
            4695 => super::extensions_timing::storage_local_set_idb_by_addonid.get_submetric_id(label),
            4738 => super::creditcard::detected_cc_number_fields_count.get_submetric_id(label),
            4757 => super::formautofill::form_submission_heuristic.get_submetric_id(label),
            4776 => super::test_only::button_jars.get_submetric_id(label),
            4790 => super::test_only::keyed_expired.get_submetric_id(label),
            4791 => super::test_only::keyed_mobile_only.get_submetric_id(label),
            4792 => super::test_only::keyed_release_optin.get_submetric_id(label),
            4793 => super::test_only::keyed_release_optout.get_submetric_id(label),
            4794 => super::test_only::mabels_balloon_labels.get_submetric_id(label),
            4795 => super::test_only::mabels_balloon_strings.get_submetric_id(label),
            4796 => super::test_only::mabels_bathroom_counters.get_submetric_id(label),
            4797 => super::test_only::mabels_custom_label_lengths.get_submetric_id(label),
            4798 => super::test_only::mabels_kitchen_counters.get_submetric_id(label),
            4799 => super::test_only::mabels_label_maker.get_submetric_id(label),
            4800 => super::test_only::mabels_labeled_counters.get_submetric_id(label),
            4801 => super::test_only::mabels_like_balloons.get_submetric_id(label),
            4802 => super::test_only::mabels_like_labeled_balloons.get_submetric_id(label),
            4807 => super::test_only::mirrors_for_labeled_bools.get_submetric_id(label),
            4815 => super::test_only::what_do_you_remember.get_submetric_id(label),
            4818 => super::test_only::where_has_the_time_gone.get_submetric_id(label),
            4824 => super::test_only_ipc::a_labeled_counter.get_submetric_id(label),
            4825 => super::test_only_ipc::a_labeled_counter_for_categorical.get_submetric_id(label),
            4826 => super::test_only_ipc::a_labeled_counter_for_hgram.get_submetric_id(label),
            4827 => super::test_only_ipc::a_labeled_counter_for_keyed_count_hgram.get_submetric_id(label),
            4839 => super::test_only_ipc::an_unordered_labeled_boolean.get_submetric_id(label),
            4840 => super::test_only_ipc::another_labeled_counter.get_submetric_id(label),
            4847 => super::media_sniffer::mp4_brand_pattern.get_submetric_id(label),
            4868 => super::firefox_ai_runtime::engine_creation_success.get_submetric_id(label),
            4870 => super::firefox_ai_runtime::run_inference_success.get_submetric_id(label),
            4911 => super::nimbus_targeting_environment::attr_eval_errors.get_submetric_id(label),
            4912 => super::nimbus_targeting_environment::pref_type_errors.get_submetric_id(label),
            4929 => super::normandy::recipe_freshness.get_submetric_id(label),
            4960 => super::pwmgr::form_autofill_result.get_submetric_id(label),
            4962 => super::pwmgr::import_logins_from_file_categorical.get_submetric_id(label),
            4963 => super::pwmgr::is_username_only_form.get_submetric_id(label),
            4973 => super::pwmgr::num_improved_generated_passwords.get_submetric_id(label),
            5016 => super::pdfjs::buttons.get_submetric_id(label),
            5017 => super::pdfjs::editing.get_submetric_id(label),
            5018 => super::pdfjs::geckoview.get_submetric_id(label),
            5019 => super::pdfjs::stamp.get_submetric_id(label),
            5022 => super::pdfjs_editing_highlight::color.get_submetric_id(label),
            5026 => super::pdfjs_editing_highlight::kind.get_submetric_id(label),
            5027 => super::pdfjs_editing_highlight::method.get_submetric_id(label),
            5028 => super::pdfjs_editing_highlight::number_of_colors.get_submetric_id(label),
            5035 => super::pdfjs_image::added.get_submetric_id(label),
            5036 => super::pdfjs_image::alt_text_edit.get_submetric_id(label),
            5058 => super::pdfjs_signature::clear.get_submetric_id(label),
            5061 => super::pdfjs_signature::edit_description.get_submetric_id(label),
            5115 => super::places::places_database_corruption_handling_stage.get_submetric_id(label),
            5123 => super::printing::error.get_submetric_id(label),
            5126 => super::printing::settings_changed.get_submetric_id(label),
            5128 => super::printing::target_type.get_submetric_id(label),
            5130 => super::power::cpu_time_per_process_type_ms.get_submetric_id(label),
            5131 => super::power::cpu_time_per_tracker_type_ms.get_submetric_id(label),
            5132 => super::power::energy_per_process_type.get_submetric_id(label),
            5134 => super::power::gpu_time_per_process_type_ms.get_submetric_id(label),
            5138 => super::power::wakeups_per_process_type.get_submetric_id(label),
            5140 => super::power_cpu_ms_per_thread::content_background.get_submetric_id(label),
            5141 => super::power_cpu_ms_per_thread::content_foreground.get_submetric_id(label),
            5142 => super::power_cpu_ms_per_thread::gpu_process.get_submetric_id(label),
            5143 => super::power_cpu_ms_per_thread::parent_active.get_submetric_id(label),
            5144 => super::power_cpu_ms_per_thread::parent_inactive.get_submetric_id(label),
            5145 => super::power_wakeups_per_thread::content_background.get_submetric_id(label),
            5146 => super::power_wakeups_per_thread::content_foreground.get_submetric_id(label),
            5147 => super::power_wakeups_per_thread::gpu_process.get_submetric_id(label),
            5148 => super::power_wakeups_per_thread::parent_active.get_submetric_id(label),
            5149 => super::power_wakeups_per_thread::parent_inactive.get_submetric_id(label),
            5200 => super::application_reputation::binary_archive.get_submetric_id(label),
            5201 => super::application_reputation::binary_type.get_submetric_id(label),
            5203 => super::application_reputation::reason.get_submetric_id(label),
            5205 => super::application_reputation::remote_lookup_timeout.get_submetric_id(label),
            5207 => super::application_reputation::server_2.get_submetric_id(label),
            5209 => super::application_reputation::should_block.get_submetric_id(label),
            5481 => super::browser_searchinit::engine_invalid_webextension.get_submetric_id(label),
            5486 => super::search::suggestions_latency.get_submetric_id(label),
            5503 => super::search_service::initialization_status.get_submetric_id(label),
            5505 => super::search_suggestions::aborted_requests.get_submetric_id(label),
            5506 => super::search_suggestions::failed_requests.get_submetric_id(label),
            5507 => super::search_suggestions::successful_requests.get_submetric_id(label),
            5537 => super::telemetry::event_ping_sent.get_submetric_id(label),
            5538 => super::telemetry::event_recording_error.get_submetric_id(label),
            5539 => super::telemetry::event_registration_error.get_submetric_id(label),
            5541 => super::telemetry::invalid_ping_type_submitted.get_submetric_id(label),
            5555 => super::telemetry::send_failure_type.get_submetric_id(label),
            5558 => super::telemetry::success.get_submetric_id(label),
            5583 => super::translations::request_count.get_submetric_id(label),
            5627 => super::urlclassifier::cl_keyed_update_time.get_submetric_id(label),
            5628 => super::urlclassifier::complete_remote_status2.get_submetric_id(label),
            5629 => super::urlclassifier::complete_server_response_time.get_submetric_id(label),
            5636 => super::urlclassifier::update_error.get_submetric_id(label),
            5637 => super::urlclassifier::update_remote_network_error.get_submetric_id(label),
            5638 => super::urlclassifier::update_remote_status2.get_submetric_id(label),
            5639 => super::urlclassifier::update_server_response_time.get_submetric_id(label),
            5640 => super::urlclassifier::update_timeout.get_submetric_id(label),
            5644 => super::urlclassifier::vlps_metadata_corrupt.get_submetric_id(label),
            5670 => super::mozstorage::sqlitejsm_transaction_timeout.get_submetric_id(label),
            5674 => super::region::store_region_result.get_submetric_id(label),
            5684 => super::popup_notification::dismissal.get_submetric_id(label),
            5685 => super::popup_notification::main_action.get_submetric_id(label),
            5686 => super::popup_notification::stats.get_submetric_id(label),
            5782 => super::update::can_use_bits_external.get_submetric_id(label),
            5783 => super::update::can_use_bits_notify.get_submetric_id(label),
            5784 => super::update::can_use_bits_subsequent.get_submetric_id(label),
            5791 => super::update::check_extended_error_external.get_submetric_id(label),
            5792 => super::update::check_extended_error_notify.get_submetric_id(label),
            5793 => super::update::check_extended_error_subsequent.get_submetric_id(label),
            5816 => super::update::notification_badge_shown.get_submetric_id(label),
            5817 => super::update::notification_dismissed.get_submetric_id(label),
            5818 => super::update::notification_main_action_doorhanger.get_submetric_id(label),
            5819 => super::update::notification_main_action_menu.get_submetric_id(label),
            5820 => super::update::notification_shown.get_submetric_id(label),
            5830 => super::update::service_installed_external.get_submetric_id(label),
            5831 => super::update::service_installed_notify.get_submetric_id(label),
            5832 => super::update::service_installed_subsequent.get_submetric_id(label),
            5851 => super::update::bitshresult.get_submetric_id(label),
            5852 => super::update::move_result.get_submetric_id(label),
            5864 => super::widget::ime_name_on_mac.get_submetric_id(label),
            5866 => super::widget::ime_name_on_linux.get_submetric_id(label),
            5869 => super::widget::pointing_devices.get_submetric_id(label),
            5870 => super::widget::ime_name_on_windows.get_submetric_id(label),
            5871 => super::widget::ime_name_on_windows_inserted_crlf.get_submetric_id(label),
            5872 => super::widget::touch_enabled_device.get_submetric_id(label),
            5876 => super::cycle_collector::finish_igc.get_submetric_id(label),
            5880 => super::cycle_collector::need_gc.get_submetric_id(label),
            5882 => super::cycle_collector::sync_skippable.get_submetric_id(label),
            5888 => super::cycle_collector::worker_need_gc.get_submetric_id(label),
            5892 => super::event::longtask.get_submetric_id(label),
            _ => panic!("No labeled metric for id {}", metric_id),
        }
    }

    pub(crate) mod submetric_maps {
        use std::sync::{
          atomic::AtomicU32,
          Arc,
          RwLock,
        };
        use super::*;

        pub(crate) const SUBMETRIC_BIT: u32 = 25;
        pub(crate) static NEXT_LABELED_SUBMETRIC_ID: AtomicU32 = AtomicU32::new((1 << SUBMETRIC_BIT) + 1);
        pub(crate) static LABELED_METRICS_TO_IDS: Lazy<RwLock<HashMap<(BaseMetricId, String), SubMetricId>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub(crate) static LABELED_ENUMS_TO_IDS: Lazy<RwLock<HashMap<(u32, u16), u32>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );

        pub static BOOLEAN_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledBooleanMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static CUSTOM_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledCustomDistributionMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static QUANTITY_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledQuantityMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static STRING_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledStringMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static TIMING_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledTimingDistributionMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static COUNTER_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledCounterMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
        pub static MEMORY_DISTRIBUTION_MAP: Lazy<RwLock<HashMap<SubMetricId, Arc<LabeledMemoryDistributionMetric>>>> = Lazy::new(||
            RwLock::new(HashMap::new())
        );
    }
}

